""" Cisco_IOS_XR_mpls_ldp_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR mpls\-ldp package operational data.

This module contains definitions
for the following management objects\:
  mpls\-ldp\: MPLS LDP operational data

Copyright (c) 2013\-2016 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.entity_utils import get_relative_entity_path as _get_relative_entity_path
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class DhcbState(Enum):
    """
    DhcbState

    DHCB State Type

    .. data:: none = 0

    	None

    .. data:: dhcb_active = 1

    	Active

    .. data:: dhcb_passive = 2

    	Passive

    .. data:: dhcb_active_passive = 3

    	Active and Passive

    """

    none = Enum.YLeaf(0, "none")

    dhcb_active = Enum.YLeaf(1, "dhcb-active")

    dhcb_passive = Enum.YLeaf(2, "dhcb-passive")

    dhcb_active_passive = Enum.YLeaf(3, "dhcb-active-passive")


class L2VpnLdpPwAgi(Enum):
    """
    L2VpnLdpPwAgi

    L2vpn ldp pw agi

    .. data:: rd = 0

    	AGI type RD

    """

    rd = Enum.YLeaf(0, "rd")


class L2VpnLdpPwAii(Enum):
    """
    L2VpnLdpPwAii

    L2vpn ldp pw aii

    .. data:: local_id = 0

    	AII Type 1

    .. data:: type2 = 1

    	AII Type 2

    """

    local_id = Enum.YLeaf(0, "local-id")

    type2 = Enum.YLeaf(1, "type2")


class L2VpnLdpPwFec(Enum):
    """
    L2VpnLdpPwFec

    L2vpn ldp pw fec

    .. data:: fec128 = 0

    	FEC 128 pseudowire type

    .. data:: fec129 = 1

    	FEC 129 pseudowire type

    .. data:: fec130 = 2

    	FEC 130 pseudowire type

    .. data:: invalid = 3

    	FEC not applicable

    """

    fec128 = Enum.YLeaf(0, "fec128")

    fec129 = Enum.YLeaf(1, "fec129")

    fec130 = Enum.YLeaf(2, "fec130")

    invalid = Enum.YLeaf(3, "invalid")


class LabelValue(Enum):
    """
    LabelValue

    Label Value Type

    .. data:: mpls_label = 0

    	MPLS Label

    .. data:: un_labelled = 1

    	Unlabelled

    .. data:: unknown = 2

    	Unknown label

    """

    mpls_label = Enum.YLeaf(0, "mpls-label")

    un_labelled = Enum.YLeaf(1, "un-labelled")

    unknown = Enum.YLeaf(2, "unknown")


class LdpAdjUnionDiscrim(Enum):
    """
    LdpAdjUnionDiscrim

    MPLS LDP Hello Type

    .. data:: link_hello = 0

    	Link hello

    .. data:: targeted_hello = 1

    	Targeted hello

    """

    link_hello = Enum.YLeaf(0, "link-hello")

    targeted_hello = Enum.YLeaf(1, "targeted-hello")


class LdpAf(Enum):
    """
    LdpAf

    Ldp af

    .. data:: ldp_show_af_none = 0

    	No Address Family

    .. data:: ldp_show_af_ipv4 = 1

    	IPv4 AFI

    .. data:: ldp_show_af_ipv6 = 2

    	IPv6 AFI

    .. data:: ldp_show_af_ipv4_ipv6 = 3

    	Both IPv4/IPv6 AFIs

    """

    ldp_show_af_none = Enum.YLeaf(0, "ldp-show-af-none")

    ldp_show_af_ipv4 = Enum.YLeaf(1, "ldp-show-af-ipv4")

    ldp_show_af_ipv6 = Enum.YLeaf(2, "ldp-show-af-ipv6")

    ldp_show_af_ipv4_ipv6 = Enum.YLeaf(3, "ldp-show-af-ipv4-ipv6")


class LdpAfId(Enum):
    """
    LdpAfId

    Ldp af id

    .. data:: ldp_af_id_none = 0

    	No Address Family

    .. data:: ldp_af_id_ipv4 = 2

    	IPv4 AFI

    .. data:: ldp_af_id_ipv6 = 10

    	IPv6 AFI

    """

    ldp_af_id_none = Enum.YLeaf(0, "ldp-af-id-none")

    ldp_af_id_ipv4 = Enum.YLeaf(2, "ldp-af-id-ipv4")

    ldp_af_id_ipv6 = Enum.YLeaf(10, "ldp-af-id-ipv6")


class LdpFwdUnlblRsn(Enum):
    """
    LdpFwdUnlblRsn

    Ldp fwd unlbl rsn

    .. data:: ldp_fwd_labelled = 0

    	ldp fwd labelled

    .. data:: ldp_fwd_un_labelled_vrf_down = 1

    	ldp fwd un labelled vrf down

    .. data:: ldp_fwd_un_labelled_no_nh = 2

    	ldp fwd un labelled no nh

    .. data:: ldp_fwd_un_labelled_recursive_path = 3

    	ldp fwd un labelled recursive path

    .. data:: ldp_fwd_un_labelled_intf_not_ldp = 4

    	ldp fwd un labelled intf not ldp

    .. data:: ldp_fwd_un_labelled_no_rmt = 5

    	ldp fwd un labelled no rmt

    .. data:: ldp_fwd_un_labelled_no_ldp_adj = 6

    	ldp fwd un labelled no ldp adj

    .. data:: ldp_fwd_un_labelled_no_session = 7

    	ldp fwd un labelled no session

    .. data:: ldp_fwd_un_labelled_unknown = 8

    	ldp fwd un labelled unknown

    """

    ldp_fwd_labelled = Enum.YLeaf(0, "ldp-fwd-labelled")

    ldp_fwd_un_labelled_vrf_down = Enum.YLeaf(1, "ldp-fwd-un-labelled-vrf-down")

    ldp_fwd_un_labelled_no_nh = Enum.YLeaf(2, "ldp-fwd-un-labelled-no-nh")

    ldp_fwd_un_labelled_recursive_path = Enum.YLeaf(3, "ldp-fwd-un-labelled-recursive-path")

    ldp_fwd_un_labelled_intf_not_ldp = Enum.YLeaf(4, "ldp-fwd-un-labelled-intf-not-ldp")

    ldp_fwd_un_labelled_no_rmt = Enum.YLeaf(5, "ldp-fwd-un-labelled-no-rmt")

    ldp_fwd_un_labelled_no_ldp_adj = Enum.YLeaf(6, "ldp-fwd-un-labelled-no-ldp-adj")

    ldp_fwd_un_labelled_no_session = Enum.YLeaf(7, "ldp-fwd-un-labelled-no-session")

    ldp_fwd_un_labelled_unknown = Enum.YLeaf(8, "ldp-fwd-un-labelled-unknown")


class LdpIgpSyncDownReason(Enum):
    """
    LdpIgpSyncDownReason

    Reason IGP Sync Not Achieved

    .. data:: igp_sync_down_reason_not_applicable = 0

    	Not Applicable

    .. data:: no_hello_adjacency = 1

    	No hello adjacency

    .. data:: no_peer_session = 2

    	No peer session

    .. data:: initial_update_to_peer_not_done = 3

    	Initial update to peer not done yet

    .. data:: initial_update_from_peer_not_received = 4

    	Initial update from peer not received yet

    .. data:: internal_reason = 5

    	Internal reason

    """

    igp_sync_down_reason_not_applicable = Enum.YLeaf(0, "igp-sync-down-reason-not-applicable")

    no_hello_adjacency = Enum.YLeaf(1, "no-hello-adjacency")

    no_peer_session = Enum.YLeaf(2, "no-peer-session")

    initial_update_to_peer_not_done = Enum.YLeaf(3, "initial-update-to-peer-not-done")

    initial_update_from_peer_not_received = Enum.YLeaf(4, "initial-update-from-peer-not-received")

    internal_reason = Enum.YLeaf(5, "internal-reason")


class LdpIgpSyncState(Enum):
    """
    LdpIgpSyncState

    IGP Sync State

    .. data:: isync_ready = 0

    	Acheived

    .. data:: isync_not_ready = 1

    	Not acheived

    .. data:: isync_deferred = 2

    	Deferred due to interface delay or global

    	restart delay

    """

    isync_ready = Enum.YLeaf(0, "isync-ready")

    isync_not_ready = Enum.YLeaf(1, "isync-not-ready")

    isync_deferred = Enum.YLeaf(2, "isync-deferred")


class LdpRoutePathFlags(Enum):
    """
    LdpRoutePathFlags

    Route path flags

    .. data:: ip_path_no_flag = 0

    	A primary path with no special flag/attribute

    .. data:: ip_path_protected = 1

    	A primary path with LFA FRR protection

    .. data:: ip_path_backup = 2

    	A non-primary local LFA FRR (pure) backup path

    .. data:: ip_path_backup_remote = 3

    	A non-primary remote LFA FRR (pure) backup path

    .. data:: ip_path_bgp_backup = 4

    	A non-primary BGP backup path

    """

    ip_path_no_flag = Enum.YLeaf(0, "ip-path-no-flag")

    ip_path_protected = Enum.YLeaf(1, "ip-path-protected")

    ip_path_backup = Enum.YLeaf(2, "ip-path-backup")

    ip_path_backup_remote = Enum.YLeaf(3, "ip-path-backup-remote")

    ip_path_bgp_backup = Enum.YLeaf(4, "ip-path-bgp-backup")


class LdpRoutePathLblOwner(Enum):
    """
    LdpRoutePathLblOwner

    Route path label owner

    .. data:: ip_path_lbl_owner_none = 0

    	No label and no owner

    .. data:: ip_path_lbl_owner_ldp = 1

    	Path outgoing label owned by LDP

    .. data:: ip_path_lbl_owner_bgp = 2

    	Path outgoing label owned by BGP

    """

    ip_path_lbl_owner_none = Enum.YLeaf(0, "ip-path-lbl-owner-none")

    ip_path_lbl_owner_ldp = Enum.YLeaf(1, "ip-path-lbl-owner-ldp")

    ip_path_lbl_owner_bgp = Enum.YLeaf(2, "ip-path-lbl-owner-bgp")


class LocalLabelState(Enum):
    """
    LocalLabelState

    MPLS LDP Local Label State Type

    .. data:: local_label_state_none = 1

    	None

    .. data:: local_label_state_assigned = 2

    	Assigned

    .. data:: local_label_state_withdrawn = 3

    	Withdrawn

    """

    local_label_state_none = Enum.YLeaf(1, "local-label-state-none")

    local_label_state_assigned = Enum.YLeaf(2, "local-label-state-assigned")

    local_label_state_withdrawn = Enum.YLeaf(3, "local-label-state-withdrawn")


class MgmtLdpNbrBgpAdvtState(Enum):
    """
    MgmtLdpNbrBgpAdvtState

    MPLS LDP Neighbor BGP Label Advertisement State

    Type

    .. data:: not_applicable = 0

    	Not applicable

    .. data:: permit = 1

    	Advertisement permitted

    .. data:: deny = 2

    	Advertisement denied

    """

    not_applicable = Enum.YLeaf(0, "not-applicable")

    permit = Enum.YLeaf(1, "permit")

    deny = Enum.YLeaf(2, "deny")


class MgmtLdpNsrPeerLdpSyncNackRsn(Enum):
    """
    MgmtLdpNsrPeerLdpSyncNackRsn

    Mgmt ldp nsr peer ldp sync nack rsn

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_none = 0

    	mgmt ldp nsr peer ldp sync nack rsn none

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_tbl_id_mismatch = 1

    	mgmt ldp nsr peer ldp sync nack rsn tbl id

    	mismatch

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_pp_exists = 2

    	mgmt ldp nsr peer ldp sync nack rsn pp exists

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_missing_elem = 3

    	mgmt ldp nsr peer ldp sync nack rsn missing

    	elem

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_no_p_end_sock = 4

    	mgmt ldp nsr peer ldp sync nack rsn no p end

    	sock

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_p_end_sock_not_synced = 5

    	mgmt ldp nsr peer ldp sync nack rsn p end sock

    	not synced

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_adj_add = 6

    	mgmt ldp nsr peer ldp sync nack rsn err adj add

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_dhcb_add = 7

    	mgmt ldp nsr peer ldp sync nack rsn err dhcb

    	add

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_enomem = 8

    	mgmt ldp nsr peer ldp sync nack rsn enomem

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_tp_create = 9

    	mgmt ldp nsr peer ldp sync nack rsn err tp

    	create

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_pp_create = 10

    	mgmt ldp nsr peer ldp sync nack rsn err pp

    	create

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_addr_bind = 11

    	mgmt ldp nsr peer ldp sync nack rsn err addr

    	bind

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_rx_bad_pie = 12

    	mgmt ldp nsr peer ldp sync nack rsn err rx bad

    	pie

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_rx_notif = 13

    	mgmt ldp nsr peer ldp sync nack rsn err rx

    	notif

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_rx_unexp_open = 14

    	mgmt ldp nsr peer ldp sync nack rsn err rx

    	unexp open

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_unexp_peer_down = 15

    	mgmt ldp nsr peer ldp sync nack rsn err unexp

    	peer down

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_app_not_found = 16

    	mgmt ldp nsr peer ldp sync nack rsn err app not

    	found

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_app_invalid = 17

    	mgmt ldp nsr peer ldp sync nack rsn err app

    	invalid

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_adj_grp_not_found = 18

    	mgmt ldp nsr peer ldp sync nack rsn err adj grp

    	not found

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_invalid_elem = 19

    	mgmt ldp nsr peer ldp sync nack rsn invalid

    	elem

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_app_data_invalid = 20

    	mgmt ldp nsr peer ldp sync nack rsn err app

    	data invalid

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_invalid_per_idx = 21

    	mgmt ldp nsr peer ldp sync nack rsn err invalid

    	per idx

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_pfx_not_found = 22

    	mgmt ldp nsr peer ldp sync nack rsn err pfx not

    	found

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_bm_size_invalid = 23

    	mgmt ldp nsr peer ldp sync nack rsn err bm size

    	invalid

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_adv_bm_clear = 24

    	mgmt ldp nsr peer ldp sync nack rsn err adv bm

    	clear

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_tcp_struct_create = 25

    	mgmt ldp nsr peer ldp sync nack rsn err tcp

    	struct create

    .. data:: mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_no_ctx = 26

    	mgmt ldp nsr peer ldp sync nack rsn no ctx

    """

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_none = Enum.YLeaf(0, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-none")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_tbl_id_mismatch = Enum.YLeaf(1, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-tbl-id-mismatch")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_pp_exists = Enum.YLeaf(2, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-pp-exists")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_missing_elem = Enum.YLeaf(3, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-missing-elem")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_no_p_end_sock = Enum.YLeaf(4, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-no-p-end-sock")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_p_end_sock_not_synced = Enum.YLeaf(5, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-p-end-sock-not-synced")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_adj_add = Enum.YLeaf(6, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-adj-add")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_dhcb_add = Enum.YLeaf(7, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-dhcb-add")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_enomem = Enum.YLeaf(8, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-enomem")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_tp_create = Enum.YLeaf(9, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-tp-create")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_pp_create = Enum.YLeaf(10, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-pp-create")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_addr_bind = Enum.YLeaf(11, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-addr-bind")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_rx_bad_pie = Enum.YLeaf(12, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-rx-bad-pie")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_rx_notif = Enum.YLeaf(13, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-rx-notif")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_rx_unexp_open = Enum.YLeaf(14, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-rx-unexp-open")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_unexp_peer_down = Enum.YLeaf(15, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-unexp-peer-down")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_app_not_found = Enum.YLeaf(16, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-app-not-found")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_app_invalid = Enum.YLeaf(17, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-app-invalid")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_adj_grp_not_found = Enum.YLeaf(18, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-adj-grp-not-found")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_invalid_elem = Enum.YLeaf(19, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-invalid-elem")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_app_data_invalid = Enum.YLeaf(20, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-app-data-invalid")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_invalid_per_idx = Enum.YLeaf(21, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-invalid-per-idx")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_pfx_not_found = Enum.YLeaf(22, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-pfx-not-found")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_bm_size_invalid = Enum.YLeaf(23, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-bm-size-invalid")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_adv_bm_clear = Enum.YLeaf(24, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-adv-bm-clear")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_err_tcp_struct_create = Enum.YLeaf(25, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-err-tcp-struct-create")

    mgmt_ldp_nsr_peer_ldp_sync_nack_rsn_no_ctx = Enum.YLeaf(26, "mgmt-ldp-nsr-peer-ldp-sync-nack-rsn-no-ctx")


class MgmtLdpNsrPeerSyncErr(Enum):
    """
    MgmtLdpNsrPeerSyncErr

    Mgmt ldp nsr peer sync err

    .. data:: mgmt_ldp_nsr_peer_sync_err_none = 0

    	mgmt ldp nsr peer sync err none

    .. data:: mgmt_ldp_nsr_peer_sync_err_ldp_sync_nack = 1

    	mgmt ldp nsr peer sync err ldp sync nack

    .. data:: mgmt_ldp_nsr_peer_sync_err_sync_prep = 2

    	mgmt ldp nsr peer sync err sync prep

    .. data:: mgmt_ldp_nsr_peer_sync_err_tcp_peer = 3

    	mgmt ldp nsr peer sync err tcp peer

    .. data:: mgmt_ldp_nsr_peer_sync_err_tcp_gbl = 4

    	mgmt ldp nsr peer sync err tcp gbl

    .. data:: mgmt_ldp_nsr_peer_sync_err_ldp_peer = 5

    	mgmt ldp nsr peer sync err ldp peer

    .. data:: mgmt_ldp_nsr_peer_sync_err_ldp_gbl = 6

    	mgmt ldp nsr peer sync err ldp gbl

    .. data:: mgmt_ldp_nsr_peer_sync_err_app_fail = 7

    	mgmt ldp nsr peer sync err app fail

    .. data:: mgmt_ldp_nsr_peer_sync_err_sync_tcp_phase1 = 8

    	mgmt ldp nsr peer sync err sync tcp phase1

    .. data:: mgmt_ldp_nsr_peer_sync_err_sync_tcp_phase2 = 9

    	mgmt ldp nsr peer sync err sync tcp phase2

    """

    mgmt_ldp_nsr_peer_sync_err_none = Enum.YLeaf(0, "mgmt-ldp-nsr-peer-sync-err-none")

    mgmt_ldp_nsr_peer_sync_err_ldp_sync_nack = Enum.YLeaf(1, "mgmt-ldp-nsr-peer-sync-err-ldp-sync-nack")

    mgmt_ldp_nsr_peer_sync_err_sync_prep = Enum.YLeaf(2, "mgmt-ldp-nsr-peer-sync-err-sync-prep")

    mgmt_ldp_nsr_peer_sync_err_tcp_peer = Enum.YLeaf(3, "mgmt-ldp-nsr-peer-sync-err-tcp-peer")

    mgmt_ldp_nsr_peer_sync_err_tcp_gbl = Enum.YLeaf(4, "mgmt-ldp-nsr-peer-sync-err-tcp-gbl")

    mgmt_ldp_nsr_peer_sync_err_ldp_peer = Enum.YLeaf(5, "mgmt-ldp-nsr-peer-sync-err-ldp-peer")

    mgmt_ldp_nsr_peer_sync_err_ldp_gbl = Enum.YLeaf(6, "mgmt-ldp-nsr-peer-sync-err-ldp-gbl")

    mgmt_ldp_nsr_peer_sync_err_app_fail = Enum.YLeaf(7, "mgmt-ldp-nsr-peer-sync-err-app-fail")

    mgmt_ldp_nsr_peer_sync_err_sync_tcp_phase1 = Enum.YLeaf(8, "mgmt-ldp-nsr-peer-sync-err-sync-tcp-phase1")

    mgmt_ldp_nsr_peer_sync_err_sync_tcp_phase2 = Enum.YLeaf(9, "mgmt-ldp-nsr-peer-sync-err-sync-tcp-phase2")


class MgmtLdpNsrPeerSyncState(Enum):
    """
    MgmtLdpNsrPeerSyncState

    Mgmt ldp nsr peer sync state

    .. data:: mgmt_ldp_nsr_peer_sync_st_none = 0

    	mgmt ldp nsr peer sync st none

    .. data:: mgmt_ldp_nsr_peer_sync_st_wait = 1

    	mgmt ldp nsr peer sync st wait

    .. data:: mgmt_ldp_nsr_peer_sync_st_ready = 2

    	mgmt ldp nsr peer sync st ready

    .. data:: mgmt_ldp_nsr_peer_sync_st_prep = 3

    	mgmt ldp nsr peer sync st prep

    .. data:: mgmt_ldp_nsr_peer_sync_st_app_wait = 4

    	mgmt ldp nsr peer sync st app wait

    .. data:: mgmt_ldp_nsr_peer_sync_st_oper = 5

    	mgmt ldp nsr peer sync st oper

    .. data:: mgmt_ldp_nsr_peer_sync_st_tcp_phase1 = 6

    	mgmt ldp nsr peer sync st tcp phase1

    .. data:: mgmt_ldp_nsr_peer_sync_st_tcp_phase2 = 7

    	mgmt ldp nsr peer sync st tcp phase2

    """

    mgmt_ldp_nsr_peer_sync_st_none = Enum.YLeaf(0, "mgmt-ldp-nsr-peer-sync-st-none")

    mgmt_ldp_nsr_peer_sync_st_wait = Enum.YLeaf(1, "mgmt-ldp-nsr-peer-sync-st-wait")

    mgmt_ldp_nsr_peer_sync_st_ready = Enum.YLeaf(2, "mgmt-ldp-nsr-peer-sync-st-ready")

    mgmt_ldp_nsr_peer_sync_st_prep = Enum.YLeaf(3, "mgmt-ldp-nsr-peer-sync-st-prep")

    mgmt_ldp_nsr_peer_sync_st_app_wait = Enum.YLeaf(4, "mgmt-ldp-nsr-peer-sync-st-app-wait")

    mgmt_ldp_nsr_peer_sync_st_oper = Enum.YLeaf(5, "mgmt-ldp-nsr-peer-sync-st-oper")

    mgmt_ldp_nsr_peer_sync_st_tcp_phase1 = Enum.YLeaf(6, "mgmt-ldp-nsr-peer-sync-st-tcp-phase1")

    mgmt_ldp_nsr_peer_sync_st_tcp_phase2 = Enum.YLeaf(7, "mgmt-ldp-nsr-peer-sync-st-tcp-phase2")


class MplsLdpOperAfName(Enum):
    """
    MplsLdpOperAfName

    Mpls ldp oper af name

    .. data:: ipv4 = 1

    	IPv4

    .. data:: ipv6 = 2

    	IPv6

    """

    ipv4 = Enum.YLeaf(1, "ipv4")

    ipv6 = Enum.YLeaf(2, "ipv6")


class ShowNsrState(Enum):
    """
    ShowNsrState

    NSR State Type

    .. data:: nsr_ready = 0

    	NSR ready

    .. data:: nsr_not_ready = 1

    	NSR not ready

    .. data:: nsr_na = 2

    	NSR not applicable

    """

    nsr_ready = Enum.YLeaf(0, "nsr-ready")

    nsr_not_ready = Enum.YLeaf(1, "nsr-not-ready")

    nsr_na = Enum.YLeaf(2, "nsr-na")



class MplsLdp(Entity):
    """
    MPLS LDP operational data
    
    .. attribute:: global_
    
    	Global MPLS LDP operational data
    	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_>`
    
    .. attribute:: nodes
    
    	Location MPLS LDP operational data
    	**type**\:   :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes>`
    
    

    """

    _prefix = 'mpls-ldp-oper'
    _revision = '2015-11-09'

    def __init__(self):
        super(MplsLdp, self).__init__()
        self._top_entity = None

        self.yang_name = "mpls-ldp"
        self.yang_parent_name = "Cisco-IOS-XR-mpls-ldp-oper"

        self.global_ = MplsLdp.Global_()
        self.global_.parent = self
        self._children_name_map["global_"] = "global"
        self._children_yang_names.add("global")

        self.nodes = MplsLdp.Nodes()
        self.nodes.parent = self
        self._children_name_map["nodes"] = "nodes"
        self._children_yang_names.add("nodes")


    class Global_(Entity):
        """
        Global MPLS LDP operational data
        
        .. attribute:: active
        
        	Active MPLS LDP operational data
        	**type**\:   :py:class:`Active <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active>`
        
        .. attribute:: standby
        
        	Standby MPLS LDP operational data
        	**type**\:   :py:class:`Standby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby>`
        
        

        """

        _prefix = 'mpls-ldp-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLdp.Global_, self).__init__()

            self.yang_name = "global"
            self.yang_parent_name = "mpls-ldp"

            self.active = MplsLdp.Global_.Active()
            self.active.parent = self
            self._children_name_map["active"] = "active"
            self._children_yang_names.add("active")

            self.standby = MplsLdp.Global_.Standby()
            self.standby.parent = self
            self._children_name_map["standby"] = "standby"
            self._children_yang_names.add("standby")


        class Standby(Entity):
            """
            Standby MPLS LDP operational data
            
            .. attribute:: ato_mdb_table_entries
            
            	AToM DB Table
            	**type**\:   :py:class:`AtoMdbTableEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries>`
            
            .. attribute:: bindings_summary_all
            
            	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
            	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.BindingsSummaryAll>`
            
            .. attribute:: default_vrf
            
            	DefaultVRF specific operational data
            	**type**\:   :py:class:`DefaultVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf>`
            
            .. attribute:: discovery_summary_all
            
            	Summary information regarding LDP discovery
            	**type**\:   :py:class:`DiscoverySummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DiscoverySummaryAll>`
            
            .. attribute:: forwarding_summary_all
            
            	Summary information regarding LDP forwarding setup
            	**type**\:   :py:class:`ForwardingSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll>`
            
            .. attribute:: nsr_summary_all
            
            	Summary information regarding LDP NSR State
            	**type**\:   :py:class:`NsrSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.NsrSummaryAll>`
            
            .. attribute:: summary
            
            	LDP summary
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Summary>`
            
            .. attribute:: vrfs
            
            	VRF specific operational data
            	**type**\:   :py:class:`Vrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs>`
            
            

            """

            _prefix = 'mpls-ldp-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLdp.Global_.Standby, self).__init__()

                self.yang_name = "standby"
                self.yang_parent_name = "global"

                self.ato_mdb_table_entries = MplsLdp.Global_.Standby.AtoMdbTableEntries()
                self.ato_mdb_table_entries.parent = self
                self._children_name_map["ato_mdb_table_entries"] = "ato-mdb-table-entries"
                self._children_yang_names.add("ato-mdb-table-entries")

                self.bindings_summary_all = MplsLdp.Global_.Standby.BindingsSummaryAll()
                self.bindings_summary_all.parent = self
                self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                self._children_yang_names.add("bindings-summary-all")

                self.default_vrf = MplsLdp.Global_.Standby.DefaultVrf()
                self.default_vrf.parent = self
                self._children_name_map["default_vrf"] = "default-vrf"
                self._children_yang_names.add("default-vrf")

                self.discovery_summary_all = MplsLdp.Global_.Standby.DiscoverySummaryAll()
                self.discovery_summary_all.parent = self
                self._children_name_map["discovery_summary_all"] = "discovery-summary-all"
                self._children_yang_names.add("discovery-summary-all")

                self.forwarding_summary_all = MplsLdp.Global_.Standby.ForwardingSummaryAll()
                self.forwarding_summary_all.parent = self
                self._children_name_map["forwarding_summary_all"] = "forwarding-summary-all"
                self._children_yang_names.add("forwarding-summary-all")

                self.nsr_summary_all = MplsLdp.Global_.Standby.NsrSummaryAll()
                self.nsr_summary_all.parent = self
                self._children_name_map["nsr_summary_all"] = "nsr-summary-all"
                self._children_yang_names.add("nsr-summary-all")

                self.summary = MplsLdp.Global_.Standby.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")

                self.vrfs = MplsLdp.Global_.Standby.Vrfs()
                self.vrfs.parent = self
                self._children_name_map["vrfs"] = "vrfs"
                self._children_yang_names.add("vrfs")


            class DefaultVrf(Entity):
                """
                DefaultVRF specific operational data
                
                .. attribute:: afs
                
                	Address Family specific operational data
                	**type**\:   :py:class:`Afs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs>`
                
                .. attribute:: backoff_parameters
                
                	The LDP Backoff Parameters
                	**type**\:   :py:class:`BackoffParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.BackoffParameters>`
                
                .. attribute:: backoffs
                
                	The LDP backoff
                	**type**\:   :py:class:`Backoffs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Backoffs>`
                
                .. attribute:: capabilities
                
                	LDP capability database information
                	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Capabilities>`
                
                .. attribute:: graceful_restart
                
                	LDP Graceful Restart info
                	**type**\:   :py:class:`GracefulRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart>`
                
                .. attribute:: issu
                
                	LDP ISSU related information
                	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu>`
                
                .. attribute:: ldp_id
                
                	Local LDP Id
                	**type**\:   :py:class:`LdpId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.LdpId>`
                
                .. attribute:: neighbor_briefs
                
                	The LDP Neighbors (brief)
                	**type**\:   :py:class:`NeighborBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs>`
                
                .. attribute:: neighbor_capabilities
                
                	LDP Neighbors Capabilities
                	**type**\:   :py:class:`NeighborCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities>`
                
                .. attribute:: neighbors
                
                	The LDP Neighbors
                	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors>`
                
                .. attribute:: nsr
                
                	LDP NSR related information
                	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr>`
                
                .. attribute:: parameters
                
                	LDP parameters
                	**type**\:   :py:class:`Parameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Parameters>`
                
                .. attribute:: statistics
                
                	The LDP Statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Statistics>`
                
                .. attribute:: summary
                
                	LDP VRF summary
                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Summary>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.DefaultVrf, self).__init__()

                    self.yang_name = "default-vrf"
                    self.yang_parent_name = "standby"

                    self.afs = MplsLdp.Global_.Standby.DefaultVrf.Afs()
                    self.afs.parent = self
                    self._children_name_map["afs"] = "afs"
                    self._children_yang_names.add("afs")

                    self.backoff_parameters = MplsLdp.Global_.Standby.DefaultVrf.BackoffParameters()
                    self.backoff_parameters.parent = self
                    self._children_name_map["backoff_parameters"] = "backoff-parameters"
                    self._children_yang_names.add("backoff-parameters")

                    self.backoffs = MplsLdp.Global_.Standby.DefaultVrf.Backoffs()
                    self.backoffs.parent = self
                    self._children_name_map["backoffs"] = "backoffs"
                    self._children_yang_names.add("backoffs")

                    self.capabilities = MplsLdp.Global_.Standby.DefaultVrf.Capabilities()
                    self.capabilities.parent = self
                    self._children_name_map["capabilities"] = "capabilities"
                    self._children_yang_names.add("capabilities")

                    self.graceful_restart = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart()
                    self.graceful_restart.parent = self
                    self._children_name_map["graceful_restart"] = "graceful-restart"
                    self._children_yang_names.add("graceful-restart")

                    self.issu = MplsLdp.Global_.Standby.DefaultVrf.Issu()
                    self.issu.parent = self
                    self._children_name_map["issu"] = "issu"
                    self._children_yang_names.add("issu")

                    self.ldp_id = MplsLdp.Global_.Standby.DefaultVrf.LdpId()
                    self.ldp_id.parent = self
                    self._children_name_map["ldp_id"] = "ldp-id"
                    self._children_yang_names.add("ldp-id")

                    self.neighbor_briefs = MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs()
                    self.neighbor_briefs.parent = self
                    self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                    self._children_yang_names.add("neighbor-briefs")

                    self.neighbor_capabilities = MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities()
                    self.neighbor_capabilities.parent = self
                    self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                    self._children_yang_names.add("neighbor-capabilities")

                    self.neighbors = MplsLdp.Global_.Standby.DefaultVrf.Neighbors()
                    self.neighbors.parent = self
                    self._children_name_map["neighbors"] = "neighbors"
                    self._children_yang_names.add("neighbors")

                    self.nsr = MplsLdp.Global_.Standby.DefaultVrf.Nsr()
                    self.nsr.parent = self
                    self._children_name_map["nsr"] = "nsr"
                    self._children_yang_names.add("nsr")

                    self.parameters = MplsLdp.Global_.Standby.DefaultVrf.Parameters()
                    self.parameters.parent = self
                    self._children_name_map["parameters"] = "parameters"
                    self._children_yang_names.add("parameters")

                    self.statistics = MplsLdp.Global_.Standby.DefaultVrf.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.summary = MplsLdp.Global_.Standby.DefaultVrf.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._children_yang_names.add("summary")


                class GracefulRestart(Entity):
                    """
                    LDP Graceful Restart info
                    
                    .. attribute:: forwarding_state_hold_timer_remaining_seconds
                    
                    	Forwarding state hold timer remaining time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: graceful_restartable_neighbor
                    
                    	Vector of graceful restart neighbor information
                    	**type**\: list of    :py:class:`GracefulRestartableNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor>`
                    
                    .. attribute:: is_forwarding_state_hold_timer_running
                    
                    	Is graceful restart forwarding state hold timer running
                    	**type**\:  bool
                    
                    .. attribute:: vrf
                    
                    	VRF information
                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.Vrf>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart, self).__init__()

                        self.yang_name = "graceful-restart"
                        self.yang_parent_name = "default-vrf"

                        self.forwarding_state_hold_timer_remaining_seconds = YLeaf(YType.uint32, "forwarding-state-hold-timer-remaining-seconds")

                        self.is_forwarding_state_hold_timer_running = YLeaf(YType.boolean, "is-forwarding-state-hold-timer-running")

                        self.vrf = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.Vrf()
                        self.vrf.parent = self
                        self._children_name_map["vrf"] = "vrf"
                        self._children_yang_names.add("vrf")

                        self.graceful_restartable_neighbor = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("forwarding_state_hold_timer_remaining_seconds",
                                        "is_forwarding_state_hold_timer_running") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart, self).__setattr__(name, value)


                    class Vrf(Entity):
                        """
                        VRF information
                        
                        .. attribute:: id
                        
                        	VRF Id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.Vrf, self).__init__()

                            self.yang_name = "vrf"
                            self.yang_parent_name = "graceful-restart"

                            self.id = YLeaf(YType.uint32, "id")

                            self.name = YLeaf(YType.str, "name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("id",
                                            "name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.Vrf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.Vrf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.id.is_set or
                                self.name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.id.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/graceful-restart/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.id.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "id" or name == "name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "id"):
                                self.id = value
                                self.id.value_namespace = name_space
                                self.id.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix


                    class GracefulRestartableNeighbor(Entity):
                        """
                        Vector of graceful restart neighbor information
                        
                        .. attribute:: connect_count
                        
                        	ConnectCount
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_address
                        
                        	Addresses bound to GR down Nbr
                        	**type**\: list of    :py:class:`DownNbrAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress>`
                        
                        .. attribute:: down_nbr_down_reason
                        
                        	Session down reason code
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_flags
                        
                        	Flags
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_flap_count
                        
                        	Count of back2back flaps
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: down_nbr_interface
                        
                        	Interfaces bound to GR down Nbr
                        	**type**\: list of    :py:class:`DownNbrInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface>`
                        
                        .. attribute:: gr_peer
                        
                        	GR peer LDP Id
                        	**type**\:   :py:class:`GrPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer>`
                        
                        .. attribute:: is_liveness_timer_running
                        
                        	Is liveness timer running
                        	**type**\:  bool
                        
                        .. attribute:: is_neighbor_up
                        
                        	Is neighbor up
                        	**type**\:  bool
                        
                        .. attribute:: is_recovery_timer_running
                        
                        	Is recovery timer running
                        	**type**\:  bool
                        
                        .. attribute:: liveness_timer_remaining_seconds
                        
                        	Remaining time from liveness timer
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: recovery_timer_remaining_seconds
                        
                        	Recovery timer remining time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__init__()

                            self.yang_name = "graceful-restartable-neighbor"
                            self.yang_parent_name = "graceful-restart"

                            self.connect_count = YLeaf(YType.uint32, "connect-count")

                            self.down_nbr_down_reason = YLeaf(YType.uint32, "down-nbr-down-reason")

                            self.down_nbr_flags = YLeaf(YType.uint32, "down-nbr-flags")

                            self.down_nbr_flap_count = YLeaf(YType.uint8, "down-nbr-flap-count")

                            self.is_liveness_timer_running = YLeaf(YType.boolean, "is-liveness-timer-running")

                            self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                            self.is_recovery_timer_running = YLeaf(YType.boolean, "is-recovery-timer-running")

                            self.liveness_timer_remaining_seconds = YLeaf(YType.uint32, "liveness-timer-remaining-seconds")

                            self.recovery_timer_remaining_seconds = YLeaf(YType.uint32, "recovery-timer-remaining-seconds")

                            self.gr_peer = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                            self.gr_peer.parent = self
                            self._children_name_map["gr_peer"] = "gr-peer"
                            self._children_yang_names.add("gr-peer")

                            self.down_nbr_address = YList(self)
                            self.down_nbr_interface = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("connect_count",
                                            "down_nbr_down_reason",
                                            "down_nbr_flags",
                                            "down_nbr_flap_count",
                                            "is_liveness_timer_running",
                                            "is_neighbor_up",
                                            "is_recovery_timer_running",
                                            "liveness_timer_remaining_seconds",
                                            "recovery_timer_remaining_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)


                        class GrPeer(Entity):
                            """
                            GR peer LDP Id
                            
                            .. attribute:: label_space_id
                            
                            	Label space identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: ldp_id
                            
                            	LDP identifier
                            	**type**\:  str
                            
                            .. attribute:: lsr_id
                            
                            	LSR identifier
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__init__()

                                self.yang_name = "gr-peer"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "ldp_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.label_space_id.is_set or
                                    self.ldp_id.is_set or
                                    self.lsr_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.ldp_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gr-peer" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/graceful-restart/graceful-restartable-neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-id"):
                                    self.ldp_id = value
                                    self.ldp_id.value_namespace = name_space
                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix


                        class DownNbrInterface(Entity):
                            """
                            Interfaces bound to GR down Nbr
                            
                            .. attribute:: address_family
                            
                            	Interface adj Address Family
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: interface_handle
                            
                            	Interfaces handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__init__()

                                self.yang_name = "down-nbr-interface"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.interface_handle = YLeaf(YType.str, "interface-handle")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "interface_handle") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.interface_handle.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.interface_handle.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "down-nbr-interface" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/graceful-restart/graceful-restartable-neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_handle.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-family" or name == "interface-handle"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-handle"):
                                    self.interface_handle = value
                                    self.interface_handle.value_namespace = name_space
                                    self.interface_handle.value_namespace_prefix = name_space_prefix


                        class DownNbrAddress(Entity):
                            """
                            Addresses bound to GR down Nbr
                            
                            .. attribute:: afi
                            
                            	AFI
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: dummy
                            
                            	No Address
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: ipv4
                            
                            	IPv4 address type
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv6
                            
                            	IPv6 address type
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__init__()

                                self.yang_name = "down-nbr-address"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.afi = YLeaf(YType.enumeration, "afi")

                                self.dummy = YLeaf(YType.uint8, "dummy")

                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                self.ipv6 = YLeaf(YType.str, "ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("afi",
                                                "dummy",
                                                "ipv4",
                                                "ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.afi.is_set or
                                    self.dummy.is_set or
                                    self.ipv4.is_set or
                                    self.ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.afi.yfilter != YFilter.not_set or
                                    self.dummy.yfilter != YFilter.not_set or
                                    self.ipv4.yfilter != YFilter.not_set or
                                    self.ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "down-nbr-address" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/graceful-restart/graceful-restartable-neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "afi"):
                                    self.afi = value
                                    self.afi.value_namespace = name_space
                                    self.afi.value_namespace_prefix = name_space_prefix
                                if(value_path == "dummy"):
                                    self.dummy = value
                                    self.dummy.value_namespace = name_space
                                    self.dummy.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv4"):
                                    self.ipv4 = value
                                    self.ipv4.value_namespace = name_space
                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv6"):
                                    self.ipv6 = value
                                    self.ipv6.value_namespace = name_space
                                    self.ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.down_nbr_address:
                                if (c.has_data()):
                                    return True
                            for c in self.down_nbr_interface:
                                if (c.has_data()):
                                    return True
                            return (
                                self.connect_count.is_set or
                                self.down_nbr_down_reason.is_set or
                                self.down_nbr_flags.is_set or
                                self.down_nbr_flap_count.is_set or
                                self.is_liveness_timer_running.is_set or
                                self.is_neighbor_up.is_set or
                                self.is_recovery_timer_running.is_set or
                                self.liveness_timer_remaining_seconds.is_set or
                                self.recovery_timer_remaining_seconds.is_set or
                                (self.gr_peer is not None and self.gr_peer.has_data()))

                        def has_operation(self):
                            for c in self.down_nbr_address:
                                if (c.has_operation()):
                                    return True
                            for c in self.down_nbr_interface:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.connect_count.yfilter != YFilter.not_set or
                                self.down_nbr_down_reason.yfilter != YFilter.not_set or
                                self.down_nbr_flags.yfilter != YFilter.not_set or
                                self.down_nbr_flap_count.yfilter != YFilter.not_set or
                                self.is_liveness_timer_running.yfilter != YFilter.not_set or
                                self.is_neighbor_up.yfilter != YFilter.not_set or
                                self.is_recovery_timer_running.yfilter != YFilter.not_set or
                                self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set or
                                self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set or
                                (self.gr_peer is not None and self.gr_peer.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restartable-neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/graceful-restart/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.connect_count.get_name_leafdata())
                            if (self.down_nbr_down_reason.is_set or self.down_nbr_down_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_down_reason.get_name_leafdata())
                            if (self.down_nbr_flags.is_set or self.down_nbr_flags.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_flags.get_name_leafdata())
                            if (self.down_nbr_flap_count.is_set or self.down_nbr_flap_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_flap_count.get_name_leafdata())
                            if (self.is_liveness_timer_running.is_set or self.is_liveness_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_liveness_timer_running.get_name_leafdata())
                            if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                            if (self.is_recovery_timer_running.is_set or self.is_recovery_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_recovery_timer_running.get_name_leafdata())
                            if (self.liveness_timer_remaining_seconds.is_set or self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.liveness_timer_remaining_seconds.get_name_leafdata())
                            if (self.recovery_timer_remaining_seconds.is_set or self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.recovery_timer_remaining_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "down-nbr-address"):
                                for c in self.down_nbr_address:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.down_nbr_address.append(c)
                                return c

                            if (child_yang_name == "down-nbr-interface"):
                                for c in self.down_nbr_interface:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.down_nbr_interface.append(c)
                                return c

                            if (child_yang_name == "gr-peer"):
                                if (self.gr_peer is None):
                                    self.gr_peer = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                    self.gr_peer.parent = self
                                    self._children_name_map["gr_peer"] = "gr-peer"
                                return self.gr_peer

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "down-nbr-address" or name == "down-nbr-interface" or name == "gr-peer" or name == "connect-count" or name == "down-nbr-down-reason" or name == "down-nbr-flags" or name == "down-nbr-flap-count" or name == "is-liveness-timer-running" or name == "is-neighbor-up" or name == "is-recovery-timer-running" or name == "liveness-timer-remaining-seconds" or name == "recovery-timer-remaining-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "connect-count"):
                                self.connect_count = value
                                self.connect_count.value_namespace = name_space
                                self.connect_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-down-reason"):
                                self.down_nbr_down_reason = value
                                self.down_nbr_down_reason.value_namespace = name_space
                                self.down_nbr_down_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-flags"):
                                self.down_nbr_flags = value
                                self.down_nbr_flags.value_namespace = name_space
                                self.down_nbr_flags.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-flap-count"):
                                self.down_nbr_flap_count = value
                                self.down_nbr_flap_count.value_namespace = name_space
                                self.down_nbr_flap_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-liveness-timer-running"):
                                self.is_liveness_timer_running = value
                                self.is_liveness_timer_running.value_namespace = name_space
                                self.is_liveness_timer_running.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-neighbor-up"):
                                self.is_neighbor_up = value
                                self.is_neighbor_up.value_namespace = name_space
                                self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-recovery-timer-running"):
                                self.is_recovery_timer_running = value
                                self.is_recovery_timer_running.value_namespace = name_space
                                self.is_recovery_timer_running.value_namespace_prefix = name_space_prefix
                            if(value_path == "liveness-timer-remaining-seconds"):
                                self.liveness_timer_remaining_seconds = value
                                self.liveness_timer_remaining_seconds.value_namespace = name_space
                                self.liveness_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "recovery-timer-remaining-seconds"):
                                self.recovery_timer_remaining_seconds = value
                                self.recovery_timer_remaining_seconds.value_namespace = name_space
                                self.recovery_timer_remaining_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.graceful_restartable_neighbor:
                            if (c.has_data()):
                                return True
                        return (
                            self.forwarding_state_hold_timer_remaining_seconds.is_set or
                            self.is_forwarding_state_hold_timer_running.is_set or
                            (self.vrf is not None and self.vrf.has_data()))

                    def has_operation(self):
                        for c in self.graceful_restartable_neighbor:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set or
                            self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set or
                            (self.vrf is not None and self.vrf.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "graceful-restart" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.forwarding_state_hold_timer_remaining_seconds.is_set or self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forwarding_state_hold_timer_remaining_seconds.get_name_leafdata())
                        if (self.is_forwarding_state_hold_timer_running.is_set or self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_forwarding_state_hold_timer_running.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "graceful-restartable-neighbor"):
                            for c in self.graceful_restartable_neighbor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.graceful_restartable_neighbor.append(c)
                            return c

                        if (child_yang_name == "vrf"):
                            if (self.vrf is None):
                                self.vrf = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                            return self.vrf

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "graceful-restartable-neighbor" or name == "vrf" or name == "forwarding-state-hold-timer-remaining-seconds" or name == "is-forwarding-state-hold-timer-running"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "forwarding-state-hold-timer-remaining-seconds"):
                            self.forwarding_state_hold_timer_remaining_seconds = value
                            self.forwarding_state_hold_timer_remaining_seconds.value_namespace = name_space
                            self.forwarding_state_hold_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-forwarding-state-hold-timer-running"):
                            self.is_forwarding_state_hold_timer_running = value
                            self.is_forwarding_state_hold_timer_running.value_namespace = name_space
                            self.is_forwarding_state_hold_timer_running.value_namespace_prefix = name_space_prefix


                class Capabilities(Entity):
                    """
                    LDP capability database information
                    
                    .. attribute:: capability
                    
                    	Information on LDP capability
                    	**type**\: list of    :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities, self).__init__()

                        self.yang_name = "capabilities"
                        self.yang_parent_name = "default-vrf"

                        self.capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities, self).__setattr__(name, value)


                    class Capability(Entity):
                        """
                        Information on LDP capability
                        
                        .. attribute:: capability_type  <key>
                        
                        	The capability type (IANA assigned)
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: capability
                        
                        	Capability information
                        	**type**\:   :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability.Capability>`
                        
                        .. attribute:: capability_owner
                        
                        	Capability owner
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability, self).__init__()

                            self.yang_name = "capability"
                            self.yang_parent_name = "capabilities"

                            self.capability_type = YLeaf(YType.int32, "capability-type")

                            self.capability_owner = YLeaf(YType.str, "capability-owner")

                            self.capability = MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability.Capability()
                            self.capability.parent = self
                            self._children_name_map["capability"] = "capability"
                            self._children_yang_names.add("capability")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("capability_type",
                                            "capability_owner") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability, self).__setattr__(name, value)


                        class Capability(Entity):
                            """
                            Capability information
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability.Capability, self).__init__()

                                self.yang_name = "capability"
                                self.yang_parent_name = "capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability.Capability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability.Capability, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "capability" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.capability_type.is_set or
                                self.capability_owner.is_set or
                                (self.capability is not None and self.capability.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.capability_type.yfilter != YFilter.not_set or
                                self.capability_owner.yfilter != YFilter.not_set or
                                (self.capability is not None and self.capability.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "capability" + "[capability-type='" + self.capability_type.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.capability_type.is_set or self.capability_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.capability_type.get_name_leafdata())
                            if (self.capability_owner.is_set or self.capability_owner.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.capability_owner.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "capability"):
                                if (self.capability is None):
                                    self.capability = MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability.Capability()
                                    self.capability.parent = self
                                    self._children_name_map["capability"] = "capability"
                                return self.capability

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "capability" or name == "capability-type" or name == "capability-owner"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "capability-type"):
                                self.capability_type = value
                                self.capability_type.value_namespace = name_space
                                self.capability_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "capability-owner"):
                                self.capability_owner = value
                                self.capability_owner.value_namespace = name_space
                                self.capability_owner.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "capability"):
                            for c in self.capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.Capabilities.Capability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Summary(Entity):
                    """
                    LDP VRF summary
                    
                    .. attribute:: common
                    
                    	Common Summary information
                    	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Summary.Common>`
                    
                    .. attribute:: vrf
                    
                    	VRF information
                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Summary.Vrf>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "default-vrf"

                        self.common = MplsLdp.Global_.Standby.DefaultVrf.Summary.Common()
                        self.common.parent = self
                        self._children_name_map["common"] = "common"
                        self._children_yang_names.add("common")

                        self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Summary.Vrf()
                        self.vrf.parent = self
                        self._children_name_map["vrf"] = "vrf"
                        self._children_yang_names.add("vrf")


                    class Vrf(Entity):
                        """
                        VRF information
                        
                        .. attribute:: id
                        
                        	VRF Id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Summary.Vrf, self).__init__()

                            self.yang_name = "vrf"
                            self.yang_parent_name = "summary"

                            self.id = YLeaf(YType.uint32, "id")

                            self.name = YLeaf(YType.str, "name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("id",
                                            "name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Summary.Vrf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Summary.Vrf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.id.is_set or
                                self.name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.id.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.id.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "id" or name == "name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "id"):
                                self.id = value
                                self.id.value_namespace = name_space
                                self.id.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix


                    class Common(Entity):
                        """
                        Common Summary information
                        
                        .. attribute:: address_families
                        
                        	Address Families enabled
                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                        
                        .. attribute:: number_of_bindings_ipv4
                        
                        	Total number of ipv4 bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_bindings_ipv6
                        
                        	Total number of ipv6 bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_downstream_on_demand_neighbors
                        
                        	Number of Downstream\-On\-Demand neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_graceful_restart_neighbors
                        
                        	Number of Graceful Restart neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_hello_adj
                        
                        	Number of LDP discovery IPv4 hello adjacencies
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_local_addresses
                        
                        	Number of IPv4 local addresses
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_routes
                        
                        	Number of resolved IPv4 routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4af
                        
                        	Number of IPv4 address\-families enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4ldp_interfaces
                        
                        	Number of LDP IPv4 configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_hello_adj
                        
                        	Number of LDP discovery IPv6 hello adjacencies
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_local_addresses
                        
                        	Number of IPv6 local addresses
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_routes
                        
                        	Number of resolved IPv6 routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6af
                        
                        	Number of IPv6 address\-families enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6ldp_interfaces
                        
                        	Number of LDP IPv6 configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ldp_interfaces
                        
                        	Number of LDP configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_local_bindings_ipv4
                        
                        	Total number of ipv4 local label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_local_bindings_ipv6
                        
                        	Total number of ipv6 local label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_neighbors
                        
                        	Number of neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_nsr_synced_neighbors
                        
                        	Number of NSR\-synced/operational neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_remote_bindings_ipv4
                        
                        	Total number of ipv4 remote label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_remote_bindings_ipv6
                        
                        	Total number of ipv6 remote label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Summary.Common, self).__init__()

                            self.yang_name = "common"
                            self.yang_parent_name = "summary"

                            self.address_families = YLeaf(YType.enumeration, "address-families")

                            self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                            self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                            self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                            self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                            self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                            self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                            self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                            self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                            self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                            self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                            self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                            self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                            self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                            self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                            self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                            self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                            self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                            self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                            self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                            self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                            self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("address_families",
                                            "number_of_bindings_ipv4",
                                            "number_of_bindings_ipv6",
                                            "number_of_downstream_on_demand_neighbors",
                                            "number_of_graceful_restart_neighbors",
                                            "number_of_ipv4_hello_adj",
                                            "number_of_ipv4_local_addresses",
                                            "number_of_ipv4_routes",
                                            "number_of_ipv4af",
                                            "number_of_ipv4ldp_interfaces",
                                            "number_of_ipv6_hello_adj",
                                            "number_of_ipv6_local_addresses",
                                            "number_of_ipv6_routes",
                                            "number_of_ipv6af",
                                            "number_of_ipv6ldp_interfaces",
                                            "number_of_ldp_interfaces",
                                            "number_of_local_bindings_ipv4",
                                            "number_of_local_bindings_ipv6",
                                            "number_of_neighbors",
                                            "number_of_nsr_synced_neighbors",
                                            "number_of_remote_bindings_ipv4",
                                            "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Summary.Common, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Summary.Common, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.address_families.is_set or
                                self.number_of_bindings_ipv4.is_set or
                                self.number_of_bindings_ipv6.is_set or
                                self.number_of_downstream_on_demand_neighbors.is_set or
                                self.number_of_graceful_restart_neighbors.is_set or
                                self.number_of_ipv4_hello_adj.is_set or
                                self.number_of_ipv4_local_addresses.is_set or
                                self.number_of_ipv4_routes.is_set or
                                self.number_of_ipv4af.is_set or
                                self.number_of_ipv4ldp_interfaces.is_set or
                                self.number_of_ipv6_hello_adj.is_set or
                                self.number_of_ipv6_local_addresses.is_set or
                                self.number_of_ipv6_routes.is_set or
                                self.number_of_ipv6af.is_set or
                                self.number_of_ipv6ldp_interfaces.is_set or
                                self.number_of_ldp_interfaces.is_set or
                                self.number_of_local_bindings_ipv4.is_set or
                                self.number_of_local_bindings_ipv6.is_set or
                                self.number_of_neighbors.is_set or
                                self.number_of_nsr_synced_neighbors.is_set or
                                self.number_of_remote_bindings_ipv4.is_set or
                                self.number_of_remote_bindings_ipv6.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.address_families.yfilter != YFilter.not_set or
                                self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                                self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                                self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                                self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                                self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                                self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                                self.number_of_ipv4af.yfilter != YFilter.not_set or
                                self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                                self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                                self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                                self.number_of_ipv6af.yfilter != YFilter.not_set or
                                self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                                self.number_of_neighbors.yfilter != YFilter.not_set or
                                self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                                self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "common" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.address_families.get_name_leafdata())
                            if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                            if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                            if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                            if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                            if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                            if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                            if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                            if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                            if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                            if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                            if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                            if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                            if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                            if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                            if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                            if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                            if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                            if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "address-families"):
                                self.address_families = value
                                self.address_families.value_namespace = name_space
                                self.address_families.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-bindings-ipv4"):
                                self.number_of_bindings_ipv4 = value
                                self.number_of_bindings_ipv4.value_namespace = name_space
                                self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-bindings-ipv6"):
                                self.number_of_bindings_ipv6 = value
                                self.number_of_bindings_ipv6.value_namespace = name_space
                                self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-downstream-on-demand-neighbors"):
                                self.number_of_downstream_on_demand_neighbors = value
                                self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                                self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-graceful-restart-neighbors"):
                                self.number_of_graceful_restart_neighbors = value
                                self.number_of_graceful_restart_neighbors.value_namespace = name_space
                                self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-hello-adj"):
                                self.number_of_ipv4_hello_adj = value
                                self.number_of_ipv4_hello_adj.value_namespace = name_space
                                self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-local-addresses"):
                                self.number_of_ipv4_local_addresses = value
                                self.number_of_ipv4_local_addresses.value_namespace = name_space
                                self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-routes"):
                                self.number_of_ipv4_routes = value
                                self.number_of_ipv4_routes.value_namespace = name_space
                                self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4af"):
                                self.number_of_ipv4af = value
                                self.number_of_ipv4af.value_namespace = name_space
                                self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4ldp-interfaces"):
                                self.number_of_ipv4ldp_interfaces = value
                                self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                                self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-hello-adj"):
                                self.number_of_ipv6_hello_adj = value
                                self.number_of_ipv6_hello_adj.value_namespace = name_space
                                self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-local-addresses"):
                                self.number_of_ipv6_local_addresses = value
                                self.number_of_ipv6_local_addresses.value_namespace = name_space
                                self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-routes"):
                                self.number_of_ipv6_routes = value
                                self.number_of_ipv6_routes.value_namespace = name_space
                                self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6af"):
                                self.number_of_ipv6af = value
                                self.number_of_ipv6af.value_namespace = name_space
                                self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6ldp-interfaces"):
                                self.number_of_ipv6ldp_interfaces = value
                                self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                                self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ldp-interfaces"):
                                self.number_of_ldp_interfaces = value
                                self.number_of_ldp_interfaces.value_namespace = name_space
                                self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-local-bindings-ipv4"):
                                self.number_of_local_bindings_ipv4 = value
                                self.number_of_local_bindings_ipv4.value_namespace = name_space
                                self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-local-bindings-ipv6"):
                                self.number_of_local_bindings_ipv6 = value
                                self.number_of_local_bindings_ipv6.value_namespace = name_space
                                self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-neighbors"):
                                self.number_of_neighbors = value
                                self.number_of_neighbors.value_namespace = name_space
                                self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-nsr-synced-neighbors"):
                                self.number_of_nsr_synced_neighbors = value
                                self.number_of_nsr_synced_neighbors.value_namespace = name_space
                                self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-remote-bindings-ipv4"):
                                self.number_of_remote_bindings_ipv4 = value
                                self.number_of_remote_bindings_ipv4.value_namespace = name_space
                                self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-remote-bindings-ipv6"):
                                self.number_of_remote_bindings_ipv6 = value
                                self.number_of_remote_bindings_ipv6.value_namespace = name_space
                                self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.common is not None and self.common.has_data()) or
                            (self.vrf is not None and self.vrf.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.common is not None and self.common.has_operation()) or
                            (self.vrf is not None and self.vrf.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "common"):
                            if (self.common is None):
                                self.common = MplsLdp.Global_.Standby.DefaultVrf.Summary.Common()
                                self.common.parent = self
                                self._children_name_map["common"] = "common"
                            return self.common

                        if (child_yang_name == "vrf"):
                            if (self.vrf is None):
                                self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Summary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                            return self.vrf

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "common" or name == "vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Afs(Entity):
                    """
                    Address Family specific operational data
                    
                    .. attribute:: af
                    
                    	Operational data for given Address Family
                    	**type**\: list of    :py:class:`Af <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs, self).__init__()

                        self.yang_name = "afs"
                        self.yang_parent_name = "default-vrf"

                        self.af = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs, self).__setattr__(name, value)


                    class Af(Entity):
                        """
                        Operational data for given Address Family
                        
                        .. attribute:: af_name  <key>
                        
                        	Address Family name
                        	**type**\:   :py:class:`MplsLdpOperAfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdpOperAfName>`
                        
                        .. attribute:: bindings
                        
                        	The LDP Bindings
                        	**type**\:   :py:class:`Bindings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings>`
                        
                        .. attribute:: bindings_advertise_spec
                        
                        	Advertisement Spec (ACL) for LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsAdvertiseSpec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec>`
                        
                        .. attribute:: bindings_summary
                        
                        	Counters for the LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary>`
                        
                        .. attribute:: bindings_summary_all
                        
                        	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll>`
                        
                        .. attribute:: discovery
                        
                        	The LDP Discovery
                        	**type**\:   :py:class:`Discovery <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery>`
                        
                        .. attribute:: forwarding_summary
                        
                        	Summary information regarding LDP forwarding setup
                        	**type**\:   :py:class:`ForwardingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary>`
                        
                        .. attribute:: forwardings
                        
                        	The LDP Forwarding rewrites
                        	**type**\:   :py:class:`Forwardings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings>`
                        
                        .. attribute:: igp
                        
                        	LDP IGP related information
                        	**type**\:   :py:class:`Igp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp>`
                        
                        .. attribute:: interface_summary
                        
                        	IPv4 interface summary information
                        	**type**\:   :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.InterfaceSummary>`
                        
                        .. attribute:: interfaces
                        
                        	LDP Interface related information
                        	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af, self).__init__()

                            self.yang_name = "af"
                            self.yang_parent_name = "afs"

                            self.af_name = YLeaf(YType.enumeration, "af-name")

                            self.bindings = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings()
                            self.bindings.parent = self
                            self._children_name_map["bindings"] = "bindings"
                            self._children_yang_names.add("bindings")

                            self.bindings_advertise_spec = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec()
                            self.bindings_advertise_spec.parent = self
                            self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                            self._children_yang_names.add("bindings-advertise-spec")

                            self.bindings_summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary()
                            self.bindings_summary.parent = self
                            self._children_name_map["bindings_summary"] = "bindings-summary"
                            self._children_yang_names.add("bindings-summary")

                            self.bindings_summary_all = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll()
                            self.bindings_summary_all.parent = self
                            self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                            self._children_yang_names.add("bindings-summary-all")

                            self.discovery = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery()
                            self.discovery.parent = self
                            self._children_name_map["discovery"] = "discovery"
                            self._children_yang_names.add("discovery")

                            self.forwarding_summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary()
                            self.forwarding_summary.parent = self
                            self._children_name_map["forwarding_summary"] = "forwarding-summary"
                            self._children_yang_names.add("forwarding-summary")

                            self.forwardings = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings()
                            self.forwardings.parent = self
                            self._children_name_map["forwardings"] = "forwardings"
                            self._children_yang_names.add("forwardings")

                            self.igp = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp()
                            self.igp.parent = self
                            self._children_name_map["igp"] = "igp"
                            self._children_yang_names.add("igp")

                            self.interface_summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.InterfaceSummary()
                            self.interface_summary.parent = self
                            self._children_name_map["interface_summary"] = "interface-summary"
                            self._children_yang_names.add("interface-summary")

                            self.interfaces = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces()
                            self.interfaces.parent = self
                            self._children_name_map["interfaces"] = "interfaces"
                            self._children_yang_names.add("interfaces")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("af_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af, self).__setattr__(name, value)


                        class InterfaceSummary(Entity):
                            """
                            IPv4 interface summary information
                            
                            .. attribute:: auto_config
                            
                            	Auto\-configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: auto_config_disabled
                            
                            	Autoconfigure disabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: auto_config_forward_reference_interfaces
                            
                            	Auto\-configured forward references
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: forward_references
                            
                            	Number of forward referenced interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: known_ip_interface_count
                            
                            	Number of known IP Interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: known_ip_interface_ldp_enabled
                            
                            	Number of known IP Interfaces with LDP Enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ldp_configured_attached_interface
                            
                            	Number of attached interfaces configured in LDP
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ldp_configured_te_interface
                            
                            	Number of TE tunnel interfaces configured in LDP
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.InterfaceSummary, self).__init__()

                                self.yang_name = "interface-summary"
                                self.yang_parent_name = "af"

                                self.auto_config = YLeaf(YType.uint32, "auto-config")

                                self.auto_config_disabled = YLeaf(YType.uint32, "auto-config-disabled")

                                self.auto_config_forward_reference_interfaces = YLeaf(YType.uint32, "auto-config-forward-reference-interfaces")

                                self.forward_references = YLeaf(YType.uint32, "forward-references")

                                self.known_ip_interface_count = YLeaf(YType.uint32, "known-ip-interface-count")

                                self.known_ip_interface_ldp_enabled = YLeaf(YType.uint32, "known-ip-interface-ldp-enabled")

                                self.ldp_configured_attached_interface = YLeaf(YType.uint32, "ldp-configured-attached-interface")

                                self.ldp_configured_te_interface = YLeaf(YType.uint32, "ldp-configured-te-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("auto_config",
                                                "auto_config_disabled",
                                                "auto_config_forward_reference_interfaces",
                                                "forward_references",
                                                "known_ip_interface_count",
                                                "known_ip_interface_ldp_enabled",
                                                "ldp_configured_attached_interface",
                                                "ldp_configured_te_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.auto_config.is_set or
                                    self.auto_config_disabled.is_set or
                                    self.auto_config_forward_reference_interfaces.is_set or
                                    self.forward_references.is_set or
                                    self.known_ip_interface_count.is_set or
                                    self.known_ip_interface_ldp_enabled.is_set or
                                    self.ldp_configured_attached_interface.is_set or
                                    self.ldp_configured_te_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.auto_config.yfilter != YFilter.not_set or
                                    self.auto_config_disabled.yfilter != YFilter.not_set or
                                    self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set or
                                    self.forward_references.yfilter != YFilter.not_set or
                                    self.known_ip_interface_count.yfilter != YFilter.not_set or
                                    self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set or
                                    self.ldp_configured_attached_interface.yfilter != YFilter.not_set or
                                    self.ldp_configured_te_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.auto_config.is_set or self.auto_config.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config.get_name_leafdata())
                                if (self.auto_config_disabled.is_set or self.auto_config_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config_disabled.get_name_leafdata())
                                if (self.auto_config_forward_reference_interfaces.is_set or self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config_forward_reference_interfaces.get_name_leafdata())
                                if (self.forward_references.is_set or self.forward_references.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_references.get_name_leafdata())
                                if (self.known_ip_interface_count.is_set or self.known_ip_interface_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.known_ip_interface_count.get_name_leafdata())
                                if (self.known_ip_interface_ldp_enabled.is_set or self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.known_ip_interface_ldp_enabled.get_name_leafdata())
                                if (self.ldp_configured_attached_interface.is_set or self.ldp_configured_attached_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_configured_attached_interface.get_name_leafdata())
                                if (self.ldp_configured_te_interface.is_set or self.ldp_configured_te_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_configured_te_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "auto-config" or name == "auto-config-disabled" or name == "auto-config-forward-reference-interfaces" or name == "forward-references" or name == "known-ip-interface-count" or name == "known-ip-interface-ldp-enabled" or name == "ldp-configured-attached-interface" or name == "ldp-configured-te-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "auto-config"):
                                    self.auto_config = value
                                    self.auto_config.value_namespace = name_space
                                    self.auto_config.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-config-disabled"):
                                    self.auto_config_disabled = value
                                    self.auto_config_disabled.value_namespace = name_space
                                    self.auto_config_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-config-forward-reference-interfaces"):
                                    self.auto_config_forward_reference_interfaces = value
                                    self.auto_config_forward_reference_interfaces.value_namespace = name_space
                                    self.auto_config_forward_reference_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-references"):
                                    self.forward_references = value
                                    self.forward_references.value_namespace = name_space
                                    self.forward_references.value_namespace_prefix = name_space_prefix
                                if(value_path == "known-ip-interface-count"):
                                    self.known_ip_interface_count = value
                                    self.known_ip_interface_count.value_namespace = name_space
                                    self.known_ip_interface_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "known-ip-interface-ldp-enabled"):
                                    self.known_ip_interface_ldp_enabled = value
                                    self.known_ip_interface_ldp_enabled.value_namespace = name_space
                                    self.known_ip_interface_ldp_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-configured-attached-interface"):
                                    self.ldp_configured_attached_interface = value
                                    self.ldp_configured_attached_interface.value_namespace = name_space
                                    self.ldp_configured_attached_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-configured-te-interface"):
                                    self.ldp_configured_te_interface = value
                                    self.ldp_configured_te_interface.value_namespace = name_space
                                    self.ldp_configured_te_interface.value_namespace_prefix = name_space_prefix


                        class Bindings(Entity):
                            """
                            The LDP Bindings
                            
                            .. attribute:: binding
                            
                            	Binding Information
                            	**type**\: list of    :py:class:`Binding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings, self).__init__()

                                self.yang_name = "bindings"
                                self.yang_parent_name = "af"

                                self.binding = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings, self).__setattr__(name, value)


                            class Binding(Entity):
                                """
                                Binding Information
                                
                                .. attribute:: prefix  <key>
                                
                                	The IP Prefix
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                
                                
                                ----
                                .. attribute:: advertise_prefix_acl
                                
                                	Advertise Prerfix ACL
                                	**type**\:  str
                                
                                .. attribute:: advertise_tsr_acl
                                
                                	Advertise TSR ACL
                                	**type**\:  str
                                
                                .. attribute:: config_enforced_local_label_value
                                
                                	Config/User enforced local label value
                                	**type**\:  bool
                                
                                .. attribute:: is_elc
                                
                                	Is the entry entropy label capable
                                	**type**\:  bool
                                
                                .. attribute:: is_no_route
                                
                                	No route
                                	**type**\:  bool
                                
                                .. attribute:: label_oor
                                
                                	Label space depletion OOR
                                	**type**\:  bool
                                
                                .. attribute:: le_local_binding_revision
                                
                                	Local Binding revision
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: le_local_label_state
                                
                                	Local label state
                                	**type**\:   :py:class:`LocalLabelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LocalLabelState>`
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: peers_acked
                                
                                	Peers that have ACKed this entry
                                	**type**\: list of    :py:class:`PeersAcked <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked>`
                                
                                .. attribute:: peers_advertised_to
                                
                                	Peers this entry is advertised to
                                	**type**\: list of    :py:class:`PeersAdvertisedTo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo>`
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: prefix_xr
                                
                                	IP Prefix
                                	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr>`
                                
                                .. attribute:: remote_binding
                                
                                	Remote binding
                                	**type**\: list of    :py:class:`RemoteBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding, self).__init__()

                                    self.yang_name = "binding"
                                    self.yang_parent_name = "bindings"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.advertise_prefix_acl = YLeaf(YType.str, "advertise-prefix-acl")

                                    self.advertise_tsr_acl = YLeaf(YType.str, "advertise-tsr-acl")

                                    self.config_enforced_local_label_value = YLeaf(YType.boolean, "config-enforced-local-label-value")

                                    self.is_elc = YLeaf(YType.boolean, "is-elc")

                                    self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                    self.label_oor = YLeaf(YType.boolean, "label-oor")

                                    self.le_local_binding_revision = YLeaf(YType.uint32, "le-local-binding-revision")

                                    self.le_local_label_state = YLeaf(YType.enumeration, "le-local-label-state")

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.prefix_xr = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr()
                                    self.prefix_xr.parent = self
                                    self._children_name_map["prefix_xr"] = "prefix-xr"
                                    self._children_yang_names.add("prefix-xr")

                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.peers_acked = YList(self)
                                    self.peers_advertised_to = YList(self)
                                    self.remote_binding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "advertise_prefix_acl",
                                                    "advertise_tsr_acl",
                                                    "config_enforced_local_label_value",
                                                    "is_elc",
                                                    "is_no_route",
                                                    "label_oor",
                                                    "le_local_binding_revision",
                                                    "le_local_label_state",
                                                    "local_label",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "binding"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class PrefixXr(Entity):
                                    """
                                    IP Prefix
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__init__()

                                        self.yang_name = "prefix-xr"
                                        self.yang_parent_name = "binding"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prefix-xr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class RemoteBinding(Entity):
                                    """
                                    Remote binding
                                    
                                    .. attribute:: assigning_peer_ldp_ident
                                    
                                    	Assigning peer
                                    	**type**\:   :py:class:`AssigningPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent>`
                                    
                                    .. attribute:: is_elc
                                    
                                    	Is the entry entropy label capable
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_stale
                                    
                                    	Is the entry stale
                                    	**type**\:  bool
                                    
                                    .. attribute:: remote_label
                                    
                                    	Remote Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__init__()

                                        self.yang_name = "remote-binding"
                                        self.yang_parent_name = "binding"

                                        self.is_elc = YLeaf(YType.boolean, "is-elc")

                                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                                        self.remote_label = YLeaf(YType.uint32, "remote-label")

                                        self.assigning_peer_ldp_ident = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                        self.assigning_peer_ldp_ident.parent = self
                                        self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                        self._children_yang_names.add("assigning-peer-ldp-ident")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_elc",
                                                        "is_stale",
                                                        "remote_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)


                                    class AssigningPeerLdpIdent(Entity):
                                        """
                                        Assigning peer
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__init__()

                                            self.yang_name = "assigning-peer-ldp-ident"
                                            self.yang_parent_name = "remote-binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "assigning-peer-ldp-ident" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.is_elc.is_set or
                                            self.is_stale.is_set or
                                            self.remote_label.is_set or
                                            (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_elc.yfilter != YFilter.not_set or
                                            self.is_stale.yfilter != YFilter.not_set or
                                            self.remote_label.yfilter != YFilter.not_set or
                                            (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "remote-binding" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_elc.get_name_leafdata())
                                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                                        if (self.remote_label.is_set or self.remote_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "assigning-peer-ldp-ident"):
                                            if (self.assigning_peer_ldp_ident is None):
                                                self.assigning_peer_ldp_ident = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                                self.assigning_peer_ldp_ident.parent = self
                                                self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                            return self.assigning_peer_ldp_ident

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "assigning-peer-ldp-ident" or name == "is-elc" or name == "is-stale" or name == "remote-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-elc"):
                                            self.is_elc = value
                                            self.is_elc.value_namespace = name_space
                                            self.is_elc.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-stale"):
                                            self.is_stale = value
                                            self.is_stale.value_namespace = name_space
                                            self.is_stale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-label"):
                                            self.remote_label = value
                                            self.remote_label.value_namespace = name_space
                                            self.remote_label.value_namespace_prefix = name_space_prefix


                                class PeersAdvertisedTo(Entity):
                                    """
                                    Peers this entry is advertised to
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: ldp_id
                                    
                                    	LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__init__()

                                        self.yang_name = "peers-advertised-to"
                                        self.yang_parent_name = "binding"

                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "ldp_id",
                                                        "lsr_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.ldp_id.is_set or
                                            self.lsr_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.ldp_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "peers-advertised-to" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-id"):
                                            self.ldp_id = value
                                            self.ldp_id.value_namespace = name_space
                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix


                                class PeersAcked(Entity):
                                    """
                                    Peers that have ACKed this entry
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: ldp_id
                                    
                                    	LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__init__()

                                        self.yang_name = "peers-acked"
                                        self.yang_parent_name = "binding"

                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "ldp_id",
                                                        "lsr_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.ldp_id.is_set or
                                            self.lsr_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.ldp_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "peers-acked" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-id"):
                                            self.ldp_id = value
                                            self.ldp_id.value_namespace = name_space
                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.peers_acked:
                                        if (c.has_data()):
                                            return True
                                    for c in self.peers_advertised_to:
                                        if (c.has_data()):
                                            return True
                                    for c in self.remote_binding:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.prefix.is_set or
                                        self.advertise_prefix_acl.is_set or
                                        self.advertise_tsr_acl.is_set or
                                        self.config_enforced_local_label_value.is_set or
                                        self.is_elc.is_set or
                                        self.is_no_route.is_set or
                                        self.label_oor.is_set or
                                        self.le_local_binding_revision.is_set or
                                        self.le_local_label_state.is_set or
                                        self.local_label.is_set or
                                        self.prefix_length.is_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.peers_acked:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.peers_advertised_to:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.remote_binding:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.advertise_prefix_acl.yfilter != YFilter.not_set or
                                        self.advertise_tsr_acl.yfilter != YFilter.not_set or
                                        self.config_enforced_local_label_value.yfilter != YFilter.not_set or
                                        self.is_elc.yfilter != YFilter.not_set or
                                        self.is_no_route.yfilter != YFilter.not_set or
                                        self.label_oor.yfilter != YFilter.not_set or
                                        self.le_local_binding_revision.yfilter != YFilter.not_set or
                                        self.le_local_label_state.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "binding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.advertise_prefix_acl.is_set or self.advertise_prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_prefix_acl.get_name_leafdata())
                                    if (self.advertise_tsr_acl.is_set or self.advertise_tsr_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_tsr_acl.get_name_leafdata())
                                    if (self.config_enforced_local_label_value.is_set or self.config_enforced_local_label_value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.config_enforced_local_label_value.get_name_leafdata())
                                    if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_elc.get_name_leafdata())
                                    if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                    if (self.label_oor.is_set or self.label_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_oor.get_name_leafdata())
                                    if (self.le_local_binding_revision.is_set or self.le_local_binding_revision.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.le_local_binding_revision.get_name_leafdata())
                                    if (self.le_local_label_state.is_set or self.le_local_label_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.le_local_label_state.get_name_leafdata())
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "peers-acked"):
                                        for c in self.peers_acked:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.peers_acked.append(c)
                                        return c

                                    if (child_yang_name == "peers-advertised-to"):
                                        for c in self.peers_advertised_to:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.peers_advertised_to.append(c)
                                        return c

                                    if (child_yang_name == "prefix-xr"):
                                        if (self.prefix_xr is None):
                                            self.prefix_xr = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr()
                                            self.prefix_xr.parent = self
                                            self._children_name_map["prefix_xr"] = "prefix-xr"
                                        return self.prefix_xr

                                    if (child_yang_name == "remote-binding"):
                                        for c in self.remote_binding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.remote_binding.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "peers-acked" or name == "peers-advertised-to" or name == "prefix-xr" or name == "remote-binding" or name == "vrf" or name == "prefix" or name == "advertise-prefix-acl" or name == "advertise-tsr-acl" or name == "config-enforced-local-label-value" or name == "is-elc" or name == "is-no-route" or name == "label-oor" or name == "le-local-binding-revision" or name == "le-local-label-state" or name == "local-label" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "advertise-prefix-acl"):
                                        self.advertise_prefix_acl = value
                                        self.advertise_prefix_acl.value_namespace = name_space
                                        self.advertise_prefix_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "advertise-tsr-acl"):
                                        self.advertise_tsr_acl = value
                                        self.advertise_tsr_acl.value_namespace = name_space
                                        self.advertise_tsr_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "config-enforced-local-label-value"):
                                        self.config_enforced_local_label_value = value
                                        self.config_enforced_local_label_value.value_namespace = name_space
                                        self.config_enforced_local_label_value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-elc"):
                                        self.is_elc = value
                                        self.is_elc.value_namespace = name_space
                                        self.is_elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-no-route"):
                                        self.is_no_route = value
                                        self.is_no_route.value_namespace = name_space
                                        self.is_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-oor"):
                                        self.label_oor = value
                                        self.label_oor.value_namespace = name_space
                                        self.label_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "le-local-binding-revision"):
                                        self.le_local_binding_revision = value
                                        self.le_local_binding_revision.value_namespace = name_space
                                        self.le_local_binding_revision.value_namespace_prefix = name_space_prefix
                                    if(value_path == "le-local-label-state"):
                                        self.le_local_label_state = value
                                        self.le_local_label_state.value_namespace = name_space
                                        self.le_local_label_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.binding:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.binding:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "binding"):
                                    for c in self.binding:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings.Binding()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.binding.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "binding"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Igp(Entity):
                            """
                            LDP IGP related information
                            
                            .. attribute:: sync_delay_restart
                            
                            	LDP\-IGP Synchronization Delay related information
                            	**type**\:   :py:class:`SyncDelayRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.SyncDelayRestart>`
                            
                            .. attribute:: syncs
                            
                            	LDP IGP Sync related information
                            	**type**\:   :py:class:`Syncs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp, self).__init__()

                                self.yang_name = "igp"
                                self.yang_parent_name = "af"

                                self.sync_delay_restart = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.SyncDelayRestart()
                                self.sync_delay_restart.parent = self
                                self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                self._children_yang_names.add("sync-delay-restart")

                                self.syncs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs()
                                self.syncs.parent = self
                                self._children_name_map["syncs"] = "syncs"
                                self._children_yang_names.add("syncs")


                            class Syncs(Entity):
                                """
                                LDP IGP Sync related information
                                
                                .. attribute:: sync
                                
                                	LDP\-IGP Synchronization related information for an interface
                                	**type**\: list of    :py:class:`Sync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs, self).__init__()

                                    self.yang_name = "syncs"
                                    self.yang_parent_name = "igp"

                                    self.sync = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)


                                class Sync(Entity):
                                    """
                                    LDP\-IGP Synchronization related information
                                    for an interface
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: delay_timer_remaining
                                    
                                    	Remaining timer (seconds) till expiry of sync delay timer
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: gr_only_peer
                                    
                                    	Interface GR\-only reachable peers
                                    	**type**\: list of    :py:class:`GrOnlyPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer>`
                                    
                                    .. attribute:: igp_sync_delay
                                    
                                    	IGP sync delay in seconds
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: igp_sync_down_reason
                                    
                                    	Reason IGP Sync Not Achieved
                                    	**type**\:   :py:class:`LdpIgpSyncDownReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncDownReason>`
                                    
                                    .. attribute:: igp_sync_state
                                    
                                    	IGP Sync state
                                    	**type**\:   :py:class:`LdpIgpSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncState>`
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: is_delay_timer_running
                                    
                                    	Is sync delay timer running
                                    	**type**\:  bool
                                    
                                    .. attribute:: peers
                                    
                                    	Interface Peers
                                    	**type**\: list of    :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__init__()

                                        self.yang_name = "sync"
                                        self.yang_parent_name = "syncs"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.delay_timer_remaining = YLeaf(YType.uint32, "delay-timer-remaining")

                                        self.igp_sync_delay = YLeaf(YType.uint32, "igp-sync-delay")

                                        self.igp_sync_down_reason = YLeaf(YType.enumeration, "igp-sync-down-reason")

                                        self.igp_sync_state = YLeaf(YType.enumeration, "igp-sync-state")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.is_delay_timer_running = YLeaf(YType.boolean, "is-delay-timer-running")

                                        self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.gr_only_peer = YList(self)
                                        self.peers = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "delay_timer_remaining",
                                                        "igp_sync_delay",
                                                        "igp_sync_down_reason",
                                                        "igp_sync_state",
                                                        "interface_name_xr",
                                                        "is_delay_timer_running") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "sync"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class Peers(Entity):
                                        """
                                        Interface Peers
                                        
                                        .. attribute:: is_gr_enabled
                                        
                                        	Is GR enabled session
                                        	**type**\:  bool
                                        
                                        .. attribute:: peer_id
                                        
                                        	Peer Identifier
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__init__()

                                            self.yang_name = "peers"
                                            self.yang_parent_name = "sync"

                                            self.is_gr_enabled = YLeaf(YType.boolean, "is-gr-enabled")

                                            self.peer_id = YLeaf(YType.str, "peer-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_gr_enabled",
                                                            "peer_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_gr_enabled.is_set or
                                                self.peer_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_gr_enabled.yfilter != YFilter.not_set or
                                                self.peer_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_gr_enabled.is_set or self.is_gr_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_gr_enabled.get_name_leafdata())
                                            if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.peer_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-gr-enabled" or name == "peer-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-gr-enabled"):
                                                self.is_gr_enabled = value
                                                self.is_gr_enabled.value_namespace = name_space
                                                self.is_gr_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "peer-id"):
                                                self.peer_id = value
                                                self.peer_id.value_namespace = name_space
                                                self.peer_id.value_namespace_prefix = name_space_prefix


                                    class GrOnlyPeer(Entity):
                                        """
                                        Interface GR\-only reachable peers
                                        
                                        .. attribute:: is_chkpt_created
                                        
                                        	Is created due to checkpointing
                                        	**type**\:  bool
                                        
                                        .. attribute:: peer_id
                                        
                                        	Peer Identifier
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__init__()

                                            self.yang_name = "gr-only-peer"
                                            self.yang_parent_name = "sync"

                                            self.is_chkpt_created = YLeaf(YType.boolean, "is-chkpt-created")

                                            self.peer_id = YLeaf(YType.str, "peer-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_chkpt_created",
                                                            "peer_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_chkpt_created.is_set or
                                                self.peer_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_chkpt_created.yfilter != YFilter.not_set or
                                                self.peer_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "gr-only-peer" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_chkpt_created.is_set or self.is_chkpt_created.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_chkpt_created.get_name_leafdata())
                                            if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.peer_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-chkpt-created" or name == "peer-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-chkpt-created"):
                                                self.is_chkpt_created = value
                                                self.is_chkpt_created.value_namespace = name_space
                                                self.is_chkpt_created.value_namespace_prefix = name_space_prefix
                                            if(value_path == "peer-id"):
                                                self.peer_id = value
                                                self.peer_id.value_namespace = name_space
                                                self.peer_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.gr_only_peer:
                                            if (c.has_data()):
                                                return True
                                        for c in self.peers:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.delay_timer_remaining.is_set or
                                            self.igp_sync_delay.is_set or
                                            self.igp_sync_down_reason.is_set or
                                            self.igp_sync_state.is_set or
                                            self.interface_name_xr.is_set or
                                            self.is_delay_timer_running.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.gr_only_peer:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.peers:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.delay_timer_remaining.yfilter != YFilter.not_set or
                                            self.igp_sync_delay.yfilter != YFilter.not_set or
                                            self.igp_sync_down_reason.yfilter != YFilter.not_set or
                                            self.igp_sync_state.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.is_delay_timer_running.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sync" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.delay_timer_remaining.is_set or self.delay_timer_remaining.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.delay_timer_remaining.get_name_leafdata())
                                        if (self.igp_sync_delay.is_set or self.igp_sync_delay.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_delay.get_name_leafdata())
                                        if (self.igp_sync_down_reason.is_set or self.igp_sync_down_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_down_reason.get_name_leafdata())
                                        if (self.igp_sync_state.is_set or self.igp_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_state.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.is_delay_timer_running.is_set or self.is_delay_timer_running.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_delay_timer_running.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "gr-only-peer"):
                                            for c in self.gr_only_peer:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.gr_only_peer.append(c)
                                            return c

                                        if (child_yang_name == "peers"):
                                            for c in self.peers:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "gr-only-peer" or name == "peers" or name == "vrf" or name == "interface-name" or name == "delay-timer-remaining" or name == "igp-sync-delay" or name == "igp-sync-down-reason" or name == "igp-sync-state" or name == "interface-name-xr" or name == "is-delay-timer-running"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "delay-timer-remaining"):
                                            self.delay_timer_remaining = value
                                            self.delay_timer_remaining.value_namespace = name_space
                                            self.delay_timer_remaining.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-delay"):
                                            self.igp_sync_delay = value
                                            self.igp_sync_delay.value_namespace = name_space
                                            self.igp_sync_delay.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-down-reason"):
                                            self.igp_sync_down_reason = value
                                            self.igp_sync_down_reason.value_namespace = name_space
                                            self.igp_sync_down_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-state"):
                                            self.igp_sync_state = value
                                            self.igp_sync_state.value_namespace = name_space
                                            self.igp_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-delay-timer-running"):
                                            self.is_delay_timer_running = value
                                            self.is_delay_timer_running.value_namespace = name_space
                                            self.is_delay_timer_running.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sync:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.sync:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "syncs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sync"):
                                        for c in self.sync:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs.Sync()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sync.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class SyncDelayRestart(Entity):
                                """
                                LDP\-IGP Synchronization Delay related
                                information
                                
                                .. attribute:: configured
                                
                                	Is restart delay configured
                                	**type**\:  bool
                                
                                .. attribute:: delay_secs
                                
                                	Delay time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: remaining_secs
                                
                                	Delay timer remaining time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: timer_running
                                
                                	Is restart delay timer running
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__init__()

                                    self.yang_name = "sync-delay-restart"
                                    self.yang_parent_name = "igp"

                                    self.configured = YLeaf(YType.boolean, "configured")

                                    self.delay_secs = YLeaf(YType.uint32, "delay-secs")

                                    self.remaining_secs = YLeaf(YType.uint32, "remaining-secs")

                                    self.timer_running = YLeaf(YType.boolean, "timer-running")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("configured",
                                                    "delay_secs",
                                                    "remaining_secs",
                                                    "timer_running") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.configured.is_set or
                                        self.delay_secs.is_set or
                                        self.remaining_secs.is_set or
                                        self.timer_running.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.configured.yfilter != YFilter.not_set or
                                        self.delay_secs.yfilter != YFilter.not_set or
                                        self.remaining_secs.yfilter != YFilter.not_set or
                                        self.timer_running.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sync-delay-restart" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.configured.is_set or self.configured.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.configured.get_name_leafdata())
                                    if (self.delay_secs.is_set or self.delay_secs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.delay_secs.get_name_leafdata())
                                    if (self.remaining_secs.is_set or self.remaining_secs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remaining_secs.get_name_leafdata())
                                    if (self.timer_running.is_set or self.timer_running.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.timer_running.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "configured" or name == "delay-secs" or name == "remaining-secs" or name == "timer-running"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "configured"):
                                        self.configured = value
                                        self.configured.value_namespace = name_space
                                        self.configured.value_namespace_prefix = name_space_prefix
                                    if(value_path == "delay-secs"):
                                        self.delay_secs = value
                                        self.delay_secs.value_namespace = name_space
                                        self.delay_secs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remaining-secs"):
                                        self.remaining_secs = value
                                        self.remaining_secs.value_namespace = name_space
                                        self.remaining_secs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "timer-running"):
                                        self.timer_running = value
                                        self.timer_running.value_namespace = name_space
                                        self.timer_running.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sync_delay_restart is not None and self.sync_delay_restart.has_data()) or
                                    (self.syncs is not None and self.syncs.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sync_delay_restart is not None and self.sync_delay_restart.has_operation()) or
                                    (self.syncs is not None and self.syncs.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "igp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sync-delay-restart"):
                                    if (self.sync_delay_restart is None):
                                        self.sync_delay_restart = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.SyncDelayRestart()
                                        self.sync_delay_restart.parent = self
                                        self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                    return self.sync_delay_restart

                                if (child_yang_name == "syncs"):
                                    if (self.syncs is None):
                                        self.syncs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp.Syncs()
                                        self.syncs.parent = self
                                        self._children_name_map["syncs"] = "syncs"
                                    return self.syncs

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sync-delay-restart" or name == "syncs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsSummary(Entity):
                            """
                            Counters for the LDP Label Infomation Base
                            (LIB)
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: bind_af
                            
                            	bind af
                            	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.BindAf>`
                            
                            .. attribute:: binding_local_explicit_null
                            
                            	Number of local explicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_implicit_null
                            
                            	Number of local implicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_no_route
                            
                            	Local bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_non_null
                            
                            	Number of local non\-null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_null
                            
                            	Number of local null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_oor
                            
                            	Number of local bindings        needing label \- OOR
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_no_route
                            
                            	Bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: highest_allocated_label
                            
                            	Highest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lowest_allocated_label
                            
                            	Lowest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary, self).__init__()

                                self.yang_name = "bindings-summary"
                                self.yang_parent_name = "af"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.bind_af = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "binding_local_explicit_null",
                                                "binding_local_implicit_null",
                                                "binding_local_no_route",
                                                "binding_local_non_null",
                                                "binding_local_null",
                                                "binding_local_oor",
                                                "binding_no_route",
                                                "highest_allocated_label",
                                                "lowest_allocated_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "bindings-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class BindAf(Entity):
                                """
                                bind af
                                
                                .. attribute:: address_family
                                
                                	Binding Summary Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: binding_local
                                
                                	Number of local bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_remote
                                
                                	Number of remote bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_total
                                
                                	Total bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_lib_update
                                
                                	Last update to LIB local binding
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lib_minimum_revision_sent_all
                                
                                	Last update sent to all peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__init__()

                                    self.yang_name = "bind-af"
                                    self.yang_parent_name = "bindings-summary"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local = YLeaf(YType.uint32, "binding-local")

                                    self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                    self.binding_total = YLeaf(YType.uint32, "binding-total")

                                    self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                    self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local",
                                                    "binding_remote",
                                                    "binding_total",
                                                    "last_lib_update",
                                                    "lib_minimum_revision_sent_all") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local.is_set or
                                        self.binding_remote.is_set or
                                        self.binding_total.is_set or
                                        self.last_lib_update.is_set or
                                        self.lib_minimum_revision_sent_all.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local.yfilter != YFilter.not_set or
                                        self.binding_remote.yfilter != YFilter.not_set or
                                        self.binding_total.yfilter != YFilter.not_set or
                                        self.last_lib_update.yfilter != YFilter.not_set or
                                        self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bind-af" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local.get_name_leafdata())
                                    if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                    if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_total.get_name_leafdata())
                                    if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                    if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local"):
                                        self.binding_local = value
                                        self.binding_local.value_namespace = name_space
                                        self.binding_local.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-remote"):
                                        self.binding_remote = value
                                        self.binding_remote.value_namespace = name_space
                                        self.binding_remote.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-total"):
                                        self.binding_total = value
                                        self.binding_total.value_namespace = name_space
                                        self.binding_total.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-lib-update"):
                                        self.last_lib_update = value
                                        self.last_lib_update.value_namespace = name_space
                                        self.last_lib_update.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lib-minimum-revision-sent-all"):
                                        self.lib_minimum_revision_sent_all = value
                                        self.lib_minimum_revision_sent_all.value_namespace = name_space
                                        self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bind_af:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.address_family.is_set or
                                    self.binding_local_explicit_null.is_set or
                                    self.binding_local_implicit_null.is_set or
                                    self.binding_local_no_route.is_set or
                                    self.binding_local_non_null.is_set or
                                    self.binding_local_null.is_set or
                                    self.binding_local_oor.is_set or
                                    self.binding_no_route.is_set or
                                    self.highest_allocated_label.is_set or
                                    self.lowest_allocated_label.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.bind_af:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_no_route.yfilter != YFilter.not_set or
                                    self.binding_local_non_null.yfilter != YFilter.not_set or
                                    self.binding_local_null.yfilter != YFilter.not_set or
                                    self.binding_local_oor.yfilter != YFilter.not_set or
                                    self.binding_no_route.yfilter != YFilter.not_set or
                                    self.highest_allocated_label.yfilter != YFilter.not_set or
                                    self.lowest_allocated_label.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bind-af"):
                                    for c in self.bind_af:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.BindAf()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bind_af.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-explicit-null"):
                                    self.binding_local_explicit_null = value
                                    self.binding_local_explicit_null.value_namespace = name_space
                                    self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-implicit-null"):
                                    self.binding_local_implicit_null = value
                                    self.binding_local_implicit_null.value_namespace = name_space
                                    self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-no-route"):
                                    self.binding_local_no_route = value
                                    self.binding_local_no_route.value_namespace = name_space
                                    self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-non-null"):
                                    self.binding_local_non_null = value
                                    self.binding_local_non_null.value_namespace = name_space
                                    self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-null"):
                                    self.binding_local_null = value
                                    self.binding_local_null.value_namespace = name_space
                                    self.binding_local_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-oor"):
                                    self.binding_local_oor = value
                                    self.binding_local_oor.value_namespace = name_space
                                    self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-no-route"):
                                    self.binding_no_route = value
                                    self.binding_no_route.value_namespace = name_space
                                    self.binding_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "highest-allocated-label"):
                                    self.highest_allocated_label = value
                                    self.highest_allocated_label.value_namespace = name_space
                                    self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lowest-allocated-label"):
                                    self.lowest_allocated_label = value
                                    self.lowest_allocated_label.value_namespace = name_space
                                    self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                        class Interfaces(Entity):
                            """
                            LDP Interface related information
                            
                            .. attribute:: interface
                            
                            	IPv4 interface information
                            	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces, self).__init__()

                                self.yang_name = "interfaces"
                                self.yang_parent_name = "af"

                                self.interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces, self).__setattr__(name, value)


                            class Interface(Entity):
                                """
                                IPv4 interface information
                                
                                .. attribute:: interface_name  <key>
                                
                                	The Interface Name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: auto_config
                                
                                	Auto config
                                	**type**\: list of    :py:class:`AutoConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig>`
                                
                                .. attribute:: interface
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: interface_name_xr
                                
                                	Interface name
                                	**type**\:  str
                                
                                .. attribute:: is_im_stale
                                
                                	Is IM information stale
                                	**type**\:  bool
                                
                                .. attribute:: ldp_autoconfig_disable
                                
                                	LDP autoconfig disable
                                	**type**\:  bool
                                
                                .. attribute:: ldp_config_mode
                                
                                	LDP config mode
                                	**type**\:  bool
                                
                                .. attribute:: ldp_enabled
                                
                                	LDP enabled
                                	**type**\:  bool
                                
                                .. attribute:: te_mesh_grp
                                
                                	TE tunnel mesh\-group
                                	**type**\: list of    :py:class:`TeMeshGrp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface, self).__init__()

                                    self.yang_name = "interface"
                                    self.yang_parent_name = "interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.interface = YLeaf(YType.str, "interface")

                                    self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                    self.is_im_stale = YLeaf(YType.boolean, "is-im-stale")

                                    self.ldp_autoconfig_disable = YLeaf(YType.boolean, "ldp-autoconfig-disable")

                                    self.ldp_config_mode = YLeaf(YType.boolean, "ldp-config-mode")

                                    self.ldp_enabled = YLeaf(YType.boolean, "ldp-enabled")

                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.auto_config = YList(self)
                                    self.te_mesh_grp = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "interface",
                                                    "interface_name_xr",
                                                    "is_im_stale",
                                                    "ldp_autoconfig_disable",
                                                    "ldp_config_mode",
                                                    "ldp_enabled") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "interface"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class TeMeshGrp(Entity):
                                    """
                                    TE tunnel mesh\-group
                                    
                                    .. attribute:: ldp_mesh_group_enabled
                                    
                                    	LDP has enabled this TE mesh\-group
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_te_mesh_group_all_cfgd
                                    
                                    	LDP has enabled all TE mesh\-groups
                                    	**type**\:  bool
                                    
                                    .. attribute:: te_mesh_group_id
                                    
                                    	TE tunnel Mesh Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__init__()

                                        self.yang_name = "te-mesh-grp"
                                        self.yang_parent_name = "interface"

                                        self.ldp_mesh_group_enabled = YLeaf(YType.boolean, "ldp-mesh-group-enabled")

                                        self.ldp_te_mesh_group_all_cfgd = YLeaf(YType.boolean, "ldp-te-mesh-group-all-cfgd")

                                        self.te_mesh_group_id = YLeaf(YType.uint32, "te-mesh-group-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ldp_mesh_group_enabled",
                                                        "ldp_te_mesh_group_all_cfgd",
                                                        "te_mesh_group_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ldp_mesh_group_enabled.is_set or
                                            self.ldp_te_mesh_group_all_cfgd.is_set or
                                            self.te_mesh_group_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ldp_mesh_group_enabled.yfilter != YFilter.not_set or
                                            self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set or
                                            self.te_mesh_group_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-mesh-grp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ldp_mesh_group_enabled.is_set or self.ldp_mesh_group_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_mesh_group_enabled.get_name_leafdata())
                                        if (self.ldp_te_mesh_group_all_cfgd.is_set or self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_te_mesh_group_all_cfgd.get_name_leafdata())
                                        if (self.te_mesh_group_id.is_set or self.te_mesh_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_mesh_group_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ldp-mesh-group-enabled" or name == "ldp-te-mesh-group-all-cfgd" or name == "te-mesh-group-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ldp-mesh-group-enabled"):
                                            self.ldp_mesh_group_enabled = value
                                            self.ldp_mesh_group_enabled.value_namespace = name_space
                                            self.ldp_mesh_group_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-te-mesh-group-all-cfgd"):
                                            self.ldp_te_mesh_group_all_cfgd = value
                                            self.ldp_te_mesh_group_all_cfgd.value_namespace = name_space
                                            self.ldp_te_mesh_group_all_cfgd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-mesh-group-id"):
                                            self.te_mesh_group_id = value
                                            self.te_mesh_group_id.value_namespace = name_space
                                            self.te_mesh_group_id.value_namespace_prefix = name_space_prefix


                                class AutoConfig(Entity):
                                    """
                                    Auto config
                                    
                                    .. attribute:: tuple
                                    
                                    	Tuple
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__init__()

                                        self.yang_name = "auto-config"
                                        self.yang_parent_name = "interface"

                                        self.tuple = YLeaf(YType.str, "tuple")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tuple") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.tuple.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tuple.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "auto-config" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tuple.is_set or self.tuple.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tuple.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "tuple"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tuple"):
                                            self.tuple = value
                                            self.tuple.value_namespace = name_space
                                            self.tuple.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.auto_config:
                                        if (c.has_data()):
                                            return True
                                    for c in self.te_mesh_grp:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.interface_name.is_set or
                                        self.interface.is_set or
                                        self.interface_name_xr.is_set or
                                        self.is_im_stale.is_set or
                                        self.ldp_autoconfig_disable.is_set or
                                        self.ldp_config_mode.is_set or
                                        self.ldp_enabled.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.auto_config:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.te_mesh_grp:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.interface.yfilter != YFilter.not_set or
                                        self.interface_name_xr.yfilter != YFilter.not_set or
                                        self.is_im_stale.yfilter != YFilter.not_set or
                                        self.ldp_autoconfig_disable.yfilter != YFilter.not_set or
                                        self.ldp_config_mode.yfilter != YFilter.not_set or
                                        self.ldp_enabled.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface.get_name_leafdata())
                                    if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                    if (self.is_im_stale.is_set or self.is_im_stale.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_im_stale.get_name_leafdata())
                                    if (self.ldp_autoconfig_disable.is_set or self.ldp_autoconfig_disable.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_autoconfig_disable.get_name_leafdata())
                                    if (self.ldp_config_mode.is_set or self.ldp_config_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_config_mode.get_name_leafdata())
                                    if (self.ldp_enabled.is_set or self.ldp_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_enabled.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "auto-config"):
                                        for c in self.auto_config:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.auto_config.append(c)
                                        return c

                                    if (child_yang_name == "te-mesh-grp"):
                                        for c in self.te_mesh_grp:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.te_mesh_grp.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "auto-config" or name == "te-mesh-grp" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "is-im-stale" or name == "ldp-autoconfig-disable" or name == "ldp-config-mode" or name == "ldp-enabled"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface"):
                                        self.interface = value
                                        self.interface.value_namespace = name_space
                                        self.interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-name-xr"):
                                        self.interface_name_xr = value
                                        self.interface_name_xr.value_namespace = name_space
                                        self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-im-stale"):
                                        self.is_im_stale = value
                                        self.is_im_stale.value_namespace = name_space
                                        self.is_im_stale.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-autoconfig-disable"):
                                        self.ldp_autoconfig_disable = value
                                        self.ldp_autoconfig_disable.value_namespace = name_space
                                        self.ldp_autoconfig_disable.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-config-mode"):
                                        self.ldp_config_mode = value
                                        self.ldp_config_mode.value_namespace = name_space
                                        self.ldp_config_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-enabled"):
                                        self.ldp_enabled = value
                                        self.ldp_enabled.value_namespace = name_space
                                        self.ldp_enabled.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "interface"):
                                    for c in self.interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces.Interface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Discovery(Entity):
                            """
                            The LDP Discovery
                            
                            .. attribute:: brief
                            
                            	Brief information on LDP discovery
                            	**type**\:   :py:class:`Brief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief>`
                            
                            .. attribute:: link_hellos
                            
                            	The LDP Discovery link
                            	**type**\:   :py:class:`LinkHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos>`
                            
                            .. attribute:: stats
                            
                            	The LDP Discovery Statistics
                            	**type**\:   :py:class:`Stats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats>`
                            
                            .. attribute:: summary
                            
                            	Summarized information on LDP discovery
                            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary>`
                            
                            .. attribute:: targeted_hellos
                            
                            	The LDP Discovery Targeted
                            	**type**\:   :py:class:`TargetedHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery, self).__init__()

                                self.yang_name = "discovery"
                                self.yang_parent_name = "af"

                                self.brief = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief()
                                self.brief.parent = self
                                self._children_name_map["brief"] = "brief"
                                self._children_yang_names.add("brief")

                                self.link_hellos = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos()
                                self.link_hellos.parent = self
                                self._children_name_map["link_hellos"] = "link-hellos"
                                self._children_yang_names.add("link-hellos")

                                self.stats = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats()
                                self.stats.parent = self
                                self._children_name_map["stats"] = "stats"
                                self._children_yang_names.add("stats")

                                self.summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary()
                                self.summary.parent = self
                                self._children_name_map["summary"] = "summary"
                                self._children_yang_names.add("summary")

                                self.targeted_hellos = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos()
                                self.targeted_hellos.parent = self
                                self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                self._children_yang_names.add("targeted-hellos")


                            class LinkHellos(Entity):
                                """
                                The LDP Discovery link
                                
                                .. attribute:: link_hello
                                
                                	Information on LDP link discovery
                                	**type**\: list of    :py:class:`LinkHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__init__()

                                    self.yang_name = "link-hellos"
                                    self.yang_parent_name = "discovery"

                                    self.link_hello = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)


                                class LinkHello(Entity):
                                    """
                                    Information on LDP link discovery
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: discovery_link_af
                                    
                                    	LDP hello AF info
                                    	**type**\: list of    :py:class:`DiscoveryLinkAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf>`
                                    
                                    .. attribute:: hello_information
                                    
                                    	LDP hello info
                                    	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation>`
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: next_hello
                                    
                                    	Next hello due time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: quick_start_disabled
                                    
                                    	Quick\-start disabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__init__()

                                        self.yang_name = "link-hello"
                                        self.yang_parent_name = "link-hellos"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.next_hello = YLeaf(YType.uint32, "next-hello")

                                        self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                        self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.discovery_link_af = YList(self)
                                        self.hello_information = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "interface",
                                                        "interface_name_xr",
                                                        "next_hello",
                                                        "quick_start_disabled") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "link-hello"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class HelloInformation(Entity):
                                        """
                                        LDP hello info
                                        
                                        .. attribute:: disc_expiry
                                        
                                        	Discovery expiry time in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: established_age
                                        
                                        	Hello adjacency estabished age in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: established_time
                                        
                                        	Hello adjacency estabished time in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: hold_time
                                        
                                        	Session hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: is_no_route
                                        
                                        	Is route valid
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_targeted
                                        
                                        	Is session a targeted session
                                        	**type**\:  bool
                                        
                                        .. attribute:: last_session_down_info
                                        
                                        	Last session down information
                                        	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo>`
                                        
                                        .. attribute:: local_hold_time
                                        
                                        	Local hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: neighbor_hold_time
                                        
                                        	Neighbor hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: neighbor_ldp_identifier
                                        
                                        	Neighbor LDP Identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: neighbor_src_address
                                        
                                        	Neighbor source address
                                        	**type**\:   :py:class:`NeighborSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress>`
                                        
                                        .. attribute:: neighbor_transport_address
                                        
                                        	Neighbor transport address
                                        	**type**\:   :py:class:`NeighborTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress>`
                                        
                                        .. attribute:: session_bringup_failure_reason
                                        
                                        	session bringup failure reason
                                        	**type**\:  str
                                        
                                        .. attribute:: session_up
                                        
                                        	Is session up for this adj
                                        	**type**\:  bool
                                        
                                        .. attribute:: target
                                        
                                        	Target address
                                        	**type**\:   :py:class:`Target <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__init__()

                                            self.yang_name = "hello-information"
                                            self.yang_parent_name = "link-hello"

                                            self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                            self.established_age = YLeaf(YType.uint64, "established-age")

                                            self.established_time = YLeaf(YType.uint64, "established-time")

                                            self.hold_time = YLeaf(YType.uint32, "hold-time")

                                            self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                            self.is_targeted = YLeaf(YType.boolean, "is-targeted")

                                            self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                            self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                            self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                            self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                            self.session_up = YLeaf(YType.boolean, "session-up")

                                            self.neighbor_src_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                            self.neighbor_src_address.parent = self
                                            self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                            self._children_yang_names.add("neighbor-src-address")

                                            self.neighbor_transport_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                            self.neighbor_transport_address.parent = self
                                            self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                            self._children_yang_names.add("neighbor-transport-address")

                                            self.target = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                            self.target.parent = self
                                            self._children_name_map["target"] = "target"
                                            self._children_yang_names.add("target")

                                            self.last_session_down_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("disc_expiry",
                                                            "established_age",
                                                            "established_time",
                                                            "hold_time",
                                                            "is_no_route",
                                                            "is_targeted",
                                                            "local_hold_time",
                                                            "neighbor_hold_time",
                                                            "neighbor_ldp_identifier",
                                                            "session_bringup_failure_reason",
                                                            "session_up") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)


                                        class NeighborSrcAddress(Entity):
                                            """
                                            Neighbor source address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__init__()

                                                self.yang_name = "neighbor-src-address"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-src-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class NeighborTransportAddress(Entity):
                                            """
                                            Neighbor transport address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__init__()

                                                self.yang_name = "neighbor-transport-address"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-transport-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class Target(Entity):
                                            """
                                            Target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__init__()

                                                self.yang_name = "target"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LastSessionDownInfo(Entity):
                                            """
                                            Last session down information
                                            
                                            .. attribute:: last_session_down_reason
                                            
                                            	The reason of last socket failure
                                            	**type**\:  str
                                            
                                            .. attribute:: last_session_down_time
                                            
                                            	Timestamp of when the last session went down
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: last_session_up_time
                                            
                                            	The time duration the last session was up
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__init__()

                                                self.yang_name = "last-session-down-info"
                                                self.yang_parent_name = "hello-information"

                                                self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("last_session_down_reason",
                                                                "last_session_down_time",
                                                                "last_session_up_time") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.last_session_down_reason.is_set or
                                                    self.last_session_down_time.is_set or
                                                    self.last_session_up_time.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.last_session_down_reason.yfilter != YFilter.not_set or
                                                    self.last_session_down_time.yfilter != YFilter.not_set or
                                                    self.last_session_up_time.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "last-session-down-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "last-session-down-reason"):
                                                    self.last_session_down_reason = value
                                                    self.last_session_down_reason.value_namespace = name_space
                                                    self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-down-time"):
                                                    self.last_session_down_time = value
                                                    self.last_session_down_time.value_namespace = name_space
                                                    self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-up-time"):
                                                    self.last_session_up_time = value
                                                    self.last_session_up_time.value_namespace = name_space
                                                    self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.disc_expiry.is_set or
                                                self.established_age.is_set or
                                                self.established_time.is_set or
                                                self.hold_time.is_set or
                                                self.is_no_route.is_set or
                                                self.is_targeted.is_set or
                                                self.local_hold_time.is_set or
                                                self.neighbor_hold_time.is_set or
                                                self.neighbor_ldp_identifier.is_set or
                                                self.session_bringup_failure_reason.is_set or
                                                self.session_up.is_set or
                                                (self.neighbor_src_address is not None and self.neighbor_src_address.has_data()) or
                                                (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_data()) or
                                                (self.target is not None and self.target.has_data()))

                                        def has_operation(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.disc_expiry.yfilter != YFilter.not_set or
                                                self.established_age.yfilter != YFilter.not_set or
                                                self.established_time.yfilter != YFilter.not_set or
                                                self.hold_time.yfilter != YFilter.not_set or
                                                self.is_no_route.yfilter != YFilter.not_set or
                                                self.is_targeted.yfilter != YFilter.not_set or
                                                self.local_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                self.session_up.yfilter != YFilter.not_set or
                                                (self.neighbor_src_address is not None and self.neighbor_src_address.has_operation()) or
                                                (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_operation()) or
                                                (self.target is not None and self.target.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "hello-information" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                            if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_age.get_name_leafdata())
                                            if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_time.get_name_leafdata())
                                            if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_time.get_name_leafdata())
                                            if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                            if (self.is_targeted.is_set or self.is_targeted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_targeted.get_name_leafdata())
                                            if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                            if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                            if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                            if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                            if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_up.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "last-session-down-info"):
                                                for c in self.last_session_down_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.last_session_down_info.append(c)
                                                return c

                                            if (child_yang_name == "neighbor-src-address"):
                                                if (self.neighbor_src_address is None):
                                                    self.neighbor_src_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                    self.neighbor_src_address.parent = self
                                                    self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                return self.neighbor_src_address

                                            if (child_yang_name == "neighbor-transport-address"):
                                                if (self.neighbor_transport_address is None):
                                                    self.neighbor_transport_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                    self.neighbor_transport_address.parent = self
                                                    self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                return self.neighbor_transport_address

                                            if (child_yang_name == "target"):
                                                if (self.target is None):
                                                    self.target = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                    self.target.parent = self
                                                    self._children_name_map["target"] = "target"
                                                return self.target

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "last-session-down-info" or name == "neighbor-src-address" or name == "neighbor-transport-address" or name == "target" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "is-no-route" or name == "is-targeted" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "neighbor-ldp-identifier" or name == "session-bringup-failure-reason" or name == "session-up"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "disc-expiry"):
                                                self.disc_expiry = value
                                                self.disc_expiry.value_namespace = name_space
                                                self.disc_expiry.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-age"):
                                                self.established_age = value
                                                self.established_age.value_namespace = name_space
                                                self.established_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-time"):
                                                self.established_time = value
                                                self.established_time.value_namespace = name_space
                                                self.established_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-time"):
                                                self.hold_time = value
                                                self.hold_time.value_namespace = name_space
                                                self.hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-route"):
                                                self.is_no_route = value
                                                self.is_no_route.value_namespace = name_space
                                                self.is_no_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-targeted"):
                                                self.is_targeted = value
                                                self.is_targeted.value_namespace = name_space
                                                self.is_targeted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-hold-time"):
                                                self.local_hold_time = value
                                                self.local_hold_time.value_namespace = name_space
                                                self.local_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-hold-time"):
                                                self.neighbor_hold_time = value
                                                self.neighbor_hold_time.value_namespace = name_space
                                                self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-ldp-identifier"):
                                                self.neighbor_ldp_identifier = value
                                                self.neighbor_ldp_identifier.value_namespace = name_space
                                                self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-bringup-failure-reason"):
                                                self.session_bringup_failure_reason = value
                                                self.session_bringup_failure_reason.value_namespace = name_space
                                                self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-up"):
                                                self.session_up = value
                                                self.session_up.value_namespace = name_space
                                                self.session_up.value_namespace_prefix = name_space_prefix


                                    class DiscoveryLinkAf(Entity):
                                        """
                                        LDP hello AF info
                                        
                                        .. attribute:: interval
                                        
                                        	Hello interval in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: local_src_address
                                        
                                        	Local source address
                                        	**type**\:   :py:class:`LocalSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress>`
                                        
                                        .. attribute:: local_transport_address
                                        
                                        	Local transport address
                                        	**type**\:   :py:class:`LocalTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__init__()

                                            self.yang_name = "discovery-link-af"
                                            self.yang_parent_name = "link-hello"

                                            self.interval = YLeaf(YType.uint32, "interval")

                                            self.local_src_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                            self.local_src_address.parent = self
                                            self._children_name_map["local_src_address"] = "local-src-address"
                                            self._children_yang_names.add("local-src-address")

                                            self.local_transport_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                            self.local_transport_address.parent = self
                                            self._children_name_map["local_transport_address"] = "local-transport-address"
                                            self._children_yang_names.add("local-transport-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interval") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)


                                        class LocalSrcAddress(Entity):
                                            """
                                            Local source address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__init__()

                                                self.yang_name = "local-src-address"
                                                self.yang_parent_name = "discovery-link-af"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-src-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LocalTransportAddress(Entity):
                                            """
                                            Local transport address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__init__()

                                                self.yang_name = "local-transport-address"
                                                self.yang_parent_name = "discovery-link-af"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-transport-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interval.is_set or
                                                (self.local_src_address is not None and self.local_src_address.has_data()) or
                                                (self.local_transport_address is not None and self.local_transport_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interval.yfilter != YFilter.not_set or
                                                (self.local_src_address is not None and self.local_src_address.has_operation()) or
                                                (self.local_transport_address is not None and self.local_transport_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "discovery-link-af" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interval.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-src-address"):
                                                if (self.local_src_address is None):
                                                    self.local_src_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                    self.local_src_address.parent = self
                                                    self._children_name_map["local_src_address"] = "local-src-address"
                                                return self.local_src_address

                                            if (child_yang_name == "local-transport-address"):
                                                if (self.local_transport_address is None):
                                                    self.local_transport_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                    self.local_transport_address.parent = self
                                                    self._children_name_map["local_transport_address"] = "local-transport-address"
                                                return self.local_transport_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-src-address" or name == "local-transport-address" or name == "interval"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interval"):
                                                self.interval = value
                                                self.interval.value_namespace = name_space
                                                self.interval.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.discovery_link_af:
                                            if (c.has_data()):
                                                return True
                                        for c in self.hello_information:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.interface.is_set or
                                            self.interface_name_xr.is_set or
                                            self.next_hello.is_set or
                                            self.quick_start_disabled.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.discovery_link_af:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.hello_information:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.next_hello.yfilter != YFilter.not_set or
                                            self.quick_start_disabled.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hello.get_name_leafdata())
                                        if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "discovery-link-af"):
                                            for c in self.discovery_link_af:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.discovery_link_af.append(c)
                                            return c

                                        if (child_yang_name == "hello-information"):
                                            for c in self.hello_information:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.hello_information.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "discovery-link-af" or name == "hello-information" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "next-hello" or name == "quick-start-disabled"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hello"):
                                            self.next_hello = value
                                            self.next_hello.value_namespace = name_space
                                            self.next_hello.value_namespace_prefix = name_space_prefix
                                        if(value_path == "quick-start-disabled"):
                                            self.quick_start_disabled = value
                                            self.quick_start_disabled.value_namespace = name_space
                                            self.quick_start_disabled.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.link_hello:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.link_hello:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "link-hellos" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello"):
                                        for c in self.link_hello:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.link_hello.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Summary(Entity):
                                """
                                Summarized information on LDP discovery
                                
                                .. attribute:: local_ldp_id
                                
                                	Local LDP identifier
                                	**type**\:  str
                                
                                .. attribute:: num_of_active_ldp_interfaces
                                
                                	Number of active LDP enabled interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_addr_recv
                                
                                	Number of hello discoveries received with bad source address
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_hello_pdu
                                
                                	Number of hello discoveries received with bad hello PDU
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_xport_addr
                                
                                	Number of hello discoveries received with bad export address
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_same_router_id
                                
                                	Number of hello discoveries received with the same router id as this router
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_wrong_router_id
                                
                                	Number of hello discoveries received with the router id that is not destined for this router
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_ldp_interfaces
                                
                                	Total Number of LDP configured interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_lnk_disc_recv
                                
                                	Number of link hello discoveries in recv state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_lnk_disc_xmit
                                
                                	Number of link hello discoveries in xmit state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_tgt_disc_recv
                                
                                	Number of targeted hello discoveries in recv state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_tgt_disc_xmit
                                
                                	Number of targeted hello discoveries in xmit state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary, self).__init__()

                                    self.yang_name = "summary"
                                    self.yang_parent_name = "discovery"

                                    self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                                    self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                                    self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                                    self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                                    self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                                    self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                                    self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                                    self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                                    self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                                    self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                                    self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                                    self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_ldp_id",
                                                    "num_of_active_ldp_interfaces",
                                                    "num_of_disc_with_bad_addr_recv",
                                                    "num_of_disc_with_bad_hello_pdu",
                                                    "num_of_disc_with_bad_xport_addr",
                                                    "num_of_disc_with_same_router_id",
                                                    "num_of_disc_with_wrong_router_id",
                                                    "num_of_ldp_interfaces",
                                                    "num_of_lnk_disc_recv",
                                                    "num_of_lnk_disc_xmit",
                                                    "num_of_tgt_disc_recv",
                                                    "num_of_tgt_disc_xmit") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.local_ldp_id.is_set or
                                        self.num_of_active_ldp_interfaces.is_set or
                                        self.num_of_disc_with_bad_addr_recv.is_set or
                                        self.num_of_disc_with_bad_hello_pdu.is_set or
                                        self.num_of_disc_with_bad_xport_addr.is_set or
                                        self.num_of_disc_with_same_router_id.is_set or
                                        self.num_of_disc_with_wrong_router_id.is_set or
                                        self.num_of_ldp_interfaces.is_set or
                                        self.num_of_lnk_disc_recv.is_set or
                                        self.num_of_lnk_disc_xmit.is_set or
                                        self.num_of_tgt_disc_recv.is_set or
                                        self.num_of_tgt_disc_xmit.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_ldp_id.yfilter != YFilter.not_set or
                                        self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                                        self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                                        self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                                        self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                                        self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                                        self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                                    if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                                    if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                                    if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                                    if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                                    if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                                    if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                                    if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                                    if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-ldp-id"):
                                        self.local_ldp_id = value
                                        self.local_ldp_id.value_namespace = name_space
                                        self.local_ldp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-active-ldp-interfaces"):
                                        self.num_of_active_ldp_interfaces = value
                                        self.num_of_active_ldp_interfaces.value_namespace = name_space
                                        self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-addr-recv"):
                                        self.num_of_disc_with_bad_addr_recv = value
                                        self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                                        self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-hello-pdu"):
                                        self.num_of_disc_with_bad_hello_pdu = value
                                        self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                                        self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-xport-addr"):
                                        self.num_of_disc_with_bad_xport_addr = value
                                        self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                                        self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-same-router-id"):
                                        self.num_of_disc_with_same_router_id = value
                                        self.num_of_disc_with_same_router_id.value_namespace = name_space
                                        self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-wrong-router-id"):
                                        self.num_of_disc_with_wrong_router_id = value
                                        self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                                        self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-ldp-interfaces"):
                                        self.num_of_ldp_interfaces = value
                                        self.num_of_ldp_interfaces.value_namespace = name_space
                                        self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-lnk-disc-recv"):
                                        self.num_of_lnk_disc_recv = value
                                        self.num_of_lnk_disc_recv.value_namespace = name_space
                                        self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-lnk-disc-xmit"):
                                        self.num_of_lnk_disc_xmit = value
                                        self.num_of_lnk_disc_xmit.value_namespace = name_space
                                        self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-tgt-disc-recv"):
                                        self.num_of_tgt_disc_recv = value
                                        self.num_of_tgt_disc_recv.value_namespace = name_space
                                        self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-tgt-disc-xmit"):
                                        self.num_of_tgt_disc_xmit = value
                                        self.num_of_tgt_disc_xmit.value_namespace = name_space
                                        self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix


                            class TargetedHellos(Entity):
                                """
                                The LDP Discovery Targeted
                                
                                .. attribute:: targeted_hello
                                
                                	Information on LDP targeted discovery
                                	**type**\: list of    :py:class:`TargetedHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__init__()

                                    self.yang_name = "targeted-hellos"
                                    self.yang_parent_name = "discovery"

                                    self.targeted_hello = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)


                                class TargetedHello(Entity):
                                    """
                                    Information on LDP targeted discovery
                                    
                                    .. attribute:: adjacency_ldp_identifier
                                    
                                    	Adjacency LDP Identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: dhcb_local_address
                                    
                                    	DHCB local address
                                    	**type**\:   :py:class:`DhcbLocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress>`
                                    
                                    .. attribute:: dhcb_target_address
                                    
                                    	DHCB target address
                                    	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress>`
                                    
                                    .. attribute:: disc_expiry
                                    
                                    	Discovery expiry time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: established_age
                                    
                                    	Hello adjacency estabished age in nanosec
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: established_time
                                    
                                    	Hello adjacency estabished time in nanosec
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: hold_time
                                    
                                    	Targeted hello hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interval
                                    
                                    	Hello interval in sec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_session_down_info
                                    
                                    	Last session down information
                                    	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo>`
                                    
                                    .. attribute:: local_address
                                    
                                    	Local IP Address
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: local_hold_time
                                    
                                    	Local hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_hold_time
                                    
                                    	Neighbor hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hello
                                    
                                    	Next hello due time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: quick_start_disabled
                                    
                                    	Quick\-start disabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: session_bringup_failure_reason
                                    
                                    	session bringup failure reason
                                    	**type**\:  str
                                    
                                    .. attribute:: session_up
                                    
                                    	Is session up for this adj
                                    	**type**\:  bool
                                    
                                    .. attribute:: state
                                    
                                    	Targeted hello state
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	The target IP Address
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__init__()

                                        self.yang_name = "targeted-hello"
                                        self.yang_parent_name = "targeted-hellos"

                                        self.adjacency_ldp_identifier = YLeaf(YType.str, "adjacency-ldp-identifier")

                                        self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                        self.established_age = YLeaf(YType.uint64, "established-age")

                                        self.established_time = YLeaf(YType.uint64, "established-time")

                                        self.hold_time = YLeaf(YType.uint32, "hold-time")

                                        self.interval = YLeaf(YType.uint32, "interval")

                                        self.local_address = YLeaf(YType.str, "local-address")

                                        self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                        self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                        self.next_hello = YLeaf(YType.uint32, "next-hello")

                                        self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                        self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                        self.session_up = YLeaf(YType.boolean, "session-up")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.target_address = YLeaf(YType.str, "target-address")

                                        self.dhcb_local_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                        self.dhcb_local_address.parent = self
                                        self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                        self._children_yang_names.add("dhcb-local-address")

                                        self.dhcb_target_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                        self.dhcb_target_address.parent = self
                                        self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                        self._children_yang_names.add("dhcb-target-address")

                                        self.last_session_down_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("adjacency_ldp_identifier",
                                                        "disc_expiry",
                                                        "established_age",
                                                        "established_time",
                                                        "hold_time",
                                                        "interval",
                                                        "local_address",
                                                        "local_hold_time",
                                                        "neighbor_hold_time",
                                                        "next_hello",
                                                        "quick_start_disabled",
                                                        "session_bringup_failure_reason",
                                                        "session_up",
                                                        "state",
                                                        "target_address") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)


                                    class DhcbLocalAddress(Entity):
                                        """
                                        DHCB local address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__init__()

                                            self.yang_name = "dhcb-local-address"
                                            self.yang_parent_name = "targeted-hello"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "dhcb-local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class DhcbTargetAddress(Entity):
                                        """
                                        DHCB target address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__init__()

                                            self.yang_name = "dhcb-target-address"
                                            self.yang_parent_name = "targeted-hello"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "dhcb-target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class LastSessionDownInfo(Entity):
                                        """
                                        Last session down information
                                        
                                        .. attribute:: last_session_down_reason
                                        
                                        	The reason of last socket failure
                                        	**type**\:  str
                                        
                                        .. attribute:: last_session_down_time
                                        
                                        	Timestamp of when the last session went down
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: last_session_up_time
                                        
                                        	The time duration the last session was up
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__init__()

                                            self.yang_name = "last-session-down-info"
                                            self.yang_parent_name = "targeted-hello"

                                            self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                            self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                            self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("last_session_down_reason",
                                                            "last_session_down_time",
                                                            "last_session_up_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.last_session_down_reason.is_set or
                                                self.last_session_down_time.is_set or
                                                self.last_session_up_time.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.last_session_down_reason.yfilter != YFilter.not_set or
                                                self.last_session_down_time.yfilter != YFilter.not_set or
                                                self.last_session_up_time.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "last-session-down-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                            if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                            if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "last-session-down-reason"):
                                                self.last_session_down_reason = value
                                                self.last_session_down_reason.value_namespace = name_space
                                                self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-session-down-time"):
                                                self.last_session_down_time = value
                                                self.last_session_down_time.value_namespace = name_space
                                                self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-session-up-time"):
                                                self.last_session_up_time = value
                                                self.last_session_up_time.value_namespace = name_space
                                                self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.last_session_down_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.adjacency_ldp_identifier.is_set or
                                            self.disc_expiry.is_set or
                                            self.established_age.is_set or
                                            self.established_time.is_set or
                                            self.hold_time.is_set or
                                            self.interval.is_set or
                                            self.local_address.is_set or
                                            self.local_hold_time.is_set or
                                            self.neighbor_hold_time.is_set or
                                            self.next_hello.is_set or
                                            self.quick_start_disabled.is_set or
                                            self.session_bringup_failure_reason.is_set or
                                            self.session_up.is_set or
                                            self.state.is_set or
                                            self.target_address.is_set or
                                            (self.dhcb_local_address is not None and self.dhcb_local_address.has_data()) or
                                            (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()))

                                    def has_operation(self):
                                        for c in self.last_session_down_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.adjacency_ldp_identifier.yfilter != YFilter.not_set or
                                            self.disc_expiry.yfilter != YFilter.not_set or
                                            self.established_age.yfilter != YFilter.not_set or
                                            self.established_time.yfilter != YFilter.not_set or
                                            self.hold_time.yfilter != YFilter.not_set or
                                            self.interval.yfilter != YFilter.not_set or
                                            self.local_address.yfilter != YFilter.not_set or
                                            self.local_hold_time.yfilter != YFilter.not_set or
                                            self.neighbor_hold_time.yfilter != YFilter.not_set or
                                            self.next_hello.yfilter != YFilter.not_set or
                                            self.quick_start_disabled.yfilter != YFilter.not_set or
                                            self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                            self.session_up.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.target_address.yfilter != YFilter.not_set or
                                            (self.dhcb_local_address is not None and self.dhcb_local_address.has_operation()) or
                                            (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hello" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.adjacency_ldp_identifier.is_set or self.adjacency_ldp_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.adjacency_ldp_identifier.get_name_leafdata())
                                        if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                        if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.established_age.get_name_leafdata())
                                        if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.established_time.get_name_leafdata())
                                        if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_time.get_name_leafdata())
                                        if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interval.get_name_leafdata())
                                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_address.get_name_leafdata())
                                        if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                        if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                        if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hello.get_name_leafdata())
                                        if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())
                                        if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                        if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.session_up.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.target_address.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "dhcb-local-address"):
                                            if (self.dhcb_local_address is None):
                                                self.dhcb_local_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                                self.dhcb_local_address.parent = self
                                                self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                            return self.dhcb_local_address

                                        if (child_yang_name == "dhcb-target-address"):
                                            if (self.dhcb_target_address is None):
                                                self.dhcb_target_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                                self.dhcb_target_address.parent = self
                                                self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            return self.dhcb_target_address

                                        if (child_yang_name == "last-session-down-info"):
                                            for c in self.last_session_down_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.last_session_down_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dhcb-local-address" or name == "dhcb-target-address" or name == "last-session-down-info" or name == "adjacency-ldp-identifier" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "interval" or name == "local-address" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "next-hello" or name == "quick-start-disabled" or name == "session-bringup-failure-reason" or name == "session-up" or name == "state" or name == "target-address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "adjacency-ldp-identifier"):
                                            self.adjacency_ldp_identifier = value
                                            self.adjacency_ldp_identifier.value_namespace = name_space
                                            self.adjacency_ldp_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "disc-expiry"):
                                            self.disc_expiry = value
                                            self.disc_expiry.value_namespace = name_space
                                            self.disc_expiry.value_namespace_prefix = name_space_prefix
                                        if(value_path == "established-age"):
                                            self.established_age = value
                                            self.established_age.value_namespace = name_space
                                            self.established_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "established-time"):
                                            self.established_time = value
                                            self.established_time.value_namespace = name_space
                                            self.established_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-time"):
                                            self.hold_time = value
                                            self.hold_time.value_namespace = name_space
                                            self.hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interval"):
                                            self.interval = value
                                            self.interval.value_namespace = name_space
                                            self.interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-address"):
                                            self.local_address = value
                                            self.local_address.value_namespace = name_space
                                            self.local_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-hold-time"):
                                            self.local_hold_time = value
                                            self.local_hold_time.value_namespace = name_space
                                            self.local_hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-hold-time"):
                                            self.neighbor_hold_time = value
                                            self.neighbor_hold_time.value_namespace = name_space
                                            self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hello"):
                                            self.next_hello = value
                                            self.next_hello.value_namespace = name_space
                                            self.next_hello.value_namespace_prefix = name_space_prefix
                                        if(value_path == "quick-start-disabled"):
                                            self.quick_start_disabled = value
                                            self.quick_start_disabled.value_namespace = name_space
                                            self.quick_start_disabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "session-bringup-failure-reason"):
                                            self.session_bringup_failure_reason = value
                                            self.session_bringup_failure_reason.value_namespace = name_space
                                            self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "session-up"):
                                            self.session_up = value
                                            self.session_up.value_namespace = name_space
                                            self.session_up.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "target-address"):
                                            self.target_address = value
                                            self.target_address.value_namespace = name_space
                                            self.target_address.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.targeted_hello:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.targeted_hello:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "targeted-hellos" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "targeted-hello"):
                                        for c in self.targeted_hello:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.targeted_hello.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "targeted-hello"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Brief(Entity):
                                """
                                Brief information on LDP discovery
                                
                                .. attribute:: link_hello_briefs
                                
                                	The LDP Discovery link brief information
                                	**type**\:   :py:class:`LinkHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs>`
                                
                                .. attribute:: targeted_hello_briefs
                                
                                	The LDP Discovery Targeted brief information
                                	**type**\:   :py:class:`TargetedHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief, self).__init__()

                                    self.yang_name = "brief"
                                    self.yang_parent_name = "discovery"

                                    self.link_hello_briefs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                    self.link_hello_briefs.parent = self
                                    self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                    self._children_yang_names.add("link-hello-briefs")

                                    self.targeted_hello_briefs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                    self.targeted_hello_briefs.parent = self
                                    self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                    self._children_yang_names.add("targeted-hello-briefs")


                                class LinkHelloBriefs(Entity):
                                    """
                                    The LDP Discovery link brief information
                                    
                                    .. attribute:: link_hello_brief
                                    
                                    	Brief information on LDP link discovery
                                    	**type**\: list of    :py:class:`LinkHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__init__()

                                        self.yang_name = "link-hello-briefs"
                                        self.yang_parent_name = "brief"

                                        self.link_hello_brief = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)


                                    class LinkHelloBrief(Entity):
                                        """
                                        Brief information on LDP link discovery
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: address_family
                                        
                                        	Discovery Brief Address Family
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: address_family_set
                                        
                                        	Discovery Brief Address Family Set
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation>`
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__init__()

                                            self.yang_name = "link-hello-brief"
                                            self.yang_parent_name = "link-hello-briefs"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.address_family = YLeaf(YType.enumeration, "address-family")

                                            self.address_family_set = YLeaf(YType.enumeration, "address-family-set")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "address_family",
                                                            "address_family_set",
                                                            "interface",
                                                            "interface_name_xr") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "link-hello-brief"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "link-hello-brief"

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_up.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.address_family.is_set or
                                                self.address_family_set.is_set or
                                                self.interface.is_set or
                                                self.interface_name_xr.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.address_family.yfilter != YFilter.not_set or
                                                self.address_family_set.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family.get_name_leafdata())
                                            if (self.address_family_set.is_set or self.address_family_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family_set.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "hello-information" or name == "vrf" or name == "interface-name" or name == "address-family" or name == "address-family-set" or name == "interface" or name == "interface-name-xr"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "address-family"):
                                                self.address_family = value
                                                self.address_family.value_namespace = name_space
                                                self.address_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "address-family-set"):
                                                self.address_family_set = value
                                                self.address_family_set.value_namespace = name_space
                                                self.address_family_set.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link_hello_brief:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.link_hello_brief:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-briefs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-brief"):
                                            for c in self.link_hello_brief:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link_hello_brief.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-brief"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class TargetedHelloBriefs(Entity):
                                    """
                                    The LDP Discovery Targeted brief information
                                    
                                    .. attribute:: targeted_hello_brief
                                    
                                    	Brief information on LDP targeted discovery
                                    	**type**\: list of    :py:class:`TargetedHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__init__()

                                        self.yang_name = "targeted-hello-briefs"
                                        self.yang_parent_name = "brief"

                                        self.targeted_hello_brief = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)


                                    class TargetedHelloBrief(Entity):
                                        """
                                        Brief information on LDP targeted discovery
                                        
                                        .. attribute:: address_family
                                        
                                        	Targeted Discovery Address Family
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: dhcb_target_address
                                        
                                        	DHCB target address
                                        	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation>`
                                        
                                        .. attribute:: local_address
                                        
                                        	Local IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: target_address
                                        
                                        	The target IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__init__()

                                            self.yang_name = "targeted-hello-brief"
                                            self.yang_parent_name = "targeted-hello-briefs"

                                            self.address_family = YLeaf(YType.enumeration, "address-family")

                                            self.local_address = YLeaf(YType.str, "local-address")

                                            self.target_address = YLeaf(YType.str, "target-address")

                                            self.dhcb_target_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                            self.dhcb_target_address.parent = self
                                            self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            self._children_yang_names.add("dhcb-target-address")

                                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address_family",
                                                            "local_address",
                                                            "target_address") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class DhcbTargetAddress(Entity):
                                            """
                                            DHCB target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__init__()

                                                self.yang_name = "dhcb-target-address"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_up.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.address_family.is_set or
                                                self.local_address.is_set or
                                                self.target_address.is_set or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()) or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address_family.yfilter != YFilter.not_set or
                                                self.local_address.yfilter != YFilter.not_set or
                                                self.target_address.yfilter != YFilter.not_set or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()) or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello-brief" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family.get_name_leafdata())
                                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_address.get_name_leafdata())
                                            if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.target_address.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "dhcb-target-address"):
                                                if (self.dhcb_target_address is None):
                                                    self.dhcb_target_address = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                    self.dhcb_target_address.parent = self
                                                    self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                return self.dhcb_target_address

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "dhcb-target-address" or name == "hello-information" or name == "vrf" or name == "address-family" or name == "local-address" or name == "target-address"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address-family"):
                                                self.address_family = value
                                                self.address_family.value_namespace = name_space
                                                self.address_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-address"):
                                                self.local_address = value
                                                self.local_address.value_namespace = name_space
                                                self.local_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "target-address"):
                                                self.target_address = value
                                                self.target_address.value_namespace = name_space
                                                self.target_address.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.targeted_hello_brief:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.targeted_hello_brief:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hello-briefs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "targeted-hello-brief"):
                                            for c in self.targeted_hello_brief:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.targeted_hello_brief.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "targeted-hello-brief"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        (self.link_hello_briefs is not None and self.link_hello_briefs.has_data()) or
                                        (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.link_hello_briefs is not None and self.link_hello_briefs.has_operation()) or
                                        (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "brief" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-briefs"):
                                        if (self.link_hello_briefs is None):
                                            self.link_hello_briefs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                            self.link_hello_briefs.parent = self
                                            self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                        return self.link_hello_briefs

                                    if (child_yang_name == "targeted-hello-briefs"):
                                        if (self.targeted_hello_briefs is None):
                                            self.targeted_hello_briefs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                            self.targeted_hello_briefs.parent = self
                                            self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                        return self.targeted_hello_briefs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-briefs" or name == "targeted-hello-briefs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Stats(Entity):
                                """
                                The LDP Discovery Statistics
                                
                                .. attribute:: stat
                                
                                	Information on LDP discovery statistics
                                	**type**\: list of    :py:class:`Stat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats.Stat>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats, self).__init__()

                                    self.yang_name = "stats"
                                    self.yang_parent_name = "discovery"

                                    self.stat = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)


                                class Stat(Entity):
                                    """
                                    Information on LDP discovery statistics
                                    
                                    .. attribute:: adjacency_group_up_time
                                    
                                    	Adjacency group up time in seconds
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: tcp_arb_chg_count
                                    
                                    	Count of changes in TCP arbitration
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tcp_open_count
                                    
                                    	Count of attempted TCP opens
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tcp_role
                                    
                                    	TCP Role
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__init__()

                                        self.yang_name = "stat"
                                        self.yang_parent_name = "stats"

                                        self.adjacency_group_up_time = YLeaf(YType.uint32, "adjacency-group-up-time")

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.tcp_arb_chg_count = YLeaf(YType.uint32, "tcp-arb-chg-count")

                                        self.tcp_open_count = YLeaf(YType.uint32, "tcp-open-count")

                                        self.tcp_role = YLeaf(YType.uint32, "tcp-role")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("adjacency_group_up_time",
                                                        "label_space_id",
                                                        "lsr_id",
                                                        "tcp_arb_chg_count",
                                                        "tcp_open_count",
                                                        "tcp_role") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.adjacency_group_up_time.is_set or
                                            self.label_space_id.is_set or
                                            self.lsr_id.is_set or
                                            self.tcp_arb_chg_count.is_set or
                                            self.tcp_open_count.is_set or
                                            self.tcp_role.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.adjacency_group_up_time.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.tcp_arb_chg_count.yfilter != YFilter.not_set or
                                            self.tcp_open_count.yfilter != YFilter.not_set or
                                            self.tcp_role.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stat" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.adjacency_group_up_time.is_set or self.adjacency_group_up_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.adjacency_group_up_time.get_name_leafdata())
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.tcp_arb_chg_count.is_set or self.tcp_arb_chg_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_arb_chg_count.get_name_leafdata())
                                        if (self.tcp_open_count.is_set or self.tcp_open_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_open_count.get_name_leafdata())
                                        if (self.tcp_role.is_set or self.tcp_role.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_role.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "adjacency-group-up-time" or name == "label-space-id" or name == "lsr-id" or name == "tcp-arb-chg-count" or name == "tcp-open-count" or name == "tcp-role"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "adjacency-group-up-time"):
                                            self.adjacency_group_up_time = value
                                            self.adjacency_group_up_time.value_namespace = name_space
                                            self.adjacency_group_up_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-arb-chg-count"):
                                            self.tcp_arb_chg_count = value
                                            self.tcp_arb_chg_count.value_namespace = name_space
                                            self.tcp_arb_chg_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-open-count"):
                                            self.tcp_open_count = value
                                            self.tcp_open_count.value_namespace = name_space
                                            self.tcp_open_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-role"):
                                            self.tcp_role = value
                                            self.tcp_role.value_namespace = name_space
                                            self.tcp_role.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.stat:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.stat:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "stat"):
                                        for c in self.stat:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats.Stat()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.stat.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "stat"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.brief is not None and self.brief.has_data()) or
                                    (self.link_hellos is not None and self.link_hellos.has_data()) or
                                    (self.stats is not None and self.stats.has_data()) or
                                    (self.summary is not None and self.summary.has_data()) or
                                    (self.targeted_hellos is not None and self.targeted_hellos.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.brief is not None and self.brief.has_operation()) or
                                    (self.link_hellos is not None and self.link_hellos.has_operation()) or
                                    (self.stats is not None and self.stats.has_operation()) or
                                    (self.summary is not None and self.summary.has_operation()) or
                                    (self.targeted_hellos is not None and self.targeted_hellos.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovery" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "brief"):
                                    if (self.brief is None):
                                        self.brief = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Brief()
                                        self.brief.parent = self
                                        self._children_name_map["brief"] = "brief"
                                    return self.brief

                                if (child_yang_name == "link-hellos"):
                                    if (self.link_hellos is None):
                                        self.link_hellos = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.LinkHellos()
                                        self.link_hellos.parent = self
                                        self._children_name_map["link_hellos"] = "link-hellos"
                                    return self.link_hellos

                                if (child_yang_name == "stats"):
                                    if (self.stats is None):
                                        self.stats = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Stats()
                                        self.stats.parent = self
                                        self._children_name_map["stats"] = "stats"
                                    return self.stats

                                if (child_yang_name == "summary"):
                                    if (self.summary is None):
                                        self.summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.Summary()
                                        self.summary.parent = self
                                        self._children_name_map["summary"] = "summary"
                                    return self.summary

                                if (child_yang_name == "targeted-hellos"):
                                    if (self.targeted_hellos is None):
                                        self.targeted_hellos = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery.TargetedHellos()
                                        self.targeted_hellos.parent = self
                                        self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                    return self.targeted_hellos

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "brief" or name == "link-hellos" or name == "stats" or name == "summary" or name == "targeted-hellos"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsSummaryAll(Entity):
                            """
                            Aggregate VRF counters for the LDP Label
                            Infomation Base (LIB)
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: bind_af
                            
                            	bind af
                            	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf>`
                            
                            .. attribute:: binding_local_explicit_null
                            
                            	Number of local explicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_implicit_null
                            
                            	Number of local implicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_no_route
                            
                            	Local bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_non_null
                            
                            	Number of local non\-null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_null
                            
                            	Number of local null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_oor
                            
                            	Number of local bindings        needing label \- OOR
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_no_route
                            
                            	Bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: highest_allocated_label
                            
                            	Highest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lowest_allocated_label
                            
                            	Lowest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__init__()

                                self.yang_name = "bindings-summary-all"
                                self.yang_parent_name = "af"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.bind_af = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "binding_local_explicit_null",
                                                "binding_local_implicit_null",
                                                "binding_local_no_route",
                                                "binding_local_non_null",
                                                "binding_local_null",
                                                "binding_local_oor",
                                                "binding_no_route",
                                                "highest_allocated_label",
                                                "lowest_allocated_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "bindings-summary-all"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class BindAf(Entity):
                                """
                                bind af
                                
                                .. attribute:: address_family
                                
                                	Binding Summary Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: binding_local
                                
                                	Number of local bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_remote
                                
                                	Number of remote bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_total
                                
                                	Total bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_lib_update
                                
                                	Last update to LIB local binding
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lib_minimum_revision_sent_all
                                
                                	Last update sent to all peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__init__()

                                    self.yang_name = "bind-af"
                                    self.yang_parent_name = "bindings-summary-all"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local = YLeaf(YType.uint32, "binding-local")

                                    self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                    self.binding_total = YLeaf(YType.uint32, "binding-total")

                                    self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                    self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local",
                                                    "binding_remote",
                                                    "binding_total",
                                                    "last_lib_update",
                                                    "lib_minimum_revision_sent_all") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local.is_set or
                                        self.binding_remote.is_set or
                                        self.binding_total.is_set or
                                        self.last_lib_update.is_set or
                                        self.lib_minimum_revision_sent_all.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local.yfilter != YFilter.not_set or
                                        self.binding_remote.yfilter != YFilter.not_set or
                                        self.binding_total.yfilter != YFilter.not_set or
                                        self.last_lib_update.yfilter != YFilter.not_set or
                                        self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bind-af" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local.get_name_leafdata())
                                    if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                    if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_total.get_name_leafdata())
                                    if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                    if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local"):
                                        self.binding_local = value
                                        self.binding_local.value_namespace = name_space
                                        self.binding_local.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-remote"):
                                        self.binding_remote = value
                                        self.binding_remote.value_namespace = name_space
                                        self.binding_remote.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-total"):
                                        self.binding_total = value
                                        self.binding_total.value_namespace = name_space
                                        self.binding_total.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-lib-update"):
                                        self.last_lib_update = value
                                        self.last_lib_update.value_namespace = name_space
                                        self.last_lib_update.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lib-minimum-revision-sent-all"):
                                        self.lib_minimum_revision_sent_all = value
                                        self.lib_minimum_revision_sent_all.value_namespace = name_space
                                        self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bind_af:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.address_family.is_set or
                                    self.binding_local_explicit_null.is_set or
                                    self.binding_local_implicit_null.is_set or
                                    self.binding_local_no_route.is_set or
                                    self.binding_local_non_null.is_set or
                                    self.binding_local_null.is_set or
                                    self.binding_local_oor.is_set or
                                    self.binding_no_route.is_set or
                                    self.highest_allocated_label.is_set or
                                    self.lowest_allocated_label.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.bind_af:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_no_route.yfilter != YFilter.not_set or
                                    self.binding_local_non_null.yfilter != YFilter.not_set or
                                    self.binding_local_null.yfilter != YFilter.not_set or
                                    self.binding_local_oor.yfilter != YFilter.not_set or
                                    self.binding_no_route.yfilter != YFilter.not_set or
                                    self.highest_allocated_label.yfilter != YFilter.not_set or
                                    self.lowest_allocated_label.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-summary-all" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bind-af"):
                                    for c in self.bind_af:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bind_af.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-explicit-null"):
                                    self.binding_local_explicit_null = value
                                    self.binding_local_explicit_null.value_namespace = name_space
                                    self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-implicit-null"):
                                    self.binding_local_implicit_null = value
                                    self.binding_local_implicit_null.value_namespace = name_space
                                    self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-no-route"):
                                    self.binding_local_no_route = value
                                    self.binding_local_no_route.value_namespace = name_space
                                    self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-non-null"):
                                    self.binding_local_non_null = value
                                    self.binding_local_non_null.value_namespace = name_space
                                    self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-null"):
                                    self.binding_local_null = value
                                    self.binding_local_null.value_namespace = name_space
                                    self.binding_local_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-oor"):
                                    self.binding_local_oor = value
                                    self.binding_local_oor.value_namespace = name_space
                                    self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-no-route"):
                                    self.binding_no_route = value
                                    self.binding_no_route.value_namespace = name_space
                                    self.binding_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "highest-allocated-label"):
                                    self.highest_allocated_label = value
                                    self.highest_allocated_label.value_namespace = name_space
                                    self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lowest-allocated-label"):
                                    self.lowest_allocated_label = value
                                    self.lowest_allocated_label.value_namespace = name_space
                                    self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                        class Forwardings(Entity):
                            """
                            The LDP Forwarding rewrites
                            
                            .. attribute:: forwarding
                            
                            	Information on a particular LDP forwarding rewrite
                            	**type**\: list of    :py:class:`Forwarding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings, self).__init__()

                                self.yang_name = "forwardings"
                                self.yang_parent_name = "af"

                                self.forwarding = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings, self).__setattr__(name, value)


                            class Forwarding(Entity):
                                """
                                Information on a particular LDP forwarding
                                rewrite
                                
                                .. attribute:: prefix  <key>
                                
                                	The IP Prefix
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                
                                
                                ----
                                .. attribute:: paths
                                
                                	Paths
                                	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths>`
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: prefix_xr
                                
                                	IP Prefix
                                	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr>`
                                
                                .. attribute:: route
                                
                                	Route
                                	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route>`
                                
                                .. attribute:: table_id
                                
                                	Table ID associated with IP prefix
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__init__()

                                    self.yang_name = "forwarding"
                                    self.yang_parent_name = "forwardings"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.prefix_xr = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                    self.prefix_xr.parent = self
                                    self._children_name_map["prefix_xr"] = "prefix-xr"
                                    self._children_yang_names.add("prefix-xr")

                                    self.route = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route()
                                    self.route.parent = self
                                    self._children_name_map["route"] = "route"
                                    self._children_yang_names.add("route")

                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.paths = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "forwarding"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class PrefixXr(Entity):
                                    """
                                    IP Prefix
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__init__()

                                        self.yang_name = "prefix-xr"
                                        self.yang_parent_name = "forwarding"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prefix-xr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class Route(Entity):
                                    """
                                    Route
                                    
                                    .. attribute:: mpls
                                    
                                    	MPLS information
                                    	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls>`
                                    
                                    .. attribute:: routing
                                    
                                    	IP routing information
                                    	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route, self).__init__()

                                        self.yang_name = "route"
                                        self.yang_parent_name = "forwarding"

                                        self.mpls = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                        self.mpls.parent = self
                                        self._children_name_map["mpls"] = "mpls"
                                        self._children_yang_names.add("mpls")

                                        self.routing = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                        self.routing.parent = self
                                        self._children_name_map["routing"] = "routing"
                                        self._children_yang_names.add("routing")


                                    class Routing(Entity):
                                        """
                                        IP routing information
                                        
                                        .. attribute:: flags
                                        
                                        	Route RIB flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_local_vrf_leaked
                                        
                                        	Is route leaked across local VRFs?
                                        	**type**\:  bool
                                        
                                        .. attribute:: metric
                                        
                                        	Route metric
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: priority
                                        
                                        	Route priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: routing_update_age
                                        
                                        	Last Routing update nanosec age
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: routing_update_count
                                        
                                        	Number of routing updates
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: routing_update_timestamp
                                        
                                        	Last Routing update nanosec timestamp
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: source
                                        
                                        	Route source protol Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sr_local_label
                                        
                                        	SR Local\-label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: type
                                        
                                        	Route type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: version
                                        
                                        	Route RIB ersion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__init__()

                                            self.yang_name = "routing"
                                            self.yang_parent_name = "route"

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.is_local_vrf_leaked = YLeaf(YType.boolean, "is-local-vrf-leaked")

                                            self.metric = YLeaf(YType.uint32, "metric")

                                            self.priority = YLeaf(YType.uint8, "priority")

                                            self.routing_update_age = YLeaf(YType.uint64, "routing-update-age")

                                            self.routing_update_count = YLeaf(YType.uint32, "routing-update-count")

                                            self.routing_update_timestamp = YLeaf(YType.uint64, "routing-update-timestamp")

                                            self.source = YLeaf(YType.uint16, "source")

                                            self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                            self.type = YLeaf(YType.uint16, "type")

                                            self.version = YLeaf(YType.uint32, "version")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("flags",
                                                            "is_local_vrf_leaked",
                                                            "metric",
                                                            "priority",
                                                            "routing_update_age",
                                                            "routing_update_count",
                                                            "routing_update_timestamp",
                                                            "source",
                                                            "sr_local_label",
                                                            "type",
                                                            "version") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.flags.is_set or
                                                self.is_local_vrf_leaked.is_set or
                                                self.metric.is_set or
                                                self.priority.is_set or
                                                self.routing_update_age.is_set or
                                                self.routing_update_count.is_set or
                                                self.routing_update_timestamp.is_set or
                                                self.source.is_set or
                                                self.sr_local_label.is_set or
                                                self.type.is_set or
                                                self.version.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.flags.yfilter != YFilter.not_set or
                                                self.is_local_vrf_leaked.yfilter != YFilter.not_set or
                                                self.metric.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                self.routing_update_age.yfilter != YFilter.not_set or
                                                self.routing_update_count.yfilter != YFilter.not_set or
                                                self.routing_update_timestamp.yfilter != YFilter.not_set or
                                                self.source.yfilter != YFilter.not_set or
                                                self.sr_local_label.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set or
                                                self.version.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "routing" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flags.get_name_leafdata())
                                            if (self.is_local_vrf_leaked.is_set or self.is_local_vrf_leaked.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_local_vrf_leaked.get_name_leafdata())
                                            if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.metric.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())
                                            if (self.routing_update_age.is_set or self.routing_update_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_age.get_name_leafdata())
                                            if (self.routing_update_count.is_set or self.routing_update_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_count.get_name_leafdata())
                                            if (self.routing_update_timestamp.is_set or self.routing_update_timestamp.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_timestamp.get_name_leafdata())
                                            if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source.get_name_leafdata())
                                            if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())
                                            if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.version.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "flags" or name == "is-local-vrf-leaked" or name == "metric" or name == "priority" or name == "routing-update-age" or name == "routing-update-count" or name == "routing-update-timestamp" or name == "source" or name == "sr-local-label" or name == "type" or name == "version"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "flags"):
                                                self.flags = value
                                                self.flags.value_namespace = name_space
                                                self.flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-local-vrf-leaked"):
                                                self.is_local_vrf_leaked = value
                                                self.is_local_vrf_leaked.value_namespace = name_space
                                                self.is_local_vrf_leaked.value_namespace_prefix = name_space_prefix
                                            if(value_path == "metric"):
                                                self.metric = value
                                                self.metric.value_namespace = name_space
                                                self.metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-age"):
                                                self.routing_update_age = value
                                                self.routing_update_age.value_namespace = name_space
                                                self.routing_update_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-count"):
                                                self.routing_update_count = value
                                                self.routing_update_count.value_namespace = name_space
                                                self.routing_update_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-timestamp"):
                                                self.routing_update_timestamp = value
                                                self.routing_update_timestamp.value_namespace = name_space
                                                self.routing_update_timestamp.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source"):
                                                self.source = value
                                                self.source.value_namespace = name_space
                                                self.source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sr-local-label"):
                                                self.sr_local_label = value
                                                self.sr_local_label.value_namespace = name_space
                                                self.sr_local_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "version"):
                                                self.version = value
                                                self.version.value_namespace = name_space
                                                self.version.value_namespace_prefix = name_space_prefix


                                    class Mpls(Entity):
                                        """
                                        MPLS information
                                        
                                        .. attribute:: forwarding_update_age
                                        
                                        	Last Forwarding update nanosec age
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: forwarding_update_count
                                        
                                        	Number of forwarding updates
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forwarding_update_timestamp
                                        
                                        	Last Forwarding update nanosec timestamp
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: local_label
                                        
                                        	Local label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__init__()

                                            self.yang_name = "mpls"
                                            self.yang_parent_name = "route"

                                            self.forwarding_update_age = YLeaf(YType.uint64, "forwarding-update-age")

                                            self.forwarding_update_count = YLeaf(YType.uint32, "forwarding-update-count")

                                            self.forwarding_update_timestamp = YLeaf(YType.uint64, "forwarding-update-timestamp")

                                            self.local_label = YLeaf(YType.uint32, "local-label")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("forwarding_update_age",
                                                            "forwarding_update_count",
                                                            "forwarding_update_timestamp",
                                                            "local_label") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.forwarding_update_age.is_set or
                                                self.forwarding_update_count.is_set or
                                                self.forwarding_update_timestamp.is_set or
                                                self.local_label.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.forwarding_update_age.yfilter != YFilter.not_set or
                                                self.forwarding_update_count.yfilter != YFilter.not_set or
                                                self.forwarding_update_timestamp.yfilter != YFilter.not_set or
                                                self.local_label.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mpls" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.forwarding_update_age.is_set or self.forwarding_update_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_age.get_name_leafdata())
                                            if (self.forwarding_update_count.is_set or self.forwarding_update_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_count.get_name_leafdata())
                                            if (self.forwarding_update_timestamp.is_set or self.forwarding_update_timestamp.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_timestamp.get_name_leafdata())
                                            if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_label.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "forwarding-update-age" or name == "forwarding-update-count" or name == "forwarding-update-timestamp" or name == "local-label"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "forwarding-update-age"):
                                                self.forwarding_update_age = value
                                                self.forwarding_update_age.value_namespace = name_space
                                                self.forwarding_update_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-update-count"):
                                                self.forwarding_update_count = value
                                                self.forwarding_update_count.value_namespace = name_space
                                                self.forwarding_update_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-update-timestamp"):
                                                self.forwarding_update_timestamp = value
                                                self.forwarding_update_timestamp.value_namespace = name_space
                                                self.forwarding_update_timestamp.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-label"):
                                                self.local_label = value
                                                self.local_label.value_namespace = name_space
                                                self.local_label.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.mpls is not None and self.mpls.has_data()) or
                                            (self.routing is not None and self.routing.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.mpls is not None and self.mpls.has_operation()) or
                                            (self.routing is not None and self.routing.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "route" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mpls"):
                                            if (self.mpls is None):
                                                self.mpls = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                                self.mpls.parent = self
                                                self._children_name_map["mpls"] = "mpls"
                                            return self.mpls

                                        if (child_yang_name == "routing"):
                                            if (self.routing is None):
                                                self.routing = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                                self.routing.parent = self
                                                self._children_name_map["routing"] = "routing"
                                            return self.routing

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mpls" or name == "routing"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Paths(Entity):
                                    """
                                    Paths
                                    
                                    .. attribute:: mpls
                                    
                                    	MPLS information
                                    	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls>`
                                    
                                    .. attribute:: routing
                                    
                                    	IP routing information
                                    	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths, self).__init__()

                                        self.yang_name = "paths"
                                        self.yang_parent_name = "forwarding"

                                        self.mpls = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                        self.mpls.parent = self
                                        self._children_name_map["mpls"] = "mpls"
                                        self._children_yang_names.add("mpls")

                                        self.routing = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                        self.routing.parent = self
                                        self._children_name_map["routing"] = "routing"
                                        self._children_yang_names.add("routing")


                                    class Routing(Entity):
                                        """
                                        IP routing information
                                        
                                        .. attribute:: bkup_path_id
                                        
                                        	Backup path Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: flags
                                        
                                        	Route path flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface Name
                                        	**type**\:  str
                                        
                                        .. attribute:: load_metric
                                        
                                        	Path's load metric for load balancing
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hop
                                        
                                        	Next Hop
                                        	**type**\:   :py:class:`NextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop>`
                                        
                                        .. attribute:: next_hop_table_id
                                        
                                        	Table ID for nexthop address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: nexthop_id
                                        
                                        	Nexthop Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: nh_is_overriden
                                        
                                        	Nexthop is overriden by LDP
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_flags
                                        
                                        	Routing path flags decoded
                                        	**type**\:   :py:class:`LdpRoutePathFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathFlags>`
                                        
                                        .. attribute:: path_id
                                        
                                        	path Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: remote_lfa
                                        
                                        	Remote LFA\-FRR backup info
                                        	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__init__()

                                            self.yang_name = "routing"
                                            self.yang_parent_name = "paths"

                                            self.bkup_path_id = YLeaf(YType.uint8, "bkup-path-id")

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.load_metric = YLeaf(YType.uint32, "load-metric")

                                            self.next_hop_table_id = YLeaf(YType.uint32, "next-hop-table-id")

                                            self.nexthop_id = YLeaf(YType.uint32, "nexthop-id")

                                            self.nh_is_overriden = YLeaf(YType.boolean, "nh-is-overriden")

                                            self.path_flags = YLeaf(YType.enumeration, "path-flags")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.next_hop = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                            self.next_hop.parent = self
                                            self._children_name_map["next_hop"] = "next-hop"
                                            self._children_yang_names.add("next-hop")

                                            self.remote_lfa = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                            self.remote_lfa.parent = self
                                            self._children_name_map["remote_lfa"] = "remote-lfa"
                                            self._children_yang_names.add("remote-lfa")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bkup_path_id",
                                                            "flags",
                                                            "interface",
                                                            "interface_name",
                                                            "load_metric",
                                                            "next_hop_table_id",
                                                            "nexthop_id",
                                                            "nh_is_overriden",
                                                            "path_flags",
                                                            "path_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)


                                        class NextHop(Entity):
                                            """
                                            Next Hop
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__init__()

                                                self.yang_name = "next-hop"
                                                self.yang_parent_name = "routing"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "next-hop" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class RemoteLfa(Entity):
                                            """
                                            Remote LFA\-FRR backup info
                                            
                                            .. attribute:: has_q_node
                                            
                                            	Whether remote LFA path has a Q node associated
                                            	**type**\:  bool
                                            
                                            .. attribute:: has_remote_lfa_bkup
                                            
                                            	Whether path has remote LFA backup
                                            	**type**\:  bool
                                            
                                            .. attribute:: needs_tldp
                                            
                                            	Whether TLDP is needed with remote PQ node
                                            	**type**\:  bool
                                            
                                            .. attribute:: remote_p_node_id
                                            
                                            	Remote/P node address
                                            	**type**\:   :py:class:`RemotePNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId>`
                                            
                                            .. attribute:: remote_q_node_id
                                            
                                            	Remote/Q node address
                                            	**type**\:   :py:class:`RemoteQNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__init__()

                                                self.yang_name = "remote-lfa"
                                                self.yang_parent_name = "routing"

                                                self.has_q_node = YLeaf(YType.boolean, "has-q-node")

                                                self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                self.needs_tldp = YLeaf(YType.boolean, "needs-tldp")

                                                self.remote_p_node_id = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                self.remote_p_node_id.parent = self
                                                self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                self._children_yang_names.add("remote-p-node-id")

                                                self.remote_q_node_id = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                self.remote_q_node_id.parent = self
                                                self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                self._children_yang_names.add("remote-q-node-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("has_q_node",
                                                                "has_remote_lfa_bkup",
                                                                "needs_tldp") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)


                                            class RemotePNodeId(Entity):
                                                """
                                                Remote/P node address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__init__()

                                                    self.yang_name = "remote-p-node-id"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-p-node-id" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class RemoteQNodeId(Entity):
                                                """
                                                Remote/Q node address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__init__()

                                                    self.yang_name = "remote-q-node-id"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-q-node-id" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.has_q_node.is_set or
                                                    self.has_remote_lfa_bkup.is_set or
                                                    self.needs_tldp.is_set or
                                                    (self.remote_p_node_id is not None and self.remote_p_node_id.has_data()) or
                                                    (self.remote_q_node_id is not None and self.remote_q_node_id.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.has_q_node.yfilter != YFilter.not_set or
                                                    self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                    self.needs_tldp.yfilter != YFilter.not_set or
                                                    (self.remote_p_node_id is not None and self.remote_p_node_id.has_operation()) or
                                                    (self.remote_q_node_id is not None and self.remote_q_node_id.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "remote-lfa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.has_q_node.is_set or self.has_q_node.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_q_node.get_name_leafdata())
                                                if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())
                                                if (self.needs_tldp.is_set or self.needs_tldp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.needs_tldp.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "remote-p-node-id"):
                                                    if (self.remote_p_node_id is None):
                                                        self.remote_p_node_id = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                        self.remote_p_node_id.parent = self
                                                        self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                    return self.remote_p_node_id

                                                if (child_yang_name == "remote-q-node-id"):
                                                    if (self.remote_q_node_id is None):
                                                        self.remote_q_node_id = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                        self.remote_q_node_id.parent = self
                                                        self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                    return self.remote_q_node_id

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "remote-p-node-id" or name == "remote-q-node-id" or name == "has-q-node" or name == "has-remote-lfa-bkup" or name == "needs-tldp"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "has-q-node"):
                                                    self.has_q_node = value
                                                    self.has_q_node.value_namespace = name_space
                                                    self.has_q_node.value_namespace_prefix = name_space_prefix
                                                if(value_path == "has-remote-lfa-bkup"):
                                                    self.has_remote_lfa_bkup = value
                                                    self.has_remote_lfa_bkup.value_namespace = name_space
                                                    self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix
                                                if(value_path == "needs-tldp"):
                                                    self.needs_tldp = value
                                                    self.needs_tldp.value_namespace = name_space
                                                    self.needs_tldp.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.bkup_path_id.is_set or
                                                self.flags.is_set or
                                                self.interface.is_set or
                                                self.interface_name.is_set or
                                                self.load_metric.is_set or
                                                self.next_hop_table_id.is_set or
                                                self.nexthop_id.is_set or
                                                self.nh_is_overriden.is_set or
                                                self.path_flags.is_set or
                                                self.path_id.is_set or
                                                (self.next_hop is not None and self.next_hop.has_data()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bkup_path_id.yfilter != YFilter.not_set or
                                                self.flags.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.load_metric.yfilter != YFilter.not_set or
                                                self.next_hop_table_id.yfilter != YFilter.not_set or
                                                self.nexthop_id.yfilter != YFilter.not_set or
                                                self.nh_is_overriden.yfilter != YFilter.not_set or
                                                self.path_flags.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                (self.next_hop is not None and self.next_hop.has_operation()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "routing" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bkup_path_id.is_set or self.bkup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bkup_path_id.get_name_leafdata())
                                            if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flags.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_metric.get_name_leafdata())
                                            if (self.next_hop_table_id.is_set or self.next_hop_table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_table_id.get_name_leafdata())
                                            if (self.nexthop_id.is_set or self.nexthop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nexthop_id.get_name_leafdata())
                                            if (self.nh_is_overriden.is_set or self.nh_is_overriden.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nh_is_overriden.get_name_leafdata())
                                            if (self.path_flags.is_set or self.path_flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "next-hop"):
                                                if (self.next_hop is None):
                                                    self.next_hop = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                    self.next_hop.parent = self
                                                    self._children_name_map["next_hop"] = "next-hop"
                                                return self.next_hop

                                            if (child_yang_name == "remote-lfa"):
                                                if (self.remote_lfa is None):
                                                    self.remote_lfa = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                    self.remote_lfa.parent = self
                                                    self._children_name_map["remote_lfa"] = "remote-lfa"
                                                return self.remote_lfa

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "next-hop" or name == "remote-lfa" or name == "bkup-path-id" or name == "flags" or name == "interface" or name == "interface-name" or name == "load-metric" or name == "next-hop-table-id" or name == "nexthop-id" or name == "nh-is-overriden" or name == "path-flags" or name == "path-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bkup-path-id"):
                                                self.bkup_path_id = value
                                                self.bkup_path_id.value_namespace = name_space
                                                self.bkup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "flags"):
                                                self.flags = value
                                                self.flags.value_namespace = name_space
                                                self.flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-metric"):
                                                self.load_metric = value
                                                self.load_metric.value_namespace = name_space
                                                self.load_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-table-id"):
                                                self.next_hop_table_id = value
                                                self.next_hop_table_id.value_namespace = name_space
                                                self.next_hop_table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nexthop-id"):
                                                self.nexthop_id = value
                                                self.nexthop_id.value_namespace = name_space
                                                self.nexthop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nh-is-overriden"):
                                                self.nh_is_overriden = value
                                                self.nh_is_overriden.value_namespace = name_space
                                                self.nh_is_overriden.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags"):
                                                self.path_flags = value
                                                self.path_flags.value_namespace = name_space
                                                self.path_flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix


                                    class Mpls(Entity):
                                        """
                                        MPLS information
                                        
                                        .. attribute:: mpls_outgoing_info
                                        
                                        	MPLS nexthop info
                                        	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo>`
                                        
                                        .. attribute:: remote_lfa
                                        
                                        	Remote LFA\-FRR backup info
                                        	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls, self).__init__()

                                            self.yang_name = "mpls"
                                            self.yang_parent_name = "paths"

                                            self.mpls_outgoing_info = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                            self.mpls_outgoing_info.parent = self
                                            self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                            self._children_yang_names.add("mpls-outgoing-info")

                                            self.remote_lfa = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                            self.remote_lfa.parent = self
                                            self._children_name_map["remote_lfa"] = "remote-lfa"
                                            self._children_yang_names.add("remote-lfa")


                                        class MplsOutgoingInfo(Entity):
                                            """
                                            MPLS nexthop info
                                            
                                            .. attribute:: is_from_graceful_restartable_neighbor
                                            
                                            	Is from a GR neighbor
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_stale
                                            
                                            	Is the entry stale
                                            	**type**\:  bool
                                            
                                            .. attribute:: nexthop_peer_ldp_ident
                                            
                                            	Nexthop LDP peer
                                            	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent>`
                                            
                                            .. attribute:: out_label
                                            
                                            	Outgoing label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: out_label_owner
                                            
                                            	Outgoing label owner
                                            	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                            
                                            .. attribute:: out_label_rsn
                                            
                                            	Outgoing label reason
                                            	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                            
                                            .. attribute:: out_label_type
                                            
                                            	Outgoing Label Type
                                            	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__init__()

                                                self.yang_name = "mpls-outgoing-info"
                                                self.yang_parent_name = "mpls"

                                                self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                self.out_label = YLeaf(YType.uint32, "out-label")

                                                self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                self.nexthop_peer_ldp_ident.parent = self
                                                self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                self._children_yang_names.add("nexthop-peer-ldp-ident")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_from_graceful_restartable_neighbor",
                                                                "is_stale",
                                                                "out_label",
                                                                "out_label_owner",
                                                                "out_label_rsn",
                                                                "out_label_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)


                                            class NexthopPeerLdpIdent(Entity):
                                                """
                                                Nexthop LDP peer
                                                
                                                .. attribute:: label_space_id
                                                
                                                	Label space identifier
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: ldp_id
                                                
                                                	LDP identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: lsr_id
                                                
                                                	LSR identifier
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__init__()

                                                    self.yang_name = "nexthop-peer-ldp-ident"
                                                    self.yang_parent_name = "mpls-outgoing-info"

                                                    self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                    self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("label_space_id",
                                                                    "ldp_id",
                                                                    "lsr_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.label_space_id.is_set or
                                                        self.ldp_id.is_set or
                                                        self.lsr_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.label_space_id.yfilter != YFilter.not_set or
                                                        self.ldp_id.yfilter != YFilter.not_set or
                                                        self.lsr_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                    if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "label-space-id"):
                                                        self.label_space_id = value
                                                        self.label_space_id.value_namespace = name_space
                                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ldp-id"):
                                                        self.ldp_id = value
                                                        self.ldp_id.value_namespace = name_space
                                                        self.ldp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsr-id"):
                                                        self.lsr_id = value
                                                        self.lsr_id.value_namespace = name_space
                                                        self.lsr_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.is_from_graceful_restartable_neighbor.is_set or
                                                    self.is_stale.is_set or
                                                    self.out_label.is_set or
                                                    self.out_label_owner.is_set or
                                                    self.out_label_rsn.is_set or
                                                    self.out_label_type.is_set or
                                                    (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                    self.is_stale.yfilter != YFilter.not_set or
                                                    self.out_label.yfilter != YFilter.not_set or
                                                    self.out_label_owner.yfilter != YFilter.not_set or
                                                    self.out_label_rsn.yfilter != YFilter.not_set or
                                                    self.out_label_type.yfilter != YFilter.not_set or
                                                    (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls-outgoing-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                                if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                    if (self.nexthop_peer_ldp_ident is None):
                                                        self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                        self.nexthop_peer_ldp_ident.parent = self
                                                        self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                    return self.nexthop_peer_ldp_ident

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-from-graceful-restartable-neighbor"):
                                                    self.is_from_graceful_restartable_neighbor = value
                                                    self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                    self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-stale"):
                                                    self.is_stale = value
                                                    self.is_stale.value_namespace = name_space
                                                    self.is_stale.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label"):
                                                    self.out_label = value
                                                    self.out_label.value_namespace = name_space
                                                    self.out_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-owner"):
                                                    self.out_label_owner = value
                                                    self.out_label_owner.value_namespace = name_space
                                                    self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-rsn"):
                                                    self.out_label_rsn = value
                                                    self.out_label_rsn.value_namespace = name_space
                                                    self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-type"):
                                                    self.out_label_type = value
                                                    self.out_label_type.value_namespace = name_space
                                                    self.out_label_type.value_namespace_prefix = name_space_prefix


                                        class RemoteLfa(Entity):
                                            """
                                            Remote LFA\-FRR backup info
                                            
                                            .. attribute:: has_remote_lfa_bkup
                                            
                                            	Whether path has remote LFA backup
                                            	**type**\:  bool
                                            
                                            .. attribute:: mpls_outgoing_info
                                            
                                            	Remote LFA MPLS nexthop(s\_ info
                                            	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__init__()

                                                self.yang_name = "remote-lfa"
                                                self.yang_parent_name = "mpls"

                                                self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                self.mpls_outgoing_info = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                self.mpls_outgoing_info.parent = self
                                                self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                self._children_yang_names.add("mpls-outgoing-info")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("has_remote_lfa_bkup") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)


                                            class MplsOutgoingInfo(Entity):
                                                """
                                                Remote LFA MPLS nexthop(s\_ info
                                                
                                                .. attribute:: stack
                                                
                                                	Inner label stack info
                                                	**type**\: list of    :py:class:`Stack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__init__()

                                                    self.yang_name = "mpls-outgoing-info"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.stack = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)


                                                class Stack(Entity):
                                                    """
                                                    Inner label stack info
                                                    
                                                    .. attribute:: is_from_graceful_restartable_neighbor
                                                    
                                                    	Is from a GR neighbor
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_stale
                                                    
                                                    	Is the entry stale
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: nexthop_peer_ldp_ident
                                                    
                                                    	Nexthop LDP peer
                                                    	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent>`
                                                    
                                                    .. attribute:: out_label
                                                    
                                                    	Outgoing label
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: out_label_owner
                                                    
                                                    	Outgoing label owner
                                                    	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                    
                                                    .. attribute:: out_label_rsn
                                                    
                                                    	Outgoing label reason
                                                    	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                    
                                                    .. attribute:: out_label_type
                                                    
                                                    	Outgoing Label Type
                                                    	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__init__()

                                                        self.yang_name = "stack"
                                                        self.yang_parent_name = "mpls-outgoing-info"

                                                        self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                                        self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                        self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                        self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                        self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                        self.nexthop_peer_ldp_ident.parent = self
                                                        self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                        self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("is_from_graceful_restartable_neighbor",
                                                                        "is_stale",
                                                                        "out_label",
                                                                        "out_label_owner",
                                                                        "out_label_rsn",
                                                                        "out_label_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)


                                                    class NexthopPeerLdpIdent(Entity):
                                                        """
                                                        Nexthop LDP peer
                                                        
                                                        .. attribute:: label_space_id
                                                        
                                                        	Label space identifier
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: ldp_id
                                                        
                                                        	LDP identifier
                                                        	**type**\:  str
                                                        
                                                        .. attribute:: lsr_id
                                                        
                                                        	LSR identifier
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-ldp-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__init__()

                                                            self.yang_name = "nexthop-peer-ldp-ident"
                                                            self.yang_parent_name = "stack"

                                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("label_space_id",
                                                                            "ldp_id",
                                                                            "lsr_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.label_space_id.is_set or
                                                                self.ldp_id.is_set or
                                                                self.lsr_id.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.label_space_id.yfilter != YFilter.not_set or
                                                                self.ldp_id.yfilter != YFilter.not_set or
                                                                self.lsr_id.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "label-space-id"):
                                                                self.label_space_id = value
                                                                self.label_space_id.value_namespace = name_space
                                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "ldp-id"):
                                                                self.ldp_id = value
                                                                self.ldp_id.value_namespace = name_space
                                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "lsr-id"):
                                                                self.lsr_id = value
                                                                self.lsr_id.value_namespace = name_space
                                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.is_from_graceful_restartable_neighbor.is_set or
                                                            self.is_stale.is_set or
                                                            self.out_label.is_set or
                                                            self.out_label_owner.is_set or
                                                            self.out_label_rsn.is_set or
                                                            self.out_label_type.is_set or
                                                            (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                            self.is_stale.yfilter != YFilter.not_set or
                                                            self.out_label.yfilter != YFilter.not_set or
                                                            self.out_label_owner.yfilter != YFilter.not_set or
                                                            self.out_label_rsn.yfilter != YFilter.not_set or
                                                            self.out_label_type.yfilter != YFilter.not_set or
                                                            (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "stack" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                                        if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                        if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                        if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                            if (self.nexthop_peer_ldp_ident is None):
                                                                self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                                self.nexthop_peer_ldp_ident.parent = self
                                                                self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                            return self.nexthop_peer_ldp_ident

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "is-from-graceful-restartable-neighbor"):
                                                            self.is_from_graceful_restartable_neighbor = value
                                                            self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                            self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-stale"):
                                                            self.is_stale = value
                                                            self.is_stale.value_namespace = name_space
                                                            self.is_stale.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label"):
                                                            self.out_label = value
                                                            self.out_label.value_namespace = name_space
                                                            self.out_label.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-owner"):
                                                            self.out_label_owner = value
                                                            self.out_label_owner.value_namespace = name_space
                                                            self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-rsn"):
                                                            self.out_label_rsn = value
                                                            self.out_label_rsn.value_namespace = name_space
                                                            self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-type"):
                                                            self.out_label_type = value
                                                            self.out_label_type.value_namespace = name_space
                                                            self.out_label_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.stack:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.stack:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mpls-outgoing-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "stack"):
                                                        for c in self.stack:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.stack.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "stack"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.has_remote_lfa_bkup.is_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "remote-lfa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mpls-outgoing-info"):
                                                    if (self.mpls_outgoing_info is None):
                                                        self.mpls_outgoing_info = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                        self.mpls_outgoing_info.parent = self
                                                        self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    return self.mpls_outgoing_info

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mpls-outgoing-info" or name == "has-remote-lfa-bkup"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "has-remote-lfa-bkup"):
                                                    self.has_remote_lfa_bkup = value
                                                    self.has_remote_lfa_bkup.value_namespace = name_space
                                                    self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mpls" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls-outgoing-info"):
                                                if (self.mpls_outgoing_info is None):
                                                    self.mpls_outgoing_info = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                    self.mpls_outgoing_info.parent = self
                                                    self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                return self.mpls_outgoing_info

                                            if (child_yang_name == "remote-lfa"):
                                                if (self.remote_lfa is None):
                                                    self.remote_lfa = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                    self.remote_lfa.parent = self
                                                    self._children_name_map["remote_lfa"] = "remote-lfa"
                                                return self.remote_lfa

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls-outgoing-info" or name == "remote-lfa"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.mpls is not None and self.mpls.has_data()) or
                                            (self.routing is not None and self.routing.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.mpls is not None and self.mpls.has_operation()) or
                                            (self.routing is not None and self.routing.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "paths" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mpls"):
                                            if (self.mpls is None):
                                                self.mpls = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                                self.mpls.parent = self
                                                self._children_name_map["mpls"] = "mpls"
                                            return self.mpls

                                        if (child_yang_name == "routing"):
                                            if (self.routing is None):
                                                self.routing = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                                self.routing.parent = self
                                                self._children_name_map["routing"] = "routing"
                                            return self.routing

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mpls" or name == "routing"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    for c in self.paths:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.table_id.is_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                        (self.route is not None and self.route.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.paths:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                        (self.route is not None and self.route.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwarding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "paths"):
                                        for c in self.paths:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.paths.append(c)
                                        return c

                                    if (child_yang_name == "prefix-xr"):
                                        if (self.prefix_xr is None):
                                            self.prefix_xr = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                            self.prefix_xr.parent = self
                                            self._children_name_map["prefix_xr"] = "prefix-xr"
                                        return self.prefix_xr

                                    if (child_yang_name == "route"):
                                        if (self.route is None):
                                            self.route = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route()
                                            self.route.parent = self
                                            self._children_name_map["route"] = "route"
                                        return self.route

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "paths" or name == "prefix-xr" or name == "route" or name == "vrf" or name == "prefix" or name == "prefix-length" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.forwarding:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.forwarding:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "forwardings" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "forwarding"):
                                    for c in self.forwarding:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings.Forwarding()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.forwarding.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "forwarding"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsAdvertiseSpec(Entity):
                            """
                            Advertisement Spec (ACL) for LDP Label
                            Infomation Base (LIB)
                            
                            .. attribute:: advt_acl
                            
                            	Advertisement ACLs
                            	**type**\: list of    :py:class:`AdvtAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl>`
                            
                            .. attribute:: allocation_acl
                            
                            	Local label Allocation filter
                            	**type**\:   :py:class:`AllocationAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__init__()

                                self.yang_name = "bindings-advertise-spec"
                                self.yang_parent_name = "af"

                                self.allocation_acl = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                self.allocation_acl.parent = self
                                self._children_name_map["allocation_acl"] = "allocation-acl"
                                self._children_yang_names.add("allocation-acl")

                                self.advt_acl = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)


                            class AllocationAcl(Entity):
                                """
                                Local label Allocation filter
                                
                                .. attribute:: has_acl
                                
                                	Has ACL filter?
                                	**type**\:  bool
                                
                                .. attribute:: is_host_route_only
                                
                                	Host\-routes only?
                                	**type**\:  bool
                                
                                .. attribute:: prefix_acl
                                
                                	Prefix ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__init__()

                                    self.yang_name = "allocation-acl"
                                    self.yang_parent_name = "bindings-advertise-spec"

                                    self.has_acl = YLeaf(YType.boolean, "has-acl")

                                    self.is_host_route_only = YLeaf(YType.boolean, "is-host-route-only")

                                    self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("has_acl",
                                                    "is_host_route_only",
                                                    "prefix_acl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.has_acl.is_set or
                                        self.is_host_route_only.is_set or
                                        self.prefix_acl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.has_acl.yfilter != YFilter.not_set or
                                        self.is_host_route_only.yfilter != YFilter.not_set or
                                        self.prefix_acl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "allocation-acl" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.has_acl.is_set or self.has_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_acl.get_name_leafdata())
                                    if (self.is_host_route_only.is_set or self.is_host_route_only.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_host_route_only.get_name_leafdata())
                                    if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "has-acl" or name == "is-host-route-only" or name == "prefix-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "has-acl"):
                                        self.has_acl = value
                                        self.has_acl.value_namespace = name_space
                                        self.has_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-host-route-only"):
                                        self.is_host_route_only = value
                                        self.is_host_route_only.value_namespace = name_space
                                        self.is_host_route_only.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-acl"):
                                        self.prefix_acl = value
                                        self.prefix_acl.value_namespace = name_space
                                        self.prefix_acl.value_namespace_prefix = name_space_prefix


                            class AdvtAcl(Entity):
                                """
                                Advertisement ACLs
                                
                                .. attribute:: peer_acl
                                
                                	Peer ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                .. attribute:: prefix_acl
                                
                                	Prefix ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__init__()

                                    self.yang_name = "advt-acl"
                                    self.yang_parent_name = "bindings-advertise-spec"

                                    self.peer_acl = YLeaf(YType.str, "peer-acl")

                                    self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("peer_acl",
                                                    "prefix_acl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.peer_acl.is_set or
                                        self.prefix_acl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.peer_acl.yfilter != YFilter.not_set or
                                        self.prefix_acl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "advt-acl" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.peer_acl.is_set or self.peer_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_acl.get_name_leafdata())
                                    if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "peer-acl" or name == "prefix-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "peer-acl"):
                                        self.peer_acl = value
                                        self.peer_acl.value_namespace = name_space
                                        self.peer_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-acl"):
                                        self.prefix_acl = value
                                        self.prefix_acl.value_namespace = name_space
                                        self.prefix_acl.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.advt_acl:
                                    if (c.has_data()):
                                        return True
                                return (self.allocation_acl is not None and self.allocation_acl.has_data())

                            def has_operation(self):
                                for c in self.advt_acl:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.allocation_acl is not None and self.allocation_acl.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-advertise-spec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "advt-acl"):
                                    for c in self.advt_acl:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.advt_acl.append(c)
                                    return c

                                if (child_yang_name == "allocation-acl"):
                                    if (self.allocation_acl is None):
                                        self.allocation_acl = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                        self.allocation_acl.parent = self
                                        self._children_name_map["allocation_acl"] = "allocation-acl"
                                    return self.allocation_acl

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "advt-acl" or name == "allocation-acl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class ForwardingSummary(Entity):
                            """
                            Summary information regarding LDP forwarding
                            setup
                            
                            .. attribute:: fsht
                            
                            	Forwarding state hold time registered with LSD
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: intfs
                            
                            	MPLS forwarding enabled interface count
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: is_lsd_bound
                            
                            	LDP is connected to LSD server
                            	**type**\:  bool
                            
                            .. attribute:: lbls
                            
                            	Local label allocated count
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: rws
                            
                            	Forwarding rewrites summary
                            	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary, self).__init__()

                                self.yang_name = "forwarding-summary"
                                self.yang_parent_name = "af"

                                self.fsht = YLeaf(YType.uint16, "fsht")

                                self.intfs = YLeaf(YType.uint16, "intfs")

                                self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                                self.lbls = YLeaf(YType.uint16, "lbls")

                                self.rws = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws()
                                self.rws.parent = self
                                self._children_name_map["rws"] = "rws"
                                self._children_yang_names.add("rws")

                                self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fsht",
                                                "intfs",
                                                "is_lsd_bound",
                                                "lbls") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "forwarding-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Rws(Entity):
                                """
                                Forwarding rewrites summary
                                
                                .. attribute:: nhs
                                
                                	Forwarding rewrites nexthops (paths) summary
                                	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs>`
                                
                                .. attribute:: pfxs
                                
                                	Forwarding rewrites prefix summary
                                	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws, self).__init__()

                                    self.yang_name = "rws"
                                    self.yang_parent_name = "forwarding-summary"

                                    self.nhs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                    self.nhs.parent = self
                                    self._children_name_map["nhs"] = "nhs"
                                    self._children_yang_names.add("nhs")

                                    self.pfxs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                    self.pfxs.parent = self
                                    self._children_name_map["pfxs"] = "pfxs"
                                    self._children_yang_names.add("pfxs")


                                class Pfxs(Entity):
                                    """
                                    Forwarding rewrites prefix summary
                                    
                                    .. attribute:: ecmp_pfxs
                                    
                                    	Count of prefixes with ECMP
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: labeled_pfxs_aggr
                                    
                                    	Labeled prefix count for all paths
                                    	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr>`
                                    
                                    .. attribute:: labeled_pfxs_backup
                                    
                                    	Labeled prefix count related to backup paths only
                                    	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup>`
                                    
                                    .. attribute:: labeled_pfxs_primary
                                    
                                    	Labeled prefix count related to primary paths only
                                    	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary>`
                                    
                                    .. attribute:: protected_pfxs
                                    
                                    	Count of FRR protected prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: total_pfxs
                                    
                                    	Total Prefix count
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__init__()

                                        self.yang_name = "pfxs"
                                        self.yang_parent_name = "rws"

                                        self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                                        self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                                        self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                                        self.labeled_pfxs_aggr = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                        self.labeled_pfxs_aggr.parent = self
                                        self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                        self._children_yang_names.add("labeled-pfxs-aggr")

                                        self.labeled_pfxs_backup = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                        self.labeled_pfxs_backup.parent = self
                                        self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                        self._children_yang_names.add("labeled-pfxs-backup")

                                        self.labeled_pfxs_primary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                        self.labeled_pfxs_primary.parent = self
                                        self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                        self._children_yang_names.add("labeled-pfxs-primary")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ecmp_pfxs",
                                                        "protected_pfxs",
                                                        "total_pfxs") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)


                                    class LabeledPfxsAggr(Entity):
                                        """
                                        Labeled prefix count for all paths
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                            self.yang_name = "labeled-pfxs-aggr"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-aggr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                    class LabeledPfxsPrimary(Entity):
                                        """
                                        Labeled prefix count related to primary paths
                                        only
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                            self.yang_name = "labeled-pfxs-primary"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-primary" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                    class LabeledPfxsBackup(Entity):
                                        """
                                        Labeled prefix count related to backup paths
                                        only
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                            self.yang_name = "labeled-pfxs-backup"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-backup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.ecmp_pfxs.is_set or
                                            self.protected_pfxs.is_set or
                                            self.total_pfxs.is_set or
                                            (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                            (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                            (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ecmp_pfxs.yfilter != YFilter.not_set or
                                            self.protected_pfxs.yfilter != YFilter.not_set or
                                            self.total_pfxs.yfilter != YFilter.not_set or
                                            (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                            (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                            (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pfxs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                                        if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                                        if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "labeled-pfxs-aggr"):
                                            if (self.labeled_pfxs_aggr is None):
                                                self.labeled_pfxs_aggr = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                                self.labeled_pfxs_aggr.parent = self
                                                self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                            return self.labeled_pfxs_aggr

                                        if (child_yang_name == "labeled-pfxs-backup"):
                                            if (self.labeled_pfxs_backup is None):
                                                self.labeled_pfxs_backup = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                                self.labeled_pfxs_backup.parent = self
                                                self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                            return self.labeled_pfxs_backup

                                        if (child_yang_name == "labeled-pfxs-primary"):
                                            if (self.labeled_pfxs_primary is None):
                                                self.labeled_pfxs_primary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                                self.labeled_pfxs_primary.parent = self
                                                self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                            return self.labeled_pfxs_primary

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ecmp-pfxs"):
                                            self.ecmp_pfxs = value
                                            self.ecmp_pfxs.value_namespace = name_space
                                            self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protected-pfxs"):
                                            self.protected_pfxs = value
                                            self.protected_pfxs.value_namespace = name_space
                                            self.protected_pfxs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-pfxs"):
                                            self.total_pfxs = value
                                            self.total_pfxs.value_namespace = name_space
                                            self.total_pfxs.value_namespace_prefix = name_space_prefix


                                class Nhs(Entity):
                                    """
                                    Forwarding rewrites nexthops (paths) summary
                                    
                                    .. attribute:: backup_paths
                                    
                                    	Count of non\-primary backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: labeled_backup_paths
                                    
                                    	Count of labeled backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: labeled_paths
                                    
                                    	Count of all labeled paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: protected_paths
                                    
                                    	Count of FRR protected paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: remote_backup_paths
                                    
                                    	Count of non\-primary remote backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_paths
                                    
                                    	Total path count
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__init__()

                                        self.yang_name = "nhs"
                                        self.yang_parent_name = "rws"

                                        self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                                        self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                                        self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                                        self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                                        self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                                        self.total_paths = YLeaf(YType.uint32, "total-paths")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_paths",
                                                        "labeled_backup_paths",
                                                        "labeled_paths",
                                                        "protected_paths",
                                                        "remote_backup_paths",
                                                        "total_paths") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_paths.is_set or
                                            self.labeled_backup_paths.is_set or
                                            self.labeled_paths.is_set or
                                            self.protected_paths.is_set or
                                            self.remote_backup_paths.is_set or
                                            self.total_paths.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_paths.yfilter != YFilter.not_set or
                                            self.labeled_backup_paths.yfilter != YFilter.not_set or
                                            self.labeled_paths.yfilter != YFilter.not_set or
                                            self.protected_paths.yfilter != YFilter.not_set or
                                            self.remote_backup_paths.yfilter != YFilter.not_set or
                                            self.total_paths.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nhs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_paths.get_name_leafdata())
                                        if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                                        if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                                        if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protected_paths.get_name_leafdata())
                                        if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                                        if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_paths.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-paths"):
                                            self.backup_paths = value
                                            self.backup_paths.value_namespace = name_space
                                            self.backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "labeled-backup-paths"):
                                            self.labeled_backup_paths = value
                                            self.labeled_backup_paths.value_namespace = name_space
                                            self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "labeled-paths"):
                                            self.labeled_paths = value
                                            self.labeled_paths.value_namespace = name_space
                                            self.labeled_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protected-paths"):
                                            self.protected_paths = value
                                            self.protected_paths.value_namespace = name_space
                                            self.protected_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-backup-paths"):
                                            self.remote_backup_paths = value
                                            self.remote_backup_paths.value_namespace = name_space
                                            self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-paths"):
                                            self.total_paths = value
                                            self.total_paths.value_namespace = name_space
                                            self.total_paths.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.nhs is not None and self.nhs.has_data()) or
                                        (self.pfxs is not None and self.pfxs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.nhs is not None and self.nhs.has_operation()) or
                                        (self.pfxs is not None and self.pfxs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "rws" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "nhs"):
                                        if (self.nhs is None):
                                            self.nhs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                            self.nhs.parent = self
                                            self._children_name_map["nhs"] = "nhs"
                                        return self.nhs

                                    if (child_yang_name == "pfxs"):
                                        if (self.pfxs is None):
                                            self.pfxs = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                            self.pfxs.parent = self
                                            self._children_name_map["pfxs"] = "pfxs"
                                        return self.pfxs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nhs" or name == "pfxs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.fsht.is_set or
                                    self.intfs.is_set or
                                    self.is_lsd_bound.is_set or
                                    self.lbls.is_set or
                                    (self.rws is not None and self.rws.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fsht.yfilter != YFilter.not_set or
                                    self.intfs.yfilter != YFilter.not_set or
                                    self.is_lsd_bound.yfilter != YFilter.not_set or
                                    self.lbls.yfilter != YFilter.not_set or
                                    (self.rws is not None and self.rws.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "forwarding-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fsht.get_name_leafdata())
                                if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intfs.get_name_leafdata())
                                if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                                if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lbls.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "rws"):
                                    if (self.rws is None):
                                        self.rws = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Rws()
                                        self.rws.parent = self
                                        self._children_name_map["rws"] = "rws"
                                    return self.rws

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fsht"):
                                    self.fsht = value
                                    self.fsht.value_namespace = name_space
                                    self.fsht.value_namespace_prefix = name_space_prefix
                                if(value_path == "intfs"):
                                    self.intfs = value
                                    self.intfs.value_namespace = name_space
                                    self.intfs.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lsd-bound"):
                                    self.is_lsd_bound = value
                                    self.is_lsd_bound.value_namespace = name_space
                                    self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                                if(value_path == "lbls"):
                                    self.lbls = value
                                    self.lbls.value_namespace = name_space
                                    self.lbls.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.af_name.is_set or
                                (self.bindings is not None and self.bindings.has_data()) or
                                (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_data()) or
                                (self.bindings_summary is not None and self.bindings_summary.has_data()) or
                                (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                                (self.discovery is not None and self.discovery.has_data()) or
                                (self.forwarding_summary is not None and self.forwarding_summary.has_data()) or
                                (self.forwardings is not None and self.forwardings.has_data()) or
                                (self.igp is not None and self.igp.has_data()) or
                                (self.interface_summary is not None and self.interface_summary.has_data()) or
                                (self.interfaces is not None and self.interfaces.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.af_name.yfilter != YFilter.not_set or
                                (self.bindings is not None and self.bindings.has_operation()) or
                                (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_operation()) or
                                (self.bindings_summary is not None and self.bindings_summary.has_operation()) or
                                (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                                (self.discovery is not None and self.discovery.has_operation()) or
                                (self.forwarding_summary is not None and self.forwarding_summary.has_operation()) or
                                (self.forwardings is not None and self.forwardings.has_operation()) or
                                (self.igp is not None and self.igp.has_operation()) or
                                (self.interface_summary is not None and self.interface_summary.has_operation()) or
                                (self.interfaces is not None and self.interfaces.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "af" + "[af-name='" + self.af_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/afs/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.af_name.is_set or self.af_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.af_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bindings"):
                                if (self.bindings is None):
                                    self.bindings = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Bindings()
                                    self.bindings.parent = self
                                    self._children_name_map["bindings"] = "bindings"
                                return self.bindings

                            if (child_yang_name == "bindings-advertise-spec"):
                                if (self.bindings_advertise_spec is None):
                                    self.bindings_advertise_spec = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsAdvertiseSpec()
                                    self.bindings_advertise_spec.parent = self
                                    self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                return self.bindings_advertise_spec

                            if (child_yang_name == "bindings-summary"):
                                if (self.bindings_summary is None):
                                    self.bindings_summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummary()
                                    self.bindings_summary.parent = self
                                    self._children_name_map["bindings_summary"] = "bindings-summary"
                                return self.bindings_summary

                            if (child_yang_name == "bindings-summary-all"):
                                if (self.bindings_summary_all is None):
                                    self.bindings_summary_all = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.BindingsSummaryAll()
                                    self.bindings_summary_all.parent = self
                                    self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                return self.bindings_summary_all

                            if (child_yang_name == "discovery"):
                                if (self.discovery is None):
                                    self.discovery = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Discovery()
                                    self.discovery.parent = self
                                    self._children_name_map["discovery"] = "discovery"
                                return self.discovery

                            if (child_yang_name == "forwarding-summary"):
                                if (self.forwarding_summary is None):
                                    self.forwarding_summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.ForwardingSummary()
                                    self.forwarding_summary.parent = self
                                    self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                return self.forwarding_summary

                            if (child_yang_name == "forwardings"):
                                if (self.forwardings is None):
                                    self.forwardings = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Forwardings()
                                    self.forwardings.parent = self
                                    self._children_name_map["forwardings"] = "forwardings"
                                return self.forwardings

                            if (child_yang_name == "igp"):
                                if (self.igp is None):
                                    self.igp = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Igp()
                                    self.igp.parent = self
                                    self._children_name_map["igp"] = "igp"
                                return self.igp

                            if (child_yang_name == "interface-summary"):
                                if (self.interface_summary is None):
                                    self.interface_summary = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.InterfaceSummary()
                                    self.interface_summary.parent = self
                                    self._children_name_map["interface_summary"] = "interface-summary"
                                return self.interface_summary

                            if (child_yang_name == "interfaces"):
                                if (self.interfaces is None):
                                    self.interfaces = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af.Interfaces()
                                    self.interfaces.parent = self
                                    self._children_name_map["interfaces"] = "interfaces"
                                return self.interfaces

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bindings" or name == "bindings-advertise-spec" or name == "bindings-summary" or name == "bindings-summary-all" or name == "discovery" or name == "forwarding-summary" or name == "forwardings" or name == "igp" or name == "interface-summary" or name == "interfaces" or name == "af-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "af-name"):
                                self.af_name = value
                                self.af_name.value_namespace = name_space
                                self.af_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.af:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.af:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "afs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "af"):
                            for c in self.af:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.Afs.Af()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.af.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "af"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborBriefs(Entity):
                    """
                    The LDP Neighbors (brief)
                    
                    .. attribute:: neighbor_brief
                    
                    	Brief information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`NeighborBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs, self).__init__()

                        self.yang_name = "neighbor-briefs"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor_brief = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs, self).__setattr__(name, value)


                    class NeighborBrief(Entity):
                        """
                        Brief information on a particular LDP neighbor
                        
                        .. attribute:: is_graceful_restartable
                        
                        	Is graceful restartable
                        	**type**\:  bool
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: nbr_br_af_info
                        
                        	Neighbor Brief AF Info
                        	**type**\: list of    :py:class:`NbrBrAfInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo>`
                        
                        .. attribute:: nsr_state
                        
                        	NSR readiness state
                        	**type**\:   :py:class:`ShowNsrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.ShowNsrState>`
                        
                        .. attribute:: up_time_seconds
                        
                        	Up time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief, self).__init__()

                            self.yang_name = "neighbor-brief"
                            self.yang_parent_name = "neighbor-briefs"

                            self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.nsr_state = YLeaf(YType.enumeration, "nsr-state")

                            self.up_time_seconds = YLeaf(YType.uint32, "up-time-seconds")

                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")

                            self.nbr_br_af_info = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_graceful_restartable",
                                            "label_space_id",
                                            "lsr_id",
                                            "nsr_state",
                                            "up_time_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "neighbor-brief"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbor-briefs/neighbor-brief/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class NbrBrAfInfo(Entity):
                            """
                            Neighbor Brief AF Info
                            
                            .. attribute:: address_family
                            
                            	Neighbor Brief Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: num_of_nbr_addresses
                            
                            	Number of neighbor addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: num_of_nbr_discovery
                            
                            	Number of neighbor discovery sources
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: num_of_nbr_lbl
                            
                            	Number of neighbor labels
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__init__()

                                self.yang_name = "nbr-br-af-info"
                                self.yang_parent_name = "neighbor-brief"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.num_of_nbr_addresses = YLeaf(YType.uint32, "num-of-nbr-addresses")

                                self.num_of_nbr_discovery = YLeaf(YType.uint32, "num-of-nbr-discovery")

                                self.num_of_nbr_lbl = YLeaf(YType.uint32, "num-of-nbr-lbl")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "num_of_nbr_addresses",
                                                "num_of_nbr_discovery",
                                                "num_of_nbr_lbl") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.num_of_nbr_addresses.is_set or
                                    self.num_of_nbr_discovery.is_set or
                                    self.num_of_nbr_lbl.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.num_of_nbr_addresses.yfilter != YFilter.not_set or
                                    self.num_of_nbr_discovery.yfilter != YFilter.not_set or
                                    self.num_of_nbr_lbl.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nbr-br-af-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbor-briefs/neighbor-brief/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.num_of_nbr_addresses.is_set or self.num_of_nbr_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_addresses.get_name_leafdata())
                                if (self.num_of_nbr_discovery.is_set or self.num_of_nbr_discovery.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_discovery.get_name_leafdata())
                                if (self.num_of_nbr_lbl.is_set or self.num_of_nbr_lbl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_lbl.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-family" or name == "num-of-nbr-addresses" or name == "num-of-nbr-discovery" or name == "num-of-nbr-lbl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-addresses"):
                                    self.num_of_nbr_addresses = value
                                    self.num_of_nbr_addresses.value_namespace = name_space
                                    self.num_of_nbr_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-discovery"):
                                    self.num_of_nbr_discovery = value
                                    self.num_of_nbr_discovery.value_namespace = name_space
                                    self.num_of_nbr_discovery.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-lbl"):
                                    self.num_of_nbr_lbl = value
                                    self.num_of_nbr_lbl.value_namespace = name_space
                                    self.num_of_nbr_lbl.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nbr_br_af_info:
                                if (c.has_data()):
                                    return True
                            return (
                                self.is_graceful_restartable.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                self.nsr_state.is_set or
                                self.up_time_seconds.is_set or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            for c in self.nbr_br_af_info:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_graceful_restartable.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                self.nsr_state.yfilter != YFilter.not_set or
                                self.up_time_seconds.yfilter != YFilter.not_set or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-brief" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbor-briefs/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                            if (self.nsr_state.is_set or self.nsr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_state.get_name_leafdata())
                            if (self.up_time_seconds.is_set or self.up_time_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_time_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nbr-br-af-info"):
                                for c in self.nbr_br_af_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nbr_br_af_info.append(c)
                                return c

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nbr-br-af-info" or name == "vrf" or name == "is-graceful-restartable" or name == "label-space-id" or name == "lsr-id" or name == "nsr-state" or name == "up-time-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-graceful-restartable"):
                                self.is_graceful_restartable = value
                                self.is_graceful_restartable.value_namespace = name_space
                                self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-state"):
                                self.nsr_state = value
                                self.nsr_state.value_namespace = name_space
                                self.nsr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-time-seconds"):
                                self.up_time_seconds = value
                                self.up_time_seconds.value_namespace = name_space
                                self.up_time_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor_brief:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor_brief:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-briefs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor-brief"):
                            for c in self.neighbor_brief:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs.NeighborBrief()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor_brief.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor-brief"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class BackoffParameters(Entity):
                    """
                    The LDP Backoff Parameters
                    
                    .. attribute:: initial_seconds
                    
                    	Initial backoff value in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: maximum_seconds
                    
                    	Maximum backoff value in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.BackoffParameters, self).__init__()

                        self.yang_name = "backoff-parameters"
                        self.yang_parent_name = "default-vrf"

                        self.initial_seconds = YLeaf(YType.uint32, "initial-seconds")

                        self.maximum_seconds = YLeaf(YType.uint32, "maximum-seconds")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("initial_seconds",
                                        "maximum_seconds") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.BackoffParameters, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.BackoffParameters, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.initial_seconds.is_set or
                            self.maximum_seconds.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.initial_seconds.yfilter != YFilter.not_set or
                            self.maximum_seconds.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "backoff-parameters" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.initial_seconds.is_set or self.initial_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.initial_seconds.get_name_leafdata())
                        if (self.maximum_seconds.is_set or self.maximum_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_seconds.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "initial-seconds" or name == "maximum-seconds"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "initial-seconds"):
                            self.initial_seconds = value
                            self.initial_seconds.value_namespace = name_space
                            self.initial_seconds.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-seconds"):
                            self.maximum_seconds = value
                            self.maximum_seconds.value_namespace = name_space
                            self.maximum_seconds.value_namespace_prefix = name_space_prefix


                class Backoffs(Entity):
                    """
                    The LDP backoff
                    
                    .. attribute:: backoff
                    
                    	LDP Backoff Information
                    	**type**\: list of    :py:class:`Backoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Backoffs.Backoff>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Backoffs, self).__init__()

                        self.yang_name = "backoffs"
                        self.yang_parent_name = "default-vrf"

                        self.backoff = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Backoffs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.Backoffs, self).__setattr__(name, value)


                    class Backoff(Entity):
                        """
                        LDP Backoff Information
                        
                        .. attribute:: backoff_seconds
                        
                        	Backoff seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: waiting_seconds
                        
                        	Backoff waiting seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Backoffs.Backoff, self).__init__()

                            self.yang_name = "backoff"
                            self.yang_parent_name = "backoffs"

                            self.backoff_seconds = YLeaf(YType.uint32, "backoff-seconds")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.waiting_seconds = YLeaf(YType.uint32, "waiting-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backoff_seconds",
                                            "label_space_id",
                                            "lsr_id",
                                            "waiting_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Backoffs.Backoff, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Backoffs.Backoff, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backoff_seconds.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                self.waiting_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backoff_seconds.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                self.waiting_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoff" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/backoffs/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backoff_seconds.is_set or self.backoff_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backoff_seconds.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                            if (self.waiting_seconds.is_set or self.waiting_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.waiting_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff-seconds" or name == "label-space-id" or name == "lsr-id" or name == "waiting-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backoff-seconds"):
                                self.backoff_seconds = value
                                self.backoff_seconds.value_namespace = name_space
                                self.backoff_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "waiting-seconds"):
                                self.waiting_seconds = value
                                self.waiting_seconds.value_namespace = name_space
                                self.waiting_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.backoff:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.backoff:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "backoffs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "backoff"):
                            for c in self.backoff:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.Backoffs.Backoff()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.backoff.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "backoff"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Nsr(Entity):
                    """
                    LDP NSR related information
                    
                    .. attribute:: ha_statistics
                    
                    	LDP NSR Statistics related information
                    	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics>`
                    
                    .. attribute:: ha_summary
                    
                    	LDP HA Summary
                    	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary>`
                    
                    .. attribute:: nsr_pending
                    
                    	LDP NSR Pending related information
                    	**type**\:   :py:class:`NsrPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr, self).__init__()

                        self.yang_name = "nsr"
                        self.yang_parent_name = "default-vrf"

                        self.ha_statistics = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics()
                        self.ha_statistics.parent = self
                        self._children_name_map["ha_statistics"] = "ha-statistics"
                        self._children_yang_names.add("ha-statistics")

                        self.ha_summary = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary()
                        self.ha_summary.parent = self
                        self._children_name_map["ha_summary"] = "ha-summary"
                        self._children_yang_names.add("ha-summary")

                        self.nsr_pending = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending()
                        self.nsr_pending.parent = self
                        self._children_name_map["nsr_pending"] = "nsr-pending"
                        self._children_yang_names.add("nsr-pending")


                    class NsrPending(Entity):
                        """
                        LDP NSR Pending related information
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending, self).__init__()

                            self.yang_name = "nsr-pending"
                            self.yang_parent_name = "nsr"

                            self.ha_neighbors = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "nsr-pending"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/nsr-pending/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/nsr-pending/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/nsr-pending/ha-neighbors/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/nsr-pending/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (self.ha_neighbors is not None and self.ha_neighbors.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaSummary(Entity):
                        """
                        LDP HA Summary
                        
                        .. attribute:: sessions
                        
                        	Session summary
                        	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Sessions>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary, self).__init__()

                            self.yang_name = "ha-summary"
                            self.yang_parent_name = "nsr"

                            self.sessions = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                            self._children_yang_names.add("sessions")

                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "ha-summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Sessions(Entity):
                            """
                            Session summary
                            
                            .. attribute:: nsr_eligible
                            
                            	NSR eligible sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_app_wait
                            
                            	Number of sessions in NSR app\-wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_none
                            
                            	Number of sessions in NSR none state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_operational
                            
                            	Number of sessions in NSR operational state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_prepare
                            
                            	Number of sessions in NSR prepare state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_ready
                            
                            	Number of sessions in NSR ready state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase1
                            
                            	Number of sessions in NSR TCP phase 1 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase2
                            
                            	Number of sessions in NSR TCP phase 2 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_wait
                            
                            	Number of sessions in NSR wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total
                            
                            	Total sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Sessions, self).__init__()

                                self.yang_name = "sessions"
                                self.yang_parent_name = "ha-summary"

                                self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                self.total = YLeaf(YType.uint32, "total")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_eligible",
                                                "nsr_state_app_wait",
                                                "nsr_state_none",
                                                "nsr_state_operational",
                                                "nsr_state_prepare",
                                                "nsr_state_ready",
                                                "nsr_state_tcp_phase1",
                                                "nsr_state_tcp_phase2",
                                                "nsr_state_wait",
                                                "total") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_eligible.is_set or
                                    self.nsr_state_app_wait.is_set or
                                    self.nsr_state_none.is_set or
                                    self.nsr_state_operational.is_set or
                                    self.nsr_state_prepare.is_set or
                                    self.nsr_state_ready.is_set or
                                    self.nsr_state_tcp_phase1.is_set or
                                    self.nsr_state_tcp_phase2.is_set or
                                    self.nsr_state_wait.is_set or
                                    self.total.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_eligible.yfilter != YFilter.not_set or
                                    self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                    self.nsr_state_none.yfilter != YFilter.not_set or
                                    self.nsr_state_operational.yfilter != YFilter.not_set or
                                    self.nsr_state_prepare.yfilter != YFilter.not_set or
                                    self.nsr_state_ready.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                    self.nsr_state_wait.yfilter != YFilter.not_set or
                                    self.total.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sessions" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-eligible"):
                                    self.nsr_eligible = value
                                    self.nsr_eligible.value_namespace = name_space
                                    self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-app-wait"):
                                    self.nsr_state_app_wait = value
                                    self.nsr_state_app_wait.value_namespace = name_space
                                    self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-none"):
                                    self.nsr_state_none = value
                                    self.nsr_state_none.value_namespace = name_space
                                    self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-operational"):
                                    self.nsr_state_operational = value
                                    self.nsr_state_operational.value_namespace = name_space
                                    self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-prepare"):
                                    self.nsr_state_prepare = value
                                    self.nsr_state_prepare.value_namespace = name_space
                                    self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-ready"):
                                    self.nsr_state_ready = value
                                    self.nsr_state_ready.value_namespace = name_space
                                    self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase1"):
                                    self.nsr_state_tcp_phase1 = value
                                    self.nsr_state_tcp_phase1.value_namespace = name_space
                                    self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase2"):
                                    self.nsr_state_tcp_phase2 = value
                                    self.nsr_state_tcp_phase2.value_namespace = name_space
                                    self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-wait"):
                                    self.nsr_state_wait = value
                                    self.nsr_state_wait.value_namespace = name_space
                                    self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "total"):
                                    self.total = value
                                    self.total.value_namespace = name_space
                                    self.total.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.sessions is not None and self.sessions.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.sessions is not None and self.sessions.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sessions"):
                                if (self.sessions is None):
                                    self.sessions = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Sessions()
                                    self.sessions.parent = self
                                    self._children_name_map["sessions"] = "sessions"
                                return self.sessions

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sessions" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaStatistics(Entity):
                        """
                        LDP NSR Statistics related information
                        
                        .. attribute:: ha_global
                        
                        	LDP NSR Global Statistics information
                        	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal>`
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics, self).__init__()

                            self.yang_name = "ha-statistics"
                            self.yang_parent_name = "nsr"

                            self.ha_global = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal()
                            self.ha_global.parent = self
                            self._children_name_map["ha_global"] = "ha-global"
                            self._children_yang_names.add("ha-global")

                            self.ha_neighbors = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaGlobal(Entity):
                            """
                            LDP NSR Global Statistics information
                            
                            .. attribute:: init_sync
                            
                            	Init Sync
                            	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal, self).__init__()

                                self.yang_name = "ha-global"
                                self.yang_parent_name = "ha-statistics"

                                self.init_sync = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                self.init_sync.parent = self
                                self._children_name_map["init_sync"] = "init-sync"
                                self._children_yang_names.add("init-sync")


                            class InitSync(Entity):
                                """
                                Init Sync
                                
                                .. attribute:: init_sync_end
                                
                                	Init Sync End Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_sync_start
                                
                                	Init Sync Start Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_default_mtu
                                
                                	default IPC MTU bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_exceeded_mtu_msg_cnt
                                
                                	ipc exceeded mtu msg cnt
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_max_rx_batch_bytes
                                
                                	biggest IPC RX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_max_tx_batch_bytes
                                
                                	biggest IPC TX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_rx_bytes
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_rx_cnt
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_tx_bytes
                                
                                	total IPC bytes sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_tx_cnt
                                
                                	num IPC msgs sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_restart_cnt
                                
                                	number of times ipc has been restarted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_tx_fail_cnt
                                
                                	number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_cfged
                                
                                	TRUE if NSR configured
                                	**type**\:  bool
                                
                                .. attribute:: nsr_synced
                                
                                	TRUE if NSR synced
                                	**type**\:  bool
                                
                                .. attribute:: num_cap_rcvd
                                
                                	Number of Rcvd Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_cap_sent
                                
                                	Number of Sent Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl
                                
                                	Number of label bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl_adv
                                
                                	Num of lbl adv
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lcl_addr_wd
                                
                                	Num of lcl address withdraw
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_peers
                                
                                	Number of Peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_pfx
                                
                                	Number of binding prefixes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_ipc_tx_fail_cnt
                                
                                	total number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__init__()

                                    self.yang_name = "init-sync"
                                    self.yang_parent_name = "ha-global"

                                    self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                    self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                    self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                    self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                    self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                    self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                    self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                    self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                    self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                    self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                    self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                    self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                    self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                    self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                    self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                    self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                    self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                    self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                    self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                    self.num_peers = YLeaf(YType.uint32, "num-peers")

                                    self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                    self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("init_sync_end",
                                                    "init_sync_start",
                                                    "ipc_default_mtu",
                                                    "ipc_exceeded_mtu_msg_cnt",
                                                    "ipc_max_rx_batch_bytes",
                                                    "ipc_max_tx_batch_bytes",
                                                    "ipc_msg_rx_bytes",
                                                    "ipc_msg_rx_cnt",
                                                    "ipc_msg_tx_bytes",
                                                    "ipc_msg_tx_cnt",
                                                    "ipc_restart_cnt",
                                                    "ipc_tx_fail_cnt",
                                                    "nsr_cfged",
                                                    "nsr_synced",
                                                    "num_cap_rcvd",
                                                    "num_cap_sent",
                                                    "num_lbl",
                                                    "num_lbl_adv",
                                                    "num_lcl_addr_wd",
                                                    "num_peers",
                                                    "num_pfx",
                                                    "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.init_sync_end.is_set or
                                        self.init_sync_start.is_set or
                                        self.ipc_default_mtu.is_set or
                                        self.ipc_exceeded_mtu_msg_cnt.is_set or
                                        self.ipc_max_rx_batch_bytes.is_set or
                                        self.ipc_max_tx_batch_bytes.is_set or
                                        self.ipc_msg_rx_bytes.is_set or
                                        self.ipc_msg_rx_cnt.is_set or
                                        self.ipc_msg_tx_bytes.is_set or
                                        self.ipc_msg_tx_cnt.is_set or
                                        self.ipc_restart_cnt.is_set or
                                        self.ipc_tx_fail_cnt.is_set or
                                        self.nsr_cfged.is_set or
                                        self.nsr_synced.is_set or
                                        self.num_cap_rcvd.is_set or
                                        self.num_cap_sent.is_set or
                                        self.num_lbl.is_set or
                                        self.num_lbl_adv.is_set or
                                        self.num_lcl_addr_wd.is_set or
                                        self.num_peers.is_set or
                                        self.num_pfx.is_set or
                                        self.total_ipc_tx_fail_cnt.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.init_sync_end.yfilter != YFilter.not_set or
                                        self.init_sync_start.yfilter != YFilter.not_set or
                                        self.ipc_default_mtu.yfilter != YFilter.not_set or
                                        self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                        self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                        self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                        self.nsr_cfged.yfilter != YFilter.not_set or
                                        self.nsr_synced.yfilter != YFilter.not_set or
                                        self.num_cap_rcvd.yfilter != YFilter.not_set or
                                        self.num_cap_sent.yfilter != YFilter.not_set or
                                        self.num_lbl.yfilter != YFilter.not_set or
                                        self.num_lbl_adv.yfilter != YFilter.not_set or
                                        self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                        self.num_peers.yfilter != YFilter.not_set or
                                        self.num_pfx.yfilter != YFilter.not_set or
                                        self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "init-sync" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-statistics/ha-global/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                    if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                    if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                    if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                    if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                    if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                    if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                    if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                    if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                    if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                    if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                    if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                    if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                    if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                    if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                    if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_peers.get_name_leafdata())
                                    if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                    if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "init-sync-end"):
                                        self.init_sync_end = value
                                        self.init_sync_end.value_namespace = name_space
                                        self.init_sync_end.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-sync-start"):
                                        self.init_sync_start = value
                                        self.init_sync_start.value_namespace = name_space
                                        self.init_sync_start.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-default-mtu"):
                                        self.ipc_default_mtu = value
                                        self.ipc_default_mtu.value_namespace = name_space
                                        self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                        self.ipc_exceeded_mtu_msg_cnt = value
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-rx-batch-bytes"):
                                        self.ipc_max_rx_batch_bytes = value
                                        self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-tx-batch-bytes"):
                                        self.ipc_max_tx_batch_bytes = value
                                        self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-bytes"):
                                        self.ipc_msg_rx_bytes = value
                                        self.ipc_msg_rx_bytes.value_namespace = name_space
                                        self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-cnt"):
                                        self.ipc_msg_rx_cnt = value
                                        self.ipc_msg_rx_cnt.value_namespace = name_space
                                        self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-bytes"):
                                        self.ipc_msg_tx_bytes = value
                                        self.ipc_msg_tx_bytes.value_namespace = name_space
                                        self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-cnt"):
                                        self.ipc_msg_tx_cnt = value
                                        self.ipc_msg_tx_cnt.value_namespace = name_space
                                        self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-restart-cnt"):
                                        self.ipc_restart_cnt = value
                                        self.ipc_restart_cnt.value_namespace = name_space
                                        self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-tx-fail-cnt"):
                                        self.ipc_tx_fail_cnt = value
                                        self.ipc_tx_fail_cnt.value_namespace = name_space
                                        self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-cfged"):
                                        self.nsr_cfged = value
                                        self.nsr_cfged.value_namespace = name_space
                                        self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-synced"):
                                        self.nsr_synced = value
                                        self.nsr_synced.value_namespace = name_space
                                        self.nsr_synced.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-rcvd"):
                                        self.num_cap_rcvd = value
                                        self.num_cap_rcvd.value_namespace = name_space
                                        self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-sent"):
                                        self.num_cap_sent = value
                                        self.num_cap_sent.value_namespace = name_space
                                        self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl"):
                                        self.num_lbl = value
                                        self.num_lbl.value_namespace = name_space
                                        self.num_lbl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl-adv"):
                                        self.num_lbl_adv = value
                                        self.num_lbl_adv.value_namespace = name_space
                                        self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lcl-addr-wd"):
                                        self.num_lcl_addr_wd = value
                                        self.num_lcl_addr_wd.value_namespace = name_space
                                        self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-peers"):
                                        self.num_peers = value
                                        self.num_peers.value_namespace = name_space
                                        self.num_peers.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-pfx"):
                                        self.num_pfx = value
                                        self.num_pfx.value_namespace = name_space
                                        self.num_pfx.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-ipc-tx-fail-cnt"):
                                        self.total_ipc_tx_fail_cnt = value
                                        self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                        self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.init_sync is not None and self.init_sync.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.init_sync is not None and self.init_sync.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-global" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "init-sync"):
                                    if (self.init_sync is None):
                                        self.init_sync = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                        self.init_sync.parent = self
                                        self._children_name_map["init_sync"] = "init-sync"
                                    return self.init_sync

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "init-sync"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "ha-statistics"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-statistics/ha-neighbors/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_global is not None and self.ha_global.has_data()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_global is not None and self.ha_global.has_operation()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/nsr/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-global"):
                                if (self.ha_global is None):
                                    self.ha_global = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaGlobal()
                                    self.ha_global.parent = self
                                    self._children_name_map["ha_global"] = "ha-global"
                                return self.ha_global

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-global" or name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                            (self.ha_summary is not None and self.ha_summary.has_data()) or
                            (self.nsr_pending is not None and self.nsr_pending.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                            (self.ha_summary is not None and self.ha_summary.has_operation()) or
                            (self.nsr_pending is not None and self.nsr_pending.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "nsr" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ha-statistics"):
                            if (self.ha_statistics is None):
                                self.ha_statistics = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaStatistics()
                                self.ha_statistics.parent = self
                                self._children_name_map["ha_statistics"] = "ha-statistics"
                            return self.ha_statistics

                        if (child_yang_name == "ha-summary"):
                            if (self.ha_summary is None):
                                self.ha_summary = MplsLdp.Global_.Standby.DefaultVrf.Nsr.HaSummary()
                                self.ha_summary.parent = self
                                self._children_name_map["ha_summary"] = "ha-summary"
                            return self.ha_summary

                        if (child_yang_name == "nsr-pending"):
                            if (self.nsr_pending is None):
                                self.nsr_pending = MplsLdp.Global_.Standby.DefaultVrf.Nsr.NsrPending()
                                self.nsr_pending.parent = self
                                self._children_name_map["nsr_pending"] = "nsr-pending"
                            return self.nsr_pending

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ha-statistics" or name == "ha-summary" or name == "nsr-pending"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Parameters(Entity):
                    """
                    LDP parameters
                    
                    .. attribute:: address_family_parameter
                    
                    	Per AF parameters
                    	**type**\: list of    :py:class:`AddressFamilyParameter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter>`
                    
                    .. attribute:: af_binding_withdraw_delay
                    
                    	Delay (sec) in Binding Withdrawal for an Address Family
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: discovery_quick_start_disabled_on_interfaces
                    
                    	Discovery quick\-start disabled on some LDP\-enabled interfaces
                    	**type**\:  bool
                    
                    .. attribute:: global_discovery_quick_start_disabled
                    
                    	Discovery quick\-start globally disabled
                    	**type**\:  bool
                    
                    .. attribute:: global_md5_password_enabled
                    
                    	Global MD5 password enabled
                    	**type**\:  bool
                    
                    .. attribute:: graceful_restart_information
                    
                    	Graceful restart information
                    	**type**\:   :py:class:`GracefulRestartInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Parameters.GracefulRestartInformation>`
                    
                    .. attribute:: hello_hold_time
                    
                    	Hello hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hello_interval
                    
                    	Hello interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: housekeeping_timer_interval
                    
                    	Housekeeping periodic timer interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp_sync_delay_time_for_interface
                    
                    	Interface IGP sync delay time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: igp_sync_delay_time_on_restart
                    
                    	IGP sync delay time on process restart in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: keepalive_interval
                    
                    	Keepalive interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ldp_out_of_mem_state
                    
                    	LDP Out of memory state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ldp_recovery_timeout
                    
                    	LDP recovery timeout with LSD
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: le_no_route_timeout
                    
                    	LIB entry no route timeout
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_intf_attached
                    
                    	Maximum number of LDP enabled attached interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_intf_te
                    
                    	Maximum number of LDP enabled TE interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_peer
                    
                    	Maximum number of LDP peers
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_enabled
                    
                    	TRUE if NSR is enabled
                    	**type**\:  bool
                    
                    .. attribute:: nsr_synced
                    
                    	TRUE if LDP is standby and is NSR Sync\-ed with active
                    	**type**\:  bool
                    
                    .. attribute:: protocol_version
                    
                    	Protocol version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: role_is_active
                    
                    	Is process role active or standby
                    	**type**\:  bool
                    
                    .. attribute:: router_id
                    
                    	Router ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: session_hold_time
                    
                    	Session hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: targeted_hello_hold_time
                    
                    	Targeted hello hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: targeted_hello_interval
                    
                    	Targeted hello interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Parameters, self).__init__()

                        self.yang_name = "parameters"
                        self.yang_parent_name = "default-vrf"

                        self.af_binding_withdraw_delay = YLeaf(YType.uint32, "af-binding-withdraw-delay")

                        self.discovery_quick_start_disabled_on_interfaces = YLeaf(YType.boolean, "discovery-quick-start-disabled-on-interfaces")

                        self.global_discovery_quick_start_disabled = YLeaf(YType.boolean, "global-discovery-quick-start-disabled")

                        self.global_md5_password_enabled = YLeaf(YType.boolean, "global-md5-password-enabled")

                        self.hello_hold_time = YLeaf(YType.uint32, "hello-hold-time")

                        self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                        self.housekeeping_timer_interval = YLeaf(YType.uint32, "housekeeping-timer-interval")

                        self.igp_sync_delay_time_for_interface = YLeaf(YType.uint32, "igp-sync-delay-time-for-interface")

                        self.igp_sync_delay_time_on_restart = YLeaf(YType.uint32, "igp-sync-delay-time-on-restart")

                        self.keepalive_interval = YLeaf(YType.uint32, "keepalive-interval")

                        self.ldp_out_of_mem_state = YLeaf(YType.uint32, "ldp-out-of-mem-state")

                        self.ldp_recovery_timeout = YLeaf(YType.uint32, "ldp-recovery-timeout")

                        self.le_no_route_timeout = YLeaf(YType.uint32, "le-no-route-timeout")

                        self.max_intf_attached = YLeaf(YType.uint32, "max-intf-attached")

                        self.max_intf_te = YLeaf(YType.uint32, "max-intf-te")

                        self.max_peer = YLeaf(YType.uint32, "max-peer")

                        self.nsr_enabled = YLeaf(YType.boolean, "nsr-enabled")

                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                        self.protocol_version = YLeaf(YType.uint32, "protocol-version")

                        self.role_is_active = YLeaf(YType.boolean, "role-is-active")

                        self.router_id = YLeaf(YType.str, "router-id")

                        self.session_hold_time = YLeaf(YType.uint32, "session-hold-time")

                        self.targeted_hello_hold_time = YLeaf(YType.uint32, "targeted-hello-hold-time")

                        self.targeted_hello_interval = YLeaf(YType.uint32, "targeted-hello-interval")

                        self.graceful_restart_information = MplsLdp.Global_.Standby.DefaultVrf.Parameters.GracefulRestartInformation()
                        self.graceful_restart_information.parent = self
                        self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                        self._children_yang_names.add("graceful-restart-information")

                        self.address_family_parameter = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("af_binding_withdraw_delay",
                                        "discovery_quick_start_disabled_on_interfaces",
                                        "global_discovery_quick_start_disabled",
                                        "global_md5_password_enabled",
                                        "hello_hold_time",
                                        "hello_interval",
                                        "housekeeping_timer_interval",
                                        "igp_sync_delay_time_for_interface",
                                        "igp_sync_delay_time_on_restart",
                                        "keepalive_interval",
                                        "ldp_out_of_mem_state",
                                        "ldp_recovery_timeout",
                                        "le_no_route_timeout",
                                        "max_intf_attached",
                                        "max_intf_te",
                                        "max_peer",
                                        "nsr_enabled",
                                        "nsr_synced",
                                        "protocol_version",
                                        "role_is_active",
                                        "router_id",
                                        "session_hold_time",
                                        "targeted_hello_hold_time",
                                        "targeted_hello_interval") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Parameters, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.Parameters, self).__setattr__(name, value)


                    class GracefulRestartInformation(Entity):
                        """
                        Graceful restart information
                        
                        .. attribute:: graceful_restart_forwarding_state_hold_time
                        
                        	Graceful restart forward state hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: graceful_restart_reconnect_timeout
                        
                        	Reconnect timeout value
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_graceful_restart_configured
                        
                        	Is graceful restart configured
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.GracefulRestartInformation, self).__init__()

                            self.yang_name = "graceful-restart-information"
                            self.yang_parent_name = "parameters"

                            self.graceful_restart_forwarding_state_hold_time = YLeaf(YType.uint32, "graceful-restart-forwarding-state-hold-time")

                            self.graceful_restart_reconnect_timeout = YLeaf(YType.uint32, "graceful-restart-reconnect-timeout")

                            self.is_graceful_restart_configured = YLeaf(YType.boolean, "is-graceful-restart-configured")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("graceful_restart_forwarding_state_hold_time",
                                            "graceful_restart_reconnect_timeout",
                                            "is_graceful_restart_configured") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.graceful_restart_forwarding_state_hold_time.is_set or
                                self.graceful_restart_reconnect_timeout.is_set or
                                self.is_graceful_restart_configured.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set or
                                self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set or
                                self.is_graceful_restart_configured.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restart-information" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/parameters/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.graceful_restart_forwarding_state_hold_time.is_set or self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.graceful_restart_forwarding_state_hold_time.get_name_leafdata())
                            if (self.graceful_restart_reconnect_timeout.is_set or self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.graceful_restart_reconnect_timeout.get_name_leafdata())
                            if (self.is_graceful_restart_configured.is_set or self.is_graceful_restart_configured.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_graceful_restart_configured.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "graceful-restart-forwarding-state-hold-time" or name == "graceful-restart-reconnect-timeout" or name == "is-graceful-restart-configured"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "graceful-restart-forwarding-state-hold-time"):
                                self.graceful_restart_forwarding_state_hold_time = value
                                self.graceful_restart_forwarding_state_hold_time.value_namespace = name_space
                                self.graceful_restart_forwarding_state_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "graceful-restart-reconnect-timeout"):
                                self.graceful_restart_reconnect_timeout = value
                                self.graceful_restart_reconnect_timeout.value_namespace = name_space
                                self.graceful_restart_reconnect_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-graceful-restart-configured"):
                                self.is_graceful_restart_configured = value
                                self.is_graceful_restart_configured.value_namespace = name_space
                                self.is_graceful_restart_configured.value_namespace_prefix = name_space_prefix


                    class AddressFamilyParameter(Entity):
                        """
                        Per AF parameters
                        
                        .. attribute:: address_family
                        
                        	Address Family
                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                        
                        .. attribute:: discovery_transport_address
                        
                        	Discovery transport address
                        	**type**\:   :py:class:`DiscoveryTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress>`
                        
                        .. attribute:: is_accepting_targeted_hellos
                        
                        	Accepting targeted Hellos
                        	**type**\:  bool
                        
                        .. attribute:: label_imp_null_override_acl
                        
                        	ACL to override local label to use implicit\-null
                        	**type**\:  str
                        
                        .. attribute:: null_label
                        
                        	Null label
                        	**type**\:  str
                        
                        .. attribute:: targeted_hello_acl
                        
                        	Targeted Hello ACL
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter, self).__init__()

                            self.yang_name = "address-family-parameter"
                            self.yang_parent_name = "parameters"

                            self.address_family = YLeaf(YType.enumeration, "address-family")

                            self.is_accepting_targeted_hellos = YLeaf(YType.boolean, "is-accepting-targeted-hellos")

                            self.label_imp_null_override_acl = YLeaf(YType.str, "label-imp-null-override-acl")

                            self.null_label = YLeaf(YType.str, "null-label")

                            self.targeted_hello_acl = YLeaf(YType.str, "targeted-hello-acl")

                            self.discovery_transport_address = MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                            self.discovery_transport_address.parent = self
                            self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                            self._children_yang_names.add("discovery-transport-address")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("address_family",
                                            "is_accepting_targeted_hellos",
                                            "label_imp_null_override_acl",
                                            "null_label",
                                            "targeted_hello_acl") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)


                        class DiscoveryTransportAddress(Entity):
                            """
                            Discovery transport address
                            
                            .. attribute:: afi
                            
                            	AFI
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: dummy
                            
                            	No Address
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: ipv4
                            
                            	IPv4 address type
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv6
                            
                            	IPv6 address type
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__init__()

                                self.yang_name = "discovery-transport-address"
                                self.yang_parent_name = "address-family-parameter"

                                self.afi = YLeaf(YType.enumeration, "afi")

                                self.dummy = YLeaf(YType.uint8, "dummy")

                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                self.ipv6 = YLeaf(YType.str, "ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("afi",
                                                "dummy",
                                                "ipv4",
                                                "ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.afi.is_set or
                                    self.dummy.is_set or
                                    self.ipv4.is_set or
                                    self.ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.afi.yfilter != YFilter.not_set or
                                    self.dummy.yfilter != YFilter.not_set or
                                    self.ipv4.yfilter != YFilter.not_set or
                                    self.ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovery-transport-address" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/parameters/address-family-parameter/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "afi"):
                                    self.afi = value
                                    self.afi.value_namespace = name_space
                                    self.afi.value_namespace_prefix = name_space_prefix
                                if(value_path == "dummy"):
                                    self.dummy = value
                                    self.dummy.value_namespace = name_space
                                    self.dummy.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv4"):
                                    self.ipv4 = value
                                    self.ipv4.value_namespace = name_space
                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv6"):
                                    self.ipv6 = value
                                    self.ipv6.value_namespace = name_space
                                    self.ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.address_family.is_set or
                                self.is_accepting_targeted_hellos.is_set or
                                self.label_imp_null_override_acl.is_set or
                                self.null_label.is_set or
                                self.targeted_hello_acl.is_set or
                                (self.discovery_transport_address is not None and self.discovery_transport_address.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.address_family.yfilter != YFilter.not_set or
                                self.is_accepting_targeted_hellos.yfilter != YFilter.not_set or
                                self.label_imp_null_override_acl.yfilter != YFilter.not_set or
                                self.null_label.yfilter != YFilter.not_set or
                                self.targeted_hello_acl.yfilter != YFilter.not_set or
                                (self.discovery_transport_address is not None and self.discovery_transport_address.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "address-family-parameter" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/parameters/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.address_family.get_name_leafdata())
                            if (self.is_accepting_targeted_hellos.is_set or self.is_accepting_targeted_hellos.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_accepting_targeted_hellos.get_name_leafdata())
                            if (self.label_imp_null_override_acl.is_set or self.label_imp_null_override_acl.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_imp_null_override_acl.get_name_leafdata())
                            if (self.null_label.is_set or self.null_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.null_label.get_name_leafdata())
                            if (self.targeted_hello_acl.is_set or self.targeted_hello_acl.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_acl.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "discovery-transport-address"):
                                if (self.discovery_transport_address is None):
                                    self.discovery_transport_address = MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                    self.discovery_transport_address.parent = self
                                    self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                return self.discovery_transport_address

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "discovery-transport-address" or name == "address-family" or name == "is-accepting-targeted-hellos" or name == "label-imp-null-override-acl" or name == "null-label" or name == "targeted-hello-acl"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "address-family"):
                                self.address_family = value
                                self.address_family.value_namespace = name_space
                                self.address_family.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-accepting-targeted-hellos"):
                                self.is_accepting_targeted_hellos = value
                                self.is_accepting_targeted_hellos.value_namespace = name_space
                                self.is_accepting_targeted_hellos.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-imp-null-override-acl"):
                                self.label_imp_null_override_acl = value
                                self.label_imp_null_override_acl.value_namespace = name_space
                                self.label_imp_null_override_acl.value_namespace_prefix = name_space_prefix
                            if(value_path == "null-label"):
                                self.null_label = value
                                self.null_label.value_namespace = name_space
                                self.null_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-acl"):
                                self.targeted_hello_acl = value
                                self.targeted_hello_acl.value_namespace = name_space
                                self.targeted_hello_acl.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.address_family_parameter:
                            if (c.has_data()):
                                return True
                        return (
                            self.af_binding_withdraw_delay.is_set or
                            self.discovery_quick_start_disabled_on_interfaces.is_set or
                            self.global_discovery_quick_start_disabled.is_set or
                            self.global_md5_password_enabled.is_set or
                            self.hello_hold_time.is_set or
                            self.hello_interval.is_set or
                            self.housekeeping_timer_interval.is_set or
                            self.igp_sync_delay_time_for_interface.is_set or
                            self.igp_sync_delay_time_on_restart.is_set or
                            self.keepalive_interval.is_set or
                            self.ldp_out_of_mem_state.is_set or
                            self.ldp_recovery_timeout.is_set or
                            self.le_no_route_timeout.is_set or
                            self.max_intf_attached.is_set or
                            self.max_intf_te.is_set or
                            self.max_peer.is_set or
                            self.nsr_enabled.is_set or
                            self.nsr_synced.is_set or
                            self.protocol_version.is_set or
                            self.role_is_active.is_set or
                            self.router_id.is_set or
                            self.session_hold_time.is_set or
                            self.targeted_hello_hold_time.is_set or
                            self.targeted_hello_interval.is_set or
                            (self.graceful_restart_information is not None and self.graceful_restart_information.has_data()))

                    def has_operation(self):
                        for c in self.address_family_parameter:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.af_binding_withdraw_delay.yfilter != YFilter.not_set or
                            self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set or
                            self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set or
                            self.global_md5_password_enabled.yfilter != YFilter.not_set or
                            self.hello_hold_time.yfilter != YFilter.not_set or
                            self.hello_interval.yfilter != YFilter.not_set or
                            self.housekeeping_timer_interval.yfilter != YFilter.not_set or
                            self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set or
                            self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set or
                            self.keepalive_interval.yfilter != YFilter.not_set or
                            self.ldp_out_of_mem_state.yfilter != YFilter.not_set or
                            self.ldp_recovery_timeout.yfilter != YFilter.not_set or
                            self.le_no_route_timeout.yfilter != YFilter.not_set or
                            self.max_intf_attached.yfilter != YFilter.not_set or
                            self.max_intf_te.yfilter != YFilter.not_set or
                            self.max_peer.yfilter != YFilter.not_set or
                            self.nsr_enabled.yfilter != YFilter.not_set or
                            self.nsr_synced.yfilter != YFilter.not_set or
                            self.protocol_version.yfilter != YFilter.not_set or
                            self.role_is_active.yfilter != YFilter.not_set or
                            self.router_id.yfilter != YFilter.not_set or
                            self.session_hold_time.yfilter != YFilter.not_set or
                            self.targeted_hello_hold_time.yfilter != YFilter.not_set or
                            self.targeted_hello_interval.yfilter != YFilter.not_set or
                            (self.graceful_restart_information is not None and self.graceful_restart_information.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "parameters" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.af_binding_withdraw_delay.is_set or self.af_binding_withdraw_delay.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.af_binding_withdraw_delay.get_name_leafdata())
                        if (self.discovery_quick_start_disabled_on_interfaces.is_set or self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.discovery_quick_start_disabled_on_interfaces.get_name_leafdata())
                        if (self.global_discovery_quick_start_disabled.is_set or self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_discovery_quick_start_disabled.get_name_leafdata())
                        if (self.global_md5_password_enabled.is_set or self.global_md5_password_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_md5_password_enabled.get_name_leafdata())
                        if (self.hello_hold_time.is_set or self.hello_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hello_hold_time.get_name_leafdata())
                        if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hello_interval.get_name_leafdata())
                        if (self.housekeeping_timer_interval.is_set or self.housekeeping_timer_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.housekeeping_timer_interval.get_name_leafdata())
                        if (self.igp_sync_delay_time_for_interface.is_set or self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_sync_delay_time_for_interface.get_name_leafdata())
                        if (self.igp_sync_delay_time_on_restart.is_set or self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_sync_delay_time_on_restart.get_name_leafdata())
                        if (self.keepalive_interval.is_set or self.keepalive_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.keepalive_interval.get_name_leafdata())
                        if (self.ldp_out_of_mem_state.is_set or self.ldp_out_of_mem_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_out_of_mem_state.get_name_leafdata())
                        if (self.ldp_recovery_timeout.is_set or self.ldp_recovery_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_recovery_timeout.get_name_leafdata())
                        if (self.le_no_route_timeout.is_set or self.le_no_route_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.le_no_route_timeout.get_name_leafdata())
                        if (self.max_intf_attached.is_set or self.max_intf_attached.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_intf_attached.get_name_leafdata())
                        if (self.max_intf_te.is_set or self.max_intf_te.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_intf_te.get_name_leafdata())
                        if (self.max_peer.is_set or self.max_peer.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_peer.get_name_leafdata())
                        if (self.nsr_enabled.is_set or self.nsr_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_enabled.get_name_leafdata())
                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                        if (self.protocol_version.is_set or self.protocol_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protocol_version.get_name_leafdata())
                        if (self.role_is_active.is_set or self.role_is_active.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role_is_active.get_name_leafdata())
                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.router_id.get_name_leafdata())
                        if (self.session_hold_time.is_set or self.session_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.session_hold_time.get_name_leafdata())
                        if (self.targeted_hello_hold_time.is_set or self.targeted_hello_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.targeted_hello_hold_time.get_name_leafdata())
                        if (self.targeted_hello_interval.is_set or self.targeted_hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.targeted_hello_interval.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "address-family-parameter"):
                            for c in self.address_family_parameter:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.Parameters.AddressFamilyParameter()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.address_family_parameter.append(c)
                            return c

                        if (child_yang_name == "graceful-restart-information"):
                            if (self.graceful_restart_information is None):
                                self.graceful_restart_information = MplsLdp.Global_.Standby.DefaultVrf.Parameters.GracefulRestartInformation()
                                self.graceful_restart_information.parent = self
                                self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                            return self.graceful_restart_information

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family-parameter" or name == "graceful-restart-information" or name == "af-binding-withdraw-delay" or name == "discovery-quick-start-disabled-on-interfaces" or name == "global-discovery-quick-start-disabled" or name == "global-md5-password-enabled" or name == "hello-hold-time" or name == "hello-interval" or name == "housekeeping-timer-interval" or name == "igp-sync-delay-time-for-interface" or name == "igp-sync-delay-time-on-restart" or name == "keepalive-interval" or name == "ldp-out-of-mem-state" or name == "ldp-recovery-timeout" or name == "le-no-route-timeout" or name == "max-intf-attached" or name == "max-intf-te" or name == "max-peer" or name == "nsr-enabled" or name == "nsr-synced" or name == "protocol-version" or name == "role-is-active" or name == "router-id" or name == "session-hold-time" or name == "targeted-hello-hold-time" or name == "targeted-hello-interval"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "af-binding-withdraw-delay"):
                            self.af_binding_withdraw_delay = value
                            self.af_binding_withdraw_delay.value_namespace = name_space
                            self.af_binding_withdraw_delay.value_namespace_prefix = name_space_prefix
                        if(value_path == "discovery-quick-start-disabled-on-interfaces"):
                            self.discovery_quick_start_disabled_on_interfaces = value
                            self.discovery_quick_start_disabled_on_interfaces.value_namespace = name_space
                            self.discovery_quick_start_disabled_on_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "global-discovery-quick-start-disabled"):
                            self.global_discovery_quick_start_disabled = value
                            self.global_discovery_quick_start_disabled.value_namespace = name_space
                            self.global_discovery_quick_start_disabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "global-md5-password-enabled"):
                            self.global_md5_password_enabled = value
                            self.global_md5_password_enabled.value_namespace = name_space
                            self.global_md5_password_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "hello-hold-time"):
                            self.hello_hold_time = value
                            self.hello_hold_time.value_namespace = name_space
                            self.hello_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "hello-interval"):
                            self.hello_interval = value
                            self.hello_interval.value_namespace = name_space
                            self.hello_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "housekeeping-timer-interval"):
                            self.housekeeping_timer_interval = value
                            self.housekeeping_timer_interval.value_namespace = name_space
                            self.housekeeping_timer_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-sync-delay-time-for-interface"):
                            self.igp_sync_delay_time_for_interface = value
                            self.igp_sync_delay_time_for_interface.value_namespace = name_space
                            self.igp_sync_delay_time_for_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-sync-delay-time-on-restart"):
                            self.igp_sync_delay_time_on_restart = value
                            self.igp_sync_delay_time_on_restart.value_namespace = name_space
                            self.igp_sync_delay_time_on_restart.value_namespace_prefix = name_space_prefix
                        if(value_path == "keepalive-interval"):
                            self.keepalive_interval = value
                            self.keepalive_interval.value_namespace = name_space
                            self.keepalive_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-out-of-mem-state"):
                            self.ldp_out_of_mem_state = value
                            self.ldp_out_of_mem_state.value_namespace = name_space
                            self.ldp_out_of_mem_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-recovery-timeout"):
                            self.ldp_recovery_timeout = value
                            self.ldp_recovery_timeout.value_namespace = name_space
                            self.ldp_recovery_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "le-no-route-timeout"):
                            self.le_no_route_timeout = value
                            self.le_no_route_timeout.value_namespace = name_space
                            self.le_no_route_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-intf-attached"):
                            self.max_intf_attached = value
                            self.max_intf_attached.value_namespace = name_space
                            self.max_intf_attached.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-intf-te"):
                            self.max_intf_te = value
                            self.max_intf_te.value_namespace = name_space
                            self.max_intf_te.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-peer"):
                            self.max_peer = value
                            self.max_peer.value_namespace = name_space
                            self.max_peer.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-enabled"):
                            self.nsr_enabled = value
                            self.nsr_enabled.value_namespace = name_space
                            self.nsr_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-synced"):
                            self.nsr_synced = value
                            self.nsr_synced.value_namespace = name_space
                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                        if(value_path == "protocol-version"):
                            self.protocol_version = value
                            self.protocol_version.value_namespace = name_space
                            self.protocol_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "role-is-active"):
                            self.role_is_active = value
                            self.role_is_active.value_namespace = name_space
                            self.role_is_active.value_namespace_prefix = name_space_prefix
                        if(value_path == "router-id"):
                            self.router_id = value
                            self.router_id.value_namespace = name_space
                            self.router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "session-hold-time"):
                            self.session_hold_time = value
                            self.session_hold_time.value_namespace = name_space
                            self.session_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "targeted-hello-hold-time"):
                            self.targeted_hello_hold_time = value
                            self.targeted_hello_hold_time.value_namespace = name_space
                            self.targeted_hello_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "targeted-hello-interval"):
                            self.targeted_hello_interval = value
                            self.targeted_hello_interval.value_namespace = name_space
                            self.targeted_hello_interval.value_namespace_prefix = name_space_prefix


                class Issu(Entity):
                    """
                    LDP ISSU related information
                    
                    .. attribute:: ha_statistics
                    
                    	LDP NSR Statistics related information
                    	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics>`
                    
                    .. attribute:: ha_summary
                    
                    	LDP HA Summary
                    	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Issu, self).__init__()

                        self.yang_name = "issu"
                        self.yang_parent_name = "default-vrf"

                        self.ha_statistics = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics()
                        self.ha_statistics.parent = self
                        self._children_name_map["ha_statistics"] = "ha-statistics"
                        self._children_yang_names.add("ha-statistics")

                        self.ha_summary = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary()
                        self.ha_summary.parent = self
                        self._children_name_map["ha_summary"] = "ha-summary"
                        self._children_yang_names.add("ha-summary")


                    class HaSummary(Entity):
                        """
                        LDP HA Summary
                        
                        .. attribute:: sessions
                        
                        	Session summary
                        	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Sessions>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary, self).__init__()

                            self.yang_name = "ha-summary"
                            self.yang_parent_name = "issu"

                            self.sessions = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                            self._children_yang_names.add("sessions")

                            self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "ha-summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Sessions(Entity):
                            """
                            Session summary
                            
                            .. attribute:: nsr_eligible
                            
                            	NSR eligible sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_app_wait
                            
                            	Number of sessions in NSR app\-wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_none
                            
                            	Number of sessions in NSR none state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_operational
                            
                            	Number of sessions in NSR operational state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_prepare
                            
                            	Number of sessions in NSR prepare state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_ready
                            
                            	Number of sessions in NSR ready state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase1
                            
                            	Number of sessions in NSR TCP phase 1 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase2
                            
                            	Number of sessions in NSR TCP phase 2 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_wait
                            
                            	Number of sessions in NSR wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total
                            
                            	Total sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Sessions, self).__init__()

                                self.yang_name = "sessions"
                                self.yang_parent_name = "ha-summary"

                                self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                self.total = YLeaf(YType.uint32, "total")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_eligible",
                                                "nsr_state_app_wait",
                                                "nsr_state_none",
                                                "nsr_state_operational",
                                                "nsr_state_prepare",
                                                "nsr_state_ready",
                                                "nsr_state_tcp_phase1",
                                                "nsr_state_tcp_phase2",
                                                "nsr_state_wait",
                                                "total") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_eligible.is_set or
                                    self.nsr_state_app_wait.is_set or
                                    self.nsr_state_none.is_set or
                                    self.nsr_state_operational.is_set or
                                    self.nsr_state_prepare.is_set or
                                    self.nsr_state_ready.is_set or
                                    self.nsr_state_tcp_phase1.is_set or
                                    self.nsr_state_tcp_phase2.is_set or
                                    self.nsr_state_wait.is_set or
                                    self.total.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_eligible.yfilter != YFilter.not_set or
                                    self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                    self.nsr_state_none.yfilter != YFilter.not_set or
                                    self.nsr_state_operational.yfilter != YFilter.not_set or
                                    self.nsr_state_prepare.yfilter != YFilter.not_set or
                                    self.nsr_state_ready.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                    self.nsr_state_wait.yfilter != YFilter.not_set or
                                    self.total.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sessions" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-eligible"):
                                    self.nsr_eligible = value
                                    self.nsr_eligible.value_namespace = name_space
                                    self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-app-wait"):
                                    self.nsr_state_app_wait = value
                                    self.nsr_state_app_wait.value_namespace = name_space
                                    self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-none"):
                                    self.nsr_state_none = value
                                    self.nsr_state_none.value_namespace = name_space
                                    self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-operational"):
                                    self.nsr_state_operational = value
                                    self.nsr_state_operational.value_namespace = name_space
                                    self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-prepare"):
                                    self.nsr_state_prepare = value
                                    self.nsr_state_prepare.value_namespace = name_space
                                    self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-ready"):
                                    self.nsr_state_ready = value
                                    self.nsr_state_ready.value_namespace = name_space
                                    self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase1"):
                                    self.nsr_state_tcp_phase1 = value
                                    self.nsr_state_tcp_phase1.value_namespace = name_space
                                    self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase2"):
                                    self.nsr_state_tcp_phase2 = value
                                    self.nsr_state_tcp_phase2.value_namespace = name_space
                                    self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-wait"):
                                    self.nsr_state_wait = value
                                    self.nsr_state_wait.value_namespace = name_space
                                    self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "total"):
                                    self.total = value
                                    self.total.value_namespace = name_space
                                    self.total.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.sessions is not None and self.sessions.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.sessions is not None and self.sessions.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sessions"):
                                if (self.sessions is None):
                                    self.sessions = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Sessions()
                                    self.sessions.parent = self
                                    self._children_name_map["sessions"] = "sessions"
                                return self.sessions

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sessions" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaStatistics(Entity):
                        """
                        LDP NSR Statistics related information
                        
                        .. attribute:: ha_global
                        
                        	LDP NSR Global Statistics information
                        	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal>`
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics, self).__init__()

                            self.yang_name = "ha-statistics"
                            self.yang_parent_name = "issu"

                            self.ha_global = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal()
                            self.ha_global.parent = self
                            self._children_name_map["ha_global"] = "ha-global"
                            self._children_yang_names.add("ha-global")

                            self.ha_neighbors = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaGlobal(Entity):
                            """
                            LDP NSR Global Statistics information
                            
                            .. attribute:: init_sync
                            
                            	Init Sync
                            	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal, self).__init__()

                                self.yang_name = "ha-global"
                                self.yang_parent_name = "ha-statistics"

                                self.init_sync = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync()
                                self.init_sync.parent = self
                                self._children_name_map["init_sync"] = "init-sync"
                                self._children_yang_names.add("init-sync")


                            class InitSync(Entity):
                                """
                                Init Sync
                                
                                .. attribute:: init_sync_end
                                
                                	Init Sync End Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_sync_start
                                
                                	Init Sync Start Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_default_mtu
                                
                                	default IPC MTU bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_exceeded_mtu_msg_cnt
                                
                                	ipc exceeded mtu msg cnt
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_max_rx_batch_bytes
                                
                                	biggest IPC RX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_max_tx_batch_bytes
                                
                                	biggest IPC TX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_rx_bytes
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_rx_cnt
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_tx_bytes
                                
                                	total IPC bytes sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_tx_cnt
                                
                                	num IPC msgs sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_restart_cnt
                                
                                	number of times ipc has been restarted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_tx_fail_cnt
                                
                                	number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_cfged
                                
                                	TRUE if NSR configured
                                	**type**\:  bool
                                
                                .. attribute:: nsr_synced
                                
                                	TRUE if NSR synced
                                	**type**\:  bool
                                
                                .. attribute:: num_cap_rcvd
                                
                                	Number of Rcvd Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_cap_sent
                                
                                	Number of Sent Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl
                                
                                	Number of label bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl_adv
                                
                                	Num of lbl adv
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lcl_addr_wd
                                
                                	Num of lcl address withdraw
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_peers
                                
                                	Number of Peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_pfx
                                
                                	Number of binding prefixes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_ipc_tx_fail_cnt
                                
                                	total number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__init__()

                                    self.yang_name = "init-sync"
                                    self.yang_parent_name = "ha-global"

                                    self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                    self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                    self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                    self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                    self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                    self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                    self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                    self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                    self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                    self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                    self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                    self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                    self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                    self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                    self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                    self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                    self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                    self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                    self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                    self.num_peers = YLeaf(YType.uint32, "num-peers")

                                    self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                    self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("init_sync_end",
                                                    "init_sync_start",
                                                    "ipc_default_mtu",
                                                    "ipc_exceeded_mtu_msg_cnt",
                                                    "ipc_max_rx_batch_bytes",
                                                    "ipc_max_tx_batch_bytes",
                                                    "ipc_msg_rx_bytes",
                                                    "ipc_msg_rx_cnt",
                                                    "ipc_msg_tx_bytes",
                                                    "ipc_msg_tx_cnt",
                                                    "ipc_restart_cnt",
                                                    "ipc_tx_fail_cnt",
                                                    "nsr_cfged",
                                                    "nsr_synced",
                                                    "num_cap_rcvd",
                                                    "num_cap_sent",
                                                    "num_lbl",
                                                    "num_lbl_adv",
                                                    "num_lcl_addr_wd",
                                                    "num_peers",
                                                    "num_pfx",
                                                    "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.init_sync_end.is_set or
                                        self.init_sync_start.is_set or
                                        self.ipc_default_mtu.is_set or
                                        self.ipc_exceeded_mtu_msg_cnt.is_set or
                                        self.ipc_max_rx_batch_bytes.is_set or
                                        self.ipc_max_tx_batch_bytes.is_set or
                                        self.ipc_msg_rx_bytes.is_set or
                                        self.ipc_msg_rx_cnt.is_set or
                                        self.ipc_msg_tx_bytes.is_set or
                                        self.ipc_msg_tx_cnt.is_set or
                                        self.ipc_restart_cnt.is_set or
                                        self.ipc_tx_fail_cnt.is_set or
                                        self.nsr_cfged.is_set or
                                        self.nsr_synced.is_set or
                                        self.num_cap_rcvd.is_set or
                                        self.num_cap_sent.is_set or
                                        self.num_lbl.is_set or
                                        self.num_lbl_adv.is_set or
                                        self.num_lcl_addr_wd.is_set or
                                        self.num_peers.is_set or
                                        self.num_pfx.is_set or
                                        self.total_ipc_tx_fail_cnt.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.init_sync_end.yfilter != YFilter.not_set or
                                        self.init_sync_start.yfilter != YFilter.not_set or
                                        self.ipc_default_mtu.yfilter != YFilter.not_set or
                                        self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                        self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                        self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                        self.nsr_cfged.yfilter != YFilter.not_set or
                                        self.nsr_synced.yfilter != YFilter.not_set or
                                        self.num_cap_rcvd.yfilter != YFilter.not_set or
                                        self.num_cap_sent.yfilter != YFilter.not_set or
                                        self.num_lbl.yfilter != YFilter.not_set or
                                        self.num_lbl_adv.yfilter != YFilter.not_set or
                                        self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                        self.num_peers.yfilter != YFilter.not_set or
                                        self.num_pfx.yfilter != YFilter.not_set or
                                        self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "init-sync" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-statistics/ha-global/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                    if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                    if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                    if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                    if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                    if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                    if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                    if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                    if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                    if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                    if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                    if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                    if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                    if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                    if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                    if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_peers.get_name_leafdata())
                                    if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                    if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "init-sync-end"):
                                        self.init_sync_end = value
                                        self.init_sync_end.value_namespace = name_space
                                        self.init_sync_end.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-sync-start"):
                                        self.init_sync_start = value
                                        self.init_sync_start.value_namespace = name_space
                                        self.init_sync_start.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-default-mtu"):
                                        self.ipc_default_mtu = value
                                        self.ipc_default_mtu.value_namespace = name_space
                                        self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                        self.ipc_exceeded_mtu_msg_cnt = value
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-rx-batch-bytes"):
                                        self.ipc_max_rx_batch_bytes = value
                                        self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-tx-batch-bytes"):
                                        self.ipc_max_tx_batch_bytes = value
                                        self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-bytes"):
                                        self.ipc_msg_rx_bytes = value
                                        self.ipc_msg_rx_bytes.value_namespace = name_space
                                        self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-cnt"):
                                        self.ipc_msg_rx_cnt = value
                                        self.ipc_msg_rx_cnt.value_namespace = name_space
                                        self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-bytes"):
                                        self.ipc_msg_tx_bytes = value
                                        self.ipc_msg_tx_bytes.value_namespace = name_space
                                        self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-cnt"):
                                        self.ipc_msg_tx_cnt = value
                                        self.ipc_msg_tx_cnt.value_namespace = name_space
                                        self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-restart-cnt"):
                                        self.ipc_restart_cnt = value
                                        self.ipc_restart_cnt.value_namespace = name_space
                                        self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-tx-fail-cnt"):
                                        self.ipc_tx_fail_cnt = value
                                        self.ipc_tx_fail_cnt.value_namespace = name_space
                                        self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-cfged"):
                                        self.nsr_cfged = value
                                        self.nsr_cfged.value_namespace = name_space
                                        self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-synced"):
                                        self.nsr_synced = value
                                        self.nsr_synced.value_namespace = name_space
                                        self.nsr_synced.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-rcvd"):
                                        self.num_cap_rcvd = value
                                        self.num_cap_rcvd.value_namespace = name_space
                                        self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-sent"):
                                        self.num_cap_sent = value
                                        self.num_cap_sent.value_namespace = name_space
                                        self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl"):
                                        self.num_lbl = value
                                        self.num_lbl.value_namespace = name_space
                                        self.num_lbl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl-adv"):
                                        self.num_lbl_adv = value
                                        self.num_lbl_adv.value_namespace = name_space
                                        self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lcl-addr-wd"):
                                        self.num_lcl_addr_wd = value
                                        self.num_lcl_addr_wd.value_namespace = name_space
                                        self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-peers"):
                                        self.num_peers = value
                                        self.num_peers.value_namespace = name_space
                                        self.num_peers.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-pfx"):
                                        self.num_pfx = value
                                        self.num_pfx.value_namespace = name_space
                                        self.num_pfx.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-ipc-tx-fail-cnt"):
                                        self.total_ipc_tx_fail_cnt = value
                                        self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                        self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.init_sync is not None and self.init_sync.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.init_sync is not None and self.init_sync.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-global" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "init-sync"):
                                    if (self.init_sync is None):
                                        self.init_sync = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync()
                                        self.init_sync.parent = self
                                        self._children_name_map["init_sync"] = "init-sync"
                                    return self.init_sync

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "init-sync"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "ha-statistics"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-statistics/ha-neighbors/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_global is not None and self.ha_global.has_data()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_global is not None and self.ha_global.has_operation()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/issu/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-global"):
                                if (self.ha_global is None):
                                    self.ha_global = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaGlobal()
                                    self.ha_global.parent = self
                                    self._children_name_map["ha_global"] = "ha-global"
                                return self.ha_global

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-global" or name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                            (self.ha_summary is not None and self.ha_summary.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                            (self.ha_summary is not None and self.ha_summary.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "issu" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ha-statistics"):
                            if (self.ha_statistics is None):
                                self.ha_statistics = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaStatistics()
                                self.ha_statistics.parent = self
                                self._children_name_map["ha_statistics"] = "ha-statistics"
                            return self.ha_statistics

                        if (child_yang_name == "ha-summary"):
                            if (self.ha_summary is None):
                                self.ha_summary = MplsLdp.Global_.Standby.DefaultVrf.Issu.HaSummary()
                                self.ha_summary.parent = self
                                self._children_name_map["ha_summary"] = "ha-summary"
                            return self.ha_summary

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ha-statistics" or name == "ha-summary"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborCapabilities(Entity):
                    """
                    LDP Neighbors Capabilities
                    
                    .. attribute:: neighbor_capability
                    
                    	Information on capabilities of a particular LDP neighbor
                    	**type**\: list of    :py:class:`NeighborCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities, self).__init__()

                        self.yang_name = "neighbor-capabilities"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities, self).__setattr__(name, value)


                    class NeighborCapability(Entity):
                        """
                        Information on capabilities of a particular LDP
                        neighbor
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: received
                        
                        	List of received capabilities
                        	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Received>`
                        
                        .. attribute:: sent
                        
                        	List of sent capabilities
                        	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__init__()

                            self.yang_name = "neighbor-capability"
                            self.yang_parent_name = "neighbor-capabilities"

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.received = YList(self)
                            self.sent = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)


                        class Sent(Entity):
                            """
                            List of sent capabilities
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__init__()

                                self.yang_name = "sent"
                                self.yang_parent_name = "neighbor-capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sent" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbor-capabilities/neighbor-capability/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix


                        class Received(Entity):
                            """
                            List of received capabilities
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__init__()

                                self.yang_name = "received"
                                self.yang_parent_name = "neighbor-capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "received" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbor-capabilities/neighbor-capability/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.received:
                                if (c.has_data()):
                                    return True
                            for c in self.sent:
                                if (c.has_data()):
                                    return True
                            return (
                                self.label_space_id.is_set or
                                self.lsr_id.is_set)

                        def has_operation(self):
                            for c in self.received:
                                if (c.has_operation()):
                                    return True
                            for c in self.sent:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbor-capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "received"):
                                for c in self.received:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Received()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.received.append(c)
                                return c

                            if (child_yang_name == "sent"):
                                for c in self.sent:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.sent.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "received" or name == "sent" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor-capability"):
                            for c in self.neighbor_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities.NeighborCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Neighbors(Entity):
                    """
                    The LDP Neighbors
                    
                    .. attribute:: neighbor
                    
                    	Information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors, self).__init__()

                        self.yang_name = "neighbors"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors, self).__setattr__(name, value)


                    class Neighbor(Entity):
                        """
                        Information on a particular LDP neighbor
                        
                        .. attribute:: detailed_information
                        
                        	Detailed information with regards to holdtime, KA, inbound filtering, and Session protection
                        	**type**\:   :py:class:`DetailedInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation>`
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: ldp_nbr_bound_ipv4_address_info
                        
                        	Neighbor IPv4 Address Info
                        	**type**\: list of    :py:class:`LdpNbrBoundIpv4AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo>`
                        
                        .. attribute:: ldp_nbr_bound_ipv6_address_info
                        
                        	Neighbor IPv6 Address Info
                        	**type**\: list of    :py:class:`LdpNbrBoundIpv6AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo>`
                        
                        .. attribute:: ldp_nbr_ipv4_adj_info
                        
                        	Neighbor's IPv4 Adjacency Information
                        	**type**\: list of    :py:class:`LdpNbrIpv4AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo>`
                        
                        .. attribute:: ldp_nbr_ipv6_adj_info
                        
                        	Neighbor's IPv6 Adjacency Information
                        	**type**\: list of    :py:class:`LdpNbrIpv6AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo>`
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: protocol_information
                        
                        	Protocol Information
                        	**type**\:   :py:class:`ProtocolInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation>`
                        
                        .. attribute:: tcp_information
                        
                        	TCP Information
                        	**type**\:   :py:class:`TcpInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor, self).__init__()

                            self.yang_name = "neighbor"
                            self.yang_parent_name = "neighbors"

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.detailed_information = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation()
                            self.detailed_information.parent = self
                            self._children_name_map["detailed_information"] = "detailed-information"
                            self._children_yang_names.add("detailed-information")

                            self.protocol_information = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation()
                            self.protocol_information.parent = self
                            self._children_name_map["protocol_information"] = "protocol-information"
                            self._children_yang_names.add("protocol-information")

                            self.tcp_information = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation()
                            self.tcp_information.parent = self
                            self._children_name_map["tcp_information"] = "tcp-information"
                            self._children_yang_names.add("tcp-information")

                            self.ldp_nbr_bound_ipv4_address_info = YList(self)
                            self.ldp_nbr_bound_ipv6_address_info = YList(self)
                            self.ldp_nbr_ipv4_adj_info = YList(self)
                            self.ldp_nbr_ipv6_adj_info = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor, self).__setattr__(name, value)


                        class ProtocolInformation(Entity):
                            """
                            Protocol Information
                            
                            .. attribute:: downstream_on_demand
                            
                            	Is Label advertisment mode in Downstream On Demand mode or Not
                            	**type**\:  bool
                            
                            .. attribute:: ta_graceful_restart_adjacency
                            
                            	Graceful restart information
                            	**type**\:   :py:class:`TaGracefulRestartAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency>`
                            
                            .. attribute:: ta_holdtime
                            
                            	Session holdtime in sec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_pies_rcvd
                            
                            	Number of pies received
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_pies_sent
                            
                            	Number of pies sent
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_state
                            
                            	State
                            	**type**\:  str
                            
                            .. attribute:: ta_up_time_seconds
                            
                            	Up time in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__init__()

                                self.yang_name = "protocol-information"
                                self.yang_parent_name = "neighbor"

                                self.downstream_on_demand = YLeaf(YType.boolean, "downstream-on-demand")

                                self.ta_holdtime = YLeaf(YType.uint32, "ta-holdtime")

                                self.ta_pies_rcvd = YLeaf(YType.uint32, "ta-pies-rcvd")

                                self.ta_pies_sent = YLeaf(YType.uint32, "ta-pies-sent")

                                self.ta_state = YLeaf(YType.str, "ta-state")

                                self.ta_up_time_seconds = YLeaf(YType.uint32, "ta-up-time-seconds")

                                self.ta_graceful_restart_adjacency = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                self.ta_graceful_restart_adjacency.parent = self
                                self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                self._children_yang_names.add("ta-graceful-restart-adjacency")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("downstream_on_demand",
                                                "ta_holdtime",
                                                "ta_pies_rcvd",
                                                "ta_pies_sent",
                                                "ta_state",
                                                "ta_up_time_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)


                            class TaGracefulRestartAdjacency(Entity):
                                """
                                Graceful restart information
                                
                                .. attribute:: is_graceful_restartable
                                
                                	Is graceful restartable
                                	**type**\:  bool
                                
                                .. attribute:: reconnect_timeout
                                
                                	Reconnect timeout
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: recovery_time
                                
                                	Recovery time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__init__()

                                    self.yang_name = "ta-graceful-restart-adjacency"
                                    self.yang_parent_name = "protocol-information"

                                    self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                    self.reconnect_timeout = YLeaf(YType.uint32, "reconnect-timeout")

                                    self.recovery_time = YLeaf(YType.uint32, "recovery-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_graceful_restartable",
                                                    "reconnect_timeout",
                                                    "recovery_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_graceful_restartable.is_set or
                                        self.reconnect_timeout.is_set or
                                        self.recovery_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_graceful_restartable.yfilter != YFilter.not_set or
                                        self.reconnect_timeout.yfilter != YFilter.not_set or
                                        self.recovery_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ta-graceful-restart-adjacency" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/protocol-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                    if (self.reconnect_timeout.is_set or self.reconnect_timeout.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reconnect_timeout.get_name_leafdata())
                                    if (self.recovery_time.is_set or self.recovery_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.recovery_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-graceful-restartable" or name == "reconnect-timeout" or name == "recovery-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-graceful-restartable"):
                                        self.is_graceful_restartable = value
                                        self.is_graceful_restartable.value_namespace = name_space
                                        self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reconnect-timeout"):
                                        self.reconnect_timeout = value
                                        self.reconnect_timeout.value_namespace = name_space
                                        self.reconnect_timeout.value_namespace_prefix = name_space_prefix
                                    if(value_path == "recovery-time"):
                                        self.recovery_time = value
                                        self.recovery_time.value_namespace = name_space
                                        self.recovery_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.downstream_on_demand.is_set or
                                    self.ta_holdtime.is_set or
                                    self.ta_pies_rcvd.is_set or
                                    self.ta_pies_sent.is_set or
                                    self.ta_state.is_set or
                                    self.ta_up_time_seconds.is_set or
                                    (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.downstream_on_demand.yfilter != YFilter.not_set or
                                    self.ta_holdtime.yfilter != YFilter.not_set or
                                    self.ta_pies_rcvd.yfilter != YFilter.not_set or
                                    self.ta_pies_sent.yfilter != YFilter.not_set or
                                    self.ta_state.yfilter != YFilter.not_set or
                                    self.ta_up_time_seconds.yfilter != YFilter.not_set or
                                    (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.downstream_on_demand.is_set or self.downstream_on_demand.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.downstream_on_demand.get_name_leafdata())
                                if (self.ta_holdtime.is_set or self.ta_holdtime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_holdtime.get_name_leafdata())
                                if (self.ta_pies_rcvd.is_set or self.ta_pies_rcvd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_pies_rcvd.get_name_leafdata())
                                if (self.ta_pies_sent.is_set or self.ta_pies_sent.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_pies_sent.get_name_leafdata())
                                if (self.ta_state.is_set or self.ta_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_state.get_name_leafdata())
                                if (self.ta_up_time_seconds.is_set or self.ta_up_time_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_up_time_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ta-graceful-restart-adjacency"):
                                    if (self.ta_graceful_restart_adjacency is None):
                                        self.ta_graceful_restart_adjacency = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                        self.ta_graceful_restart_adjacency.parent = self
                                        self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                    return self.ta_graceful_restart_adjacency

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ta-graceful-restart-adjacency" or name == "downstream-on-demand" or name == "ta-holdtime" or name == "ta-pies-rcvd" or name == "ta-pies-sent" or name == "ta-state" or name == "ta-up-time-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "downstream-on-demand"):
                                    self.downstream_on_demand = value
                                    self.downstream_on_demand.value_namespace = name_space
                                    self.downstream_on_demand.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-holdtime"):
                                    self.ta_holdtime = value
                                    self.ta_holdtime.value_namespace = name_space
                                    self.ta_holdtime.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-pies-rcvd"):
                                    self.ta_pies_rcvd = value
                                    self.ta_pies_rcvd.value_namespace = name_space
                                    self.ta_pies_rcvd.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-pies-sent"):
                                    self.ta_pies_sent = value
                                    self.ta_pies_sent.value_namespace = name_space
                                    self.ta_pies_sent.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-state"):
                                    self.ta_state = value
                                    self.ta_state.value_namespace = name_space
                                    self.ta_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-up-time-seconds"):
                                    self.ta_up_time_seconds = value
                                    self.ta_up_time_seconds.value_namespace = name_space
                                    self.ta_up_time_seconds.value_namespace_prefix = name_space_prefix


                        class TcpInformation(Entity):
                            """
                            TCP Information
                            
                            .. attribute:: foreign_host
                            
                            	Foreign host address
                            	**type**\:   :py:class:`ForeignHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost>`
                            
                            .. attribute:: foreign_port
                            
                            	Foreign port number
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: is_md5_on
                            
                            	Is MD5 Digest on
                            	**type**\:  bool
                            
                            .. attribute:: local_host
                            
                            	Local host address
                            	**type**\:   :py:class:`LocalHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost>`
                            
                            .. attribute:: local_port
                            
                            	Local port number
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__init__()

                                self.yang_name = "tcp-information"
                                self.yang_parent_name = "neighbor"

                                self.foreign_port = YLeaf(YType.uint16, "foreign-port")

                                self.is_md5_on = YLeaf(YType.boolean, "is-md5-on")

                                self.local_port = YLeaf(YType.uint16, "local-port")

                                self.foreign_host = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                self.foreign_host.parent = self
                                self._children_name_map["foreign_host"] = "foreign-host"
                                self._children_yang_names.add("foreign-host")

                                self.local_host = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                self.local_host.parent = self
                                self._children_name_map["local_host"] = "local-host"
                                self._children_yang_names.add("local-host")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("foreign_port",
                                                "is_md5_on",
                                                "local_port") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)


                            class ForeignHost(Entity):
                                """
                                Foreign host address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__init__()

                                    self.yang_name = "foreign-host"
                                    self.yang_parent_name = "tcp-information"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "foreign-host" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/tcp-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix


                            class LocalHost(Entity):
                                """
                                Local host address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__init__()

                                    self.yang_name = "local-host"
                                    self.yang_parent_name = "tcp-information"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "local-host" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/tcp-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.foreign_port.is_set or
                                    self.is_md5_on.is_set or
                                    self.local_port.is_set or
                                    (self.foreign_host is not None and self.foreign_host.has_data()) or
                                    (self.local_host is not None and self.local_host.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.foreign_port.yfilter != YFilter.not_set or
                                    self.is_md5_on.yfilter != YFilter.not_set or
                                    self.local_port.yfilter != YFilter.not_set or
                                    (self.foreign_host is not None and self.foreign_host.has_operation()) or
                                    (self.local_host is not None and self.local_host.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tcp-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.foreign_port.is_set or self.foreign_port.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.foreign_port.get_name_leafdata())
                                if (self.is_md5_on.is_set or self.is_md5_on.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_md5_on.get_name_leafdata())
                                if (self.local_port.is_set or self.local_port.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_port.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "foreign-host"):
                                    if (self.foreign_host is None):
                                        self.foreign_host = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                        self.foreign_host.parent = self
                                        self._children_name_map["foreign_host"] = "foreign-host"
                                    return self.foreign_host

                                if (child_yang_name == "local-host"):
                                    if (self.local_host is None):
                                        self.local_host = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                        self.local_host.parent = self
                                        self._children_name_map["local_host"] = "local-host"
                                    return self.local_host

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "foreign-host" or name == "local-host" or name == "foreign-port" or name == "is-md5-on" or name == "local-port"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "foreign-port"):
                                    self.foreign_port = value
                                    self.foreign_port.value_namespace = name_space
                                    self.foreign_port.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-md5-on"):
                                    self.is_md5_on = value
                                    self.is_md5_on.value_namespace = name_space
                                    self.is_md5_on.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-port"):
                                    self.local_port = value
                                    self.local_port.value_namespace = name_space
                                    self.local_port.value_namespace_prefix = name_space_prefix


                        class DetailedInformation(Entity):
                            """
                            Detailed information with regards to holdtime,
                            KA, inbound filtering, and Session protection
                            
                            .. attribute:: advertise_bgp_prefixes
                            
                            	Is BGP labelled prefixes advertised to the neighbor
                            	**type**\:  bool
                            
                            .. attribute:: bgp_advertisement_state
                            
                            	BGP labelled prefixes advertisement state
                            	**type**\:   :py:class:`MgmtLdpNbrBgpAdvtState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNbrBgpAdvtState>`
                            
                            .. attribute:: capabilities
                            
                            	Capabilities sent to and received from neighbor
                            	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities>`
                            
                            .. attribute:: client
                            
                            	Targeted Session clients
                            	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client>`
                            
                            .. attribute:: has_ipv4_inbound
                            
                            	IPv4 Inbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv4_outbound
                            
                            	IPv4 Outbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv6_inbound
                            
                            	IPv6 Inbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv6_outbound
                            
                            	IPv6 Outbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_sp
                            
                            	Session Protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: inbound_ipv4acl
                            
                            	IPv4 Inbound accept ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: inbound_ipv6acl
                            
                            	IPv6 Inbound accept ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: ipv4_duplicate_address
                            
                            	Duplicate IPv4 address bound to this peer
                            	**type**\: list of    :py:class:`Ipv4DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress>`
                            
                            .. attribute:: ipv6_duplicate_address
                            
                            	Duplicate IPv6 address bound to this peer
                            	**type**\: list of    :py:class:`Ipv6DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress>`
                            
                            .. attribute:: keep_alive_interval
                            
                            	Session keepalive interval in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: nsr_last_sync_error
                            
                            	Last NSR sync error
                            	**type**\:   :py:class:`MgmtLdpNsrPeerSyncErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncErr>`
                            
                            .. attribute:: nsr_last_sync_nack_reason
                            
                            	Last NSR sync NACK reaston
                            	**type**\:   :py:class:`MgmtLdpNsrPeerLdpSyncNackRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerLdpSyncNackRsn>`
                            
                            .. attribute:: nsr_sync_state
                            
                            	NSR Sync State
                            	**type**\:   :py:class:`MgmtLdpNsrPeerSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncState>`
                            
                            .. attribute:: outbound_ipv4acl
                            
                            	IPv4 Outbound advertise ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: outbound_ipv6acl
                            
                            	IPv6 Outbound advertise ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: peer_holdtime
                            
                            	Session holdtime value in seconds from the peer
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: peer_state
                            
                            	Peer state
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: sp_duration
                            
                            	Session protection holdup time duration in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: sp_has_acl
                            
                            	Session protection ACL is present
                            	**type**\:  bool
                            
                            .. attribute:: sp_has_duration
                            
                            	Session Protection has non\-default duration
                            	**type**\:  bool
                            
                            .. attribute:: sp_state
                            
                            	Session Protection state
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: spacl
                            
                            	Session Protection ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: spht_remaining
                            
                            	Session Protection holdup time remaining value in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: spht_running
                            
                            	Session Protection holdup timer is running
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__init__()

                                self.yang_name = "detailed-information"
                                self.yang_parent_name = "neighbor"

                                self.advertise_bgp_prefixes = YLeaf(YType.boolean, "advertise-bgp-prefixes")

                                self.bgp_advertisement_state = YLeaf(YType.enumeration, "bgp-advertisement-state")

                                self.has_ipv4_inbound = YLeaf(YType.boolean, "has-ipv4-inbound")

                                self.has_ipv4_outbound = YLeaf(YType.boolean, "has-ipv4-outbound")

                                self.has_ipv6_inbound = YLeaf(YType.boolean, "has-ipv6-inbound")

                                self.has_ipv6_outbound = YLeaf(YType.boolean, "has-ipv6-outbound")

                                self.has_sp = YLeaf(YType.boolean, "has-sp")

                                self.inbound_ipv4acl = YLeaf(YType.str, "inbound-ipv4acl")

                                self.inbound_ipv6acl = YLeaf(YType.str, "inbound-ipv6acl")

                                self.keep_alive_interval = YLeaf(YType.uint32, "keep-alive-interval")

                                self.nsr_last_sync_error = YLeaf(YType.enumeration, "nsr-last-sync-error")

                                self.nsr_last_sync_nack_reason = YLeaf(YType.enumeration, "nsr-last-sync-nack-reason")

                                self.nsr_sync_state = YLeaf(YType.enumeration, "nsr-sync-state")

                                self.outbound_ipv4acl = YLeaf(YType.str, "outbound-ipv4acl")

                                self.outbound_ipv6acl = YLeaf(YType.str, "outbound-ipv6acl")

                                self.peer_holdtime = YLeaf(YType.uint32, "peer-holdtime")

                                self.peer_state = YLeaf(YType.str, "peer-state")

                                self.sp_duration = YLeaf(YType.uint32, "sp-duration")

                                self.sp_has_acl = YLeaf(YType.boolean, "sp-has-acl")

                                self.sp_has_duration = YLeaf(YType.boolean, "sp-has-duration")

                                self.sp_state = YLeaf(YType.str, "sp-state")

                                self.spacl = YLeaf(YType.str, "spacl")

                                self.spht_remaining = YLeaf(YType.uint32, "spht-remaining")

                                self.spht_running = YLeaf(YType.boolean, "spht-running")

                                self.capabilities = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                self.capabilities.parent = self
                                self._children_name_map["capabilities"] = "capabilities"
                                self._children_yang_names.add("capabilities")

                                self.client = YList(self)
                                self.ipv4_duplicate_address = YList(self)
                                self.ipv6_duplicate_address = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("advertise_bgp_prefixes",
                                                "bgp_advertisement_state",
                                                "has_ipv4_inbound",
                                                "has_ipv4_outbound",
                                                "has_ipv6_inbound",
                                                "has_ipv6_outbound",
                                                "has_sp",
                                                "inbound_ipv4acl",
                                                "inbound_ipv6acl",
                                                "keep_alive_interval",
                                                "nsr_last_sync_error",
                                                "nsr_last_sync_nack_reason",
                                                "nsr_sync_state",
                                                "outbound_ipv4acl",
                                                "outbound_ipv6acl",
                                                "peer_holdtime",
                                                "peer_state",
                                                "sp_duration",
                                                "sp_has_acl",
                                                "sp_has_duration",
                                                "sp_state",
                                                "spacl",
                                                "spht_remaining",
                                                "spht_running") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)


                            class Capabilities(Entity):
                                """
                                Capabilities sent to and received from neighbor
                                
                                .. attribute:: received
                                
                                	List of received capabilities
                                	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received>`
                                
                                .. attribute:: sent
                                
                                	List of sent capabilities
                                	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__init__()

                                    self.yang_name = "capabilities"
                                    self.yang_parent_name = "detailed-information"

                                    self.received = YList(self)
                                    self.sent = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)


                                class Sent(Entity):
                                    """
                                    List of sent capabilities
                                    
                                    .. attribute:: capability_data
                                    
                                    	Capability data
                                    	**type**\:  str
                                    
                                    .. attribute:: capability_data_length
                                    
                                    	Capability data length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: description
                                    
                                    	Capability description
                                    	**type**\:  str
                                    
                                    	**length:** 0..80
                                    
                                    .. attribute:: type
                                    
                                    	Capability type (IANA assigned)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__init__()

                                        self.yang_name = "sent"
                                        self.yang_parent_name = "capabilities"

                                        self.capability_data = YLeaf(YType.str, "capability-data")

                                        self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                        self.description = YLeaf(YType.str, "description")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("capability_data",
                                                        "capability_data_length",
                                                        "description",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.capability_data.is_set or
                                            self.capability_data_length.is_set or
                                            self.description.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.capability_data.yfilter != YFilter.not_set or
                                            self.capability_data_length.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sent" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/capabilities/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data.get_name_leafdata())
                                        if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "capability-data"):
                                            self.capability_data = value
                                            self.capability_data.value_namespace = name_space
                                            self.capability_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "capability-data-length"):
                                            self.capability_data_length = value
                                            self.capability_data_length.value_namespace = name_space
                                            self.capability_data_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class Received(Entity):
                                    """
                                    List of received capabilities
                                    
                                    .. attribute:: capability_data
                                    
                                    	Capability data
                                    	**type**\:  str
                                    
                                    .. attribute:: capability_data_length
                                    
                                    	Capability data length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: description
                                    
                                    	Capability description
                                    	**type**\:  str
                                    
                                    	**length:** 0..80
                                    
                                    .. attribute:: type
                                    
                                    	Capability type (IANA assigned)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__init__()

                                        self.yang_name = "received"
                                        self.yang_parent_name = "capabilities"

                                        self.capability_data = YLeaf(YType.str, "capability-data")

                                        self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                        self.description = YLeaf(YType.str, "description")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("capability_data",
                                                        "capability_data_length",
                                                        "description",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.capability_data.is_set or
                                            self.capability_data_length.is_set or
                                            self.description.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.capability_data.yfilter != YFilter.not_set or
                                            self.capability_data_length.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "received" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/capabilities/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data.get_name_leafdata())
                                        if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "capability-data"):
                                            self.capability_data = value
                                            self.capability_data.value_namespace = name_space
                                            self.capability_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "capability-data-length"):
                                            self.capability_data_length = value
                                            self.capability_data_length.value_namespace = name_space
                                            self.capability_data_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.received:
                                        if (c.has_data()):
                                            return True
                                    for c in self.sent:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.received:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.sent:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "capabilities" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "received"):
                                        for c in self.received:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.received.append(c)
                                        return c

                                    if (child_yang_name == "sent"):
                                        for c in self.sent:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sent.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "received" or name == "sent"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Client(Entity):
                                """
                                Targeted Session clients
                                
                                .. attribute:: name
                                
                                	Client's name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__init__()

                                    self.yang_name = "client"
                                    self.yang_parent_name = "detailed-information"

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "client" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Ipv4DuplicateAddress(Entity):
                                """
                                Duplicate IPv4 address bound to this peer
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress, self).__init__()

                                    self.yang_name = "ipv4-duplicate-address"
                                    self.yang_parent_name = "detailed-information"

                                    self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ipv4-duplicate-address"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/ipv4-duplicate-address/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-duplicate-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Ipv6DuplicateAddress(Entity):
                                """
                                Duplicate IPv6 address bound to this peer
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress, self).__init__()

                                    self.yang_name = "ipv6-duplicate-address"
                                    self.yang_parent_name = "detailed-information"

                                    self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ipv6-duplicate-address"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/ipv6-duplicate-address/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-duplicate-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                for c in self.client:
                                    if (c.has_data()):
                                        return True
                                for c in self.ipv4_duplicate_address:
                                    if (c.has_data()):
                                        return True
                                for c in self.ipv6_duplicate_address:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.advertise_bgp_prefixes.is_set or
                                    self.bgp_advertisement_state.is_set or
                                    self.has_ipv4_inbound.is_set or
                                    self.has_ipv4_outbound.is_set or
                                    self.has_ipv6_inbound.is_set or
                                    self.has_ipv6_outbound.is_set or
                                    self.has_sp.is_set or
                                    self.inbound_ipv4acl.is_set or
                                    self.inbound_ipv6acl.is_set or
                                    self.keep_alive_interval.is_set or
                                    self.nsr_last_sync_error.is_set or
                                    self.nsr_last_sync_nack_reason.is_set or
                                    self.nsr_sync_state.is_set or
                                    self.outbound_ipv4acl.is_set or
                                    self.outbound_ipv6acl.is_set or
                                    self.peer_holdtime.is_set or
                                    self.peer_state.is_set or
                                    self.sp_duration.is_set or
                                    self.sp_has_acl.is_set or
                                    self.sp_has_duration.is_set or
                                    self.sp_state.is_set or
                                    self.spacl.is_set or
                                    self.spht_remaining.is_set or
                                    self.spht_running.is_set or
                                    (self.capabilities is not None and self.capabilities.has_data()))

                            def has_operation(self):
                                for c in self.client:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ipv4_duplicate_address:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ipv6_duplicate_address:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.advertise_bgp_prefixes.yfilter != YFilter.not_set or
                                    self.bgp_advertisement_state.yfilter != YFilter.not_set or
                                    self.has_ipv4_inbound.yfilter != YFilter.not_set or
                                    self.has_ipv4_outbound.yfilter != YFilter.not_set or
                                    self.has_ipv6_inbound.yfilter != YFilter.not_set or
                                    self.has_ipv6_outbound.yfilter != YFilter.not_set or
                                    self.has_sp.yfilter != YFilter.not_set or
                                    self.inbound_ipv4acl.yfilter != YFilter.not_set or
                                    self.inbound_ipv6acl.yfilter != YFilter.not_set or
                                    self.keep_alive_interval.yfilter != YFilter.not_set or
                                    self.nsr_last_sync_error.yfilter != YFilter.not_set or
                                    self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set or
                                    self.nsr_sync_state.yfilter != YFilter.not_set or
                                    self.outbound_ipv4acl.yfilter != YFilter.not_set or
                                    self.outbound_ipv6acl.yfilter != YFilter.not_set or
                                    self.peer_holdtime.yfilter != YFilter.not_set or
                                    self.peer_state.yfilter != YFilter.not_set or
                                    self.sp_duration.yfilter != YFilter.not_set or
                                    self.sp_has_acl.yfilter != YFilter.not_set or
                                    self.sp_has_duration.yfilter != YFilter.not_set or
                                    self.sp_state.yfilter != YFilter.not_set or
                                    self.spacl.yfilter != YFilter.not_set or
                                    self.spht_remaining.yfilter != YFilter.not_set or
                                    self.spht_running.yfilter != YFilter.not_set or
                                    (self.capabilities is not None and self.capabilities.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "detailed-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.advertise_bgp_prefixes.is_set or self.advertise_bgp_prefixes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.advertise_bgp_prefixes.get_name_leafdata())
                                if (self.bgp_advertisement_state.is_set or self.bgp_advertisement_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bgp_advertisement_state.get_name_leafdata())
                                if (self.has_ipv4_inbound.is_set or self.has_ipv4_inbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv4_inbound.get_name_leafdata())
                                if (self.has_ipv4_outbound.is_set or self.has_ipv4_outbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv4_outbound.get_name_leafdata())
                                if (self.has_ipv6_inbound.is_set or self.has_ipv6_inbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv6_inbound.get_name_leafdata())
                                if (self.has_ipv6_outbound.is_set or self.has_ipv6_outbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv6_outbound.get_name_leafdata())
                                if (self.has_sp.is_set or self.has_sp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_sp.get_name_leafdata())
                                if (self.inbound_ipv4acl.is_set or self.inbound_ipv4acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inbound_ipv4acl.get_name_leafdata())
                                if (self.inbound_ipv6acl.is_set or self.inbound_ipv6acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inbound_ipv6acl.get_name_leafdata())
                                if (self.keep_alive_interval.is_set or self.keep_alive_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_interval.get_name_leafdata())
                                if (self.nsr_last_sync_error.is_set or self.nsr_last_sync_error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_last_sync_error.get_name_leafdata())
                                if (self.nsr_last_sync_nack_reason.is_set or self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_last_sync_nack_reason.get_name_leafdata())
                                if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                if (self.outbound_ipv4acl.is_set or self.outbound_ipv4acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outbound_ipv4acl.get_name_leafdata())
                                if (self.outbound_ipv6acl.is_set or self.outbound_ipv6acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outbound_ipv6acl.get_name_leafdata())
                                if (self.peer_holdtime.is_set or self.peer_holdtime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_holdtime.get_name_leafdata())
                                if (self.peer_state.is_set or self.peer_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_state.get_name_leafdata())
                                if (self.sp_duration.is_set or self.sp_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_duration.get_name_leafdata())
                                if (self.sp_has_acl.is_set or self.sp_has_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_has_acl.get_name_leafdata())
                                if (self.sp_has_duration.is_set or self.sp_has_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_has_duration.get_name_leafdata())
                                if (self.sp_state.is_set or self.sp_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_state.get_name_leafdata())
                                if (self.spacl.is_set or self.spacl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spacl.get_name_leafdata())
                                if (self.spht_remaining.is_set or self.spht_remaining.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spht_remaining.get_name_leafdata())
                                if (self.spht_running.is_set or self.spht_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spht_running.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "capabilities"):
                                    if (self.capabilities is None):
                                        self.capabilities = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                        self.capabilities.parent = self
                                        self._children_name_map["capabilities"] = "capabilities"
                                    return self.capabilities

                                if (child_yang_name == "client"):
                                    for c in self.client:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.client.append(c)
                                    return c

                                if (child_yang_name == "ipv4-duplicate-address"):
                                    for c in self.ipv4_duplicate_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipv4_duplicate_address.append(c)
                                    return c

                                if (child_yang_name == "ipv6-duplicate-address"):
                                    for c in self.ipv6_duplicate_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipv6_duplicate_address.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capabilities" or name == "client" or name == "ipv4-duplicate-address" or name == "ipv6-duplicate-address" or name == "advertise-bgp-prefixes" or name == "bgp-advertisement-state" or name == "has-ipv4-inbound" or name == "has-ipv4-outbound" or name == "has-ipv6-inbound" or name == "has-ipv6-outbound" or name == "has-sp" or name == "inbound-ipv4acl" or name == "inbound-ipv6acl" or name == "keep-alive-interval" or name == "nsr-last-sync-error" or name == "nsr-last-sync-nack-reason" or name == "nsr-sync-state" or name == "outbound-ipv4acl" or name == "outbound-ipv6acl" or name == "peer-holdtime" or name == "peer-state" or name == "sp-duration" or name == "sp-has-acl" or name == "sp-has-duration" or name == "sp-state" or name == "spacl" or name == "spht-remaining" or name == "spht-running"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "advertise-bgp-prefixes"):
                                    self.advertise_bgp_prefixes = value
                                    self.advertise_bgp_prefixes.value_namespace = name_space
                                    self.advertise_bgp_prefixes.value_namespace_prefix = name_space_prefix
                                if(value_path == "bgp-advertisement-state"):
                                    self.bgp_advertisement_state = value
                                    self.bgp_advertisement_state.value_namespace = name_space
                                    self.bgp_advertisement_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv4-inbound"):
                                    self.has_ipv4_inbound = value
                                    self.has_ipv4_inbound.value_namespace = name_space
                                    self.has_ipv4_inbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv4-outbound"):
                                    self.has_ipv4_outbound = value
                                    self.has_ipv4_outbound.value_namespace = name_space
                                    self.has_ipv4_outbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv6-inbound"):
                                    self.has_ipv6_inbound = value
                                    self.has_ipv6_inbound.value_namespace = name_space
                                    self.has_ipv6_inbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv6-outbound"):
                                    self.has_ipv6_outbound = value
                                    self.has_ipv6_outbound.value_namespace = name_space
                                    self.has_ipv6_outbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-sp"):
                                    self.has_sp = value
                                    self.has_sp.value_namespace = name_space
                                    self.has_sp.value_namespace_prefix = name_space_prefix
                                if(value_path == "inbound-ipv4acl"):
                                    self.inbound_ipv4acl = value
                                    self.inbound_ipv4acl.value_namespace = name_space
                                    self.inbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "inbound-ipv6acl"):
                                    self.inbound_ipv6acl = value
                                    self.inbound_ipv6acl.value_namespace = name_space
                                    self.inbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-interval"):
                                    self.keep_alive_interval = value
                                    self.keep_alive_interval.value_namespace = name_space
                                    self.keep_alive_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-last-sync-error"):
                                    self.nsr_last_sync_error = value
                                    self.nsr_last_sync_error.value_namespace = name_space
                                    self.nsr_last_sync_error.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-last-sync-nack-reason"):
                                    self.nsr_last_sync_nack_reason = value
                                    self.nsr_last_sync_nack_reason.value_namespace = name_space
                                    self.nsr_last_sync_nack_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sync-state"):
                                    self.nsr_sync_state = value
                                    self.nsr_sync_state.value_namespace = name_space
                                    self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "outbound-ipv4acl"):
                                    self.outbound_ipv4acl = value
                                    self.outbound_ipv4acl.value_namespace = name_space
                                    self.outbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "outbound-ipv6acl"):
                                    self.outbound_ipv6acl = value
                                    self.outbound_ipv6acl.value_namespace = name_space
                                    self.outbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-holdtime"):
                                    self.peer_holdtime = value
                                    self.peer_holdtime.value_namespace = name_space
                                    self.peer_holdtime.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-state"):
                                    self.peer_state = value
                                    self.peer_state.value_namespace = name_space
                                    self.peer_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-duration"):
                                    self.sp_duration = value
                                    self.sp_duration.value_namespace = name_space
                                    self.sp_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-has-acl"):
                                    self.sp_has_acl = value
                                    self.sp_has_acl.value_namespace = name_space
                                    self.sp_has_acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-has-duration"):
                                    self.sp_has_duration = value
                                    self.sp_has_duration.value_namespace = name_space
                                    self.sp_has_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-state"):
                                    self.sp_state = value
                                    self.sp_state.value_namespace = name_space
                                    self.sp_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "spacl"):
                                    self.spacl = value
                                    self.spacl.value_namespace = name_space
                                    self.spacl.value_namespace_prefix = name_space_prefix
                                if(value_path == "spht-remaining"):
                                    self.spht_remaining = value
                                    self.spht_remaining.value_namespace = name_space
                                    self.spht_remaining.value_namespace_prefix = name_space_prefix
                                if(value_path == "spht-running"):
                                    self.spht_running = value
                                    self.spht_running.value_namespace = name_space
                                    self.spht_running.value_namespace_prefix = name_space_prefix


                        class LdpNbrBoundIpv4AddressInfo(Entity):
                            """
                            Neighbor IPv4 Address Info
                            
                            .. attribute:: address
                            
                            	Neighbor Address
                            	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo, self).__init__()

                                self.yang_name = "ldp-nbr-bound-ipv4-address-info"
                                self.yang_parent_name = "neighbor"

                                self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                self.address.parent = self
                                self._children_name_map["address"] = "address"
                                self._children_yang_names.add("address")


                            class Address(Entity):
                                """
                                Neighbor Address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__init__()

                                    self.yang_name = "address"
                                    self.yang_parent_name = "ldp-nbr-bound-ipv4-address-info"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-bound-ipv4-address-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.address is not None and self.address.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.address is not None and self.address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-bound-ipv4-address-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "address"):
                                    if (self.address is None):
                                        self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                    return self.address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrBoundIpv6AddressInfo(Entity):
                            """
                            Neighbor IPv6 Address Info
                            
                            .. attribute:: address
                            
                            	Neighbor Address
                            	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo, self).__init__()

                                self.yang_name = "ldp-nbr-bound-ipv6-address-info"
                                self.yang_parent_name = "neighbor"

                                self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                self.address.parent = self
                                self._children_name_map["address"] = "address"
                                self._children_yang_names.add("address")


                            class Address(Entity):
                                """
                                Neighbor Address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__init__()

                                    self.yang_name = "address"
                                    self.yang_parent_name = "ldp-nbr-bound-ipv6-address-info"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-bound-ipv6-address-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.address is not None and self.address.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.address is not None and self.address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-bound-ipv6-address-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "address"):
                                    if (self.address is None):
                                        self.address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                    return self.address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrIpv4AdjInfo(Entity):
                            """
                            Neighbor's IPv4 Adjacency Information
                            
                            .. attribute:: adjacency_group
                            
                            	Adjacency group
                            	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo, self).__init__()

                                self.yang_name = "ldp-nbr-ipv4-adj-info"
                                self.yang_parent_name = "neighbor"

                                self.adjacency_group = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                self.adjacency_group.parent = self
                                self._children_name_map["adjacency_group"] = "adjacency-group"
                                self._children_yang_names.add("adjacency-group")


                            class AdjacencyGroup(Entity):
                                """
                                Adjacency group
                                
                                .. attribute:: hello_type
                                
                                	HelloType
                                	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                
                                .. attribute:: link_hello_data
                                
                                	Link hello
                                	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData>`
                                
                                .. attribute:: target_hello_data
                                
                                	Target Hello
                                	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__init__()

                                    self.yang_name = "adjacency-group"
                                    self.yang_parent_name = "ldp-nbr-ipv4-adj-info"

                                    self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                    self.link_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                    self.link_hello_data.parent = self
                                    self._children_name_map["link_hello_data"] = "link-hello-data"
                                    self._children_yang_names.add("link-hello-data")

                                    self.target_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                    self.target_hello_data.parent = self
                                    self._children_name_map["target_hello_data"] = "target-hello-data"
                                    self._children_yang_names.add("target-hello-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("hello_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                class LinkHelloData(Entity):
                                    """
                                    Link hello
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                        self.yang_name = "link-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface",
                                                        "interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface.is_set or
                                            self.interface_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix


                                class TargetHelloData(Entity):
                                    """
                                    Target Hello
                                    
                                    .. attribute:: local_address
                                    
                                    	Local Address
                                    	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	Target Address
                                    	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                        self.yang_name = "target-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.local_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                        self.local_address.parent = self
                                        self._children_name_map["local_address"] = "local-address"
                                        self._children_yang_names.add("local-address")

                                        self.target_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                        self.target_address.parent = self
                                        self._children_name_map["target_address"] = "target-address"
                                        self._children_yang_names.add("target-address")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                    class LocalAddress(Entity):
                                        """
                                        Local Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                            self.yang_name = "local-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class TargetAddress(Entity):
                                        """
                                        Target Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                            self.yang_name = "target-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.state.is_set or
                                            (self.local_address is not None and self.local_address.has_data()) or
                                            (self.target_address is not None and self.target_address.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            (self.local_address is not None and self.local_address.has_operation()) or
                                            (self.target_address is not None and self.target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "target-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "local-address"):
                                            if (self.local_address is None):
                                                self.local_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                self.local_address.parent = self
                                                self._children_name_map["local_address"] = "local-address"
                                            return self.local_address

                                        if (child_yang_name == "target-address"):
                                            if (self.target_address is None):
                                                self.target_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                self.target_address.parent = self
                                                self._children_name_map["target_address"] = "target-address"
                                            return self.target_address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-address" or name == "target-address" or name == "state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.hello_type.is_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.hello_type.yfilter != YFilter.not_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "adjacency-group" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-data"):
                                        if (self.link_hello_data is None):
                                            self.link_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                            self.link_hello_data.parent = self
                                            self._children_name_map["link_hello_data"] = "link-hello-data"
                                        return self.link_hello_data

                                    if (child_yang_name == "target-hello-data"):
                                        if (self.target_hello_data is None):
                                            self.target_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                            self.target_hello_data.parent = self
                                            self._children_name_map["target_hello_data"] = "target-hello-data"
                                        return self.target_hello_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "hello-type"):
                                        self.hello_type = value
                                        self.hello_type.value_namespace = name_space
                                        self.hello_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.adjacency_group is not None and self.adjacency_group.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-ipv4-adj-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "adjacency-group"):
                                    if (self.adjacency_group is None):
                                        self.adjacency_group = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                        self.adjacency_group.parent = self
                                        self._children_name_map["adjacency_group"] = "adjacency-group"
                                    return self.adjacency_group

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "adjacency-group"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrIpv6AdjInfo(Entity):
                            """
                            Neighbor's IPv6 Adjacency Information
                            
                            .. attribute:: adjacency_group
                            
                            	Adjacency group
                            	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo, self).__init__()

                                self.yang_name = "ldp-nbr-ipv6-adj-info"
                                self.yang_parent_name = "neighbor"

                                self.adjacency_group = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                self.adjacency_group.parent = self
                                self._children_name_map["adjacency_group"] = "adjacency-group"
                                self._children_yang_names.add("adjacency-group")


                            class AdjacencyGroup(Entity):
                                """
                                Adjacency group
                                
                                .. attribute:: hello_type
                                
                                	HelloType
                                	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                
                                .. attribute:: link_hello_data
                                
                                	Link hello
                                	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData>`
                                
                                .. attribute:: target_hello_data
                                
                                	Target Hello
                                	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__init__()

                                    self.yang_name = "adjacency-group"
                                    self.yang_parent_name = "ldp-nbr-ipv6-adj-info"

                                    self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                    self.link_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                    self.link_hello_data.parent = self
                                    self._children_name_map["link_hello_data"] = "link-hello-data"
                                    self._children_yang_names.add("link-hello-data")

                                    self.target_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                    self.target_hello_data.parent = self
                                    self._children_name_map["target_hello_data"] = "target-hello-data"
                                    self._children_yang_names.add("target-hello-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("hello_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                class LinkHelloData(Entity):
                                    """
                                    Link hello
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                        self.yang_name = "link-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface",
                                                        "interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface.is_set or
                                            self.interface_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix


                                class TargetHelloData(Entity):
                                    """
                                    Target Hello
                                    
                                    .. attribute:: local_address
                                    
                                    	Local Address
                                    	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	Target Address
                                    	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                        self.yang_name = "target-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.local_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                        self.local_address.parent = self
                                        self._children_name_map["local_address"] = "local-address"
                                        self._children_yang_names.add("local-address")

                                        self.target_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                        self.target_address.parent = self
                                        self._children_name_map["target_address"] = "target-address"
                                        self._children_yang_names.add("target-address")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                    class LocalAddress(Entity):
                                        """
                                        Local Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                            self.yang_name = "local-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class TargetAddress(Entity):
                                        """
                                        Target Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                            self.yang_name = "target-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.state.is_set or
                                            (self.local_address is not None and self.local_address.has_data()) or
                                            (self.target_address is not None and self.target_address.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            (self.local_address is not None and self.local_address.has_operation()) or
                                            (self.target_address is not None and self.target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "target-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "local-address"):
                                            if (self.local_address is None):
                                                self.local_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                self.local_address.parent = self
                                                self._children_name_map["local_address"] = "local-address"
                                            return self.local_address

                                        if (child_yang_name == "target-address"):
                                            if (self.target_address is None):
                                                self.target_address = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                self.target_address.parent = self
                                                self._children_name_map["target_address"] = "target-address"
                                            return self.target_address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-address" or name == "target-address" or name == "state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.hello_type.is_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.hello_type.yfilter != YFilter.not_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "adjacency-group" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-data"):
                                        if (self.link_hello_data is None):
                                            self.link_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                            self.link_hello_data.parent = self
                                            self._children_name_map["link_hello_data"] = "link-hello-data"
                                        return self.link_hello_data

                                    if (child_yang_name == "target-hello-data"):
                                        if (self.target_hello_data is None):
                                            self.target_hello_data = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                            self.target_hello_data.parent = self
                                            self._children_name_map["target_hello_data"] = "target-hello-data"
                                        return self.target_hello_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "hello-type"):
                                        self.hello_type = value
                                        self.hello_type.value_namespace = name_space
                                        self.hello_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.adjacency_group is not None and self.adjacency_group.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-ipv6-adj-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "adjacency-group"):
                                    if (self.adjacency_group is None):
                                        self.adjacency_group = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                        self.adjacency_group.parent = self
                                        self._children_name_map["adjacency_group"] = "adjacency-group"
                                    return self.adjacency_group

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "adjacency-group"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            for c in self.ldp_nbr_bound_ipv4_address_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_bound_ipv6_address_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_ipv4_adj_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_ipv6_adj_info:
                                if (c.has_data()):
                                    return True
                            return (
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                (self.detailed_information is not None and self.detailed_information.has_data()) or
                                (self.protocol_information is not None and self.protocol_information.has_data()) or
                                (self.tcp_information is not None and self.tcp_information.has_data()))

                        def has_operation(self):
                            for c in self.ldp_nbr_bound_ipv4_address_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_bound_ipv6_address_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_ipv4_adj_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_ipv6_adj_info:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                (self.detailed_information is not None and self.detailed_information.has_operation()) or
                                (self.protocol_information is not None and self.protocol_information.has_operation()) or
                                (self.tcp_information is not None and self.tcp_information.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/neighbors/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "detailed-information"):
                                if (self.detailed_information is None):
                                    self.detailed_information = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.DetailedInformation()
                                    self.detailed_information.parent = self
                                    self._children_name_map["detailed_information"] = "detailed-information"
                                return self.detailed_information

                            if (child_yang_name == "ldp-nbr-bound-ipv4-address-info"):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_bound_ipv4_address_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-bound-ipv6-address-info"):
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_bound_ipv6_address_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-ipv4-adj-info"):
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_ipv4_adj_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-ipv6-adj-info"):
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_ipv6_adj_info.append(c)
                                return c

                            if (child_yang_name == "protocol-information"):
                                if (self.protocol_information is None):
                                    self.protocol_information = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.ProtocolInformation()
                                    self.protocol_information.parent = self
                                    self._children_name_map["protocol_information"] = "protocol-information"
                                return self.protocol_information

                            if (child_yang_name == "tcp-information"):
                                if (self.tcp_information is None):
                                    self.tcp_information = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor.TcpInformation()
                                    self.tcp_information.parent = self
                                    self._children_name_map["tcp_information"] = "tcp-information"
                                return self.tcp_information

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "detailed-information" or name == "ldp-nbr-bound-ipv4-address-info" or name == "ldp-nbr-bound-ipv6-address-info" or name == "ldp-nbr-ipv4-adj-info" or name == "ldp-nbr-ipv6-adj-info" or name == "protocol-information" or name == "tcp-information" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbors" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor"):
                            for c in self.neighbor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.Neighbors.Neighbor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class LdpId(Entity):
                    """
                    Local LDP Id
                    
                    .. attribute:: label_space_id
                    
                    	Label space identifier
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: ldp_id
                    
                    	LDP identifier
                    	**type**\:  str
                    
                    .. attribute:: lsr_id
                    
                    	LSR identifier
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.LdpId, self).__init__()

                        self.yang_name = "ldp-id"
                        self.yang_parent_name = "default-vrf"

                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("label_space_id",
                                        "ldp_id",
                                        "lsr_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.LdpId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.LdpId, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.label_space_id.is_set or
                            self.ldp_id.is_set or
                            self.lsr_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.label_space_id.yfilter != YFilter.not_set or
                            self.ldp_id.yfilter != YFilter.not_set or
                            self.lsr_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ldp-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "label-space-id"):
                            self.label_space_id = value
                            self.label_space_id.value_namespace = name_space
                            self.label_space_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-id"):
                            self.ldp_id = value
                            self.ldp_id.value_namespace = name_space
                            self.ldp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsr-id"):
                            self.lsr_id = value
                            self.lsr_id.value_namespace = name_space
                            self.lsr_id.value_namespace_prefix = name_space_prefix


                class Statistics(Entity):
                    """
                    The LDP Statistics
                    
                    .. attribute:: statistic
                    
                    	Statistical Information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`Statistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DefaultVrf.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "default-vrf"

                        self.statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DefaultVrf.Statistics, self).__setattr__(name, value)


                    class Statistic(Entity):
                        """
                        Statistical Information on a particular LDP
                        neighbor
                        
                        .. attribute:: iccp_enabled
                        
                        	Is session ICCP enabled?
                        	**type**\:  bool
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: message_in
                        
                        	Message in count
                        	**type**\:   :py:class:`MessageIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageIn>`
                        
                        .. attribute:: message_out
                        
                        	Message out count
                        	**type**\:   :py:class:`MessageOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageOut>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic, self).__init__()

                            self.yang_name = "statistic"
                            self.yang_parent_name = "statistics"

                            self.iccp_enabled = YLeaf(YType.boolean, "iccp-enabled")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.message_in = MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageIn()
                            self.message_in.parent = self
                            self._children_name_map["message_in"] = "message-in"
                            self._children_yang_names.add("message-in")

                            self.message_out = MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageOut()
                            self.message_out.parent = self
                            self._children_name_map["message_out"] = "message-out"
                            self._children_yang_names.add("message-out")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("iccp_enabled",
                                            "label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic, self).__setattr__(name, value)


                        class MessageOut(Entity):
                            """
                            Message out count
                            
                            .. attribute:: address_count
                            
                            	Address message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: address_withdraw_count
                            
                            	Address withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_app_data_count
                            
                            	ICCP RG App Data count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_conn_count
                            
                            	ICCP RG Connect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_disconn_count
                            
                            	ICCP RG Disconnect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_notif_count
                            
                            	ICCP RG Notif count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: init_count
                            
                            	Init message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: keep_alive_count
                            
                            	Keepalive count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_abort_request_count
                            
                            	Label abort request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_map_count
                            
                            	Label map count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_release_count
                            
                            	Label release count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_request_count
                            
                            	Label request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_withdraw_count
                            
                            	Label withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: notification_count
                            
                            	Notification count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_count
                            
                            	Total message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageOut, self).__init__()

                                self.yang_name = "message-out"
                                self.yang_parent_name = "statistic"

                                self.address_count = YLeaf(YType.uint32, "address-count")

                                self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                self.init_count = YLeaf(YType.uint32, "init-count")

                                self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                self.notification_count = YLeaf(YType.uint32, "notification-count")

                                self.total_count = YLeaf(YType.uint32, "total-count")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_count",
                                                "address_withdraw_count",
                                                "iccp_rg_app_data_count",
                                                "iccp_rg_conn_count",
                                                "iccp_rg_disconn_count",
                                                "iccp_rg_notif_count",
                                                "init_count",
                                                "keep_alive_count",
                                                "label_abort_request_count",
                                                "label_map_count",
                                                "label_release_count",
                                                "label_request_count",
                                                "label_withdraw_count",
                                                "notification_count",
                                                "total_count") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_count.is_set or
                                    self.address_withdraw_count.is_set or
                                    self.iccp_rg_app_data_count.is_set or
                                    self.iccp_rg_conn_count.is_set or
                                    self.iccp_rg_disconn_count.is_set or
                                    self.iccp_rg_notif_count.is_set or
                                    self.init_count.is_set or
                                    self.keep_alive_count.is_set or
                                    self.label_abort_request_count.is_set or
                                    self.label_map_count.is_set or
                                    self.label_release_count.is_set or
                                    self.label_request_count.is_set or
                                    self.label_withdraw_count.is_set or
                                    self.notification_count.is_set or
                                    self.total_count.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_count.yfilter != YFilter.not_set or
                                    self.address_withdraw_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                    self.init_count.yfilter != YFilter.not_set or
                                    self.keep_alive_count.yfilter != YFilter.not_set or
                                    self.label_abort_request_count.yfilter != YFilter.not_set or
                                    self.label_map_count.yfilter != YFilter.not_set or
                                    self.label_release_count.yfilter != YFilter.not_set or
                                    self.label_request_count.yfilter != YFilter.not_set or
                                    self.label_withdraw_count.yfilter != YFilter.not_set or
                                    self.notification_count.yfilter != YFilter.not_set or
                                    self.total_count.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "message-out" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/statistics/statistic/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_count.get_name_leafdata())
                                if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.init_count.get_name_leafdata())
                                if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.notification_count.get_name_leafdata())
                                if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_count.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-count"):
                                    self.address_count = value
                                    self.address_count.value_namespace = name_space
                                    self.address_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "address-withdraw-count"):
                                    self.address_withdraw_count = value
                                    self.address_withdraw_count.value_namespace = name_space
                                    self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-app-data-count"):
                                    self.iccp_rg_app_data_count = value
                                    self.iccp_rg_app_data_count.value_namespace = name_space
                                    self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-conn-count"):
                                    self.iccp_rg_conn_count = value
                                    self.iccp_rg_conn_count.value_namespace = name_space
                                    self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-disconn-count"):
                                    self.iccp_rg_disconn_count = value
                                    self.iccp_rg_disconn_count.value_namespace = name_space
                                    self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-notif-count"):
                                    self.iccp_rg_notif_count = value
                                    self.iccp_rg_notif_count.value_namespace = name_space
                                    self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "init-count"):
                                    self.init_count = value
                                    self.init_count.value_namespace = name_space
                                    self.init_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-count"):
                                    self.keep_alive_count = value
                                    self.keep_alive_count.value_namespace = name_space
                                    self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-abort-request-count"):
                                    self.label_abort_request_count = value
                                    self.label_abort_request_count.value_namespace = name_space
                                    self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-map-count"):
                                    self.label_map_count = value
                                    self.label_map_count.value_namespace = name_space
                                    self.label_map_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-release-count"):
                                    self.label_release_count = value
                                    self.label_release_count.value_namespace = name_space
                                    self.label_release_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-request-count"):
                                    self.label_request_count = value
                                    self.label_request_count.value_namespace = name_space
                                    self.label_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-withdraw-count"):
                                    self.label_withdraw_count = value
                                    self.label_withdraw_count.value_namespace = name_space
                                    self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "notification-count"):
                                    self.notification_count = value
                                    self.notification_count.value_namespace = name_space
                                    self.notification_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-count"):
                                    self.total_count = value
                                    self.total_count.value_namespace = name_space
                                    self.total_count.value_namespace_prefix = name_space_prefix


                        class MessageIn(Entity):
                            """
                            Message in count
                            
                            .. attribute:: address_count
                            
                            	Address message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: address_withdraw_count
                            
                            	Address withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_app_data_count
                            
                            	ICCP RG App Data count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_conn_count
                            
                            	ICCP RG Connect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_disconn_count
                            
                            	ICCP RG Disconnect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_notif_count
                            
                            	ICCP RG Notif count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: init_count
                            
                            	Init message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: keep_alive_count
                            
                            	Keepalive count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_abort_request_count
                            
                            	Label abort request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_map_count
                            
                            	Label map count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_release_count
                            
                            	Label release count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_request_count
                            
                            	Label request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_withdraw_count
                            
                            	Label withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: notification_count
                            
                            	Notification count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_count
                            
                            	Total message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageIn, self).__init__()

                                self.yang_name = "message-in"
                                self.yang_parent_name = "statistic"

                                self.address_count = YLeaf(YType.uint32, "address-count")

                                self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                self.init_count = YLeaf(YType.uint32, "init-count")

                                self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                self.notification_count = YLeaf(YType.uint32, "notification-count")

                                self.total_count = YLeaf(YType.uint32, "total-count")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_count",
                                                "address_withdraw_count",
                                                "iccp_rg_app_data_count",
                                                "iccp_rg_conn_count",
                                                "iccp_rg_disconn_count",
                                                "iccp_rg_notif_count",
                                                "init_count",
                                                "keep_alive_count",
                                                "label_abort_request_count",
                                                "label_map_count",
                                                "label_release_count",
                                                "label_request_count",
                                                "label_withdraw_count",
                                                "notification_count",
                                                "total_count") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_count.is_set or
                                    self.address_withdraw_count.is_set or
                                    self.iccp_rg_app_data_count.is_set or
                                    self.iccp_rg_conn_count.is_set or
                                    self.iccp_rg_disconn_count.is_set or
                                    self.iccp_rg_notif_count.is_set or
                                    self.init_count.is_set or
                                    self.keep_alive_count.is_set or
                                    self.label_abort_request_count.is_set or
                                    self.label_map_count.is_set or
                                    self.label_release_count.is_set or
                                    self.label_request_count.is_set or
                                    self.label_withdraw_count.is_set or
                                    self.notification_count.is_set or
                                    self.total_count.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_count.yfilter != YFilter.not_set or
                                    self.address_withdraw_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                    self.init_count.yfilter != YFilter.not_set or
                                    self.keep_alive_count.yfilter != YFilter.not_set or
                                    self.label_abort_request_count.yfilter != YFilter.not_set or
                                    self.label_map_count.yfilter != YFilter.not_set or
                                    self.label_release_count.yfilter != YFilter.not_set or
                                    self.label_request_count.yfilter != YFilter.not_set or
                                    self.label_withdraw_count.yfilter != YFilter.not_set or
                                    self.notification_count.yfilter != YFilter.not_set or
                                    self.total_count.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "message-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/statistics/statistic/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_count.get_name_leafdata())
                                if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.init_count.get_name_leafdata())
                                if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.notification_count.get_name_leafdata())
                                if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_count.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-count"):
                                    self.address_count = value
                                    self.address_count.value_namespace = name_space
                                    self.address_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "address-withdraw-count"):
                                    self.address_withdraw_count = value
                                    self.address_withdraw_count.value_namespace = name_space
                                    self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-app-data-count"):
                                    self.iccp_rg_app_data_count = value
                                    self.iccp_rg_app_data_count.value_namespace = name_space
                                    self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-conn-count"):
                                    self.iccp_rg_conn_count = value
                                    self.iccp_rg_conn_count.value_namespace = name_space
                                    self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-disconn-count"):
                                    self.iccp_rg_disconn_count = value
                                    self.iccp_rg_disconn_count.value_namespace = name_space
                                    self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-notif-count"):
                                    self.iccp_rg_notif_count = value
                                    self.iccp_rg_notif_count.value_namespace = name_space
                                    self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "init-count"):
                                    self.init_count = value
                                    self.init_count.value_namespace = name_space
                                    self.init_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-count"):
                                    self.keep_alive_count = value
                                    self.keep_alive_count.value_namespace = name_space
                                    self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-abort-request-count"):
                                    self.label_abort_request_count = value
                                    self.label_abort_request_count.value_namespace = name_space
                                    self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-map-count"):
                                    self.label_map_count = value
                                    self.label_map_count.value_namespace = name_space
                                    self.label_map_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-release-count"):
                                    self.label_release_count = value
                                    self.label_release_count.value_namespace = name_space
                                    self.label_release_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-request-count"):
                                    self.label_request_count = value
                                    self.label_request_count.value_namespace = name_space
                                    self.label_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-withdraw-count"):
                                    self.label_withdraw_count = value
                                    self.label_withdraw_count.value_namespace = name_space
                                    self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "notification-count"):
                                    self.notification_count = value
                                    self.notification_count.value_namespace = name_space
                                    self.notification_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-count"):
                                    self.total_count = value
                                    self.total_count.value_namespace = name_space
                                    self.total_count.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.iccp_enabled.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                (self.message_in is not None and self.message_in.has_data()) or
                                (self.message_out is not None and self.message_out.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.iccp_enabled.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                (self.message_in is not None and self.message_in.has_operation()) or
                                (self.message_out is not None and self.message_out.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/statistics/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.iccp_enabled.is_set or self.iccp_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.iccp_enabled.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "message-in"):
                                if (self.message_in is None):
                                    self.message_in = MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageIn()
                                    self.message_in.parent = self
                                    self._children_name_map["message_in"] = "message-in"
                                return self.message_in

                            if (child_yang_name == "message-out"):
                                if (self.message_out is None):
                                    self.message_out = MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic.MessageOut()
                                    self.message_out.parent = self
                                    self._children_name_map["message_out"] = "message-out"
                                return self.message_out

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "message-in" or name == "message-out" or name == "iccp-enabled" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "iccp-enabled"):
                                self.iccp_enabled = value
                                self.iccp_enabled.value_namespace = name_space
                                self.iccp_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.statistic:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.statistic:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistic"):
                            for c in self.statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Standby.DefaultVrf.Statistics.Statistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.statistic.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistic"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        (self.afs is not None and self.afs.has_data()) or
                        (self.backoff_parameters is not None and self.backoff_parameters.has_data()) or
                        (self.backoffs is not None and self.backoffs.has_data()) or
                        (self.capabilities is not None and self.capabilities.has_data()) or
                        (self.graceful_restart is not None and self.graceful_restart.has_data()) or
                        (self.issu is not None and self.issu.has_data()) or
                        (self.ldp_id is not None and self.ldp_id.has_data()) or
                        (self.neighbor_briefs is not None and self.neighbor_briefs.has_data()) or
                        (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_data()) or
                        (self.neighbors is not None and self.neighbors.has_data()) or
                        (self.nsr is not None and self.nsr.has_data()) or
                        (self.parameters is not None and self.parameters.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()) or
                        (self.summary is not None and self.summary.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.afs is not None and self.afs.has_operation()) or
                        (self.backoff_parameters is not None and self.backoff_parameters.has_operation()) or
                        (self.backoffs is not None and self.backoffs.has_operation()) or
                        (self.capabilities is not None and self.capabilities.has_operation()) or
                        (self.graceful_restart is not None and self.graceful_restart.has_operation()) or
                        (self.issu is not None and self.issu.has_operation()) or
                        (self.ldp_id is not None and self.ldp_id.has_operation()) or
                        (self.neighbor_briefs is not None and self.neighbor_briefs.has_operation()) or
                        (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_operation()) or
                        (self.neighbors is not None and self.neighbors.has_operation()) or
                        (self.nsr is not None and self.nsr.has_operation()) or
                        (self.parameters is not None and self.parameters.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()) or
                        (self.summary is not None and self.summary.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "default-vrf" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "afs"):
                        if (self.afs is None):
                            self.afs = MplsLdp.Global_.Standby.DefaultVrf.Afs()
                            self.afs.parent = self
                            self._children_name_map["afs"] = "afs"
                        return self.afs

                    if (child_yang_name == "backoff-parameters"):
                        if (self.backoff_parameters is None):
                            self.backoff_parameters = MplsLdp.Global_.Standby.DefaultVrf.BackoffParameters()
                            self.backoff_parameters.parent = self
                            self._children_name_map["backoff_parameters"] = "backoff-parameters"
                        return self.backoff_parameters

                    if (child_yang_name == "backoffs"):
                        if (self.backoffs is None):
                            self.backoffs = MplsLdp.Global_.Standby.DefaultVrf.Backoffs()
                            self.backoffs.parent = self
                            self._children_name_map["backoffs"] = "backoffs"
                        return self.backoffs

                    if (child_yang_name == "capabilities"):
                        if (self.capabilities is None):
                            self.capabilities = MplsLdp.Global_.Standby.DefaultVrf.Capabilities()
                            self.capabilities.parent = self
                            self._children_name_map["capabilities"] = "capabilities"
                        return self.capabilities

                    if (child_yang_name == "graceful-restart"):
                        if (self.graceful_restart is None):
                            self.graceful_restart = MplsLdp.Global_.Standby.DefaultVrf.GracefulRestart()
                            self.graceful_restart.parent = self
                            self._children_name_map["graceful_restart"] = "graceful-restart"
                        return self.graceful_restart

                    if (child_yang_name == "issu"):
                        if (self.issu is None):
                            self.issu = MplsLdp.Global_.Standby.DefaultVrf.Issu()
                            self.issu.parent = self
                            self._children_name_map["issu"] = "issu"
                        return self.issu

                    if (child_yang_name == "ldp-id"):
                        if (self.ldp_id is None):
                            self.ldp_id = MplsLdp.Global_.Standby.DefaultVrf.LdpId()
                            self.ldp_id.parent = self
                            self._children_name_map["ldp_id"] = "ldp-id"
                        return self.ldp_id

                    if (child_yang_name == "neighbor-briefs"):
                        if (self.neighbor_briefs is None):
                            self.neighbor_briefs = MplsLdp.Global_.Standby.DefaultVrf.NeighborBriefs()
                            self.neighbor_briefs.parent = self
                            self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                        return self.neighbor_briefs

                    if (child_yang_name == "neighbor-capabilities"):
                        if (self.neighbor_capabilities is None):
                            self.neighbor_capabilities = MplsLdp.Global_.Standby.DefaultVrf.NeighborCapabilities()
                            self.neighbor_capabilities.parent = self
                            self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                        return self.neighbor_capabilities

                    if (child_yang_name == "neighbors"):
                        if (self.neighbors is None):
                            self.neighbors = MplsLdp.Global_.Standby.DefaultVrf.Neighbors()
                            self.neighbors.parent = self
                            self._children_name_map["neighbors"] = "neighbors"
                        return self.neighbors

                    if (child_yang_name == "nsr"):
                        if (self.nsr is None):
                            self.nsr = MplsLdp.Global_.Standby.DefaultVrf.Nsr()
                            self.nsr.parent = self
                            self._children_name_map["nsr"] = "nsr"
                        return self.nsr

                    if (child_yang_name == "parameters"):
                        if (self.parameters is None):
                            self.parameters = MplsLdp.Global_.Standby.DefaultVrf.Parameters()
                            self.parameters.parent = self
                            self._children_name_map["parameters"] = "parameters"
                        return self.parameters

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsLdp.Global_.Standby.DefaultVrf.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    if (child_yang_name == "summary"):
                        if (self.summary is None):
                            self.summary = MplsLdp.Global_.Standby.DefaultVrf.Summary()
                            self.summary.parent = self
                            self._children_name_map["summary"] = "summary"
                        return self.summary

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "afs" or name == "backoff-parameters" or name == "backoffs" or name == "capabilities" or name == "graceful-restart" or name == "issu" or name == "ldp-id" or name == "neighbor-briefs" or name == "neighbor-capabilities" or name == "neighbors" or name == "nsr" or name == "parameters" or name == "statistics" or name == "summary"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class ForwardingSummaryAll(Entity):
                """
                Summary information regarding LDP forwarding
                setup
                
                .. attribute:: fsht
                
                	Forwarding state hold time registered with LSD
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: intfs
                
                	MPLS forwarding enabled interface count
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: is_lsd_bound
                
                	LDP is connected to LSD server
                	**type**\:  bool
                
                .. attribute:: lbls
                
                	Local label allocated count
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: rws
                
                	Forwarding rewrites summary
                	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws>`
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.ForwardingSummaryAll, self).__init__()

                    self.yang_name = "forwarding-summary-all"
                    self.yang_parent_name = "standby"

                    self.fsht = YLeaf(YType.uint16, "fsht")

                    self.intfs = YLeaf(YType.uint16, "intfs")

                    self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                    self.lbls = YLeaf(YType.uint16, "lbls")

                    self.rws = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws()
                    self.rws.parent = self
                    self._children_name_map["rws"] = "rws"
                    self._children_yang_names.add("rws")

                    self.vrf = MplsLdp.Global_.Standby.ForwardingSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("fsht",
                                    "intfs",
                                    "is_lsd_bound",
                                    "lbls") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Standby.ForwardingSummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Standby.ForwardingSummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "forwarding-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/forwarding-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class Rws(Entity):
                    """
                    Forwarding rewrites summary
                    
                    .. attribute:: nhs
                    
                    	Forwarding rewrites nexthops (paths) summary
                    	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Nhs>`
                    
                    .. attribute:: pfxs
                    
                    	Forwarding rewrites prefix summary
                    	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws, self).__init__()

                        self.yang_name = "rws"
                        self.yang_parent_name = "forwarding-summary-all"

                        self.nhs = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Nhs()
                        self.nhs.parent = self
                        self._children_name_map["nhs"] = "nhs"
                        self._children_yang_names.add("nhs")

                        self.pfxs = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs()
                        self.pfxs.parent = self
                        self._children_name_map["pfxs"] = "pfxs"
                        self._children_yang_names.add("pfxs")


                    class Pfxs(Entity):
                        """
                        Forwarding rewrites prefix summary
                        
                        .. attribute:: ecmp_pfxs
                        
                        	Count of prefixes with ECMP
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: labeled_pfxs_aggr
                        
                        	Labeled prefix count for all paths
                        	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr>`
                        
                        .. attribute:: labeled_pfxs_backup
                        
                        	Labeled prefix count related to backup paths only
                        	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup>`
                        
                        .. attribute:: labeled_pfxs_primary
                        
                        	Labeled prefix count related to primary paths only
                        	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary>`
                        
                        .. attribute:: protected_pfxs
                        
                        	Count of FRR protected prefixes
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: total_pfxs
                        
                        	Total Prefix count
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs, self).__init__()

                            self.yang_name = "pfxs"
                            self.yang_parent_name = "rws"

                            self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                            self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                            self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                            self.labeled_pfxs_aggr = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr()
                            self.labeled_pfxs_aggr.parent = self
                            self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                            self._children_yang_names.add("labeled-pfxs-aggr")

                            self.labeled_pfxs_backup = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup()
                            self.labeled_pfxs_backup.parent = self
                            self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                            self._children_yang_names.add("labeled-pfxs-backup")

                            self.labeled_pfxs_primary = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary()
                            self.labeled_pfxs_primary.parent = self
                            self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                            self._children_yang_names.add("labeled-pfxs-primary")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ecmp_pfxs",
                                            "protected_pfxs",
                                            "total_pfxs") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs, self).__setattr__(name, value)


                        class LabeledPfxsAggr(Entity):
                            """
                            Labeled prefix count for all paths
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                self.yang_name = "labeled-pfxs-aggr"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-aggr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/forwarding-summary-all/rws/pfxs/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                        class LabeledPfxsPrimary(Entity):
                            """
                            Labeled prefix count related to primary paths
                            only
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                self.yang_name = "labeled-pfxs-primary"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-primary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/forwarding-summary-all/rws/pfxs/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                        class LabeledPfxsBackup(Entity):
                            """
                            Labeled prefix count related to backup paths
                            only
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                self.yang_name = "labeled-pfxs-backup"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-backup" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/forwarding-summary-all/rws/pfxs/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ecmp_pfxs.is_set or
                                self.protected_pfxs.is_set or
                                self.total_pfxs.is_set or
                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ecmp_pfxs.yfilter != YFilter.not_set or
                                self.protected_pfxs.yfilter != YFilter.not_set or
                                self.total_pfxs.yfilter != YFilter.not_set or
                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pfxs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/forwarding-summary-all/rws/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                            if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                            if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "labeled-pfxs-aggr"):
                                if (self.labeled_pfxs_aggr is None):
                                    self.labeled_pfxs_aggr = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr()
                                    self.labeled_pfxs_aggr.parent = self
                                    self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                return self.labeled_pfxs_aggr

                            if (child_yang_name == "labeled-pfxs-backup"):
                                if (self.labeled_pfxs_backup is None):
                                    self.labeled_pfxs_backup = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup()
                                    self.labeled_pfxs_backup.parent = self
                                    self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                return self.labeled_pfxs_backup

                            if (child_yang_name == "labeled-pfxs-primary"):
                                if (self.labeled_pfxs_primary is None):
                                    self.labeled_pfxs_primary = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary()
                                    self.labeled_pfxs_primary.parent = self
                                    self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                return self.labeled_pfxs_primary

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ecmp-pfxs"):
                                self.ecmp_pfxs = value
                                self.ecmp_pfxs.value_namespace = name_space
                                self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-pfxs"):
                                self.protected_pfxs = value
                                self.protected_pfxs.value_namespace = name_space
                                self.protected_pfxs.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-pfxs"):
                                self.total_pfxs = value
                                self.total_pfxs.value_namespace = name_space
                                self.total_pfxs.value_namespace_prefix = name_space_prefix


                    class Nhs(Entity):
                        """
                        Forwarding rewrites nexthops (paths) summary
                        
                        .. attribute:: backup_paths
                        
                        	Count of non\-primary backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: labeled_backup_paths
                        
                        	Count of labeled backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: labeled_paths
                        
                        	Count of all labeled paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: protected_paths
                        
                        	Count of FRR protected paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remote_backup_paths
                        
                        	Count of non\-primary remote backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_paths
                        
                        	Total path count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Nhs, self).__init__()

                            self.yang_name = "nhs"
                            self.yang_parent_name = "rws"

                            self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                            self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                            self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                            self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                            self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                            self.total_paths = YLeaf(YType.uint32, "total-paths")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_paths",
                                            "labeled_backup_paths",
                                            "labeled_paths",
                                            "protected_paths",
                                            "remote_backup_paths",
                                            "total_paths") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Nhs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Nhs, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backup_paths.is_set or
                                self.labeled_backup_paths.is_set or
                                self.labeled_paths.is_set or
                                self.protected_paths.is_set or
                                self.remote_backup_paths.is_set or
                                self.total_paths.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_paths.yfilter != YFilter.not_set or
                                self.labeled_backup_paths.yfilter != YFilter.not_set or
                                self.labeled_paths.yfilter != YFilter.not_set or
                                self.protected_paths.yfilter != YFilter.not_set or
                                self.remote_backup_paths.yfilter != YFilter.not_set or
                                self.total_paths.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nhs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/forwarding-summary-all/rws/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_paths.get_name_leafdata())
                            if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                            if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                            if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_paths.get_name_leafdata())
                            if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                            if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_paths.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-paths"):
                                self.backup_paths = value
                                self.backup_paths.value_namespace = name_space
                                self.backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "labeled-backup-paths"):
                                self.labeled_backup_paths = value
                                self.labeled_backup_paths.value_namespace = name_space
                                self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "labeled-paths"):
                                self.labeled_paths = value
                                self.labeled_paths.value_namespace = name_space
                                self.labeled_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-paths"):
                                self.protected_paths = value
                                self.protected_paths.value_namespace = name_space
                                self.protected_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-backup-paths"):
                                self.remote_backup_paths = value
                                self.remote_backup_paths.value_namespace = name_space
                                self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-paths"):
                                self.total_paths = value
                                self.total_paths.value_namespace = name_space
                                self.total_paths.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.nhs is not None and self.nhs.has_data()) or
                            (self.pfxs is not None and self.pfxs.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.nhs is not None and self.nhs.has_operation()) or
                            (self.pfxs is not None and self.pfxs.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rws" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/forwarding-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "nhs"):
                            if (self.nhs is None):
                                self.nhs = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Nhs()
                                self.nhs.parent = self
                                self._children_name_map["nhs"] = "nhs"
                            return self.nhs

                        if (child_yang_name == "pfxs"):
                            if (self.pfxs is None):
                                self.pfxs = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws.Pfxs()
                                self.pfxs.parent = self
                                self._children_name_map["pfxs"] = "pfxs"
                            return self.pfxs

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nhs" or name == "pfxs"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.fsht.is_set or
                        self.intfs.is_set or
                        self.is_lsd_bound.is_set or
                        self.lbls.is_set or
                        (self.rws is not None and self.rws.has_data()) or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.fsht.yfilter != YFilter.not_set or
                        self.intfs.yfilter != YFilter.not_set or
                        self.is_lsd_bound.yfilter != YFilter.not_set or
                        self.lbls.yfilter != YFilter.not_set or
                        (self.rws is not None and self.rws.has_operation()) or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "forwarding-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.fsht.get_name_leafdata())
                    if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.intfs.get_name_leafdata())
                    if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                    if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lbls.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "rws"):
                        if (self.rws is None):
                            self.rws = MplsLdp.Global_.Standby.ForwardingSummaryAll.Rws()
                            self.rws.parent = self
                            self._children_name_map["rws"] = "rws"
                        return self.rws

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Standby.ForwardingSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "fsht"):
                        self.fsht = value
                        self.fsht.value_namespace = name_space
                        self.fsht.value_namespace_prefix = name_space_prefix
                    if(value_path == "intfs"):
                        self.intfs = value
                        self.intfs.value_namespace = name_space
                        self.intfs.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-lsd-bound"):
                        self.is_lsd_bound = value
                        self.is_lsd_bound.value_namespace = name_space
                        self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                    if(value_path == "lbls"):
                        self.lbls = value
                        self.lbls.value_namespace = name_space
                        self.lbls.value_namespace_prefix = name_space_prefix


            class BindingsSummaryAll(Entity):
                """
                Aggregate VRF counters for the LDP Label
                Infomation Base (LIB)
                
                .. attribute:: address_family
                
                	Address Family
                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                
                .. attribute:: bind_af
                
                	bind af
                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.BindingsSummaryAll.BindAf>`
                
                .. attribute:: binding_local_explicit_null
                
                	Number of local explicit null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_implicit_null
                
                	Number of local implicit null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_no_route
                
                	Local bindings with no route
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_non_null
                
                	Number of local non\-null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_null
                
                	Number of local null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_oor
                
                	Number of local bindings        needing label \- OOR
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_no_route
                
                	Bindings with no route
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: highest_allocated_label
                
                	Highest allocated label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lowest_allocated_label
                
                	Lowest allocated label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.BindingsSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.BindingsSummaryAll, self).__init__()

                    self.yang_name = "bindings-summary-all"
                    self.yang_parent_name = "standby"

                    self.address_family = YLeaf(YType.enumeration, "address-family")

                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                    self.vrf = MplsLdp.Global_.Standby.BindingsSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                    self.bind_af = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address_family",
                                    "binding_local_explicit_null",
                                    "binding_local_implicit_null",
                                    "binding_local_no_route",
                                    "binding_local_non_null",
                                    "binding_local_null",
                                    "binding_local_oor",
                                    "binding_no_route",
                                    "highest_allocated_label",
                                    "lowest_allocated_label") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Standby.BindingsSummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Standby.BindingsSummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.BindingsSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "bindings-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/bindings-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class BindAf(Entity):
                    """
                    bind af
                    
                    .. attribute:: address_family
                    
                    	Binding Summary Address Family
                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                    
                    .. attribute:: binding_local
                    
                    	Number of local bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: binding_remote
                    
                    	Number of remote bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: binding_total
                    
                    	Total bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: last_lib_update
                    
                    	Last update to LIB local binding
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lib_minimum_revision_sent_all
                    
                    	Last update sent to all peers
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.BindingsSummaryAll.BindAf, self).__init__()

                        self.yang_name = "bind-af"
                        self.yang_parent_name = "bindings-summary-all"

                        self.address_family = YLeaf(YType.enumeration, "address-family")

                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_family",
                                        "binding_local",
                                        "binding_remote",
                                        "binding_total",
                                        "last_lib_update",
                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_family.is_set or
                            self.binding_local.is_set or
                            self.binding_remote.is_set or
                            self.binding_total.is_set or
                            self.last_lib_update.is_set or
                            self.lib_minimum_revision_sent_all.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_family.yfilter != YFilter.not_set or
                            self.binding_local.yfilter != YFilter.not_set or
                            self.binding_remote.yfilter != YFilter.not_set or
                            self.binding_total.yfilter != YFilter.not_set or
                            self.last_lib_update.yfilter != YFilter.not_set or
                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bind-af" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/bindings-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_family.get_name_leafdata())
                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-family"):
                            self.address_family = value
                            self.address_family.value_namespace = name_space
                            self.address_family.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-local"):
                            self.binding_local = value
                            self.binding_local.value_namespace = name_space
                            self.binding_local.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-remote"):
                            self.binding_remote = value
                            self.binding_remote.value_namespace = name_space
                            self.binding_remote.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-total"):
                            self.binding_total = value
                            self.binding_total.value_namespace = name_space
                            self.binding_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-lib-update"):
                            self.last_lib_update = value
                            self.last_lib_update.value_namespace = name_space
                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                        if(value_path == "lib-minimum-revision-sent-all"):
                            self.lib_minimum_revision_sent_all = value
                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.bind_af:
                        if (c.has_data()):
                            return True
                    return (
                        self.address_family.is_set or
                        self.binding_local_explicit_null.is_set or
                        self.binding_local_implicit_null.is_set or
                        self.binding_local_no_route.is_set or
                        self.binding_local_non_null.is_set or
                        self.binding_local_null.is_set or
                        self.binding_local_oor.is_set or
                        self.binding_no_route.is_set or
                        self.highest_allocated_label.is_set or
                        self.lowest_allocated_label.is_set or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    for c in self.bind_af:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address_family.yfilter != YFilter.not_set or
                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                        self.binding_local_no_route.yfilter != YFilter.not_set or
                        self.binding_local_non_null.yfilter != YFilter.not_set or
                        self.binding_local_null.yfilter != YFilter.not_set or
                        self.binding_local_oor.yfilter != YFilter.not_set or
                        self.binding_no_route.yfilter != YFilter.not_set or
                        self.highest_allocated_label.yfilter != YFilter.not_set or
                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bindings-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.address_family.get_name_leafdata())
                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "bind-af"):
                        for c in self.bind_af:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Global_.Standby.BindingsSummaryAll.BindAf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.bind_af.append(c)
                        return c

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Standby.BindingsSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address-family"):
                        self.address_family = value
                        self.address_family.value_namespace = name_space
                        self.address_family.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-explicit-null"):
                        self.binding_local_explicit_null = value
                        self.binding_local_explicit_null.value_namespace = name_space
                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-implicit-null"):
                        self.binding_local_implicit_null = value
                        self.binding_local_implicit_null.value_namespace = name_space
                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-no-route"):
                        self.binding_local_no_route = value
                        self.binding_local_no_route.value_namespace = name_space
                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-non-null"):
                        self.binding_local_non_null = value
                        self.binding_local_non_null.value_namespace = name_space
                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-null"):
                        self.binding_local_null = value
                        self.binding_local_null.value_namespace = name_space
                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-oor"):
                        self.binding_local_oor = value
                        self.binding_local_oor.value_namespace = name_space
                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-no-route"):
                        self.binding_no_route = value
                        self.binding_no_route.value_namespace = name_space
                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "highest-allocated-label"):
                        self.highest_allocated_label = value
                        self.highest_allocated_label.value_namespace = name_space
                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lowest-allocated-label"):
                        self.lowest_allocated_label = value
                        self.lowest_allocated_label.value_namespace = name_space
                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


            class AtoMdbTableEntries(Entity):
                """
                AToM DB Table
                
                .. attribute:: ato_mdb_table_entry
                
                	Entries in AToM DB
                	**type**\: list of    :py:class:`AtoMdbTableEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries, self).__init__()

                    self.yang_name = "ato-mdb-table-entries"
                    self.yang_parent_name = "standby"

                    self.ato_mdb_table_entry = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries, self).__setattr__(name, value)


                class AtoMdbTableEntry(Entity):
                    """
                    Entries in AToM DB
                    
                    .. attribute:: agi
                    
                    	AGI
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: agi_type
                    
                    	AGI Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: fe_ctype
                    
                    	FEC Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: fec_info
                    
                    	Pseudowire FEC information
                    	**type**\:   :py:class:`FecInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo>`
                    
                    .. attribute:: mapping_tlv_count
                    
                    	TLV Count from Label Mapping Message
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: notification_tlv_count
                    
                    	TLV Count from Notification Message
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: peer_id
                    
                    	Peer ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: peer_id_xr
                    
                    	Peer ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: pw_id
                    
                    	PW ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_ac_id
                    
                    	SAII AC ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_global_id
                    
                    	SAII Global ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_local_id
                    
                    	SAII Local ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: saii_prefix
                    
                    	SAII Prefix
                    	**type**\:  str
                    
                    	**pattern:** [0\-9a\-fA\-F]{1,8}
                    
                    .. attribute:: saii_type
                    
                    	SAII Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_ac_id
                    
                    	TAII AC ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_global_id
                    
                    	TAII Global ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_local_id
                    
                    	TAII Local ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: taii_prefix
                    
                    	TAII Prefix
                    	**type**\:  str
                    
                    	**pattern:** [0\-9a\-fA\-F]{1,8}
                    
                    .. attribute:: taii_type
                    
                    	TAII Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry, self).__init__()

                        self.yang_name = "ato-mdb-table-entry"
                        self.yang_parent_name = "ato-mdb-table-entries"

                        self.agi = YLeaf(YType.int32, "agi")

                        self.agi_type = YLeaf(YType.int32, "agi-type")

                        self.fe_ctype = YLeaf(YType.int32, "fe-ctype")

                        self.mapping_tlv_count = YLeaf(YType.uint32, "mapping-tlv-count")

                        self.notification_tlv_count = YLeaf(YType.uint32, "notification-tlv-count")

                        self.peer_id = YLeaf(YType.str, "peer-id")

                        self.peer_id_xr = YLeaf(YType.str, "peer-id-xr")

                        self.pw_id = YLeaf(YType.int32, "pw-id")

                        self.saii_ac_id = YLeaf(YType.int32, "saii-ac-id")

                        self.saii_global_id = YLeaf(YType.int32, "saii-global-id")

                        self.saii_local_id = YLeaf(YType.str, "saii-local-id")

                        self.saii_prefix = YLeaf(YType.str, "saii-prefix")

                        self.saii_type = YLeaf(YType.int32, "saii-type")

                        self.taii_ac_id = YLeaf(YType.int32, "taii-ac-id")

                        self.taii_global_id = YLeaf(YType.int32, "taii-global-id")

                        self.taii_local_id = YLeaf(YType.str, "taii-local-id")

                        self.taii_prefix = YLeaf(YType.str, "taii-prefix")

                        self.taii_type = YLeaf(YType.int32, "taii-type")

                        self.fec_info = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo()
                        self.fec_info.parent = self
                        self._children_name_map["fec_info"] = "fec-info"
                        self._children_yang_names.add("fec-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("agi",
                                        "agi_type",
                                        "fe_ctype",
                                        "mapping_tlv_count",
                                        "notification_tlv_count",
                                        "peer_id",
                                        "peer_id_xr",
                                        "pw_id",
                                        "saii_ac_id",
                                        "saii_global_id",
                                        "saii_local_id",
                                        "saii_prefix",
                                        "saii_type",
                                        "taii_ac_id",
                                        "taii_global_id",
                                        "taii_local_id",
                                        "taii_prefix",
                                        "taii_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry, self).__setattr__(name, value)


                    class FecInfo(Entity):
                        """
                        Pseudowire FEC information
                        
                        .. attribute:: fe_ctype
                        
                        	FECType
                        	**type**\:   :py:class:`L2VpnLdpPwFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwFec>`
                        
                        .. attribute:: fec128
                        
                        	fec128
                        	**type**\:   :py:class:`Fec128 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128>`
                        
                        .. attribute:: fec129
                        
                        	fec129
                        	**type**\:   :py:class:`Fec129 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129>`
                        
                        .. attribute:: fec130
                        
                        	fec130
                        	**type**\:   :py:class:`Fec130 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__init__()

                            self.yang_name = "fec-info"
                            self.yang_parent_name = "ato-mdb-table-entry"

                            self.fe_ctype = YLeaf(YType.enumeration, "fe-ctype")

                            self.fec128 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128()
                            self.fec128.parent = self
                            self._children_name_map["fec128"] = "fec128"
                            self._children_yang_names.add("fec128")

                            self.fec129 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129()
                            self.fec129.parent = self
                            self._children_name_map["fec129"] = "fec129"
                            self._children_yang_names.add("fec129")

                            self.fec130 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130()
                            self.fec130.parent = self
                            self._children_name_map["fec130"] = "fec130"
                            self._children_yang_names.add("fec130")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fe_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__setattr__(name, value)


                        class Fec128(Entity):
                            """
                            fec128
                            
                            .. attribute:: pseudowire_id
                            
                            	Pseudowire ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__init__()

                                self.yang_name = "fec128"
                                self.yang_parent_name = "fec-info"

                                self.pseudowire_id = YLeaf(YType.uint32, "pseudowire-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pseudowire_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pseudowire_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pseudowire_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec128" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pseudowire_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pseudowire-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pseudowire-id"):
                                    self.pseudowire_id = value
                                    self.pseudowire_id.value_namespace = name_space
                                    self.pseudowire_id.value_namespace_prefix = name_space_prefix


                        class Fec129(Entity):
                            """
                            fec129
                            
                            .. attribute:: agi
                            
                            	AGI
                            	**type**\:   :py:class:`Agi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi>`
                            
                            .. attribute:: saii
                            
                            	Source Attachment Individual Identifier
                            	**type**\:   :py:class:`Saii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii>`
                            
                            .. attribute:: taii
                            
                            	Target Attachment Individual Identifier
                            	**type**\:   :py:class:`Taii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129, self).__init__()

                                self.yang_name = "fec129"
                                self.yang_parent_name = "fec-info"

                                self.agi = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi()
                                self.agi.parent = self
                                self._children_name_map["agi"] = "agi"
                                self._children_yang_names.add("agi")

                                self.saii = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii()
                                self.saii.parent = self
                                self._children_name_map["saii"] = "saii"
                                self._children_yang_names.add("saii")

                                self.taii = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii()
                                self.taii.parent = self
                                self._children_name_map["taii"] = "taii"
                                self._children_yang_names.add("taii")


                            class Agi(Entity):
                                """
                                AGI
                                
                                .. attribute:: agi1
                                
                                	agi1
                                	**type**\:   :py:class:`Agi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1>`
                                
                                .. attribute:: agi_type
                                
                                	AGIType
                                	**type**\:   :py:class:`L2VpnLdpPwAgi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAgi>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__init__()

                                    self.yang_name = "agi"
                                    self.yang_parent_name = "fec129"

                                    self.agi_type = YLeaf(YType.enumeration, "agi-type")

                                    self.agi1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1()
                                    self.agi1.parent = self
                                    self._children_name_map["agi1"] = "agi1"
                                    self._children_yang_names.add("agi1")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("agi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__setattr__(name, value)


                                class Agi1(Entity):
                                    """
                                    agi1
                                    
                                    .. attribute:: rd
                                    
                                    	Route Distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__init__()

                                        self.yang_name = "agi1"
                                        self.yang_parent_name = "agi"

                                        self.rd = YLeaf(YType.uint64, "rd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.rd.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "agi1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/agi/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rd.is_set or self.rd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rd"):
                                            self.rd = value
                                            self.rd.value_namespace = name_space
                                            self.rd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.agi_type.is_set or
                                        (self.agi1 is not None and self.agi1.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.agi_type.yfilter != YFilter.not_set or
                                        (self.agi1 is not None and self.agi1.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "agi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.agi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "agi1"):
                                        if (self.agi1 is None):
                                            self.agi1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1()
                                            self.agi1.parent = self
                                            self._children_name_map["agi1"] = "agi1"
                                        return self.agi1

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "agi1" or name == "agi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "agi-type"):
                                        self.agi_type = value
                                        self.agi_type.value_namespace = name_space
                                        self.agi_type.value_namespace_prefix = name_space_prefix


                            class Saii(Entity):
                                """
                                Source Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__init__()

                                    self.yang_name = "saii"
                                    self.yang_parent_name = "fec129"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "saii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "saii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "saii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix


                            class Taii(Entity):
                                """
                                Target Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__init__()

                                    self.yang_name = "taii"
                                    self.yang_parent_name = "fec129"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "taii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/taii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "taii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/taii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "taii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.agi is not None and self.agi.has_data()) or
                                    (self.saii is not None and self.saii.has_data()) or
                                    (self.taii is not None and self.taii.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.agi is not None and self.agi.has_operation()) or
                                    (self.saii is not None and self.saii.has_operation()) or
                                    (self.taii is not None and self.taii.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec129" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "agi"):
                                    if (self.agi is None):
                                        self.agi = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi()
                                        self.agi.parent = self
                                        self._children_name_map["agi"] = "agi"
                                    return self.agi

                                if (child_yang_name == "saii"):
                                    if (self.saii is None):
                                        self.saii = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii()
                                        self.saii.parent = self
                                        self._children_name_map["saii"] = "saii"
                                    return self.saii

                                if (child_yang_name == "taii"):
                                    if (self.taii is None):
                                        self.taii = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii()
                                        self.taii.parent = self
                                        self._children_name_map["taii"] = "taii"
                                    return self.taii

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "agi" or name == "saii" or name == "taii"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Fec130(Entity):
                            """
                            fec130
                            
                            .. attribute:: agi
                            
                            	AGI
                            	**type**\:   :py:class:`Agi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi>`
                            
                            .. attribute:: saii
                            
                            	Source Attachment Individual Identifier
                            	**type**\:   :py:class:`Saii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130, self).__init__()

                                self.yang_name = "fec130"
                                self.yang_parent_name = "fec-info"

                                self.agi = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi()
                                self.agi.parent = self
                                self._children_name_map["agi"] = "agi"
                                self._children_yang_names.add("agi")

                                self.saii = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii()
                                self.saii.parent = self
                                self._children_name_map["saii"] = "saii"
                                self._children_yang_names.add("saii")


                            class Agi(Entity):
                                """
                                AGI
                                
                                .. attribute:: agi1
                                
                                	agi1
                                	**type**\:   :py:class:`Agi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1>`
                                
                                .. attribute:: agi_type
                                
                                	AGIType
                                	**type**\:   :py:class:`L2VpnLdpPwAgi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAgi>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__init__()

                                    self.yang_name = "agi"
                                    self.yang_parent_name = "fec130"

                                    self.agi_type = YLeaf(YType.enumeration, "agi-type")

                                    self.agi1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1()
                                    self.agi1.parent = self
                                    self._children_name_map["agi1"] = "agi1"
                                    self._children_yang_names.add("agi1")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("agi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__setattr__(name, value)


                                class Agi1(Entity):
                                    """
                                    agi1
                                    
                                    .. attribute:: rd
                                    
                                    	Route Distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__init__()

                                        self.yang_name = "agi1"
                                        self.yang_parent_name = "agi"

                                        self.rd = YLeaf(YType.uint64, "rd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.rd.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "agi1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/agi/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rd.is_set or self.rd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rd"):
                                            self.rd = value
                                            self.rd.value_namespace = name_space
                                            self.rd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.agi_type.is_set or
                                        (self.agi1 is not None and self.agi1.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.agi_type.yfilter != YFilter.not_set or
                                        (self.agi1 is not None and self.agi1.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "agi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.agi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "agi1"):
                                        if (self.agi1 is None):
                                            self.agi1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1()
                                            self.agi1.parent = self
                                            self._children_name_map["agi1"] = "agi1"
                                        return self.agi1

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "agi1" or name == "agi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "agi-type"):
                                        self.agi_type = value
                                        self.agi_type.value_namespace = name_space
                                        self.agi_type.value_namespace_prefix = name_space_prefix


                            class Saii(Entity):
                                """
                                Source Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__init__()

                                    self.yang_name = "saii"
                                    self.yang_parent_name = "fec130"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "saii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "saii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "saii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.agi is not None and self.agi.has_data()) or
                                    (self.saii is not None and self.saii.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.agi is not None and self.agi.has_operation()) or
                                    (self.saii is not None and self.saii.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec130" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "agi"):
                                    if (self.agi is None):
                                        self.agi = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi()
                                        self.agi.parent = self
                                        self._children_name_map["agi"] = "agi"
                                    return self.agi

                                if (child_yang_name == "saii"):
                                    if (self.saii is None):
                                        self.saii = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii()
                                        self.saii.parent = self
                                        self._children_name_map["saii"] = "saii"
                                    return self.saii

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "agi" or name == "saii"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.fe_ctype.is_set or
                                (self.fec128 is not None and self.fec128.has_data()) or
                                (self.fec129 is not None and self.fec129.has_data()) or
                                (self.fec130 is not None and self.fec130.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fe_ctype.yfilter != YFilter.not_set or
                                (self.fec128 is not None and self.fec128.has_operation()) or
                                (self.fec129 is not None and self.fec129.has_operation()) or
                                (self.fec130 is not None and self.fec130.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/ato-mdb-table-entry/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fe_ctype.is_set or self.fe_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fe_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec128"):
                                if (self.fec128 is None):
                                    self.fec128 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128()
                                    self.fec128.parent = self
                                    self._children_name_map["fec128"] = "fec128"
                                return self.fec128

                            if (child_yang_name == "fec129"):
                                if (self.fec129 is None):
                                    self.fec129 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129()
                                    self.fec129.parent = self
                                    self._children_name_map["fec129"] = "fec129"
                                return self.fec129

                            if (child_yang_name == "fec130"):
                                if (self.fec130 is None):
                                    self.fec130 = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130()
                                    self.fec130.parent = self
                                    self._children_name_map["fec130"] = "fec130"
                                return self.fec130

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec128" or name == "fec129" or name == "fec130" or name == "fe-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fe-ctype"):
                                self.fe_ctype = value
                                self.fe_ctype.value_namespace = name_space
                                self.fe_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.agi.is_set or
                            self.agi_type.is_set or
                            self.fe_ctype.is_set or
                            self.mapping_tlv_count.is_set or
                            self.notification_tlv_count.is_set or
                            self.peer_id.is_set or
                            self.peer_id_xr.is_set or
                            self.pw_id.is_set or
                            self.saii_ac_id.is_set or
                            self.saii_global_id.is_set or
                            self.saii_local_id.is_set or
                            self.saii_prefix.is_set or
                            self.saii_type.is_set or
                            self.taii_ac_id.is_set or
                            self.taii_global_id.is_set or
                            self.taii_local_id.is_set or
                            self.taii_prefix.is_set or
                            self.taii_type.is_set or
                            (self.fec_info is not None and self.fec_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.agi.yfilter != YFilter.not_set or
                            self.agi_type.yfilter != YFilter.not_set or
                            self.fe_ctype.yfilter != YFilter.not_set or
                            self.mapping_tlv_count.yfilter != YFilter.not_set or
                            self.notification_tlv_count.yfilter != YFilter.not_set or
                            self.peer_id.yfilter != YFilter.not_set or
                            self.peer_id_xr.yfilter != YFilter.not_set or
                            self.pw_id.yfilter != YFilter.not_set or
                            self.saii_ac_id.yfilter != YFilter.not_set or
                            self.saii_global_id.yfilter != YFilter.not_set or
                            self.saii_local_id.yfilter != YFilter.not_set or
                            self.saii_prefix.yfilter != YFilter.not_set or
                            self.saii_type.yfilter != YFilter.not_set or
                            self.taii_ac_id.yfilter != YFilter.not_set or
                            self.taii_global_id.yfilter != YFilter.not_set or
                            self.taii_local_id.yfilter != YFilter.not_set or
                            self.taii_prefix.yfilter != YFilter.not_set or
                            self.taii_type.yfilter != YFilter.not_set or
                            (self.fec_info is not None and self.fec_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ato-mdb-table-entry" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/ato-mdb-table-entries/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.agi.is_set or self.agi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.agi.get_name_leafdata())
                        if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.agi_type.get_name_leafdata())
                        if (self.fe_ctype.is_set or self.fe_ctype.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fe_ctype.get_name_leafdata())
                        if (self.mapping_tlv_count.is_set or self.mapping_tlv_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mapping_tlv_count.get_name_leafdata())
                        if (self.notification_tlv_count.is_set or self.notification_tlv_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.notification_tlv_count.get_name_leafdata())
                        if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.peer_id.get_name_leafdata())
                        if (self.peer_id_xr.is_set or self.peer_id_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.peer_id_xr.get_name_leafdata())
                        if (self.pw_id.is_set or self.pw_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pw_id.get_name_leafdata())
                        if (self.saii_ac_id.is_set or self.saii_ac_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_ac_id.get_name_leafdata())
                        if (self.saii_global_id.is_set or self.saii_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_global_id.get_name_leafdata())
                        if (self.saii_local_id.is_set or self.saii_local_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_local_id.get_name_leafdata())
                        if (self.saii_prefix.is_set or self.saii_prefix.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_prefix.get_name_leafdata())
                        if (self.saii_type.is_set or self.saii_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_type.get_name_leafdata())
                        if (self.taii_ac_id.is_set or self.taii_ac_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_ac_id.get_name_leafdata())
                        if (self.taii_global_id.is_set or self.taii_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_global_id.get_name_leafdata())
                        if (self.taii_local_id.is_set or self.taii_local_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_local_id.get_name_leafdata())
                        if (self.taii_prefix.is_set or self.taii_prefix.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_prefix.get_name_leafdata())
                        if (self.taii_type.is_set or self.taii_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-info"):
                            if (self.fec_info is None):
                                self.fec_info = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo()
                                self.fec_info.parent = self
                                self._children_name_map["fec_info"] = "fec-info"
                            return self.fec_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-info" or name == "agi" or name == "agi-type" or name == "fe-ctype" or name == "mapping-tlv-count" or name == "notification-tlv-count" or name == "peer-id" or name == "peer-id-xr" or name == "pw-id" or name == "saii-ac-id" or name == "saii-global-id" or name == "saii-local-id" or name == "saii-prefix" or name == "saii-type" or name == "taii-ac-id" or name == "taii-global-id" or name == "taii-local-id" or name == "taii-prefix" or name == "taii-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "agi"):
                            self.agi = value
                            self.agi.value_namespace = name_space
                            self.agi.value_namespace_prefix = name_space_prefix
                        if(value_path == "agi-type"):
                            self.agi_type = value
                            self.agi_type.value_namespace = name_space
                            self.agi_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "fe-ctype"):
                            self.fe_ctype = value
                            self.fe_ctype.value_namespace = name_space
                            self.fe_ctype.value_namespace_prefix = name_space_prefix
                        if(value_path == "mapping-tlv-count"):
                            self.mapping_tlv_count = value
                            self.mapping_tlv_count.value_namespace = name_space
                            self.mapping_tlv_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "notification-tlv-count"):
                            self.notification_tlv_count = value
                            self.notification_tlv_count.value_namespace = name_space
                            self.notification_tlv_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "peer-id"):
                            self.peer_id = value
                            self.peer_id.value_namespace = name_space
                            self.peer_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "peer-id-xr"):
                            self.peer_id_xr = value
                            self.peer_id_xr.value_namespace = name_space
                            self.peer_id_xr.value_namespace_prefix = name_space_prefix
                        if(value_path == "pw-id"):
                            self.pw_id = value
                            self.pw_id.value_namespace = name_space
                            self.pw_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-ac-id"):
                            self.saii_ac_id = value
                            self.saii_ac_id.value_namespace = name_space
                            self.saii_ac_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-global-id"):
                            self.saii_global_id = value
                            self.saii_global_id.value_namespace = name_space
                            self.saii_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-local-id"):
                            self.saii_local_id = value
                            self.saii_local_id.value_namespace = name_space
                            self.saii_local_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-prefix"):
                            self.saii_prefix = value
                            self.saii_prefix.value_namespace = name_space
                            self.saii_prefix.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-type"):
                            self.saii_type = value
                            self.saii_type.value_namespace = name_space
                            self.saii_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-ac-id"):
                            self.taii_ac_id = value
                            self.taii_ac_id.value_namespace = name_space
                            self.taii_ac_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-global-id"):
                            self.taii_global_id = value
                            self.taii_global_id.value_namespace = name_space
                            self.taii_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-local-id"):
                            self.taii_local_id = value
                            self.taii_local_id.value_namespace = name_space
                            self.taii_local_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-prefix"):
                            self.taii_prefix = value
                            self.taii_prefix.value_namespace = name_space
                            self.taii_prefix.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-type"):
                            self.taii_type = value
                            self.taii_type.value_namespace = name_space
                            self.taii_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.ato_mdb_table_entry:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.ato_mdb_table_entry:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ato-mdb-table-entries" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ato-mdb-table-entry"):
                        for c in self.ato_mdb_table_entry:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Global_.Standby.AtoMdbTableEntries.AtoMdbTableEntry()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.ato_mdb_table_entry.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ato-mdb-table-entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class NsrSummaryAll(Entity):
                """
                Summary information regarding LDP NSR State
                
                .. attribute:: sessions
                
                	Session summary
                	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.NsrSummaryAll.Sessions>`
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.NsrSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.NsrSummaryAll, self).__init__()

                    self.yang_name = "nsr-summary-all"
                    self.yang_parent_name = "standby"

                    self.sessions = MplsLdp.Global_.Standby.NsrSummaryAll.Sessions()
                    self.sessions.parent = self
                    self._children_name_map["sessions"] = "sessions"
                    self._children_yang_names.add("sessions")

                    self.vrf = MplsLdp.Global_.Standby.NsrSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.NsrSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "nsr-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.NsrSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.NsrSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/nsr-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class Sessions(Entity):
                    """
                    Session summary
                    
                    .. attribute:: nsr_eligible
                    
                    	NSR eligible sessions
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_app_wait
                    
                    	Number of sessions in NSR app\-wait state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_none
                    
                    	Number of sessions in NSR none state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_operational
                    
                    	Number of sessions in NSR operational state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_prepare
                    
                    	Number of sessions in NSR prepare state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_ready
                    
                    	Number of sessions in NSR ready state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_tcp_phase1
                    
                    	Number of sessions in NSR TCP phase 1 state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_tcp_phase2
                    
                    	Number of sessions in NSR TCP phase 2 state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_wait
                    
                    	Number of sessions in NSR wait state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total
                    
                    	Total sessions
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.NsrSummaryAll.Sessions, self).__init__()

                        self.yang_name = "sessions"
                        self.yang_parent_name = "nsr-summary-all"

                        self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                        self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                        self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                        self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                        self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                        self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                        self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                        self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                        self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                        self.total = YLeaf(YType.uint32, "total")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("nsr_eligible",
                                        "nsr_state_app_wait",
                                        "nsr_state_none",
                                        "nsr_state_operational",
                                        "nsr_state_prepare",
                                        "nsr_state_ready",
                                        "nsr_state_tcp_phase1",
                                        "nsr_state_tcp_phase2",
                                        "nsr_state_wait",
                                        "total") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.NsrSummaryAll.Sessions, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.NsrSummaryAll.Sessions, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.nsr_eligible.is_set or
                            self.nsr_state_app_wait.is_set or
                            self.nsr_state_none.is_set or
                            self.nsr_state_operational.is_set or
                            self.nsr_state_prepare.is_set or
                            self.nsr_state_ready.is_set or
                            self.nsr_state_tcp_phase1.is_set or
                            self.nsr_state_tcp_phase2.is_set or
                            self.nsr_state_wait.is_set or
                            self.total.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.nsr_eligible.yfilter != YFilter.not_set or
                            self.nsr_state_app_wait.yfilter != YFilter.not_set or
                            self.nsr_state_none.yfilter != YFilter.not_set or
                            self.nsr_state_operational.yfilter != YFilter.not_set or
                            self.nsr_state_prepare.yfilter != YFilter.not_set or
                            self.nsr_state_ready.yfilter != YFilter.not_set or
                            self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                            self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                            self.nsr_state_wait.yfilter != YFilter.not_set or
                            self.total.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sessions" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/nsr-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                        if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                        if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                        if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                        if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                        if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                        if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                        if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                        if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                        if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "nsr-eligible"):
                            self.nsr_eligible = value
                            self.nsr_eligible.value_namespace = name_space
                            self.nsr_eligible.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-app-wait"):
                            self.nsr_state_app_wait = value
                            self.nsr_state_app_wait.value_namespace = name_space
                            self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-none"):
                            self.nsr_state_none = value
                            self.nsr_state_none.value_namespace = name_space
                            self.nsr_state_none.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-operational"):
                            self.nsr_state_operational = value
                            self.nsr_state_operational.value_namespace = name_space
                            self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-prepare"):
                            self.nsr_state_prepare = value
                            self.nsr_state_prepare.value_namespace = name_space
                            self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-ready"):
                            self.nsr_state_ready = value
                            self.nsr_state_ready.value_namespace = name_space
                            self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-tcp-phase1"):
                            self.nsr_state_tcp_phase1 = value
                            self.nsr_state_tcp_phase1.value_namespace = name_space
                            self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-tcp-phase2"):
                            self.nsr_state_tcp_phase2 = value
                            self.nsr_state_tcp_phase2.value_namespace = name_space
                            self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-wait"):
                            self.nsr_state_wait = value
                            self.nsr_state_wait.value_namespace = name_space
                            self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                        if(value_path == "total"):
                            self.total = value
                            self.total.value_namespace = name_space
                            self.total.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.sessions is not None and self.sessions.has_data()) or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.sessions is not None and self.sessions.has_operation()) or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nsr-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "sessions"):
                        if (self.sessions is None):
                            self.sessions = MplsLdp.Global_.Standby.NsrSummaryAll.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                        return self.sessions

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Standby.NsrSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "sessions" or name == "vrf"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Summary(Entity):
                """
                LDP summary
                
                .. attribute:: common
                
                	Common Summary information
                	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Summary.Common>`
                
                .. attribute:: is_bound_with_atom
                
                	Bound status with L2VPN ATOM
                	**type**\:  bool
                
                .. attribute:: is_bound_with_interface_manager
                
                	Bound status with Interface Manager
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ip_arm
                
                	Bound status with IP Arm
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ipv4_rib
                
                	Bound status with IPv4 RIB
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ipv6_rib
                
                	Bound status with IPv6 RIB
                	**type**\:  bool
                
                .. attribute:: is_bound_with_lsd
                
                	Bound status with LSD
                	**type**\:  bool
                
                .. attribute:: is_bound_with_nsr_mate
                
                	Bound status with NSR Mate
                	**type**\:  bool
                
                .. attribute:: is_bound_with_rsi
                
                	Bound status with rsi
                	**type**\:  bool
                
                .. attribute:: is_bound_with_sysdb
                
                	Bound status with sysdb
                	**type**\:  bool
                
                .. attribute:: is_mldp_registered
                
                	mLDP registration status
                	**type**\:  bool
                
                .. attribute:: is_nsr_configured
                
                	NSR configured
                	**type**\:  bool
                
                .. attribute:: is_registered_with_interface_manager
                
                	Registration status with Interface Manager
                	**type**\:  bool
                
                .. attribute:: is_registered_with_ipv4_rib
                
                	Registration status with IPv4 RIB
                	**type**\:  bool
                
                .. attribute:: is_registered_with_ipv6_rib
                
                	Registration status with IPv6 RIB
                	**type**\:  bool
                
                .. attribute:: is_registered_with_lsd
                
                	Registration status with LSD
                	**type**\:  bool
                
                .. attribute:: is_registered_with_sysdb
                
                	Registration status with Sysdb
                	**type**\:  bool
                
                .. attribute:: number_of_autocfg_interfaces
                
                	Number of auto\-configured interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_fwd_ref_interfaces
                
                	Number of Forward Referenc interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_interfaces
                
                	Number of known interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_ipv4rib_tables
                
                	Total number of ipv4 RIB tables
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_ipv6rib_tables
                
                	Total number of ipv6 RIB tables
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_registered_ipv4rib_tables
                
                	Number of ipv4 RIB tables registered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_registered_ipv6rib_tables
                
                	Number of ipv6 RIB tables registered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_vrf
                
                	Number of configured VRFs (including default)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_vrf_oper
                
                	Number of configured operational VRFs (including default)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "standby"

                    self.is_bound_with_atom = YLeaf(YType.boolean, "is-bound-with-atom")

                    self.is_bound_with_interface_manager = YLeaf(YType.boolean, "is-bound-with-interface-manager")

                    self.is_bound_with_ip_arm = YLeaf(YType.boolean, "is-bound-with-ip-arm")

                    self.is_bound_with_ipv4_rib = YLeaf(YType.boolean, "is-bound-with-ipv4-rib")

                    self.is_bound_with_ipv6_rib = YLeaf(YType.boolean, "is-bound-with-ipv6-rib")

                    self.is_bound_with_lsd = YLeaf(YType.boolean, "is-bound-with-lsd")

                    self.is_bound_with_nsr_mate = YLeaf(YType.boolean, "is-bound-with-nsr-mate")

                    self.is_bound_with_rsi = YLeaf(YType.boolean, "is-bound-with-rsi")

                    self.is_bound_with_sysdb = YLeaf(YType.boolean, "is-bound-with-sysdb")

                    self.is_mldp_registered = YLeaf(YType.boolean, "is-mldp-registered")

                    self.is_nsr_configured = YLeaf(YType.boolean, "is-nsr-configured")

                    self.is_registered_with_interface_manager = YLeaf(YType.boolean, "is-registered-with-interface-manager")

                    self.is_registered_with_ipv4_rib = YLeaf(YType.boolean, "is-registered-with-ipv4-rib")

                    self.is_registered_with_ipv6_rib = YLeaf(YType.boolean, "is-registered-with-ipv6-rib")

                    self.is_registered_with_lsd = YLeaf(YType.boolean, "is-registered-with-lsd")

                    self.is_registered_with_sysdb = YLeaf(YType.boolean, "is-registered-with-sysdb")

                    self.number_of_autocfg_interfaces = YLeaf(YType.uint32, "number-of-autocfg-interfaces")

                    self.number_of_fwd_ref_interfaces = YLeaf(YType.uint32, "number-of-fwd-ref-interfaces")

                    self.number_of_interfaces = YLeaf(YType.uint32, "number-of-interfaces")

                    self.number_of_ipv4rib_tables = YLeaf(YType.uint32, "number-of-ipv4rib-tables")

                    self.number_of_ipv6rib_tables = YLeaf(YType.uint32, "number-of-ipv6rib-tables")

                    self.number_of_registered_ipv4rib_tables = YLeaf(YType.uint32, "number-of-registered-ipv4rib-tables")

                    self.number_of_registered_ipv6rib_tables = YLeaf(YType.uint32, "number-of-registered-ipv6rib-tables")

                    self.number_of_vrf = YLeaf(YType.uint32, "number-of-vrf")

                    self.number_of_vrf_oper = YLeaf(YType.uint32, "number-of-vrf-oper")

                    self.common = MplsLdp.Global_.Standby.Summary.Common()
                    self.common.parent = self
                    self._children_name_map["common"] = "common"
                    self._children_yang_names.add("common")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_bound_with_atom",
                                    "is_bound_with_interface_manager",
                                    "is_bound_with_ip_arm",
                                    "is_bound_with_ipv4_rib",
                                    "is_bound_with_ipv6_rib",
                                    "is_bound_with_lsd",
                                    "is_bound_with_nsr_mate",
                                    "is_bound_with_rsi",
                                    "is_bound_with_sysdb",
                                    "is_mldp_registered",
                                    "is_nsr_configured",
                                    "is_registered_with_interface_manager",
                                    "is_registered_with_ipv4_rib",
                                    "is_registered_with_ipv6_rib",
                                    "is_registered_with_lsd",
                                    "is_registered_with_sysdb",
                                    "number_of_autocfg_interfaces",
                                    "number_of_fwd_ref_interfaces",
                                    "number_of_interfaces",
                                    "number_of_ipv4rib_tables",
                                    "number_of_ipv6rib_tables",
                                    "number_of_registered_ipv4rib_tables",
                                    "number_of_registered_ipv6rib_tables",
                                    "number_of_vrf",
                                    "number_of_vrf_oper") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Standby.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Standby.Summary, self).__setattr__(name, value)


                class Common(Entity):
                    """
                    Common Summary information
                    
                    .. attribute:: address_families
                    
                    	Address Families enabled
                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                    
                    .. attribute:: number_of_bindings_ipv4
                    
                    	Total number of ipv4 bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_bindings_ipv6
                    
                    	Total number of ipv6 bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_downstream_on_demand_neighbors
                    
                    	Number of Downstream\-On\-Demand neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_graceful_restart_neighbors
                    
                    	Number of Graceful Restart neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_hello_adj
                    
                    	Number of LDP discovery IPv4 hello adjacencies
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_local_addresses
                    
                    	Number of IPv4 local addresses
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_routes
                    
                    	Number of resolved IPv4 routes
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4af
                    
                    	Number of IPv4 address\-families enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4ldp_interfaces
                    
                    	Number of LDP IPv4 configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_hello_adj
                    
                    	Number of LDP discovery IPv6 hello adjacencies
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_local_addresses
                    
                    	Number of IPv6 local addresses
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_routes
                    
                    	Number of resolved IPv6 routes
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6af
                    
                    	Number of IPv6 address\-families enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6ldp_interfaces
                    
                    	Number of LDP IPv6 configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ldp_interfaces
                    
                    	Number of LDP configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_local_bindings_ipv4
                    
                    	Total number of ipv4 local label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_local_bindings_ipv6
                    
                    	Total number of ipv6 local label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_neighbors
                    
                    	Number of neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_nsr_synced_neighbors
                    
                    	Number of NSR\-synced/operational neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_remote_bindings_ipv4
                    
                    	Total number of ipv4 remote label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_remote_bindings_ipv6
                    
                    	Total number of ipv6 remote label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.Summary.Common, self).__init__()

                        self.yang_name = "common"
                        self.yang_parent_name = "summary"

                        self.address_families = YLeaf(YType.enumeration, "address-families")

                        self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                        self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                        self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                        self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                        self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                        self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                        self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                        self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                        self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                        self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                        self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                        self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                        self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                        self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                        self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                        self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                        self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                        self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                        self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                        self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                        self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_families",
                                        "number_of_bindings_ipv4",
                                        "number_of_bindings_ipv6",
                                        "number_of_downstream_on_demand_neighbors",
                                        "number_of_graceful_restart_neighbors",
                                        "number_of_ipv4_hello_adj",
                                        "number_of_ipv4_local_addresses",
                                        "number_of_ipv4_routes",
                                        "number_of_ipv4af",
                                        "number_of_ipv4ldp_interfaces",
                                        "number_of_ipv6_hello_adj",
                                        "number_of_ipv6_local_addresses",
                                        "number_of_ipv6_routes",
                                        "number_of_ipv6af",
                                        "number_of_ipv6ldp_interfaces",
                                        "number_of_ldp_interfaces",
                                        "number_of_local_bindings_ipv4",
                                        "number_of_local_bindings_ipv6",
                                        "number_of_neighbors",
                                        "number_of_nsr_synced_neighbors",
                                        "number_of_remote_bindings_ipv4",
                                        "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.Summary.Common, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.Summary.Common, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_families.is_set or
                            self.number_of_bindings_ipv4.is_set or
                            self.number_of_bindings_ipv6.is_set or
                            self.number_of_downstream_on_demand_neighbors.is_set or
                            self.number_of_graceful_restart_neighbors.is_set or
                            self.number_of_ipv4_hello_adj.is_set or
                            self.number_of_ipv4_local_addresses.is_set or
                            self.number_of_ipv4_routes.is_set or
                            self.number_of_ipv4af.is_set or
                            self.number_of_ipv4ldp_interfaces.is_set or
                            self.number_of_ipv6_hello_adj.is_set or
                            self.number_of_ipv6_local_addresses.is_set or
                            self.number_of_ipv6_routes.is_set or
                            self.number_of_ipv6af.is_set or
                            self.number_of_ipv6ldp_interfaces.is_set or
                            self.number_of_ldp_interfaces.is_set or
                            self.number_of_local_bindings_ipv4.is_set or
                            self.number_of_local_bindings_ipv6.is_set or
                            self.number_of_neighbors.is_set or
                            self.number_of_nsr_synced_neighbors.is_set or
                            self.number_of_remote_bindings_ipv4.is_set or
                            self.number_of_remote_bindings_ipv6.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_families.yfilter != YFilter.not_set or
                            self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                            self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                            self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                            self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                            self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                            self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                            self.number_of_ipv4af.yfilter != YFilter.not_set or
                            self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                            self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                            self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                            self.number_of_ipv6af.yfilter != YFilter.not_set or
                            self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                            self.number_of_neighbors.yfilter != YFilter.not_set or
                            self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                            self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "common" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_families.get_name_leafdata())
                        if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                        if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                        if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                        if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                        if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                        if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                        if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                        if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                        if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                        if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                        if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                        if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                        if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                        if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                        if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                        if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                        if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                        if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-families"):
                            self.address_families = value
                            self.address_families.value_namespace = name_space
                            self.address_families.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-bindings-ipv4"):
                            self.number_of_bindings_ipv4 = value
                            self.number_of_bindings_ipv4.value_namespace = name_space
                            self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-bindings-ipv6"):
                            self.number_of_bindings_ipv6 = value
                            self.number_of_bindings_ipv6.value_namespace = name_space
                            self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-downstream-on-demand-neighbors"):
                            self.number_of_downstream_on_demand_neighbors = value
                            self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                            self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-graceful-restart-neighbors"):
                            self.number_of_graceful_restart_neighbors = value
                            self.number_of_graceful_restart_neighbors.value_namespace = name_space
                            self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-hello-adj"):
                            self.number_of_ipv4_hello_adj = value
                            self.number_of_ipv4_hello_adj.value_namespace = name_space
                            self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-local-addresses"):
                            self.number_of_ipv4_local_addresses = value
                            self.number_of_ipv4_local_addresses.value_namespace = name_space
                            self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-routes"):
                            self.number_of_ipv4_routes = value
                            self.number_of_ipv4_routes.value_namespace = name_space
                            self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4af"):
                            self.number_of_ipv4af = value
                            self.number_of_ipv4af.value_namespace = name_space
                            self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4ldp-interfaces"):
                            self.number_of_ipv4ldp_interfaces = value
                            self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                            self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-hello-adj"):
                            self.number_of_ipv6_hello_adj = value
                            self.number_of_ipv6_hello_adj.value_namespace = name_space
                            self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-local-addresses"):
                            self.number_of_ipv6_local_addresses = value
                            self.number_of_ipv6_local_addresses.value_namespace = name_space
                            self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-routes"):
                            self.number_of_ipv6_routes = value
                            self.number_of_ipv6_routes.value_namespace = name_space
                            self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6af"):
                            self.number_of_ipv6af = value
                            self.number_of_ipv6af.value_namespace = name_space
                            self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6ldp-interfaces"):
                            self.number_of_ipv6ldp_interfaces = value
                            self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                            self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ldp-interfaces"):
                            self.number_of_ldp_interfaces = value
                            self.number_of_ldp_interfaces.value_namespace = name_space
                            self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-local-bindings-ipv4"):
                            self.number_of_local_bindings_ipv4 = value
                            self.number_of_local_bindings_ipv4.value_namespace = name_space
                            self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-local-bindings-ipv6"):
                            self.number_of_local_bindings_ipv6 = value
                            self.number_of_local_bindings_ipv6.value_namespace = name_space
                            self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-neighbors"):
                            self.number_of_neighbors = value
                            self.number_of_neighbors.value_namespace = name_space
                            self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-nsr-synced-neighbors"):
                            self.number_of_nsr_synced_neighbors = value
                            self.number_of_nsr_synced_neighbors.value_namespace = name_space
                            self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-remote-bindings-ipv4"):
                            self.number_of_remote_bindings_ipv4 = value
                            self.number_of_remote_bindings_ipv4.value_namespace = name_space
                            self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-remote-bindings-ipv6"):
                            self.number_of_remote_bindings_ipv6 = value
                            self.number_of_remote_bindings_ipv6.value_namespace = name_space
                            self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.is_bound_with_atom.is_set or
                        self.is_bound_with_interface_manager.is_set or
                        self.is_bound_with_ip_arm.is_set or
                        self.is_bound_with_ipv4_rib.is_set or
                        self.is_bound_with_ipv6_rib.is_set or
                        self.is_bound_with_lsd.is_set or
                        self.is_bound_with_nsr_mate.is_set or
                        self.is_bound_with_rsi.is_set or
                        self.is_bound_with_sysdb.is_set or
                        self.is_mldp_registered.is_set or
                        self.is_nsr_configured.is_set or
                        self.is_registered_with_interface_manager.is_set or
                        self.is_registered_with_ipv4_rib.is_set or
                        self.is_registered_with_ipv6_rib.is_set or
                        self.is_registered_with_lsd.is_set or
                        self.is_registered_with_sysdb.is_set or
                        self.number_of_autocfg_interfaces.is_set or
                        self.number_of_fwd_ref_interfaces.is_set or
                        self.number_of_interfaces.is_set or
                        self.number_of_ipv4rib_tables.is_set or
                        self.number_of_ipv6rib_tables.is_set or
                        self.number_of_registered_ipv4rib_tables.is_set or
                        self.number_of_registered_ipv6rib_tables.is_set or
                        self.number_of_vrf.is_set or
                        self.number_of_vrf_oper.is_set or
                        (self.common is not None and self.common.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_bound_with_atom.yfilter != YFilter.not_set or
                        self.is_bound_with_interface_manager.yfilter != YFilter.not_set or
                        self.is_bound_with_ip_arm.yfilter != YFilter.not_set or
                        self.is_bound_with_ipv4_rib.yfilter != YFilter.not_set or
                        self.is_bound_with_ipv6_rib.yfilter != YFilter.not_set or
                        self.is_bound_with_lsd.yfilter != YFilter.not_set or
                        self.is_bound_with_nsr_mate.yfilter != YFilter.not_set or
                        self.is_bound_with_rsi.yfilter != YFilter.not_set or
                        self.is_bound_with_sysdb.yfilter != YFilter.not_set or
                        self.is_mldp_registered.yfilter != YFilter.not_set or
                        self.is_nsr_configured.yfilter != YFilter.not_set or
                        self.is_registered_with_interface_manager.yfilter != YFilter.not_set or
                        self.is_registered_with_ipv4_rib.yfilter != YFilter.not_set or
                        self.is_registered_with_ipv6_rib.yfilter != YFilter.not_set or
                        self.is_registered_with_lsd.yfilter != YFilter.not_set or
                        self.is_registered_with_sysdb.yfilter != YFilter.not_set or
                        self.number_of_autocfg_interfaces.yfilter != YFilter.not_set or
                        self.number_of_fwd_ref_interfaces.yfilter != YFilter.not_set or
                        self.number_of_interfaces.yfilter != YFilter.not_set or
                        self.number_of_ipv4rib_tables.yfilter != YFilter.not_set or
                        self.number_of_ipv6rib_tables.yfilter != YFilter.not_set or
                        self.number_of_registered_ipv4rib_tables.yfilter != YFilter.not_set or
                        self.number_of_registered_ipv6rib_tables.yfilter != YFilter.not_set or
                        self.number_of_vrf.yfilter != YFilter.not_set or
                        self.number_of_vrf_oper.yfilter != YFilter.not_set or
                        (self.common is not None and self.common.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_bound_with_atom.is_set or self.is_bound_with_atom.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_atom.get_name_leafdata())
                    if (self.is_bound_with_interface_manager.is_set or self.is_bound_with_interface_manager.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_interface_manager.get_name_leafdata())
                    if (self.is_bound_with_ip_arm.is_set or self.is_bound_with_ip_arm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ip_arm.get_name_leafdata())
                    if (self.is_bound_with_ipv4_rib.is_set or self.is_bound_with_ipv4_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ipv4_rib.get_name_leafdata())
                    if (self.is_bound_with_ipv6_rib.is_set or self.is_bound_with_ipv6_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ipv6_rib.get_name_leafdata())
                    if (self.is_bound_with_lsd.is_set or self.is_bound_with_lsd.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_lsd.get_name_leafdata())
                    if (self.is_bound_with_nsr_mate.is_set or self.is_bound_with_nsr_mate.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_nsr_mate.get_name_leafdata())
                    if (self.is_bound_with_rsi.is_set or self.is_bound_with_rsi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_rsi.get_name_leafdata())
                    if (self.is_bound_with_sysdb.is_set or self.is_bound_with_sysdb.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_sysdb.get_name_leafdata())
                    if (self.is_mldp_registered.is_set or self.is_mldp_registered.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_mldp_registered.get_name_leafdata())
                    if (self.is_nsr_configured.is_set or self.is_nsr_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_nsr_configured.get_name_leafdata())
                    if (self.is_registered_with_interface_manager.is_set or self.is_registered_with_interface_manager.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_interface_manager.get_name_leafdata())
                    if (self.is_registered_with_ipv4_rib.is_set or self.is_registered_with_ipv4_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_ipv4_rib.get_name_leafdata())
                    if (self.is_registered_with_ipv6_rib.is_set or self.is_registered_with_ipv6_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_ipv6_rib.get_name_leafdata())
                    if (self.is_registered_with_lsd.is_set or self.is_registered_with_lsd.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_lsd.get_name_leafdata())
                    if (self.is_registered_with_sysdb.is_set or self.is_registered_with_sysdb.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_sysdb.get_name_leafdata())
                    if (self.number_of_autocfg_interfaces.is_set or self.number_of_autocfg_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_autocfg_interfaces.get_name_leafdata())
                    if (self.number_of_fwd_ref_interfaces.is_set or self.number_of_fwd_ref_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_fwd_ref_interfaces.get_name_leafdata())
                    if (self.number_of_interfaces.is_set or self.number_of_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_interfaces.get_name_leafdata())
                    if (self.number_of_ipv4rib_tables.is_set or self.number_of_ipv4rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_ipv4rib_tables.get_name_leafdata())
                    if (self.number_of_ipv6rib_tables.is_set or self.number_of_ipv6rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_ipv6rib_tables.get_name_leafdata())
                    if (self.number_of_registered_ipv4rib_tables.is_set or self.number_of_registered_ipv4rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_registered_ipv4rib_tables.get_name_leafdata())
                    if (self.number_of_registered_ipv6rib_tables.is_set or self.number_of_registered_ipv6rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_registered_ipv6rib_tables.get_name_leafdata())
                    if (self.number_of_vrf.is_set or self.number_of_vrf.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_vrf.get_name_leafdata())
                    if (self.number_of_vrf_oper.is_set or self.number_of_vrf_oper.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_vrf_oper.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "common"):
                        if (self.common is None):
                            self.common = MplsLdp.Global_.Standby.Summary.Common()
                            self.common.parent = self
                            self._children_name_map["common"] = "common"
                        return self.common

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "common" or name == "is-bound-with-atom" or name == "is-bound-with-interface-manager" or name == "is-bound-with-ip-arm" or name == "is-bound-with-ipv4-rib" or name == "is-bound-with-ipv6-rib" or name == "is-bound-with-lsd" or name == "is-bound-with-nsr-mate" or name == "is-bound-with-rsi" or name == "is-bound-with-sysdb" or name == "is-mldp-registered" or name == "is-nsr-configured" or name == "is-registered-with-interface-manager" or name == "is-registered-with-ipv4-rib" or name == "is-registered-with-ipv6-rib" or name == "is-registered-with-lsd" or name == "is-registered-with-sysdb" or name == "number-of-autocfg-interfaces" or name == "number-of-fwd-ref-interfaces" or name == "number-of-interfaces" or name == "number-of-ipv4rib-tables" or name == "number-of-ipv6rib-tables" or name == "number-of-registered-ipv4rib-tables" or name == "number-of-registered-ipv6rib-tables" or name == "number-of-vrf" or name == "number-of-vrf-oper"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-bound-with-atom"):
                        self.is_bound_with_atom = value
                        self.is_bound_with_atom.value_namespace = name_space
                        self.is_bound_with_atom.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-interface-manager"):
                        self.is_bound_with_interface_manager = value
                        self.is_bound_with_interface_manager.value_namespace = name_space
                        self.is_bound_with_interface_manager.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ip-arm"):
                        self.is_bound_with_ip_arm = value
                        self.is_bound_with_ip_arm.value_namespace = name_space
                        self.is_bound_with_ip_arm.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ipv4-rib"):
                        self.is_bound_with_ipv4_rib = value
                        self.is_bound_with_ipv4_rib.value_namespace = name_space
                        self.is_bound_with_ipv4_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ipv6-rib"):
                        self.is_bound_with_ipv6_rib = value
                        self.is_bound_with_ipv6_rib.value_namespace = name_space
                        self.is_bound_with_ipv6_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-lsd"):
                        self.is_bound_with_lsd = value
                        self.is_bound_with_lsd.value_namespace = name_space
                        self.is_bound_with_lsd.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-nsr-mate"):
                        self.is_bound_with_nsr_mate = value
                        self.is_bound_with_nsr_mate.value_namespace = name_space
                        self.is_bound_with_nsr_mate.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-rsi"):
                        self.is_bound_with_rsi = value
                        self.is_bound_with_rsi.value_namespace = name_space
                        self.is_bound_with_rsi.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-sysdb"):
                        self.is_bound_with_sysdb = value
                        self.is_bound_with_sysdb.value_namespace = name_space
                        self.is_bound_with_sysdb.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-mldp-registered"):
                        self.is_mldp_registered = value
                        self.is_mldp_registered.value_namespace = name_space
                        self.is_mldp_registered.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-nsr-configured"):
                        self.is_nsr_configured = value
                        self.is_nsr_configured.value_namespace = name_space
                        self.is_nsr_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-interface-manager"):
                        self.is_registered_with_interface_manager = value
                        self.is_registered_with_interface_manager.value_namespace = name_space
                        self.is_registered_with_interface_manager.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-ipv4-rib"):
                        self.is_registered_with_ipv4_rib = value
                        self.is_registered_with_ipv4_rib.value_namespace = name_space
                        self.is_registered_with_ipv4_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-ipv6-rib"):
                        self.is_registered_with_ipv6_rib = value
                        self.is_registered_with_ipv6_rib.value_namespace = name_space
                        self.is_registered_with_ipv6_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-lsd"):
                        self.is_registered_with_lsd = value
                        self.is_registered_with_lsd.value_namespace = name_space
                        self.is_registered_with_lsd.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-sysdb"):
                        self.is_registered_with_sysdb = value
                        self.is_registered_with_sysdb.value_namespace = name_space
                        self.is_registered_with_sysdb.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-autocfg-interfaces"):
                        self.number_of_autocfg_interfaces = value
                        self.number_of_autocfg_interfaces.value_namespace = name_space
                        self.number_of_autocfg_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-fwd-ref-interfaces"):
                        self.number_of_fwd_ref_interfaces = value
                        self.number_of_fwd_ref_interfaces.value_namespace = name_space
                        self.number_of_fwd_ref_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-interfaces"):
                        self.number_of_interfaces = value
                        self.number_of_interfaces.value_namespace = name_space
                        self.number_of_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-ipv4rib-tables"):
                        self.number_of_ipv4rib_tables = value
                        self.number_of_ipv4rib_tables.value_namespace = name_space
                        self.number_of_ipv4rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-ipv6rib-tables"):
                        self.number_of_ipv6rib_tables = value
                        self.number_of_ipv6rib_tables.value_namespace = name_space
                        self.number_of_ipv6rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-registered-ipv4rib-tables"):
                        self.number_of_registered_ipv4rib_tables = value
                        self.number_of_registered_ipv4rib_tables.value_namespace = name_space
                        self.number_of_registered_ipv4rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-registered-ipv6rib-tables"):
                        self.number_of_registered_ipv6rib_tables = value
                        self.number_of_registered_ipv6rib_tables.value_namespace = name_space
                        self.number_of_registered_ipv6rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-vrf"):
                        self.number_of_vrf = value
                        self.number_of_vrf.value_namespace = name_space
                        self.number_of_vrf.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-vrf-oper"):
                        self.number_of_vrf_oper = value
                        self.number_of_vrf_oper.value_namespace = name_space
                        self.number_of_vrf_oper.value_namespace_prefix = name_space_prefix


            class Vrfs(Entity):
                """
                VRF specific operational data
                
                .. attribute:: vrf
                
                	Operational data for given VRF
                	**type**\: list of    :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.Vrfs, self).__init__()

                    self.yang_name = "vrfs"
                    self.yang_parent_name = "standby"

                    self.vrf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Standby.Vrfs, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Standby.Vrfs, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    Operational data for given VRF
                    
                    .. attribute:: vrf_name  <key>
                    
                    	VRF Name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: afs
                    
                    	Address Family specific operational data
                    	**type**\:   :py:class:`Afs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs>`
                    
                    .. attribute:: backoff_parameters
                    
                    	The LDP Backoff Parameters
                    	**type**\:   :py:class:`BackoffParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.BackoffParameters>`
                    
                    .. attribute:: backoffs
                    
                    	The LDP backoff
                    	**type**\:   :py:class:`Backoffs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs>`
                    
                    .. attribute:: capabilities
                    
                    	LDP capability database information
                    	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities>`
                    
                    .. attribute:: graceful_restart
                    
                    	LDP Graceful Restart info
                    	**type**\:   :py:class:`GracefulRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart>`
                    
                    .. attribute:: issu
                    
                    	LDP ISSU related information
                    	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu>`
                    
                    .. attribute:: ldp_id
                    
                    	Local LDP Id
                    	**type**\:   :py:class:`LdpId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.LdpId>`
                    
                    .. attribute:: neighbor_briefs
                    
                    	The LDP Neighbors (brief)
                    	**type**\:   :py:class:`NeighborBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs>`
                    
                    .. attribute:: neighbor_capabilities
                    
                    	LDP Neighbors Capabilities
                    	**type**\:   :py:class:`NeighborCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities>`
                    
                    .. attribute:: neighbors
                    
                    	The LDP Neighbors
                    	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors>`
                    
                    .. attribute:: nsr
                    
                    	LDP NSR related information
                    	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr>`
                    
                    .. attribute:: parameters
                    
                    	LDP parameters
                    	**type**\:   :py:class:`Parameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters>`
                    
                    .. attribute:: statistics
                    
                    	The LDP Statistics
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics>`
                    
                    .. attribute:: summary
                    
                    	LDP VRF summary
                    	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Summary>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.Vrfs.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "vrfs"

                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                        self.afs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs()
                        self.afs.parent = self
                        self._children_name_map["afs"] = "afs"
                        self._children_yang_names.add("afs")

                        self.backoff_parameters = MplsLdp.Global_.Standby.Vrfs.Vrf.BackoffParameters()
                        self.backoff_parameters.parent = self
                        self._children_name_map["backoff_parameters"] = "backoff-parameters"
                        self._children_yang_names.add("backoff-parameters")

                        self.backoffs = MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs()
                        self.backoffs.parent = self
                        self._children_name_map["backoffs"] = "backoffs"
                        self._children_yang_names.add("backoffs")

                        self.capabilities = MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities()
                        self.capabilities.parent = self
                        self._children_name_map["capabilities"] = "capabilities"
                        self._children_yang_names.add("capabilities")

                        self.graceful_restart = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart()
                        self.graceful_restart.parent = self
                        self._children_name_map["graceful_restart"] = "graceful-restart"
                        self._children_yang_names.add("graceful-restart")

                        self.issu = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu()
                        self.issu.parent = self
                        self._children_name_map["issu"] = "issu"
                        self._children_yang_names.add("issu")

                        self.ldp_id = MplsLdp.Global_.Standby.Vrfs.Vrf.LdpId()
                        self.ldp_id.parent = self
                        self._children_name_map["ldp_id"] = "ldp-id"
                        self._children_yang_names.add("ldp-id")

                        self.neighbor_briefs = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs()
                        self.neighbor_briefs.parent = self
                        self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                        self._children_yang_names.add("neighbor-briefs")

                        self.neighbor_capabilities = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities()
                        self.neighbor_capabilities.parent = self
                        self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                        self._children_yang_names.add("neighbor-capabilities")

                        self.neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors()
                        self.neighbors.parent = self
                        self._children_name_map["neighbors"] = "neighbors"
                        self._children_yang_names.add("neighbors")

                        self.nsr = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr()
                        self.nsr.parent = self
                        self._children_name_map["nsr"] = "nsr"
                        self._children_yang_names.add("nsr")

                        self.parameters = MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters()
                        self.parameters.parent = self
                        self._children_name_map["parameters"] = "parameters"
                        self._children_yang_names.add("parameters")

                        self.statistics = MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                        self.summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                        self._children_yang_names.add("summary")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("vrf_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf, self).__setattr__(name, value)


                    class GracefulRestart(Entity):
                        """
                        LDP Graceful Restart info
                        
                        .. attribute:: forwarding_state_hold_timer_remaining_seconds
                        
                        	Forwarding state hold timer remaining time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: graceful_restartable_neighbor
                        
                        	Vector of graceful restart neighbor information
                        	**type**\: list of    :py:class:`GracefulRestartableNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor>`
                        
                        .. attribute:: is_forwarding_state_hold_timer_running
                        
                        	Is graceful restart forwarding state hold timer running
                        	**type**\:  bool
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart, self).__init__()

                            self.yang_name = "graceful-restart"
                            self.yang_parent_name = "vrf"

                            self.forwarding_state_hold_timer_remaining_seconds = YLeaf(YType.uint32, "forwarding-state-hold-timer-remaining-seconds")

                            self.is_forwarding_state_hold_timer_running = YLeaf(YType.boolean, "is-forwarding-state-hold-timer-running")

                            self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")

                            self.graceful_restartable_neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("forwarding_state_hold_timer_remaining_seconds",
                                            "is_forwarding_state_hold_timer_running") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart, self).__setattr__(name, value)


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "graceful-restart"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class GracefulRestartableNeighbor(Entity):
                            """
                            Vector of graceful restart neighbor information
                            
                            .. attribute:: connect_count
                            
                            	ConnectCount
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_address
                            
                            	Addresses bound to GR down Nbr
                            	**type**\: list of    :py:class:`DownNbrAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress>`
                            
                            .. attribute:: down_nbr_down_reason
                            
                            	Session down reason code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_flags
                            
                            	Flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_flap_count
                            
                            	Count of back2back flaps
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: down_nbr_interface
                            
                            	Interfaces bound to GR down Nbr
                            	**type**\: list of    :py:class:`DownNbrInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface>`
                            
                            .. attribute:: gr_peer
                            
                            	GR peer LDP Id
                            	**type**\:   :py:class:`GrPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer>`
                            
                            .. attribute:: is_liveness_timer_running
                            
                            	Is liveness timer running
                            	**type**\:  bool
                            
                            .. attribute:: is_neighbor_up
                            
                            	Is neighbor up
                            	**type**\:  bool
                            
                            .. attribute:: is_recovery_timer_running
                            
                            	Is recovery timer running
                            	**type**\:  bool
                            
                            .. attribute:: liveness_timer_remaining_seconds
                            
                            	Remaining time from liveness timer
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: recovery_timer_remaining_seconds
                            
                            	Recovery timer remining time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__init__()

                                self.yang_name = "graceful-restartable-neighbor"
                                self.yang_parent_name = "graceful-restart"

                                self.connect_count = YLeaf(YType.uint32, "connect-count")

                                self.down_nbr_down_reason = YLeaf(YType.uint32, "down-nbr-down-reason")

                                self.down_nbr_flags = YLeaf(YType.uint32, "down-nbr-flags")

                                self.down_nbr_flap_count = YLeaf(YType.uint8, "down-nbr-flap-count")

                                self.is_liveness_timer_running = YLeaf(YType.boolean, "is-liveness-timer-running")

                                self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                                self.is_recovery_timer_running = YLeaf(YType.boolean, "is-recovery-timer-running")

                                self.liveness_timer_remaining_seconds = YLeaf(YType.uint32, "liveness-timer-remaining-seconds")

                                self.recovery_timer_remaining_seconds = YLeaf(YType.uint32, "recovery-timer-remaining-seconds")

                                self.gr_peer = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                self.gr_peer.parent = self
                                self._children_name_map["gr_peer"] = "gr-peer"
                                self._children_yang_names.add("gr-peer")

                                self.down_nbr_address = YList(self)
                                self.down_nbr_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("connect_count",
                                                "down_nbr_down_reason",
                                                "down_nbr_flags",
                                                "down_nbr_flap_count",
                                                "is_liveness_timer_running",
                                                "is_neighbor_up",
                                                "is_recovery_timer_running",
                                                "liveness_timer_remaining_seconds",
                                                "recovery_timer_remaining_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)


                            class GrPeer(Entity):
                                """
                                GR peer LDP Id
                                
                                .. attribute:: label_space_id
                                
                                	Label space identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: ldp_id
                                
                                	LDP identifier
                                	**type**\:  str
                                
                                .. attribute:: lsr_id
                                
                                	LSR identifier
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__init__()

                                    self.yang_name = "gr-peer"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                    self.ldp_id = YLeaf(YType.str, "ldp-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "ldp_id",
                                                    "lsr_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.ldp_id.is_set or
                                        self.lsr_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.ldp_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "gr-peer" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-id"):
                                        self.ldp_id = value
                                        self.ldp_id.value_namespace = name_space
                                        self.ldp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix


                            class DownNbrInterface(Entity):
                                """
                                Interfaces bound to GR down Nbr
                                
                                .. attribute:: address_family
                                
                                	Interface adj Address Family
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: interface_handle
                                
                                	Interfaces handle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__init__()

                                    self.yang_name = "down-nbr-interface"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.interface_handle = YLeaf(YType.str, "interface-handle")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "interface_handle") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.interface_handle.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.interface_handle.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "down-nbr-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_handle.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "interface-handle"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-handle"):
                                        self.interface_handle = value
                                        self.interface_handle.value_namespace = name_space
                                        self.interface_handle.value_namespace_prefix = name_space_prefix


                            class DownNbrAddress(Entity):
                                """
                                Addresses bound to GR down Nbr
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__init__()

                                    self.yang_name = "down-nbr-address"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "down-nbr-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.down_nbr_address:
                                    if (c.has_data()):
                                        return True
                                for c in self.down_nbr_interface:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.connect_count.is_set or
                                    self.down_nbr_down_reason.is_set or
                                    self.down_nbr_flags.is_set or
                                    self.down_nbr_flap_count.is_set or
                                    self.is_liveness_timer_running.is_set or
                                    self.is_neighbor_up.is_set or
                                    self.is_recovery_timer_running.is_set or
                                    self.liveness_timer_remaining_seconds.is_set or
                                    self.recovery_timer_remaining_seconds.is_set or
                                    (self.gr_peer is not None and self.gr_peer.has_data()))

                            def has_operation(self):
                                for c in self.down_nbr_address:
                                    if (c.has_operation()):
                                        return True
                                for c in self.down_nbr_interface:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.connect_count.yfilter != YFilter.not_set or
                                    self.down_nbr_down_reason.yfilter != YFilter.not_set or
                                    self.down_nbr_flags.yfilter != YFilter.not_set or
                                    self.down_nbr_flap_count.yfilter != YFilter.not_set or
                                    self.is_liveness_timer_running.yfilter != YFilter.not_set or
                                    self.is_neighbor_up.yfilter != YFilter.not_set or
                                    self.is_recovery_timer_running.yfilter != YFilter.not_set or
                                    self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set or
                                    self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set or
                                    (self.gr_peer is not None and self.gr_peer.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "graceful-restartable-neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.connect_count.get_name_leafdata())
                                if (self.down_nbr_down_reason.is_set or self.down_nbr_down_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_down_reason.get_name_leafdata())
                                if (self.down_nbr_flags.is_set or self.down_nbr_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_flags.get_name_leafdata())
                                if (self.down_nbr_flap_count.is_set or self.down_nbr_flap_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_flap_count.get_name_leafdata())
                                if (self.is_liveness_timer_running.is_set or self.is_liveness_timer_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_liveness_timer_running.get_name_leafdata())
                                if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                                if (self.is_recovery_timer_running.is_set or self.is_recovery_timer_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_recovery_timer_running.get_name_leafdata())
                                if (self.liveness_timer_remaining_seconds.is_set or self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.liveness_timer_remaining_seconds.get_name_leafdata())
                                if (self.recovery_timer_remaining_seconds.is_set or self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.recovery_timer_remaining_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "down-nbr-address"):
                                    for c in self.down_nbr_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.down_nbr_address.append(c)
                                    return c

                                if (child_yang_name == "down-nbr-interface"):
                                    for c in self.down_nbr_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.down_nbr_interface.append(c)
                                    return c

                                if (child_yang_name == "gr-peer"):
                                    if (self.gr_peer is None):
                                        self.gr_peer = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                        self.gr_peer.parent = self
                                        self._children_name_map["gr_peer"] = "gr-peer"
                                    return self.gr_peer

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "down-nbr-address" or name == "down-nbr-interface" or name == "gr-peer" or name == "connect-count" or name == "down-nbr-down-reason" or name == "down-nbr-flags" or name == "down-nbr-flap-count" or name == "is-liveness-timer-running" or name == "is-neighbor-up" or name == "is-recovery-timer-running" or name == "liveness-timer-remaining-seconds" or name == "recovery-timer-remaining-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "connect-count"):
                                    self.connect_count = value
                                    self.connect_count.value_namespace = name_space
                                    self.connect_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-down-reason"):
                                    self.down_nbr_down_reason = value
                                    self.down_nbr_down_reason.value_namespace = name_space
                                    self.down_nbr_down_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-flags"):
                                    self.down_nbr_flags = value
                                    self.down_nbr_flags.value_namespace = name_space
                                    self.down_nbr_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-flap-count"):
                                    self.down_nbr_flap_count = value
                                    self.down_nbr_flap_count.value_namespace = name_space
                                    self.down_nbr_flap_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-liveness-timer-running"):
                                    self.is_liveness_timer_running = value
                                    self.is_liveness_timer_running.value_namespace = name_space
                                    self.is_liveness_timer_running.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-up"):
                                    self.is_neighbor_up = value
                                    self.is_neighbor_up.value_namespace = name_space
                                    self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-recovery-timer-running"):
                                    self.is_recovery_timer_running = value
                                    self.is_recovery_timer_running.value_namespace = name_space
                                    self.is_recovery_timer_running.value_namespace_prefix = name_space_prefix
                                if(value_path == "liveness-timer-remaining-seconds"):
                                    self.liveness_timer_remaining_seconds = value
                                    self.liveness_timer_remaining_seconds.value_namespace = name_space
                                    self.liveness_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                                if(value_path == "recovery-timer-remaining-seconds"):
                                    self.recovery_timer_remaining_seconds = value
                                    self.recovery_timer_remaining_seconds.value_namespace = name_space
                                    self.recovery_timer_remaining_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.graceful_restartable_neighbor:
                                if (c.has_data()):
                                    return True
                            return (
                                self.forwarding_state_hold_timer_remaining_seconds.is_set or
                                self.is_forwarding_state_hold_timer_running.is_set or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            for c in self.graceful_restartable_neighbor:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set or
                                self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restart" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.forwarding_state_hold_timer_remaining_seconds.is_set or self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.forwarding_state_hold_timer_remaining_seconds.get_name_leafdata())
                            if (self.is_forwarding_state_hold_timer_running.is_set or self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_forwarding_state_hold_timer_running.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "graceful-restartable-neighbor"):
                                for c in self.graceful_restartable_neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.graceful_restartable_neighbor.append(c)
                                return c

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "graceful-restartable-neighbor" or name == "vrf" or name == "forwarding-state-hold-timer-remaining-seconds" or name == "is-forwarding-state-hold-timer-running"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "forwarding-state-hold-timer-remaining-seconds"):
                                self.forwarding_state_hold_timer_remaining_seconds = value
                                self.forwarding_state_hold_timer_remaining_seconds.value_namespace = name_space
                                self.forwarding_state_hold_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-forwarding-state-hold-timer-running"):
                                self.is_forwarding_state_hold_timer_running = value
                                self.is_forwarding_state_hold_timer_running.value_namespace = name_space
                                self.is_forwarding_state_hold_timer_running.value_namespace_prefix = name_space_prefix


                    class Capabilities(Entity):
                        """
                        LDP capability database information
                        
                        .. attribute:: capability
                        
                        	Information on LDP capability
                        	**type**\: list of    :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities, self).__init__()

                            self.yang_name = "capabilities"
                            self.yang_parent_name = "vrf"

                            self.capability = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities, self).__setattr__(name, value)


                        class Capability(Entity):
                            """
                            Information on LDP capability
                            
                            .. attribute:: capability_type  <key>
                            
                            	The capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: capability
                            
                            	Capability information
                            	**type**\:   :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability.Capability>`
                            
                            .. attribute:: capability_owner
                            
                            	Capability owner
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability, self).__init__()

                                self.yang_name = "capability"
                                self.yang_parent_name = "capabilities"

                                self.capability_type = YLeaf(YType.int32, "capability-type")

                                self.capability_owner = YLeaf(YType.str, "capability-owner")

                                self.capability = MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability.Capability()
                                self.capability.parent = self
                                self._children_name_map["capability"] = "capability"
                                self._children_yang_names.add("capability")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_type",
                                                "capability_owner") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability, self).__setattr__(name, value)


                            class Capability(Entity):
                                """
                                Capability information
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability.Capability, self).__init__()

                                    self.yang_name = "capability"
                                    self.yang_parent_name = "capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability.Capability, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability.Capability, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "capability" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.capability_type.is_set or
                                    self.capability_owner.is_set or
                                    (self.capability is not None and self.capability.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_type.yfilter != YFilter.not_set or
                                    self.capability_owner.yfilter != YFilter.not_set or
                                    (self.capability is not None and self.capability.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "capability" + "[capability-type='" + self.capability_type.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_type.is_set or self.capability_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_type.get_name_leafdata())
                                if (self.capability_owner.is_set or self.capability_owner.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_owner.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "capability"):
                                    if (self.capability is None):
                                        self.capability = MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability.Capability()
                                        self.capability.parent = self
                                        self._children_name_map["capability"] = "capability"
                                    return self.capability

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability" or name == "capability-type" or name == "capability-owner"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-type"):
                                    self.capability_type = value
                                    self.capability_type.value_namespace = name_space
                                    self.capability_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-owner"):
                                    self.capability_owner = value
                                    self.capability_owner.value_namespace = name_space
                                    self.capability_owner.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.capability:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.capability:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "capabilities" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "capability"):
                                for c in self.capability:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities.Capability()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.capability.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Summary(Entity):
                        """
                        LDP VRF summary
                        
                        .. attribute:: common
                        
                        	Common Summary information
                        	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Common>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Summary, self).__init__()

                            self.yang_name = "summary"
                            self.yang_parent_name = "vrf"

                            self.common = MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Common()
                            self.common.parent = self
                            self._children_name_map["common"] = "common"
                            self._children_yang_names.add("common")

                            self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Common(Entity):
                            """
                            Common Summary information
                            
                            .. attribute:: address_families
                            
                            	Address Families enabled
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: number_of_bindings_ipv4
                            
                            	Total number of ipv4 bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_bindings_ipv6
                            
                            	Total number of ipv6 bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_downstream_on_demand_neighbors
                            
                            	Number of Downstream\-On\-Demand neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_graceful_restart_neighbors
                            
                            	Number of Graceful Restart neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_hello_adj
                            
                            	Number of LDP discovery IPv4 hello adjacencies
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_local_addresses
                            
                            	Number of IPv4 local addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_routes
                            
                            	Number of resolved IPv4 routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4af
                            
                            	Number of IPv4 address\-families enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4ldp_interfaces
                            
                            	Number of LDP IPv4 configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_hello_adj
                            
                            	Number of LDP discovery IPv6 hello adjacencies
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_local_addresses
                            
                            	Number of IPv6 local addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_routes
                            
                            	Number of resolved IPv6 routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6af
                            
                            	Number of IPv6 address\-families enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6ldp_interfaces
                            
                            	Number of LDP IPv6 configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ldp_interfaces
                            
                            	Number of LDP configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_local_bindings_ipv4
                            
                            	Total number of ipv4 local label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_local_bindings_ipv6
                            
                            	Total number of ipv6 local label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_neighbors
                            
                            	Number of neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_nsr_synced_neighbors
                            
                            	Number of NSR\-synced/operational neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_remote_bindings_ipv4
                            
                            	Total number of ipv4 remote label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_remote_bindings_ipv6
                            
                            	Total number of ipv6 remote label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Common, self).__init__()

                                self.yang_name = "common"
                                self.yang_parent_name = "summary"

                                self.address_families = YLeaf(YType.enumeration, "address-families")

                                self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                                self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                                self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                                self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                                self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                                self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                                self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                                self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                                self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                                self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                                self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                                self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                                self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                                self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                                self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                                self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                                self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                                self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                                self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                                self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                                self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_families",
                                                "number_of_bindings_ipv4",
                                                "number_of_bindings_ipv6",
                                                "number_of_downstream_on_demand_neighbors",
                                                "number_of_graceful_restart_neighbors",
                                                "number_of_ipv4_hello_adj",
                                                "number_of_ipv4_local_addresses",
                                                "number_of_ipv4_routes",
                                                "number_of_ipv4af",
                                                "number_of_ipv4ldp_interfaces",
                                                "number_of_ipv6_hello_adj",
                                                "number_of_ipv6_local_addresses",
                                                "number_of_ipv6_routes",
                                                "number_of_ipv6af",
                                                "number_of_ipv6ldp_interfaces",
                                                "number_of_ldp_interfaces",
                                                "number_of_local_bindings_ipv4",
                                                "number_of_local_bindings_ipv6",
                                                "number_of_neighbors",
                                                "number_of_nsr_synced_neighbors",
                                                "number_of_remote_bindings_ipv4",
                                                "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Common, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Common, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_families.is_set or
                                    self.number_of_bindings_ipv4.is_set or
                                    self.number_of_bindings_ipv6.is_set or
                                    self.number_of_downstream_on_demand_neighbors.is_set or
                                    self.number_of_graceful_restart_neighbors.is_set or
                                    self.number_of_ipv4_hello_adj.is_set or
                                    self.number_of_ipv4_local_addresses.is_set or
                                    self.number_of_ipv4_routes.is_set or
                                    self.number_of_ipv4af.is_set or
                                    self.number_of_ipv4ldp_interfaces.is_set or
                                    self.number_of_ipv6_hello_adj.is_set or
                                    self.number_of_ipv6_local_addresses.is_set or
                                    self.number_of_ipv6_routes.is_set or
                                    self.number_of_ipv6af.is_set or
                                    self.number_of_ipv6ldp_interfaces.is_set or
                                    self.number_of_ldp_interfaces.is_set or
                                    self.number_of_local_bindings_ipv4.is_set or
                                    self.number_of_local_bindings_ipv6.is_set or
                                    self.number_of_neighbors.is_set or
                                    self.number_of_nsr_synced_neighbors.is_set or
                                    self.number_of_remote_bindings_ipv4.is_set or
                                    self.number_of_remote_bindings_ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_families.yfilter != YFilter.not_set or
                                    self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                                    self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                                    self.number_of_ipv4af.yfilter != YFilter.not_set or
                                    self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                                    self.number_of_ipv6af.yfilter != YFilter.not_set or
                                    self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                                    self.number_of_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "common" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_families.get_name_leafdata())
                                if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                                if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                                if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                                if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                                if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                                if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                                if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                                if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                                if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                                if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                                if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                                if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                                if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                                if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                                if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                                if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                                if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                                if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-families"):
                                    self.address_families = value
                                    self.address_families.value_namespace = name_space
                                    self.address_families.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-bindings-ipv4"):
                                    self.number_of_bindings_ipv4 = value
                                    self.number_of_bindings_ipv4.value_namespace = name_space
                                    self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-bindings-ipv6"):
                                    self.number_of_bindings_ipv6 = value
                                    self.number_of_bindings_ipv6.value_namespace = name_space
                                    self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-downstream-on-demand-neighbors"):
                                    self.number_of_downstream_on_demand_neighbors = value
                                    self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                                    self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-graceful-restart-neighbors"):
                                    self.number_of_graceful_restart_neighbors = value
                                    self.number_of_graceful_restart_neighbors.value_namespace = name_space
                                    self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-hello-adj"):
                                    self.number_of_ipv4_hello_adj = value
                                    self.number_of_ipv4_hello_adj.value_namespace = name_space
                                    self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-local-addresses"):
                                    self.number_of_ipv4_local_addresses = value
                                    self.number_of_ipv4_local_addresses.value_namespace = name_space
                                    self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-routes"):
                                    self.number_of_ipv4_routes = value
                                    self.number_of_ipv4_routes.value_namespace = name_space
                                    self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4af"):
                                    self.number_of_ipv4af = value
                                    self.number_of_ipv4af.value_namespace = name_space
                                    self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4ldp-interfaces"):
                                    self.number_of_ipv4ldp_interfaces = value
                                    self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                                    self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-hello-adj"):
                                    self.number_of_ipv6_hello_adj = value
                                    self.number_of_ipv6_hello_adj.value_namespace = name_space
                                    self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-local-addresses"):
                                    self.number_of_ipv6_local_addresses = value
                                    self.number_of_ipv6_local_addresses.value_namespace = name_space
                                    self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-routes"):
                                    self.number_of_ipv6_routes = value
                                    self.number_of_ipv6_routes.value_namespace = name_space
                                    self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6af"):
                                    self.number_of_ipv6af = value
                                    self.number_of_ipv6af.value_namespace = name_space
                                    self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6ldp-interfaces"):
                                    self.number_of_ipv6ldp_interfaces = value
                                    self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                                    self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ldp-interfaces"):
                                    self.number_of_ldp_interfaces = value
                                    self.number_of_ldp_interfaces.value_namespace = name_space
                                    self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-local-bindings-ipv4"):
                                    self.number_of_local_bindings_ipv4 = value
                                    self.number_of_local_bindings_ipv4.value_namespace = name_space
                                    self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-local-bindings-ipv6"):
                                    self.number_of_local_bindings_ipv6 = value
                                    self.number_of_local_bindings_ipv6.value_namespace = name_space
                                    self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-neighbors"):
                                    self.number_of_neighbors = value
                                    self.number_of_neighbors.value_namespace = name_space
                                    self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-nsr-synced-neighbors"):
                                    self.number_of_nsr_synced_neighbors = value
                                    self.number_of_nsr_synced_neighbors.value_namespace = name_space
                                    self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-remote-bindings-ipv4"):
                                    self.number_of_remote_bindings_ipv4 = value
                                    self.number_of_remote_bindings_ipv4.value_namespace = name_space
                                    self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-remote-bindings-ipv6"):
                                    self.number_of_remote_bindings_ipv6 = value
                                    self.number_of_remote_bindings_ipv6.value_namespace = name_space
                                    self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.common is not None and self.common.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.common is not None and self.common.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "common"):
                                if (self.common is None):
                                    self.common = MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Common()
                                    self.common.parent = self
                                    self._children_name_map["common"] = "common"
                                return self.common

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Summary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "common" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Afs(Entity):
                        """
                        Address Family specific operational data
                        
                        .. attribute:: af
                        
                        	Operational data for given Address Family
                        	**type**\: list of    :py:class:`Af <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs, self).__init__()

                            self.yang_name = "afs"
                            self.yang_parent_name = "vrf"

                            self.af = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs, self).__setattr__(name, value)


                        class Af(Entity):
                            """
                            Operational data for given Address Family
                            
                            .. attribute:: af_name  <key>
                            
                            	Address Family name
                            	**type**\:   :py:class:`MplsLdpOperAfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdpOperAfName>`
                            
                            .. attribute:: bindings
                            
                            	The LDP Bindings
                            	**type**\:   :py:class:`Bindings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings>`
                            
                            .. attribute:: bindings_advertise_spec
                            
                            	Advertisement Spec (ACL) for LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsAdvertiseSpec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec>`
                            
                            .. attribute:: bindings_summary
                            
                            	Counters for the LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary>`
                            
                            .. attribute:: bindings_summary_all
                            
                            	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll>`
                            
                            .. attribute:: discovery
                            
                            	The LDP Discovery
                            	**type**\:   :py:class:`Discovery <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery>`
                            
                            .. attribute:: forwarding_summary
                            
                            	Summary information regarding LDP forwarding setup
                            	**type**\:   :py:class:`ForwardingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary>`
                            
                            .. attribute:: forwardings
                            
                            	The LDP Forwarding rewrites
                            	**type**\:   :py:class:`Forwardings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings>`
                            
                            .. attribute:: igp
                            
                            	LDP IGP related information
                            	**type**\:   :py:class:`Igp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp>`
                            
                            .. attribute:: interface_summary
                            
                            	IPv4 interface summary information
                            	**type**\:   :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.InterfaceSummary>`
                            
                            .. attribute:: interfaces
                            
                            	LDP Interface related information
                            	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af, self).__init__()

                                self.yang_name = "af"
                                self.yang_parent_name = "afs"

                                self.af_name = YLeaf(YType.enumeration, "af-name")

                                self.bindings = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings()
                                self.bindings.parent = self
                                self._children_name_map["bindings"] = "bindings"
                                self._children_yang_names.add("bindings")

                                self.bindings_advertise_spec = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec()
                                self.bindings_advertise_spec.parent = self
                                self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                self._children_yang_names.add("bindings-advertise-spec")

                                self.bindings_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary()
                                self.bindings_summary.parent = self
                                self._children_name_map["bindings_summary"] = "bindings-summary"
                                self._children_yang_names.add("bindings-summary")

                                self.bindings_summary_all = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll()
                                self.bindings_summary_all.parent = self
                                self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                self._children_yang_names.add("bindings-summary-all")

                                self.discovery = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery()
                                self.discovery.parent = self
                                self._children_name_map["discovery"] = "discovery"
                                self._children_yang_names.add("discovery")

                                self.forwarding_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary()
                                self.forwarding_summary.parent = self
                                self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                self._children_yang_names.add("forwarding-summary")

                                self.forwardings = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings()
                                self.forwardings.parent = self
                                self._children_name_map["forwardings"] = "forwardings"
                                self._children_yang_names.add("forwardings")

                                self.igp = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp()
                                self.igp.parent = self
                                self._children_name_map["igp"] = "igp"
                                self._children_yang_names.add("igp")

                                self.interface_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.InterfaceSummary()
                                self.interface_summary.parent = self
                                self._children_name_map["interface_summary"] = "interface-summary"
                                self._children_yang_names.add("interface-summary")

                                self.interfaces = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces()
                                self.interfaces.parent = self
                                self._children_name_map["interfaces"] = "interfaces"
                                self._children_yang_names.add("interfaces")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("af_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af, self).__setattr__(name, value)


                            class InterfaceSummary(Entity):
                                """
                                IPv4 interface summary information
                                
                                .. attribute:: auto_config
                                
                                	Auto\-configured interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: auto_config_disabled
                                
                                	Autoconfigure disabled
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: auto_config_forward_reference_interfaces
                                
                                	Auto\-configured forward references
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: forward_references
                                
                                	Number of forward referenced interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: known_ip_interface_count
                                
                                	Number of known IP Interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: known_ip_interface_ldp_enabled
                                
                                	Number of known IP Interfaces with LDP Enabled
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ldp_configured_attached_interface
                                
                                	Number of attached interfaces configured in LDP
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ldp_configured_te_interface
                                
                                	Number of TE tunnel interfaces configured in LDP
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__init__()

                                    self.yang_name = "interface-summary"
                                    self.yang_parent_name = "af"

                                    self.auto_config = YLeaf(YType.uint32, "auto-config")

                                    self.auto_config_disabled = YLeaf(YType.uint32, "auto-config-disabled")

                                    self.auto_config_forward_reference_interfaces = YLeaf(YType.uint32, "auto-config-forward-reference-interfaces")

                                    self.forward_references = YLeaf(YType.uint32, "forward-references")

                                    self.known_ip_interface_count = YLeaf(YType.uint32, "known-ip-interface-count")

                                    self.known_ip_interface_ldp_enabled = YLeaf(YType.uint32, "known-ip-interface-ldp-enabled")

                                    self.ldp_configured_attached_interface = YLeaf(YType.uint32, "ldp-configured-attached-interface")

                                    self.ldp_configured_te_interface = YLeaf(YType.uint32, "ldp-configured-te-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("auto_config",
                                                    "auto_config_disabled",
                                                    "auto_config_forward_reference_interfaces",
                                                    "forward_references",
                                                    "known_ip_interface_count",
                                                    "known_ip_interface_ldp_enabled",
                                                    "ldp_configured_attached_interface",
                                                    "ldp_configured_te_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.auto_config.is_set or
                                        self.auto_config_disabled.is_set or
                                        self.auto_config_forward_reference_interfaces.is_set or
                                        self.forward_references.is_set or
                                        self.known_ip_interface_count.is_set or
                                        self.known_ip_interface_ldp_enabled.is_set or
                                        self.ldp_configured_attached_interface.is_set or
                                        self.ldp_configured_te_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.auto_config.yfilter != YFilter.not_set or
                                        self.auto_config_disabled.yfilter != YFilter.not_set or
                                        self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set or
                                        self.forward_references.yfilter != YFilter.not_set or
                                        self.known_ip_interface_count.yfilter != YFilter.not_set or
                                        self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set or
                                        self.ldp_configured_attached_interface.yfilter != YFilter.not_set or
                                        self.ldp_configured_te_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.auto_config.is_set or self.auto_config.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config.get_name_leafdata())
                                    if (self.auto_config_disabled.is_set or self.auto_config_disabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config_disabled.get_name_leafdata())
                                    if (self.auto_config_forward_reference_interfaces.is_set or self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config_forward_reference_interfaces.get_name_leafdata())
                                    if (self.forward_references.is_set or self.forward_references.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.forward_references.get_name_leafdata())
                                    if (self.known_ip_interface_count.is_set or self.known_ip_interface_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.known_ip_interface_count.get_name_leafdata())
                                    if (self.known_ip_interface_ldp_enabled.is_set or self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.known_ip_interface_ldp_enabled.get_name_leafdata())
                                    if (self.ldp_configured_attached_interface.is_set or self.ldp_configured_attached_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_configured_attached_interface.get_name_leafdata())
                                    if (self.ldp_configured_te_interface.is_set or self.ldp_configured_te_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_configured_te_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "auto-config" or name == "auto-config-disabled" or name == "auto-config-forward-reference-interfaces" or name == "forward-references" or name == "known-ip-interface-count" or name == "known-ip-interface-ldp-enabled" or name == "ldp-configured-attached-interface" or name == "ldp-configured-te-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "auto-config"):
                                        self.auto_config = value
                                        self.auto_config.value_namespace = name_space
                                        self.auto_config.value_namespace_prefix = name_space_prefix
                                    if(value_path == "auto-config-disabled"):
                                        self.auto_config_disabled = value
                                        self.auto_config_disabled.value_namespace = name_space
                                        self.auto_config_disabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "auto-config-forward-reference-interfaces"):
                                        self.auto_config_forward_reference_interfaces = value
                                        self.auto_config_forward_reference_interfaces.value_namespace = name_space
                                        self.auto_config_forward_reference_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "forward-references"):
                                        self.forward_references = value
                                        self.forward_references.value_namespace = name_space
                                        self.forward_references.value_namespace_prefix = name_space_prefix
                                    if(value_path == "known-ip-interface-count"):
                                        self.known_ip_interface_count = value
                                        self.known_ip_interface_count.value_namespace = name_space
                                        self.known_ip_interface_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "known-ip-interface-ldp-enabled"):
                                        self.known_ip_interface_ldp_enabled = value
                                        self.known_ip_interface_ldp_enabled.value_namespace = name_space
                                        self.known_ip_interface_ldp_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-configured-attached-interface"):
                                        self.ldp_configured_attached_interface = value
                                        self.ldp_configured_attached_interface.value_namespace = name_space
                                        self.ldp_configured_attached_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-configured-te-interface"):
                                        self.ldp_configured_te_interface = value
                                        self.ldp_configured_te_interface.value_namespace = name_space
                                        self.ldp_configured_te_interface.value_namespace_prefix = name_space_prefix


                            class Bindings(Entity):
                                """
                                The LDP Bindings
                                
                                .. attribute:: binding
                                
                                	Binding Information
                                	**type**\: list of    :py:class:`Binding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings, self).__init__()

                                    self.yang_name = "bindings"
                                    self.yang_parent_name = "af"

                                    self.binding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings, self).__setattr__(name, value)


                                class Binding(Entity):
                                    """
                                    Binding Information
                                    
                                    .. attribute:: prefix  <key>
                                    
                                    	The IP Prefix
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                    
                                    
                                    ----
                                    .. attribute:: advertise_prefix_acl
                                    
                                    	Advertise Prerfix ACL
                                    	**type**\:  str
                                    
                                    .. attribute:: advertise_tsr_acl
                                    
                                    	Advertise TSR ACL
                                    	**type**\:  str
                                    
                                    .. attribute:: config_enforced_local_label_value
                                    
                                    	Config/User enforced local label value
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_elc
                                    
                                    	Is the entry entropy label capable
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_no_route
                                    
                                    	No route
                                    	**type**\:  bool
                                    
                                    .. attribute:: label_oor
                                    
                                    	Label space depletion OOR
                                    	**type**\:  bool
                                    
                                    .. attribute:: le_local_binding_revision
                                    
                                    	Local Binding revision
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: le_local_label_state
                                    
                                    	Local label state
                                    	**type**\:   :py:class:`LocalLabelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LocalLabelState>`
                                    
                                    .. attribute:: local_label
                                    
                                    	Local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: peers_acked
                                    
                                    	Peers that have ACKed this entry
                                    	**type**\: list of    :py:class:`PeersAcked <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked>`
                                    
                                    .. attribute:: peers_advertised_to
                                    
                                    	Peers this entry is advertised to
                                    	**type**\: list of    :py:class:`PeersAdvertisedTo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo>`
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix Length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: prefix_xr
                                    
                                    	IP Prefix
                                    	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr>`
                                    
                                    .. attribute:: remote_binding
                                    
                                    	Remote binding
                                    	**type**\: list of    :py:class:`RemoteBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__init__()

                                        self.yang_name = "binding"
                                        self.yang_parent_name = "bindings"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.advertise_prefix_acl = YLeaf(YType.str, "advertise-prefix-acl")

                                        self.advertise_tsr_acl = YLeaf(YType.str, "advertise-tsr-acl")

                                        self.config_enforced_local_label_value = YLeaf(YType.boolean, "config-enforced-local-label-value")

                                        self.is_elc = YLeaf(YType.boolean, "is-elc")

                                        self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                        self.label_oor = YLeaf(YType.boolean, "label-oor")

                                        self.le_local_binding_revision = YLeaf(YType.uint32, "le-local-binding-revision")

                                        self.le_local_label_state = YLeaf(YType.enumeration, "le-local-label-state")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.prefix_xr = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr()
                                        self.prefix_xr.parent = self
                                        self._children_name_map["prefix_xr"] = "prefix-xr"
                                        self._children_yang_names.add("prefix-xr")

                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.peers_acked = YList(self)
                                        self.peers_advertised_to = YList(self)
                                        self.remote_binding = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "advertise_prefix_acl",
                                                        "advertise_tsr_acl",
                                                        "config_enforced_local_label_value",
                                                        "is_elc",
                                                        "is_no_route",
                                                        "label_oor",
                                                        "le_local_binding_revision",
                                                        "le_local_label_state",
                                                        "local_label",
                                                        "prefix_length") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "binding"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class PrefixXr(Entity):
                                        """
                                        IP Prefix
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__init__()

                                            self.yang_name = "prefix-xr"
                                            self.yang_parent_name = "binding"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix-xr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class RemoteBinding(Entity):
                                        """
                                        Remote binding
                                        
                                        .. attribute:: assigning_peer_ldp_ident
                                        
                                        	Assigning peer
                                        	**type**\:   :py:class:`AssigningPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent>`
                                        
                                        .. attribute:: is_elc
                                        
                                        	Is the entry entropy label capable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_stale
                                        
                                        	Is the entry stale
                                        	**type**\:  bool
                                        
                                        .. attribute:: remote_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__init__()

                                            self.yang_name = "remote-binding"
                                            self.yang_parent_name = "binding"

                                            self.is_elc = YLeaf(YType.boolean, "is-elc")

                                            self.is_stale = YLeaf(YType.boolean, "is-stale")

                                            self.remote_label = YLeaf(YType.uint32, "remote-label")

                                            self.assigning_peer_ldp_ident = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                            self.assigning_peer_ldp_ident.parent = self
                                            self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                            self._children_yang_names.add("assigning-peer-ldp-ident")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_elc",
                                                            "is_stale",
                                                            "remote_label") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)


                                        class AssigningPeerLdpIdent(Entity):
                                            """
                                            Assigning peer
                                            
                                            .. attribute:: label_space_id
                                            
                                            	Label space identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: ldp_id
                                            
                                            	LDP identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: lsr_id
                                            
                                            	LSR identifier
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__init__()

                                                self.yang_name = "assigning-peer-ldp-ident"
                                                self.yang_parent_name = "remote-binding"

                                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("label_space_id",
                                                                "ldp_id",
                                                                "lsr_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.label_space_id.is_set or
                                                    self.ldp_id.is_set or
                                                    self.lsr_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.label_space_id.yfilter != YFilter.not_set or
                                                    self.ldp_id.yfilter != YFilter.not_set or
                                                    self.lsr_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "assigning-peer-ldp-ident" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "label-space-id"):
                                                    self.label_space_id = value
                                                    self.label_space_id.value_namespace = name_space
                                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ldp-id"):
                                                    self.ldp_id = value
                                                    self.ldp_id.value_namespace = name_space
                                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsr-id"):
                                                    self.lsr_id = value
                                                    self.lsr_id.value_namespace = name_space
                                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.is_elc.is_set or
                                                self.is_stale.is_set or
                                                self.remote_label.is_set or
                                                (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_elc.yfilter != YFilter.not_set or
                                                self.is_stale.yfilter != YFilter.not_set or
                                                self.remote_label.yfilter != YFilter.not_set or
                                                (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "remote-binding" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_elc.get_name_leafdata())
                                            if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_stale.get_name_leafdata())
                                            if (self.remote_label.is_set or self.remote_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.remote_label.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "assigning-peer-ldp-ident"):
                                                if (self.assigning_peer_ldp_ident is None):
                                                    self.assigning_peer_ldp_ident = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                                    self.assigning_peer_ldp_ident.parent = self
                                                    self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                                return self.assigning_peer_ldp_ident

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "assigning-peer-ldp-ident" or name == "is-elc" or name == "is-stale" or name == "remote-label"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-elc"):
                                                self.is_elc = value
                                                self.is_elc.value_namespace = name_space
                                                self.is_elc.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-stale"):
                                                self.is_stale = value
                                                self.is_stale.value_namespace = name_space
                                                self.is_stale.value_namespace_prefix = name_space_prefix
                                            if(value_path == "remote-label"):
                                                self.remote_label = value
                                                self.remote_label.value_namespace = name_space
                                                self.remote_label.value_namespace_prefix = name_space_prefix


                                    class PeersAdvertisedTo(Entity):
                                        """
                                        Peers this entry is advertised to
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__init__()

                                            self.yang_name = "peers-advertised-to"
                                            self.yang_parent_name = "binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers-advertised-to" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix


                                    class PeersAcked(Entity):
                                        """
                                        Peers that have ACKed this entry
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__init__()

                                            self.yang_name = "peers-acked"
                                            self.yang_parent_name = "binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers-acked" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.peers_acked:
                                            if (c.has_data()):
                                                return True
                                        for c in self.peers_advertised_to:
                                            if (c.has_data()):
                                                return True
                                        for c in self.remote_binding:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.prefix.is_set or
                                            self.advertise_prefix_acl.is_set or
                                            self.advertise_tsr_acl.is_set or
                                            self.config_enforced_local_label_value.is_set or
                                            self.is_elc.is_set or
                                            self.is_no_route.is_set or
                                            self.label_oor.is_set or
                                            self.le_local_binding_revision.is_set or
                                            self.le_local_label_state.is_set or
                                            self.local_label.is_set or
                                            self.prefix_length.is_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.peers_acked:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.peers_advertised_to:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.remote_binding:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.advertise_prefix_acl.yfilter != YFilter.not_set or
                                            self.advertise_tsr_acl.yfilter != YFilter.not_set or
                                            self.config_enforced_local_label_value.yfilter != YFilter.not_set or
                                            self.is_elc.yfilter != YFilter.not_set or
                                            self.is_no_route.yfilter != YFilter.not_set or
                                            self.label_oor.yfilter != YFilter.not_set or
                                            self.le_local_binding_revision.yfilter != YFilter.not_set or
                                            self.le_local_label_state.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "binding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.advertise_prefix_acl.is_set or self.advertise_prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertise_prefix_acl.get_name_leafdata())
                                        if (self.advertise_tsr_acl.is_set or self.advertise_tsr_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertise_tsr_acl.get_name_leafdata())
                                        if (self.config_enforced_local_label_value.is_set or self.config_enforced_local_label_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.config_enforced_local_label_value.get_name_leafdata())
                                        if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_elc.get_name_leafdata())
                                        if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                        if (self.label_oor.is_set or self.label_oor.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_oor.get_name_leafdata())
                                        if (self.le_local_binding_revision.is_set or self.le_local_binding_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.le_local_binding_revision.get_name_leafdata())
                                        if (self.le_local_label_state.is_set or self.le_local_label_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.le_local_label_state.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "peers-acked"):
                                            for c in self.peers_acked:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers_acked.append(c)
                                            return c

                                        if (child_yang_name == "peers-advertised-to"):
                                            for c in self.peers_advertised_to:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers_advertised_to.append(c)
                                            return c

                                        if (child_yang_name == "prefix-xr"):
                                            if (self.prefix_xr is None):
                                                self.prefix_xr = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr()
                                                self.prefix_xr.parent = self
                                                self._children_name_map["prefix_xr"] = "prefix-xr"
                                            return self.prefix_xr

                                        if (child_yang_name == "remote-binding"):
                                            for c in self.remote_binding:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.remote_binding.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "peers-acked" or name == "peers-advertised-to" or name == "prefix-xr" or name == "remote-binding" or name == "vrf" or name == "prefix" or name == "advertise-prefix-acl" or name == "advertise-tsr-acl" or name == "config-enforced-local-label-value" or name == "is-elc" or name == "is-no-route" or name == "label-oor" or name == "le-local-binding-revision" or name == "le-local-label-state" or name == "local-label" or name == "prefix-length"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "advertise-prefix-acl"):
                                            self.advertise_prefix_acl = value
                                            self.advertise_prefix_acl.value_namespace = name_space
                                            self.advertise_prefix_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "advertise-tsr-acl"):
                                            self.advertise_tsr_acl = value
                                            self.advertise_tsr_acl.value_namespace = name_space
                                            self.advertise_tsr_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "config-enforced-local-label-value"):
                                            self.config_enforced_local_label_value = value
                                            self.config_enforced_local_label_value.value_namespace = name_space
                                            self.config_enforced_local_label_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-elc"):
                                            self.is_elc = value
                                            self.is_elc.value_namespace = name_space
                                            self.is_elc.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-no-route"):
                                            self.is_no_route = value
                                            self.is_no_route.value_namespace = name_space
                                            self.is_no_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-oor"):
                                            self.label_oor = value
                                            self.label_oor.value_namespace = name_space
                                            self.label_oor.value_namespace_prefix = name_space_prefix
                                        if(value_path == "le-local-binding-revision"):
                                            self.le_local_binding_revision = value
                                            self.le_local_binding_revision.value_namespace = name_space
                                            self.le_local_binding_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "le-local-label-state"):
                                            self.le_local_label_state = value
                                            self.le_local_label_state.value_namespace = name_space
                                            self.le_local_label_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.binding:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.binding:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "binding"):
                                        for c in self.binding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings.Binding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.binding.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "binding"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Igp(Entity):
                                """
                                LDP IGP related information
                                
                                .. attribute:: sync_delay_restart
                                
                                	LDP\-IGP Synchronization Delay related information
                                	**type**\:   :py:class:`SyncDelayRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart>`
                                
                                .. attribute:: syncs
                                
                                	LDP IGP Sync related information
                                	**type**\:   :py:class:`Syncs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp, self).__init__()

                                    self.yang_name = "igp"
                                    self.yang_parent_name = "af"

                                    self.sync_delay_restart = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart()
                                    self.sync_delay_restart.parent = self
                                    self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                    self._children_yang_names.add("sync-delay-restart")

                                    self.syncs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs()
                                    self.syncs.parent = self
                                    self._children_name_map["syncs"] = "syncs"
                                    self._children_yang_names.add("syncs")


                                class Syncs(Entity):
                                    """
                                    LDP IGP Sync related information
                                    
                                    .. attribute:: sync
                                    
                                    	LDP\-IGP Synchronization related information for an interface
                                    	**type**\: list of    :py:class:`Sync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__init__()

                                        self.yang_name = "syncs"
                                        self.yang_parent_name = "igp"

                                        self.sync = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)


                                    class Sync(Entity):
                                        """
                                        LDP\-IGP Synchronization related information
                                        for an interface
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: delay_timer_remaining
                                        
                                        	Remaining timer (seconds) till expiry of sync delay timer
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: gr_only_peer
                                        
                                        	Interface GR\-only reachable peers
                                        	**type**\: list of    :py:class:`GrOnlyPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer>`
                                        
                                        .. attribute:: igp_sync_delay
                                        
                                        	IGP sync delay in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: igp_sync_down_reason
                                        
                                        	Reason IGP Sync Not Achieved
                                        	**type**\:   :py:class:`LdpIgpSyncDownReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncDownReason>`
                                        
                                        .. attribute:: igp_sync_state
                                        
                                        	IGP Sync state
                                        	**type**\:   :py:class:`LdpIgpSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncState>`
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: is_delay_timer_running
                                        
                                        	Is sync delay timer running
                                        	**type**\:  bool
                                        
                                        .. attribute:: peers
                                        
                                        	Interface Peers
                                        	**type**\: list of    :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers>`
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__init__()

                                            self.yang_name = "sync"
                                            self.yang_parent_name = "syncs"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.delay_timer_remaining = YLeaf(YType.uint32, "delay-timer-remaining")

                                            self.igp_sync_delay = YLeaf(YType.uint32, "igp-sync-delay")

                                            self.igp_sync_down_reason = YLeaf(YType.enumeration, "igp-sync-down-reason")

                                            self.igp_sync_state = YLeaf(YType.enumeration, "igp-sync-state")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.is_delay_timer_running = YLeaf(YType.boolean, "is-delay-timer-running")

                                            self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.gr_only_peer = YList(self)
                                            self.peers = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "delay_timer_remaining",
                                                            "igp_sync_delay",
                                                            "igp_sync_down_reason",
                                                            "igp_sync_state",
                                                            "interface_name_xr",
                                                            "is_delay_timer_running") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "sync"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class Peers(Entity):
                                            """
                                            Interface Peers
                                            
                                            .. attribute:: is_gr_enabled
                                            
                                            	Is GR enabled session
                                            	**type**\:  bool
                                            
                                            .. attribute:: peer_id
                                            
                                            	Peer Identifier
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__init__()

                                                self.yang_name = "peers"
                                                self.yang_parent_name = "sync"

                                                self.is_gr_enabled = YLeaf(YType.boolean, "is-gr-enabled")

                                                self.peer_id = YLeaf(YType.str, "peer-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_gr_enabled",
                                                                "peer_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_gr_enabled.is_set or
                                                    self.peer_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_gr_enabled.yfilter != YFilter.not_set or
                                                    self.peer_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "peers" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_gr_enabled.is_set or self.is_gr_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_gr_enabled.get_name_leafdata())
                                                if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.peer_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-gr-enabled" or name == "peer-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-gr-enabled"):
                                                    self.is_gr_enabled = value
                                                    self.is_gr_enabled.value_namespace = name_space
                                                    self.is_gr_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "peer-id"):
                                                    self.peer_id = value
                                                    self.peer_id.value_namespace = name_space
                                                    self.peer_id.value_namespace_prefix = name_space_prefix


                                        class GrOnlyPeer(Entity):
                                            """
                                            Interface GR\-only reachable peers
                                            
                                            .. attribute:: is_chkpt_created
                                            
                                            	Is created due to checkpointing
                                            	**type**\:  bool
                                            
                                            .. attribute:: peer_id
                                            
                                            	Peer Identifier
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__init__()

                                                self.yang_name = "gr-only-peer"
                                                self.yang_parent_name = "sync"

                                                self.is_chkpt_created = YLeaf(YType.boolean, "is-chkpt-created")

                                                self.peer_id = YLeaf(YType.str, "peer-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_chkpt_created",
                                                                "peer_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_chkpt_created.is_set or
                                                    self.peer_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_chkpt_created.yfilter != YFilter.not_set or
                                                    self.peer_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "gr-only-peer" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_chkpt_created.is_set or self.is_chkpt_created.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_chkpt_created.get_name_leafdata())
                                                if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.peer_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-chkpt-created" or name == "peer-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-chkpt-created"):
                                                    self.is_chkpt_created = value
                                                    self.is_chkpt_created.value_namespace = name_space
                                                    self.is_chkpt_created.value_namespace_prefix = name_space_prefix
                                                if(value_path == "peer-id"):
                                                    self.peer_id = value
                                                    self.peer_id.value_namespace = name_space
                                                    self.peer_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.gr_only_peer:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.peers:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.delay_timer_remaining.is_set or
                                                self.igp_sync_delay.is_set or
                                                self.igp_sync_down_reason.is_set or
                                                self.igp_sync_state.is_set or
                                                self.interface_name_xr.is_set or
                                                self.is_delay_timer_running.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.gr_only_peer:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.peers:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.delay_timer_remaining.yfilter != YFilter.not_set or
                                                self.igp_sync_delay.yfilter != YFilter.not_set or
                                                self.igp_sync_down_reason.yfilter != YFilter.not_set or
                                                self.igp_sync_state.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                self.is_delay_timer_running.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "sync" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.delay_timer_remaining.is_set or self.delay_timer_remaining.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.delay_timer_remaining.get_name_leafdata())
                                            if (self.igp_sync_delay.is_set or self.igp_sync_delay.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_delay.get_name_leafdata())
                                            if (self.igp_sync_down_reason.is_set or self.igp_sync_down_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_down_reason.get_name_leafdata())
                                            if (self.igp_sync_state.is_set or self.igp_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_state.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                            if (self.is_delay_timer_running.is_set or self.is_delay_timer_running.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_delay_timer_running.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "gr-only-peer"):
                                                for c in self.gr_only_peer:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.gr_only_peer.append(c)
                                                return c

                                            if (child_yang_name == "peers"):
                                                for c in self.peers:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.peers.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "gr-only-peer" or name == "peers" or name == "vrf" or name == "interface-name" or name == "delay-timer-remaining" or name == "igp-sync-delay" or name == "igp-sync-down-reason" or name == "igp-sync-state" or name == "interface-name-xr" or name == "is-delay-timer-running"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "delay-timer-remaining"):
                                                self.delay_timer_remaining = value
                                                self.delay_timer_remaining.value_namespace = name_space
                                                self.delay_timer_remaining.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-delay"):
                                                self.igp_sync_delay = value
                                                self.igp_sync_delay.value_namespace = name_space
                                                self.igp_sync_delay.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-down-reason"):
                                                self.igp_sync_down_reason = value
                                                self.igp_sync_down_reason.value_namespace = name_space
                                                self.igp_sync_down_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-state"):
                                                self.igp_sync_state = value
                                                self.igp_sync_state.value_namespace = name_space
                                                self.igp_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-delay-timer-running"):
                                                self.is_delay_timer_running = value
                                                self.is_delay_timer_running.value_namespace = name_space
                                                self.is_delay_timer_running.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.sync:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.sync:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "syncs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "sync"):
                                            for c in self.sync:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.sync.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "sync"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class SyncDelayRestart(Entity):
                                    """
                                    LDP\-IGP Synchronization Delay related
                                    information
                                    
                                    .. attribute:: configured
                                    
                                    	Is restart delay configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: delay_secs
                                    
                                    	Delay time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: remaining_secs
                                    
                                    	Delay timer remaining time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: timer_running
                                    
                                    	Is restart delay timer running
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__init__()

                                        self.yang_name = "sync-delay-restart"
                                        self.yang_parent_name = "igp"

                                        self.configured = YLeaf(YType.boolean, "configured")

                                        self.delay_secs = YLeaf(YType.uint32, "delay-secs")

                                        self.remaining_secs = YLeaf(YType.uint32, "remaining-secs")

                                        self.timer_running = YLeaf(YType.boolean, "timer-running")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured",
                                                        "delay_secs",
                                                        "remaining_secs",
                                                        "timer_running") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.configured.is_set or
                                            self.delay_secs.is_set or
                                            self.remaining_secs.is_set or
                                            self.timer_running.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured.yfilter != YFilter.not_set or
                                            self.delay_secs.yfilter != YFilter.not_set or
                                            self.remaining_secs.yfilter != YFilter.not_set or
                                            self.timer_running.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sync-delay-restart" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured.is_set or self.configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured.get_name_leafdata())
                                        if (self.delay_secs.is_set or self.delay_secs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.delay_secs.get_name_leafdata())
                                        if (self.remaining_secs.is_set or self.remaining_secs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remaining_secs.get_name_leafdata())
                                        if (self.timer_running.is_set or self.timer_running.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.timer_running.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "configured" or name == "delay-secs" or name == "remaining-secs" or name == "timer-running"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured"):
                                            self.configured = value
                                            self.configured.value_namespace = name_space
                                            self.configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "delay-secs"):
                                            self.delay_secs = value
                                            self.delay_secs.value_namespace = name_space
                                            self.delay_secs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remaining-secs"):
                                            self.remaining_secs = value
                                            self.remaining_secs.value_namespace = name_space
                                            self.remaining_secs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "timer-running"):
                                            self.timer_running = value
                                            self.timer_running.value_namespace = name_space
                                            self.timer_running.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.sync_delay_restart is not None and self.sync_delay_restart.has_data()) or
                                        (self.syncs is not None and self.syncs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.sync_delay_restart is not None and self.sync_delay_restart.has_operation()) or
                                        (self.syncs is not None and self.syncs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "igp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sync-delay-restart"):
                                        if (self.sync_delay_restart is None):
                                            self.sync_delay_restart = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart()
                                            self.sync_delay_restart.parent = self
                                            self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                        return self.sync_delay_restart

                                    if (child_yang_name == "syncs"):
                                        if (self.syncs is None):
                                            self.syncs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp.Syncs()
                                            self.syncs.parent = self
                                            self._children_name_map["syncs"] = "syncs"
                                        return self.syncs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sync-delay-restart" or name == "syncs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsSummary(Entity):
                                """
                                Counters for the LDP Label Infomation Base
                                (LIB)
                                
                                .. attribute:: address_family
                                
                                	Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: bind_af
                                
                                	bind af
                                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf>`
                                
                                .. attribute:: binding_local_explicit_null
                                
                                	Number of local explicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_implicit_null
                                
                                	Number of local implicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_no_route
                                
                                	Local bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_non_null
                                
                                	Number of local non\-null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_null
                                
                                	Number of local null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_oor
                                
                                	Number of local bindings        needing label \- OOR
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_no_route
                                
                                	Bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: highest_allocated_label
                                
                                	Highest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lowest_allocated_label
                                
                                	Lowest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__init__()

                                    self.yang_name = "bindings-summary"
                                    self.yang_parent_name = "af"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                    self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.bind_af = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local_explicit_null",
                                                    "binding_local_implicit_null",
                                                    "binding_local_no_route",
                                                    "binding_local_non_null",
                                                    "binding_local_null",
                                                    "binding_local_oor",
                                                    "binding_no_route",
                                                    "highest_allocated_label",
                                                    "lowest_allocated_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "bindings-summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class BindAf(Entity):
                                    """
                                    bind af
                                    
                                    .. attribute:: address_family
                                    
                                    	Binding Summary Address Family
                                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                    
                                    .. attribute:: binding_local
                                    
                                    	Number of local bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_remote
                                    
                                    	Number of remote bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_total
                                    
                                    	Total bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_lib_update
                                    
                                    	Last update to LIB local binding
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lib_minimum_revision_sent_all
                                    
                                    	Last update sent to all peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__init__()

                                        self.yang_name = "bind-af"
                                        self.yang_parent_name = "bindings-summary"

                                        self.address_family = YLeaf(YType.enumeration, "address-family")

                                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address_family",
                                                        "binding_local",
                                                        "binding_remote",
                                                        "binding_total",
                                                        "last_lib_update",
                                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address_family.is_set or
                                            self.binding_local.is_set or
                                            self.binding_remote.is_set or
                                            self.binding_total.is_set or
                                            self.last_lib_update.is_set or
                                            self.lib_minimum_revision_sent_all.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address_family.yfilter != YFilter.not_set or
                                            self.binding_local.yfilter != YFilter.not_set or
                                            self.binding_remote.yfilter != YFilter.not_set or
                                            self.binding_total.yfilter != YFilter.not_set or
                                            self.last_lib_update.yfilter != YFilter.not_set or
                                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bind-af" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address_family.get_name_leafdata())
                                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address-family"):
                                            self.address_family = value
                                            self.address_family.value_namespace = name_space
                                            self.address_family.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-local"):
                                            self.binding_local = value
                                            self.binding_local.value_namespace = name_space
                                            self.binding_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-remote"):
                                            self.binding_remote = value
                                            self.binding_remote.value_namespace = name_space
                                            self.binding_remote.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-total"):
                                            self.binding_total = value
                                            self.binding_total.value_namespace = name_space
                                            self.binding_total.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-lib-update"):
                                            self.last_lib_update = value
                                            self.last_lib_update.value_namespace = name_space
                                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lib-minimum-revision-sent-all"):
                                            self.lib_minimum_revision_sent_all = value
                                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bind_af:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local_explicit_null.is_set or
                                        self.binding_local_implicit_null.is_set or
                                        self.binding_local_no_route.is_set or
                                        self.binding_local_non_null.is_set or
                                        self.binding_local_null.is_set or
                                        self.binding_local_oor.is_set or
                                        self.binding_no_route.is_set or
                                        self.highest_allocated_label.is_set or
                                        self.lowest_allocated_label.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.bind_af:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_no_route.yfilter != YFilter.not_set or
                                        self.binding_local_non_null.yfilter != YFilter.not_set or
                                        self.binding_local_null.yfilter != YFilter.not_set or
                                        self.binding_local_oor.yfilter != YFilter.not_set or
                                        self.binding_no_route.yfilter != YFilter.not_set or
                                        self.highest_allocated_label.yfilter != YFilter.not_set or
                                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bind-af"):
                                        for c in self.bind_af:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bind_af.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-explicit-null"):
                                        self.binding_local_explicit_null = value
                                        self.binding_local_explicit_null.value_namespace = name_space
                                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-implicit-null"):
                                        self.binding_local_implicit_null = value
                                        self.binding_local_implicit_null.value_namespace = name_space
                                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-no-route"):
                                        self.binding_local_no_route = value
                                        self.binding_local_no_route.value_namespace = name_space
                                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-non-null"):
                                        self.binding_local_non_null = value
                                        self.binding_local_non_null.value_namespace = name_space
                                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-null"):
                                        self.binding_local_null = value
                                        self.binding_local_null.value_namespace = name_space
                                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-oor"):
                                        self.binding_local_oor = value
                                        self.binding_local_oor.value_namespace = name_space
                                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-no-route"):
                                        self.binding_no_route = value
                                        self.binding_no_route.value_namespace = name_space
                                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "highest-allocated-label"):
                                        self.highest_allocated_label = value
                                        self.highest_allocated_label.value_namespace = name_space
                                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lowest-allocated-label"):
                                        self.lowest_allocated_label = value
                                        self.lowest_allocated_label.value_namespace = name_space
                                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                            class Interfaces(Entity):
                                """
                                LDP Interface related information
                                
                                .. attribute:: interface
                                
                                	IPv4 interface information
                                	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces, self).__init__()

                                    self.yang_name = "interfaces"
                                    self.yang_parent_name = "af"

                                    self.interface = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces, self).__setattr__(name, value)


                                class Interface(Entity):
                                    """
                                    IPv4 interface information
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: auto_config
                                    
                                    	Auto config
                                    	**type**\: list of    :py:class:`AutoConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig>`
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: is_im_stale
                                    
                                    	Is IM information stale
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_autoconfig_disable
                                    
                                    	LDP autoconfig disable
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_config_mode
                                    
                                    	LDP config mode
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_enabled
                                    
                                    	LDP enabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: te_mesh_grp
                                    
                                    	TE tunnel mesh\-group
                                    	**type**\: list of    :py:class:`TeMeshGrp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__init__()

                                        self.yang_name = "interface"
                                        self.yang_parent_name = "interfaces"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.is_im_stale = YLeaf(YType.boolean, "is-im-stale")

                                        self.ldp_autoconfig_disable = YLeaf(YType.boolean, "ldp-autoconfig-disable")

                                        self.ldp_config_mode = YLeaf(YType.boolean, "ldp-config-mode")

                                        self.ldp_enabled = YLeaf(YType.boolean, "ldp-enabled")

                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.auto_config = YList(self)
                                        self.te_mesh_grp = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "interface",
                                                        "interface_name_xr",
                                                        "is_im_stale",
                                                        "ldp_autoconfig_disable",
                                                        "ldp_config_mode",
                                                        "ldp_enabled") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "interface"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class TeMeshGrp(Entity):
                                        """
                                        TE tunnel mesh\-group
                                        
                                        .. attribute:: ldp_mesh_group_enabled
                                        
                                        	LDP has enabled this TE mesh\-group
                                        	**type**\:  bool
                                        
                                        .. attribute:: ldp_te_mesh_group_all_cfgd
                                        
                                        	LDP has enabled all TE mesh\-groups
                                        	**type**\:  bool
                                        
                                        .. attribute:: te_mesh_group_id
                                        
                                        	TE tunnel Mesh Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__init__()

                                            self.yang_name = "te-mesh-grp"
                                            self.yang_parent_name = "interface"

                                            self.ldp_mesh_group_enabled = YLeaf(YType.boolean, "ldp-mesh-group-enabled")

                                            self.ldp_te_mesh_group_all_cfgd = YLeaf(YType.boolean, "ldp-te-mesh-group-all-cfgd")

                                            self.te_mesh_group_id = YLeaf(YType.uint32, "te-mesh-group-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ldp_mesh_group_enabled",
                                                            "ldp_te_mesh_group_all_cfgd",
                                                            "te_mesh_group_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.ldp_mesh_group_enabled.is_set or
                                                self.ldp_te_mesh_group_all_cfgd.is_set or
                                                self.te_mesh_group_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ldp_mesh_group_enabled.yfilter != YFilter.not_set or
                                                self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set or
                                                self.te_mesh_group_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "te-mesh-grp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ldp_mesh_group_enabled.is_set or self.ldp_mesh_group_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_mesh_group_enabled.get_name_leafdata())
                                            if (self.ldp_te_mesh_group_all_cfgd.is_set or self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_te_mesh_group_all_cfgd.get_name_leafdata())
                                            if (self.te_mesh_group_id.is_set or self.te_mesh_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.te_mesh_group_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "ldp-mesh-group-enabled" or name == "ldp-te-mesh-group-all-cfgd" or name == "te-mesh-group-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ldp-mesh-group-enabled"):
                                                self.ldp_mesh_group_enabled = value
                                                self.ldp_mesh_group_enabled.value_namespace = name_space
                                                self.ldp_mesh_group_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-te-mesh-group-all-cfgd"):
                                                self.ldp_te_mesh_group_all_cfgd = value
                                                self.ldp_te_mesh_group_all_cfgd.value_namespace = name_space
                                                self.ldp_te_mesh_group_all_cfgd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "te-mesh-group-id"):
                                                self.te_mesh_group_id = value
                                                self.te_mesh_group_id.value_namespace = name_space
                                                self.te_mesh_group_id.value_namespace_prefix = name_space_prefix


                                    class AutoConfig(Entity):
                                        """
                                        Auto config
                                        
                                        .. attribute:: tuple
                                        
                                        	Tuple
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__init__()

                                            self.yang_name = "auto-config"
                                            self.yang_parent_name = "interface"

                                            self.tuple = YLeaf(YType.str, "tuple")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("tuple") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.tuple.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.tuple.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "auto-config" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.tuple.is_set or self.tuple.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tuple.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "tuple"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "tuple"):
                                                self.tuple = value
                                                self.tuple.value_namespace = name_space
                                                self.tuple.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.auto_config:
                                            if (c.has_data()):
                                                return True
                                        for c in self.te_mesh_grp:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.interface.is_set or
                                            self.interface_name_xr.is_set or
                                            self.is_im_stale.is_set or
                                            self.ldp_autoconfig_disable.is_set or
                                            self.ldp_config_mode.is_set or
                                            self.ldp_enabled.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.auto_config:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.te_mesh_grp:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.is_im_stale.yfilter != YFilter.not_set or
                                            self.ldp_autoconfig_disable.yfilter != YFilter.not_set or
                                            self.ldp_config_mode.yfilter != YFilter.not_set or
                                            self.ldp_enabled.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.is_im_stale.is_set or self.is_im_stale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_im_stale.get_name_leafdata())
                                        if (self.ldp_autoconfig_disable.is_set or self.ldp_autoconfig_disable.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_autoconfig_disable.get_name_leafdata())
                                        if (self.ldp_config_mode.is_set or self.ldp_config_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_config_mode.get_name_leafdata())
                                        if (self.ldp_enabled.is_set or self.ldp_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_enabled.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "auto-config"):
                                            for c in self.auto_config:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.auto_config.append(c)
                                            return c

                                        if (child_yang_name == "te-mesh-grp"):
                                            for c in self.te_mesh_grp:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.te_mesh_grp.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "auto-config" or name == "te-mesh-grp" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "is-im-stale" or name == "ldp-autoconfig-disable" or name == "ldp-config-mode" or name == "ldp-enabled"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-im-stale"):
                                            self.is_im_stale = value
                                            self.is_im_stale.value_namespace = name_space
                                            self.is_im_stale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-autoconfig-disable"):
                                            self.ldp_autoconfig_disable = value
                                            self.ldp_autoconfig_disable.value_namespace = name_space
                                            self.ldp_autoconfig_disable.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-config-mode"):
                                            self.ldp_config_mode = value
                                            self.ldp_config_mode.value_namespace = name_space
                                            self.ldp_config_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-enabled"):
                                            self.ldp_enabled = value
                                            self.ldp_enabled.value_namespace = name_space
                                            self.ldp_enabled.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.interface:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.interface:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interfaces" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "interface"):
                                        for c in self.interface:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces.Interface()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.interface.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Discovery(Entity):
                                """
                                The LDP Discovery
                                
                                .. attribute:: brief
                                
                                	Brief information on LDP discovery
                                	**type**\:   :py:class:`Brief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief>`
                                
                                .. attribute:: link_hellos
                                
                                	The LDP Discovery link
                                	**type**\:   :py:class:`LinkHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos>`
                                
                                .. attribute:: stats
                                
                                	The LDP Discovery Statistics
                                	**type**\:   :py:class:`Stats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats>`
                                
                                .. attribute:: summary
                                
                                	Summarized information on LDP discovery
                                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary>`
                                
                                .. attribute:: targeted_hellos
                                
                                	The LDP Discovery Targeted
                                	**type**\:   :py:class:`TargetedHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery, self).__init__()

                                    self.yang_name = "discovery"
                                    self.yang_parent_name = "af"

                                    self.brief = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief()
                                    self.brief.parent = self
                                    self._children_name_map["brief"] = "brief"
                                    self._children_yang_names.add("brief")

                                    self.link_hellos = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos()
                                    self.link_hellos.parent = self
                                    self._children_name_map["link_hellos"] = "link-hellos"
                                    self._children_yang_names.add("link-hellos")

                                    self.stats = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats()
                                    self.stats.parent = self
                                    self._children_name_map["stats"] = "stats"
                                    self._children_yang_names.add("stats")

                                    self.summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary()
                                    self.summary.parent = self
                                    self._children_name_map["summary"] = "summary"
                                    self._children_yang_names.add("summary")

                                    self.targeted_hellos = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos()
                                    self.targeted_hellos.parent = self
                                    self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                    self._children_yang_names.add("targeted-hellos")


                                class LinkHellos(Entity):
                                    """
                                    The LDP Discovery link
                                    
                                    .. attribute:: link_hello
                                    
                                    	Information on LDP link discovery
                                    	**type**\: list of    :py:class:`LinkHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__init__()

                                        self.yang_name = "link-hellos"
                                        self.yang_parent_name = "discovery"

                                        self.link_hello = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)


                                    class LinkHello(Entity):
                                        """
                                        Information on LDP link discovery
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: discovery_link_af
                                        
                                        	LDP hello AF info
                                        	**type**\: list of    :py:class:`DiscoveryLinkAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation>`
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: next_hello
                                        
                                        	Next hello due time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: quick_start_disabled
                                        
                                        	Quick\-start disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__init__()

                                            self.yang_name = "link-hello"
                                            self.yang_parent_name = "link-hellos"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.next_hello = YLeaf(YType.uint32, "next-hello")

                                            self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                            self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.discovery_link_af = YList(self)
                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "interface",
                                                            "interface_name_xr",
                                                            "next_hello",
                                                            "quick_start_disabled") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "link-hello"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: disc_expiry
                                            
                                            	Discovery expiry time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: established_age
                                            
                                            	Hello adjacency estabished age in nanosec
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: established_time
                                            
                                            	Hello adjacency estabished time in nanosec
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: is_no_route
                                            
                                            	Is route valid
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_targeted
                                            
                                            	Is session a targeted session
                                            	**type**\:  bool
                                            
                                            .. attribute:: last_session_down_info
                                            
                                            	Last session down information
                                            	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo>`
                                            
                                            .. attribute:: local_hold_time
                                            
                                            	Local hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: neighbor_hold_time
                                            
                                            	Neighbor hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: neighbor_src_address
                                            
                                            	Neighbor source address
                                            	**type**\:   :py:class:`NeighborSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress>`
                                            
                                            .. attribute:: neighbor_transport_address
                                            
                                            	Neighbor transport address
                                            	**type**\:   :py:class:`NeighborTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress>`
                                            
                                            .. attribute:: session_bringup_failure_reason
                                            
                                            	session bringup failure reason
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            .. attribute:: target
                                            
                                            	Target address
                                            	**type**\:   :py:class:`Target <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "link-hello"

                                                self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                                self.established_age = YLeaf(YType.uint64, "established-age")

                                                self.established_time = YLeaf(YType.uint64, "established-time")

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                                self.is_targeted = YLeaf(YType.boolean, "is-targeted")

                                                self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                                self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                                self.neighbor_src_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                self.neighbor_src_address.parent = self
                                                self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                self._children_yang_names.add("neighbor-src-address")

                                                self.neighbor_transport_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                self.neighbor_transport_address.parent = self
                                                self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                self._children_yang_names.add("neighbor-transport-address")

                                                self.target = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                self.target.parent = self
                                                self._children_name_map["target"] = "target"
                                                self._children_yang_names.add("target")

                                                self.last_session_down_info = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("disc_expiry",
                                                                "established_age",
                                                                "established_time",
                                                                "hold_time",
                                                                "is_no_route",
                                                                "is_targeted",
                                                                "local_hold_time",
                                                                "neighbor_hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_bringup_failure_reason",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)


                                            class NeighborSrcAddress(Entity):
                                                """
                                                Neighbor source address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__init__()

                                                    self.yang_name = "neighbor-src-address"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "neighbor-src-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class NeighborTransportAddress(Entity):
                                                """
                                                Neighbor transport address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__init__()

                                                    self.yang_name = "neighbor-transport-address"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "neighbor-transport-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class Target(Entity):
                                                """
                                                Target address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__init__()

                                                    self.yang_name = "target"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "target" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class LastSessionDownInfo(Entity):
                                                """
                                                Last session down information
                                                
                                                .. attribute:: last_session_down_reason
                                                
                                                	The reason of last socket failure
                                                	**type**\:  str
                                                
                                                .. attribute:: last_session_down_time
                                                
                                                	Timestamp of when the last session went down
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: last_session_up_time
                                                
                                                	The time duration the last session was up
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__init__()

                                                    self.yang_name = "last-session-down-info"
                                                    self.yang_parent_name = "hello-information"

                                                    self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                    self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                    self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("last_session_down_reason",
                                                                    "last_session_down_time",
                                                                    "last_session_up_time") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.last_session_down_reason.is_set or
                                                        self.last_session_down_time.is_set or
                                                        self.last_session_up_time.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.last_session_down_reason.yfilter != YFilter.not_set or
                                                        self.last_session_down_time.yfilter != YFilter.not_set or
                                                        self.last_session_up_time.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "last-session-down-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                    if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                    if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "last-session-down-reason"):
                                                        self.last_session_down_reason = value
                                                        self.last_session_down_reason.value_namespace = name_space
                                                        self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "last-session-down-time"):
                                                        self.last_session_down_time = value
                                                        self.last_session_down_time.value_namespace = name_space
                                                        self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "last-session-up-time"):
                                                        self.last_session_up_time = value
                                                        self.last_session_up_time.value_namespace = name_space
                                                        self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.last_session_down_info:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.disc_expiry.is_set or
                                                    self.established_age.is_set or
                                                    self.established_time.is_set or
                                                    self.hold_time.is_set or
                                                    self.is_no_route.is_set or
                                                    self.is_targeted.is_set or
                                                    self.local_hold_time.is_set or
                                                    self.neighbor_hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_bringup_failure_reason.is_set or
                                                    self.session_up.is_set or
                                                    (self.neighbor_src_address is not None and self.neighbor_src_address.has_data()) or
                                                    (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_data()) or
                                                    (self.target is not None and self.target.has_data()))

                                            def has_operation(self):
                                                for c in self.last_session_down_info:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.disc_expiry.yfilter != YFilter.not_set or
                                                    self.established_age.yfilter != YFilter.not_set or
                                                    self.established_time.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.is_no_route.yfilter != YFilter.not_set or
                                                    self.is_targeted.yfilter != YFilter.not_set or
                                                    self.local_hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set or
                                                    (self.neighbor_src_address is not None and self.neighbor_src_address.has_operation()) or
                                                    (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_operation()) or
                                                    (self.target is not None and self.target.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                                if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.established_age.get_name_leafdata())
                                                if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.established_time.get_name_leafdata())
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                                if (self.is_targeted.is_set or self.is_targeted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_targeted.get_name_leafdata())
                                                if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                                if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "last-session-down-info"):
                                                    for c in self.last_session_down_info:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.last_session_down_info.append(c)
                                                    return c

                                                if (child_yang_name == "neighbor-src-address"):
                                                    if (self.neighbor_src_address is None):
                                                        self.neighbor_src_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                        self.neighbor_src_address.parent = self
                                                        self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                    return self.neighbor_src_address

                                                if (child_yang_name == "neighbor-transport-address"):
                                                    if (self.neighbor_transport_address is None):
                                                        self.neighbor_transport_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                        self.neighbor_transport_address.parent = self
                                                        self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                    return self.neighbor_transport_address

                                                if (child_yang_name == "target"):
                                                    if (self.target is None):
                                                        self.target = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                        self.target.parent = self
                                                        self._children_name_map["target"] = "target"
                                                    return self.target

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-info" or name == "neighbor-src-address" or name == "neighbor-transport-address" or name == "target" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "is-no-route" or name == "is-targeted" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "neighbor-ldp-identifier" or name == "session-bringup-failure-reason" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "disc-expiry"):
                                                    self.disc_expiry = value
                                                    self.disc_expiry.value_namespace = name_space
                                                    self.disc_expiry.value_namespace_prefix = name_space_prefix
                                                if(value_path == "established-age"):
                                                    self.established_age = value
                                                    self.established_age.value_namespace = name_space
                                                    self.established_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "established-time"):
                                                    self.established_time = value
                                                    self.established_time.value_namespace = name_space
                                                    self.established_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-route"):
                                                    self.is_no_route = value
                                                    self.is_no_route.value_namespace = name_space
                                                    self.is_no_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-targeted"):
                                                    self.is_targeted = value
                                                    self.is_targeted.value_namespace = name_space
                                                    self.is_targeted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-hold-time"):
                                                    self.local_hold_time = value
                                                    self.local_hold_time.value_namespace = name_space
                                                    self.local_hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-hold-time"):
                                                    self.neighbor_hold_time = value
                                                    self.neighbor_hold_time.value_namespace = name_space
                                                    self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-bringup-failure-reason"):
                                                    self.session_bringup_failure_reason = value
                                                    self.session_bringup_failure_reason.value_namespace = name_space
                                                    self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix


                                        class DiscoveryLinkAf(Entity):
                                            """
                                            LDP hello AF info
                                            
                                            .. attribute:: interval
                                            
                                            	Hello interval in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: local_src_address
                                            
                                            	Local source address
                                            	**type**\:   :py:class:`LocalSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress>`
                                            
                                            .. attribute:: local_transport_address
                                            
                                            	Local transport address
                                            	**type**\:   :py:class:`LocalTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__init__()

                                                self.yang_name = "discovery-link-af"
                                                self.yang_parent_name = "link-hello"

                                                self.interval = YLeaf(YType.uint32, "interval")

                                                self.local_src_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                self.local_src_address.parent = self
                                                self._children_name_map["local_src_address"] = "local-src-address"
                                                self._children_yang_names.add("local-src-address")

                                                self.local_transport_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                self.local_transport_address.parent = self
                                                self._children_name_map["local_transport_address"] = "local-transport-address"
                                                self._children_yang_names.add("local-transport-address")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interval") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)


                                            class LocalSrcAddress(Entity):
                                                """
                                                Local source address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__init__()

                                                    self.yang_name = "local-src-address"
                                                    self.yang_parent_name = "discovery-link-af"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "local-src-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class LocalTransportAddress(Entity):
                                                """
                                                Local transport address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__init__()

                                                    self.yang_name = "local-transport-address"
                                                    self.yang_parent_name = "discovery-link-af"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "local-transport-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interval.is_set or
                                                    (self.local_src_address is not None and self.local_src_address.has_data()) or
                                                    (self.local_transport_address is not None and self.local_transport_address.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interval.yfilter != YFilter.not_set or
                                                    (self.local_src_address is not None and self.local_src_address.has_operation()) or
                                                    (self.local_transport_address is not None and self.local_transport_address.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "discovery-link-af" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interval.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "local-src-address"):
                                                    if (self.local_src_address is None):
                                                        self.local_src_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                        self.local_src_address.parent = self
                                                        self._children_name_map["local_src_address"] = "local-src-address"
                                                    return self.local_src_address

                                                if (child_yang_name == "local-transport-address"):
                                                    if (self.local_transport_address is None):
                                                        self.local_transport_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                        self.local_transport_address.parent = self
                                                        self._children_name_map["local_transport_address"] = "local-transport-address"
                                                    return self.local_transport_address

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "local-src-address" or name == "local-transport-address" or name == "interval"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interval"):
                                                    self.interval = value
                                                    self.interval.value_namespace = name_space
                                                    self.interval.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.discovery_link_af:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.interface.is_set or
                                                self.interface_name_xr.is_set or
                                                self.next_hello.is_set or
                                                self.quick_start_disabled.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.discovery_link_af:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                self.next_hello.yfilter != YFilter.not_set or
                                                self.quick_start_disabled.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                            if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hello.get_name_leafdata())
                                            if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "discovery-link-af"):
                                                for c in self.discovery_link_af:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.discovery_link_af.append(c)
                                                return c

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "discovery-link-af" or name == "hello-information" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "next-hello" or name == "quick-start-disabled"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hello"):
                                                self.next_hello = value
                                                self.next_hello.value_namespace = name_space
                                                self.next_hello.value_namespace_prefix = name_space_prefix
                                            if(value_path == "quick-start-disabled"):
                                                self.quick_start_disabled = value
                                                self.quick_start_disabled.value_namespace = name_space
                                                self.quick_start_disabled.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link_hello:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.link_hello:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hellos" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello"):
                                            for c in self.link_hello:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link_hello.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Summary(Entity):
                                    """
                                    Summarized information on LDP discovery
                                    
                                    .. attribute:: local_ldp_id
                                    
                                    	Local LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: num_of_active_ldp_interfaces
                                    
                                    	Number of active LDP enabled interfaces
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_addr_recv
                                    
                                    	Number of hello discoveries received with bad source address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_hello_pdu
                                    
                                    	Number of hello discoveries received with bad hello PDU
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_xport_addr
                                    
                                    	Number of hello discoveries received with bad export address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_same_router_id
                                    
                                    	Number of hello discoveries received with the same router id as this router
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_wrong_router_id
                                    
                                    	Number of hello discoveries received with the router id that is not destined for this router
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_ldp_interfaces
                                    
                                    	Total Number of LDP configured interfaces
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_lnk_disc_recv
                                    
                                    	Number of link hello discoveries in recv state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_lnk_disc_xmit
                                    
                                    	Number of link hello discoveries in xmit state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_tgt_disc_recv
                                    
                                    	Number of targeted hello discoveries in recv state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_tgt_disc_xmit
                                    
                                    	Number of targeted hello discoveries in xmit state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__init__()

                                        self.yang_name = "summary"
                                        self.yang_parent_name = "discovery"

                                        self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                                        self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                                        self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                                        self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                                        self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                                        self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                                        self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                                        self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                                        self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                                        self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                                        self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                                        self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_ldp_id",
                                                        "num_of_active_ldp_interfaces",
                                                        "num_of_disc_with_bad_addr_recv",
                                                        "num_of_disc_with_bad_hello_pdu",
                                                        "num_of_disc_with_bad_xport_addr",
                                                        "num_of_disc_with_same_router_id",
                                                        "num_of_disc_with_wrong_router_id",
                                                        "num_of_ldp_interfaces",
                                                        "num_of_lnk_disc_recv",
                                                        "num_of_lnk_disc_xmit",
                                                        "num_of_tgt_disc_recv",
                                                        "num_of_tgt_disc_xmit") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "summary"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.local_ldp_id.is_set or
                                            self.num_of_active_ldp_interfaces.is_set or
                                            self.num_of_disc_with_bad_addr_recv.is_set or
                                            self.num_of_disc_with_bad_hello_pdu.is_set or
                                            self.num_of_disc_with_bad_xport_addr.is_set or
                                            self.num_of_disc_with_same_router_id.is_set or
                                            self.num_of_disc_with_wrong_router_id.is_set or
                                            self.num_of_ldp_interfaces.is_set or
                                            self.num_of_lnk_disc_recv.is_set or
                                            self.num_of_lnk_disc_xmit.is_set or
                                            self.num_of_tgt_disc_recv.is_set or
                                            self.num_of_tgt_disc_xmit.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_ldp_id.yfilter != YFilter.not_set or
                                            self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                                            self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                                            self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                                            self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                                            self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                                            self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "summary" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                                        if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                                        if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                                        if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                                        if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                                        if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                                        if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                                        if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                                        if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-ldp-id"):
                                            self.local_ldp_id = value
                                            self.local_ldp_id.value_namespace = name_space
                                            self.local_ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-active-ldp-interfaces"):
                                            self.num_of_active_ldp_interfaces = value
                                            self.num_of_active_ldp_interfaces.value_namespace = name_space
                                            self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-addr-recv"):
                                            self.num_of_disc_with_bad_addr_recv = value
                                            self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                                            self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-hello-pdu"):
                                            self.num_of_disc_with_bad_hello_pdu = value
                                            self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                                            self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-xport-addr"):
                                            self.num_of_disc_with_bad_xport_addr = value
                                            self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                                            self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-same-router-id"):
                                            self.num_of_disc_with_same_router_id = value
                                            self.num_of_disc_with_same_router_id.value_namespace = name_space
                                            self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-wrong-router-id"):
                                            self.num_of_disc_with_wrong_router_id = value
                                            self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                                            self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-ldp-interfaces"):
                                            self.num_of_ldp_interfaces = value
                                            self.num_of_ldp_interfaces.value_namespace = name_space
                                            self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-lnk-disc-recv"):
                                            self.num_of_lnk_disc_recv = value
                                            self.num_of_lnk_disc_recv.value_namespace = name_space
                                            self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-lnk-disc-xmit"):
                                            self.num_of_lnk_disc_xmit = value
                                            self.num_of_lnk_disc_xmit.value_namespace = name_space
                                            self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-tgt-disc-recv"):
                                            self.num_of_tgt_disc_recv = value
                                            self.num_of_tgt_disc_recv.value_namespace = name_space
                                            self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-tgt-disc-xmit"):
                                            self.num_of_tgt_disc_xmit = value
                                            self.num_of_tgt_disc_xmit.value_namespace = name_space
                                            self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix


                                class TargetedHellos(Entity):
                                    """
                                    The LDP Discovery Targeted
                                    
                                    .. attribute:: targeted_hello
                                    
                                    	Information on LDP targeted discovery
                                    	**type**\: list of    :py:class:`TargetedHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__init__()

                                        self.yang_name = "targeted-hellos"
                                        self.yang_parent_name = "discovery"

                                        self.targeted_hello = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)


                                    class TargetedHello(Entity):
                                        """
                                        Information on LDP targeted discovery
                                        
                                        .. attribute:: adjacency_ldp_identifier
                                        
                                        	Adjacency LDP Identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: dhcb_local_address
                                        
                                        	DHCB local address
                                        	**type**\:   :py:class:`DhcbLocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress>`
                                        
                                        .. attribute:: dhcb_target_address
                                        
                                        	DHCB target address
                                        	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress>`
                                        
                                        .. attribute:: disc_expiry
                                        
                                        	Discovery expiry time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: established_age
                                        
                                        	Hello adjacency estabished age in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: established_time
                                        
                                        	Hello adjacency estabished time in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: hold_time
                                        
                                        	Targeted hello hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interval
                                        
                                        	Hello interval in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: last_session_down_info
                                        
                                        	Last session down information
                                        	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo>`
                                        
                                        .. attribute:: local_address
                                        
                                        	Local IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: local_hold_time
                                        
                                        	Local hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_hold_time
                                        
                                        	Neighbor hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hello
                                        
                                        	Next hello due time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: quick_start_disabled
                                        
                                        	Quick\-start disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: session_bringup_failure_reason
                                        
                                        	session bringup failure reason
                                        	**type**\:  str
                                        
                                        .. attribute:: session_up
                                        
                                        	Is session up for this adj
                                        	**type**\:  bool
                                        
                                        .. attribute:: state
                                        
                                        	Targeted hello state
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	The target IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__init__()

                                            self.yang_name = "targeted-hello"
                                            self.yang_parent_name = "targeted-hellos"

                                            self.adjacency_ldp_identifier = YLeaf(YType.str, "adjacency-ldp-identifier")

                                            self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                            self.established_age = YLeaf(YType.uint64, "established-age")

                                            self.established_time = YLeaf(YType.uint64, "established-time")

                                            self.hold_time = YLeaf(YType.uint32, "hold-time")

                                            self.interval = YLeaf(YType.uint32, "interval")

                                            self.local_address = YLeaf(YType.str, "local-address")

                                            self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                            self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                            self.next_hello = YLeaf(YType.uint32, "next-hello")

                                            self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                            self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                            self.session_up = YLeaf(YType.boolean, "session-up")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.target_address = YLeaf(YType.str, "target-address")

                                            self.dhcb_local_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                            self.dhcb_local_address.parent = self
                                            self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                            self._children_yang_names.add("dhcb-local-address")

                                            self.dhcb_target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                            self.dhcb_target_address.parent = self
                                            self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            self._children_yang_names.add("dhcb-target-address")

                                            self.last_session_down_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("adjacency_ldp_identifier",
                                                            "disc_expiry",
                                                            "established_age",
                                                            "established_time",
                                                            "hold_time",
                                                            "interval",
                                                            "local_address",
                                                            "local_hold_time",
                                                            "neighbor_hold_time",
                                                            "next_hello",
                                                            "quick_start_disabled",
                                                            "session_bringup_failure_reason",
                                                            "session_up",
                                                            "state",
                                                            "target_address") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)


                                        class DhcbLocalAddress(Entity):
                                            """
                                            DHCB local address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__init__()

                                                self.yang_name = "dhcb-local-address"
                                                self.yang_parent_name = "targeted-hello"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class DhcbTargetAddress(Entity):
                                            """
                                            DHCB target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__init__()

                                                self.yang_name = "dhcb-target-address"
                                                self.yang_parent_name = "targeted-hello"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LastSessionDownInfo(Entity):
                                            """
                                            Last session down information
                                            
                                            .. attribute:: last_session_down_reason
                                            
                                            	The reason of last socket failure
                                            	**type**\:  str
                                            
                                            .. attribute:: last_session_down_time
                                            
                                            	Timestamp of when the last session went down
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: last_session_up_time
                                            
                                            	The time duration the last session was up
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__init__()

                                                self.yang_name = "last-session-down-info"
                                                self.yang_parent_name = "targeted-hello"

                                                self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("last_session_down_reason",
                                                                "last_session_down_time",
                                                                "last_session_up_time") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.last_session_down_reason.is_set or
                                                    self.last_session_down_time.is_set or
                                                    self.last_session_up_time.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.last_session_down_reason.yfilter != YFilter.not_set or
                                                    self.last_session_down_time.yfilter != YFilter.not_set or
                                                    self.last_session_up_time.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "last-session-down-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "last-session-down-reason"):
                                                    self.last_session_down_reason = value
                                                    self.last_session_down_reason.value_namespace = name_space
                                                    self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-down-time"):
                                                    self.last_session_down_time = value
                                                    self.last_session_down_time.value_namespace = name_space
                                                    self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-up-time"):
                                                    self.last_session_up_time = value
                                                    self.last_session_up_time.value_namespace = name_space
                                                    self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.adjacency_ldp_identifier.is_set or
                                                self.disc_expiry.is_set or
                                                self.established_age.is_set or
                                                self.established_time.is_set or
                                                self.hold_time.is_set or
                                                self.interval.is_set or
                                                self.local_address.is_set or
                                                self.local_hold_time.is_set or
                                                self.neighbor_hold_time.is_set or
                                                self.next_hello.is_set or
                                                self.quick_start_disabled.is_set or
                                                self.session_bringup_failure_reason.is_set or
                                                self.session_up.is_set or
                                                self.state.is_set or
                                                self.target_address.is_set or
                                                (self.dhcb_local_address is not None and self.dhcb_local_address.has_data()) or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()))

                                        def has_operation(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.adjacency_ldp_identifier.yfilter != YFilter.not_set or
                                                self.disc_expiry.yfilter != YFilter.not_set or
                                                self.established_age.yfilter != YFilter.not_set or
                                                self.established_time.yfilter != YFilter.not_set or
                                                self.hold_time.yfilter != YFilter.not_set or
                                                self.interval.yfilter != YFilter.not_set or
                                                self.local_address.yfilter != YFilter.not_set or
                                                self.local_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                self.next_hello.yfilter != YFilter.not_set or
                                                self.quick_start_disabled.yfilter != YFilter.not_set or
                                                self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                self.session_up.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.target_address.yfilter != YFilter.not_set or
                                                (self.dhcb_local_address is not None and self.dhcb_local_address.has_operation()) or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.adjacency_ldp_identifier.is_set or self.adjacency_ldp_identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.adjacency_ldp_identifier.get_name_leafdata())
                                            if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                            if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_age.get_name_leafdata())
                                            if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_time.get_name_leafdata())
                                            if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_time.get_name_leafdata())
                                            if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interval.get_name_leafdata())
                                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_address.get_name_leafdata())
                                            if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                            if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                            if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hello.get_name_leafdata())
                                            if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())
                                            if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                            if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_up.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.target_address.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "dhcb-local-address"):
                                                if (self.dhcb_local_address is None):
                                                    self.dhcb_local_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                                    self.dhcb_local_address.parent = self
                                                    self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                                return self.dhcb_local_address

                                            if (child_yang_name == "dhcb-target-address"):
                                                if (self.dhcb_target_address is None):
                                                    self.dhcb_target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                                    self.dhcb_target_address.parent = self
                                                    self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                return self.dhcb_target_address

                                            if (child_yang_name == "last-session-down-info"):
                                                for c in self.last_session_down_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.last_session_down_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "dhcb-local-address" or name == "dhcb-target-address" or name == "last-session-down-info" or name == "adjacency-ldp-identifier" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "interval" or name == "local-address" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "next-hello" or name == "quick-start-disabled" or name == "session-bringup-failure-reason" or name == "session-up" or name == "state" or name == "target-address"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "adjacency-ldp-identifier"):
                                                self.adjacency_ldp_identifier = value
                                                self.adjacency_ldp_identifier.value_namespace = name_space
                                                self.adjacency_ldp_identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "disc-expiry"):
                                                self.disc_expiry = value
                                                self.disc_expiry.value_namespace = name_space
                                                self.disc_expiry.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-age"):
                                                self.established_age = value
                                                self.established_age.value_namespace = name_space
                                                self.established_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-time"):
                                                self.established_time = value
                                                self.established_time.value_namespace = name_space
                                                self.established_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-time"):
                                                self.hold_time = value
                                                self.hold_time.value_namespace = name_space
                                                self.hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interval"):
                                                self.interval = value
                                                self.interval.value_namespace = name_space
                                                self.interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-address"):
                                                self.local_address = value
                                                self.local_address.value_namespace = name_space
                                                self.local_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-hold-time"):
                                                self.local_hold_time = value
                                                self.local_hold_time.value_namespace = name_space
                                                self.local_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-hold-time"):
                                                self.neighbor_hold_time = value
                                                self.neighbor_hold_time.value_namespace = name_space
                                                self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hello"):
                                                self.next_hello = value
                                                self.next_hello.value_namespace = name_space
                                                self.next_hello.value_namespace_prefix = name_space_prefix
                                            if(value_path == "quick-start-disabled"):
                                                self.quick_start_disabled = value
                                                self.quick_start_disabled.value_namespace = name_space
                                                self.quick_start_disabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-bringup-failure-reason"):
                                                self.session_bringup_failure_reason = value
                                                self.session_bringup_failure_reason.value_namespace = name_space
                                                self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-up"):
                                                self.session_up = value
                                                self.session_up.value_namespace = name_space
                                                self.session_up.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "target-address"):
                                                self.target_address = value
                                                self.target_address.value_namespace = name_space
                                                self.target_address.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.targeted_hello:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.targeted_hello:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hellos" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "targeted-hello"):
                                            for c in self.targeted_hello:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.targeted_hello.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "targeted-hello"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Brief(Entity):
                                    """
                                    Brief information on LDP discovery
                                    
                                    .. attribute:: link_hello_briefs
                                    
                                    	The LDP Discovery link brief information
                                    	**type**\:   :py:class:`LinkHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs>`
                                    
                                    .. attribute:: targeted_hello_briefs
                                    
                                    	The LDP Discovery Targeted brief information
                                    	**type**\:   :py:class:`TargetedHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief, self).__init__()

                                        self.yang_name = "brief"
                                        self.yang_parent_name = "discovery"

                                        self.link_hello_briefs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                        self.link_hello_briefs.parent = self
                                        self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                        self._children_yang_names.add("link-hello-briefs")

                                        self.targeted_hello_briefs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                        self.targeted_hello_briefs.parent = self
                                        self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                        self._children_yang_names.add("targeted-hello-briefs")


                                    class LinkHelloBriefs(Entity):
                                        """
                                        The LDP Discovery link brief information
                                        
                                        .. attribute:: link_hello_brief
                                        
                                        	Brief information on LDP link discovery
                                        	**type**\: list of    :py:class:`LinkHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__init__()

                                            self.yang_name = "link-hello-briefs"
                                            self.yang_parent_name = "brief"

                                            self.link_hello_brief = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)


                                        class LinkHelloBrief(Entity):
                                            """
                                            Brief information on LDP link discovery
                                            
                                            .. attribute:: interface_name  <key>
                                            
                                            	The Interface Name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: address_family
                                            
                                            	Discovery Brief Address Family
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: address_family_set
                                            
                                            	Discovery Brief Address Family Set
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: hello_information
                                            
                                            	LDP hello info
                                            	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation>`
                                            
                                            .. attribute:: interface
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: interface_name_xr
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            .. attribute:: vrf
                                            
                                            	VRF information
                                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__init__()

                                                self.yang_name = "link-hello-brief"
                                                self.yang_parent_name = "link-hello-briefs"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                                self.address_family_set = YLeaf(YType.enumeration, "address-family-set")

                                                self.interface = YLeaf(YType.str, "interface")

                                                self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                                self._children_yang_names.add("vrf")

                                                self.hello_information = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "address_family",
                                                                "address_family_set",
                                                                "interface",
                                                                "interface_name_xr") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)


                                            class Vrf(Entity):
                                                """
                                                VRF information
                                                
                                                .. attribute:: id
                                                
                                                	VRF Id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	VRF Name
                                                	**type**\:  str
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__init__()

                                                    self.yang_name = "vrf"
                                                    self.yang_parent_name = "link-hello-brief"

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("id",
                                                                    "name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.id.is_set or
                                                        self.name.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.id.yfilter != YFilter.not_set or
                                                        self.name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "vrf" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.id.get_name_leafdata())
                                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "id" or name == "name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "id"):
                                                        self.id = value
                                                        self.id.value_namespace = name_space
                                                        self.id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "name"):
                                                        self.name = value
                                                        self.name.value_namespace = name_space
                                                        self.name.value_namespace_prefix = name_space_prefix


                                            class HelloInformation(Entity):
                                                """
                                                LDP hello info
                                                
                                                .. attribute:: hold_time
                                                
                                                	Session hold time in sec
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: neighbor_ldp_identifier
                                                
                                                	Neighbor LDP Identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: session_up
                                                
                                                	Is session up for this adj
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__init__()

                                                    self.yang_name = "hello-information"
                                                    self.yang_parent_name = "link-hello-brief"

                                                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                    self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                    self.session_up = YLeaf(YType.boolean, "session-up")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("hold_time",
                                                                    "neighbor_ldp_identifier",
                                                                    "session_up") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.hold_time.is_set or
                                                        self.neighbor_ldp_identifier.is_set or
                                                        self.session_up.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.hold_time.yfilter != YFilter.not_set or
                                                        self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                        self.session_up.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "hello-information" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                    if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                    if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.session_up.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "hold-time"):
                                                        self.hold_time = value
                                                        self.hold_time.value_namespace = name_space
                                                        self.hold_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "neighbor-ldp-identifier"):
                                                        self.neighbor_ldp_identifier = value
                                                        self.neighbor_ldp_identifier.value_namespace = name_space
                                                        self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "session-up"):
                                                        self.session_up = value
                                                        self.session_up.value_namespace = name_space
                                                        self.session_up.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.hello_information:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.interface_name.is_set or
                                                    self.address_family.is_set or
                                                    self.address_family_set.is_set or
                                                    self.interface.is_set or
                                                    self.interface_name_xr.is_set or
                                                    (self.vrf is not None and self.vrf.has_data()))

                                            def has_operation(self):
                                                for c in self.hello_information:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.address_family.yfilter != YFilter.not_set or
                                                    self.address_family_set.yfilter != YFilter.not_set or
                                                    self.interface.yfilter != YFilter.not_set or
                                                    self.interface_name_xr.yfilter != YFilter.not_set or
                                                    (self.vrf is not None and self.vrf.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "link-hello-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                                if (self.address_family_set.is_set or self.address_family_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family_set.get_name_leafdata())
                                                if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface.get_name_leafdata())
                                                if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "hello-information"):
                                                    for c in self.hello_information:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.hello_information.append(c)
                                                    return c

                                                if (child_yang_name == "vrf"):
                                                    if (self.vrf is None):
                                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                        self.vrf.parent = self
                                                        self._children_name_map["vrf"] = "vrf"
                                                    return self.vrf

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hello-information" or name == "vrf" or name == "interface-name" or name == "address-family" or name == "address-family-set" or name == "interface" or name == "interface-name-xr"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "address-family"):
                                                    self.address_family = value
                                                    self.address_family.value_namespace = name_space
                                                    self.address_family.value_namespace_prefix = name_space_prefix
                                                if(value_path == "address-family-set"):
                                                    self.address_family_set = value
                                                    self.address_family_set.value_namespace = name_space
                                                    self.address_family_set.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface"):
                                                    self.interface = value
                                                    self.interface.value_namespace = name_space
                                                    self.interface.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface-name-xr"):
                                                    self.interface_name_xr = value
                                                    self.interface_name_xr.value_namespace = name_space
                                                    self.interface_name_xr.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.link_hello_brief:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.link_hello_brief:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-briefs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "link-hello-brief"):
                                                for c in self.link_hello_brief:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.link_hello_brief.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "link-hello-brief"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TargetedHelloBriefs(Entity):
                                        """
                                        The LDP Discovery Targeted brief information
                                        
                                        .. attribute:: targeted_hello_brief
                                        
                                        	Brief information on LDP targeted discovery
                                        	**type**\: list of    :py:class:`TargetedHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__init__()

                                            self.yang_name = "targeted-hello-briefs"
                                            self.yang_parent_name = "brief"

                                            self.targeted_hello_brief = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)


                                        class TargetedHelloBrief(Entity):
                                            """
                                            Brief information on LDP targeted discovery
                                            
                                            .. attribute:: address_family
                                            
                                            	Targeted Discovery Address Family
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: dhcb_target_address
                                            
                                            	DHCB target address
                                            	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress>`
                                            
                                            .. attribute:: hello_information
                                            
                                            	LDP hello info
                                            	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation>`
                                            
                                            .. attribute:: local_address
                                            
                                            	Local IP Address
                                            	**type**\: one of the below types:
                                            
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            .. attribute:: target_address
                                            
                                            	The target IP Address
                                            	**type**\: one of the below types:
                                            
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            .. attribute:: vrf
                                            
                                            	VRF information
                                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__init__()

                                                self.yang_name = "targeted-hello-brief"
                                                self.yang_parent_name = "targeted-hello-briefs"

                                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                                self.local_address = YLeaf(YType.str, "local-address")

                                                self.target_address = YLeaf(YType.str, "target-address")

                                                self.dhcb_target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                self.dhcb_target_address.parent = self
                                                self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                self._children_yang_names.add("dhcb-target-address")

                                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                                self._children_yang_names.add("vrf")

                                                self.hello_information = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("address_family",
                                                                "local_address",
                                                                "target_address") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)


                                            class Vrf(Entity):
                                                """
                                                VRF information
                                                
                                                .. attribute:: id
                                                
                                                	VRF Id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	VRF Name
                                                	**type**\:  str
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__init__()

                                                    self.yang_name = "vrf"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("id",
                                                                    "name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.id.is_set or
                                                        self.name.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.id.yfilter != YFilter.not_set or
                                                        self.name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "vrf" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.id.get_name_leafdata())
                                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "id" or name == "name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "id"):
                                                        self.id = value
                                                        self.id.value_namespace = name_space
                                                        self.id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "name"):
                                                        self.name = value
                                                        self.name.value_namespace = name_space
                                                        self.name.value_namespace_prefix = name_space_prefix


                                            class DhcbTargetAddress(Entity):
                                                """
                                                DHCB target address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__init__()

                                                    self.yang_name = "dhcb-target-address"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "dhcb-target-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class HelloInformation(Entity):
                                                """
                                                LDP hello info
                                                
                                                .. attribute:: hold_time
                                                
                                                	Session hold time in sec
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: neighbor_ldp_identifier
                                                
                                                	Neighbor LDP Identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: session_up
                                                
                                                	Is session up for this adj
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__init__()

                                                    self.yang_name = "hello-information"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                    self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                    self.session_up = YLeaf(YType.boolean, "session-up")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("hold_time",
                                                                    "neighbor_ldp_identifier",
                                                                    "session_up") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.hold_time.is_set or
                                                        self.neighbor_ldp_identifier.is_set or
                                                        self.session_up.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.hold_time.yfilter != YFilter.not_set or
                                                        self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                        self.session_up.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "hello-information" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                    if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                    if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.session_up.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "hold-time"):
                                                        self.hold_time = value
                                                        self.hold_time.value_namespace = name_space
                                                        self.hold_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "neighbor-ldp-identifier"):
                                                        self.neighbor_ldp_identifier = value
                                                        self.neighbor_ldp_identifier.value_namespace = name_space
                                                        self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "session-up"):
                                                        self.session_up = value
                                                        self.session_up.value_namespace = name_space
                                                        self.session_up.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.hello_information:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.address_family.is_set or
                                                    self.local_address.is_set or
                                                    self.target_address.is_set or
                                                    (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()) or
                                                    (self.vrf is not None and self.vrf.has_data()))

                                            def has_operation(self):
                                                for c in self.hello_information:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.address_family.yfilter != YFilter.not_set or
                                                    self.local_address.yfilter != YFilter.not_set or
                                                    self.target_address.yfilter != YFilter.not_set or
                                                    (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()) or
                                                    (self.vrf is not None and self.vrf.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "targeted-hello-brief" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                                if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_address.get_name_leafdata())
                                                if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.target_address.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "dhcb-target-address"):
                                                    if (self.dhcb_target_address is None):
                                                        self.dhcb_target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                        self.dhcb_target_address.parent = self
                                                        self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                    return self.dhcb_target_address

                                                if (child_yang_name == "hello-information"):
                                                    for c in self.hello_information:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.hello_information.append(c)
                                                    return c

                                                if (child_yang_name == "vrf"):
                                                    if (self.vrf is None):
                                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                        self.vrf.parent = self
                                                        self._children_name_map["vrf"] = "vrf"
                                                    return self.vrf

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "dhcb-target-address" or name == "hello-information" or name == "vrf" or name == "address-family" or name == "local-address" or name == "target-address"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "address-family"):
                                                    self.address_family = value
                                                    self.address_family.value_namespace = name_space
                                                    self.address_family.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-address"):
                                                    self.local_address = value
                                                    self.local_address.value_namespace = name_space
                                                    self.local_address.value_namespace_prefix = name_space_prefix
                                                if(value_path == "target-address"):
                                                    self.target_address = value
                                                    self.target_address.value_namespace = name_space
                                                    self.target_address.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.targeted_hello_brief:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.targeted_hello_brief:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello-briefs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "targeted-hello-brief"):
                                                for c in self.targeted_hello_brief:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.targeted_hello_brief.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "targeted-hello-brief"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.link_hello_briefs is not None and self.link_hello_briefs.has_data()) or
                                            (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.link_hello_briefs is not None and self.link_hello_briefs.has_operation()) or
                                            (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "brief" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-briefs"):
                                            if (self.link_hello_briefs is None):
                                                self.link_hello_briefs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                                self.link_hello_briefs.parent = self
                                                self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                            return self.link_hello_briefs

                                        if (child_yang_name == "targeted-hello-briefs"):
                                            if (self.targeted_hello_briefs is None):
                                                self.targeted_hello_briefs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                                self.targeted_hello_briefs.parent = self
                                                self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                            return self.targeted_hello_briefs

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-briefs" or name == "targeted-hello-briefs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Stats(Entity):
                                    """
                                    The LDP Discovery Statistics
                                    
                                    .. attribute:: stat
                                    
                                    	Information on LDP discovery statistics
                                    	**type**\: list of    :py:class:`Stat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__init__()

                                        self.yang_name = "stats"
                                        self.yang_parent_name = "discovery"

                                        self.stat = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)


                                    class Stat(Entity):
                                        """
                                        Information on LDP discovery statistics
                                        
                                        .. attribute:: adjacency_group_up_time
                                        
                                        	Adjacency group up time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space ID of neighbor
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR ID of neighbor
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: tcp_arb_chg_count
                                        
                                        	Count of changes in TCP arbitration
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tcp_open_count
                                        
                                        	Count of attempted TCP opens
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tcp_role
                                        
                                        	TCP Role
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__init__()

                                            self.yang_name = "stat"
                                            self.yang_parent_name = "stats"

                                            self.adjacency_group_up_time = YLeaf(YType.uint32, "adjacency-group-up-time")

                                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                            self.tcp_arb_chg_count = YLeaf(YType.uint32, "tcp-arb-chg-count")

                                            self.tcp_open_count = YLeaf(YType.uint32, "tcp-open-count")

                                            self.tcp_role = YLeaf(YType.uint32, "tcp-role")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("adjacency_group_up_time",
                                                            "label_space_id",
                                                            "lsr_id",
                                                            "tcp_arb_chg_count",
                                                            "tcp_open_count",
                                                            "tcp_role") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.adjacency_group_up_time.is_set or
                                                self.label_space_id.is_set or
                                                self.lsr_id.is_set or
                                                self.tcp_arb_chg_count.is_set or
                                                self.tcp_open_count.is_set or
                                                self.tcp_role.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.adjacency_group_up_time.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set or
                                                self.tcp_arb_chg_count.yfilter != YFilter.not_set or
                                                self.tcp_open_count.yfilter != YFilter.not_set or
                                                self.tcp_role.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "stat" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.adjacency_group_up_time.is_set or self.adjacency_group_up_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.adjacency_group_up_time.get_name_leafdata())
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                            if (self.tcp_arb_chg_count.is_set or self.tcp_arb_chg_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_arb_chg_count.get_name_leafdata())
                                            if (self.tcp_open_count.is_set or self.tcp_open_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_open_count.get_name_leafdata())
                                            if (self.tcp_role.is_set or self.tcp_role.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_role.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "adjacency-group-up-time" or name == "label-space-id" or name == "lsr-id" or name == "tcp-arb-chg-count" or name == "tcp-open-count" or name == "tcp-role"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "adjacency-group-up-time"):
                                                self.adjacency_group_up_time = value
                                                self.adjacency_group_up_time.value_namespace = name_space
                                                self.adjacency_group_up_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-arb-chg-count"):
                                                self.tcp_arb_chg_count = value
                                                self.tcp_arb_chg_count.value_namespace = name_space
                                                self.tcp_arb_chg_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-open-count"):
                                                self.tcp_open_count = value
                                                self.tcp_open_count.value_namespace = name_space
                                                self.tcp_open_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-role"):
                                                self.tcp_role = value
                                                self.tcp_role.value_namespace = name_space
                                                self.tcp_role.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.stat:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.stat:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "stat"):
                                            for c in self.stat:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.stat.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "stat"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        (self.brief is not None and self.brief.has_data()) or
                                        (self.link_hellos is not None and self.link_hellos.has_data()) or
                                        (self.stats is not None and self.stats.has_data()) or
                                        (self.summary is not None and self.summary.has_data()) or
                                        (self.targeted_hellos is not None and self.targeted_hellos.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.brief is not None and self.brief.has_operation()) or
                                        (self.link_hellos is not None and self.link_hellos.has_operation()) or
                                        (self.stats is not None and self.stats.has_operation()) or
                                        (self.summary is not None and self.summary.has_operation()) or
                                        (self.targeted_hellos is not None and self.targeted_hellos.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovery" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "brief"):
                                        if (self.brief is None):
                                            self.brief = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Brief()
                                            self.brief.parent = self
                                            self._children_name_map["brief"] = "brief"
                                        return self.brief

                                    if (child_yang_name == "link-hellos"):
                                        if (self.link_hellos is None):
                                            self.link_hellos = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos()
                                            self.link_hellos.parent = self
                                            self._children_name_map["link_hellos"] = "link-hellos"
                                        return self.link_hellos

                                    if (child_yang_name == "stats"):
                                        if (self.stats is None):
                                            self.stats = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Stats()
                                            self.stats.parent = self
                                            self._children_name_map["stats"] = "stats"
                                        return self.stats

                                    if (child_yang_name == "summary"):
                                        if (self.summary is None):
                                            self.summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.Summary()
                                            self.summary.parent = self
                                            self._children_name_map["summary"] = "summary"
                                        return self.summary

                                    if (child_yang_name == "targeted-hellos"):
                                        if (self.targeted_hellos is None):
                                            self.targeted_hellos = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos()
                                            self.targeted_hellos.parent = self
                                            self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                        return self.targeted_hellos

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "brief" or name == "link-hellos" or name == "stats" or name == "summary" or name == "targeted-hellos"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsSummaryAll(Entity):
                                """
                                Aggregate VRF counters for the LDP Label
                                Infomation Base (LIB)
                                
                                .. attribute:: address_family
                                
                                	Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: bind_af
                                
                                	bind af
                                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf>`
                                
                                .. attribute:: binding_local_explicit_null
                                
                                	Number of local explicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_implicit_null
                                
                                	Number of local implicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_no_route
                                
                                	Local bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_non_null
                                
                                	Number of local non\-null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_null
                                
                                	Number of local null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_oor
                                
                                	Number of local bindings        needing label \- OOR
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_no_route
                                
                                	Bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: highest_allocated_label
                                
                                	Highest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lowest_allocated_label
                                
                                	Lowest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__init__()

                                    self.yang_name = "bindings-summary-all"
                                    self.yang_parent_name = "af"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                    self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.bind_af = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local_explicit_null",
                                                    "binding_local_implicit_null",
                                                    "binding_local_no_route",
                                                    "binding_local_non_null",
                                                    "binding_local_null",
                                                    "binding_local_oor",
                                                    "binding_no_route",
                                                    "highest_allocated_label",
                                                    "lowest_allocated_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "bindings-summary-all"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class BindAf(Entity):
                                    """
                                    bind af
                                    
                                    .. attribute:: address_family
                                    
                                    	Binding Summary Address Family
                                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                    
                                    .. attribute:: binding_local
                                    
                                    	Number of local bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_remote
                                    
                                    	Number of remote bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_total
                                    
                                    	Total bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_lib_update
                                    
                                    	Last update to LIB local binding
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lib_minimum_revision_sent_all
                                    
                                    	Last update sent to all peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__init__()

                                        self.yang_name = "bind-af"
                                        self.yang_parent_name = "bindings-summary-all"

                                        self.address_family = YLeaf(YType.enumeration, "address-family")

                                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address_family",
                                                        "binding_local",
                                                        "binding_remote",
                                                        "binding_total",
                                                        "last_lib_update",
                                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address_family.is_set or
                                            self.binding_local.is_set or
                                            self.binding_remote.is_set or
                                            self.binding_total.is_set or
                                            self.last_lib_update.is_set or
                                            self.lib_minimum_revision_sent_all.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address_family.yfilter != YFilter.not_set or
                                            self.binding_local.yfilter != YFilter.not_set or
                                            self.binding_remote.yfilter != YFilter.not_set or
                                            self.binding_total.yfilter != YFilter.not_set or
                                            self.last_lib_update.yfilter != YFilter.not_set or
                                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bind-af" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address_family.get_name_leafdata())
                                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address-family"):
                                            self.address_family = value
                                            self.address_family.value_namespace = name_space
                                            self.address_family.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-local"):
                                            self.binding_local = value
                                            self.binding_local.value_namespace = name_space
                                            self.binding_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-remote"):
                                            self.binding_remote = value
                                            self.binding_remote.value_namespace = name_space
                                            self.binding_remote.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-total"):
                                            self.binding_total = value
                                            self.binding_total.value_namespace = name_space
                                            self.binding_total.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-lib-update"):
                                            self.last_lib_update = value
                                            self.last_lib_update.value_namespace = name_space
                                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lib-minimum-revision-sent-all"):
                                            self.lib_minimum_revision_sent_all = value
                                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bind_af:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local_explicit_null.is_set or
                                        self.binding_local_implicit_null.is_set or
                                        self.binding_local_no_route.is_set or
                                        self.binding_local_non_null.is_set or
                                        self.binding_local_null.is_set or
                                        self.binding_local_oor.is_set or
                                        self.binding_no_route.is_set or
                                        self.highest_allocated_label.is_set or
                                        self.lowest_allocated_label.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.bind_af:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_no_route.yfilter != YFilter.not_set or
                                        self.binding_local_non_null.yfilter != YFilter.not_set or
                                        self.binding_local_null.yfilter != YFilter.not_set or
                                        self.binding_local_oor.yfilter != YFilter.not_set or
                                        self.binding_no_route.yfilter != YFilter.not_set or
                                        self.highest_allocated_label.yfilter != YFilter.not_set or
                                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-summary-all" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bind-af"):
                                        for c in self.bind_af:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bind_af.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-explicit-null"):
                                        self.binding_local_explicit_null = value
                                        self.binding_local_explicit_null.value_namespace = name_space
                                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-implicit-null"):
                                        self.binding_local_implicit_null = value
                                        self.binding_local_implicit_null.value_namespace = name_space
                                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-no-route"):
                                        self.binding_local_no_route = value
                                        self.binding_local_no_route.value_namespace = name_space
                                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-non-null"):
                                        self.binding_local_non_null = value
                                        self.binding_local_non_null.value_namespace = name_space
                                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-null"):
                                        self.binding_local_null = value
                                        self.binding_local_null.value_namespace = name_space
                                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-oor"):
                                        self.binding_local_oor = value
                                        self.binding_local_oor.value_namespace = name_space
                                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-no-route"):
                                        self.binding_no_route = value
                                        self.binding_no_route.value_namespace = name_space
                                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "highest-allocated-label"):
                                        self.highest_allocated_label = value
                                        self.highest_allocated_label.value_namespace = name_space
                                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lowest-allocated-label"):
                                        self.lowest_allocated_label = value
                                        self.lowest_allocated_label.value_namespace = name_space
                                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                            class Forwardings(Entity):
                                """
                                The LDP Forwarding rewrites
                                
                                .. attribute:: forwarding
                                
                                	Information on a particular LDP forwarding rewrite
                                	**type**\: list of    :py:class:`Forwarding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings, self).__init__()

                                    self.yang_name = "forwardings"
                                    self.yang_parent_name = "af"

                                    self.forwarding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings, self).__setattr__(name, value)


                                class Forwarding(Entity):
                                    """
                                    Information on a particular LDP forwarding
                                    rewrite
                                    
                                    .. attribute:: prefix  <key>
                                    
                                    	The IP Prefix
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                    
                                    
                                    ----
                                    .. attribute:: paths
                                    
                                    	Paths
                                    	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths>`
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: prefix_xr
                                    
                                    	IP Prefix
                                    	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr>`
                                    
                                    .. attribute:: route
                                    
                                    	Route
                                    	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route>`
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID associated with IP prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__init__()

                                        self.yang_name = "forwarding"
                                        self.yang_parent_name = "forwardings"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.prefix_xr = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                        self.prefix_xr.parent = self
                                        self._children_name_map["prefix_xr"] = "prefix-xr"
                                        self._children_yang_names.add("prefix-xr")

                                        self.route = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route()
                                        self.route.parent = self
                                        self._children_name_map["route"] = "route"
                                        self._children_yang_names.add("route")

                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.paths = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "forwarding"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class PrefixXr(Entity):
                                        """
                                        IP Prefix
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__init__()

                                            self.yang_name = "prefix-xr"
                                            self.yang_parent_name = "forwarding"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix-xr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class Route(Entity):
                                        """
                                        Route
                                        
                                        .. attribute:: mpls
                                        
                                        	MPLS information
                                        	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls>`
                                        
                                        .. attribute:: routing
                                        
                                        	IP routing information
                                        	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route, self).__init__()

                                            self.yang_name = "route"
                                            self.yang_parent_name = "forwarding"

                                            self.mpls = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                            self.mpls.parent = self
                                            self._children_name_map["mpls"] = "mpls"
                                            self._children_yang_names.add("mpls")

                                            self.routing = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                            self.routing.parent = self
                                            self._children_name_map["routing"] = "routing"
                                            self._children_yang_names.add("routing")


                                        class Routing(Entity):
                                            """
                                            IP routing information
                                            
                                            .. attribute:: flags
                                            
                                            	Route RIB flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_local_vrf_leaked
                                            
                                            	Is route leaked across local VRFs?
                                            	**type**\:  bool
                                            
                                            .. attribute:: metric
                                            
                                            	Route metric
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: priority
                                            
                                            	Route priority
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: routing_update_age
                                            
                                            	Last Routing update nanosec age
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: routing_update_count
                                            
                                            	Number of routing updates
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: routing_update_timestamp
                                            
                                            	Last Routing update nanosec timestamp
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: source
                                            
                                            	Route source protol Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sr_local_label
                                            
                                            	SR Local\-label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Route type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: version
                                            
                                            	Route RIB ersion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__init__()

                                                self.yang_name = "routing"
                                                self.yang_parent_name = "route"

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.is_local_vrf_leaked = YLeaf(YType.boolean, "is-local-vrf-leaked")

                                                self.metric = YLeaf(YType.uint32, "metric")

                                                self.priority = YLeaf(YType.uint8, "priority")

                                                self.routing_update_age = YLeaf(YType.uint64, "routing-update-age")

                                                self.routing_update_count = YLeaf(YType.uint32, "routing-update-count")

                                                self.routing_update_timestamp = YLeaf(YType.uint64, "routing-update-timestamp")

                                                self.source = YLeaf(YType.uint16, "source")

                                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                                self.type = YLeaf(YType.uint16, "type")

                                                self.version = YLeaf(YType.uint32, "version")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("flags",
                                                                "is_local_vrf_leaked",
                                                                "metric",
                                                                "priority",
                                                                "routing_update_age",
                                                                "routing_update_count",
                                                                "routing_update_timestamp",
                                                                "source",
                                                                "sr_local_label",
                                                                "type",
                                                                "version") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.flags.is_set or
                                                    self.is_local_vrf_leaked.is_set or
                                                    self.metric.is_set or
                                                    self.priority.is_set or
                                                    self.routing_update_age.is_set or
                                                    self.routing_update_count.is_set or
                                                    self.routing_update_timestamp.is_set or
                                                    self.source.is_set or
                                                    self.sr_local_label.is_set or
                                                    self.type.is_set or
                                                    self.version.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.flags.yfilter != YFilter.not_set or
                                                    self.is_local_vrf_leaked.yfilter != YFilter.not_set or
                                                    self.metric.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    self.routing_update_age.yfilter != YFilter.not_set or
                                                    self.routing_update_count.yfilter != YFilter.not_set or
                                                    self.routing_update_timestamp.yfilter != YFilter.not_set or
                                                    self.source.yfilter != YFilter.not_set or
                                                    self.sr_local_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    self.version.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "routing" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.flags.get_name_leafdata())
                                                if (self.is_local_vrf_leaked.is_set or self.is_local_vrf_leaked.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_local_vrf_leaked.get_name_leafdata())
                                                if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.metric.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())
                                                if (self.routing_update_age.is_set or self.routing_update_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_age.get_name_leafdata())
                                                if (self.routing_update_count.is_set or self.routing_update_count.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_count.get_name_leafdata())
                                                if (self.routing_update_timestamp.is_set or self.routing_update_timestamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_timestamp.get_name_leafdata())
                                                if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source.get_name_leafdata())
                                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())
                                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.version.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "flags" or name == "is-local-vrf-leaked" or name == "metric" or name == "priority" or name == "routing-update-age" or name == "routing-update-count" or name == "routing-update-timestamp" or name == "source" or name == "sr-local-label" or name == "type" or name == "version"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "flags"):
                                                    self.flags = value
                                                    self.flags.value_namespace = name_space
                                                    self.flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-local-vrf-leaked"):
                                                    self.is_local_vrf_leaked = value
                                                    self.is_local_vrf_leaked.value_namespace = name_space
                                                    self.is_local_vrf_leaked.value_namespace_prefix = name_space_prefix
                                                if(value_path == "metric"):
                                                    self.metric = value
                                                    self.metric.value_namespace = name_space
                                                    self.metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-age"):
                                                    self.routing_update_age = value
                                                    self.routing_update_age.value_namespace = name_space
                                                    self.routing_update_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-count"):
                                                    self.routing_update_count = value
                                                    self.routing_update_count.value_namespace = name_space
                                                    self.routing_update_count.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-timestamp"):
                                                    self.routing_update_timestamp = value
                                                    self.routing_update_timestamp.value_namespace = name_space
                                                    self.routing_update_timestamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source"):
                                                    self.source = value
                                                    self.source.value_namespace = name_space
                                                    self.source.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sr-local-label"):
                                                    self.sr_local_label = value
                                                    self.sr_local_label.value_namespace = name_space
                                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "version"):
                                                    self.version = value
                                                    self.version.value_namespace = name_space
                                                    self.version.value_namespace_prefix = name_space_prefix


                                        class Mpls(Entity):
                                            """
                                            MPLS information
                                            
                                            .. attribute:: forwarding_update_age
                                            
                                            	Last Forwarding update nanosec age
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: forwarding_update_count
                                            
                                            	Number of forwarding updates
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forwarding_update_timestamp
                                            
                                            	Last Forwarding update nanosec timestamp
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: local_label
                                            
                                            	Local label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__init__()

                                                self.yang_name = "mpls"
                                                self.yang_parent_name = "route"

                                                self.forwarding_update_age = YLeaf(YType.uint64, "forwarding-update-age")

                                                self.forwarding_update_count = YLeaf(YType.uint32, "forwarding-update-count")

                                                self.forwarding_update_timestamp = YLeaf(YType.uint64, "forwarding-update-timestamp")

                                                self.local_label = YLeaf(YType.uint32, "local-label")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("forwarding_update_age",
                                                                "forwarding_update_count",
                                                                "forwarding_update_timestamp",
                                                                "local_label") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.forwarding_update_age.is_set or
                                                    self.forwarding_update_count.is_set or
                                                    self.forwarding_update_timestamp.is_set or
                                                    self.local_label.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.forwarding_update_age.yfilter != YFilter.not_set or
                                                    self.forwarding_update_count.yfilter != YFilter.not_set or
                                                    self.forwarding_update_timestamp.yfilter != YFilter.not_set or
                                                    self.local_label.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.forwarding_update_age.is_set or self.forwarding_update_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_age.get_name_leafdata())
                                                if (self.forwarding_update_count.is_set or self.forwarding_update_count.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_count.get_name_leafdata())
                                                if (self.forwarding_update_timestamp.is_set or self.forwarding_update_timestamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_timestamp.get_name_leafdata())
                                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "forwarding-update-age" or name == "forwarding-update-count" or name == "forwarding-update-timestamp" or name == "local-label"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "forwarding-update-age"):
                                                    self.forwarding_update_age = value
                                                    self.forwarding_update_age.value_namespace = name_space
                                                    self.forwarding_update_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-update-count"):
                                                    self.forwarding_update_count = value
                                                    self.forwarding_update_count.value_namespace = name_space
                                                    self.forwarding_update_count.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-update-timestamp"):
                                                    self.forwarding_update_timestamp = value
                                                    self.forwarding_update_timestamp.value_namespace = name_space
                                                    self.forwarding_update_timestamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-label"):
                                                    self.local_label = value
                                                    self.local_label.value_namespace = name_space
                                                    self.local_label.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.mpls is not None and self.mpls.has_data()) or
                                                (self.routing is not None and self.routing.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls is not None and self.mpls.has_operation()) or
                                                (self.routing is not None and self.routing.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "route" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls"):
                                                if (self.mpls is None):
                                                    self.mpls = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                                    self.mpls.parent = self
                                                    self._children_name_map["mpls"] = "mpls"
                                                return self.mpls

                                            if (child_yang_name == "routing"):
                                                if (self.routing is None):
                                                    self.routing = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                                    self.routing.parent = self
                                                    self._children_name_map["routing"] = "routing"
                                                return self.routing

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls" or name == "routing"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Paths(Entity):
                                        """
                                        Paths
                                        
                                        .. attribute:: mpls
                                        
                                        	MPLS information
                                        	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls>`
                                        
                                        .. attribute:: routing
                                        
                                        	IP routing information
                                        	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths, self).__init__()

                                            self.yang_name = "paths"
                                            self.yang_parent_name = "forwarding"

                                            self.mpls = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                            self.mpls.parent = self
                                            self._children_name_map["mpls"] = "mpls"
                                            self._children_yang_names.add("mpls")

                                            self.routing = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                            self.routing.parent = self
                                            self._children_name_map["routing"] = "routing"
                                            self._children_yang_names.add("routing")


                                        class Routing(Entity):
                                            """
                                            IP routing information
                                            
                                            .. attribute:: bkup_path_id
                                            
                                            	Backup path Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: flags
                                            
                                            	Route path flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: interface
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: interface_name
                                            
                                            	Interface Name
                                            	**type**\:  str
                                            
                                            .. attribute:: load_metric
                                            
                                            	Path's load metric for load balancing
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_hop
                                            
                                            	Next Hop
                                            	**type**\:   :py:class:`NextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop>`
                                            
                                            .. attribute:: next_hop_table_id
                                            
                                            	Table ID for nexthop address
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: nexthop_id
                                            
                                            	Nexthop Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: nh_is_overriden
                                            
                                            	Nexthop is overriden by LDP
                                            	**type**\:  bool
                                            
                                            .. attribute:: path_flags
                                            
                                            	Routing path flags decoded
                                            	**type**\:   :py:class:`LdpRoutePathFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathFlags>`
                                            
                                            .. attribute:: path_id
                                            
                                            	path Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: remote_lfa
                                            
                                            	Remote LFA\-FRR backup info
                                            	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__init__()

                                                self.yang_name = "routing"
                                                self.yang_parent_name = "paths"

                                                self.bkup_path_id = YLeaf(YType.uint8, "bkup-path-id")

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.interface = YLeaf(YType.str, "interface")

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.load_metric = YLeaf(YType.uint32, "load-metric")

                                                self.next_hop_table_id = YLeaf(YType.uint32, "next-hop-table-id")

                                                self.nexthop_id = YLeaf(YType.uint32, "nexthop-id")

                                                self.nh_is_overriden = YLeaf(YType.boolean, "nh-is-overriden")

                                                self.path_flags = YLeaf(YType.enumeration, "path-flags")

                                                self.path_id = YLeaf(YType.uint8, "path-id")

                                                self.next_hop = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                self.next_hop.parent = self
                                                self._children_name_map["next_hop"] = "next-hop"
                                                self._children_yang_names.add("next-hop")

                                                self.remote_lfa = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                self.remote_lfa.parent = self
                                                self._children_name_map["remote_lfa"] = "remote-lfa"
                                                self._children_yang_names.add("remote-lfa")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bkup_path_id",
                                                                "flags",
                                                                "interface",
                                                                "interface_name",
                                                                "load_metric",
                                                                "next_hop_table_id",
                                                                "nexthop_id",
                                                                "nh_is_overriden",
                                                                "path_flags",
                                                                "path_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)


                                            class NextHop(Entity):
                                                """
                                                Next Hop
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__init__()

                                                    self.yang_name = "next-hop"
                                                    self.yang_parent_name = "routing"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "next-hop" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class RemoteLfa(Entity):
                                                """
                                                Remote LFA\-FRR backup info
                                                
                                                .. attribute:: has_q_node
                                                
                                                	Whether remote LFA path has a Q node associated
                                                	**type**\:  bool
                                                
                                                .. attribute:: has_remote_lfa_bkup
                                                
                                                	Whether path has remote LFA backup
                                                	**type**\:  bool
                                                
                                                .. attribute:: needs_tldp
                                                
                                                	Whether TLDP is needed with remote PQ node
                                                	**type**\:  bool
                                                
                                                .. attribute:: remote_p_node_id
                                                
                                                	Remote/P node address
                                                	**type**\:   :py:class:`RemotePNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId>`
                                                
                                                .. attribute:: remote_q_node_id
                                                
                                                	Remote/Q node address
                                                	**type**\:   :py:class:`RemoteQNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__init__()

                                                    self.yang_name = "remote-lfa"
                                                    self.yang_parent_name = "routing"

                                                    self.has_q_node = YLeaf(YType.boolean, "has-q-node")

                                                    self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                    self.needs_tldp = YLeaf(YType.boolean, "needs-tldp")

                                                    self.remote_p_node_id = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                    self.remote_p_node_id.parent = self
                                                    self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                    self._children_yang_names.add("remote-p-node-id")

                                                    self.remote_q_node_id = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                    self.remote_q_node_id.parent = self
                                                    self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                    self._children_yang_names.add("remote-q-node-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("has_q_node",
                                                                    "has_remote_lfa_bkup",
                                                                    "needs_tldp") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)


                                                class RemotePNodeId(Entity):
                                                    """
                                                    Remote/P node address
                                                    
                                                    .. attribute:: afi
                                                    
                                                    	AFI
                                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                    
                                                    .. attribute:: dummy
                                                    
                                                    	No Address
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ipv4
                                                    
                                                    	IPv4 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: ipv6
                                                    
                                                    	IPv6 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__init__()

                                                        self.yang_name = "remote-p-node-id"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.afi = YLeaf(YType.enumeration, "afi")

                                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("afi",
                                                                        "dummy",
                                                                        "ipv4",
                                                                        "ipv6") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.afi.is_set or
                                                            self.dummy.is_set or
                                                            self.ipv4.is_set or
                                                            self.ipv6.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.afi.yfilter != YFilter.not_set or
                                                            self.dummy.yfilter != YFilter.not_set or
                                                            self.ipv4.yfilter != YFilter.not_set or
                                                            self.ipv6.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "remote-p-node-id" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "afi"):
                                                            self.afi = value
                                                            self.afi.value_namespace = name_space
                                                            self.afi.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "dummy"):
                                                            self.dummy = value
                                                            self.dummy.value_namespace = name_space
                                                            self.dummy.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv4"):
                                                            self.ipv4 = value
                                                            self.ipv4.value_namespace = name_space
                                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv6"):
                                                            self.ipv6 = value
                                                            self.ipv6.value_namespace = name_space
                                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                                class RemoteQNodeId(Entity):
                                                    """
                                                    Remote/Q node address
                                                    
                                                    .. attribute:: afi
                                                    
                                                    	AFI
                                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                    
                                                    .. attribute:: dummy
                                                    
                                                    	No Address
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ipv4
                                                    
                                                    	IPv4 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: ipv6
                                                    
                                                    	IPv6 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__init__()

                                                        self.yang_name = "remote-q-node-id"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.afi = YLeaf(YType.enumeration, "afi")

                                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("afi",
                                                                        "dummy",
                                                                        "ipv4",
                                                                        "ipv6") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.afi.is_set or
                                                            self.dummy.is_set or
                                                            self.ipv4.is_set or
                                                            self.ipv6.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.afi.yfilter != YFilter.not_set or
                                                            self.dummy.yfilter != YFilter.not_set or
                                                            self.ipv4.yfilter != YFilter.not_set or
                                                            self.ipv6.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "remote-q-node-id" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "afi"):
                                                            self.afi = value
                                                            self.afi.value_namespace = name_space
                                                            self.afi.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "dummy"):
                                                            self.dummy = value
                                                            self.dummy.value_namespace = name_space
                                                            self.dummy.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv4"):
                                                            self.ipv4 = value
                                                            self.ipv4.value_namespace = name_space
                                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv6"):
                                                            self.ipv6 = value
                                                            self.ipv6.value_namespace = name_space
                                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.has_q_node.is_set or
                                                        self.has_remote_lfa_bkup.is_set or
                                                        self.needs_tldp.is_set or
                                                        (self.remote_p_node_id is not None and self.remote_p_node_id.has_data()) or
                                                        (self.remote_q_node_id is not None and self.remote_q_node_id.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.has_q_node.yfilter != YFilter.not_set or
                                                        self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                        self.needs_tldp.yfilter != YFilter.not_set or
                                                        (self.remote_p_node_id is not None and self.remote_p_node_id.has_operation()) or
                                                        (self.remote_q_node_id is not None and self.remote_q_node_id.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-lfa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.has_q_node.is_set or self.has_q_node.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_q_node.get_name_leafdata())
                                                    if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())
                                                    if (self.needs_tldp.is_set or self.needs_tldp.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.needs_tldp.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "remote-p-node-id"):
                                                        if (self.remote_p_node_id is None):
                                                            self.remote_p_node_id = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                            self.remote_p_node_id.parent = self
                                                            self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                        return self.remote_p_node_id

                                                    if (child_yang_name == "remote-q-node-id"):
                                                        if (self.remote_q_node_id is None):
                                                            self.remote_q_node_id = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                            self.remote_q_node_id.parent = self
                                                            self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                        return self.remote_q_node_id

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "remote-p-node-id" or name == "remote-q-node-id" or name == "has-q-node" or name == "has-remote-lfa-bkup" or name == "needs-tldp"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "has-q-node"):
                                                        self.has_q_node = value
                                                        self.has_q_node.value_namespace = name_space
                                                        self.has_q_node.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "has-remote-lfa-bkup"):
                                                        self.has_remote_lfa_bkup = value
                                                        self.has_remote_lfa_bkup.value_namespace = name_space
                                                        self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "needs-tldp"):
                                                        self.needs_tldp = value
                                                        self.needs_tldp.value_namespace = name_space
                                                        self.needs_tldp.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.bkup_path_id.is_set or
                                                    self.flags.is_set or
                                                    self.interface.is_set or
                                                    self.interface_name.is_set or
                                                    self.load_metric.is_set or
                                                    self.next_hop_table_id.is_set or
                                                    self.nexthop_id.is_set or
                                                    self.nh_is_overriden.is_set or
                                                    self.path_flags.is_set or
                                                    self.path_id.is_set or
                                                    (self.next_hop is not None and self.next_hop.has_data()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bkup_path_id.yfilter != YFilter.not_set or
                                                    self.flags.yfilter != YFilter.not_set or
                                                    self.interface.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.load_metric.yfilter != YFilter.not_set or
                                                    self.next_hop_table_id.yfilter != YFilter.not_set or
                                                    self.nexthop_id.yfilter != YFilter.not_set or
                                                    self.nh_is_overriden.yfilter != YFilter.not_set or
                                                    self.path_flags.yfilter != YFilter.not_set or
                                                    self.path_id.yfilter != YFilter.not_set or
                                                    (self.next_hop is not None and self.next_hop.has_operation()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "routing" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bkup_path_id.is_set or self.bkup_path_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bkup_path_id.get_name_leafdata())
                                                if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.flags.get_name_leafdata())
                                                if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface.get_name_leafdata())
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.load_metric.get_name_leafdata())
                                                if (self.next_hop_table_id.is_set or self.next_hop_table_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_hop_table_id.get_name_leafdata())
                                                if (self.nexthop_id.is_set or self.nexthop_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nexthop_id.get_name_leafdata())
                                                if (self.nh_is_overriden.is_set or self.nh_is_overriden.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nh_is_overriden.get_name_leafdata())
                                                if (self.path_flags.is_set or self.path_flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_flags.get_name_leafdata())
                                                if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "next-hop"):
                                                    if (self.next_hop is None):
                                                        self.next_hop = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                        self.next_hop.parent = self
                                                        self._children_name_map["next_hop"] = "next-hop"
                                                    return self.next_hop

                                                if (child_yang_name == "remote-lfa"):
                                                    if (self.remote_lfa is None):
                                                        self.remote_lfa = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                        self.remote_lfa.parent = self
                                                        self._children_name_map["remote_lfa"] = "remote-lfa"
                                                    return self.remote_lfa

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "next-hop" or name == "remote-lfa" or name == "bkup-path-id" or name == "flags" or name == "interface" or name == "interface-name" or name == "load-metric" or name == "next-hop-table-id" or name == "nexthop-id" or name == "nh-is-overriden" or name == "path-flags" or name == "path-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bkup-path-id"):
                                                    self.bkup_path_id = value
                                                    self.bkup_path_id.value_namespace = name_space
                                                    self.bkup_path_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "flags"):
                                                    self.flags = value
                                                    self.flags.value_namespace = name_space
                                                    self.flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface"):
                                                    self.interface = value
                                                    self.interface.value_namespace = name_space
                                                    self.interface.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "load-metric"):
                                                    self.load_metric = value
                                                    self.load_metric.value_namespace = name_space
                                                    self.load_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-hop-table-id"):
                                                    self.next_hop_table_id = value
                                                    self.next_hop_table_id.value_namespace = name_space
                                                    self.next_hop_table_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nexthop-id"):
                                                    self.nexthop_id = value
                                                    self.nexthop_id.value_namespace = name_space
                                                    self.nexthop_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nh-is-overriden"):
                                                    self.nh_is_overriden = value
                                                    self.nh_is_overriden.value_namespace = name_space
                                                    self.nh_is_overriden.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-flags"):
                                                    self.path_flags = value
                                                    self.path_flags.value_namespace = name_space
                                                    self.path_flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-id"):
                                                    self.path_id = value
                                                    self.path_id.value_namespace = name_space
                                                    self.path_id.value_namespace_prefix = name_space_prefix


                                        class Mpls(Entity):
                                            """
                                            MPLS information
                                            
                                            .. attribute:: mpls_outgoing_info
                                            
                                            	MPLS nexthop info
                                            	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo>`
                                            
                                            .. attribute:: remote_lfa
                                            
                                            	Remote LFA\-FRR backup info
                                            	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls, self).__init__()

                                                self.yang_name = "mpls"
                                                self.yang_parent_name = "paths"

                                                self.mpls_outgoing_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                self.mpls_outgoing_info.parent = self
                                                self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                self._children_yang_names.add("mpls-outgoing-info")

                                                self.remote_lfa = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                self.remote_lfa.parent = self
                                                self._children_name_map["remote_lfa"] = "remote-lfa"
                                                self._children_yang_names.add("remote-lfa")


                                            class MplsOutgoingInfo(Entity):
                                                """
                                                MPLS nexthop info
                                                
                                                .. attribute:: is_from_graceful_restartable_neighbor
                                                
                                                	Is from a GR neighbor
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_stale
                                                
                                                	Is the entry stale
                                                	**type**\:  bool
                                                
                                                .. attribute:: nexthop_peer_ldp_ident
                                                
                                                	Nexthop LDP peer
                                                	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent>`
                                                
                                                .. attribute:: out_label
                                                
                                                	Outgoing label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: out_label_owner
                                                
                                                	Outgoing label owner
                                                	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                
                                                .. attribute:: out_label_rsn
                                                
                                                	Outgoing label reason
                                                	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                
                                                .. attribute:: out_label_type
                                                
                                                	Outgoing Label Type
                                                	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__init__()

                                                    self.yang_name = "mpls-outgoing-info"
                                                    self.yang_parent_name = "mpls"

                                                    self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                    self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                                    self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                    self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                    self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                    self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                    self.nexthop_peer_ldp_ident.parent = self
                                                    self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                    self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("is_from_graceful_restartable_neighbor",
                                                                    "is_stale",
                                                                    "out_label",
                                                                    "out_label_owner",
                                                                    "out_label_rsn",
                                                                    "out_label_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)


                                                class NexthopPeerLdpIdent(Entity):
                                                    """
                                                    Nexthop LDP peer
                                                    
                                                    .. attribute:: label_space_id
                                                    
                                                    	Label space identifier
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: ldp_id
                                                    
                                                    	LDP identifier
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: lsr_id
                                                    
                                                    	LSR identifier
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__init__()

                                                        self.yang_name = "nexthop-peer-ldp-ident"
                                                        self.yang_parent_name = "mpls-outgoing-info"

                                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("label_space_id",
                                                                        "ldp_id",
                                                                        "lsr_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.label_space_id.is_set or
                                                            self.ldp_id.is_set or
                                                            self.lsr_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.label_space_id.yfilter != YFilter.not_set or
                                                            self.ldp_id.yfilter != YFilter.not_set or
                                                            self.lsr_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "label-space-id"):
                                                            self.label_space_id = value
                                                            self.label_space_id.value_namespace = name_space
                                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ldp-id"):
                                                            self.ldp_id = value
                                                            self.ldp_id.value_namespace = name_space
                                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsr-id"):
                                                            self.lsr_id = value
                                                            self.lsr_id.value_namespace = name_space
                                                            self.lsr_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.is_from_graceful_restartable_neighbor.is_set or
                                                        self.is_stale.is_set or
                                                        self.out_label.is_set or
                                                        self.out_label_owner.is_set or
                                                        self.out_label_rsn.is_set or
                                                        self.out_label_type.is_set or
                                                        (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                        self.is_stale.yfilter != YFilter.not_set or
                                                        self.out_label.yfilter != YFilter.not_set or
                                                        self.out_label_owner.yfilter != YFilter.not_set or
                                                        self.out_label_rsn.yfilter != YFilter.not_set or
                                                        self.out_label_type.yfilter != YFilter.not_set or
                                                        (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mpls-outgoing-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                    if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                                    if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                    if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                    if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                        if (self.nexthop_peer_ldp_ident is None):
                                                            self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                            self.nexthop_peer_ldp_ident.parent = self
                                                            self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                        return self.nexthop_peer_ldp_ident

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "is-from-graceful-restartable-neighbor"):
                                                        self.is_from_graceful_restartable_neighbor = value
                                                        self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                        self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-stale"):
                                                        self.is_stale = value
                                                        self.is_stale.value_namespace = name_space
                                                        self.is_stale.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label"):
                                                        self.out_label = value
                                                        self.out_label.value_namespace = name_space
                                                        self.out_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-owner"):
                                                        self.out_label_owner = value
                                                        self.out_label_owner.value_namespace = name_space
                                                        self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-rsn"):
                                                        self.out_label_rsn = value
                                                        self.out_label_rsn.value_namespace = name_space
                                                        self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-type"):
                                                        self.out_label_type = value
                                                        self.out_label_type.value_namespace = name_space
                                                        self.out_label_type.value_namespace_prefix = name_space_prefix


                                            class RemoteLfa(Entity):
                                                """
                                                Remote LFA\-FRR backup info
                                                
                                                .. attribute:: has_remote_lfa_bkup
                                                
                                                	Whether path has remote LFA backup
                                                	**type**\:  bool
                                                
                                                .. attribute:: mpls_outgoing_info
                                                
                                                	Remote LFA MPLS nexthop(s\_ info
                                                	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__init__()

                                                    self.yang_name = "remote-lfa"
                                                    self.yang_parent_name = "mpls"

                                                    self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                    self.mpls_outgoing_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                    self.mpls_outgoing_info.parent = self
                                                    self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    self._children_yang_names.add("mpls-outgoing-info")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("has_remote_lfa_bkup") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)


                                                class MplsOutgoingInfo(Entity):
                                                    """
                                                    Remote LFA MPLS nexthop(s\_ info
                                                    
                                                    .. attribute:: stack
                                                    
                                                    	Inner label stack info
                                                    	**type**\: list of    :py:class:`Stack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__init__()

                                                        self.yang_name = "mpls-outgoing-info"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.stack = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in () and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)


                                                    class Stack(Entity):
                                                        """
                                                        Inner label stack info
                                                        
                                                        .. attribute:: is_from_graceful_restartable_neighbor
                                                        
                                                        	Is from a GR neighbor
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: is_stale
                                                        
                                                        	Is the entry stale
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: nexthop_peer_ldp_ident
                                                        
                                                        	Nexthop LDP peer
                                                        	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent>`
                                                        
                                                        .. attribute:: out_label
                                                        
                                                        	Outgoing label
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: out_label_owner
                                                        
                                                        	Outgoing label owner
                                                        	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                        
                                                        .. attribute:: out_label_rsn
                                                        
                                                        	Outgoing label reason
                                                        	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                        
                                                        .. attribute:: out_label_type
                                                        
                                                        	Outgoing Label Type
                                                        	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-ldp-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__init__()

                                                            self.yang_name = "stack"
                                                            self.yang_parent_name = "mpls-outgoing-info"

                                                            self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                            self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                                            self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                            self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                            self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                            self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                            self.nexthop_peer_ldp_ident.parent = self
                                                            self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                            self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("is_from_graceful_restartable_neighbor",
                                                                            "is_stale",
                                                                            "out_label",
                                                                            "out_label_owner",
                                                                            "out_label_rsn",
                                                                            "out_label_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)


                                                        class NexthopPeerLdpIdent(Entity):
                                                            """
                                                            Nexthop LDP peer
                                                            
                                                            .. attribute:: label_space_id
                                                            
                                                            	Label space identifier
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: ldp_id
                                                            
                                                            	LDP identifier
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: lsr_id
                                                            
                                                            	LSR identifier
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-ldp-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__init__()

                                                                self.yang_name = "nexthop-peer-ldp-ident"
                                                                self.yang_parent_name = "stack"

                                                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("label_space_id",
                                                                                "ldp_id",
                                                                                "lsr_id") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.label_space_id.is_set or
                                                                    self.ldp_id.is_set or
                                                                    self.lsr_id.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.label_space_id.yfilter != YFilter.not_set or
                                                                    self.ldp_id.yfilter != YFilter.not_set or
                                                                    self.lsr_id.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "label-space-id"):
                                                                    self.label_space_id = value
                                                                    self.label_space_id.value_namespace = name_space
                                                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "ldp-id"):
                                                                    self.ldp_id = value
                                                                    self.ldp_id.value_namespace = name_space
                                                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "lsr-id"):
                                                                    self.lsr_id = value
                                                                    self.lsr_id.value_namespace = name_space
                                                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.is_from_graceful_restartable_neighbor.is_set or
                                                                self.is_stale.is_set or
                                                                self.out_label.is_set or
                                                                self.out_label_owner.is_set or
                                                                self.out_label_rsn.is_set or
                                                                self.out_label_type.is_set or
                                                                (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                                self.is_stale.yfilter != YFilter.not_set or
                                                                self.out_label.yfilter != YFilter.not_set or
                                                                self.out_label_owner.yfilter != YFilter.not_set or
                                                                self.out_label_rsn.yfilter != YFilter.not_set or
                                                                self.out_label_type.yfilter != YFilter.not_set or
                                                                (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "stack" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                            if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                                            if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                            if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                            if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                                if (self.nexthop_peer_ldp_ident is None):
                                                                    self.nexthop_peer_ldp_ident = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                                    self.nexthop_peer_ldp_ident.parent = self
                                                                    self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                                return self.nexthop_peer_ldp_ident

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "is-from-graceful-restartable-neighbor"):
                                                                self.is_from_graceful_restartable_neighbor = value
                                                                self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                                self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "is-stale"):
                                                                self.is_stale = value
                                                                self.is_stale.value_namespace = name_space
                                                                self.is_stale.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label"):
                                                                self.out_label = value
                                                                self.out_label.value_namespace = name_space
                                                                self.out_label.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-owner"):
                                                                self.out_label_owner = value
                                                                self.out_label_owner.value_namespace = name_space
                                                                self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-rsn"):
                                                                self.out_label_rsn = value
                                                                self.out_label_rsn.value_namespace = name_space
                                                                self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-type"):
                                                                self.out_label_type = value
                                                                self.out_label_type.value_namespace = name_space
                                                                self.out_label_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.stack:
                                                            if (c.has_data()):
                                                                return True
                                                        return False

                                                    def has_operation(self):
                                                        for c in self.stack:
                                                            if (c.has_operation()):
                                                                return True
                                                        return self.yfilter != YFilter.not_set

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "mpls-outgoing-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "stack"):
                                                            for c in self.stack:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.stack.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "stack"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass

                                                def has_data(self):
                                                    return (
                                                        self.has_remote_lfa_bkup.is_set or
                                                        (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                        (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-lfa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "mpls-outgoing-info"):
                                                        if (self.mpls_outgoing_info is None):
                                                            self.mpls_outgoing_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                            self.mpls_outgoing_info.parent = self
                                                            self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                        return self.mpls_outgoing_info

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "mpls-outgoing-info" or name == "has-remote-lfa-bkup"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "has-remote-lfa-bkup"):
                                                        self.has_remote_lfa_bkup = value
                                                        self.has_remote_lfa_bkup.value_namespace = name_space
                                                        self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mpls-outgoing-info"):
                                                    if (self.mpls_outgoing_info is None):
                                                        self.mpls_outgoing_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                        self.mpls_outgoing_info.parent = self
                                                        self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    return self.mpls_outgoing_info

                                                if (child_yang_name == "remote-lfa"):
                                                    if (self.remote_lfa is None):
                                                        self.remote_lfa = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                        self.remote_lfa.parent = self
                                                        self._children_name_map["remote_lfa"] = "remote-lfa"
                                                    return self.remote_lfa

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mpls-outgoing-info" or name == "remote-lfa"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                (self.mpls is not None and self.mpls.has_data()) or
                                                (self.routing is not None and self.routing.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls is not None and self.mpls.has_operation()) or
                                                (self.routing is not None and self.routing.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "paths" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls"):
                                                if (self.mpls is None):
                                                    self.mpls = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                                    self.mpls.parent = self
                                                    self._children_name_map["mpls"] = "mpls"
                                                return self.mpls

                                            if (child_yang_name == "routing"):
                                                if (self.routing is None):
                                                    self.routing = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                                    self.routing.parent = self
                                                    self._children_name_map["routing"] = "routing"
                                                return self.routing

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls" or name == "routing"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        for c in self.paths:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.table_id.is_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                            (self.route is not None and self.route.has_data()) or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.paths:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                            (self.route is not None and self.route.has_operation()) or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "forwarding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "paths"):
                                            for c in self.paths:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.paths.append(c)
                                            return c

                                        if (child_yang_name == "prefix-xr"):
                                            if (self.prefix_xr is None):
                                                self.prefix_xr = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                                self.prefix_xr.parent = self
                                                self._children_name_map["prefix_xr"] = "prefix-xr"
                                            return self.prefix_xr

                                        if (child_yang_name == "route"):
                                            if (self.route is None):
                                                self.route = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route()
                                                self.route.parent = self
                                                self._children_name_map["route"] = "route"
                                            return self.route

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "paths" or name == "prefix-xr" or name == "route" or name == "vrf" or name == "prefix" or name == "prefix-length" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.forwarding:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.forwarding:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwardings" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "forwarding"):
                                        for c in self.forwarding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.forwarding.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "forwarding"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsAdvertiseSpec(Entity):
                                """
                                Advertisement Spec (ACL) for LDP Label
                                Infomation Base (LIB)
                                
                                .. attribute:: advt_acl
                                
                                	Advertisement ACLs
                                	**type**\: list of    :py:class:`AdvtAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl>`
                                
                                .. attribute:: allocation_acl
                                
                                	Local label Allocation filter
                                	**type**\:   :py:class:`AllocationAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__init__()

                                    self.yang_name = "bindings-advertise-spec"
                                    self.yang_parent_name = "af"

                                    self.allocation_acl = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                    self.allocation_acl.parent = self
                                    self._children_name_map["allocation_acl"] = "allocation-acl"
                                    self._children_yang_names.add("allocation-acl")

                                    self.advt_acl = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)


                                class AllocationAcl(Entity):
                                    """
                                    Local label Allocation filter
                                    
                                    .. attribute:: has_acl
                                    
                                    	Has ACL filter?
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_host_route_only
                                    
                                    	Host\-routes only?
                                    	**type**\:  bool
                                    
                                    .. attribute:: prefix_acl
                                    
                                    	Prefix ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__init__()

                                        self.yang_name = "allocation-acl"
                                        self.yang_parent_name = "bindings-advertise-spec"

                                        self.has_acl = YLeaf(YType.boolean, "has-acl")

                                        self.is_host_route_only = YLeaf(YType.boolean, "is-host-route-only")

                                        self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("has_acl",
                                                        "is_host_route_only",
                                                        "prefix_acl") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.has_acl.is_set or
                                            self.is_host_route_only.is_set or
                                            self.prefix_acl.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.has_acl.yfilter != YFilter.not_set or
                                            self.is_host_route_only.yfilter != YFilter.not_set or
                                            self.prefix_acl.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "allocation-acl" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.has_acl.is_set or self.has_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.has_acl.get_name_leafdata())
                                        if (self.is_host_route_only.is_set or self.is_host_route_only.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_host_route_only.get_name_leafdata())
                                        if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "has-acl" or name == "is-host-route-only" or name == "prefix-acl"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "has-acl"):
                                            self.has_acl = value
                                            self.has_acl.value_namespace = name_space
                                            self.has_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-host-route-only"):
                                            self.is_host_route_only = value
                                            self.is_host_route_only.value_namespace = name_space
                                            self.is_host_route_only.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-acl"):
                                            self.prefix_acl = value
                                            self.prefix_acl.value_namespace = name_space
                                            self.prefix_acl.value_namespace_prefix = name_space_prefix


                                class AdvtAcl(Entity):
                                    """
                                    Advertisement ACLs
                                    
                                    .. attribute:: peer_acl
                                    
                                    	Peer ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    .. attribute:: prefix_acl
                                    
                                    	Prefix ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__init__()

                                        self.yang_name = "advt-acl"
                                        self.yang_parent_name = "bindings-advertise-spec"

                                        self.peer_acl = YLeaf(YType.str, "peer-acl")

                                        self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("peer_acl",
                                                        "prefix_acl") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.peer_acl.is_set or
                                            self.prefix_acl.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.peer_acl.yfilter != YFilter.not_set or
                                            self.prefix_acl.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "advt-acl" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.peer_acl.is_set or self.peer_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_acl.get_name_leafdata())
                                        if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "peer-acl" or name == "prefix-acl"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "peer-acl"):
                                            self.peer_acl = value
                                            self.peer_acl.value_namespace = name_space
                                            self.peer_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-acl"):
                                            self.prefix_acl = value
                                            self.prefix_acl.value_namespace = name_space
                                            self.prefix_acl.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.advt_acl:
                                        if (c.has_data()):
                                            return True
                                    return (self.allocation_acl is not None and self.allocation_acl.has_data())

                                def has_operation(self):
                                    for c in self.advt_acl:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.allocation_acl is not None and self.allocation_acl.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-advertise-spec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "advt-acl"):
                                        for c in self.advt_acl:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.advt_acl.append(c)
                                        return c

                                    if (child_yang_name == "allocation-acl"):
                                        if (self.allocation_acl is None):
                                            self.allocation_acl = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                            self.allocation_acl.parent = self
                                            self._children_name_map["allocation_acl"] = "allocation-acl"
                                        return self.allocation_acl

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "advt-acl" or name == "allocation-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class ForwardingSummary(Entity):
                                """
                                Summary information regarding LDP forwarding
                                setup
                                
                                .. attribute:: fsht
                                
                                	Forwarding state hold time registered with LSD
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: intfs
                                
                                	MPLS forwarding enabled interface count
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: is_lsd_bound
                                
                                	LDP is connected to LSD server
                                	**type**\:  bool
                                
                                .. attribute:: lbls
                                
                                	Local label allocated count
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: rws
                                
                                	Forwarding rewrites summary
                                	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__init__()

                                    self.yang_name = "forwarding-summary"
                                    self.yang_parent_name = "af"

                                    self.fsht = YLeaf(YType.uint16, "fsht")

                                    self.intfs = YLeaf(YType.uint16, "intfs")

                                    self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                                    self.lbls = YLeaf(YType.uint16, "lbls")

                                    self.rws = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws()
                                    self.rws.parent = self
                                    self._children_name_map["rws"] = "rws"
                                    self._children_yang_names.add("rws")

                                    self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fsht",
                                                    "intfs",
                                                    "is_lsd_bound",
                                                    "lbls") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "forwarding-summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class Rws(Entity):
                                    """
                                    Forwarding rewrites summary
                                    
                                    .. attribute:: nhs
                                    
                                    	Forwarding rewrites nexthops (paths) summary
                                    	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs>`
                                    
                                    .. attribute:: pfxs
                                    
                                    	Forwarding rewrites prefix summary
                                    	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws, self).__init__()

                                        self.yang_name = "rws"
                                        self.yang_parent_name = "forwarding-summary"

                                        self.nhs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                        self.nhs.parent = self
                                        self._children_name_map["nhs"] = "nhs"
                                        self._children_yang_names.add("nhs")

                                        self.pfxs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                        self.pfxs.parent = self
                                        self._children_name_map["pfxs"] = "pfxs"
                                        self._children_yang_names.add("pfxs")


                                    class Pfxs(Entity):
                                        """
                                        Forwarding rewrites prefix summary
                                        
                                        .. attribute:: ecmp_pfxs
                                        
                                        	Count of prefixes with ECMP
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_aggr
                                        
                                        	Labeled prefix count for all paths
                                        	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr>`
                                        
                                        .. attribute:: labeled_pfxs_backup
                                        
                                        	Labeled prefix count related to backup paths only
                                        	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup>`
                                        
                                        .. attribute:: labeled_pfxs_primary
                                        
                                        	Labeled prefix count related to primary paths only
                                        	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary>`
                                        
                                        .. attribute:: protected_pfxs
                                        
                                        	Count of FRR protected prefixes
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: total_pfxs
                                        
                                        	Total Prefix count
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__init__()

                                            self.yang_name = "pfxs"
                                            self.yang_parent_name = "rws"

                                            self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                                            self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                                            self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                                            self.labeled_pfxs_aggr = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                            self.labeled_pfxs_aggr.parent = self
                                            self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                            self._children_yang_names.add("labeled-pfxs-aggr")

                                            self.labeled_pfxs_backup = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                            self.labeled_pfxs_backup.parent = self
                                            self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                            self._children_yang_names.add("labeled-pfxs-backup")

                                            self.labeled_pfxs_primary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                            self.labeled_pfxs_primary.parent = self
                                            self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                            self._children_yang_names.add("labeled-pfxs-primary")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ecmp_pfxs",
                                                            "protected_pfxs",
                                                            "total_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)


                                        class LabeledPfxsAggr(Entity):
                                            """
                                            Labeled prefix count for all paths
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                                self.yang_name = "labeled-pfxs-aggr"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-aggr" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                        class LabeledPfxsPrimary(Entity):
                                            """
                                            Labeled prefix count related to primary paths
                                            only
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                                self.yang_name = "labeled-pfxs-primary"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-primary" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                        class LabeledPfxsBackup(Entity):
                                            """
                                            Labeled prefix count related to backup paths
                                            only
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                                self.yang_name = "labeled-pfxs-backup"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-backup" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.ecmp_pfxs.is_set or
                                                self.protected_pfxs.is_set or
                                                self.total_pfxs.is_set or
                                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ecmp_pfxs.yfilter != YFilter.not_set or
                                                self.protected_pfxs.yfilter != YFilter.not_set or
                                                self.total_pfxs.yfilter != YFilter.not_set or
                                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "pfxs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                                            if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                                            if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "labeled-pfxs-aggr"):
                                                if (self.labeled_pfxs_aggr is None):
                                                    self.labeled_pfxs_aggr = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                                    self.labeled_pfxs_aggr.parent = self
                                                    self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                                return self.labeled_pfxs_aggr

                                            if (child_yang_name == "labeled-pfxs-backup"):
                                                if (self.labeled_pfxs_backup is None):
                                                    self.labeled_pfxs_backup = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                                    self.labeled_pfxs_backup.parent = self
                                                    self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                                return self.labeled_pfxs_backup

                                            if (child_yang_name == "labeled-pfxs-primary"):
                                                if (self.labeled_pfxs_primary is None):
                                                    self.labeled_pfxs_primary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                                    self.labeled_pfxs_primary.parent = self
                                                    self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                                return self.labeled_pfxs_primary

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ecmp-pfxs"):
                                                self.ecmp_pfxs = value
                                                self.ecmp_pfxs.value_namespace = name_space
                                                self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-pfxs"):
                                                self.protected_pfxs = value
                                                self.protected_pfxs.value_namespace = name_space
                                                self.protected_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-pfxs"):
                                                self.total_pfxs = value
                                                self.total_pfxs.value_namespace = name_space
                                                self.total_pfxs.value_namespace_prefix = name_space_prefix


                                    class Nhs(Entity):
                                        """
                                        Forwarding rewrites nexthops (paths) summary
                                        
                                        .. attribute:: backup_paths
                                        
                                        	Count of non\-primary backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: labeled_backup_paths
                                        
                                        	Count of labeled backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: labeled_paths
                                        
                                        	Count of all labeled paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: protected_paths
                                        
                                        	Count of FRR protected paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: remote_backup_paths
                                        
                                        	Count of non\-primary remote backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: total_paths
                                        
                                        	Total path count
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__init__()

                                            self.yang_name = "nhs"
                                            self.yang_parent_name = "rws"

                                            self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                                            self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                                            self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                                            self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                                            self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                                            self.total_paths = YLeaf(YType.uint32, "total-paths")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_paths",
                                                            "labeled_backup_paths",
                                                            "labeled_paths",
                                                            "protected_paths",
                                                            "remote_backup_paths",
                                                            "total_paths") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_paths.is_set or
                                                self.labeled_backup_paths.is_set or
                                                self.labeled_paths.is_set or
                                                self.protected_paths.is_set or
                                                self.remote_backup_paths.is_set or
                                                self.total_paths.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_paths.yfilter != YFilter.not_set or
                                                self.labeled_backup_paths.yfilter != YFilter.not_set or
                                                self.labeled_paths.yfilter != YFilter.not_set or
                                                self.protected_paths.yfilter != YFilter.not_set or
                                                self.remote_backup_paths.yfilter != YFilter.not_set or
                                                self.total_paths.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nhs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_paths.get_name_leafdata())
                                            if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                                            if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                                            if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_paths.get_name_leafdata())
                                            if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                                            if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_paths.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-paths"):
                                                self.backup_paths = value
                                                self.backup_paths.value_namespace = name_space
                                                self.backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-backup-paths"):
                                                self.labeled_backup_paths = value
                                                self.labeled_backup_paths.value_namespace = name_space
                                                self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-paths"):
                                                self.labeled_paths = value
                                                self.labeled_paths.value_namespace = name_space
                                                self.labeled_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-paths"):
                                                self.protected_paths = value
                                                self.protected_paths.value_namespace = name_space
                                                self.protected_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "remote-backup-paths"):
                                                self.remote_backup_paths = value
                                                self.remote_backup_paths.value_namespace = name_space
                                                self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-paths"):
                                                self.total_paths = value
                                                self.total_paths.value_namespace = name_space
                                                self.total_paths.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.nhs is not None and self.nhs.has_data()) or
                                            (self.pfxs is not None and self.pfxs.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.nhs is not None and self.nhs.has_operation()) or
                                            (self.pfxs is not None and self.pfxs.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "rws" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "nhs"):
                                            if (self.nhs is None):
                                                self.nhs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                                self.nhs.parent = self
                                                self._children_name_map["nhs"] = "nhs"
                                            return self.nhs

                                        if (child_yang_name == "pfxs"):
                                            if (self.pfxs is None):
                                                self.pfxs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                                self.pfxs.parent = self
                                                self._children_name_map["pfxs"] = "pfxs"
                                            return self.pfxs

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nhs" or name == "pfxs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.fsht.is_set or
                                        self.intfs.is_set or
                                        self.is_lsd_bound.is_set or
                                        self.lbls.is_set or
                                        (self.rws is not None and self.rws.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fsht.yfilter != YFilter.not_set or
                                        self.intfs.yfilter != YFilter.not_set or
                                        self.is_lsd_bound.yfilter != YFilter.not_set or
                                        self.lbls.yfilter != YFilter.not_set or
                                        (self.rws is not None and self.rws.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwarding-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fsht.get_name_leafdata())
                                    if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intfs.get_name_leafdata())
                                    if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                                    if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbls.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "rws"):
                                        if (self.rws is None):
                                            self.rws = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws()
                                            self.rws.parent = self
                                            self._children_name_map["rws"] = "rws"
                                        return self.rws

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fsht"):
                                        self.fsht = value
                                        self.fsht.value_namespace = name_space
                                        self.fsht.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intfs"):
                                        self.intfs = value
                                        self.intfs.value_namespace = name_space
                                        self.intfs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-lsd-bound"):
                                        self.is_lsd_bound = value
                                        self.is_lsd_bound.value_namespace = name_space
                                        self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbls"):
                                        self.lbls = value
                                        self.lbls.value_namespace = name_space
                                        self.lbls.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.af_name.is_set or
                                    (self.bindings is not None and self.bindings.has_data()) or
                                    (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_data()) or
                                    (self.bindings_summary is not None and self.bindings_summary.has_data()) or
                                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                                    (self.discovery is not None and self.discovery.has_data()) or
                                    (self.forwarding_summary is not None and self.forwarding_summary.has_data()) or
                                    (self.forwardings is not None and self.forwardings.has_data()) or
                                    (self.igp is not None and self.igp.has_data()) or
                                    (self.interface_summary is not None and self.interface_summary.has_data()) or
                                    (self.interfaces is not None and self.interfaces.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.af_name.yfilter != YFilter.not_set or
                                    (self.bindings is not None and self.bindings.has_operation()) or
                                    (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_operation()) or
                                    (self.bindings_summary is not None and self.bindings_summary.has_operation()) or
                                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                                    (self.discovery is not None and self.discovery.has_operation()) or
                                    (self.forwarding_summary is not None and self.forwarding_summary.has_operation()) or
                                    (self.forwardings is not None and self.forwardings.has_operation()) or
                                    (self.igp is not None and self.igp.has_operation()) or
                                    (self.interface_summary is not None and self.interface_summary.has_operation()) or
                                    (self.interfaces is not None and self.interfaces.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "af" + "[af-name='" + self.af_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.af_name.is_set or self.af_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.af_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bindings"):
                                    if (self.bindings is None):
                                        self.bindings = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Bindings()
                                        self.bindings.parent = self
                                        self._children_name_map["bindings"] = "bindings"
                                    return self.bindings

                                if (child_yang_name == "bindings-advertise-spec"):
                                    if (self.bindings_advertise_spec is None):
                                        self.bindings_advertise_spec = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec()
                                        self.bindings_advertise_spec.parent = self
                                        self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                    return self.bindings_advertise_spec

                                if (child_yang_name == "bindings-summary"):
                                    if (self.bindings_summary is None):
                                        self.bindings_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummary()
                                        self.bindings_summary.parent = self
                                        self._children_name_map["bindings_summary"] = "bindings-summary"
                                    return self.bindings_summary

                                if (child_yang_name == "bindings-summary-all"):
                                    if (self.bindings_summary_all is None):
                                        self.bindings_summary_all = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.BindingsSummaryAll()
                                        self.bindings_summary_all.parent = self
                                        self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                    return self.bindings_summary_all

                                if (child_yang_name == "discovery"):
                                    if (self.discovery is None):
                                        self.discovery = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Discovery()
                                        self.discovery.parent = self
                                        self._children_name_map["discovery"] = "discovery"
                                    return self.discovery

                                if (child_yang_name == "forwarding-summary"):
                                    if (self.forwarding_summary is None):
                                        self.forwarding_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.ForwardingSummary()
                                        self.forwarding_summary.parent = self
                                        self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                    return self.forwarding_summary

                                if (child_yang_name == "forwardings"):
                                    if (self.forwardings is None):
                                        self.forwardings = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Forwardings()
                                        self.forwardings.parent = self
                                        self._children_name_map["forwardings"] = "forwardings"
                                    return self.forwardings

                                if (child_yang_name == "igp"):
                                    if (self.igp is None):
                                        self.igp = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Igp()
                                        self.igp.parent = self
                                        self._children_name_map["igp"] = "igp"
                                    return self.igp

                                if (child_yang_name == "interface-summary"):
                                    if (self.interface_summary is None):
                                        self.interface_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.InterfaceSummary()
                                        self.interface_summary.parent = self
                                        self._children_name_map["interface_summary"] = "interface-summary"
                                    return self.interface_summary

                                if (child_yang_name == "interfaces"):
                                    if (self.interfaces is None):
                                        self.interfaces = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af.Interfaces()
                                        self.interfaces.parent = self
                                        self._children_name_map["interfaces"] = "interfaces"
                                    return self.interfaces

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bindings" or name == "bindings-advertise-spec" or name == "bindings-summary" or name == "bindings-summary-all" or name == "discovery" or name == "forwarding-summary" or name == "forwardings" or name == "igp" or name == "interface-summary" or name == "interfaces" or name == "af-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "af-name"):
                                    self.af_name = value
                                    self.af_name.value_namespace = name_space
                                    self.af_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.af:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.af:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "afs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "af"):
                                for c in self.af:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs.Af()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.af.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "af"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborBriefs(Entity):
                        """
                        The LDP Neighbors (brief)
                        
                        .. attribute:: neighbor_brief
                        
                        	Brief information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`NeighborBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs, self).__init__()

                            self.yang_name = "neighbor-briefs"
                            self.yang_parent_name = "vrf"

                            self.neighbor_brief = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs, self).__setattr__(name, value)


                        class NeighborBrief(Entity):
                            """
                            Brief information on a particular LDP neighbor
                            
                            .. attribute:: is_graceful_restartable
                            
                            	Is graceful restartable
                            	**type**\:  bool
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: nbr_br_af_info
                            
                            	Neighbor Brief AF Info
                            	**type**\: list of    :py:class:`NbrBrAfInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo>`
                            
                            .. attribute:: nsr_state
                            
                            	NSR readiness state
                            	**type**\:   :py:class:`ShowNsrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.ShowNsrState>`
                            
                            .. attribute:: up_time_seconds
                            
                            	Up time in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__init__()

                                self.yang_name = "neighbor-brief"
                                self.yang_parent_name = "neighbor-briefs"

                                self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.nsr_state = YLeaf(YType.enumeration, "nsr-state")

                                self.up_time_seconds = YLeaf(YType.uint32, "up-time-seconds")

                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.nbr_br_af_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_graceful_restartable",
                                                "label_space_id",
                                                "lsr_id",
                                                "nsr_state",
                                                "up_time_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "neighbor-brief"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class NbrBrAfInfo(Entity):
                                """
                                Neighbor Brief AF Info
                                
                                .. attribute:: address_family
                                
                                	Neighbor Brief Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: num_of_nbr_addresses
                                
                                	Number of neighbor addresses
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_nbr_discovery
                                
                                	Number of neighbor discovery sources
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_nbr_lbl
                                
                                	Number of neighbor labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__init__()

                                    self.yang_name = "nbr-br-af-info"
                                    self.yang_parent_name = "neighbor-brief"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.num_of_nbr_addresses = YLeaf(YType.uint32, "num-of-nbr-addresses")

                                    self.num_of_nbr_discovery = YLeaf(YType.uint32, "num-of-nbr-discovery")

                                    self.num_of_nbr_lbl = YLeaf(YType.uint32, "num-of-nbr-lbl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "num_of_nbr_addresses",
                                                    "num_of_nbr_discovery",
                                                    "num_of_nbr_lbl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.num_of_nbr_addresses.is_set or
                                        self.num_of_nbr_discovery.is_set or
                                        self.num_of_nbr_lbl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.num_of_nbr_addresses.yfilter != YFilter.not_set or
                                        self.num_of_nbr_discovery.yfilter != YFilter.not_set or
                                        self.num_of_nbr_lbl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "nbr-br-af-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.num_of_nbr_addresses.is_set or self.num_of_nbr_addresses.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_addresses.get_name_leafdata())
                                    if (self.num_of_nbr_discovery.is_set or self.num_of_nbr_discovery.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_discovery.get_name_leafdata())
                                    if (self.num_of_nbr_lbl.is_set or self.num_of_nbr_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_lbl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "num-of-nbr-addresses" or name == "num-of-nbr-discovery" or name == "num-of-nbr-lbl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-addresses"):
                                        self.num_of_nbr_addresses = value
                                        self.num_of_nbr_addresses.value_namespace = name_space
                                        self.num_of_nbr_addresses.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-discovery"):
                                        self.num_of_nbr_discovery = value
                                        self.num_of_nbr_discovery.value_namespace = name_space
                                        self.num_of_nbr_discovery.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-lbl"):
                                        self.num_of_nbr_lbl = value
                                        self.num_of_nbr_lbl.value_namespace = name_space
                                        self.num_of_nbr_lbl.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.nbr_br_af_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_graceful_restartable.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    self.nsr_state.is_set or
                                    self.up_time_seconds.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.nbr_br_af_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_graceful_restartable.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    self.nsr_state.yfilter != YFilter.not_set or
                                    self.up_time_seconds.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-brief" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                if (self.nsr_state.is_set or self.nsr_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state.get_name_leafdata())
                                if (self.up_time_seconds.is_set or self.up_time_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.up_time_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "nbr-br-af-info"):
                                    for c in self.nbr_br_af_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.nbr_br_af_info.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nbr-br-af-info" or name == "vrf" or name == "is-graceful-restartable" or name == "label-space-id" or name == "lsr-id" or name == "nsr-state" or name == "up-time-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-graceful-restartable"):
                                    self.is_graceful_restartable = value
                                    self.is_graceful_restartable.value_namespace = name_space
                                    self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state"):
                                    self.nsr_state = value
                                    self.nsr_state.value_namespace = name_space
                                    self.nsr_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "up-time-seconds"):
                                    self.up_time_seconds = value
                                    self.up_time_seconds.value_namespace = name_space
                                    self.up_time_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor_brief:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor_brief:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-briefs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-brief"):
                                for c in self.neighbor_brief:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs.NeighborBrief()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor_brief.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-brief"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class BackoffParameters(Entity):
                        """
                        The LDP Backoff Parameters
                        
                        .. attribute:: initial_seconds
                        
                        	Initial backoff value in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: maximum_seconds
                        
                        	Maximum backoff value in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.BackoffParameters, self).__init__()

                            self.yang_name = "backoff-parameters"
                            self.yang_parent_name = "vrf"

                            self.initial_seconds = YLeaf(YType.uint32, "initial-seconds")

                            self.maximum_seconds = YLeaf(YType.uint32, "maximum-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("initial_seconds",
                                            "maximum_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.BackoffParameters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.BackoffParameters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.initial_seconds.is_set or
                                self.maximum_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.initial_seconds.yfilter != YFilter.not_set or
                                self.maximum_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoff-parameters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.initial_seconds.is_set or self.initial_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.initial_seconds.get_name_leafdata())
                            if (self.maximum_seconds.is_set or self.maximum_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "initial-seconds" or name == "maximum-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "initial-seconds"):
                                self.initial_seconds = value
                                self.initial_seconds.value_namespace = name_space
                                self.initial_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-seconds"):
                                self.maximum_seconds = value
                                self.maximum_seconds.value_namespace = name_space
                                self.maximum_seconds.value_namespace_prefix = name_space_prefix


                    class Backoffs(Entity):
                        """
                        The LDP backoff
                        
                        .. attribute:: backoff
                        
                        	LDP Backoff Information
                        	**type**\: list of    :py:class:`Backoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs.Backoff>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs, self).__init__()

                            self.yang_name = "backoffs"
                            self.yang_parent_name = "vrf"

                            self.backoff = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs, self).__setattr__(name, value)


                        class Backoff(Entity):
                            """
                            LDP Backoff Information
                            
                            .. attribute:: backoff_seconds
                            
                            	Backoff seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: waiting_seconds
                            
                            	Backoff waiting seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs.Backoff, self).__init__()

                                self.yang_name = "backoff"
                                self.yang_parent_name = "backoffs"

                                self.backoff_seconds = YLeaf(YType.uint32, "backoff-seconds")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.waiting_seconds = YLeaf(YType.uint32, "waiting-seconds")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backoff_seconds",
                                                "label_space_id",
                                                "lsr_id",
                                                "waiting_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs.Backoff, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs.Backoff, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.backoff_seconds.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    self.waiting_seconds.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backoff_seconds.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    self.waiting_seconds.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backoff" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backoff_seconds.is_set or self.backoff_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backoff_seconds.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                if (self.waiting_seconds.is_set or self.waiting_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.waiting_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backoff-seconds" or name == "label-space-id" or name == "lsr-id" or name == "waiting-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backoff-seconds"):
                                    self.backoff_seconds = value
                                    self.backoff_seconds.value_namespace = name_space
                                    self.backoff_seconds.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "waiting-seconds"):
                                    self.waiting_seconds = value
                                    self.waiting_seconds.value_namespace = name_space
                                    self.waiting_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.backoff:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.backoff:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoffs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backoff"):
                                for c in self.backoff:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs.Backoff()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.backoff.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Nsr(Entity):
                        """
                        LDP NSR related information
                        
                        .. attribute:: ha_statistics
                        
                        	LDP NSR Statistics related information
                        	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics>`
                        
                        .. attribute:: ha_summary
                        
                        	LDP HA Summary
                        	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary>`
                        
                        .. attribute:: nsr_pending
                        
                        	LDP NSR Pending related information
                        	**type**\:   :py:class:`NsrPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr, self).__init__()

                            self.yang_name = "nsr"
                            self.yang_parent_name = "vrf"

                            self.ha_statistics = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics()
                            self.ha_statistics.parent = self
                            self._children_name_map["ha_statistics"] = "ha-statistics"
                            self._children_yang_names.add("ha-statistics")

                            self.ha_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary()
                            self.ha_summary.parent = self
                            self._children_name_map["ha_summary"] = "ha-summary"
                            self._children_yang_names.add("ha-summary")

                            self.nsr_pending = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending()
                            self.nsr_pending.parent = self
                            self._children_name_map["nsr_pending"] = "nsr-pending"
                            self._children_yang_names.add("nsr-pending")


                        class NsrPending(Entity):
                            """
                            LDP NSR Pending related information
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending, self).__init__()

                                self.yang_name = "nsr-pending"
                                self.yang_parent_name = "nsr"

                                self.ha_neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "nsr-pending"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (self.ha_neighbors is not None and self.ha_neighbors.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nsr-pending" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaSummary(Entity):
                            """
                            LDP HA Summary
                            
                            .. attribute:: sessions
                            
                            	Session summary
                            	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Sessions>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary, self).__init__()

                                self.yang_name = "ha-summary"
                                self.yang_parent_name = "nsr"

                                self.sessions = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Sessions()
                                self.sessions.parent = self
                                self._children_name_map["sessions"] = "sessions"
                                self._children_yang_names.add("sessions")

                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "ha-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Sessions(Entity):
                                """
                                Session summary
                                
                                .. attribute:: nsr_eligible
                                
                                	NSR eligible sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_app_wait
                                
                                	Number of sessions in NSR app\-wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_none
                                
                                	Number of sessions in NSR none state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_operational
                                
                                	Number of sessions in NSR operational state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_prepare
                                
                                	Number of sessions in NSR prepare state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_ready
                                
                                	Number of sessions in NSR ready state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase1
                                
                                	Number of sessions in NSR TCP phase 1 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase2
                                
                                	Number of sessions in NSR TCP phase 2 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_wait
                                
                                	Number of sessions in NSR wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total
                                
                                	Total sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__init__()

                                    self.yang_name = "sessions"
                                    self.yang_parent_name = "ha-summary"

                                    self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                    self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                    self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                    self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                    self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                    self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                    self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                    self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                    self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                    self.total = YLeaf(YType.uint32, "total")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nsr_eligible",
                                                    "nsr_state_app_wait",
                                                    "nsr_state_none",
                                                    "nsr_state_operational",
                                                    "nsr_state_prepare",
                                                    "nsr_state_ready",
                                                    "nsr_state_tcp_phase1",
                                                    "nsr_state_tcp_phase2",
                                                    "nsr_state_wait",
                                                    "total") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nsr_eligible.is_set or
                                        self.nsr_state_app_wait.is_set or
                                        self.nsr_state_none.is_set or
                                        self.nsr_state_operational.is_set or
                                        self.nsr_state_prepare.is_set or
                                        self.nsr_state_ready.is_set or
                                        self.nsr_state_tcp_phase1.is_set or
                                        self.nsr_state_tcp_phase2.is_set or
                                        self.nsr_state_wait.is_set or
                                        self.total.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nsr_eligible.yfilter != YFilter.not_set or
                                        self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                        self.nsr_state_none.yfilter != YFilter.not_set or
                                        self.nsr_state_operational.yfilter != YFilter.not_set or
                                        self.nsr_state_prepare.yfilter != YFilter.not_set or
                                        self.nsr_state_ready.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                        self.nsr_state_wait.yfilter != YFilter.not_set or
                                        self.total.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sessions" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                    if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                    if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                    if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                    if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                    if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                    if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                    if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nsr-eligible"):
                                        self.nsr_eligible = value
                                        self.nsr_eligible.value_namespace = name_space
                                        self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-app-wait"):
                                        self.nsr_state_app_wait = value
                                        self.nsr_state_app_wait.value_namespace = name_space
                                        self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-none"):
                                        self.nsr_state_none = value
                                        self.nsr_state_none.value_namespace = name_space
                                        self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-operational"):
                                        self.nsr_state_operational = value
                                        self.nsr_state_operational.value_namespace = name_space
                                        self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-prepare"):
                                        self.nsr_state_prepare = value
                                        self.nsr_state_prepare.value_namespace = name_space
                                        self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-ready"):
                                        self.nsr_state_ready = value
                                        self.nsr_state_ready.value_namespace = name_space
                                        self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase1"):
                                        self.nsr_state_tcp_phase1 = value
                                        self.nsr_state_tcp_phase1.value_namespace = name_space
                                        self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase2"):
                                        self.nsr_state_tcp_phase2 = value
                                        self.nsr_state_tcp_phase2.value_namespace = name_space
                                        self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-wait"):
                                        self.nsr_state_wait = value
                                        self.nsr_state_wait.value_namespace = name_space
                                        self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total"):
                                        self.total = value
                                        self.total.value_namespace = name_space
                                        self.total.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sessions is not None and self.sessions.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sessions is not None and self.sessions.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sessions"):
                                    if (self.sessions is None):
                                        self.sessions = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Sessions()
                                        self.sessions.parent = self
                                        self._children_name_map["sessions"] = "sessions"
                                    return self.sessions

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sessions" or name == "vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaStatistics(Entity):
                            """
                            LDP NSR Statistics related information
                            
                            .. attribute:: ha_global
                            
                            	LDP NSR Global Statistics information
                            	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal>`
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics, self).__init__()

                                self.yang_name = "ha-statistics"
                                self.yang_parent_name = "nsr"

                                self.ha_global = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal()
                                self.ha_global.parent = self
                                self._children_name_map["ha_global"] = "ha-global"
                                self._children_yang_names.add("ha-global")

                                self.ha_neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaGlobal(Entity):
                                """
                                LDP NSR Global Statistics information
                                
                                .. attribute:: init_sync
                                
                                	Init Sync
                                	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal, self).__init__()

                                    self.yang_name = "ha-global"
                                    self.yang_parent_name = "ha-statistics"

                                    self.init_sync = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                    self.init_sync.parent = self
                                    self._children_name_map["init_sync"] = "init-sync"
                                    self._children_yang_names.add("init-sync")


                                class InitSync(Entity):
                                    """
                                    Init Sync
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_default_mtu
                                    
                                    	default IPC MTU bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_exceeded_mtu_msg_cnt
                                    
                                    	ipc exceeded mtu msg cnt
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_max_rx_batch_bytes
                                    
                                    	biggest IPC RX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_max_tx_batch_bytes
                                    
                                    	biggest IPC TX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_rx_bytes
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_rx_cnt
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_tx_bytes
                                    
                                    	total IPC bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_tx_cnt
                                    
                                    	num IPC msgs sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_restart_cnt
                                    
                                    	number of times ipc has been restarted
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_tx_fail_cnt
                                    
                                    	number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_cfged
                                    
                                    	TRUE if NSR configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: nsr_synced
                                    
                                    	TRUE if NSR synced
                                    	**type**\:  bool
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Number of Rcvd Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Number of Sent Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of label bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl_adv
                                    
                                    	Num of lbl adv
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lcl_addr_wd
                                    
                                    	Num of lcl address withdraw
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_peers
                                    
                                    	Number of Peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_pfx
                                    
                                    	Number of binding prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_ipc_tx_fail_cnt
                                    
                                    	total number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__init__()

                                        self.yang_name = "init-sync"
                                        self.yang_parent_name = "ha-global"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                        self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                        self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                        self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                        self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                        self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                        self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                        self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                        self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                        self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                        self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                        self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                        self.num_peers = YLeaf(YType.uint32, "num-peers")

                                        self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                        self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "ipc_default_mtu",
                                                        "ipc_exceeded_mtu_msg_cnt",
                                                        "ipc_max_rx_batch_bytes",
                                                        "ipc_max_tx_batch_bytes",
                                                        "ipc_msg_rx_bytes",
                                                        "ipc_msg_rx_cnt",
                                                        "ipc_msg_tx_bytes",
                                                        "ipc_msg_tx_cnt",
                                                        "ipc_restart_cnt",
                                                        "ipc_tx_fail_cnt",
                                                        "nsr_cfged",
                                                        "nsr_synced",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_lbl",
                                                        "num_lbl_adv",
                                                        "num_lcl_addr_wd",
                                                        "num_peers",
                                                        "num_pfx",
                                                        "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.ipc_default_mtu.is_set or
                                            self.ipc_exceeded_mtu_msg_cnt.is_set or
                                            self.ipc_max_rx_batch_bytes.is_set or
                                            self.ipc_max_tx_batch_bytes.is_set or
                                            self.ipc_msg_rx_bytes.is_set or
                                            self.ipc_msg_rx_cnt.is_set or
                                            self.ipc_msg_tx_bytes.is_set or
                                            self.ipc_msg_tx_cnt.is_set or
                                            self.ipc_restart_cnt.is_set or
                                            self.ipc_tx_fail_cnt.is_set or
                                            self.nsr_cfged.is_set or
                                            self.nsr_synced.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_lbl.is_set or
                                            self.num_lbl_adv.is_set or
                                            self.num_lcl_addr_wd.is_set or
                                            self.num_peers.is_set or
                                            self.num_pfx.is_set or
                                            self.total_ipc_tx_fail_cnt.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.ipc_default_mtu.yfilter != YFilter.not_set or
                                            self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                            self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                            self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                            self.nsr_cfged.yfilter != YFilter.not_set or
                                            self.nsr_synced.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_lbl_adv.yfilter != YFilter.not_set or
                                            self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                            self.num_peers.yfilter != YFilter.not_set or
                                            self.num_pfx.yfilter != YFilter.not_set or
                                            self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                        if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                        if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                        if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                        if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                        if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                        if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                        if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                        if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_peers.get_name_leafdata())
                                        if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                        if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-default-mtu"):
                                            self.ipc_default_mtu = value
                                            self.ipc_default_mtu.value_namespace = name_space
                                            self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                            self.ipc_exceeded_mtu_msg_cnt = value
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-rx-batch-bytes"):
                                            self.ipc_max_rx_batch_bytes = value
                                            self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-tx-batch-bytes"):
                                            self.ipc_max_tx_batch_bytes = value
                                            self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-bytes"):
                                            self.ipc_msg_rx_bytes = value
                                            self.ipc_msg_rx_bytes.value_namespace = name_space
                                            self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-cnt"):
                                            self.ipc_msg_rx_cnt = value
                                            self.ipc_msg_rx_cnt.value_namespace = name_space
                                            self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-bytes"):
                                            self.ipc_msg_tx_bytes = value
                                            self.ipc_msg_tx_bytes.value_namespace = name_space
                                            self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-cnt"):
                                            self.ipc_msg_tx_cnt = value
                                            self.ipc_msg_tx_cnt.value_namespace = name_space
                                            self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-restart-cnt"):
                                            self.ipc_restart_cnt = value
                                            self.ipc_restart_cnt.value_namespace = name_space
                                            self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-tx-fail-cnt"):
                                            self.ipc_tx_fail_cnt = value
                                            self.ipc_tx_fail_cnt.value_namespace = name_space
                                            self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-cfged"):
                                            self.nsr_cfged = value
                                            self.nsr_cfged.value_namespace = name_space
                                            self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-synced"):
                                            self.nsr_synced = value
                                            self.nsr_synced.value_namespace = name_space
                                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl-adv"):
                                            self.num_lbl_adv = value
                                            self.num_lbl_adv.value_namespace = name_space
                                            self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lcl-addr-wd"):
                                            self.num_lcl_addr_wd = value
                                            self.num_lcl_addr_wd.value_namespace = name_space
                                            self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-peers"):
                                            self.num_peers = value
                                            self.num_peers.value_namespace = name_space
                                            self.num_peers.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-pfx"):
                                            self.num_pfx = value
                                            self.num_pfx.value_namespace = name_space
                                            self.num_pfx.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-ipc-tx-fail-cnt"):
                                            self.total_ipc_tx_fail_cnt = value
                                            self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                            self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.init_sync is not None and self.init_sync.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.init_sync is not None and self.init_sync.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync"):
                                        if (self.init_sync is None):
                                            self.init_sync = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                            self.init_sync.parent = self
                                            self._children_name_map["init_sync"] = "init-sync"
                                        return self.init_sync

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "ha-statistics"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.ha_global is not None and self.ha_global.has_data()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_global is not None and self.ha_global.has_operation()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-global"):
                                    if (self.ha_global is None):
                                        self.ha_global = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal()
                                        self.ha_global.parent = self
                                        self._children_name_map["ha_global"] = "ha-global"
                                    return self.ha_global

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-global" or name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                                (self.ha_summary is not None and self.ha_summary.has_data()) or
                                (self.nsr_pending is not None and self.nsr_pending.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                                (self.ha_summary is not None and self.ha_summary.has_operation()) or
                                (self.nsr_pending is not None and self.nsr_pending.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-statistics"):
                                if (self.ha_statistics is None):
                                    self.ha_statistics = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaStatistics()
                                    self.ha_statistics.parent = self
                                    self._children_name_map["ha_statistics"] = "ha-statistics"
                                return self.ha_statistics

                            if (child_yang_name == "ha-summary"):
                                if (self.ha_summary is None):
                                    self.ha_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.HaSummary()
                                    self.ha_summary.parent = self
                                    self._children_name_map["ha_summary"] = "ha-summary"
                                return self.ha_summary

                            if (child_yang_name == "nsr-pending"):
                                if (self.nsr_pending is None):
                                    self.nsr_pending = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr.NsrPending()
                                    self.nsr_pending.parent = self
                                    self._children_name_map["nsr_pending"] = "nsr-pending"
                                return self.nsr_pending

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-statistics" or name == "ha-summary" or name == "nsr-pending"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Parameters(Entity):
                        """
                        LDP parameters
                        
                        .. attribute:: address_family_parameter
                        
                        	Per AF parameters
                        	**type**\: list of    :py:class:`AddressFamilyParameter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter>`
                        
                        .. attribute:: af_binding_withdraw_delay
                        
                        	Delay (sec) in Binding Withdrawal for an Address Family
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: discovery_quick_start_disabled_on_interfaces
                        
                        	Discovery quick\-start disabled on some LDP\-enabled interfaces
                        	**type**\:  bool
                        
                        .. attribute:: global_discovery_quick_start_disabled
                        
                        	Discovery quick\-start globally disabled
                        	**type**\:  bool
                        
                        .. attribute:: global_md5_password_enabled
                        
                        	Global MD5 password enabled
                        	**type**\:  bool
                        
                        .. attribute:: graceful_restart_information
                        
                        	Graceful restart information
                        	**type**\:   :py:class:`GracefulRestartInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.GracefulRestartInformation>`
                        
                        .. attribute:: hello_hold_time
                        
                        	Hello hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hello_interval
                        
                        	Hello interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: housekeeping_timer_interval
                        
                        	Housekeeping periodic timer interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: igp_sync_delay_time_for_interface
                        
                        	Interface IGP sync delay time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: igp_sync_delay_time_on_restart
                        
                        	IGP sync delay time on process restart in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: keepalive_interval
                        
                        	Keepalive interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ldp_out_of_mem_state
                        
                        	LDP Out of memory state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ldp_recovery_timeout
                        
                        	LDP recovery timeout with LSD
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: le_no_route_timeout
                        
                        	LIB entry no route timeout
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_intf_attached
                        
                        	Maximum number of LDP enabled attached interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_intf_te
                        
                        	Maximum number of LDP enabled TE interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_peer
                        
                        	Maximum number of LDP peers
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nsr_enabled
                        
                        	TRUE if NSR is enabled
                        	**type**\:  bool
                        
                        .. attribute:: nsr_synced
                        
                        	TRUE if LDP is standby and is NSR Sync\-ed with active
                        	**type**\:  bool
                        
                        .. attribute:: protocol_version
                        
                        	Protocol version
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: role_is_active
                        
                        	Is process role active or standby
                        	**type**\:  bool
                        
                        .. attribute:: router_id
                        
                        	Router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: session_hold_time
                        
                        	Session hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: targeted_hello_hold_time
                        
                        	Targeted hello hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: targeted_hello_interval
                        
                        	Targeted hello interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters, self).__init__()

                            self.yang_name = "parameters"
                            self.yang_parent_name = "vrf"

                            self.af_binding_withdraw_delay = YLeaf(YType.uint32, "af-binding-withdraw-delay")

                            self.discovery_quick_start_disabled_on_interfaces = YLeaf(YType.boolean, "discovery-quick-start-disabled-on-interfaces")

                            self.global_discovery_quick_start_disabled = YLeaf(YType.boolean, "global-discovery-quick-start-disabled")

                            self.global_md5_password_enabled = YLeaf(YType.boolean, "global-md5-password-enabled")

                            self.hello_hold_time = YLeaf(YType.uint32, "hello-hold-time")

                            self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                            self.housekeeping_timer_interval = YLeaf(YType.uint32, "housekeeping-timer-interval")

                            self.igp_sync_delay_time_for_interface = YLeaf(YType.uint32, "igp-sync-delay-time-for-interface")

                            self.igp_sync_delay_time_on_restart = YLeaf(YType.uint32, "igp-sync-delay-time-on-restart")

                            self.keepalive_interval = YLeaf(YType.uint32, "keepalive-interval")

                            self.ldp_out_of_mem_state = YLeaf(YType.uint32, "ldp-out-of-mem-state")

                            self.ldp_recovery_timeout = YLeaf(YType.uint32, "ldp-recovery-timeout")

                            self.le_no_route_timeout = YLeaf(YType.uint32, "le-no-route-timeout")

                            self.max_intf_attached = YLeaf(YType.uint32, "max-intf-attached")

                            self.max_intf_te = YLeaf(YType.uint32, "max-intf-te")

                            self.max_peer = YLeaf(YType.uint32, "max-peer")

                            self.nsr_enabled = YLeaf(YType.boolean, "nsr-enabled")

                            self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                            self.protocol_version = YLeaf(YType.uint32, "protocol-version")

                            self.role_is_active = YLeaf(YType.boolean, "role-is-active")

                            self.router_id = YLeaf(YType.str, "router-id")

                            self.session_hold_time = YLeaf(YType.uint32, "session-hold-time")

                            self.targeted_hello_hold_time = YLeaf(YType.uint32, "targeted-hello-hold-time")

                            self.targeted_hello_interval = YLeaf(YType.uint32, "targeted-hello-interval")

                            self.graceful_restart_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.GracefulRestartInformation()
                            self.graceful_restart_information.parent = self
                            self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                            self._children_yang_names.add("graceful-restart-information")

                            self.address_family_parameter = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("af_binding_withdraw_delay",
                                            "discovery_quick_start_disabled_on_interfaces",
                                            "global_discovery_quick_start_disabled",
                                            "global_md5_password_enabled",
                                            "hello_hold_time",
                                            "hello_interval",
                                            "housekeeping_timer_interval",
                                            "igp_sync_delay_time_for_interface",
                                            "igp_sync_delay_time_on_restart",
                                            "keepalive_interval",
                                            "ldp_out_of_mem_state",
                                            "ldp_recovery_timeout",
                                            "le_no_route_timeout",
                                            "max_intf_attached",
                                            "max_intf_te",
                                            "max_peer",
                                            "nsr_enabled",
                                            "nsr_synced",
                                            "protocol_version",
                                            "role_is_active",
                                            "router_id",
                                            "session_hold_time",
                                            "targeted_hello_hold_time",
                                            "targeted_hello_interval") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters, self).__setattr__(name, value)


                        class GracefulRestartInformation(Entity):
                            """
                            Graceful restart information
                            
                            .. attribute:: graceful_restart_forwarding_state_hold_time
                            
                            	Graceful restart forward state hold time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: graceful_restart_reconnect_timeout
                            
                            	Reconnect timeout value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_graceful_restart_configured
                            
                            	Is graceful restart configured
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__init__()

                                self.yang_name = "graceful-restart-information"
                                self.yang_parent_name = "parameters"

                                self.graceful_restart_forwarding_state_hold_time = YLeaf(YType.uint32, "graceful-restart-forwarding-state-hold-time")

                                self.graceful_restart_reconnect_timeout = YLeaf(YType.uint32, "graceful-restart-reconnect-timeout")

                                self.is_graceful_restart_configured = YLeaf(YType.boolean, "is-graceful-restart-configured")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("graceful_restart_forwarding_state_hold_time",
                                                "graceful_restart_reconnect_timeout",
                                                "is_graceful_restart_configured") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.graceful_restart_forwarding_state_hold_time.is_set or
                                    self.graceful_restart_reconnect_timeout.is_set or
                                    self.is_graceful_restart_configured.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set or
                                    self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set or
                                    self.is_graceful_restart_configured.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "graceful-restart-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.graceful_restart_forwarding_state_hold_time.is_set or self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.graceful_restart_forwarding_state_hold_time.get_name_leafdata())
                                if (self.graceful_restart_reconnect_timeout.is_set or self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.graceful_restart_reconnect_timeout.get_name_leafdata())
                                if (self.is_graceful_restart_configured.is_set or self.is_graceful_restart_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_graceful_restart_configured.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "graceful-restart-forwarding-state-hold-time" or name == "graceful-restart-reconnect-timeout" or name == "is-graceful-restart-configured"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "graceful-restart-forwarding-state-hold-time"):
                                    self.graceful_restart_forwarding_state_hold_time = value
                                    self.graceful_restart_forwarding_state_hold_time.value_namespace = name_space
                                    self.graceful_restart_forwarding_state_hold_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "graceful-restart-reconnect-timeout"):
                                    self.graceful_restart_reconnect_timeout = value
                                    self.graceful_restart_reconnect_timeout.value_namespace = name_space
                                    self.graceful_restart_reconnect_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-graceful-restart-configured"):
                                    self.is_graceful_restart_configured = value
                                    self.is_graceful_restart_configured.value_namespace = name_space
                                    self.is_graceful_restart_configured.value_namespace_prefix = name_space_prefix


                        class AddressFamilyParameter(Entity):
                            """
                            Per AF parameters
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: discovery_transport_address
                            
                            	Discovery transport address
                            	**type**\:   :py:class:`DiscoveryTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress>`
                            
                            .. attribute:: is_accepting_targeted_hellos
                            
                            	Accepting targeted Hellos
                            	**type**\:  bool
                            
                            .. attribute:: label_imp_null_override_acl
                            
                            	ACL to override local label to use implicit\-null
                            	**type**\:  str
                            
                            .. attribute:: null_label
                            
                            	Null label
                            	**type**\:  str
                            
                            .. attribute:: targeted_hello_acl
                            
                            	Targeted Hello ACL
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__init__()

                                self.yang_name = "address-family-parameter"
                                self.yang_parent_name = "parameters"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.is_accepting_targeted_hellos = YLeaf(YType.boolean, "is-accepting-targeted-hellos")

                                self.label_imp_null_override_acl = YLeaf(YType.str, "label-imp-null-override-acl")

                                self.null_label = YLeaf(YType.str, "null-label")

                                self.targeted_hello_acl = YLeaf(YType.str, "targeted-hello-acl")

                                self.discovery_transport_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                self.discovery_transport_address.parent = self
                                self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                self._children_yang_names.add("discovery-transport-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "is_accepting_targeted_hellos",
                                                "label_imp_null_override_acl",
                                                "null_label",
                                                "targeted_hello_acl") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)


                            class DiscoveryTransportAddress(Entity):
                                """
                                Discovery transport address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__init__()

                                    self.yang_name = "discovery-transport-address"
                                    self.yang_parent_name = "address-family-parameter"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovery-transport-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.is_accepting_targeted_hellos.is_set or
                                    self.label_imp_null_override_acl.is_set or
                                    self.null_label.is_set or
                                    self.targeted_hello_acl.is_set or
                                    (self.discovery_transport_address is not None and self.discovery_transport_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.is_accepting_targeted_hellos.yfilter != YFilter.not_set or
                                    self.label_imp_null_override_acl.yfilter != YFilter.not_set or
                                    self.null_label.yfilter != YFilter.not_set or
                                    self.targeted_hello_acl.yfilter != YFilter.not_set or
                                    (self.discovery_transport_address is not None and self.discovery_transport_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "address-family-parameter" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.is_accepting_targeted_hellos.is_set or self.is_accepting_targeted_hellos.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_accepting_targeted_hellos.get_name_leafdata())
                                if (self.label_imp_null_override_acl.is_set or self.label_imp_null_override_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_imp_null_override_acl.get_name_leafdata())
                                if (self.null_label.is_set or self.null_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.null_label.get_name_leafdata())
                                if (self.targeted_hello_acl.is_set or self.targeted_hello_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.targeted_hello_acl.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovery-transport-address"):
                                    if (self.discovery_transport_address is None):
                                        self.discovery_transport_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                        self.discovery_transport_address.parent = self
                                        self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                    return self.discovery_transport_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovery-transport-address" or name == "address-family" or name == "is-accepting-targeted-hellos" or name == "label-imp-null-override-acl" or name == "null-label" or name == "targeted-hello-acl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-accepting-targeted-hellos"):
                                    self.is_accepting_targeted_hellos = value
                                    self.is_accepting_targeted_hellos.value_namespace = name_space
                                    self.is_accepting_targeted_hellos.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-imp-null-override-acl"):
                                    self.label_imp_null_override_acl = value
                                    self.label_imp_null_override_acl.value_namespace = name_space
                                    self.label_imp_null_override_acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "null-label"):
                                    self.null_label = value
                                    self.null_label.value_namespace = name_space
                                    self.null_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "targeted-hello-acl"):
                                    self.targeted_hello_acl = value
                                    self.targeted_hello_acl.value_namespace = name_space
                                    self.targeted_hello_acl.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.address_family_parameter:
                                if (c.has_data()):
                                    return True
                            return (
                                self.af_binding_withdraw_delay.is_set or
                                self.discovery_quick_start_disabled_on_interfaces.is_set or
                                self.global_discovery_quick_start_disabled.is_set or
                                self.global_md5_password_enabled.is_set or
                                self.hello_hold_time.is_set or
                                self.hello_interval.is_set or
                                self.housekeeping_timer_interval.is_set or
                                self.igp_sync_delay_time_for_interface.is_set or
                                self.igp_sync_delay_time_on_restart.is_set or
                                self.keepalive_interval.is_set or
                                self.ldp_out_of_mem_state.is_set or
                                self.ldp_recovery_timeout.is_set or
                                self.le_no_route_timeout.is_set or
                                self.max_intf_attached.is_set or
                                self.max_intf_te.is_set or
                                self.max_peer.is_set or
                                self.nsr_enabled.is_set or
                                self.nsr_synced.is_set or
                                self.protocol_version.is_set or
                                self.role_is_active.is_set or
                                self.router_id.is_set or
                                self.session_hold_time.is_set or
                                self.targeted_hello_hold_time.is_set or
                                self.targeted_hello_interval.is_set or
                                (self.graceful_restart_information is not None and self.graceful_restart_information.has_data()))

                        def has_operation(self):
                            for c in self.address_family_parameter:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.af_binding_withdraw_delay.yfilter != YFilter.not_set or
                                self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set or
                                self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set or
                                self.global_md5_password_enabled.yfilter != YFilter.not_set or
                                self.hello_hold_time.yfilter != YFilter.not_set or
                                self.hello_interval.yfilter != YFilter.not_set or
                                self.housekeeping_timer_interval.yfilter != YFilter.not_set or
                                self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set or
                                self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set or
                                self.keepalive_interval.yfilter != YFilter.not_set or
                                self.ldp_out_of_mem_state.yfilter != YFilter.not_set or
                                self.ldp_recovery_timeout.yfilter != YFilter.not_set or
                                self.le_no_route_timeout.yfilter != YFilter.not_set or
                                self.max_intf_attached.yfilter != YFilter.not_set or
                                self.max_intf_te.yfilter != YFilter.not_set or
                                self.max_peer.yfilter != YFilter.not_set or
                                self.nsr_enabled.yfilter != YFilter.not_set or
                                self.nsr_synced.yfilter != YFilter.not_set or
                                self.protocol_version.yfilter != YFilter.not_set or
                                self.role_is_active.yfilter != YFilter.not_set or
                                self.router_id.yfilter != YFilter.not_set or
                                self.session_hold_time.yfilter != YFilter.not_set or
                                self.targeted_hello_hold_time.yfilter != YFilter.not_set or
                                self.targeted_hello_interval.yfilter != YFilter.not_set or
                                (self.graceful_restart_information is not None and self.graceful_restart_information.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "parameters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.af_binding_withdraw_delay.is_set or self.af_binding_withdraw_delay.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.af_binding_withdraw_delay.get_name_leafdata())
                            if (self.discovery_quick_start_disabled_on_interfaces.is_set or self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.discovery_quick_start_disabled_on_interfaces.get_name_leafdata())
                            if (self.global_discovery_quick_start_disabled.is_set or self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_discovery_quick_start_disabled.get_name_leafdata())
                            if (self.global_md5_password_enabled.is_set or self.global_md5_password_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_md5_password_enabled.get_name_leafdata())
                            if (self.hello_hold_time.is_set or self.hello_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_hold_time.get_name_leafdata())
                            if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_interval.get_name_leafdata())
                            if (self.housekeeping_timer_interval.is_set or self.housekeeping_timer_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.housekeeping_timer_interval.get_name_leafdata())
                            if (self.igp_sync_delay_time_for_interface.is_set or self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_sync_delay_time_for_interface.get_name_leafdata())
                            if (self.igp_sync_delay_time_on_restart.is_set or self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_sync_delay_time_on_restart.get_name_leafdata())
                            if (self.keepalive_interval.is_set or self.keepalive_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.keepalive_interval.get_name_leafdata())
                            if (self.ldp_out_of_mem_state.is_set or self.ldp_out_of_mem_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_out_of_mem_state.get_name_leafdata())
                            if (self.ldp_recovery_timeout.is_set or self.ldp_recovery_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_recovery_timeout.get_name_leafdata())
                            if (self.le_no_route_timeout.is_set or self.le_no_route_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.le_no_route_timeout.get_name_leafdata())
                            if (self.max_intf_attached.is_set or self.max_intf_attached.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_intf_attached.get_name_leafdata())
                            if (self.max_intf_te.is_set or self.max_intf_te.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_intf_te.get_name_leafdata())
                            if (self.max_peer.is_set or self.max_peer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_peer.get_name_leafdata())
                            if (self.nsr_enabled.is_set or self.nsr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_enabled.get_name_leafdata())
                            if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                            if (self.protocol_version.is_set or self.protocol_version.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_version.get_name_leafdata())
                            if (self.role_is_active.is_set or self.role_is_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role_is_active.get_name_leafdata())
                            if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.router_id.get_name_leafdata())
                            if (self.session_hold_time.is_set or self.session_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_hold_time.get_name_leafdata())
                            if (self.targeted_hello_hold_time.is_set or self.targeted_hello_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_hold_time.get_name_leafdata())
                            if (self.targeted_hello_interval.is_set or self.targeted_hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_interval.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "address-family-parameter"):
                                for c in self.address_family_parameter:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.AddressFamilyParameter()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.address_family_parameter.append(c)
                                return c

                            if (child_yang_name == "graceful-restart-information"):
                                if (self.graceful_restart_information is None):
                                    self.graceful_restart_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters.GracefulRestartInformation()
                                    self.graceful_restart_information.parent = self
                                    self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                                return self.graceful_restart_information

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "address-family-parameter" or name == "graceful-restart-information" or name == "af-binding-withdraw-delay" or name == "discovery-quick-start-disabled-on-interfaces" or name == "global-discovery-quick-start-disabled" or name == "global-md5-password-enabled" or name == "hello-hold-time" or name == "hello-interval" or name == "housekeeping-timer-interval" or name == "igp-sync-delay-time-for-interface" or name == "igp-sync-delay-time-on-restart" or name == "keepalive-interval" or name == "ldp-out-of-mem-state" or name == "ldp-recovery-timeout" or name == "le-no-route-timeout" or name == "max-intf-attached" or name == "max-intf-te" or name == "max-peer" or name == "nsr-enabled" or name == "nsr-synced" or name == "protocol-version" or name == "role-is-active" or name == "router-id" or name == "session-hold-time" or name == "targeted-hello-hold-time" or name == "targeted-hello-interval"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "af-binding-withdraw-delay"):
                                self.af_binding_withdraw_delay = value
                                self.af_binding_withdraw_delay.value_namespace = name_space
                                self.af_binding_withdraw_delay.value_namespace_prefix = name_space_prefix
                            if(value_path == "discovery-quick-start-disabled-on-interfaces"):
                                self.discovery_quick_start_disabled_on_interfaces = value
                                self.discovery_quick_start_disabled_on_interfaces.value_namespace = name_space
                                self.discovery_quick_start_disabled_on_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "global-discovery-quick-start-disabled"):
                                self.global_discovery_quick_start_disabled = value
                                self.global_discovery_quick_start_disabled.value_namespace = name_space
                                self.global_discovery_quick_start_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "global-md5-password-enabled"):
                                self.global_md5_password_enabled = value
                                self.global_md5_password_enabled.value_namespace = name_space
                                self.global_md5_password_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-hold-time"):
                                self.hello_hold_time = value
                                self.hello_hold_time.value_namespace = name_space
                                self.hello_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-interval"):
                                self.hello_interval = value
                                self.hello_interval.value_namespace = name_space
                                self.hello_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "housekeeping-timer-interval"):
                                self.housekeeping_timer_interval = value
                                self.housekeeping_timer_interval.value_namespace = name_space
                                self.housekeeping_timer_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-sync-delay-time-for-interface"):
                                self.igp_sync_delay_time_for_interface = value
                                self.igp_sync_delay_time_for_interface.value_namespace = name_space
                                self.igp_sync_delay_time_for_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-sync-delay-time-on-restart"):
                                self.igp_sync_delay_time_on_restart = value
                                self.igp_sync_delay_time_on_restart.value_namespace = name_space
                                self.igp_sync_delay_time_on_restart.value_namespace_prefix = name_space_prefix
                            if(value_path == "keepalive-interval"):
                                self.keepalive_interval = value
                                self.keepalive_interval.value_namespace = name_space
                                self.keepalive_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-out-of-mem-state"):
                                self.ldp_out_of_mem_state = value
                                self.ldp_out_of_mem_state.value_namespace = name_space
                                self.ldp_out_of_mem_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-recovery-timeout"):
                                self.ldp_recovery_timeout = value
                                self.ldp_recovery_timeout.value_namespace = name_space
                                self.ldp_recovery_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "le-no-route-timeout"):
                                self.le_no_route_timeout = value
                                self.le_no_route_timeout.value_namespace = name_space
                                self.le_no_route_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-intf-attached"):
                                self.max_intf_attached = value
                                self.max_intf_attached.value_namespace = name_space
                                self.max_intf_attached.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-intf-te"):
                                self.max_intf_te = value
                                self.max_intf_te.value_namespace = name_space
                                self.max_intf_te.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-peer"):
                                self.max_peer = value
                                self.max_peer.value_namespace = name_space
                                self.max_peer.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-enabled"):
                                self.nsr_enabled = value
                                self.nsr_enabled.value_namespace = name_space
                                self.nsr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-synced"):
                                self.nsr_synced = value
                                self.nsr_synced.value_namespace = name_space
                                self.nsr_synced.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-version"):
                                self.protocol_version = value
                                self.protocol_version.value_namespace = name_space
                                self.protocol_version.value_namespace_prefix = name_space_prefix
                            if(value_path == "role-is-active"):
                                self.role_is_active = value
                                self.role_is_active.value_namespace = name_space
                                self.role_is_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "router-id"):
                                self.router_id = value
                                self.router_id.value_namespace = name_space
                                self.router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-hold-time"):
                                self.session_hold_time = value
                                self.session_hold_time.value_namespace = name_space
                                self.session_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-hold-time"):
                                self.targeted_hello_hold_time = value
                                self.targeted_hello_hold_time.value_namespace = name_space
                                self.targeted_hello_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-interval"):
                                self.targeted_hello_interval = value
                                self.targeted_hello_interval.value_namespace = name_space
                                self.targeted_hello_interval.value_namespace_prefix = name_space_prefix


                    class Issu(Entity):
                        """
                        LDP ISSU related information
                        
                        .. attribute:: ha_statistics
                        
                        	LDP NSR Statistics related information
                        	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics>`
                        
                        .. attribute:: ha_summary
                        
                        	LDP HA Summary
                        	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu, self).__init__()

                            self.yang_name = "issu"
                            self.yang_parent_name = "vrf"

                            self.ha_statistics = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics()
                            self.ha_statistics.parent = self
                            self._children_name_map["ha_statistics"] = "ha-statistics"
                            self._children_yang_names.add("ha-statistics")

                            self.ha_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary()
                            self.ha_summary.parent = self
                            self._children_name_map["ha_summary"] = "ha-summary"
                            self._children_yang_names.add("ha-summary")


                        class HaSummary(Entity):
                            """
                            LDP HA Summary
                            
                            .. attribute:: sessions
                            
                            	Session summary
                            	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Sessions>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary, self).__init__()

                                self.yang_name = "ha-summary"
                                self.yang_parent_name = "issu"

                                self.sessions = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Sessions()
                                self.sessions.parent = self
                                self._children_name_map["sessions"] = "sessions"
                                self._children_yang_names.add("sessions")

                                self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "ha-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Sessions(Entity):
                                """
                                Session summary
                                
                                .. attribute:: nsr_eligible
                                
                                	NSR eligible sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_app_wait
                                
                                	Number of sessions in NSR app\-wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_none
                                
                                	Number of sessions in NSR none state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_operational
                                
                                	Number of sessions in NSR operational state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_prepare
                                
                                	Number of sessions in NSR prepare state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_ready
                                
                                	Number of sessions in NSR ready state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase1
                                
                                	Number of sessions in NSR TCP phase 1 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase2
                                
                                	Number of sessions in NSR TCP phase 2 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_wait
                                
                                	Number of sessions in NSR wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total
                                
                                	Total sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__init__()

                                    self.yang_name = "sessions"
                                    self.yang_parent_name = "ha-summary"

                                    self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                    self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                    self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                    self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                    self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                    self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                    self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                    self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                    self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                    self.total = YLeaf(YType.uint32, "total")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nsr_eligible",
                                                    "nsr_state_app_wait",
                                                    "nsr_state_none",
                                                    "nsr_state_operational",
                                                    "nsr_state_prepare",
                                                    "nsr_state_ready",
                                                    "nsr_state_tcp_phase1",
                                                    "nsr_state_tcp_phase2",
                                                    "nsr_state_wait",
                                                    "total") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nsr_eligible.is_set or
                                        self.nsr_state_app_wait.is_set or
                                        self.nsr_state_none.is_set or
                                        self.nsr_state_operational.is_set or
                                        self.nsr_state_prepare.is_set or
                                        self.nsr_state_ready.is_set or
                                        self.nsr_state_tcp_phase1.is_set or
                                        self.nsr_state_tcp_phase2.is_set or
                                        self.nsr_state_wait.is_set or
                                        self.total.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nsr_eligible.yfilter != YFilter.not_set or
                                        self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                        self.nsr_state_none.yfilter != YFilter.not_set or
                                        self.nsr_state_operational.yfilter != YFilter.not_set or
                                        self.nsr_state_prepare.yfilter != YFilter.not_set or
                                        self.nsr_state_ready.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                        self.nsr_state_wait.yfilter != YFilter.not_set or
                                        self.total.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sessions" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                    if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                    if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                    if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                    if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                    if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                    if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                    if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nsr-eligible"):
                                        self.nsr_eligible = value
                                        self.nsr_eligible.value_namespace = name_space
                                        self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-app-wait"):
                                        self.nsr_state_app_wait = value
                                        self.nsr_state_app_wait.value_namespace = name_space
                                        self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-none"):
                                        self.nsr_state_none = value
                                        self.nsr_state_none.value_namespace = name_space
                                        self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-operational"):
                                        self.nsr_state_operational = value
                                        self.nsr_state_operational.value_namespace = name_space
                                        self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-prepare"):
                                        self.nsr_state_prepare = value
                                        self.nsr_state_prepare.value_namespace = name_space
                                        self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-ready"):
                                        self.nsr_state_ready = value
                                        self.nsr_state_ready.value_namespace = name_space
                                        self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase1"):
                                        self.nsr_state_tcp_phase1 = value
                                        self.nsr_state_tcp_phase1.value_namespace = name_space
                                        self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase2"):
                                        self.nsr_state_tcp_phase2 = value
                                        self.nsr_state_tcp_phase2.value_namespace = name_space
                                        self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-wait"):
                                        self.nsr_state_wait = value
                                        self.nsr_state_wait.value_namespace = name_space
                                        self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total"):
                                        self.total = value
                                        self.total.value_namespace = name_space
                                        self.total.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sessions is not None and self.sessions.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sessions is not None and self.sessions.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sessions"):
                                    if (self.sessions is None):
                                        self.sessions = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Sessions()
                                        self.sessions.parent = self
                                        self._children_name_map["sessions"] = "sessions"
                                    return self.sessions

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sessions" or name == "vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaStatistics(Entity):
                            """
                            LDP NSR Statistics related information
                            
                            .. attribute:: ha_global
                            
                            	LDP NSR Global Statistics information
                            	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal>`
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics, self).__init__()

                                self.yang_name = "ha-statistics"
                                self.yang_parent_name = "issu"

                                self.ha_global = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal()
                                self.ha_global.parent = self
                                self._children_name_map["ha_global"] = "ha-global"
                                self._children_yang_names.add("ha-global")

                                self.ha_neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaGlobal(Entity):
                                """
                                LDP NSR Global Statistics information
                                
                                .. attribute:: init_sync
                                
                                	Init Sync
                                	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal, self).__init__()

                                    self.yang_name = "ha-global"
                                    self.yang_parent_name = "ha-statistics"

                                    self.init_sync = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync()
                                    self.init_sync.parent = self
                                    self._children_name_map["init_sync"] = "init-sync"
                                    self._children_yang_names.add("init-sync")


                                class InitSync(Entity):
                                    """
                                    Init Sync
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_default_mtu
                                    
                                    	default IPC MTU bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_exceeded_mtu_msg_cnt
                                    
                                    	ipc exceeded mtu msg cnt
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_max_rx_batch_bytes
                                    
                                    	biggest IPC RX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_max_tx_batch_bytes
                                    
                                    	biggest IPC TX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_rx_bytes
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_rx_cnt
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_tx_bytes
                                    
                                    	total IPC bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_tx_cnt
                                    
                                    	num IPC msgs sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_restart_cnt
                                    
                                    	number of times ipc has been restarted
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_tx_fail_cnt
                                    
                                    	number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_cfged
                                    
                                    	TRUE if NSR configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: nsr_synced
                                    
                                    	TRUE if NSR synced
                                    	**type**\:  bool
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Number of Rcvd Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Number of Sent Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of label bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl_adv
                                    
                                    	Num of lbl adv
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lcl_addr_wd
                                    
                                    	Num of lcl address withdraw
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_peers
                                    
                                    	Number of Peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_pfx
                                    
                                    	Number of binding prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_ipc_tx_fail_cnt
                                    
                                    	total number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__init__()

                                        self.yang_name = "init-sync"
                                        self.yang_parent_name = "ha-global"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                        self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                        self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                        self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                        self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                        self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                        self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                        self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                        self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                        self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                        self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                        self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                        self.num_peers = YLeaf(YType.uint32, "num-peers")

                                        self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                        self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "ipc_default_mtu",
                                                        "ipc_exceeded_mtu_msg_cnt",
                                                        "ipc_max_rx_batch_bytes",
                                                        "ipc_max_tx_batch_bytes",
                                                        "ipc_msg_rx_bytes",
                                                        "ipc_msg_rx_cnt",
                                                        "ipc_msg_tx_bytes",
                                                        "ipc_msg_tx_cnt",
                                                        "ipc_restart_cnt",
                                                        "ipc_tx_fail_cnt",
                                                        "nsr_cfged",
                                                        "nsr_synced",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_lbl",
                                                        "num_lbl_adv",
                                                        "num_lcl_addr_wd",
                                                        "num_peers",
                                                        "num_pfx",
                                                        "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.ipc_default_mtu.is_set or
                                            self.ipc_exceeded_mtu_msg_cnt.is_set or
                                            self.ipc_max_rx_batch_bytes.is_set or
                                            self.ipc_max_tx_batch_bytes.is_set or
                                            self.ipc_msg_rx_bytes.is_set or
                                            self.ipc_msg_rx_cnt.is_set or
                                            self.ipc_msg_tx_bytes.is_set or
                                            self.ipc_msg_tx_cnt.is_set or
                                            self.ipc_restart_cnt.is_set or
                                            self.ipc_tx_fail_cnt.is_set or
                                            self.nsr_cfged.is_set or
                                            self.nsr_synced.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_lbl.is_set or
                                            self.num_lbl_adv.is_set or
                                            self.num_lcl_addr_wd.is_set or
                                            self.num_peers.is_set or
                                            self.num_pfx.is_set or
                                            self.total_ipc_tx_fail_cnt.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.ipc_default_mtu.yfilter != YFilter.not_set or
                                            self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                            self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                            self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                            self.nsr_cfged.yfilter != YFilter.not_set or
                                            self.nsr_synced.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_lbl_adv.yfilter != YFilter.not_set or
                                            self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                            self.num_peers.yfilter != YFilter.not_set or
                                            self.num_pfx.yfilter != YFilter.not_set or
                                            self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                        if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                        if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                        if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                        if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                        if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                        if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                        if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                        if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_peers.get_name_leafdata())
                                        if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                        if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-default-mtu"):
                                            self.ipc_default_mtu = value
                                            self.ipc_default_mtu.value_namespace = name_space
                                            self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                            self.ipc_exceeded_mtu_msg_cnt = value
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-rx-batch-bytes"):
                                            self.ipc_max_rx_batch_bytes = value
                                            self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-tx-batch-bytes"):
                                            self.ipc_max_tx_batch_bytes = value
                                            self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-bytes"):
                                            self.ipc_msg_rx_bytes = value
                                            self.ipc_msg_rx_bytes.value_namespace = name_space
                                            self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-cnt"):
                                            self.ipc_msg_rx_cnt = value
                                            self.ipc_msg_rx_cnt.value_namespace = name_space
                                            self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-bytes"):
                                            self.ipc_msg_tx_bytes = value
                                            self.ipc_msg_tx_bytes.value_namespace = name_space
                                            self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-cnt"):
                                            self.ipc_msg_tx_cnt = value
                                            self.ipc_msg_tx_cnt.value_namespace = name_space
                                            self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-restart-cnt"):
                                            self.ipc_restart_cnt = value
                                            self.ipc_restart_cnt.value_namespace = name_space
                                            self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-tx-fail-cnt"):
                                            self.ipc_tx_fail_cnt = value
                                            self.ipc_tx_fail_cnt.value_namespace = name_space
                                            self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-cfged"):
                                            self.nsr_cfged = value
                                            self.nsr_cfged.value_namespace = name_space
                                            self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-synced"):
                                            self.nsr_synced = value
                                            self.nsr_synced.value_namespace = name_space
                                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl-adv"):
                                            self.num_lbl_adv = value
                                            self.num_lbl_adv.value_namespace = name_space
                                            self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lcl-addr-wd"):
                                            self.num_lcl_addr_wd = value
                                            self.num_lcl_addr_wd.value_namespace = name_space
                                            self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-peers"):
                                            self.num_peers = value
                                            self.num_peers.value_namespace = name_space
                                            self.num_peers.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-pfx"):
                                            self.num_pfx = value
                                            self.num_pfx.value_namespace = name_space
                                            self.num_pfx.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-ipc-tx-fail-cnt"):
                                            self.total_ipc_tx_fail_cnt = value
                                            self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                            self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.init_sync is not None and self.init_sync.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.init_sync is not None and self.init_sync.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync"):
                                        if (self.init_sync is None):
                                            self.init_sync = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync()
                                            self.init_sync.parent = self
                                            self._children_name_map["init_sync"] = "init-sync"
                                        return self.init_sync

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "ha-statistics"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.ha_global is not None and self.ha_global.has_data()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_global is not None and self.ha_global.has_operation()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-global"):
                                    if (self.ha_global is None):
                                        self.ha_global = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaGlobal()
                                        self.ha_global.parent = self
                                        self._children_name_map["ha_global"] = "ha-global"
                                    return self.ha_global

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-global" or name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                                (self.ha_summary is not None and self.ha_summary.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                                (self.ha_summary is not None and self.ha_summary.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "issu" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-statistics"):
                                if (self.ha_statistics is None):
                                    self.ha_statistics = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaStatistics()
                                    self.ha_statistics.parent = self
                                    self._children_name_map["ha_statistics"] = "ha-statistics"
                                return self.ha_statistics

                            if (child_yang_name == "ha-summary"):
                                if (self.ha_summary is None):
                                    self.ha_summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu.HaSummary()
                                    self.ha_summary.parent = self
                                    self._children_name_map["ha_summary"] = "ha-summary"
                                return self.ha_summary

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-statistics" or name == "ha-summary"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborCapabilities(Entity):
                        """
                        LDP Neighbors Capabilities
                        
                        .. attribute:: neighbor_capability
                        
                        	Information on capabilities of a particular LDP neighbor
                        	**type**\: list of    :py:class:`NeighborCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities, self).__init__()

                            self.yang_name = "neighbor-capabilities"
                            self.yang_parent_name = "vrf"

                            self.neighbor_capability = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities, self).__setattr__(name, value)


                        class NeighborCapability(Entity):
                            """
                            Information on capabilities of a particular LDP
                            neighbor
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: received
                            
                            	List of received capabilities
                            	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received>`
                            
                            .. attribute:: sent
                            
                            	List of sent capabilities
                            	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__init__()

                                self.yang_name = "neighbor-capability"
                                self.yang_parent_name = "neighbor-capabilities"

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.received = YList(self)
                                self.sent = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)


                            class Sent(Entity):
                                """
                                List of sent capabilities
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__init__()

                                    self.yang_name = "sent"
                                    self.yang_parent_name = "neighbor-capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sent" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class Received(Entity):
                                """
                                List of received capabilities
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__init__()

                                    self.yang_name = "received"
                                    self.yang_parent_name = "neighbor-capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "received" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.received:
                                    if (c.has_data()):
                                        return True
                                for c in self.sent:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set)

                            def has_operation(self):
                                for c in self.received:
                                    if (c.has_operation()):
                                        return True
                                for c in self.sent:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-capability" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "received"):
                                    for c in self.received:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.received.append(c)
                                    return c

                                if (child_yang_name == "sent"):
                                    for c in self.sent:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sent.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "received" or name == "sent" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor_capability:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor_capability:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-capabilities" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-capability"):
                                for c in self.neighbor_capability:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities.NeighborCapability()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor_capability.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Neighbors(Entity):
                        """
                        The LDP Neighbors
                        
                        .. attribute:: neighbor
                        
                        	Information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors, self).__init__()

                            self.yang_name = "neighbors"
                            self.yang_parent_name = "vrf"

                            self.neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors, self).__setattr__(name, value)


                        class Neighbor(Entity):
                            """
                            Information on a particular LDP neighbor
                            
                            .. attribute:: detailed_information
                            
                            	Detailed information with regards to holdtime, KA, inbound filtering, and Session protection
                            	**type**\:   :py:class:`DetailedInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation>`
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: ldp_nbr_bound_ipv4_address_info
                            
                            	Neighbor IPv4 Address Info
                            	**type**\: list of    :py:class:`LdpNbrBoundIpv4AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo>`
                            
                            .. attribute:: ldp_nbr_bound_ipv6_address_info
                            
                            	Neighbor IPv6 Address Info
                            	**type**\: list of    :py:class:`LdpNbrBoundIpv6AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo>`
                            
                            .. attribute:: ldp_nbr_ipv4_adj_info
                            
                            	Neighbor's IPv4 Adjacency Information
                            	**type**\: list of    :py:class:`LdpNbrIpv4AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo>`
                            
                            .. attribute:: ldp_nbr_ipv6_adj_info
                            
                            	Neighbor's IPv6 Adjacency Information
                            	**type**\: list of    :py:class:`LdpNbrIpv6AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo>`
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: protocol_information
                            
                            	Protocol Information
                            	**type**\:   :py:class:`ProtocolInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation>`
                            
                            .. attribute:: tcp_information
                            
                            	TCP Information
                            	**type**\:   :py:class:`TcpInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor, self).__init__()

                                self.yang_name = "neighbor"
                                self.yang_parent_name = "neighbors"

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.detailed_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation()
                                self.detailed_information.parent = self
                                self._children_name_map["detailed_information"] = "detailed-information"
                                self._children_yang_names.add("detailed-information")

                                self.protocol_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation()
                                self.protocol_information.parent = self
                                self._children_name_map["protocol_information"] = "protocol-information"
                                self._children_yang_names.add("protocol-information")

                                self.tcp_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation()
                                self.tcp_information.parent = self
                                self._children_name_map["tcp_information"] = "tcp-information"
                                self._children_yang_names.add("tcp-information")

                                self.ldp_nbr_bound_ipv4_address_info = YList(self)
                                self.ldp_nbr_bound_ipv6_address_info = YList(self)
                                self.ldp_nbr_ipv4_adj_info = YList(self)
                                self.ldp_nbr_ipv6_adj_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor, self).__setattr__(name, value)


                            class ProtocolInformation(Entity):
                                """
                                Protocol Information
                                
                                .. attribute:: downstream_on_demand
                                
                                	Is Label advertisment mode in Downstream On Demand mode or Not
                                	**type**\:  bool
                                
                                .. attribute:: ta_graceful_restart_adjacency
                                
                                	Graceful restart information
                                	**type**\:   :py:class:`TaGracefulRestartAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency>`
                                
                                .. attribute:: ta_holdtime
                                
                                	Session holdtime in sec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_pies_rcvd
                                
                                	Number of pies received
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_pies_sent
                                
                                	Number of pies sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_state
                                
                                	State
                                	**type**\:  str
                                
                                .. attribute:: ta_up_time_seconds
                                
                                	Up time in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__init__()

                                    self.yang_name = "protocol-information"
                                    self.yang_parent_name = "neighbor"

                                    self.downstream_on_demand = YLeaf(YType.boolean, "downstream-on-demand")

                                    self.ta_holdtime = YLeaf(YType.uint32, "ta-holdtime")

                                    self.ta_pies_rcvd = YLeaf(YType.uint32, "ta-pies-rcvd")

                                    self.ta_pies_sent = YLeaf(YType.uint32, "ta-pies-sent")

                                    self.ta_state = YLeaf(YType.str, "ta-state")

                                    self.ta_up_time_seconds = YLeaf(YType.uint32, "ta-up-time-seconds")

                                    self.ta_graceful_restart_adjacency = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                    self.ta_graceful_restart_adjacency.parent = self
                                    self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                    self._children_yang_names.add("ta-graceful-restart-adjacency")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("downstream_on_demand",
                                                    "ta_holdtime",
                                                    "ta_pies_rcvd",
                                                    "ta_pies_sent",
                                                    "ta_state",
                                                    "ta_up_time_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)


                                class TaGracefulRestartAdjacency(Entity):
                                    """
                                    Graceful restart information
                                    
                                    .. attribute:: is_graceful_restartable
                                    
                                    	Is graceful restartable
                                    	**type**\:  bool
                                    
                                    .. attribute:: reconnect_timeout
                                    
                                    	Reconnect timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: recovery_time
                                    
                                    	Recovery time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__init__()

                                        self.yang_name = "ta-graceful-restart-adjacency"
                                        self.yang_parent_name = "protocol-information"

                                        self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                        self.reconnect_timeout = YLeaf(YType.uint32, "reconnect-timeout")

                                        self.recovery_time = YLeaf(YType.uint32, "recovery-time")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_graceful_restartable",
                                                        "reconnect_timeout",
                                                        "recovery_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_graceful_restartable.is_set or
                                            self.reconnect_timeout.is_set or
                                            self.recovery_time.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_graceful_restartable.yfilter != YFilter.not_set or
                                            self.reconnect_timeout.yfilter != YFilter.not_set or
                                            self.recovery_time.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ta-graceful-restart-adjacency" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                        if (self.reconnect_timeout.is_set or self.reconnect_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reconnect_timeout.get_name_leafdata())
                                        if (self.recovery_time.is_set or self.recovery_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.recovery_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-graceful-restartable" or name == "reconnect-timeout" or name == "recovery-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-graceful-restartable"):
                                            self.is_graceful_restartable = value
                                            self.is_graceful_restartable.value_namespace = name_space
                                            self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reconnect-timeout"):
                                            self.reconnect_timeout = value
                                            self.reconnect_timeout.value_namespace = name_space
                                            self.reconnect_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "recovery-time"):
                                            self.recovery_time = value
                                            self.recovery_time.value_namespace = name_space
                                            self.recovery_time.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.downstream_on_demand.is_set or
                                        self.ta_holdtime.is_set or
                                        self.ta_pies_rcvd.is_set or
                                        self.ta_pies_sent.is_set or
                                        self.ta_state.is_set or
                                        self.ta_up_time_seconds.is_set or
                                        (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.downstream_on_demand.yfilter != YFilter.not_set or
                                        self.ta_holdtime.yfilter != YFilter.not_set or
                                        self.ta_pies_rcvd.yfilter != YFilter.not_set or
                                        self.ta_pies_sent.yfilter != YFilter.not_set or
                                        self.ta_state.yfilter != YFilter.not_set or
                                        self.ta_up_time_seconds.yfilter != YFilter.not_set or
                                        (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protocol-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.downstream_on_demand.is_set or self.downstream_on_demand.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.downstream_on_demand.get_name_leafdata())
                                    if (self.ta_holdtime.is_set or self.ta_holdtime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_holdtime.get_name_leafdata())
                                    if (self.ta_pies_rcvd.is_set or self.ta_pies_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_pies_rcvd.get_name_leafdata())
                                    if (self.ta_pies_sent.is_set or self.ta_pies_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_pies_sent.get_name_leafdata())
                                    if (self.ta_state.is_set or self.ta_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_state.get_name_leafdata())
                                    if (self.ta_up_time_seconds.is_set or self.ta_up_time_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_up_time_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ta-graceful-restart-adjacency"):
                                        if (self.ta_graceful_restart_adjacency is None):
                                            self.ta_graceful_restart_adjacency = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                            self.ta_graceful_restart_adjacency.parent = self
                                            self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                        return self.ta_graceful_restart_adjacency

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ta-graceful-restart-adjacency" or name == "downstream-on-demand" or name == "ta-holdtime" or name == "ta-pies-rcvd" or name == "ta-pies-sent" or name == "ta-state" or name == "ta-up-time-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "downstream-on-demand"):
                                        self.downstream_on_demand = value
                                        self.downstream_on_demand.value_namespace = name_space
                                        self.downstream_on_demand.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-holdtime"):
                                        self.ta_holdtime = value
                                        self.ta_holdtime.value_namespace = name_space
                                        self.ta_holdtime.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-pies-rcvd"):
                                        self.ta_pies_rcvd = value
                                        self.ta_pies_rcvd.value_namespace = name_space
                                        self.ta_pies_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-pies-sent"):
                                        self.ta_pies_sent = value
                                        self.ta_pies_sent.value_namespace = name_space
                                        self.ta_pies_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-state"):
                                        self.ta_state = value
                                        self.ta_state.value_namespace = name_space
                                        self.ta_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-up-time-seconds"):
                                        self.ta_up_time_seconds = value
                                        self.ta_up_time_seconds.value_namespace = name_space
                                        self.ta_up_time_seconds.value_namespace_prefix = name_space_prefix


                            class TcpInformation(Entity):
                                """
                                TCP Information
                                
                                .. attribute:: foreign_host
                                
                                	Foreign host address
                                	**type**\:   :py:class:`ForeignHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost>`
                                
                                .. attribute:: foreign_port
                                
                                	Foreign port number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: is_md5_on
                                
                                	Is MD5 Digest on
                                	**type**\:  bool
                                
                                .. attribute:: local_host
                                
                                	Local host address
                                	**type**\:   :py:class:`LocalHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost>`
                                
                                .. attribute:: local_port
                                
                                	Local port number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__init__()

                                    self.yang_name = "tcp-information"
                                    self.yang_parent_name = "neighbor"

                                    self.foreign_port = YLeaf(YType.uint16, "foreign-port")

                                    self.is_md5_on = YLeaf(YType.boolean, "is-md5-on")

                                    self.local_port = YLeaf(YType.uint16, "local-port")

                                    self.foreign_host = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                    self.foreign_host.parent = self
                                    self._children_name_map["foreign_host"] = "foreign-host"
                                    self._children_yang_names.add("foreign-host")

                                    self.local_host = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                    self.local_host.parent = self
                                    self._children_name_map["local_host"] = "local-host"
                                    self._children_yang_names.add("local-host")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("foreign_port",
                                                    "is_md5_on",
                                                    "local_port") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)


                                class ForeignHost(Entity):
                                    """
                                    Foreign host address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__init__()

                                        self.yang_name = "foreign-host"
                                        self.yang_parent_name = "tcp-information"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "foreign-host" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class LocalHost(Entity):
                                    """
                                    Local host address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__init__()

                                        self.yang_name = "local-host"
                                        self.yang_parent_name = "tcp-information"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "local-host" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.foreign_port.is_set or
                                        self.is_md5_on.is_set or
                                        self.local_port.is_set or
                                        (self.foreign_host is not None and self.foreign_host.has_data()) or
                                        (self.local_host is not None and self.local_host.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.foreign_port.yfilter != YFilter.not_set or
                                        self.is_md5_on.yfilter != YFilter.not_set or
                                        self.local_port.yfilter != YFilter.not_set or
                                        (self.foreign_host is not None and self.foreign_host.has_operation()) or
                                        (self.local_host is not None and self.local_host.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tcp-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.foreign_port.is_set or self.foreign_port.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.foreign_port.get_name_leafdata())
                                    if (self.is_md5_on.is_set or self.is_md5_on.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_md5_on.get_name_leafdata())
                                    if (self.local_port.is_set or self.local_port.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_port.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "foreign-host"):
                                        if (self.foreign_host is None):
                                            self.foreign_host = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                            self.foreign_host.parent = self
                                            self._children_name_map["foreign_host"] = "foreign-host"
                                        return self.foreign_host

                                    if (child_yang_name == "local-host"):
                                        if (self.local_host is None):
                                            self.local_host = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                            self.local_host.parent = self
                                            self._children_name_map["local_host"] = "local-host"
                                        return self.local_host

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "foreign-host" or name == "local-host" or name == "foreign-port" or name == "is-md5-on" or name == "local-port"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "foreign-port"):
                                        self.foreign_port = value
                                        self.foreign_port.value_namespace = name_space
                                        self.foreign_port.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-md5-on"):
                                        self.is_md5_on = value
                                        self.is_md5_on.value_namespace = name_space
                                        self.is_md5_on.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-port"):
                                        self.local_port = value
                                        self.local_port.value_namespace = name_space
                                        self.local_port.value_namespace_prefix = name_space_prefix


                            class DetailedInformation(Entity):
                                """
                                Detailed information with regards to holdtime,
                                KA, inbound filtering, and Session protection
                                
                                .. attribute:: advertise_bgp_prefixes
                                
                                	Is BGP labelled prefixes advertised to the neighbor
                                	**type**\:  bool
                                
                                .. attribute:: bgp_advertisement_state
                                
                                	BGP labelled prefixes advertisement state
                                	**type**\:   :py:class:`MgmtLdpNbrBgpAdvtState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNbrBgpAdvtState>`
                                
                                .. attribute:: capabilities
                                
                                	Capabilities sent to and received from neighbor
                                	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities>`
                                
                                .. attribute:: client
                                
                                	Targeted Session clients
                                	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client>`
                                
                                .. attribute:: has_ipv4_inbound
                                
                                	IPv4 Inbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv4_outbound
                                
                                	IPv4 Outbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv6_inbound
                                
                                	IPv6 Inbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv6_outbound
                                
                                	IPv6 Outbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_sp
                                
                                	Session Protection enabled
                                	**type**\:  bool
                                
                                .. attribute:: inbound_ipv4acl
                                
                                	IPv4 Inbound accept ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: inbound_ipv6acl
                                
                                	IPv6 Inbound accept ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: ipv4_duplicate_address
                                
                                	Duplicate IPv4 address bound to this peer
                                	**type**\: list of    :py:class:`Ipv4DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress>`
                                
                                .. attribute:: ipv6_duplicate_address
                                
                                	Duplicate IPv6 address bound to this peer
                                	**type**\: list of    :py:class:`Ipv6DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress>`
                                
                                .. attribute:: keep_alive_interval
                                
                                	Session keepalive interval in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: nsr_last_sync_error
                                
                                	Last NSR sync error
                                	**type**\:   :py:class:`MgmtLdpNsrPeerSyncErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncErr>`
                                
                                .. attribute:: nsr_last_sync_nack_reason
                                
                                	Last NSR sync NACK reaston
                                	**type**\:   :py:class:`MgmtLdpNsrPeerLdpSyncNackRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerLdpSyncNackRsn>`
                                
                                .. attribute:: nsr_sync_state
                                
                                	NSR Sync State
                                	**type**\:   :py:class:`MgmtLdpNsrPeerSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncState>`
                                
                                .. attribute:: outbound_ipv4acl
                                
                                	IPv4 Outbound advertise ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: outbound_ipv6acl
                                
                                	IPv6 Outbound advertise ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: peer_holdtime
                                
                                	Session holdtime value in seconds from the peer
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: peer_state
                                
                                	Peer state
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: sp_duration
                                
                                	Session protection holdup time duration in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: sp_has_acl
                                
                                	Session protection ACL is present
                                	**type**\:  bool
                                
                                .. attribute:: sp_has_duration
                                
                                	Session Protection has non\-default duration
                                	**type**\:  bool
                                
                                .. attribute:: sp_state
                                
                                	Session Protection state
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: spacl
                                
                                	Session Protection ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: spht_remaining
                                
                                	Session Protection holdup time remaining value in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: spht_running
                                
                                	Session Protection holdup timer is running
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__init__()

                                    self.yang_name = "detailed-information"
                                    self.yang_parent_name = "neighbor"

                                    self.advertise_bgp_prefixes = YLeaf(YType.boolean, "advertise-bgp-prefixes")

                                    self.bgp_advertisement_state = YLeaf(YType.enumeration, "bgp-advertisement-state")

                                    self.has_ipv4_inbound = YLeaf(YType.boolean, "has-ipv4-inbound")

                                    self.has_ipv4_outbound = YLeaf(YType.boolean, "has-ipv4-outbound")

                                    self.has_ipv6_inbound = YLeaf(YType.boolean, "has-ipv6-inbound")

                                    self.has_ipv6_outbound = YLeaf(YType.boolean, "has-ipv6-outbound")

                                    self.has_sp = YLeaf(YType.boolean, "has-sp")

                                    self.inbound_ipv4acl = YLeaf(YType.str, "inbound-ipv4acl")

                                    self.inbound_ipv6acl = YLeaf(YType.str, "inbound-ipv6acl")

                                    self.keep_alive_interval = YLeaf(YType.uint32, "keep-alive-interval")

                                    self.nsr_last_sync_error = YLeaf(YType.enumeration, "nsr-last-sync-error")

                                    self.nsr_last_sync_nack_reason = YLeaf(YType.enumeration, "nsr-last-sync-nack-reason")

                                    self.nsr_sync_state = YLeaf(YType.enumeration, "nsr-sync-state")

                                    self.outbound_ipv4acl = YLeaf(YType.str, "outbound-ipv4acl")

                                    self.outbound_ipv6acl = YLeaf(YType.str, "outbound-ipv6acl")

                                    self.peer_holdtime = YLeaf(YType.uint32, "peer-holdtime")

                                    self.peer_state = YLeaf(YType.str, "peer-state")

                                    self.sp_duration = YLeaf(YType.uint32, "sp-duration")

                                    self.sp_has_acl = YLeaf(YType.boolean, "sp-has-acl")

                                    self.sp_has_duration = YLeaf(YType.boolean, "sp-has-duration")

                                    self.sp_state = YLeaf(YType.str, "sp-state")

                                    self.spacl = YLeaf(YType.str, "spacl")

                                    self.spht_remaining = YLeaf(YType.uint32, "spht-remaining")

                                    self.spht_running = YLeaf(YType.boolean, "spht-running")

                                    self.capabilities = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                    self.capabilities.parent = self
                                    self._children_name_map["capabilities"] = "capabilities"
                                    self._children_yang_names.add("capabilities")

                                    self.client = YList(self)
                                    self.ipv4_duplicate_address = YList(self)
                                    self.ipv6_duplicate_address = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("advertise_bgp_prefixes",
                                                    "bgp_advertisement_state",
                                                    "has_ipv4_inbound",
                                                    "has_ipv4_outbound",
                                                    "has_ipv6_inbound",
                                                    "has_ipv6_outbound",
                                                    "has_sp",
                                                    "inbound_ipv4acl",
                                                    "inbound_ipv6acl",
                                                    "keep_alive_interval",
                                                    "nsr_last_sync_error",
                                                    "nsr_last_sync_nack_reason",
                                                    "nsr_sync_state",
                                                    "outbound_ipv4acl",
                                                    "outbound_ipv6acl",
                                                    "peer_holdtime",
                                                    "peer_state",
                                                    "sp_duration",
                                                    "sp_has_acl",
                                                    "sp_has_duration",
                                                    "sp_state",
                                                    "spacl",
                                                    "spht_remaining",
                                                    "spht_running") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)


                                class Capabilities(Entity):
                                    """
                                    Capabilities sent to and received from neighbor
                                    
                                    .. attribute:: received
                                    
                                    	List of received capabilities
                                    	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received>`
                                    
                                    .. attribute:: sent
                                    
                                    	List of sent capabilities
                                    	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__init__()

                                        self.yang_name = "capabilities"
                                        self.yang_parent_name = "detailed-information"

                                        self.received = YList(self)
                                        self.sent = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)


                                    class Sent(Entity):
                                        """
                                        List of sent capabilities
                                        
                                        .. attribute:: capability_data
                                        
                                        	Capability data
                                        	**type**\:  str
                                        
                                        .. attribute:: capability_data_length
                                        
                                        	Capability data length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: description
                                        
                                        	Capability description
                                        	**type**\:  str
                                        
                                        	**length:** 0..80
                                        
                                        .. attribute:: type
                                        
                                        	Capability type (IANA assigned)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__init__()

                                            self.yang_name = "sent"
                                            self.yang_parent_name = "capabilities"

                                            self.capability_data = YLeaf(YType.str, "capability-data")

                                            self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                            self.description = YLeaf(YType.str, "description")

                                            self.type = YLeaf(YType.uint16, "type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("capability_data",
                                                            "capability_data_length",
                                                            "description",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.capability_data.is_set or
                                                self.capability_data_length.is_set or
                                                self.description.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.capability_data.yfilter != YFilter.not_set or
                                                self.capability_data_length.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "sent" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data.get_name_leafdata())
                                            if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "capability-data"):
                                                self.capability_data = value
                                                self.capability_data.value_namespace = name_space
                                                self.capability_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "capability-data-length"):
                                                self.capability_data_length = value
                                                self.capability_data_length.value_namespace = name_space
                                                self.capability_data_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix


                                    class Received(Entity):
                                        """
                                        List of received capabilities
                                        
                                        .. attribute:: capability_data
                                        
                                        	Capability data
                                        	**type**\:  str
                                        
                                        .. attribute:: capability_data_length
                                        
                                        	Capability data length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: description
                                        
                                        	Capability description
                                        	**type**\:  str
                                        
                                        	**length:** 0..80
                                        
                                        .. attribute:: type
                                        
                                        	Capability type (IANA assigned)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__init__()

                                            self.yang_name = "received"
                                            self.yang_parent_name = "capabilities"

                                            self.capability_data = YLeaf(YType.str, "capability-data")

                                            self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                            self.description = YLeaf(YType.str, "description")

                                            self.type = YLeaf(YType.uint16, "type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("capability_data",
                                                            "capability_data_length",
                                                            "description",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.capability_data.is_set or
                                                self.capability_data_length.is_set or
                                                self.description.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.capability_data.yfilter != YFilter.not_set or
                                                self.capability_data_length.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "received" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data.get_name_leafdata())
                                            if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "capability-data"):
                                                self.capability_data = value
                                                self.capability_data.value_namespace = name_space
                                                self.capability_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "capability-data-length"):
                                                self.capability_data_length = value
                                                self.capability_data_length.value_namespace = name_space
                                                self.capability_data_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.received:
                                            if (c.has_data()):
                                                return True
                                        for c in self.sent:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.received:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.sent:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "capabilities" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "received"):
                                            for c in self.received:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.received.append(c)
                                            return c

                                        if (child_yang_name == "sent"):
                                            for c in self.sent:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.sent.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "received" or name == "sent"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Client(Entity):
                                    """
                                    Targeted Session clients
                                    
                                    .. attribute:: name
                                    
                                    	Client's name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__init__()

                                        self.yang_name = "client"
                                        self.yang_parent_name = "detailed-information"

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.name.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "client" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class Ipv4DuplicateAddress(Entity):
                                    """
                                    Duplicate IPv4 address bound to this peer
                                    
                                    .. attribute:: address
                                    
                                    	Neighbor Address
                                    	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress, self).__init__()

                                        self.yang_name = "ipv4-duplicate-address"
                                        self.yang_parent_name = "detailed-information"

                                        self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                        self._children_yang_names.add("address")


                                    class Address(Entity):
                                        """
                                        Neighbor Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__init__()

                                            self.yang_name = "address"
                                            self.yang_parent_name = "ipv4-duplicate-address"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.address is not None and self.address.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.address is not None and self.address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-duplicate-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "address"):
                                            if (self.address is None):
                                                self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                                self.address.parent = self
                                                self._children_name_map["address"] = "address"
                                            return self.address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Ipv6DuplicateAddress(Entity):
                                    """
                                    Duplicate IPv6 address bound to this peer
                                    
                                    .. attribute:: address
                                    
                                    	Neighbor Address
                                    	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress, self).__init__()

                                        self.yang_name = "ipv6-duplicate-address"
                                        self.yang_parent_name = "detailed-information"

                                        self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                        self._children_yang_names.add("address")


                                    class Address(Entity):
                                        """
                                        Neighbor Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__init__()

                                            self.yang_name = "address"
                                            self.yang_parent_name = "ipv6-duplicate-address"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.address is not None and self.address.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.address is not None and self.address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-duplicate-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "address"):
                                            if (self.address is None):
                                                self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                                self.address.parent = self
                                                self._children_name_map["address"] = "address"
                                            return self.address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    for c in self.client:
                                        if (c.has_data()):
                                            return True
                                    for c in self.ipv4_duplicate_address:
                                        if (c.has_data()):
                                            return True
                                    for c in self.ipv6_duplicate_address:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.advertise_bgp_prefixes.is_set or
                                        self.bgp_advertisement_state.is_set or
                                        self.has_ipv4_inbound.is_set or
                                        self.has_ipv4_outbound.is_set or
                                        self.has_ipv6_inbound.is_set or
                                        self.has_ipv6_outbound.is_set or
                                        self.has_sp.is_set or
                                        self.inbound_ipv4acl.is_set or
                                        self.inbound_ipv6acl.is_set or
                                        self.keep_alive_interval.is_set or
                                        self.nsr_last_sync_error.is_set or
                                        self.nsr_last_sync_nack_reason.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.outbound_ipv4acl.is_set or
                                        self.outbound_ipv6acl.is_set or
                                        self.peer_holdtime.is_set or
                                        self.peer_state.is_set or
                                        self.sp_duration.is_set or
                                        self.sp_has_acl.is_set or
                                        self.sp_has_duration.is_set or
                                        self.sp_state.is_set or
                                        self.spacl.is_set or
                                        self.spht_remaining.is_set or
                                        self.spht_running.is_set or
                                        (self.capabilities is not None and self.capabilities.has_data()))

                                def has_operation(self):
                                    for c in self.client:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.ipv4_duplicate_address:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.ipv6_duplicate_address:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.advertise_bgp_prefixes.yfilter != YFilter.not_set or
                                        self.bgp_advertisement_state.yfilter != YFilter.not_set or
                                        self.has_ipv4_inbound.yfilter != YFilter.not_set or
                                        self.has_ipv4_outbound.yfilter != YFilter.not_set or
                                        self.has_ipv6_inbound.yfilter != YFilter.not_set or
                                        self.has_ipv6_outbound.yfilter != YFilter.not_set or
                                        self.has_sp.yfilter != YFilter.not_set or
                                        self.inbound_ipv4acl.yfilter != YFilter.not_set or
                                        self.inbound_ipv6acl.yfilter != YFilter.not_set or
                                        self.keep_alive_interval.yfilter != YFilter.not_set or
                                        self.nsr_last_sync_error.yfilter != YFilter.not_set or
                                        self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.outbound_ipv4acl.yfilter != YFilter.not_set or
                                        self.outbound_ipv6acl.yfilter != YFilter.not_set or
                                        self.peer_holdtime.yfilter != YFilter.not_set or
                                        self.peer_state.yfilter != YFilter.not_set or
                                        self.sp_duration.yfilter != YFilter.not_set or
                                        self.sp_has_acl.yfilter != YFilter.not_set or
                                        self.sp_has_duration.yfilter != YFilter.not_set or
                                        self.sp_state.yfilter != YFilter.not_set or
                                        self.spacl.yfilter != YFilter.not_set or
                                        self.spht_remaining.yfilter != YFilter.not_set or
                                        self.spht_running.yfilter != YFilter.not_set or
                                        (self.capabilities is not None and self.capabilities.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "detailed-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.advertise_bgp_prefixes.is_set or self.advertise_bgp_prefixes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_bgp_prefixes.get_name_leafdata())
                                    if (self.bgp_advertisement_state.is_set or self.bgp_advertisement_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bgp_advertisement_state.get_name_leafdata())
                                    if (self.has_ipv4_inbound.is_set or self.has_ipv4_inbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv4_inbound.get_name_leafdata())
                                    if (self.has_ipv4_outbound.is_set or self.has_ipv4_outbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv4_outbound.get_name_leafdata())
                                    if (self.has_ipv6_inbound.is_set or self.has_ipv6_inbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv6_inbound.get_name_leafdata())
                                    if (self.has_ipv6_outbound.is_set or self.has_ipv6_outbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv6_outbound.get_name_leafdata())
                                    if (self.has_sp.is_set or self.has_sp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_sp.get_name_leafdata())
                                    if (self.inbound_ipv4acl.is_set or self.inbound_ipv4acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inbound_ipv4acl.get_name_leafdata())
                                    if (self.inbound_ipv6acl.is_set or self.inbound_ipv6acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inbound_ipv6acl.get_name_leafdata())
                                    if (self.keep_alive_interval.is_set or self.keep_alive_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_interval.get_name_leafdata())
                                    if (self.nsr_last_sync_error.is_set or self.nsr_last_sync_error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_last_sync_error.get_name_leafdata())
                                    if (self.nsr_last_sync_nack_reason.is_set or self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_last_sync_nack_reason.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.outbound_ipv4acl.is_set or self.outbound_ipv4acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outbound_ipv4acl.get_name_leafdata())
                                    if (self.outbound_ipv6acl.is_set or self.outbound_ipv6acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outbound_ipv6acl.get_name_leafdata())
                                    if (self.peer_holdtime.is_set or self.peer_holdtime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_holdtime.get_name_leafdata())
                                    if (self.peer_state.is_set or self.peer_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_state.get_name_leafdata())
                                    if (self.sp_duration.is_set or self.sp_duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_duration.get_name_leafdata())
                                    if (self.sp_has_acl.is_set or self.sp_has_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_has_acl.get_name_leafdata())
                                    if (self.sp_has_duration.is_set or self.sp_has_duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_has_duration.get_name_leafdata())
                                    if (self.sp_state.is_set or self.sp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_state.get_name_leafdata())
                                    if (self.spacl.is_set or self.spacl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spacl.get_name_leafdata())
                                    if (self.spht_remaining.is_set or self.spht_remaining.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spht_remaining.get_name_leafdata())
                                    if (self.spht_running.is_set or self.spht_running.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spht_running.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "capabilities"):
                                        if (self.capabilities is None):
                                            self.capabilities = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                            self.capabilities.parent = self
                                            self._children_name_map["capabilities"] = "capabilities"
                                        return self.capabilities

                                    if (child_yang_name == "client"):
                                        for c in self.client:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.client.append(c)
                                        return c

                                    if (child_yang_name == "ipv4-duplicate-address"):
                                        for c in self.ipv4_duplicate_address:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ipv4_duplicate_address.append(c)
                                        return c

                                    if (child_yang_name == "ipv6-duplicate-address"):
                                        for c in self.ipv6_duplicate_address:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ipv6_duplicate_address.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capabilities" or name == "client" or name == "ipv4-duplicate-address" or name == "ipv6-duplicate-address" or name == "advertise-bgp-prefixes" or name == "bgp-advertisement-state" or name == "has-ipv4-inbound" or name == "has-ipv4-outbound" or name == "has-ipv6-inbound" or name == "has-ipv6-outbound" or name == "has-sp" or name == "inbound-ipv4acl" or name == "inbound-ipv6acl" or name == "keep-alive-interval" or name == "nsr-last-sync-error" or name == "nsr-last-sync-nack-reason" or name == "nsr-sync-state" or name == "outbound-ipv4acl" or name == "outbound-ipv6acl" or name == "peer-holdtime" or name == "peer-state" or name == "sp-duration" or name == "sp-has-acl" or name == "sp-has-duration" or name == "sp-state" or name == "spacl" or name == "spht-remaining" or name == "spht-running"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "advertise-bgp-prefixes"):
                                        self.advertise_bgp_prefixes = value
                                        self.advertise_bgp_prefixes.value_namespace = name_space
                                        self.advertise_bgp_prefixes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "bgp-advertisement-state"):
                                        self.bgp_advertisement_state = value
                                        self.bgp_advertisement_state.value_namespace = name_space
                                        self.bgp_advertisement_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv4-inbound"):
                                        self.has_ipv4_inbound = value
                                        self.has_ipv4_inbound.value_namespace = name_space
                                        self.has_ipv4_inbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv4-outbound"):
                                        self.has_ipv4_outbound = value
                                        self.has_ipv4_outbound.value_namespace = name_space
                                        self.has_ipv4_outbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv6-inbound"):
                                        self.has_ipv6_inbound = value
                                        self.has_ipv6_inbound.value_namespace = name_space
                                        self.has_ipv6_inbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv6-outbound"):
                                        self.has_ipv6_outbound = value
                                        self.has_ipv6_outbound.value_namespace = name_space
                                        self.has_ipv6_outbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-sp"):
                                        self.has_sp = value
                                        self.has_sp.value_namespace = name_space
                                        self.has_sp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inbound-ipv4acl"):
                                        self.inbound_ipv4acl = value
                                        self.inbound_ipv4acl.value_namespace = name_space
                                        self.inbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inbound-ipv6acl"):
                                        self.inbound_ipv6acl = value
                                        self.inbound_ipv6acl.value_namespace = name_space
                                        self.inbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-interval"):
                                        self.keep_alive_interval = value
                                        self.keep_alive_interval.value_namespace = name_space
                                        self.keep_alive_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-last-sync-error"):
                                        self.nsr_last_sync_error = value
                                        self.nsr_last_sync_error.value_namespace = name_space
                                        self.nsr_last_sync_error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-last-sync-nack-reason"):
                                        self.nsr_last_sync_nack_reason = value
                                        self.nsr_last_sync_nack_reason.value_namespace = name_space
                                        self.nsr_last_sync_nack_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outbound-ipv4acl"):
                                        self.outbound_ipv4acl = value
                                        self.outbound_ipv4acl.value_namespace = name_space
                                        self.outbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outbound-ipv6acl"):
                                        self.outbound_ipv6acl = value
                                        self.outbound_ipv6acl.value_namespace = name_space
                                        self.outbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-holdtime"):
                                        self.peer_holdtime = value
                                        self.peer_holdtime.value_namespace = name_space
                                        self.peer_holdtime.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-state"):
                                        self.peer_state = value
                                        self.peer_state.value_namespace = name_space
                                        self.peer_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-duration"):
                                        self.sp_duration = value
                                        self.sp_duration.value_namespace = name_space
                                        self.sp_duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-has-acl"):
                                        self.sp_has_acl = value
                                        self.sp_has_acl.value_namespace = name_space
                                        self.sp_has_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-has-duration"):
                                        self.sp_has_duration = value
                                        self.sp_has_duration.value_namespace = name_space
                                        self.sp_has_duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-state"):
                                        self.sp_state = value
                                        self.sp_state.value_namespace = name_space
                                        self.sp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spacl"):
                                        self.spacl = value
                                        self.spacl.value_namespace = name_space
                                        self.spacl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spht-remaining"):
                                        self.spht_remaining = value
                                        self.spht_remaining.value_namespace = name_space
                                        self.spht_remaining.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spht-running"):
                                        self.spht_running = value
                                        self.spht_running.value_namespace = name_space
                                        self.spht_running.value_namespace_prefix = name_space_prefix


                            class LdpNbrBoundIpv4AddressInfo(Entity):
                                """
                                Neighbor IPv4 Address Info
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-bound-ipv4-address-info"
                                    self.yang_parent_name = "neighbor"

                                    self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ldp-nbr-bound-ipv4-address-info"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-bound-ipv4-address-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrBoundIpv6AddressInfo(Entity):
                                """
                                Neighbor IPv6 Address Info
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-bound-ipv6-address-info"
                                    self.yang_parent_name = "neighbor"

                                    self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ldp-nbr-bound-ipv6-address-info"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-bound-ipv6-address-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrIpv4AdjInfo(Entity):
                                """
                                Neighbor's IPv4 Adjacency Information
                                
                                .. attribute:: adjacency_group
                                
                                	Adjacency group
                                	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-ipv4-adj-info"
                                    self.yang_parent_name = "neighbor"

                                    self.adjacency_group = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                    self.adjacency_group.parent = self
                                    self._children_name_map["adjacency_group"] = "adjacency-group"
                                    self._children_yang_names.add("adjacency-group")


                                class AdjacencyGroup(Entity):
                                    """
                                    Adjacency group
                                    
                                    .. attribute:: hello_type
                                    
                                    	HelloType
                                    	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                    
                                    .. attribute:: link_hello_data
                                    
                                    	Link hello
                                    	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData>`
                                    
                                    .. attribute:: target_hello_data
                                    
                                    	Target Hello
                                    	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__init__()

                                        self.yang_name = "adjacency-group"
                                        self.yang_parent_name = "ldp-nbr-ipv4-adj-info"

                                        self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                        self.link_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                        self.link_hello_data.parent = self
                                        self._children_name_map["link_hello_data"] = "link-hello-data"
                                        self._children_yang_names.add("link-hello-data")

                                        self.target_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                        self.target_hello_data.parent = self
                                        self._children_name_map["target_hello_data"] = "target-hello-data"
                                        self._children_yang_names.add("target-hello-data")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hello_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                    class LinkHelloData(Entity):
                                        """
                                        Link hello
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                            self.yang_name = "link-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface",
                                                            "interface_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface.is_set or
                                                self.interface_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface" or name == "interface-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix


                                    class TargetHelloData(Entity):
                                        """
                                        Target Hello
                                        
                                        .. attribute:: local_address
                                        
                                        	Local Address
                                        	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	Target Address
                                        	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                            self.yang_name = "target-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.local_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                            self.local_address.parent = self
                                            self._children_name_map["local_address"] = "local-address"
                                            self._children_yang_names.add("local-address")

                                            self.target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                            self.target_address.parent = self
                                            self._children_name_map["target_address"] = "target-address"
                                            self._children_yang_names.add("target-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                        class LocalAddress(Entity):
                                            """
                                            Local Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                                self.yang_name = "local-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class TargetAddress(Entity):
                                            """
                                            Target Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                                self.yang_name = "target-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.state.is_set or
                                                (self.local_address is not None and self.local_address.has_data()) or
                                                (self.target_address is not None and self.target_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                (self.local_address is not None and self.local_address.has_operation()) or
                                                (self.target_address is not None and self.target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-address"):
                                                if (self.local_address is None):
                                                    self.local_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                    self.local_address.parent = self
                                                    self._children_name_map["local_address"] = "local-address"
                                                return self.local_address

                                            if (child_yang_name == "target-address"):
                                                if (self.target_address is None):
                                                    self.target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                    self.target_address.parent = self
                                                    self._children_name_map["target_address"] = "target-address"
                                                return self.target_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-address" or name == "target-address" or name == "state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hello_type.is_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hello_type.yfilter != YFilter.not_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "adjacency-group" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hello_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-data"):
                                            if (self.link_hello_data is None):
                                                self.link_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                                self.link_hello_data.parent = self
                                                self._children_name_map["link_hello_data"] = "link-hello-data"
                                            return self.link_hello_data

                                        if (child_yang_name == "target-hello-data"):
                                            if (self.target_hello_data is None):
                                                self.target_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                                self.target_hello_data.parent = self
                                                self._children_name_map["target_hello_data"] = "target-hello-data"
                                            return self.target_hello_data

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hello-type"):
                                            self.hello_type = value
                                            self.hello_type.value_namespace = name_space
                                            self.hello_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.adjacency_group is not None and self.adjacency_group.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-ipv4-adj-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "adjacency-group"):
                                        if (self.adjacency_group is None):
                                            self.adjacency_group = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                            self.adjacency_group.parent = self
                                            self._children_name_map["adjacency_group"] = "adjacency-group"
                                        return self.adjacency_group

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "adjacency-group"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrIpv6AdjInfo(Entity):
                                """
                                Neighbor's IPv6 Adjacency Information
                                
                                .. attribute:: adjacency_group
                                
                                	Adjacency group
                                	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-ipv6-adj-info"
                                    self.yang_parent_name = "neighbor"

                                    self.adjacency_group = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                    self.adjacency_group.parent = self
                                    self._children_name_map["adjacency_group"] = "adjacency-group"
                                    self._children_yang_names.add("adjacency-group")


                                class AdjacencyGroup(Entity):
                                    """
                                    Adjacency group
                                    
                                    .. attribute:: hello_type
                                    
                                    	HelloType
                                    	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                    
                                    .. attribute:: link_hello_data
                                    
                                    	Link hello
                                    	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData>`
                                    
                                    .. attribute:: target_hello_data
                                    
                                    	Target Hello
                                    	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__init__()

                                        self.yang_name = "adjacency-group"
                                        self.yang_parent_name = "ldp-nbr-ipv6-adj-info"

                                        self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                        self.link_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                        self.link_hello_data.parent = self
                                        self._children_name_map["link_hello_data"] = "link-hello-data"
                                        self._children_yang_names.add("link-hello-data")

                                        self.target_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                        self.target_hello_data.parent = self
                                        self._children_name_map["target_hello_data"] = "target-hello-data"
                                        self._children_yang_names.add("target-hello-data")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hello_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                    class LinkHelloData(Entity):
                                        """
                                        Link hello
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                            self.yang_name = "link-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface",
                                                            "interface_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface.is_set or
                                                self.interface_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface" or name == "interface-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix


                                    class TargetHelloData(Entity):
                                        """
                                        Target Hello
                                        
                                        .. attribute:: local_address
                                        
                                        	Local Address
                                        	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	Target Address
                                        	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                            self.yang_name = "target-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.local_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                            self.local_address.parent = self
                                            self._children_name_map["local_address"] = "local-address"
                                            self._children_yang_names.add("local-address")

                                            self.target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                            self.target_address.parent = self
                                            self._children_name_map["target_address"] = "target-address"
                                            self._children_yang_names.add("target-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                        class LocalAddress(Entity):
                                            """
                                            Local Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                                self.yang_name = "local-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class TargetAddress(Entity):
                                            """
                                            Target Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                                self.yang_name = "target-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.state.is_set or
                                                (self.local_address is not None and self.local_address.has_data()) or
                                                (self.target_address is not None and self.target_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                (self.local_address is not None and self.local_address.has_operation()) or
                                                (self.target_address is not None and self.target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-address"):
                                                if (self.local_address is None):
                                                    self.local_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                    self.local_address.parent = self
                                                    self._children_name_map["local_address"] = "local-address"
                                                return self.local_address

                                            if (child_yang_name == "target-address"):
                                                if (self.target_address is None):
                                                    self.target_address = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                    self.target_address.parent = self
                                                    self._children_name_map["target_address"] = "target-address"
                                                return self.target_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-address" or name == "target-address" or name == "state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hello_type.is_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hello_type.yfilter != YFilter.not_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "adjacency-group" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hello_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-data"):
                                            if (self.link_hello_data is None):
                                                self.link_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                                self.link_hello_data.parent = self
                                                self._children_name_map["link_hello_data"] = "link-hello-data"
                                            return self.link_hello_data

                                        if (child_yang_name == "target-hello-data"):
                                            if (self.target_hello_data is None):
                                                self.target_hello_data = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                                self.target_hello_data.parent = self
                                                self._children_name_map["target_hello_data"] = "target-hello-data"
                                            return self.target_hello_data

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hello-type"):
                                            self.hello_type = value
                                            self.hello_type.value_namespace = name_space
                                            self.hello_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.adjacency_group is not None and self.adjacency_group.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-ipv6-adj-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "adjacency-group"):
                                        if (self.adjacency_group is None):
                                            self.adjacency_group = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                            self.adjacency_group.parent = self
                                            self._children_name_map["adjacency_group"] = "adjacency-group"
                                        return self.adjacency_group

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "adjacency-group"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    (self.detailed_information is not None and self.detailed_information.has_data()) or
                                    (self.protocol_information is not None and self.protocol_information.has_data()) or
                                    (self.tcp_information is not None and self.tcp_information.has_data()))

                            def has_operation(self):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    (self.detailed_information is not None and self.detailed_information.has_operation()) or
                                    (self.protocol_information is not None and self.protocol_information.has_operation()) or
                                    (self.tcp_information is not None and self.tcp_information.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "detailed-information"):
                                    if (self.detailed_information is None):
                                        self.detailed_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation()
                                        self.detailed_information.parent = self
                                        self._children_name_map["detailed_information"] = "detailed-information"
                                    return self.detailed_information

                                if (child_yang_name == "ldp-nbr-bound-ipv4-address-info"):
                                    for c in self.ldp_nbr_bound_ipv4_address_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_bound_ipv4_address_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-bound-ipv6-address-info"):
                                    for c in self.ldp_nbr_bound_ipv6_address_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_bound_ipv6_address_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-ipv4-adj-info"):
                                    for c in self.ldp_nbr_ipv4_adj_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_ipv4_adj_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-ipv6-adj-info"):
                                    for c in self.ldp_nbr_ipv6_adj_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_ipv6_adj_info.append(c)
                                    return c

                                if (child_yang_name == "protocol-information"):
                                    if (self.protocol_information is None):
                                        self.protocol_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation()
                                        self.protocol_information.parent = self
                                        self._children_name_map["protocol_information"] = "protocol-information"
                                    return self.protocol_information

                                if (child_yang_name == "tcp-information"):
                                    if (self.tcp_information is None):
                                        self.tcp_information = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation()
                                        self.tcp_information.parent = self
                                        self._children_name_map["tcp_information"] = "tcp-information"
                                    return self.tcp_information

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "detailed-information" or name == "ldp-nbr-bound-ipv4-address-info" or name == "ldp-nbr-bound-ipv6-address-info" or name == "ldp-nbr-ipv4-adj-info" or name == "ldp-nbr-ipv6-adj-info" or name == "protocol-information" or name == "tcp-information" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbors" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor"):
                                for c in self.neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors.Neighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class LdpId(Entity):
                        """
                        Local LDP Id
                        
                        .. attribute:: label_space_id
                        
                        	Label space identifier
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: ldp_id
                        
                        	LDP identifier
                        	**type**\:  str
                        
                        .. attribute:: lsr_id
                        
                        	LSR identifier
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.LdpId, self).__init__()

                            self.yang_name = "ldp-id"
                            self.yang_parent_name = "vrf"

                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "ldp_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.LdpId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.LdpId, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.label_space_id.is_set or
                                self.ldp_id.is_set or
                                self.lsr_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.ldp_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ldp-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-id"):
                                self.ldp_id = value
                                self.ldp_id.value_namespace = name_space
                                self.ldp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix


                    class Statistics(Entity):
                        """
                        The LDP Statistics
                        
                        .. attribute:: statistic
                        
                        	Statistical Information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`Statistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "vrf"

                            self.statistic = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics, self).__setattr__(name, value)


                        class Statistic(Entity):
                            """
                            Statistical Information on a particular LDP
                            neighbor
                            
                            .. attribute:: iccp_enabled
                            
                            	Is session ICCP enabled?
                            	**type**\:  bool
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: message_in
                            
                            	Message in count
                            	**type**\:   :py:class:`MessageIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageIn>`
                            
                            .. attribute:: message_out
                            
                            	Message out count
                            	**type**\:   :py:class:`MessageOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageOut>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic, self).__init__()

                                self.yang_name = "statistic"
                                self.yang_parent_name = "statistics"

                                self.iccp_enabled = YLeaf(YType.boolean, "iccp-enabled")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.message_in = MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageIn()
                                self.message_in.parent = self
                                self._children_name_map["message_in"] = "message-in"
                                self._children_yang_names.add("message-in")

                                self.message_out = MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageOut()
                                self.message_out.parent = self
                                self._children_name_map["message_out"] = "message-out"
                                self._children_yang_names.add("message-out")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("iccp_enabled",
                                                "label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic, self).__setattr__(name, value)


                            class MessageOut(Entity):
                                """
                                Message out count
                                
                                .. attribute:: address_count
                                
                                	Address message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: address_withdraw_count
                                
                                	Address withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_app_data_count
                                
                                	ICCP RG App Data count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_conn_count
                                
                                	ICCP RG Connect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_disconn_count
                                
                                	ICCP RG Disconnect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_notif_count
                                
                                	ICCP RG Notif count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_count
                                
                                	Init message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: keep_alive_count
                                
                                	Keepalive count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_abort_request_count
                                
                                	Label abort request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_map_count
                                
                                	Label map count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_release_count
                                
                                	Label release count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_request_count
                                
                                	Label request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_withdraw_count
                                
                                	Label withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: notification_count
                                
                                	Notification count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_count
                                
                                	Total message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__init__()

                                    self.yang_name = "message-out"
                                    self.yang_parent_name = "statistic"

                                    self.address_count = YLeaf(YType.uint32, "address-count")

                                    self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                    self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                    self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                    self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                    self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                    self.init_count = YLeaf(YType.uint32, "init-count")

                                    self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                    self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                    self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                    self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                    self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                    self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                    self.notification_count = YLeaf(YType.uint32, "notification-count")

                                    self.total_count = YLeaf(YType.uint32, "total-count")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_count",
                                                    "address_withdraw_count",
                                                    "iccp_rg_app_data_count",
                                                    "iccp_rg_conn_count",
                                                    "iccp_rg_disconn_count",
                                                    "iccp_rg_notif_count",
                                                    "init_count",
                                                    "keep_alive_count",
                                                    "label_abort_request_count",
                                                    "label_map_count",
                                                    "label_release_count",
                                                    "label_request_count",
                                                    "label_withdraw_count",
                                                    "notification_count",
                                                    "total_count") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_count.is_set or
                                        self.address_withdraw_count.is_set or
                                        self.iccp_rg_app_data_count.is_set or
                                        self.iccp_rg_conn_count.is_set or
                                        self.iccp_rg_disconn_count.is_set or
                                        self.iccp_rg_notif_count.is_set or
                                        self.init_count.is_set or
                                        self.keep_alive_count.is_set or
                                        self.label_abort_request_count.is_set or
                                        self.label_map_count.is_set or
                                        self.label_release_count.is_set or
                                        self.label_request_count.is_set or
                                        self.label_withdraw_count.is_set or
                                        self.notification_count.is_set or
                                        self.total_count.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_count.yfilter != YFilter.not_set or
                                        self.address_withdraw_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                        self.init_count.yfilter != YFilter.not_set or
                                        self.keep_alive_count.yfilter != YFilter.not_set or
                                        self.label_abort_request_count.yfilter != YFilter.not_set or
                                        self.label_map_count.yfilter != YFilter.not_set or
                                        self.label_release_count.yfilter != YFilter.not_set or
                                        self.label_request_count.yfilter != YFilter.not_set or
                                        self.label_withdraw_count.yfilter != YFilter.not_set or
                                        self.notification_count.yfilter != YFilter.not_set or
                                        self.total_count.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "message-out" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_count.get_name_leafdata())
                                    if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                    if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                    if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                    if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                    if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                    if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_count.get_name_leafdata())
                                    if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                    if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                    if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                    if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                    if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                    if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                    if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.notification_count.get_name_leafdata())
                                    if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_count.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-count"):
                                        self.address_count = value
                                        self.address_count.value_namespace = name_space
                                        self.address_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "address-withdraw-count"):
                                        self.address_withdraw_count = value
                                        self.address_withdraw_count.value_namespace = name_space
                                        self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-app-data-count"):
                                        self.iccp_rg_app_data_count = value
                                        self.iccp_rg_app_data_count.value_namespace = name_space
                                        self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-conn-count"):
                                        self.iccp_rg_conn_count = value
                                        self.iccp_rg_conn_count.value_namespace = name_space
                                        self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-disconn-count"):
                                        self.iccp_rg_disconn_count = value
                                        self.iccp_rg_disconn_count.value_namespace = name_space
                                        self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-notif-count"):
                                        self.iccp_rg_notif_count = value
                                        self.iccp_rg_notif_count.value_namespace = name_space
                                        self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-count"):
                                        self.init_count = value
                                        self.init_count.value_namespace = name_space
                                        self.init_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-count"):
                                        self.keep_alive_count = value
                                        self.keep_alive_count.value_namespace = name_space
                                        self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-abort-request-count"):
                                        self.label_abort_request_count = value
                                        self.label_abort_request_count.value_namespace = name_space
                                        self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-map-count"):
                                        self.label_map_count = value
                                        self.label_map_count.value_namespace = name_space
                                        self.label_map_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-release-count"):
                                        self.label_release_count = value
                                        self.label_release_count.value_namespace = name_space
                                        self.label_release_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-request-count"):
                                        self.label_request_count = value
                                        self.label_request_count.value_namespace = name_space
                                        self.label_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-withdraw-count"):
                                        self.label_withdraw_count = value
                                        self.label_withdraw_count.value_namespace = name_space
                                        self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "notification-count"):
                                        self.notification_count = value
                                        self.notification_count.value_namespace = name_space
                                        self.notification_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-count"):
                                        self.total_count = value
                                        self.total_count.value_namespace = name_space
                                        self.total_count.value_namespace_prefix = name_space_prefix


                            class MessageIn(Entity):
                                """
                                Message in count
                                
                                .. attribute:: address_count
                                
                                	Address message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: address_withdraw_count
                                
                                	Address withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_app_data_count
                                
                                	ICCP RG App Data count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_conn_count
                                
                                	ICCP RG Connect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_disconn_count
                                
                                	ICCP RG Disconnect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_notif_count
                                
                                	ICCP RG Notif count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_count
                                
                                	Init message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: keep_alive_count
                                
                                	Keepalive count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_abort_request_count
                                
                                	Label abort request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_map_count
                                
                                	Label map count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_release_count
                                
                                	Label release count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_request_count
                                
                                	Label request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_withdraw_count
                                
                                	Label withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: notification_count
                                
                                	Notification count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_count
                                
                                	Total message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__init__()

                                    self.yang_name = "message-in"
                                    self.yang_parent_name = "statistic"

                                    self.address_count = YLeaf(YType.uint32, "address-count")

                                    self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                    self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                    self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                    self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                    self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                    self.init_count = YLeaf(YType.uint32, "init-count")

                                    self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                    self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                    self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                    self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                    self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                    self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                    self.notification_count = YLeaf(YType.uint32, "notification-count")

                                    self.total_count = YLeaf(YType.uint32, "total-count")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_count",
                                                    "address_withdraw_count",
                                                    "iccp_rg_app_data_count",
                                                    "iccp_rg_conn_count",
                                                    "iccp_rg_disconn_count",
                                                    "iccp_rg_notif_count",
                                                    "init_count",
                                                    "keep_alive_count",
                                                    "label_abort_request_count",
                                                    "label_map_count",
                                                    "label_release_count",
                                                    "label_request_count",
                                                    "label_withdraw_count",
                                                    "notification_count",
                                                    "total_count") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_count.is_set or
                                        self.address_withdraw_count.is_set or
                                        self.iccp_rg_app_data_count.is_set or
                                        self.iccp_rg_conn_count.is_set or
                                        self.iccp_rg_disconn_count.is_set or
                                        self.iccp_rg_notif_count.is_set or
                                        self.init_count.is_set or
                                        self.keep_alive_count.is_set or
                                        self.label_abort_request_count.is_set or
                                        self.label_map_count.is_set or
                                        self.label_release_count.is_set or
                                        self.label_request_count.is_set or
                                        self.label_withdraw_count.is_set or
                                        self.notification_count.is_set or
                                        self.total_count.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_count.yfilter != YFilter.not_set or
                                        self.address_withdraw_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                        self.init_count.yfilter != YFilter.not_set or
                                        self.keep_alive_count.yfilter != YFilter.not_set or
                                        self.label_abort_request_count.yfilter != YFilter.not_set or
                                        self.label_map_count.yfilter != YFilter.not_set or
                                        self.label_release_count.yfilter != YFilter.not_set or
                                        self.label_request_count.yfilter != YFilter.not_set or
                                        self.label_withdraw_count.yfilter != YFilter.not_set or
                                        self.notification_count.yfilter != YFilter.not_set or
                                        self.total_count.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "message-in" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_count.get_name_leafdata())
                                    if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                    if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                    if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                    if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                    if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                    if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_count.get_name_leafdata())
                                    if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                    if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                    if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                    if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                    if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                    if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                    if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.notification_count.get_name_leafdata())
                                    if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_count.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-count"):
                                        self.address_count = value
                                        self.address_count.value_namespace = name_space
                                        self.address_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "address-withdraw-count"):
                                        self.address_withdraw_count = value
                                        self.address_withdraw_count.value_namespace = name_space
                                        self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-app-data-count"):
                                        self.iccp_rg_app_data_count = value
                                        self.iccp_rg_app_data_count.value_namespace = name_space
                                        self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-conn-count"):
                                        self.iccp_rg_conn_count = value
                                        self.iccp_rg_conn_count.value_namespace = name_space
                                        self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-disconn-count"):
                                        self.iccp_rg_disconn_count = value
                                        self.iccp_rg_disconn_count.value_namespace = name_space
                                        self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-notif-count"):
                                        self.iccp_rg_notif_count = value
                                        self.iccp_rg_notif_count.value_namespace = name_space
                                        self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-count"):
                                        self.init_count = value
                                        self.init_count.value_namespace = name_space
                                        self.init_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-count"):
                                        self.keep_alive_count = value
                                        self.keep_alive_count.value_namespace = name_space
                                        self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-abort-request-count"):
                                        self.label_abort_request_count = value
                                        self.label_abort_request_count.value_namespace = name_space
                                        self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-map-count"):
                                        self.label_map_count = value
                                        self.label_map_count.value_namespace = name_space
                                        self.label_map_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-release-count"):
                                        self.label_release_count = value
                                        self.label_release_count.value_namespace = name_space
                                        self.label_release_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-request-count"):
                                        self.label_request_count = value
                                        self.label_request_count.value_namespace = name_space
                                        self.label_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-withdraw-count"):
                                        self.label_withdraw_count = value
                                        self.label_withdraw_count.value_namespace = name_space
                                        self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "notification-count"):
                                        self.notification_count = value
                                        self.notification_count.value_namespace = name_space
                                        self.notification_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-count"):
                                        self.total_count = value
                                        self.total_count.value_namespace = name_space
                                        self.total_count.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.iccp_enabled.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    (self.message_in is not None and self.message_in.has_data()) or
                                    (self.message_out is not None and self.message_out.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.iccp_enabled.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    (self.message_in is not None and self.message_in.has_operation()) or
                                    (self.message_out is not None and self.message_out.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.iccp_enabled.is_set or self.iccp_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_enabled.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "message-in"):
                                    if (self.message_in is None):
                                        self.message_in = MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageIn()
                                        self.message_in.parent = self
                                        self._children_name_map["message_in"] = "message-in"
                                    return self.message_in

                                if (child_yang_name == "message-out"):
                                    if (self.message_out is None):
                                        self.message_out = MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic.MessageOut()
                                        self.message_out.parent = self
                                        self._children_name_map["message_out"] = "message-out"
                                    return self.message_out

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "message-in" or name == "message-out" or name == "iccp-enabled" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "iccp-enabled"):
                                    self.iccp_enabled = value
                                    self.iccp_enabled.value_namespace = name_space
                                    self.iccp_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.statistic:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.statistic:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "statistic"):
                                for c in self.statistic:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics.Statistic()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.statistic.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "statistic"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.vrf_name.is_set or
                            (self.afs is not None and self.afs.has_data()) or
                            (self.backoff_parameters is not None and self.backoff_parameters.has_data()) or
                            (self.backoffs is not None and self.backoffs.has_data()) or
                            (self.capabilities is not None and self.capabilities.has_data()) or
                            (self.graceful_restart is not None and self.graceful_restart.has_data()) or
                            (self.issu is not None and self.issu.has_data()) or
                            (self.ldp_id is not None and self.ldp_id.has_data()) or
                            (self.neighbor_briefs is not None and self.neighbor_briefs.has_data()) or
                            (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_data()) or
                            (self.neighbors is not None and self.neighbors.has_data()) or
                            (self.nsr is not None and self.nsr.has_data()) or
                            (self.parameters is not None and self.parameters.has_data()) or
                            (self.statistics is not None and self.statistics.has_data()) or
                            (self.summary is not None and self.summary.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.vrf_name.yfilter != YFilter.not_set or
                            (self.afs is not None and self.afs.has_operation()) or
                            (self.backoff_parameters is not None and self.backoff_parameters.has_operation()) or
                            (self.backoffs is not None and self.backoffs.has_operation()) or
                            (self.capabilities is not None and self.capabilities.has_operation()) or
                            (self.graceful_restart is not None and self.graceful_restart.has_operation()) or
                            (self.issu is not None and self.issu.has_operation()) or
                            (self.ldp_id is not None and self.ldp_id.has_operation()) or
                            (self.neighbor_briefs is not None and self.neighbor_briefs.has_operation()) or
                            (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_operation()) or
                            (self.neighbors is not None and self.neighbors.has_operation()) or
                            (self.nsr is not None and self.nsr.has_operation()) or
                            (self.parameters is not None and self.parameters.has_operation()) or
                            (self.statistics is not None and self.statistics.has_operation()) or
                            (self.summary is not None and self.summary.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/vrfs/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "afs"):
                            if (self.afs is None):
                                self.afs = MplsLdp.Global_.Standby.Vrfs.Vrf.Afs()
                                self.afs.parent = self
                                self._children_name_map["afs"] = "afs"
                            return self.afs

                        if (child_yang_name == "backoff-parameters"):
                            if (self.backoff_parameters is None):
                                self.backoff_parameters = MplsLdp.Global_.Standby.Vrfs.Vrf.BackoffParameters()
                                self.backoff_parameters.parent = self
                                self._children_name_map["backoff_parameters"] = "backoff-parameters"
                            return self.backoff_parameters

                        if (child_yang_name == "backoffs"):
                            if (self.backoffs is None):
                                self.backoffs = MplsLdp.Global_.Standby.Vrfs.Vrf.Backoffs()
                                self.backoffs.parent = self
                                self._children_name_map["backoffs"] = "backoffs"
                            return self.backoffs

                        if (child_yang_name == "capabilities"):
                            if (self.capabilities is None):
                                self.capabilities = MplsLdp.Global_.Standby.Vrfs.Vrf.Capabilities()
                                self.capabilities.parent = self
                                self._children_name_map["capabilities"] = "capabilities"
                            return self.capabilities

                        if (child_yang_name == "graceful-restart"):
                            if (self.graceful_restart is None):
                                self.graceful_restart = MplsLdp.Global_.Standby.Vrfs.Vrf.GracefulRestart()
                                self.graceful_restart.parent = self
                                self._children_name_map["graceful_restart"] = "graceful-restart"
                            return self.graceful_restart

                        if (child_yang_name == "issu"):
                            if (self.issu is None):
                                self.issu = MplsLdp.Global_.Standby.Vrfs.Vrf.Issu()
                                self.issu.parent = self
                                self._children_name_map["issu"] = "issu"
                            return self.issu

                        if (child_yang_name == "ldp-id"):
                            if (self.ldp_id is None):
                                self.ldp_id = MplsLdp.Global_.Standby.Vrfs.Vrf.LdpId()
                                self.ldp_id.parent = self
                                self._children_name_map["ldp_id"] = "ldp-id"
                            return self.ldp_id

                        if (child_yang_name == "neighbor-briefs"):
                            if (self.neighbor_briefs is None):
                                self.neighbor_briefs = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborBriefs()
                                self.neighbor_briefs.parent = self
                                self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                            return self.neighbor_briefs

                        if (child_yang_name == "neighbor-capabilities"):
                            if (self.neighbor_capabilities is None):
                                self.neighbor_capabilities = MplsLdp.Global_.Standby.Vrfs.Vrf.NeighborCapabilities()
                                self.neighbor_capabilities.parent = self
                                self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                            return self.neighbor_capabilities

                        if (child_yang_name == "neighbors"):
                            if (self.neighbors is None):
                                self.neighbors = MplsLdp.Global_.Standby.Vrfs.Vrf.Neighbors()
                                self.neighbors.parent = self
                                self._children_name_map["neighbors"] = "neighbors"
                            return self.neighbors

                        if (child_yang_name == "nsr"):
                            if (self.nsr is None):
                                self.nsr = MplsLdp.Global_.Standby.Vrfs.Vrf.Nsr()
                                self.nsr.parent = self
                                self._children_name_map["nsr"] = "nsr"
                            return self.nsr

                        if (child_yang_name == "parameters"):
                            if (self.parameters is None):
                                self.parameters = MplsLdp.Global_.Standby.Vrfs.Vrf.Parameters()
                                self.parameters.parent = self
                                self._children_name_map["parameters"] = "parameters"
                            return self.parameters

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsLdp.Global_.Standby.Vrfs.Vrf.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        if (child_yang_name == "summary"):
                            if (self.summary is None):
                                self.summary = MplsLdp.Global_.Standby.Vrfs.Vrf.Summary()
                                self.summary.parent = self
                                self._children_name_map["summary"] = "summary"
                            return self.summary

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "afs" or name == "backoff-parameters" or name == "backoffs" or name == "capabilities" or name == "graceful-restart" or name == "issu" or name == "ldp-id" or name == "neighbor-briefs" or name == "neighbor-capabilities" or name == "neighbors" or name == "nsr" or name == "parameters" or name == "statistics" or name == "summary" or name == "vrf-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "vrf-name"):
                            self.vrf_name = value
                            self.vrf_name.value_namespace = name_space
                            self.vrf_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.vrf:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.vrf:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "vrfs" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vrf"):
                        for c in self.vrf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Global_.Standby.Vrfs.Vrf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.vrf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vrf"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class DiscoverySummaryAll(Entity):
                """
                Summary information regarding LDP discovery
                
                .. attribute:: local_ldp_id
                
                	Local LDP identifier
                	**type**\:  str
                
                .. attribute:: num_of_active_ldp_interfaces
                
                	Number of active LDP enabled interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_addr_recv
                
                	Number of hello discoveries received with bad source address
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_hello_pdu
                
                	Number of hello discoveries received with bad hello PDU
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_xport_addr
                
                	Number of hello discoveries received with bad export address
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_same_router_id
                
                	Number of hello discoveries received with the same router id as this router
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_wrong_router_id
                
                	Number of hello discoveries received with the router id that is not destined for this router
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_ldp_interfaces
                
                	Total Number of LDP configured interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_lnk_disc_recv
                
                	Number of link hello discoveries in recv state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_lnk_disc_xmit
                
                	Number of link hello discoveries in xmit state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_tgt_disc_recv
                
                	Number of targeted hello discoveries in recv state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_tgt_disc_xmit
                
                	Number of targeted hello discoveries in xmit state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Standby.DiscoverySummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Standby.DiscoverySummaryAll, self).__init__()

                    self.yang_name = "discovery-summary-all"
                    self.yang_parent_name = "standby"

                    self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                    self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                    self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                    self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                    self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                    self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                    self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                    self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                    self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                    self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                    self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                    self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                    self.vrf = MplsLdp.Global_.Standby.DiscoverySummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("local_ldp_id",
                                    "num_of_active_ldp_interfaces",
                                    "num_of_disc_with_bad_addr_recv",
                                    "num_of_disc_with_bad_hello_pdu",
                                    "num_of_disc_with_bad_xport_addr",
                                    "num_of_disc_with_same_router_id",
                                    "num_of_disc_with_wrong_router_id",
                                    "num_of_ldp_interfaces",
                                    "num_of_lnk_disc_recv",
                                    "num_of_lnk_disc_xmit",
                                    "num_of_tgt_disc_recv",
                                    "num_of_tgt_disc_xmit") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Standby.DiscoverySummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Standby.DiscoverySummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Standby.DiscoverySummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "discovery-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Standby.DiscoverySummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Standby.DiscoverySummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/discovery-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.local_ldp_id.is_set or
                        self.num_of_active_ldp_interfaces.is_set or
                        self.num_of_disc_with_bad_addr_recv.is_set or
                        self.num_of_disc_with_bad_hello_pdu.is_set or
                        self.num_of_disc_with_bad_xport_addr.is_set or
                        self.num_of_disc_with_same_router_id.is_set or
                        self.num_of_disc_with_wrong_router_id.is_set or
                        self.num_of_ldp_interfaces.is_set or
                        self.num_of_lnk_disc_recv.is_set or
                        self.num_of_lnk_disc_xmit.is_set or
                        self.num_of_tgt_disc_recv.is_set or
                        self.num_of_tgt_disc_xmit.is_set or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.local_ldp_id.yfilter != YFilter.not_set or
                        self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                        self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                        self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                        self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                        self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                        self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                        self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                        self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "discovery-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/standby/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                    if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                    if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                    if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                    if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                    if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                    if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                    if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                    if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                    if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                    if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                    if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Standby.DiscoverySummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "local-ldp-id"):
                        self.local_ldp_id = value
                        self.local_ldp_id.value_namespace = name_space
                        self.local_ldp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-active-ldp-interfaces"):
                        self.num_of_active_ldp_interfaces = value
                        self.num_of_active_ldp_interfaces.value_namespace = name_space
                        self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-addr-recv"):
                        self.num_of_disc_with_bad_addr_recv = value
                        self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                        self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-hello-pdu"):
                        self.num_of_disc_with_bad_hello_pdu = value
                        self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                        self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-xport-addr"):
                        self.num_of_disc_with_bad_xport_addr = value
                        self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                        self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-same-router-id"):
                        self.num_of_disc_with_same_router_id = value
                        self.num_of_disc_with_same_router_id.value_namespace = name_space
                        self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-wrong-router-id"):
                        self.num_of_disc_with_wrong_router_id = value
                        self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                        self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-ldp-interfaces"):
                        self.num_of_ldp_interfaces = value
                        self.num_of_ldp_interfaces.value_namespace = name_space
                        self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-lnk-disc-recv"):
                        self.num_of_lnk_disc_recv = value
                        self.num_of_lnk_disc_recv.value_namespace = name_space
                        self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-lnk-disc-xmit"):
                        self.num_of_lnk_disc_xmit = value
                        self.num_of_lnk_disc_xmit.value_namespace = name_space
                        self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-tgt-disc-recv"):
                        self.num_of_tgt_disc_recv = value
                        self.num_of_tgt_disc_recv.value_namespace = name_space
                        self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-tgt-disc-xmit"):
                        self.num_of_tgt_disc_xmit = value
                        self.num_of_tgt_disc_xmit.value_namespace = name_space
                        self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    (self.ato_mdb_table_entries is not None and self.ato_mdb_table_entries.has_data()) or
                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                    (self.default_vrf is not None and self.default_vrf.has_data()) or
                    (self.discovery_summary_all is not None and self.discovery_summary_all.has_data()) or
                    (self.forwarding_summary_all is not None and self.forwarding_summary_all.has_data()) or
                    (self.nsr_summary_all is not None and self.nsr_summary_all.has_data()) or
                    (self.summary is not None and self.summary.has_data()) or
                    (self.vrfs is not None and self.vrfs.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.ato_mdb_table_entries is not None and self.ato_mdb_table_entries.has_operation()) or
                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                    (self.default_vrf is not None and self.default_vrf.has_operation()) or
                    (self.discovery_summary_all is not None and self.discovery_summary_all.has_operation()) or
                    (self.forwarding_summary_all is not None and self.forwarding_summary_all.has_operation()) or
                    (self.nsr_summary_all is not None and self.nsr_summary_all.has_operation()) or
                    (self.summary is not None and self.summary.has_operation()) or
                    (self.vrfs is not None and self.vrfs.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "standby" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ato-mdb-table-entries"):
                    if (self.ato_mdb_table_entries is None):
                        self.ato_mdb_table_entries = MplsLdp.Global_.Standby.AtoMdbTableEntries()
                        self.ato_mdb_table_entries.parent = self
                        self._children_name_map["ato_mdb_table_entries"] = "ato-mdb-table-entries"
                    return self.ato_mdb_table_entries

                if (child_yang_name == "bindings-summary-all"):
                    if (self.bindings_summary_all is None):
                        self.bindings_summary_all = MplsLdp.Global_.Standby.BindingsSummaryAll()
                        self.bindings_summary_all.parent = self
                        self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                    return self.bindings_summary_all

                if (child_yang_name == "default-vrf"):
                    if (self.default_vrf is None):
                        self.default_vrf = MplsLdp.Global_.Standby.DefaultVrf()
                        self.default_vrf.parent = self
                        self._children_name_map["default_vrf"] = "default-vrf"
                    return self.default_vrf

                if (child_yang_name == "discovery-summary-all"):
                    if (self.discovery_summary_all is None):
                        self.discovery_summary_all = MplsLdp.Global_.Standby.DiscoverySummaryAll()
                        self.discovery_summary_all.parent = self
                        self._children_name_map["discovery_summary_all"] = "discovery-summary-all"
                    return self.discovery_summary_all

                if (child_yang_name == "forwarding-summary-all"):
                    if (self.forwarding_summary_all is None):
                        self.forwarding_summary_all = MplsLdp.Global_.Standby.ForwardingSummaryAll()
                        self.forwarding_summary_all.parent = self
                        self._children_name_map["forwarding_summary_all"] = "forwarding-summary-all"
                    return self.forwarding_summary_all

                if (child_yang_name == "nsr-summary-all"):
                    if (self.nsr_summary_all is None):
                        self.nsr_summary_all = MplsLdp.Global_.Standby.NsrSummaryAll()
                        self.nsr_summary_all.parent = self
                        self._children_name_map["nsr_summary_all"] = "nsr-summary-all"
                    return self.nsr_summary_all

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsLdp.Global_.Standby.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                if (child_yang_name == "vrfs"):
                    if (self.vrfs is None):
                        self.vrfs = MplsLdp.Global_.Standby.Vrfs()
                        self.vrfs.parent = self
                        self._children_name_map["vrfs"] = "vrfs"
                    return self.vrfs

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ato-mdb-table-entries" or name == "bindings-summary-all" or name == "default-vrf" or name == "discovery-summary-all" or name == "forwarding-summary-all" or name == "nsr-summary-all" or name == "summary" or name == "vrfs"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Active(Entity):
            """
            Active MPLS LDP operational data
            
            .. attribute:: ato_mdb_table_entries
            
            	AToM DB Table
            	**type**\:   :py:class:`AtoMdbTableEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries>`
            
            .. attribute:: bindings_summary_all
            
            	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
            	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.BindingsSummaryAll>`
            
            .. attribute:: default_vrf
            
            	DefaultVRF specific operational data
            	**type**\:   :py:class:`DefaultVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf>`
            
            .. attribute:: discovery_summary_all
            
            	Summary information regarding LDP discovery
            	**type**\:   :py:class:`DiscoverySummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DiscoverySummaryAll>`
            
            .. attribute:: forwarding_summary_all
            
            	Summary information regarding LDP forwarding setup
            	**type**\:   :py:class:`ForwardingSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll>`
            
            .. attribute:: nsr_summary_all
            
            	Summary information regarding LDP NSR State
            	**type**\:   :py:class:`NsrSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.NsrSummaryAll>`
            
            .. attribute:: summary
            
            	LDP summary
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Summary>`
            
            .. attribute:: vrfs
            
            	VRF specific operational data
            	**type**\:   :py:class:`Vrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs>`
            
            

            """

            _prefix = 'mpls-ldp-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLdp.Global_.Active, self).__init__()

                self.yang_name = "active"
                self.yang_parent_name = "global"

                self.ato_mdb_table_entries = MplsLdp.Global_.Active.AtoMdbTableEntries()
                self.ato_mdb_table_entries.parent = self
                self._children_name_map["ato_mdb_table_entries"] = "ato-mdb-table-entries"
                self._children_yang_names.add("ato-mdb-table-entries")

                self.bindings_summary_all = MplsLdp.Global_.Active.BindingsSummaryAll()
                self.bindings_summary_all.parent = self
                self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                self._children_yang_names.add("bindings-summary-all")

                self.default_vrf = MplsLdp.Global_.Active.DefaultVrf()
                self.default_vrf.parent = self
                self._children_name_map["default_vrf"] = "default-vrf"
                self._children_yang_names.add("default-vrf")

                self.discovery_summary_all = MplsLdp.Global_.Active.DiscoverySummaryAll()
                self.discovery_summary_all.parent = self
                self._children_name_map["discovery_summary_all"] = "discovery-summary-all"
                self._children_yang_names.add("discovery-summary-all")

                self.forwarding_summary_all = MplsLdp.Global_.Active.ForwardingSummaryAll()
                self.forwarding_summary_all.parent = self
                self._children_name_map["forwarding_summary_all"] = "forwarding-summary-all"
                self._children_yang_names.add("forwarding-summary-all")

                self.nsr_summary_all = MplsLdp.Global_.Active.NsrSummaryAll()
                self.nsr_summary_all.parent = self
                self._children_name_map["nsr_summary_all"] = "nsr-summary-all"
                self._children_yang_names.add("nsr-summary-all")

                self.summary = MplsLdp.Global_.Active.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")

                self.vrfs = MplsLdp.Global_.Active.Vrfs()
                self.vrfs.parent = self
                self._children_name_map["vrfs"] = "vrfs"
                self._children_yang_names.add("vrfs")


            class DefaultVrf(Entity):
                """
                DefaultVRF specific operational data
                
                .. attribute:: afs
                
                	Address Family specific operational data
                	**type**\:   :py:class:`Afs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs>`
                
                .. attribute:: backoff_parameters
                
                	The LDP Backoff Parameters
                	**type**\:   :py:class:`BackoffParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.BackoffParameters>`
                
                .. attribute:: backoffs
                
                	The LDP backoff
                	**type**\:   :py:class:`Backoffs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Backoffs>`
                
                .. attribute:: capabilities
                
                	LDP capability database information
                	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Capabilities>`
                
                .. attribute:: graceful_restart
                
                	LDP Graceful Restart info
                	**type**\:   :py:class:`GracefulRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.GracefulRestart>`
                
                .. attribute:: issu
                
                	LDP ISSU related information
                	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu>`
                
                .. attribute:: ldp_id
                
                	Local LDP Id
                	**type**\:   :py:class:`LdpId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.LdpId>`
                
                .. attribute:: neighbor_briefs
                
                	The LDP Neighbors (brief)
                	**type**\:   :py:class:`NeighborBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs>`
                
                .. attribute:: neighbor_capabilities
                
                	LDP Neighbors Capabilities
                	**type**\:   :py:class:`NeighborCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities>`
                
                .. attribute:: neighbors
                
                	The LDP Neighbors
                	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors>`
                
                .. attribute:: nsr
                
                	LDP NSR related information
                	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr>`
                
                .. attribute:: parameters
                
                	LDP parameters
                	**type**\:   :py:class:`Parameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Parameters>`
                
                .. attribute:: statistics
                
                	The LDP Statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Statistics>`
                
                .. attribute:: summary
                
                	LDP VRF summary
                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Summary>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.DefaultVrf, self).__init__()

                    self.yang_name = "default-vrf"
                    self.yang_parent_name = "active"

                    self.afs = MplsLdp.Global_.Active.DefaultVrf.Afs()
                    self.afs.parent = self
                    self._children_name_map["afs"] = "afs"
                    self._children_yang_names.add("afs")

                    self.backoff_parameters = MplsLdp.Global_.Active.DefaultVrf.BackoffParameters()
                    self.backoff_parameters.parent = self
                    self._children_name_map["backoff_parameters"] = "backoff-parameters"
                    self._children_yang_names.add("backoff-parameters")

                    self.backoffs = MplsLdp.Global_.Active.DefaultVrf.Backoffs()
                    self.backoffs.parent = self
                    self._children_name_map["backoffs"] = "backoffs"
                    self._children_yang_names.add("backoffs")

                    self.capabilities = MplsLdp.Global_.Active.DefaultVrf.Capabilities()
                    self.capabilities.parent = self
                    self._children_name_map["capabilities"] = "capabilities"
                    self._children_yang_names.add("capabilities")

                    self.graceful_restart = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart()
                    self.graceful_restart.parent = self
                    self._children_name_map["graceful_restart"] = "graceful-restart"
                    self._children_yang_names.add("graceful-restart")

                    self.issu = MplsLdp.Global_.Active.DefaultVrf.Issu()
                    self.issu.parent = self
                    self._children_name_map["issu"] = "issu"
                    self._children_yang_names.add("issu")

                    self.ldp_id = MplsLdp.Global_.Active.DefaultVrf.LdpId()
                    self.ldp_id.parent = self
                    self._children_name_map["ldp_id"] = "ldp-id"
                    self._children_yang_names.add("ldp-id")

                    self.neighbor_briefs = MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs()
                    self.neighbor_briefs.parent = self
                    self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                    self._children_yang_names.add("neighbor-briefs")

                    self.neighbor_capabilities = MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities()
                    self.neighbor_capabilities.parent = self
                    self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                    self._children_yang_names.add("neighbor-capabilities")

                    self.neighbors = MplsLdp.Global_.Active.DefaultVrf.Neighbors()
                    self.neighbors.parent = self
                    self._children_name_map["neighbors"] = "neighbors"
                    self._children_yang_names.add("neighbors")

                    self.nsr = MplsLdp.Global_.Active.DefaultVrf.Nsr()
                    self.nsr.parent = self
                    self._children_name_map["nsr"] = "nsr"
                    self._children_yang_names.add("nsr")

                    self.parameters = MplsLdp.Global_.Active.DefaultVrf.Parameters()
                    self.parameters.parent = self
                    self._children_name_map["parameters"] = "parameters"
                    self._children_yang_names.add("parameters")

                    self.statistics = MplsLdp.Global_.Active.DefaultVrf.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.summary = MplsLdp.Global_.Active.DefaultVrf.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._children_yang_names.add("summary")


                class GracefulRestart(Entity):
                    """
                    LDP Graceful Restart info
                    
                    .. attribute:: forwarding_state_hold_timer_remaining_seconds
                    
                    	Forwarding state hold timer remaining time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: graceful_restartable_neighbor
                    
                    	Vector of graceful restart neighbor information
                    	**type**\: list of    :py:class:`GracefulRestartableNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor>`
                    
                    .. attribute:: is_forwarding_state_hold_timer_running
                    
                    	Is graceful restart forwarding state hold timer running
                    	**type**\:  bool
                    
                    .. attribute:: vrf
                    
                    	VRF information
                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.Vrf>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart, self).__init__()

                        self.yang_name = "graceful-restart"
                        self.yang_parent_name = "default-vrf"

                        self.forwarding_state_hold_timer_remaining_seconds = YLeaf(YType.uint32, "forwarding-state-hold-timer-remaining-seconds")

                        self.is_forwarding_state_hold_timer_running = YLeaf(YType.boolean, "is-forwarding-state-hold-timer-running")

                        self.vrf = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.Vrf()
                        self.vrf.parent = self
                        self._children_name_map["vrf"] = "vrf"
                        self._children_yang_names.add("vrf")

                        self.graceful_restartable_neighbor = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("forwarding_state_hold_timer_remaining_seconds",
                                        "is_forwarding_state_hold_timer_running") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart, self).__setattr__(name, value)


                    class Vrf(Entity):
                        """
                        VRF information
                        
                        .. attribute:: id
                        
                        	VRF Id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.Vrf, self).__init__()

                            self.yang_name = "vrf"
                            self.yang_parent_name = "graceful-restart"

                            self.id = YLeaf(YType.uint32, "id")

                            self.name = YLeaf(YType.str, "name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("id",
                                            "name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.Vrf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.Vrf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.id.is_set or
                                self.name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.id.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/graceful-restart/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.id.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "id" or name == "name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "id"):
                                self.id = value
                                self.id.value_namespace = name_space
                                self.id.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix


                    class GracefulRestartableNeighbor(Entity):
                        """
                        Vector of graceful restart neighbor information
                        
                        .. attribute:: connect_count
                        
                        	ConnectCount
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_address
                        
                        	Addresses bound to GR down Nbr
                        	**type**\: list of    :py:class:`DownNbrAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress>`
                        
                        .. attribute:: down_nbr_down_reason
                        
                        	Session down reason code
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_flags
                        
                        	Flags
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_flap_count
                        
                        	Count of back2back flaps
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: down_nbr_interface
                        
                        	Interfaces bound to GR down Nbr
                        	**type**\: list of    :py:class:`DownNbrInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface>`
                        
                        .. attribute:: gr_peer
                        
                        	GR peer LDP Id
                        	**type**\:   :py:class:`GrPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer>`
                        
                        .. attribute:: is_liveness_timer_running
                        
                        	Is liveness timer running
                        	**type**\:  bool
                        
                        .. attribute:: is_neighbor_up
                        
                        	Is neighbor up
                        	**type**\:  bool
                        
                        .. attribute:: is_recovery_timer_running
                        
                        	Is recovery timer running
                        	**type**\:  bool
                        
                        .. attribute:: liveness_timer_remaining_seconds
                        
                        	Remaining time from liveness timer
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: recovery_timer_remaining_seconds
                        
                        	Recovery timer remining time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__init__()

                            self.yang_name = "graceful-restartable-neighbor"
                            self.yang_parent_name = "graceful-restart"

                            self.connect_count = YLeaf(YType.uint32, "connect-count")

                            self.down_nbr_down_reason = YLeaf(YType.uint32, "down-nbr-down-reason")

                            self.down_nbr_flags = YLeaf(YType.uint32, "down-nbr-flags")

                            self.down_nbr_flap_count = YLeaf(YType.uint8, "down-nbr-flap-count")

                            self.is_liveness_timer_running = YLeaf(YType.boolean, "is-liveness-timer-running")

                            self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                            self.is_recovery_timer_running = YLeaf(YType.boolean, "is-recovery-timer-running")

                            self.liveness_timer_remaining_seconds = YLeaf(YType.uint32, "liveness-timer-remaining-seconds")

                            self.recovery_timer_remaining_seconds = YLeaf(YType.uint32, "recovery-timer-remaining-seconds")

                            self.gr_peer = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                            self.gr_peer.parent = self
                            self._children_name_map["gr_peer"] = "gr-peer"
                            self._children_yang_names.add("gr-peer")

                            self.down_nbr_address = YList(self)
                            self.down_nbr_interface = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("connect_count",
                                            "down_nbr_down_reason",
                                            "down_nbr_flags",
                                            "down_nbr_flap_count",
                                            "is_liveness_timer_running",
                                            "is_neighbor_up",
                                            "is_recovery_timer_running",
                                            "liveness_timer_remaining_seconds",
                                            "recovery_timer_remaining_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)


                        class GrPeer(Entity):
                            """
                            GR peer LDP Id
                            
                            .. attribute:: label_space_id
                            
                            	Label space identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: ldp_id
                            
                            	LDP identifier
                            	**type**\:  str
                            
                            .. attribute:: lsr_id
                            
                            	LSR identifier
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__init__()

                                self.yang_name = "gr-peer"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "ldp_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.label_space_id.is_set or
                                    self.ldp_id.is_set or
                                    self.lsr_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.ldp_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gr-peer" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/graceful-restart/graceful-restartable-neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-id"):
                                    self.ldp_id = value
                                    self.ldp_id.value_namespace = name_space
                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix


                        class DownNbrInterface(Entity):
                            """
                            Interfaces bound to GR down Nbr
                            
                            .. attribute:: address_family
                            
                            	Interface adj Address Family
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: interface_handle
                            
                            	Interfaces handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__init__()

                                self.yang_name = "down-nbr-interface"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.interface_handle = YLeaf(YType.str, "interface-handle")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "interface_handle") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.interface_handle.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.interface_handle.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "down-nbr-interface" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/graceful-restart/graceful-restartable-neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_handle.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-family" or name == "interface-handle"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-handle"):
                                    self.interface_handle = value
                                    self.interface_handle.value_namespace = name_space
                                    self.interface_handle.value_namespace_prefix = name_space_prefix


                        class DownNbrAddress(Entity):
                            """
                            Addresses bound to GR down Nbr
                            
                            .. attribute:: afi
                            
                            	AFI
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: dummy
                            
                            	No Address
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: ipv4
                            
                            	IPv4 address type
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv6
                            
                            	IPv6 address type
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__init__()

                                self.yang_name = "down-nbr-address"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.afi = YLeaf(YType.enumeration, "afi")

                                self.dummy = YLeaf(YType.uint8, "dummy")

                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                self.ipv6 = YLeaf(YType.str, "ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("afi",
                                                "dummy",
                                                "ipv4",
                                                "ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.afi.is_set or
                                    self.dummy.is_set or
                                    self.ipv4.is_set or
                                    self.ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.afi.yfilter != YFilter.not_set or
                                    self.dummy.yfilter != YFilter.not_set or
                                    self.ipv4.yfilter != YFilter.not_set or
                                    self.ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "down-nbr-address" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/graceful-restart/graceful-restartable-neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "afi"):
                                    self.afi = value
                                    self.afi.value_namespace = name_space
                                    self.afi.value_namespace_prefix = name_space_prefix
                                if(value_path == "dummy"):
                                    self.dummy = value
                                    self.dummy.value_namespace = name_space
                                    self.dummy.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv4"):
                                    self.ipv4 = value
                                    self.ipv4.value_namespace = name_space
                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv6"):
                                    self.ipv6 = value
                                    self.ipv6.value_namespace = name_space
                                    self.ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.down_nbr_address:
                                if (c.has_data()):
                                    return True
                            for c in self.down_nbr_interface:
                                if (c.has_data()):
                                    return True
                            return (
                                self.connect_count.is_set or
                                self.down_nbr_down_reason.is_set or
                                self.down_nbr_flags.is_set or
                                self.down_nbr_flap_count.is_set or
                                self.is_liveness_timer_running.is_set or
                                self.is_neighbor_up.is_set or
                                self.is_recovery_timer_running.is_set or
                                self.liveness_timer_remaining_seconds.is_set or
                                self.recovery_timer_remaining_seconds.is_set or
                                (self.gr_peer is not None and self.gr_peer.has_data()))

                        def has_operation(self):
                            for c in self.down_nbr_address:
                                if (c.has_operation()):
                                    return True
                            for c in self.down_nbr_interface:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.connect_count.yfilter != YFilter.not_set or
                                self.down_nbr_down_reason.yfilter != YFilter.not_set or
                                self.down_nbr_flags.yfilter != YFilter.not_set or
                                self.down_nbr_flap_count.yfilter != YFilter.not_set or
                                self.is_liveness_timer_running.yfilter != YFilter.not_set or
                                self.is_neighbor_up.yfilter != YFilter.not_set or
                                self.is_recovery_timer_running.yfilter != YFilter.not_set or
                                self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set or
                                self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set or
                                (self.gr_peer is not None and self.gr_peer.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restartable-neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/graceful-restart/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.connect_count.get_name_leafdata())
                            if (self.down_nbr_down_reason.is_set or self.down_nbr_down_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_down_reason.get_name_leafdata())
                            if (self.down_nbr_flags.is_set or self.down_nbr_flags.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_flags.get_name_leafdata())
                            if (self.down_nbr_flap_count.is_set or self.down_nbr_flap_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_flap_count.get_name_leafdata())
                            if (self.is_liveness_timer_running.is_set or self.is_liveness_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_liveness_timer_running.get_name_leafdata())
                            if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                            if (self.is_recovery_timer_running.is_set or self.is_recovery_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_recovery_timer_running.get_name_leafdata())
                            if (self.liveness_timer_remaining_seconds.is_set or self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.liveness_timer_remaining_seconds.get_name_leafdata())
                            if (self.recovery_timer_remaining_seconds.is_set or self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.recovery_timer_remaining_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "down-nbr-address"):
                                for c in self.down_nbr_address:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.down_nbr_address.append(c)
                                return c

                            if (child_yang_name == "down-nbr-interface"):
                                for c in self.down_nbr_interface:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.down_nbr_interface.append(c)
                                return c

                            if (child_yang_name == "gr-peer"):
                                if (self.gr_peer is None):
                                    self.gr_peer = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                    self.gr_peer.parent = self
                                    self._children_name_map["gr_peer"] = "gr-peer"
                                return self.gr_peer

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "down-nbr-address" or name == "down-nbr-interface" or name == "gr-peer" or name == "connect-count" or name == "down-nbr-down-reason" or name == "down-nbr-flags" or name == "down-nbr-flap-count" or name == "is-liveness-timer-running" or name == "is-neighbor-up" or name == "is-recovery-timer-running" or name == "liveness-timer-remaining-seconds" or name == "recovery-timer-remaining-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "connect-count"):
                                self.connect_count = value
                                self.connect_count.value_namespace = name_space
                                self.connect_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-down-reason"):
                                self.down_nbr_down_reason = value
                                self.down_nbr_down_reason.value_namespace = name_space
                                self.down_nbr_down_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-flags"):
                                self.down_nbr_flags = value
                                self.down_nbr_flags.value_namespace = name_space
                                self.down_nbr_flags.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-flap-count"):
                                self.down_nbr_flap_count = value
                                self.down_nbr_flap_count.value_namespace = name_space
                                self.down_nbr_flap_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-liveness-timer-running"):
                                self.is_liveness_timer_running = value
                                self.is_liveness_timer_running.value_namespace = name_space
                                self.is_liveness_timer_running.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-neighbor-up"):
                                self.is_neighbor_up = value
                                self.is_neighbor_up.value_namespace = name_space
                                self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-recovery-timer-running"):
                                self.is_recovery_timer_running = value
                                self.is_recovery_timer_running.value_namespace = name_space
                                self.is_recovery_timer_running.value_namespace_prefix = name_space_prefix
                            if(value_path == "liveness-timer-remaining-seconds"):
                                self.liveness_timer_remaining_seconds = value
                                self.liveness_timer_remaining_seconds.value_namespace = name_space
                                self.liveness_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "recovery-timer-remaining-seconds"):
                                self.recovery_timer_remaining_seconds = value
                                self.recovery_timer_remaining_seconds.value_namespace = name_space
                                self.recovery_timer_remaining_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.graceful_restartable_neighbor:
                            if (c.has_data()):
                                return True
                        return (
                            self.forwarding_state_hold_timer_remaining_seconds.is_set or
                            self.is_forwarding_state_hold_timer_running.is_set or
                            (self.vrf is not None and self.vrf.has_data()))

                    def has_operation(self):
                        for c in self.graceful_restartable_neighbor:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set or
                            self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set or
                            (self.vrf is not None and self.vrf.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "graceful-restart" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.forwarding_state_hold_timer_remaining_seconds.is_set or self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forwarding_state_hold_timer_remaining_seconds.get_name_leafdata())
                        if (self.is_forwarding_state_hold_timer_running.is_set or self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_forwarding_state_hold_timer_running.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "graceful-restartable-neighbor"):
                            for c in self.graceful_restartable_neighbor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.graceful_restartable_neighbor.append(c)
                            return c

                        if (child_yang_name == "vrf"):
                            if (self.vrf is None):
                                self.vrf = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                            return self.vrf

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "graceful-restartable-neighbor" or name == "vrf" or name == "forwarding-state-hold-timer-remaining-seconds" or name == "is-forwarding-state-hold-timer-running"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "forwarding-state-hold-timer-remaining-seconds"):
                            self.forwarding_state_hold_timer_remaining_seconds = value
                            self.forwarding_state_hold_timer_remaining_seconds.value_namespace = name_space
                            self.forwarding_state_hold_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-forwarding-state-hold-timer-running"):
                            self.is_forwarding_state_hold_timer_running = value
                            self.is_forwarding_state_hold_timer_running.value_namespace = name_space
                            self.is_forwarding_state_hold_timer_running.value_namespace_prefix = name_space_prefix


                class Capabilities(Entity):
                    """
                    LDP capability database information
                    
                    .. attribute:: capability
                    
                    	Information on LDP capability
                    	**type**\: list of    :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Capabilities, self).__init__()

                        self.yang_name = "capabilities"
                        self.yang_parent_name = "default-vrf"

                        self.capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Capabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.Capabilities, self).__setattr__(name, value)


                    class Capability(Entity):
                        """
                        Information on LDP capability
                        
                        .. attribute:: capability_type  <key>
                        
                        	The capability type (IANA assigned)
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: capability
                        
                        	Capability information
                        	**type**\:   :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability.Capability>`
                        
                        .. attribute:: capability_owner
                        
                        	Capability owner
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability, self).__init__()

                            self.yang_name = "capability"
                            self.yang_parent_name = "capabilities"

                            self.capability_type = YLeaf(YType.int32, "capability-type")

                            self.capability_owner = YLeaf(YType.str, "capability-owner")

                            self.capability = MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability.Capability()
                            self.capability.parent = self
                            self._children_name_map["capability"] = "capability"
                            self._children_yang_names.add("capability")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("capability_type",
                                            "capability_owner") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability, self).__setattr__(name, value)


                        class Capability(Entity):
                            """
                            Capability information
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability.Capability, self).__init__()

                                self.yang_name = "capability"
                                self.yang_parent_name = "capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability.Capability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability.Capability, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "capability" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.capability_type.is_set or
                                self.capability_owner.is_set or
                                (self.capability is not None and self.capability.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.capability_type.yfilter != YFilter.not_set or
                                self.capability_owner.yfilter != YFilter.not_set or
                                (self.capability is not None and self.capability.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "capability" + "[capability-type='" + self.capability_type.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.capability_type.is_set or self.capability_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.capability_type.get_name_leafdata())
                            if (self.capability_owner.is_set or self.capability_owner.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.capability_owner.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "capability"):
                                if (self.capability is None):
                                    self.capability = MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability.Capability()
                                    self.capability.parent = self
                                    self._children_name_map["capability"] = "capability"
                                return self.capability

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "capability" or name == "capability-type" or name == "capability-owner"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "capability-type"):
                                self.capability_type = value
                                self.capability_type.value_namespace = name_space
                                self.capability_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "capability-owner"):
                                self.capability_owner = value
                                self.capability_owner.value_namespace = name_space
                                self.capability_owner.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "capability"):
                            for c in self.capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.Capabilities.Capability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Summary(Entity):
                    """
                    LDP VRF summary
                    
                    .. attribute:: common
                    
                    	Common Summary information
                    	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Summary.Common>`
                    
                    .. attribute:: vrf
                    
                    	VRF information
                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Summary.Vrf>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "default-vrf"

                        self.common = MplsLdp.Global_.Active.DefaultVrf.Summary.Common()
                        self.common.parent = self
                        self._children_name_map["common"] = "common"
                        self._children_yang_names.add("common")

                        self.vrf = MplsLdp.Global_.Active.DefaultVrf.Summary.Vrf()
                        self.vrf.parent = self
                        self._children_name_map["vrf"] = "vrf"
                        self._children_yang_names.add("vrf")


                    class Vrf(Entity):
                        """
                        VRF information
                        
                        .. attribute:: id
                        
                        	VRF Id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Summary.Vrf, self).__init__()

                            self.yang_name = "vrf"
                            self.yang_parent_name = "summary"

                            self.id = YLeaf(YType.uint32, "id")

                            self.name = YLeaf(YType.str, "name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("id",
                                            "name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Summary.Vrf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Summary.Vrf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.id.is_set or
                                self.name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.id.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.id.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "id" or name == "name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "id"):
                                self.id = value
                                self.id.value_namespace = name_space
                                self.id.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix


                    class Common(Entity):
                        """
                        Common Summary information
                        
                        .. attribute:: address_families
                        
                        	Address Families enabled
                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                        
                        .. attribute:: number_of_bindings_ipv4
                        
                        	Total number of ipv4 bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_bindings_ipv6
                        
                        	Total number of ipv6 bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_downstream_on_demand_neighbors
                        
                        	Number of Downstream\-On\-Demand neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_graceful_restart_neighbors
                        
                        	Number of Graceful Restart neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_hello_adj
                        
                        	Number of LDP discovery IPv4 hello adjacencies
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_local_addresses
                        
                        	Number of IPv4 local addresses
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_routes
                        
                        	Number of resolved IPv4 routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4af
                        
                        	Number of IPv4 address\-families enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4ldp_interfaces
                        
                        	Number of LDP IPv4 configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_hello_adj
                        
                        	Number of LDP discovery IPv6 hello adjacencies
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_local_addresses
                        
                        	Number of IPv6 local addresses
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_routes
                        
                        	Number of resolved IPv6 routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6af
                        
                        	Number of IPv6 address\-families enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6ldp_interfaces
                        
                        	Number of LDP IPv6 configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ldp_interfaces
                        
                        	Number of LDP configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_local_bindings_ipv4
                        
                        	Total number of ipv4 local label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_local_bindings_ipv6
                        
                        	Total number of ipv6 local label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_neighbors
                        
                        	Number of neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_nsr_synced_neighbors
                        
                        	Number of NSR\-synced/operational neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_remote_bindings_ipv4
                        
                        	Total number of ipv4 remote label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_remote_bindings_ipv6
                        
                        	Total number of ipv6 remote label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Summary.Common, self).__init__()

                            self.yang_name = "common"
                            self.yang_parent_name = "summary"

                            self.address_families = YLeaf(YType.enumeration, "address-families")

                            self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                            self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                            self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                            self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                            self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                            self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                            self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                            self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                            self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                            self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                            self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                            self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                            self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                            self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                            self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                            self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                            self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                            self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                            self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                            self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                            self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("address_families",
                                            "number_of_bindings_ipv4",
                                            "number_of_bindings_ipv6",
                                            "number_of_downstream_on_demand_neighbors",
                                            "number_of_graceful_restart_neighbors",
                                            "number_of_ipv4_hello_adj",
                                            "number_of_ipv4_local_addresses",
                                            "number_of_ipv4_routes",
                                            "number_of_ipv4af",
                                            "number_of_ipv4ldp_interfaces",
                                            "number_of_ipv6_hello_adj",
                                            "number_of_ipv6_local_addresses",
                                            "number_of_ipv6_routes",
                                            "number_of_ipv6af",
                                            "number_of_ipv6ldp_interfaces",
                                            "number_of_ldp_interfaces",
                                            "number_of_local_bindings_ipv4",
                                            "number_of_local_bindings_ipv6",
                                            "number_of_neighbors",
                                            "number_of_nsr_synced_neighbors",
                                            "number_of_remote_bindings_ipv4",
                                            "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Summary.Common, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Summary.Common, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.address_families.is_set or
                                self.number_of_bindings_ipv4.is_set or
                                self.number_of_bindings_ipv6.is_set or
                                self.number_of_downstream_on_demand_neighbors.is_set or
                                self.number_of_graceful_restart_neighbors.is_set or
                                self.number_of_ipv4_hello_adj.is_set or
                                self.number_of_ipv4_local_addresses.is_set or
                                self.number_of_ipv4_routes.is_set or
                                self.number_of_ipv4af.is_set or
                                self.number_of_ipv4ldp_interfaces.is_set or
                                self.number_of_ipv6_hello_adj.is_set or
                                self.number_of_ipv6_local_addresses.is_set or
                                self.number_of_ipv6_routes.is_set or
                                self.number_of_ipv6af.is_set or
                                self.number_of_ipv6ldp_interfaces.is_set or
                                self.number_of_ldp_interfaces.is_set or
                                self.number_of_local_bindings_ipv4.is_set or
                                self.number_of_local_bindings_ipv6.is_set or
                                self.number_of_neighbors.is_set or
                                self.number_of_nsr_synced_neighbors.is_set or
                                self.number_of_remote_bindings_ipv4.is_set or
                                self.number_of_remote_bindings_ipv6.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.address_families.yfilter != YFilter.not_set or
                                self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                                self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                                self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                                self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                                self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                                self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                                self.number_of_ipv4af.yfilter != YFilter.not_set or
                                self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                                self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                                self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                                self.number_of_ipv6af.yfilter != YFilter.not_set or
                                self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                                self.number_of_neighbors.yfilter != YFilter.not_set or
                                self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                                self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "common" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.address_families.get_name_leafdata())
                            if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                            if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                            if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                            if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                            if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                            if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                            if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                            if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                            if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                            if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                            if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                            if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                            if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                            if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                            if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                            if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                            if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                            if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "address-families"):
                                self.address_families = value
                                self.address_families.value_namespace = name_space
                                self.address_families.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-bindings-ipv4"):
                                self.number_of_bindings_ipv4 = value
                                self.number_of_bindings_ipv4.value_namespace = name_space
                                self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-bindings-ipv6"):
                                self.number_of_bindings_ipv6 = value
                                self.number_of_bindings_ipv6.value_namespace = name_space
                                self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-downstream-on-demand-neighbors"):
                                self.number_of_downstream_on_demand_neighbors = value
                                self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                                self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-graceful-restart-neighbors"):
                                self.number_of_graceful_restart_neighbors = value
                                self.number_of_graceful_restart_neighbors.value_namespace = name_space
                                self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-hello-adj"):
                                self.number_of_ipv4_hello_adj = value
                                self.number_of_ipv4_hello_adj.value_namespace = name_space
                                self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-local-addresses"):
                                self.number_of_ipv4_local_addresses = value
                                self.number_of_ipv4_local_addresses.value_namespace = name_space
                                self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-routes"):
                                self.number_of_ipv4_routes = value
                                self.number_of_ipv4_routes.value_namespace = name_space
                                self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4af"):
                                self.number_of_ipv4af = value
                                self.number_of_ipv4af.value_namespace = name_space
                                self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4ldp-interfaces"):
                                self.number_of_ipv4ldp_interfaces = value
                                self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                                self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-hello-adj"):
                                self.number_of_ipv6_hello_adj = value
                                self.number_of_ipv6_hello_adj.value_namespace = name_space
                                self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-local-addresses"):
                                self.number_of_ipv6_local_addresses = value
                                self.number_of_ipv6_local_addresses.value_namespace = name_space
                                self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-routes"):
                                self.number_of_ipv6_routes = value
                                self.number_of_ipv6_routes.value_namespace = name_space
                                self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6af"):
                                self.number_of_ipv6af = value
                                self.number_of_ipv6af.value_namespace = name_space
                                self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6ldp-interfaces"):
                                self.number_of_ipv6ldp_interfaces = value
                                self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                                self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ldp-interfaces"):
                                self.number_of_ldp_interfaces = value
                                self.number_of_ldp_interfaces.value_namespace = name_space
                                self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-local-bindings-ipv4"):
                                self.number_of_local_bindings_ipv4 = value
                                self.number_of_local_bindings_ipv4.value_namespace = name_space
                                self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-local-bindings-ipv6"):
                                self.number_of_local_bindings_ipv6 = value
                                self.number_of_local_bindings_ipv6.value_namespace = name_space
                                self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-neighbors"):
                                self.number_of_neighbors = value
                                self.number_of_neighbors.value_namespace = name_space
                                self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-nsr-synced-neighbors"):
                                self.number_of_nsr_synced_neighbors = value
                                self.number_of_nsr_synced_neighbors.value_namespace = name_space
                                self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-remote-bindings-ipv4"):
                                self.number_of_remote_bindings_ipv4 = value
                                self.number_of_remote_bindings_ipv4.value_namespace = name_space
                                self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-remote-bindings-ipv6"):
                                self.number_of_remote_bindings_ipv6 = value
                                self.number_of_remote_bindings_ipv6.value_namespace = name_space
                                self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.common is not None and self.common.has_data()) or
                            (self.vrf is not None and self.vrf.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.common is not None and self.common.has_operation()) or
                            (self.vrf is not None and self.vrf.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "common"):
                            if (self.common is None):
                                self.common = MplsLdp.Global_.Active.DefaultVrf.Summary.Common()
                                self.common.parent = self
                                self._children_name_map["common"] = "common"
                            return self.common

                        if (child_yang_name == "vrf"):
                            if (self.vrf is None):
                                self.vrf = MplsLdp.Global_.Active.DefaultVrf.Summary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                            return self.vrf

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "common" or name == "vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Afs(Entity):
                    """
                    Address Family specific operational data
                    
                    .. attribute:: af
                    
                    	Operational data for given Address Family
                    	**type**\: list of    :py:class:`Af <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Afs, self).__init__()

                        self.yang_name = "afs"
                        self.yang_parent_name = "default-vrf"

                        self.af = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs, self).__setattr__(name, value)


                    class Af(Entity):
                        """
                        Operational data for given Address Family
                        
                        .. attribute:: af_name  <key>
                        
                        	Address Family name
                        	**type**\:   :py:class:`MplsLdpOperAfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdpOperAfName>`
                        
                        .. attribute:: bindings
                        
                        	The LDP Bindings
                        	**type**\:   :py:class:`Bindings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings>`
                        
                        .. attribute:: bindings_advertise_spec
                        
                        	Advertisement Spec (ACL) for LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsAdvertiseSpec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec>`
                        
                        .. attribute:: bindings_summary
                        
                        	Counters for the LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary>`
                        
                        .. attribute:: bindings_summary_all
                        
                        	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll>`
                        
                        .. attribute:: discovery
                        
                        	The LDP Discovery
                        	**type**\:   :py:class:`Discovery <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery>`
                        
                        .. attribute:: forwarding_summary
                        
                        	Summary information regarding LDP forwarding setup
                        	**type**\:   :py:class:`ForwardingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary>`
                        
                        .. attribute:: forwardings
                        
                        	The LDP Forwarding rewrites
                        	**type**\:   :py:class:`Forwardings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings>`
                        
                        .. attribute:: igp
                        
                        	LDP IGP related information
                        	**type**\:   :py:class:`Igp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp>`
                        
                        .. attribute:: interface_summary
                        
                        	IPv4 interface summary information
                        	**type**\:   :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.InterfaceSummary>`
                        
                        .. attribute:: interfaces
                        
                        	LDP Interface related information
                        	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af, self).__init__()

                            self.yang_name = "af"
                            self.yang_parent_name = "afs"

                            self.af_name = YLeaf(YType.enumeration, "af-name")

                            self.bindings = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings()
                            self.bindings.parent = self
                            self._children_name_map["bindings"] = "bindings"
                            self._children_yang_names.add("bindings")

                            self.bindings_advertise_spec = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec()
                            self.bindings_advertise_spec.parent = self
                            self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                            self._children_yang_names.add("bindings-advertise-spec")

                            self.bindings_summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary()
                            self.bindings_summary.parent = self
                            self._children_name_map["bindings_summary"] = "bindings-summary"
                            self._children_yang_names.add("bindings-summary")

                            self.bindings_summary_all = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll()
                            self.bindings_summary_all.parent = self
                            self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                            self._children_yang_names.add("bindings-summary-all")

                            self.discovery = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery()
                            self.discovery.parent = self
                            self._children_name_map["discovery"] = "discovery"
                            self._children_yang_names.add("discovery")

                            self.forwarding_summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary()
                            self.forwarding_summary.parent = self
                            self._children_name_map["forwarding_summary"] = "forwarding-summary"
                            self._children_yang_names.add("forwarding-summary")

                            self.forwardings = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings()
                            self.forwardings.parent = self
                            self._children_name_map["forwardings"] = "forwardings"
                            self._children_yang_names.add("forwardings")

                            self.igp = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp()
                            self.igp.parent = self
                            self._children_name_map["igp"] = "igp"
                            self._children_yang_names.add("igp")

                            self.interface_summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.InterfaceSummary()
                            self.interface_summary.parent = self
                            self._children_name_map["interface_summary"] = "interface-summary"
                            self._children_yang_names.add("interface-summary")

                            self.interfaces = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces()
                            self.interfaces.parent = self
                            self._children_name_map["interfaces"] = "interfaces"
                            self._children_yang_names.add("interfaces")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("af_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af, self).__setattr__(name, value)


                        class InterfaceSummary(Entity):
                            """
                            IPv4 interface summary information
                            
                            .. attribute:: auto_config
                            
                            	Auto\-configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: auto_config_disabled
                            
                            	Autoconfigure disabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: auto_config_forward_reference_interfaces
                            
                            	Auto\-configured forward references
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: forward_references
                            
                            	Number of forward referenced interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: known_ip_interface_count
                            
                            	Number of known IP Interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: known_ip_interface_ldp_enabled
                            
                            	Number of known IP Interfaces with LDP Enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ldp_configured_attached_interface
                            
                            	Number of attached interfaces configured in LDP
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ldp_configured_te_interface
                            
                            	Number of TE tunnel interfaces configured in LDP
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.InterfaceSummary, self).__init__()

                                self.yang_name = "interface-summary"
                                self.yang_parent_name = "af"

                                self.auto_config = YLeaf(YType.uint32, "auto-config")

                                self.auto_config_disabled = YLeaf(YType.uint32, "auto-config-disabled")

                                self.auto_config_forward_reference_interfaces = YLeaf(YType.uint32, "auto-config-forward-reference-interfaces")

                                self.forward_references = YLeaf(YType.uint32, "forward-references")

                                self.known_ip_interface_count = YLeaf(YType.uint32, "known-ip-interface-count")

                                self.known_ip_interface_ldp_enabled = YLeaf(YType.uint32, "known-ip-interface-ldp-enabled")

                                self.ldp_configured_attached_interface = YLeaf(YType.uint32, "ldp-configured-attached-interface")

                                self.ldp_configured_te_interface = YLeaf(YType.uint32, "ldp-configured-te-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("auto_config",
                                                "auto_config_disabled",
                                                "auto_config_forward_reference_interfaces",
                                                "forward_references",
                                                "known_ip_interface_count",
                                                "known_ip_interface_ldp_enabled",
                                                "ldp_configured_attached_interface",
                                                "ldp_configured_te_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.auto_config.is_set or
                                    self.auto_config_disabled.is_set or
                                    self.auto_config_forward_reference_interfaces.is_set or
                                    self.forward_references.is_set or
                                    self.known_ip_interface_count.is_set or
                                    self.known_ip_interface_ldp_enabled.is_set or
                                    self.ldp_configured_attached_interface.is_set or
                                    self.ldp_configured_te_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.auto_config.yfilter != YFilter.not_set or
                                    self.auto_config_disabled.yfilter != YFilter.not_set or
                                    self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set or
                                    self.forward_references.yfilter != YFilter.not_set or
                                    self.known_ip_interface_count.yfilter != YFilter.not_set or
                                    self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set or
                                    self.ldp_configured_attached_interface.yfilter != YFilter.not_set or
                                    self.ldp_configured_te_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.auto_config.is_set or self.auto_config.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config.get_name_leafdata())
                                if (self.auto_config_disabled.is_set or self.auto_config_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config_disabled.get_name_leafdata())
                                if (self.auto_config_forward_reference_interfaces.is_set or self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config_forward_reference_interfaces.get_name_leafdata())
                                if (self.forward_references.is_set or self.forward_references.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_references.get_name_leafdata())
                                if (self.known_ip_interface_count.is_set or self.known_ip_interface_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.known_ip_interface_count.get_name_leafdata())
                                if (self.known_ip_interface_ldp_enabled.is_set or self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.known_ip_interface_ldp_enabled.get_name_leafdata())
                                if (self.ldp_configured_attached_interface.is_set or self.ldp_configured_attached_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_configured_attached_interface.get_name_leafdata())
                                if (self.ldp_configured_te_interface.is_set or self.ldp_configured_te_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_configured_te_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "auto-config" or name == "auto-config-disabled" or name == "auto-config-forward-reference-interfaces" or name == "forward-references" or name == "known-ip-interface-count" or name == "known-ip-interface-ldp-enabled" or name == "ldp-configured-attached-interface" or name == "ldp-configured-te-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "auto-config"):
                                    self.auto_config = value
                                    self.auto_config.value_namespace = name_space
                                    self.auto_config.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-config-disabled"):
                                    self.auto_config_disabled = value
                                    self.auto_config_disabled.value_namespace = name_space
                                    self.auto_config_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-config-forward-reference-interfaces"):
                                    self.auto_config_forward_reference_interfaces = value
                                    self.auto_config_forward_reference_interfaces.value_namespace = name_space
                                    self.auto_config_forward_reference_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-references"):
                                    self.forward_references = value
                                    self.forward_references.value_namespace = name_space
                                    self.forward_references.value_namespace_prefix = name_space_prefix
                                if(value_path == "known-ip-interface-count"):
                                    self.known_ip_interface_count = value
                                    self.known_ip_interface_count.value_namespace = name_space
                                    self.known_ip_interface_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "known-ip-interface-ldp-enabled"):
                                    self.known_ip_interface_ldp_enabled = value
                                    self.known_ip_interface_ldp_enabled.value_namespace = name_space
                                    self.known_ip_interface_ldp_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-configured-attached-interface"):
                                    self.ldp_configured_attached_interface = value
                                    self.ldp_configured_attached_interface.value_namespace = name_space
                                    self.ldp_configured_attached_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-configured-te-interface"):
                                    self.ldp_configured_te_interface = value
                                    self.ldp_configured_te_interface.value_namespace = name_space
                                    self.ldp_configured_te_interface.value_namespace_prefix = name_space_prefix


                        class Bindings(Entity):
                            """
                            The LDP Bindings
                            
                            .. attribute:: binding
                            
                            	Binding Information
                            	**type**\: list of    :py:class:`Binding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings, self).__init__()

                                self.yang_name = "bindings"
                                self.yang_parent_name = "af"

                                self.binding = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings, self).__setattr__(name, value)


                            class Binding(Entity):
                                """
                                Binding Information
                                
                                .. attribute:: prefix  <key>
                                
                                	The IP Prefix
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                
                                
                                ----
                                .. attribute:: advertise_prefix_acl
                                
                                	Advertise Prerfix ACL
                                	**type**\:  str
                                
                                .. attribute:: advertise_tsr_acl
                                
                                	Advertise TSR ACL
                                	**type**\:  str
                                
                                .. attribute:: config_enforced_local_label_value
                                
                                	Config/User enforced local label value
                                	**type**\:  bool
                                
                                .. attribute:: is_elc
                                
                                	Is the entry entropy label capable
                                	**type**\:  bool
                                
                                .. attribute:: is_no_route
                                
                                	No route
                                	**type**\:  bool
                                
                                .. attribute:: label_oor
                                
                                	Label space depletion OOR
                                	**type**\:  bool
                                
                                .. attribute:: le_local_binding_revision
                                
                                	Local Binding revision
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: le_local_label_state
                                
                                	Local label state
                                	**type**\:   :py:class:`LocalLabelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LocalLabelState>`
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: peers_acked
                                
                                	Peers that have ACKed this entry
                                	**type**\: list of    :py:class:`PeersAcked <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked>`
                                
                                .. attribute:: peers_advertised_to
                                
                                	Peers this entry is advertised to
                                	**type**\: list of    :py:class:`PeersAdvertisedTo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo>`
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: prefix_xr
                                
                                	IP Prefix
                                	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr>`
                                
                                .. attribute:: remote_binding
                                
                                	Remote binding
                                	**type**\: list of    :py:class:`RemoteBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding, self).__init__()

                                    self.yang_name = "binding"
                                    self.yang_parent_name = "bindings"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.advertise_prefix_acl = YLeaf(YType.str, "advertise-prefix-acl")

                                    self.advertise_tsr_acl = YLeaf(YType.str, "advertise-tsr-acl")

                                    self.config_enforced_local_label_value = YLeaf(YType.boolean, "config-enforced-local-label-value")

                                    self.is_elc = YLeaf(YType.boolean, "is-elc")

                                    self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                    self.label_oor = YLeaf(YType.boolean, "label-oor")

                                    self.le_local_binding_revision = YLeaf(YType.uint32, "le-local-binding-revision")

                                    self.le_local_label_state = YLeaf(YType.enumeration, "le-local-label-state")

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.prefix_xr = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr()
                                    self.prefix_xr.parent = self
                                    self._children_name_map["prefix_xr"] = "prefix-xr"
                                    self._children_yang_names.add("prefix-xr")

                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.peers_acked = YList(self)
                                    self.peers_advertised_to = YList(self)
                                    self.remote_binding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "advertise_prefix_acl",
                                                    "advertise_tsr_acl",
                                                    "config_enforced_local_label_value",
                                                    "is_elc",
                                                    "is_no_route",
                                                    "label_oor",
                                                    "le_local_binding_revision",
                                                    "le_local_label_state",
                                                    "local_label",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "binding"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class PrefixXr(Entity):
                                    """
                                    IP Prefix
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__init__()

                                        self.yang_name = "prefix-xr"
                                        self.yang_parent_name = "binding"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prefix-xr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class RemoteBinding(Entity):
                                    """
                                    Remote binding
                                    
                                    .. attribute:: assigning_peer_ldp_ident
                                    
                                    	Assigning peer
                                    	**type**\:   :py:class:`AssigningPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent>`
                                    
                                    .. attribute:: is_elc
                                    
                                    	Is the entry entropy label capable
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_stale
                                    
                                    	Is the entry stale
                                    	**type**\:  bool
                                    
                                    .. attribute:: remote_label
                                    
                                    	Remote Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__init__()

                                        self.yang_name = "remote-binding"
                                        self.yang_parent_name = "binding"

                                        self.is_elc = YLeaf(YType.boolean, "is-elc")

                                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                                        self.remote_label = YLeaf(YType.uint32, "remote-label")

                                        self.assigning_peer_ldp_ident = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                        self.assigning_peer_ldp_ident.parent = self
                                        self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                        self._children_yang_names.add("assigning-peer-ldp-ident")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_elc",
                                                        "is_stale",
                                                        "remote_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)


                                    class AssigningPeerLdpIdent(Entity):
                                        """
                                        Assigning peer
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__init__()

                                            self.yang_name = "assigning-peer-ldp-ident"
                                            self.yang_parent_name = "remote-binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "assigning-peer-ldp-ident" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.is_elc.is_set or
                                            self.is_stale.is_set or
                                            self.remote_label.is_set or
                                            (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_elc.yfilter != YFilter.not_set or
                                            self.is_stale.yfilter != YFilter.not_set or
                                            self.remote_label.yfilter != YFilter.not_set or
                                            (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "remote-binding" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_elc.get_name_leafdata())
                                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                                        if (self.remote_label.is_set or self.remote_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "assigning-peer-ldp-ident"):
                                            if (self.assigning_peer_ldp_ident is None):
                                                self.assigning_peer_ldp_ident = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                                self.assigning_peer_ldp_ident.parent = self
                                                self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                            return self.assigning_peer_ldp_ident

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "assigning-peer-ldp-ident" or name == "is-elc" or name == "is-stale" or name == "remote-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-elc"):
                                            self.is_elc = value
                                            self.is_elc.value_namespace = name_space
                                            self.is_elc.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-stale"):
                                            self.is_stale = value
                                            self.is_stale.value_namespace = name_space
                                            self.is_stale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-label"):
                                            self.remote_label = value
                                            self.remote_label.value_namespace = name_space
                                            self.remote_label.value_namespace_prefix = name_space_prefix


                                class PeersAdvertisedTo(Entity):
                                    """
                                    Peers this entry is advertised to
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: ldp_id
                                    
                                    	LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__init__()

                                        self.yang_name = "peers-advertised-to"
                                        self.yang_parent_name = "binding"

                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "ldp_id",
                                                        "lsr_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.ldp_id.is_set or
                                            self.lsr_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.ldp_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "peers-advertised-to" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-id"):
                                            self.ldp_id = value
                                            self.ldp_id.value_namespace = name_space
                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix


                                class PeersAcked(Entity):
                                    """
                                    Peers that have ACKed this entry
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: ldp_id
                                    
                                    	LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__init__()

                                        self.yang_name = "peers-acked"
                                        self.yang_parent_name = "binding"

                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "ldp_id",
                                                        "lsr_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.ldp_id.is_set or
                                            self.lsr_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.ldp_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "peers-acked" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-id"):
                                            self.ldp_id = value
                                            self.ldp_id.value_namespace = name_space
                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.peers_acked:
                                        if (c.has_data()):
                                            return True
                                    for c in self.peers_advertised_to:
                                        if (c.has_data()):
                                            return True
                                    for c in self.remote_binding:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.prefix.is_set or
                                        self.advertise_prefix_acl.is_set or
                                        self.advertise_tsr_acl.is_set or
                                        self.config_enforced_local_label_value.is_set or
                                        self.is_elc.is_set or
                                        self.is_no_route.is_set or
                                        self.label_oor.is_set or
                                        self.le_local_binding_revision.is_set or
                                        self.le_local_label_state.is_set or
                                        self.local_label.is_set or
                                        self.prefix_length.is_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.peers_acked:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.peers_advertised_to:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.remote_binding:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.advertise_prefix_acl.yfilter != YFilter.not_set or
                                        self.advertise_tsr_acl.yfilter != YFilter.not_set or
                                        self.config_enforced_local_label_value.yfilter != YFilter.not_set or
                                        self.is_elc.yfilter != YFilter.not_set or
                                        self.is_no_route.yfilter != YFilter.not_set or
                                        self.label_oor.yfilter != YFilter.not_set or
                                        self.le_local_binding_revision.yfilter != YFilter.not_set or
                                        self.le_local_label_state.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "binding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.advertise_prefix_acl.is_set or self.advertise_prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_prefix_acl.get_name_leafdata())
                                    if (self.advertise_tsr_acl.is_set or self.advertise_tsr_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_tsr_acl.get_name_leafdata())
                                    if (self.config_enforced_local_label_value.is_set or self.config_enforced_local_label_value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.config_enforced_local_label_value.get_name_leafdata())
                                    if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_elc.get_name_leafdata())
                                    if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                    if (self.label_oor.is_set or self.label_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_oor.get_name_leafdata())
                                    if (self.le_local_binding_revision.is_set or self.le_local_binding_revision.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.le_local_binding_revision.get_name_leafdata())
                                    if (self.le_local_label_state.is_set or self.le_local_label_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.le_local_label_state.get_name_leafdata())
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "peers-acked"):
                                        for c in self.peers_acked:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.peers_acked.append(c)
                                        return c

                                    if (child_yang_name == "peers-advertised-to"):
                                        for c in self.peers_advertised_to:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.peers_advertised_to.append(c)
                                        return c

                                    if (child_yang_name == "prefix-xr"):
                                        if (self.prefix_xr is None):
                                            self.prefix_xr = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr()
                                            self.prefix_xr.parent = self
                                            self._children_name_map["prefix_xr"] = "prefix-xr"
                                        return self.prefix_xr

                                    if (child_yang_name == "remote-binding"):
                                        for c in self.remote_binding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.remote_binding.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "peers-acked" or name == "peers-advertised-to" or name == "prefix-xr" or name == "remote-binding" or name == "vrf" or name == "prefix" or name == "advertise-prefix-acl" or name == "advertise-tsr-acl" or name == "config-enforced-local-label-value" or name == "is-elc" or name == "is-no-route" or name == "label-oor" or name == "le-local-binding-revision" or name == "le-local-label-state" or name == "local-label" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "advertise-prefix-acl"):
                                        self.advertise_prefix_acl = value
                                        self.advertise_prefix_acl.value_namespace = name_space
                                        self.advertise_prefix_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "advertise-tsr-acl"):
                                        self.advertise_tsr_acl = value
                                        self.advertise_tsr_acl.value_namespace = name_space
                                        self.advertise_tsr_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "config-enforced-local-label-value"):
                                        self.config_enforced_local_label_value = value
                                        self.config_enforced_local_label_value.value_namespace = name_space
                                        self.config_enforced_local_label_value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-elc"):
                                        self.is_elc = value
                                        self.is_elc.value_namespace = name_space
                                        self.is_elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-no-route"):
                                        self.is_no_route = value
                                        self.is_no_route.value_namespace = name_space
                                        self.is_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-oor"):
                                        self.label_oor = value
                                        self.label_oor.value_namespace = name_space
                                        self.label_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "le-local-binding-revision"):
                                        self.le_local_binding_revision = value
                                        self.le_local_binding_revision.value_namespace = name_space
                                        self.le_local_binding_revision.value_namespace_prefix = name_space_prefix
                                    if(value_path == "le-local-label-state"):
                                        self.le_local_label_state = value
                                        self.le_local_label_state.value_namespace = name_space
                                        self.le_local_label_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.binding:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.binding:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "binding"):
                                    for c in self.binding:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings.Binding()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.binding.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "binding"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Igp(Entity):
                            """
                            LDP IGP related information
                            
                            .. attribute:: sync_delay_restart
                            
                            	LDP\-IGP Synchronization Delay related information
                            	**type**\:   :py:class:`SyncDelayRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.SyncDelayRestart>`
                            
                            .. attribute:: syncs
                            
                            	LDP IGP Sync related information
                            	**type**\:   :py:class:`Syncs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp, self).__init__()

                                self.yang_name = "igp"
                                self.yang_parent_name = "af"

                                self.sync_delay_restart = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.SyncDelayRestart()
                                self.sync_delay_restart.parent = self
                                self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                self._children_yang_names.add("sync-delay-restart")

                                self.syncs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs()
                                self.syncs.parent = self
                                self._children_name_map["syncs"] = "syncs"
                                self._children_yang_names.add("syncs")


                            class Syncs(Entity):
                                """
                                LDP IGP Sync related information
                                
                                .. attribute:: sync
                                
                                	LDP\-IGP Synchronization related information for an interface
                                	**type**\: list of    :py:class:`Sync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs, self).__init__()

                                    self.yang_name = "syncs"
                                    self.yang_parent_name = "igp"

                                    self.sync = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)


                                class Sync(Entity):
                                    """
                                    LDP\-IGP Synchronization related information
                                    for an interface
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: delay_timer_remaining
                                    
                                    	Remaining timer (seconds) till expiry of sync delay timer
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: gr_only_peer
                                    
                                    	Interface GR\-only reachable peers
                                    	**type**\: list of    :py:class:`GrOnlyPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer>`
                                    
                                    .. attribute:: igp_sync_delay
                                    
                                    	IGP sync delay in seconds
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: igp_sync_down_reason
                                    
                                    	Reason IGP Sync Not Achieved
                                    	**type**\:   :py:class:`LdpIgpSyncDownReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncDownReason>`
                                    
                                    .. attribute:: igp_sync_state
                                    
                                    	IGP Sync state
                                    	**type**\:   :py:class:`LdpIgpSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncState>`
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: is_delay_timer_running
                                    
                                    	Is sync delay timer running
                                    	**type**\:  bool
                                    
                                    .. attribute:: peers
                                    
                                    	Interface Peers
                                    	**type**\: list of    :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__init__()

                                        self.yang_name = "sync"
                                        self.yang_parent_name = "syncs"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.delay_timer_remaining = YLeaf(YType.uint32, "delay-timer-remaining")

                                        self.igp_sync_delay = YLeaf(YType.uint32, "igp-sync-delay")

                                        self.igp_sync_down_reason = YLeaf(YType.enumeration, "igp-sync-down-reason")

                                        self.igp_sync_state = YLeaf(YType.enumeration, "igp-sync-state")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.is_delay_timer_running = YLeaf(YType.boolean, "is-delay-timer-running")

                                        self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.gr_only_peer = YList(self)
                                        self.peers = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "delay_timer_remaining",
                                                        "igp_sync_delay",
                                                        "igp_sync_down_reason",
                                                        "igp_sync_state",
                                                        "interface_name_xr",
                                                        "is_delay_timer_running") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "sync"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class Peers(Entity):
                                        """
                                        Interface Peers
                                        
                                        .. attribute:: is_gr_enabled
                                        
                                        	Is GR enabled session
                                        	**type**\:  bool
                                        
                                        .. attribute:: peer_id
                                        
                                        	Peer Identifier
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__init__()

                                            self.yang_name = "peers"
                                            self.yang_parent_name = "sync"

                                            self.is_gr_enabled = YLeaf(YType.boolean, "is-gr-enabled")

                                            self.peer_id = YLeaf(YType.str, "peer-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_gr_enabled",
                                                            "peer_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_gr_enabled.is_set or
                                                self.peer_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_gr_enabled.yfilter != YFilter.not_set or
                                                self.peer_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_gr_enabled.is_set or self.is_gr_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_gr_enabled.get_name_leafdata())
                                            if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.peer_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-gr-enabled" or name == "peer-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-gr-enabled"):
                                                self.is_gr_enabled = value
                                                self.is_gr_enabled.value_namespace = name_space
                                                self.is_gr_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "peer-id"):
                                                self.peer_id = value
                                                self.peer_id.value_namespace = name_space
                                                self.peer_id.value_namespace_prefix = name_space_prefix


                                    class GrOnlyPeer(Entity):
                                        """
                                        Interface GR\-only reachable peers
                                        
                                        .. attribute:: is_chkpt_created
                                        
                                        	Is created due to checkpointing
                                        	**type**\:  bool
                                        
                                        .. attribute:: peer_id
                                        
                                        	Peer Identifier
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__init__()

                                            self.yang_name = "gr-only-peer"
                                            self.yang_parent_name = "sync"

                                            self.is_chkpt_created = YLeaf(YType.boolean, "is-chkpt-created")

                                            self.peer_id = YLeaf(YType.str, "peer-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_chkpt_created",
                                                            "peer_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_chkpt_created.is_set or
                                                self.peer_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_chkpt_created.yfilter != YFilter.not_set or
                                                self.peer_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "gr-only-peer" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_chkpt_created.is_set or self.is_chkpt_created.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_chkpt_created.get_name_leafdata())
                                            if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.peer_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-chkpt-created" or name == "peer-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-chkpt-created"):
                                                self.is_chkpt_created = value
                                                self.is_chkpt_created.value_namespace = name_space
                                                self.is_chkpt_created.value_namespace_prefix = name_space_prefix
                                            if(value_path == "peer-id"):
                                                self.peer_id = value
                                                self.peer_id.value_namespace = name_space
                                                self.peer_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.gr_only_peer:
                                            if (c.has_data()):
                                                return True
                                        for c in self.peers:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.delay_timer_remaining.is_set or
                                            self.igp_sync_delay.is_set or
                                            self.igp_sync_down_reason.is_set or
                                            self.igp_sync_state.is_set or
                                            self.interface_name_xr.is_set or
                                            self.is_delay_timer_running.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.gr_only_peer:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.peers:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.delay_timer_remaining.yfilter != YFilter.not_set or
                                            self.igp_sync_delay.yfilter != YFilter.not_set or
                                            self.igp_sync_down_reason.yfilter != YFilter.not_set or
                                            self.igp_sync_state.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.is_delay_timer_running.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sync" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.delay_timer_remaining.is_set or self.delay_timer_remaining.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.delay_timer_remaining.get_name_leafdata())
                                        if (self.igp_sync_delay.is_set or self.igp_sync_delay.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_delay.get_name_leafdata())
                                        if (self.igp_sync_down_reason.is_set or self.igp_sync_down_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_down_reason.get_name_leafdata())
                                        if (self.igp_sync_state.is_set or self.igp_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_state.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.is_delay_timer_running.is_set or self.is_delay_timer_running.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_delay_timer_running.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "gr-only-peer"):
                                            for c in self.gr_only_peer:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.gr_only_peer.append(c)
                                            return c

                                        if (child_yang_name == "peers"):
                                            for c in self.peers:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "gr-only-peer" or name == "peers" or name == "vrf" or name == "interface-name" or name == "delay-timer-remaining" or name == "igp-sync-delay" or name == "igp-sync-down-reason" or name == "igp-sync-state" or name == "interface-name-xr" or name == "is-delay-timer-running"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "delay-timer-remaining"):
                                            self.delay_timer_remaining = value
                                            self.delay_timer_remaining.value_namespace = name_space
                                            self.delay_timer_remaining.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-delay"):
                                            self.igp_sync_delay = value
                                            self.igp_sync_delay.value_namespace = name_space
                                            self.igp_sync_delay.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-down-reason"):
                                            self.igp_sync_down_reason = value
                                            self.igp_sync_down_reason.value_namespace = name_space
                                            self.igp_sync_down_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-state"):
                                            self.igp_sync_state = value
                                            self.igp_sync_state.value_namespace = name_space
                                            self.igp_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-delay-timer-running"):
                                            self.is_delay_timer_running = value
                                            self.is_delay_timer_running.value_namespace = name_space
                                            self.is_delay_timer_running.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sync:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.sync:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "syncs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sync"):
                                        for c in self.sync:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs.Sync()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sync.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class SyncDelayRestart(Entity):
                                """
                                LDP\-IGP Synchronization Delay related
                                information
                                
                                .. attribute:: configured
                                
                                	Is restart delay configured
                                	**type**\:  bool
                                
                                .. attribute:: delay_secs
                                
                                	Delay time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: remaining_secs
                                
                                	Delay timer remaining time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: timer_running
                                
                                	Is restart delay timer running
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__init__()

                                    self.yang_name = "sync-delay-restart"
                                    self.yang_parent_name = "igp"

                                    self.configured = YLeaf(YType.boolean, "configured")

                                    self.delay_secs = YLeaf(YType.uint32, "delay-secs")

                                    self.remaining_secs = YLeaf(YType.uint32, "remaining-secs")

                                    self.timer_running = YLeaf(YType.boolean, "timer-running")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("configured",
                                                    "delay_secs",
                                                    "remaining_secs",
                                                    "timer_running") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.configured.is_set or
                                        self.delay_secs.is_set or
                                        self.remaining_secs.is_set or
                                        self.timer_running.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.configured.yfilter != YFilter.not_set or
                                        self.delay_secs.yfilter != YFilter.not_set or
                                        self.remaining_secs.yfilter != YFilter.not_set or
                                        self.timer_running.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sync-delay-restart" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.configured.is_set or self.configured.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.configured.get_name_leafdata())
                                    if (self.delay_secs.is_set or self.delay_secs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.delay_secs.get_name_leafdata())
                                    if (self.remaining_secs.is_set or self.remaining_secs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remaining_secs.get_name_leafdata())
                                    if (self.timer_running.is_set or self.timer_running.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.timer_running.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "configured" or name == "delay-secs" or name == "remaining-secs" or name == "timer-running"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "configured"):
                                        self.configured = value
                                        self.configured.value_namespace = name_space
                                        self.configured.value_namespace_prefix = name_space_prefix
                                    if(value_path == "delay-secs"):
                                        self.delay_secs = value
                                        self.delay_secs.value_namespace = name_space
                                        self.delay_secs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remaining-secs"):
                                        self.remaining_secs = value
                                        self.remaining_secs.value_namespace = name_space
                                        self.remaining_secs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "timer-running"):
                                        self.timer_running = value
                                        self.timer_running.value_namespace = name_space
                                        self.timer_running.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sync_delay_restart is not None and self.sync_delay_restart.has_data()) or
                                    (self.syncs is not None and self.syncs.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sync_delay_restart is not None and self.sync_delay_restart.has_operation()) or
                                    (self.syncs is not None and self.syncs.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "igp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sync-delay-restart"):
                                    if (self.sync_delay_restart is None):
                                        self.sync_delay_restart = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.SyncDelayRestart()
                                        self.sync_delay_restart.parent = self
                                        self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                    return self.sync_delay_restart

                                if (child_yang_name == "syncs"):
                                    if (self.syncs is None):
                                        self.syncs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp.Syncs()
                                        self.syncs.parent = self
                                        self._children_name_map["syncs"] = "syncs"
                                    return self.syncs

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sync-delay-restart" or name == "syncs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsSummary(Entity):
                            """
                            Counters for the LDP Label Infomation Base
                            (LIB)
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: bind_af
                            
                            	bind af
                            	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.BindAf>`
                            
                            .. attribute:: binding_local_explicit_null
                            
                            	Number of local explicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_implicit_null
                            
                            	Number of local implicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_no_route
                            
                            	Local bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_non_null
                            
                            	Number of local non\-null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_null
                            
                            	Number of local null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_oor
                            
                            	Number of local bindings        needing label \- OOR
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_no_route
                            
                            	Bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: highest_allocated_label
                            
                            	Highest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lowest_allocated_label
                            
                            	Lowest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary, self).__init__()

                                self.yang_name = "bindings-summary"
                                self.yang_parent_name = "af"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.bind_af = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "binding_local_explicit_null",
                                                "binding_local_implicit_null",
                                                "binding_local_no_route",
                                                "binding_local_non_null",
                                                "binding_local_null",
                                                "binding_local_oor",
                                                "binding_no_route",
                                                "highest_allocated_label",
                                                "lowest_allocated_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "bindings-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class BindAf(Entity):
                                """
                                bind af
                                
                                .. attribute:: address_family
                                
                                	Binding Summary Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: binding_local
                                
                                	Number of local bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_remote
                                
                                	Number of remote bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_total
                                
                                	Total bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_lib_update
                                
                                	Last update to LIB local binding
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lib_minimum_revision_sent_all
                                
                                	Last update sent to all peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__init__()

                                    self.yang_name = "bind-af"
                                    self.yang_parent_name = "bindings-summary"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local = YLeaf(YType.uint32, "binding-local")

                                    self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                    self.binding_total = YLeaf(YType.uint32, "binding-total")

                                    self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                    self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local",
                                                    "binding_remote",
                                                    "binding_total",
                                                    "last_lib_update",
                                                    "lib_minimum_revision_sent_all") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local.is_set or
                                        self.binding_remote.is_set or
                                        self.binding_total.is_set or
                                        self.last_lib_update.is_set or
                                        self.lib_minimum_revision_sent_all.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local.yfilter != YFilter.not_set or
                                        self.binding_remote.yfilter != YFilter.not_set or
                                        self.binding_total.yfilter != YFilter.not_set or
                                        self.last_lib_update.yfilter != YFilter.not_set or
                                        self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bind-af" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local.get_name_leafdata())
                                    if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                    if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_total.get_name_leafdata())
                                    if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                    if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local"):
                                        self.binding_local = value
                                        self.binding_local.value_namespace = name_space
                                        self.binding_local.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-remote"):
                                        self.binding_remote = value
                                        self.binding_remote.value_namespace = name_space
                                        self.binding_remote.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-total"):
                                        self.binding_total = value
                                        self.binding_total.value_namespace = name_space
                                        self.binding_total.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-lib-update"):
                                        self.last_lib_update = value
                                        self.last_lib_update.value_namespace = name_space
                                        self.last_lib_update.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lib-minimum-revision-sent-all"):
                                        self.lib_minimum_revision_sent_all = value
                                        self.lib_minimum_revision_sent_all.value_namespace = name_space
                                        self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bind_af:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.address_family.is_set or
                                    self.binding_local_explicit_null.is_set or
                                    self.binding_local_implicit_null.is_set or
                                    self.binding_local_no_route.is_set or
                                    self.binding_local_non_null.is_set or
                                    self.binding_local_null.is_set or
                                    self.binding_local_oor.is_set or
                                    self.binding_no_route.is_set or
                                    self.highest_allocated_label.is_set or
                                    self.lowest_allocated_label.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.bind_af:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_no_route.yfilter != YFilter.not_set or
                                    self.binding_local_non_null.yfilter != YFilter.not_set or
                                    self.binding_local_null.yfilter != YFilter.not_set or
                                    self.binding_local_oor.yfilter != YFilter.not_set or
                                    self.binding_no_route.yfilter != YFilter.not_set or
                                    self.highest_allocated_label.yfilter != YFilter.not_set or
                                    self.lowest_allocated_label.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bind-af"):
                                    for c in self.bind_af:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.BindAf()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bind_af.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-explicit-null"):
                                    self.binding_local_explicit_null = value
                                    self.binding_local_explicit_null.value_namespace = name_space
                                    self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-implicit-null"):
                                    self.binding_local_implicit_null = value
                                    self.binding_local_implicit_null.value_namespace = name_space
                                    self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-no-route"):
                                    self.binding_local_no_route = value
                                    self.binding_local_no_route.value_namespace = name_space
                                    self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-non-null"):
                                    self.binding_local_non_null = value
                                    self.binding_local_non_null.value_namespace = name_space
                                    self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-null"):
                                    self.binding_local_null = value
                                    self.binding_local_null.value_namespace = name_space
                                    self.binding_local_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-oor"):
                                    self.binding_local_oor = value
                                    self.binding_local_oor.value_namespace = name_space
                                    self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-no-route"):
                                    self.binding_no_route = value
                                    self.binding_no_route.value_namespace = name_space
                                    self.binding_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "highest-allocated-label"):
                                    self.highest_allocated_label = value
                                    self.highest_allocated_label.value_namespace = name_space
                                    self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lowest-allocated-label"):
                                    self.lowest_allocated_label = value
                                    self.lowest_allocated_label.value_namespace = name_space
                                    self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                        class Interfaces(Entity):
                            """
                            LDP Interface related information
                            
                            .. attribute:: interface
                            
                            	IPv4 interface information
                            	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces, self).__init__()

                                self.yang_name = "interfaces"
                                self.yang_parent_name = "af"

                                self.interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces, self).__setattr__(name, value)


                            class Interface(Entity):
                                """
                                IPv4 interface information
                                
                                .. attribute:: interface_name  <key>
                                
                                	The Interface Name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: auto_config
                                
                                	Auto config
                                	**type**\: list of    :py:class:`AutoConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig>`
                                
                                .. attribute:: interface
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: interface_name_xr
                                
                                	Interface name
                                	**type**\:  str
                                
                                .. attribute:: is_im_stale
                                
                                	Is IM information stale
                                	**type**\:  bool
                                
                                .. attribute:: ldp_autoconfig_disable
                                
                                	LDP autoconfig disable
                                	**type**\:  bool
                                
                                .. attribute:: ldp_config_mode
                                
                                	LDP config mode
                                	**type**\:  bool
                                
                                .. attribute:: ldp_enabled
                                
                                	LDP enabled
                                	**type**\:  bool
                                
                                .. attribute:: te_mesh_grp
                                
                                	TE tunnel mesh\-group
                                	**type**\: list of    :py:class:`TeMeshGrp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface, self).__init__()

                                    self.yang_name = "interface"
                                    self.yang_parent_name = "interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.interface = YLeaf(YType.str, "interface")

                                    self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                    self.is_im_stale = YLeaf(YType.boolean, "is-im-stale")

                                    self.ldp_autoconfig_disable = YLeaf(YType.boolean, "ldp-autoconfig-disable")

                                    self.ldp_config_mode = YLeaf(YType.boolean, "ldp-config-mode")

                                    self.ldp_enabled = YLeaf(YType.boolean, "ldp-enabled")

                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.auto_config = YList(self)
                                    self.te_mesh_grp = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "interface",
                                                    "interface_name_xr",
                                                    "is_im_stale",
                                                    "ldp_autoconfig_disable",
                                                    "ldp_config_mode",
                                                    "ldp_enabled") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "interface"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class TeMeshGrp(Entity):
                                    """
                                    TE tunnel mesh\-group
                                    
                                    .. attribute:: ldp_mesh_group_enabled
                                    
                                    	LDP has enabled this TE mesh\-group
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_te_mesh_group_all_cfgd
                                    
                                    	LDP has enabled all TE mesh\-groups
                                    	**type**\:  bool
                                    
                                    .. attribute:: te_mesh_group_id
                                    
                                    	TE tunnel Mesh Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__init__()

                                        self.yang_name = "te-mesh-grp"
                                        self.yang_parent_name = "interface"

                                        self.ldp_mesh_group_enabled = YLeaf(YType.boolean, "ldp-mesh-group-enabled")

                                        self.ldp_te_mesh_group_all_cfgd = YLeaf(YType.boolean, "ldp-te-mesh-group-all-cfgd")

                                        self.te_mesh_group_id = YLeaf(YType.uint32, "te-mesh-group-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ldp_mesh_group_enabled",
                                                        "ldp_te_mesh_group_all_cfgd",
                                                        "te_mesh_group_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ldp_mesh_group_enabled.is_set or
                                            self.ldp_te_mesh_group_all_cfgd.is_set or
                                            self.te_mesh_group_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ldp_mesh_group_enabled.yfilter != YFilter.not_set or
                                            self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set or
                                            self.te_mesh_group_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-mesh-grp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ldp_mesh_group_enabled.is_set or self.ldp_mesh_group_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_mesh_group_enabled.get_name_leafdata())
                                        if (self.ldp_te_mesh_group_all_cfgd.is_set or self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_te_mesh_group_all_cfgd.get_name_leafdata())
                                        if (self.te_mesh_group_id.is_set or self.te_mesh_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_mesh_group_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ldp-mesh-group-enabled" or name == "ldp-te-mesh-group-all-cfgd" or name == "te-mesh-group-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ldp-mesh-group-enabled"):
                                            self.ldp_mesh_group_enabled = value
                                            self.ldp_mesh_group_enabled.value_namespace = name_space
                                            self.ldp_mesh_group_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-te-mesh-group-all-cfgd"):
                                            self.ldp_te_mesh_group_all_cfgd = value
                                            self.ldp_te_mesh_group_all_cfgd.value_namespace = name_space
                                            self.ldp_te_mesh_group_all_cfgd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-mesh-group-id"):
                                            self.te_mesh_group_id = value
                                            self.te_mesh_group_id.value_namespace = name_space
                                            self.te_mesh_group_id.value_namespace_prefix = name_space_prefix


                                class AutoConfig(Entity):
                                    """
                                    Auto config
                                    
                                    .. attribute:: tuple
                                    
                                    	Tuple
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__init__()

                                        self.yang_name = "auto-config"
                                        self.yang_parent_name = "interface"

                                        self.tuple = YLeaf(YType.str, "tuple")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tuple") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.tuple.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tuple.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "auto-config" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tuple.is_set or self.tuple.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tuple.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "tuple"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tuple"):
                                            self.tuple = value
                                            self.tuple.value_namespace = name_space
                                            self.tuple.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.auto_config:
                                        if (c.has_data()):
                                            return True
                                    for c in self.te_mesh_grp:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.interface_name.is_set or
                                        self.interface.is_set or
                                        self.interface_name_xr.is_set or
                                        self.is_im_stale.is_set or
                                        self.ldp_autoconfig_disable.is_set or
                                        self.ldp_config_mode.is_set or
                                        self.ldp_enabled.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.auto_config:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.te_mesh_grp:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.interface.yfilter != YFilter.not_set or
                                        self.interface_name_xr.yfilter != YFilter.not_set or
                                        self.is_im_stale.yfilter != YFilter.not_set or
                                        self.ldp_autoconfig_disable.yfilter != YFilter.not_set or
                                        self.ldp_config_mode.yfilter != YFilter.not_set or
                                        self.ldp_enabled.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface.get_name_leafdata())
                                    if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                    if (self.is_im_stale.is_set or self.is_im_stale.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_im_stale.get_name_leafdata())
                                    if (self.ldp_autoconfig_disable.is_set or self.ldp_autoconfig_disable.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_autoconfig_disable.get_name_leafdata())
                                    if (self.ldp_config_mode.is_set or self.ldp_config_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_config_mode.get_name_leafdata())
                                    if (self.ldp_enabled.is_set or self.ldp_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_enabled.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "auto-config"):
                                        for c in self.auto_config:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.auto_config.append(c)
                                        return c

                                    if (child_yang_name == "te-mesh-grp"):
                                        for c in self.te_mesh_grp:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.te_mesh_grp.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "auto-config" or name == "te-mesh-grp" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "is-im-stale" or name == "ldp-autoconfig-disable" or name == "ldp-config-mode" or name == "ldp-enabled"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface"):
                                        self.interface = value
                                        self.interface.value_namespace = name_space
                                        self.interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-name-xr"):
                                        self.interface_name_xr = value
                                        self.interface_name_xr.value_namespace = name_space
                                        self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-im-stale"):
                                        self.is_im_stale = value
                                        self.is_im_stale.value_namespace = name_space
                                        self.is_im_stale.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-autoconfig-disable"):
                                        self.ldp_autoconfig_disable = value
                                        self.ldp_autoconfig_disable.value_namespace = name_space
                                        self.ldp_autoconfig_disable.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-config-mode"):
                                        self.ldp_config_mode = value
                                        self.ldp_config_mode.value_namespace = name_space
                                        self.ldp_config_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-enabled"):
                                        self.ldp_enabled = value
                                        self.ldp_enabled.value_namespace = name_space
                                        self.ldp_enabled.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "interface"):
                                    for c in self.interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces.Interface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Discovery(Entity):
                            """
                            The LDP Discovery
                            
                            .. attribute:: brief
                            
                            	Brief information on LDP discovery
                            	**type**\:   :py:class:`Brief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief>`
                            
                            .. attribute:: link_hellos
                            
                            	The LDP Discovery link
                            	**type**\:   :py:class:`LinkHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos>`
                            
                            .. attribute:: stats
                            
                            	The LDP Discovery Statistics
                            	**type**\:   :py:class:`Stats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats>`
                            
                            .. attribute:: summary
                            
                            	Summarized information on LDP discovery
                            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary>`
                            
                            .. attribute:: targeted_hellos
                            
                            	The LDP Discovery Targeted
                            	**type**\:   :py:class:`TargetedHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery, self).__init__()

                                self.yang_name = "discovery"
                                self.yang_parent_name = "af"

                                self.brief = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief()
                                self.brief.parent = self
                                self._children_name_map["brief"] = "brief"
                                self._children_yang_names.add("brief")

                                self.link_hellos = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos()
                                self.link_hellos.parent = self
                                self._children_name_map["link_hellos"] = "link-hellos"
                                self._children_yang_names.add("link-hellos")

                                self.stats = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats()
                                self.stats.parent = self
                                self._children_name_map["stats"] = "stats"
                                self._children_yang_names.add("stats")

                                self.summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary()
                                self.summary.parent = self
                                self._children_name_map["summary"] = "summary"
                                self._children_yang_names.add("summary")

                                self.targeted_hellos = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos()
                                self.targeted_hellos.parent = self
                                self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                self._children_yang_names.add("targeted-hellos")


                            class LinkHellos(Entity):
                                """
                                The LDP Discovery link
                                
                                .. attribute:: link_hello
                                
                                	Information on LDP link discovery
                                	**type**\: list of    :py:class:`LinkHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__init__()

                                    self.yang_name = "link-hellos"
                                    self.yang_parent_name = "discovery"

                                    self.link_hello = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)


                                class LinkHello(Entity):
                                    """
                                    Information on LDP link discovery
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: discovery_link_af
                                    
                                    	LDP hello AF info
                                    	**type**\: list of    :py:class:`DiscoveryLinkAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf>`
                                    
                                    .. attribute:: hello_information
                                    
                                    	LDP hello info
                                    	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation>`
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: next_hello
                                    
                                    	Next hello due time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: quick_start_disabled
                                    
                                    	Quick\-start disabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__init__()

                                        self.yang_name = "link-hello"
                                        self.yang_parent_name = "link-hellos"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.next_hello = YLeaf(YType.uint32, "next-hello")

                                        self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                        self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.discovery_link_af = YList(self)
                                        self.hello_information = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "interface",
                                                        "interface_name_xr",
                                                        "next_hello",
                                                        "quick_start_disabled") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "link-hello"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class HelloInformation(Entity):
                                        """
                                        LDP hello info
                                        
                                        .. attribute:: disc_expiry
                                        
                                        	Discovery expiry time in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: established_age
                                        
                                        	Hello adjacency estabished age in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: established_time
                                        
                                        	Hello adjacency estabished time in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: hold_time
                                        
                                        	Session hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: is_no_route
                                        
                                        	Is route valid
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_targeted
                                        
                                        	Is session a targeted session
                                        	**type**\:  bool
                                        
                                        .. attribute:: last_session_down_info
                                        
                                        	Last session down information
                                        	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo>`
                                        
                                        .. attribute:: local_hold_time
                                        
                                        	Local hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: neighbor_hold_time
                                        
                                        	Neighbor hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: neighbor_ldp_identifier
                                        
                                        	Neighbor LDP Identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: neighbor_src_address
                                        
                                        	Neighbor source address
                                        	**type**\:   :py:class:`NeighborSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress>`
                                        
                                        .. attribute:: neighbor_transport_address
                                        
                                        	Neighbor transport address
                                        	**type**\:   :py:class:`NeighborTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress>`
                                        
                                        .. attribute:: session_bringup_failure_reason
                                        
                                        	session bringup failure reason
                                        	**type**\:  str
                                        
                                        .. attribute:: session_up
                                        
                                        	Is session up for this adj
                                        	**type**\:  bool
                                        
                                        .. attribute:: target
                                        
                                        	Target address
                                        	**type**\:   :py:class:`Target <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__init__()

                                            self.yang_name = "hello-information"
                                            self.yang_parent_name = "link-hello"

                                            self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                            self.established_age = YLeaf(YType.uint64, "established-age")

                                            self.established_time = YLeaf(YType.uint64, "established-time")

                                            self.hold_time = YLeaf(YType.uint32, "hold-time")

                                            self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                            self.is_targeted = YLeaf(YType.boolean, "is-targeted")

                                            self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                            self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                            self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                            self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                            self.session_up = YLeaf(YType.boolean, "session-up")

                                            self.neighbor_src_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                            self.neighbor_src_address.parent = self
                                            self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                            self._children_yang_names.add("neighbor-src-address")

                                            self.neighbor_transport_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                            self.neighbor_transport_address.parent = self
                                            self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                            self._children_yang_names.add("neighbor-transport-address")

                                            self.target = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                            self.target.parent = self
                                            self._children_name_map["target"] = "target"
                                            self._children_yang_names.add("target")

                                            self.last_session_down_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("disc_expiry",
                                                            "established_age",
                                                            "established_time",
                                                            "hold_time",
                                                            "is_no_route",
                                                            "is_targeted",
                                                            "local_hold_time",
                                                            "neighbor_hold_time",
                                                            "neighbor_ldp_identifier",
                                                            "session_bringup_failure_reason",
                                                            "session_up") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)


                                        class NeighborSrcAddress(Entity):
                                            """
                                            Neighbor source address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__init__()

                                                self.yang_name = "neighbor-src-address"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-src-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class NeighborTransportAddress(Entity):
                                            """
                                            Neighbor transport address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__init__()

                                                self.yang_name = "neighbor-transport-address"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-transport-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class Target(Entity):
                                            """
                                            Target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__init__()

                                                self.yang_name = "target"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LastSessionDownInfo(Entity):
                                            """
                                            Last session down information
                                            
                                            .. attribute:: last_session_down_reason
                                            
                                            	The reason of last socket failure
                                            	**type**\:  str
                                            
                                            .. attribute:: last_session_down_time
                                            
                                            	Timestamp of when the last session went down
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: last_session_up_time
                                            
                                            	The time duration the last session was up
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__init__()

                                                self.yang_name = "last-session-down-info"
                                                self.yang_parent_name = "hello-information"

                                                self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("last_session_down_reason",
                                                                "last_session_down_time",
                                                                "last_session_up_time") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.last_session_down_reason.is_set or
                                                    self.last_session_down_time.is_set or
                                                    self.last_session_up_time.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.last_session_down_reason.yfilter != YFilter.not_set or
                                                    self.last_session_down_time.yfilter != YFilter.not_set or
                                                    self.last_session_up_time.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "last-session-down-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "last-session-down-reason"):
                                                    self.last_session_down_reason = value
                                                    self.last_session_down_reason.value_namespace = name_space
                                                    self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-down-time"):
                                                    self.last_session_down_time = value
                                                    self.last_session_down_time.value_namespace = name_space
                                                    self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-up-time"):
                                                    self.last_session_up_time = value
                                                    self.last_session_up_time.value_namespace = name_space
                                                    self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.disc_expiry.is_set or
                                                self.established_age.is_set or
                                                self.established_time.is_set or
                                                self.hold_time.is_set or
                                                self.is_no_route.is_set or
                                                self.is_targeted.is_set or
                                                self.local_hold_time.is_set or
                                                self.neighbor_hold_time.is_set or
                                                self.neighbor_ldp_identifier.is_set or
                                                self.session_bringup_failure_reason.is_set or
                                                self.session_up.is_set or
                                                (self.neighbor_src_address is not None and self.neighbor_src_address.has_data()) or
                                                (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_data()) or
                                                (self.target is not None and self.target.has_data()))

                                        def has_operation(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.disc_expiry.yfilter != YFilter.not_set or
                                                self.established_age.yfilter != YFilter.not_set or
                                                self.established_time.yfilter != YFilter.not_set or
                                                self.hold_time.yfilter != YFilter.not_set or
                                                self.is_no_route.yfilter != YFilter.not_set or
                                                self.is_targeted.yfilter != YFilter.not_set or
                                                self.local_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                self.session_up.yfilter != YFilter.not_set or
                                                (self.neighbor_src_address is not None and self.neighbor_src_address.has_operation()) or
                                                (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_operation()) or
                                                (self.target is not None and self.target.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "hello-information" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                            if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_age.get_name_leafdata())
                                            if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_time.get_name_leafdata())
                                            if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_time.get_name_leafdata())
                                            if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                            if (self.is_targeted.is_set or self.is_targeted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_targeted.get_name_leafdata())
                                            if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                            if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                            if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                            if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                            if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_up.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "last-session-down-info"):
                                                for c in self.last_session_down_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.last_session_down_info.append(c)
                                                return c

                                            if (child_yang_name == "neighbor-src-address"):
                                                if (self.neighbor_src_address is None):
                                                    self.neighbor_src_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                    self.neighbor_src_address.parent = self
                                                    self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                return self.neighbor_src_address

                                            if (child_yang_name == "neighbor-transport-address"):
                                                if (self.neighbor_transport_address is None):
                                                    self.neighbor_transport_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                    self.neighbor_transport_address.parent = self
                                                    self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                return self.neighbor_transport_address

                                            if (child_yang_name == "target"):
                                                if (self.target is None):
                                                    self.target = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                    self.target.parent = self
                                                    self._children_name_map["target"] = "target"
                                                return self.target

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "last-session-down-info" or name == "neighbor-src-address" or name == "neighbor-transport-address" or name == "target" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "is-no-route" or name == "is-targeted" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "neighbor-ldp-identifier" or name == "session-bringup-failure-reason" or name == "session-up"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "disc-expiry"):
                                                self.disc_expiry = value
                                                self.disc_expiry.value_namespace = name_space
                                                self.disc_expiry.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-age"):
                                                self.established_age = value
                                                self.established_age.value_namespace = name_space
                                                self.established_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-time"):
                                                self.established_time = value
                                                self.established_time.value_namespace = name_space
                                                self.established_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-time"):
                                                self.hold_time = value
                                                self.hold_time.value_namespace = name_space
                                                self.hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-route"):
                                                self.is_no_route = value
                                                self.is_no_route.value_namespace = name_space
                                                self.is_no_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-targeted"):
                                                self.is_targeted = value
                                                self.is_targeted.value_namespace = name_space
                                                self.is_targeted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-hold-time"):
                                                self.local_hold_time = value
                                                self.local_hold_time.value_namespace = name_space
                                                self.local_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-hold-time"):
                                                self.neighbor_hold_time = value
                                                self.neighbor_hold_time.value_namespace = name_space
                                                self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-ldp-identifier"):
                                                self.neighbor_ldp_identifier = value
                                                self.neighbor_ldp_identifier.value_namespace = name_space
                                                self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-bringup-failure-reason"):
                                                self.session_bringup_failure_reason = value
                                                self.session_bringup_failure_reason.value_namespace = name_space
                                                self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-up"):
                                                self.session_up = value
                                                self.session_up.value_namespace = name_space
                                                self.session_up.value_namespace_prefix = name_space_prefix


                                    class DiscoveryLinkAf(Entity):
                                        """
                                        LDP hello AF info
                                        
                                        .. attribute:: interval
                                        
                                        	Hello interval in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: local_src_address
                                        
                                        	Local source address
                                        	**type**\:   :py:class:`LocalSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress>`
                                        
                                        .. attribute:: local_transport_address
                                        
                                        	Local transport address
                                        	**type**\:   :py:class:`LocalTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__init__()

                                            self.yang_name = "discovery-link-af"
                                            self.yang_parent_name = "link-hello"

                                            self.interval = YLeaf(YType.uint32, "interval")

                                            self.local_src_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                            self.local_src_address.parent = self
                                            self._children_name_map["local_src_address"] = "local-src-address"
                                            self._children_yang_names.add("local-src-address")

                                            self.local_transport_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                            self.local_transport_address.parent = self
                                            self._children_name_map["local_transport_address"] = "local-transport-address"
                                            self._children_yang_names.add("local-transport-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interval") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)


                                        class LocalSrcAddress(Entity):
                                            """
                                            Local source address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__init__()

                                                self.yang_name = "local-src-address"
                                                self.yang_parent_name = "discovery-link-af"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-src-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LocalTransportAddress(Entity):
                                            """
                                            Local transport address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__init__()

                                                self.yang_name = "local-transport-address"
                                                self.yang_parent_name = "discovery-link-af"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-transport-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interval.is_set or
                                                (self.local_src_address is not None and self.local_src_address.has_data()) or
                                                (self.local_transport_address is not None and self.local_transport_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interval.yfilter != YFilter.not_set or
                                                (self.local_src_address is not None and self.local_src_address.has_operation()) or
                                                (self.local_transport_address is not None and self.local_transport_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "discovery-link-af" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interval.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-src-address"):
                                                if (self.local_src_address is None):
                                                    self.local_src_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                    self.local_src_address.parent = self
                                                    self._children_name_map["local_src_address"] = "local-src-address"
                                                return self.local_src_address

                                            if (child_yang_name == "local-transport-address"):
                                                if (self.local_transport_address is None):
                                                    self.local_transport_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                    self.local_transport_address.parent = self
                                                    self._children_name_map["local_transport_address"] = "local-transport-address"
                                                return self.local_transport_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-src-address" or name == "local-transport-address" or name == "interval"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interval"):
                                                self.interval = value
                                                self.interval.value_namespace = name_space
                                                self.interval.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.discovery_link_af:
                                            if (c.has_data()):
                                                return True
                                        for c in self.hello_information:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.interface.is_set or
                                            self.interface_name_xr.is_set or
                                            self.next_hello.is_set or
                                            self.quick_start_disabled.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.discovery_link_af:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.hello_information:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.next_hello.yfilter != YFilter.not_set or
                                            self.quick_start_disabled.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hello.get_name_leafdata())
                                        if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "discovery-link-af"):
                                            for c in self.discovery_link_af:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.discovery_link_af.append(c)
                                            return c

                                        if (child_yang_name == "hello-information"):
                                            for c in self.hello_information:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.hello_information.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "discovery-link-af" or name == "hello-information" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "next-hello" or name == "quick-start-disabled"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hello"):
                                            self.next_hello = value
                                            self.next_hello.value_namespace = name_space
                                            self.next_hello.value_namespace_prefix = name_space_prefix
                                        if(value_path == "quick-start-disabled"):
                                            self.quick_start_disabled = value
                                            self.quick_start_disabled.value_namespace = name_space
                                            self.quick_start_disabled.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.link_hello:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.link_hello:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "link-hellos" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello"):
                                        for c in self.link_hello:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.link_hello.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Summary(Entity):
                                """
                                Summarized information on LDP discovery
                                
                                .. attribute:: local_ldp_id
                                
                                	Local LDP identifier
                                	**type**\:  str
                                
                                .. attribute:: num_of_active_ldp_interfaces
                                
                                	Number of active LDP enabled interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_addr_recv
                                
                                	Number of hello discoveries received with bad source address
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_hello_pdu
                                
                                	Number of hello discoveries received with bad hello PDU
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_xport_addr
                                
                                	Number of hello discoveries received with bad export address
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_same_router_id
                                
                                	Number of hello discoveries received with the same router id as this router
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_wrong_router_id
                                
                                	Number of hello discoveries received with the router id that is not destined for this router
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_ldp_interfaces
                                
                                	Total Number of LDP configured interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_lnk_disc_recv
                                
                                	Number of link hello discoveries in recv state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_lnk_disc_xmit
                                
                                	Number of link hello discoveries in xmit state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_tgt_disc_recv
                                
                                	Number of targeted hello discoveries in recv state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_tgt_disc_xmit
                                
                                	Number of targeted hello discoveries in xmit state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary, self).__init__()

                                    self.yang_name = "summary"
                                    self.yang_parent_name = "discovery"

                                    self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                                    self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                                    self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                                    self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                                    self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                                    self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                                    self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                                    self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                                    self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                                    self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                                    self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                                    self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_ldp_id",
                                                    "num_of_active_ldp_interfaces",
                                                    "num_of_disc_with_bad_addr_recv",
                                                    "num_of_disc_with_bad_hello_pdu",
                                                    "num_of_disc_with_bad_xport_addr",
                                                    "num_of_disc_with_same_router_id",
                                                    "num_of_disc_with_wrong_router_id",
                                                    "num_of_ldp_interfaces",
                                                    "num_of_lnk_disc_recv",
                                                    "num_of_lnk_disc_xmit",
                                                    "num_of_tgt_disc_recv",
                                                    "num_of_tgt_disc_xmit") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.local_ldp_id.is_set or
                                        self.num_of_active_ldp_interfaces.is_set or
                                        self.num_of_disc_with_bad_addr_recv.is_set or
                                        self.num_of_disc_with_bad_hello_pdu.is_set or
                                        self.num_of_disc_with_bad_xport_addr.is_set or
                                        self.num_of_disc_with_same_router_id.is_set or
                                        self.num_of_disc_with_wrong_router_id.is_set or
                                        self.num_of_ldp_interfaces.is_set or
                                        self.num_of_lnk_disc_recv.is_set or
                                        self.num_of_lnk_disc_xmit.is_set or
                                        self.num_of_tgt_disc_recv.is_set or
                                        self.num_of_tgt_disc_xmit.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_ldp_id.yfilter != YFilter.not_set or
                                        self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                                        self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                                        self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                                        self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                                        self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                                        self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                                    if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                                    if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                                    if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                                    if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                                    if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                                    if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                                    if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                                    if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-ldp-id"):
                                        self.local_ldp_id = value
                                        self.local_ldp_id.value_namespace = name_space
                                        self.local_ldp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-active-ldp-interfaces"):
                                        self.num_of_active_ldp_interfaces = value
                                        self.num_of_active_ldp_interfaces.value_namespace = name_space
                                        self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-addr-recv"):
                                        self.num_of_disc_with_bad_addr_recv = value
                                        self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                                        self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-hello-pdu"):
                                        self.num_of_disc_with_bad_hello_pdu = value
                                        self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                                        self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-xport-addr"):
                                        self.num_of_disc_with_bad_xport_addr = value
                                        self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                                        self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-same-router-id"):
                                        self.num_of_disc_with_same_router_id = value
                                        self.num_of_disc_with_same_router_id.value_namespace = name_space
                                        self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-wrong-router-id"):
                                        self.num_of_disc_with_wrong_router_id = value
                                        self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                                        self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-ldp-interfaces"):
                                        self.num_of_ldp_interfaces = value
                                        self.num_of_ldp_interfaces.value_namespace = name_space
                                        self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-lnk-disc-recv"):
                                        self.num_of_lnk_disc_recv = value
                                        self.num_of_lnk_disc_recv.value_namespace = name_space
                                        self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-lnk-disc-xmit"):
                                        self.num_of_lnk_disc_xmit = value
                                        self.num_of_lnk_disc_xmit.value_namespace = name_space
                                        self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-tgt-disc-recv"):
                                        self.num_of_tgt_disc_recv = value
                                        self.num_of_tgt_disc_recv.value_namespace = name_space
                                        self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-tgt-disc-xmit"):
                                        self.num_of_tgt_disc_xmit = value
                                        self.num_of_tgt_disc_xmit.value_namespace = name_space
                                        self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix


                            class TargetedHellos(Entity):
                                """
                                The LDP Discovery Targeted
                                
                                .. attribute:: targeted_hello
                                
                                	Information on LDP targeted discovery
                                	**type**\: list of    :py:class:`TargetedHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__init__()

                                    self.yang_name = "targeted-hellos"
                                    self.yang_parent_name = "discovery"

                                    self.targeted_hello = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)


                                class TargetedHello(Entity):
                                    """
                                    Information on LDP targeted discovery
                                    
                                    .. attribute:: adjacency_ldp_identifier
                                    
                                    	Adjacency LDP Identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: dhcb_local_address
                                    
                                    	DHCB local address
                                    	**type**\:   :py:class:`DhcbLocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress>`
                                    
                                    .. attribute:: dhcb_target_address
                                    
                                    	DHCB target address
                                    	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress>`
                                    
                                    .. attribute:: disc_expiry
                                    
                                    	Discovery expiry time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: established_age
                                    
                                    	Hello adjacency estabished age in nanosec
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: established_time
                                    
                                    	Hello adjacency estabished time in nanosec
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: hold_time
                                    
                                    	Targeted hello hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interval
                                    
                                    	Hello interval in sec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_session_down_info
                                    
                                    	Last session down information
                                    	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo>`
                                    
                                    .. attribute:: local_address
                                    
                                    	Local IP Address
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: local_hold_time
                                    
                                    	Local hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_hold_time
                                    
                                    	Neighbor hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hello
                                    
                                    	Next hello due time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: quick_start_disabled
                                    
                                    	Quick\-start disabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: session_bringup_failure_reason
                                    
                                    	session bringup failure reason
                                    	**type**\:  str
                                    
                                    .. attribute:: session_up
                                    
                                    	Is session up for this adj
                                    	**type**\:  bool
                                    
                                    .. attribute:: state
                                    
                                    	Targeted hello state
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	The target IP Address
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__init__()

                                        self.yang_name = "targeted-hello"
                                        self.yang_parent_name = "targeted-hellos"

                                        self.adjacency_ldp_identifier = YLeaf(YType.str, "adjacency-ldp-identifier")

                                        self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                        self.established_age = YLeaf(YType.uint64, "established-age")

                                        self.established_time = YLeaf(YType.uint64, "established-time")

                                        self.hold_time = YLeaf(YType.uint32, "hold-time")

                                        self.interval = YLeaf(YType.uint32, "interval")

                                        self.local_address = YLeaf(YType.str, "local-address")

                                        self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                        self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                        self.next_hello = YLeaf(YType.uint32, "next-hello")

                                        self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                        self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                        self.session_up = YLeaf(YType.boolean, "session-up")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.target_address = YLeaf(YType.str, "target-address")

                                        self.dhcb_local_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                        self.dhcb_local_address.parent = self
                                        self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                        self._children_yang_names.add("dhcb-local-address")

                                        self.dhcb_target_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                        self.dhcb_target_address.parent = self
                                        self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                        self._children_yang_names.add("dhcb-target-address")

                                        self.last_session_down_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("adjacency_ldp_identifier",
                                                        "disc_expiry",
                                                        "established_age",
                                                        "established_time",
                                                        "hold_time",
                                                        "interval",
                                                        "local_address",
                                                        "local_hold_time",
                                                        "neighbor_hold_time",
                                                        "next_hello",
                                                        "quick_start_disabled",
                                                        "session_bringup_failure_reason",
                                                        "session_up",
                                                        "state",
                                                        "target_address") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)


                                    class DhcbLocalAddress(Entity):
                                        """
                                        DHCB local address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__init__()

                                            self.yang_name = "dhcb-local-address"
                                            self.yang_parent_name = "targeted-hello"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "dhcb-local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class DhcbTargetAddress(Entity):
                                        """
                                        DHCB target address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__init__()

                                            self.yang_name = "dhcb-target-address"
                                            self.yang_parent_name = "targeted-hello"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "dhcb-target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class LastSessionDownInfo(Entity):
                                        """
                                        Last session down information
                                        
                                        .. attribute:: last_session_down_reason
                                        
                                        	The reason of last socket failure
                                        	**type**\:  str
                                        
                                        .. attribute:: last_session_down_time
                                        
                                        	Timestamp of when the last session went down
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: last_session_up_time
                                        
                                        	The time duration the last session was up
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__init__()

                                            self.yang_name = "last-session-down-info"
                                            self.yang_parent_name = "targeted-hello"

                                            self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                            self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                            self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("last_session_down_reason",
                                                            "last_session_down_time",
                                                            "last_session_up_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.last_session_down_reason.is_set or
                                                self.last_session_down_time.is_set or
                                                self.last_session_up_time.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.last_session_down_reason.yfilter != YFilter.not_set or
                                                self.last_session_down_time.yfilter != YFilter.not_set or
                                                self.last_session_up_time.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "last-session-down-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                            if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                            if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "last-session-down-reason"):
                                                self.last_session_down_reason = value
                                                self.last_session_down_reason.value_namespace = name_space
                                                self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-session-down-time"):
                                                self.last_session_down_time = value
                                                self.last_session_down_time.value_namespace = name_space
                                                self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-session-up-time"):
                                                self.last_session_up_time = value
                                                self.last_session_up_time.value_namespace = name_space
                                                self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.last_session_down_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.adjacency_ldp_identifier.is_set or
                                            self.disc_expiry.is_set or
                                            self.established_age.is_set or
                                            self.established_time.is_set or
                                            self.hold_time.is_set or
                                            self.interval.is_set or
                                            self.local_address.is_set or
                                            self.local_hold_time.is_set or
                                            self.neighbor_hold_time.is_set or
                                            self.next_hello.is_set or
                                            self.quick_start_disabled.is_set or
                                            self.session_bringup_failure_reason.is_set or
                                            self.session_up.is_set or
                                            self.state.is_set or
                                            self.target_address.is_set or
                                            (self.dhcb_local_address is not None and self.dhcb_local_address.has_data()) or
                                            (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()))

                                    def has_operation(self):
                                        for c in self.last_session_down_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.adjacency_ldp_identifier.yfilter != YFilter.not_set or
                                            self.disc_expiry.yfilter != YFilter.not_set or
                                            self.established_age.yfilter != YFilter.not_set or
                                            self.established_time.yfilter != YFilter.not_set or
                                            self.hold_time.yfilter != YFilter.not_set or
                                            self.interval.yfilter != YFilter.not_set or
                                            self.local_address.yfilter != YFilter.not_set or
                                            self.local_hold_time.yfilter != YFilter.not_set or
                                            self.neighbor_hold_time.yfilter != YFilter.not_set or
                                            self.next_hello.yfilter != YFilter.not_set or
                                            self.quick_start_disabled.yfilter != YFilter.not_set or
                                            self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                            self.session_up.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.target_address.yfilter != YFilter.not_set or
                                            (self.dhcb_local_address is not None and self.dhcb_local_address.has_operation()) or
                                            (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hello" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.adjacency_ldp_identifier.is_set or self.adjacency_ldp_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.adjacency_ldp_identifier.get_name_leafdata())
                                        if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                        if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.established_age.get_name_leafdata())
                                        if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.established_time.get_name_leafdata())
                                        if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_time.get_name_leafdata())
                                        if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interval.get_name_leafdata())
                                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_address.get_name_leafdata())
                                        if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                        if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                        if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hello.get_name_leafdata())
                                        if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())
                                        if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                        if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.session_up.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.target_address.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "dhcb-local-address"):
                                            if (self.dhcb_local_address is None):
                                                self.dhcb_local_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                                self.dhcb_local_address.parent = self
                                                self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                            return self.dhcb_local_address

                                        if (child_yang_name == "dhcb-target-address"):
                                            if (self.dhcb_target_address is None):
                                                self.dhcb_target_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                                self.dhcb_target_address.parent = self
                                                self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            return self.dhcb_target_address

                                        if (child_yang_name == "last-session-down-info"):
                                            for c in self.last_session_down_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.last_session_down_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dhcb-local-address" or name == "dhcb-target-address" or name == "last-session-down-info" or name == "adjacency-ldp-identifier" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "interval" or name == "local-address" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "next-hello" or name == "quick-start-disabled" or name == "session-bringup-failure-reason" or name == "session-up" or name == "state" or name == "target-address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "adjacency-ldp-identifier"):
                                            self.adjacency_ldp_identifier = value
                                            self.adjacency_ldp_identifier.value_namespace = name_space
                                            self.adjacency_ldp_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "disc-expiry"):
                                            self.disc_expiry = value
                                            self.disc_expiry.value_namespace = name_space
                                            self.disc_expiry.value_namespace_prefix = name_space_prefix
                                        if(value_path == "established-age"):
                                            self.established_age = value
                                            self.established_age.value_namespace = name_space
                                            self.established_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "established-time"):
                                            self.established_time = value
                                            self.established_time.value_namespace = name_space
                                            self.established_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-time"):
                                            self.hold_time = value
                                            self.hold_time.value_namespace = name_space
                                            self.hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interval"):
                                            self.interval = value
                                            self.interval.value_namespace = name_space
                                            self.interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-address"):
                                            self.local_address = value
                                            self.local_address.value_namespace = name_space
                                            self.local_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-hold-time"):
                                            self.local_hold_time = value
                                            self.local_hold_time.value_namespace = name_space
                                            self.local_hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-hold-time"):
                                            self.neighbor_hold_time = value
                                            self.neighbor_hold_time.value_namespace = name_space
                                            self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hello"):
                                            self.next_hello = value
                                            self.next_hello.value_namespace = name_space
                                            self.next_hello.value_namespace_prefix = name_space_prefix
                                        if(value_path == "quick-start-disabled"):
                                            self.quick_start_disabled = value
                                            self.quick_start_disabled.value_namespace = name_space
                                            self.quick_start_disabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "session-bringup-failure-reason"):
                                            self.session_bringup_failure_reason = value
                                            self.session_bringup_failure_reason.value_namespace = name_space
                                            self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "session-up"):
                                            self.session_up = value
                                            self.session_up.value_namespace = name_space
                                            self.session_up.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "target-address"):
                                            self.target_address = value
                                            self.target_address.value_namespace = name_space
                                            self.target_address.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.targeted_hello:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.targeted_hello:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "targeted-hellos" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "targeted-hello"):
                                        for c in self.targeted_hello:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.targeted_hello.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "targeted-hello"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Brief(Entity):
                                """
                                Brief information on LDP discovery
                                
                                .. attribute:: link_hello_briefs
                                
                                	The LDP Discovery link brief information
                                	**type**\:   :py:class:`LinkHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs>`
                                
                                .. attribute:: targeted_hello_briefs
                                
                                	The LDP Discovery Targeted brief information
                                	**type**\:   :py:class:`TargetedHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief, self).__init__()

                                    self.yang_name = "brief"
                                    self.yang_parent_name = "discovery"

                                    self.link_hello_briefs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                    self.link_hello_briefs.parent = self
                                    self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                    self._children_yang_names.add("link-hello-briefs")

                                    self.targeted_hello_briefs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                    self.targeted_hello_briefs.parent = self
                                    self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                    self._children_yang_names.add("targeted-hello-briefs")


                                class LinkHelloBriefs(Entity):
                                    """
                                    The LDP Discovery link brief information
                                    
                                    .. attribute:: link_hello_brief
                                    
                                    	Brief information on LDP link discovery
                                    	**type**\: list of    :py:class:`LinkHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__init__()

                                        self.yang_name = "link-hello-briefs"
                                        self.yang_parent_name = "brief"

                                        self.link_hello_brief = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)


                                    class LinkHelloBrief(Entity):
                                        """
                                        Brief information on LDP link discovery
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: address_family
                                        
                                        	Discovery Brief Address Family
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: address_family_set
                                        
                                        	Discovery Brief Address Family Set
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation>`
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__init__()

                                            self.yang_name = "link-hello-brief"
                                            self.yang_parent_name = "link-hello-briefs"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.address_family = YLeaf(YType.enumeration, "address-family")

                                            self.address_family_set = YLeaf(YType.enumeration, "address-family-set")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "address_family",
                                                            "address_family_set",
                                                            "interface",
                                                            "interface_name_xr") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "link-hello-brief"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "link-hello-brief"

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_up.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.address_family.is_set or
                                                self.address_family_set.is_set or
                                                self.interface.is_set or
                                                self.interface_name_xr.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.address_family.yfilter != YFilter.not_set or
                                                self.address_family_set.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family.get_name_leafdata())
                                            if (self.address_family_set.is_set or self.address_family_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family_set.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "hello-information" or name == "vrf" or name == "interface-name" or name == "address-family" or name == "address-family-set" or name == "interface" or name == "interface-name-xr"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "address-family"):
                                                self.address_family = value
                                                self.address_family.value_namespace = name_space
                                                self.address_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "address-family-set"):
                                                self.address_family_set = value
                                                self.address_family_set.value_namespace = name_space
                                                self.address_family_set.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link_hello_brief:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.link_hello_brief:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-briefs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-brief"):
                                            for c in self.link_hello_brief:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link_hello_brief.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-brief"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class TargetedHelloBriefs(Entity):
                                    """
                                    The LDP Discovery Targeted brief information
                                    
                                    .. attribute:: targeted_hello_brief
                                    
                                    	Brief information on LDP targeted discovery
                                    	**type**\: list of    :py:class:`TargetedHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__init__()

                                        self.yang_name = "targeted-hello-briefs"
                                        self.yang_parent_name = "brief"

                                        self.targeted_hello_brief = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)


                                    class TargetedHelloBrief(Entity):
                                        """
                                        Brief information on LDP targeted discovery
                                        
                                        .. attribute:: address_family
                                        
                                        	Targeted Discovery Address Family
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: dhcb_target_address
                                        
                                        	DHCB target address
                                        	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation>`
                                        
                                        .. attribute:: local_address
                                        
                                        	Local IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: target_address
                                        
                                        	The target IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__init__()

                                            self.yang_name = "targeted-hello-brief"
                                            self.yang_parent_name = "targeted-hello-briefs"

                                            self.address_family = YLeaf(YType.enumeration, "address-family")

                                            self.local_address = YLeaf(YType.str, "local-address")

                                            self.target_address = YLeaf(YType.str, "target-address")

                                            self.dhcb_target_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                            self.dhcb_target_address.parent = self
                                            self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            self._children_yang_names.add("dhcb-target-address")

                                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address_family",
                                                            "local_address",
                                                            "target_address") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class DhcbTargetAddress(Entity):
                                            """
                                            DHCB target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__init__()

                                                self.yang_name = "dhcb-target-address"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_up.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.address_family.is_set or
                                                self.local_address.is_set or
                                                self.target_address.is_set or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()) or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address_family.yfilter != YFilter.not_set or
                                                self.local_address.yfilter != YFilter.not_set or
                                                self.target_address.yfilter != YFilter.not_set or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()) or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello-brief" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family.get_name_leafdata())
                                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_address.get_name_leafdata())
                                            if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.target_address.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "dhcb-target-address"):
                                                if (self.dhcb_target_address is None):
                                                    self.dhcb_target_address = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                    self.dhcb_target_address.parent = self
                                                    self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                return self.dhcb_target_address

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "dhcb-target-address" or name == "hello-information" or name == "vrf" or name == "address-family" or name == "local-address" or name == "target-address"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address-family"):
                                                self.address_family = value
                                                self.address_family.value_namespace = name_space
                                                self.address_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-address"):
                                                self.local_address = value
                                                self.local_address.value_namespace = name_space
                                                self.local_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "target-address"):
                                                self.target_address = value
                                                self.target_address.value_namespace = name_space
                                                self.target_address.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.targeted_hello_brief:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.targeted_hello_brief:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hello-briefs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "targeted-hello-brief"):
                                            for c in self.targeted_hello_brief:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.targeted_hello_brief.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "targeted-hello-brief"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        (self.link_hello_briefs is not None and self.link_hello_briefs.has_data()) or
                                        (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.link_hello_briefs is not None and self.link_hello_briefs.has_operation()) or
                                        (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "brief" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-briefs"):
                                        if (self.link_hello_briefs is None):
                                            self.link_hello_briefs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                            self.link_hello_briefs.parent = self
                                            self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                        return self.link_hello_briefs

                                    if (child_yang_name == "targeted-hello-briefs"):
                                        if (self.targeted_hello_briefs is None):
                                            self.targeted_hello_briefs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                            self.targeted_hello_briefs.parent = self
                                            self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                        return self.targeted_hello_briefs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-briefs" or name == "targeted-hello-briefs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Stats(Entity):
                                """
                                The LDP Discovery Statistics
                                
                                .. attribute:: stat
                                
                                	Information on LDP discovery statistics
                                	**type**\: list of    :py:class:`Stat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats.Stat>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats, self).__init__()

                                    self.yang_name = "stats"
                                    self.yang_parent_name = "discovery"

                                    self.stat = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)


                                class Stat(Entity):
                                    """
                                    Information on LDP discovery statistics
                                    
                                    .. attribute:: adjacency_group_up_time
                                    
                                    	Adjacency group up time in seconds
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: tcp_arb_chg_count
                                    
                                    	Count of changes in TCP arbitration
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tcp_open_count
                                    
                                    	Count of attempted TCP opens
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tcp_role
                                    
                                    	TCP Role
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__init__()

                                        self.yang_name = "stat"
                                        self.yang_parent_name = "stats"

                                        self.adjacency_group_up_time = YLeaf(YType.uint32, "adjacency-group-up-time")

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.tcp_arb_chg_count = YLeaf(YType.uint32, "tcp-arb-chg-count")

                                        self.tcp_open_count = YLeaf(YType.uint32, "tcp-open-count")

                                        self.tcp_role = YLeaf(YType.uint32, "tcp-role")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("adjacency_group_up_time",
                                                        "label_space_id",
                                                        "lsr_id",
                                                        "tcp_arb_chg_count",
                                                        "tcp_open_count",
                                                        "tcp_role") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.adjacency_group_up_time.is_set or
                                            self.label_space_id.is_set or
                                            self.lsr_id.is_set or
                                            self.tcp_arb_chg_count.is_set or
                                            self.tcp_open_count.is_set or
                                            self.tcp_role.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.adjacency_group_up_time.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.tcp_arb_chg_count.yfilter != YFilter.not_set or
                                            self.tcp_open_count.yfilter != YFilter.not_set or
                                            self.tcp_role.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stat" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.adjacency_group_up_time.is_set or self.adjacency_group_up_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.adjacency_group_up_time.get_name_leafdata())
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.tcp_arb_chg_count.is_set or self.tcp_arb_chg_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_arb_chg_count.get_name_leafdata())
                                        if (self.tcp_open_count.is_set or self.tcp_open_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_open_count.get_name_leafdata())
                                        if (self.tcp_role.is_set or self.tcp_role.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_role.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "adjacency-group-up-time" or name == "label-space-id" or name == "lsr-id" or name == "tcp-arb-chg-count" or name == "tcp-open-count" or name == "tcp-role"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "adjacency-group-up-time"):
                                            self.adjacency_group_up_time = value
                                            self.adjacency_group_up_time.value_namespace = name_space
                                            self.adjacency_group_up_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-arb-chg-count"):
                                            self.tcp_arb_chg_count = value
                                            self.tcp_arb_chg_count.value_namespace = name_space
                                            self.tcp_arb_chg_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-open-count"):
                                            self.tcp_open_count = value
                                            self.tcp_open_count.value_namespace = name_space
                                            self.tcp_open_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-role"):
                                            self.tcp_role = value
                                            self.tcp_role.value_namespace = name_space
                                            self.tcp_role.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.stat:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.stat:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "stat"):
                                        for c in self.stat:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats.Stat()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.stat.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "stat"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.brief is not None and self.brief.has_data()) or
                                    (self.link_hellos is not None and self.link_hellos.has_data()) or
                                    (self.stats is not None and self.stats.has_data()) or
                                    (self.summary is not None and self.summary.has_data()) or
                                    (self.targeted_hellos is not None and self.targeted_hellos.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.brief is not None and self.brief.has_operation()) or
                                    (self.link_hellos is not None and self.link_hellos.has_operation()) or
                                    (self.stats is not None and self.stats.has_operation()) or
                                    (self.summary is not None and self.summary.has_operation()) or
                                    (self.targeted_hellos is not None and self.targeted_hellos.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovery" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "brief"):
                                    if (self.brief is None):
                                        self.brief = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Brief()
                                        self.brief.parent = self
                                        self._children_name_map["brief"] = "brief"
                                    return self.brief

                                if (child_yang_name == "link-hellos"):
                                    if (self.link_hellos is None):
                                        self.link_hellos = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.LinkHellos()
                                        self.link_hellos.parent = self
                                        self._children_name_map["link_hellos"] = "link-hellos"
                                    return self.link_hellos

                                if (child_yang_name == "stats"):
                                    if (self.stats is None):
                                        self.stats = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Stats()
                                        self.stats.parent = self
                                        self._children_name_map["stats"] = "stats"
                                    return self.stats

                                if (child_yang_name == "summary"):
                                    if (self.summary is None):
                                        self.summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.Summary()
                                        self.summary.parent = self
                                        self._children_name_map["summary"] = "summary"
                                    return self.summary

                                if (child_yang_name == "targeted-hellos"):
                                    if (self.targeted_hellos is None):
                                        self.targeted_hellos = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery.TargetedHellos()
                                        self.targeted_hellos.parent = self
                                        self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                    return self.targeted_hellos

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "brief" or name == "link-hellos" or name == "stats" or name == "summary" or name == "targeted-hellos"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsSummaryAll(Entity):
                            """
                            Aggregate VRF counters for the LDP Label
                            Infomation Base (LIB)
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: bind_af
                            
                            	bind af
                            	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf>`
                            
                            .. attribute:: binding_local_explicit_null
                            
                            	Number of local explicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_implicit_null
                            
                            	Number of local implicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_no_route
                            
                            	Local bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_non_null
                            
                            	Number of local non\-null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_null
                            
                            	Number of local null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_oor
                            
                            	Number of local bindings        needing label \- OOR
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_no_route
                            
                            	Bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: highest_allocated_label
                            
                            	Highest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lowest_allocated_label
                            
                            	Lowest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__init__()

                                self.yang_name = "bindings-summary-all"
                                self.yang_parent_name = "af"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.bind_af = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "binding_local_explicit_null",
                                                "binding_local_implicit_null",
                                                "binding_local_no_route",
                                                "binding_local_non_null",
                                                "binding_local_null",
                                                "binding_local_oor",
                                                "binding_no_route",
                                                "highest_allocated_label",
                                                "lowest_allocated_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "bindings-summary-all"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class BindAf(Entity):
                                """
                                bind af
                                
                                .. attribute:: address_family
                                
                                	Binding Summary Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: binding_local
                                
                                	Number of local bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_remote
                                
                                	Number of remote bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_total
                                
                                	Total bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_lib_update
                                
                                	Last update to LIB local binding
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lib_minimum_revision_sent_all
                                
                                	Last update sent to all peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__init__()

                                    self.yang_name = "bind-af"
                                    self.yang_parent_name = "bindings-summary-all"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local = YLeaf(YType.uint32, "binding-local")

                                    self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                    self.binding_total = YLeaf(YType.uint32, "binding-total")

                                    self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                    self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local",
                                                    "binding_remote",
                                                    "binding_total",
                                                    "last_lib_update",
                                                    "lib_minimum_revision_sent_all") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local.is_set or
                                        self.binding_remote.is_set or
                                        self.binding_total.is_set or
                                        self.last_lib_update.is_set or
                                        self.lib_minimum_revision_sent_all.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local.yfilter != YFilter.not_set or
                                        self.binding_remote.yfilter != YFilter.not_set or
                                        self.binding_total.yfilter != YFilter.not_set or
                                        self.last_lib_update.yfilter != YFilter.not_set or
                                        self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bind-af" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local.get_name_leafdata())
                                    if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                    if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_total.get_name_leafdata())
                                    if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                    if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local"):
                                        self.binding_local = value
                                        self.binding_local.value_namespace = name_space
                                        self.binding_local.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-remote"):
                                        self.binding_remote = value
                                        self.binding_remote.value_namespace = name_space
                                        self.binding_remote.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-total"):
                                        self.binding_total = value
                                        self.binding_total.value_namespace = name_space
                                        self.binding_total.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-lib-update"):
                                        self.last_lib_update = value
                                        self.last_lib_update.value_namespace = name_space
                                        self.last_lib_update.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lib-minimum-revision-sent-all"):
                                        self.lib_minimum_revision_sent_all = value
                                        self.lib_minimum_revision_sent_all.value_namespace = name_space
                                        self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bind_af:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.address_family.is_set or
                                    self.binding_local_explicit_null.is_set or
                                    self.binding_local_implicit_null.is_set or
                                    self.binding_local_no_route.is_set or
                                    self.binding_local_non_null.is_set or
                                    self.binding_local_null.is_set or
                                    self.binding_local_oor.is_set or
                                    self.binding_no_route.is_set or
                                    self.highest_allocated_label.is_set or
                                    self.lowest_allocated_label.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.bind_af:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_no_route.yfilter != YFilter.not_set or
                                    self.binding_local_non_null.yfilter != YFilter.not_set or
                                    self.binding_local_null.yfilter != YFilter.not_set or
                                    self.binding_local_oor.yfilter != YFilter.not_set or
                                    self.binding_no_route.yfilter != YFilter.not_set or
                                    self.highest_allocated_label.yfilter != YFilter.not_set or
                                    self.lowest_allocated_label.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-summary-all" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bind-af"):
                                    for c in self.bind_af:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bind_af.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-explicit-null"):
                                    self.binding_local_explicit_null = value
                                    self.binding_local_explicit_null.value_namespace = name_space
                                    self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-implicit-null"):
                                    self.binding_local_implicit_null = value
                                    self.binding_local_implicit_null.value_namespace = name_space
                                    self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-no-route"):
                                    self.binding_local_no_route = value
                                    self.binding_local_no_route.value_namespace = name_space
                                    self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-non-null"):
                                    self.binding_local_non_null = value
                                    self.binding_local_non_null.value_namespace = name_space
                                    self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-null"):
                                    self.binding_local_null = value
                                    self.binding_local_null.value_namespace = name_space
                                    self.binding_local_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-oor"):
                                    self.binding_local_oor = value
                                    self.binding_local_oor.value_namespace = name_space
                                    self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-no-route"):
                                    self.binding_no_route = value
                                    self.binding_no_route.value_namespace = name_space
                                    self.binding_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "highest-allocated-label"):
                                    self.highest_allocated_label = value
                                    self.highest_allocated_label.value_namespace = name_space
                                    self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lowest-allocated-label"):
                                    self.lowest_allocated_label = value
                                    self.lowest_allocated_label.value_namespace = name_space
                                    self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                        class Forwardings(Entity):
                            """
                            The LDP Forwarding rewrites
                            
                            .. attribute:: forwarding
                            
                            	Information on a particular LDP forwarding rewrite
                            	**type**\: list of    :py:class:`Forwarding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings, self).__init__()

                                self.yang_name = "forwardings"
                                self.yang_parent_name = "af"

                                self.forwarding = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings, self).__setattr__(name, value)


                            class Forwarding(Entity):
                                """
                                Information on a particular LDP forwarding
                                rewrite
                                
                                .. attribute:: prefix  <key>
                                
                                	The IP Prefix
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                
                                
                                ----
                                .. attribute:: paths
                                
                                	Paths
                                	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths>`
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: prefix_xr
                                
                                	IP Prefix
                                	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr>`
                                
                                .. attribute:: route
                                
                                	Route
                                	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route>`
                                
                                .. attribute:: table_id
                                
                                	Table ID associated with IP prefix
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__init__()

                                    self.yang_name = "forwarding"
                                    self.yang_parent_name = "forwardings"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.prefix_xr = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                    self.prefix_xr.parent = self
                                    self._children_name_map["prefix_xr"] = "prefix-xr"
                                    self._children_yang_names.add("prefix-xr")

                                    self.route = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route()
                                    self.route.parent = self
                                    self._children_name_map["route"] = "route"
                                    self._children_yang_names.add("route")

                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.paths = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "forwarding"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class PrefixXr(Entity):
                                    """
                                    IP Prefix
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__init__()

                                        self.yang_name = "prefix-xr"
                                        self.yang_parent_name = "forwarding"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prefix-xr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class Route(Entity):
                                    """
                                    Route
                                    
                                    .. attribute:: mpls
                                    
                                    	MPLS information
                                    	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls>`
                                    
                                    .. attribute:: routing
                                    
                                    	IP routing information
                                    	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route, self).__init__()

                                        self.yang_name = "route"
                                        self.yang_parent_name = "forwarding"

                                        self.mpls = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                        self.mpls.parent = self
                                        self._children_name_map["mpls"] = "mpls"
                                        self._children_yang_names.add("mpls")

                                        self.routing = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                        self.routing.parent = self
                                        self._children_name_map["routing"] = "routing"
                                        self._children_yang_names.add("routing")


                                    class Routing(Entity):
                                        """
                                        IP routing information
                                        
                                        .. attribute:: flags
                                        
                                        	Route RIB flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_local_vrf_leaked
                                        
                                        	Is route leaked across local VRFs?
                                        	**type**\:  bool
                                        
                                        .. attribute:: metric
                                        
                                        	Route metric
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: priority
                                        
                                        	Route priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: routing_update_age
                                        
                                        	Last Routing update nanosec age
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: routing_update_count
                                        
                                        	Number of routing updates
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: routing_update_timestamp
                                        
                                        	Last Routing update nanosec timestamp
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: source
                                        
                                        	Route source protol Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sr_local_label
                                        
                                        	SR Local\-label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: type
                                        
                                        	Route type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: version
                                        
                                        	Route RIB ersion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__init__()

                                            self.yang_name = "routing"
                                            self.yang_parent_name = "route"

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.is_local_vrf_leaked = YLeaf(YType.boolean, "is-local-vrf-leaked")

                                            self.metric = YLeaf(YType.uint32, "metric")

                                            self.priority = YLeaf(YType.uint8, "priority")

                                            self.routing_update_age = YLeaf(YType.uint64, "routing-update-age")

                                            self.routing_update_count = YLeaf(YType.uint32, "routing-update-count")

                                            self.routing_update_timestamp = YLeaf(YType.uint64, "routing-update-timestamp")

                                            self.source = YLeaf(YType.uint16, "source")

                                            self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                            self.type = YLeaf(YType.uint16, "type")

                                            self.version = YLeaf(YType.uint32, "version")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("flags",
                                                            "is_local_vrf_leaked",
                                                            "metric",
                                                            "priority",
                                                            "routing_update_age",
                                                            "routing_update_count",
                                                            "routing_update_timestamp",
                                                            "source",
                                                            "sr_local_label",
                                                            "type",
                                                            "version") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.flags.is_set or
                                                self.is_local_vrf_leaked.is_set or
                                                self.metric.is_set or
                                                self.priority.is_set or
                                                self.routing_update_age.is_set or
                                                self.routing_update_count.is_set or
                                                self.routing_update_timestamp.is_set or
                                                self.source.is_set or
                                                self.sr_local_label.is_set or
                                                self.type.is_set or
                                                self.version.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.flags.yfilter != YFilter.not_set or
                                                self.is_local_vrf_leaked.yfilter != YFilter.not_set or
                                                self.metric.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                self.routing_update_age.yfilter != YFilter.not_set or
                                                self.routing_update_count.yfilter != YFilter.not_set or
                                                self.routing_update_timestamp.yfilter != YFilter.not_set or
                                                self.source.yfilter != YFilter.not_set or
                                                self.sr_local_label.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set or
                                                self.version.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "routing" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flags.get_name_leafdata())
                                            if (self.is_local_vrf_leaked.is_set or self.is_local_vrf_leaked.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_local_vrf_leaked.get_name_leafdata())
                                            if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.metric.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())
                                            if (self.routing_update_age.is_set or self.routing_update_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_age.get_name_leafdata())
                                            if (self.routing_update_count.is_set or self.routing_update_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_count.get_name_leafdata())
                                            if (self.routing_update_timestamp.is_set or self.routing_update_timestamp.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_timestamp.get_name_leafdata())
                                            if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source.get_name_leafdata())
                                            if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())
                                            if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.version.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "flags" or name == "is-local-vrf-leaked" or name == "metric" or name == "priority" or name == "routing-update-age" or name == "routing-update-count" or name == "routing-update-timestamp" or name == "source" or name == "sr-local-label" or name == "type" or name == "version"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "flags"):
                                                self.flags = value
                                                self.flags.value_namespace = name_space
                                                self.flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-local-vrf-leaked"):
                                                self.is_local_vrf_leaked = value
                                                self.is_local_vrf_leaked.value_namespace = name_space
                                                self.is_local_vrf_leaked.value_namespace_prefix = name_space_prefix
                                            if(value_path == "metric"):
                                                self.metric = value
                                                self.metric.value_namespace = name_space
                                                self.metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-age"):
                                                self.routing_update_age = value
                                                self.routing_update_age.value_namespace = name_space
                                                self.routing_update_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-count"):
                                                self.routing_update_count = value
                                                self.routing_update_count.value_namespace = name_space
                                                self.routing_update_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-timestamp"):
                                                self.routing_update_timestamp = value
                                                self.routing_update_timestamp.value_namespace = name_space
                                                self.routing_update_timestamp.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source"):
                                                self.source = value
                                                self.source.value_namespace = name_space
                                                self.source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sr-local-label"):
                                                self.sr_local_label = value
                                                self.sr_local_label.value_namespace = name_space
                                                self.sr_local_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "version"):
                                                self.version = value
                                                self.version.value_namespace = name_space
                                                self.version.value_namespace_prefix = name_space_prefix


                                    class Mpls(Entity):
                                        """
                                        MPLS information
                                        
                                        .. attribute:: forwarding_update_age
                                        
                                        	Last Forwarding update nanosec age
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: forwarding_update_count
                                        
                                        	Number of forwarding updates
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forwarding_update_timestamp
                                        
                                        	Last Forwarding update nanosec timestamp
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: local_label
                                        
                                        	Local label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__init__()

                                            self.yang_name = "mpls"
                                            self.yang_parent_name = "route"

                                            self.forwarding_update_age = YLeaf(YType.uint64, "forwarding-update-age")

                                            self.forwarding_update_count = YLeaf(YType.uint32, "forwarding-update-count")

                                            self.forwarding_update_timestamp = YLeaf(YType.uint64, "forwarding-update-timestamp")

                                            self.local_label = YLeaf(YType.uint32, "local-label")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("forwarding_update_age",
                                                            "forwarding_update_count",
                                                            "forwarding_update_timestamp",
                                                            "local_label") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.forwarding_update_age.is_set or
                                                self.forwarding_update_count.is_set or
                                                self.forwarding_update_timestamp.is_set or
                                                self.local_label.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.forwarding_update_age.yfilter != YFilter.not_set or
                                                self.forwarding_update_count.yfilter != YFilter.not_set or
                                                self.forwarding_update_timestamp.yfilter != YFilter.not_set or
                                                self.local_label.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mpls" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.forwarding_update_age.is_set or self.forwarding_update_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_age.get_name_leafdata())
                                            if (self.forwarding_update_count.is_set or self.forwarding_update_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_count.get_name_leafdata())
                                            if (self.forwarding_update_timestamp.is_set or self.forwarding_update_timestamp.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_timestamp.get_name_leafdata())
                                            if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_label.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "forwarding-update-age" or name == "forwarding-update-count" or name == "forwarding-update-timestamp" or name == "local-label"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "forwarding-update-age"):
                                                self.forwarding_update_age = value
                                                self.forwarding_update_age.value_namespace = name_space
                                                self.forwarding_update_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-update-count"):
                                                self.forwarding_update_count = value
                                                self.forwarding_update_count.value_namespace = name_space
                                                self.forwarding_update_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-update-timestamp"):
                                                self.forwarding_update_timestamp = value
                                                self.forwarding_update_timestamp.value_namespace = name_space
                                                self.forwarding_update_timestamp.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-label"):
                                                self.local_label = value
                                                self.local_label.value_namespace = name_space
                                                self.local_label.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.mpls is not None and self.mpls.has_data()) or
                                            (self.routing is not None and self.routing.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.mpls is not None and self.mpls.has_operation()) or
                                            (self.routing is not None and self.routing.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "route" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mpls"):
                                            if (self.mpls is None):
                                                self.mpls = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                                self.mpls.parent = self
                                                self._children_name_map["mpls"] = "mpls"
                                            return self.mpls

                                        if (child_yang_name == "routing"):
                                            if (self.routing is None):
                                                self.routing = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                                self.routing.parent = self
                                                self._children_name_map["routing"] = "routing"
                                            return self.routing

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mpls" or name == "routing"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Paths(Entity):
                                    """
                                    Paths
                                    
                                    .. attribute:: mpls
                                    
                                    	MPLS information
                                    	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls>`
                                    
                                    .. attribute:: routing
                                    
                                    	IP routing information
                                    	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths, self).__init__()

                                        self.yang_name = "paths"
                                        self.yang_parent_name = "forwarding"

                                        self.mpls = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                        self.mpls.parent = self
                                        self._children_name_map["mpls"] = "mpls"
                                        self._children_yang_names.add("mpls")

                                        self.routing = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                        self.routing.parent = self
                                        self._children_name_map["routing"] = "routing"
                                        self._children_yang_names.add("routing")


                                    class Routing(Entity):
                                        """
                                        IP routing information
                                        
                                        .. attribute:: bkup_path_id
                                        
                                        	Backup path Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: flags
                                        
                                        	Route path flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface Name
                                        	**type**\:  str
                                        
                                        .. attribute:: load_metric
                                        
                                        	Path's load metric for load balancing
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hop
                                        
                                        	Next Hop
                                        	**type**\:   :py:class:`NextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop>`
                                        
                                        .. attribute:: next_hop_table_id
                                        
                                        	Table ID for nexthop address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: nexthop_id
                                        
                                        	Nexthop Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: nh_is_overriden
                                        
                                        	Nexthop is overriden by LDP
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_flags
                                        
                                        	Routing path flags decoded
                                        	**type**\:   :py:class:`LdpRoutePathFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathFlags>`
                                        
                                        .. attribute:: path_id
                                        
                                        	path Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: remote_lfa
                                        
                                        	Remote LFA\-FRR backup info
                                        	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__init__()

                                            self.yang_name = "routing"
                                            self.yang_parent_name = "paths"

                                            self.bkup_path_id = YLeaf(YType.uint8, "bkup-path-id")

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.load_metric = YLeaf(YType.uint32, "load-metric")

                                            self.next_hop_table_id = YLeaf(YType.uint32, "next-hop-table-id")

                                            self.nexthop_id = YLeaf(YType.uint32, "nexthop-id")

                                            self.nh_is_overriden = YLeaf(YType.boolean, "nh-is-overriden")

                                            self.path_flags = YLeaf(YType.enumeration, "path-flags")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.next_hop = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                            self.next_hop.parent = self
                                            self._children_name_map["next_hop"] = "next-hop"
                                            self._children_yang_names.add("next-hop")

                                            self.remote_lfa = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                            self.remote_lfa.parent = self
                                            self._children_name_map["remote_lfa"] = "remote-lfa"
                                            self._children_yang_names.add("remote-lfa")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bkup_path_id",
                                                            "flags",
                                                            "interface",
                                                            "interface_name",
                                                            "load_metric",
                                                            "next_hop_table_id",
                                                            "nexthop_id",
                                                            "nh_is_overriden",
                                                            "path_flags",
                                                            "path_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)


                                        class NextHop(Entity):
                                            """
                                            Next Hop
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__init__()

                                                self.yang_name = "next-hop"
                                                self.yang_parent_name = "routing"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "next-hop" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class RemoteLfa(Entity):
                                            """
                                            Remote LFA\-FRR backup info
                                            
                                            .. attribute:: has_q_node
                                            
                                            	Whether remote LFA path has a Q node associated
                                            	**type**\:  bool
                                            
                                            .. attribute:: has_remote_lfa_bkup
                                            
                                            	Whether path has remote LFA backup
                                            	**type**\:  bool
                                            
                                            .. attribute:: needs_tldp
                                            
                                            	Whether TLDP is needed with remote PQ node
                                            	**type**\:  bool
                                            
                                            .. attribute:: remote_p_node_id
                                            
                                            	Remote/P node address
                                            	**type**\:   :py:class:`RemotePNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId>`
                                            
                                            .. attribute:: remote_q_node_id
                                            
                                            	Remote/Q node address
                                            	**type**\:   :py:class:`RemoteQNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__init__()

                                                self.yang_name = "remote-lfa"
                                                self.yang_parent_name = "routing"

                                                self.has_q_node = YLeaf(YType.boolean, "has-q-node")

                                                self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                self.needs_tldp = YLeaf(YType.boolean, "needs-tldp")

                                                self.remote_p_node_id = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                self.remote_p_node_id.parent = self
                                                self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                self._children_yang_names.add("remote-p-node-id")

                                                self.remote_q_node_id = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                self.remote_q_node_id.parent = self
                                                self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                self._children_yang_names.add("remote-q-node-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("has_q_node",
                                                                "has_remote_lfa_bkup",
                                                                "needs_tldp") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)


                                            class RemotePNodeId(Entity):
                                                """
                                                Remote/P node address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__init__()

                                                    self.yang_name = "remote-p-node-id"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-p-node-id" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class RemoteQNodeId(Entity):
                                                """
                                                Remote/Q node address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__init__()

                                                    self.yang_name = "remote-q-node-id"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-q-node-id" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.has_q_node.is_set or
                                                    self.has_remote_lfa_bkup.is_set or
                                                    self.needs_tldp.is_set or
                                                    (self.remote_p_node_id is not None and self.remote_p_node_id.has_data()) or
                                                    (self.remote_q_node_id is not None and self.remote_q_node_id.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.has_q_node.yfilter != YFilter.not_set or
                                                    self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                    self.needs_tldp.yfilter != YFilter.not_set or
                                                    (self.remote_p_node_id is not None and self.remote_p_node_id.has_operation()) or
                                                    (self.remote_q_node_id is not None and self.remote_q_node_id.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "remote-lfa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.has_q_node.is_set or self.has_q_node.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_q_node.get_name_leafdata())
                                                if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())
                                                if (self.needs_tldp.is_set or self.needs_tldp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.needs_tldp.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "remote-p-node-id"):
                                                    if (self.remote_p_node_id is None):
                                                        self.remote_p_node_id = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                        self.remote_p_node_id.parent = self
                                                        self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                    return self.remote_p_node_id

                                                if (child_yang_name == "remote-q-node-id"):
                                                    if (self.remote_q_node_id is None):
                                                        self.remote_q_node_id = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                        self.remote_q_node_id.parent = self
                                                        self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                    return self.remote_q_node_id

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "remote-p-node-id" or name == "remote-q-node-id" or name == "has-q-node" or name == "has-remote-lfa-bkup" or name == "needs-tldp"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "has-q-node"):
                                                    self.has_q_node = value
                                                    self.has_q_node.value_namespace = name_space
                                                    self.has_q_node.value_namespace_prefix = name_space_prefix
                                                if(value_path == "has-remote-lfa-bkup"):
                                                    self.has_remote_lfa_bkup = value
                                                    self.has_remote_lfa_bkup.value_namespace = name_space
                                                    self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix
                                                if(value_path == "needs-tldp"):
                                                    self.needs_tldp = value
                                                    self.needs_tldp.value_namespace = name_space
                                                    self.needs_tldp.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.bkup_path_id.is_set or
                                                self.flags.is_set or
                                                self.interface.is_set or
                                                self.interface_name.is_set or
                                                self.load_metric.is_set or
                                                self.next_hop_table_id.is_set or
                                                self.nexthop_id.is_set or
                                                self.nh_is_overriden.is_set or
                                                self.path_flags.is_set or
                                                self.path_id.is_set or
                                                (self.next_hop is not None and self.next_hop.has_data()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bkup_path_id.yfilter != YFilter.not_set or
                                                self.flags.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.load_metric.yfilter != YFilter.not_set or
                                                self.next_hop_table_id.yfilter != YFilter.not_set or
                                                self.nexthop_id.yfilter != YFilter.not_set or
                                                self.nh_is_overriden.yfilter != YFilter.not_set or
                                                self.path_flags.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                (self.next_hop is not None and self.next_hop.has_operation()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "routing" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bkup_path_id.is_set or self.bkup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bkup_path_id.get_name_leafdata())
                                            if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flags.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_metric.get_name_leafdata())
                                            if (self.next_hop_table_id.is_set or self.next_hop_table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_table_id.get_name_leafdata())
                                            if (self.nexthop_id.is_set or self.nexthop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nexthop_id.get_name_leafdata())
                                            if (self.nh_is_overriden.is_set or self.nh_is_overriden.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nh_is_overriden.get_name_leafdata())
                                            if (self.path_flags.is_set or self.path_flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "next-hop"):
                                                if (self.next_hop is None):
                                                    self.next_hop = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                    self.next_hop.parent = self
                                                    self._children_name_map["next_hop"] = "next-hop"
                                                return self.next_hop

                                            if (child_yang_name == "remote-lfa"):
                                                if (self.remote_lfa is None):
                                                    self.remote_lfa = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                    self.remote_lfa.parent = self
                                                    self._children_name_map["remote_lfa"] = "remote-lfa"
                                                return self.remote_lfa

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "next-hop" or name == "remote-lfa" or name == "bkup-path-id" or name == "flags" or name == "interface" or name == "interface-name" or name == "load-metric" or name == "next-hop-table-id" or name == "nexthop-id" or name == "nh-is-overriden" or name == "path-flags" or name == "path-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bkup-path-id"):
                                                self.bkup_path_id = value
                                                self.bkup_path_id.value_namespace = name_space
                                                self.bkup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "flags"):
                                                self.flags = value
                                                self.flags.value_namespace = name_space
                                                self.flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-metric"):
                                                self.load_metric = value
                                                self.load_metric.value_namespace = name_space
                                                self.load_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-table-id"):
                                                self.next_hop_table_id = value
                                                self.next_hop_table_id.value_namespace = name_space
                                                self.next_hop_table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nexthop-id"):
                                                self.nexthop_id = value
                                                self.nexthop_id.value_namespace = name_space
                                                self.nexthop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nh-is-overriden"):
                                                self.nh_is_overriden = value
                                                self.nh_is_overriden.value_namespace = name_space
                                                self.nh_is_overriden.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags"):
                                                self.path_flags = value
                                                self.path_flags.value_namespace = name_space
                                                self.path_flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix


                                    class Mpls(Entity):
                                        """
                                        MPLS information
                                        
                                        .. attribute:: mpls_outgoing_info
                                        
                                        	MPLS nexthop info
                                        	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo>`
                                        
                                        .. attribute:: remote_lfa
                                        
                                        	Remote LFA\-FRR backup info
                                        	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls, self).__init__()

                                            self.yang_name = "mpls"
                                            self.yang_parent_name = "paths"

                                            self.mpls_outgoing_info = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                            self.mpls_outgoing_info.parent = self
                                            self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                            self._children_yang_names.add("mpls-outgoing-info")

                                            self.remote_lfa = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                            self.remote_lfa.parent = self
                                            self._children_name_map["remote_lfa"] = "remote-lfa"
                                            self._children_yang_names.add("remote-lfa")


                                        class MplsOutgoingInfo(Entity):
                                            """
                                            MPLS nexthop info
                                            
                                            .. attribute:: is_from_graceful_restartable_neighbor
                                            
                                            	Is from a GR neighbor
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_stale
                                            
                                            	Is the entry stale
                                            	**type**\:  bool
                                            
                                            .. attribute:: nexthop_peer_ldp_ident
                                            
                                            	Nexthop LDP peer
                                            	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent>`
                                            
                                            .. attribute:: out_label
                                            
                                            	Outgoing label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: out_label_owner
                                            
                                            	Outgoing label owner
                                            	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                            
                                            .. attribute:: out_label_rsn
                                            
                                            	Outgoing label reason
                                            	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                            
                                            .. attribute:: out_label_type
                                            
                                            	Outgoing Label Type
                                            	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__init__()

                                                self.yang_name = "mpls-outgoing-info"
                                                self.yang_parent_name = "mpls"

                                                self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                self.out_label = YLeaf(YType.uint32, "out-label")

                                                self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                self.nexthop_peer_ldp_ident.parent = self
                                                self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                self._children_yang_names.add("nexthop-peer-ldp-ident")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_from_graceful_restartable_neighbor",
                                                                "is_stale",
                                                                "out_label",
                                                                "out_label_owner",
                                                                "out_label_rsn",
                                                                "out_label_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)


                                            class NexthopPeerLdpIdent(Entity):
                                                """
                                                Nexthop LDP peer
                                                
                                                .. attribute:: label_space_id
                                                
                                                	Label space identifier
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: ldp_id
                                                
                                                	LDP identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: lsr_id
                                                
                                                	LSR identifier
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__init__()

                                                    self.yang_name = "nexthop-peer-ldp-ident"
                                                    self.yang_parent_name = "mpls-outgoing-info"

                                                    self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                    self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("label_space_id",
                                                                    "ldp_id",
                                                                    "lsr_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.label_space_id.is_set or
                                                        self.ldp_id.is_set or
                                                        self.lsr_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.label_space_id.yfilter != YFilter.not_set or
                                                        self.ldp_id.yfilter != YFilter.not_set or
                                                        self.lsr_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                    if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "label-space-id"):
                                                        self.label_space_id = value
                                                        self.label_space_id.value_namespace = name_space
                                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ldp-id"):
                                                        self.ldp_id = value
                                                        self.ldp_id.value_namespace = name_space
                                                        self.ldp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsr-id"):
                                                        self.lsr_id = value
                                                        self.lsr_id.value_namespace = name_space
                                                        self.lsr_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.is_from_graceful_restartable_neighbor.is_set or
                                                    self.is_stale.is_set or
                                                    self.out_label.is_set or
                                                    self.out_label_owner.is_set or
                                                    self.out_label_rsn.is_set or
                                                    self.out_label_type.is_set or
                                                    (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                    self.is_stale.yfilter != YFilter.not_set or
                                                    self.out_label.yfilter != YFilter.not_set or
                                                    self.out_label_owner.yfilter != YFilter.not_set or
                                                    self.out_label_rsn.yfilter != YFilter.not_set or
                                                    self.out_label_type.yfilter != YFilter.not_set or
                                                    (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls-outgoing-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                                if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                    if (self.nexthop_peer_ldp_ident is None):
                                                        self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                        self.nexthop_peer_ldp_ident.parent = self
                                                        self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                    return self.nexthop_peer_ldp_ident

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-from-graceful-restartable-neighbor"):
                                                    self.is_from_graceful_restartable_neighbor = value
                                                    self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                    self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-stale"):
                                                    self.is_stale = value
                                                    self.is_stale.value_namespace = name_space
                                                    self.is_stale.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label"):
                                                    self.out_label = value
                                                    self.out_label.value_namespace = name_space
                                                    self.out_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-owner"):
                                                    self.out_label_owner = value
                                                    self.out_label_owner.value_namespace = name_space
                                                    self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-rsn"):
                                                    self.out_label_rsn = value
                                                    self.out_label_rsn.value_namespace = name_space
                                                    self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-type"):
                                                    self.out_label_type = value
                                                    self.out_label_type.value_namespace = name_space
                                                    self.out_label_type.value_namespace_prefix = name_space_prefix


                                        class RemoteLfa(Entity):
                                            """
                                            Remote LFA\-FRR backup info
                                            
                                            .. attribute:: has_remote_lfa_bkup
                                            
                                            	Whether path has remote LFA backup
                                            	**type**\:  bool
                                            
                                            .. attribute:: mpls_outgoing_info
                                            
                                            	Remote LFA MPLS nexthop(s\_ info
                                            	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__init__()

                                                self.yang_name = "remote-lfa"
                                                self.yang_parent_name = "mpls"

                                                self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                self.mpls_outgoing_info = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                self.mpls_outgoing_info.parent = self
                                                self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                self._children_yang_names.add("mpls-outgoing-info")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("has_remote_lfa_bkup") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)


                                            class MplsOutgoingInfo(Entity):
                                                """
                                                Remote LFA MPLS nexthop(s\_ info
                                                
                                                .. attribute:: stack
                                                
                                                	Inner label stack info
                                                	**type**\: list of    :py:class:`Stack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__init__()

                                                    self.yang_name = "mpls-outgoing-info"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.stack = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)


                                                class Stack(Entity):
                                                    """
                                                    Inner label stack info
                                                    
                                                    .. attribute:: is_from_graceful_restartable_neighbor
                                                    
                                                    	Is from a GR neighbor
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_stale
                                                    
                                                    	Is the entry stale
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: nexthop_peer_ldp_ident
                                                    
                                                    	Nexthop LDP peer
                                                    	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent>`
                                                    
                                                    .. attribute:: out_label
                                                    
                                                    	Outgoing label
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: out_label_owner
                                                    
                                                    	Outgoing label owner
                                                    	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                    
                                                    .. attribute:: out_label_rsn
                                                    
                                                    	Outgoing label reason
                                                    	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                    
                                                    .. attribute:: out_label_type
                                                    
                                                    	Outgoing Label Type
                                                    	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__init__()

                                                        self.yang_name = "stack"
                                                        self.yang_parent_name = "mpls-outgoing-info"

                                                        self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                                        self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                        self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                        self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                        self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                        self.nexthop_peer_ldp_ident.parent = self
                                                        self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                        self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("is_from_graceful_restartable_neighbor",
                                                                        "is_stale",
                                                                        "out_label",
                                                                        "out_label_owner",
                                                                        "out_label_rsn",
                                                                        "out_label_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)


                                                    class NexthopPeerLdpIdent(Entity):
                                                        """
                                                        Nexthop LDP peer
                                                        
                                                        .. attribute:: label_space_id
                                                        
                                                        	Label space identifier
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: ldp_id
                                                        
                                                        	LDP identifier
                                                        	**type**\:  str
                                                        
                                                        .. attribute:: lsr_id
                                                        
                                                        	LSR identifier
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-ldp-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__init__()

                                                            self.yang_name = "nexthop-peer-ldp-ident"
                                                            self.yang_parent_name = "stack"

                                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("label_space_id",
                                                                            "ldp_id",
                                                                            "lsr_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.label_space_id.is_set or
                                                                self.ldp_id.is_set or
                                                                self.lsr_id.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.label_space_id.yfilter != YFilter.not_set or
                                                                self.ldp_id.yfilter != YFilter.not_set or
                                                                self.lsr_id.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "label-space-id"):
                                                                self.label_space_id = value
                                                                self.label_space_id.value_namespace = name_space
                                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "ldp-id"):
                                                                self.ldp_id = value
                                                                self.ldp_id.value_namespace = name_space
                                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "lsr-id"):
                                                                self.lsr_id = value
                                                                self.lsr_id.value_namespace = name_space
                                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.is_from_graceful_restartable_neighbor.is_set or
                                                            self.is_stale.is_set or
                                                            self.out_label.is_set or
                                                            self.out_label_owner.is_set or
                                                            self.out_label_rsn.is_set or
                                                            self.out_label_type.is_set or
                                                            (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                            self.is_stale.yfilter != YFilter.not_set or
                                                            self.out_label.yfilter != YFilter.not_set or
                                                            self.out_label_owner.yfilter != YFilter.not_set or
                                                            self.out_label_rsn.yfilter != YFilter.not_set or
                                                            self.out_label_type.yfilter != YFilter.not_set or
                                                            (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "stack" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                                        if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                        if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                        if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                            if (self.nexthop_peer_ldp_ident is None):
                                                                self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                                self.nexthop_peer_ldp_ident.parent = self
                                                                self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                            return self.nexthop_peer_ldp_ident

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "is-from-graceful-restartable-neighbor"):
                                                            self.is_from_graceful_restartable_neighbor = value
                                                            self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                            self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-stale"):
                                                            self.is_stale = value
                                                            self.is_stale.value_namespace = name_space
                                                            self.is_stale.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label"):
                                                            self.out_label = value
                                                            self.out_label.value_namespace = name_space
                                                            self.out_label.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-owner"):
                                                            self.out_label_owner = value
                                                            self.out_label_owner.value_namespace = name_space
                                                            self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-rsn"):
                                                            self.out_label_rsn = value
                                                            self.out_label_rsn.value_namespace = name_space
                                                            self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-type"):
                                                            self.out_label_type = value
                                                            self.out_label_type.value_namespace = name_space
                                                            self.out_label_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.stack:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.stack:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mpls-outgoing-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "stack"):
                                                        for c in self.stack:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.stack.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "stack"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.has_remote_lfa_bkup.is_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "remote-lfa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mpls-outgoing-info"):
                                                    if (self.mpls_outgoing_info is None):
                                                        self.mpls_outgoing_info = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                        self.mpls_outgoing_info.parent = self
                                                        self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    return self.mpls_outgoing_info

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mpls-outgoing-info" or name == "has-remote-lfa-bkup"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "has-remote-lfa-bkup"):
                                                    self.has_remote_lfa_bkup = value
                                                    self.has_remote_lfa_bkup.value_namespace = name_space
                                                    self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mpls" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls-outgoing-info"):
                                                if (self.mpls_outgoing_info is None):
                                                    self.mpls_outgoing_info = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                    self.mpls_outgoing_info.parent = self
                                                    self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                return self.mpls_outgoing_info

                                            if (child_yang_name == "remote-lfa"):
                                                if (self.remote_lfa is None):
                                                    self.remote_lfa = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                    self.remote_lfa.parent = self
                                                    self._children_name_map["remote_lfa"] = "remote-lfa"
                                                return self.remote_lfa

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls-outgoing-info" or name == "remote-lfa"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.mpls is not None and self.mpls.has_data()) or
                                            (self.routing is not None and self.routing.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.mpls is not None and self.mpls.has_operation()) or
                                            (self.routing is not None and self.routing.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "paths" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mpls"):
                                            if (self.mpls is None):
                                                self.mpls = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                                self.mpls.parent = self
                                                self._children_name_map["mpls"] = "mpls"
                                            return self.mpls

                                        if (child_yang_name == "routing"):
                                            if (self.routing is None):
                                                self.routing = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                                self.routing.parent = self
                                                self._children_name_map["routing"] = "routing"
                                            return self.routing

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mpls" or name == "routing"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    for c in self.paths:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.table_id.is_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                        (self.route is not None and self.route.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.paths:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                        (self.route is not None and self.route.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwarding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "paths"):
                                        for c in self.paths:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.paths.append(c)
                                        return c

                                    if (child_yang_name == "prefix-xr"):
                                        if (self.prefix_xr is None):
                                            self.prefix_xr = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                            self.prefix_xr.parent = self
                                            self._children_name_map["prefix_xr"] = "prefix-xr"
                                        return self.prefix_xr

                                    if (child_yang_name == "route"):
                                        if (self.route is None):
                                            self.route = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route()
                                            self.route.parent = self
                                            self._children_name_map["route"] = "route"
                                        return self.route

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "paths" or name == "prefix-xr" or name == "route" or name == "vrf" or name == "prefix" or name == "prefix-length" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.forwarding:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.forwarding:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "forwardings" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "forwarding"):
                                    for c in self.forwarding:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings.Forwarding()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.forwarding.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "forwarding"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsAdvertiseSpec(Entity):
                            """
                            Advertisement Spec (ACL) for LDP Label
                            Infomation Base (LIB)
                            
                            .. attribute:: advt_acl
                            
                            	Advertisement ACLs
                            	**type**\: list of    :py:class:`AdvtAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl>`
                            
                            .. attribute:: allocation_acl
                            
                            	Local label Allocation filter
                            	**type**\:   :py:class:`AllocationAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__init__()

                                self.yang_name = "bindings-advertise-spec"
                                self.yang_parent_name = "af"

                                self.allocation_acl = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                self.allocation_acl.parent = self
                                self._children_name_map["allocation_acl"] = "allocation-acl"
                                self._children_yang_names.add("allocation-acl")

                                self.advt_acl = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)


                            class AllocationAcl(Entity):
                                """
                                Local label Allocation filter
                                
                                .. attribute:: has_acl
                                
                                	Has ACL filter?
                                	**type**\:  bool
                                
                                .. attribute:: is_host_route_only
                                
                                	Host\-routes only?
                                	**type**\:  bool
                                
                                .. attribute:: prefix_acl
                                
                                	Prefix ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__init__()

                                    self.yang_name = "allocation-acl"
                                    self.yang_parent_name = "bindings-advertise-spec"

                                    self.has_acl = YLeaf(YType.boolean, "has-acl")

                                    self.is_host_route_only = YLeaf(YType.boolean, "is-host-route-only")

                                    self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("has_acl",
                                                    "is_host_route_only",
                                                    "prefix_acl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.has_acl.is_set or
                                        self.is_host_route_only.is_set or
                                        self.prefix_acl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.has_acl.yfilter != YFilter.not_set or
                                        self.is_host_route_only.yfilter != YFilter.not_set or
                                        self.prefix_acl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "allocation-acl" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.has_acl.is_set or self.has_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_acl.get_name_leafdata())
                                    if (self.is_host_route_only.is_set or self.is_host_route_only.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_host_route_only.get_name_leafdata())
                                    if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "has-acl" or name == "is-host-route-only" or name == "prefix-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "has-acl"):
                                        self.has_acl = value
                                        self.has_acl.value_namespace = name_space
                                        self.has_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-host-route-only"):
                                        self.is_host_route_only = value
                                        self.is_host_route_only.value_namespace = name_space
                                        self.is_host_route_only.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-acl"):
                                        self.prefix_acl = value
                                        self.prefix_acl.value_namespace = name_space
                                        self.prefix_acl.value_namespace_prefix = name_space_prefix


                            class AdvtAcl(Entity):
                                """
                                Advertisement ACLs
                                
                                .. attribute:: peer_acl
                                
                                	Peer ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                .. attribute:: prefix_acl
                                
                                	Prefix ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__init__()

                                    self.yang_name = "advt-acl"
                                    self.yang_parent_name = "bindings-advertise-spec"

                                    self.peer_acl = YLeaf(YType.str, "peer-acl")

                                    self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("peer_acl",
                                                    "prefix_acl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.peer_acl.is_set or
                                        self.prefix_acl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.peer_acl.yfilter != YFilter.not_set or
                                        self.prefix_acl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "advt-acl" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.peer_acl.is_set or self.peer_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_acl.get_name_leafdata())
                                    if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "peer-acl" or name == "prefix-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "peer-acl"):
                                        self.peer_acl = value
                                        self.peer_acl.value_namespace = name_space
                                        self.peer_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-acl"):
                                        self.prefix_acl = value
                                        self.prefix_acl.value_namespace = name_space
                                        self.prefix_acl.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.advt_acl:
                                    if (c.has_data()):
                                        return True
                                return (self.allocation_acl is not None and self.allocation_acl.has_data())

                            def has_operation(self):
                                for c in self.advt_acl:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.allocation_acl is not None and self.allocation_acl.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-advertise-spec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "advt-acl"):
                                    for c in self.advt_acl:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.advt_acl.append(c)
                                    return c

                                if (child_yang_name == "allocation-acl"):
                                    if (self.allocation_acl is None):
                                        self.allocation_acl = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                        self.allocation_acl.parent = self
                                        self._children_name_map["allocation_acl"] = "allocation-acl"
                                    return self.allocation_acl

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "advt-acl" or name == "allocation-acl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class ForwardingSummary(Entity):
                            """
                            Summary information regarding LDP forwarding
                            setup
                            
                            .. attribute:: fsht
                            
                            	Forwarding state hold time registered with LSD
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: intfs
                            
                            	MPLS forwarding enabled interface count
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: is_lsd_bound
                            
                            	LDP is connected to LSD server
                            	**type**\:  bool
                            
                            .. attribute:: lbls
                            
                            	Local label allocated count
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: rws
                            
                            	Forwarding rewrites summary
                            	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary, self).__init__()

                                self.yang_name = "forwarding-summary"
                                self.yang_parent_name = "af"

                                self.fsht = YLeaf(YType.uint16, "fsht")

                                self.intfs = YLeaf(YType.uint16, "intfs")

                                self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                                self.lbls = YLeaf(YType.uint16, "lbls")

                                self.rws = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws()
                                self.rws.parent = self
                                self._children_name_map["rws"] = "rws"
                                self._children_yang_names.add("rws")

                                self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fsht",
                                                "intfs",
                                                "is_lsd_bound",
                                                "lbls") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "forwarding-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Rws(Entity):
                                """
                                Forwarding rewrites summary
                                
                                .. attribute:: nhs
                                
                                	Forwarding rewrites nexthops (paths) summary
                                	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs>`
                                
                                .. attribute:: pfxs
                                
                                	Forwarding rewrites prefix summary
                                	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws, self).__init__()

                                    self.yang_name = "rws"
                                    self.yang_parent_name = "forwarding-summary"

                                    self.nhs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                    self.nhs.parent = self
                                    self._children_name_map["nhs"] = "nhs"
                                    self._children_yang_names.add("nhs")

                                    self.pfxs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                    self.pfxs.parent = self
                                    self._children_name_map["pfxs"] = "pfxs"
                                    self._children_yang_names.add("pfxs")


                                class Pfxs(Entity):
                                    """
                                    Forwarding rewrites prefix summary
                                    
                                    .. attribute:: ecmp_pfxs
                                    
                                    	Count of prefixes with ECMP
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: labeled_pfxs_aggr
                                    
                                    	Labeled prefix count for all paths
                                    	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr>`
                                    
                                    .. attribute:: labeled_pfxs_backup
                                    
                                    	Labeled prefix count related to backup paths only
                                    	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup>`
                                    
                                    .. attribute:: labeled_pfxs_primary
                                    
                                    	Labeled prefix count related to primary paths only
                                    	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary>`
                                    
                                    .. attribute:: protected_pfxs
                                    
                                    	Count of FRR protected prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: total_pfxs
                                    
                                    	Total Prefix count
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__init__()

                                        self.yang_name = "pfxs"
                                        self.yang_parent_name = "rws"

                                        self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                                        self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                                        self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                                        self.labeled_pfxs_aggr = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                        self.labeled_pfxs_aggr.parent = self
                                        self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                        self._children_yang_names.add("labeled-pfxs-aggr")

                                        self.labeled_pfxs_backup = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                        self.labeled_pfxs_backup.parent = self
                                        self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                        self._children_yang_names.add("labeled-pfxs-backup")

                                        self.labeled_pfxs_primary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                        self.labeled_pfxs_primary.parent = self
                                        self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                        self._children_yang_names.add("labeled-pfxs-primary")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ecmp_pfxs",
                                                        "protected_pfxs",
                                                        "total_pfxs") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)


                                    class LabeledPfxsAggr(Entity):
                                        """
                                        Labeled prefix count for all paths
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                            self.yang_name = "labeled-pfxs-aggr"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-aggr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                    class LabeledPfxsPrimary(Entity):
                                        """
                                        Labeled prefix count related to primary paths
                                        only
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                            self.yang_name = "labeled-pfxs-primary"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-primary" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                    class LabeledPfxsBackup(Entity):
                                        """
                                        Labeled prefix count related to backup paths
                                        only
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                            self.yang_name = "labeled-pfxs-backup"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-backup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.ecmp_pfxs.is_set or
                                            self.protected_pfxs.is_set or
                                            self.total_pfxs.is_set or
                                            (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                            (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                            (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ecmp_pfxs.yfilter != YFilter.not_set or
                                            self.protected_pfxs.yfilter != YFilter.not_set or
                                            self.total_pfxs.yfilter != YFilter.not_set or
                                            (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                            (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                            (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pfxs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                                        if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                                        if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "labeled-pfxs-aggr"):
                                            if (self.labeled_pfxs_aggr is None):
                                                self.labeled_pfxs_aggr = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                                self.labeled_pfxs_aggr.parent = self
                                                self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                            return self.labeled_pfxs_aggr

                                        if (child_yang_name == "labeled-pfxs-backup"):
                                            if (self.labeled_pfxs_backup is None):
                                                self.labeled_pfxs_backup = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                                self.labeled_pfxs_backup.parent = self
                                                self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                            return self.labeled_pfxs_backup

                                        if (child_yang_name == "labeled-pfxs-primary"):
                                            if (self.labeled_pfxs_primary is None):
                                                self.labeled_pfxs_primary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                                self.labeled_pfxs_primary.parent = self
                                                self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                            return self.labeled_pfxs_primary

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ecmp-pfxs"):
                                            self.ecmp_pfxs = value
                                            self.ecmp_pfxs.value_namespace = name_space
                                            self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protected-pfxs"):
                                            self.protected_pfxs = value
                                            self.protected_pfxs.value_namespace = name_space
                                            self.protected_pfxs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-pfxs"):
                                            self.total_pfxs = value
                                            self.total_pfxs.value_namespace = name_space
                                            self.total_pfxs.value_namespace_prefix = name_space_prefix


                                class Nhs(Entity):
                                    """
                                    Forwarding rewrites nexthops (paths) summary
                                    
                                    .. attribute:: backup_paths
                                    
                                    	Count of non\-primary backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: labeled_backup_paths
                                    
                                    	Count of labeled backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: labeled_paths
                                    
                                    	Count of all labeled paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: protected_paths
                                    
                                    	Count of FRR protected paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: remote_backup_paths
                                    
                                    	Count of non\-primary remote backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_paths
                                    
                                    	Total path count
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__init__()

                                        self.yang_name = "nhs"
                                        self.yang_parent_name = "rws"

                                        self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                                        self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                                        self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                                        self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                                        self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                                        self.total_paths = YLeaf(YType.uint32, "total-paths")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_paths",
                                                        "labeled_backup_paths",
                                                        "labeled_paths",
                                                        "protected_paths",
                                                        "remote_backup_paths",
                                                        "total_paths") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_paths.is_set or
                                            self.labeled_backup_paths.is_set or
                                            self.labeled_paths.is_set or
                                            self.protected_paths.is_set or
                                            self.remote_backup_paths.is_set or
                                            self.total_paths.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_paths.yfilter != YFilter.not_set or
                                            self.labeled_backup_paths.yfilter != YFilter.not_set or
                                            self.labeled_paths.yfilter != YFilter.not_set or
                                            self.protected_paths.yfilter != YFilter.not_set or
                                            self.remote_backup_paths.yfilter != YFilter.not_set or
                                            self.total_paths.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nhs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_paths.get_name_leafdata())
                                        if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                                        if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                                        if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protected_paths.get_name_leafdata())
                                        if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                                        if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_paths.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-paths"):
                                            self.backup_paths = value
                                            self.backup_paths.value_namespace = name_space
                                            self.backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "labeled-backup-paths"):
                                            self.labeled_backup_paths = value
                                            self.labeled_backup_paths.value_namespace = name_space
                                            self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "labeled-paths"):
                                            self.labeled_paths = value
                                            self.labeled_paths.value_namespace = name_space
                                            self.labeled_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protected-paths"):
                                            self.protected_paths = value
                                            self.protected_paths.value_namespace = name_space
                                            self.protected_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-backup-paths"):
                                            self.remote_backup_paths = value
                                            self.remote_backup_paths.value_namespace = name_space
                                            self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-paths"):
                                            self.total_paths = value
                                            self.total_paths.value_namespace = name_space
                                            self.total_paths.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.nhs is not None and self.nhs.has_data()) or
                                        (self.pfxs is not None and self.pfxs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.nhs is not None and self.nhs.has_operation()) or
                                        (self.pfxs is not None and self.pfxs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "rws" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "nhs"):
                                        if (self.nhs is None):
                                            self.nhs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                            self.nhs.parent = self
                                            self._children_name_map["nhs"] = "nhs"
                                        return self.nhs

                                    if (child_yang_name == "pfxs"):
                                        if (self.pfxs is None):
                                            self.pfxs = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                            self.pfxs.parent = self
                                            self._children_name_map["pfxs"] = "pfxs"
                                        return self.pfxs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nhs" or name == "pfxs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.fsht.is_set or
                                    self.intfs.is_set or
                                    self.is_lsd_bound.is_set or
                                    self.lbls.is_set or
                                    (self.rws is not None and self.rws.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fsht.yfilter != YFilter.not_set or
                                    self.intfs.yfilter != YFilter.not_set or
                                    self.is_lsd_bound.yfilter != YFilter.not_set or
                                    self.lbls.yfilter != YFilter.not_set or
                                    (self.rws is not None and self.rws.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "forwarding-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fsht.get_name_leafdata())
                                if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intfs.get_name_leafdata())
                                if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                                if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lbls.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "rws"):
                                    if (self.rws is None):
                                        self.rws = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Rws()
                                        self.rws.parent = self
                                        self._children_name_map["rws"] = "rws"
                                    return self.rws

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fsht"):
                                    self.fsht = value
                                    self.fsht.value_namespace = name_space
                                    self.fsht.value_namespace_prefix = name_space_prefix
                                if(value_path == "intfs"):
                                    self.intfs = value
                                    self.intfs.value_namespace = name_space
                                    self.intfs.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lsd-bound"):
                                    self.is_lsd_bound = value
                                    self.is_lsd_bound.value_namespace = name_space
                                    self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                                if(value_path == "lbls"):
                                    self.lbls = value
                                    self.lbls.value_namespace = name_space
                                    self.lbls.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.af_name.is_set or
                                (self.bindings is not None and self.bindings.has_data()) or
                                (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_data()) or
                                (self.bindings_summary is not None and self.bindings_summary.has_data()) or
                                (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                                (self.discovery is not None and self.discovery.has_data()) or
                                (self.forwarding_summary is not None and self.forwarding_summary.has_data()) or
                                (self.forwardings is not None and self.forwardings.has_data()) or
                                (self.igp is not None and self.igp.has_data()) or
                                (self.interface_summary is not None and self.interface_summary.has_data()) or
                                (self.interfaces is not None and self.interfaces.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.af_name.yfilter != YFilter.not_set or
                                (self.bindings is not None and self.bindings.has_operation()) or
                                (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_operation()) or
                                (self.bindings_summary is not None and self.bindings_summary.has_operation()) or
                                (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                                (self.discovery is not None and self.discovery.has_operation()) or
                                (self.forwarding_summary is not None and self.forwarding_summary.has_operation()) or
                                (self.forwardings is not None and self.forwardings.has_operation()) or
                                (self.igp is not None and self.igp.has_operation()) or
                                (self.interface_summary is not None and self.interface_summary.has_operation()) or
                                (self.interfaces is not None and self.interfaces.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "af" + "[af-name='" + self.af_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/afs/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.af_name.is_set or self.af_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.af_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bindings"):
                                if (self.bindings is None):
                                    self.bindings = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Bindings()
                                    self.bindings.parent = self
                                    self._children_name_map["bindings"] = "bindings"
                                return self.bindings

                            if (child_yang_name == "bindings-advertise-spec"):
                                if (self.bindings_advertise_spec is None):
                                    self.bindings_advertise_spec = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsAdvertiseSpec()
                                    self.bindings_advertise_spec.parent = self
                                    self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                return self.bindings_advertise_spec

                            if (child_yang_name == "bindings-summary"):
                                if (self.bindings_summary is None):
                                    self.bindings_summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummary()
                                    self.bindings_summary.parent = self
                                    self._children_name_map["bindings_summary"] = "bindings-summary"
                                return self.bindings_summary

                            if (child_yang_name == "bindings-summary-all"):
                                if (self.bindings_summary_all is None):
                                    self.bindings_summary_all = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.BindingsSummaryAll()
                                    self.bindings_summary_all.parent = self
                                    self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                return self.bindings_summary_all

                            if (child_yang_name == "discovery"):
                                if (self.discovery is None):
                                    self.discovery = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Discovery()
                                    self.discovery.parent = self
                                    self._children_name_map["discovery"] = "discovery"
                                return self.discovery

                            if (child_yang_name == "forwarding-summary"):
                                if (self.forwarding_summary is None):
                                    self.forwarding_summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.ForwardingSummary()
                                    self.forwarding_summary.parent = self
                                    self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                return self.forwarding_summary

                            if (child_yang_name == "forwardings"):
                                if (self.forwardings is None):
                                    self.forwardings = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Forwardings()
                                    self.forwardings.parent = self
                                    self._children_name_map["forwardings"] = "forwardings"
                                return self.forwardings

                            if (child_yang_name == "igp"):
                                if (self.igp is None):
                                    self.igp = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Igp()
                                    self.igp.parent = self
                                    self._children_name_map["igp"] = "igp"
                                return self.igp

                            if (child_yang_name == "interface-summary"):
                                if (self.interface_summary is None):
                                    self.interface_summary = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.InterfaceSummary()
                                    self.interface_summary.parent = self
                                    self._children_name_map["interface_summary"] = "interface-summary"
                                return self.interface_summary

                            if (child_yang_name == "interfaces"):
                                if (self.interfaces is None):
                                    self.interfaces = MplsLdp.Global_.Active.DefaultVrf.Afs.Af.Interfaces()
                                    self.interfaces.parent = self
                                    self._children_name_map["interfaces"] = "interfaces"
                                return self.interfaces

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bindings" or name == "bindings-advertise-spec" or name == "bindings-summary" or name == "bindings-summary-all" or name == "discovery" or name == "forwarding-summary" or name == "forwardings" or name == "igp" or name == "interface-summary" or name == "interfaces" or name == "af-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "af-name"):
                                self.af_name = value
                                self.af_name.value_namespace = name_space
                                self.af_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.af:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.af:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "afs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "af"):
                            for c in self.af:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.Afs.Af()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.af.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "af"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborBriefs(Entity):
                    """
                    The LDP Neighbors (brief)
                    
                    .. attribute:: neighbor_brief
                    
                    	Brief information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`NeighborBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs, self).__init__()

                        self.yang_name = "neighbor-briefs"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor_brief = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs, self).__setattr__(name, value)


                    class NeighborBrief(Entity):
                        """
                        Brief information on a particular LDP neighbor
                        
                        .. attribute:: is_graceful_restartable
                        
                        	Is graceful restartable
                        	**type**\:  bool
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: nbr_br_af_info
                        
                        	Neighbor Brief AF Info
                        	**type**\: list of    :py:class:`NbrBrAfInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo>`
                        
                        .. attribute:: nsr_state
                        
                        	NSR readiness state
                        	**type**\:   :py:class:`ShowNsrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.ShowNsrState>`
                        
                        .. attribute:: up_time_seconds
                        
                        	Up time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief, self).__init__()

                            self.yang_name = "neighbor-brief"
                            self.yang_parent_name = "neighbor-briefs"

                            self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.nsr_state = YLeaf(YType.enumeration, "nsr-state")

                            self.up_time_seconds = YLeaf(YType.uint32, "up-time-seconds")

                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")

                            self.nbr_br_af_info = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_graceful_restartable",
                                            "label_space_id",
                                            "lsr_id",
                                            "nsr_state",
                                            "up_time_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "neighbor-brief"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbor-briefs/neighbor-brief/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class NbrBrAfInfo(Entity):
                            """
                            Neighbor Brief AF Info
                            
                            .. attribute:: address_family
                            
                            	Neighbor Brief Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: num_of_nbr_addresses
                            
                            	Number of neighbor addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: num_of_nbr_discovery
                            
                            	Number of neighbor discovery sources
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: num_of_nbr_lbl
                            
                            	Number of neighbor labels
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__init__()

                                self.yang_name = "nbr-br-af-info"
                                self.yang_parent_name = "neighbor-brief"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.num_of_nbr_addresses = YLeaf(YType.uint32, "num-of-nbr-addresses")

                                self.num_of_nbr_discovery = YLeaf(YType.uint32, "num-of-nbr-discovery")

                                self.num_of_nbr_lbl = YLeaf(YType.uint32, "num-of-nbr-lbl")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "num_of_nbr_addresses",
                                                "num_of_nbr_discovery",
                                                "num_of_nbr_lbl") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.num_of_nbr_addresses.is_set or
                                    self.num_of_nbr_discovery.is_set or
                                    self.num_of_nbr_lbl.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.num_of_nbr_addresses.yfilter != YFilter.not_set or
                                    self.num_of_nbr_discovery.yfilter != YFilter.not_set or
                                    self.num_of_nbr_lbl.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nbr-br-af-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbor-briefs/neighbor-brief/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.num_of_nbr_addresses.is_set or self.num_of_nbr_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_addresses.get_name_leafdata())
                                if (self.num_of_nbr_discovery.is_set or self.num_of_nbr_discovery.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_discovery.get_name_leafdata())
                                if (self.num_of_nbr_lbl.is_set or self.num_of_nbr_lbl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_lbl.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-family" or name == "num-of-nbr-addresses" or name == "num-of-nbr-discovery" or name == "num-of-nbr-lbl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-addresses"):
                                    self.num_of_nbr_addresses = value
                                    self.num_of_nbr_addresses.value_namespace = name_space
                                    self.num_of_nbr_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-discovery"):
                                    self.num_of_nbr_discovery = value
                                    self.num_of_nbr_discovery.value_namespace = name_space
                                    self.num_of_nbr_discovery.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-lbl"):
                                    self.num_of_nbr_lbl = value
                                    self.num_of_nbr_lbl.value_namespace = name_space
                                    self.num_of_nbr_lbl.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nbr_br_af_info:
                                if (c.has_data()):
                                    return True
                            return (
                                self.is_graceful_restartable.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                self.nsr_state.is_set or
                                self.up_time_seconds.is_set or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            for c in self.nbr_br_af_info:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_graceful_restartable.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                self.nsr_state.yfilter != YFilter.not_set or
                                self.up_time_seconds.yfilter != YFilter.not_set or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-brief" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbor-briefs/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                            if (self.nsr_state.is_set or self.nsr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_state.get_name_leafdata())
                            if (self.up_time_seconds.is_set or self.up_time_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_time_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nbr-br-af-info"):
                                for c in self.nbr_br_af_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nbr_br_af_info.append(c)
                                return c

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nbr-br-af-info" or name == "vrf" or name == "is-graceful-restartable" or name == "label-space-id" or name == "lsr-id" or name == "nsr-state" or name == "up-time-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-graceful-restartable"):
                                self.is_graceful_restartable = value
                                self.is_graceful_restartable.value_namespace = name_space
                                self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-state"):
                                self.nsr_state = value
                                self.nsr_state.value_namespace = name_space
                                self.nsr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-time-seconds"):
                                self.up_time_seconds = value
                                self.up_time_seconds.value_namespace = name_space
                                self.up_time_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor_brief:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor_brief:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-briefs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor-brief"):
                            for c in self.neighbor_brief:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs.NeighborBrief()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor_brief.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor-brief"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class BackoffParameters(Entity):
                    """
                    The LDP Backoff Parameters
                    
                    .. attribute:: initial_seconds
                    
                    	Initial backoff value in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: maximum_seconds
                    
                    	Maximum backoff value in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.BackoffParameters, self).__init__()

                        self.yang_name = "backoff-parameters"
                        self.yang_parent_name = "default-vrf"

                        self.initial_seconds = YLeaf(YType.uint32, "initial-seconds")

                        self.maximum_seconds = YLeaf(YType.uint32, "maximum-seconds")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("initial_seconds",
                                        "maximum_seconds") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.BackoffParameters, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.BackoffParameters, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.initial_seconds.is_set or
                            self.maximum_seconds.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.initial_seconds.yfilter != YFilter.not_set or
                            self.maximum_seconds.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "backoff-parameters" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.initial_seconds.is_set or self.initial_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.initial_seconds.get_name_leafdata())
                        if (self.maximum_seconds.is_set or self.maximum_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_seconds.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "initial-seconds" or name == "maximum-seconds"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "initial-seconds"):
                            self.initial_seconds = value
                            self.initial_seconds.value_namespace = name_space
                            self.initial_seconds.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-seconds"):
                            self.maximum_seconds = value
                            self.maximum_seconds.value_namespace = name_space
                            self.maximum_seconds.value_namespace_prefix = name_space_prefix


                class Backoffs(Entity):
                    """
                    The LDP backoff
                    
                    .. attribute:: backoff
                    
                    	LDP Backoff Information
                    	**type**\: list of    :py:class:`Backoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Backoffs.Backoff>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Backoffs, self).__init__()

                        self.yang_name = "backoffs"
                        self.yang_parent_name = "default-vrf"

                        self.backoff = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Backoffs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.Backoffs, self).__setattr__(name, value)


                    class Backoff(Entity):
                        """
                        LDP Backoff Information
                        
                        .. attribute:: backoff_seconds
                        
                        	Backoff seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: waiting_seconds
                        
                        	Backoff waiting seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Backoffs.Backoff, self).__init__()

                            self.yang_name = "backoff"
                            self.yang_parent_name = "backoffs"

                            self.backoff_seconds = YLeaf(YType.uint32, "backoff-seconds")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.waiting_seconds = YLeaf(YType.uint32, "waiting-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backoff_seconds",
                                            "label_space_id",
                                            "lsr_id",
                                            "waiting_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Backoffs.Backoff, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Backoffs.Backoff, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backoff_seconds.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                self.waiting_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backoff_seconds.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                self.waiting_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoff" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/backoffs/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backoff_seconds.is_set or self.backoff_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backoff_seconds.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                            if (self.waiting_seconds.is_set or self.waiting_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.waiting_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff-seconds" or name == "label-space-id" or name == "lsr-id" or name == "waiting-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backoff-seconds"):
                                self.backoff_seconds = value
                                self.backoff_seconds.value_namespace = name_space
                                self.backoff_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "waiting-seconds"):
                                self.waiting_seconds = value
                                self.waiting_seconds.value_namespace = name_space
                                self.waiting_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.backoff:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.backoff:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "backoffs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "backoff"):
                            for c in self.backoff:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.Backoffs.Backoff()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.backoff.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "backoff"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Nsr(Entity):
                    """
                    LDP NSR related information
                    
                    .. attribute:: ha_statistics
                    
                    	LDP NSR Statistics related information
                    	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics>`
                    
                    .. attribute:: ha_summary
                    
                    	LDP HA Summary
                    	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary>`
                    
                    .. attribute:: nsr_pending
                    
                    	LDP NSR Pending related information
                    	**type**\:   :py:class:`NsrPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr, self).__init__()

                        self.yang_name = "nsr"
                        self.yang_parent_name = "default-vrf"

                        self.ha_statistics = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics()
                        self.ha_statistics.parent = self
                        self._children_name_map["ha_statistics"] = "ha-statistics"
                        self._children_yang_names.add("ha-statistics")

                        self.ha_summary = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary()
                        self.ha_summary.parent = self
                        self._children_name_map["ha_summary"] = "ha-summary"
                        self._children_yang_names.add("ha-summary")

                        self.nsr_pending = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending()
                        self.nsr_pending.parent = self
                        self._children_name_map["nsr_pending"] = "nsr-pending"
                        self._children_yang_names.add("nsr-pending")


                    class NsrPending(Entity):
                        """
                        LDP NSR Pending related information
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending, self).__init__()

                            self.yang_name = "nsr-pending"
                            self.yang_parent_name = "nsr"

                            self.ha_neighbors = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "nsr-pending"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/nsr-pending/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/nsr-pending/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/nsr-pending/ha-neighbors/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/nsr-pending/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (self.ha_neighbors is not None and self.ha_neighbors.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaSummary(Entity):
                        """
                        LDP HA Summary
                        
                        .. attribute:: sessions
                        
                        	Session summary
                        	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Sessions>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary, self).__init__()

                            self.yang_name = "ha-summary"
                            self.yang_parent_name = "nsr"

                            self.sessions = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                            self._children_yang_names.add("sessions")

                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "ha-summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Sessions(Entity):
                            """
                            Session summary
                            
                            .. attribute:: nsr_eligible
                            
                            	NSR eligible sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_app_wait
                            
                            	Number of sessions in NSR app\-wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_none
                            
                            	Number of sessions in NSR none state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_operational
                            
                            	Number of sessions in NSR operational state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_prepare
                            
                            	Number of sessions in NSR prepare state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_ready
                            
                            	Number of sessions in NSR ready state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase1
                            
                            	Number of sessions in NSR TCP phase 1 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase2
                            
                            	Number of sessions in NSR TCP phase 2 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_wait
                            
                            	Number of sessions in NSR wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total
                            
                            	Total sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Sessions, self).__init__()

                                self.yang_name = "sessions"
                                self.yang_parent_name = "ha-summary"

                                self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                self.total = YLeaf(YType.uint32, "total")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_eligible",
                                                "nsr_state_app_wait",
                                                "nsr_state_none",
                                                "nsr_state_operational",
                                                "nsr_state_prepare",
                                                "nsr_state_ready",
                                                "nsr_state_tcp_phase1",
                                                "nsr_state_tcp_phase2",
                                                "nsr_state_wait",
                                                "total") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_eligible.is_set or
                                    self.nsr_state_app_wait.is_set or
                                    self.nsr_state_none.is_set or
                                    self.nsr_state_operational.is_set or
                                    self.nsr_state_prepare.is_set or
                                    self.nsr_state_ready.is_set or
                                    self.nsr_state_tcp_phase1.is_set or
                                    self.nsr_state_tcp_phase2.is_set or
                                    self.nsr_state_wait.is_set or
                                    self.total.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_eligible.yfilter != YFilter.not_set or
                                    self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                    self.nsr_state_none.yfilter != YFilter.not_set or
                                    self.nsr_state_operational.yfilter != YFilter.not_set or
                                    self.nsr_state_prepare.yfilter != YFilter.not_set or
                                    self.nsr_state_ready.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                    self.nsr_state_wait.yfilter != YFilter.not_set or
                                    self.total.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sessions" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-eligible"):
                                    self.nsr_eligible = value
                                    self.nsr_eligible.value_namespace = name_space
                                    self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-app-wait"):
                                    self.nsr_state_app_wait = value
                                    self.nsr_state_app_wait.value_namespace = name_space
                                    self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-none"):
                                    self.nsr_state_none = value
                                    self.nsr_state_none.value_namespace = name_space
                                    self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-operational"):
                                    self.nsr_state_operational = value
                                    self.nsr_state_operational.value_namespace = name_space
                                    self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-prepare"):
                                    self.nsr_state_prepare = value
                                    self.nsr_state_prepare.value_namespace = name_space
                                    self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-ready"):
                                    self.nsr_state_ready = value
                                    self.nsr_state_ready.value_namespace = name_space
                                    self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase1"):
                                    self.nsr_state_tcp_phase1 = value
                                    self.nsr_state_tcp_phase1.value_namespace = name_space
                                    self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase2"):
                                    self.nsr_state_tcp_phase2 = value
                                    self.nsr_state_tcp_phase2.value_namespace = name_space
                                    self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-wait"):
                                    self.nsr_state_wait = value
                                    self.nsr_state_wait.value_namespace = name_space
                                    self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "total"):
                                    self.total = value
                                    self.total.value_namespace = name_space
                                    self.total.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.sessions is not None and self.sessions.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.sessions is not None and self.sessions.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sessions"):
                                if (self.sessions is None):
                                    self.sessions = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Sessions()
                                    self.sessions.parent = self
                                    self._children_name_map["sessions"] = "sessions"
                                return self.sessions

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sessions" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaStatistics(Entity):
                        """
                        LDP NSR Statistics related information
                        
                        .. attribute:: ha_global
                        
                        	LDP NSR Global Statistics information
                        	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal>`
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics, self).__init__()

                            self.yang_name = "ha-statistics"
                            self.yang_parent_name = "nsr"

                            self.ha_global = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal()
                            self.ha_global.parent = self
                            self._children_name_map["ha_global"] = "ha-global"
                            self._children_yang_names.add("ha-global")

                            self.ha_neighbors = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaGlobal(Entity):
                            """
                            LDP NSR Global Statistics information
                            
                            .. attribute:: init_sync
                            
                            	Init Sync
                            	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal, self).__init__()

                                self.yang_name = "ha-global"
                                self.yang_parent_name = "ha-statistics"

                                self.init_sync = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                self.init_sync.parent = self
                                self._children_name_map["init_sync"] = "init-sync"
                                self._children_yang_names.add("init-sync")


                            class InitSync(Entity):
                                """
                                Init Sync
                                
                                .. attribute:: init_sync_end
                                
                                	Init Sync End Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_sync_start
                                
                                	Init Sync Start Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_default_mtu
                                
                                	default IPC MTU bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_exceeded_mtu_msg_cnt
                                
                                	ipc exceeded mtu msg cnt
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_max_rx_batch_bytes
                                
                                	biggest IPC RX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_max_tx_batch_bytes
                                
                                	biggest IPC TX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_rx_bytes
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_rx_cnt
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_tx_bytes
                                
                                	total IPC bytes sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_tx_cnt
                                
                                	num IPC msgs sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_restart_cnt
                                
                                	number of times ipc has been restarted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_tx_fail_cnt
                                
                                	number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_cfged
                                
                                	TRUE if NSR configured
                                	**type**\:  bool
                                
                                .. attribute:: nsr_synced
                                
                                	TRUE if NSR synced
                                	**type**\:  bool
                                
                                .. attribute:: num_cap_rcvd
                                
                                	Number of Rcvd Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_cap_sent
                                
                                	Number of Sent Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl
                                
                                	Number of label bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl_adv
                                
                                	Num of lbl adv
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lcl_addr_wd
                                
                                	Num of lcl address withdraw
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_peers
                                
                                	Number of Peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_pfx
                                
                                	Number of binding prefixes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_ipc_tx_fail_cnt
                                
                                	total number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__init__()

                                    self.yang_name = "init-sync"
                                    self.yang_parent_name = "ha-global"

                                    self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                    self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                    self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                    self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                    self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                    self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                    self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                    self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                    self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                    self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                    self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                    self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                    self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                    self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                    self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                    self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                    self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                    self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                    self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                    self.num_peers = YLeaf(YType.uint32, "num-peers")

                                    self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                    self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("init_sync_end",
                                                    "init_sync_start",
                                                    "ipc_default_mtu",
                                                    "ipc_exceeded_mtu_msg_cnt",
                                                    "ipc_max_rx_batch_bytes",
                                                    "ipc_max_tx_batch_bytes",
                                                    "ipc_msg_rx_bytes",
                                                    "ipc_msg_rx_cnt",
                                                    "ipc_msg_tx_bytes",
                                                    "ipc_msg_tx_cnt",
                                                    "ipc_restart_cnt",
                                                    "ipc_tx_fail_cnt",
                                                    "nsr_cfged",
                                                    "nsr_synced",
                                                    "num_cap_rcvd",
                                                    "num_cap_sent",
                                                    "num_lbl",
                                                    "num_lbl_adv",
                                                    "num_lcl_addr_wd",
                                                    "num_peers",
                                                    "num_pfx",
                                                    "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.init_sync_end.is_set or
                                        self.init_sync_start.is_set or
                                        self.ipc_default_mtu.is_set or
                                        self.ipc_exceeded_mtu_msg_cnt.is_set or
                                        self.ipc_max_rx_batch_bytes.is_set or
                                        self.ipc_max_tx_batch_bytes.is_set or
                                        self.ipc_msg_rx_bytes.is_set or
                                        self.ipc_msg_rx_cnt.is_set or
                                        self.ipc_msg_tx_bytes.is_set or
                                        self.ipc_msg_tx_cnt.is_set or
                                        self.ipc_restart_cnt.is_set or
                                        self.ipc_tx_fail_cnt.is_set or
                                        self.nsr_cfged.is_set or
                                        self.nsr_synced.is_set or
                                        self.num_cap_rcvd.is_set or
                                        self.num_cap_sent.is_set or
                                        self.num_lbl.is_set or
                                        self.num_lbl_adv.is_set or
                                        self.num_lcl_addr_wd.is_set or
                                        self.num_peers.is_set or
                                        self.num_pfx.is_set or
                                        self.total_ipc_tx_fail_cnt.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.init_sync_end.yfilter != YFilter.not_set or
                                        self.init_sync_start.yfilter != YFilter.not_set or
                                        self.ipc_default_mtu.yfilter != YFilter.not_set or
                                        self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                        self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                        self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                        self.nsr_cfged.yfilter != YFilter.not_set or
                                        self.nsr_synced.yfilter != YFilter.not_set or
                                        self.num_cap_rcvd.yfilter != YFilter.not_set or
                                        self.num_cap_sent.yfilter != YFilter.not_set or
                                        self.num_lbl.yfilter != YFilter.not_set or
                                        self.num_lbl_adv.yfilter != YFilter.not_set or
                                        self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                        self.num_peers.yfilter != YFilter.not_set or
                                        self.num_pfx.yfilter != YFilter.not_set or
                                        self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "init-sync" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-statistics/ha-global/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                    if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                    if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                    if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                    if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                    if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                    if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                    if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                    if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                    if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                    if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                    if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                    if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                    if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                    if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                    if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_peers.get_name_leafdata())
                                    if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                    if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "init-sync-end"):
                                        self.init_sync_end = value
                                        self.init_sync_end.value_namespace = name_space
                                        self.init_sync_end.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-sync-start"):
                                        self.init_sync_start = value
                                        self.init_sync_start.value_namespace = name_space
                                        self.init_sync_start.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-default-mtu"):
                                        self.ipc_default_mtu = value
                                        self.ipc_default_mtu.value_namespace = name_space
                                        self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                        self.ipc_exceeded_mtu_msg_cnt = value
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-rx-batch-bytes"):
                                        self.ipc_max_rx_batch_bytes = value
                                        self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-tx-batch-bytes"):
                                        self.ipc_max_tx_batch_bytes = value
                                        self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-bytes"):
                                        self.ipc_msg_rx_bytes = value
                                        self.ipc_msg_rx_bytes.value_namespace = name_space
                                        self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-cnt"):
                                        self.ipc_msg_rx_cnt = value
                                        self.ipc_msg_rx_cnt.value_namespace = name_space
                                        self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-bytes"):
                                        self.ipc_msg_tx_bytes = value
                                        self.ipc_msg_tx_bytes.value_namespace = name_space
                                        self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-cnt"):
                                        self.ipc_msg_tx_cnt = value
                                        self.ipc_msg_tx_cnt.value_namespace = name_space
                                        self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-restart-cnt"):
                                        self.ipc_restart_cnt = value
                                        self.ipc_restart_cnt.value_namespace = name_space
                                        self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-tx-fail-cnt"):
                                        self.ipc_tx_fail_cnt = value
                                        self.ipc_tx_fail_cnt.value_namespace = name_space
                                        self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-cfged"):
                                        self.nsr_cfged = value
                                        self.nsr_cfged.value_namespace = name_space
                                        self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-synced"):
                                        self.nsr_synced = value
                                        self.nsr_synced.value_namespace = name_space
                                        self.nsr_synced.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-rcvd"):
                                        self.num_cap_rcvd = value
                                        self.num_cap_rcvd.value_namespace = name_space
                                        self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-sent"):
                                        self.num_cap_sent = value
                                        self.num_cap_sent.value_namespace = name_space
                                        self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl"):
                                        self.num_lbl = value
                                        self.num_lbl.value_namespace = name_space
                                        self.num_lbl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl-adv"):
                                        self.num_lbl_adv = value
                                        self.num_lbl_adv.value_namespace = name_space
                                        self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lcl-addr-wd"):
                                        self.num_lcl_addr_wd = value
                                        self.num_lcl_addr_wd.value_namespace = name_space
                                        self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-peers"):
                                        self.num_peers = value
                                        self.num_peers.value_namespace = name_space
                                        self.num_peers.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-pfx"):
                                        self.num_pfx = value
                                        self.num_pfx.value_namespace = name_space
                                        self.num_pfx.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-ipc-tx-fail-cnt"):
                                        self.total_ipc_tx_fail_cnt = value
                                        self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                        self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.init_sync is not None and self.init_sync.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.init_sync is not None and self.init_sync.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-global" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "init-sync"):
                                    if (self.init_sync is None):
                                        self.init_sync = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                        self.init_sync.parent = self
                                        self._children_name_map["init_sync"] = "init-sync"
                                    return self.init_sync

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "init-sync"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "ha-statistics"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-statistics/ha-neighbors/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_global is not None and self.ha_global.has_data()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_global is not None and self.ha_global.has_operation()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/nsr/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-global"):
                                if (self.ha_global is None):
                                    self.ha_global = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaGlobal()
                                    self.ha_global.parent = self
                                    self._children_name_map["ha_global"] = "ha-global"
                                return self.ha_global

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-global" or name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                            (self.ha_summary is not None and self.ha_summary.has_data()) or
                            (self.nsr_pending is not None and self.nsr_pending.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                            (self.ha_summary is not None and self.ha_summary.has_operation()) or
                            (self.nsr_pending is not None and self.nsr_pending.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "nsr" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ha-statistics"):
                            if (self.ha_statistics is None):
                                self.ha_statistics = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaStatistics()
                                self.ha_statistics.parent = self
                                self._children_name_map["ha_statistics"] = "ha-statistics"
                            return self.ha_statistics

                        if (child_yang_name == "ha-summary"):
                            if (self.ha_summary is None):
                                self.ha_summary = MplsLdp.Global_.Active.DefaultVrf.Nsr.HaSummary()
                                self.ha_summary.parent = self
                                self._children_name_map["ha_summary"] = "ha-summary"
                            return self.ha_summary

                        if (child_yang_name == "nsr-pending"):
                            if (self.nsr_pending is None):
                                self.nsr_pending = MplsLdp.Global_.Active.DefaultVrf.Nsr.NsrPending()
                                self.nsr_pending.parent = self
                                self._children_name_map["nsr_pending"] = "nsr-pending"
                            return self.nsr_pending

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ha-statistics" or name == "ha-summary" or name == "nsr-pending"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Parameters(Entity):
                    """
                    LDP parameters
                    
                    .. attribute:: address_family_parameter
                    
                    	Per AF parameters
                    	**type**\: list of    :py:class:`AddressFamilyParameter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter>`
                    
                    .. attribute:: af_binding_withdraw_delay
                    
                    	Delay (sec) in Binding Withdrawal for an Address Family
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: discovery_quick_start_disabled_on_interfaces
                    
                    	Discovery quick\-start disabled on some LDP\-enabled interfaces
                    	**type**\:  bool
                    
                    .. attribute:: global_discovery_quick_start_disabled
                    
                    	Discovery quick\-start globally disabled
                    	**type**\:  bool
                    
                    .. attribute:: global_md5_password_enabled
                    
                    	Global MD5 password enabled
                    	**type**\:  bool
                    
                    .. attribute:: graceful_restart_information
                    
                    	Graceful restart information
                    	**type**\:   :py:class:`GracefulRestartInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Parameters.GracefulRestartInformation>`
                    
                    .. attribute:: hello_hold_time
                    
                    	Hello hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hello_interval
                    
                    	Hello interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: housekeeping_timer_interval
                    
                    	Housekeeping periodic timer interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp_sync_delay_time_for_interface
                    
                    	Interface IGP sync delay time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: igp_sync_delay_time_on_restart
                    
                    	IGP sync delay time on process restart in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: keepalive_interval
                    
                    	Keepalive interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ldp_out_of_mem_state
                    
                    	LDP Out of memory state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ldp_recovery_timeout
                    
                    	LDP recovery timeout with LSD
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: le_no_route_timeout
                    
                    	LIB entry no route timeout
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_intf_attached
                    
                    	Maximum number of LDP enabled attached interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_intf_te
                    
                    	Maximum number of LDP enabled TE interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_peer
                    
                    	Maximum number of LDP peers
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_enabled
                    
                    	TRUE if NSR is enabled
                    	**type**\:  bool
                    
                    .. attribute:: nsr_synced
                    
                    	TRUE if LDP is standby and is NSR Sync\-ed with active
                    	**type**\:  bool
                    
                    .. attribute:: protocol_version
                    
                    	Protocol version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: role_is_active
                    
                    	Is process role active or standby
                    	**type**\:  bool
                    
                    .. attribute:: router_id
                    
                    	Router ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: session_hold_time
                    
                    	Session hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: targeted_hello_hold_time
                    
                    	Targeted hello hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: targeted_hello_interval
                    
                    	Targeted hello interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Parameters, self).__init__()

                        self.yang_name = "parameters"
                        self.yang_parent_name = "default-vrf"

                        self.af_binding_withdraw_delay = YLeaf(YType.uint32, "af-binding-withdraw-delay")

                        self.discovery_quick_start_disabled_on_interfaces = YLeaf(YType.boolean, "discovery-quick-start-disabled-on-interfaces")

                        self.global_discovery_quick_start_disabled = YLeaf(YType.boolean, "global-discovery-quick-start-disabled")

                        self.global_md5_password_enabled = YLeaf(YType.boolean, "global-md5-password-enabled")

                        self.hello_hold_time = YLeaf(YType.uint32, "hello-hold-time")

                        self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                        self.housekeeping_timer_interval = YLeaf(YType.uint32, "housekeeping-timer-interval")

                        self.igp_sync_delay_time_for_interface = YLeaf(YType.uint32, "igp-sync-delay-time-for-interface")

                        self.igp_sync_delay_time_on_restart = YLeaf(YType.uint32, "igp-sync-delay-time-on-restart")

                        self.keepalive_interval = YLeaf(YType.uint32, "keepalive-interval")

                        self.ldp_out_of_mem_state = YLeaf(YType.uint32, "ldp-out-of-mem-state")

                        self.ldp_recovery_timeout = YLeaf(YType.uint32, "ldp-recovery-timeout")

                        self.le_no_route_timeout = YLeaf(YType.uint32, "le-no-route-timeout")

                        self.max_intf_attached = YLeaf(YType.uint32, "max-intf-attached")

                        self.max_intf_te = YLeaf(YType.uint32, "max-intf-te")

                        self.max_peer = YLeaf(YType.uint32, "max-peer")

                        self.nsr_enabled = YLeaf(YType.boolean, "nsr-enabled")

                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                        self.protocol_version = YLeaf(YType.uint32, "protocol-version")

                        self.role_is_active = YLeaf(YType.boolean, "role-is-active")

                        self.router_id = YLeaf(YType.str, "router-id")

                        self.session_hold_time = YLeaf(YType.uint32, "session-hold-time")

                        self.targeted_hello_hold_time = YLeaf(YType.uint32, "targeted-hello-hold-time")

                        self.targeted_hello_interval = YLeaf(YType.uint32, "targeted-hello-interval")

                        self.graceful_restart_information = MplsLdp.Global_.Active.DefaultVrf.Parameters.GracefulRestartInformation()
                        self.graceful_restart_information.parent = self
                        self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                        self._children_yang_names.add("graceful-restart-information")

                        self.address_family_parameter = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("af_binding_withdraw_delay",
                                        "discovery_quick_start_disabled_on_interfaces",
                                        "global_discovery_quick_start_disabled",
                                        "global_md5_password_enabled",
                                        "hello_hold_time",
                                        "hello_interval",
                                        "housekeeping_timer_interval",
                                        "igp_sync_delay_time_for_interface",
                                        "igp_sync_delay_time_on_restart",
                                        "keepalive_interval",
                                        "ldp_out_of_mem_state",
                                        "ldp_recovery_timeout",
                                        "le_no_route_timeout",
                                        "max_intf_attached",
                                        "max_intf_te",
                                        "max_peer",
                                        "nsr_enabled",
                                        "nsr_synced",
                                        "protocol_version",
                                        "role_is_active",
                                        "router_id",
                                        "session_hold_time",
                                        "targeted_hello_hold_time",
                                        "targeted_hello_interval") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Parameters, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.Parameters, self).__setattr__(name, value)


                    class GracefulRestartInformation(Entity):
                        """
                        Graceful restart information
                        
                        .. attribute:: graceful_restart_forwarding_state_hold_time
                        
                        	Graceful restart forward state hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: graceful_restart_reconnect_timeout
                        
                        	Reconnect timeout value
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_graceful_restart_configured
                        
                        	Is graceful restart configured
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Parameters.GracefulRestartInformation, self).__init__()

                            self.yang_name = "graceful-restart-information"
                            self.yang_parent_name = "parameters"

                            self.graceful_restart_forwarding_state_hold_time = YLeaf(YType.uint32, "graceful-restart-forwarding-state-hold-time")

                            self.graceful_restart_reconnect_timeout = YLeaf(YType.uint32, "graceful-restart-reconnect-timeout")

                            self.is_graceful_restart_configured = YLeaf(YType.boolean, "is-graceful-restart-configured")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("graceful_restart_forwarding_state_hold_time",
                                            "graceful_restart_reconnect_timeout",
                                            "is_graceful_restart_configured") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.graceful_restart_forwarding_state_hold_time.is_set or
                                self.graceful_restart_reconnect_timeout.is_set or
                                self.is_graceful_restart_configured.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set or
                                self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set or
                                self.is_graceful_restart_configured.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restart-information" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/parameters/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.graceful_restart_forwarding_state_hold_time.is_set or self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.graceful_restart_forwarding_state_hold_time.get_name_leafdata())
                            if (self.graceful_restart_reconnect_timeout.is_set or self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.graceful_restart_reconnect_timeout.get_name_leafdata())
                            if (self.is_graceful_restart_configured.is_set or self.is_graceful_restart_configured.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_graceful_restart_configured.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "graceful-restart-forwarding-state-hold-time" or name == "graceful-restart-reconnect-timeout" or name == "is-graceful-restart-configured"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "graceful-restart-forwarding-state-hold-time"):
                                self.graceful_restart_forwarding_state_hold_time = value
                                self.graceful_restart_forwarding_state_hold_time.value_namespace = name_space
                                self.graceful_restart_forwarding_state_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "graceful-restart-reconnect-timeout"):
                                self.graceful_restart_reconnect_timeout = value
                                self.graceful_restart_reconnect_timeout.value_namespace = name_space
                                self.graceful_restart_reconnect_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-graceful-restart-configured"):
                                self.is_graceful_restart_configured = value
                                self.is_graceful_restart_configured.value_namespace = name_space
                                self.is_graceful_restart_configured.value_namespace_prefix = name_space_prefix


                    class AddressFamilyParameter(Entity):
                        """
                        Per AF parameters
                        
                        .. attribute:: address_family
                        
                        	Address Family
                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                        
                        .. attribute:: discovery_transport_address
                        
                        	Discovery transport address
                        	**type**\:   :py:class:`DiscoveryTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress>`
                        
                        .. attribute:: is_accepting_targeted_hellos
                        
                        	Accepting targeted Hellos
                        	**type**\:  bool
                        
                        .. attribute:: label_imp_null_override_acl
                        
                        	ACL to override local label to use implicit\-null
                        	**type**\:  str
                        
                        .. attribute:: null_label
                        
                        	Null label
                        	**type**\:  str
                        
                        .. attribute:: targeted_hello_acl
                        
                        	Targeted Hello ACL
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter, self).__init__()

                            self.yang_name = "address-family-parameter"
                            self.yang_parent_name = "parameters"

                            self.address_family = YLeaf(YType.enumeration, "address-family")

                            self.is_accepting_targeted_hellos = YLeaf(YType.boolean, "is-accepting-targeted-hellos")

                            self.label_imp_null_override_acl = YLeaf(YType.str, "label-imp-null-override-acl")

                            self.null_label = YLeaf(YType.str, "null-label")

                            self.targeted_hello_acl = YLeaf(YType.str, "targeted-hello-acl")

                            self.discovery_transport_address = MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                            self.discovery_transport_address.parent = self
                            self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                            self._children_yang_names.add("discovery-transport-address")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("address_family",
                                            "is_accepting_targeted_hellos",
                                            "label_imp_null_override_acl",
                                            "null_label",
                                            "targeted_hello_acl") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)


                        class DiscoveryTransportAddress(Entity):
                            """
                            Discovery transport address
                            
                            .. attribute:: afi
                            
                            	AFI
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: dummy
                            
                            	No Address
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: ipv4
                            
                            	IPv4 address type
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv6
                            
                            	IPv6 address type
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__init__()

                                self.yang_name = "discovery-transport-address"
                                self.yang_parent_name = "address-family-parameter"

                                self.afi = YLeaf(YType.enumeration, "afi")

                                self.dummy = YLeaf(YType.uint8, "dummy")

                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                self.ipv6 = YLeaf(YType.str, "ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("afi",
                                                "dummy",
                                                "ipv4",
                                                "ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.afi.is_set or
                                    self.dummy.is_set or
                                    self.ipv4.is_set or
                                    self.ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.afi.yfilter != YFilter.not_set or
                                    self.dummy.yfilter != YFilter.not_set or
                                    self.ipv4.yfilter != YFilter.not_set or
                                    self.ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovery-transport-address" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/parameters/address-family-parameter/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "afi"):
                                    self.afi = value
                                    self.afi.value_namespace = name_space
                                    self.afi.value_namespace_prefix = name_space_prefix
                                if(value_path == "dummy"):
                                    self.dummy = value
                                    self.dummy.value_namespace = name_space
                                    self.dummy.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv4"):
                                    self.ipv4 = value
                                    self.ipv4.value_namespace = name_space
                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv6"):
                                    self.ipv6 = value
                                    self.ipv6.value_namespace = name_space
                                    self.ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.address_family.is_set or
                                self.is_accepting_targeted_hellos.is_set or
                                self.label_imp_null_override_acl.is_set or
                                self.null_label.is_set or
                                self.targeted_hello_acl.is_set or
                                (self.discovery_transport_address is not None and self.discovery_transport_address.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.address_family.yfilter != YFilter.not_set or
                                self.is_accepting_targeted_hellos.yfilter != YFilter.not_set or
                                self.label_imp_null_override_acl.yfilter != YFilter.not_set or
                                self.null_label.yfilter != YFilter.not_set or
                                self.targeted_hello_acl.yfilter != YFilter.not_set or
                                (self.discovery_transport_address is not None and self.discovery_transport_address.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "address-family-parameter" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/parameters/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.address_family.get_name_leafdata())
                            if (self.is_accepting_targeted_hellos.is_set or self.is_accepting_targeted_hellos.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_accepting_targeted_hellos.get_name_leafdata())
                            if (self.label_imp_null_override_acl.is_set or self.label_imp_null_override_acl.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_imp_null_override_acl.get_name_leafdata())
                            if (self.null_label.is_set or self.null_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.null_label.get_name_leafdata())
                            if (self.targeted_hello_acl.is_set or self.targeted_hello_acl.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_acl.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "discovery-transport-address"):
                                if (self.discovery_transport_address is None):
                                    self.discovery_transport_address = MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                    self.discovery_transport_address.parent = self
                                    self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                return self.discovery_transport_address

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "discovery-transport-address" or name == "address-family" or name == "is-accepting-targeted-hellos" or name == "label-imp-null-override-acl" or name == "null-label" or name == "targeted-hello-acl"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "address-family"):
                                self.address_family = value
                                self.address_family.value_namespace = name_space
                                self.address_family.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-accepting-targeted-hellos"):
                                self.is_accepting_targeted_hellos = value
                                self.is_accepting_targeted_hellos.value_namespace = name_space
                                self.is_accepting_targeted_hellos.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-imp-null-override-acl"):
                                self.label_imp_null_override_acl = value
                                self.label_imp_null_override_acl.value_namespace = name_space
                                self.label_imp_null_override_acl.value_namespace_prefix = name_space_prefix
                            if(value_path == "null-label"):
                                self.null_label = value
                                self.null_label.value_namespace = name_space
                                self.null_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-acl"):
                                self.targeted_hello_acl = value
                                self.targeted_hello_acl.value_namespace = name_space
                                self.targeted_hello_acl.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.address_family_parameter:
                            if (c.has_data()):
                                return True
                        return (
                            self.af_binding_withdraw_delay.is_set or
                            self.discovery_quick_start_disabled_on_interfaces.is_set or
                            self.global_discovery_quick_start_disabled.is_set or
                            self.global_md5_password_enabled.is_set or
                            self.hello_hold_time.is_set or
                            self.hello_interval.is_set or
                            self.housekeeping_timer_interval.is_set or
                            self.igp_sync_delay_time_for_interface.is_set or
                            self.igp_sync_delay_time_on_restart.is_set or
                            self.keepalive_interval.is_set or
                            self.ldp_out_of_mem_state.is_set or
                            self.ldp_recovery_timeout.is_set or
                            self.le_no_route_timeout.is_set or
                            self.max_intf_attached.is_set or
                            self.max_intf_te.is_set or
                            self.max_peer.is_set or
                            self.nsr_enabled.is_set or
                            self.nsr_synced.is_set or
                            self.protocol_version.is_set or
                            self.role_is_active.is_set or
                            self.router_id.is_set or
                            self.session_hold_time.is_set or
                            self.targeted_hello_hold_time.is_set or
                            self.targeted_hello_interval.is_set or
                            (self.graceful_restart_information is not None and self.graceful_restart_information.has_data()))

                    def has_operation(self):
                        for c in self.address_family_parameter:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.af_binding_withdraw_delay.yfilter != YFilter.not_set or
                            self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set or
                            self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set or
                            self.global_md5_password_enabled.yfilter != YFilter.not_set or
                            self.hello_hold_time.yfilter != YFilter.not_set or
                            self.hello_interval.yfilter != YFilter.not_set or
                            self.housekeeping_timer_interval.yfilter != YFilter.not_set or
                            self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set or
                            self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set or
                            self.keepalive_interval.yfilter != YFilter.not_set or
                            self.ldp_out_of_mem_state.yfilter != YFilter.not_set or
                            self.ldp_recovery_timeout.yfilter != YFilter.not_set or
                            self.le_no_route_timeout.yfilter != YFilter.not_set or
                            self.max_intf_attached.yfilter != YFilter.not_set or
                            self.max_intf_te.yfilter != YFilter.not_set or
                            self.max_peer.yfilter != YFilter.not_set or
                            self.nsr_enabled.yfilter != YFilter.not_set or
                            self.nsr_synced.yfilter != YFilter.not_set or
                            self.protocol_version.yfilter != YFilter.not_set or
                            self.role_is_active.yfilter != YFilter.not_set or
                            self.router_id.yfilter != YFilter.not_set or
                            self.session_hold_time.yfilter != YFilter.not_set or
                            self.targeted_hello_hold_time.yfilter != YFilter.not_set or
                            self.targeted_hello_interval.yfilter != YFilter.not_set or
                            (self.graceful_restart_information is not None and self.graceful_restart_information.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "parameters" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.af_binding_withdraw_delay.is_set or self.af_binding_withdraw_delay.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.af_binding_withdraw_delay.get_name_leafdata())
                        if (self.discovery_quick_start_disabled_on_interfaces.is_set or self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.discovery_quick_start_disabled_on_interfaces.get_name_leafdata())
                        if (self.global_discovery_quick_start_disabled.is_set or self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_discovery_quick_start_disabled.get_name_leafdata())
                        if (self.global_md5_password_enabled.is_set or self.global_md5_password_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_md5_password_enabled.get_name_leafdata())
                        if (self.hello_hold_time.is_set or self.hello_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hello_hold_time.get_name_leafdata())
                        if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hello_interval.get_name_leafdata())
                        if (self.housekeeping_timer_interval.is_set or self.housekeeping_timer_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.housekeeping_timer_interval.get_name_leafdata())
                        if (self.igp_sync_delay_time_for_interface.is_set or self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_sync_delay_time_for_interface.get_name_leafdata())
                        if (self.igp_sync_delay_time_on_restart.is_set or self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_sync_delay_time_on_restart.get_name_leafdata())
                        if (self.keepalive_interval.is_set or self.keepalive_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.keepalive_interval.get_name_leafdata())
                        if (self.ldp_out_of_mem_state.is_set or self.ldp_out_of_mem_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_out_of_mem_state.get_name_leafdata())
                        if (self.ldp_recovery_timeout.is_set or self.ldp_recovery_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_recovery_timeout.get_name_leafdata())
                        if (self.le_no_route_timeout.is_set or self.le_no_route_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.le_no_route_timeout.get_name_leafdata())
                        if (self.max_intf_attached.is_set or self.max_intf_attached.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_intf_attached.get_name_leafdata())
                        if (self.max_intf_te.is_set or self.max_intf_te.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_intf_te.get_name_leafdata())
                        if (self.max_peer.is_set or self.max_peer.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_peer.get_name_leafdata())
                        if (self.nsr_enabled.is_set or self.nsr_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_enabled.get_name_leafdata())
                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                        if (self.protocol_version.is_set or self.protocol_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protocol_version.get_name_leafdata())
                        if (self.role_is_active.is_set or self.role_is_active.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role_is_active.get_name_leafdata())
                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.router_id.get_name_leafdata())
                        if (self.session_hold_time.is_set or self.session_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.session_hold_time.get_name_leafdata())
                        if (self.targeted_hello_hold_time.is_set or self.targeted_hello_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.targeted_hello_hold_time.get_name_leafdata())
                        if (self.targeted_hello_interval.is_set or self.targeted_hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.targeted_hello_interval.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "address-family-parameter"):
                            for c in self.address_family_parameter:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.Parameters.AddressFamilyParameter()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.address_family_parameter.append(c)
                            return c

                        if (child_yang_name == "graceful-restart-information"):
                            if (self.graceful_restart_information is None):
                                self.graceful_restart_information = MplsLdp.Global_.Active.DefaultVrf.Parameters.GracefulRestartInformation()
                                self.graceful_restart_information.parent = self
                                self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                            return self.graceful_restart_information

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family-parameter" or name == "graceful-restart-information" or name == "af-binding-withdraw-delay" or name == "discovery-quick-start-disabled-on-interfaces" or name == "global-discovery-quick-start-disabled" or name == "global-md5-password-enabled" or name == "hello-hold-time" or name == "hello-interval" or name == "housekeeping-timer-interval" or name == "igp-sync-delay-time-for-interface" or name == "igp-sync-delay-time-on-restart" or name == "keepalive-interval" or name == "ldp-out-of-mem-state" or name == "ldp-recovery-timeout" or name == "le-no-route-timeout" or name == "max-intf-attached" or name == "max-intf-te" or name == "max-peer" or name == "nsr-enabled" or name == "nsr-synced" or name == "protocol-version" or name == "role-is-active" or name == "router-id" or name == "session-hold-time" or name == "targeted-hello-hold-time" or name == "targeted-hello-interval"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "af-binding-withdraw-delay"):
                            self.af_binding_withdraw_delay = value
                            self.af_binding_withdraw_delay.value_namespace = name_space
                            self.af_binding_withdraw_delay.value_namespace_prefix = name_space_prefix
                        if(value_path == "discovery-quick-start-disabled-on-interfaces"):
                            self.discovery_quick_start_disabled_on_interfaces = value
                            self.discovery_quick_start_disabled_on_interfaces.value_namespace = name_space
                            self.discovery_quick_start_disabled_on_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "global-discovery-quick-start-disabled"):
                            self.global_discovery_quick_start_disabled = value
                            self.global_discovery_quick_start_disabled.value_namespace = name_space
                            self.global_discovery_quick_start_disabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "global-md5-password-enabled"):
                            self.global_md5_password_enabled = value
                            self.global_md5_password_enabled.value_namespace = name_space
                            self.global_md5_password_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "hello-hold-time"):
                            self.hello_hold_time = value
                            self.hello_hold_time.value_namespace = name_space
                            self.hello_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "hello-interval"):
                            self.hello_interval = value
                            self.hello_interval.value_namespace = name_space
                            self.hello_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "housekeeping-timer-interval"):
                            self.housekeeping_timer_interval = value
                            self.housekeeping_timer_interval.value_namespace = name_space
                            self.housekeeping_timer_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-sync-delay-time-for-interface"):
                            self.igp_sync_delay_time_for_interface = value
                            self.igp_sync_delay_time_for_interface.value_namespace = name_space
                            self.igp_sync_delay_time_for_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-sync-delay-time-on-restart"):
                            self.igp_sync_delay_time_on_restart = value
                            self.igp_sync_delay_time_on_restart.value_namespace = name_space
                            self.igp_sync_delay_time_on_restart.value_namespace_prefix = name_space_prefix
                        if(value_path == "keepalive-interval"):
                            self.keepalive_interval = value
                            self.keepalive_interval.value_namespace = name_space
                            self.keepalive_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-out-of-mem-state"):
                            self.ldp_out_of_mem_state = value
                            self.ldp_out_of_mem_state.value_namespace = name_space
                            self.ldp_out_of_mem_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-recovery-timeout"):
                            self.ldp_recovery_timeout = value
                            self.ldp_recovery_timeout.value_namespace = name_space
                            self.ldp_recovery_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "le-no-route-timeout"):
                            self.le_no_route_timeout = value
                            self.le_no_route_timeout.value_namespace = name_space
                            self.le_no_route_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-intf-attached"):
                            self.max_intf_attached = value
                            self.max_intf_attached.value_namespace = name_space
                            self.max_intf_attached.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-intf-te"):
                            self.max_intf_te = value
                            self.max_intf_te.value_namespace = name_space
                            self.max_intf_te.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-peer"):
                            self.max_peer = value
                            self.max_peer.value_namespace = name_space
                            self.max_peer.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-enabled"):
                            self.nsr_enabled = value
                            self.nsr_enabled.value_namespace = name_space
                            self.nsr_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-synced"):
                            self.nsr_synced = value
                            self.nsr_synced.value_namespace = name_space
                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                        if(value_path == "protocol-version"):
                            self.protocol_version = value
                            self.protocol_version.value_namespace = name_space
                            self.protocol_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "role-is-active"):
                            self.role_is_active = value
                            self.role_is_active.value_namespace = name_space
                            self.role_is_active.value_namespace_prefix = name_space_prefix
                        if(value_path == "router-id"):
                            self.router_id = value
                            self.router_id.value_namespace = name_space
                            self.router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "session-hold-time"):
                            self.session_hold_time = value
                            self.session_hold_time.value_namespace = name_space
                            self.session_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "targeted-hello-hold-time"):
                            self.targeted_hello_hold_time = value
                            self.targeted_hello_hold_time.value_namespace = name_space
                            self.targeted_hello_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "targeted-hello-interval"):
                            self.targeted_hello_interval = value
                            self.targeted_hello_interval.value_namespace = name_space
                            self.targeted_hello_interval.value_namespace_prefix = name_space_prefix


                class Issu(Entity):
                    """
                    LDP ISSU related information
                    
                    .. attribute:: ha_statistics
                    
                    	LDP NSR Statistics related information
                    	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics>`
                    
                    .. attribute:: ha_summary
                    
                    	LDP HA Summary
                    	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Issu, self).__init__()

                        self.yang_name = "issu"
                        self.yang_parent_name = "default-vrf"

                        self.ha_statistics = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics()
                        self.ha_statistics.parent = self
                        self._children_name_map["ha_statistics"] = "ha-statistics"
                        self._children_yang_names.add("ha-statistics")

                        self.ha_summary = MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary()
                        self.ha_summary.parent = self
                        self._children_name_map["ha_summary"] = "ha-summary"
                        self._children_yang_names.add("ha-summary")


                    class HaSummary(Entity):
                        """
                        LDP HA Summary
                        
                        .. attribute:: sessions
                        
                        	Session summary
                        	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Sessions>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary, self).__init__()

                            self.yang_name = "ha-summary"
                            self.yang_parent_name = "issu"

                            self.sessions = MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                            self._children_yang_names.add("sessions")

                            self.vrf = MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "ha-summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Sessions(Entity):
                            """
                            Session summary
                            
                            .. attribute:: nsr_eligible
                            
                            	NSR eligible sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_app_wait
                            
                            	Number of sessions in NSR app\-wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_none
                            
                            	Number of sessions in NSR none state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_operational
                            
                            	Number of sessions in NSR operational state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_prepare
                            
                            	Number of sessions in NSR prepare state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_ready
                            
                            	Number of sessions in NSR ready state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase1
                            
                            	Number of sessions in NSR TCP phase 1 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase2
                            
                            	Number of sessions in NSR TCP phase 2 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_wait
                            
                            	Number of sessions in NSR wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total
                            
                            	Total sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Sessions, self).__init__()

                                self.yang_name = "sessions"
                                self.yang_parent_name = "ha-summary"

                                self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                self.total = YLeaf(YType.uint32, "total")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_eligible",
                                                "nsr_state_app_wait",
                                                "nsr_state_none",
                                                "nsr_state_operational",
                                                "nsr_state_prepare",
                                                "nsr_state_ready",
                                                "nsr_state_tcp_phase1",
                                                "nsr_state_tcp_phase2",
                                                "nsr_state_wait",
                                                "total") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_eligible.is_set or
                                    self.nsr_state_app_wait.is_set or
                                    self.nsr_state_none.is_set or
                                    self.nsr_state_operational.is_set or
                                    self.nsr_state_prepare.is_set or
                                    self.nsr_state_ready.is_set or
                                    self.nsr_state_tcp_phase1.is_set or
                                    self.nsr_state_tcp_phase2.is_set or
                                    self.nsr_state_wait.is_set or
                                    self.total.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_eligible.yfilter != YFilter.not_set or
                                    self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                    self.nsr_state_none.yfilter != YFilter.not_set or
                                    self.nsr_state_operational.yfilter != YFilter.not_set or
                                    self.nsr_state_prepare.yfilter != YFilter.not_set or
                                    self.nsr_state_ready.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                    self.nsr_state_wait.yfilter != YFilter.not_set or
                                    self.total.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sessions" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-summary/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-eligible"):
                                    self.nsr_eligible = value
                                    self.nsr_eligible.value_namespace = name_space
                                    self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-app-wait"):
                                    self.nsr_state_app_wait = value
                                    self.nsr_state_app_wait.value_namespace = name_space
                                    self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-none"):
                                    self.nsr_state_none = value
                                    self.nsr_state_none.value_namespace = name_space
                                    self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-operational"):
                                    self.nsr_state_operational = value
                                    self.nsr_state_operational.value_namespace = name_space
                                    self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-prepare"):
                                    self.nsr_state_prepare = value
                                    self.nsr_state_prepare.value_namespace = name_space
                                    self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-ready"):
                                    self.nsr_state_ready = value
                                    self.nsr_state_ready.value_namespace = name_space
                                    self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase1"):
                                    self.nsr_state_tcp_phase1 = value
                                    self.nsr_state_tcp_phase1.value_namespace = name_space
                                    self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase2"):
                                    self.nsr_state_tcp_phase2 = value
                                    self.nsr_state_tcp_phase2.value_namespace = name_space
                                    self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-wait"):
                                    self.nsr_state_wait = value
                                    self.nsr_state_wait.value_namespace = name_space
                                    self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "total"):
                                    self.total = value
                                    self.total.value_namespace = name_space
                                    self.total.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.sessions is not None and self.sessions.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.sessions is not None and self.sessions.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sessions"):
                                if (self.sessions is None):
                                    self.sessions = MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Sessions()
                                    self.sessions.parent = self
                                    self._children_name_map["sessions"] = "sessions"
                                return self.sessions

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sessions" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaStatistics(Entity):
                        """
                        LDP NSR Statistics related information
                        
                        .. attribute:: ha_global
                        
                        	LDP NSR Global Statistics information
                        	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal>`
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics, self).__init__()

                            self.yang_name = "ha-statistics"
                            self.yang_parent_name = "issu"

                            self.ha_global = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal()
                            self.ha_global.parent = self
                            self._children_name_map["ha_global"] = "ha-global"
                            self._children_yang_names.add("ha-global")

                            self.ha_neighbors = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaGlobal(Entity):
                            """
                            LDP NSR Global Statistics information
                            
                            .. attribute:: init_sync
                            
                            	Init Sync
                            	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal, self).__init__()

                                self.yang_name = "ha-global"
                                self.yang_parent_name = "ha-statistics"

                                self.init_sync = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync()
                                self.init_sync.parent = self
                                self._children_name_map["init_sync"] = "init-sync"
                                self._children_yang_names.add("init-sync")


                            class InitSync(Entity):
                                """
                                Init Sync
                                
                                .. attribute:: init_sync_end
                                
                                	Init Sync End Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_sync_start
                                
                                	Init Sync Start Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_default_mtu
                                
                                	default IPC MTU bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_exceeded_mtu_msg_cnt
                                
                                	ipc exceeded mtu msg cnt
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_max_rx_batch_bytes
                                
                                	biggest IPC RX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_max_tx_batch_bytes
                                
                                	biggest IPC TX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_rx_bytes
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_rx_cnt
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_tx_bytes
                                
                                	total IPC bytes sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_tx_cnt
                                
                                	num IPC msgs sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_restart_cnt
                                
                                	number of times ipc has been restarted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_tx_fail_cnt
                                
                                	number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_cfged
                                
                                	TRUE if NSR configured
                                	**type**\:  bool
                                
                                .. attribute:: nsr_synced
                                
                                	TRUE if NSR synced
                                	**type**\:  bool
                                
                                .. attribute:: num_cap_rcvd
                                
                                	Number of Rcvd Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_cap_sent
                                
                                	Number of Sent Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl
                                
                                	Number of label bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl_adv
                                
                                	Num of lbl adv
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lcl_addr_wd
                                
                                	Num of lcl address withdraw
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_peers
                                
                                	Number of Peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_pfx
                                
                                	Number of binding prefixes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_ipc_tx_fail_cnt
                                
                                	total number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__init__()

                                    self.yang_name = "init-sync"
                                    self.yang_parent_name = "ha-global"

                                    self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                    self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                    self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                    self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                    self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                    self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                    self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                    self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                    self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                    self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                    self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                    self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                    self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                    self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                    self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                    self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                    self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                    self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                    self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                    self.num_peers = YLeaf(YType.uint32, "num-peers")

                                    self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                    self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("init_sync_end",
                                                    "init_sync_start",
                                                    "ipc_default_mtu",
                                                    "ipc_exceeded_mtu_msg_cnt",
                                                    "ipc_max_rx_batch_bytes",
                                                    "ipc_max_tx_batch_bytes",
                                                    "ipc_msg_rx_bytes",
                                                    "ipc_msg_rx_cnt",
                                                    "ipc_msg_tx_bytes",
                                                    "ipc_msg_tx_cnt",
                                                    "ipc_restart_cnt",
                                                    "ipc_tx_fail_cnt",
                                                    "nsr_cfged",
                                                    "nsr_synced",
                                                    "num_cap_rcvd",
                                                    "num_cap_sent",
                                                    "num_lbl",
                                                    "num_lbl_adv",
                                                    "num_lcl_addr_wd",
                                                    "num_peers",
                                                    "num_pfx",
                                                    "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.init_sync_end.is_set or
                                        self.init_sync_start.is_set or
                                        self.ipc_default_mtu.is_set or
                                        self.ipc_exceeded_mtu_msg_cnt.is_set or
                                        self.ipc_max_rx_batch_bytes.is_set or
                                        self.ipc_max_tx_batch_bytes.is_set or
                                        self.ipc_msg_rx_bytes.is_set or
                                        self.ipc_msg_rx_cnt.is_set or
                                        self.ipc_msg_tx_bytes.is_set or
                                        self.ipc_msg_tx_cnt.is_set or
                                        self.ipc_restart_cnt.is_set or
                                        self.ipc_tx_fail_cnt.is_set or
                                        self.nsr_cfged.is_set or
                                        self.nsr_synced.is_set or
                                        self.num_cap_rcvd.is_set or
                                        self.num_cap_sent.is_set or
                                        self.num_lbl.is_set or
                                        self.num_lbl_adv.is_set or
                                        self.num_lcl_addr_wd.is_set or
                                        self.num_peers.is_set or
                                        self.num_pfx.is_set or
                                        self.total_ipc_tx_fail_cnt.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.init_sync_end.yfilter != YFilter.not_set or
                                        self.init_sync_start.yfilter != YFilter.not_set or
                                        self.ipc_default_mtu.yfilter != YFilter.not_set or
                                        self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                        self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                        self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                        self.nsr_cfged.yfilter != YFilter.not_set or
                                        self.nsr_synced.yfilter != YFilter.not_set or
                                        self.num_cap_rcvd.yfilter != YFilter.not_set or
                                        self.num_cap_sent.yfilter != YFilter.not_set or
                                        self.num_lbl.yfilter != YFilter.not_set or
                                        self.num_lbl_adv.yfilter != YFilter.not_set or
                                        self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                        self.num_peers.yfilter != YFilter.not_set or
                                        self.num_pfx.yfilter != YFilter.not_set or
                                        self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "init-sync" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-statistics/ha-global/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                    if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                    if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                    if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                    if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                    if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                    if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                    if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                    if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                    if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                    if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                    if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                    if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                    if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                    if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                    if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_peers.get_name_leafdata())
                                    if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                    if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "init-sync-end"):
                                        self.init_sync_end = value
                                        self.init_sync_end.value_namespace = name_space
                                        self.init_sync_end.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-sync-start"):
                                        self.init_sync_start = value
                                        self.init_sync_start.value_namespace = name_space
                                        self.init_sync_start.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-default-mtu"):
                                        self.ipc_default_mtu = value
                                        self.ipc_default_mtu.value_namespace = name_space
                                        self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                        self.ipc_exceeded_mtu_msg_cnt = value
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-rx-batch-bytes"):
                                        self.ipc_max_rx_batch_bytes = value
                                        self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-tx-batch-bytes"):
                                        self.ipc_max_tx_batch_bytes = value
                                        self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-bytes"):
                                        self.ipc_msg_rx_bytes = value
                                        self.ipc_msg_rx_bytes.value_namespace = name_space
                                        self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-cnt"):
                                        self.ipc_msg_rx_cnt = value
                                        self.ipc_msg_rx_cnt.value_namespace = name_space
                                        self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-bytes"):
                                        self.ipc_msg_tx_bytes = value
                                        self.ipc_msg_tx_bytes.value_namespace = name_space
                                        self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-cnt"):
                                        self.ipc_msg_tx_cnt = value
                                        self.ipc_msg_tx_cnt.value_namespace = name_space
                                        self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-restart-cnt"):
                                        self.ipc_restart_cnt = value
                                        self.ipc_restart_cnt.value_namespace = name_space
                                        self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-tx-fail-cnt"):
                                        self.ipc_tx_fail_cnt = value
                                        self.ipc_tx_fail_cnt.value_namespace = name_space
                                        self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-cfged"):
                                        self.nsr_cfged = value
                                        self.nsr_cfged.value_namespace = name_space
                                        self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-synced"):
                                        self.nsr_synced = value
                                        self.nsr_synced.value_namespace = name_space
                                        self.nsr_synced.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-rcvd"):
                                        self.num_cap_rcvd = value
                                        self.num_cap_rcvd.value_namespace = name_space
                                        self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-sent"):
                                        self.num_cap_sent = value
                                        self.num_cap_sent.value_namespace = name_space
                                        self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl"):
                                        self.num_lbl = value
                                        self.num_lbl.value_namespace = name_space
                                        self.num_lbl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl-adv"):
                                        self.num_lbl_adv = value
                                        self.num_lbl_adv.value_namespace = name_space
                                        self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lcl-addr-wd"):
                                        self.num_lcl_addr_wd = value
                                        self.num_lcl_addr_wd.value_namespace = name_space
                                        self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-peers"):
                                        self.num_peers = value
                                        self.num_peers.value_namespace = name_space
                                        self.num_peers.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-pfx"):
                                        self.num_pfx = value
                                        self.num_pfx.value_namespace = name_space
                                        self.num_pfx.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-ipc-tx-fail-cnt"):
                                        self.total_ipc_tx_fail_cnt = value
                                        self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                        self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.init_sync is not None and self.init_sync.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.init_sync is not None and self.init_sync.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-global" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "init-sync"):
                                    if (self.init_sync is None):
                                        self.init_sync = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync()
                                        self.init_sync.parent = self
                                        self._children_name_map["init_sync"] = "init-sync"
                                    return self.init_sync

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "init-sync"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "ha-statistics"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-statistics/ha-neighbors/ha-neighbor/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-statistics/ha-neighbors/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/ha-statistics/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_global is not None and self.ha_global.has_data()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_global is not None and self.ha_global.has_operation()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/issu/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-global"):
                                if (self.ha_global is None):
                                    self.ha_global = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaGlobal()
                                    self.ha_global.parent = self
                                    self._children_name_map["ha_global"] = "ha-global"
                                return self.ha_global

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-global" or name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                            (self.ha_summary is not None and self.ha_summary.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                            (self.ha_summary is not None and self.ha_summary.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "issu" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ha-statistics"):
                            if (self.ha_statistics is None):
                                self.ha_statistics = MplsLdp.Global_.Active.DefaultVrf.Issu.HaStatistics()
                                self.ha_statistics.parent = self
                                self._children_name_map["ha_statistics"] = "ha-statistics"
                            return self.ha_statistics

                        if (child_yang_name == "ha-summary"):
                            if (self.ha_summary is None):
                                self.ha_summary = MplsLdp.Global_.Active.DefaultVrf.Issu.HaSummary()
                                self.ha_summary.parent = self
                                self._children_name_map["ha_summary"] = "ha-summary"
                            return self.ha_summary

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ha-statistics" or name == "ha-summary"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborCapabilities(Entity):
                    """
                    LDP Neighbors Capabilities
                    
                    .. attribute:: neighbor_capability
                    
                    	Information on capabilities of a particular LDP neighbor
                    	**type**\: list of    :py:class:`NeighborCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities, self).__init__()

                        self.yang_name = "neighbor-capabilities"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities, self).__setattr__(name, value)


                    class NeighborCapability(Entity):
                        """
                        Information on capabilities of a particular LDP
                        neighbor
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: received
                        
                        	List of received capabilities
                        	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Received>`
                        
                        .. attribute:: sent
                        
                        	List of sent capabilities
                        	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__init__()

                            self.yang_name = "neighbor-capability"
                            self.yang_parent_name = "neighbor-capabilities"

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.received = YList(self)
                            self.sent = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)


                        class Sent(Entity):
                            """
                            List of sent capabilities
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__init__()

                                self.yang_name = "sent"
                                self.yang_parent_name = "neighbor-capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sent" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbor-capabilities/neighbor-capability/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix


                        class Received(Entity):
                            """
                            List of received capabilities
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__init__()

                                self.yang_name = "received"
                                self.yang_parent_name = "neighbor-capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "received" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbor-capabilities/neighbor-capability/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.received:
                                if (c.has_data()):
                                    return True
                            for c in self.sent:
                                if (c.has_data()):
                                    return True
                            return (
                                self.label_space_id.is_set or
                                self.lsr_id.is_set)

                        def has_operation(self):
                            for c in self.received:
                                if (c.has_operation()):
                                    return True
                            for c in self.sent:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbor-capabilities/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "received"):
                                for c in self.received:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Received()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.received.append(c)
                                return c

                            if (child_yang_name == "sent"):
                                for c in self.sent:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.sent.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "received" or name == "sent" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor-capability"):
                            for c in self.neighbor_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities.NeighborCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Neighbors(Entity):
                    """
                    The LDP Neighbors
                    
                    .. attribute:: neighbor
                    
                    	Information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors, self).__init__()

                        self.yang_name = "neighbors"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors, self).__setattr__(name, value)


                    class Neighbor(Entity):
                        """
                        Information on a particular LDP neighbor
                        
                        .. attribute:: detailed_information
                        
                        	Detailed information with regards to holdtime, KA, inbound filtering, and Session protection
                        	**type**\:   :py:class:`DetailedInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation>`
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: ldp_nbr_bound_ipv4_address_info
                        
                        	Neighbor IPv4 Address Info
                        	**type**\: list of    :py:class:`LdpNbrBoundIpv4AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo>`
                        
                        .. attribute:: ldp_nbr_bound_ipv6_address_info
                        
                        	Neighbor IPv6 Address Info
                        	**type**\: list of    :py:class:`LdpNbrBoundIpv6AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo>`
                        
                        .. attribute:: ldp_nbr_ipv4_adj_info
                        
                        	Neighbor's IPv4 Adjacency Information
                        	**type**\: list of    :py:class:`LdpNbrIpv4AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo>`
                        
                        .. attribute:: ldp_nbr_ipv6_adj_info
                        
                        	Neighbor's IPv6 Adjacency Information
                        	**type**\: list of    :py:class:`LdpNbrIpv6AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo>`
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: protocol_information
                        
                        	Protocol Information
                        	**type**\:   :py:class:`ProtocolInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation>`
                        
                        .. attribute:: tcp_information
                        
                        	TCP Information
                        	**type**\:   :py:class:`TcpInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor, self).__init__()

                            self.yang_name = "neighbor"
                            self.yang_parent_name = "neighbors"

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.detailed_information = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation()
                            self.detailed_information.parent = self
                            self._children_name_map["detailed_information"] = "detailed-information"
                            self._children_yang_names.add("detailed-information")

                            self.protocol_information = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation()
                            self.protocol_information.parent = self
                            self._children_name_map["protocol_information"] = "protocol-information"
                            self._children_yang_names.add("protocol-information")

                            self.tcp_information = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation()
                            self.tcp_information.parent = self
                            self._children_name_map["tcp_information"] = "tcp-information"
                            self._children_yang_names.add("tcp-information")

                            self.ldp_nbr_bound_ipv4_address_info = YList(self)
                            self.ldp_nbr_bound_ipv6_address_info = YList(self)
                            self.ldp_nbr_ipv4_adj_info = YList(self)
                            self.ldp_nbr_ipv6_adj_info = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor, self).__setattr__(name, value)


                        class ProtocolInformation(Entity):
                            """
                            Protocol Information
                            
                            .. attribute:: downstream_on_demand
                            
                            	Is Label advertisment mode in Downstream On Demand mode or Not
                            	**type**\:  bool
                            
                            .. attribute:: ta_graceful_restart_adjacency
                            
                            	Graceful restart information
                            	**type**\:   :py:class:`TaGracefulRestartAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency>`
                            
                            .. attribute:: ta_holdtime
                            
                            	Session holdtime in sec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_pies_rcvd
                            
                            	Number of pies received
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_pies_sent
                            
                            	Number of pies sent
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_state
                            
                            	State
                            	**type**\:  str
                            
                            .. attribute:: ta_up_time_seconds
                            
                            	Up time in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__init__()

                                self.yang_name = "protocol-information"
                                self.yang_parent_name = "neighbor"

                                self.downstream_on_demand = YLeaf(YType.boolean, "downstream-on-demand")

                                self.ta_holdtime = YLeaf(YType.uint32, "ta-holdtime")

                                self.ta_pies_rcvd = YLeaf(YType.uint32, "ta-pies-rcvd")

                                self.ta_pies_sent = YLeaf(YType.uint32, "ta-pies-sent")

                                self.ta_state = YLeaf(YType.str, "ta-state")

                                self.ta_up_time_seconds = YLeaf(YType.uint32, "ta-up-time-seconds")

                                self.ta_graceful_restart_adjacency = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                self.ta_graceful_restart_adjacency.parent = self
                                self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                self._children_yang_names.add("ta-graceful-restart-adjacency")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("downstream_on_demand",
                                                "ta_holdtime",
                                                "ta_pies_rcvd",
                                                "ta_pies_sent",
                                                "ta_state",
                                                "ta_up_time_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)


                            class TaGracefulRestartAdjacency(Entity):
                                """
                                Graceful restart information
                                
                                .. attribute:: is_graceful_restartable
                                
                                	Is graceful restartable
                                	**type**\:  bool
                                
                                .. attribute:: reconnect_timeout
                                
                                	Reconnect timeout
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: recovery_time
                                
                                	Recovery time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__init__()

                                    self.yang_name = "ta-graceful-restart-adjacency"
                                    self.yang_parent_name = "protocol-information"

                                    self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                    self.reconnect_timeout = YLeaf(YType.uint32, "reconnect-timeout")

                                    self.recovery_time = YLeaf(YType.uint32, "recovery-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_graceful_restartable",
                                                    "reconnect_timeout",
                                                    "recovery_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_graceful_restartable.is_set or
                                        self.reconnect_timeout.is_set or
                                        self.recovery_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_graceful_restartable.yfilter != YFilter.not_set or
                                        self.reconnect_timeout.yfilter != YFilter.not_set or
                                        self.recovery_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ta-graceful-restart-adjacency" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/protocol-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                    if (self.reconnect_timeout.is_set or self.reconnect_timeout.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reconnect_timeout.get_name_leafdata())
                                    if (self.recovery_time.is_set or self.recovery_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.recovery_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-graceful-restartable" or name == "reconnect-timeout" or name == "recovery-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-graceful-restartable"):
                                        self.is_graceful_restartable = value
                                        self.is_graceful_restartable.value_namespace = name_space
                                        self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reconnect-timeout"):
                                        self.reconnect_timeout = value
                                        self.reconnect_timeout.value_namespace = name_space
                                        self.reconnect_timeout.value_namespace_prefix = name_space_prefix
                                    if(value_path == "recovery-time"):
                                        self.recovery_time = value
                                        self.recovery_time.value_namespace = name_space
                                        self.recovery_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.downstream_on_demand.is_set or
                                    self.ta_holdtime.is_set or
                                    self.ta_pies_rcvd.is_set or
                                    self.ta_pies_sent.is_set or
                                    self.ta_state.is_set or
                                    self.ta_up_time_seconds.is_set or
                                    (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.downstream_on_demand.yfilter != YFilter.not_set or
                                    self.ta_holdtime.yfilter != YFilter.not_set or
                                    self.ta_pies_rcvd.yfilter != YFilter.not_set or
                                    self.ta_pies_sent.yfilter != YFilter.not_set or
                                    self.ta_state.yfilter != YFilter.not_set or
                                    self.ta_up_time_seconds.yfilter != YFilter.not_set or
                                    (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.downstream_on_demand.is_set or self.downstream_on_demand.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.downstream_on_demand.get_name_leafdata())
                                if (self.ta_holdtime.is_set or self.ta_holdtime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_holdtime.get_name_leafdata())
                                if (self.ta_pies_rcvd.is_set or self.ta_pies_rcvd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_pies_rcvd.get_name_leafdata())
                                if (self.ta_pies_sent.is_set or self.ta_pies_sent.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_pies_sent.get_name_leafdata())
                                if (self.ta_state.is_set or self.ta_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_state.get_name_leafdata())
                                if (self.ta_up_time_seconds.is_set or self.ta_up_time_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_up_time_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ta-graceful-restart-adjacency"):
                                    if (self.ta_graceful_restart_adjacency is None):
                                        self.ta_graceful_restart_adjacency = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                        self.ta_graceful_restart_adjacency.parent = self
                                        self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                    return self.ta_graceful_restart_adjacency

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ta-graceful-restart-adjacency" or name == "downstream-on-demand" or name == "ta-holdtime" or name == "ta-pies-rcvd" or name == "ta-pies-sent" or name == "ta-state" or name == "ta-up-time-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "downstream-on-demand"):
                                    self.downstream_on_demand = value
                                    self.downstream_on_demand.value_namespace = name_space
                                    self.downstream_on_demand.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-holdtime"):
                                    self.ta_holdtime = value
                                    self.ta_holdtime.value_namespace = name_space
                                    self.ta_holdtime.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-pies-rcvd"):
                                    self.ta_pies_rcvd = value
                                    self.ta_pies_rcvd.value_namespace = name_space
                                    self.ta_pies_rcvd.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-pies-sent"):
                                    self.ta_pies_sent = value
                                    self.ta_pies_sent.value_namespace = name_space
                                    self.ta_pies_sent.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-state"):
                                    self.ta_state = value
                                    self.ta_state.value_namespace = name_space
                                    self.ta_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-up-time-seconds"):
                                    self.ta_up_time_seconds = value
                                    self.ta_up_time_seconds.value_namespace = name_space
                                    self.ta_up_time_seconds.value_namespace_prefix = name_space_prefix


                        class TcpInformation(Entity):
                            """
                            TCP Information
                            
                            .. attribute:: foreign_host
                            
                            	Foreign host address
                            	**type**\:   :py:class:`ForeignHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost>`
                            
                            .. attribute:: foreign_port
                            
                            	Foreign port number
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: is_md5_on
                            
                            	Is MD5 Digest on
                            	**type**\:  bool
                            
                            .. attribute:: local_host
                            
                            	Local host address
                            	**type**\:   :py:class:`LocalHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost>`
                            
                            .. attribute:: local_port
                            
                            	Local port number
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__init__()

                                self.yang_name = "tcp-information"
                                self.yang_parent_name = "neighbor"

                                self.foreign_port = YLeaf(YType.uint16, "foreign-port")

                                self.is_md5_on = YLeaf(YType.boolean, "is-md5-on")

                                self.local_port = YLeaf(YType.uint16, "local-port")

                                self.foreign_host = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                self.foreign_host.parent = self
                                self._children_name_map["foreign_host"] = "foreign-host"
                                self._children_yang_names.add("foreign-host")

                                self.local_host = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                self.local_host.parent = self
                                self._children_name_map["local_host"] = "local-host"
                                self._children_yang_names.add("local-host")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("foreign_port",
                                                "is_md5_on",
                                                "local_port") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)


                            class ForeignHost(Entity):
                                """
                                Foreign host address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__init__()

                                    self.yang_name = "foreign-host"
                                    self.yang_parent_name = "tcp-information"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "foreign-host" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/tcp-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix


                            class LocalHost(Entity):
                                """
                                Local host address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__init__()

                                    self.yang_name = "local-host"
                                    self.yang_parent_name = "tcp-information"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "local-host" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/tcp-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.foreign_port.is_set or
                                    self.is_md5_on.is_set or
                                    self.local_port.is_set or
                                    (self.foreign_host is not None and self.foreign_host.has_data()) or
                                    (self.local_host is not None and self.local_host.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.foreign_port.yfilter != YFilter.not_set or
                                    self.is_md5_on.yfilter != YFilter.not_set or
                                    self.local_port.yfilter != YFilter.not_set or
                                    (self.foreign_host is not None and self.foreign_host.has_operation()) or
                                    (self.local_host is not None and self.local_host.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tcp-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.foreign_port.is_set or self.foreign_port.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.foreign_port.get_name_leafdata())
                                if (self.is_md5_on.is_set or self.is_md5_on.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_md5_on.get_name_leafdata())
                                if (self.local_port.is_set or self.local_port.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_port.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "foreign-host"):
                                    if (self.foreign_host is None):
                                        self.foreign_host = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                        self.foreign_host.parent = self
                                        self._children_name_map["foreign_host"] = "foreign-host"
                                    return self.foreign_host

                                if (child_yang_name == "local-host"):
                                    if (self.local_host is None):
                                        self.local_host = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                        self.local_host.parent = self
                                        self._children_name_map["local_host"] = "local-host"
                                    return self.local_host

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "foreign-host" or name == "local-host" or name == "foreign-port" or name == "is-md5-on" or name == "local-port"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "foreign-port"):
                                    self.foreign_port = value
                                    self.foreign_port.value_namespace = name_space
                                    self.foreign_port.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-md5-on"):
                                    self.is_md5_on = value
                                    self.is_md5_on.value_namespace = name_space
                                    self.is_md5_on.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-port"):
                                    self.local_port = value
                                    self.local_port.value_namespace = name_space
                                    self.local_port.value_namespace_prefix = name_space_prefix


                        class DetailedInformation(Entity):
                            """
                            Detailed information with regards to holdtime,
                            KA, inbound filtering, and Session protection
                            
                            .. attribute:: advertise_bgp_prefixes
                            
                            	Is BGP labelled prefixes advertised to the neighbor
                            	**type**\:  bool
                            
                            .. attribute:: bgp_advertisement_state
                            
                            	BGP labelled prefixes advertisement state
                            	**type**\:   :py:class:`MgmtLdpNbrBgpAdvtState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNbrBgpAdvtState>`
                            
                            .. attribute:: capabilities
                            
                            	Capabilities sent to and received from neighbor
                            	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities>`
                            
                            .. attribute:: client
                            
                            	Targeted Session clients
                            	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client>`
                            
                            .. attribute:: has_ipv4_inbound
                            
                            	IPv4 Inbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv4_outbound
                            
                            	IPv4 Outbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv6_inbound
                            
                            	IPv6 Inbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv6_outbound
                            
                            	IPv6 Outbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_sp
                            
                            	Session Protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: inbound_ipv4acl
                            
                            	IPv4 Inbound accept ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: inbound_ipv6acl
                            
                            	IPv6 Inbound accept ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: ipv4_duplicate_address
                            
                            	Duplicate IPv4 address bound to this peer
                            	**type**\: list of    :py:class:`Ipv4DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress>`
                            
                            .. attribute:: ipv6_duplicate_address
                            
                            	Duplicate IPv6 address bound to this peer
                            	**type**\: list of    :py:class:`Ipv6DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress>`
                            
                            .. attribute:: keep_alive_interval
                            
                            	Session keepalive interval in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: nsr_last_sync_error
                            
                            	Last NSR sync error
                            	**type**\:   :py:class:`MgmtLdpNsrPeerSyncErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncErr>`
                            
                            .. attribute:: nsr_last_sync_nack_reason
                            
                            	Last NSR sync NACK reaston
                            	**type**\:   :py:class:`MgmtLdpNsrPeerLdpSyncNackRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerLdpSyncNackRsn>`
                            
                            .. attribute:: nsr_sync_state
                            
                            	NSR Sync State
                            	**type**\:   :py:class:`MgmtLdpNsrPeerSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncState>`
                            
                            .. attribute:: outbound_ipv4acl
                            
                            	IPv4 Outbound advertise ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: outbound_ipv6acl
                            
                            	IPv6 Outbound advertise ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: peer_holdtime
                            
                            	Session holdtime value in seconds from the peer
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: peer_state
                            
                            	Peer state
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: sp_duration
                            
                            	Session protection holdup time duration in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: sp_has_acl
                            
                            	Session protection ACL is present
                            	**type**\:  bool
                            
                            .. attribute:: sp_has_duration
                            
                            	Session Protection has non\-default duration
                            	**type**\:  bool
                            
                            .. attribute:: sp_state
                            
                            	Session Protection state
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: spacl
                            
                            	Session Protection ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: spht_remaining
                            
                            	Session Protection holdup time remaining value in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: spht_running
                            
                            	Session Protection holdup timer is running
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__init__()

                                self.yang_name = "detailed-information"
                                self.yang_parent_name = "neighbor"

                                self.advertise_bgp_prefixes = YLeaf(YType.boolean, "advertise-bgp-prefixes")

                                self.bgp_advertisement_state = YLeaf(YType.enumeration, "bgp-advertisement-state")

                                self.has_ipv4_inbound = YLeaf(YType.boolean, "has-ipv4-inbound")

                                self.has_ipv4_outbound = YLeaf(YType.boolean, "has-ipv4-outbound")

                                self.has_ipv6_inbound = YLeaf(YType.boolean, "has-ipv6-inbound")

                                self.has_ipv6_outbound = YLeaf(YType.boolean, "has-ipv6-outbound")

                                self.has_sp = YLeaf(YType.boolean, "has-sp")

                                self.inbound_ipv4acl = YLeaf(YType.str, "inbound-ipv4acl")

                                self.inbound_ipv6acl = YLeaf(YType.str, "inbound-ipv6acl")

                                self.keep_alive_interval = YLeaf(YType.uint32, "keep-alive-interval")

                                self.nsr_last_sync_error = YLeaf(YType.enumeration, "nsr-last-sync-error")

                                self.nsr_last_sync_nack_reason = YLeaf(YType.enumeration, "nsr-last-sync-nack-reason")

                                self.nsr_sync_state = YLeaf(YType.enumeration, "nsr-sync-state")

                                self.outbound_ipv4acl = YLeaf(YType.str, "outbound-ipv4acl")

                                self.outbound_ipv6acl = YLeaf(YType.str, "outbound-ipv6acl")

                                self.peer_holdtime = YLeaf(YType.uint32, "peer-holdtime")

                                self.peer_state = YLeaf(YType.str, "peer-state")

                                self.sp_duration = YLeaf(YType.uint32, "sp-duration")

                                self.sp_has_acl = YLeaf(YType.boolean, "sp-has-acl")

                                self.sp_has_duration = YLeaf(YType.boolean, "sp-has-duration")

                                self.sp_state = YLeaf(YType.str, "sp-state")

                                self.spacl = YLeaf(YType.str, "spacl")

                                self.spht_remaining = YLeaf(YType.uint32, "spht-remaining")

                                self.spht_running = YLeaf(YType.boolean, "spht-running")

                                self.capabilities = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                self.capabilities.parent = self
                                self._children_name_map["capabilities"] = "capabilities"
                                self._children_yang_names.add("capabilities")

                                self.client = YList(self)
                                self.ipv4_duplicate_address = YList(self)
                                self.ipv6_duplicate_address = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("advertise_bgp_prefixes",
                                                "bgp_advertisement_state",
                                                "has_ipv4_inbound",
                                                "has_ipv4_outbound",
                                                "has_ipv6_inbound",
                                                "has_ipv6_outbound",
                                                "has_sp",
                                                "inbound_ipv4acl",
                                                "inbound_ipv6acl",
                                                "keep_alive_interval",
                                                "nsr_last_sync_error",
                                                "nsr_last_sync_nack_reason",
                                                "nsr_sync_state",
                                                "outbound_ipv4acl",
                                                "outbound_ipv6acl",
                                                "peer_holdtime",
                                                "peer_state",
                                                "sp_duration",
                                                "sp_has_acl",
                                                "sp_has_duration",
                                                "sp_state",
                                                "spacl",
                                                "spht_remaining",
                                                "spht_running") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)


                            class Capabilities(Entity):
                                """
                                Capabilities sent to and received from neighbor
                                
                                .. attribute:: received
                                
                                	List of received capabilities
                                	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received>`
                                
                                .. attribute:: sent
                                
                                	List of sent capabilities
                                	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__init__()

                                    self.yang_name = "capabilities"
                                    self.yang_parent_name = "detailed-information"

                                    self.received = YList(self)
                                    self.sent = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)


                                class Sent(Entity):
                                    """
                                    List of sent capabilities
                                    
                                    .. attribute:: capability_data
                                    
                                    	Capability data
                                    	**type**\:  str
                                    
                                    .. attribute:: capability_data_length
                                    
                                    	Capability data length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: description
                                    
                                    	Capability description
                                    	**type**\:  str
                                    
                                    	**length:** 0..80
                                    
                                    .. attribute:: type
                                    
                                    	Capability type (IANA assigned)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__init__()

                                        self.yang_name = "sent"
                                        self.yang_parent_name = "capabilities"

                                        self.capability_data = YLeaf(YType.str, "capability-data")

                                        self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                        self.description = YLeaf(YType.str, "description")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("capability_data",
                                                        "capability_data_length",
                                                        "description",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.capability_data.is_set or
                                            self.capability_data_length.is_set or
                                            self.description.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.capability_data.yfilter != YFilter.not_set or
                                            self.capability_data_length.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sent" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/capabilities/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data.get_name_leafdata())
                                        if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "capability-data"):
                                            self.capability_data = value
                                            self.capability_data.value_namespace = name_space
                                            self.capability_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "capability-data-length"):
                                            self.capability_data_length = value
                                            self.capability_data_length.value_namespace = name_space
                                            self.capability_data_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class Received(Entity):
                                    """
                                    List of received capabilities
                                    
                                    .. attribute:: capability_data
                                    
                                    	Capability data
                                    	**type**\:  str
                                    
                                    .. attribute:: capability_data_length
                                    
                                    	Capability data length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: description
                                    
                                    	Capability description
                                    	**type**\:  str
                                    
                                    	**length:** 0..80
                                    
                                    .. attribute:: type
                                    
                                    	Capability type (IANA assigned)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__init__()

                                        self.yang_name = "received"
                                        self.yang_parent_name = "capabilities"

                                        self.capability_data = YLeaf(YType.str, "capability-data")

                                        self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                        self.description = YLeaf(YType.str, "description")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("capability_data",
                                                        "capability_data_length",
                                                        "description",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.capability_data.is_set or
                                            self.capability_data_length.is_set or
                                            self.description.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.capability_data.yfilter != YFilter.not_set or
                                            self.capability_data_length.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "received" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/capabilities/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data.get_name_leafdata())
                                        if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "capability-data"):
                                            self.capability_data = value
                                            self.capability_data.value_namespace = name_space
                                            self.capability_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "capability-data-length"):
                                            self.capability_data_length = value
                                            self.capability_data_length.value_namespace = name_space
                                            self.capability_data_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.received:
                                        if (c.has_data()):
                                            return True
                                    for c in self.sent:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.received:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.sent:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "capabilities" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "received"):
                                        for c in self.received:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.received.append(c)
                                        return c

                                    if (child_yang_name == "sent"):
                                        for c in self.sent:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sent.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "received" or name == "sent"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Client(Entity):
                                """
                                Targeted Session clients
                                
                                .. attribute:: name
                                
                                	Client's name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__init__()

                                    self.yang_name = "client"
                                    self.yang_parent_name = "detailed-information"

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "client" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Ipv4DuplicateAddress(Entity):
                                """
                                Duplicate IPv4 address bound to this peer
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress, self).__init__()

                                    self.yang_name = "ipv4-duplicate-address"
                                    self.yang_parent_name = "detailed-information"

                                    self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ipv4-duplicate-address"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/ipv4-duplicate-address/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-duplicate-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Ipv6DuplicateAddress(Entity):
                                """
                                Duplicate IPv6 address bound to this peer
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress, self).__init__()

                                    self.yang_name = "ipv6-duplicate-address"
                                    self.yang_parent_name = "detailed-information"

                                    self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ipv6-duplicate-address"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/ipv6-duplicate-address/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-duplicate-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/detailed-information/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                for c in self.client:
                                    if (c.has_data()):
                                        return True
                                for c in self.ipv4_duplicate_address:
                                    if (c.has_data()):
                                        return True
                                for c in self.ipv6_duplicate_address:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.advertise_bgp_prefixes.is_set or
                                    self.bgp_advertisement_state.is_set or
                                    self.has_ipv4_inbound.is_set or
                                    self.has_ipv4_outbound.is_set or
                                    self.has_ipv6_inbound.is_set or
                                    self.has_ipv6_outbound.is_set or
                                    self.has_sp.is_set or
                                    self.inbound_ipv4acl.is_set or
                                    self.inbound_ipv6acl.is_set or
                                    self.keep_alive_interval.is_set or
                                    self.nsr_last_sync_error.is_set or
                                    self.nsr_last_sync_nack_reason.is_set or
                                    self.nsr_sync_state.is_set or
                                    self.outbound_ipv4acl.is_set or
                                    self.outbound_ipv6acl.is_set or
                                    self.peer_holdtime.is_set or
                                    self.peer_state.is_set or
                                    self.sp_duration.is_set or
                                    self.sp_has_acl.is_set or
                                    self.sp_has_duration.is_set or
                                    self.sp_state.is_set or
                                    self.spacl.is_set or
                                    self.spht_remaining.is_set or
                                    self.spht_running.is_set or
                                    (self.capabilities is not None and self.capabilities.has_data()))

                            def has_operation(self):
                                for c in self.client:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ipv4_duplicate_address:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ipv6_duplicate_address:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.advertise_bgp_prefixes.yfilter != YFilter.not_set or
                                    self.bgp_advertisement_state.yfilter != YFilter.not_set or
                                    self.has_ipv4_inbound.yfilter != YFilter.not_set or
                                    self.has_ipv4_outbound.yfilter != YFilter.not_set or
                                    self.has_ipv6_inbound.yfilter != YFilter.not_set or
                                    self.has_ipv6_outbound.yfilter != YFilter.not_set or
                                    self.has_sp.yfilter != YFilter.not_set or
                                    self.inbound_ipv4acl.yfilter != YFilter.not_set or
                                    self.inbound_ipv6acl.yfilter != YFilter.not_set or
                                    self.keep_alive_interval.yfilter != YFilter.not_set or
                                    self.nsr_last_sync_error.yfilter != YFilter.not_set or
                                    self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set or
                                    self.nsr_sync_state.yfilter != YFilter.not_set or
                                    self.outbound_ipv4acl.yfilter != YFilter.not_set or
                                    self.outbound_ipv6acl.yfilter != YFilter.not_set or
                                    self.peer_holdtime.yfilter != YFilter.not_set or
                                    self.peer_state.yfilter != YFilter.not_set or
                                    self.sp_duration.yfilter != YFilter.not_set or
                                    self.sp_has_acl.yfilter != YFilter.not_set or
                                    self.sp_has_duration.yfilter != YFilter.not_set or
                                    self.sp_state.yfilter != YFilter.not_set or
                                    self.spacl.yfilter != YFilter.not_set or
                                    self.spht_remaining.yfilter != YFilter.not_set or
                                    self.spht_running.yfilter != YFilter.not_set or
                                    (self.capabilities is not None and self.capabilities.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "detailed-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.advertise_bgp_prefixes.is_set or self.advertise_bgp_prefixes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.advertise_bgp_prefixes.get_name_leafdata())
                                if (self.bgp_advertisement_state.is_set or self.bgp_advertisement_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bgp_advertisement_state.get_name_leafdata())
                                if (self.has_ipv4_inbound.is_set or self.has_ipv4_inbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv4_inbound.get_name_leafdata())
                                if (self.has_ipv4_outbound.is_set or self.has_ipv4_outbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv4_outbound.get_name_leafdata())
                                if (self.has_ipv6_inbound.is_set or self.has_ipv6_inbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv6_inbound.get_name_leafdata())
                                if (self.has_ipv6_outbound.is_set or self.has_ipv6_outbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv6_outbound.get_name_leafdata())
                                if (self.has_sp.is_set or self.has_sp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_sp.get_name_leafdata())
                                if (self.inbound_ipv4acl.is_set or self.inbound_ipv4acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inbound_ipv4acl.get_name_leafdata())
                                if (self.inbound_ipv6acl.is_set or self.inbound_ipv6acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inbound_ipv6acl.get_name_leafdata())
                                if (self.keep_alive_interval.is_set or self.keep_alive_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_interval.get_name_leafdata())
                                if (self.nsr_last_sync_error.is_set or self.nsr_last_sync_error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_last_sync_error.get_name_leafdata())
                                if (self.nsr_last_sync_nack_reason.is_set or self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_last_sync_nack_reason.get_name_leafdata())
                                if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                if (self.outbound_ipv4acl.is_set or self.outbound_ipv4acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outbound_ipv4acl.get_name_leafdata())
                                if (self.outbound_ipv6acl.is_set or self.outbound_ipv6acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outbound_ipv6acl.get_name_leafdata())
                                if (self.peer_holdtime.is_set or self.peer_holdtime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_holdtime.get_name_leafdata())
                                if (self.peer_state.is_set or self.peer_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_state.get_name_leafdata())
                                if (self.sp_duration.is_set or self.sp_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_duration.get_name_leafdata())
                                if (self.sp_has_acl.is_set or self.sp_has_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_has_acl.get_name_leafdata())
                                if (self.sp_has_duration.is_set or self.sp_has_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_has_duration.get_name_leafdata())
                                if (self.sp_state.is_set or self.sp_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_state.get_name_leafdata())
                                if (self.spacl.is_set or self.spacl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spacl.get_name_leafdata())
                                if (self.spht_remaining.is_set or self.spht_remaining.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spht_remaining.get_name_leafdata())
                                if (self.spht_running.is_set or self.spht_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spht_running.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "capabilities"):
                                    if (self.capabilities is None):
                                        self.capabilities = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                        self.capabilities.parent = self
                                        self._children_name_map["capabilities"] = "capabilities"
                                    return self.capabilities

                                if (child_yang_name == "client"):
                                    for c in self.client:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.client.append(c)
                                    return c

                                if (child_yang_name == "ipv4-duplicate-address"):
                                    for c in self.ipv4_duplicate_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipv4_duplicate_address.append(c)
                                    return c

                                if (child_yang_name == "ipv6-duplicate-address"):
                                    for c in self.ipv6_duplicate_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipv6_duplicate_address.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capabilities" or name == "client" or name == "ipv4-duplicate-address" or name == "ipv6-duplicate-address" or name == "advertise-bgp-prefixes" or name == "bgp-advertisement-state" or name == "has-ipv4-inbound" or name == "has-ipv4-outbound" or name == "has-ipv6-inbound" or name == "has-ipv6-outbound" or name == "has-sp" or name == "inbound-ipv4acl" or name == "inbound-ipv6acl" or name == "keep-alive-interval" or name == "nsr-last-sync-error" or name == "nsr-last-sync-nack-reason" or name == "nsr-sync-state" or name == "outbound-ipv4acl" or name == "outbound-ipv6acl" or name == "peer-holdtime" or name == "peer-state" or name == "sp-duration" or name == "sp-has-acl" or name == "sp-has-duration" or name == "sp-state" or name == "spacl" or name == "spht-remaining" or name == "spht-running"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "advertise-bgp-prefixes"):
                                    self.advertise_bgp_prefixes = value
                                    self.advertise_bgp_prefixes.value_namespace = name_space
                                    self.advertise_bgp_prefixes.value_namespace_prefix = name_space_prefix
                                if(value_path == "bgp-advertisement-state"):
                                    self.bgp_advertisement_state = value
                                    self.bgp_advertisement_state.value_namespace = name_space
                                    self.bgp_advertisement_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv4-inbound"):
                                    self.has_ipv4_inbound = value
                                    self.has_ipv4_inbound.value_namespace = name_space
                                    self.has_ipv4_inbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv4-outbound"):
                                    self.has_ipv4_outbound = value
                                    self.has_ipv4_outbound.value_namespace = name_space
                                    self.has_ipv4_outbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv6-inbound"):
                                    self.has_ipv6_inbound = value
                                    self.has_ipv6_inbound.value_namespace = name_space
                                    self.has_ipv6_inbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv6-outbound"):
                                    self.has_ipv6_outbound = value
                                    self.has_ipv6_outbound.value_namespace = name_space
                                    self.has_ipv6_outbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-sp"):
                                    self.has_sp = value
                                    self.has_sp.value_namespace = name_space
                                    self.has_sp.value_namespace_prefix = name_space_prefix
                                if(value_path == "inbound-ipv4acl"):
                                    self.inbound_ipv4acl = value
                                    self.inbound_ipv4acl.value_namespace = name_space
                                    self.inbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "inbound-ipv6acl"):
                                    self.inbound_ipv6acl = value
                                    self.inbound_ipv6acl.value_namespace = name_space
                                    self.inbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-interval"):
                                    self.keep_alive_interval = value
                                    self.keep_alive_interval.value_namespace = name_space
                                    self.keep_alive_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-last-sync-error"):
                                    self.nsr_last_sync_error = value
                                    self.nsr_last_sync_error.value_namespace = name_space
                                    self.nsr_last_sync_error.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-last-sync-nack-reason"):
                                    self.nsr_last_sync_nack_reason = value
                                    self.nsr_last_sync_nack_reason.value_namespace = name_space
                                    self.nsr_last_sync_nack_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sync-state"):
                                    self.nsr_sync_state = value
                                    self.nsr_sync_state.value_namespace = name_space
                                    self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "outbound-ipv4acl"):
                                    self.outbound_ipv4acl = value
                                    self.outbound_ipv4acl.value_namespace = name_space
                                    self.outbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "outbound-ipv6acl"):
                                    self.outbound_ipv6acl = value
                                    self.outbound_ipv6acl.value_namespace = name_space
                                    self.outbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-holdtime"):
                                    self.peer_holdtime = value
                                    self.peer_holdtime.value_namespace = name_space
                                    self.peer_holdtime.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-state"):
                                    self.peer_state = value
                                    self.peer_state.value_namespace = name_space
                                    self.peer_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-duration"):
                                    self.sp_duration = value
                                    self.sp_duration.value_namespace = name_space
                                    self.sp_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-has-acl"):
                                    self.sp_has_acl = value
                                    self.sp_has_acl.value_namespace = name_space
                                    self.sp_has_acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-has-duration"):
                                    self.sp_has_duration = value
                                    self.sp_has_duration.value_namespace = name_space
                                    self.sp_has_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-state"):
                                    self.sp_state = value
                                    self.sp_state.value_namespace = name_space
                                    self.sp_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "spacl"):
                                    self.spacl = value
                                    self.spacl.value_namespace = name_space
                                    self.spacl.value_namespace_prefix = name_space_prefix
                                if(value_path == "spht-remaining"):
                                    self.spht_remaining = value
                                    self.spht_remaining.value_namespace = name_space
                                    self.spht_remaining.value_namespace_prefix = name_space_prefix
                                if(value_path == "spht-running"):
                                    self.spht_running = value
                                    self.spht_running.value_namespace = name_space
                                    self.spht_running.value_namespace_prefix = name_space_prefix


                        class LdpNbrBoundIpv4AddressInfo(Entity):
                            """
                            Neighbor IPv4 Address Info
                            
                            .. attribute:: address
                            
                            	Neighbor Address
                            	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo, self).__init__()

                                self.yang_name = "ldp-nbr-bound-ipv4-address-info"
                                self.yang_parent_name = "neighbor"

                                self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                self.address.parent = self
                                self._children_name_map["address"] = "address"
                                self._children_yang_names.add("address")


                            class Address(Entity):
                                """
                                Neighbor Address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__init__()

                                    self.yang_name = "address"
                                    self.yang_parent_name = "ldp-nbr-bound-ipv4-address-info"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-bound-ipv4-address-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.address is not None and self.address.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.address is not None and self.address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-bound-ipv4-address-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "address"):
                                    if (self.address is None):
                                        self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                    return self.address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrBoundIpv6AddressInfo(Entity):
                            """
                            Neighbor IPv6 Address Info
                            
                            .. attribute:: address
                            
                            	Neighbor Address
                            	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo, self).__init__()

                                self.yang_name = "ldp-nbr-bound-ipv6-address-info"
                                self.yang_parent_name = "neighbor"

                                self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                self.address.parent = self
                                self._children_name_map["address"] = "address"
                                self._children_yang_names.add("address")


                            class Address(Entity):
                                """
                                Neighbor Address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__init__()

                                    self.yang_name = "address"
                                    self.yang_parent_name = "ldp-nbr-bound-ipv6-address-info"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-bound-ipv6-address-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.address is not None and self.address.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.address is not None and self.address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-bound-ipv6-address-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "address"):
                                    if (self.address is None):
                                        self.address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                    return self.address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrIpv4AdjInfo(Entity):
                            """
                            Neighbor's IPv4 Adjacency Information
                            
                            .. attribute:: adjacency_group
                            
                            	Adjacency group
                            	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo, self).__init__()

                                self.yang_name = "ldp-nbr-ipv4-adj-info"
                                self.yang_parent_name = "neighbor"

                                self.adjacency_group = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                self.adjacency_group.parent = self
                                self._children_name_map["adjacency_group"] = "adjacency-group"
                                self._children_yang_names.add("adjacency-group")


                            class AdjacencyGroup(Entity):
                                """
                                Adjacency group
                                
                                .. attribute:: hello_type
                                
                                	HelloType
                                	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                
                                .. attribute:: link_hello_data
                                
                                	Link hello
                                	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData>`
                                
                                .. attribute:: target_hello_data
                                
                                	Target Hello
                                	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__init__()

                                    self.yang_name = "adjacency-group"
                                    self.yang_parent_name = "ldp-nbr-ipv4-adj-info"

                                    self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                    self.link_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                    self.link_hello_data.parent = self
                                    self._children_name_map["link_hello_data"] = "link-hello-data"
                                    self._children_yang_names.add("link-hello-data")

                                    self.target_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                    self.target_hello_data.parent = self
                                    self._children_name_map["target_hello_data"] = "target-hello-data"
                                    self._children_yang_names.add("target-hello-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("hello_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                class LinkHelloData(Entity):
                                    """
                                    Link hello
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                        self.yang_name = "link-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface",
                                                        "interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface.is_set or
                                            self.interface_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix


                                class TargetHelloData(Entity):
                                    """
                                    Target Hello
                                    
                                    .. attribute:: local_address
                                    
                                    	Local Address
                                    	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	Target Address
                                    	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                        self.yang_name = "target-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.local_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                        self.local_address.parent = self
                                        self._children_name_map["local_address"] = "local-address"
                                        self._children_yang_names.add("local-address")

                                        self.target_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                        self.target_address.parent = self
                                        self._children_name_map["target_address"] = "target-address"
                                        self._children_yang_names.add("target-address")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                    class LocalAddress(Entity):
                                        """
                                        Local Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                            self.yang_name = "local-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class TargetAddress(Entity):
                                        """
                                        Target Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                            self.yang_name = "target-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.state.is_set or
                                            (self.local_address is not None and self.local_address.has_data()) or
                                            (self.target_address is not None and self.target_address.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            (self.local_address is not None and self.local_address.has_operation()) or
                                            (self.target_address is not None and self.target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "target-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "local-address"):
                                            if (self.local_address is None):
                                                self.local_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                self.local_address.parent = self
                                                self._children_name_map["local_address"] = "local-address"
                                            return self.local_address

                                        if (child_yang_name == "target-address"):
                                            if (self.target_address is None):
                                                self.target_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                self.target_address.parent = self
                                                self._children_name_map["target_address"] = "target-address"
                                            return self.target_address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-address" or name == "target-address" or name == "state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.hello_type.is_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.hello_type.yfilter != YFilter.not_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "adjacency-group" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv4-adj-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-data"):
                                        if (self.link_hello_data is None):
                                            self.link_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                            self.link_hello_data.parent = self
                                            self._children_name_map["link_hello_data"] = "link-hello-data"
                                        return self.link_hello_data

                                    if (child_yang_name == "target-hello-data"):
                                        if (self.target_hello_data is None):
                                            self.target_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                            self.target_hello_data.parent = self
                                            self._children_name_map["target_hello_data"] = "target-hello-data"
                                        return self.target_hello_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "hello-type"):
                                        self.hello_type = value
                                        self.hello_type.value_namespace = name_space
                                        self.hello_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.adjacency_group is not None and self.adjacency_group.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-ipv4-adj-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "adjacency-group"):
                                    if (self.adjacency_group is None):
                                        self.adjacency_group = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                        self.adjacency_group.parent = self
                                        self._children_name_map["adjacency_group"] = "adjacency-group"
                                    return self.adjacency_group

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "adjacency-group"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrIpv6AdjInfo(Entity):
                            """
                            Neighbor's IPv6 Adjacency Information
                            
                            .. attribute:: adjacency_group
                            
                            	Adjacency group
                            	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo, self).__init__()

                                self.yang_name = "ldp-nbr-ipv6-adj-info"
                                self.yang_parent_name = "neighbor"

                                self.adjacency_group = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                self.adjacency_group.parent = self
                                self._children_name_map["adjacency_group"] = "adjacency-group"
                                self._children_yang_names.add("adjacency-group")


                            class AdjacencyGroup(Entity):
                                """
                                Adjacency group
                                
                                .. attribute:: hello_type
                                
                                	HelloType
                                	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                
                                .. attribute:: link_hello_data
                                
                                	Link hello
                                	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData>`
                                
                                .. attribute:: target_hello_data
                                
                                	Target Hello
                                	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__init__()

                                    self.yang_name = "adjacency-group"
                                    self.yang_parent_name = "ldp-nbr-ipv6-adj-info"

                                    self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                    self.link_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                    self.link_hello_data.parent = self
                                    self._children_name_map["link_hello_data"] = "link-hello-data"
                                    self._children_yang_names.add("link-hello-data")

                                    self.target_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                    self.target_hello_data.parent = self
                                    self._children_name_map["target_hello_data"] = "target-hello-data"
                                    self._children_yang_names.add("target-hello-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("hello_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                class LinkHelloData(Entity):
                                    """
                                    Link hello
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                        self.yang_name = "link-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface",
                                                        "interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface.is_set or
                                            self.interface_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix


                                class TargetHelloData(Entity):
                                    """
                                    Target Hello
                                    
                                    .. attribute:: local_address
                                    
                                    	Local Address
                                    	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	Target Address
                                    	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                        self.yang_name = "target-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.local_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                        self.local_address.parent = self
                                        self._children_name_map["local_address"] = "local-address"
                                        self._children_yang_names.add("local-address")

                                        self.target_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                        self.target_address.parent = self
                                        self._children_name_map["target_address"] = "target-address"
                                        self._children_yang_names.add("target-address")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                    class LocalAddress(Entity):
                                        """
                                        Local Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                            self.yang_name = "local-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class TargetAddress(Entity):
                                        """
                                        Target Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                            self.yang_name = "target-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/target-hello-data/%s" % self.get_segment_path()
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.state.is_set or
                                            (self.local_address is not None and self.local_address.has_data()) or
                                            (self.target_address is not None and self.target_address.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            (self.local_address is not None and self.local_address.has_operation()) or
                                            (self.target_address is not None and self.target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "target-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/adjacency-group/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "local-address"):
                                            if (self.local_address is None):
                                                self.local_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                self.local_address.parent = self
                                                self._children_name_map["local_address"] = "local-address"
                                            return self.local_address

                                        if (child_yang_name == "target-address"):
                                            if (self.target_address is None):
                                                self.target_address = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                self.target_address.parent = self
                                                self._children_name_map["target_address"] = "target-address"
                                            return self.target_address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-address" or name == "target-address" or name == "state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.hello_type.is_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.hello_type.yfilter != YFilter.not_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "adjacency-group" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/ldp-nbr-ipv6-adj-info/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-data"):
                                        if (self.link_hello_data is None):
                                            self.link_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                            self.link_hello_data.parent = self
                                            self._children_name_map["link_hello_data"] = "link-hello-data"
                                        return self.link_hello_data

                                    if (child_yang_name == "target-hello-data"):
                                        if (self.target_hello_data is None):
                                            self.target_hello_data = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                            self.target_hello_data.parent = self
                                            self._children_name_map["target_hello_data"] = "target-hello-data"
                                        return self.target_hello_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "hello-type"):
                                        self.hello_type = value
                                        self.hello_type.value_namespace = name_space
                                        self.hello_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.adjacency_group is not None and self.adjacency_group.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-ipv6-adj-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/neighbor/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "adjacency-group"):
                                    if (self.adjacency_group is None):
                                        self.adjacency_group = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                        self.adjacency_group.parent = self
                                        self._children_name_map["adjacency_group"] = "adjacency-group"
                                    return self.adjacency_group

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "adjacency-group"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            for c in self.ldp_nbr_bound_ipv4_address_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_bound_ipv6_address_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_ipv4_adj_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_ipv6_adj_info:
                                if (c.has_data()):
                                    return True
                            return (
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                (self.detailed_information is not None and self.detailed_information.has_data()) or
                                (self.protocol_information is not None and self.protocol_information.has_data()) or
                                (self.tcp_information is not None and self.tcp_information.has_data()))

                        def has_operation(self):
                            for c in self.ldp_nbr_bound_ipv4_address_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_bound_ipv6_address_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_ipv4_adj_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_ipv6_adj_info:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                (self.detailed_information is not None and self.detailed_information.has_operation()) or
                                (self.protocol_information is not None and self.protocol_information.has_operation()) or
                                (self.tcp_information is not None and self.tcp_information.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/neighbors/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "detailed-information"):
                                if (self.detailed_information is None):
                                    self.detailed_information = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.DetailedInformation()
                                    self.detailed_information.parent = self
                                    self._children_name_map["detailed_information"] = "detailed-information"
                                return self.detailed_information

                            if (child_yang_name == "ldp-nbr-bound-ipv4-address-info"):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_bound_ipv4_address_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-bound-ipv6-address-info"):
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_bound_ipv6_address_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-ipv4-adj-info"):
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_ipv4_adj_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-ipv6-adj-info"):
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_ipv6_adj_info.append(c)
                                return c

                            if (child_yang_name == "protocol-information"):
                                if (self.protocol_information is None):
                                    self.protocol_information = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.ProtocolInformation()
                                    self.protocol_information.parent = self
                                    self._children_name_map["protocol_information"] = "protocol-information"
                                return self.protocol_information

                            if (child_yang_name == "tcp-information"):
                                if (self.tcp_information is None):
                                    self.tcp_information = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor.TcpInformation()
                                    self.tcp_information.parent = self
                                    self._children_name_map["tcp_information"] = "tcp-information"
                                return self.tcp_information

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "detailed-information" or name == "ldp-nbr-bound-ipv4-address-info" or name == "ldp-nbr-bound-ipv6-address-info" or name == "ldp-nbr-ipv4-adj-info" or name == "ldp-nbr-ipv6-adj-info" or name == "protocol-information" or name == "tcp-information" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbors" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor"):
                            for c in self.neighbor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.Neighbors.Neighbor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class LdpId(Entity):
                    """
                    Local LDP Id
                    
                    .. attribute:: label_space_id
                    
                    	Label space identifier
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: ldp_id
                    
                    	LDP identifier
                    	**type**\:  str
                    
                    .. attribute:: lsr_id
                    
                    	LSR identifier
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.LdpId, self).__init__()

                        self.yang_name = "ldp-id"
                        self.yang_parent_name = "default-vrf"

                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("label_space_id",
                                        "ldp_id",
                                        "lsr_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.LdpId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.LdpId, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.label_space_id.is_set or
                            self.ldp_id.is_set or
                            self.lsr_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.label_space_id.yfilter != YFilter.not_set or
                            self.ldp_id.yfilter != YFilter.not_set or
                            self.lsr_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ldp-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "label-space-id"):
                            self.label_space_id = value
                            self.label_space_id.value_namespace = name_space
                            self.label_space_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-id"):
                            self.ldp_id = value
                            self.ldp_id.value_namespace = name_space
                            self.ldp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsr-id"):
                            self.lsr_id = value
                            self.lsr_id.value_namespace = name_space
                            self.lsr_id.value_namespace_prefix = name_space_prefix


                class Statistics(Entity):
                    """
                    The LDP Statistics
                    
                    .. attribute:: statistic
                    
                    	Statistical Information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`Statistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DefaultVrf.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "default-vrf"

                        self.statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DefaultVrf.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DefaultVrf.Statistics, self).__setattr__(name, value)


                    class Statistic(Entity):
                        """
                        Statistical Information on a particular LDP
                        neighbor
                        
                        .. attribute:: iccp_enabled
                        
                        	Is session ICCP enabled?
                        	**type**\:  bool
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: message_in
                        
                        	Message in count
                        	**type**\:   :py:class:`MessageIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageIn>`
                        
                        .. attribute:: message_out
                        
                        	Message out count
                        	**type**\:   :py:class:`MessageOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageOut>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic, self).__init__()

                            self.yang_name = "statistic"
                            self.yang_parent_name = "statistics"

                            self.iccp_enabled = YLeaf(YType.boolean, "iccp-enabled")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.message_in = MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageIn()
                            self.message_in.parent = self
                            self._children_name_map["message_in"] = "message-in"
                            self._children_yang_names.add("message-in")

                            self.message_out = MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageOut()
                            self.message_out.parent = self
                            self._children_name_map["message_out"] = "message-out"
                            self._children_yang_names.add("message-out")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("iccp_enabled",
                                            "label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic, self).__setattr__(name, value)


                        class MessageOut(Entity):
                            """
                            Message out count
                            
                            .. attribute:: address_count
                            
                            	Address message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: address_withdraw_count
                            
                            	Address withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_app_data_count
                            
                            	ICCP RG App Data count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_conn_count
                            
                            	ICCP RG Connect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_disconn_count
                            
                            	ICCP RG Disconnect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_notif_count
                            
                            	ICCP RG Notif count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: init_count
                            
                            	Init message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: keep_alive_count
                            
                            	Keepalive count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_abort_request_count
                            
                            	Label abort request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_map_count
                            
                            	Label map count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_release_count
                            
                            	Label release count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_request_count
                            
                            	Label request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_withdraw_count
                            
                            	Label withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: notification_count
                            
                            	Notification count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_count
                            
                            	Total message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageOut, self).__init__()

                                self.yang_name = "message-out"
                                self.yang_parent_name = "statistic"

                                self.address_count = YLeaf(YType.uint32, "address-count")

                                self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                self.init_count = YLeaf(YType.uint32, "init-count")

                                self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                self.notification_count = YLeaf(YType.uint32, "notification-count")

                                self.total_count = YLeaf(YType.uint32, "total-count")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_count",
                                                "address_withdraw_count",
                                                "iccp_rg_app_data_count",
                                                "iccp_rg_conn_count",
                                                "iccp_rg_disconn_count",
                                                "iccp_rg_notif_count",
                                                "init_count",
                                                "keep_alive_count",
                                                "label_abort_request_count",
                                                "label_map_count",
                                                "label_release_count",
                                                "label_request_count",
                                                "label_withdraw_count",
                                                "notification_count",
                                                "total_count") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_count.is_set or
                                    self.address_withdraw_count.is_set or
                                    self.iccp_rg_app_data_count.is_set or
                                    self.iccp_rg_conn_count.is_set or
                                    self.iccp_rg_disconn_count.is_set or
                                    self.iccp_rg_notif_count.is_set or
                                    self.init_count.is_set or
                                    self.keep_alive_count.is_set or
                                    self.label_abort_request_count.is_set or
                                    self.label_map_count.is_set or
                                    self.label_release_count.is_set or
                                    self.label_request_count.is_set or
                                    self.label_withdraw_count.is_set or
                                    self.notification_count.is_set or
                                    self.total_count.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_count.yfilter != YFilter.not_set or
                                    self.address_withdraw_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                    self.init_count.yfilter != YFilter.not_set or
                                    self.keep_alive_count.yfilter != YFilter.not_set or
                                    self.label_abort_request_count.yfilter != YFilter.not_set or
                                    self.label_map_count.yfilter != YFilter.not_set or
                                    self.label_release_count.yfilter != YFilter.not_set or
                                    self.label_request_count.yfilter != YFilter.not_set or
                                    self.label_withdraw_count.yfilter != YFilter.not_set or
                                    self.notification_count.yfilter != YFilter.not_set or
                                    self.total_count.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "message-out" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/statistics/statistic/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_count.get_name_leafdata())
                                if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.init_count.get_name_leafdata())
                                if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.notification_count.get_name_leafdata())
                                if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_count.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-count"):
                                    self.address_count = value
                                    self.address_count.value_namespace = name_space
                                    self.address_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "address-withdraw-count"):
                                    self.address_withdraw_count = value
                                    self.address_withdraw_count.value_namespace = name_space
                                    self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-app-data-count"):
                                    self.iccp_rg_app_data_count = value
                                    self.iccp_rg_app_data_count.value_namespace = name_space
                                    self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-conn-count"):
                                    self.iccp_rg_conn_count = value
                                    self.iccp_rg_conn_count.value_namespace = name_space
                                    self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-disconn-count"):
                                    self.iccp_rg_disconn_count = value
                                    self.iccp_rg_disconn_count.value_namespace = name_space
                                    self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-notif-count"):
                                    self.iccp_rg_notif_count = value
                                    self.iccp_rg_notif_count.value_namespace = name_space
                                    self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "init-count"):
                                    self.init_count = value
                                    self.init_count.value_namespace = name_space
                                    self.init_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-count"):
                                    self.keep_alive_count = value
                                    self.keep_alive_count.value_namespace = name_space
                                    self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-abort-request-count"):
                                    self.label_abort_request_count = value
                                    self.label_abort_request_count.value_namespace = name_space
                                    self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-map-count"):
                                    self.label_map_count = value
                                    self.label_map_count.value_namespace = name_space
                                    self.label_map_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-release-count"):
                                    self.label_release_count = value
                                    self.label_release_count.value_namespace = name_space
                                    self.label_release_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-request-count"):
                                    self.label_request_count = value
                                    self.label_request_count.value_namespace = name_space
                                    self.label_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-withdraw-count"):
                                    self.label_withdraw_count = value
                                    self.label_withdraw_count.value_namespace = name_space
                                    self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "notification-count"):
                                    self.notification_count = value
                                    self.notification_count.value_namespace = name_space
                                    self.notification_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-count"):
                                    self.total_count = value
                                    self.total_count.value_namespace = name_space
                                    self.total_count.value_namespace_prefix = name_space_prefix


                        class MessageIn(Entity):
                            """
                            Message in count
                            
                            .. attribute:: address_count
                            
                            	Address message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: address_withdraw_count
                            
                            	Address withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_app_data_count
                            
                            	ICCP RG App Data count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_conn_count
                            
                            	ICCP RG Connect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_disconn_count
                            
                            	ICCP RG Disconnect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_notif_count
                            
                            	ICCP RG Notif count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: init_count
                            
                            	Init message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: keep_alive_count
                            
                            	Keepalive count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_abort_request_count
                            
                            	Label abort request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_map_count
                            
                            	Label map count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_release_count
                            
                            	Label release count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_request_count
                            
                            	Label request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_withdraw_count
                            
                            	Label withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: notification_count
                            
                            	Notification count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_count
                            
                            	Total message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageIn, self).__init__()

                                self.yang_name = "message-in"
                                self.yang_parent_name = "statistic"

                                self.address_count = YLeaf(YType.uint32, "address-count")

                                self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                self.init_count = YLeaf(YType.uint32, "init-count")

                                self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                self.notification_count = YLeaf(YType.uint32, "notification-count")

                                self.total_count = YLeaf(YType.uint32, "total-count")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_count",
                                                "address_withdraw_count",
                                                "iccp_rg_app_data_count",
                                                "iccp_rg_conn_count",
                                                "iccp_rg_disconn_count",
                                                "iccp_rg_notif_count",
                                                "init_count",
                                                "keep_alive_count",
                                                "label_abort_request_count",
                                                "label_map_count",
                                                "label_release_count",
                                                "label_request_count",
                                                "label_withdraw_count",
                                                "notification_count",
                                                "total_count") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_count.is_set or
                                    self.address_withdraw_count.is_set or
                                    self.iccp_rg_app_data_count.is_set or
                                    self.iccp_rg_conn_count.is_set or
                                    self.iccp_rg_disconn_count.is_set or
                                    self.iccp_rg_notif_count.is_set or
                                    self.init_count.is_set or
                                    self.keep_alive_count.is_set or
                                    self.label_abort_request_count.is_set or
                                    self.label_map_count.is_set or
                                    self.label_release_count.is_set or
                                    self.label_request_count.is_set or
                                    self.label_withdraw_count.is_set or
                                    self.notification_count.is_set or
                                    self.total_count.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_count.yfilter != YFilter.not_set or
                                    self.address_withdraw_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                    self.init_count.yfilter != YFilter.not_set or
                                    self.keep_alive_count.yfilter != YFilter.not_set or
                                    self.label_abort_request_count.yfilter != YFilter.not_set or
                                    self.label_map_count.yfilter != YFilter.not_set or
                                    self.label_release_count.yfilter != YFilter.not_set or
                                    self.label_request_count.yfilter != YFilter.not_set or
                                    self.label_withdraw_count.yfilter != YFilter.not_set or
                                    self.notification_count.yfilter != YFilter.not_set or
                                    self.total_count.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "message-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/statistics/statistic/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_count.get_name_leafdata())
                                if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.init_count.get_name_leafdata())
                                if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.notification_count.get_name_leafdata())
                                if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_count.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-count"):
                                    self.address_count = value
                                    self.address_count.value_namespace = name_space
                                    self.address_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "address-withdraw-count"):
                                    self.address_withdraw_count = value
                                    self.address_withdraw_count.value_namespace = name_space
                                    self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-app-data-count"):
                                    self.iccp_rg_app_data_count = value
                                    self.iccp_rg_app_data_count.value_namespace = name_space
                                    self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-conn-count"):
                                    self.iccp_rg_conn_count = value
                                    self.iccp_rg_conn_count.value_namespace = name_space
                                    self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-disconn-count"):
                                    self.iccp_rg_disconn_count = value
                                    self.iccp_rg_disconn_count.value_namespace = name_space
                                    self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-notif-count"):
                                    self.iccp_rg_notif_count = value
                                    self.iccp_rg_notif_count.value_namespace = name_space
                                    self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "init-count"):
                                    self.init_count = value
                                    self.init_count.value_namespace = name_space
                                    self.init_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-count"):
                                    self.keep_alive_count = value
                                    self.keep_alive_count.value_namespace = name_space
                                    self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-abort-request-count"):
                                    self.label_abort_request_count = value
                                    self.label_abort_request_count.value_namespace = name_space
                                    self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-map-count"):
                                    self.label_map_count = value
                                    self.label_map_count.value_namespace = name_space
                                    self.label_map_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-release-count"):
                                    self.label_release_count = value
                                    self.label_release_count.value_namespace = name_space
                                    self.label_release_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-request-count"):
                                    self.label_request_count = value
                                    self.label_request_count.value_namespace = name_space
                                    self.label_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-withdraw-count"):
                                    self.label_withdraw_count = value
                                    self.label_withdraw_count.value_namespace = name_space
                                    self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "notification-count"):
                                    self.notification_count = value
                                    self.notification_count.value_namespace = name_space
                                    self.notification_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-count"):
                                    self.total_count = value
                                    self.total_count.value_namespace = name_space
                                    self.total_count.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.iccp_enabled.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                (self.message_in is not None and self.message_in.has_data()) or
                                (self.message_out is not None and self.message_out.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.iccp_enabled.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                (self.message_in is not None and self.message_in.has_operation()) or
                                (self.message_out is not None and self.message_out.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/statistics/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.iccp_enabled.is_set or self.iccp_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.iccp_enabled.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "message-in"):
                                if (self.message_in is None):
                                    self.message_in = MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageIn()
                                    self.message_in.parent = self
                                    self._children_name_map["message_in"] = "message-in"
                                return self.message_in

                            if (child_yang_name == "message-out"):
                                if (self.message_out is None):
                                    self.message_out = MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic.MessageOut()
                                    self.message_out.parent = self
                                    self._children_name_map["message_out"] = "message-out"
                                return self.message_out

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "message-in" or name == "message-out" or name == "iccp-enabled" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "iccp-enabled"):
                                self.iccp_enabled = value
                                self.iccp_enabled.value_namespace = name_space
                                self.iccp_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.statistic:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.statistic:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/default-vrf/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistic"):
                            for c in self.statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Global_.Active.DefaultVrf.Statistics.Statistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.statistic.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistic"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        (self.afs is not None and self.afs.has_data()) or
                        (self.backoff_parameters is not None and self.backoff_parameters.has_data()) or
                        (self.backoffs is not None and self.backoffs.has_data()) or
                        (self.capabilities is not None and self.capabilities.has_data()) or
                        (self.graceful_restart is not None and self.graceful_restart.has_data()) or
                        (self.issu is not None and self.issu.has_data()) or
                        (self.ldp_id is not None and self.ldp_id.has_data()) or
                        (self.neighbor_briefs is not None and self.neighbor_briefs.has_data()) or
                        (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_data()) or
                        (self.neighbors is not None and self.neighbors.has_data()) or
                        (self.nsr is not None and self.nsr.has_data()) or
                        (self.parameters is not None and self.parameters.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()) or
                        (self.summary is not None and self.summary.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.afs is not None and self.afs.has_operation()) or
                        (self.backoff_parameters is not None and self.backoff_parameters.has_operation()) or
                        (self.backoffs is not None and self.backoffs.has_operation()) or
                        (self.capabilities is not None and self.capabilities.has_operation()) or
                        (self.graceful_restart is not None and self.graceful_restart.has_operation()) or
                        (self.issu is not None and self.issu.has_operation()) or
                        (self.ldp_id is not None and self.ldp_id.has_operation()) or
                        (self.neighbor_briefs is not None and self.neighbor_briefs.has_operation()) or
                        (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_operation()) or
                        (self.neighbors is not None and self.neighbors.has_operation()) or
                        (self.nsr is not None and self.nsr.has_operation()) or
                        (self.parameters is not None and self.parameters.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()) or
                        (self.summary is not None and self.summary.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "default-vrf" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "afs"):
                        if (self.afs is None):
                            self.afs = MplsLdp.Global_.Active.DefaultVrf.Afs()
                            self.afs.parent = self
                            self._children_name_map["afs"] = "afs"
                        return self.afs

                    if (child_yang_name == "backoff-parameters"):
                        if (self.backoff_parameters is None):
                            self.backoff_parameters = MplsLdp.Global_.Active.DefaultVrf.BackoffParameters()
                            self.backoff_parameters.parent = self
                            self._children_name_map["backoff_parameters"] = "backoff-parameters"
                        return self.backoff_parameters

                    if (child_yang_name == "backoffs"):
                        if (self.backoffs is None):
                            self.backoffs = MplsLdp.Global_.Active.DefaultVrf.Backoffs()
                            self.backoffs.parent = self
                            self._children_name_map["backoffs"] = "backoffs"
                        return self.backoffs

                    if (child_yang_name == "capabilities"):
                        if (self.capabilities is None):
                            self.capabilities = MplsLdp.Global_.Active.DefaultVrf.Capabilities()
                            self.capabilities.parent = self
                            self._children_name_map["capabilities"] = "capabilities"
                        return self.capabilities

                    if (child_yang_name == "graceful-restart"):
                        if (self.graceful_restart is None):
                            self.graceful_restart = MplsLdp.Global_.Active.DefaultVrf.GracefulRestart()
                            self.graceful_restart.parent = self
                            self._children_name_map["graceful_restart"] = "graceful-restart"
                        return self.graceful_restart

                    if (child_yang_name == "issu"):
                        if (self.issu is None):
                            self.issu = MplsLdp.Global_.Active.DefaultVrf.Issu()
                            self.issu.parent = self
                            self._children_name_map["issu"] = "issu"
                        return self.issu

                    if (child_yang_name == "ldp-id"):
                        if (self.ldp_id is None):
                            self.ldp_id = MplsLdp.Global_.Active.DefaultVrf.LdpId()
                            self.ldp_id.parent = self
                            self._children_name_map["ldp_id"] = "ldp-id"
                        return self.ldp_id

                    if (child_yang_name == "neighbor-briefs"):
                        if (self.neighbor_briefs is None):
                            self.neighbor_briefs = MplsLdp.Global_.Active.DefaultVrf.NeighborBriefs()
                            self.neighbor_briefs.parent = self
                            self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                        return self.neighbor_briefs

                    if (child_yang_name == "neighbor-capabilities"):
                        if (self.neighbor_capabilities is None):
                            self.neighbor_capabilities = MplsLdp.Global_.Active.DefaultVrf.NeighborCapabilities()
                            self.neighbor_capabilities.parent = self
                            self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                        return self.neighbor_capabilities

                    if (child_yang_name == "neighbors"):
                        if (self.neighbors is None):
                            self.neighbors = MplsLdp.Global_.Active.DefaultVrf.Neighbors()
                            self.neighbors.parent = self
                            self._children_name_map["neighbors"] = "neighbors"
                        return self.neighbors

                    if (child_yang_name == "nsr"):
                        if (self.nsr is None):
                            self.nsr = MplsLdp.Global_.Active.DefaultVrf.Nsr()
                            self.nsr.parent = self
                            self._children_name_map["nsr"] = "nsr"
                        return self.nsr

                    if (child_yang_name == "parameters"):
                        if (self.parameters is None):
                            self.parameters = MplsLdp.Global_.Active.DefaultVrf.Parameters()
                            self.parameters.parent = self
                            self._children_name_map["parameters"] = "parameters"
                        return self.parameters

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsLdp.Global_.Active.DefaultVrf.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    if (child_yang_name == "summary"):
                        if (self.summary is None):
                            self.summary = MplsLdp.Global_.Active.DefaultVrf.Summary()
                            self.summary.parent = self
                            self._children_name_map["summary"] = "summary"
                        return self.summary

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "afs" or name == "backoff-parameters" or name == "backoffs" or name == "capabilities" or name == "graceful-restart" or name == "issu" or name == "ldp-id" or name == "neighbor-briefs" or name == "neighbor-capabilities" or name == "neighbors" or name == "nsr" or name == "parameters" or name == "statistics" or name == "summary"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class ForwardingSummaryAll(Entity):
                """
                Summary information regarding LDP forwarding
                setup
                
                .. attribute:: fsht
                
                	Forwarding state hold time registered with LSD
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: intfs
                
                	MPLS forwarding enabled interface count
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: is_lsd_bound
                
                	LDP is connected to LSD server
                	**type**\:  bool
                
                .. attribute:: lbls
                
                	Local label allocated count
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: rws
                
                	Forwarding rewrites summary
                	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll.Rws>`
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.ForwardingSummaryAll, self).__init__()

                    self.yang_name = "forwarding-summary-all"
                    self.yang_parent_name = "active"

                    self.fsht = YLeaf(YType.uint16, "fsht")

                    self.intfs = YLeaf(YType.uint16, "intfs")

                    self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                    self.lbls = YLeaf(YType.uint16, "lbls")

                    self.rws = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws()
                    self.rws.parent = self
                    self._children_name_map["rws"] = "rws"
                    self._children_yang_names.add("rws")

                    self.vrf = MplsLdp.Global_.Active.ForwardingSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("fsht",
                                    "intfs",
                                    "is_lsd_bound",
                                    "lbls") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Active.ForwardingSummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Active.ForwardingSummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.ForwardingSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "forwarding-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.ForwardingSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.ForwardingSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/forwarding-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class Rws(Entity):
                    """
                    Forwarding rewrites summary
                    
                    .. attribute:: nhs
                    
                    	Forwarding rewrites nexthops (paths) summary
                    	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Nhs>`
                    
                    .. attribute:: pfxs
                    
                    	Forwarding rewrites prefix summary
                    	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws, self).__init__()

                        self.yang_name = "rws"
                        self.yang_parent_name = "forwarding-summary-all"

                        self.nhs = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Nhs()
                        self.nhs.parent = self
                        self._children_name_map["nhs"] = "nhs"
                        self._children_yang_names.add("nhs")

                        self.pfxs = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs()
                        self.pfxs.parent = self
                        self._children_name_map["pfxs"] = "pfxs"
                        self._children_yang_names.add("pfxs")


                    class Pfxs(Entity):
                        """
                        Forwarding rewrites prefix summary
                        
                        .. attribute:: ecmp_pfxs
                        
                        	Count of prefixes with ECMP
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: labeled_pfxs_aggr
                        
                        	Labeled prefix count for all paths
                        	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr>`
                        
                        .. attribute:: labeled_pfxs_backup
                        
                        	Labeled prefix count related to backup paths only
                        	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup>`
                        
                        .. attribute:: labeled_pfxs_primary
                        
                        	Labeled prefix count related to primary paths only
                        	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary>`
                        
                        .. attribute:: protected_pfxs
                        
                        	Count of FRR protected prefixes
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: total_pfxs
                        
                        	Total Prefix count
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs, self).__init__()

                            self.yang_name = "pfxs"
                            self.yang_parent_name = "rws"

                            self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                            self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                            self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                            self.labeled_pfxs_aggr = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr()
                            self.labeled_pfxs_aggr.parent = self
                            self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                            self._children_yang_names.add("labeled-pfxs-aggr")

                            self.labeled_pfxs_backup = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup()
                            self.labeled_pfxs_backup.parent = self
                            self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                            self._children_yang_names.add("labeled-pfxs-backup")

                            self.labeled_pfxs_primary = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary()
                            self.labeled_pfxs_primary.parent = self
                            self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                            self._children_yang_names.add("labeled-pfxs-primary")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ecmp_pfxs",
                                            "protected_pfxs",
                                            "total_pfxs") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs, self).__setattr__(name, value)


                        class LabeledPfxsAggr(Entity):
                            """
                            Labeled prefix count for all paths
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                self.yang_name = "labeled-pfxs-aggr"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-aggr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/forwarding-summary-all/rws/pfxs/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                        class LabeledPfxsPrimary(Entity):
                            """
                            Labeled prefix count related to primary paths
                            only
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                self.yang_name = "labeled-pfxs-primary"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-primary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/forwarding-summary-all/rws/pfxs/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                        class LabeledPfxsBackup(Entity):
                            """
                            Labeled prefix count related to backup paths
                            only
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                self.yang_name = "labeled-pfxs-backup"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-backup" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/forwarding-summary-all/rws/pfxs/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ecmp_pfxs.is_set or
                                self.protected_pfxs.is_set or
                                self.total_pfxs.is_set or
                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ecmp_pfxs.yfilter != YFilter.not_set or
                                self.protected_pfxs.yfilter != YFilter.not_set or
                                self.total_pfxs.yfilter != YFilter.not_set or
                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pfxs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/forwarding-summary-all/rws/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                            if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                            if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "labeled-pfxs-aggr"):
                                if (self.labeled_pfxs_aggr is None):
                                    self.labeled_pfxs_aggr = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr()
                                    self.labeled_pfxs_aggr.parent = self
                                    self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                return self.labeled_pfxs_aggr

                            if (child_yang_name == "labeled-pfxs-backup"):
                                if (self.labeled_pfxs_backup is None):
                                    self.labeled_pfxs_backup = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup()
                                    self.labeled_pfxs_backup.parent = self
                                    self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                return self.labeled_pfxs_backup

                            if (child_yang_name == "labeled-pfxs-primary"):
                                if (self.labeled_pfxs_primary is None):
                                    self.labeled_pfxs_primary = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary()
                                    self.labeled_pfxs_primary.parent = self
                                    self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                return self.labeled_pfxs_primary

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ecmp-pfxs"):
                                self.ecmp_pfxs = value
                                self.ecmp_pfxs.value_namespace = name_space
                                self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-pfxs"):
                                self.protected_pfxs = value
                                self.protected_pfxs.value_namespace = name_space
                                self.protected_pfxs.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-pfxs"):
                                self.total_pfxs = value
                                self.total_pfxs.value_namespace = name_space
                                self.total_pfxs.value_namespace_prefix = name_space_prefix


                    class Nhs(Entity):
                        """
                        Forwarding rewrites nexthops (paths) summary
                        
                        .. attribute:: backup_paths
                        
                        	Count of non\-primary backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: labeled_backup_paths
                        
                        	Count of labeled backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: labeled_paths
                        
                        	Count of all labeled paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: protected_paths
                        
                        	Count of FRR protected paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remote_backup_paths
                        
                        	Count of non\-primary remote backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_paths
                        
                        	Total path count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Nhs, self).__init__()

                            self.yang_name = "nhs"
                            self.yang_parent_name = "rws"

                            self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                            self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                            self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                            self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                            self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                            self.total_paths = YLeaf(YType.uint32, "total-paths")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_paths",
                                            "labeled_backup_paths",
                                            "labeled_paths",
                                            "protected_paths",
                                            "remote_backup_paths",
                                            "total_paths") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Nhs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Nhs, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backup_paths.is_set or
                                self.labeled_backup_paths.is_set or
                                self.labeled_paths.is_set or
                                self.protected_paths.is_set or
                                self.remote_backup_paths.is_set or
                                self.total_paths.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_paths.yfilter != YFilter.not_set or
                                self.labeled_backup_paths.yfilter != YFilter.not_set or
                                self.labeled_paths.yfilter != YFilter.not_set or
                                self.protected_paths.yfilter != YFilter.not_set or
                                self.remote_backup_paths.yfilter != YFilter.not_set or
                                self.total_paths.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nhs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/forwarding-summary-all/rws/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_paths.get_name_leafdata())
                            if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                            if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                            if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_paths.get_name_leafdata())
                            if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                            if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_paths.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-paths"):
                                self.backup_paths = value
                                self.backup_paths.value_namespace = name_space
                                self.backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "labeled-backup-paths"):
                                self.labeled_backup_paths = value
                                self.labeled_backup_paths.value_namespace = name_space
                                self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "labeled-paths"):
                                self.labeled_paths = value
                                self.labeled_paths.value_namespace = name_space
                                self.labeled_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-paths"):
                                self.protected_paths = value
                                self.protected_paths.value_namespace = name_space
                                self.protected_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-backup-paths"):
                                self.remote_backup_paths = value
                                self.remote_backup_paths.value_namespace = name_space
                                self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-paths"):
                                self.total_paths = value
                                self.total_paths.value_namespace = name_space
                                self.total_paths.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.nhs is not None and self.nhs.has_data()) or
                            (self.pfxs is not None and self.pfxs.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.nhs is not None and self.nhs.has_operation()) or
                            (self.pfxs is not None and self.pfxs.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rws" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/forwarding-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "nhs"):
                            if (self.nhs is None):
                                self.nhs = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Nhs()
                                self.nhs.parent = self
                                self._children_name_map["nhs"] = "nhs"
                            return self.nhs

                        if (child_yang_name == "pfxs"):
                            if (self.pfxs is None):
                                self.pfxs = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws.Pfxs()
                                self.pfxs.parent = self
                                self._children_name_map["pfxs"] = "pfxs"
                            return self.pfxs

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nhs" or name == "pfxs"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.fsht.is_set or
                        self.intfs.is_set or
                        self.is_lsd_bound.is_set or
                        self.lbls.is_set or
                        (self.rws is not None and self.rws.has_data()) or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.fsht.yfilter != YFilter.not_set or
                        self.intfs.yfilter != YFilter.not_set or
                        self.is_lsd_bound.yfilter != YFilter.not_set or
                        self.lbls.yfilter != YFilter.not_set or
                        (self.rws is not None and self.rws.has_operation()) or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "forwarding-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.fsht.get_name_leafdata())
                    if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.intfs.get_name_leafdata())
                    if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                    if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lbls.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "rws"):
                        if (self.rws is None):
                            self.rws = MplsLdp.Global_.Active.ForwardingSummaryAll.Rws()
                            self.rws.parent = self
                            self._children_name_map["rws"] = "rws"
                        return self.rws

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Active.ForwardingSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "fsht"):
                        self.fsht = value
                        self.fsht.value_namespace = name_space
                        self.fsht.value_namespace_prefix = name_space_prefix
                    if(value_path == "intfs"):
                        self.intfs = value
                        self.intfs.value_namespace = name_space
                        self.intfs.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-lsd-bound"):
                        self.is_lsd_bound = value
                        self.is_lsd_bound.value_namespace = name_space
                        self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                    if(value_path == "lbls"):
                        self.lbls = value
                        self.lbls.value_namespace = name_space
                        self.lbls.value_namespace_prefix = name_space_prefix


            class BindingsSummaryAll(Entity):
                """
                Aggregate VRF counters for the LDP Label
                Infomation Base (LIB)
                
                .. attribute:: address_family
                
                	Address Family
                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                
                .. attribute:: bind_af
                
                	bind af
                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.BindingsSummaryAll.BindAf>`
                
                .. attribute:: binding_local_explicit_null
                
                	Number of local explicit null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_implicit_null
                
                	Number of local implicit null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_no_route
                
                	Local bindings with no route
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_non_null
                
                	Number of local non\-null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_null
                
                	Number of local null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_oor
                
                	Number of local bindings        needing label \- OOR
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_no_route
                
                	Bindings with no route
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: highest_allocated_label
                
                	Highest allocated label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lowest_allocated_label
                
                	Lowest allocated label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.BindingsSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.BindingsSummaryAll, self).__init__()

                    self.yang_name = "bindings-summary-all"
                    self.yang_parent_name = "active"

                    self.address_family = YLeaf(YType.enumeration, "address-family")

                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                    self.vrf = MplsLdp.Global_.Active.BindingsSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                    self.bind_af = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address_family",
                                    "binding_local_explicit_null",
                                    "binding_local_implicit_null",
                                    "binding_local_no_route",
                                    "binding_local_non_null",
                                    "binding_local_null",
                                    "binding_local_oor",
                                    "binding_no_route",
                                    "highest_allocated_label",
                                    "lowest_allocated_label") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Active.BindingsSummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Active.BindingsSummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.BindingsSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "bindings-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/bindings-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class BindAf(Entity):
                    """
                    bind af
                    
                    .. attribute:: address_family
                    
                    	Binding Summary Address Family
                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                    
                    .. attribute:: binding_local
                    
                    	Number of local bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: binding_remote
                    
                    	Number of remote bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: binding_total
                    
                    	Total bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: last_lib_update
                    
                    	Last update to LIB local binding
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lib_minimum_revision_sent_all
                    
                    	Last update sent to all peers
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.BindingsSummaryAll.BindAf, self).__init__()

                        self.yang_name = "bind-af"
                        self.yang_parent_name = "bindings-summary-all"

                        self.address_family = YLeaf(YType.enumeration, "address-family")

                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_family",
                                        "binding_local",
                                        "binding_remote",
                                        "binding_total",
                                        "last_lib_update",
                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_family.is_set or
                            self.binding_local.is_set or
                            self.binding_remote.is_set or
                            self.binding_total.is_set or
                            self.last_lib_update.is_set or
                            self.lib_minimum_revision_sent_all.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_family.yfilter != YFilter.not_set or
                            self.binding_local.yfilter != YFilter.not_set or
                            self.binding_remote.yfilter != YFilter.not_set or
                            self.binding_total.yfilter != YFilter.not_set or
                            self.last_lib_update.yfilter != YFilter.not_set or
                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bind-af" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/bindings-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_family.get_name_leafdata())
                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-family"):
                            self.address_family = value
                            self.address_family.value_namespace = name_space
                            self.address_family.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-local"):
                            self.binding_local = value
                            self.binding_local.value_namespace = name_space
                            self.binding_local.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-remote"):
                            self.binding_remote = value
                            self.binding_remote.value_namespace = name_space
                            self.binding_remote.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-total"):
                            self.binding_total = value
                            self.binding_total.value_namespace = name_space
                            self.binding_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-lib-update"):
                            self.last_lib_update = value
                            self.last_lib_update.value_namespace = name_space
                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                        if(value_path == "lib-minimum-revision-sent-all"):
                            self.lib_minimum_revision_sent_all = value
                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.bind_af:
                        if (c.has_data()):
                            return True
                    return (
                        self.address_family.is_set or
                        self.binding_local_explicit_null.is_set or
                        self.binding_local_implicit_null.is_set or
                        self.binding_local_no_route.is_set or
                        self.binding_local_non_null.is_set or
                        self.binding_local_null.is_set or
                        self.binding_local_oor.is_set or
                        self.binding_no_route.is_set or
                        self.highest_allocated_label.is_set or
                        self.lowest_allocated_label.is_set or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    for c in self.bind_af:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address_family.yfilter != YFilter.not_set or
                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                        self.binding_local_no_route.yfilter != YFilter.not_set or
                        self.binding_local_non_null.yfilter != YFilter.not_set or
                        self.binding_local_null.yfilter != YFilter.not_set or
                        self.binding_local_oor.yfilter != YFilter.not_set or
                        self.binding_no_route.yfilter != YFilter.not_set or
                        self.highest_allocated_label.yfilter != YFilter.not_set or
                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bindings-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.address_family.get_name_leafdata())
                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "bind-af"):
                        for c in self.bind_af:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Global_.Active.BindingsSummaryAll.BindAf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.bind_af.append(c)
                        return c

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Active.BindingsSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address-family"):
                        self.address_family = value
                        self.address_family.value_namespace = name_space
                        self.address_family.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-explicit-null"):
                        self.binding_local_explicit_null = value
                        self.binding_local_explicit_null.value_namespace = name_space
                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-implicit-null"):
                        self.binding_local_implicit_null = value
                        self.binding_local_implicit_null.value_namespace = name_space
                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-no-route"):
                        self.binding_local_no_route = value
                        self.binding_local_no_route.value_namespace = name_space
                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-non-null"):
                        self.binding_local_non_null = value
                        self.binding_local_non_null.value_namespace = name_space
                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-null"):
                        self.binding_local_null = value
                        self.binding_local_null.value_namespace = name_space
                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-oor"):
                        self.binding_local_oor = value
                        self.binding_local_oor.value_namespace = name_space
                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-no-route"):
                        self.binding_no_route = value
                        self.binding_no_route.value_namespace = name_space
                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "highest-allocated-label"):
                        self.highest_allocated_label = value
                        self.highest_allocated_label.value_namespace = name_space
                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lowest-allocated-label"):
                        self.lowest_allocated_label = value
                        self.lowest_allocated_label.value_namespace = name_space
                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


            class AtoMdbTableEntries(Entity):
                """
                AToM DB Table
                
                .. attribute:: ato_mdb_table_entry
                
                	Entries in AToM DB
                	**type**\: list of    :py:class:`AtoMdbTableEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.AtoMdbTableEntries, self).__init__()

                    self.yang_name = "ato-mdb-table-entries"
                    self.yang_parent_name = "active"

                    self.ato_mdb_table_entry = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Active.AtoMdbTableEntries, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Active.AtoMdbTableEntries, self).__setattr__(name, value)


                class AtoMdbTableEntry(Entity):
                    """
                    Entries in AToM DB
                    
                    .. attribute:: agi
                    
                    	AGI
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: agi_type
                    
                    	AGI Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: fe_ctype
                    
                    	FEC Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: fec_info
                    
                    	Pseudowire FEC information
                    	**type**\:   :py:class:`FecInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo>`
                    
                    .. attribute:: mapping_tlv_count
                    
                    	TLV Count from Label Mapping Message
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: notification_tlv_count
                    
                    	TLV Count from Notification Message
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: peer_id
                    
                    	Peer ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: peer_id_xr
                    
                    	Peer ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: pw_id
                    
                    	PW ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_ac_id
                    
                    	SAII AC ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_global_id
                    
                    	SAII Global ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_local_id
                    
                    	SAII Local ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: saii_prefix
                    
                    	SAII Prefix
                    	**type**\:  str
                    
                    	**pattern:** [0\-9a\-fA\-F]{1,8}
                    
                    .. attribute:: saii_type
                    
                    	SAII Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_ac_id
                    
                    	TAII AC ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_global_id
                    
                    	TAII Global ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_local_id
                    
                    	TAII Local ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: taii_prefix
                    
                    	TAII Prefix
                    	**type**\:  str
                    
                    	**pattern:** [0\-9a\-fA\-F]{1,8}
                    
                    .. attribute:: taii_type
                    
                    	TAII Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry, self).__init__()

                        self.yang_name = "ato-mdb-table-entry"
                        self.yang_parent_name = "ato-mdb-table-entries"

                        self.agi = YLeaf(YType.int32, "agi")

                        self.agi_type = YLeaf(YType.int32, "agi-type")

                        self.fe_ctype = YLeaf(YType.int32, "fe-ctype")

                        self.mapping_tlv_count = YLeaf(YType.uint32, "mapping-tlv-count")

                        self.notification_tlv_count = YLeaf(YType.uint32, "notification-tlv-count")

                        self.peer_id = YLeaf(YType.str, "peer-id")

                        self.peer_id_xr = YLeaf(YType.str, "peer-id-xr")

                        self.pw_id = YLeaf(YType.int32, "pw-id")

                        self.saii_ac_id = YLeaf(YType.int32, "saii-ac-id")

                        self.saii_global_id = YLeaf(YType.int32, "saii-global-id")

                        self.saii_local_id = YLeaf(YType.str, "saii-local-id")

                        self.saii_prefix = YLeaf(YType.str, "saii-prefix")

                        self.saii_type = YLeaf(YType.int32, "saii-type")

                        self.taii_ac_id = YLeaf(YType.int32, "taii-ac-id")

                        self.taii_global_id = YLeaf(YType.int32, "taii-global-id")

                        self.taii_local_id = YLeaf(YType.str, "taii-local-id")

                        self.taii_prefix = YLeaf(YType.str, "taii-prefix")

                        self.taii_type = YLeaf(YType.int32, "taii-type")

                        self.fec_info = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo()
                        self.fec_info.parent = self
                        self._children_name_map["fec_info"] = "fec-info"
                        self._children_yang_names.add("fec-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("agi",
                                        "agi_type",
                                        "fe_ctype",
                                        "mapping_tlv_count",
                                        "notification_tlv_count",
                                        "peer_id",
                                        "peer_id_xr",
                                        "pw_id",
                                        "saii_ac_id",
                                        "saii_global_id",
                                        "saii_local_id",
                                        "saii_prefix",
                                        "saii_type",
                                        "taii_ac_id",
                                        "taii_global_id",
                                        "taii_local_id",
                                        "taii_prefix",
                                        "taii_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry, self).__setattr__(name, value)


                    class FecInfo(Entity):
                        """
                        Pseudowire FEC information
                        
                        .. attribute:: fe_ctype
                        
                        	FECType
                        	**type**\:   :py:class:`L2VpnLdpPwFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwFec>`
                        
                        .. attribute:: fec128
                        
                        	fec128
                        	**type**\:   :py:class:`Fec128 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128>`
                        
                        .. attribute:: fec129
                        
                        	fec129
                        	**type**\:   :py:class:`Fec129 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129>`
                        
                        .. attribute:: fec130
                        
                        	fec130
                        	**type**\:   :py:class:`Fec130 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__init__()

                            self.yang_name = "fec-info"
                            self.yang_parent_name = "ato-mdb-table-entry"

                            self.fe_ctype = YLeaf(YType.enumeration, "fe-ctype")

                            self.fec128 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128()
                            self.fec128.parent = self
                            self._children_name_map["fec128"] = "fec128"
                            self._children_yang_names.add("fec128")

                            self.fec129 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129()
                            self.fec129.parent = self
                            self._children_name_map["fec129"] = "fec129"
                            self._children_yang_names.add("fec129")

                            self.fec130 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130()
                            self.fec130.parent = self
                            self._children_name_map["fec130"] = "fec130"
                            self._children_yang_names.add("fec130")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fe_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__setattr__(name, value)


                        class Fec128(Entity):
                            """
                            fec128
                            
                            .. attribute:: pseudowire_id
                            
                            	Pseudowire ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__init__()

                                self.yang_name = "fec128"
                                self.yang_parent_name = "fec-info"

                                self.pseudowire_id = YLeaf(YType.uint32, "pseudowire-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pseudowire_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pseudowire_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pseudowire_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec128" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pseudowire_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pseudowire-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pseudowire-id"):
                                    self.pseudowire_id = value
                                    self.pseudowire_id.value_namespace = name_space
                                    self.pseudowire_id.value_namespace_prefix = name_space_prefix


                        class Fec129(Entity):
                            """
                            fec129
                            
                            .. attribute:: agi
                            
                            	AGI
                            	**type**\:   :py:class:`Agi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi>`
                            
                            .. attribute:: saii
                            
                            	Source Attachment Individual Identifier
                            	**type**\:   :py:class:`Saii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii>`
                            
                            .. attribute:: taii
                            
                            	Target Attachment Individual Identifier
                            	**type**\:   :py:class:`Taii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129, self).__init__()

                                self.yang_name = "fec129"
                                self.yang_parent_name = "fec-info"

                                self.agi = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi()
                                self.agi.parent = self
                                self._children_name_map["agi"] = "agi"
                                self._children_yang_names.add("agi")

                                self.saii = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii()
                                self.saii.parent = self
                                self._children_name_map["saii"] = "saii"
                                self._children_yang_names.add("saii")

                                self.taii = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii()
                                self.taii.parent = self
                                self._children_name_map["taii"] = "taii"
                                self._children_yang_names.add("taii")


                            class Agi(Entity):
                                """
                                AGI
                                
                                .. attribute:: agi1
                                
                                	agi1
                                	**type**\:   :py:class:`Agi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1>`
                                
                                .. attribute:: agi_type
                                
                                	AGIType
                                	**type**\:   :py:class:`L2VpnLdpPwAgi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAgi>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__init__()

                                    self.yang_name = "agi"
                                    self.yang_parent_name = "fec129"

                                    self.agi_type = YLeaf(YType.enumeration, "agi-type")

                                    self.agi1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1()
                                    self.agi1.parent = self
                                    self._children_name_map["agi1"] = "agi1"
                                    self._children_yang_names.add("agi1")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("agi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__setattr__(name, value)


                                class Agi1(Entity):
                                    """
                                    agi1
                                    
                                    .. attribute:: rd
                                    
                                    	Route Distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__init__()

                                        self.yang_name = "agi1"
                                        self.yang_parent_name = "agi"

                                        self.rd = YLeaf(YType.uint64, "rd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.rd.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "agi1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/agi/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rd.is_set or self.rd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rd"):
                                            self.rd = value
                                            self.rd.value_namespace = name_space
                                            self.rd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.agi_type.is_set or
                                        (self.agi1 is not None and self.agi1.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.agi_type.yfilter != YFilter.not_set or
                                        (self.agi1 is not None and self.agi1.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "agi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.agi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "agi1"):
                                        if (self.agi1 is None):
                                            self.agi1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1()
                                            self.agi1.parent = self
                                            self._children_name_map["agi1"] = "agi1"
                                        return self.agi1

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "agi1" or name == "agi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "agi-type"):
                                        self.agi_type = value
                                        self.agi_type.value_namespace = name_space
                                        self.agi_type.value_namespace_prefix = name_space_prefix


                            class Saii(Entity):
                                """
                                Source Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__init__()

                                    self.yang_name = "saii"
                                    self.yang_parent_name = "fec129"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "saii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "saii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "saii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix


                            class Taii(Entity):
                                """
                                Target Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__init__()

                                    self.yang_name = "taii"
                                    self.yang_parent_name = "fec129"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "taii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/taii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "taii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/taii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "taii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec129/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.agi is not None and self.agi.has_data()) or
                                    (self.saii is not None and self.saii.has_data()) or
                                    (self.taii is not None and self.taii.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.agi is not None and self.agi.has_operation()) or
                                    (self.saii is not None and self.saii.has_operation()) or
                                    (self.taii is not None and self.taii.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec129" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "agi"):
                                    if (self.agi is None):
                                        self.agi = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi()
                                        self.agi.parent = self
                                        self._children_name_map["agi"] = "agi"
                                    return self.agi

                                if (child_yang_name == "saii"):
                                    if (self.saii is None):
                                        self.saii = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii()
                                        self.saii.parent = self
                                        self._children_name_map["saii"] = "saii"
                                    return self.saii

                                if (child_yang_name == "taii"):
                                    if (self.taii is None):
                                        self.taii = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii()
                                        self.taii.parent = self
                                        self._children_name_map["taii"] = "taii"
                                    return self.taii

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "agi" or name == "saii" or name == "taii"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Fec130(Entity):
                            """
                            fec130
                            
                            .. attribute:: agi
                            
                            	AGI
                            	**type**\:   :py:class:`Agi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi>`
                            
                            .. attribute:: saii
                            
                            	Source Attachment Individual Identifier
                            	**type**\:   :py:class:`Saii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130, self).__init__()

                                self.yang_name = "fec130"
                                self.yang_parent_name = "fec-info"

                                self.agi = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi()
                                self.agi.parent = self
                                self._children_name_map["agi"] = "agi"
                                self._children_yang_names.add("agi")

                                self.saii = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii()
                                self.saii.parent = self
                                self._children_name_map["saii"] = "saii"
                                self._children_yang_names.add("saii")


                            class Agi(Entity):
                                """
                                AGI
                                
                                .. attribute:: agi1
                                
                                	agi1
                                	**type**\:   :py:class:`Agi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1>`
                                
                                .. attribute:: agi_type
                                
                                	AGIType
                                	**type**\:   :py:class:`L2VpnLdpPwAgi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAgi>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__init__()

                                    self.yang_name = "agi"
                                    self.yang_parent_name = "fec130"

                                    self.agi_type = YLeaf(YType.enumeration, "agi-type")

                                    self.agi1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1()
                                    self.agi1.parent = self
                                    self._children_name_map["agi1"] = "agi1"
                                    self._children_yang_names.add("agi1")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("agi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__setattr__(name, value)


                                class Agi1(Entity):
                                    """
                                    agi1
                                    
                                    .. attribute:: rd
                                    
                                    	Route Distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__init__()

                                        self.yang_name = "agi1"
                                        self.yang_parent_name = "agi"

                                        self.rd = YLeaf(YType.uint64, "rd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.rd.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "agi1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/agi/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rd.is_set or self.rd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rd"):
                                            self.rd = value
                                            self.rd.value_namespace = name_space
                                            self.rd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.agi_type.is_set or
                                        (self.agi1 is not None and self.agi1.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.agi_type.yfilter != YFilter.not_set or
                                        (self.agi1 is not None and self.agi1.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "agi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.agi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "agi1"):
                                        if (self.agi1 is None):
                                            self.agi1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1()
                                            self.agi1.parent = self
                                            self._children_name_map["agi1"] = "agi1"
                                        return self.agi1

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "agi1" or name == "agi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "agi-type"):
                                        self.agi_type = value
                                        self.agi_type.value_namespace = name_space
                                        self.agi_type.value_namespace_prefix = name_space_prefix


                            class Saii(Entity):
                                """
                                Source Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__init__()

                                    self.yang_name = "saii"
                                    self.yang_parent_name = "fec130"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "saii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "saii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/saii/%s" % self.get_segment_path()
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "saii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/fec130/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.agi is not None and self.agi.has_data()) or
                                    (self.saii is not None and self.saii.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.agi is not None and self.agi.has_operation()) or
                                    (self.saii is not None and self.saii.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec130" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/fec-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "agi"):
                                    if (self.agi is None):
                                        self.agi = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi()
                                        self.agi.parent = self
                                        self._children_name_map["agi"] = "agi"
                                    return self.agi

                                if (child_yang_name == "saii"):
                                    if (self.saii is None):
                                        self.saii = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii()
                                        self.saii.parent = self
                                        self._children_name_map["saii"] = "saii"
                                    return self.saii

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "agi" or name == "saii"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.fe_ctype.is_set or
                                (self.fec128 is not None and self.fec128.has_data()) or
                                (self.fec129 is not None and self.fec129.has_data()) or
                                (self.fec130 is not None and self.fec130.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fe_ctype.yfilter != YFilter.not_set or
                                (self.fec128 is not None and self.fec128.has_operation()) or
                                (self.fec129 is not None and self.fec129.has_operation()) or
                                (self.fec130 is not None and self.fec130.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/ato-mdb-table-entry/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fe_ctype.is_set or self.fe_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fe_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec128"):
                                if (self.fec128 is None):
                                    self.fec128 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128()
                                    self.fec128.parent = self
                                    self._children_name_map["fec128"] = "fec128"
                                return self.fec128

                            if (child_yang_name == "fec129"):
                                if (self.fec129 is None):
                                    self.fec129 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129()
                                    self.fec129.parent = self
                                    self._children_name_map["fec129"] = "fec129"
                                return self.fec129

                            if (child_yang_name == "fec130"):
                                if (self.fec130 is None):
                                    self.fec130 = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130()
                                    self.fec130.parent = self
                                    self._children_name_map["fec130"] = "fec130"
                                return self.fec130

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec128" or name == "fec129" or name == "fec130" or name == "fe-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fe-ctype"):
                                self.fe_ctype = value
                                self.fe_ctype.value_namespace = name_space
                                self.fe_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.agi.is_set or
                            self.agi_type.is_set or
                            self.fe_ctype.is_set or
                            self.mapping_tlv_count.is_set or
                            self.notification_tlv_count.is_set or
                            self.peer_id.is_set or
                            self.peer_id_xr.is_set or
                            self.pw_id.is_set or
                            self.saii_ac_id.is_set or
                            self.saii_global_id.is_set or
                            self.saii_local_id.is_set or
                            self.saii_prefix.is_set or
                            self.saii_type.is_set or
                            self.taii_ac_id.is_set or
                            self.taii_global_id.is_set or
                            self.taii_local_id.is_set or
                            self.taii_prefix.is_set or
                            self.taii_type.is_set or
                            (self.fec_info is not None and self.fec_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.agi.yfilter != YFilter.not_set or
                            self.agi_type.yfilter != YFilter.not_set or
                            self.fe_ctype.yfilter != YFilter.not_set or
                            self.mapping_tlv_count.yfilter != YFilter.not_set or
                            self.notification_tlv_count.yfilter != YFilter.not_set or
                            self.peer_id.yfilter != YFilter.not_set or
                            self.peer_id_xr.yfilter != YFilter.not_set or
                            self.pw_id.yfilter != YFilter.not_set or
                            self.saii_ac_id.yfilter != YFilter.not_set or
                            self.saii_global_id.yfilter != YFilter.not_set or
                            self.saii_local_id.yfilter != YFilter.not_set or
                            self.saii_prefix.yfilter != YFilter.not_set or
                            self.saii_type.yfilter != YFilter.not_set or
                            self.taii_ac_id.yfilter != YFilter.not_set or
                            self.taii_global_id.yfilter != YFilter.not_set or
                            self.taii_local_id.yfilter != YFilter.not_set or
                            self.taii_prefix.yfilter != YFilter.not_set or
                            self.taii_type.yfilter != YFilter.not_set or
                            (self.fec_info is not None and self.fec_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ato-mdb-table-entry" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/ato-mdb-table-entries/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.agi.is_set or self.agi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.agi.get_name_leafdata())
                        if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.agi_type.get_name_leafdata())
                        if (self.fe_ctype.is_set or self.fe_ctype.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fe_ctype.get_name_leafdata())
                        if (self.mapping_tlv_count.is_set or self.mapping_tlv_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mapping_tlv_count.get_name_leafdata())
                        if (self.notification_tlv_count.is_set or self.notification_tlv_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.notification_tlv_count.get_name_leafdata())
                        if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.peer_id.get_name_leafdata())
                        if (self.peer_id_xr.is_set or self.peer_id_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.peer_id_xr.get_name_leafdata())
                        if (self.pw_id.is_set or self.pw_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pw_id.get_name_leafdata())
                        if (self.saii_ac_id.is_set or self.saii_ac_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_ac_id.get_name_leafdata())
                        if (self.saii_global_id.is_set or self.saii_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_global_id.get_name_leafdata())
                        if (self.saii_local_id.is_set or self.saii_local_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_local_id.get_name_leafdata())
                        if (self.saii_prefix.is_set or self.saii_prefix.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_prefix.get_name_leafdata())
                        if (self.saii_type.is_set or self.saii_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_type.get_name_leafdata())
                        if (self.taii_ac_id.is_set or self.taii_ac_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_ac_id.get_name_leafdata())
                        if (self.taii_global_id.is_set or self.taii_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_global_id.get_name_leafdata())
                        if (self.taii_local_id.is_set or self.taii_local_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_local_id.get_name_leafdata())
                        if (self.taii_prefix.is_set or self.taii_prefix.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_prefix.get_name_leafdata())
                        if (self.taii_type.is_set or self.taii_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-info"):
                            if (self.fec_info is None):
                                self.fec_info = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo()
                                self.fec_info.parent = self
                                self._children_name_map["fec_info"] = "fec-info"
                            return self.fec_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-info" or name == "agi" or name == "agi-type" or name == "fe-ctype" or name == "mapping-tlv-count" or name == "notification-tlv-count" or name == "peer-id" or name == "peer-id-xr" or name == "pw-id" or name == "saii-ac-id" or name == "saii-global-id" or name == "saii-local-id" or name == "saii-prefix" or name == "saii-type" or name == "taii-ac-id" or name == "taii-global-id" or name == "taii-local-id" or name == "taii-prefix" or name == "taii-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "agi"):
                            self.agi = value
                            self.agi.value_namespace = name_space
                            self.agi.value_namespace_prefix = name_space_prefix
                        if(value_path == "agi-type"):
                            self.agi_type = value
                            self.agi_type.value_namespace = name_space
                            self.agi_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "fe-ctype"):
                            self.fe_ctype = value
                            self.fe_ctype.value_namespace = name_space
                            self.fe_ctype.value_namespace_prefix = name_space_prefix
                        if(value_path == "mapping-tlv-count"):
                            self.mapping_tlv_count = value
                            self.mapping_tlv_count.value_namespace = name_space
                            self.mapping_tlv_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "notification-tlv-count"):
                            self.notification_tlv_count = value
                            self.notification_tlv_count.value_namespace = name_space
                            self.notification_tlv_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "peer-id"):
                            self.peer_id = value
                            self.peer_id.value_namespace = name_space
                            self.peer_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "peer-id-xr"):
                            self.peer_id_xr = value
                            self.peer_id_xr.value_namespace = name_space
                            self.peer_id_xr.value_namespace_prefix = name_space_prefix
                        if(value_path == "pw-id"):
                            self.pw_id = value
                            self.pw_id.value_namespace = name_space
                            self.pw_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-ac-id"):
                            self.saii_ac_id = value
                            self.saii_ac_id.value_namespace = name_space
                            self.saii_ac_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-global-id"):
                            self.saii_global_id = value
                            self.saii_global_id.value_namespace = name_space
                            self.saii_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-local-id"):
                            self.saii_local_id = value
                            self.saii_local_id.value_namespace = name_space
                            self.saii_local_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-prefix"):
                            self.saii_prefix = value
                            self.saii_prefix.value_namespace = name_space
                            self.saii_prefix.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-type"):
                            self.saii_type = value
                            self.saii_type.value_namespace = name_space
                            self.saii_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-ac-id"):
                            self.taii_ac_id = value
                            self.taii_ac_id.value_namespace = name_space
                            self.taii_ac_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-global-id"):
                            self.taii_global_id = value
                            self.taii_global_id.value_namespace = name_space
                            self.taii_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-local-id"):
                            self.taii_local_id = value
                            self.taii_local_id.value_namespace = name_space
                            self.taii_local_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-prefix"):
                            self.taii_prefix = value
                            self.taii_prefix.value_namespace = name_space
                            self.taii_prefix.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-type"):
                            self.taii_type = value
                            self.taii_type.value_namespace = name_space
                            self.taii_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.ato_mdb_table_entry:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.ato_mdb_table_entry:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ato-mdb-table-entries" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ato-mdb-table-entry"):
                        for c in self.ato_mdb_table_entry:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Global_.Active.AtoMdbTableEntries.AtoMdbTableEntry()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.ato_mdb_table_entry.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ato-mdb-table-entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class NsrSummaryAll(Entity):
                """
                Summary information regarding LDP NSR State
                
                .. attribute:: sessions
                
                	Session summary
                	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.NsrSummaryAll.Sessions>`
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.NsrSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.NsrSummaryAll, self).__init__()

                    self.yang_name = "nsr-summary-all"
                    self.yang_parent_name = "active"

                    self.sessions = MplsLdp.Global_.Active.NsrSummaryAll.Sessions()
                    self.sessions.parent = self
                    self._children_name_map["sessions"] = "sessions"
                    self._children_yang_names.add("sessions")

                    self.vrf = MplsLdp.Global_.Active.NsrSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.NsrSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "nsr-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.NsrSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.NsrSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/nsr-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class Sessions(Entity):
                    """
                    Session summary
                    
                    .. attribute:: nsr_eligible
                    
                    	NSR eligible sessions
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_app_wait
                    
                    	Number of sessions in NSR app\-wait state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_none
                    
                    	Number of sessions in NSR none state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_operational
                    
                    	Number of sessions in NSR operational state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_prepare
                    
                    	Number of sessions in NSR prepare state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_ready
                    
                    	Number of sessions in NSR ready state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_tcp_phase1
                    
                    	Number of sessions in NSR TCP phase 1 state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_tcp_phase2
                    
                    	Number of sessions in NSR TCP phase 2 state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_wait
                    
                    	Number of sessions in NSR wait state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total
                    
                    	Total sessions
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.NsrSummaryAll.Sessions, self).__init__()

                        self.yang_name = "sessions"
                        self.yang_parent_name = "nsr-summary-all"

                        self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                        self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                        self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                        self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                        self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                        self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                        self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                        self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                        self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                        self.total = YLeaf(YType.uint32, "total")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("nsr_eligible",
                                        "nsr_state_app_wait",
                                        "nsr_state_none",
                                        "nsr_state_operational",
                                        "nsr_state_prepare",
                                        "nsr_state_ready",
                                        "nsr_state_tcp_phase1",
                                        "nsr_state_tcp_phase2",
                                        "nsr_state_wait",
                                        "total") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.NsrSummaryAll.Sessions, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.NsrSummaryAll.Sessions, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.nsr_eligible.is_set or
                            self.nsr_state_app_wait.is_set or
                            self.nsr_state_none.is_set or
                            self.nsr_state_operational.is_set or
                            self.nsr_state_prepare.is_set or
                            self.nsr_state_ready.is_set or
                            self.nsr_state_tcp_phase1.is_set or
                            self.nsr_state_tcp_phase2.is_set or
                            self.nsr_state_wait.is_set or
                            self.total.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.nsr_eligible.yfilter != YFilter.not_set or
                            self.nsr_state_app_wait.yfilter != YFilter.not_set or
                            self.nsr_state_none.yfilter != YFilter.not_set or
                            self.nsr_state_operational.yfilter != YFilter.not_set or
                            self.nsr_state_prepare.yfilter != YFilter.not_set or
                            self.nsr_state_ready.yfilter != YFilter.not_set or
                            self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                            self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                            self.nsr_state_wait.yfilter != YFilter.not_set or
                            self.total.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sessions" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/nsr-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                        if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                        if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                        if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                        if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                        if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                        if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                        if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                        if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                        if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "nsr-eligible"):
                            self.nsr_eligible = value
                            self.nsr_eligible.value_namespace = name_space
                            self.nsr_eligible.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-app-wait"):
                            self.nsr_state_app_wait = value
                            self.nsr_state_app_wait.value_namespace = name_space
                            self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-none"):
                            self.nsr_state_none = value
                            self.nsr_state_none.value_namespace = name_space
                            self.nsr_state_none.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-operational"):
                            self.nsr_state_operational = value
                            self.nsr_state_operational.value_namespace = name_space
                            self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-prepare"):
                            self.nsr_state_prepare = value
                            self.nsr_state_prepare.value_namespace = name_space
                            self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-ready"):
                            self.nsr_state_ready = value
                            self.nsr_state_ready.value_namespace = name_space
                            self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-tcp-phase1"):
                            self.nsr_state_tcp_phase1 = value
                            self.nsr_state_tcp_phase1.value_namespace = name_space
                            self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-tcp-phase2"):
                            self.nsr_state_tcp_phase2 = value
                            self.nsr_state_tcp_phase2.value_namespace = name_space
                            self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-wait"):
                            self.nsr_state_wait = value
                            self.nsr_state_wait.value_namespace = name_space
                            self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                        if(value_path == "total"):
                            self.total = value
                            self.total.value_namespace = name_space
                            self.total.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.sessions is not None and self.sessions.has_data()) or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.sessions is not None and self.sessions.has_operation()) or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nsr-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "sessions"):
                        if (self.sessions is None):
                            self.sessions = MplsLdp.Global_.Active.NsrSummaryAll.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                        return self.sessions

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Active.NsrSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "sessions" or name == "vrf"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Summary(Entity):
                """
                LDP summary
                
                .. attribute:: common
                
                	Common Summary information
                	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Summary.Common>`
                
                .. attribute:: is_bound_with_atom
                
                	Bound status with L2VPN ATOM
                	**type**\:  bool
                
                .. attribute:: is_bound_with_interface_manager
                
                	Bound status with Interface Manager
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ip_arm
                
                	Bound status with IP Arm
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ipv4_rib
                
                	Bound status with IPv4 RIB
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ipv6_rib
                
                	Bound status with IPv6 RIB
                	**type**\:  bool
                
                .. attribute:: is_bound_with_lsd
                
                	Bound status with LSD
                	**type**\:  bool
                
                .. attribute:: is_bound_with_nsr_mate
                
                	Bound status with NSR Mate
                	**type**\:  bool
                
                .. attribute:: is_bound_with_rsi
                
                	Bound status with rsi
                	**type**\:  bool
                
                .. attribute:: is_bound_with_sysdb
                
                	Bound status with sysdb
                	**type**\:  bool
                
                .. attribute:: is_mldp_registered
                
                	mLDP registration status
                	**type**\:  bool
                
                .. attribute:: is_nsr_configured
                
                	NSR configured
                	**type**\:  bool
                
                .. attribute:: is_registered_with_interface_manager
                
                	Registration status with Interface Manager
                	**type**\:  bool
                
                .. attribute:: is_registered_with_ipv4_rib
                
                	Registration status with IPv4 RIB
                	**type**\:  bool
                
                .. attribute:: is_registered_with_ipv6_rib
                
                	Registration status with IPv6 RIB
                	**type**\:  bool
                
                .. attribute:: is_registered_with_lsd
                
                	Registration status with LSD
                	**type**\:  bool
                
                .. attribute:: is_registered_with_sysdb
                
                	Registration status with Sysdb
                	**type**\:  bool
                
                .. attribute:: number_of_autocfg_interfaces
                
                	Number of auto\-configured interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_fwd_ref_interfaces
                
                	Number of Forward Referenc interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_interfaces
                
                	Number of known interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_ipv4rib_tables
                
                	Total number of ipv4 RIB tables
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_ipv6rib_tables
                
                	Total number of ipv6 RIB tables
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_registered_ipv4rib_tables
                
                	Number of ipv4 RIB tables registered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_registered_ipv6rib_tables
                
                	Number of ipv6 RIB tables registered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_vrf
                
                	Number of configured VRFs (including default)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_vrf_oper
                
                	Number of configured operational VRFs (including default)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "active"

                    self.is_bound_with_atom = YLeaf(YType.boolean, "is-bound-with-atom")

                    self.is_bound_with_interface_manager = YLeaf(YType.boolean, "is-bound-with-interface-manager")

                    self.is_bound_with_ip_arm = YLeaf(YType.boolean, "is-bound-with-ip-arm")

                    self.is_bound_with_ipv4_rib = YLeaf(YType.boolean, "is-bound-with-ipv4-rib")

                    self.is_bound_with_ipv6_rib = YLeaf(YType.boolean, "is-bound-with-ipv6-rib")

                    self.is_bound_with_lsd = YLeaf(YType.boolean, "is-bound-with-lsd")

                    self.is_bound_with_nsr_mate = YLeaf(YType.boolean, "is-bound-with-nsr-mate")

                    self.is_bound_with_rsi = YLeaf(YType.boolean, "is-bound-with-rsi")

                    self.is_bound_with_sysdb = YLeaf(YType.boolean, "is-bound-with-sysdb")

                    self.is_mldp_registered = YLeaf(YType.boolean, "is-mldp-registered")

                    self.is_nsr_configured = YLeaf(YType.boolean, "is-nsr-configured")

                    self.is_registered_with_interface_manager = YLeaf(YType.boolean, "is-registered-with-interface-manager")

                    self.is_registered_with_ipv4_rib = YLeaf(YType.boolean, "is-registered-with-ipv4-rib")

                    self.is_registered_with_ipv6_rib = YLeaf(YType.boolean, "is-registered-with-ipv6-rib")

                    self.is_registered_with_lsd = YLeaf(YType.boolean, "is-registered-with-lsd")

                    self.is_registered_with_sysdb = YLeaf(YType.boolean, "is-registered-with-sysdb")

                    self.number_of_autocfg_interfaces = YLeaf(YType.uint32, "number-of-autocfg-interfaces")

                    self.number_of_fwd_ref_interfaces = YLeaf(YType.uint32, "number-of-fwd-ref-interfaces")

                    self.number_of_interfaces = YLeaf(YType.uint32, "number-of-interfaces")

                    self.number_of_ipv4rib_tables = YLeaf(YType.uint32, "number-of-ipv4rib-tables")

                    self.number_of_ipv6rib_tables = YLeaf(YType.uint32, "number-of-ipv6rib-tables")

                    self.number_of_registered_ipv4rib_tables = YLeaf(YType.uint32, "number-of-registered-ipv4rib-tables")

                    self.number_of_registered_ipv6rib_tables = YLeaf(YType.uint32, "number-of-registered-ipv6rib-tables")

                    self.number_of_vrf = YLeaf(YType.uint32, "number-of-vrf")

                    self.number_of_vrf_oper = YLeaf(YType.uint32, "number-of-vrf-oper")

                    self.common = MplsLdp.Global_.Active.Summary.Common()
                    self.common.parent = self
                    self._children_name_map["common"] = "common"
                    self._children_yang_names.add("common")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_bound_with_atom",
                                    "is_bound_with_interface_manager",
                                    "is_bound_with_ip_arm",
                                    "is_bound_with_ipv4_rib",
                                    "is_bound_with_ipv6_rib",
                                    "is_bound_with_lsd",
                                    "is_bound_with_nsr_mate",
                                    "is_bound_with_rsi",
                                    "is_bound_with_sysdb",
                                    "is_mldp_registered",
                                    "is_nsr_configured",
                                    "is_registered_with_interface_manager",
                                    "is_registered_with_ipv4_rib",
                                    "is_registered_with_ipv6_rib",
                                    "is_registered_with_lsd",
                                    "is_registered_with_sysdb",
                                    "number_of_autocfg_interfaces",
                                    "number_of_fwd_ref_interfaces",
                                    "number_of_interfaces",
                                    "number_of_ipv4rib_tables",
                                    "number_of_ipv6rib_tables",
                                    "number_of_registered_ipv4rib_tables",
                                    "number_of_registered_ipv6rib_tables",
                                    "number_of_vrf",
                                    "number_of_vrf_oper") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Active.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Active.Summary, self).__setattr__(name, value)


                class Common(Entity):
                    """
                    Common Summary information
                    
                    .. attribute:: address_families
                    
                    	Address Families enabled
                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                    
                    .. attribute:: number_of_bindings_ipv4
                    
                    	Total number of ipv4 bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_bindings_ipv6
                    
                    	Total number of ipv6 bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_downstream_on_demand_neighbors
                    
                    	Number of Downstream\-On\-Demand neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_graceful_restart_neighbors
                    
                    	Number of Graceful Restart neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_hello_adj
                    
                    	Number of LDP discovery IPv4 hello adjacencies
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_local_addresses
                    
                    	Number of IPv4 local addresses
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_routes
                    
                    	Number of resolved IPv4 routes
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4af
                    
                    	Number of IPv4 address\-families enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4ldp_interfaces
                    
                    	Number of LDP IPv4 configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_hello_adj
                    
                    	Number of LDP discovery IPv6 hello adjacencies
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_local_addresses
                    
                    	Number of IPv6 local addresses
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_routes
                    
                    	Number of resolved IPv6 routes
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6af
                    
                    	Number of IPv6 address\-families enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6ldp_interfaces
                    
                    	Number of LDP IPv6 configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ldp_interfaces
                    
                    	Number of LDP configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_local_bindings_ipv4
                    
                    	Total number of ipv4 local label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_local_bindings_ipv6
                    
                    	Total number of ipv6 local label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_neighbors
                    
                    	Number of neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_nsr_synced_neighbors
                    
                    	Number of NSR\-synced/operational neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_remote_bindings_ipv4
                    
                    	Total number of ipv4 remote label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_remote_bindings_ipv6
                    
                    	Total number of ipv6 remote label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.Summary.Common, self).__init__()

                        self.yang_name = "common"
                        self.yang_parent_name = "summary"

                        self.address_families = YLeaf(YType.enumeration, "address-families")

                        self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                        self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                        self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                        self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                        self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                        self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                        self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                        self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                        self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                        self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                        self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                        self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                        self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                        self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                        self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                        self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                        self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                        self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                        self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                        self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                        self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_families",
                                        "number_of_bindings_ipv4",
                                        "number_of_bindings_ipv6",
                                        "number_of_downstream_on_demand_neighbors",
                                        "number_of_graceful_restart_neighbors",
                                        "number_of_ipv4_hello_adj",
                                        "number_of_ipv4_local_addresses",
                                        "number_of_ipv4_routes",
                                        "number_of_ipv4af",
                                        "number_of_ipv4ldp_interfaces",
                                        "number_of_ipv6_hello_adj",
                                        "number_of_ipv6_local_addresses",
                                        "number_of_ipv6_routes",
                                        "number_of_ipv6af",
                                        "number_of_ipv6ldp_interfaces",
                                        "number_of_ldp_interfaces",
                                        "number_of_local_bindings_ipv4",
                                        "number_of_local_bindings_ipv6",
                                        "number_of_neighbors",
                                        "number_of_nsr_synced_neighbors",
                                        "number_of_remote_bindings_ipv4",
                                        "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.Summary.Common, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.Summary.Common, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_families.is_set or
                            self.number_of_bindings_ipv4.is_set or
                            self.number_of_bindings_ipv6.is_set or
                            self.number_of_downstream_on_demand_neighbors.is_set or
                            self.number_of_graceful_restart_neighbors.is_set or
                            self.number_of_ipv4_hello_adj.is_set or
                            self.number_of_ipv4_local_addresses.is_set or
                            self.number_of_ipv4_routes.is_set or
                            self.number_of_ipv4af.is_set or
                            self.number_of_ipv4ldp_interfaces.is_set or
                            self.number_of_ipv6_hello_adj.is_set or
                            self.number_of_ipv6_local_addresses.is_set or
                            self.number_of_ipv6_routes.is_set or
                            self.number_of_ipv6af.is_set or
                            self.number_of_ipv6ldp_interfaces.is_set or
                            self.number_of_ldp_interfaces.is_set or
                            self.number_of_local_bindings_ipv4.is_set or
                            self.number_of_local_bindings_ipv6.is_set or
                            self.number_of_neighbors.is_set or
                            self.number_of_nsr_synced_neighbors.is_set or
                            self.number_of_remote_bindings_ipv4.is_set or
                            self.number_of_remote_bindings_ipv6.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_families.yfilter != YFilter.not_set or
                            self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                            self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                            self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                            self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                            self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                            self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                            self.number_of_ipv4af.yfilter != YFilter.not_set or
                            self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                            self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                            self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                            self.number_of_ipv6af.yfilter != YFilter.not_set or
                            self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                            self.number_of_neighbors.yfilter != YFilter.not_set or
                            self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                            self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "common" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_families.get_name_leafdata())
                        if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                        if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                        if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                        if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                        if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                        if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                        if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                        if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                        if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                        if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                        if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                        if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                        if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                        if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                        if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                        if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                        if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                        if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-families"):
                            self.address_families = value
                            self.address_families.value_namespace = name_space
                            self.address_families.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-bindings-ipv4"):
                            self.number_of_bindings_ipv4 = value
                            self.number_of_bindings_ipv4.value_namespace = name_space
                            self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-bindings-ipv6"):
                            self.number_of_bindings_ipv6 = value
                            self.number_of_bindings_ipv6.value_namespace = name_space
                            self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-downstream-on-demand-neighbors"):
                            self.number_of_downstream_on_demand_neighbors = value
                            self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                            self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-graceful-restart-neighbors"):
                            self.number_of_graceful_restart_neighbors = value
                            self.number_of_graceful_restart_neighbors.value_namespace = name_space
                            self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-hello-adj"):
                            self.number_of_ipv4_hello_adj = value
                            self.number_of_ipv4_hello_adj.value_namespace = name_space
                            self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-local-addresses"):
                            self.number_of_ipv4_local_addresses = value
                            self.number_of_ipv4_local_addresses.value_namespace = name_space
                            self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-routes"):
                            self.number_of_ipv4_routes = value
                            self.number_of_ipv4_routes.value_namespace = name_space
                            self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4af"):
                            self.number_of_ipv4af = value
                            self.number_of_ipv4af.value_namespace = name_space
                            self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4ldp-interfaces"):
                            self.number_of_ipv4ldp_interfaces = value
                            self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                            self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-hello-adj"):
                            self.number_of_ipv6_hello_adj = value
                            self.number_of_ipv6_hello_adj.value_namespace = name_space
                            self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-local-addresses"):
                            self.number_of_ipv6_local_addresses = value
                            self.number_of_ipv6_local_addresses.value_namespace = name_space
                            self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-routes"):
                            self.number_of_ipv6_routes = value
                            self.number_of_ipv6_routes.value_namespace = name_space
                            self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6af"):
                            self.number_of_ipv6af = value
                            self.number_of_ipv6af.value_namespace = name_space
                            self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6ldp-interfaces"):
                            self.number_of_ipv6ldp_interfaces = value
                            self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                            self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ldp-interfaces"):
                            self.number_of_ldp_interfaces = value
                            self.number_of_ldp_interfaces.value_namespace = name_space
                            self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-local-bindings-ipv4"):
                            self.number_of_local_bindings_ipv4 = value
                            self.number_of_local_bindings_ipv4.value_namespace = name_space
                            self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-local-bindings-ipv6"):
                            self.number_of_local_bindings_ipv6 = value
                            self.number_of_local_bindings_ipv6.value_namespace = name_space
                            self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-neighbors"):
                            self.number_of_neighbors = value
                            self.number_of_neighbors.value_namespace = name_space
                            self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-nsr-synced-neighbors"):
                            self.number_of_nsr_synced_neighbors = value
                            self.number_of_nsr_synced_neighbors.value_namespace = name_space
                            self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-remote-bindings-ipv4"):
                            self.number_of_remote_bindings_ipv4 = value
                            self.number_of_remote_bindings_ipv4.value_namespace = name_space
                            self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-remote-bindings-ipv6"):
                            self.number_of_remote_bindings_ipv6 = value
                            self.number_of_remote_bindings_ipv6.value_namespace = name_space
                            self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.is_bound_with_atom.is_set or
                        self.is_bound_with_interface_manager.is_set or
                        self.is_bound_with_ip_arm.is_set or
                        self.is_bound_with_ipv4_rib.is_set or
                        self.is_bound_with_ipv6_rib.is_set or
                        self.is_bound_with_lsd.is_set or
                        self.is_bound_with_nsr_mate.is_set or
                        self.is_bound_with_rsi.is_set or
                        self.is_bound_with_sysdb.is_set or
                        self.is_mldp_registered.is_set or
                        self.is_nsr_configured.is_set or
                        self.is_registered_with_interface_manager.is_set or
                        self.is_registered_with_ipv4_rib.is_set or
                        self.is_registered_with_ipv6_rib.is_set or
                        self.is_registered_with_lsd.is_set or
                        self.is_registered_with_sysdb.is_set or
                        self.number_of_autocfg_interfaces.is_set or
                        self.number_of_fwd_ref_interfaces.is_set or
                        self.number_of_interfaces.is_set or
                        self.number_of_ipv4rib_tables.is_set or
                        self.number_of_ipv6rib_tables.is_set or
                        self.number_of_registered_ipv4rib_tables.is_set or
                        self.number_of_registered_ipv6rib_tables.is_set or
                        self.number_of_vrf.is_set or
                        self.number_of_vrf_oper.is_set or
                        (self.common is not None and self.common.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_bound_with_atom.yfilter != YFilter.not_set or
                        self.is_bound_with_interface_manager.yfilter != YFilter.not_set or
                        self.is_bound_with_ip_arm.yfilter != YFilter.not_set or
                        self.is_bound_with_ipv4_rib.yfilter != YFilter.not_set or
                        self.is_bound_with_ipv6_rib.yfilter != YFilter.not_set or
                        self.is_bound_with_lsd.yfilter != YFilter.not_set or
                        self.is_bound_with_nsr_mate.yfilter != YFilter.not_set or
                        self.is_bound_with_rsi.yfilter != YFilter.not_set or
                        self.is_bound_with_sysdb.yfilter != YFilter.not_set or
                        self.is_mldp_registered.yfilter != YFilter.not_set or
                        self.is_nsr_configured.yfilter != YFilter.not_set or
                        self.is_registered_with_interface_manager.yfilter != YFilter.not_set or
                        self.is_registered_with_ipv4_rib.yfilter != YFilter.not_set or
                        self.is_registered_with_ipv6_rib.yfilter != YFilter.not_set or
                        self.is_registered_with_lsd.yfilter != YFilter.not_set or
                        self.is_registered_with_sysdb.yfilter != YFilter.not_set or
                        self.number_of_autocfg_interfaces.yfilter != YFilter.not_set or
                        self.number_of_fwd_ref_interfaces.yfilter != YFilter.not_set or
                        self.number_of_interfaces.yfilter != YFilter.not_set or
                        self.number_of_ipv4rib_tables.yfilter != YFilter.not_set or
                        self.number_of_ipv6rib_tables.yfilter != YFilter.not_set or
                        self.number_of_registered_ipv4rib_tables.yfilter != YFilter.not_set or
                        self.number_of_registered_ipv6rib_tables.yfilter != YFilter.not_set or
                        self.number_of_vrf.yfilter != YFilter.not_set or
                        self.number_of_vrf_oper.yfilter != YFilter.not_set or
                        (self.common is not None and self.common.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_bound_with_atom.is_set or self.is_bound_with_atom.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_atom.get_name_leafdata())
                    if (self.is_bound_with_interface_manager.is_set or self.is_bound_with_interface_manager.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_interface_manager.get_name_leafdata())
                    if (self.is_bound_with_ip_arm.is_set or self.is_bound_with_ip_arm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ip_arm.get_name_leafdata())
                    if (self.is_bound_with_ipv4_rib.is_set or self.is_bound_with_ipv4_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ipv4_rib.get_name_leafdata())
                    if (self.is_bound_with_ipv6_rib.is_set or self.is_bound_with_ipv6_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ipv6_rib.get_name_leafdata())
                    if (self.is_bound_with_lsd.is_set or self.is_bound_with_lsd.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_lsd.get_name_leafdata())
                    if (self.is_bound_with_nsr_mate.is_set or self.is_bound_with_nsr_mate.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_nsr_mate.get_name_leafdata())
                    if (self.is_bound_with_rsi.is_set or self.is_bound_with_rsi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_rsi.get_name_leafdata())
                    if (self.is_bound_with_sysdb.is_set or self.is_bound_with_sysdb.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_sysdb.get_name_leafdata())
                    if (self.is_mldp_registered.is_set or self.is_mldp_registered.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_mldp_registered.get_name_leafdata())
                    if (self.is_nsr_configured.is_set or self.is_nsr_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_nsr_configured.get_name_leafdata())
                    if (self.is_registered_with_interface_manager.is_set or self.is_registered_with_interface_manager.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_interface_manager.get_name_leafdata())
                    if (self.is_registered_with_ipv4_rib.is_set or self.is_registered_with_ipv4_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_ipv4_rib.get_name_leafdata())
                    if (self.is_registered_with_ipv6_rib.is_set or self.is_registered_with_ipv6_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_ipv6_rib.get_name_leafdata())
                    if (self.is_registered_with_lsd.is_set or self.is_registered_with_lsd.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_lsd.get_name_leafdata())
                    if (self.is_registered_with_sysdb.is_set or self.is_registered_with_sysdb.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_sysdb.get_name_leafdata())
                    if (self.number_of_autocfg_interfaces.is_set or self.number_of_autocfg_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_autocfg_interfaces.get_name_leafdata())
                    if (self.number_of_fwd_ref_interfaces.is_set or self.number_of_fwd_ref_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_fwd_ref_interfaces.get_name_leafdata())
                    if (self.number_of_interfaces.is_set or self.number_of_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_interfaces.get_name_leafdata())
                    if (self.number_of_ipv4rib_tables.is_set or self.number_of_ipv4rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_ipv4rib_tables.get_name_leafdata())
                    if (self.number_of_ipv6rib_tables.is_set or self.number_of_ipv6rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_ipv6rib_tables.get_name_leafdata())
                    if (self.number_of_registered_ipv4rib_tables.is_set or self.number_of_registered_ipv4rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_registered_ipv4rib_tables.get_name_leafdata())
                    if (self.number_of_registered_ipv6rib_tables.is_set or self.number_of_registered_ipv6rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_registered_ipv6rib_tables.get_name_leafdata())
                    if (self.number_of_vrf.is_set or self.number_of_vrf.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_vrf.get_name_leafdata())
                    if (self.number_of_vrf_oper.is_set or self.number_of_vrf_oper.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_vrf_oper.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "common"):
                        if (self.common is None):
                            self.common = MplsLdp.Global_.Active.Summary.Common()
                            self.common.parent = self
                            self._children_name_map["common"] = "common"
                        return self.common

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "common" or name == "is-bound-with-atom" or name == "is-bound-with-interface-manager" or name == "is-bound-with-ip-arm" or name == "is-bound-with-ipv4-rib" or name == "is-bound-with-ipv6-rib" or name == "is-bound-with-lsd" or name == "is-bound-with-nsr-mate" or name == "is-bound-with-rsi" or name == "is-bound-with-sysdb" or name == "is-mldp-registered" or name == "is-nsr-configured" or name == "is-registered-with-interface-manager" or name == "is-registered-with-ipv4-rib" or name == "is-registered-with-ipv6-rib" or name == "is-registered-with-lsd" or name == "is-registered-with-sysdb" or name == "number-of-autocfg-interfaces" or name == "number-of-fwd-ref-interfaces" or name == "number-of-interfaces" or name == "number-of-ipv4rib-tables" or name == "number-of-ipv6rib-tables" or name == "number-of-registered-ipv4rib-tables" or name == "number-of-registered-ipv6rib-tables" or name == "number-of-vrf" or name == "number-of-vrf-oper"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-bound-with-atom"):
                        self.is_bound_with_atom = value
                        self.is_bound_with_atom.value_namespace = name_space
                        self.is_bound_with_atom.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-interface-manager"):
                        self.is_bound_with_interface_manager = value
                        self.is_bound_with_interface_manager.value_namespace = name_space
                        self.is_bound_with_interface_manager.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ip-arm"):
                        self.is_bound_with_ip_arm = value
                        self.is_bound_with_ip_arm.value_namespace = name_space
                        self.is_bound_with_ip_arm.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ipv4-rib"):
                        self.is_bound_with_ipv4_rib = value
                        self.is_bound_with_ipv4_rib.value_namespace = name_space
                        self.is_bound_with_ipv4_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ipv6-rib"):
                        self.is_bound_with_ipv6_rib = value
                        self.is_bound_with_ipv6_rib.value_namespace = name_space
                        self.is_bound_with_ipv6_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-lsd"):
                        self.is_bound_with_lsd = value
                        self.is_bound_with_lsd.value_namespace = name_space
                        self.is_bound_with_lsd.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-nsr-mate"):
                        self.is_bound_with_nsr_mate = value
                        self.is_bound_with_nsr_mate.value_namespace = name_space
                        self.is_bound_with_nsr_mate.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-rsi"):
                        self.is_bound_with_rsi = value
                        self.is_bound_with_rsi.value_namespace = name_space
                        self.is_bound_with_rsi.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-sysdb"):
                        self.is_bound_with_sysdb = value
                        self.is_bound_with_sysdb.value_namespace = name_space
                        self.is_bound_with_sysdb.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-mldp-registered"):
                        self.is_mldp_registered = value
                        self.is_mldp_registered.value_namespace = name_space
                        self.is_mldp_registered.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-nsr-configured"):
                        self.is_nsr_configured = value
                        self.is_nsr_configured.value_namespace = name_space
                        self.is_nsr_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-interface-manager"):
                        self.is_registered_with_interface_manager = value
                        self.is_registered_with_interface_manager.value_namespace = name_space
                        self.is_registered_with_interface_manager.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-ipv4-rib"):
                        self.is_registered_with_ipv4_rib = value
                        self.is_registered_with_ipv4_rib.value_namespace = name_space
                        self.is_registered_with_ipv4_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-ipv6-rib"):
                        self.is_registered_with_ipv6_rib = value
                        self.is_registered_with_ipv6_rib.value_namespace = name_space
                        self.is_registered_with_ipv6_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-lsd"):
                        self.is_registered_with_lsd = value
                        self.is_registered_with_lsd.value_namespace = name_space
                        self.is_registered_with_lsd.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-sysdb"):
                        self.is_registered_with_sysdb = value
                        self.is_registered_with_sysdb.value_namespace = name_space
                        self.is_registered_with_sysdb.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-autocfg-interfaces"):
                        self.number_of_autocfg_interfaces = value
                        self.number_of_autocfg_interfaces.value_namespace = name_space
                        self.number_of_autocfg_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-fwd-ref-interfaces"):
                        self.number_of_fwd_ref_interfaces = value
                        self.number_of_fwd_ref_interfaces.value_namespace = name_space
                        self.number_of_fwd_ref_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-interfaces"):
                        self.number_of_interfaces = value
                        self.number_of_interfaces.value_namespace = name_space
                        self.number_of_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-ipv4rib-tables"):
                        self.number_of_ipv4rib_tables = value
                        self.number_of_ipv4rib_tables.value_namespace = name_space
                        self.number_of_ipv4rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-ipv6rib-tables"):
                        self.number_of_ipv6rib_tables = value
                        self.number_of_ipv6rib_tables.value_namespace = name_space
                        self.number_of_ipv6rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-registered-ipv4rib-tables"):
                        self.number_of_registered_ipv4rib_tables = value
                        self.number_of_registered_ipv4rib_tables.value_namespace = name_space
                        self.number_of_registered_ipv4rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-registered-ipv6rib-tables"):
                        self.number_of_registered_ipv6rib_tables = value
                        self.number_of_registered_ipv6rib_tables.value_namespace = name_space
                        self.number_of_registered_ipv6rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-vrf"):
                        self.number_of_vrf = value
                        self.number_of_vrf.value_namespace = name_space
                        self.number_of_vrf.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-vrf-oper"):
                        self.number_of_vrf_oper = value
                        self.number_of_vrf_oper.value_namespace = name_space
                        self.number_of_vrf_oper.value_namespace_prefix = name_space_prefix


            class Vrfs(Entity):
                """
                VRF specific operational data
                
                .. attribute:: vrf
                
                	Operational data for given VRF
                	**type**\: list of    :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.Vrfs, self).__init__()

                    self.yang_name = "vrfs"
                    self.yang_parent_name = "active"

                    self.vrf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Active.Vrfs, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Active.Vrfs, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    Operational data for given VRF
                    
                    .. attribute:: vrf_name  <key>
                    
                    	VRF Name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: afs
                    
                    	Address Family specific operational data
                    	**type**\:   :py:class:`Afs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs>`
                    
                    .. attribute:: backoff_parameters
                    
                    	The LDP Backoff Parameters
                    	**type**\:   :py:class:`BackoffParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.BackoffParameters>`
                    
                    .. attribute:: backoffs
                    
                    	The LDP backoff
                    	**type**\:   :py:class:`Backoffs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs>`
                    
                    .. attribute:: capabilities
                    
                    	LDP capability database information
                    	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities>`
                    
                    .. attribute:: graceful_restart
                    
                    	LDP Graceful Restart info
                    	**type**\:   :py:class:`GracefulRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart>`
                    
                    .. attribute:: issu
                    
                    	LDP ISSU related information
                    	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu>`
                    
                    .. attribute:: ldp_id
                    
                    	Local LDP Id
                    	**type**\:   :py:class:`LdpId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.LdpId>`
                    
                    .. attribute:: neighbor_briefs
                    
                    	The LDP Neighbors (brief)
                    	**type**\:   :py:class:`NeighborBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs>`
                    
                    .. attribute:: neighbor_capabilities
                    
                    	LDP Neighbors Capabilities
                    	**type**\:   :py:class:`NeighborCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities>`
                    
                    .. attribute:: neighbors
                    
                    	The LDP Neighbors
                    	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors>`
                    
                    .. attribute:: nsr
                    
                    	LDP NSR related information
                    	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr>`
                    
                    .. attribute:: parameters
                    
                    	LDP parameters
                    	**type**\:   :py:class:`Parameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Parameters>`
                    
                    .. attribute:: statistics
                    
                    	The LDP Statistics
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Statistics>`
                    
                    .. attribute:: summary
                    
                    	LDP VRF summary
                    	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Summary>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.Vrfs.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "vrfs"

                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                        self.afs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs()
                        self.afs.parent = self
                        self._children_name_map["afs"] = "afs"
                        self._children_yang_names.add("afs")

                        self.backoff_parameters = MplsLdp.Global_.Active.Vrfs.Vrf.BackoffParameters()
                        self.backoff_parameters.parent = self
                        self._children_name_map["backoff_parameters"] = "backoff-parameters"
                        self._children_yang_names.add("backoff-parameters")

                        self.backoffs = MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs()
                        self.backoffs.parent = self
                        self._children_name_map["backoffs"] = "backoffs"
                        self._children_yang_names.add("backoffs")

                        self.capabilities = MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities()
                        self.capabilities.parent = self
                        self._children_name_map["capabilities"] = "capabilities"
                        self._children_yang_names.add("capabilities")

                        self.graceful_restart = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart()
                        self.graceful_restart.parent = self
                        self._children_name_map["graceful_restart"] = "graceful-restart"
                        self._children_yang_names.add("graceful-restart")

                        self.issu = MplsLdp.Global_.Active.Vrfs.Vrf.Issu()
                        self.issu.parent = self
                        self._children_name_map["issu"] = "issu"
                        self._children_yang_names.add("issu")

                        self.ldp_id = MplsLdp.Global_.Active.Vrfs.Vrf.LdpId()
                        self.ldp_id.parent = self
                        self._children_name_map["ldp_id"] = "ldp-id"
                        self._children_yang_names.add("ldp-id")

                        self.neighbor_briefs = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs()
                        self.neighbor_briefs.parent = self
                        self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                        self._children_yang_names.add("neighbor-briefs")

                        self.neighbor_capabilities = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities()
                        self.neighbor_capabilities.parent = self
                        self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                        self._children_yang_names.add("neighbor-capabilities")

                        self.neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors()
                        self.neighbors.parent = self
                        self._children_name_map["neighbors"] = "neighbors"
                        self._children_yang_names.add("neighbors")

                        self.nsr = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr()
                        self.nsr.parent = self
                        self._children_name_map["nsr"] = "nsr"
                        self._children_yang_names.add("nsr")

                        self.parameters = MplsLdp.Global_.Active.Vrfs.Vrf.Parameters()
                        self.parameters.parent = self
                        self._children_name_map["parameters"] = "parameters"
                        self._children_yang_names.add("parameters")

                        self.statistics = MplsLdp.Global_.Active.Vrfs.Vrf.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                        self.summary = MplsLdp.Global_.Active.Vrfs.Vrf.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                        self._children_yang_names.add("summary")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("vrf_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.Vrfs.Vrf, self).__setattr__(name, value)


                    class GracefulRestart(Entity):
                        """
                        LDP Graceful Restart info
                        
                        .. attribute:: forwarding_state_hold_timer_remaining_seconds
                        
                        	Forwarding state hold timer remaining time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: graceful_restartable_neighbor
                        
                        	Vector of graceful restart neighbor information
                        	**type**\: list of    :py:class:`GracefulRestartableNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor>`
                        
                        .. attribute:: is_forwarding_state_hold_timer_running
                        
                        	Is graceful restart forwarding state hold timer running
                        	**type**\:  bool
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart, self).__init__()

                            self.yang_name = "graceful-restart"
                            self.yang_parent_name = "vrf"

                            self.forwarding_state_hold_timer_remaining_seconds = YLeaf(YType.uint32, "forwarding-state-hold-timer-remaining-seconds")

                            self.is_forwarding_state_hold_timer_running = YLeaf(YType.boolean, "is-forwarding-state-hold-timer-running")

                            self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")

                            self.graceful_restartable_neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("forwarding_state_hold_timer_remaining_seconds",
                                            "is_forwarding_state_hold_timer_running") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart, self).__setattr__(name, value)


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "graceful-restart"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class GracefulRestartableNeighbor(Entity):
                            """
                            Vector of graceful restart neighbor information
                            
                            .. attribute:: connect_count
                            
                            	ConnectCount
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_address
                            
                            	Addresses bound to GR down Nbr
                            	**type**\: list of    :py:class:`DownNbrAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress>`
                            
                            .. attribute:: down_nbr_down_reason
                            
                            	Session down reason code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_flags
                            
                            	Flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_flap_count
                            
                            	Count of back2back flaps
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: down_nbr_interface
                            
                            	Interfaces bound to GR down Nbr
                            	**type**\: list of    :py:class:`DownNbrInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface>`
                            
                            .. attribute:: gr_peer
                            
                            	GR peer LDP Id
                            	**type**\:   :py:class:`GrPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer>`
                            
                            .. attribute:: is_liveness_timer_running
                            
                            	Is liveness timer running
                            	**type**\:  bool
                            
                            .. attribute:: is_neighbor_up
                            
                            	Is neighbor up
                            	**type**\:  bool
                            
                            .. attribute:: is_recovery_timer_running
                            
                            	Is recovery timer running
                            	**type**\:  bool
                            
                            .. attribute:: liveness_timer_remaining_seconds
                            
                            	Remaining time from liveness timer
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: recovery_timer_remaining_seconds
                            
                            	Recovery timer remining time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__init__()

                                self.yang_name = "graceful-restartable-neighbor"
                                self.yang_parent_name = "graceful-restart"

                                self.connect_count = YLeaf(YType.uint32, "connect-count")

                                self.down_nbr_down_reason = YLeaf(YType.uint32, "down-nbr-down-reason")

                                self.down_nbr_flags = YLeaf(YType.uint32, "down-nbr-flags")

                                self.down_nbr_flap_count = YLeaf(YType.uint8, "down-nbr-flap-count")

                                self.is_liveness_timer_running = YLeaf(YType.boolean, "is-liveness-timer-running")

                                self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                                self.is_recovery_timer_running = YLeaf(YType.boolean, "is-recovery-timer-running")

                                self.liveness_timer_remaining_seconds = YLeaf(YType.uint32, "liveness-timer-remaining-seconds")

                                self.recovery_timer_remaining_seconds = YLeaf(YType.uint32, "recovery-timer-remaining-seconds")

                                self.gr_peer = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                self.gr_peer.parent = self
                                self._children_name_map["gr_peer"] = "gr-peer"
                                self._children_yang_names.add("gr-peer")

                                self.down_nbr_address = YList(self)
                                self.down_nbr_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("connect_count",
                                                "down_nbr_down_reason",
                                                "down_nbr_flags",
                                                "down_nbr_flap_count",
                                                "is_liveness_timer_running",
                                                "is_neighbor_up",
                                                "is_recovery_timer_running",
                                                "liveness_timer_remaining_seconds",
                                                "recovery_timer_remaining_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)


                            class GrPeer(Entity):
                                """
                                GR peer LDP Id
                                
                                .. attribute:: label_space_id
                                
                                	Label space identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: ldp_id
                                
                                	LDP identifier
                                	**type**\:  str
                                
                                .. attribute:: lsr_id
                                
                                	LSR identifier
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__init__()

                                    self.yang_name = "gr-peer"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                    self.ldp_id = YLeaf(YType.str, "ldp-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "ldp_id",
                                                    "lsr_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.ldp_id.is_set or
                                        self.lsr_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.ldp_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "gr-peer" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-id"):
                                        self.ldp_id = value
                                        self.ldp_id.value_namespace = name_space
                                        self.ldp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix


                            class DownNbrInterface(Entity):
                                """
                                Interfaces bound to GR down Nbr
                                
                                .. attribute:: address_family
                                
                                	Interface adj Address Family
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: interface_handle
                                
                                	Interfaces handle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__init__()

                                    self.yang_name = "down-nbr-interface"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.interface_handle = YLeaf(YType.str, "interface-handle")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "interface_handle") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.interface_handle.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.interface_handle.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "down-nbr-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_handle.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "interface-handle"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-handle"):
                                        self.interface_handle = value
                                        self.interface_handle.value_namespace = name_space
                                        self.interface_handle.value_namespace_prefix = name_space_prefix


                            class DownNbrAddress(Entity):
                                """
                                Addresses bound to GR down Nbr
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__init__()

                                    self.yang_name = "down-nbr-address"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "down-nbr-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.down_nbr_address:
                                    if (c.has_data()):
                                        return True
                                for c in self.down_nbr_interface:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.connect_count.is_set or
                                    self.down_nbr_down_reason.is_set or
                                    self.down_nbr_flags.is_set or
                                    self.down_nbr_flap_count.is_set or
                                    self.is_liveness_timer_running.is_set or
                                    self.is_neighbor_up.is_set or
                                    self.is_recovery_timer_running.is_set or
                                    self.liveness_timer_remaining_seconds.is_set or
                                    self.recovery_timer_remaining_seconds.is_set or
                                    (self.gr_peer is not None and self.gr_peer.has_data()))

                            def has_operation(self):
                                for c in self.down_nbr_address:
                                    if (c.has_operation()):
                                        return True
                                for c in self.down_nbr_interface:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.connect_count.yfilter != YFilter.not_set or
                                    self.down_nbr_down_reason.yfilter != YFilter.not_set or
                                    self.down_nbr_flags.yfilter != YFilter.not_set or
                                    self.down_nbr_flap_count.yfilter != YFilter.not_set or
                                    self.is_liveness_timer_running.yfilter != YFilter.not_set or
                                    self.is_neighbor_up.yfilter != YFilter.not_set or
                                    self.is_recovery_timer_running.yfilter != YFilter.not_set or
                                    self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set or
                                    self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set or
                                    (self.gr_peer is not None and self.gr_peer.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "graceful-restartable-neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.connect_count.get_name_leafdata())
                                if (self.down_nbr_down_reason.is_set or self.down_nbr_down_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_down_reason.get_name_leafdata())
                                if (self.down_nbr_flags.is_set or self.down_nbr_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_flags.get_name_leafdata())
                                if (self.down_nbr_flap_count.is_set or self.down_nbr_flap_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_flap_count.get_name_leafdata())
                                if (self.is_liveness_timer_running.is_set or self.is_liveness_timer_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_liveness_timer_running.get_name_leafdata())
                                if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                                if (self.is_recovery_timer_running.is_set or self.is_recovery_timer_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_recovery_timer_running.get_name_leafdata())
                                if (self.liveness_timer_remaining_seconds.is_set or self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.liveness_timer_remaining_seconds.get_name_leafdata())
                                if (self.recovery_timer_remaining_seconds.is_set or self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.recovery_timer_remaining_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "down-nbr-address"):
                                    for c in self.down_nbr_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.down_nbr_address.append(c)
                                    return c

                                if (child_yang_name == "down-nbr-interface"):
                                    for c in self.down_nbr_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.down_nbr_interface.append(c)
                                    return c

                                if (child_yang_name == "gr-peer"):
                                    if (self.gr_peer is None):
                                        self.gr_peer = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                        self.gr_peer.parent = self
                                        self._children_name_map["gr_peer"] = "gr-peer"
                                    return self.gr_peer

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "down-nbr-address" or name == "down-nbr-interface" or name == "gr-peer" or name == "connect-count" or name == "down-nbr-down-reason" or name == "down-nbr-flags" or name == "down-nbr-flap-count" or name == "is-liveness-timer-running" or name == "is-neighbor-up" or name == "is-recovery-timer-running" or name == "liveness-timer-remaining-seconds" or name == "recovery-timer-remaining-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "connect-count"):
                                    self.connect_count = value
                                    self.connect_count.value_namespace = name_space
                                    self.connect_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-down-reason"):
                                    self.down_nbr_down_reason = value
                                    self.down_nbr_down_reason.value_namespace = name_space
                                    self.down_nbr_down_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-flags"):
                                    self.down_nbr_flags = value
                                    self.down_nbr_flags.value_namespace = name_space
                                    self.down_nbr_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-flap-count"):
                                    self.down_nbr_flap_count = value
                                    self.down_nbr_flap_count.value_namespace = name_space
                                    self.down_nbr_flap_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-liveness-timer-running"):
                                    self.is_liveness_timer_running = value
                                    self.is_liveness_timer_running.value_namespace = name_space
                                    self.is_liveness_timer_running.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-up"):
                                    self.is_neighbor_up = value
                                    self.is_neighbor_up.value_namespace = name_space
                                    self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-recovery-timer-running"):
                                    self.is_recovery_timer_running = value
                                    self.is_recovery_timer_running.value_namespace = name_space
                                    self.is_recovery_timer_running.value_namespace_prefix = name_space_prefix
                                if(value_path == "liveness-timer-remaining-seconds"):
                                    self.liveness_timer_remaining_seconds = value
                                    self.liveness_timer_remaining_seconds.value_namespace = name_space
                                    self.liveness_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                                if(value_path == "recovery-timer-remaining-seconds"):
                                    self.recovery_timer_remaining_seconds = value
                                    self.recovery_timer_remaining_seconds.value_namespace = name_space
                                    self.recovery_timer_remaining_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.graceful_restartable_neighbor:
                                if (c.has_data()):
                                    return True
                            return (
                                self.forwarding_state_hold_timer_remaining_seconds.is_set or
                                self.is_forwarding_state_hold_timer_running.is_set or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            for c in self.graceful_restartable_neighbor:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set or
                                self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restart" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.forwarding_state_hold_timer_remaining_seconds.is_set or self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.forwarding_state_hold_timer_remaining_seconds.get_name_leafdata())
                            if (self.is_forwarding_state_hold_timer_running.is_set or self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_forwarding_state_hold_timer_running.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "graceful-restartable-neighbor"):
                                for c in self.graceful_restartable_neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.graceful_restartable_neighbor.append(c)
                                return c

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "graceful-restartable-neighbor" or name == "vrf" or name == "forwarding-state-hold-timer-remaining-seconds" or name == "is-forwarding-state-hold-timer-running"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "forwarding-state-hold-timer-remaining-seconds"):
                                self.forwarding_state_hold_timer_remaining_seconds = value
                                self.forwarding_state_hold_timer_remaining_seconds.value_namespace = name_space
                                self.forwarding_state_hold_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-forwarding-state-hold-timer-running"):
                                self.is_forwarding_state_hold_timer_running = value
                                self.is_forwarding_state_hold_timer_running.value_namespace = name_space
                                self.is_forwarding_state_hold_timer_running.value_namespace_prefix = name_space_prefix


                    class Capabilities(Entity):
                        """
                        LDP capability database information
                        
                        .. attribute:: capability
                        
                        	Information on LDP capability
                        	**type**\: list of    :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities, self).__init__()

                            self.yang_name = "capabilities"
                            self.yang_parent_name = "vrf"

                            self.capability = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities, self).__setattr__(name, value)


                        class Capability(Entity):
                            """
                            Information on LDP capability
                            
                            .. attribute:: capability_type  <key>
                            
                            	The capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: capability
                            
                            	Capability information
                            	**type**\:   :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability.Capability>`
                            
                            .. attribute:: capability_owner
                            
                            	Capability owner
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability, self).__init__()

                                self.yang_name = "capability"
                                self.yang_parent_name = "capabilities"

                                self.capability_type = YLeaf(YType.int32, "capability-type")

                                self.capability_owner = YLeaf(YType.str, "capability-owner")

                                self.capability = MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability.Capability()
                                self.capability.parent = self
                                self._children_name_map["capability"] = "capability"
                                self._children_yang_names.add("capability")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_type",
                                                "capability_owner") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability, self).__setattr__(name, value)


                            class Capability(Entity):
                                """
                                Capability information
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability.Capability, self).__init__()

                                    self.yang_name = "capability"
                                    self.yang_parent_name = "capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability.Capability, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability.Capability, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "capability" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.capability_type.is_set or
                                    self.capability_owner.is_set or
                                    (self.capability is not None and self.capability.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_type.yfilter != YFilter.not_set or
                                    self.capability_owner.yfilter != YFilter.not_set or
                                    (self.capability is not None and self.capability.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "capability" + "[capability-type='" + self.capability_type.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_type.is_set or self.capability_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_type.get_name_leafdata())
                                if (self.capability_owner.is_set or self.capability_owner.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_owner.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "capability"):
                                    if (self.capability is None):
                                        self.capability = MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability.Capability()
                                        self.capability.parent = self
                                        self._children_name_map["capability"] = "capability"
                                    return self.capability

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability" or name == "capability-type" or name == "capability-owner"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-type"):
                                    self.capability_type = value
                                    self.capability_type.value_namespace = name_space
                                    self.capability_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-owner"):
                                    self.capability_owner = value
                                    self.capability_owner.value_namespace = name_space
                                    self.capability_owner.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.capability:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.capability:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "capabilities" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "capability"):
                                for c in self.capability:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities.Capability()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.capability.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Summary(Entity):
                        """
                        LDP VRF summary
                        
                        .. attribute:: common
                        
                        	Common Summary information
                        	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Common>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Summary, self).__init__()

                            self.yang_name = "summary"
                            self.yang_parent_name = "vrf"

                            self.common = MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Common()
                            self.common.parent = self
                            self._children_name_map["common"] = "common"
                            self._children_yang_names.add("common")

                            self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Common(Entity):
                            """
                            Common Summary information
                            
                            .. attribute:: address_families
                            
                            	Address Families enabled
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: number_of_bindings_ipv4
                            
                            	Total number of ipv4 bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_bindings_ipv6
                            
                            	Total number of ipv6 bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_downstream_on_demand_neighbors
                            
                            	Number of Downstream\-On\-Demand neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_graceful_restart_neighbors
                            
                            	Number of Graceful Restart neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_hello_adj
                            
                            	Number of LDP discovery IPv4 hello adjacencies
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_local_addresses
                            
                            	Number of IPv4 local addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_routes
                            
                            	Number of resolved IPv4 routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4af
                            
                            	Number of IPv4 address\-families enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4ldp_interfaces
                            
                            	Number of LDP IPv4 configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_hello_adj
                            
                            	Number of LDP discovery IPv6 hello adjacencies
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_local_addresses
                            
                            	Number of IPv6 local addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_routes
                            
                            	Number of resolved IPv6 routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6af
                            
                            	Number of IPv6 address\-families enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6ldp_interfaces
                            
                            	Number of LDP IPv6 configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ldp_interfaces
                            
                            	Number of LDP configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_local_bindings_ipv4
                            
                            	Total number of ipv4 local label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_local_bindings_ipv6
                            
                            	Total number of ipv6 local label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_neighbors
                            
                            	Number of neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_nsr_synced_neighbors
                            
                            	Number of NSR\-synced/operational neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_remote_bindings_ipv4
                            
                            	Total number of ipv4 remote label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_remote_bindings_ipv6
                            
                            	Total number of ipv6 remote label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Common, self).__init__()

                                self.yang_name = "common"
                                self.yang_parent_name = "summary"

                                self.address_families = YLeaf(YType.enumeration, "address-families")

                                self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                                self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                                self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                                self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                                self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                                self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                                self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                                self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                                self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                                self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                                self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                                self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                                self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                                self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                                self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                                self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                                self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                                self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                                self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                                self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                                self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_families",
                                                "number_of_bindings_ipv4",
                                                "number_of_bindings_ipv6",
                                                "number_of_downstream_on_demand_neighbors",
                                                "number_of_graceful_restart_neighbors",
                                                "number_of_ipv4_hello_adj",
                                                "number_of_ipv4_local_addresses",
                                                "number_of_ipv4_routes",
                                                "number_of_ipv4af",
                                                "number_of_ipv4ldp_interfaces",
                                                "number_of_ipv6_hello_adj",
                                                "number_of_ipv6_local_addresses",
                                                "number_of_ipv6_routes",
                                                "number_of_ipv6af",
                                                "number_of_ipv6ldp_interfaces",
                                                "number_of_ldp_interfaces",
                                                "number_of_local_bindings_ipv4",
                                                "number_of_local_bindings_ipv6",
                                                "number_of_neighbors",
                                                "number_of_nsr_synced_neighbors",
                                                "number_of_remote_bindings_ipv4",
                                                "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Common, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Common, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_families.is_set or
                                    self.number_of_bindings_ipv4.is_set or
                                    self.number_of_bindings_ipv6.is_set or
                                    self.number_of_downstream_on_demand_neighbors.is_set or
                                    self.number_of_graceful_restart_neighbors.is_set or
                                    self.number_of_ipv4_hello_adj.is_set or
                                    self.number_of_ipv4_local_addresses.is_set or
                                    self.number_of_ipv4_routes.is_set or
                                    self.number_of_ipv4af.is_set or
                                    self.number_of_ipv4ldp_interfaces.is_set or
                                    self.number_of_ipv6_hello_adj.is_set or
                                    self.number_of_ipv6_local_addresses.is_set or
                                    self.number_of_ipv6_routes.is_set or
                                    self.number_of_ipv6af.is_set or
                                    self.number_of_ipv6ldp_interfaces.is_set or
                                    self.number_of_ldp_interfaces.is_set or
                                    self.number_of_local_bindings_ipv4.is_set or
                                    self.number_of_local_bindings_ipv6.is_set or
                                    self.number_of_neighbors.is_set or
                                    self.number_of_nsr_synced_neighbors.is_set or
                                    self.number_of_remote_bindings_ipv4.is_set or
                                    self.number_of_remote_bindings_ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_families.yfilter != YFilter.not_set or
                                    self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                                    self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                                    self.number_of_ipv4af.yfilter != YFilter.not_set or
                                    self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                                    self.number_of_ipv6af.yfilter != YFilter.not_set or
                                    self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                                    self.number_of_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "common" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_families.get_name_leafdata())
                                if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                                if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                                if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                                if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                                if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                                if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                                if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                                if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                                if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                                if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                                if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                                if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                                if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                                if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                                if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                                if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                                if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                                if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-families"):
                                    self.address_families = value
                                    self.address_families.value_namespace = name_space
                                    self.address_families.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-bindings-ipv4"):
                                    self.number_of_bindings_ipv4 = value
                                    self.number_of_bindings_ipv4.value_namespace = name_space
                                    self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-bindings-ipv6"):
                                    self.number_of_bindings_ipv6 = value
                                    self.number_of_bindings_ipv6.value_namespace = name_space
                                    self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-downstream-on-demand-neighbors"):
                                    self.number_of_downstream_on_demand_neighbors = value
                                    self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                                    self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-graceful-restart-neighbors"):
                                    self.number_of_graceful_restart_neighbors = value
                                    self.number_of_graceful_restart_neighbors.value_namespace = name_space
                                    self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-hello-adj"):
                                    self.number_of_ipv4_hello_adj = value
                                    self.number_of_ipv4_hello_adj.value_namespace = name_space
                                    self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-local-addresses"):
                                    self.number_of_ipv4_local_addresses = value
                                    self.number_of_ipv4_local_addresses.value_namespace = name_space
                                    self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-routes"):
                                    self.number_of_ipv4_routes = value
                                    self.number_of_ipv4_routes.value_namespace = name_space
                                    self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4af"):
                                    self.number_of_ipv4af = value
                                    self.number_of_ipv4af.value_namespace = name_space
                                    self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4ldp-interfaces"):
                                    self.number_of_ipv4ldp_interfaces = value
                                    self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                                    self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-hello-adj"):
                                    self.number_of_ipv6_hello_adj = value
                                    self.number_of_ipv6_hello_adj.value_namespace = name_space
                                    self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-local-addresses"):
                                    self.number_of_ipv6_local_addresses = value
                                    self.number_of_ipv6_local_addresses.value_namespace = name_space
                                    self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-routes"):
                                    self.number_of_ipv6_routes = value
                                    self.number_of_ipv6_routes.value_namespace = name_space
                                    self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6af"):
                                    self.number_of_ipv6af = value
                                    self.number_of_ipv6af.value_namespace = name_space
                                    self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6ldp-interfaces"):
                                    self.number_of_ipv6ldp_interfaces = value
                                    self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                                    self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ldp-interfaces"):
                                    self.number_of_ldp_interfaces = value
                                    self.number_of_ldp_interfaces.value_namespace = name_space
                                    self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-local-bindings-ipv4"):
                                    self.number_of_local_bindings_ipv4 = value
                                    self.number_of_local_bindings_ipv4.value_namespace = name_space
                                    self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-local-bindings-ipv6"):
                                    self.number_of_local_bindings_ipv6 = value
                                    self.number_of_local_bindings_ipv6.value_namespace = name_space
                                    self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-neighbors"):
                                    self.number_of_neighbors = value
                                    self.number_of_neighbors.value_namespace = name_space
                                    self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-nsr-synced-neighbors"):
                                    self.number_of_nsr_synced_neighbors = value
                                    self.number_of_nsr_synced_neighbors.value_namespace = name_space
                                    self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-remote-bindings-ipv4"):
                                    self.number_of_remote_bindings_ipv4 = value
                                    self.number_of_remote_bindings_ipv4.value_namespace = name_space
                                    self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-remote-bindings-ipv6"):
                                    self.number_of_remote_bindings_ipv6 = value
                                    self.number_of_remote_bindings_ipv6.value_namespace = name_space
                                    self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.common is not None and self.common.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.common is not None and self.common.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "common"):
                                if (self.common is None):
                                    self.common = MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Common()
                                    self.common.parent = self
                                    self._children_name_map["common"] = "common"
                                return self.common

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Summary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "common" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Afs(Entity):
                        """
                        Address Family specific operational data
                        
                        .. attribute:: af
                        
                        	Operational data for given Address Family
                        	**type**\: list of    :py:class:`Af <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs, self).__init__()

                            self.yang_name = "afs"
                            self.yang_parent_name = "vrf"

                            self.af = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs, self).__setattr__(name, value)


                        class Af(Entity):
                            """
                            Operational data for given Address Family
                            
                            .. attribute:: af_name  <key>
                            
                            	Address Family name
                            	**type**\:   :py:class:`MplsLdpOperAfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdpOperAfName>`
                            
                            .. attribute:: bindings
                            
                            	The LDP Bindings
                            	**type**\:   :py:class:`Bindings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings>`
                            
                            .. attribute:: bindings_advertise_spec
                            
                            	Advertisement Spec (ACL) for LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsAdvertiseSpec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec>`
                            
                            .. attribute:: bindings_summary
                            
                            	Counters for the LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary>`
                            
                            .. attribute:: bindings_summary_all
                            
                            	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll>`
                            
                            .. attribute:: discovery
                            
                            	The LDP Discovery
                            	**type**\:   :py:class:`Discovery <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery>`
                            
                            .. attribute:: forwarding_summary
                            
                            	Summary information regarding LDP forwarding setup
                            	**type**\:   :py:class:`ForwardingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary>`
                            
                            .. attribute:: forwardings
                            
                            	The LDP Forwarding rewrites
                            	**type**\:   :py:class:`Forwardings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings>`
                            
                            .. attribute:: igp
                            
                            	LDP IGP related information
                            	**type**\:   :py:class:`Igp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp>`
                            
                            .. attribute:: interface_summary
                            
                            	IPv4 interface summary information
                            	**type**\:   :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.InterfaceSummary>`
                            
                            .. attribute:: interfaces
                            
                            	LDP Interface related information
                            	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af, self).__init__()

                                self.yang_name = "af"
                                self.yang_parent_name = "afs"

                                self.af_name = YLeaf(YType.enumeration, "af-name")

                                self.bindings = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings()
                                self.bindings.parent = self
                                self._children_name_map["bindings"] = "bindings"
                                self._children_yang_names.add("bindings")

                                self.bindings_advertise_spec = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec()
                                self.bindings_advertise_spec.parent = self
                                self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                self._children_yang_names.add("bindings-advertise-spec")

                                self.bindings_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary()
                                self.bindings_summary.parent = self
                                self._children_name_map["bindings_summary"] = "bindings-summary"
                                self._children_yang_names.add("bindings-summary")

                                self.bindings_summary_all = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll()
                                self.bindings_summary_all.parent = self
                                self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                self._children_yang_names.add("bindings-summary-all")

                                self.discovery = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery()
                                self.discovery.parent = self
                                self._children_name_map["discovery"] = "discovery"
                                self._children_yang_names.add("discovery")

                                self.forwarding_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary()
                                self.forwarding_summary.parent = self
                                self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                self._children_yang_names.add("forwarding-summary")

                                self.forwardings = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings()
                                self.forwardings.parent = self
                                self._children_name_map["forwardings"] = "forwardings"
                                self._children_yang_names.add("forwardings")

                                self.igp = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp()
                                self.igp.parent = self
                                self._children_name_map["igp"] = "igp"
                                self._children_yang_names.add("igp")

                                self.interface_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.InterfaceSummary()
                                self.interface_summary.parent = self
                                self._children_name_map["interface_summary"] = "interface-summary"
                                self._children_yang_names.add("interface-summary")

                                self.interfaces = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces()
                                self.interfaces.parent = self
                                self._children_name_map["interfaces"] = "interfaces"
                                self._children_yang_names.add("interfaces")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("af_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af, self).__setattr__(name, value)


                            class InterfaceSummary(Entity):
                                """
                                IPv4 interface summary information
                                
                                .. attribute:: auto_config
                                
                                	Auto\-configured interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: auto_config_disabled
                                
                                	Autoconfigure disabled
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: auto_config_forward_reference_interfaces
                                
                                	Auto\-configured forward references
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: forward_references
                                
                                	Number of forward referenced interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: known_ip_interface_count
                                
                                	Number of known IP Interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: known_ip_interface_ldp_enabled
                                
                                	Number of known IP Interfaces with LDP Enabled
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ldp_configured_attached_interface
                                
                                	Number of attached interfaces configured in LDP
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ldp_configured_te_interface
                                
                                	Number of TE tunnel interfaces configured in LDP
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__init__()

                                    self.yang_name = "interface-summary"
                                    self.yang_parent_name = "af"

                                    self.auto_config = YLeaf(YType.uint32, "auto-config")

                                    self.auto_config_disabled = YLeaf(YType.uint32, "auto-config-disabled")

                                    self.auto_config_forward_reference_interfaces = YLeaf(YType.uint32, "auto-config-forward-reference-interfaces")

                                    self.forward_references = YLeaf(YType.uint32, "forward-references")

                                    self.known_ip_interface_count = YLeaf(YType.uint32, "known-ip-interface-count")

                                    self.known_ip_interface_ldp_enabled = YLeaf(YType.uint32, "known-ip-interface-ldp-enabled")

                                    self.ldp_configured_attached_interface = YLeaf(YType.uint32, "ldp-configured-attached-interface")

                                    self.ldp_configured_te_interface = YLeaf(YType.uint32, "ldp-configured-te-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("auto_config",
                                                    "auto_config_disabled",
                                                    "auto_config_forward_reference_interfaces",
                                                    "forward_references",
                                                    "known_ip_interface_count",
                                                    "known_ip_interface_ldp_enabled",
                                                    "ldp_configured_attached_interface",
                                                    "ldp_configured_te_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.auto_config.is_set or
                                        self.auto_config_disabled.is_set or
                                        self.auto_config_forward_reference_interfaces.is_set or
                                        self.forward_references.is_set or
                                        self.known_ip_interface_count.is_set or
                                        self.known_ip_interface_ldp_enabled.is_set or
                                        self.ldp_configured_attached_interface.is_set or
                                        self.ldp_configured_te_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.auto_config.yfilter != YFilter.not_set or
                                        self.auto_config_disabled.yfilter != YFilter.not_set or
                                        self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set or
                                        self.forward_references.yfilter != YFilter.not_set or
                                        self.known_ip_interface_count.yfilter != YFilter.not_set or
                                        self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set or
                                        self.ldp_configured_attached_interface.yfilter != YFilter.not_set or
                                        self.ldp_configured_te_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.auto_config.is_set or self.auto_config.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config.get_name_leafdata())
                                    if (self.auto_config_disabled.is_set or self.auto_config_disabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config_disabled.get_name_leafdata())
                                    if (self.auto_config_forward_reference_interfaces.is_set or self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config_forward_reference_interfaces.get_name_leafdata())
                                    if (self.forward_references.is_set or self.forward_references.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.forward_references.get_name_leafdata())
                                    if (self.known_ip_interface_count.is_set or self.known_ip_interface_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.known_ip_interface_count.get_name_leafdata())
                                    if (self.known_ip_interface_ldp_enabled.is_set or self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.known_ip_interface_ldp_enabled.get_name_leafdata())
                                    if (self.ldp_configured_attached_interface.is_set or self.ldp_configured_attached_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_configured_attached_interface.get_name_leafdata())
                                    if (self.ldp_configured_te_interface.is_set or self.ldp_configured_te_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_configured_te_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "auto-config" or name == "auto-config-disabled" or name == "auto-config-forward-reference-interfaces" or name == "forward-references" or name == "known-ip-interface-count" or name == "known-ip-interface-ldp-enabled" or name == "ldp-configured-attached-interface" or name == "ldp-configured-te-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "auto-config"):
                                        self.auto_config = value
                                        self.auto_config.value_namespace = name_space
                                        self.auto_config.value_namespace_prefix = name_space_prefix
                                    if(value_path == "auto-config-disabled"):
                                        self.auto_config_disabled = value
                                        self.auto_config_disabled.value_namespace = name_space
                                        self.auto_config_disabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "auto-config-forward-reference-interfaces"):
                                        self.auto_config_forward_reference_interfaces = value
                                        self.auto_config_forward_reference_interfaces.value_namespace = name_space
                                        self.auto_config_forward_reference_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "forward-references"):
                                        self.forward_references = value
                                        self.forward_references.value_namespace = name_space
                                        self.forward_references.value_namespace_prefix = name_space_prefix
                                    if(value_path == "known-ip-interface-count"):
                                        self.known_ip_interface_count = value
                                        self.known_ip_interface_count.value_namespace = name_space
                                        self.known_ip_interface_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "known-ip-interface-ldp-enabled"):
                                        self.known_ip_interface_ldp_enabled = value
                                        self.known_ip_interface_ldp_enabled.value_namespace = name_space
                                        self.known_ip_interface_ldp_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-configured-attached-interface"):
                                        self.ldp_configured_attached_interface = value
                                        self.ldp_configured_attached_interface.value_namespace = name_space
                                        self.ldp_configured_attached_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-configured-te-interface"):
                                        self.ldp_configured_te_interface = value
                                        self.ldp_configured_te_interface.value_namespace = name_space
                                        self.ldp_configured_te_interface.value_namespace_prefix = name_space_prefix


                            class Bindings(Entity):
                                """
                                The LDP Bindings
                                
                                .. attribute:: binding
                                
                                	Binding Information
                                	**type**\: list of    :py:class:`Binding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings, self).__init__()

                                    self.yang_name = "bindings"
                                    self.yang_parent_name = "af"

                                    self.binding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings, self).__setattr__(name, value)


                                class Binding(Entity):
                                    """
                                    Binding Information
                                    
                                    .. attribute:: prefix  <key>
                                    
                                    	The IP Prefix
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                    
                                    
                                    ----
                                    .. attribute:: advertise_prefix_acl
                                    
                                    	Advertise Prerfix ACL
                                    	**type**\:  str
                                    
                                    .. attribute:: advertise_tsr_acl
                                    
                                    	Advertise TSR ACL
                                    	**type**\:  str
                                    
                                    .. attribute:: config_enforced_local_label_value
                                    
                                    	Config/User enforced local label value
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_elc
                                    
                                    	Is the entry entropy label capable
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_no_route
                                    
                                    	No route
                                    	**type**\:  bool
                                    
                                    .. attribute:: label_oor
                                    
                                    	Label space depletion OOR
                                    	**type**\:  bool
                                    
                                    .. attribute:: le_local_binding_revision
                                    
                                    	Local Binding revision
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: le_local_label_state
                                    
                                    	Local label state
                                    	**type**\:   :py:class:`LocalLabelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LocalLabelState>`
                                    
                                    .. attribute:: local_label
                                    
                                    	Local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: peers_acked
                                    
                                    	Peers that have ACKed this entry
                                    	**type**\: list of    :py:class:`PeersAcked <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked>`
                                    
                                    .. attribute:: peers_advertised_to
                                    
                                    	Peers this entry is advertised to
                                    	**type**\: list of    :py:class:`PeersAdvertisedTo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo>`
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix Length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: prefix_xr
                                    
                                    	IP Prefix
                                    	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr>`
                                    
                                    .. attribute:: remote_binding
                                    
                                    	Remote binding
                                    	**type**\: list of    :py:class:`RemoteBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__init__()

                                        self.yang_name = "binding"
                                        self.yang_parent_name = "bindings"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.advertise_prefix_acl = YLeaf(YType.str, "advertise-prefix-acl")

                                        self.advertise_tsr_acl = YLeaf(YType.str, "advertise-tsr-acl")

                                        self.config_enforced_local_label_value = YLeaf(YType.boolean, "config-enforced-local-label-value")

                                        self.is_elc = YLeaf(YType.boolean, "is-elc")

                                        self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                        self.label_oor = YLeaf(YType.boolean, "label-oor")

                                        self.le_local_binding_revision = YLeaf(YType.uint32, "le-local-binding-revision")

                                        self.le_local_label_state = YLeaf(YType.enumeration, "le-local-label-state")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.prefix_xr = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr()
                                        self.prefix_xr.parent = self
                                        self._children_name_map["prefix_xr"] = "prefix-xr"
                                        self._children_yang_names.add("prefix-xr")

                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.peers_acked = YList(self)
                                        self.peers_advertised_to = YList(self)
                                        self.remote_binding = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "advertise_prefix_acl",
                                                        "advertise_tsr_acl",
                                                        "config_enforced_local_label_value",
                                                        "is_elc",
                                                        "is_no_route",
                                                        "label_oor",
                                                        "le_local_binding_revision",
                                                        "le_local_label_state",
                                                        "local_label",
                                                        "prefix_length") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "binding"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class PrefixXr(Entity):
                                        """
                                        IP Prefix
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__init__()

                                            self.yang_name = "prefix-xr"
                                            self.yang_parent_name = "binding"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix-xr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class RemoteBinding(Entity):
                                        """
                                        Remote binding
                                        
                                        .. attribute:: assigning_peer_ldp_ident
                                        
                                        	Assigning peer
                                        	**type**\:   :py:class:`AssigningPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent>`
                                        
                                        .. attribute:: is_elc
                                        
                                        	Is the entry entropy label capable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_stale
                                        
                                        	Is the entry stale
                                        	**type**\:  bool
                                        
                                        .. attribute:: remote_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__init__()

                                            self.yang_name = "remote-binding"
                                            self.yang_parent_name = "binding"

                                            self.is_elc = YLeaf(YType.boolean, "is-elc")

                                            self.is_stale = YLeaf(YType.boolean, "is-stale")

                                            self.remote_label = YLeaf(YType.uint32, "remote-label")

                                            self.assigning_peer_ldp_ident = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                            self.assigning_peer_ldp_ident.parent = self
                                            self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                            self._children_yang_names.add("assigning-peer-ldp-ident")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_elc",
                                                            "is_stale",
                                                            "remote_label") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)


                                        class AssigningPeerLdpIdent(Entity):
                                            """
                                            Assigning peer
                                            
                                            .. attribute:: label_space_id
                                            
                                            	Label space identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: ldp_id
                                            
                                            	LDP identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: lsr_id
                                            
                                            	LSR identifier
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__init__()

                                                self.yang_name = "assigning-peer-ldp-ident"
                                                self.yang_parent_name = "remote-binding"

                                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("label_space_id",
                                                                "ldp_id",
                                                                "lsr_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.label_space_id.is_set or
                                                    self.ldp_id.is_set or
                                                    self.lsr_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.label_space_id.yfilter != YFilter.not_set or
                                                    self.ldp_id.yfilter != YFilter.not_set or
                                                    self.lsr_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "assigning-peer-ldp-ident" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "label-space-id"):
                                                    self.label_space_id = value
                                                    self.label_space_id.value_namespace = name_space
                                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ldp-id"):
                                                    self.ldp_id = value
                                                    self.ldp_id.value_namespace = name_space
                                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsr-id"):
                                                    self.lsr_id = value
                                                    self.lsr_id.value_namespace = name_space
                                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.is_elc.is_set or
                                                self.is_stale.is_set or
                                                self.remote_label.is_set or
                                                (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_elc.yfilter != YFilter.not_set or
                                                self.is_stale.yfilter != YFilter.not_set or
                                                self.remote_label.yfilter != YFilter.not_set or
                                                (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "remote-binding" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_elc.get_name_leafdata())
                                            if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_stale.get_name_leafdata())
                                            if (self.remote_label.is_set or self.remote_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.remote_label.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "assigning-peer-ldp-ident"):
                                                if (self.assigning_peer_ldp_ident is None):
                                                    self.assigning_peer_ldp_ident = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                                    self.assigning_peer_ldp_ident.parent = self
                                                    self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                                return self.assigning_peer_ldp_ident

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "assigning-peer-ldp-ident" or name == "is-elc" or name == "is-stale" or name == "remote-label"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-elc"):
                                                self.is_elc = value
                                                self.is_elc.value_namespace = name_space
                                                self.is_elc.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-stale"):
                                                self.is_stale = value
                                                self.is_stale.value_namespace = name_space
                                                self.is_stale.value_namespace_prefix = name_space_prefix
                                            if(value_path == "remote-label"):
                                                self.remote_label = value
                                                self.remote_label.value_namespace = name_space
                                                self.remote_label.value_namespace_prefix = name_space_prefix


                                    class PeersAdvertisedTo(Entity):
                                        """
                                        Peers this entry is advertised to
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__init__()

                                            self.yang_name = "peers-advertised-to"
                                            self.yang_parent_name = "binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers-advertised-to" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix


                                    class PeersAcked(Entity):
                                        """
                                        Peers that have ACKed this entry
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__init__()

                                            self.yang_name = "peers-acked"
                                            self.yang_parent_name = "binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers-acked" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.peers_acked:
                                            if (c.has_data()):
                                                return True
                                        for c in self.peers_advertised_to:
                                            if (c.has_data()):
                                                return True
                                        for c in self.remote_binding:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.prefix.is_set or
                                            self.advertise_prefix_acl.is_set or
                                            self.advertise_tsr_acl.is_set or
                                            self.config_enforced_local_label_value.is_set or
                                            self.is_elc.is_set or
                                            self.is_no_route.is_set or
                                            self.label_oor.is_set or
                                            self.le_local_binding_revision.is_set or
                                            self.le_local_label_state.is_set or
                                            self.local_label.is_set or
                                            self.prefix_length.is_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.peers_acked:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.peers_advertised_to:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.remote_binding:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.advertise_prefix_acl.yfilter != YFilter.not_set or
                                            self.advertise_tsr_acl.yfilter != YFilter.not_set or
                                            self.config_enforced_local_label_value.yfilter != YFilter.not_set or
                                            self.is_elc.yfilter != YFilter.not_set or
                                            self.is_no_route.yfilter != YFilter.not_set or
                                            self.label_oor.yfilter != YFilter.not_set or
                                            self.le_local_binding_revision.yfilter != YFilter.not_set or
                                            self.le_local_label_state.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "binding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.advertise_prefix_acl.is_set or self.advertise_prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertise_prefix_acl.get_name_leafdata())
                                        if (self.advertise_tsr_acl.is_set or self.advertise_tsr_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertise_tsr_acl.get_name_leafdata())
                                        if (self.config_enforced_local_label_value.is_set or self.config_enforced_local_label_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.config_enforced_local_label_value.get_name_leafdata())
                                        if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_elc.get_name_leafdata())
                                        if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                        if (self.label_oor.is_set or self.label_oor.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_oor.get_name_leafdata())
                                        if (self.le_local_binding_revision.is_set or self.le_local_binding_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.le_local_binding_revision.get_name_leafdata())
                                        if (self.le_local_label_state.is_set or self.le_local_label_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.le_local_label_state.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "peers-acked"):
                                            for c in self.peers_acked:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers_acked.append(c)
                                            return c

                                        if (child_yang_name == "peers-advertised-to"):
                                            for c in self.peers_advertised_to:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers_advertised_to.append(c)
                                            return c

                                        if (child_yang_name == "prefix-xr"):
                                            if (self.prefix_xr is None):
                                                self.prefix_xr = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr()
                                                self.prefix_xr.parent = self
                                                self._children_name_map["prefix_xr"] = "prefix-xr"
                                            return self.prefix_xr

                                        if (child_yang_name == "remote-binding"):
                                            for c in self.remote_binding:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.remote_binding.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "peers-acked" or name == "peers-advertised-to" or name == "prefix-xr" or name == "remote-binding" or name == "vrf" or name == "prefix" or name == "advertise-prefix-acl" or name == "advertise-tsr-acl" or name == "config-enforced-local-label-value" or name == "is-elc" or name == "is-no-route" or name == "label-oor" or name == "le-local-binding-revision" or name == "le-local-label-state" or name == "local-label" or name == "prefix-length"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "advertise-prefix-acl"):
                                            self.advertise_prefix_acl = value
                                            self.advertise_prefix_acl.value_namespace = name_space
                                            self.advertise_prefix_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "advertise-tsr-acl"):
                                            self.advertise_tsr_acl = value
                                            self.advertise_tsr_acl.value_namespace = name_space
                                            self.advertise_tsr_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "config-enforced-local-label-value"):
                                            self.config_enforced_local_label_value = value
                                            self.config_enforced_local_label_value.value_namespace = name_space
                                            self.config_enforced_local_label_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-elc"):
                                            self.is_elc = value
                                            self.is_elc.value_namespace = name_space
                                            self.is_elc.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-no-route"):
                                            self.is_no_route = value
                                            self.is_no_route.value_namespace = name_space
                                            self.is_no_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-oor"):
                                            self.label_oor = value
                                            self.label_oor.value_namespace = name_space
                                            self.label_oor.value_namespace_prefix = name_space_prefix
                                        if(value_path == "le-local-binding-revision"):
                                            self.le_local_binding_revision = value
                                            self.le_local_binding_revision.value_namespace = name_space
                                            self.le_local_binding_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "le-local-label-state"):
                                            self.le_local_label_state = value
                                            self.le_local_label_state.value_namespace = name_space
                                            self.le_local_label_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.binding:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.binding:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "binding"):
                                        for c in self.binding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings.Binding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.binding.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "binding"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Igp(Entity):
                                """
                                LDP IGP related information
                                
                                .. attribute:: sync_delay_restart
                                
                                	LDP\-IGP Synchronization Delay related information
                                	**type**\:   :py:class:`SyncDelayRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart>`
                                
                                .. attribute:: syncs
                                
                                	LDP IGP Sync related information
                                	**type**\:   :py:class:`Syncs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp, self).__init__()

                                    self.yang_name = "igp"
                                    self.yang_parent_name = "af"

                                    self.sync_delay_restart = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart()
                                    self.sync_delay_restart.parent = self
                                    self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                    self._children_yang_names.add("sync-delay-restart")

                                    self.syncs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs()
                                    self.syncs.parent = self
                                    self._children_name_map["syncs"] = "syncs"
                                    self._children_yang_names.add("syncs")


                                class Syncs(Entity):
                                    """
                                    LDP IGP Sync related information
                                    
                                    .. attribute:: sync
                                    
                                    	LDP\-IGP Synchronization related information for an interface
                                    	**type**\: list of    :py:class:`Sync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__init__()

                                        self.yang_name = "syncs"
                                        self.yang_parent_name = "igp"

                                        self.sync = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)


                                    class Sync(Entity):
                                        """
                                        LDP\-IGP Synchronization related information
                                        for an interface
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: delay_timer_remaining
                                        
                                        	Remaining timer (seconds) till expiry of sync delay timer
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: gr_only_peer
                                        
                                        	Interface GR\-only reachable peers
                                        	**type**\: list of    :py:class:`GrOnlyPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer>`
                                        
                                        .. attribute:: igp_sync_delay
                                        
                                        	IGP sync delay in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: igp_sync_down_reason
                                        
                                        	Reason IGP Sync Not Achieved
                                        	**type**\:   :py:class:`LdpIgpSyncDownReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncDownReason>`
                                        
                                        .. attribute:: igp_sync_state
                                        
                                        	IGP Sync state
                                        	**type**\:   :py:class:`LdpIgpSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncState>`
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: is_delay_timer_running
                                        
                                        	Is sync delay timer running
                                        	**type**\:  bool
                                        
                                        .. attribute:: peers
                                        
                                        	Interface Peers
                                        	**type**\: list of    :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers>`
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__init__()

                                            self.yang_name = "sync"
                                            self.yang_parent_name = "syncs"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.delay_timer_remaining = YLeaf(YType.uint32, "delay-timer-remaining")

                                            self.igp_sync_delay = YLeaf(YType.uint32, "igp-sync-delay")

                                            self.igp_sync_down_reason = YLeaf(YType.enumeration, "igp-sync-down-reason")

                                            self.igp_sync_state = YLeaf(YType.enumeration, "igp-sync-state")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.is_delay_timer_running = YLeaf(YType.boolean, "is-delay-timer-running")

                                            self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.gr_only_peer = YList(self)
                                            self.peers = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "delay_timer_remaining",
                                                            "igp_sync_delay",
                                                            "igp_sync_down_reason",
                                                            "igp_sync_state",
                                                            "interface_name_xr",
                                                            "is_delay_timer_running") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "sync"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class Peers(Entity):
                                            """
                                            Interface Peers
                                            
                                            .. attribute:: is_gr_enabled
                                            
                                            	Is GR enabled session
                                            	**type**\:  bool
                                            
                                            .. attribute:: peer_id
                                            
                                            	Peer Identifier
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__init__()

                                                self.yang_name = "peers"
                                                self.yang_parent_name = "sync"

                                                self.is_gr_enabled = YLeaf(YType.boolean, "is-gr-enabled")

                                                self.peer_id = YLeaf(YType.str, "peer-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_gr_enabled",
                                                                "peer_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_gr_enabled.is_set or
                                                    self.peer_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_gr_enabled.yfilter != YFilter.not_set or
                                                    self.peer_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "peers" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_gr_enabled.is_set or self.is_gr_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_gr_enabled.get_name_leafdata())
                                                if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.peer_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-gr-enabled" or name == "peer-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-gr-enabled"):
                                                    self.is_gr_enabled = value
                                                    self.is_gr_enabled.value_namespace = name_space
                                                    self.is_gr_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "peer-id"):
                                                    self.peer_id = value
                                                    self.peer_id.value_namespace = name_space
                                                    self.peer_id.value_namespace_prefix = name_space_prefix


                                        class GrOnlyPeer(Entity):
                                            """
                                            Interface GR\-only reachable peers
                                            
                                            .. attribute:: is_chkpt_created
                                            
                                            	Is created due to checkpointing
                                            	**type**\:  bool
                                            
                                            .. attribute:: peer_id
                                            
                                            	Peer Identifier
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__init__()

                                                self.yang_name = "gr-only-peer"
                                                self.yang_parent_name = "sync"

                                                self.is_chkpt_created = YLeaf(YType.boolean, "is-chkpt-created")

                                                self.peer_id = YLeaf(YType.str, "peer-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_chkpt_created",
                                                                "peer_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_chkpt_created.is_set or
                                                    self.peer_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_chkpt_created.yfilter != YFilter.not_set or
                                                    self.peer_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "gr-only-peer" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_chkpt_created.is_set or self.is_chkpt_created.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_chkpt_created.get_name_leafdata())
                                                if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.peer_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-chkpt-created" or name == "peer-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-chkpt-created"):
                                                    self.is_chkpt_created = value
                                                    self.is_chkpt_created.value_namespace = name_space
                                                    self.is_chkpt_created.value_namespace_prefix = name_space_prefix
                                                if(value_path == "peer-id"):
                                                    self.peer_id = value
                                                    self.peer_id.value_namespace = name_space
                                                    self.peer_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.gr_only_peer:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.peers:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.delay_timer_remaining.is_set or
                                                self.igp_sync_delay.is_set or
                                                self.igp_sync_down_reason.is_set or
                                                self.igp_sync_state.is_set or
                                                self.interface_name_xr.is_set or
                                                self.is_delay_timer_running.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.gr_only_peer:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.peers:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.delay_timer_remaining.yfilter != YFilter.not_set or
                                                self.igp_sync_delay.yfilter != YFilter.not_set or
                                                self.igp_sync_down_reason.yfilter != YFilter.not_set or
                                                self.igp_sync_state.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                self.is_delay_timer_running.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "sync" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.delay_timer_remaining.is_set or self.delay_timer_remaining.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.delay_timer_remaining.get_name_leafdata())
                                            if (self.igp_sync_delay.is_set or self.igp_sync_delay.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_delay.get_name_leafdata())
                                            if (self.igp_sync_down_reason.is_set or self.igp_sync_down_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_down_reason.get_name_leafdata())
                                            if (self.igp_sync_state.is_set or self.igp_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_state.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                            if (self.is_delay_timer_running.is_set or self.is_delay_timer_running.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_delay_timer_running.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "gr-only-peer"):
                                                for c in self.gr_only_peer:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.gr_only_peer.append(c)
                                                return c

                                            if (child_yang_name == "peers"):
                                                for c in self.peers:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.peers.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "gr-only-peer" or name == "peers" or name == "vrf" or name == "interface-name" or name == "delay-timer-remaining" or name == "igp-sync-delay" or name == "igp-sync-down-reason" or name == "igp-sync-state" or name == "interface-name-xr" or name == "is-delay-timer-running"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "delay-timer-remaining"):
                                                self.delay_timer_remaining = value
                                                self.delay_timer_remaining.value_namespace = name_space
                                                self.delay_timer_remaining.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-delay"):
                                                self.igp_sync_delay = value
                                                self.igp_sync_delay.value_namespace = name_space
                                                self.igp_sync_delay.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-down-reason"):
                                                self.igp_sync_down_reason = value
                                                self.igp_sync_down_reason.value_namespace = name_space
                                                self.igp_sync_down_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-state"):
                                                self.igp_sync_state = value
                                                self.igp_sync_state.value_namespace = name_space
                                                self.igp_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-delay-timer-running"):
                                                self.is_delay_timer_running = value
                                                self.is_delay_timer_running.value_namespace = name_space
                                                self.is_delay_timer_running.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.sync:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.sync:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "syncs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "sync"):
                                            for c in self.sync:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.sync.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "sync"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class SyncDelayRestart(Entity):
                                    """
                                    LDP\-IGP Synchronization Delay related
                                    information
                                    
                                    .. attribute:: configured
                                    
                                    	Is restart delay configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: delay_secs
                                    
                                    	Delay time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: remaining_secs
                                    
                                    	Delay timer remaining time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: timer_running
                                    
                                    	Is restart delay timer running
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__init__()

                                        self.yang_name = "sync-delay-restart"
                                        self.yang_parent_name = "igp"

                                        self.configured = YLeaf(YType.boolean, "configured")

                                        self.delay_secs = YLeaf(YType.uint32, "delay-secs")

                                        self.remaining_secs = YLeaf(YType.uint32, "remaining-secs")

                                        self.timer_running = YLeaf(YType.boolean, "timer-running")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured",
                                                        "delay_secs",
                                                        "remaining_secs",
                                                        "timer_running") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.configured.is_set or
                                            self.delay_secs.is_set or
                                            self.remaining_secs.is_set or
                                            self.timer_running.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured.yfilter != YFilter.not_set or
                                            self.delay_secs.yfilter != YFilter.not_set or
                                            self.remaining_secs.yfilter != YFilter.not_set or
                                            self.timer_running.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sync-delay-restart" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured.is_set or self.configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured.get_name_leafdata())
                                        if (self.delay_secs.is_set or self.delay_secs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.delay_secs.get_name_leafdata())
                                        if (self.remaining_secs.is_set or self.remaining_secs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remaining_secs.get_name_leafdata())
                                        if (self.timer_running.is_set or self.timer_running.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.timer_running.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "configured" or name == "delay-secs" or name == "remaining-secs" or name == "timer-running"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured"):
                                            self.configured = value
                                            self.configured.value_namespace = name_space
                                            self.configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "delay-secs"):
                                            self.delay_secs = value
                                            self.delay_secs.value_namespace = name_space
                                            self.delay_secs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remaining-secs"):
                                            self.remaining_secs = value
                                            self.remaining_secs.value_namespace = name_space
                                            self.remaining_secs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "timer-running"):
                                            self.timer_running = value
                                            self.timer_running.value_namespace = name_space
                                            self.timer_running.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.sync_delay_restart is not None and self.sync_delay_restart.has_data()) or
                                        (self.syncs is not None and self.syncs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.sync_delay_restart is not None and self.sync_delay_restart.has_operation()) or
                                        (self.syncs is not None and self.syncs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "igp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sync-delay-restart"):
                                        if (self.sync_delay_restart is None):
                                            self.sync_delay_restart = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart()
                                            self.sync_delay_restart.parent = self
                                            self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                        return self.sync_delay_restart

                                    if (child_yang_name == "syncs"):
                                        if (self.syncs is None):
                                            self.syncs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp.Syncs()
                                            self.syncs.parent = self
                                            self._children_name_map["syncs"] = "syncs"
                                        return self.syncs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sync-delay-restart" or name == "syncs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsSummary(Entity):
                                """
                                Counters for the LDP Label Infomation Base
                                (LIB)
                                
                                .. attribute:: address_family
                                
                                	Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: bind_af
                                
                                	bind af
                                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf>`
                                
                                .. attribute:: binding_local_explicit_null
                                
                                	Number of local explicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_implicit_null
                                
                                	Number of local implicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_no_route
                                
                                	Local bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_non_null
                                
                                	Number of local non\-null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_null
                                
                                	Number of local null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_oor
                                
                                	Number of local bindings        needing label \- OOR
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_no_route
                                
                                	Bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: highest_allocated_label
                                
                                	Highest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lowest_allocated_label
                                
                                	Lowest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__init__()

                                    self.yang_name = "bindings-summary"
                                    self.yang_parent_name = "af"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                    self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.bind_af = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local_explicit_null",
                                                    "binding_local_implicit_null",
                                                    "binding_local_no_route",
                                                    "binding_local_non_null",
                                                    "binding_local_null",
                                                    "binding_local_oor",
                                                    "binding_no_route",
                                                    "highest_allocated_label",
                                                    "lowest_allocated_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "bindings-summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class BindAf(Entity):
                                    """
                                    bind af
                                    
                                    .. attribute:: address_family
                                    
                                    	Binding Summary Address Family
                                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                    
                                    .. attribute:: binding_local
                                    
                                    	Number of local bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_remote
                                    
                                    	Number of remote bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_total
                                    
                                    	Total bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_lib_update
                                    
                                    	Last update to LIB local binding
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lib_minimum_revision_sent_all
                                    
                                    	Last update sent to all peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__init__()

                                        self.yang_name = "bind-af"
                                        self.yang_parent_name = "bindings-summary"

                                        self.address_family = YLeaf(YType.enumeration, "address-family")

                                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address_family",
                                                        "binding_local",
                                                        "binding_remote",
                                                        "binding_total",
                                                        "last_lib_update",
                                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address_family.is_set or
                                            self.binding_local.is_set or
                                            self.binding_remote.is_set or
                                            self.binding_total.is_set or
                                            self.last_lib_update.is_set or
                                            self.lib_minimum_revision_sent_all.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address_family.yfilter != YFilter.not_set or
                                            self.binding_local.yfilter != YFilter.not_set or
                                            self.binding_remote.yfilter != YFilter.not_set or
                                            self.binding_total.yfilter != YFilter.not_set or
                                            self.last_lib_update.yfilter != YFilter.not_set or
                                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bind-af" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address_family.get_name_leafdata())
                                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address-family"):
                                            self.address_family = value
                                            self.address_family.value_namespace = name_space
                                            self.address_family.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-local"):
                                            self.binding_local = value
                                            self.binding_local.value_namespace = name_space
                                            self.binding_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-remote"):
                                            self.binding_remote = value
                                            self.binding_remote.value_namespace = name_space
                                            self.binding_remote.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-total"):
                                            self.binding_total = value
                                            self.binding_total.value_namespace = name_space
                                            self.binding_total.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-lib-update"):
                                            self.last_lib_update = value
                                            self.last_lib_update.value_namespace = name_space
                                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lib-minimum-revision-sent-all"):
                                            self.lib_minimum_revision_sent_all = value
                                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bind_af:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local_explicit_null.is_set or
                                        self.binding_local_implicit_null.is_set or
                                        self.binding_local_no_route.is_set or
                                        self.binding_local_non_null.is_set or
                                        self.binding_local_null.is_set or
                                        self.binding_local_oor.is_set or
                                        self.binding_no_route.is_set or
                                        self.highest_allocated_label.is_set or
                                        self.lowest_allocated_label.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.bind_af:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_no_route.yfilter != YFilter.not_set or
                                        self.binding_local_non_null.yfilter != YFilter.not_set or
                                        self.binding_local_null.yfilter != YFilter.not_set or
                                        self.binding_local_oor.yfilter != YFilter.not_set or
                                        self.binding_no_route.yfilter != YFilter.not_set or
                                        self.highest_allocated_label.yfilter != YFilter.not_set or
                                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bind-af"):
                                        for c in self.bind_af:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bind_af.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-explicit-null"):
                                        self.binding_local_explicit_null = value
                                        self.binding_local_explicit_null.value_namespace = name_space
                                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-implicit-null"):
                                        self.binding_local_implicit_null = value
                                        self.binding_local_implicit_null.value_namespace = name_space
                                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-no-route"):
                                        self.binding_local_no_route = value
                                        self.binding_local_no_route.value_namespace = name_space
                                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-non-null"):
                                        self.binding_local_non_null = value
                                        self.binding_local_non_null.value_namespace = name_space
                                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-null"):
                                        self.binding_local_null = value
                                        self.binding_local_null.value_namespace = name_space
                                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-oor"):
                                        self.binding_local_oor = value
                                        self.binding_local_oor.value_namespace = name_space
                                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-no-route"):
                                        self.binding_no_route = value
                                        self.binding_no_route.value_namespace = name_space
                                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "highest-allocated-label"):
                                        self.highest_allocated_label = value
                                        self.highest_allocated_label.value_namespace = name_space
                                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lowest-allocated-label"):
                                        self.lowest_allocated_label = value
                                        self.lowest_allocated_label.value_namespace = name_space
                                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                            class Interfaces(Entity):
                                """
                                LDP Interface related information
                                
                                .. attribute:: interface
                                
                                	IPv4 interface information
                                	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces, self).__init__()

                                    self.yang_name = "interfaces"
                                    self.yang_parent_name = "af"

                                    self.interface = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces, self).__setattr__(name, value)


                                class Interface(Entity):
                                    """
                                    IPv4 interface information
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: auto_config
                                    
                                    	Auto config
                                    	**type**\: list of    :py:class:`AutoConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig>`
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: is_im_stale
                                    
                                    	Is IM information stale
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_autoconfig_disable
                                    
                                    	LDP autoconfig disable
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_config_mode
                                    
                                    	LDP config mode
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_enabled
                                    
                                    	LDP enabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: te_mesh_grp
                                    
                                    	TE tunnel mesh\-group
                                    	**type**\: list of    :py:class:`TeMeshGrp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__init__()

                                        self.yang_name = "interface"
                                        self.yang_parent_name = "interfaces"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.is_im_stale = YLeaf(YType.boolean, "is-im-stale")

                                        self.ldp_autoconfig_disable = YLeaf(YType.boolean, "ldp-autoconfig-disable")

                                        self.ldp_config_mode = YLeaf(YType.boolean, "ldp-config-mode")

                                        self.ldp_enabled = YLeaf(YType.boolean, "ldp-enabled")

                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.auto_config = YList(self)
                                        self.te_mesh_grp = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "interface",
                                                        "interface_name_xr",
                                                        "is_im_stale",
                                                        "ldp_autoconfig_disable",
                                                        "ldp_config_mode",
                                                        "ldp_enabled") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "interface"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class TeMeshGrp(Entity):
                                        """
                                        TE tunnel mesh\-group
                                        
                                        .. attribute:: ldp_mesh_group_enabled
                                        
                                        	LDP has enabled this TE mesh\-group
                                        	**type**\:  bool
                                        
                                        .. attribute:: ldp_te_mesh_group_all_cfgd
                                        
                                        	LDP has enabled all TE mesh\-groups
                                        	**type**\:  bool
                                        
                                        .. attribute:: te_mesh_group_id
                                        
                                        	TE tunnel Mesh Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__init__()

                                            self.yang_name = "te-mesh-grp"
                                            self.yang_parent_name = "interface"

                                            self.ldp_mesh_group_enabled = YLeaf(YType.boolean, "ldp-mesh-group-enabled")

                                            self.ldp_te_mesh_group_all_cfgd = YLeaf(YType.boolean, "ldp-te-mesh-group-all-cfgd")

                                            self.te_mesh_group_id = YLeaf(YType.uint32, "te-mesh-group-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ldp_mesh_group_enabled",
                                                            "ldp_te_mesh_group_all_cfgd",
                                                            "te_mesh_group_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.ldp_mesh_group_enabled.is_set or
                                                self.ldp_te_mesh_group_all_cfgd.is_set or
                                                self.te_mesh_group_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ldp_mesh_group_enabled.yfilter != YFilter.not_set or
                                                self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set or
                                                self.te_mesh_group_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "te-mesh-grp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ldp_mesh_group_enabled.is_set or self.ldp_mesh_group_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_mesh_group_enabled.get_name_leafdata())
                                            if (self.ldp_te_mesh_group_all_cfgd.is_set or self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_te_mesh_group_all_cfgd.get_name_leafdata())
                                            if (self.te_mesh_group_id.is_set or self.te_mesh_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.te_mesh_group_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "ldp-mesh-group-enabled" or name == "ldp-te-mesh-group-all-cfgd" or name == "te-mesh-group-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ldp-mesh-group-enabled"):
                                                self.ldp_mesh_group_enabled = value
                                                self.ldp_mesh_group_enabled.value_namespace = name_space
                                                self.ldp_mesh_group_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-te-mesh-group-all-cfgd"):
                                                self.ldp_te_mesh_group_all_cfgd = value
                                                self.ldp_te_mesh_group_all_cfgd.value_namespace = name_space
                                                self.ldp_te_mesh_group_all_cfgd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "te-mesh-group-id"):
                                                self.te_mesh_group_id = value
                                                self.te_mesh_group_id.value_namespace = name_space
                                                self.te_mesh_group_id.value_namespace_prefix = name_space_prefix


                                    class AutoConfig(Entity):
                                        """
                                        Auto config
                                        
                                        .. attribute:: tuple
                                        
                                        	Tuple
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__init__()

                                            self.yang_name = "auto-config"
                                            self.yang_parent_name = "interface"

                                            self.tuple = YLeaf(YType.str, "tuple")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("tuple") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.tuple.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.tuple.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "auto-config" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.tuple.is_set or self.tuple.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tuple.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "tuple"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "tuple"):
                                                self.tuple = value
                                                self.tuple.value_namespace = name_space
                                                self.tuple.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.auto_config:
                                            if (c.has_data()):
                                                return True
                                        for c in self.te_mesh_grp:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.interface.is_set or
                                            self.interface_name_xr.is_set or
                                            self.is_im_stale.is_set or
                                            self.ldp_autoconfig_disable.is_set or
                                            self.ldp_config_mode.is_set or
                                            self.ldp_enabled.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.auto_config:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.te_mesh_grp:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.is_im_stale.yfilter != YFilter.not_set or
                                            self.ldp_autoconfig_disable.yfilter != YFilter.not_set or
                                            self.ldp_config_mode.yfilter != YFilter.not_set or
                                            self.ldp_enabled.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.is_im_stale.is_set or self.is_im_stale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_im_stale.get_name_leafdata())
                                        if (self.ldp_autoconfig_disable.is_set or self.ldp_autoconfig_disable.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_autoconfig_disable.get_name_leafdata())
                                        if (self.ldp_config_mode.is_set or self.ldp_config_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_config_mode.get_name_leafdata())
                                        if (self.ldp_enabled.is_set or self.ldp_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_enabled.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "auto-config"):
                                            for c in self.auto_config:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.auto_config.append(c)
                                            return c

                                        if (child_yang_name == "te-mesh-grp"):
                                            for c in self.te_mesh_grp:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.te_mesh_grp.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "auto-config" or name == "te-mesh-grp" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "is-im-stale" or name == "ldp-autoconfig-disable" or name == "ldp-config-mode" or name == "ldp-enabled"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-im-stale"):
                                            self.is_im_stale = value
                                            self.is_im_stale.value_namespace = name_space
                                            self.is_im_stale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-autoconfig-disable"):
                                            self.ldp_autoconfig_disable = value
                                            self.ldp_autoconfig_disable.value_namespace = name_space
                                            self.ldp_autoconfig_disable.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-config-mode"):
                                            self.ldp_config_mode = value
                                            self.ldp_config_mode.value_namespace = name_space
                                            self.ldp_config_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-enabled"):
                                            self.ldp_enabled = value
                                            self.ldp_enabled.value_namespace = name_space
                                            self.ldp_enabled.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.interface:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.interface:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interfaces" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "interface"):
                                        for c in self.interface:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces.Interface()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.interface.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Discovery(Entity):
                                """
                                The LDP Discovery
                                
                                .. attribute:: brief
                                
                                	Brief information on LDP discovery
                                	**type**\:   :py:class:`Brief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief>`
                                
                                .. attribute:: link_hellos
                                
                                	The LDP Discovery link
                                	**type**\:   :py:class:`LinkHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos>`
                                
                                .. attribute:: stats
                                
                                	The LDP Discovery Statistics
                                	**type**\:   :py:class:`Stats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats>`
                                
                                .. attribute:: summary
                                
                                	Summarized information on LDP discovery
                                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary>`
                                
                                .. attribute:: targeted_hellos
                                
                                	The LDP Discovery Targeted
                                	**type**\:   :py:class:`TargetedHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery, self).__init__()

                                    self.yang_name = "discovery"
                                    self.yang_parent_name = "af"

                                    self.brief = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief()
                                    self.brief.parent = self
                                    self._children_name_map["brief"] = "brief"
                                    self._children_yang_names.add("brief")

                                    self.link_hellos = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos()
                                    self.link_hellos.parent = self
                                    self._children_name_map["link_hellos"] = "link-hellos"
                                    self._children_yang_names.add("link-hellos")

                                    self.stats = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats()
                                    self.stats.parent = self
                                    self._children_name_map["stats"] = "stats"
                                    self._children_yang_names.add("stats")

                                    self.summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary()
                                    self.summary.parent = self
                                    self._children_name_map["summary"] = "summary"
                                    self._children_yang_names.add("summary")

                                    self.targeted_hellos = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos()
                                    self.targeted_hellos.parent = self
                                    self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                    self._children_yang_names.add("targeted-hellos")


                                class LinkHellos(Entity):
                                    """
                                    The LDP Discovery link
                                    
                                    .. attribute:: link_hello
                                    
                                    	Information on LDP link discovery
                                    	**type**\: list of    :py:class:`LinkHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__init__()

                                        self.yang_name = "link-hellos"
                                        self.yang_parent_name = "discovery"

                                        self.link_hello = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)


                                    class LinkHello(Entity):
                                        """
                                        Information on LDP link discovery
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: discovery_link_af
                                        
                                        	LDP hello AF info
                                        	**type**\: list of    :py:class:`DiscoveryLinkAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation>`
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: next_hello
                                        
                                        	Next hello due time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: quick_start_disabled
                                        
                                        	Quick\-start disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__init__()

                                            self.yang_name = "link-hello"
                                            self.yang_parent_name = "link-hellos"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.next_hello = YLeaf(YType.uint32, "next-hello")

                                            self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                            self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.discovery_link_af = YList(self)
                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "interface",
                                                            "interface_name_xr",
                                                            "next_hello",
                                                            "quick_start_disabled") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "link-hello"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: disc_expiry
                                            
                                            	Discovery expiry time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: established_age
                                            
                                            	Hello adjacency estabished age in nanosec
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: established_time
                                            
                                            	Hello adjacency estabished time in nanosec
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: is_no_route
                                            
                                            	Is route valid
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_targeted
                                            
                                            	Is session a targeted session
                                            	**type**\:  bool
                                            
                                            .. attribute:: last_session_down_info
                                            
                                            	Last session down information
                                            	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo>`
                                            
                                            .. attribute:: local_hold_time
                                            
                                            	Local hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: neighbor_hold_time
                                            
                                            	Neighbor hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: neighbor_src_address
                                            
                                            	Neighbor source address
                                            	**type**\:   :py:class:`NeighborSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress>`
                                            
                                            .. attribute:: neighbor_transport_address
                                            
                                            	Neighbor transport address
                                            	**type**\:   :py:class:`NeighborTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress>`
                                            
                                            .. attribute:: session_bringup_failure_reason
                                            
                                            	session bringup failure reason
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            .. attribute:: target
                                            
                                            	Target address
                                            	**type**\:   :py:class:`Target <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "link-hello"

                                                self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                                self.established_age = YLeaf(YType.uint64, "established-age")

                                                self.established_time = YLeaf(YType.uint64, "established-time")

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                                self.is_targeted = YLeaf(YType.boolean, "is-targeted")

                                                self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                                self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                                self.neighbor_src_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                self.neighbor_src_address.parent = self
                                                self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                self._children_yang_names.add("neighbor-src-address")

                                                self.neighbor_transport_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                self.neighbor_transport_address.parent = self
                                                self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                self._children_yang_names.add("neighbor-transport-address")

                                                self.target = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                self.target.parent = self
                                                self._children_name_map["target"] = "target"
                                                self._children_yang_names.add("target")

                                                self.last_session_down_info = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("disc_expiry",
                                                                "established_age",
                                                                "established_time",
                                                                "hold_time",
                                                                "is_no_route",
                                                                "is_targeted",
                                                                "local_hold_time",
                                                                "neighbor_hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_bringup_failure_reason",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)


                                            class NeighborSrcAddress(Entity):
                                                """
                                                Neighbor source address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__init__()

                                                    self.yang_name = "neighbor-src-address"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "neighbor-src-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class NeighborTransportAddress(Entity):
                                                """
                                                Neighbor transport address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__init__()

                                                    self.yang_name = "neighbor-transport-address"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "neighbor-transport-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class Target(Entity):
                                                """
                                                Target address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__init__()

                                                    self.yang_name = "target"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "target" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class LastSessionDownInfo(Entity):
                                                """
                                                Last session down information
                                                
                                                .. attribute:: last_session_down_reason
                                                
                                                	The reason of last socket failure
                                                	**type**\:  str
                                                
                                                .. attribute:: last_session_down_time
                                                
                                                	Timestamp of when the last session went down
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: last_session_up_time
                                                
                                                	The time duration the last session was up
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__init__()

                                                    self.yang_name = "last-session-down-info"
                                                    self.yang_parent_name = "hello-information"

                                                    self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                    self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                    self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("last_session_down_reason",
                                                                    "last_session_down_time",
                                                                    "last_session_up_time") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.last_session_down_reason.is_set or
                                                        self.last_session_down_time.is_set or
                                                        self.last_session_up_time.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.last_session_down_reason.yfilter != YFilter.not_set or
                                                        self.last_session_down_time.yfilter != YFilter.not_set or
                                                        self.last_session_up_time.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "last-session-down-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                    if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                    if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "last-session-down-reason"):
                                                        self.last_session_down_reason = value
                                                        self.last_session_down_reason.value_namespace = name_space
                                                        self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "last-session-down-time"):
                                                        self.last_session_down_time = value
                                                        self.last_session_down_time.value_namespace = name_space
                                                        self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "last-session-up-time"):
                                                        self.last_session_up_time = value
                                                        self.last_session_up_time.value_namespace = name_space
                                                        self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.last_session_down_info:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.disc_expiry.is_set or
                                                    self.established_age.is_set or
                                                    self.established_time.is_set or
                                                    self.hold_time.is_set or
                                                    self.is_no_route.is_set or
                                                    self.is_targeted.is_set or
                                                    self.local_hold_time.is_set or
                                                    self.neighbor_hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_bringup_failure_reason.is_set or
                                                    self.session_up.is_set or
                                                    (self.neighbor_src_address is not None and self.neighbor_src_address.has_data()) or
                                                    (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_data()) or
                                                    (self.target is not None and self.target.has_data()))

                                            def has_operation(self):
                                                for c in self.last_session_down_info:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.disc_expiry.yfilter != YFilter.not_set or
                                                    self.established_age.yfilter != YFilter.not_set or
                                                    self.established_time.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.is_no_route.yfilter != YFilter.not_set or
                                                    self.is_targeted.yfilter != YFilter.not_set or
                                                    self.local_hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set or
                                                    (self.neighbor_src_address is not None and self.neighbor_src_address.has_operation()) or
                                                    (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_operation()) or
                                                    (self.target is not None and self.target.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                                if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.established_age.get_name_leafdata())
                                                if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.established_time.get_name_leafdata())
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                                if (self.is_targeted.is_set or self.is_targeted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_targeted.get_name_leafdata())
                                                if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                                if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "last-session-down-info"):
                                                    for c in self.last_session_down_info:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.last_session_down_info.append(c)
                                                    return c

                                                if (child_yang_name == "neighbor-src-address"):
                                                    if (self.neighbor_src_address is None):
                                                        self.neighbor_src_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                        self.neighbor_src_address.parent = self
                                                        self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                    return self.neighbor_src_address

                                                if (child_yang_name == "neighbor-transport-address"):
                                                    if (self.neighbor_transport_address is None):
                                                        self.neighbor_transport_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                        self.neighbor_transport_address.parent = self
                                                        self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                    return self.neighbor_transport_address

                                                if (child_yang_name == "target"):
                                                    if (self.target is None):
                                                        self.target = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                        self.target.parent = self
                                                        self._children_name_map["target"] = "target"
                                                    return self.target

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-info" or name == "neighbor-src-address" or name == "neighbor-transport-address" or name == "target" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "is-no-route" or name == "is-targeted" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "neighbor-ldp-identifier" or name == "session-bringup-failure-reason" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "disc-expiry"):
                                                    self.disc_expiry = value
                                                    self.disc_expiry.value_namespace = name_space
                                                    self.disc_expiry.value_namespace_prefix = name_space_prefix
                                                if(value_path == "established-age"):
                                                    self.established_age = value
                                                    self.established_age.value_namespace = name_space
                                                    self.established_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "established-time"):
                                                    self.established_time = value
                                                    self.established_time.value_namespace = name_space
                                                    self.established_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-route"):
                                                    self.is_no_route = value
                                                    self.is_no_route.value_namespace = name_space
                                                    self.is_no_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-targeted"):
                                                    self.is_targeted = value
                                                    self.is_targeted.value_namespace = name_space
                                                    self.is_targeted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-hold-time"):
                                                    self.local_hold_time = value
                                                    self.local_hold_time.value_namespace = name_space
                                                    self.local_hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-hold-time"):
                                                    self.neighbor_hold_time = value
                                                    self.neighbor_hold_time.value_namespace = name_space
                                                    self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-bringup-failure-reason"):
                                                    self.session_bringup_failure_reason = value
                                                    self.session_bringup_failure_reason.value_namespace = name_space
                                                    self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix


                                        class DiscoveryLinkAf(Entity):
                                            """
                                            LDP hello AF info
                                            
                                            .. attribute:: interval
                                            
                                            	Hello interval in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: local_src_address
                                            
                                            	Local source address
                                            	**type**\:   :py:class:`LocalSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress>`
                                            
                                            .. attribute:: local_transport_address
                                            
                                            	Local transport address
                                            	**type**\:   :py:class:`LocalTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__init__()

                                                self.yang_name = "discovery-link-af"
                                                self.yang_parent_name = "link-hello"

                                                self.interval = YLeaf(YType.uint32, "interval")

                                                self.local_src_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                self.local_src_address.parent = self
                                                self._children_name_map["local_src_address"] = "local-src-address"
                                                self._children_yang_names.add("local-src-address")

                                                self.local_transport_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                self.local_transport_address.parent = self
                                                self._children_name_map["local_transport_address"] = "local-transport-address"
                                                self._children_yang_names.add("local-transport-address")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interval") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)


                                            class LocalSrcAddress(Entity):
                                                """
                                                Local source address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__init__()

                                                    self.yang_name = "local-src-address"
                                                    self.yang_parent_name = "discovery-link-af"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "local-src-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class LocalTransportAddress(Entity):
                                                """
                                                Local transport address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__init__()

                                                    self.yang_name = "local-transport-address"
                                                    self.yang_parent_name = "discovery-link-af"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "local-transport-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interval.is_set or
                                                    (self.local_src_address is not None and self.local_src_address.has_data()) or
                                                    (self.local_transport_address is not None and self.local_transport_address.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interval.yfilter != YFilter.not_set or
                                                    (self.local_src_address is not None and self.local_src_address.has_operation()) or
                                                    (self.local_transport_address is not None and self.local_transport_address.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "discovery-link-af" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interval.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "local-src-address"):
                                                    if (self.local_src_address is None):
                                                        self.local_src_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                        self.local_src_address.parent = self
                                                        self._children_name_map["local_src_address"] = "local-src-address"
                                                    return self.local_src_address

                                                if (child_yang_name == "local-transport-address"):
                                                    if (self.local_transport_address is None):
                                                        self.local_transport_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                        self.local_transport_address.parent = self
                                                        self._children_name_map["local_transport_address"] = "local-transport-address"
                                                    return self.local_transport_address

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "local-src-address" or name == "local-transport-address" or name == "interval"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interval"):
                                                    self.interval = value
                                                    self.interval.value_namespace = name_space
                                                    self.interval.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.discovery_link_af:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.interface.is_set or
                                                self.interface_name_xr.is_set or
                                                self.next_hello.is_set or
                                                self.quick_start_disabled.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.discovery_link_af:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                self.next_hello.yfilter != YFilter.not_set or
                                                self.quick_start_disabled.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                            if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hello.get_name_leafdata())
                                            if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "discovery-link-af"):
                                                for c in self.discovery_link_af:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.discovery_link_af.append(c)
                                                return c

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "discovery-link-af" or name == "hello-information" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "next-hello" or name == "quick-start-disabled"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hello"):
                                                self.next_hello = value
                                                self.next_hello.value_namespace = name_space
                                                self.next_hello.value_namespace_prefix = name_space_prefix
                                            if(value_path == "quick-start-disabled"):
                                                self.quick_start_disabled = value
                                                self.quick_start_disabled.value_namespace = name_space
                                                self.quick_start_disabled.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link_hello:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.link_hello:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hellos" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello"):
                                            for c in self.link_hello:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link_hello.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Summary(Entity):
                                    """
                                    Summarized information on LDP discovery
                                    
                                    .. attribute:: local_ldp_id
                                    
                                    	Local LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: num_of_active_ldp_interfaces
                                    
                                    	Number of active LDP enabled interfaces
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_addr_recv
                                    
                                    	Number of hello discoveries received with bad source address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_hello_pdu
                                    
                                    	Number of hello discoveries received with bad hello PDU
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_xport_addr
                                    
                                    	Number of hello discoveries received with bad export address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_same_router_id
                                    
                                    	Number of hello discoveries received with the same router id as this router
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_wrong_router_id
                                    
                                    	Number of hello discoveries received with the router id that is not destined for this router
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_ldp_interfaces
                                    
                                    	Total Number of LDP configured interfaces
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_lnk_disc_recv
                                    
                                    	Number of link hello discoveries in recv state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_lnk_disc_xmit
                                    
                                    	Number of link hello discoveries in xmit state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_tgt_disc_recv
                                    
                                    	Number of targeted hello discoveries in recv state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_tgt_disc_xmit
                                    
                                    	Number of targeted hello discoveries in xmit state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__init__()

                                        self.yang_name = "summary"
                                        self.yang_parent_name = "discovery"

                                        self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                                        self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                                        self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                                        self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                                        self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                                        self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                                        self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                                        self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                                        self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                                        self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                                        self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                                        self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_ldp_id",
                                                        "num_of_active_ldp_interfaces",
                                                        "num_of_disc_with_bad_addr_recv",
                                                        "num_of_disc_with_bad_hello_pdu",
                                                        "num_of_disc_with_bad_xport_addr",
                                                        "num_of_disc_with_same_router_id",
                                                        "num_of_disc_with_wrong_router_id",
                                                        "num_of_ldp_interfaces",
                                                        "num_of_lnk_disc_recv",
                                                        "num_of_lnk_disc_xmit",
                                                        "num_of_tgt_disc_recv",
                                                        "num_of_tgt_disc_xmit") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "summary"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.local_ldp_id.is_set or
                                            self.num_of_active_ldp_interfaces.is_set or
                                            self.num_of_disc_with_bad_addr_recv.is_set or
                                            self.num_of_disc_with_bad_hello_pdu.is_set or
                                            self.num_of_disc_with_bad_xport_addr.is_set or
                                            self.num_of_disc_with_same_router_id.is_set or
                                            self.num_of_disc_with_wrong_router_id.is_set or
                                            self.num_of_ldp_interfaces.is_set or
                                            self.num_of_lnk_disc_recv.is_set or
                                            self.num_of_lnk_disc_xmit.is_set or
                                            self.num_of_tgt_disc_recv.is_set or
                                            self.num_of_tgt_disc_xmit.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_ldp_id.yfilter != YFilter.not_set or
                                            self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                                            self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                                            self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                                            self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                                            self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                                            self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "summary" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                                        if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                                        if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                                        if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                                        if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                                        if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                                        if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                                        if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                                        if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-ldp-id"):
                                            self.local_ldp_id = value
                                            self.local_ldp_id.value_namespace = name_space
                                            self.local_ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-active-ldp-interfaces"):
                                            self.num_of_active_ldp_interfaces = value
                                            self.num_of_active_ldp_interfaces.value_namespace = name_space
                                            self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-addr-recv"):
                                            self.num_of_disc_with_bad_addr_recv = value
                                            self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                                            self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-hello-pdu"):
                                            self.num_of_disc_with_bad_hello_pdu = value
                                            self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                                            self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-xport-addr"):
                                            self.num_of_disc_with_bad_xport_addr = value
                                            self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                                            self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-same-router-id"):
                                            self.num_of_disc_with_same_router_id = value
                                            self.num_of_disc_with_same_router_id.value_namespace = name_space
                                            self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-wrong-router-id"):
                                            self.num_of_disc_with_wrong_router_id = value
                                            self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                                            self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-ldp-interfaces"):
                                            self.num_of_ldp_interfaces = value
                                            self.num_of_ldp_interfaces.value_namespace = name_space
                                            self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-lnk-disc-recv"):
                                            self.num_of_lnk_disc_recv = value
                                            self.num_of_lnk_disc_recv.value_namespace = name_space
                                            self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-lnk-disc-xmit"):
                                            self.num_of_lnk_disc_xmit = value
                                            self.num_of_lnk_disc_xmit.value_namespace = name_space
                                            self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-tgt-disc-recv"):
                                            self.num_of_tgt_disc_recv = value
                                            self.num_of_tgt_disc_recv.value_namespace = name_space
                                            self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-tgt-disc-xmit"):
                                            self.num_of_tgt_disc_xmit = value
                                            self.num_of_tgt_disc_xmit.value_namespace = name_space
                                            self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix


                                class TargetedHellos(Entity):
                                    """
                                    The LDP Discovery Targeted
                                    
                                    .. attribute:: targeted_hello
                                    
                                    	Information on LDP targeted discovery
                                    	**type**\: list of    :py:class:`TargetedHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__init__()

                                        self.yang_name = "targeted-hellos"
                                        self.yang_parent_name = "discovery"

                                        self.targeted_hello = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)


                                    class TargetedHello(Entity):
                                        """
                                        Information on LDP targeted discovery
                                        
                                        .. attribute:: adjacency_ldp_identifier
                                        
                                        	Adjacency LDP Identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: dhcb_local_address
                                        
                                        	DHCB local address
                                        	**type**\:   :py:class:`DhcbLocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress>`
                                        
                                        .. attribute:: dhcb_target_address
                                        
                                        	DHCB target address
                                        	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress>`
                                        
                                        .. attribute:: disc_expiry
                                        
                                        	Discovery expiry time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: established_age
                                        
                                        	Hello adjacency estabished age in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: established_time
                                        
                                        	Hello adjacency estabished time in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: hold_time
                                        
                                        	Targeted hello hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interval
                                        
                                        	Hello interval in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: last_session_down_info
                                        
                                        	Last session down information
                                        	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo>`
                                        
                                        .. attribute:: local_address
                                        
                                        	Local IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: local_hold_time
                                        
                                        	Local hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_hold_time
                                        
                                        	Neighbor hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hello
                                        
                                        	Next hello due time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: quick_start_disabled
                                        
                                        	Quick\-start disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: session_bringup_failure_reason
                                        
                                        	session bringup failure reason
                                        	**type**\:  str
                                        
                                        .. attribute:: session_up
                                        
                                        	Is session up for this adj
                                        	**type**\:  bool
                                        
                                        .. attribute:: state
                                        
                                        	Targeted hello state
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	The target IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__init__()

                                            self.yang_name = "targeted-hello"
                                            self.yang_parent_name = "targeted-hellos"

                                            self.adjacency_ldp_identifier = YLeaf(YType.str, "adjacency-ldp-identifier")

                                            self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                            self.established_age = YLeaf(YType.uint64, "established-age")

                                            self.established_time = YLeaf(YType.uint64, "established-time")

                                            self.hold_time = YLeaf(YType.uint32, "hold-time")

                                            self.interval = YLeaf(YType.uint32, "interval")

                                            self.local_address = YLeaf(YType.str, "local-address")

                                            self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                            self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                            self.next_hello = YLeaf(YType.uint32, "next-hello")

                                            self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                            self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                            self.session_up = YLeaf(YType.boolean, "session-up")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.target_address = YLeaf(YType.str, "target-address")

                                            self.dhcb_local_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                            self.dhcb_local_address.parent = self
                                            self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                            self._children_yang_names.add("dhcb-local-address")

                                            self.dhcb_target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                            self.dhcb_target_address.parent = self
                                            self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            self._children_yang_names.add("dhcb-target-address")

                                            self.last_session_down_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("adjacency_ldp_identifier",
                                                            "disc_expiry",
                                                            "established_age",
                                                            "established_time",
                                                            "hold_time",
                                                            "interval",
                                                            "local_address",
                                                            "local_hold_time",
                                                            "neighbor_hold_time",
                                                            "next_hello",
                                                            "quick_start_disabled",
                                                            "session_bringup_failure_reason",
                                                            "session_up",
                                                            "state",
                                                            "target_address") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)


                                        class DhcbLocalAddress(Entity):
                                            """
                                            DHCB local address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__init__()

                                                self.yang_name = "dhcb-local-address"
                                                self.yang_parent_name = "targeted-hello"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class DhcbTargetAddress(Entity):
                                            """
                                            DHCB target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__init__()

                                                self.yang_name = "dhcb-target-address"
                                                self.yang_parent_name = "targeted-hello"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LastSessionDownInfo(Entity):
                                            """
                                            Last session down information
                                            
                                            .. attribute:: last_session_down_reason
                                            
                                            	The reason of last socket failure
                                            	**type**\:  str
                                            
                                            .. attribute:: last_session_down_time
                                            
                                            	Timestamp of when the last session went down
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: last_session_up_time
                                            
                                            	The time duration the last session was up
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__init__()

                                                self.yang_name = "last-session-down-info"
                                                self.yang_parent_name = "targeted-hello"

                                                self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("last_session_down_reason",
                                                                "last_session_down_time",
                                                                "last_session_up_time") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.last_session_down_reason.is_set or
                                                    self.last_session_down_time.is_set or
                                                    self.last_session_up_time.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.last_session_down_reason.yfilter != YFilter.not_set or
                                                    self.last_session_down_time.yfilter != YFilter.not_set or
                                                    self.last_session_up_time.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "last-session-down-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "last-session-down-reason"):
                                                    self.last_session_down_reason = value
                                                    self.last_session_down_reason.value_namespace = name_space
                                                    self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-down-time"):
                                                    self.last_session_down_time = value
                                                    self.last_session_down_time.value_namespace = name_space
                                                    self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-up-time"):
                                                    self.last_session_up_time = value
                                                    self.last_session_up_time.value_namespace = name_space
                                                    self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.adjacency_ldp_identifier.is_set or
                                                self.disc_expiry.is_set or
                                                self.established_age.is_set or
                                                self.established_time.is_set or
                                                self.hold_time.is_set or
                                                self.interval.is_set or
                                                self.local_address.is_set or
                                                self.local_hold_time.is_set or
                                                self.neighbor_hold_time.is_set or
                                                self.next_hello.is_set or
                                                self.quick_start_disabled.is_set or
                                                self.session_bringup_failure_reason.is_set or
                                                self.session_up.is_set or
                                                self.state.is_set or
                                                self.target_address.is_set or
                                                (self.dhcb_local_address is not None and self.dhcb_local_address.has_data()) or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()))

                                        def has_operation(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.adjacency_ldp_identifier.yfilter != YFilter.not_set or
                                                self.disc_expiry.yfilter != YFilter.not_set or
                                                self.established_age.yfilter != YFilter.not_set or
                                                self.established_time.yfilter != YFilter.not_set or
                                                self.hold_time.yfilter != YFilter.not_set or
                                                self.interval.yfilter != YFilter.not_set or
                                                self.local_address.yfilter != YFilter.not_set or
                                                self.local_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                self.next_hello.yfilter != YFilter.not_set or
                                                self.quick_start_disabled.yfilter != YFilter.not_set or
                                                self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                self.session_up.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.target_address.yfilter != YFilter.not_set or
                                                (self.dhcb_local_address is not None and self.dhcb_local_address.has_operation()) or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.adjacency_ldp_identifier.is_set or self.adjacency_ldp_identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.adjacency_ldp_identifier.get_name_leafdata())
                                            if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                            if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_age.get_name_leafdata())
                                            if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_time.get_name_leafdata())
                                            if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_time.get_name_leafdata())
                                            if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interval.get_name_leafdata())
                                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_address.get_name_leafdata())
                                            if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                            if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                            if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hello.get_name_leafdata())
                                            if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())
                                            if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                            if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_up.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.target_address.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "dhcb-local-address"):
                                                if (self.dhcb_local_address is None):
                                                    self.dhcb_local_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                                    self.dhcb_local_address.parent = self
                                                    self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                                return self.dhcb_local_address

                                            if (child_yang_name == "dhcb-target-address"):
                                                if (self.dhcb_target_address is None):
                                                    self.dhcb_target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                                    self.dhcb_target_address.parent = self
                                                    self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                return self.dhcb_target_address

                                            if (child_yang_name == "last-session-down-info"):
                                                for c in self.last_session_down_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.last_session_down_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "dhcb-local-address" or name == "dhcb-target-address" or name == "last-session-down-info" or name == "adjacency-ldp-identifier" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "interval" or name == "local-address" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "next-hello" or name == "quick-start-disabled" or name == "session-bringup-failure-reason" or name == "session-up" or name == "state" or name == "target-address"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "adjacency-ldp-identifier"):
                                                self.adjacency_ldp_identifier = value
                                                self.adjacency_ldp_identifier.value_namespace = name_space
                                                self.adjacency_ldp_identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "disc-expiry"):
                                                self.disc_expiry = value
                                                self.disc_expiry.value_namespace = name_space
                                                self.disc_expiry.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-age"):
                                                self.established_age = value
                                                self.established_age.value_namespace = name_space
                                                self.established_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-time"):
                                                self.established_time = value
                                                self.established_time.value_namespace = name_space
                                                self.established_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-time"):
                                                self.hold_time = value
                                                self.hold_time.value_namespace = name_space
                                                self.hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interval"):
                                                self.interval = value
                                                self.interval.value_namespace = name_space
                                                self.interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-address"):
                                                self.local_address = value
                                                self.local_address.value_namespace = name_space
                                                self.local_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-hold-time"):
                                                self.local_hold_time = value
                                                self.local_hold_time.value_namespace = name_space
                                                self.local_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-hold-time"):
                                                self.neighbor_hold_time = value
                                                self.neighbor_hold_time.value_namespace = name_space
                                                self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hello"):
                                                self.next_hello = value
                                                self.next_hello.value_namespace = name_space
                                                self.next_hello.value_namespace_prefix = name_space_prefix
                                            if(value_path == "quick-start-disabled"):
                                                self.quick_start_disabled = value
                                                self.quick_start_disabled.value_namespace = name_space
                                                self.quick_start_disabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-bringup-failure-reason"):
                                                self.session_bringup_failure_reason = value
                                                self.session_bringup_failure_reason.value_namespace = name_space
                                                self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-up"):
                                                self.session_up = value
                                                self.session_up.value_namespace = name_space
                                                self.session_up.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "target-address"):
                                                self.target_address = value
                                                self.target_address.value_namespace = name_space
                                                self.target_address.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.targeted_hello:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.targeted_hello:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hellos" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "targeted-hello"):
                                            for c in self.targeted_hello:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.targeted_hello.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "targeted-hello"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Brief(Entity):
                                    """
                                    Brief information on LDP discovery
                                    
                                    .. attribute:: link_hello_briefs
                                    
                                    	The LDP Discovery link brief information
                                    	**type**\:   :py:class:`LinkHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs>`
                                    
                                    .. attribute:: targeted_hello_briefs
                                    
                                    	The LDP Discovery Targeted brief information
                                    	**type**\:   :py:class:`TargetedHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief, self).__init__()

                                        self.yang_name = "brief"
                                        self.yang_parent_name = "discovery"

                                        self.link_hello_briefs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                        self.link_hello_briefs.parent = self
                                        self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                        self._children_yang_names.add("link-hello-briefs")

                                        self.targeted_hello_briefs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                        self.targeted_hello_briefs.parent = self
                                        self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                        self._children_yang_names.add("targeted-hello-briefs")


                                    class LinkHelloBriefs(Entity):
                                        """
                                        The LDP Discovery link brief information
                                        
                                        .. attribute:: link_hello_brief
                                        
                                        	Brief information on LDP link discovery
                                        	**type**\: list of    :py:class:`LinkHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__init__()

                                            self.yang_name = "link-hello-briefs"
                                            self.yang_parent_name = "brief"

                                            self.link_hello_brief = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)


                                        class LinkHelloBrief(Entity):
                                            """
                                            Brief information on LDP link discovery
                                            
                                            .. attribute:: interface_name  <key>
                                            
                                            	The Interface Name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: address_family
                                            
                                            	Discovery Brief Address Family
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: address_family_set
                                            
                                            	Discovery Brief Address Family Set
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: hello_information
                                            
                                            	LDP hello info
                                            	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation>`
                                            
                                            .. attribute:: interface
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: interface_name_xr
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            .. attribute:: vrf
                                            
                                            	VRF information
                                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__init__()

                                                self.yang_name = "link-hello-brief"
                                                self.yang_parent_name = "link-hello-briefs"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                                self.address_family_set = YLeaf(YType.enumeration, "address-family-set")

                                                self.interface = YLeaf(YType.str, "interface")

                                                self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                                self._children_yang_names.add("vrf")

                                                self.hello_information = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "address_family",
                                                                "address_family_set",
                                                                "interface",
                                                                "interface_name_xr") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)


                                            class Vrf(Entity):
                                                """
                                                VRF information
                                                
                                                .. attribute:: id
                                                
                                                	VRF Id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	VRF Name
                                                	**type**\:  str
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__init__()

                                                    self.yang_name = "vrf"
                                                    self.yang_parent_name = "link-hello-brief"

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("id",
                                                                    "name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.id.is_set or
                                                        self.name.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.id.yfilter != YFilter.not_set or
                                                        self.name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "vrf" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.id.get_name_leafdata())
                                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "id" or name == "name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "id"):
                                                        self.id = value
                                                        self.id.value_namespace = name_space
                                                        self.id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "name"):
                                                        self.name = value
                                                        self.name.value_namespace = name_space
                                                        self.name.value_namespace_prefix = name_space_prefix


                                            class HelloInformation(Entity):
                                                """
                                                LDP hello info
                                                
                                                .. attribute:: hold_time
                                                
                                                	Session hold time in sec
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: neighbor_ldp_identifier
                                                
                                                	Neighbor LDP Identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: session_up
                                                
                                                	Is session up for this adj
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__init__()

                                                    self.yang_name = "hello-information"
                                                    self.yang_parent_name = "link-hello-brief"

                                                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                    self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                    self.session_up = YLeaf(YType.boolean, "session-up")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("hold_time",
                                                                    "neighbor_ldp_identifier",
                                                                    "session_up") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.hold_time.is_set or
                                                        self.neighbor_ldp_identifier.is_set or
                                                        self.session_up.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.hold_time.yfilter != YFilter.not_set or
                                                        self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                        self.session_up.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "hello-information" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                    if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                    if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.session_up.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "hold-time"):
                                                        self.hold_time = value
                                                        self.hold_time.value_namespace = name_space
                                                        self.hold_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "neighbor-ldp-identifier"):
                                                        self.neighbor_ldp_identifier = value
                                                        self.neighbor_ldp_identifier.value_namespace = name_space
                                                        self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "session-up"):
                                                        self.session_up = value
                                                        self.session_up.value_namespace = name_space
                                                        self.session_up.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.hello_information:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.interface_name.is_set or
                                                    self.address_family.is_set or
                                                    self.address_family_set.is_set or
                                                    self.interface.is_set or
                                                    self.interface_name_xr.is_set or
                                                    (self.vrf is not None and self.vrf.has_data()))

                                            def has_operation(self):
                                                for c in self.hello_information:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.address_family.yfilter != YFilter.not_set or
                                                    self.address_family_set.yfilter != YFilter.not_set or
                                                    self.interface.yfilter != YFilter.not_set or
                                                    self.interface_name_xr.yfilter != YFilter.not_set or
                                                    (self.vrf is not None and self.vrf.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "link-hello-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                                if (self.address_family_set.is_set or self.address_family_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family_set.get_name_leafdata())
                                                if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface.get_name_leafdata())
                                                if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "hello-information"):
                                                    for c in self.hello_information:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.hello_information.append(c)
                                                    return c

                                                if (child_yang_name == "vrf"):
                                                    if (self.vrf is None):
                                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                        self.vrf.parent = self
                                                        self._children_name_map["vrf"] = "vrf"
                                                    return self.vrf

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hello-information" or name == "vrf" or name == "interface-name" or name == "address-family" or name == "address-family-set" or name == "interface" or name == "interface-name-xr"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "address-family"):
                                                    self.address_family = value
                                                    self.address_family.value_namespace = name_space
                                                    self.address_family.value_namespace_prefix = name_space_prefix
                                                if(value_path == "address-family-set"):
                                                    self.address_family_set = value
                                                    self.address_family_set.value_namespace = name_space
                                                    self.address_family_set.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface"):
                                                    self.interface = value
                                                    self.interface.value_namespace = name_space
                                                    self.interface.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface-name-xr"):
                                                    self.interface_name_xr = value
                                                    self.interface_name_xr.value_namespace = name_space
                                                    self.interface_name_xr.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.link_hello_brief:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.link_hello_brief:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-briefs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "link-hello-brief"):
                                                for c in self.link_hello_brief:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.link_hello_brief.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "link-hello-brief"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TargetedHelloBriefs(Entity):
                                        """
                                        The LDP Discovery Targeted brief information
                                        
                                        .. attribute:: targeted_hello_brief
                                        
                                        	Brief information on LDP targeted discovery
                                        	**type**\: list of    :py:class:`TargetedHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__init__()

                                            self.yang_name = "targeted-hello-briefs"
                                            self.yang_parent_name = "brief"

                                            self.targeted_hello_brief = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)


                                        class TargetedHelloBrief(Entity):
                                            """
                                            Brief information on LDP targeted discovery
                                            
                                            .. attribute:: address_family
                                            
                                            	Targeted Discovery Address Family
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: dhcb_target_address
                                            
                                            	DHCB target address
                                            	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress>`
                                            
                                            .. attribute:: hello_information
                                            
                                            	LDP hello info
                                            	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation>`
                                            
                                            .. attribute:: local_address
                                            
                                            	Local IP Address
                                            	**type**\: one of the below types:
                                            
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            .. attribute:: target_address
                                            
                                            	The target IP Address
                                            	**type**\: one of the below types:
                                            
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            .. attribute:: vrf
                                            
                                            	VRF information
                                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__init__()

                                                self.yang_name = "targeted-hello-brief"
                                                self.yang_parent_name = "targeted-hello-briefs"

                                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                                self.local_address = YLeaf(YType.str, "local-address")

                                                self.target_address = YLeaf(YType.str, "target-address")

                                                self.dhcb_target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                self.dhcb_target_address.parent = self
                                                self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                self._children_yang_names.add("dhcb-target-address")

                                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                                self._children_yang_names.add("vrf")

                                                self.hello_information = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("address_family",
                                                                "local_address",
                                                                "target_address") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)


                                            class Vrf(Entity):
                                                """
                                                VRF information
                                                
                                                .. attribute:: id
                                                
                                                	VRF Id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	VRF Name
                                                	**type**\:  str
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__init__()

                                                    self.yang_name = "vrf"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("id",
                                                                    "name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.id.is_set or
                                                        self.name.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.id.yfilter != YFilter.not_set or
                                                        self.name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "vrf" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.id.get_name_leafdata())
                                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "id" or name == "name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "id"):
                                                        self.id = value
                                                        self.id.value_namespace = name_space
                                                        self.id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "name"):
                                                        self.name = value
                                                        self.name.value_namespace = name_space
                                                        self.name.value_namespace_prefix = name_space_prefix


                                            class DhcbTargetAddress(Entity):
                                                """
                                                DHCB target address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__init__()

                                                    self.yang_name = "dhcb-target-address"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "dhcb-target-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class HelloInformation(Entity):
                                                """
                                                LDP hello info
                                                
                                                .. attribute:: hold_time
                                                
                                                	Session hold time in sec
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: neighbor_ldp_identifier
                                                
                                                	Neighbor LDP Identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: session_up
                                                
                                                	Is session up for this adj
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__init__()

                                                    self.yang_name = "hello-information"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                    self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                    self.session_up = YLeaf(YType.boolean, "session-up")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("hold_time",
                                                                    "neighbor_ldp_identifier",
                                                                    "session_up") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.hold_time.is_set or
                                                        self.neighbor_ldp_identifier.is_set or
                                                        self.session_up.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.hold_time.yfilter != YFilter.not_set or
                                                        self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                        self.session_up.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "hello-information" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                    if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                    if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.session_up.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "hold-time"):
                                                        self.hold_time = value
                                                        self.hold_time.value_namespace = name_space
                                                        self.hold_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "neighbor-ldp-identifier"):
                                                        self.neighbor_ldp_identifier = value
                                                        self.neighbor_ldp_identifier.value_namespace = name_space
                                                        self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "session-up"):
                                                        self.session_up = value
                                                        self.session_up.value_namespace = name_space
                                                        self.session_up.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.hello_information:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.address_family.is_set or
                                                    self.local_address.is_set or
                                                    self.target_address.is_set or
                                                    (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()) or
                                                    (self.vrf is not None and self.vrf.has_data()))

                                            def has_operation(self):
                                                for c in self.hello_information:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.address_family.yfilter != YFilter.not_set or
                                                    self.local_address.yfilter != YFilter.not_set or
                                                    self.target_address.yfilter != YFilter.not_set or
                                                    (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()) or
                                                    (self.vrf is not None and self.vrf.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "targeted-hello-brief" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                                if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_address.get_name_leafdata())
                                                if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.target_address.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "dhcb-target-address"):
                                                    if (self.dhcb_target_address is None):
                                                        self.dhcb_target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                        self.dhcb_target_address.parent = self
                                                        self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                    return self.dhcb_target_address

                                                if (child_yang_name == "hello-information"):
                                                    for c in self.hello_information:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.hello_information.append(c)
                                                    return c

                                                if (child_yang_name == "vrf"):
                                                    if (self.vrf is None):
                                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                        self.vrf.parent = self
                                                        self._children_name_map["vrf"] = "vrf"
                                                    return self.vrf

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "dhcb-target-address" or name == "hello-information" or name == "vrf" or name == "address-family" or name == "local-address" or name == "target-address"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "address-family"):
                                                    self.address_family = value
                                                    self.address_family.value_namespace = name_space
                                                    self.address_family.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-address"):
                                                    self.local_address = value
                                                    self.local_address.value_namespace = name_space
                                                    self.local_address.value_namespace_prefix = name_space_prefix
                                                if(value_path == "target-address"):
                                                    self.target_address = value
                                                    self.target_address.value_namespace = name_space
                                                    self.target_address.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.targeted_hello_brief:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.targeted_hello_brief:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello-briefs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "targeted-hello-brief"):
                                                for c in self.targeted_hello_brief:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.targeted_hello_brief.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "targeted-hello-brief"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.link_hello_briefs is not None and self.link_hello_briefs.has_data()) or
                                            (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.link_hello_briefs is not None and self.link_hello_briefs.has_operation()) or
                                            (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "brief" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-briefs"):
                                            if (self.link_hello_briefs is None):
                                                self.link_hello_briefs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                                self.link_hello_briefs.parent = self
                                                self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                            return self.link_hello_briefs

                                        if (child_yang_name == "targeted-hello-briefs"):
                                            if (self.targeted_hello_briefs is None):
                                                self.targeted_hello_briefs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                                self.targeted_hello_briefs.parent = self
                                                self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                            return self.targeted_hello_briefs

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-briefs" or name == "targeted-hello-briefs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Stats(Entity):
                                    """
                                    The LDP Discovery Statistics
                                    
                                    .. attribute:: stat
                                    
                                    	Information on LDP discovery statistics
                                    	**type**\: list of    :py:class:`Stat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__init__()

                                        self.yang_name = "stats"
                                        self.yang_parent_name = "discovery"

                                        self.stat = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)


                                    class Stat(Entity):
                                        """
                                        Information on LDP discovery statistics
                                        
                                        .. attribute:: adjacency_group_up_time
                                        
                                        	Adjacency group up time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space ID of neighbor
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR ID of neighbor
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: tcp_arb_chg_count
                                        
                                        	Count of changes in TCP arbitration
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tcp_open_count
                                        
                                        	Count of attempted TCP opens
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tcp_role
                                        
                                        	TCP Role
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__init__()

                                            self.yang_name = "stat"
                                            self.yang_parent_name = "stats"

                                            self.adjacency_group_up_time = YLeaf(YType.uint32, "adjacency-group-up-time")

                                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                            self.tcp_arb_chg_count = YLeaf(YType.uint32, "tcp-arb-chg-count")

                                            self.tcp_open_count = YLeaf(YType.uint32, "tcp-open-count")

                                            self.tcp_role = YLeaf(YType.uint32, "tcp-role")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("adjacency_group_up_time",
                                                            "label_space_id",
                                                            "lsr_id",
                                                            "tcp_arb_chg_count",
                                                            "tcp_open_count",
                                                            "tcp_role") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.adjacency_group_up_time.is_set or
                                                self.label_space_id.is_set or
                                                self.lsr_id.is_set or
                                                self.tcp_arb_chg_count.is_set or
                                                self.tcp_open_count.is_set or
                                                self.tcp_role.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.adjacency_group_up_time.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set or
                                                self.tcp_arb_chg_count.yfilter != YFilter.not_set or
                                                self.tcp_open_count.yfilter != YFilter.not_set or
                                                self.tcp_role.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "stat" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.adjacency_group_up_time.is_set or self.adjacency_group_up_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.adjacency_group_up_time.get_name_leafdata())
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                            if (self.tcp_arb_chg_count.is_set or self.tcp_arb_chg_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_arb_chg_count.get_name_leafdata())
                                            if (self.tcp_open_count.is_set or self.tcp_open_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_open_count.get_name_leafdata())
                                            if (self.tcp_role.is_set or self.tcp_role.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_role.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "adjacency-group-up-time" or name == "label-space-id" or name == "lsr-id" or name == "tcp-arb-chg-count" or name == "tcp-open-count" or name == "tcp-role"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "adjacency-group-up-time"):
                                                self.adjacency_group_up_time = value
                                                self.adjacency_group_up_time.value_namespace = name_space
                                                self.adjacency_group_up_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-arb-chg-count"):
                                                self.tcp_arb_chg_count = value
                                                self.tcp_arb_chg_count.value_namespace = name_space
                                                self.tcp_arb_chg_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-open-count"):
                                                self.tcp_open_count = value
                                                self.tcp_open_count.value_namespace = name_space
                                                self.tcp_open_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-role"):
                                                self.tcp_role = value
                                                self.tcp_role.value_namespace = name_space
                                                self.tcp_role.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.stat:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.stat:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "stat"):
                                            for c in self.stat:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.stat.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "stat"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        (self.brief is not None and self.brief.has_data()) or
                                        (self.link_hellos is not None and self.link_hellos.has_data()) or
                                        (self.stats is not None and self.stats.has_data()) or
                                        (self.summary is not None and self.summary.has_data()) or
                                        (self.targeted_hellos is not None and self.targeted_hellos.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.brief is not None and self.brief.has_operation()) or
                                        (self.link_hellos is not None and self.link_hellos.has_operation()) or
                                        (self.stats is not None and self.stats.has_operation()) or
                                        (self.summary is not None and self.summary.has_operation()) or
                                        (self.targeted_hellos is not None and self.targeted_hellos.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovery" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "brief"):
                                        if (self.brief is None):
                                            self.brief = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Brief()
                                            self.brief.parent = self
                                            self._children_name_map["brief"] = "brief"
                                        return self.brief

                                    if (child_yang_name == "link-hellos"):
                                        if (self.link_hellos is None):
                                            self.link_hellos = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos()
                                            self.link_hellos.parent = self
                                            self._children_name_map["link_hellos"] = "link-hellos"
                                        return self.link_hellos

                                    if (child_yang_name == "stats"):
                                        if (self.stats is None):
                                            self.stats = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Stats()
                                            self.stats.parent = self
                                            self._children_name_map["stats"] = "stats"
                                        return self.stats

                                    if (child_yang_name == "summary"):
                                        if (self.summary is None):
                                            self.summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.Summary()
                                            self.summary.parent = self
                                            self._children_name_map["summary"] = "summary"
                                        return self.summary

                                    if (child_yang_name == "targeted-hellos"):
                                        if (self.targeted_hellos is None):
                                            self.targeted_hellos = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos()
                                            self.targeted_hellos.parent = self
                                            self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                        return self.targeted_hellos

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "brief" or name == "link-hellos" or name == "stats" or name == "summary" or name == "targeted-hellos"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsSummaryAll(Entity):
                                """
                                Aggregate VRF counters for the LDP Label
                                Infomation Base (LIB)
                                
                                .. attribute:: address_family
                                
                                	Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: bind_af
                                
                                	bind af
                                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf>`
                                
                                .. attribute:: binding_local_explicit_null
                                
                                	Number of local explicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_implicit_null
                                
                                	Number of local implicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_no_route
                                
                                	Local bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_non_null
                                
                                	Number of local non\-null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_null
                                
                                	Number of local null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_oor
                                
                                	Number of local bindings        needing label \- OOR
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_no_route
                                
                                	Bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: highest_allocated_label
                                
                                	Highest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lowest_allocated_label
                                
                                	Lowest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__init__()

                                    self.yang_name = "bindings-summary-all"
                                    self.yang_parent_name = "af"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                    self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.bind_af = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local_explicit_null",
                                                    "binding_local_implicit_null",
                                                    "binding_local_no_route",
                                                    "binding_local_non_null",
                                                    "binding_local_null",
                                                    "binding_local_oor",
                                                    "binding_no_route",
                                                    "highest_allocated_label",
                                                    "lowest_allocated_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "bindings-summary-all"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class BindAf(Entity):
                                    """
                                    bind af
                                    
                                    .. attribute:: address_family
                                    
                                    	Binding Summary Address Family
                                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                    
                                    .. attribute:: binding_local
                                    
                                    	Number of local bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_remote
                                    
                                    	Number of remote bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_total
                                    
                                    	Total bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_lib_update
                                    
                                    	Last update to LIB local binding
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lib_minimum_revision_sent_all
                                    
                                    	Last update sent to all peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__init__()

                                        self.yang_name = "bind-af"
                                        self.yang_parent_name = "bindings-summary-all"

                                        self.address_family = YLeaf(YType.enumeration, "address-family")

                                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address_family",
                                                        "binding_local",
                                                        "binding_remote",
                                                        "binding_total",
                                                        "last_lib_update",
                                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address_family.is_set or
                                            self.binding_local.is_set or
                                            self.binding_remote.is_set or
                                            self.binding_total.is_set or
                                            self.last_lib_update.is_set or
                                            self.lib_minimum_revision_sent_all.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address_family.yfilter != YFilter.not_set or
                                            self.binding_local.yfilter != YFilter.not_set or
                                            self.binding_remote.yfilter != YFilter.not_set or
                                            self.binding_total.yfilter != YFilter.not_set or
                                            self.last_lib_update.yfilter != YFilter.not_set or
                                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bind-af" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address_family.get_name_leafdata())
                                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address-family"):
                                            self.address_family = value
                                            self.address_family.value_namespace = name_space
                                            self.address_family.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-local"):
                                            self.binding_local = value
                                            self.binding_local.value_namespace = name_space
                                            self.binding_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-remote"):
                                            self.binding_remote = value
                                            self.binding_remote.value_namespace = name_space
                                            self.binding_remote.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-total"):
                                            self.binding_total = value
                                            self.binding_total.value_namespace = name_space
                                            self.binding_total.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-lib-update"):
                                            self.last_lib_update = value
                                            self.last_lib_update.value_namespace = name_space
                                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lib-minimum-revision-sent-all"):
                                            self.lib_minimum_revision_sent_all = value
                                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bind_af:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local_explicit_null.is_set or
                                        self.binding_local_implicit_null.is_set or
                                        self.binding_local_no_route.is_set or
                                        self.binding_local_non_null.is_set or
                                        self.binding_local_null.is_set or
                                        self.binding_local_oor.is_set or
                                        self.binding_no_route.is_set or
                                        self.highest_allocated_label.is_set or
                                        self.lowest_allocated_label.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.bind_af:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_no_route.yfilter != YFilter.not_set or
                                        self.binding_local_non_null.yfilter != YFilter.not_set or
                                        self.binding_local_null.yfilter != YFilter.not_set or
                                        self.binding_local_oor.yfilter != YFilter.not_set or
                                        self.binding_no_route.yfilter != YFilter.not_set or
                                        self.highest_allocated_label.yfilter != YFilter.not_set or
                                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-summary-all" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bind-af"):
                                        for c in self.bind_af:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bind_af.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-explicit-null"):
                                        self.binding_local_explicit_null = value
                                        self.binding_local_explicit_null.value_namespace = name_space
                                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-implicit-null"):
                                        self.binding_local_implicit_null = value
                                        self.binding_local_implicit_null.value_namespace = name_space
                                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-no-route"):
                                        self.binding_local_no_route = value
                                        self.binding_local_no_route.value_namespace = name_space
                                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-non-null"):
                                        self.binding_local_non_null = value
                                        self.binding_local_non_null.value_namespace = name_space
                                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-null"):
                                        self.binding_local_null = value
                                        self.binding_local_null.value_namespace = name_space
                                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-oor"):
                                        self.binding_local_oor = value
                                        self.binding_local_oor.value_namespace = name_space
                                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-no-route"):
                                        self.binding_no_route = value
                                        self.binding_no_route.value_namespace = name_space
                                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "highest-allocated-label"):
                                        self.highest_allocated_label = value
                                        self.highest_allocated_label.value_namespace = name_space
                                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lowest-allocated-label"):
                                        self.lowest_allocated_label = value
                                        self.lowest_allocated_label.value_namespace = name_space
                                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                            class Forwardings(Entity):
                                """
                                The LDP Forwarding rewrites
                                
                                .. attribute:: forwarding
                                
                                	Information on a particular LDP forwarding rewrite
                                	**type**\: list of    :py:class:`Forwarding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings, self).__init__()

                                    self.yang_name = "forwardings"
                                    self.yang_parent_name = "af"

                                    self.forwarding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings, self).__setattr__(name, value)


                                class Forwarding(Entity):
                                    """
                                    Information on a particular LDP forwarding
                                    rewrite
                                    
                                    .. attribute:: prefix  <key>
                                    
                                    	The IP Prefix
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                    
                                    
                                    ----
                                    .. attribute:: paths
                                    
                                    	Paths
                                    	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths>`
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: prefix_xr
                                    
                                    	IP Prefix
                                    	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr>`
                                    
                                    .. attribute:: route
                                    
                                    	Route
                                    	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route>`
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID associated with IP prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__init__()

                                        self.yang_name = "forwarding"
                                        self.yang_parent_name = "forwardings"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.prefix_xr = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                        self.prefix_xr.parent = self
                                        self._children_name_map["prefix_xr"] = "prefix-xr"
                                        self._children_yang_names.add("prefix-xr")

                                        self.route = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route()
                                        self.route.parent = self
                                        self._children_name_map["route"] = "route"
                                        self._children_yang_names.add("route")

                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.paths = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "forwarding"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class PrefixXr(Entity):
                                        """
                                        IP Prefix
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__init__()

                                            self.yang_name = "prefix-xr"
                                            self.yang_parent_name = "forwarding"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix-xr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class Route(Entity):
                                        """
                                        Route
                                        
                                        .. attribute:: mpls
                                        
                                        	MPLS information
                                        	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls>`
                                        
                                        .. attribute:: routing
                                        
                                        	IP routing information
                                        	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route, self).__init__()

                                            self.yang_name = "route"
                                            self.yang_parent_name = "forwarding"

                                            self.mpls = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                            self.mpls.parent = self
                                            self._children_name_map["mpls"] = "mpls"
                                            self._children_yang_names.add("mpls")

                                            self.routing = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                            self.routing.parent = self
                                            self._children_name_map["routing"] = "routing"
                                            self._children_yang_names.add("routing")


                                        class Routing(Entity):
                                            """
                                            IP routing information
                                            
                                            .. attribute:: flags
                                            
                                            	Route RIB flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_local_vrf_leaked
                                            
                                            	Is route leaked across local VRFs?
                                            	**type**\:  bool
                                            
                                            .. attribute:: metric
                                            
                                            	Route metric
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: priority
                                            
                                            	Route priority
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: routing_update_age
                                            
                                            	Last Routing update nanosec age
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: routing_update_count
                                            
                                            	Number of routing updates
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: routing_update_timestamp
                                            
                                            	Last Routing update nanosec timestamp
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: source
                                            
                                            	Route source protol Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sr_local_label
                                            
                                            	SR Local\-label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Route type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: version
                                            
                                            	Route RIB ersion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__init__()

                                                self.yang_name = "routing"
                                                self.yang_parent_name = "route"

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.is_local_vrf_leaked = YLeaf(YType.boolean, "is-local-vrf-leaked")

                                                self.metric = YLeaf(YType.uint32, "metric")

                                                self.priority = YLeaf(YType.uint8, "priority")

                                                self.routing_update_age = YLeaf(YType.uint64, "routing-update-age")

                                                self.routing_update_count = YLeaf(YType.uint32, "routing-update-count")

                                                self.routing_update_timestamp = YLeaf(YType.uint64, "routing-update-timestamp")

                                                self.source = YLeaf(YType.uint16, "source")

                                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                                self.type = YLeaf(YType.uint16, "type")

                                                self.version = YLeaf(YType.uint32, "version")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("flags",
                                                                "is_local_vrf_leaked",
                                                                "metric",
                                                                "priority",
                                                                "routing_update_age",
                                                                "routing_update_count",
                                                                "routing_update_timestamp",
                                                                "source",
                                                                "sr_local_label",
                                                                "type",
                                                                "version") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.flags.is_set or
                                                    self.is_local_vrf_leaked.is_set or
                                                    self.metric.is_set or
                                                    self.priority.is_set or
                                                    self.routing_update_age.is_set or
                                                    self.routing_update_count.is_set or
                                                    self.routing_update_timestamp.is_set or
                                                    self.source.is_set or
                                                    self.sr_local_label.is_set or
                                                    self.type.is_set or
                                                    self.version.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.flags.yfilter != YFilter.not_set or
                                                    self.is_local_vrf_leaked.yfilter != YFilter.not_set or
                                                    self.metric.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    self.routing_update_age.yfilter != YFilter.not_set or
                                                    self.routing_update_count.yfilter != YFilter.not_set or
                                                    self.routing_update_timestamp.yfilter != YFilter.not_set or
                                                    self.source.yfilter != YFilter.not_set or
                                                    self.sr_local_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    self.version.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "routing" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.flags.get_name_leafdata())
                                                if (self.is_local_vrf_leaked.is_set or self.is_local_vrf_leaked.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_local_vrf_leaked.get_name_leafdata())
                                                if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.metric.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())
                                                if (self.routing_update_age.is_set or self.routing_update_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_age.get_name_leafdata())
                                                if (self.routing_update_count.is_set or self.routing_update_count.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_count.get_name_leafdata())
                                                if (self.routing_update_timestamp.is_set or self.routing_update_timestamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_timestamp.get_name_leafdata())
                                                if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source.get_name_leafdata())
                                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())
                                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.version.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "flags" or name == "is-local-vrf-leaked" or name == "metric" or name == "priority" or name == "routing-update-age" or name == "routing-update-count" or name == "routing-update-timestamp" or name == "source" or name == "sr-local-label" or name == "type" or name == "version"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "flags"):
                                                    self.flags = value
                                                    self.flags.value_namespace = name_space
                                                    self.flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-local-vrf-leaked"):
                                                    self.is_local_vrf_leaked = value
                                                    self.is_local_vrf_leaked.value_namespace = name_space
                                                    self.is_local_vrf_leaked.value_namespace_prefix = name_space_prefix
                                                if(value_path == "metric"):
                                                    self.metric = value
                                                    self.metric.value_namespace = name_space
                                                    self.metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-age"):
                                                    self.routing_update_age = value
                                                    self.routing_update_age.value_namespace = name_space
                                                    self.routing_update_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-count"):
                                                    self.routing_update_count = value
                                                    self.routing_update_count.value_namespace = name_space
                                                    self.routing_update_count.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-timestamp"):
                                                    self.routing_update_timestamp = value
                                                    self.routing_update_timestamp.value_namespace = name_space
                                                    self.routing_update_timestamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source"):
                                                    self.source = value
                                                    self.source.value_namespace = name_space
                                                    self.source.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sr-local-label"):
                                                    self.sr_local_label = value
                                                    self.sr_local_label.value_namespace = name_space
                                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "version"):
                                                    self.version = value
                                                    self.version.value_namespace = name_space
                                                    self.version.value_namespace_prefix = name_space_prefix


                                        class Mpls(Entity):
                                            """
                                            MPLS information
                                            
                                            .. attribute:: forwarding_update_age
                                            
                                            	Last Forwarding update nanosec age
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: forwarding_update_count
                                            
                                            	Number of forwarding updates
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forwarding_update_timestamp
                                            
                                            	Last Forwarding update nanosec timestamp
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: local_label
                                            
                                            	Local label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__init__()

                                                self.yang_name = "mpls"
                                                self.yang_parent_name = "route"

                                                self.forwarding_update_age = YLeaf(YType.uint64, "forwarding-update-age")

                                                self.forwarding_update_count = YLeaf(YType.uint32, "forwarding-update-count")

                                                self.forwarding_update_timestamp = YLeaf(YType.uint64, "forwarding-update-timestamp")

                                                self.local_label = YLeaf(YType.uint32, "local-label")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("forwarding_update_age",
                                                                "forwarding_update_count",
                                                                "forwarding_update_timestamp",
                                                                "local_label") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.forwarding_update_age.is_set or
                                                    self.forwarding_update_count.is_set or
                                                    self.forwarding_update_timestamp.is_set or
                                                    self.local_label.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.forwarding_update_age.yfilter != YFilter.not_set or
                                                    self.forwarding_update_count.yfilter != YFilter.not_set or
                                                    self.forwarding_update_timestamp.yfilter != YFilter.not_set or
                                                    self.local_label.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.forwarding_update_age.is_set or self.forwarding_update_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_age.get_name_leafdata())
                                                if (self.forwarding_update_count.is_set or self.forwarding_update_count.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_count.get_name_leafdata())
                                                if (self.forwarding_update_timestamp.is_set or self.forwarding_update_timestamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_timestamp.get_name_leafdata())
                                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "forwarding-update-age" or name == "forwarding-update-count" or name == "forwarding-update-timestamp" or name == "local-label"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "forwarding-update-age"):
                                                    self.forwarding_update_age = value
                                                    self.forwarding_update_age.value_namespace = name_space
                                                    self.forwarding_update_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-update-count"):
                                                    self.forwarding_update_count = value
                                                    self.forwarding_update_count.value_namespace = name_space
                                                    self.forwarding_update_count.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-update-timestamp"):
                                                    self.forwarding_update_timestamp = value
                                                    self.forwarding_update_timestamp.value_namespace = name_space
                                                    self.forwarding_update_timestamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-label"):
                                                    self.local_label = value
                                                    self.local_label.value_namespace = name_space
                                                    self.local_label.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.mpls is not None and self.mpls.has_data()) or
                                                (self.routing is not None and self.routing.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls is not None and self.mpls.has_operation()) or
                                                (self.routing is not None and self.routing.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "route" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls"):
                                                if (self.mpls is None):
                                                    self.mpls = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                                    self.mpls.parent = self
                                                    self._children_name_map["mpls"] = "mpls"
                                                return self.mpls

                                            if (child_yang_name == "routing"):
                                                if (self.routing is None):
                                                    self.routing = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                                    self.routing.parent = self
                                                    self._children_name_map["routing"] = "routing"
                                                return self.routing

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls" or name == "routing"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Paths(Entity):
                                        """
                                        Paths
                                        
                                        .. attribute:: mpls
                                        
                                        	MPLS information
                                        	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls>`
                                        
                                        .. attribute:: routing
                                        
                                        	IP routing information
                                        	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths, self).__init__()

                                            self.yang_name = "paths"
                                            self.yang_parent_name = "forwarding"

                                            self.mpls = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                            self.mpls.parent = self
                                            self._children_name_map["mpls"] = "mpls"
                                            self._children_yang_names.add("mpls")

                                            self.routing = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                            self.routing.parent = self
                                            self._children_name_map["routing"] = "routing"
                                            self._children_yang_names.add("routing")


                                        class Routing(Entity):
                                            """
                                            IP routing information
                                            
                                            .. attribute:: bkup_path_id
                                            
                                            	Backup path Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: flags
                                            
                                            	Route path flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: interface
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: interface_name
                                            
                                            	Interface Name
                                            	**type**\:  str
                                            
                                            .. attribute:: load_metric
                                            
                                            	Path's load metric for load balancing
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_hop
                                            
                                            	Next Hop
                                            	**type**\:   :py:class:`NextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop>`
                                            
                                            .. attribute:: next_hop_table_id
                                            
                                            	Table ID for nexthop address
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: nexthop_id
                                            
                                            	Nexthop Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: nh_is_overriden
                                            
                                            	Nexthop is overriden by LDP
                                            	**type**\:  bool
                                            
                                            .. attribute:: path_flags
                                            
                                            	Routing path flags decoded
                                            	**type**\:   :py:class:`LdpRoutePathFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathFlags>`
                                            
                                            .. attribute:: path_id
                                            
                                            	path Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: remote_lfa
                                            
                                            	Remote LFA\-FRR backup info
                                            	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__init__()

                                                self.yang_name = "routing"
                                                self.yang_parent_name = "paths"

                                                self.bkup_path_id = YLeaf(YType.uint8, "bkup-path-id")

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.interface = YLeaf(YType.str, "interface")

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.load_metric = YLeaf(YType.uint32, "load-metric")

                                                self.next_hop_table_id = YLeaf(YType.uint32, "next-hop-table-id")

                                                self.nexthop_id = YLeaf(YType.uint32, "nexthop-id")

                                                self.nh_is_overriden = YLeaf(YType.boolean, "nh-is-overriden")

                                                self.path_flags = YLeaf(YType.enumeration, "path-flags")

                                                self.path_id = YLeaf(YType.uint8, "path-id")

                                                self.next_hop = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                self.next_hop.parent = self
                                                self._children_name_map["next_hop"] = "next-hop"
                                                self._children_yang_names.add("next-hop")

                                                self.remote_lfa = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                self.remote_lfa.parent = self
                                                self._children_name_map["remote_lfa"] = "remote-lfa"
                                                self._children_yang_names.add("remote-lfa")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bkup_path_id",
                                                                "flags",
                                                                "interface",
                                                                "interface_name",
                                                                "load_metric",
                                                                "next_hop_table_id",
                                                                "nexthop_id",
                                                                "nh_is_overriden",
                                                                "path_flags",
                                                                "path_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)


                                            class NextHop(Entity):
                                                """
                                                Next Hop
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__init__()

                                                    self.yang_name = "next-hop"
                                                    self.yang_parent_name = "routing"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "next-hop" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class RemoteLfa(Entity):
                                                """
                                                Remote LFA\-FRR backup info
                                                
                                                .. attribute:: has_q_node
                                                
                                                	Whether remote LFA path has a Q node associated
                                                	**type**\:  bool
                                                
                                                .. attribute:: has_remote_lfa_bkup
                                                
                                                	Whether path has remote LFA backup
                                                	**type**\:  bool
                                                
                                                .. attribute:: needs_tldp
                                                
                                                	Whether TLDP is needed with remote PQ node
                                                	**type**\:  bool
                                                
                                                .. attribute:: remote_p_node_id
                                                
                                                	Remote/P node address
                                                	**type**\:   :py:class:`RemotePNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId>`
                                                
                                                .. attribute:: remote_q_node_id
                                                
                                                	Remote/Q node address
                                                	**type**\:   :py:class:`RemoteQNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__init__()

                                                    self.yang_name = "remote-lfa"
                                                    self.yang_parent_name = "routing"

                                                    self.has_q_node = YLeaf(YType.boolean, "has-q-node")

                                                    self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                    self.needs_tldp = YLeaf(YType.boolean, "needs-tldp")

                                                    self.remote_p_node_id = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                    self.remote_p_node_id.parent = self
                                                    self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                    self._children_yang_names.add("remote-p-node-id")

                                                    self.remote_q_node_id = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                    self.remote_q_node_id.parent = self
                                                    self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                    self._children_yang_names.add("remote-q-node-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("has_q_node",
                                                                    "has_remote_lfa_bkup",
                                                                    "needs_tldp") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)


                                                class RemotePNodeId(Entity):
                                                    """
                                                    Remote/P node address
                                                    
                                                    .. attribute:: afi
                                                    
                                                    	AFI
                                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                    
                                                    .. attribute:: dummy
                                                    
                                                    	No Address
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ipv4
                                                    
                                                    	IPv4 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: ipv6
                                                    
                                                    	IPv6 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__init__()

                                                        self.yang_name = "remote-p-node-id"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.afi = YLeaf(YType.enumeration, "afi")

                                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("afi",
                                                                        "dummy",
                                                                        "ipv4",
                                                                        "ipv6") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.afi.is_set or
                                                            self.dummy.is_set or
                                                            self.ipv4.is_set or
                                                            self.ipv6.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.afi.yfilter != YFilter.not_set or
                                                            self.dummy.yfilter != YFilter.not_set or
                                                            self.ipv4.yfilter != YFilter.not_set or
                                                            self.ipv6.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "remote-p-node-id" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "afi"):
                                                            self.afi = value
                                                            self.afi.value_namespace = name_space
                                                            self.afi.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "dummy"):
                                                            self.dummy = value
                                                            self.dummy.value_namespace = name_space
                                                            self.dummy.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv4"):
                                                            self.ipv4 = value
                                                            self.ipv4.value_namespace = name_space
                                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv6"):
                                                            self.ipv6 = value
                                                            self.ipv6.value_namespace = name_space
                                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                                class RemoteQNodeId(Entity):
                                                    """
                                                    Remote/Q node address
                                                    
                                                    .. attribute:: afi
                                                    
                                                    	AFI
                                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                    
                                                    .. attribute:: dummy
                                                    
                                                    	No Address
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ipv4
                                                    
                                                    	IPv4 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: ipv6
                                                    
                                                    	IPv6 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__init__()

                                                        self.yang_name = "remote-q-node-id"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.afi = YLeaf(YType.enumeration, "afi")

                                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("afi",
                                                                        "dummy",
                                                                        "ipv4",
                                                                        "ipv6") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.afi.is_set or
                                                            self.dummy.is_set or
                                                            self.ipv4.is_set or
                                                            self.ipv6.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.afi.yfilter != YFilter.not_set or
                                                            self.dummy.yfilter != YFilter.not_set or
                                                            self.ipv4.yfilter != YFilter.not_set or
                                                            self.ipv6.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "remote-q-node-id" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "afi"):
                                                            self.afi = value
                                                            self.afi.value_namespace = name_space
                                                            self.afi.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "dummy"):
                                                            self.dummy = value
                                                            self.dummy.value_namespace = name_space
                                                            self.dummy.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv4"):
                                                            self.ipv4 = value
                                                            self.ipv4.value_namespace = name_space
                                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv6"):
                                                            self.ipv6 = value
                                                            self.ipv6.value_namespace = name_space
                                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.has_q_node.is_set or
                                                        self.has_remote_lfa_bkup.is_set or
                                                        self.needs_tldp.is_set or
                                                        (self.remote_p_node_id is not None and self.remote_p_node_id.has_data()) or
                                                        (self.remote_q_node_id is not None and self.remote_q_node_id.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.has_q_node.yfilter != YFilter.not_set or
                                                        self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                        self.needs_tldp.yfilter != YFilter.not_set or
                                                        (self.remote_p_node_id is not None and self.remote_p_node_id.has_operation()) or
                                                        (self.remote_q_node_id is not None and self.remote_q_node_id.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-lfa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.has_q_node.is_set or self.has_q_node.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_q_node.get_name_leafdata())
                                                    if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())
                                                    if (self.needs_tldp.is_set or self.needs_tldp.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.needs_tldp.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "remote-p-node-id"):
                                                        if (self.remote_p_node_id is None):
                                                            self.remote_p_node_id = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                            self.remote_p_node_id.parent = self
                                                            self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                        return self.remote_p_node_id

                                                    if (child_yang_name == "remote-q-node-id"):
                                                        if (self.remote_q_node_id is None):
                                                            self.remote_q_node_id = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                            self.remote_q_node_id.parent = self
                                                            self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                        return self.remote_q_node_id

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "remote-p-node-id" or name == "remote-q-node-id" or name == "has-q-node" or name == "has-remote-lfa-bkup" or name == "needs-tldp"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "has-q-node"):
                                                        self.has_q_node = value
                                                        self.has_q_node.value_namespace = name_space
                                                        self.has_q_node.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "has-remote-lfa-bkup"):
                                                        self.has_remote_lfa_bkup = value
                                                        self.has_remote_lfa_bkup.value_namespace = name_space
                                                        self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "needs-tldp"):
                                                        self.needs_tldp = value
                                                        self.needs_tldp.value_namespace = name_space
                                                        self.needs_tldp.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.bkup_path_id.is_set or
                                                    self.flags.is_set or
                                                    self.interface.is_set or
                                                    self.interface_name.is_set or
                                                    self.load_metric.is_set or
                                                    self.next_hop_table_id.is_set or
                                                    self.nexthop_id.is_set or
                                                    self.nh_is_overriden.is_set or
                                                    self.path_flags.is_set or
                                                    self.path_id.is_set or
                                                    (self.next_hop is not None and self.next_hop.has_data()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bkup_path_id.yfilter != YFilter.not_set or
                                                    self.flags.yfilter != YFilter.not_set or
                                                    self.interface.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.load_metric.yfilter != YFilter.not_set or
                                                    self.next_hop_table_id.yfilter != YFilter.not_set or
                                                    self.nexthop_id.yfilter != YFilter.not_set or
                                                    self.nh_is_overriden.yfilter != YFilter.not_set or
                                                    self.path_flags.yfilter != YFilter.not_set or
                                                    self.path_id.yfilter != YFilter.not_set or
                                                    (self.next_hop is not None and self.next_hop.has_operation()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "routing" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bkup_path_id.is_set or self.bkup_path_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bkup_path_id.get_name_leafdata())
                                                if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.flags.get_name_leafdata())
                                                if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface.get_name_leafdata())
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.load_metric.get_name_leafdata())
                                                if (self.next_hop_table_id.is_set or self.next_hop_table_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_hop_table_id.get_name_leafdata())
                                                if (self.nexthop_id.is_set or self.nexthop_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nexthop_id.get_name_leafdata())
                                                if (self.nh_is_overriden.is_set or self.nh_is_overriden.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nh_is_overriden.get_name_leafdata())
                                                if (self.path_flags.is_set or self.path_flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_flags.get_name_leafdata())
                                                if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "next-hop"):
                                                    if (self.next_hop is None):
                                                        self.next_hop = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                        self.next_hop.parent = self
                                                        self._children_name_map["next_hop"] = "next-hop"
                                                    return self.next_hop

                                                if (child_yang_name == "remote-lfa"):
                                                    if (self.remote_lfa is None):
                                                        self.remote_lfa = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                        self.remote_lfa.parent = self
                                                        self._children_name_map["remote_lfa"] = "remote-lfa"
                                                    return self.remote_lfa

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "next-hop" or name == "remote-lfa" or name == "bkup-path-id" or name == "flags" or name == "interface" or name == "interface-name" or name == "load-metric" or name == "next-hop-table-id" or name == "nexthop-id" or name == "nh-is-overriden" or name == "path-flags" or name == "path-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bkup-path-id"):
                                                    self.bkup_path_id = value
                                                    self.bkup_path_id.value_namespace = name_space
                                                    self.bkup_path_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "flags"):
                                                    self.flags = value
                                                    self.flags.value_namespace = name_space
                                                    self.flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface"):
                                                    self.interface = value
                                                    self.interface.value_namespace = name_space
                                                    self.interface.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "load-metric"):
                                                    self.load_metric = value
                                                    self.load_metric.value_namespace = name_space
                                                    self.load_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-hop-table-id"):
                                                    self.next_hop_table_id = value
                                                    self.next_hop_table_id.value_namespace = name_space
                                                    self.next_hop_table_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nexthop-id"):
                                                    self.nexthop_id = value
                                                    self.nexthop_id.value_namespace = name_space
                                                    self.nexthop_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nh-is-overriden"):
                                                    self.nh_is_overriden = value
                                                    self.nh_is_overriden.value_namespace = name_space
                                                    self.nh_is_overriden.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-flags"):
                                                    self.path_flags = value
                                                    self.path_flags.value_namespace = name_space
                                                    self.path_flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-id"):
                                                    self.path_id = value
                                                    self.path_id.value_namespace = name_space
                                                    self.path_id.value_namespace_prefix = name_space_prefix


                                        class Mpls(Entity):
                                            """
                                            MPLS information
                                            
                                            .. attribute:: mpls_outgoing_info
                                            
                                            	MPLS nexthop info
                                            	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo>`
                                            
                                            .. attribute:: remote_lfa
                                            
                                            	Remote LFA\-FRR backup info
                                            	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls, self).__init__()

                                                self.yang_name = "mpls"
                                                self.yang_parent_name = "paths"

                                                self.mpls_outgoing_info = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                self.mpls_outgoing_info.parent = self
                                                self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                self._children_yang_names.add("mpls-outgoing-info")

                                                self.remote_lfa = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                self.remote_lfa.parent = self
                                                self._children_name_map["remote_lfa"] = "remote-lfa"
                                                self._children_yang_names.add("remote-lfa")


                                            class MplsOutgoingInfo(Entity):
                                                """
                                                MPLS nexthop info
                                                
                                                .. attribute:: is_from_graceful_restartable_neighbor
                                                
                                                	Is from a GR neighbor
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_stale
                                                
                                                	Is the entry stale
                                                	**type**\:  bool
                                                
                                                .. attribute:: nexthop_peer_ldp_ident
                                                
                                                	Nexthop LDP peer
                                                	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent>`
                                                
                                                .. attribute:: out_label
                                                
                                                	Outgoing label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: out_label_owner
                                                
                                                	Outgoing label owner
                                                	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                
                                                .. attribute:: out_label_rsn
                                                
                                                	Outgoing label reason
                                                	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                
                                                .. attribute:: out_label_type
                                                
                                                	Outgoing Label Type
                                                	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__init__()

                                                    self.yang_name = "mpls-outgoing-info"
                                                    self.yang_parent_name = "mpls"

                                                    self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                    self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                                    self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                    self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                    self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                    self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                    self.nexthop_peer_ldp_ident.parent = self
                                                    self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                    self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("is_from_graceful_restartable_neighbor",
                                                                    "is_stale",
                                                                    "out_label",
                                                                    "out_label_owner",
                                                                    "out_label_rsn",
                                                                    "out_label_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)


                                                class NexthopPeerLdpIdent(Entity):
                                                    """
                                                    Nexthop LDP peer
                                                    
                                                    .. attribute:: label_space_id
                                                    
                                                    	Label space identifier
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: ldp_id
                                                    
                                                    	LDP identifier
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: lsr_id
                                                    
                                                    	LSR identifier
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__init__()

                                                        self.yang_name = "nexthop-peer-ldp-ident"
                                                        self.yang_parent_name = "mpls-outgoing-info"

                                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("label_space_id",
                                                                        "ldp_id",
                                                                        "lsr_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.label_space_id.is_set or
                                                            self.ldp_id.is_set or
                                                            self.lsr_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.label_space_id.yfilter != YFilter.not_set or
                                                            self.ldp_id.yfilter != YFilter.not_set or
                                                            self.lsr_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "label-space-id"):
                                                            self.label_space_id = value
                                                            self.label_space_id.value_namespace = name_space
                                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ldp-id"):
                                                            self.ldp_id = value
                                                            self.ldp_id.value_namespace = name_space
                                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsr-id"):
                                                            self.lsr_id = value
                                                            self.lsr_id.value_namespace = name_space
                                                            self.lsr_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.is_from_graceful_restartable_neighbor.is_set or
                                                        self.is_stale.is_set or
                                                        self.out_label.is_set or
                                                        self.out_label_owner.is_set or
                                                        self.out_label_rsn.is_set or
                                                        self.out_label_type.is_set or
                                                        (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                        self.is_stale.yfilter != YFilter.not_set or
                                                        self.out_label.yfilter != YFilter.not_set or
                                                        self.out_label_owner.yfilter != YFilter.not_set or
                                                        self.out_label_rsn.yfilter != YFilter.not_set or
                                                        self.out_label_type.yfilter != YFilter.not_set or
                                                        (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mpls-outgoing-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                    if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                                    if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                    if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                    if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                        if (self.nexthop_peer_ldp_ident is None):
                                                            self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                            self.nexthop_peer_ldp_ident.parent = self
                                                            self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                        return self.nexthop_peer_ldp_ident

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "is-from-graceful-restartable-neighbor"):
                                                        self.is_from_graceful_restartable_neighbor = value
                                                        self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                        self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-stale"):
                                                        self.is_stale = value
                                                        self.is_stale.value_namespace = name_space
                                                        self.is_stale.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label"):
                                                        self.out_label = value
                                                        self.out_label.value_namespace = name_space
                                                        self.out_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-owner"):
                                                        self.out_label_owner = value
                                                        self.out_label_owner.value_namespace = name_space
                                                        self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-rsn"):
                                                        self.out_label_rsn = value
                                                        self.out_label_rsn.value_namespace = name_space
                                                        self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-type"):
                                                        self.out_label_type = value
                                                        self.out_label_type.value_namespace = name_space
                                                        self.out_label_type.value_namespace_prefix = name_space_prefix


                                            class RemoteLfa(Entity):
                                                """
                                                Remote LFA\-FRR backup info
                                                
                                                .. attribute:: has_remote_lfa_bkup
                                                
                                                	Whether path has remote LFA backup
                                                	**type**\:  bool
                                                
                                                .. attribute:: mpls_outgoing_info
                                                
                                                	Remote LFA MPLS nexthop(s\_ info
                                                	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__init__()

                                                    self.yang_name = "remote-lfa"
                                                    self.yang_parent_name = "mpls"

                                                    self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                    self.mpls_outgoing_info = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                    self.mpls_outgoing_info.parent = self
                                                    self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    self._children_yang_names.add("mpls-outgoing-info")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("has_remote_lfa_bkup") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)


                                                class MplsOutgoingInfo(Entity):
                                                    """
                                                    Remote LFA MPLS nexthop(s\_ info
                                                    
                                                    .. attribute:: stack
                                                    
                                                    	Inner label stack info
                                                    	**type**\: list of    :py:class:`Stack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__init__()

                                                        self.yang_name = "mpls-outgoing-info"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.stack = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in () and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)


                                                    class Stack(Entity):
                                                        """
                                                        Inner label stack info
                                                        
                                                        .. attribute:: is_from_graceful_restartable_neighbor
                                                        
                                                        	Is from a GR neighbor
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: is_stale
                                                        
                                                        	Is the entry stale
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: nexthop_peer_ldp_ident
                                                        
                                                        	Nexthop LDP peer
                                                        	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent>`
                                                        
                                                        .. attribute:: out_label
                                                        
                                                        	Outgoing label
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: out_label_owner
                                                        
                                                        	Outgoing label owner
                                                        	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                        
                                                        .. attribute:: out_label_rsn
                                                        
                                                        	Outgoing label reason
                                                        	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                        
                                                        .. attribute:: out_label_type
                                                        
                                                        	Outgoing Label Type
                                                        	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-ldp-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__init__()

                                                            self.yang_name = "stack"
                                                            self.yang_parent_name = "mpls-outgoing-info"

                                                            self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                            self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                                            self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                            self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                            self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                            self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                            self.nexthop_peer_ldp_ident.parent = self
                                                            self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                            self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("is_from_graceful_restartable_neighbor",
                                                                            "is_stale",
                                                                            "out_label",
                                                                            "out_label_owner",
                                                                            "out_label_rsn",
                                                                            "out_label_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)


                                                        class NexthopPeerLdpIdent(Entity):
                                                            """
                                                            Nexthop LDP peer
                                                            
                                                            .. attribute:: label_space_id
                                                            
                                                            	Label space identifier
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: ldp_id
                                                            
                                                            	LDP identifier
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: lsr_id
                                                            
                                                            	LSR identifier
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-ldp-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__init__()

                                                                self.yang_name = "nexthop-peer-ldp-ident"
                                                                self.yang_parent_name = "stack"

                                                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("label_space_id",
                                                                                "ldp_id",
                                                                                "lsr_id") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.label_space_id.is_set or
                                                                    self.ldp_id.is_set or
                                                                    self.lsr_id.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.label_space_id.yfilter != YFilter.not_set or
                                                                    self.ldp_id.yfilter != YFilter.not_set or
                                                                    self.lsr_id.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "label-space-id"):
                                                                    self.label_space_id = value
                                                                    self.label_space_id.value_namespace = name_space
                                                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "ldp-id"):
                                                                    self.ldp_id = value
                                                                    self.ldp_id.value_namespace = name_space
                                                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "lsr-id"):
                                                                    self.lsr_id = value
                                                                    self.lsr_id.value_namespace = name_space
                                                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.is_from_graceful_restartable_neighbor.is_set or
                                                                self.is_stale.is_set or
                                                                self.out_label.is_set or
                                                                self.out_label_owner.is_set or
                                                                self.out_label_rsn.is_set or
                                                                self.out_label_type.is_set or
                                                                (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                                self.is_stale.yfilter != YFilter.not_set or
                                                                self.out_label.yfilter != YFilter.not_set or
                                                                self.out_label_owner.yfilter != YFilter.not_set or
                                                                self.out_label_rsn.yfilter != YFilter.not_set or
                                                                self.out_label_type.yfilter != YFilter.not_set or
                                                                (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "stack" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                            if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                                            if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                            if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                            if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                                if (self.nexthop_peer_ldp_ident is None):
                                                                    self.nexthop_peer_ldp_ident = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                                    self.nexthop_peer_ldp_ident.parent = self
                                                                    self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                                return self.nexthop_peer_ldp_ident

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "is-from-graceful-restartable-neighbor"):
                                                                self.is_from_graceful_restartable_neighbor = value
                                                                self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                                self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "is-stale"):
                                                                self.is_stale = value
                                                                self.is_stale.value_namespace = name_space
                                                                self.is_stale.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label"):
                                                                self.out_label = value
                                                                self.out_label.value_namespace = name_space
                                                                self.out_label.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-owner"):
                                                                self.out_label_owner = value
                                                                self.out_label_owner.value_namespace = name_space
                                                                self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-rsn"):
                                                                self.out_label_rsn = value
                                                                self.out_label_rsn.value_namespace = name_space
                                                                self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-type"):
                                                                self.out_label_type = value
                                                                self.out_label_type.value_namespace = name_space
                                                                self.out_label_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.stack:
                                                            if (c.has_data()):
                                                                return True
                                                        return False

                                                    def has_operation(self):
                                                        for c in self.stack:
                                                            if (c.has_operation()):
                                                                return True
                                                        return self.yfilter != YFilter.not_set

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "mpls-outgoing-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "stack"):
                                                            for c in self.stack:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.stack.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "stack"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass

                                                def has_data(self):
                                                    return (
                                                        self.has_remote_lfa_bkup.is_set or
                                                        (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                        (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-lfa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "mpls-outgoing-info"):
                                                        if (self.mpls_outgoing_info is None):
                                                            self.mpls_outgoing_info = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                            self.mpls_outgoing_info.parent = self
                                                            self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                        return self.mpls_outgoing_info

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "mpls-outgoing-info" or name == "has-remote-lfa-bkup"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "has-remote-lfa-bkup"):
                                                        self.has_remote_lfa_bkup = value
                                                        self.has_remote_lfa_bkup.value_namespace = name_space
                                                        self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mpls-outgoing-info"):
                                                    if (self.mpls_outgoing_info is None):
                                                        self.mpls_outgoing_info = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                        self.mpls_outgoing_info.parent = self
                                                        self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    return self.mpls_outgoing_info

                                                if (child_yang_name == "remote-lfa"):
                                                    if (self.remote_lfa is None):
                                                        self.remote_lfa = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                        self.remote_lfa.parent = self
                                                        self._children_name_map["remote_lfa"] = "remote-lfa"
                                                    return self.remote_lfa

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mpls-outgoing-info" or name == "remote-lfa"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                (self.mpls is not None and self.mpls.has_data()) or
                                                (self.routing is not None and self.routing.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls is not None and self.mpls.has_operation()) or
                                                (self.routing is not None and self.routing.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "paths" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls"):
                                                if (self.mpls is None):
                                                    self.mpls = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                                    self.mpls.parent = self
                                                    self._children_name_map["mpls"] = "mpls"
                                                return self.mpls

                                            if (child_yang_name == "routing"):
                                                if (self.routing is None):
                                                    self.routing = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                                    self.routing.parent = self
                                                    self._children_name_map["routing"] = "routing"
                                                return self.routing

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls" or name == "routing"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        for c in self.paths:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.table_id.is_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                            (self.route is not None and self.route.has_data()) or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.paths:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                            (self.route is not None and self.route.has_operation()) or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "forwarding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "paths"):
                                            for c in self.paths:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.paths.append(c)
                                            return c

                                        if (child_yang_name == "prefix-xr"):
                                            if (self.prefix_xr is None):
                                                self.prefix_xr = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                                self.prefix_xr.parent = self
                                                self._children_name_map["prefix_xr"] = "prefix-xr"
                                            return self.prefix_xr

                                        if (child_yang_name == "route"):
                                            if (self.route is None):
                                                self.route = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route()
                                                self.route.parent = self
                                                self._children_name_map["route"] = "route"
                                            return self.route

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "paths" or name == "prefix-xr" or name == "route" or name == "vrf" or name == "prefix" or name == "prefix-length" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.forwarding:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.forwarding:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwardings" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "forwarding"):
                                        for c in self.forwarding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.forwarding.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "forwarding"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsAdvertiseSpec(Entity):
                                """
                                Advertisement Spec (ACL) for LDP Label
                                Infomation Base (LIB)
                                
                                .. attribute:: advt_acl
                                
                                	Advertisement ACLs
                                	**type**\: list of    :py:class:`AdvtAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl>`
                                
                                .. attribute:: allocation_acl
                                
                                	Local label Allocation filter
                                	**type**\:   :py:class:`AllocationAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__init__()

                                    self.yang_name = "bindings-advertise-spec"
                                    self.yang_parent_name = "af"

                                    self.allocation_acl = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                    self.allocation_acl.parent = self
                                    self._children_name_map["allocation_acl"] = "allocation-acl"
                                    self._children_yang_names.add("allocation-acl")

                                    self.advt_acl = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)


                                class AllocationAcl(Entity):
                                    """
                                    Local label Allocation filter
                                    
                                    .. attribute:: has_acl
                                    
                                    	Has ACL filter?
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_host_route_only
                                    
                                    	Host\-routes only?
                                    	**type**\:  bool
                                    
                                    .. attribute:: prefix_acl
                                    
                                    	Prefix ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__init__()

                                        self.yang_name = "allocation-acl"
                                        self.yang_parent_name = "bindings-advertise-spec"

                                        self.has_acl = YLeaf(YType.boolean, "has-acl")

                                        self.is_host_route_only = YLeaf(YType.boolean, "is-host-route-only")

                                        self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("has_acl",
                                                        "is_host_route_only",
                                                        "prefix_acl") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.has_acl.is_set or
                                            self.is_host_route_only.is_set or
                                            self.prefix_acl.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.has_acl.yfilter != YFilter.not_set or
                                            self.is_host_route_only.yfilter != YFilter.not_set or
                                            self.prefix_acl.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "allocation-acl" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.has_acl.is_set or self.has_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.has_acl.get_name_leafdata())
                                        if (self.is_host_route_only.is_set or self.is_host_route_only.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_host_route_only.get_name_leafdata())
                                        if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "has-acl" or name == "is-host-route-only" or name == "prefix-acl"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "has-acl"):
                                            self.has_acl = value
                                            self.has_acl.value_namespace = name_space
                                            self.has_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-host-route-only"):
                                            self.is_host_route_only = value
                                            self.is_host_route_only.value_namespace = name_space
                                            self.is_host_route_only.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-acl"):
                                            self.prefix_acl = value
                                            self.prefix_acl.value_namespace = name_space
                                            self.prefix_acl.value_namespace_prefix = name_space_prefix


                                class AdvtAcl(Entity):
                                    """
                                    Advertisement ACLs
                                    
                                    .. attribute:: peer_acl
                                    
                                    	Peer ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    .. attribute:: prefix_acl
                                    
                                    	Prefix ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__init__()

                                        self.yang_name = "advt-acl"
                                        self.yang_parent_name = "bindings-advertise-spec"

                                        self.peer_acl = YLeaf(YType.str, "peer-acl")

                                        self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("peer_acl",
                                                        "prefix_acl") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.peer_acl.is_set or
                                            self.prefix_acl.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.peer_acl.yfilter != YFilter.not_set or
                                            self.prefix_acl.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "advt-acl" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.peer_acl.is_set or self.peer_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_acl.get_name_leafdata())
                                        if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "peer-acl" or name == "prefix-acl"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "peer-acl"):
                                            self.peer_acl = value
                                            self.peer_acl.value_namespace = name_space
                                            self.peer_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-acl"):
                                            self.prefix_acl = value
                                            self.prefix_acl.value_namespace = name_space
                                            self.prefix_acl.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.advt_acl:
                                        if (c.has_data()):
                                            return True
                                    return (self.allocation_acl is not None and self.allocation_acl.has_data())

                                def has_operation(self):
                                    for c in self.advt_acl:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.allocation_acl is not None and self.allocation_acl.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-advertise-spec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "advt-acl"):
                                        for c in self.advt_acl:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.advt_acl.append(c)
                                        return c

                                    if (child_yang_name == "allocation-acl"):
                                        if (self.allocation_acl is None):
                                            self.allocation_acl = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                            self.allocation_acl.parent = self
                                            self._children_name_map["allocation_acl"] = "allocation-acl"
                                        return self.allocation_acl

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "advt-acl" or name == "allocation-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class ForwardingSummary(Entity):
                                """
                                Summary information regarding LDP forwarding
                                setup
                                
                                .. attribute:: fsht
                                
                                	Forwarding state hold time registered with LSD
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: intfs
                                
                                	MPLS forwarding enabled interface count
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: is_lsd_bound
                                
                                	LDP is connected to LSD server
                                	**type**\:  bool
                                
                                .. attribute:: lbls
                                
                                	Local label allocated count
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: rws
                                
                                	Forwarding rewrites summary
                                	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__init__()

                                    self.yang_name = "forwarding-summary"
                                    self.yang_parent_name = "af"

                                    self.fsht = YLeaf(YType.uint16, "fsht")

                                    self.intfs = YLeaf(YType.uint16, "intfs")

                                    self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                                    self.lbls = YLeaf(YType.uint16, "lbls")

                                    self.rws = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws()
                                    self.rws.parent = self
                                    self._children_name_map["rws"] = "rws"
                                    self._children_yang_names.add("rws")

                                    self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fsht",
                                                    "intfs",
                                                    "is_lsd_bound",
                                                    "lbls") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "forwarding-summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class Rws(Entity):
                                    """
                                    Forwarding rewrites summary
                                    
                                    .. attribute:: nhs
                                    
                                    	Forwarding rewrites nexthops (paths) summary
                                    	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs>`
                                    
                                    .. attribute:: pfxs
                                    
                                    	Forwarding rewrites prefix summary
                                    	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws, self).__init__()

                                        self.yang_name = "rws"
                                        self.yang_parent_name = "forwarding-summary"

                                        self.nhs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                        self.nhs.parent = self
                                        self._children_name_map["nhs"] = "nhs"
                                        self._children_yang_names.add("nhs")

                                        self.pfxs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                        self.pfxs.parent = self
                                        self._children_name_map["pfxs"] = "pfxs"
                                        self._children_yang_names.add("pfxs")


                                    class Pfxs(Entity):
                                        """
                                        Forwarding rewrites prefix summary
                                        
                                        .. attribute:: ecmp_pfxs
                                        
                                        	Count of prefixes with ECMP
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_aggr
                                        
                                        	Labeled prefix count for all paths
                                        	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr>`
                                        
                                        .. attribute:: labeled_pfxs_backup
                                        
                                        	Labeled prefix count related to backup paths only
                                        	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup>`
                                        
                                        .. attribute:: labeled_pfxs_primary
                                        
                                        	Labeled prefix count related to primary paths only
                                        	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary>`
                                        
                                        .. attribute:: protected_pfxs
                                        
                                        	Count of FRR protected prefixes
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: total_pfxs
                                        
                                        	Total Prefix count
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__init__()

                                            self.yang_name = "pfxs"
                                            self.yang_parent_name = "rws"

                                            self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                                            self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                                            self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                                            self.labeled_pfxs_aggr = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                            self.labeled_pfxs_aggr.parent = self
                                            self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                            self._children_yang_names.add("labeled-pfxs-aggr")

                                            self.labeled_pfxs_backup = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                            self.labeled_pfxs_backup.parent = self
                                            self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                            self._children_yang_names.add("labeled-pfxs-backup")

                                            self.labeled_pfxs_primary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                            self.labeled_pfxs_primary.parent = self
                                            self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                            self._children_yang_names.add("labeled-pfxs-primary")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ecmp_pfxs",
                                                            "protected_pfxs",
                                                            "total_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)


                                        class LabeledPfxsAggr(Entity):
                                            """
                                            Labeled prefix count for all paths
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                                self.yang_name = "labeled-pfxs-aggr"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-aggr" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                        class LabeledPfxsPrimary(Entity):
                                            """
                                            Labeled prefix count related to primary paths
                                            only
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                                self.yang_name = "labeled-pfxs-primary"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-primary" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                        class LabeledPfxsBackup(Entity):
                                            """
                                            Labeled prefix count related to backup paths
                                            only
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                                self.yang_name = "labeled-pfxs-backup"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-backup" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.ecmp_pfxs.is_set or
                                                self.protected_pfxs.is_set or
                                                self.total_pfxs.is_set or
                                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ecmp_pfxs.yfilter != YFilter.not_set or
                                                self.protected_pfxs.yfilter != YFilter.not_set or
                                                self.total_pfxs.yfilter != YFilter.not_set or
                                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "pfxs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                                            if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                                            if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "labeled-pfxs-aggr"):
                                                if (self.labeled_pfxs_aggr is None):
                                                    self.labeled_pfxs_aggr = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                                    self.labeled_pfxs_aggr.parent = self
                                                    self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                                return self.labeled_pfxs_aggr

                                            if (child_yang_name == "labeled-pfxs-backup"):
                                                if (self.labeled_pfxs_backup is None):
                                                    self.labeled_pfxs_backup = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                                    self.labeled_pfxs_backup.parent = self
                                                    self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                                return self.labeled_pfxs_backup

                                            if (child_yang_name == "labeled-pfxs-primary"):
                                                if (self.labeled_pfxs_primary is None):
                                                    self.labeled_pfxs_primary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                                    self.labeled_pfxs_primary.parent = self
                                                    self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                                return self.labeled_pfxs_primary

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ecmp-pfxs"):
                                                self.ecmp_pfxs = value
                                                self.ecmp_pfxs.value_namespace = name_space
                                                self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-pfxs"):
                                                self.protected_pfxs = value
                                                self.protected_pfxs.value_namespace = name_space
                                                self.protected_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-pfxs"):
                                                self.total_pfxs = value
                                                self.total_pfxs.value_namespace = name_space
                                                self.total_pfxs.value_namespace_prefix = name_space_prefix


                                    class Nhs(Entity):
                                        """
                                        Forwarding rewrites nexthops (paths) summary
                                        
                                        .. attribute:: backup_paths
                                        
                                        	Count of non\-primary backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: labeled_backup_paths
                                        
                                        	Count of labeled backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: labeled_paths
                                        
                                        	Count of all labeled paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: protected_paths
                                        
                                        	Count of FRR protected paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: remote_backup_paths
                                        
                                        	Count of non\-primary remote backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: total_paths
                                        
                                        	Total path count
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__init__()

                                            self.yang_name = "nhs"
                                            self.yang_parent_name = "rws"

                                            self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                                            self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                                            self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                                            self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                                            self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                                            self.total_paths = YLeaf(YType.uint32, "total-paths")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_paths",
                                                            "labeled_backup_paths",
                                                            "labeled_paths",
                                                            "protected_paths",
                                                            "remote_backup_paths",
                                                            "total_paths") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_paths.is_set or
                                                self.labeled_backup_paths.is_set or
                                                self.labeled_paths.is_set or
                                                self.protected_paths.is_set or
                                                self.remote_backup_paths.is_set or
                                                self.total_paths.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_paths.yfilter != YFilter.not_set or
                                                self.labeled_backup_paths.yfilter != YFilter.not_set or
                                                self.labeled_paths.yfilter != YFilter.not_set or
                                                self.protected_paths.yfilter != YFilter.not_set or
                                                self.remote_backup_paths.yfilter != YFilter.not_set or
                                                self.total_paths.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nhs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_paths.get_name_leafdata())
                                            if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                                            if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                                            if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_paths.get_name_leafdata())
                                            if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                                            if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_paths.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-paths"):
                                                self.backup_paths = value
                                                self.backup_paths.value_namespace = name_space
                                                self.backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-backup-paths"):
                                                self.labeled_backup_paths = value
                                                self.labeled_backup_paths.value_namespace = name_space
                                                self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-paths"):
                                                self.labeled_paths = value
                                                self.labeled_paths.value_namespace = name_space
                                                self.labeled_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-paths"):
                                                self.protected_paths = value
                                                self.protected_paths.value_namespace = name_space
                                                self.protected_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "remote-backup-paths"):
                                                self.remote_backup_paths = value
                                                self.remote_backup_paths.value_namespace = name_space
                                                self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-paths"):
                                                self.total_paths = value
                                                self.total_paths.value_namespace = name_space
                                                self.total_paths.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.nhs is not None and self.nhs.has_data()) or
                                            (self.pfxs is not None and self.pfxs.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.nhs is not None and self.nhs.has_operation()) or
                                            (self.pfxs is not None and self.pfxs.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "rws" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "nhs"):
                                            if (self.nhs is None):
                                                self.nhs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                                self.nhs.parent = self
                                                self._children_name_map["nhs"] = "nhs"
                                            return self.nhs

                                        if (child_yang_name == "pfxs"):
                                            if (self.pfxs is None):
                                                self.pfxs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                                self.pfxs.parent = self
                                                self._children_name_map["pfxs"] = "pfxs"
                                            return self.pfxs

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nhs" or name == "pfxs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.fsht.is_set or
                                        self.intfs.is_set or
                                        self.is_lsd_bound.is_set or
                                        self.lbls.is_set or
                                        (self.rws is not None and self.rws.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fsht.yfilter != YFilter.not_set or
                                        self.intfs.yfilter != YFilter.not_set or
                                        self.is_lsd_bound.yfilter != YFilter.not_set or
                                        self.lbls.yfilter != YFilter.not_set or
                                        (self.rws is not None and self.rws.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwarding-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fsht.get_name_leafdata())
                                    if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intfs.get_name_leafdata())
                                    if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                                    if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbls.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "rws"):
                                        if (self.rws is None):
                                            self.rws = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws()
                                            self.rws.parent = self
                                            self._children_name_map["rws"] = "rws"
                                        return self.rws

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fsht"):
                                        self.fsht = value
                                        self.fsht.value_namespace = name_space
                                        self.fsht.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intfs"):
                                        self.intfs = value
                                        self.intfs.value_namespace = name_space
                                        self.intfs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-lsd-bound"):
                                        self.is_lsd_bound = value
                                        self.is_lsd_bound.value_namespace = name_space
                                        self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbls"):
                                        self.lbls = value
                                        self.lbls.value_namespace = name_space
                                        self.lbls.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.af_name.is_set or
                                    (self.bindings is not None and self.bindings.has_data()) or
                                    (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_data()) or
                                    (self.bindings_summary is not None and self.bindings_summary.has_data()) or
                                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                                    (self.discovery is not None and self.discovery.has_data()) or
                                    (self.forwarding_summary is not None and self.forwarding_summary.has_data()) or
                                    (self.forwardings is not None and self.forwardings.has_data()) or
                                    (self.igp is not None and self.igp.has_data()) or
                                    (self.interface_summary is not None and self.interface_summary.has_data()) or
                                    (self.interfaces is not None and self.interfaces.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.af_name.yfilter != YFilter.not_set or
                                    (self.bindings is not None and self.bindings.has_operation()) or
                                    (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_operation()) or
                                    (self.bindings_summary is not None and self.bindings_summary.has_operation()) or
                                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                                    (self.discovery is not None and self.discovery.has_operation()) or
                                    (self.forwarding_summary is not None and self.forwarding_summary.has_operation()) or
                                    (self.forwardings is not None and self.forwardings.has_operation()) or
                                    (self.igp is not None and self.igp.has_operation()) or
                                    (self.interface_summary is not None and self.interface_summary.has_operation()) or
                                    (self.interfaces is not None and self.interfaces.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "af" + "[af-name='" + self.af_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.af_name.is_set or self.af_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.af_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bindings"):
                                    if (self.bindings is None):
                                        self.bindings = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Bindings()
                                        self.bindings.parent = self
                                        self._children_name_map["bindings"] = "bindings"
                                    return self.bindings

                                if (child_yang_name == "bindings-advertise-spec"):
                                    if (self.bindings_advertise_spec is None):
                                        self.bindings_advertise_spec = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec()
                                        self.bindings_advertise_spec.parent = self
                                        self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                    return self.bindings_advertise_spec

                                if (child_yang_name == "bindings-summary"):
                                    if (self.bindings_summary is None):
                                        self.bindings_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummary()
                                        self.bindings_summary.parent = self
                                        self._children_name_map["bindings_summary"] = "bindings-summary"
                                    return self.bindings_summary

                                if (child_yang_name == "bindings-summary-all"):
                                    if (self.bindings_summary_all is None):
                                        self.bindings_summary_all = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.BindingsSummaryAll()
                                        self.bindings_summary_all.parent = self
                                        self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                    return self.bindings_summary_all

                                if (child_yang_name == "discovery"):
                                    if (self.discovery is None):
                                        self.discovery = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Discovery()
                                        self.discovery.parent = self
                                        self._children_name_map["discovery"] = "discovery"
                                    return self.discovery

                                if (child_yang_name == "forwarding-summary"):
                                    if (self.forwarding_summary is None):
                                        self.forwarding_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.ForwardingSummary()
                                        self.forwarding_summary.parent = self
                                        self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                    return self.forwarding_summary

                                if (child_yang_name == "forwardings"):
                                    if (self.forwardings is None):
                                        self.forwardings = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Forwardings()
                                        self.forwardings.parent = self
                                        self._children_name_map["forwardings"] = "forwardings"
                                    return self.forwardings

                                if (child_yang_name == "igp"):
                                    if (self.igp is None):
                                        self.igp = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Igp()
                                        self.igp.parent = self
                                        self._children_name_map["igp"] = "igp"
                                    return self.igp

                                if (child_yang_name == "interface-summary"):
                                    if (self.interface_summary is None):
                                        self.interface_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.InterfaceSummary()
                                        self.interface_summary.parent = self
                                        self._children_name_map["interface_summary"] = "interface-summary"
                                    return self.interface_summary

                                if (child_yang_name == "interfaces"):
                                    if (self.interfaces is None):
                                        self.interfaces = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af.Interfaces()
                                        self.interfaces.parent = self
                                        self._children_name_map["interfaces"] = "interfaces"
                                    return self.interfaces

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bindings" or name == "bindings-advertise-spec" or name == "bindings-summary" or name == "bindings-summary-all" or name == "discovery" or name == "forwarding-summary" or name == "forwardings" or name == "igp" or name == "interface-summary" or name == "interfaces" or name == "af-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "af-name"):
                                    self.af_name = value
                                    self.af_name.value_namespace = name_space
                                    self.af_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.af:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.af:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "afs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "af"):
                                for c in self.af:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Afs.Af()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.af.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "af"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborBriefs(Entity):
                        """
                        The LDP Neighbors (brief)
                        
                        .. attribute:: neighbor_brief
                        
                        	Brief information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`NeighborBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs, self).__init__()

                            self.yang_name = "neighbor-briefs"
                            self.yang_parent_name = "vrf"

                            self.neighbor_brief = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs, self).__setattr__(name, value)


                        class NeighborBrief(Entity):
                            """
                            Brief information on a particular LDP neighbor
                            
                            .. attribute:: is_graceful_restartable
                            
                            	Is graceful restartable
                            	**type**\:  bool
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: nbr_br_af_info
                            
                            	Neighbor Brief AF Info
                            	**type**\: list of    :py:class:`NbrBrAfInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo>`
                            
                            .. attribute:: nsr_state
                            
                            	NSR readiness state
                            	**type**\:   :py:class:`ShowNsrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.ShowNsrState>`
                            
                            .. attribute:: up_time_seconds
                            
                            	Up time in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__init__()

                                self.yang_name = "neighbor-brief"
                                self.yang_parent_name = "neighbor-briefs"

                                self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.nsr_state = YLeaf(YType.enumeration, "nsr-state")

                                self.up_time_seconds = YLeaf(YType.uint32, "up-time-seconds")

                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.nbr_br_af_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_graceful_restartable",
                                                "label_space_id",
                                                "lsr_id",
                                                "nsr_state",
                                                "up_time_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "neighbor-brief"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class NbrBrAfInfo(Entity):
                                """
                                Neighbor Brief AF Info
                                
                                .. attribute:: address_family
                                
                                	Neighbor Brief Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: num_of_nbr_addresses
                                
                                	Number of neighbor addresses
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_nbr_discovery
                                
                                	Number of neighbor discovery sources
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_nbr_lbl
                                
                                	Number of neighbor labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__init__()

                                    self.yang_name = "nbr-br-af-info"
                                    self.yang_parent_name = "neighbor-brief"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.num_of_nbr_addresses = YLeaf(YType.uint32, "num-of-nbr-addresses")

                                    self.num_of_nbr_discovery = YLeaf(YType.uint32, "num-of-nbr-discovery")

                                    self.num_of_nbr_lbl = YLeaf(YType.uint32, "num-of-nbr-lbl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "num_of_nbr_addresses",
                                                    "num_of_nbr_discovery",
                                                    "num_of_nbr_lbl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.num_of_nbr_addresses.is_set or
                                        self.num_of_nbr_discovery.is_set or
                                        self.num_of_nbr_lbl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.num_of_nbr_addresses.yfilter != YFilter.not_set or
                                        self.num_of_nbr_discovery.yfilter != YFilter.not_set or
                                        self.num_of_nbr_lbl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "nbr-br-af-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.num_of_nbr_addresses.is_set or self.num_of_nbr_addresses.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_addresses.get_name_leafdata())
                                    if (self.num_of_nbr_discovery.is_set or self.num_of_nbr_discovery.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_discovery.get_name_leafdata())
                                    if (self.num_of_nbr_lbl.is_set or self.num_of_nbr_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_lbl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "num-of-nbr-addresses" or name == "num-of-nbr-discovery" or name == "num-of-nbr-lbl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-addresses"):
                                        self.num_of_nbr_addresses = value
                                        self.num_of_nbr_addresses.value_namespace = name_space
                                        self.num_of_nbr_addresses.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-discovery"):
                                        self.num_of_nbr_discovery = value
                                        self.num_of_nbr_discovery.value_namespace = name_space
                                        self.num_of_nbr_discovery.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-lbl"):
                                        self.num_of_nbr_lbl = value
                                        self.num_of_nbr_lbl.value_namespace = name_space
                                        self.num_of_nbr_lbl.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.nbr_br_af_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_graceful_restartable.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    self.nsr_state.is_set or
                                    self.up_time_seconds.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.nbr_br_af_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_graceful_restartable.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    self.nsr_state.yfilter != YFilter.not_set or
                                    self.up_time_seconds.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-brief" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                if (self.nsr_state.is_set or self.nsr_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state.get_name_leafdata())
                                if (self.up_time_seconds.is_set or self.up_time_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.up_time_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "nbr-br-af-info"):
                                    for c in self.nbr_br_af_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.nbr_br_af_info.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nbr-br-af-info" or name == "vrf" or name == "is-graceful-restartable" or name == "label-space-id" or name == "lsr-id" or name == "nsr-state" or name == "up-time-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-graceful-restartable"):
                                    self.is_graceful_restartable = value
                                    self.is_graceful_restartable.value_namespace = name_space
                                    self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state"):
                                    self.nsr_state = value
                                    self.nsr_state.value_namespace = name_space
                                    self.nsr_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "up-time-seconds"):
                                    self.up_time_seconds = value
                                    self.up_time_seconds.value_namespace = name_space
                                    self.up_time_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor_brief:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor_brief:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-briefs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-brief"):
                                for c in self.neighbor_brief:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs.NeighborBrief()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor_brief.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-brief"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class BackoffParameters(Entity):
                        """
                        The LDP Backoff Parameters
                        
                        .. attribute:: initial_seconds
                        
                        	Initial backoff value in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: maximum_seconds
                        
                        	Maximum backoff value in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.BackoffParameters, self).__init__()

                            self.yang_name = "backoff-parameters"
                            self.yang_parent_name = "vrf"

                            self.initial_seconds = YLeaf(YType.uint32, "initial-seconds")

                            self.maximum_seconds = YLeaf(YType.uint32, "maximum-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("initial_seconds",
                                            "maximum_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.BackoffParameters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.BackoffParameters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.initial_seconds.is_set or
                                self.maximum_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.initial_seconds.yfilter != YFilter.not_set or
                                self.maximum_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoff-parameters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.initial_seconds.is_set or self.initial_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.initial_seconds.get_name_leafdata())
                            if (self.maximum_seconds.is_set or self.maximum_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "initial-seconds" or name == "maximum-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "initial-seconds"):
                                self.initial_seconds = value
                                self.initial_seconds.value_namespace = name_space
                                self.initial_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-seconds"):
                                self.maximum_seconds = value
                                self.maximum_seconds.value_namespace = name_space
                                self.maximum_seconds.value_namespace_prefix = name_space_prefix


                    class Backoffs(Entity):
                        """
                        The LDP backoff
                        
                        .. attribute:: backoff
                        
                        	LDP Backoff Information
                        	**type**\: list of    :py:class:`Backoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs.Backoff>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs, self).__init__()

                            self.yang_name = "backoffs"
                            self.yang_parent_name = "vrf"

                            self.backoff = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs, self).__setattr__(name, value)


                        class Backoff(Entity):
                            """
                            LDP Backoff Information
                            
                            .. attribute:: backoff_seconds
                            
                            	Backoff seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: waiting_seconds
                            
                            	Backoff waiting seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs.Backoff, self).__init__()

                                self.yang_name = "backoff"
                                self.yang_parent_name = "backoffs"

                                self.backoff_seconds = YLeaf(YType.uint32, "backoff-seconds")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.waiting_seconds = YLeaf(YType.uint32, "waiting-seconds")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backoff_seconds",
                                                "label_space_id",
                                                "lsr_id",
                                                "waiting_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs.Backoff, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs.Backoff, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.backoff_seconds.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    self.waiting_seconds.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backoff_seconds.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    self.waiting_seconds.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backoff" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backoff_seconds.is_set or self.backoff_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backoff_seconds.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                if (self.waiting_seconds.is_set or self.waiting_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.waiting_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backoff-seconds" or name == "label-space-id" or name == "lsr-id" or name == "waiting-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backoff-seconds"):
                                    self.backoff_seconds = value
                                    self.backoff_seconds.value_namespace = name_space
                                    self.backoff_seconds.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "waiting-seconds"):
                                    self.waiting_seconds = value
                                    self.waiting_seconds.value_namespace = name_space
                                    self.waiting_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.backoff:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.backoff:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoffs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backoff"):
                                for c in self.backoff:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs.Backoff()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.backoff.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Nsr(Entity):
                        """
                        LDP NSR related information
                        
                        .. attribute:: ha_statistics
                        
                        	LDP NSR Statistics related information
                        	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics>`
                        
                        .. attribute:: ha_summary
                        
                        	LDP HA Summary
                        	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary>`
                        
                        .. attribute:: nsr_pending
                        
                        	LDP NSR Pending related information
                        	**type**\:   :py:class:`NsrPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr, self).__init__()

                            self.yang_name = "nsr"
                            self.yang_parent_name = "vrf"

                            self.ha_statistics = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics()
                            self.ha_statistics.parent = self
                            self._children_name_map["ha_statistics"] = "ha-statistics"
                            self._children_yang_names.add("ha-statistics")

                            self.ha_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary()
                            self.ha_summary.parent = self
                            self._children_name_map["ha_summary"] = "ha-summary"
                            self._children_yang_names.add("ha-summary")

                            self.nsr_pending = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending()
                            self.nsr_pending.parent = self
                            self._children_name_map["nsr_pending"] = "nsr-pending"
                            self._children_yang_names.add("nsr-pending")


                        class NsrPending(Entity):
                            """
                            LDP NSR Pending related information
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending, self).__init__()

                                self.yang_name = "nsr-pending"
                                self.yang_parent_name = "nsr"

                                self.ha_neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "nsr-pending"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (self.ha_neighbors is not None and self.ha_neighbors.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nsr-pending" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaSummary(Entity):
                            """
                            LDP HA Summary
                            
                            .. attribute:: sessions
                            
                            	Session summary
                            	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Sessions>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary, self).__init__()

                                self.yang_name = "ha-summary"
                                self.yang_parent_name = "nsr"

                                self.sessions = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Sessions()
                                self.sessions.parent = self
                                self._children_name_map["sessions"] = "sessions"
                                self._children_yang_names.add("sessions")

                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "ha-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Sessions(Entity):
                                """
                                Session summary
                                
                                .. attribute:: nsr_eligible
                                
                                	NSR eligible sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_app_wait
                                
                                	Number of sessions in NSR app\-wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_none
                                
                                	Number of sessions in NSR none state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_operational
                                
                                	Number of sessions in NSR operational state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_prepare
                                
                                	Number of sessions in NSR prepare state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_ready
                                
                                	Number of sessions in NSR ready state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase1
                                
                                	Number of sessions in NSR TCP phase 1 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase2
                                
                                	Number of sessions in NSR TCP phase 2 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_wait
                                
                                	Number of sessions in NSR wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total
                                
                                	Total sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__init__()

                                    self.yang_name = "sessions"
                                    self.yang_parent_name = "ha-summary"

                                    self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                    self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                    self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                    self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                    self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                    self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                    self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                    self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                    self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                    self.total = YLeaf(YType.uint32, "total")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nsr_eligible",
                                                    "nsr_state_app_wait",
                                                    "nsr_state_none",
                                                    "nsr_state_operational",
                                                    "nsr_state_prepare",
                                                    "nsr_state_ready",
                                                    "nsr_state_tcp_phase1",
                                                    "nsr_state_tcp_phase2",
                                                    "nsr_state_wait",
                                                    "total") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nsr_eligible.is_set or
                                        self.nsr_state_app_wait.is_set or
                                        self.nsr_state_none.is_set or
                                        self.nsr_state_operational.is_set or
                                        self.nsr_state_prepare.is_set or
                                        self.nsr_state_ready.is_set or
                                        self.nsr_state_tcp_phase1.is_set or
                                        self.nsr_state_tcp_phase2.is_set or
                                        self.nsr_state_wait.is_set or
                                        self.total.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nsr_eligible.yfilter != YFilter.not_set or
                                        self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                        self.nsr_state_none.yfilter != YFilter.not_set or
                                        self.nsr_state_operational.yfilter != YFilter.not_set or
                                        self.nsr_state_prepare.yfilter != YFilter.not_set or
                                        self.nsr_state_ready.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                        self.nsr_state_wait.yfilter != YFilter.not_set or
                                        self.total.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sessions" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                    if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                    if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                    if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                    if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                    if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                    if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                    if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nsr-eligible"):
                                        self.nsr_eligible = value
                                        self.nsr_eligible.value_namespace = name_space
                                        self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-app-wait"):
                                        self.nsr_state_app_wait = value
                                        self.nsr_state_app_wait.value_namespace = name_space
                                        self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-none"):
                                        self.nsr_state_none = value
                                        self.nsr_state_none.value_namespace = name_space
                                        self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-operational"):
                                        self.nsr_state_operational = value
                                        self.nsr_state_operational.value_namespace = name_space
                                        self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-prepare"):
                                        self.nsr_state_prepare = value
                                        self.nsr_state_prepare.value_namespace = name_space
                                        self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-ready"):
                                        self.nsr_state_ready = value
                                        self.nsr_state_ready.value_namespace = name_space
                                        self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase1"):
                                        self.nsr_state_tcp_phase1 = value
                                        self.nsr_state_tcp_phase1.value_namespace = name_space
                                        self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase2"):
                                        self.nsr_state_tcp_phase2 = value
                                        self.nsr_state_tcp_phase2.value_namespace = name_space
                                        self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-wait"):
                                        self.nsr_state_wait = value
                                        self.nsr_state_wait.value_namespace = name_space
                                        self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total"):
                                        self.total = value
                                        self.total.value_namespace = name_space
                                        self.total.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sessions is not None and self.sessions.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sessions is not None and self.sessions.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sessions"):
                                    if (self.sessions is None):
                                        self.sessions = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Sessions()
                                        self.sessions.parent = self
                                        self._children_name_map["sessions"] = "sessions"
                                    return self.sessions

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sessions" or name == "vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaStatistics(Entity):
                            """
                            LDP NSR Statistics related information
                            
                            .. attribute:: ha_global
                            
                            	LDP NSR Global Statistics information
                            	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal>`
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics, self).__init__()

                                self.yang_name = "ha-statistics"
                                self.yang_parent_name = "nsr"

                                self.ha_global = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal()
                                self.ha_global.parent = self
                                self._children_name_map["ha_global"] = "ha-global"
                                self._children_yang_names.add("ha-global")

                                self.ha_neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaGlobal(Entity):
                                """
                                LDP NSR Global Statistics information
                                
                                .. attribute:: init_sync
                                
                                	Init Sync
                                	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal, self).__init__()

                                    self.yang_name = "ha-global"
                                    self.yang_parent_name = "ha-statistics"

                                    self.init_sync = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                    self.init_sync.parent = self
                                    self._children_name_map["init_sync"] = "init-sync"
                                    self._children_yang_names.add("init-sync")


                                class InitSync(Entity):
                                    """
                                    Init Sync
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_default_mtu
                                    
                                    	default IPC MTU bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_exceeded_mtu_msg_cnt
                                    
                                    	ipc exceeded mtu msg cnt
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_max_rx_batch_bytes
                                    
                                    	biggest IPC RX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_max_tx_batch_bytes
                                    
                                    	biggest IPC TX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_rx_bytes
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_rx_cnt
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_tx_bytes
                                    
                                    	total IPC bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_tx_cnt
                                    
                                    	num IPC msgs sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_restart_cnt
                                    
                                    	number of times ipc has been restarted
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_tx_fail_cnt
                                    
                                    	number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_cfged
                                    
                                    	TRUE if NSR configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: nsr_synced
                                    
                                    	TRUE if NSR synced
                                    	**type**\:  bool
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Number of Rcvd Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Number of Sent Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of label bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl_adv
                                    
                                    	Num of lbl adv
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lcl_addr_wd
                                    
                                    	Num of lcl address withdraw
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_peers
                                    
                                    	Number of Peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_pfx
                                    
                                    	Number of binding prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_ipc_tx_fail_cnt
                                    
                                    	total number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__init__()

                                        self.yang_name = "init-sync"
                                        self.yang_parent_name = "ha-global"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                        self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                        self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                        self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                        self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                        self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                        self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                        self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                        self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                        self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                        self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                        self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                        self.num_peers = YLeaf(YType.uint32, "num-peers")

                                        self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                        self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "ipc_default_mtu",
                                                        "ipc_exceeded_mtu_msg_cnt",
                                                        "ipc_max_rx_batch_bytes",
                                                        "ipc_max_tx_batch_bytes",
                                                        "ipc_msg_rx_bytes",
                                                        "ipc_msg_rx_cnt",
                                                        "ipc_msg_tx_bytes",
                                                        "ipc_msg_tx_cnt",
                                                        "ipc_restart_cnt",
                                                        "ipc_tx_fail_cnt",
                                                        "nsr_cfged",
                                                        "nsr_synced",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_lbl",
                                                        "num_lbl_adv",
                                                        "num_lcl_addr_wd",
                                                        "num_peers",
                                                        "num_pfx",
                                                        "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.ipc_default_mtu.is_set or
                                            self.ipc_exceeded_mtu_msg_cnt.is_set or
                                            self.ipc_max_rx_batch_bytes.is_set or
                                            self.ipc_max_tx_batch_bytes.is_set or
                                            self.ipc_msg_rx_bytes.is_set or
                                            self.ipc_msg_rx_cnt.is_set or
                                            self.ipc_msg_tx_bytes.is_set or
                                            self.ipc_msg_tx_cnt.is_set or
                                            self.ipc_restart_cnt.is_set or
                                            self.ipc_tx_fail_cnt.is_set or
                                            self.nsr_cfged.is_set or
                                            self.nsr_synced.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_lbl.is_set or
                                            self.num_lbl_adv.is_set or
                                            self.num_lcl_addr_wd.is_set or
                                            self.num_peers.is_set or
                                            self.num_pfx.is_set or
                                            self.total_ipc_tx_fail_cnt.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.ipc_default_mtu.yfilter != YFilter.not_set or
                                            self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                            self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                            self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                            self.nsr_cfged.yfilter != YFilter.not_set or
                                            self.nsr_synced.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_lbl_adv.yfilter != YFilter.not_set or
                                            self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                            self.num_peers.yfilter != YFilter.not_set or
                                            self.num_pfx.yfilter != YFilter.not_set or
                                            self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                        if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                        if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                        if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                        if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                        if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                        if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                        if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                        if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_peers.get_name_leafdata())
                                        if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                        if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-default-mtu"):
                                            self.ipc_default_mtu = value
                                            self.ipc_default_mtu.value_namespace = name_space
                                            self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                            self.ipc_exceeded_mtu_msg_cnt = value
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-rx-batch-bytes"):
                                            self.ipc_max_rx_batch_bytes = value
                                            self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-tx-batch-bytes"):
                                            self.ipc_max_tx_batch_bytes = value
                                            self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-bytes"):
                                            self.ipc_msg_rx_bytes = value
                                            self.ipc_msg_rx_bytes.value_namespace = name_space
                                            self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-cnt"):
                                            self.ipc_msg_rx_cnt = value
                                            self.ipc_msg_rx_cnt.value_namespace = name_space
                                            self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-bytes"):
                                            self.ipc_msg_tx_bytes = value
                                            self.ipc_msg_tx_bytes.value_namespace = name_space
                                            self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-cnt"):
                                            self.ipc_msg_tx_cnt = value
                                            self.ipc_msg_tx_cnt.value_namespace = name_space
                                            self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-restart-cnt"):
                                            self.ipc_restart_cnt = value
                                            self.ipc_restart_cnt.value_namespace = name_space
                                            self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-tx-fail-cnt"):
                                            self.ipc_tx_fail_cnt = value
                                            self.ipc_tx_fail_cnt.value_namespace = name_space
                                            self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-cfged"):
                                            self.nsr_cfged = value
                                            self.nsr_cfged.value_namespace = name_space
                                            self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-synced"):
                                            self.nsr_synced = value
                                            self.nsr_synced.value_namespace = name_space
                                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl-adv"):
                                            self.num_lbl_adv = value
                                            self.num_lbl_adv.value_namespace = name_space
                                            self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lcl-addr-wd"):
                                            self.num_lcl_addr_wd = value
                                            self.num_lcl_addr_wd.value_namespace = name_space
                                            self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-peers"):
                                            self.num_peers = value
                                            self.num_peers.value_namespace = name_space
                                            self.num_peers.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-pfx"):
                                            self.num_pfx = value
                                            self.num_pfx.value_namespace = name_space
                                            self.num_pfx.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-ipc-tx-fail-cnt"):
                                            self.total_ipc_tx_fail_cnt = value
                                            self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                            self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.init_sync is not None and self.init_sync.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.init_sync is not None and self.init_sync.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync"):
                                        if (self.init_sync is None):
                                            self.init_sync = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                            self.init_sync.parent = self
                                            self._children_name_map["init_sync"] = "init-sync"
                                        return self.init_sync

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "ha-statistics"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.ha_global is not None and self.ha_global.has_data()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_global is not None and self.ha_global.has_operation()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-global"):
                                    if (self.ha_global is None):
                                        self.ha_global = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal()
                                        self.ha_global.parent = self
                                        self._children_name_map["ha_global"] = "ha-global"
                                    return self.ha_global

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-global" or name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                                (self.ha_summary is not None and self.ha_summary.has_data()) or
                                (self.nsr_pending is not None and self.nsr_pending.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                                (self.ha_summary is not None and self.ha_summary.has_operation()) or
                                (self.nsr_pending is not None and self.nsr_pending.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-statistics"):
                                if (self.ha_statistics is None):
                                    self.ha_statistics = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaStatistics()
                                    self.ha_statistics.parent = self
                                    self._children_name_map["ha_statistics"] = "ha-statistics"
                                return self.ha_statistics

                            if (child_yang_name == "ha-summary"):
                                if (self.ha_summary is None):
                                    self.ha_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.HaSummary()
                                    self.ha_summary.parent = self
                                    self._children_name_map["ha_summary"] = "ha-summary"
                                return self.ha_summary

                            if (child_yang_name == "nsr-pending"):
                                if (self.nsr_pending is None):
                                    self.nsr_pending = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr.NsrPending()
                                    self.nsr_pending.parent = self
                                    self._children_name_map["nsr_pending"] = "nsr-pending"
                                return self.nsr_pending

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-statistics" or name == "ha-summary" or name == "nsr-pending"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Parameters(Entity):
                        """
                        LDP parameters
                        
                        .. attribute:: address_family_parameter
                        
                        	Per AF parameters
                        	**type**\: list of    :py:class:`AddressFamilyParameter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter>`
                        
                        .. attribute:: af_binding_withdraw_delay
                        
                        	Delay (sec) in Binding Withdrawal for an Address Family
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: discovery_quick_start_disabled_on_interfaces
                        
                        	Discovery quick\-start disabled on some LDP\-enabled interfaces
                        	**type**\:  bool
                        
                        .. attribute:: global_discovery_quick_start_disabled
                        
                        	Discovery quick\-start globally disabled
                        	**type**\:  bool
                        
                        .. attribute:: global_md5_password_enabled
                        
                        	Global MD5 password enabled
                        	**type**\:  bool
                        
                        .. attribute:: graceful_restart_information
                        
                        	Graceful restart information
                        	**type**\:   :py:class:`GracefulRestartInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.GracefulRestartInformation>`
                        
                        .. attribute:: hello_hold_time
                        
                        	Hello hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hello_interval
                        
                        	Hello interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: housekeeping_timer_interval
                        
                        	Housekeeping periodic timer interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: igp_sync_delay_time_for_interface
                        
                        	Interface IGP sync delay time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: igp_sync_delay_time_on_restart
                        
                        	IGP sync delay time on process restart in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: keepalive_interval
                        
                        	Keepalive interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ldp_out_of_mem_state
                        
                        	LDP Out of memory state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ldp_recovery_timeout
                        
                        	LDP recovery timeout with LSD
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: le_no_route_timeout
                        
                        	LIB entry no route timeout
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_intf_attached
                        
                        	Maximum number of LDP enabled attached interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_intf_te
                        
                        	Maximum number of LDP enabled TE interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_peer
                        
                        	Maximum number of LDP peers
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nsr_enabled
                        
                        	TRUE if NSR is enabled
                        	**type**\:  bool
                        
                        .. attribute:: nsr_synced
                        
                        	TRUE if LDP is standby and is NSR Sync\-ed with active
                        	**type**\:  bool
                        
                        .. attribute:: protocol_version
                        
                        	Protocol version
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: role_is_active
                        
                        	Is process role active or standby
                        	**type**\:  bool
                        
                        .. attribute:: router_id
                        
                        	Router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: session_hold_time
                        
                        	Session hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: targeted_hello_hold_time
                        
                        	Targeted hello hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: targeted_hello_interval
                        
                        	Targeted hello interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters, self).__init__()

                            self.yang_name = "parameters"
                            self.yang_parent_name = "vrf"

                            self.af_binding_withdraw_delay = YLeaf(YType.uint32, "af-binding-withdraw-delay")

                            self.discovery_quick_start_disabled_on_interfaces = YLeaf(YType.boolean, "discovery-quick-start-disabled-on-interfaces")

                            self.global_discovery_quick_start_disabled = YLeaf(YType.boolean, "global-discovery-quick-start-disabled")

                            self.global_md5_password_enabled = YLeaf(YType.boolean, "global-md5-password-enabled")

                            self.hello_hold_time = YLeaf(YType.uint32, "hello-hold-time")

                            self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                            self.housekeeping_timer_interval = YLeaf(YType.uint32, "housekeeping-timer-interval")

                            self.igp_sync_delay_time_for_interface = YLeaf(YType.uint32, "igp-sync-delay-time-for-interface")

                            self.igp_sync_delay_time_on_restart = YLeaf(YType.uint32, "igp-sync-delay-time-on-restart")

                            self.keepalive_interval = YLeaf(YType.uint32, "keepalive-interval")

                            self.ldp_out_of_mem_state = YLeaf(YType.uint32, "ldp-out-of-mem-state")

                            self.ldp_recovery_timeout = YLeaf(YType.uint32, "ldp-recovery-timeout")

                            self.le_no_route_timeout = YLeaf(YType.uint32, "le-no-route-timeout")

                            self.max_intf_attached = YLeaf(YType.uint32, "max-intf-attached")

                            self.max_intf_te = YLeaf(YType.uint32, "max-intf-te")

                            self.max_peer = YLeaf(YType.uint32, "max-peer")

                            self.nsr_enabled = YLeaf(YType.boolean, "nsr-enabled")

                            self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                            self.protocol_version = YLeaf(YType.uint32, "protocol-version")

                            self.role_is_active = YLeaf(YType.boolean, "role-is-active")

                            self.router_id = YLeaf(YType.str, "router-id")

                            self.session_hold_time = YLeaf(YType.uint32, "session-hold-time")

                            self.targeted_hello_hold_time = YLeaf(YType.uint32, "targeted-hello-hold-time")

                            self.targeted_hello_interval = YLeaf(YType.uint32, "targeted-hello-interval")

                            self.graceful_restart_information = MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.GracefulRestartInformation()
                            self.graceful_restart_information.parent = self
                            self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                            self._children_yang_names.add("graceful-restart-information")

                            self.address_family_parameter = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("af_binding_withdraw_delay",
                                            "discovery_quick_start_disabled_on_interfaces",
                                            "global_discovery_quick_start_disabled",
                                            "global_md5_password_enabled",
                                            "hello_hold_time",
                                            "hello_interval",
                                            "housekeeping_timer_interval",
                                            "igp_sync_delay_time_for_interface",
                                            "igp_sync_delay_time_on_restart",
                                            "keepalive_interval",
                                            "ldp_out_of_mem_state",
                                            "ldp_recovery_timeout",
                                            "le_no_route_timeout",
                                            "max_intf_attached",
                                            "max_intf_te",
                                            "max_peer",
                                            "nsr_enabled",
                                            "nsr_synced",
                                            "protocol_version",
                                            "role_is_active",
                                            "router_id",
                                            "session_hold_time",
                                            "targeted_hello_hold_time",
                                            "targeted_hello_interval") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters, self).__setattr__(name, value)


                        class GracefulRestartInformation(Entity):
                            """
                            Graceful restart information
                            
                            .. attribute:: graceful_restart_forwarding_state_hold_time
                            
                            	Graceful restart forward state hold time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: graceful_restart_reconnect_timeout
                            
                            	Reconnect timeout value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_graceful_restart_configured
                            
                            	Is graceful restart configured
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__init__()

                                self.yang_name = "graceful-restart-information"
                                self.yang_parent_name = "parameters"

                                self.graceful_restart_forwarding_state_hold_time = YLeaf(YType.uint32, "graceful-restart-forwarding-state-hold-time")

                                self.graceful_restart_reconnect_timeout = YLeaf(YType.uint32, "graceful-restart-reconnect-timeout")

                                self.is_graceful_restart_configured = YLeaf(YType.boolean, "is-graceful-restart-configured")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("graceful_restart_forwarding_state_hold_time",
                                                "graceful_restart_reconnect_timeout",
                                                "is_graceful_restart_configured") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.graceful_restart_forwarding_state_hold_time.is_set or
                                    self.graceful_restart_reconnect_timeout.is_set or
                                    self.is_graceful_restart_configured.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set or
                                    self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set or
                                    self.is_graceful_restart_configured.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "graceful-restart-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.graceful_restart_forwarding_state_hold_time.is_set or self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.graceful_restart_forwarding_state_hold_time.get_name_leafdata())
                                if (self.graceful_restart_reconnect_timeout.is_set or self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.graceful_restart_reconnect_timeout.get_name_leafdata())
                                if (self.is_graceful_restart_configured.is_set or self.is_graceful_restart_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_graceful_restart_configured.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "graceful-restart-forwarding-state-hold-time" or name == "graceful-restart-reconnect-timeout" or name == "is-graceful-restart-configured"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "graceful-restart-forwarding-state-hold-time"):
                                    self.graceful_restart_forwarding_state_hold_time = value
                                    self.graceful_restart_forwarding_state_hold_time.value_namespace = name_space
                                    self.graceful_restart_forwarding_state_hold_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "graceful-restart-reconnect-timeout"):
                                    self.graceful_restart_reconnect_timeout = value
                                    self.graceful_restart_reconnect_timeout.value_namespace = name_space
                                    self.graceful_restart_reconnect_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-graceful-restart-configured"):
                                    self.is_graceful_restart_configured = value
                                    self.is_graceful_restart_configured.value_namespace = name_space
                                    self.is_graceful_restart_configured.value_namespace_prefix = name_space_prefix


                        class AddressFamilyParameter(Entity):
                            """
                            Per AF parameters
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: discovery_transport_address
                            
                            	Discovery transport address
                            	**type**\:   :py:class:`DiscoveryTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress>`
                            
                            .. attribute:: is_accepting_targeted_hellos
                            
                            	Accepting targeted Hellos
                            	**type**\:  bool
                            
                            .. attribute:: label_imp_null_override_acl
                            
                            	ACL to override local label to use implicit\-null
                            	**type**\:  str
                            
                            .. attribute:: null_label
                            
                            	Null label
                            	**type**\:  str
                            
                            .. attribute:: targeted_hello_acl
                            
                            	Targeted Hello ACL
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__init__()

                                self.yang_name = "address-family-parameter"
                                self.yang_parent_name = "parameters"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.is_accepting_targeted_hellos = YLeaf(YType.boolean, "is-accepting-targeted-hellos")

                                self.label_imp_null_override_acl = YLeaf(YType.str, "label-imp-null-override-acl")

                                self.null_label = YLeaf(YType.str, "null-label")

                                self.targeted_hello_acl = YLeaf(YType.str, "targeted-hello-acl")

                                self.discovery_transport_address = MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                self.discovery_transport_address.parent = self
                                self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                self._children_yang_names.add("discovery-transport-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "is_accepting_targeted_hellos",
                                                "label_imp_null_override_acl",
                                                "null_label",
                                                "targeted_hello_acl") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)


                            class DiscoveryTransportAddress(Entity):
                                """
                                Discovery transport address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__init__()

                                    self.yang_name = "discovery-transport-address"
                                    self.yang_parent_name = "address-family-parameter"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovery-transport-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.is_accepting_targeted_hellos.is_set or
                                    self.label_imp_null_override_acl.is_set or
                                    self.null_label.is_set or
                                    self.targeted_hello_acl.is_set or
                                    (self.discovery_transport_address is not None and self.discovery_transport_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.is_accepting_targeted_hellos.yfilter != YFilter.not_set or
                                    self.label_imp_null_override_acl.yfilter != YFilter.not_set or
                                    self.null_label.yfilter != YFilter.not_set or
                                    self.targeted_hello_acl.yfilter != YFilter.not_set or
                                    (self.discovery_transport_address is not None and self.discovery_transport_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "address-family-parameter" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.is_accepting_targeted_hellos.is_set or self.is_accepting_targeted_hellos.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_accepting_targeted_hellos.get_name_leafdata())
                                if (self.label_imp_null_override_acl.is_set or self.label_imp_null_override_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_imp_null_override_acl.get_name_leafdata())
                                if (self.null_label.is_set or self.null_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.null_label.get_name_leafdata())
                                if (self.targeted_hello_acl.is_set or self.targeted_hello_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.targeted_hello_acl.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovery-transport-address"):
                                    if (self.discovery_transport_address is None):
                                        self.discovery_transport_address = MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                        self.discovery_transport_address.parent = self
                                        self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                    return self.discovery_transport_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovery-transport-address" or name == "address-family" or name == "is-accepting-targeted-hellos" or name == "label-imp-null-override-acl" or name == "null-label" or name == "targeted-hello-acl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-accepting-targeted-hellos"):
                                    self.is_accepting_targeted_hellos = value
                                    self.is_accepting_targeted_hellos.value_namespace = name_space
                                    self.is_accepting_targeted_hellos.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-imp-null-override-acl"):
                                    self.label_imp_null_override_acl = value
                                    self.label_imp_null_override_acl.value_namespace = name_space
                                    self.label_imp_null_override_acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "null-label"):
                                    self.null_label = value
                                    self.null_label.value_namespace = name_space
                                    self.null_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "targeted-hello-acl"):
                                    self.targeted_hello_acl = value
                                    self.targeted_hello_acl.value_namespace = name_space
                                    self.targeted_hello_acl.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.address_family_parameter:
                                if (c.has_data()):
                                    return True
                            return (
                                self.af_binding_withdraw_delay.is_set or
                                self.discovery_quick_start_disabled_on_interfaces.is_set or
                                self.global_discovery_quick_start_disabled.is_set or
                                self.global_md5_password_enabled.is_set or
                                self.hello_hold_time.is_set or
                                self.hello_interval.is_set or
                                self.housekeeping_timer_interval.is_set or
                                self.igp_sync_delay_time_for_interface.is_set or
                                self.igp_sync_delay_time_on_restart.is_set or
                                self.keepalive_interval.is_set or
                                self.ldp_out_of_mem_state.is_set or
                                self.ldp_recovery_timeout.is_set or
                                self.le_no_route_timeout.is_set or
                                self.max_intf_attached.is_set or
                                self.max_intf_te.is_set or
                                self.max_peer.is_set or
                                self.nsr_enabled.is_set or
                                self.nsr_synced.is_set or
                                self.protocol_version.is_set or
                                self.role_is_active.is_set or
                                self.router_id.is_set or
                                self.session_hold_time.is_set or
                                self.targeted_hello_hold_time.is_set or
                                self.targeted_hello_interval.is_set or
                                (self.graceful_restart_information is not None and self.graceful_restart_information.has_data()))

                        def has_operation(self):
                            for c in self.address_family_parameter:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.af_binding_withdraw_delay.yfilter != YFilter.not_set or
                                self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set or
                                self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set or
                                self.global_md5_password_enabled.yfilter != YFilter.not_set or
                                self.hello_hold_time.yfilter != YFilter.not_set or
                                self.hello_interval.yfilter != YFilter.not_set or
                                self.housekeeping_timer_interval.yfilter != YFilter.not_set or
                                self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set or
                                self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set or
                                self.keepalive_interval.yfilter != YFilter.not_set or
                                self.ldp_out_of_mem_state.yfilter != YFilter.not_set or
                                self.ldp_recovery_timeout.yfilter != YFilter.not_set or
                                self.le_no_route_timeout.yfilter != YFilter.not_set or
                                self.max_intf_attached.yfilter != YFilter.not_set or
                                self.max_intf_te.yfilter != YFilter.not_set or
                                self.max_peer.yfilter != YFilter.not_set or
                                self.nsr_enabled.yfilter != YFilter.not_set or
                                self.nsr_synced.yfilter != YFilter.not_set or
                                self.protocol_version.yfilter != YFilter.not_set or
                                self.role_is_active.yfilter != YFilter.not_set or
                                self.router_id.yfilter != YFilter.not_set or
                                self.session_hold_time.yfilter != YFilter.not_set or
                                self.targeted_hello_hold_time.yfilter != YFilter.not_set or
                                self.targeted_hello_interval.yfilter != YFilter.not_set or
                                (self.graceful_restart_information is not None and self.graceful_restart_information.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "parameters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.af_binding_withdraw_delay.is_set or self.af_binding_withdraw_delay.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.af_binding_withdraw_delay.get_name_leafdata())
                            if (self.discovery_quick_start_disabled_on_interfaces.is_set or self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.discovery_quick_start_disabled_on_interfaces.get_name_leafdata())
                            if (self.global_discovery_quick_start_disabled.is_set or self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_discovery_quick_start_disabled.get_name_leafdata())
                            if (self.global_md5_password_enabled.is_set or self.global_md5_password_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_md5_password_enabled.get_name_leafdata())
                            if (self.hello_hold_time.is_set or self.hello_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_hold_time.get_name_leafdata())
                            if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_interval.get_name_leafdata())
                            if (self.housekeeping_timer_interval.is_set or self.housekeeping_timer_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.housekeeping_timer_interval.get_name_leafdata())
                            if (self.igp_sync_delay_time_for_interface.is_set or self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_sync_delay_time_for_interface.get_name_leafdata())
                            if (self.igp_sync_delay_time_on_restart.is_set or self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_sync_delay_time_on_restart.get_name_leafdata())
                            if (self.keepalive_interval.is_set or self.keepalive_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.keepalive_interval.get_name_leafdata())
                            if (self.ldp_out_of_mem_state.is_set or self.ldp_out_of_mem_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_out_of_mem_state.get_name_leafdata())
                            if (self.ldp_recovery_timeout.is_set or self.ldp_recovery_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_recovery_timeout.get_name_leafdata())
                            if (self.le_no_route_timeout.is_set or self.le_no_route_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.le_no_route_timeout.get_name_leafdata())
                            if (self.max_intf_attached.is_set or self.max_intf_attached.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_intf_attached.get_name_leafdata())
                            if (self.max_intf_te.is_set or self.max_intf_te.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_intf_te.get_name_leafdata())
                            if (self.max_peer.is_set or self.max_peer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_peer.get_name_leafdata())
                            if (self.nsr_enabled.is_set or self.nsr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_enabled.get_name_leafdata())
                            if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                            if (self.protocol_version.is_set or self.protocol_version.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_version.get_name_leafdata())
                            if (self.role_is_active.is_set or self.role_is_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role_is_active.get_name_leafdata())
                            if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.router_id.get_name_leafdata())
                            if (self.session_hold_time.is_set or self.session_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_hold_time.get_name_leafdata())
                            if (self.targeted_hello_hold_time.is_set or self.targeted_hello_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_hold_time.get_name_leafdata())
                            if (self.targeted_hello_interval.is_set or self.targeted_hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_interval.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "address-family-parameter"):
                                for c in self.address_family_parameter:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.AddressFamilyParameter()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.address_family_parameter.append(c)
                                return c

                            if (child_yang_name == "graceful-restart-information"):
                                if (self.graceful_restart_information is None):
                                    self.graceful_restart_information = MplsLdp.Global_.Active.Vrfs.Vrf.Parameters.GracefulRestartInformation()
                                    self.graceful_restart_information.parent = self
                                    self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                                return self.graceful_restart_information

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "address-family-parameter" or name == "graceful-restart-information" or name == "af-binding-withdraw-delay" or name == "discovery-quick-start-disabled-on-interfaces" or name == "global-discovery-quick-start-disabled" or name == "global-md5-password-enabled" or name == "hello-hold-time" or name == "hello-interval" or name == "housekeeping-timer-interval" or name == "igp-sync-delay-time-for-interface" or name == "igp-sync-delay-time-on-restart" or name == "keepalive-interval" or name == "ldp-out-of-mem-state" or name == "ldp-recovery-timeout" or name == "le-no-route-timeout" or name == "max-intf-attached" or name == "max-intf-te" or name == "max-peer" or name == "nsr-enabled" or name == "nsr-synced" or name == "protocol-version" or name == "role-is-active" or name == "router-id" or name == "session-hold-time" or name == "targeted-hello-hold-time" or name == "targeted-hello-interval"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "af-binding-withdraw-delay"):
                                self.af_binding_withdraw_delay = value
                                self.af_binding_withdraw_delay.value_namespace = name_space
                                self.af_binding_withdraw_delay.value_namespace_prefix = name_space_prefix
                            if(value_path == "discovery-quick-start-disabled-on-interfaces"):
                                self.discovery_quick_start_disabled_on_interfaces = value
                                self.discovery_quick_start_disabled_on_interfaces.value_namespace = name_space
                                self.discovery_quick_start_disabled_on_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "global-discovery-quick-start-disabled"):
                                self.global_discovery_quick_start_disabled = value
                                self.global_discovery_quick_start_disabled.value_namespace = name_space
                                self.global_discovery_quick_start_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "global-md5-password-enabled"):
                                self.global_md5_password_enabled = value
                                self.global_md5_password_enabled.value_namespace = name_space
                                self.global_md5_password_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-hold-time"):
                                self.hello_hold_time = value
                                self.hello_hold_time.value_namespace = name_space
                                self.hello_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-interval"):
                                self.hello_interval = value
                                self.hello_interval.value_namespace = name_space
                                self.hello_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "housekeeping-timer-interval"):
                                self.housekeeping_timer_interval = value
                                self.housekeeping_timer_interval.value_namespace = name_space
                                self.housekeeping_timer_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-sync-delay-time-for-interface"):
                                self.igp_sync_delay_time_for_interface = value
                                self.igp_sync_delay_time_for_interface.value_namespace = name_space
                                self.igp_sync_delay_time_for_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-sync-delay-time-on-restart"):
                                self.igp_sync_delay_time_on_restart = value
                                self.igp_sync_delay_time_on_restart.value_namespace = name_space
                                self.igp_sync_delay_time_on_restart.value_namespace_prefix = name_space_prefix
                            if(value_path == "keepalive-interval"):
                                self.keepalive_interval = value
                                self.keepalive_interval.value_namespace = name_space
                                self.keepalive_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-out-of-mem-state"):
                                self.ldp_out_of_mem_state = value
                                self.ldp_out_of_mem_state.value_namespace = name_space
                                self.ldp_out_of_mem_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-recovery-timeout"):
                                self.ldp_recovery_timeout = value
                                self.ldp_recovery_timeout.value_namespace = name_space
                                self.ldp_recovery_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "le-no-route-timeout"):
                                self.le_no_route_timeout = value
                                self.le_no_route_timeout.value_namespace = name_space
                                self.le_no_route_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-intf-attached"):
                                self.max_intf_attached = value
                                self.max_intf_attached.value_namespace = name_space
                                self.max_intf_attached.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-intf-te"):
                                self.max_intf_te = value
                                self.max_intf_te.value_namespace = name_space
                                self.max_intf_te.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-peer"):
                                self.max_peer = value
                                self.max_peer.value_namespace = name_space
                                self.max_peer.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-enabled"):
                                self.nsr_enabled = value
                                self.nsr_enabled.value_namespace = name_space
                                self.nsr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-synced"):
                                self.nsr_synced = value
                                self.nsr_synced.value_namespace = name_space
                                self.nsr_synced.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-version"):
                                self.protocol_version = value
                                self.protocol_version.value_namespace = name_space
                                self.protocol_version.value_namespace_prefix = name_space_prefix
                            if(value_path == "role-is-active"):
                                self.role_is_active = value
                                self.role_is_active.value_namespace = name_space
                                self.role_is_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "router-id"):
                                self.router_id = value
                                self.router_id.value_namespace = name_space
                                self.router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-hold-time"):
                                self.session_hold_time = value
                                self.session_hold_time.value_namespace = name_space
                                self.session_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-hold-time"):
                                self.targeted_hello_hold_time = value
                                self.targeted_hello_hold_time.value_namespace = name_space
                                self.targeted_hello_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-interval"):
                                self.targeted_hello_interval = value
                                self.targeted_hello_interval.value_namespace = name_space
                                self.targeted_hello_interval.value_namespace_prefix = name_space_prefix


                    class Issu(Entity):
                        """
                        LDP ISSU related information
                        
                        .. attribute:: ha_statistics
                        
                        	LDP NSR Statistics related information
                        	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics>`
                        
                        .. attribute:: ha_summary
                        
                        	LDP HA Summary
                        	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu, self).__init__()

                            self.yang_name = "issu"
                            self.yang_parent_name = "vrf"

                            self.ha_statistics = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics()
                            self.ha_statistics.parent = self
                            self._children_name_map["ha_statistics"] = "ha-statistics"
                            self._children_yang_names.add("ha-statistics")

                            self.ha_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary()
                            self.ha_summary.parent = self
                            self._children_name_map["ha_summary"] = "ha-summary"
                            self._children_yang_names.add("ha-summary")


                        class HaSummary(Entity):
                            """
                            LDP HA Summary
                            
                            .. attribute:: sessions
                            
                            	Session summary
                            	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Sessions>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary, self).__init__()

                                self.yang_name = "ha-summary"
                                self.yang_parent_name = "issu"

                                self.sessions = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Sessions()
                                self.sessions.parent = self
                                self._children_name_map["sessions"] = "sessions"
                                self._children_yang_names.add("sessions")

                                self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "ha-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Sessions(Entity):
                                """
                                Session summary
                                
                                .. attribute:: nsr_eligible
                                
                                	NSR eligible sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_app_wait
                                
                                	Number of sessions in NSR app\-wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_none
                                
                                	Number of sessions in NSR none state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_operational
                                
                                	Number of sessions in NSR operational state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_prepare
                                
                                	Number of sessions in NSR prepare state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_ready
                                
                                	Number of sessions in NSR ready state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase1
                                
                                	Number of sessions in NSR TCP phase 1 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase2
                                
                                	Number of sessions in NSR TCP phase 2 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_wait
                                
                                	Number of sessions in NSR wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total
                                
                                	Total sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__init__()

                                    self.yang_name = "sessions"
                                    self.yang_parent_name = "ha-summary"

                                    self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                    self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                    self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                    self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                    self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                    self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                    self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                    self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                    self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                    self.total = YLeaf(YType.uint32, "total")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nsr_eligible",
                                                    "nsr_state_app_wait",
                                                    "nsr_state_none",
                                                    "nsr_state_operational",
                                                    "nsr_state_prepare",
                                                    "nsr_state_ready",
                                                    "nsr_state_tcp_phase1",
                                                    "nsr_state_tcp_phase2",
                                                    "nsr_state_wait",
                                                    "total") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nsr_eligible.is_set or
                                        self.nsr_state_app_wait.is_set or
                                        self.nsr_state_none.is_set or
                                        self.nsr_state_operational.is_set or
                                        self.nsr_state_prepare.is_set or
                                        self.nsr_state_ready.is_set or
                                        self.nsr_state_tcp_phase1.is_set or
                                        self.nsr_state_tcp_phase2.is_set or
                                        self.nsr_state_wait.is_set or
                                        self.total.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nsr_eligible.yfilter != YFilter.not_set or
                                        self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                        self.nsr_state_none.yfilter != YFilter.not_set or
                                        self.nsr_state_operational.yfilter != YFilter.not_set or
                                        self.nsr_state_prepare.yfilter != YFilter.not_set or
                                        self.nsr_state_ready.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                        self.nsr_state_wait.yfilter != YFilter.not_set or
                                        self.total.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sessions" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                    if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                    if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                    if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                    if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                    if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                    if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                    if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nsr-eligible"):
                                        self.nsr_eligible = value
                                        self.nsr_eligible.value_namespace = name_space
                                        self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-app-wait"):
                                        self.nsr_state_app_wait = value
                                        self.nsr_state_app_wait.value_namespace = name_space
                                        self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-none"):
                                        self.nsr_state_none = value
                                        self.nsr_state_none.value_namespace = name_space
                                        self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-operational"):
                                        self.nsr_state_operational = value
                                        self.nsr_state_operational.value_namespace = name_space
                                        self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-prepare"):
                                        self.nsr_state_prepare = value
                                        self.nsr_state_prepare.value_namespace = name_space
                                        self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-ready"):
                                        self.nsr_state_ready = value
                                        self.nsr_state_ready.value_namespace = name_space
                                        self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase1"):
                                        self.nsr_state_tcp_phase1 = value
                                        self.nsr_state_tcp_phase1.value_namespace = name_space
                                        self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase2"):
                                        self.nsr_state_tcp_phase2 = value
                                        self.nsr_state_tcp_phase2.value_namespace = name_space
                                        self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-wait"):
                                        self.nsr_state_wait = value
                                        self.nsr_state_wait.value_namespace = name_space
                                        self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total"):
                                        self.total = value
                                        self.total.value_namespace = name_space
                                        self.total.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sessions is not None and self.sessions.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sessions is not None and self.sessions.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sessions"):
                                    if (self.sessions is None):
                                        self.sessions = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Sessions()
                                        self.sessions.parent = self
                                        self._children_name_map["sessions"] = "sessions"
                                    return self.sessions

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sessions" or name == "vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaStatistics(Entity):
                            """
                            LDP NSR Statistics related information
                            
                            .. attribute:: ha_global
                            
                            	LDP NSR Global Statistics information
                            	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal>`
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics, self).__init__()

                                self.yang_name = "ha-statistics"
                                self.yang_parent_name = "issu"

                                self.ha_global = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal()
                                self.ha_global.parent = self
                                self._children_name_map["ha_global"] = "ha-global"
                                self._children_yang_names.add("ha-global")

                                self.ha_neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaGlobal(Entity):
                                """
                                LDP NSR Global Statistics information
                                
                                .. attribute:: init_sync
                                
                                	Init Sync
                                	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal, self).__init__()

                                    self.yang_name = "ha-global"
                                    self.yang_parent_name = "ha-statistics"

                                    self.init_sync = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync()
                                    self.init_sync.parent = self
                                    self._children_name_map["init_sync"] = "init-sync"
                                    self._children_yang_names.add("init-sync")


                                class InitSync(Entity):
                                    """
                                    Init Sync
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_default_mtu
                                    
                                    	default IPC MTU bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_exceeded_mtu_msg_cnt
                                    
                                    	ipc exceeded mtu msg cnt
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_max_rx_batch_bytes
                                    
                                    	biggest IPC RX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_max_tx_batch_bytes
                                    
                                    	biggest IPC TX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_rx_bytes
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_rx_cnt
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_tx_bytes
                                    
                                    	total IPC bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_tx_cnt
                                    
                                    	num IPC msgs sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_restart_cnt
                                    
                                    	number of times ipc has been restarted
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_tx_fail_cnt
                                    
                                    	number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_cfged
                                    
                                    	TRUE if NSR configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: nsr_synced
                                    
                                    	TRUE if NSR synced
                                    	**type**\:  bool
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Number of Rcvd Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Number of Sent Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of label bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl_adv
                                    
                                    	Num of lbl adv
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lcl_addr_wd
                                    
                                    	Num of lcl address withdraw
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_peers
                                    
                                    	Number of Peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_pfx
                                    
                                    	Number of binding prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_ipc_tx_fail_cnt
                                    
                                    	total number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__init__()

                                        self.yang_name = "init-sync"
                                        self.yang_parent_name = "ha-global"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                        self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                        self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                        self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                        self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                        self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                        self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                        self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                        self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                        self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                        self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                        self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                        self.num_peers = YLeaf(YType.uint32, "num-peers")

                                        self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                        self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "ipc_default_mtu",
                                                        "ipc_exceeded_mtu_msg_cnt",
                                                        "ipc_max_rx_batch_bytes",
                                                        "ipc_max_tx_batch_bytes",
                                                        "ipc_msg_rx_bytes",
                                                        "ipc_msg_rx_cnt",
                                                        "ipc_msg_tx_bytes",
                                                        "ipc_msg_tx_cnt",
                                                        "ipc_restart_cnt",
                                                        "ipc_tx_fail_cnt",
                                                        "nsr_cfged",
                                                        "nsr_synced",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_lbl",
                                                        "num_lbl_adv",
                                                        "num_lcl_addr_wd",
                                                        "num_peers",
                                                        "num_pfx",
                                                        "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.ipc_default_mtu.is_set or
                                            self.ipc_exceeded_mtu_msg_cnt.is_set or
                                            self.ipc_max_rx_batch_bytes.is_set or
                                            self.ipc_max_tx_batch_bytes.is_set or
                                            self.ipc_msg_rx_bytes.is_set or
                                            self.ipc_msg_rx_cnt.is_set or
                                            self.ipc_msg_tx_bytes.is_set or
                                            self.ipc_msg_tx_cnt.is_set or
                                            self.ipc_restart_cnt.is_set or
                                            self.ipc_tx_fail_cnt.is_set or
                                            self.nsr_cfged.is_set or
                                            self.nsr_synced.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_lbl.is_set or
                                            self.num_lbl_adv.is_set or
                                            self.num_lcl_addr_wd.is_set or
                                            self.num_peers.is_set or
                                            self.num_pfx.is_set or
                                            self.total_ipc_tx_fail_cnt.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.ipc_default_mtu.yfilter != YFilter.not_set or
                                            self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                            self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                            self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                            self.nsr_cfged.yfilter != YFilter.not_set or
                                            self.nsr_synced.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_lbl_adv.yfilter != YFilter.not_set or
                                            self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                            self.num_peers.yfilter != YFilter.not_set or
                                            self.num_pfx.yfilter != YFilter.not_set or
                                            self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                        if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                        if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                        if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                        if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                        if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                        if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                        if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                        if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_peers.get_name_leafdata())
                                        if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                        if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-default-mtu"):
                                            self.ipc_default_mtu = value
                                            self.ipc_default_mtu.value_namespace = name_space
                                            self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                            self.ipc_exceeded_mtu_msg_cnt = value
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-rx-batch-bytes"):
                                            self.ipc_max_rx_batch_bytes = value
                                            self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-tx-batch-bytes"):
                                            self.ipc_max_tx_batch_bytes = value
                                            self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-bytes"):
                                            self.ipc_msg_rx_bytes = value
                                            self.ipc_msg_rx_bytes.value_namespace = name_space
                                            self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-cnt"):
                                            self.ipc_msg_rx_cnt = value
                                            self.ipc_msg_rx_cnt.value_namespace = name_space
                                            self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-bytes"):
                                            self.ipc_msg_tx_bytes = value
                                            self.ipc_msg_tx_bytes.value_namespace = name_space
                                            self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-cnt"):
                                            self.ipc_msg_tx_cnt = value
                                            self.ipc_msg_tx_cnt.value_namespace = name_space
                                            self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-restart-cnt"):
                                            self.ipc_restart_cnt = value
                                            self.ipc_restart_cnt.value_namespace = name_space
                                            self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-tx-fail-cnt"):
                                            self.ipc_tx_fail_cnt = value
                                            self.ipc_tx_fail_cnt.value_namespace = name_space
                                            self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-cfged"):
                                            self.nsr_cfged = value
                                            self.nsr_cfged.value_namespace = name_space
                                            self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-synced"):
                                            self.nsr_synced = value
                                            self.nsr_synced.value_namespace = name_space
                                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl-adv"):
                                            self.num_lbl_adv = value
                                            self.num_lbl_adv.value_namespace = name_space
                                            self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lcl-addr-wd"):
                                            self.num_lcl_addr_wd = value
                                            self.num_lcl_addr_wd.value_namespace = name_space
                                            self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-peers"):
                                            self.num_peers = value
                                            self.num_peers.value_namespace = name_space
                                            self.num_peers.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-pfx"):
                                            self.num_pfx = value
                                            self.num_pfx.value_namespace = name_space
                                            self.num_pfx.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-ipc-tx-fail-cnt"):
                                            self.total_ipc_tx_fail_cnt = value
                                            self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                            self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.init_sync is not None and self.init_sync.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.init_sync is not None and self.init_sync.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync"):
                                        if (self.init_sync is None):
                                            self.init_sync = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync()
                                            self.init_sync.parent = self
                                            self._children_name_map["init_sync"] = "init-sync"
                                        return self.init_sync

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "ha-statistics"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.ha_global is not None and self.ha_global.has_data()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_global is not None and self.ha_global.has_operation()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-global"):
                                    if (self.ha_global is None):
                                        self.ha_global = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaGlobal()
                                        self.ha_global.parent = self
                                        self._children_name_map["ha_global"] = "ha-global"
                                    return self.ha_global

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-global" or name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                                (self.ha_summary is not None and self.ha_summary.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                                (self.ha_summary is not None and self.ha_summary.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "issu" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-statistics"):
                                if (self.ha_statistics is None):
                                    self.ha_statistics = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaStatistics()
                                    self.ha_statistics.parent = self
                                    self._children_name_map["ha_statistics"] = "ha-statistics"
                                return self.ha_statistics

                            if (child_yang_name == "ha-summary"):
                                if (self.ha_summary is None):
                                    self.ha_summary = MplsLdp.Global_.Active.Vrfs.Vrf.Issu.HaSummary()
                                    self.ha_summary.parent = self
                                    self._children_name_map["ha_summary"] = "ha-summary"
                                return self.ha_summary

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-statistics" or name == "ha-summary"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborCapabilities(Entity):
                        """
                        LDP Neighbors Capabilities
                        
                        .. attribute:: neighbor_capability
                        
                        	Information on capabilities of a particular LDP neighbor
                        	**type**\: list of    :py:class:`NeighborCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities, self).__init__()

                            self.yang_name = "neighbor-capabilities"
                            self.yang_parent_name = "vrf"

                            self.neighbor_capability = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities, self).__setattr__(name, value)


                        class NeighborCapability(Entity):
                            """
                            Information on capabilities of a particular LDP
                            neighbor
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: received
                            
                            	List of received capabilities
                            	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received>`
                            
                            .. attribute:: sent
                            
                            	List of sent capabilities
                            	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__init__()

                                self.yang_name = "neighbor-capability"
                                self.yang_parent_name = "neighbor-capabilities"

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.received = YList(self)
                                self.sent = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)


                            class Sent(Entity):
                                """
                                List of sent capabilities
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__init__()

                                    self.yang_name = "sent"
                                    self.yang_parent_name = "neighbor-capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sent" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class Received(Entity):
                                """
                                List of received capabilities
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__init__()

                                    self.yang_name = "received"
                                    self.yang_parent_name = "neighbor-capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "received" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.received:
                                    if (c.has_data()):
                                        return True
                                for c in self.sent:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set)

                            def has_operation(self):
                                for c in self.received:
                                    if (c.has_operation()):
                                        return True
                                for c in self.sent:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-capability" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "received"):
                                    for c in self.received:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.received.append(c)
                                    return c

                                if (child_yang_name == "sent"):
                                    for c in self.sent:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sent.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "received" or name == "sent" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor_capability:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor_capability:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-capabilities" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-capability"):
                                for c in self.neighbor_capability:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities.NeighborCapability()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor_capability.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Neighbors(Entity):
                        """
                        The LDP Neighbors
                        
                        .. attribute:: neighbor
                        
                        	Information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors, self).__init__()

                            self.yang_name = "neighbors"
                            self.yang_parent_name = "vrf"

                            self.neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors, self).__setattr__(name, value)


                        class Neighbor(Entity):
                            """
                            Information on a particular LDP neighbor
                            
                            .. attribute:: detailed_information
                            
                            	Detailed information with regards to holdtime, KA, inbound filtering, and Session protection
                            	**type**\:   :py:class:`DetailedInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation>`
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: ldp_nbr_bound_ipv4_address_info
                            
                            	Neighbor IPv4 Address Info
                            	**type**\: list of    :py:class:`LdpNbrBoundIpv4AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo>`
                            
                            .. attribute:: ldp_nbr_bound_ipv6_address_info
                            
                            	Neighbor IPv6 Address Info
                            	**type**\: list of    :py:class:`LdpNbrBoundIpv6AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo>`
                            
                            .. attribute:: ldp_nbr_ipv4_adj_info
                            
                            	Neighbor's IPv4 Adjacency Information
                            	**type**\: list of    :py:class:`LdpNbrIpv4AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo>`
                            
                            .. attribute:: ldp_nbr_ipv6_adj_info
                            
                            	Neighbor's IPv6 Adjacency Information
                            	**type**\: list of    :py:class:`LdpNbrIpv6AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo>`
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: protocol_information
                            
                            	Protocol Information
                            	**type**\:   :py:class:`ProtocolInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation>`
                            
                            .. attribute:: tcp_information
                            
                            	TCP Information
                            	**type**\:   :py:class:`TcpInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor, self).__init__()

                                self.yang_name = "neighbor"
                                self.yang_parent_name = "neighbors"

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.detailed_information = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation()
                                self.detailed_information.parent = self
                                self._children_name_map["detailed_information"] = "detailed-information"
                                self._children_yang_names.add("detailed-information")

                                self.protocol_information = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation()
                                self.protocol_information.parent = self
                                self._children_name_map["protocol_information"] = "protocol-information"
                                self._children_yang_names.add("protocol-information")

                                self.tcp_information = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation()
                                self.tcp_information.parent = self
                                self._children_name_map["tcp_information"] = "tcp-information"
                                self._children_yang_names.add("tcp-information")

                                self.ldp_nbr_bound_ipv4_address_info = YList(self)
                                self.ldp_nbr_bound_ipv6_address_info = YList(self)
                                self.ldp_nbr_ipv4_adj_info = YList(self)
                                self.ldp_nbr_ipv6_adj_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor, self).__setattr__(name, value)


                            class ProtocolInformation(Entity):
                                """
                                Protocol Information
                                
                                .. attribute:: downstream_on_demand
                                
                                	Is Label advertisment mode in Downstream On Demand mode or Not
                                	**type**\:  bool
                                
                                .. attribute:: ta_graceful_restart_adjacency
                                
                                	Graceful restart information
                                	**type**\:   :py:class:`TaGracefulRestartAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency>`
                                
                                .. attribute:: ta_holdtime
                                
                                	Session holdtime in sec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_pies_rcvd
                                
                                	Number of pies received
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_pies_sent
                                
                                	Number of pies sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_state
                                
                                	State
                                	**type**\:  str
                                
                                .. attribute:: ta_up_time_seconds
                                
                                	Up time in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__init__()

                                    self.yang_name = "protocol-information"
                                    self.yang_parent_name = "neighbor"

                                    self.downstream_on_demand = YLeaf(YType.boolean, "downstream-on-demand")

                                    self.ta_holdtime = YLeaf(YType.uint32, "ta-holdtime")

                                    self.ta_pies_rcvd = YLeaf(YType.uint32, "ta-pies-rcvd")

                                    self.ta_pies_sent = YLeaf(YType.uint32, "ta-pies-sent")

                                    self.ta_state = YLeaf(YType.str, "ta-state")

                                    self.ta_up_time_seconds = YLeaf(YType.uint32, "ta-up-time-seconds")

                                    self.ta_graceful_restart_adjacency = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                    self.ta_graceful_restart_adjacency.parent = self
                                    self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                    self._children_yang_names.add("ta-graceful-restart-adjacency")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("downstream_on_demand",
                                                    "ta_holdtime",
                                                    "ta_pies_rcvd",
                                                    "ta_pies_sent",
                                                    "ta_state",
                                                    "ta_up_time_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)


                                class TaGracefulRestartAdjacency(Entity):
                                    """
                                    Graceful restart information
                                    
                                    .. attribute:: is_graceful_restartable
                                    
                                    	Is graceful restartable
                                    	**type**\:  bool
                                    
                                    .. attribute:: reconnect_timeout
                                    
                                    	Reconnect timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: recovery_time
                                    
                                    	Recovery time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__init__()

                                        self.yang_name = "ta-graceful-restart-adjacency"
                                        self.yang_parent_name = "protocol-information"

                                        self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                        self.reconnect_timeout = YLeaf(YType.uint32, "reconnect-timeout")

                                        self.recovery_time = YLeaf(YType.uint32, "recovery-time")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_graceful_restartable",
                                                        "reconnect_timeout",
                                                        "recovery_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_graceful_restartable.is_set or
                                            self.reconnect_timeout.is_set or
                                            self.recovery_time.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_graceful_restartable.yfilter != YFilter.not_set or
                                            self.reconnect_timeout.yfilter != YFilter.not_set or
                                            self.recovery_time.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ta-graceful-restart-adjacency" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                        if (self.reconnect_timeout.is_set or self.reconnect_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reconnect_timeout.get_name_leafdata())
                                        if (self.recovery_time.is_set or self.recovery_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.recovery_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-graceful-restartable" or name == "reconnect-timeout" or name == "recovery-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-graceful-restartable"):
                                            self.is_graceful_restartable = value
                                            self.is_graceful_restartable.value_namespace = name_space
                                            self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reconnect-timeout"):
                                            self.reconnect_timeout = value
                                            self.reconnect_timeout.value_namespace = name_space
                                            self.reconnect_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "recovery-time"):
                                            self.recovery_time = value
                                            self.recovery_time.value_namespace = name_space
                                            self.recovery_time.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.downstream_on_demand.is_set or
                                        self.ta_holdtime.is_set or
                                        self.ta_pies_rcvd.is_set or
                                        self.ta_pies_sent.is_set or
                                        self.ta_state.is_set or
                                        self.ta_up_time_seconds.is_set or
                                        (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.downstream_on_demand.yfilter != YFilter.not_set or
                                        self.ta_holdtime.yfilter != YFilter.not_set or
                                        self.ta_pies_rcvd.yfilter != YFilter.not_set or
                                        self.ta_pies_sent.yfilter != YFilter.not_set or
                                        self.ta_state.yfilter != YFilter.not_set or
                                        self.ta_up_time_seconds.yfilter != YFilter.not_set or
                                        (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protocol-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.downstream_on_demand.is_set or self.downstream_on_demand.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.downstream_on_demand.get_name_leafdata())
                                    if (self.ta_holdtime.is_set or self.ta_holdtime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_holdtime.get_name_leafdata())
                                    if (self.ta_pies_rcvd.is_set or self.ta_pies_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_pies_rcvd.get_name_leafdata())
                                    if (self.ta_pies_sent.is_set or self.ta_pies_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_pies_sent.get_name_leafdata())
                                    if (self.ta_state.is_set or self.ta_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_state.get_name_leafdata())
                                    if (self.ta_up_time_seconds.is_set or self.ta_up_time_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_up_time_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ta-graceful-restart-adjacency"):
                                        if (self.ta_graceful_restart_adjacency is None):
                                            self.ta_graceful_restart_adjacency = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                            self.ta_graceful_restart_adjacency.parent = self
                                            self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                        return self.ta_graceful_restart_adjacency

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ta-graceful-restart-adjacency" or name == "downstream-on-demand" or name == "ta-holdtime" or name == "ta-pies-rcvd" or name == "ta-pies-sent" or name == "ta-state" or name == "ta-up-time-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "downstream-on-demand"):
                                        self.downstream_on_demand = value
                                        self.downstream_on_demand.value_namespace = name_space
                                        self.downstream_on_demand.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-holdtime"):
                                        self.ta_holdtime = value
                                        self.ta_holdtime.value_namespace = name_space
                                        self.ta_holdtime.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-pies-rcvd"):
                                        self.ta_pies_rcvd = value
                                        self.ta_pies_rcvd.value_namespace = name_space
                                        self.ta_pies_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-pies-sent"):
                                        self.ta_pies_sent = value
                                        self.ta_pies_sent.value_namespace = name_space
                                        self.ta_pies_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-state"):
                                        self.ta_state = value
                                        self.ta_state.value_namespace = name_space
                                        self.ta_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-up-time-seconds"):
                                        self.ta_up_time_seconds = value
                                        self.ta_up_time_seconds.value_namespace = name_space
                                        self.ta_up_time_seconds.value_namespace_prefix = name_space_prefix


                            class TcpInformation(Entity):
                                """
                                TCP Information
                                
                                .. attribute:: foreign_host
                                
                                	Foreign host address
                                	**type**\:   :py:class:`ForeignHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost>`
                                
                                .. attribute:: foreign_port
                                
                                	Foreign port number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: is_md5_on
                                
                                	Is MD5 Digest on
                                	**type**\:  bool
                                
                                .. attribute:: local_host
                                
                                	Local host address
                                	**type**\:   :py:class:`LocalHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost>`
                                
                                .. attribute:: local_port
                                
                                	Local port number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__init__()

                                    self.yang_name = "tcp-information"
                                    self.yang_parent_name = "neighbor"

                                    self.foreign_port = YLeaf(YType.uint16, "foreign-port")

                                    self.is_md5_on = YLeaf(YType.boolean, "is-md5-on")

                                    self.local_port = YLeaf(YType.uint16, "local-port")

                                    self.foreign_host = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                    self.foreign_host.parent = self
                                    self._children_name_map["foreign_host"] = "foreign-host"
                                    self._children_yang_names.add("foreign-host")

                                    self.local_host = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                    self.local_host.parent = self
                                    self._children_name_map["local_host"] = "local-host"
                                    self._children_yang_names.add("local-host")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("foreign_port",
                                                    "is_md5_on",
                                                    "local_port") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)


                                class ForeignHost(Entity):
                                    """
                                    Foreign host address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__init__()

                                        self.yang_name = "foreign-host"
                                        self.yang_parent_name = "tcp-information"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "foreign-host" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class LocalHost(Entity):
                                    """
                                    Local host address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__init__()

                                        self.yang_name = "local-host"
                                        self.yang_parent_name = "tcp-information"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "local-host" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.foreign_port.is_set or
                                        self.is_md5_on.is_set or
                                        self.local_port.is_set or
                                        (self.foreign_host is not None and self.foreign_host.has_data()) or
                                        (self.local_host is not None and self.local_host.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.foreign_port.yfilter != YFilter.not_set or
                                        self.is_md5_on.yfilter != YFilter.not_set or
                                        self.local_port.yfilter != YFilter.not_set or
                                        (self.foreign_host is not None and self.foreign_host.has_operation()) or
                                        (self.local_host is not None and self.local_host.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tcp-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.foreign_port.is_set or self.foreign_port.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.foreign_port.get_name_leafdata())
                                    if (self.is_md5_on.is_set or self.is_md5_on.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_md5_on.get_name_leafdata())
                                    if (self.local_port.is_set or self.local_port.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_port.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "foreign-host"):
                                        if (self.foreign_host is None):
                                            self.foreign_host = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                            self.foreign_host.parent = self
                                            self._children_name_map["foreign_host"] = "foreign-host"
                                        return self.foreign_host

                                    if (child_yang_name == "local-host"):
                                        if (self.local_host is None):
                                            self.local_host = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                            self.local_host.parent = self
                                            self._children_name_map["local_host"] = "local-host"
                                        return self.local_host

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "foreign-host" or name == "local-host" or name == "foreign-port" or name == "is-md5-on" or name == "local-port"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "foreign-port"):
                                        self.foreign_port = value
                                        self.foreign_port.value_namespace = name_space
                                        self.foreign_port.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-md5-on"):
                                        self.is_md5_on = value
                                        self.is_md5_on.value_namespace = name_space
                                        self.is_md5_on.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-port"):
                                        self.local_port = value
                                        self.local_port.value_namespace = name_space
                                        self.local_port.value_namespace_prefix = name_space_prefix


                            class DetailedInformation(Entity):
                                """
                                Detailed information with regards to holdtime,
                                KA, inbound filtering, and Session protection
                                
                                .. attribute:: advertise_bgp_prefixes
                                
                                	Is BGP labelled prefixes advertised to the neighbor
                                	**type**\:  bool
                                
                                .. attribute:: bgp_advertisement_state
                                
                                	BGP labelled prefixes advertisement state
                                	**type**\:   :py:class:`MgmtLdpNbrBgpAdvtState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNbrBgpAdvtState>`
                                
                                .. attribute:: capabilities
                                
                                	Capabilities sent to and received from neighbor
                                	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities>`
                                
                                .. attribute:: client
                                
                                	Targeted Session clients
                                	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client>`
                                
                                .. attribute:: has_ipv4_inbound
                                
                                	IPv4 Inbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv4_outbound
                                
                                	IPv4 Outbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv6_inbound
                                
                                	IPv6 Inbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv6_outbound
                                
                                	IPv6 Outbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_sp
                                
                                	Session Protection enabled
                                	**type**\:  bool
                                
                                .. attribute:: inbound_ipv4acl
                                
                                	IPv4 Inbound accept ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: inbound_ipv6acl
                                
                                	IPv6 Inbound accept ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: ipv4_duplicate_address
                                
                                	Duplicate IPv4 address bound to this peer
                                	**type**\: list of    :py:class:`Ipv4DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress>`
                                
                                .. attribute:: ipv6_duplicate_address
                                
                                	Duplicate IPv6 address bound to this peer
                                	**type**\: list of    :py:class:`Ipv6DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress>`
                                
                                .. attribute:: keep_alive_interval
                                
                                	Session keepalive interval in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: nsr_last_sync_error
                                
                                	Last NSR sync error
                                	**type**\:   :py:class:`MgmtLdpNsrPeerSyncErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncErr>`
                                
                                .. attribute:: nsr_last_sync_nack_reason
                                
                                	Last NSR sync NACK reaston
                                	**type**\:   :py:class:`MgmtLdpNsrPeerLdpSyncNackRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerLdpSyncNackRsn>`
                                
                                .. attribute:: nsr_sync_state
                                
                                	NSR Sync State
                                	**type**\:   :py:class:`MgmtLdpNsrPeerSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncState>`
                                
                                .. attribute:: outbound_ipv4acl
                                
                                	IPv4 Outbound advertise ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: outbound_ipv6acl
                                
                                	IPv6 Outbound advertise ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: peer_holdtime
                                
                                	Session holdtime value in seconds from the peer
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: peer_state
                                
                                	Peer state
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: sp_duration
                                
                                	Session protection holdup time duration in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: sp_has_acl
                                
                                	Session protection ACL is present
                                	**type**\:  bool
                                
                                .. attribute:: sp_has_duration
                                
                                	Session Protection has non\-default duration
                                	**type**\:  bool
                                
                                .. attribute:: sp_state
                                
                                	Session Protection state
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: spacl
                                
                                	Session Protection ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: spht_remaining
                                
                                	Session Protection holdup time remaining value in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: spht_running
                                
                                	Session Protection holdup timer is running
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__init__()

                                    self.yang_name = "detailed-information"
                                    self.yang_parent_name = "neighbor"

                                    self.advertise_bgp_prefixes = YLeaf(YType.boolean, "advertise-bgp-prefixes")

                                    self.bgp_advertisement_state = YLeaf(YType.enumeration, "bgp-advertisement-state")

                                    self.has_ipv4_inbound = YLeaf(YType.boolean, "has-ipv4-inbound")

                                    self.has_ipv4_outbound = YLeaf(YType.boolean, "has-ipv4-outbound")

                                    self.has_ipv6_inbound = YLeaf(YType.boolean, "has-ipv6-inbound")

                                    self.has_ipv6_outbound = YLeaf(YType.boolean, "has-ipv6-outbound")

                                    self.has_sp = YLeaf(YType.boolean, "has-sp")

                                    self.inbound_ipv4acl = YLeaf(YType.str, "inbound-ipv4acl")

                                    self.inbound_ipv6acl = YLeaf(YType.str, "inbound-ipv6acl")

                                    self.keep_alive_interval = YLeaf(YType.uint32, "keep-alive-interval")

                                    self.nsr_last_sync_error = YLeaf(YType.enumeration, "nsr-last-sync-error")

                                    self.nsr_last_sync_nack_reason = YLeaf(YType.enumeration, "nsr-last-sync-nack-reason")

                                    self.nsr_sync_state = YLeaf(YType.enumeration, "nsr-sync-state")

                                    self.outbound_ipv4acl = YLeaf(YType.str, "outbound-ipv4acl")

                                    self.outbound_ipv6acl = YLeaf(YType.str, "outbound-ipv6acl")

                                    self.peer_holdtime = YLeaf(YType.uint32, "peer-holdtime")

                                    self.peer_state = YLeaf(YType.str, "peer-state")

                                    self.sp_duration = YLeaf(YType.uint32, "sp-duration")

                                    self.sp_has_acl = YLeaf(YType.boolean, "sp-has-acl")

                                    self.sp_has_duration = YLeaf(YType.boolean, "sp-has-duration")

                                    self.sp_state = YLeaf(YType.str, "sp-state")

                                    self.spacl = YLeaf(YType.str, "spacl")

                                    self.spht_remaining = YLeaf(YType.uint32, "spht-remaining")

                                    self.spht_running = YLeaf(YType.boolean, "spht-running")

                                    self.capabilities = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                    self.capabilities.parent = self
                                    self._children_name_map["capabilities"] = "capabilities"
                                    self._children_yang_names.add("capabilities")

                                    self.client = YList(self)
                                    self.ipv4_duplicate_address = YList(self)
                                    self.ipv6_duplicate_address = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("advertise_bgp_prefixes",
                                                    "bgp_advertisement_state",
                                                    "has_ipv4_inbound",
                                                    "has_ipv4_outbound",
                                                    "has_ipv6_inbound",
                                                    "has_ipv6_outbound",
                                                    "has_sp",
                                                    "inbound_ipv4acl",
                                                    "inbound_ipv6acl",
                                                    "keep_alive_interval",
                                                    "nsr_last_sync_error",
                                                    "nsr_last_sync_nack_reason",
                                                    "nsr_sync_state",
                                                    "outbound_ipv4acl",
                                                    "outbound_ipv6acl",
                                                    "peer_holdtime",
                                                    "peer_state",
                                                    "sp_duration",
                                                    "sp_has_acl",
                                                    "sp_has_duration",
                                                    "sp_state",
                                                    "spacl",
                                                    "spht_remaining",
                                                    "spht_running") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)


                                class Capabilities(Entity):
                                    """
                                    Capabilities sent to and received from neighbor
                                    
                                    .. attribute:: received
                                    
                                    	List of received capabilities
                                    	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received>`
                                    
                                    .. attribute:: sent
                                    
                                    	List of sent capabilities
                                    	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__init__()

                                        self.yang_name = "capabilities"
                                        self.yang_parent_name = "detailed-information"

                                        self.received = YList(self)
                                        self.sent = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)


                                    class Sent(Entity):
                                        """
                                        List of sent capabilities
                                        
                                        .. attribute:: capability_data
                                        
                                        	Capability data
                                        	**type**\:  str
                                        
                                        .. attribute:: capability_data_length
                                        
                                        	Capability data length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: description
                                        
                                        	Capability description
                                        	**type**\:  str
                                        
                                        	**length:** 0..80
                                        
                                        .. attribute:: type
                                        
                                        	Capability type (IANA assigned)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__init__()

                                            self.yang_name = "sent"
                                            self.yang_parent_name = "capabilities"

                                            self.capability_data = YLeaf(YType.str, "capability-data")

                                            self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                            self.description = YLeaf(YType.str, "description")

                                            self.type = YLeaf(YType.uint16, "type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("capability_data",
                                                            "capability_data_length",
                                                            "description",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.capability_data.is_set or
                                                self.capability_data_length.is_set or
                                                self.description.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.capability_data.yfilter != YFilter.not_set or
                                                self.capability_data_length.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "sent" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data.get_name_leafdata())
                                            if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "capability-data"):
                                                self.capability_data = value
                                                self.capability_data.value_namespace = name_space
                                                self.capability_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "capability-data-length"):
                                                self.capability_data_length = value
                                                self.capability_data_length.value_namespace = name_space
                                                self.capability_data_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix


                                    class Received(Entity):
                                        """
                                        List of received capabilities
                                        
                                        .. attribute:: capability_data
                                        
                                        	Capability data
                                        	**type**\:  str
                                        
                                        .. attribute:: capability_data_length
                                        
                                        	Capability data length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: description
                                        
                                        	Capability description
                                        	**type**\:  str
                                        
                                        	**length:** 0..80
                                        
                                        .. attribute:: type
                                        
                                        	Capability type (IANA assigned)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__init__()

                                            self.yang_name = "received"
                                            self.yang_parent_name = "capabilities"

                                            self.capability_data = YLeaf(YType.str, "capability-data")

                                            self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                            self.description = YLeaf(YType.str, "description")

                                            self.type = YLeaf(YType.uint16, "type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("capability_data",
                                                            "capability_data_length",
                                                            "description",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.capability_data.is_set or
                                                self.capability_data_length.is_set or
                                                self.description.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.capability_data.yfilter != YFilter.not_set or
                                                self.capability_data_length.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "received" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data.get_name_leafdata())
                                            if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "capability-data"):
                                                self.capability_data = value
                                                self.capability_data.value_namespace = name_space
                                                self.capability_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "capability-data-length"):
                                                self.capability_data_length = value
                                                self.capability_data_length.value_namespace = name_space
                                                self.capability_data_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.received:
                                            if (c.has_data()):
                                                return True
                                        for c in self.sent:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.received:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.sent:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "capabilities" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "received"):
                                            for c in self.received:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.received.append(c)
                                            return c

                                        if (child_yang_name == "sent"):
                                            for c in self.sent:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.sent.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "received" or name == "sent"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Client(Entity):
                                    """
                                    Targeted Session clients
                                    
                                    .. attribute:: name
                                    
                                    	Client's name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__init__()

                                        self.yang_name = "client"
                                        self.yang_parent_name = "detailed-information"

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.name.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "client" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class Ipv4DuplicateAddress(Entity):
                                    """
                                    Duplicate IPv4 address bound to this peer
                                    
                                    .. attribute:: address
                                    
                                    	Neighbor Address
                                    	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress, self).__init__()

                                        self.yang_name = "ipv4-duplicate-address"
                                        self.yang_parent_name = "detailed-information"

                                        self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                        self._children_yang_names.add("address")


                                    class Address(Entity):
                                        """
                                        Neighbor Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__init__()

                                            self.yang_name = "address"
                                            self.yang_parent_name = "ipv4-duplicate-address"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.address is not None and self.address.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.address is not None and self.address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-duplicate-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "address"):
                                            if (self.address is None):
                                                self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                                self.address.parent = self
                                                self._children_name_map["address"] = "address"
                                            return self.address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Ipv6DuplicateAddress(Entity):
                                    """
                                    Duplicate IPv6 address bound to this peer
                                    
                                    .. attribute:: address
                                    
                                    	Neighbor Address
                                    	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress, self).__init__()

                                        self.yang_name = "ipv6-duplicate-address"
                                        self.yang_parent_name = "detailed-information"

                                        self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                        self._children_yang_names.add("address")


                                    class Address(Entity):
                                        """
                                        Neighbor Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__init__()

                                            self.yang_name = "address"
                                            self.yang_parent_name = "ipv6-duplicate-address"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.address is not None and self.address.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.address is not None and self.address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-duplicate-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "address"):
                                            if (self.address is None):
                                                self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                                self.address.parent = self
                                                self._children_name_map["address"] = "address"
                                            return self.address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    for c in self.client:
                                        if (c.has_data()):
                                            return True
                                    for c in self.ipv4_duplicate_address:
                                        if (c.has_data()):
                                            return True
                                    for c in self.ipv6_duplicate_address:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.advertise_bgp_prefixes.is_set or
                                        self.bgp_advertisement_state.is_set or
                                        self.has_ipv4_inbound.is_set or
                                        self.has_ipv4_outbound.is_set or
                                        self.has_ipv6_inbound.is_set or
                                        self.has_ipv6_outbound.is_set or
                                        self.has_sp.is_set or
                                        self.inbound_ipv4acl.is_set or
                                        self.inbound_ipv6acl.is_set or
                                        self.keep_alive_interval.is_set or
                                        self.nsr_last_sync_error.is_set or
                                        self.nsr_last_sync_nack_reason.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.outbound_ipv4acl.is_set or
                                        self.outbound_ipv6acl.is_set or
                                        self.peer_holdtime.is_set or
                                        self.peer_state.is_set or
                                        self.sp_duration.is_set or
                                        self.sp_has_acl.is_set or
                                        self.sp_has_duration.is_set or
                                        self.sp_state.is_set or
                                        self.spacl.is_set or
                                        self.spht_remaining.is_set or
                                        self.spht_running.is_set or
                                        (self.capabilities is not None and self.capabilities.has_data()))

                                def has_operation(self):
                                    for c in self.client:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.ipv4_duplicate_address:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.ipv6_duplicate_address:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.advertise_bgp_prefixes.yfilter != YFilter.not_set or
                                        self.bgp_advertisement_state.yfilter != YFilter.not_set or
                                        self.has_ipv4_inbound.yfilter != YFilter.not_set or
                                        self.has_ipv4_outbound.yfilter != YFilter.not_set or
                                        self.has_ipv6_inbound.yfilter != YFilter.not_set or
                                        self.has_ipv6_outbound.yfilter != YFilter.not_set or
                                        self.has_sp.yfilter != YFilter.not_set or
                                        self.inbound_ipv4acl.yfilter != YFilter.not_set or
                                        self.inbound_ipv6acl.yfilter != YFilter.not_set or
                                        self.keep_alive_interval.yfilter != YFilter.not_set or
                                        self.nsr_last_sync_error.yfilter != YFilter.not_set or
                                        self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.outbound_ipv4acl.yfilter != YFilter.not_set or
                                        self.outbound_ipv6acl.yfilter != YFilter.not_set or
                                        self.peer_holdtime.yfilter != YFilter.not_set or
                                        self.peer_state.yfilter != YFilter.not_set or
                                        self.sp_duration.yfilter != YFilter.not_set or
                                        self.sp_has_acl.yfilter != YFilter.not_set or
                                        self.sp_has_duration.yfilter != YFilter.not_set or
                                        self.sp_state.yfilter != YFilter.not_set or
                                        self.spacl.yfilter != YFilter.not_set or
                                        self.spht_remaining.yfilter != YFilter.not_set or
                                        self.spht_running.yfilter != YFilter.not_set or
                                        (self.capabilities is not None and self.capabilities.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "detailed-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.advertise_bgp_prefixes.is_set or self.advertise_bgp_prefixes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_bgp_prefixes.get_name_leafdata())
                                    if (self.bgp_advertisement_state.is_set or self.bgp_advertisement_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bgp_advertisement_state.get_name_leafdata())
                                    if (self.has_ipv4_inbound.is_set or self.has_ipv4_inbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv4_inbound.get_name_leafdata())
                                    if (self.has_ipv4_outbound.is_set or self.has_ipv4_outbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv4_outbound.get_name_leafdata())
                                    if (self.has_ipv6_inbound.is_set or self.has_ipv6_inbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv6_inbound.get_name_leafdata())
                                    if (self.has_ipv6_outbound.is_set or self.has_ipv6_outbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv6_outbound.get_name_leafdata())
                                    if (self.has_sp.is_set or self.has_sp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_sp.get_name_leafdata())
                                    if (self.inbound_ipv4acl.is_set or self.inbound_ipv4acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inbound_ipv4acl.get_name_leafdata())
                                    if (self.inbound_ipv6acl.is_set or self.inbound_ipv6acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inbound_ipv6acl.get_name_leafdata())
                                    if (self.keep_alive_interval.is_set or self.keep_alive_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_interval.get_name_leafdata())
                                    if (self.nsr_last_sync_error.is_set or self.nsr_last_sync_error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_last_sync_error.get_name_leafdata())
                                    if (self.nsr_last_sync_nack_reason.is_set or self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_last_sync_nack_reason.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.outbound_ipv4acl.is_set or self.outbound_ipv4acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outbound_ipv4acl.get_name_leafdata())
                                    if (self.outbound_ipv6acl.is_set or self.outbound_ipv6acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outbound_ipv6acl.get_name_leafdata())
                                    if (self.peer_holdtime.is_set or self.peer_holdtime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_holdtime.get_name_leafdata())
                                    if (self.peer_state.is_set or self.peer_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_state.get_name_leafdata())
                                    if (self.sp_duration.is_set or self.sp_duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_duration.get_name_leafdata())
                                    if (self.sp_has_acl.is_set or self.sp_has_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_has_acl.get_name_leafdata())
                                    if (self.sp_has_duration.is_set or self.sp_has_duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_has_duration.get_name_leafdata())
                                    if (self.sp_state.is_set or self.sp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_state.get_name_leafdata())
                                    if (self.spacl.is_set or self.spacl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spacl.get_name_leafdata())
                                    if (self.spht_remaining.is_set or self.spht_remaining.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spht_remaining.get_name_leafdata())
                                    if (self.spht_running.is_set or self.spht_running.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spht_running.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "capabilities"):
                                        if (self.capabilities is None):
                                            self.capabilities = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                            self.capabilities.parent = self
                                            self._children_name_map["capabilities"] = "capabilities"
                                        return self.capabilities

                                    if (child_yang_name == "client"):
                                        for c in self.client:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.client.append(c)
                                        return c

                                    if (child_yang_name == "ipv4-duplicate-address"):
                                        for c in self.ipv4_duplicate_address:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ipv4_duplicate_address.append(c)
                                        return c

                                    if (child_yang_name == "ipv6-duplicate-address"):
                                        for c in self.ipv6_duplicate_address:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ipv6_duplicate_address.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capabilities" or name == "client" or name == "ipv4-duplicate-address" or name == "ipv6-duplicate-address" or name == "advertise-bgp-prefixes" or name == "bgp-advertisement-state" or name == "has-ipv4-inbound" or name == "has-ipv4-outbound" or name == "has-ipv6-inbound" or name == "has-ipv6-outbound" or name == "has-sp" or name == "inbound-ipv4acl" or name == "inbound-ipv6acl" or name == "keep-alive-interval" or name == "nsr-last-sync-error" or name == "nsr-last-sync-nack-reason" or name == "nsr-sync-state" or name == "outbound-ipv4acl" or name == "outbound-ipv6acl" or name == "peer-holdtime" or name == "peer-state" or name == "sp-duration" or name == "sp-has-acl" or name == "sp-has-duration" or name == "sp-state" or name == "spacl" or name == "spht-remaining" or name == "spht-running"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "advertise-bgp-prefixes"):
                                        self.advertise_bgp_prefixes = value
                                        self.advertise_bgp_prefixes.value_namespace = name_space
                                        self.advertise_bgp_prefixes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "bgp-advertisement-state"):
                                        self.bgp_advertisement_state = value
                                        self.bgp_advertisement_state.value_namespace = name_space
                                        self.bgp_advertisement_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv4-inbound"):
                                        self.has_ipv4_inbound = value
                                        self.has_ipv4_inbound.value_namespace = name_space
                                        self.has_ipv4_inbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv4-outbound"):
                                        self.has_ipv4_outbound = value
                                        self.has_ipv4_outbound.value_namespace = name_space
                                        self.has_ipv4_outbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv6-inbound"):
                                        self.has_ipv6_inbound = value
                                        self.has_ipv6_inbound.value_namespace = name_space
                                        self.has_ipv6_inbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv6-outbound"):
                                        self.has_ipv6_outbound = value
                                        self.has_ipv6_outbound.value_namespace = name_space
                                        self.has_ipv6_outbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-sp"):
                                        self.has_sp = value
                                        self.has_sp.value_namespace = name_space
                                        self.has_sp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inbound-ipv4acl"):
                                        self.inbound_ipv4acl = value
                                        self.inbound_ipv4acl.value_namespace = name_space
                                        self.inbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inbound-ipv6acl"):
                                        self.inbound_ipv6acl = value
                                        self.inbound_ipv6acl.value_namespace = name_space
                                        self.inbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-interval"):
                                        self.keep_alive_interval = value
                                        self.keep_alive_interval.value_namespace = name_space
                                        self.keep_alive_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-last-sync-error"):
                                        self.nsr_last_sync_error = value
                                        self.nsr_last_sync_error.value_namespace = name_space
                                        self.nsr_last_sync_error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-last-sync-nack-reason"):
                                        self.nsr_last_sync_nack_reason = value
                                        self.nsr_last_sync_nack_reason.value_namespace = name_space
                                        self.nsr_last_sync_nack_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outbound-ipv4acl"):
                                        self.outbound_ipv4acl = value
                                        self.outbound_ipv4acl.value_namespace = name_space
                                        self.outbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outbound-ipv6acl"):
                                        self.outbound_ipv6acl = value
                                        self.outbound_ipv6acl.value_namespace = name_space
                                        self.outbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-holdtime"):
                                        self.peer_holdtime = value
                                        self.peer_holdtime.value_namespace = name_space
                                        self.peer_holdtime.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-state"):
                                        self.peer_state = value
                                        self.peer_state.value_namespace = name_space
                                        self.peer_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-duration"):
                                        self.sp_duration = value
                                        self.sp_duration.value_namespace = name_space
                                        self.sp_duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-has-acl"):
                                        self.sp_has_acl = value
                                        self.sp_has_acl.value_namespace = name_space
                                        self.sp_has_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-has-duration"):
                                        self.sp_has_duration = value
                                        self.sp_has_duration.value_namespace = name_space
                                        self.sp_has_duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-state"):
                                        self.sp_state = value
                                        self.sp_state.value_namespace = name_space
                                        self.sp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spacl"):
                                        self.spacl = value
                                        self.spacl.value_namespace = name_space
                                        self.spacl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spht-remaining"):
                                        self.spht_remaining = value
                                        self.spht_remaining.value_namespace = name_space
                                        self.spht_remaining.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spht-running"):
                                        self.spht_running = value
                                        self.spht_running.value_namespace = name_space
                                        self.spht_running.value_namespace_prefix = name_space_prefix


                            class LdpNbrBoundIpv4AddressInfo(Entity):
                                """
                                Neighbor IPv4 Address Info
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-bound-ipv4-address-info"
                                    self.yang_parent_name = "neighbor"

                                    self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ldp-nbr-bound-ipv4-address-info"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-bound-ipv4-address-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrBoundIpv6AddressInfo(Entity):
                                """
                                Neighbor IPv6 Address Info
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-bound-ipv6-address-info"
                                    self.yang_parent_name = "neighbor"

                                    self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ldp-nbr-bound-ipv6-address-info"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-bound-ipv6-address-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrIpv4AdjInfo(Entity):
                                """
                                Neighbor's IPv4 Adjacency Information
                                
                                .. attribute:: adjacency_group
                                
                                	Adjacency group
                                	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-ipv4-adj-info"
                                    self.yang_parent_name = "neighbor"

                                    self.adjacency_group = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                    self.adjacency_group.parent = self
                                    self._children_name_map["adjacency_group"] = "adjacency-group"
                                    self._children_yang_names.add("adjacency-group")


                                class AdjacencyGroup(Entity):
                                    """
                                    Adjacency group
                                    
                                    .. attribute:: hello_type
                                    
                                    	HelloType
                                    	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                    
                                    .. attribute:: link_hello_data
                                    
                                    	Link hello
                                    	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData>`
                                    
                                    .. attribute:: target_hello_data
                                    
                                    	Target Hello
                                    	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__init__()

                                        self.yang_name = "adjacency-group"
                                        self.yang_parent_name = "ldp-nbr-ipv4-adj-info"

                                        self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                        self.link_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                        self.link_hello_data.parent = self
                                        self._children_name_map["link_hello_data"] = "link-hello-data"
                                        self._children_yang_names.add("link-hello-data")

                                        self.target_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                        self.target_hello_data.parent = self
                                        self._children_name_map["target_hello_data"] = "target-hello-data"
                                        self._children_yang_names.add("target-hello-data")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hello_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                    class LinkHelloData(Entity):
                                        """
                                        Link hello
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                            self.yang_name = "link-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface",
                                                            "interface_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface.is_set or
                                                self.interface_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface" or name == "interface-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix


                                    class TargetHelloData(Entity):
                                        """
                                        Target Hello
                                        
                                        .. attribute:: local_address
                                        
                                        	Local Address
                                        	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	Target Address
                                        	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                            self.yang_name = "target-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.local_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                            self.local_address.parent = self
                                            self._children_name_map["local_address"] = "local-address"
                                            self._children_yang_names.add("local-address")

                                            self.target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                            self.target_address.parent = self
                                            self._children_name_map["target_address"] = "target-address"
                                            self._children_yang_names.add("target-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                        class LocalAddress(Entity):
                                            """
                                            Local Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                                self.yang_name = "local-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class TargetAddress(Entity):
                                            """
                                            Target Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                                self.yang_name = "target-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.state.is_set or
                                                (self.local_address is not None and self.local_address.has_data()) or
                                                (self.target_address is not None and self.target_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                (self.local_address is not None and self.local_address.has_operation()) or
                                                (self.target_address is not None and self.target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-address"):
                                                if (self.local_address is None):
                                                    self.local_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                    self.local_address.parent = self
                                                    self._children_name_map["local_address"] = "local-address"
                                                return self.local_address

                                            if (child_yang_name == "target-address"):
                                                if (self.target_address is None):
                                                    self.target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                    self.target_address.parent = self
                                                    self._children_name_map["target_address"] = "target-address"
                                                return self.target_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-address" or name == "target-address" or name == "state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hello_type.is_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hello_type.yfilter != YFilter.not_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "adjacency-group" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hello_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-data"):
                                            if (self.link_hello_data is None):
                                                self.link_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                                self.link_hello_data.parent = self
                                                self._children_name_map["link_hello_data"] = "link-hello-data"
                                            return self.link_hello_data

                                        if (child_yang_name == "target-hello-data"):
                                            if (self.target_hello_data is None):
                                                self.target_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                                self.target_hello_data.parent = self
                                                self._children_name_map["target_hello_data"] = "target-hello-data"
                                            return self.target_hello_data

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hello-type"):
                                            self.hello_type = value
                                            self.hello_type.value_namespace = name_space
                                            self.hello_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.adjacency_group is not None and self.adjacency_group.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-ipv4-adj-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "adjacency-group"):
                                        if (self.adjacency_group is None):
                                            self.adjacency_group = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                            self.adjacency_group.parent = self
                                            self._children_name_map["adjacency_group"] = "adjacency-group"
                                        return self.adjacency_group

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "adjacency-group"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrIpv6AdjInfo(Entity):
                                """
                                Neighbor's IPv6 Adjacency Information
                                
                                .. attribute:: adjacency_group
                                
                                	Adjacency group
                                	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-ipv6-adj-info"
                                    self.yang_parent_name = "neighbor"

                                    self.adjacency_group = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                    self.adjacency_group.parent = self
                                    self._children_name_map["adjacency_group"] = "adjacency-group"
                                    self._children_yang_names.add("adjacency-group")


                                class AdjacencyGroup(Entity):
                                    """
                                    Adjacency group
                                    
                                    .. attribute:: hello_type
                                    
                                    	HelloType
                                    	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                    
                                    .. attribute:: link_hello_data
                                    
                                    	Link hello
                                    	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData>`
                                    
                                    .. attribute:: target_hello_data
                                    
                                    	Target Hello
                                    	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__init__()

                                        self.yang_name = "adjacency-group"
                                        self.yang_parent_name = "ldp-nbr-ipv6-adj-info"

                                        self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                        self.link_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                        self.link_hello_data.parent = self
                                        self._children_name_map["link_hello_data"] = "link-hello-data"
                                        self._children_yang_names.add("link-hello-data")

                                        self.target_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                        self.target_hello_data.parent = self
                                        self._children_name_map["target_hello_data"] = "target-hello-data"
                                        self._children_yang_names.add("target-hello-data")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hello_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                    class LinkHelloData(Entity):
                                        """
                                        Link hello
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                            self.yang_name = "link-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface",
                                                            "interface_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface.is_set or
                                                self.interface_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface" or name == "interface-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix


                                    class TargetHelloData(Entity):
                                        """
                                        Target Hello
                                        
                                        .. attribute:: local_address
                                        
                                        	Local Address
                                        	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	Target Address
                                        	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                            self.yang_name = "target-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.local_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                            self.local_address.parent = self
                                            self._children_name_map["local_address"] = "local-address"
                                            self._children_yang_names.add("local-address")

                                            self.target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                            self.target_address.parent = self
                                            self._children_name_map["target_address"] = "target-address"
                                            self._children_yang_names.add("target-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                        class LocalAddress(Entity):
                                            """
                                            Local Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                                self.yang_name = "local-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class TargetAddress(Entity):
                                            """
                                            Target Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                                self.yang_name = "target-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.state.is_set or
                                                (self.local_address is not None and self.local_address.has_data()) or
                                                (self.target_address is not None and self.target_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                (self.local_address is not None and self.local_address.has_operation()) or
                                                (self.target_address is not None and self.target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-address"):
                                                if (self.local_address is None):
                                                    self.local_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                    self.local_address.parent = self
                                                    self._children_name_map["local_address"] = "local-address"
                                                return self.local_address

                                            if (child_yang_name == "target-address"):
                                                if (self.target_address is None):
                                                    self.target_address = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                    self.target_address.parent = self
                                                    self._children_name_map["target_address"] = "target-address"
                                                return self.target_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-address" or name == "target-address" or name == "state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hello_type.is_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hello_type.yfilter != YFilter.not_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "adjacency-group" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hello_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-data"):
                                            if (self.link_hello_data is None):
                                                self.link_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                                self.link_hello_data.parent = self
                                                self._children_name_map["link_hello_data"] = "link-hello-data"
                                            return self.link_hello_data

                                        if (child_yang_name == "target-hello-data"):
                                            if (self.target_hello_data is None):
                                                self.target_hello_data = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                                self.target_hello_data.parent = self
                                                self._children_name_map["target_hello_data"] = "target-hello-data"
                                            return self.target_hello_data

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hello-type"):
                                            self.hello_type = value
                                            self.hello_type.value_namespace = name_space
                                            self.hello_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.adjacency_group is not None and self.adjacency_group.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-ipv6-adj-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "adjacency-group"):
                                        if (self.adjacency_group is None):
                                            self.adjacency_group = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                            self.adjacency_group.parent = self
                                            self._children_name_map["adjacency_group"] = "adjacency-group"
                                        return self.adjacency_group

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "adjacency-group"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    (self.detailed_information is not None and self.detailed_information.has_data()) or
                                    (self.protocol_information is not None and self.protocol_information.has_data()) or
                                    (self.tcp_information is not None and self.tcp_information.has_data()))

                            def has_operation(self):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    (self.detailed_information is not None and self.detailed_information.has_operation()) or
                                    (self.protocol_information is not None and self.protocol_information.has_operation()) or
                                    (self.tcp_information is not None and self.tcp_information.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "detailed-information"):
                                    if (self.detailed_information is None):
                                        self.detailed_information = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation()
                                        self.detailed_information.parent = self
                                        self._children_name_map["detailed_information"] = "detailed-information"
                                    return self.detailed_information

                                if (child_yang_name == "ldp-nbr-bound-ipv4-address-info"):
                                    for c in self.ldp_nbr_bound_ipv4_address_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_bound_ipv4_address_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-bound-ipv6-address-info"):
                                    for c in self.ldp_nbr_bound_ipv6_address_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_bound_ipv6_address_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-ipv4-adj-info"):
                                    for c in self.ldp_nbr_ipv4_adj_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_ipv4_adj_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-ipv6-adj-info"):
                                    for c in self.ldp_nbr_ipv6_adj_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_ipv6_adj_info.append(c)
                                    return c

                                if (child_yang_name == "protocol-information"):
                                    if (self.protocol_information is None):
                                        self.protocol_information = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation()
                                        self.protocol_information.parent = self
                                        self._children_name_map["protocol_information"] = "protocol-information"
                                    return self.protocol_information

                                if (child_yang_name == "tcp-information"):
                                    if (self.tcp_information is None):
                                        self.tcp_information = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation()
                                        self.tcp_information.parent = self
                                        self._children_name_map["tcp_information"] = "tcp-information"
                                    return self.tcp_information

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "detailed-information" or name == "ldp-nbr-bound-ipv4-address-info" or name == "ldp-nbr-bound-ipv6-address-info" or name == "ldp-nbr-ipv4-adj-info" or name == "ldp-nbr-ipv6-adj-info" or name == "protocol-information" or name == "tcp-information" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbors" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor"):
                                for c in self.neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors.Neighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class LdpId(Entity):
                        """
                        Local LDP Id
                        
                        .. attribute:: label_space_id
                        
                        	Label space identifier
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: ldp_id
                        
                        	LDP identifier
                        	**type**\:  str
                        
                        .. attribute:: lsr_id
                        
                        	LSR identifier
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.LdpId, self).__init__()

                            self.yang_name = "ldp-id"
                            self.yang_parent_name = "vrf"

                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "ldp_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.LdpId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.LdpId, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.label_space_id.is_set or
                                self.ldp_id.is_set or
                                self.lsr_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.ldp_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ldp-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-id"):
                                self.ldp_id = value
                                self.ldp_id.value_namespace = name_space
                                self.ldp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix


                    class Statistics(Entity):
                        """
                        The LDP Statistics
                        
                        .. attribute:: statistic
                        
                        	Statistical Information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`Statistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "vrf"

                            self.statistic = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics, self).__setattr__(name, value)


                        class Statistic(Entity):
                            """
                            Statistical Information on a particular LDP
                            neighbor
                            
                            .. attribute:: iccp_enabled
                            
                            	Is session ICCP enabled?
                            	**type**\:  bool
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: message_in
                            
                            	Message in count
                            	**type**\:   :py:class:`MessageIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageIn>`
                            
                            .. attribute:: message_out
                            
                            	Message out count
                            	**type**\:   :py:class:`MessageOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageOut>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic, self).__init__()

                                self.yang_name = "statistic"
                                self.yang_parent_name = "statistics"

                                self.iccp_enabled = YLeaf(YType.boolean, "iccp-enabled")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.message_in = MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageIn()
                                self.message_in.parent = self
                                self._children_name_map["message_in"] = "message-in"
                                self._children_yang_names.add("message-in")

                                self.message_out = MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageOut()
                                self.message_out.parent = self
                                self._children_name_map["message_out"] = "message-out"
                                self._children_yang_names.add("message-out")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("iccp_enabled",
                                                "label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic, self).__setattr__(name, value)


                            class MessageOut(Entity):
                                """
                                Message out count
                                
                                .. attribute:: address_count
                                
                                	Address message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: address_withdraw_count
                                
                                	Address withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_app_data_count
                                
                                	ICCP RG App Data count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_conn_count
                                
                                	ICCP RG Connect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_disconn_count
                                
                                	ICCP RG Disconnect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_notif_count
                                
                                	ICCP RG Notif count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_count
                                
                                	Init message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: keep_alive_count
                                
                                	Keepalive count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_abort_request_count
                                
                                	Label abort request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_map_count
                                
                                	Label map count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_release_count
                                
                                	Label release count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_request_count
                                
                                	Label request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_withdraw_count
                                
                                	Label withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: notification_count
                                
                                	Notification count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_count
                                
                                	Total message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__init__()

                                    self.yang_name = "message-out"
                                    self.yang_parent_name = "statistic"

                                    self.address_count = YLeaf(YType.uint32, "address-count")

                                    self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                    self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                    self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                    self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                    self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                    self.init_count = YLeaf(YType.uint32, "init-count")

                                    self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                    self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                    self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                    self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                    self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                    self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                    self.notification_count = YLeaf(YType.uint32, "notification-count")

                                    self.total_count = YLeaf(YType.uint32, "total-count")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_count",
                                                    "address_withdraw_count",
                                                    "iccp_rg_app_data_count",
                                                    "iccp_rg_conn_count",
                                                    "iccp_rg_disconn_count",
                                                    "iccp_rg_notif_count",
                                                    "init_count",
                                                    "keep_alive_count",
                                                    "label_abort_request_count",
                                                    "label_map_count",
                                                    "label_release_count",
                                                    "label_request_count",
                                                    "label_withdraw_count",
                                                    "notification_count",
                                                    "total_count") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_count.is_set or
                                        self.address_withdraw_count.is_set or
                                        self.iccp_rg_app_data_count.is_set or
                                        self.iccp_rg_conn_count.is_set or
                                        self.iccp_rg_disconn_count.is_set or
                                        self.iccp_rg_notif_count.is_set or
                                        self.init_count.is_set or
                                        self.keep_alive_count.is_set or
                                        self.label_abort_request_count.is_set or
                                        self.label_map_count.is_set or
                                        self.label_release_count.is_set or
                                        self.label_request_count.is_set or
                                        self.label_withdraw_count.is_set or
                                        self.notification_count.is_set or
                                        self.total_count.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_count.yfilter != YFilter.not_set or
                                        self.address_withdraw_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                        self.init_count.yfilter != YFilter.not_set or
                                        self.keep_alive_count.yfilter != YFilter.not_set or
                                        self.label_abort_request_count.yfilter != YFilter.not_set or
                                        self.label_map_count.yfilter != YFilter.not_set or
                                        self.label_release_count.yfilter != YFilter.not_set or
                                        self.label_request_count.yfilter != YFilter.not_set or
                                        self.label_withdraw_count.yfilter != YFilter.not_set or
                                        self.notification_count.yfilter != YFilter.not_set or
                                        self.total_count.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "message-out" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_count.get_name_leafdata())
                                    if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                    if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                    if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                    if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                    if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                    if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_count.get_name_leafdata())
                                    if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                    if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                    if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                    if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                    if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                    if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                    if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.notification_count.get_name_leafdata())
                                    if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_count.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-count"):
                                        self.address_count = value
                                        self.address_count.value_namespace = name_space
                                        self.address_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "address-withdraw-count"):
                                        self.address_withdraw_count = value
                                        self.address_withdraw_count.value_namespace = name_space
                                        self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-app-data-count"):
                                        self.iccp_rg_app_data_count = value
                                        self.iccp_rg_app_data_count.value_namespace = name_space
                                        self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-conn-count"):
                                        self.iccp_rg_conn_count = value
                                        self.iccp_rg_conn_count.value_namespace = name_space
                                        self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-disconn-count"):
                                        self.iccp_rg_disconn_count = value
                                        self.iccp_rg_disconn_count.value_namespace = name_space
                                        self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-notif-count"):
                                        self.iccp_rg_notif_count = value
                                        self.iccp_rg_notif_count.value_namespace = name_space
                                        self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-count"):
                                        self.init_count = value
                                        self.init_count.value_namespace = name_space
                                        self.init_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-count"):
                                        self.keep_alive_count = value
                                        self.keep_alive_count.value_namespace = name_space
                                        self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-abort-request-count"):
                                        self.label_abort_request_count = value
                                        self.label_abort_request_count.value_namespace = name_space
                                        self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-map-count"):
                                        self.label_map_count = value
                                        self.label_map_count.value_namespace = name_space
                                        self.label_map_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-release-count"):
                                        self.label_release_count = value
                                        self.label_release_count.value_namespace = name_space
                                        self.label_release_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-request-count"):
                                        self.label_request_count = value
                                        self.label_request_count.value_namespace = name_space
                                        self.label_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-withdraw-count"):
                                        self.label_withdraw_count = value
                                        self.label_withdraw_count.value_namespace = name_space
                                        self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "notification-count"):
                                        self.notification_count = value
                                        self.notification_count.value_namespace = name_space
                                        self.notification_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-count"):
                                        self.total_count = value
                                        self.total_count.value_namespace = name_space
                                        self.total_count.value_namespace_prefix = name_space_prefix


                            class MessageIn(Entity):
                                """
                                Message in count
                                
                                .. attribute:: address_count
                                
                                	Address message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: address_withdraw_count
                                
                                	Address withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_app_data_count
                                
                                	ICCP RG App Data count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_conn_count
                                
                                	ICCP RG Connect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_disconn_count
                                
                                	ICCP RG Disconnect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_notif_count
                                
                                	ICCP RG Notif count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_count
                                
                                	Init message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: keep_alive_count
                                
                                	Keepalive count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_abort_request_count
                                
                                	Label abort request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_map_count
                                
                                	Label map count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_release_count
                                
                                	Label release count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_request_count
                                
                                	Label request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_withdraw_count
                                
                                	Label withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: notification_count
                                
                                	Notification count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_count
                                
                                	Total message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__init__()

                                    self.yang_name = "message-in"
                                    self.yang_parent_name = "statistic"

                                    self.address_count = YLeaf(YType.uint32, "address-count")

                                    self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                    self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                    self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                    self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                    self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                    self.init_count = YLeaf(YType.uint32, "init-count")

                                    self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                    self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                    self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                    self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                    self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                    self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                    self.notification_count = YLeaf(YType.uint32, "notification-count")

                                    self.total_count = YLeaf(YType.uint32, "total-count")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_count",
                                                    "address_withdraw_count",
                                                    "iccp_rg_app_data_count",
                                                    "iccp_rg_conn_count",
                                                    "iccp_rg_disconn_count",
                                                    "iccp_rg_notif_count",
                                                    "init_count",
                                                    "keep_alive_count",
                                                    "label_abort_request_count",
                                                    "label_map_count",
                                                    "label_release_count",
                                                    "label_request_count",
                                                    "label_withdraw_count",
                                                    "notification_count",
                                                    "total_count") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_count.is_set or
                                        self.address_withdraw_count.is_set or
                                        self.iccp_rg_app_data_count.is_set or
                                        self.iccp_rg_conn_count.is_set or
                                        self.iccp_rg_disconn_count.is_set or
                                        self.iccp_rg_notif_count.is_set or
                                        self.init_count.is_set or
                                        self.keep_alive_count.is_set or
                                        self.label_abort_request_count.is_set or
                                        self.label_map_count.is_set or
                                        self.label_release_count.is_set or
                                        self.label_request_count.is_set or
                                        self.label_withdraw_count.is_set or
                                        self.notification_count.is_set or
                                        self.total_count.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_count.yfilter != YFilter.not_set or
                                        self.address_withdraw_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                        self.init_count.yfilter != YFilter.not_set or
                                        self.keep_alive_count.yfilter != YFilter.not_set or
                                        self.label_abort_request_count.yfilter != YFilter.not_set or
                                        self.label_map_count.yfilter != YFilter.not_set or
                                        self.label_release_count.yfilter != YFilter.not_set or
                                        self.label_request_count.yfilter != YFilter.not_set or
                                        self.label_withdraw_count.yfilter != YFilter.not_set or
                                        self.notification_count.yfilter != YFilter.not_set or
                                        self.total_count.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "message-in" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_count.get_name_leafdata())
                                    if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                    if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                    if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                    if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                    if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                    if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_count.get_name_leafdata())
                                    if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                    if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                    if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                    if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                    if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                    if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                    if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.notification_count.get_name_leafdata())
                                    if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_count.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-count"):
                                        self.address_count = value
                                        self.address_count.value_namespace = name_space
                                        self.address_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "address-withdraw-count"):
                                        self.address_withdraw_count = value
                                        self.address_withdraw_count.value_namespace = name_space
                                        self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-app-data-count"):
                                        self.iccp_rg_app_data_count = value
                                        self.iccp_rg_app_data_count.value_namespace = name_space
                                        self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-conn-count"):
                                        self.iccp_rg_conn_count = value
                                        self.iccp_rg_conn_count.value_namespace = name_space
                                        self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-disconn-count"):
                                        self.iccp_rg_disconn_count = value
                                        self.iccp_rg_disconn_count.value_namespace = name_space
                                        self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-notif-count"):
                                        self.iccp_rg_notif_count = value
                                        self.iccp_rg_notif_count.value_namespace = name_space
                                        self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-count"):
                                        self.init_count = value
                                        self.init_count.value_namespace = name_space
                                        self.init_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-count"):
                                        self.keep_alive_count = value
                                        self.keep_alive_count.value_namespace = name_space
                                        self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-abort-request-count"):
                                        self.label_abort_request_count = value
                                        self.label_abort_request_count.value_namespace = name_space
                                        self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-map-count"):
                                        self.label_map_count = value
                                        self.label_map_count.value_namespace = name_space
                                        self.label_map_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-release-count"):
                                        self.label_release_count = value
                                        self.label_release_count.value_namespace = name_space
                                        self.label_release_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-request-count"):
                                        self.label_request_count = value
                                        self.label_request_count.value_namespace = name_space
                                        self.label_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-withdraw-count"):
                                        self.label_withdraw_count = value
                                        self.label_withdraw_count.value_namespace = name_space
                                        self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "notification-count"):
                                        self.notification_count = value
                                        self.notification_count.value_namespace = name_space
                                        self.notification_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-count"):
                                        self.total_count = value
                                        self.total_count.value_namespace = name_space
                                        self.total_count.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.iccp_enabled.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    (self.message_in is not None and self.message_in.has_data()) or
                                    (self.message_out is not None and self.message_out.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.iccp_enabled.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    (self.message_in is not None and self.message_in.has_operation()) or
                                    (self.message_out is not None and self.message_out.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.iccp_enabled.is_set or self.iccp_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_enabled.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "message-in"):
                                    if (self.message_in is None):
                                        self.message_in = MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageIn()
                                        self.message_in.parent = self
                                        self._children_name_map["message_in"] = "message-in"
                                    return self.message_in

                                if (child_yang_name == "message-out"):
                                    if (self.message_out is None):
                                        self.message_out = MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic.MessageOut()
                                        self.message_out.parent = self
                                        self._children_name_map["message_out"] = "message-out"
                                    return self.message_out

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "message-in" or name == "message-out" or name == "iccp-enabled" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "iccp-enabled"):
                                    self.iccp_enabled = value
                                    self.iccp_enabled.value_namespace = name_space
                                    self.iccp_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.statistic:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.statistic:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "statistic"):
                                for c in self.statistic:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Global_.Active.Vrfs.Vrf.Statistics.Statistic()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.statistic.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "statistic"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.vrf_name.is_set or
                            (self.afs is not None and self.afs.has_data()) or
                            (self.backoff_parameters is not None and self.backoff_parameters.has_data()) or
                            (self.backoffs is not None and self.backoffs.has_data()) or
                            (self.capabilities is not None and self.capabilities.has_data()) or
                            (self.graceful_restart is not None and self.graceful_restart.has_data()) or
                            (self.issu is not None and self.issu.has_data()) or
                            (self.ldp_id is not None and self.ldp_id.has_data()) or
                            (self.neighbor_briefs is not None and self.neighbor_briefs.has_data()) or
                            (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_data()) or
                            (self.neighbors is not None and self.neighbors.has_data()) or
                            (self.nsr is not None and self.nsr.has_data()) or
                            (self.parameters is not None and self.parameters.has_data()) or
                            (self.statistics is not None and self.statistics.has_data()) or
                            (self.summary is not None and self.summary.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.vrf_name.yfilter != YFilter.not_set or
                            (self.afs is not None and self.afs.has_operation()) or
                            (self.backoff_parameters is not None and self.backoff_parameters.has_operation()) or
                            (self.backoffs is not None and self.backoffs.has_operation()) or
                            (self.capabilities is not None and self.capabilities.has_operation()) or
                            (self.graceful_restart is not None and self.graceful_restart.has_operation()) or
                            (self.issu is not None and self.issu.has_operation()) or
                            (self.ldp_id is not None and self.ldp_id.has_operation()) or
                            (self.neighbor_briefs is not None and self.neighbor_briefs.has_operation()) or
                            (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_operation()) or
                            (self.neighbors is not None and self.neighbors.has_operation()) or
                            (self.nsr is not None and self.nsr.has_operation()) or
                            (self.parameters is not None and self.parameters.has_operation()) or
                            (self.statistics is not None and self.statistics.has_operation()) or
                            (self.summary is not None and self.summary.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/vrfs/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "afs"):
                            if (self.afs is None):
                                self.afs = MplsLdp.Global_.Active.Vrfs.Vrf.Afs()
                                self.afs.parent = self
                                self._children_name_map["afs"] = "afs"
                            return self.afs

                        if (child_yang_name == "backoff-parameters"):
                            if (self.backoff_parameters is None):
                                self.backoff_parameters = MplsLdp.Global_.Active.Vrfs.Vrf.BackoffParameters()
                                self.backoff_parameters.parent = self
                                self._children_name_map["backoff_parameters"] = "backoff-parameters"
                            return self.backoff_parameters

                        if (child_yang_name == "backoffs"):
                            if (self.backoffs is None):
                                self.backoffs = MplsLdp.Global_.Active.Vrfs.Vrf.Backoffs()
                                self.backoffs.parent = self
                                self._children_name_map["backoffs"] = "backoffs"
                            return self.backoffs

                        if (child_yang_name == "capabilities"):
                            if (self.capabilities is None):
                                self.capabilities = MplsLdp.Global_.Active.Vrfs.Vrf.Capabilities()
                                self.capabilities.parent = self
                                self._children_name_map["capabilities"] = "capabilities"
                            return self.capabilities

                        if (child_yang_name == "graceful-restart"):
                            if (self.graceful_restart is None):
                                self.graceful_restart = MplsLdp.Global_.Active.Vrfs.Vrf.GracefulRestart()
                                self.graceful_restart.parent = self
                                self._children_name_map["graceful_restart"] = "graceful-restart"
                            return self.graceful_restart

                        if (child_yang_name == "issu"):
                            if (self.issu is None):
                                self.issu = MplsLdp.Global_.Active.Vrfs.Vrf.Issu()
                                self.issu.parent = self
                                self._children_name_map["issu"] = "issu"
                            return self.issu

                        if (child_yang_name == "ldp-id"):
                            if (self.ldp_id is None):
                                self.ldp_id = MplsLdp.Global_.Active.Vrfs.Vrf.LdpId()
                                self.ldp_id.parent = self
                                self._children_name_map["ldp_id"] = "ldp-id"
                            return self.ldp_id

                        if (child_yang_name == "neighbor-briefs"):
                            if (self.neighbor_briefs is None):
                                self.neighbor_briefs = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborBriefs()
                                self.neighbor_briefs.parent = self
                                self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                            return self.neighbor_briefs

                        if (child_yang_name == "neighbor-capabilities"):
                            if (self.neighbor_capabilities is None):
                                self.neighbor_capabilities = MplsLdp.Global_.Active.Vrfs.Vrf.NeighborCapabilities()
                                self.neighbor_capabilities.parent = self
                                self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                            return self.neighbor_capabilities

                        if (child_yang_name == "neighbors"):
                            if (self.neighbors is None):
                                self.neighbors = MplsLdp.Global_.Active.Vrfs.Vrf.Neighbors()
                                self.neighbors.parent = self
                                self._children_name_map["neighbors"] = "neighbors"
                            return self.neighbors

                        if (child_yang_name == "nsr"):
                            if (self.nsr is None):
                                self.nsr = MplsLdp.Global_.Active.Vrfs.Vrf.Nsr()
                                self.nsr.parent = self
                                self._children_name_map["nsr"] = "nsr"
                            return self.nsr

                        if (child_yang_name == "parameters"):
                            if (self.parameters is None):
                                self.parameters = MplsLdp.Global_.Active.Vrfs.Vrf.Parameters()
                                self.parameters.parent = self
                                self._children_name_map["parameters"] = "parameters"
                            return self.parameters

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsLdp.Global_.Active.Vrfs.Vrf.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        if (child_yang_name == "summary"):
                            if (self.summary is None):
                                self.summary = MplsLdp.Global_.Active.Vrfs.Vrf.Summary()
                                self.summary.parent = self
                                self._children_name_map["summary"] = "summary"
                            return self.summary

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "afs" or name == "backoff-parameters" or name == "backoffs" or name == "capabilities" or name == "graceful-restart" or name == "issu" or name == "ldp-id" or name == "neighbor-briefs" or name == "neighbor-capabilities" or name == "neighbors" or name == "nsr" or name == "parameters" or name == "statistics" or name == "summary" or name == "vrf-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "vrf-name"):
                            self.vrf_name = value
                            self.vrf_name.value_namespace = name_space
                            self.vrf_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.vrf:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.vrf:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "vrfs" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vrf"):
                        for c in self.vrf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Global_.Active.Vrfs.Vrf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.vrf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vrf"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class DiscoverySummaryAll(Entity):
                """
                Summary information regarding LDP discovery
                
                .. attribute:: local_ldp_id
                
                	Local LDP identifier
                	**type**\:  str
                
                .. attribute:: num_of_active_ldp_interfaces
                
                	Number of active LDP enabled interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_addr_recv
                
                	Number of hello discoveries received with bad source address
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_hello_pdu
                
                	Number of hello discoveries received with bad hello PDU
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_xport_addr
                
                	Number of hello discoveries received with bad export address
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_same_router_id
                
                	Number of hello discoveries received with the same router id as this router
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_wrong_router_id
                
                	Number of hello discoveries received with the router id that is not destined for this router
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_ldp_interfaces
                
                	Total Number of LDP configured interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_lnk_disc_recv
                
                	Number of link hello discoveries in recv state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_lnk_disc_xmit
                
                	Number of link hello discoveries in xmit state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_tgt_disc_recv
                
                	Number of targeted hello discoveries in recv state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_tgt_disc_xmit
                
                	Number of targeted hello discoveries in xmit state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Global_.Active.DiscoverySummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Global_.Active.DiscoverySummaryAll, self).__init__()

                    self.yang_name = "discovery-summary-all"
                    self.yang_parent_name = "active"

                    self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                    self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                    self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                    self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                    self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                    self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                    self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                    self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                    self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                    self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                    self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                    self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                    self.vrf = MplsLdp.Global_.Active.DiscoverySummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("local_ldp_id",
                                    "num_of_active_ldp_interfaces",
                                    "num_of_disc_with_bad_addr_recv",
                                    "num_of_disc_with_bad_hello_pdu",
                                    "num_of_disc_with_bad_xport_addr",
                                    "num_of_disc_with_same_router_id",
                                    "num_of_disc_with_wrong_router_id",
                                    "num_of_ldp_interfaces",
                                    "num_of_lnk_disc_recv",
                                    "num_of_lnk_disc_xmit",
                                    "num_of_tgt_disc_recv",
                                    "num_of_tgt_disc_xmit") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Global_.Active.DiscoverySummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Global_.Active.DiscoverySummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Global_.Active.DiscoverySummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "discovery-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Global_.Active.DiscoverySummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Global_.Active.DiscoverySummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/discovery-summary-all/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.local_ldp_id.is_set or
                        self.num_of_active_ldp_interfaces.is_set or
                        self.num_of_disc_with_bad_addr_recv.is_set or
                        self.num_of_disc_with_bad_hello_pdu.is_set or
                        self.num_of_disc_with_bad_xport_addr.is_set or
                        self.num_of_disc_with_same_router_id.is_set or
                        self.num_of_disc_with_wrong_router_id.is_set or
                        self.num_of_ldp_interfaces.is_set or
                        self.num_of_lnk_disc_recv.is_set or
                        self.num_of_lnk_disc_xmit.is_set or
                        self.num_of_tgt_disc_recv.is_set or
                        self.num_of_tgt_disc_xmit.is_set or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.local_ldp_id.yfilter != YFilter.not_set or
                        self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                        self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                        self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                        self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                        self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                        self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                        self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                        self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "discovery-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/active/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                    if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                    if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                    if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                    if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                    if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                    if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                    if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                    if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                    if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                    if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                    if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Global_.Active.DiscoverySummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "local-ldp-id"):
                        self.local_ldp_id = value
                        self.local_ldp_id.value_namespace = name_space
                        self.local_ldp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-active-ldp-interfaces"):
                        self.num_of_active_ldp_interfaces = value
                        self.num_of_active_ldp_interfaces.value_namespace = name_space
                        self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-addr-recv"):
                        self.num_of_disc_with_bad_addr_recv = value
                        self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                        self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-hello-pdu"):
                        self.num_of_disc_with_bad_hello_pdu = value
                        self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                        self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-xport-addr"):
                        self.num_of_disc_with_bad_xport_addr = value
                        self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                        self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-same-router-id"):
                        self.num_of_disc_with_same_router_id = value
                        self.num_of_disc_with_same_router_id.value_namespace = name_space
                        self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-wrong-router-id"):
                        self.num_of_disc_with_wrong_router_id = value
                        self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                        self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-ldp-interfaces"):
                        self.num_of_ldp_interfaces = value
                        self.num_of_ldp_interfaces.value_namespace = name_space
                        self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-lnk-disc-recv"):
                        self.num_of_lnk_disc_recv = value
                        self.num_of_lnk_disc_recv.value_namespace = name_space
                        self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-lnk-disc-xmit"):
                        self.num_of_lnk_disc_xmit = value
                        self.num_of_lnk_disc_xmit.value_namespace = name_space
                        self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-tgt-disc-recv"):
                        self.num_of_tgt_disc_recv = value
                        self.num_of_tgt_disc_recv.value_namespace = name_space
                        self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-tgt-disc-xmit"):
                        self.num_of_tgt_disc_xmit = value
                        self.num_of_tgt_disc_xmit.value_namespace = name_space
                        self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    (self.ato_mdb_table_entries is not None and self.ato_mdb_table_entries.has_data()) or
                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                    (self.default_vrf is not None and self.default_vrf.has_data()) or
                    (self.discovery_summary_all is not None and self.discovery_summary_all.has_data()) or
                    (self.forwarding_summary_all is not None and self.forwarding_summary_all.has_data()) or
                    (self.nsr_summary_all is not None and self.nsr_summary_all.has_data()) or
                    (self.summary is not None and self.summary.has_data()) or
                    (self.vrfs is not None and self.vrfs.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.ato_mdb_table_entries is not None and self.ato_mdb_table_entries.has_operation()) or
                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                    (self.default_vrf is not None and self.default_vrf.has_operation()) or
                    (self.discovery_summary_all is not None and self.discovery_summary_all.has_operation()) or
                    (self.forwarding_summary_all is not None and self.forwarding_summary_all.has_operation()) or
                    (self.nsr_summary_all is not None and self.nsr_summary_all.has_operation()) or
                    (self.summary is not None and self.summary.has_operation()) or
                    (self.vrfs is not None and self.vrfs.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "active" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/global/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ato-mdb-table-entries"):
                    if (self.ato_mdb_table_entries is None):
                        self.ato_mdb_table_entries = MplsLdp.Global_.Active.AtoMdbTableEntries()
                        self.ato_mdb_table_entries.parent = self
                        self._children_name_map["ato_mdb_table_entries"] = "ato-mdb-table-entries"
                    return self.ato_mdb_table_entries

                if (child_yang_name == "bindings-summary-all"):
                    if (self.bindings_summary_all is None):
                        self.bindings_summary_all = MplsLdp.Global_.Active.BindingsSummaryAll()
                        self.bindings_summary_all.parent = self
                        self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                    return self.bindings_summary_all

                if (child_yang_name == "default-vrf"):
                    if (self.default_vrf is None):
                        self.default_vrf = MplsLdp.Global_.Active.DefaultVrf()
                        self.default_vrf.parent = self
                        self._children_name_map["default_vrf"] = "default-vrf"
                    return self.default_vrf

                if (child_yang_name == "discovery-summary-all"):
                    if (self.discovery_summary_all is None):
                        self.discovery_summary_all = MplsLdp.Global_.Active.DiscoverySummaryAll()
                        self.discovery_summary_all.parent = self
                        self._children_name_map["discovery_summary_all"] = "discovery-summary-all"
                    return self.discovery_summary_all

                if (child_yang_name == "forwarding-summary-all"):
                    if (self.forwarding_summary_all is None):
                        self.forwarding_summary_all = MplsLdp.Global_.Active.ForwardingSummaryAll()
                        self.forwarding_summary_all.parent = self
                        self._children_name_map["forwarding_summary_all"] = "forwarding-summary-all"
                    return self.forwarding_summary_all

                if (child_yang_name == "nsr-summary-all"):
                    if (self.nsr_summary_all is None):
                        self.nsr_summary_all = MplsLdp.Global_.Active.NsrSummaryAll()
                        self.nsr_summary_all.parent = self
                        self._children_name_map["nsr_summary_all"] = "nsr-summary-all"
                    return self.nsr_summary_all

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsLdp.Global_.Active.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                if (child_yang_name == "vrfs"):
                    if (self.vrfs is None):
                        self.vrfs = MplsLdp.Global_.Active.Vrfs()
                        self.vrfs.parent = self
                        self._children_name_map["vrfs"] = "vrfs"
                    return self.vrfs

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ato-mdb-table-entries" or name == "bindings-summary-all" or name == "default-vrf" or name == "discovery-summary-all" or name == "forwarding-summary-all" or name == "nsr-summary-all" or name == "summary" or name == "vrfs"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.active is not None and self.active.has_data()) or
                (self.standby is not None and self.standby.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.active is not None and self.active.has_operation()) or
                (self.standby is not None and self.standby.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "global" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "active"):
                if (self.active is None):
                    self.active = MplsLdp.Global_.Active()
                    self.active.parent = self
                    self._children_name_map["active"] = "active"
                return self.active

            if (child_yang_name == "standby"):
                if (self.standby is None):
                    self.standby = MplsLdp.Global_.Standby()
                    self.standby.parent = self
                    self._children_name_map["standby"] = "standby"
                return self.standby

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "active" or name == "standby"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Nodes(Entity):
        """
        Location MPLS LDP operational data
        
        .. attribute:: node
        
        	The MPLD LDP operational data for a particular node
        	**type**\: list of    :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node>`
        
        

        """

        _prefix = 'mpls-ldp-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsLdp.Nodes, self).__init__()

            self.yang_name = "nodes"
            self.yang_parent_name = "mpls-ldp"

            self.node = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsLdp.Nodes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsLdp.Nodes, self).__setattr__(name, value)


        class Node(Entity):
            """
            The MPLD LDP operational data for a particular
            node
            
            .. attribute:: node_name  <key>
            
            	The identifier for the node
            	**type**\:  str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            .. attribute:: ato_mdb_table_entries
            
            	AToM DB Table
            	**type**\:   :py:class:`AtoMdbTableEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries>`
            
            .. attribute:: bindings_summary_all
            
            	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
            	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.BindingsSummaryAll>`
            
            .. attribute:: default_vrf
            
            	DefaultVRF specific operational data
            	**type**\:   :py:class:`DefaultVrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf>`
            
            .. attribute:: discovery_summary_all
            
            	Summary information regarding LDP discovery
            	**type**\:   :py:class:`DiscoverySummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DiscoverySummaryAll>`
            
            .. attribute:: forwarding_summary_all
            
            	Summary information regarding LDP forwarding setup
            	**type**\:   :py:class:`ForwardingSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll>`
            
            .. attribute:: nsr_summary_all
            
            	Summary information regarding LDP NSR State
            	**type**\:   :py:class:`NsrSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.NsrSummaryAll>`
            
            .. attribute:: summary
            
            	LDP summary
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Summary>`
            
            .. attribute:: vrfs
            
            	VRF specific operational data
            	**type**\:   :py:class:`Vrfs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs>`
            
            

            """

            _prefix = 'mpls-ldp-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsLdp.Nodes.Node, self).__init__()

                self.yang_name = "node"
                self.yang_parent_name = "nodes"

                self.node_name = YLeaf(YType.str, "node-name")

                self.ato_mdb_table_entries = MplsLdp.Nodes.Node.AtoMdbTableEntries()
                self.ato_mdb_table_entries.parent = self
                self._children_name_map["ato_mdb_table_entries"] = "ato-mdb-table-entries"
                self._children_yang_names.add("ato-mdb-table-entries")

                self.bindings_summary_all = MplsLdp.Nodes.Node.BindingsSummaryAll()
                self.bindings_summary_all.parent = self
                self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                self._children_yang_names.add("bindings-summary-all")

                self.default_vrf = MplsLdp.Nodes.Node.DefaultVrf()
                self.default_vrf.parent = self
                self._children_name_map["default_vrf"] = "default-vrf"
                self._children_yang_names.add("default-vrf")

                self.discovery_summary_all = MplsLdp.Nodes.Node.DiscoverySummaryAll()
                self.discovery_summary_all.parent = self
                self._children_name_map["discovery_summary_all"] = "discovery-summary-all"
                self._children_yang_names.add("discovery-summary-all")

                self.forwarding_summary_all = MplsLdp.Nodes.Node.ForwardingSummaryAll()
                self.forwarding_summary_all.parent = self
                self._children_name_map["forwarding_summary_all"] = "forwarding-summary-all"
                self._children_yang_names.add("forwarding-summary-all")

                self.nsr_summary_all = MplsLdp.Nodes.Node.NsrSummaryAll()
                self.nsr_summary_all.parent = self
                self._children_name_map["nsr_summary_all"] = "nsr-summary-all"
                self._children_yang_names.add("nsr-summary-all")

                self.summary = MplsLdp.Nodes.Node.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")

                self.vrfs = MplsLdp.Nodes.Node.Vrfs()
                self.vrfs.parent = self
                self._children_name_map["vrfs"] = "vrfs"
                self._children_yang_names.add("vrfs")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("node_name") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsLdp.Nodes.Node, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsLdp.Nodes.Node, self).__setattr__(name, value)


            class DefaultVrf(Entity):
                """
                DefaultVRF specific operational data
                
                .. attribute:: afs
                
                	Address Family specific operational data
                	**type**\:   :py:class:`Afs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs>`
                
                .. attribute:: backoff_parameters
                
                	The LDP Backoff Parameters
                	**type**\:   :py:class:`BackoffParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.BackoffParameters>`
                
                .. attribute:: backoffs
                
                	The LDP backoff
                	**type**\:   :py:class:`Backoffs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Backoffs>`
                
                .. attribute:: capabilities
                
                	LDP capability database information
                	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Capabilities>`
                
                .. attribute:: graceful_restart
                
                	LDP Graceful Restart info
                	**type**\:   :py:class:`GracefulRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart>`
                
                .. attribute:: issu
                
                	LDP ISSU related information
                	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu>`
                
                .. attribute:: ldp_id
                
                	Local LDP Id
                	**type**\:   :py:class:`LdpId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.LdpId>`
                
                .. attribute:: neighbor_briefs
                
                	The LDP Neighbors (brief)
                	**type**\:   :py:class:`NeighborBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs>`
                
                .. attribute:: neighbor_capabilities
                
                	LDP Neighbors Capabilities
                	**type**\:   :py:class:`NeighborCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities>`
                
                .. attribute:: neighbors
                
                	The LDP Neighbors
                	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors>`
                
                .. attribute:: nsr
                
                	LDP NSR related information
                	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr>`
                
                .. attribute:: parameters
                
                	LDP parameters
                	**type**\:   :py:class:`Parameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Parameters>`
                
                .. attribute:: statistics
                
                	The LDP Statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Statistics>`
                
                .. attribute:: summary
                
                	LDP VRF summary
                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Summary>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.DefaultVrf, self).__init__()

                    self.yang_name = "default-vrf"
                    self.yang_parent_name = "node"

                    self.afs = MplsLdp.Nodes.Node.DefaultVrf.Afs()
                    self.afs.parent = self
                    self._children_name_map["afs"] = "afs"
                    self._children_yang_names.add("afs")

                    self.backoff_parameters = MplsLdp.Nodes.Node.DefaultVrf.BackoffParameters()
                    self.backoff_parameters.parent = self
                    self._children_name_map["backoff_parameters"] = "backoff-parameters"
                    self._children_yang_names.add("backoff-parameters")

                    self.backoffs = MplsLdp.Nodes.Node.DefaultVrf.Backoffs()
                    self.backoffs.parent = self
                    self._children_name_map["backoffs"] = "backoffs"
                    self._children_yang_names.add("backoffs")

                    self.capabilities = MplsLdp.Nodes.Node.DefaultVrf.Capabilities()
                    self.capabilities.parent = self
                    self._children_name_map["capabilities"] = "capabilities"
                    self._children_yang_names.add("capabilities")

                    self.graceful_restart = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart()
                    self.graceful_restart.parent = self
                    self._children_name_map["graceful_restart"] = "graceful-restart"
                    self._children_yang_names.add("graceful-restart")

                    self.issu = MplsLdp.Nodes.Node.DefaultVrf.Issu()
                    self.issu.parent = self
                    self._children_name_map["issu"] = "issu"
                    self._children_yang_names.add("issu")

                    self.ldp_id = MplsLdp.Nodes.Node.DefaultVrf.LdpId()
                    self.ldp_id.parent = self
                    self._children_name_map["ldp_id"] = "ldp-id"
                    self._children_yang_names.add("ldp-id")

                    self.neighbor_briefs = MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs()
                    self.neighbor_briefs.parent = self
                    self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                    self._children_yang_names.add("neighbor-briefs")

                    self.neighbor_capabilities = MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities()
                    self.neighbor_capabilities.parent = self
                    self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                    self._children_yang_names.add("neighbor-capabilities")

                    self.neighbors = MplsLdp.Nodes.Node.DefaultVrf.Neighbors()
                    self.neighbors.parent = self
                    self._children_name_map["neighbors"] = "neighbors"
                    self._children_yang_names.add("neighbors")

                    self.nsr = MplsLdp.Nodes.Node.DefaultVrf.Nsr()
                    self.nsr.parent = self
                    self._children_name_map["nsr"] = "nsr"
                    self._children_yang_names.add("nsr")

                    self.parameters = MplsLdp.Nodes.Node.DefaultVrf.Parameters()
                    self.parameters.parent = self
                    self._children_name_map["parameters"] = "parameters"
                    self._children_yang_names.add("parameters")

                    self.statistics = MplsLdp.Nodes.Node.DefaultVrf.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.summary = MplsLdp.Nodes.Node.DefaultVrf.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._children_yang_names.add("summary")


                class GracefulRestart(Entity):
                    """
                    LDP Graceful Restart info
                    
                    .. attribute:: forwarding_state_hold_timer_remaining_seconds
                    
                    	Forwarding state hold timer remaining time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: graceful_restartable_neighbor
                    
                    	Vector of graceful restart neighbor information
                    	**type**\: list of    :py:class:`GracefulRestartableNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor>`
                    
                    .. attribute:: is_forwarding_state_hold_timer_running
                    
                    	Is graceful restart forwarding state hold timer running
                    	**type**\:  bool
                    
                    .. attribute:: vrf
                    
                    	VRF information
                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.Vrf>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart, self).__init__()

                        self.yang_name = "graceful-restart"
                        self.yang_parent_name = "default-vrf"

                        self.forwarding_state_hold_timer_remaining_seconds = YLeaf(YType.uint32, "forwarding-state-hold-timer-remaining-seconds")

                        self.is_forwarding_state_hold_timer_running = YLeaf(YType.boolean, "is-forwarding-state-hold-timer-running")

                        self.vrf = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.Vrf()
                        self.vrf.parent = self
                        self._children_name_map["vrf"] = "vrf"
                        self._children_yang_names.add("vrf")

                        self.graceful_restartable_neighbor = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("forwarding_state_hold_timer_remaining_seconds",
                                        "is_forwarding_state_hold_timer_running") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart, self).__setattr__(name, value)


                    class Vrf(Entity):
                        """
                        VRF information
                        
                        .. attribute:: id
                        
                        	VRF Id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.Vrf, self).__init__()

                            self.yang_name = "vrf"
                            self.yang_parent_name = "graceful-restart"

                            self.id = YLeaf(YType.uint32, "id")

                            self.name = YLeaf(YType.str, "name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("id",
                                            "name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.Vrf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.Vrf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.id.is_set or
                                self.name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.id.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.id.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "id" or name == "name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "id"):
                                self.id = value
                                self.id.value_namespace = name_space
                                self.id.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix


                    class GracefulRestartableNeighbor(Entity):
                        """
                        Vector of graceful restart neighbor information
                        
                        .. attribute:: connect_count
                        
                        	ConnectCount
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_address
                        
                        	Addresses bound to GR down Nbr
                        	**type**\: list of    :py:class:`DownNbrAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress>`
                        
                        .. attribute:: down_nbr_down_reason
                        
                        	Session down reason code
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_flags
                        
                        	Flags
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_nbr_flap_count
                        
                        	Count of back2back flaps
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: down_nbr_interface
                        
                        	Interfaces bound to GR down Nbr
                        	**type**\: list of    :py:class:`DownNbrInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface>`
                        
                        .. attribute:: gr_peer
                        
                        	GR peer LDP Id
                        	**type**\:   :py:class:`GrPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer>`
                        
                        .. attribute:: is_liveness_timer_running
                        
                        	Is liveness timer running
                        	**type**\:  bool
                        
                        .. attribute:: is_neighbor_up
                        
                        	Is neighbor up
                        	**type**\:  bool
                        
                        .. attribute:: is_recovery_timer_running
                        
                        	Is recovery timer running
                        	**type**\:  bool
                        
                        .. attribute:: liveness_timer_remaining_seconds
                        
                        	Remaining time from liveness timer
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: recovery_timer_remaining_seconds
                        
                        	Recovery timer remining time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__init__()

                            self.yang_name = "graceful-restartable-neighbor"
                            self.yang_parent_name = "graceful-restart"

                            self.connect_count = YLeaf(YType.uint32, "connect-count")

                            self.down_nbr_down_reason = YLeaf(YType.uint32, "down-nbr-down-reason")

                            self.down_nbr_flags = YLeaf(YType.uint32, "down-nbr-flags")

                            self.down_nbr_flap_count = YLeaf(YType.uint8, "down-nbr-flap-count")

                            self.is_liveness_timer_running = YLeaf(YType.boolean, "is-liveness-timer-running")

                            self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                            self.is_recovery_timer_running = YLeaf(YType.boolean, "is-recovery-timer-running")

                            self.liveness_timer_remaining_seconds = YLeaf(YType.uint32, "liveness-timer-remaining-seconds")

                            self.recovery_timer_remaining_seconds = YLeaf(YType.uint32, "recovery-timer-remaining-seconds")

                            self.gr_peer = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                            self.gr_peer.parent = self
                            self._children_name_map["gr_peer"] = "gr-peer"
                            self._children_yang_names.add("gr-peer")

                            self.down_nbr_address = YList(self)
                            self.down_nbr_interface = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("connect_count",
                                            "down_nbr_down_reason",
                                            "down_nbr_flags",
                                            "down_nbr_flap_count",
                                            "is_liveness_timer_running",
                                            "is_neighbor_up",
                                            "is_recovery_timer_running",
                                            "liveness_timer_remaining_seconds",
                                            "recovery_timer_remaining_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)


                        class GrPeer(Entity):
                            """
                            GR peer LDP Id
                            
                            .. attribute:: label_space_id
                            
                            	Label space identifier
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: ldp_id
                            
                            	LDP identifier
                            	**type**\:  str
                            
                            .. attribute:: lsr_id
                            
                            	LSR identifier
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__init__()

                                self.yang_name = "gr-peer"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "ldp_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.label_space_id.is_set or
                                    self.ldp_id.is_set or
                                    self.lsr_id.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.ldp_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gr-peer" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-id"):
                                    self.ldp_id = value
                                    self.ldp_id.value_namespace = name_space
                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix


                        class DownNbrInterface(Entity):
                            """
                            Interfaces bound to GR down Nbr
                            
                            .. attribute:: address_family
                            
                            	Interface adj Address Family
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: interface_handle
                            
                            	Interfaces handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__init__()

                                self.yang_name = "down-nbr-interface"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.interface_handle = YLeaf(YType.str, "interface-handle")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "interface_handle") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.interface_handle.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.interface_handle.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "down-nbr-interface" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.interface_handle.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-family" or name == "interface-handle"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "interface-handle"):
                                    self.interface_handle = value
                                    self.interface_handle.value_namespace = name_space
                                    self.interface_handle.value_namespace_prefix = name_space_prefix


                        class DownNbrAddress(Entity):
                            """
                            Addresses bound to GR down Nbr
                            
                            .. attribute:: afi
                            
                            	AFI
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: dummy
                            
                            	No Address
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: ipv4
                            
                            	IPv4 address type
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv6
                            
                            	IPv6 address type
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__init__()

                                self.yang_name = "down-nbr-address"
                                self.yang_parent_name = "graceful-restartable-neighbor"

                                self.afi = YLeaf(YType.enumeration, "afi")

                                self.dummy = YLeaf(YType.uint8, "dummy")

                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                self.ipv6 = YLeaf(YType.str, "ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("afi",
                                                "dummy",
                                                "ipv4",
                                                "ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.afi.is_set or
                                    self.dummy.is_set or
                                    self.ipv4.is_set or
                                    self.ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.afi.yfilter != YFilter.not_set or
                                    self.dummy.yfilter != YFilter.not_set or
                                    self.ipv4.yfilter != YFilter.not_set or
                                    self.ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "down-nbr-address" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "afi"):
                                    self.afi = value
                                    self.afi.value_namespace = name_space
                                    self.afi.value_namespace_prefix = name_space_prefix
                                if(value_path == "dummy"):
                                    self.dummy = value
                                    self.dummy.value_namespace = name_space
                                    self.dummy.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv4"):
                                    self.ipv4 = value
                                    self.ipv4.value_namespace = name_space
                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv6"):
                                    self.ipv6 = value
                                    self.ipv6.value_namespace = name_space
                                    self.ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.down_nbr_address:
                                if (c.has_data()):
                                    return True
                            for c in self.down_nbr_interface:
                                if (c.has_data()):
                                    return True
                            return (
                                self.connect_count.is_set or
                                self.down_nbr_down_reason.is_set or
                                self.down_nbr_flags.is_set or
                                self.down_nbr_flap_count.is_set or
                                self.is_liveness_timer_running.is_set or
                                self.is_neighbor_up.is_set or
                                self.is_recovery_timer_running.is_set or
                                self.liveness_timer_remaining_seconds.is_set or
                                self.recovery_timer_remaining_seconds.is_set or
                                (self.gr_peer is not None and self.gr_peer.has_data()))

                        def has_operation(self):
                            for c in self.down_nbr_address:
                                if (c.has_operation()):
                                    return True
                            for c in self.down_nbr_interface:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.connect_count.yfilter != YFilter.not_set or
                                self.down_nbr_down_reason.yfilter != YFilter.not_set or
                                self.down_nbr_flags.yfilter != YFilter.not_set or
                                self.down_nbr_flap_count.yfilter != YFilter.not_set or
                                self.is_liveness_timer_running.yfilter != YFilter.not_set or
                                self.is_neighbor_up.yfilter != YFilter.not_set or
                                self.is_recovery_timer_running.yfilter != YFilter.not_set or
                                self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set or
                                self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set or
                                (self.gr_peer is not None and self.gr_peer.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restartable-neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.connect_count.get_name_leafdata())
                            if (self.down_nbr_down_reason.is_set or self.down_nbr_down_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_down_reason.get_name_leafdata())
                            if (self.down_nbr_flags.is_set or self.down_nbr_flags.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_flags.get_name_leafdata())
                            if (self.down_nbr_flap_count.is_set or self.down_nbr_flap_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_nbr_flap_count.get_name_leafdata())
                            if (self.is_liveness_timer_running.is_set or self.is_liveness_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_liveness_timer_running.get_name_leafdata())
                            if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                            if (self.is_recovery_timer_running.is_set or self.is_recovery_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_recovery_timer_running.get_name_leafdata())
                            if (self.liveness_timer_remaining_seconds.is_set or self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.liveness_timer_remaining_seconds.get_name_leafdata())
                            if (self.recovery_timer_remaining_seconds.is_set or self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.recovery_timer_remaining_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "down-nbr-address"):
                                for c in self.down_nbr_address:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.down_nbr_address.append(c)
                                return c

                            if (child_yang_name == "down-nbr-interface"):
                                for c in self.down_nbr_interface:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.down_nbr_interface.append(c)
                                return c

                            if (child_yang_name == "gr-peer"):
                                if (self.gr_peer is None):
                                    self.gr_peer = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                    self.gr_peer.parent = self
                                    self._children_name_map["gr_peer"] = "gr-peer"
                                return self.gr_peer

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "down-nbr-address" or name == "down-nbr-interface" or name == "gr-peer" or name == "connect-count" or name == "down-nbr-down-reason" or name == "down-nbr-flags" or name == "down-nbr-flap-count" or name == "is-liveness-timer-running" or name == "is-neighbor-up" or name == "is-recovery-timer-running" or name == "liveness-timer-remaining-seconds" or name == "recovery-timer-remaining-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "connect-count"):
                                self.connect_count = value
                                self.connect_count.value_namespace = name_space
                                self.connect_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-down-reason"):
                                self.down_nbr_down_reason = value
                                self.down_nbr_down_reason.value_namespace = name_space
                                self.down_nbr_down_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-flags"):
                                self.down_nbr_flags = value
                                self.down_nbr_flags.value_namespace = name_space
                                self.down_nbr_flags.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-nbr-flap-count"):
                                self.down_nbr_flap_count = value
                                self.down_nbr_flap_count.value_namespace = name_space
                                self.down_nbr_flap_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-liveness-timer-running"):
                                self.is_liveness_timer_running = value
                                self.is_liveness_timer_running.value_namespace = name_space
                                self.is_liveness_timer_running.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-neighbor-up"):
                                self.is_neighbor_up = value
                                self.is_neighbor_up.value_namespace = name_space
                                self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-recovery-timer-running"):
                                self.is_recovery_timer_running = value
                                self.is_recovery_timer_running.value_namespace = name_space
                                self.is_recovery_timer_running.value_namespace_prefix = name_space_prefix
                            if(value_path == "liveness-timer-remaining-seconds"):
                                self.liveness_timer_remaining_seconds = value
                                self.liveness_timer_remaining_seconds.value_namespace = name_space
                                self.liveness_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "recovery-timer-remaining-seconds"):
                                self.recovery_timer_remaining_seconds = value
                                self.recovery_timer_remaining_seconds.value_namespace = name_space
                                self.recovery_timer_remaining_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.graceful_restartable_neighbor:
                            if (c.has_data()):
                                return True
                        return (
                            self.forwarding_state_hold_timer_remaining_seconds.is_set or
                            self.is_forwarding_state_hold_timer_running.is_set or
                            (self.vrf is not None and self.vrf.has_data()))

                    def has_operation(self):
                        for c in self.graceful_restartable_neighbor:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set or
                            self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set or
                            (self.vrf is not None and self.vrf.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "graceful-restart" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.forwarding_state_hold_timer_remaining_seconds.is_set or self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forwarding_state_hold_timer_remaining_seconds.get_name_leafdata())
                        if (self.is_forwarding_state_hold_timer_running.is_set or self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_forwarding_state_hold_timer_running.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "graceful-restartable-neighbor"):
                            for c in self.graceful_restartable_neighbor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.GracefulRestartableNeighbor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.graceful_restartable_neighbor.append(c)
                            return c

                        if (child_yang_name == "vrf"):
                            if (self.vrf is None):
                                self.vrf = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                            return self.vrf

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "graceful-restartable-neighbor" or name == "vrf" or name == "forwarding-state-hold-timer-remaining-seconds" or name == "is-forwarding-state-hold-timer-running"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "forwarding-state-hold-timer-remaining-seconds"):
                            self.forwarding_state_hold_timer_remaining_seconds = value
                            self.forwarding_state_hold_timer_remaining_seconds.value_namespace = name_space
                            self.forwarding_state_hold_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-forwarding-state-hold-timer-running"):
                            self.is_forwarding_state_hold_timer_running = value
                            self.is_forwarding_state_hold_timer_running.value_namespace = name_space
                            self.is_forwarding_state_hold_timer_running.value_namespace_prefix = name_space_prefix


                class Capabilities(Entity):
                    """
                    LDP capability database information
                    
                    .. attribute:: capability
                    
                    	Information on LDP capability
                    	**type**\: list of    :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities, self).__init__()

                        self.yang_name = "capabilities"
                        self.yang_parent_name = "default-vrf"

                        self.capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities, self).__setattr__(name, value)


                    class Capability(Entity):
                        """
                        Information on LDP capability
                        
                        .. attribute:: capability_type  <key>
                        
                        	The capability type (IANA assigned)
                        	**type**\:  int
                        
                        	**range:** \-2147483648..2147483647
                        
                        .. attribute:: capability
                        
                        	Capability information
                        	**type**\:   :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability.Capability>`
                        
                        .. attribute:: capability_owner
                        
                        	Capability owner
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability, self).__init__()

                            self.yang_name = "capability"
                            self.yang_parent_name = "capabilities"

                            self.capability_type = YLeaf(YType.int32, "capability-type")

                            self.capability_owner = YLeaf(YType.str, "capability-owner")

                            self.capability = MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability.Capability()
                            self.capability.parent = self
                            self._children_name_map["capability"] = "capability"
                            self._children_yang_names.add("capability")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("capability_type",
                                            "capability_owner") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability, self).__setattr__(name, value)


                        class Capability(Entity):
                            """
                            Capability information
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability.Capability, self).__init__()

                                self.yang_name = "capability"
                                self.yang_parent_name = "capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability.Capability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability.Capability, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "capability" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.capability_type.is_set or
                                self.capability_owner.is_set or
                                (self.capability is not None and self.capability.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.capability_type.yfilter != YFilter.not_set or
                                self.capability_owner.yfilter != YFilter.not_set or
                                (self.capability is not None and self.capability.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "capability" + "[capability-type='" + self.capability_type.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.capability_type.is_set or self.capability_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.capability_type.get_name_leafdata())
                            if (self.capability_owner.is_set or self.capability_owner.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.capability_owner.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "capability"):
                                if (self.capability is None):
                                    self.capability = MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability.Capability()
                                    self.capability.parent = self
                                    self._children_name_map["capability"] = "capability"
                                return self.capability

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "capability" or name == "capability-type" or name == "capability-owner"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "capability-type"):
                                self.capability_type = value
                                self.capability_type.value_namespace = name_space
                                self.capability_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "capability-owner"):
                                self.capability_owner = value
                                self.capability_owner.value_namespace = name_space
                                self.capability_owner.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "capability"):
                            for c in self.capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.Capabilities.Capability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Summary(Entity):
                    """
                    LDP VRF summary
                    
                    .. attribute:: common
                    
                    	Common Summary information
                    	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Summary.Common>`
                    
                    .. attribute:: vrf
                    
                    	VRF information
                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Summary.Vrf>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "default-vrf"

                        self.common = MplsLdp.Nodes.Node.DefaultVrf.Summary.Common()
                        self.common.parent = self
                        self._children_name_map["common"] = "common"
                        self._children_yang_names.add("common")

                        self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Summary.Vrf()
                        self.vrf.parent = self
                        self._children_name_map["vrf"] = "vrf"
                        self._children_yang_names.add("vrf")


                    class Vrf(Entity):
                        """
                        VRF information
                        
                        .. attribute:: id
                        
                        	VRF Id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: name
                        
                        	VRF Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Summary.Vrf, self).__init__()

                            self.yang_name = "vrf"
                            self.yang_parent_name = "summary"

                            self.id = YLeaf(YType.uint32, "id")

                            self.name = YLeaf(YType.str, "name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("id",
                                            "name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Summary.Vrf, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Summary.Vrf, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.id.is_set or
                                self.name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.id.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vrf" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.id.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "id" or name == "name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "id"):
                                self.id = value
                                self.id.value_namespace = name_space
                                self.id.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix


                    class Common(Entity):
                        """
                        Common Summary information
                        
                        .. attribute:: address_families
                        
                        	Address Families enabled
                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                        
                        .. attribute:: number_of_bindings_ipv4
                        
                        	Total number of ipv4 bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_bindings_ipv6
                        
                        	Total number of ipv6 bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_downstream_on_demand_neighbors
                        
                        	Number of Downstream\-On\-Demand neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_graceful_restart_neighbors
                        
                        	Number of Graceful Restart neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_hello_adj
                        
                        	Number of LDP discovery IPv4 hello adjacencies
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_local_addresses
                        
                        	Number of IPv4 local addresses
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4_routes
                        
                        	Number of resolved IPv4 routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4af
                        
                        	Number of IPv4 address\-families enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv4ldp_interfaces
                        
                        	Number of LDP IPv4 configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_hello_adj
                        
                        	Number of LDP discovery IPv6 hello adjacencies
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_local_addresses
                        
                        	Number of IPv6 local addresses
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6_routes
                        
                        	Number of resolved IPv6 routes
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6af
                        
                        	Number of IPv6 address\-families enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ipv6ldp_interfaces
                        
                        	Number of LDP IPv6 configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_ldp_interfaces
                        
                        	Number of LDP configured interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_local_bindings_ipv4
                        
                        	Total number of ipv4 local label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_local_bindings_ipv6
                        
                        	Total number of ipv6 local label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_neighbors
                        
                        	Number of neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_nsr_synced_neighbors
                        
                        	Number of NSR\-synced/operational neighbors
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_remote_bindings_ipv4
                        
                        	Total number of ipv4 remote label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: number_of_remote_bindings_ipv6
                        
                        	Total number of ipv6 remote label bindings
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Summary.Common, self).__init__()

                            self.yang_name = "common"
                            self.yang_parent_name = "summary"

                            self.address_families = YLeaf(YType.enumeration, "address-families")

                            self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                            self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                            self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                            self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                            self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                            self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                            self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                            self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                            self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                            self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                            self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                            self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                            self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                            self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                            self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                            self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                            self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                            self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                            self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                            self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                            self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("address_families",
                                            "number_of_bindings_ipv4",
                                            "number_of_bindings_ipv6",
                                            "number_of_downstream_on_demand_neighbors",
                                            "number_of_graceful_restart_neighbors",
                                            "number_of_ipv4_hello_adj",
                                            "number_of_ipv4_local_addresses",
                                            "number_of_ipv4_routes",
                                            "number_of_ipv4af",
                                            "number_of_ipv4ldp_interfaces",
                                            "number_of_ipv6_hello_adj",
                                            "number_of_ipv6_local_addresses",
                                            "number_of_ipv6_routes",
                                            "number_of_ipv6af",
                                            "number_of_ipv6ldp_interfaces",
                                            "number_of_ldp_interfaces",
                                            "number_of_local_bindings_ipv4",
                                            "number_of_local_bindings_ipv6",
                                            "number_of_neighbors",
                                            "number_of_nsr_synced_neighbors",
                                            "number_of_remote_bindings_ipv4",
                                            "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Summary.Common, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Summary.Common, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.address_families.is_set or
                                self.number_of_bindings_ipv4.is_set or
                                self.number_of_bindings_ipv6.is_set or
                                self.number_of_downstream_on_demand_neighbors.is_set or
                                self.number_of_graceful_restart_neighbors.is_set or
                                self.number_of_ipv4_hello_adj.is_set or
                                self.number_of_ipv4_local_addresses.is_set or
                                self.number_of_ipv4_routes.is_set or
                                self.number_of_ipv4af.is_set or
                                self.number_of_ipv4ldp_interfaces.is_set or
                                self.number_of_ipv6_hello_adj.is_set or
                                self.number_of_ipv6_local_addresses.is_set or
                                self.number_of_ipv6_routes.is_set or
                                self.number_of_ipv6af.is_set or
                                self.number_of_ipv6ldp_interfaces.is_set or
                                self.number_of_ldp_interfaces.is_set or
                                self.number_of_local_bindings_ipv4.is_set or
                                self.number_of_local_bindings_ipv6.is_set or
                                self.number_of_neighbors.is_set or
                                self.number_of_nsr_synced_neighbors.is_set or
                                self.number_of_remote_bindings_ipv4.is_set or
                                self.number_of_remote_bindings_ipv6.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.address_families.yfilter != YFilter.not_set or
                                self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                                self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                                self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                                self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                                self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                                self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                                self.number_of_ipv4af.yfilter != YFilter.not_set or
                                self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                                self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                                self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                                self.number_of_ipv6af.yfilter != YFilter.not_set or
                                self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                                self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                                self.number_of_neighbors.yfilter != YFilter.not_set or
                                self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                                self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                                self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "common" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.address_families.get_name_leafdata())
                            if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                            if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                            if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                            if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                            if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                            if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                            if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                            if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                            if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                            if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                            if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                            if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                            if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                            if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                            if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                            if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                            if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                            if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                            if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "address-families"):
                                self.address_families = value
                                self.address_families.value_namespace = name_space
                                self.address_families.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-bindings-ipv4"):
                                self.number_of_bindings_ipv4 = value
                                self.number_of_bindings_ipv4.value_namespace = name_space
                                self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-bindings-ipv6"):
                                self.number_of_bindings_ipv6 = value
                                self.number_of_bindings_ipv6.value_namespace = name_space
                                self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-downstream-on-demand-neighbors"):
                                self.number_of_downstream_on_demand_neighbors = value
                                self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                                self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-graceful-restart-neighbors"):
                                self.number_of_graceful_restart_neighbors = value
                                self.number_of_graceful_restart_neighbors.value_namespace = name_space
                                self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-hello-adj"):
                                self.number_of_ipv4_hello_adj = value
                                self.number_of_ipv4_hello_adj.value_namespace = name_space
                                self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-local-addresses"):
                                self.number_of_ipv4_local_addresses = value
                                self.number_of_ipv4_local_addresses.value_namespace = name_space
                                self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4-routes"):
                                self.number_of_ipv4_routes = value
                                self.number_of_ipv4_routes.value_namespace = name_space
                                self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4af"):
                                self.number_of_ipv4af = value
                                self.number_of_ipv4af.value_namespace = name_space
                                self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv4ldp-interfaces"):
                                self.number_of_ipv4ldp_interfaces = value
                                self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                                self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-hello-adj"):
                                self.number_of_ipv6_hello_adj = value
                                self.number_of_ipv6_hello_adj.value_namespace = name_space
                                self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-local-addresses"):
                                self.number_of_ipv6_local_addresses = value
                                self.number_of_ipv6_local_addresses.value_namespace = name_space
                                self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6-routes"):
                                self.number_of_ipv6_routes = value
                                self.number_of_ipv6_routes.value_namespace = name_space
                                self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6af"):
                                self.number_of_ipv6af = value
                                self.number_of_ipv6af.value_namespace = name_space
                                self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ipv6ldp-interfaces"):
                                self.number_of_ipv6ldp_interfaces = value
                                self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                                self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-ldp-interfaces"):
                                self.number_of_ldp_interfaces = value
                                self.number_of_ldp_interfaces.value_namespace = name_space
                                self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-local-bindings-ipv4"):
                                self.number_of_local_bindings_ipv4 = value
                                self.number_of_local_bindings_ipv4.value_namespace = name_space
                                self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-local-bindings-ipv6"):
                                self.number_of_local_bindings_ipv6 = value
                                self.number_of_local_bindings_ipv6.value_namespace = name_space
                                self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-neighbors"):
                                self.number_of_neighbors = value
                                self.number_of_neighbors.value_namespace = name_space
                                self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-nsr-synced-neighbors"):
                                self.number_of_nsr_synced_neighbors = value
                                self.number_of_nsr_synced_neighbors.value_namespace = name_space
                                self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-remote-bindings-ipv4"):
                                self.number_of_remote_bindings_ipv4 = value
                                self.number_of_remote_bindings_ipv4.value_namespace = name_space
                                self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                            if(value_path == "number-of-remote-bindings-ipv6"):
                                self.number_of_remote_bindings_ipv6 = value
                                self.number_of_remote_bindings_ipv6.value_namespace = name_space
                                self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.common is not None and self.common.has_data()) or
                            (self.vrf is not None and self.vrf.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.common is not None and self.common.has_operation()) or
                            (self.vrf is not None and self.vrf.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "common"):
                            if (self.common is None):
                                self.common = MplsLdp.Nodes.Node.DefaultVrf.Summary.Common()
                                self.common.parent = self
                                self._children_name_map["common"] = "common"
                            return self.common

                        if (child_yang_name == "vrf"):
                            if (self.vrf is None):
                                self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Summary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                            return self.vrf

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "common" or name == "vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Afs(Entity):
                    """
                    Address Family specific operational data
                    
                    .. attribute:: af
                    
                    	Operational data for given Address Family
                    	**type**\: list of    :py:class:`Af <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs, self).__init__()

                        self.yang_name = "afs"
                        self.yang_parent_name = "default-vrf"

                        self.af = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs, self).__setattr__(name, value)


                    class Af(Entity):
                        """
                        Operational data for given Address Family
                        
                        .. attribute:: af_name  <key>
                        
                        	Address Family name
                        	**type**\:   :py:class:`MplsLdpOperAfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdpOperAfName>`
                        
                        .. attribute:: bindings
                        
                        	The LDP Bindings
                        	**type**\:   :py:class:`Bindings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings>`
                        
                        .. attribute:: bindings_advertise_spec
                        
                        	Advertisement Spec (ACL) for LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsAdvertiseSpec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec>`
                        
                        .. attribute:: bindings_summary
                        
                        	Counters for the LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary>`
                        
                        .. attribute:: bindings_summary_all
                        
                        	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
                        	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll>`
                        
                        .. attribute:: discovery
                        
                        	The LDP Discovery
                        	**type**\:   :py:class:`Discovery <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery>`
                        
                        .. attribute:: forwarding_summary
                        
                        	Summary information regarding LDP forwarding setup
                        	**type**\:   :py:class:`ForwardingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary>`
                        
                        .. attribute:: forwardings
                        
                        	The LDP Forwarding rewrites
                        	**type**\:   :py:class:`Forwardings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings>`
                        
                        .. attribute:: igp
                        
                        	LDP IGP related information
                        	**type**\:   :py:class:`Igp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp>`
                        
                        .. attribute:: interface_summary
                        
                        	IPv4 interface summary information
                        	**type**\:   :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.InterfaceSummary>`
                        
                        .. attribute:: interfaces
                        
                        	LDP Interface related information
                        	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af, self).__init__()

                            self.yang_name = "af"
                            self.yang_parent_name = "afs"

                            self.af_name = YLeaf(YType.enumeration, "af-name")

                            self.bindings = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings()
                            self.bindings.parent = self
                            self._children_name_map["bindings"] = "bindings"
                            self._children_yang_names.add("bindings")

                            self.bindings_advertise_spec = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec()
                            self.bindings_advertise_spec.parent = self
                            self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                            self._children_yang_names.add("bindings-advertise-spec")

                            self.bindings_summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary()
                            self.bindings_summary.parent = self
                            self._children_name_map["bindings_summary"] = "bindings-summary"
                            self._children_yang_names.add("bindings-summary")

                            self.bindings_summary_all = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll()
                            self.bindings_summary_all.parent = self
                            self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                            self._children_yang_names.add("bindings-summary-all")

                            self.discovery = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery()
                            self.discovery.parent = self
                            self._children_name_map["discovery"] = "discovery"
                            self._children_yang_names.add("discovery")

                            self.forwarding_summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary()
                            self.forwarding_summary.parent = self
                            self._children_name_map["forwarding_summary"] = "forwarding-summary"
                            self._children_yang_names.add("forwarding-summary")

                            self.forwardings = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings()
                            self.forwardings.parent = self
                            self._children_name_map["forwardings"] = "forwardings"
                            self._children_yang_names.add("forwardings")

                            self.igp = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp()
                            self.igp.parent = self
                            self._children_name_map["igp"] = "igp"
                            self._children_yang_names.add("igp")

                            self.interface_summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.InterfaceSummary()
                            self.interface_summary.parent = self
                            self._children_name_map["interface_summary"] = "interface-summary"
                            self._children_yang_names.add("interface-summary")

                            self.interfaces = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces()
                            self.interfaces.parent = self
                            self._children_name_map["interfaces"] = "interfaces"
                            self._children_yang_names.add("interfaces")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("af_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af, self).__setattr__(name, value)


                        class InterfaceSummary(Entity):
                            """
                            IPv4 interface summary information
                            
                            .. attribute:: auto_config
                            
                            	Auto\-configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: auto_config_disabled
                            
                            	Autoconfigure disabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: auto_config_forward_reference_interfaces
                            
                            	Auto\-configured forward references
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: forward_references
                            
                            	Number of forward referenced interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: known_ip_interface_count
                            
                            	Number of known IP Interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: known_ip_interface_ldp_enabled
                            
                            	Number of known IP Interfaces with LDP Enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ldp_configured_attached_interface
                            
                            	Number of attached interfaces configured in LDP
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ldp_configured_te_interface
                            
                            	Number of TE tunnel interfaces configured in LDP
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.InterfaceSummary, self).__init__()

                                self.yang_name = "interface-summary"
                                self.yang_parent_name = "af"

                                self.auto_config = YLeaf(YType.uint32, "auto-config")

                                self.auto_config_disabled = YLeaf(YType.uint32, "auto-config-disabled")

                                self.auto_config_forward_reference_interfaces = YLeaf(YType.uint32, "auto-config-forward-reference-interfaces")

                                self.forward_references = YLeaf(YType.uint32, "forward-references")

                                self.known_ip_interface_count = YLeaf(YType.uint32, "known-ip-interface-count")

                                self.known_ip_interface_ldp_enabled = YLeaf(YType.uint32, "known-ip-interface-ldp-enabled")

                                self.ldp_configured_attached_interface = YLeaf(YType.uint32, "ldp-configured-attached-interface")

                                self.ldp_configured_te_interface = YLeaf(YType.uint32, "ldp-configured-te-interface")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("auto_config",
                                                "auto_config_disabled",
                                                "auto_config_forward_reference_interfaces",
                                                "forward_references",
                                                "known_ip_interface_count",
                                                "known_ip_interface_ldp_enabled",
                                                "ldp_configured_attached_interface",
                                                "ldp_configured_te_interface") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.auto_config.is_set or
                                    self.auto_config_disabled.is_set or
                                    self.auto_config_forward_reference_interfaces.is_set or
                                    self.forward_references.is_set or
                                    self.known_ip_interface_count.is_set or
                                    self.known_ip_interface_ldp_enabled.is_set or
                                    self.ldp_configured_attached_interface.is_set or
                                    self.ldp_configured_te_interface.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.auto_config.yfilter != YFilter.not_set or
                                    self.auto_config_disabled.yfilter != YFilter.not_set or
                                    self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set or
                                    self.forward_references.yfilter != YFilter.not_set or
                                    self.known_ip_interface_count.yfilter != YFilter.not_set or
                                    self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set or
                                    self.ldp_configured_attached_interface.yfilter != YFilter.not_set or
                                    self.ldp_configured_te_interface.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interface-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.auto_config.is_set or self.auto_config.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config.get_name_leafdata())
                                if (self.auto_config_disabled.is_set or self.auto_config_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config_disabled.get_name_leafdata())
                                if (self.auto_config_forward_reference_interfaces.is_set or self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_config_forward_reference_interfaces.get_name_leafdata())
                                if (self.forward_references.is_set or self.forward_references.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_references.get_name_leafdata())
                                if (self.known_ip_interface_count.is_set or self.known_ip_interface_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.known_ip_interface_count.get_name_leafdata())
                                if (self.known_ip_interface_ldp_enabled.is_set or self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.known_ip_interface_ldp_enabled.get_name_leafdata())
                                if (self.ldp_configured_attached_interface.is_set or self.ldp_configured_attached_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_configured_attached_interface.get_name_leafdata())
                                if (self.ldp_configured_te_interface.is_set or self.ldp_configured_te_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ldp_configured_te_interface.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "auto-config" or name == "auto-config-disabled" or name == "auto-config-forward-reference-interfaces" or name == "forward-references" or name == "known-ip-interface-count" or name == "known-ip-interface-ldp-enabled" or name == "ldp-configured-attached-interface" or name == "ldp-configured-te-interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "auto-config"):
                                    self.auto_config = value
                                    self.auto_config.value_namespace = name_space
                                    self.auto_config.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-config-disabled"):
                                    self.auto_config_disabled = value
                                    self.auto_config_disabled.value_namespace = name_space
                                    self.auto_config_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-config-forward-reference-interfaces"):
                                    self.auto_config_forward_reference_interfaces = value
                                    self.auto_config_forward_reference_interfaces.value_namespace = name_space
                                    self.auto_config_forward_reference_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-references"):
                                    self.forward_references = value
                                    self.forward_references.value_namespace = name_space
                                    self.forward_references.value_namespace_prefix = name_space_prefix
                                if(value_path == "known-ip-interface-count"):
                                    self.known_ip_interface_count = value
                                    self.known_ip_interface_count.value_namespace = name_space
                                    self.known_ip_interface_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "known-ip-interface-ldp-enabled"):
                                    self.known_ip_interface_ldp_enabled = value
                                    self.known_ip_interface_ldp_enabled.value_namespace = name_space
                                    self.known_ip_interface_ldp_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-configured-attached-interface"):
                                    self.ldp_configured_attached_interface = value
                                    self.ldp_configured_attached_interface.value_namespace = name_space
                                    self.ldp_configured_attached_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "ldp-configured-te-interface"):
                                    self.ldp_configured_te_interface = value
                                    self.ldp_configured_te_interface.value_namespace = name_space
                                    self.ldp_configured_te_interface.value_namespace_prefix = name_space_prefix


                        class Bindings(Entity):
                            """
                            The LDP Bindings
                            
                            .. attribute:: binding
                            
                            	Binding Information
                            	**type**\: list of    :py:class:`Binding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings, self).__init__()

                                self.yang_name = "bindings"
                                self.yang_parent_name = "af"

                                self.binding = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings, self).__setattr__(name, value)


                            class Binding(Entity):
                                """
                                Binding Information
                                
                                .. attribute:: prefix  <key>
                                
                                	The IP Prefix
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                
                                
                                ----
                                .. attribute:: advertise_prefix_acl
                                
                                	Advertise Prerfix ACL
                                	**type**\:  str
                                
                                .. attribute:: advertise_tsr_acl
                                
                                	Advertise TSR ACL
                                	**type**\:  str
                                
                                .. attribute:: config_enforced_local_label_value
                                
                                	Config/User enforced local label value
                                	**type**\:  bool
                                
                                .. attribute:: is_elc
                                
                                	Is the entry entropy label capable
                                	**type**\:  bool
                                
                                .. attribute:: is_no_route
                                
                                	No route
                                	**type**\:  bool
                                
                                .. attribute:: label_oor
                                
                                	Label space depletion OOR
                                	**type**\:  bool
                                
                                .. attribute:: le_local_binding_revision
                                
                                	Local Binding revision
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: le_local_label_state
                                
                                	Local label state
                                	**type**\:   :py:class:`LocalLabelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LocalLabelState>`
                                
                                .. attribute:: local_label
                                
                                	Local label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: peers_acked
                                
                                	Peers that have ACKed this entry
                                	**type**\: list of    :py:class:`PeersAcked <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked>`
                                
                                .. attribute:: peers_advertised_to
                                
                                	Peers this entry is advertised to
                                	**type**\: list of    :py:class:`PeersAdvertisedTo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo>`
                                
                                .. attribute:: prefix_length
                                
                                	Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: prefix_xr
                                
                                	IP Prefix
                                	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr>`
                                
                                .. attribute:: remote_binding
                                
                                	Remote binding
                                	**type**\: list of    :py:class:`RemoteBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding, self).__init__()

                                    self.yang_name = "binding"
                                    self.yang_parent_name = "bindings"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.advertise_prefix_acl = YLeaf(YType.str, "advertise-prefix-acl")

                                    self.advertise_tsr_acl = YLeaf(YType.str, "advertise-tsr-acl")

                                    self.config_enforced_local_label_value = YLeaf(YType.boolean, "config-enforced-local-label-value")

                                    self.is_elc = YLeaf(YType.boolean, "is-elc")

                                    self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                    self.label_oor = YLeaf(YType.boolean, "label-oor")

                                    self.le_local_binding_revision = YLeaf(YType.uint32, "le-local-binding-revision")

                                    self.le_local_label_state = YLeaf(YType.enumeration, "le-local-label-state")

                                    self.local_label = YLeaf(YType.uint32, "local-label")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.prefix_xr = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr()
                                    self.prefix_xr.parent = self
                                    self._children_name_map["prefix_xr"] = "prefix-xr"
                                    self._children_yang_names.add("prefix-xr")

                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.peers_acked = YList(self)
                                    self.peers_advertised_to = YList(self)
                                    self.remote_binding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "advertise_prefix_acl",
                                                    "advertise_tsr_acl",
                                                    "config_enforced_local_label_value",
                                                    "is_elc",
                                                    "is_no_route",
                                                    "label_oor",
                                                    "le_local_binding_revision",
                                                    "le_local_label_state",
                                                    "local_label",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "binding"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class PrefixXr(Entity):
                                    """
                                    IP Prefix
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__init__()

                                        self.yang_name = "prefix-xr"
                                        self.yang_parent_name = "binding"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prefix-xr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class RemoteBinding(Entity):
                                    """
                                    Remote binding
                                    
                                    .. attribute:: assigning_peer_ldp_ident
                                    
                                    	Assigning peer
                                    	**type**\:   :py:class:`AssigningPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent>`
                                    
                                    .. attribute:: is_elc
                                    
                                    	Is the entry entropy label capable
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_stale
                                    
                                    	Is the entry stale
                                    	**type**\:  bool
                                    
                                    .. attribute:: remote_label
                                    
                                    	Remote Label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__init__()

                                        self.yang_name = "remote-binding"
                                        self.yang_parent_name = "binding"

                                        self.is_elc = YLeaf(YType.boolean, "is-elc")

                                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                                        self.remote_label = YLeaf(YType.uint32, "remote-label")

                                        self.assigning_peer_ldp_ident = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                        self.assigning_peer_ldp_ident.parent = self
                                        self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                        self._children_yang_names.add("assigning-peer-ldp-ident")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_elc",
                                                        "is_stale",
                                                        "remote_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)


                                    class AssigningPeerLdpIdent(Entity):
                                        """
                                        Assigning peer
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__init__()

                                            self.yang_name = "assigning-peer-ldp-ident"
                                            self.yang_parent_name = "remote-binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "assigning-peer-ldp-ident" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.is_elc.is_set or
                                            self.is_stale.is_set or
                                            self.remote_label.is_set or
                                            (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_elc.yfilter != YFilter.not_set or
                                            self.is_stale.yfilter != YFilter.not_set or
                                            self.remote_label.yfilter != YFilter.not_set or
                                            (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "remote-binding" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_elc.get_name_leafdata())
                                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                                        if (self.remote_label.is_set or self.remote_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "assigning-peer-ldp-ident"):
                                            if (self.assigning_peer_ldp_ident is None):
                                                self.assigning_peer_ldp_ident = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                                self.assigning_peer_ldp_ident.parent = self
                                                self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                            return self.assigning_peer_ldp_ident

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "assigning-peer-ldp-ident" or name == "is-elc" or name == "is-stale" or name == "remote-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-elc"):
                                            self.is_elc = value
                                            self.is_elc.value_namespace = name_space
                                            self.is_elc.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-stale"):
                                            self.is_stale = value
                                            self.is_stale.value_namespace = name_space
                                            self.is_stale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-label"):
                                            self.remote_label = value
                                            self.remote_label.value_namespace = name_space
                                            self.remote_label.value_namespace_prefix = name_space_prefix


                                class PeersAdvertisedTo(Entity):
                                    """
                                    Peers this entry is advertised to
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: ldp_id
                                    
                                    	LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__init__()

                                        self.yang_name = "peers-advertised-to"
                                        self.yang_parent_name = "binding"

                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "ldp_id",
                                                        "lsr_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.ldp_id.is_set or
                                            self.lsr_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.ldp_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "peers-advertised-to" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-id"):
                                            self.ldp_id = value
                                            self.ldp_id.value_namespace = name_space
                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix


                                class PeersAcked(Entity):
                                    """
                                    Peers that have ACKed this entry
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: ldp_id
                                    
                                    	LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__init__()

                                        self.yang_name = "peers-acked"
                                        self.yang_parent_name = "binding"

                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "ldp_id",
                                                        "lsr_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.ldp_id.is_set or
                                            self.lsr_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.ldp_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "peers-acked" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-id"):
                                            self.ldp_id = value
                                            self.ldp_id.value_namespace = name_space
                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.peers_acked:
                                        if (c.has_data()):
                                            return True
                                    for c in self.peers_advertised_to:
                                        if (c.has_data()):
                                            return True
                                    for c in self.remote_binding:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.prefix.is_set or
                                        self.advertise_prefix_acl.is_set or
                                        self.advertise_tsr_acl.is_set or
                                        self.config_enforced_local_label_value.is_set or
                                        self.is_elc.is_set or
                                        self.is_no_route.is_set or
                                        self.label_oor.is_set or
                                        self.le_local_binding_revision.is_set or
                                        self.le_local_label_state.is_set or
                                        self.local_label.is_set or
                                        self.prefix_length.is_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.peers_acked:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.peers_advertised_to:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.remote_binding:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.advertise_prefix_acl.yfilter != YFilter.not_set or
                                        self.advertise_tsr_acl.yfilter != YFilter.not_set or
                                        self.config_enforced_local_label_value.yfilter != YFilter.not_set or
                                        self.is_elc.yfilter != YFilter.not_set or
                                        self.is_no_route.yfilter != YFilter.not_set or
                                        self.label_oor.yfilter != YFilter.not_set or
                                        self.le_local_binding_revision.yfilter != YFilter.not_set or
                                        self.le_local_label_state.yfilter != YFilter.not_set or
                                        self.local_label.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "binding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.advertise_prefix_acl.is_set or self.advertise_prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_prefix_acl.get_name_leafdata())
                                    if (self.advertise_tsr_acl.is_set or self.advertise_tsr_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_tsr_acl.get_name_leafdata())
                                    if (self.config_enforced_local_label_value.is_set or self.config_enforced_local_label_value.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.config_enforced_local_label_value.get_name_leafdata())
                                    if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_elc.get_name_leafdata())
                                    if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                    if (self.label_oor.is_set or self.label_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_oor.get_name_leafdata())
                                    if (self.le_local_binding_revision.is_set or self.le_local_binding_revision.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.le_local_binding_revision.get_name_leafdata())
                                    if (self.le_local_label_state.is_set or self.le_local_label_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.le_local_label_state.get_name_leafdata())
                                    if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_label.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "peers-acked"):
                                        for c in self.peers_acked:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAcked()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.peers_acked.append(c)
                                        return c

                                    if (child_yang_name == "peers-advertised-to"):
                                        for c in self.peers_advertised_to:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.peers_advertised_to.append(c)
                                        return c

                                    if (child_yang_name == "prefix-xr"):
                                        if (self.prefix_xr is None):
                                            self.prefix_xr = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.PrefixXr()
                                            self.prefix_xr.parent = self
                                            self._children_name_map["prefix_xr"] = "prefix-xr"
                                        return self.prefix_xr

                                    if (child_yang_name == "remote-binding"):
                                        for c in self.remote_binding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.RemoteBinding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.remote_binding.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "peers-acked" or name == "peers-advertised-to" or name == "prefix-xr" or name == "remote-binding" or name == "vrf" or name == "prefix" or name == "advertise-prefix-acl" or name == "advertise-tsr-acl" or name == "config-enforced-local-label-value" or name == "is-elc" or name == "is-no-route" or name == "label-oor" or name == "le-local-binding-revision" or name == "le-local-label-state" or name == "local-label" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "advertise-prefix-acl"):
                                        self.advertise_prefix_acl = value
                                        self.advertise_prefix_acl.value_namespace = name_space
                                        self.advertise_prefix_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "advertise-tsr-acl"):
                                        self.advertise_tsr_acl = value
                                        self.advertise_tsr_acl.value_namespace = name_space
                                        self.advertise_tsr_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "config-enforced-local-label-value"):
                                        self.config_enforced_local_label_value = value
                                        self.config_enforced_local_label_value.value_namespace = name_space
                                        self.config_enforced_local_label_value.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-elc"):
                                        self.is_elc = value
                                        self.is_elc.value_namespace = name_space
                                        self.is_elc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-no-route"):
                                        self.is_no_route = value
                                        self.is_no_route.value_namespace = name_space
                                        self.is_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-oor"):
                                        self.label_oor = value
                                        self.label_oor.value_namespace = name_space
                                        self.label_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "le-local-binding-revision"):
                                        self.le_local_binding_revision = value
                                        self.le_local_binding_revision.value_namespace = name_space
                                        self.le_local_binding_revision.value_namespace_prefix = name_space_prefix
                                    if(value_path == "le-local-label-state"):
                                        self.le_local_label_state = value
                                        self.le_local_label_state.value_namespace = name_space
                                        self.le_local_label_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-label"):
                                        self.local_label = value
                                        self.local_label.value_namespace = name_space
                                        self.local_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.binding:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.binding:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "binding"):
                                    for c in self.binding:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings.Binding()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.binding.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "binding"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Igp(Entity):
                            """
                            LDP IGP related information
                            
                            .. attribute:: sync_delay_restart
                            
                            	LDP\-IGP Synchronization Delay related information
                            	**type**\:   :py:class:`SyncDelayRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.SyncDelayRestart>`
                            
                            .. attribute:: syncs
                            
                            	LDP IGP Sync related information
                            	**type**\:   :py:class:`Syncs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp, self).__init__()

                                self.yang_name = "igp"
                                self.yang_parent_name = "af"

                                self.sync_delay_restart = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.SyncDelayRestart()
                                self.sync_delay_restart.parent = self
                                self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                self._children_yang_names.add("sync-delay-restart")

                                self.syncs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs()
                                self.syncs.parent = self
                                self._children_name_map["syncs"] = "syncs"
                                self._children_yang_names.add("syncs")


                            class Syncs(Entity):
                                """
                                LDP IGP Sync related information
                                
                                .. attribute:: sync
                                
                                	LDP\-IGP Synchronization related information for an interface
                                	**type**\: list of    :py:class:`Sync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs, self).__init__()

                                    self.yang_name = "syncs"
                                    self.yang_parent_name = "igp"

                                    self.sync = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)


                                class Sync(Entity):
                                    """
                                    LDP\-IGP Synchronization related information
                                    for an interface
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: delay_timer_remaining
                                    
                                    	Remaining timer (seconds) till expiry of sync delay timer
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: gr_only_peer
                                    
                                    	Interface GR\-only reachable peers
                                    	**type**\: list of    :py:class:`GrOnlyPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer>`
                                    
                                    .. attribute:: igp_sync_delay
                                    
                                    	IGP sync delay in seconds
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: igp_sync_down_reason
                                    
                                    	Reason IGP Sync Not Achieved
                                    	**type**\:   :py:class:`LdpIgpSyncDownReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncDownReason>`
                                    
                                    .. attribute:: igp_sync_state
                                    
                                    	IGP Sync state
                                    	**type**\:   :py:class:`LdpIgpSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncState>`
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: is_delay_timer_running
                                    
                                    	Is sync delay timer running
                                    	**type**\:  bool
                                    
                                    .. attribute:: peers
                                    
                                    	Interface Peers
                                    	**type**\: list of    :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__init__()

                                        self.yang_name = "sync"
                                        self.yang_parent_name = "syncs"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.delay_timer_remaining = YLeaf(YType.uint32, "delay-timer-remaining")

                                        self.igp_sync_delay = YLeaf(YType.uint32, "igp-sync-delay")

                                        self.igp_sync_down_reason = YLeaf(YType.enumeration, "igp-sync-down-reason")

                                        self.igp_sync_state = YLeaf(YType.enumeration, "igp-sync-state")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.is_delay_timer_running = YLeaf(YType.boolean, "is-delay-timer-running")

                                        self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.gr_only_peer = YList(self)
                                        self.peers = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "delay_timer_remaining",
                                                        "igp_sync_delay",
                                                        "igp_sync_down_reason",
                                                        "igp_sync_state",
                                                        "interface_name_xr",
                                                        "is_delay_timer_running") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "sync"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class Peers(Entity):
                                        """
                                        Interface Peers
                                        
                                        .. attribute:: is_gr_enabled
                                        
                                        	Is GR enabled session
                                        	**type**\:  bool
                                        
                                        .. attribute:: peer_id
                                        
                                        	Peer Identifier
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__init__()

                                            self.yang_name = "peers"
                                            self.yang_parent_name = "sync"

                                            self.is_gr_enabled = YLeaf(YType.boolean, "is-gr-enabled")

                                            self.peer_id = YLeaf(YType.str, "peer-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_gr_enabled",
                                                            "peer_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_gr_enabled.is_set or
                                                self.peer_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_gr_enabled.yfilter != YFilter.not_set or
                                                self.peer_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_gr_enabled.is_set or self.is_gr_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_gr_enabled.get_name_leafdata())
                                            if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.peer_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-gr-enabled" or name == "peer-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-gr-enabled"):
                                                self.is_gr_enabled = value
                                                self.is_gr_enabled.value_namespace = name_space
                                                self.is_gr_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "peer-id"):
                                                self.peer_id = value
                                                self.peer_id.value_namespace = name_space
                                                self.peer_id.value_namespace_prefix = name_space_prefix


                                    class GrOnlyPeer(Entity):
                                        """
                                        Interface GR\-only reachable peers
                                        
                                        .. attribute:: is_chkpt_created
                                        
                                        	Is created due to checkpointing
                                        	**type**\:  bool
                                        
                                        .. attribute:: peer_id
                                        
                                        	Peer Identifier
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__init__()

                                            self.yang_name = "gr-only-peer"
                                            self.yang_parent_name = "sync"

                                            self.is_chkpt_created = YLeaf(YType.boolean, "is-chkpt-created")

                                            self.peer_id = YLeaf(YType.str, "peer-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_chkpt_created",
                                                            "peer_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_chkpt_created.is_set or
                                                self.peer_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_chkpt_created.yfilter != YFilter.not_set or
                                                self.peer_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "gr-only-peer" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_chkpt_created.is_set or self.is_chkpt_created.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_chkpt_created.get_name_leafdata())
                                            if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.peer_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-chkpt-created" or name == "peer-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-chkpt-created"):
                                                self.is_chkpt_created = value
                                                self.is_chkpt_created.value_namespace = name_space
                                                self.is_chkpt_created.value_namespace_prefix = name_space_prefix
                                            if(value_path == "peer-id"):
                                                self.peer_id = value
                                                self.peer_id.value_namespace = name_space
                                                self.peer_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.gr_only_peer:
                                            if (c.has_data()):
                                                return True
                                        for c in self.peers:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.delay_timer_remaining.is_set or
                                            self.igp_sync_delay.is_set or
                                            self.igp_sync_down_reason.is_set or
                                            self.igp_sync_state.is_set or
                                            self.interface_name_xr.is_set or
                                            self.is_delay_timer_running.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.gr_only_peer:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.peers:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.delay_timer_remaining.yfilter != YFilter.not_set or
                                            self.igp_sync_delay.yfilter != YFilter.not_set or
                                            self.igp_sync_down_reason.yfilter != YFilter.not_set or
                                            self.igp_sync_state.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.is_delay_timer_running.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sync" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.delay_timer_remaining.is_set or self.delay_timer_remaining.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.delay_timer_remaining.get_name_leafdata())
                                        if (self.igp_sync_delay.is_set or self.igp_sync_delay.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_delay.get_name_leafdata())
                                        if (self.igp_sync_down_reason.is_set or self.igp_sync_down_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_down_reason.get_name_leafdata())
                                        if (self.igp_sync_state.is_set or self.igp_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.igp_sync_state.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.is_delay_timer_running.is_set or self.is_delay_timer_running.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_delay_timer_running.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "gr-only-peer"):
                                            for c in self.gr_only_peer:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.gr_only_peer.append(c)
                                            return c

                                        if (child_yang_name == "peers"):
                                            for c in self.peers:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Peers()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "gr-only-peer" or name == "peers" or name == "vrf" or name == "interface-name" or name == "delay-timer-remaining" or name == "igp-sync-delay" or name == "igp-sync-down-reason" or name == "igp-sync-state" or name == "interface-name-xr" or name == "is-delay-timer-running"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "delay-timer-remaining"):
                                            self.delay_timer_remaining = value
                                            self.delay_timer_remaining.value_namespace = name_space
                                            self.delay_timer_remaining.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-delay"):
                                            self.igp_sync_delay = value
                                            self.igp_sync_delay.value_namespace = name_space
                                            self.igp_sync_delay.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-down-reason"):
                                            self.igp_sync_down_reason = value
                                            self.igp_sync_down_reason.value_namespace = name_space
                                            self.igp_sync_down_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "igp-sync-state"):
                                            self.igp_sync_state = value
                                            self.igp_sync_state.value_namespace = name_space
                                            self.igp_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-delay-timer-running"):
                                            self.is_delay_timer_running = value
                                            self.is_delay_timer_running.value_namespace = name_space
                                            self.is_delay_timer_running.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sync:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.sync:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "syncs" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sync"):
                                        for c in self.sync:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs.Sync()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sync.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class SyncDelayRestart(Entity):
                                """
                                LDP\-IGP Synchronization Delay related
                                information
                                
                                .. attribute:: configured
                                
                                	Is restart delay configured
                                	**type**\:  bool
                                
                                .. attribute:: delay_secs
                                
                                	Delay time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: remaining_secs
                                
                                	Delay timer remaining time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: timer_running
                                
                                	Is restart delay timer running
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__init__()

                                    self.yang_name = "sync-delay-restart"
                                    self.yang_parent_name = "igp"

                                    self.configured = YLeaf(YType.boolean, "configured")

                                    self.delay_secs = YLeaf(YType.uint32, "delay-secs")

                                    self.remaining_secs = YLeaf(YType.uint32, "remaining-secs")

                                    self.timer_running = YLeaf(YType.boolean, "timer-running")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("configured",
                                                    "delay_secs",
                                                    "remaining_secs",
                                                    "timer_running") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.configured.is_set or
                                        self.delay_secs.is_set or
                                        self.remaining_secs.is_set or
                                        self.timer_running.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.configured.yfilter != YFilter.not_set or
                                        self.delay_secs.yfilter != YFilter.not_set or
                                        self.remaining_secs.yfilter != YFilter.not_set or
                                        self.timer_running.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sync-delay-restart" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.configured.is_set or self.configured.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.configured.get_name_leafdata())
                                    if (self.delay_secs.is_set or self.delay_secs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.delay_secs.get_name_leafdata())
                                    if (self.remaining_secs.is_set or self.remaining_secs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.remaining_secs.get_name_leafdata())
                                    if (self.timer_running.is_set or self.timer_running.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.timer_running.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "configured" or name == "delay-secs" or name == "remaining-secs" or name == "timer-running"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "configured"):
                                        self.configured = value
                                        self.configured.value_namespace = name_space
                                        self.configured.value_namespace_prefix = name_space_prefix
                                    if(value_path == "delay-secs"):
                                        self.delay_secs = value
                                        self.delay_secs.value_namespace = name_space
                                        self.delay_secs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "remaining-secs"):
                                        self.remaining_secs = value
                                        self.remaining_secs.value_namespace = name_space
                                        self.remaining_secs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "timer-running"):
                                        self.timer_running = value
                                        self.timer_running.value_namespace = name_space
                                        self.timer_running.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sync_delay_restart is not None and self.sync_delay_restart.has_data()) or
                                    (self.syncs is not None and self.syncs.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sync_delay_restart is not None and self.sync_delay_restart.has_operation()) or
                                    (self.syncs is not None and self.syncs.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "igp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sync-delay-restart"):
                                    if (self.sync_delay_restart is None):
                                        self.sync_delay_restart = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.SyncDelayRestart()
                                        self.sync_delay_restart.parent = self
                                        self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                    return self.sync_delay_restart

                                if (child_yang_name == "syncs"):
                                    if (self.syncs is None):
                                        self.syncs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp.Syncs()
                                        self.syncs.parent = self
                                        self._children_name_map["syncs"] = "syncs"
                                    return self.syncs

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sync-delay-restart" or name == "syncs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsSummary(Entity):
                            """
                            Counters for the LDP Label Infomation Base
                            (LIB)
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: bind_af
                            
                            	bind af
                            	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.BindAf>`
                            
                            .. attribute:: binding_local_explicit_null
                            
                            	Number of local explicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_implicit_null
                            
                            	Number of local implicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_no_route
                            
                            	Local bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_non_null
                            
                            	Number of local non\-null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_null
                            
                            	Number of local null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_oor
                            
                            	Number of local bindings        needing label \- OOR
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_no_route
                            
                            	Bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: highest_allocated_label
                            
                            	Highest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lowest_allocated_label
                            
                            	Lowest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary, self).__init__()

                                self.yang_name = "bindings-summary"
                                self.yang_parent_name = "af"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.bind_af = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "binding_local_explicit_null",
                                                "binding_local_implicit_null",
                                                "binding_local_no_route",
                                                "binding_local_non_null",
                                                "binding_local_null",
                                                "binding_local_oor",
                                                "binding_no_route",
                                                "highest_allocated_label",
                                                "lowest_allocated_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "bindings-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class BindAf(Entity):
                                """
                                bind af
                                
                                .. attribute:: address_family
                                
                                	Binding Summary Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: binding_local
                                
                                	Number of local bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_remote
                                
                                	Number of remote bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_total
                                
                                	Total bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_lib_update
                                
                                	Last update to LIB local binding
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lib_minimum_revision_sent_all
                                
                                	Last update sent to all peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__init__()

                                    self.yang_name = "bind-af"
                                    self.yang_parent_name = "bindings-summary"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local = YLeaf(YType.uint32, "binding-local")

                                    self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                    self.binding_total = YLeaf(YType.uint32, "binding-total")

                                    self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                    self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local",
                                                    "binding_remote",
                                                    "binding_total",
                                                    "last_lib_update",
                                                    "lib_minimum_revision_sent_all") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local.is_set or
                                        self.binding_remote.is_set or
                                        self.binding_total.is_set or
                                        self.last_lib_update.is_set or
                                        self.lib_minimum_revision_sent_all.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local.yfilter != YFilter.not_set or
                                        self.binding_remote.yfilter != YFilter.not_set or
                                        self.binding_total.yfilter != YFilter.not_set or
                                        self.last_lib_update.yfilter != YFilter.not_set or
                                        self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bind-af" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local.get_name_leafdata())
                                    if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                    if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_total.get_name_leafdata())
                                    if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                    if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local"):
                                        self.binding_local = value
                                        self.binding_local.value_namespace = name_space
                                        self.binding_local.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-remote"):
                                        self.binding_remote = value
                                        self.binding_remote.value_namespace = name_space
                                        self.binding_remote.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-total"):
                                        self.binding_total = value
                                        self.binding_total.value_namespace = name_space
                                        self.binding_total.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-lib-update"):
                                        self.last_lib_update = value
                                        self.last_lib_update.value_namespace = name_space
                                        self.last_lib_update.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lib-minimum-revision-sent-all"):
                                        self.lib_minimum_revision_sent_all = value
                                        self.lib_minimum_revision_sent_all.value_namespace = name_space
                                        self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bind_af:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.address_family.is_set or
                                    self.binding_local_explicit_null.is_set or
                                    self.binding_local_implicit_null.is_set or
                                    self.binding_local_no_route.is_set or
                                    self.binding_local_non_null.is_set or
                                    self.binding_local_null.is_set or
                                    self.binding_local_oor.is_set or
                                    self.binding_no_route.is_set or
                                    self.highest_allocated_label.is_set or
                                    self.lowest_allocated_label.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.bind_af:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_no_route.yfilter != YFilter.not_set or
                                    self.binding_local_non_null.yfilter != YFilter.not_set or
                                    self.binding_local_null.yfilter != YFilter.not_set or
                                    self.binding_local_oor.yfilter != YFilter.not_set or
                                    self.binding_no_route.yfilter != YFilter.not_set or
                                    self.highest_allocated_label.yfilter != YFilter.not_set or
                                    self.lowest_allocated_label.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bind-af"):
                                    for c in self.bind_af:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.BindAf()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bind_af.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-explicit-null"):
                                    self.binding_local_explicit_null = value
                                    self.binding_local_explicit_null.value_namespace = name_space
                                    self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-implicit-null"):
                                    self.binding_local_implicit_null = value
                                    self.binding_local_implicit_null.value_namespace = name_space
                                    self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-no-route"):
                                    self.binding_local_no_route = value
                                    self.binding_local_no_route.value_namespace = name_space
                                    self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-non-null"):
                                    self.binding_local_non_null = value
                                    self.binding_local_non_null.value_namespace = name_space
                                    self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-null"):
                                    self.binding_local_null = value
                                    self.binding_local_null.value_namespace = name_space
                                    self.binding_local_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-oor"):
                                    self.binding_local_oor = value
                                    self.binding_local_oor.value_namespace = name_space
                                    self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-no-route"):
                                    self.binding_no_route = value
                                    self.binding_no_route.value_namespace = name_space
                                    self.binding_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "highest-allocated-label"):
                                    self.highest_allocated_label = value
                                    self.highest_allocated_label.value_namespace = name_space
                                    self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lowest-allocated-label"):
                                    self.lowest_allocated_label = value
                                    self.lowest_allocated_label.value_namespace = name_space
                                    self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                        class Interfaces(Entity):
                            """
                            LDP Interface related information
                            
                            .. attribute:: interface
                            
                            	IPv4 interface information
                            	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces, self).__init__()

                                self.yang_name = "interfaces"
                                self.yang_parent_name = "af"

                                self.interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces, self).__setattr__(name, value)


                            class Interface(Entity):
                                """
                                IPv4 interface information
                                
                                .. attribute:: interface_name  <key>
                                
                                	The Interface Name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: auto_config
                                
                                	Auto config
                                	**type**\: list of    :py:class:`AutoConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig>`
                                
                                .. attribute:: interface
                                
                                	Interface name
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: interface_name_xr
                                
                                	Interface name
                                	**type**\:  str
                                
                                .. attribute:: is_im_stale
                                
                                	Is IM information stale
                                	**type**\:  bool
                                
                                .. attribute:: ldp_autoconfig_disable
                                
                                	LDP autoconfig disable
                                	**type**\:  bool
                                
                                .. attribute:: ldp_config_mode
                                
                                	LDP config mode
                                	**type**\:  bool
                                
                                .. attribute:: ldp_enabled
                                
                                	LDP enabled
                                	**type**\:  bool
                                
                                .. attribute:: te_mesh_grp
                                
                                	TE tunnel mesh\-group
                                	**type**\: list of    :py:class:`TeMeshGrp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface, self).__init__()

                                    self.yang_name = "interface"
                                    self.yang_parent_name = "interfaces"

                                    self.interface_name = YLeaf(YType.str, "interface-name")

                                    self.interface = YLeaf(YType.str, "interface")

                                    self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                    self.is_im_stale = YLeaf(YType.boolean, "is-im-stale")

                                    self.ldp_autoconfig_disable = YLeaf(YType.boolean, "ldp-autoconfig-disable")

                                    self.ldp_config_mode = YLeaf(YType.boolean, "ldp-config-mode")

                                    self.ldp_enabled = YLeaf(YType.boolean, "ldp-enabled")

                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.auto_config = YList(self)
                                    self.te_mesh_grp = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_name",
                                                    "interface",
                                                    "interface_name_xr",
                                                    "is_im_stale",
                                                    "ldp_autoconfig_disable",
                                                    "ldp_config_mode",
                                                    "ldp_enabled") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "interface"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class TeMeshGrp(Entity):
                                    """
                                    TE tunnel mesh\-group
                                    
                                    .. attribute:: ldp_mesh_group_enabled
                                    
                                    	LDP has enabled this TE mesh\-group
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_te_mesh_group_all_cfgd
                                    
                                    	LDP has enabled all TE mesh\-groups
                                    	**type**\:  bool
                                    
                                    .. attribute:: te_mesh_group_id
                                    
                                    	TE tunnel Mesh Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__init__()

                                        self.yang_name = "te-mesh-grp"
                                        self.yang_parent_name = "interface"

                                        self.ldp_mesh_group_enabled = YLeaf(YType.boolean, "ldp-mesh-group-enabled")

                                        self.ldp_te_mesh_group_all_cfgd = YLeaf(YType.boolean, "ldp-te-mesh-group-all-cfgd")

                                        self.te_mesh_group_id = YLeaf(YType.uint32, "te-mesh-group-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ldp_mesh_group_enabled",
                                                        "ldp_te_mesh_group_all_cfgd",
                                                        "te_mesh_group_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ldp_mesh_group_enabled.is_set or
                                            self.ldp_te_mesh_group_all_cfgd.is_set or
                                            self.te_mesh_group_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ldp_mesh_group_enabled.yfilter != YFilter.not_set or
                                            self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set or
                                            self.te_mesh_group_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "te-mesh-grp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ldp_mesh_group_enabled.is_set or self.ldp_mesh_group_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_mesh_group_enabled.get_name_leafdata())
                                        if (self.ldp_te_mesh_group_all_cfgd.is_set or self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_te_mesh_group_all_cfgd.get_name_leafdata())
                                        if (self.te_mesh_group_id.is_set or self.te_mesh_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_mesh_group_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ldp-mesh-group-enabled" or name == "ldp-te-mesh-group-all-cfgd" or name == "te-mesh-group-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ldp-mesh-group-enabled"):
                                            self.ldp_mesh_group_enabled = value
                                            self.ldp_mesh_group_enabled.value_namespace = name_space
                                            self.ldp_mesh_group_enabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-te-mesh-group-all-cfgd"):
                                            self.ldp_te_mesh_group_all_cfgd = value
                                            self.ldp_te_mesh_group_all_cfgd.value_namespace = name_space
                                            self.ldp_te_mesh_group_all_cfgd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-mesh-group-id"):
                                            self.te_mesh_group_id = value
                                            self.te_mesh_group_id.value_namespace = name_space
                                            self.te_mesh_group_id.value_namespace_prefix = name_space_prefix


                                class AutoConfig(Entity):
                                    """
                                    Auto config
                                    
                                    .. attribute:: tuple
                                    
                                    	Tuple
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__init__()

                                        self.yang_name = "auto-config"
                                        self.yang_parent_name = "interface"

                                        self.tuple = YLeaf(YType.str, "tuple")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tuple") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.tuple.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tuple.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "auto-config" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tuple.is_set or self.tuple.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tuple.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "tuple"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tuple"):
                                            self.tuple = value
                                            self.tuple.value_namespace = name_space
                                            self.tuple.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.auto_config:
                                        if (c.has_data()):
                                            return True
                                    for c in self.te_mesh_grp:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.interface_name.is_set or
                                        self.interface.is_set or
                                        self.interface_name_xr.is_set or
                                        self.is_im_stale.is_set or
                                        self.ldp_autoconfig_disable.is_set or
                                        self.ldp_config_mode.is_set or
                                        self.ldp_enabled.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.auto_config:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.te_mesh_grp:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_name.yfilter != YFilter.not_set or
                                        self.interface.yfilter != YFilter.not_set or
                                        self.interface_name_xr.yfilter != YFilter.not_set or
                                        self.is_im_stale.yfilter != YFilter.not_set or
                                        self.ldp_autoconfig_disable.yfilter != YFilter.not_set or
                                        self.ldp_config_mode.yfilter != YFilter.not_set or
                                        self.ldp_enabled.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface.get_name_leafdata())
                                    if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                    if (self.is_im_stale.is_set or self.is_im_stale.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_im_stale.get_name_leafdata())
                                    if (self.ldp_autoconfig_disable.is_set or self.ldp_autoconfig_disable.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_autoconfig_disable.get_name_leafdata())
                                    if (self.ldp_config_mode.is_set or self.ldp_config_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_config_mode.get_name_leafdata())
                                    if (self.ldp_enabled.is_set or self.ldp_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_enabled.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "auto-config"):
                                        for c in self.auto_config:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.AutoConfig()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.auto_config.append(c)
                                        return c

                                    if (child_yang_name == "te-mesh-grp"):
                                        for c in self.te_mesh_grp:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.TeMeshGrp()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.te_mesh_grp.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "auto-config" or name == "te-mesh-grp" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "is-im-stale" or name == "ldp-autoconfig-disable" or name == "ldp-config-mode" or name == "ldp-enabled"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-name"):
                                        self.interface_name = value
                                        self.interface_name.value_namespace = name_space
                                        self.interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface"):
                                        self.interface = value
                                        self.interface.value_namespace = name_space
                                        self.interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-name-xr"):
                                        self.interface_name_xr = value
                                        self.interface_name_xr.value_namespace = name_space
                                        self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-im-stale"):
                                        self.is_im_stale = value
                                        self.is_im_stale.value_namespace = name_space
                                        self.is_im_stale.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-autoconfig-disable"):
                                        self.ldp_autoconfig_disable = value
                                        self.ldp_autoconfig_disable.value_namespace = name_space
                                        self.ldp_autoconfig_disable.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-config-mode"):
                                        self.ldp_config_mode = value
                                        self.ldp_config_mode.value_namespace = name_space
                                        self.ldp_config_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-enabled"):
                                        self.ldp_enabled = value
                                        self.ldp_enabled.value_namespace = name_space
                                        self.ldp_enabled.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.interface:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.interface:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "interfaces" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "interface"):
                                    for c in self.interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces.Interface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.interface.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "interface"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Discovery(Entity):
                            """
                            The LDP Discovery
                            
                            .. attribute:: brief
                            
                            	Brief information on LDP discovery
                            	**type**\:   :py:class:`Brief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief>`
                            
                            .. attribute:: link_hellos
                            
                            	The LDP Discovery link
                            	**type**\:   :py:class:`LinkHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos>`
                            
                            .. attribute:: stats
                            
                            	The LDP Discovery Statistics
                            	**type**\:   :py:class:`Stats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats>`
                            
                            .. attribute:: summary
                            
                            	Summarized information on LDP discovery
                            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary>`
                            
                            .. attribute:: targeted_hellos
                            
                            	The LDP Discovery Targeted
                            	**type**\:   :py:class:`TargetedHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery, self).__init__()

                                self.yang_name = "discovery"
                                self.yang_parent_name = "af"

                                self.brief = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief()
                                self.brief.parent = self
                                self._children_name_map["brief"] = "brief"
                                self._children_yang_names.add("brief")

                                self.link_hellos = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos()
                                self.link_hellos.parent = self
                                self._children_name_map["link_hellos"] = "link-hellos"
                                self._children_yang_names.add("link-hellos")

                                self.stats = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats()
                                self.stats.parent = self
                                self._children_name_map["stats"] = "stats"
                                self._children_yang_names.add("stats")

                                self.summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary()
                                self.summary.parent = self
                                self._children_name_map["summary"] = "summary"
                                self._children_yang_names.add("summary")

                                self.targeted_hellos = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos()
                                self.targeted_hellos.parent = self
                                self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                self._children_yang_names.add("targeted-hellos")


                            class LinkHellos(Entity):
                                """
                                The LDP Discovery link
                                
                                .. attribute:: link_hello
                                
                                	Information on LDP link discovery
                                	**type**\: list of    :py:class:`LinkHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__init__()

                                    self.yang_name = "link-hellos"
                                    self.yang_parent_name = "discovery"

                                    self.link_hello = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)


                                class LinkHello(Entity):
                                    """
                                    Information on LDP link discovery
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: discovery_link_af
                                    
                                    	LDP hello AF info
                                    	**type**\: list of    :py:class:`DiscoveryLinkAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf>`
                                    
                                    .. attribute:: hello_information
                                    
                                    	LDP hello info
                                    	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation>`
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: next_hello
                                    
                                    	Next hello due time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: quick_start_disabled
                                    
                                    	Quick\-start disabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__init__()

                                        self.yang_name = "link-hello"
                                        self.yang_parent_name = "link-hellos"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.next_hello = YLeaf(YType.uint32, "next-hello")

                                        self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                        self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.discovery_link_af = YList(self)
                                        self.hello_information = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "interface",
                                                        "interface_name_xr",
                                                        "next_hello",
                                                        "quick_start_disabled") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "link-hello"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class HelloInformation(Entity):
                                        """
                                        LDP hello info
                                        
                                        .. attribute:: disc_expiry
                                        
                                        	Discovery expiry time in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: established_age
                                        
                                        	Hello adjacency estabished age in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: established_time
                                        
                                        	Hello adjacency estabished time in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: hold_time
                                        
                                        	Session hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: is_no_route
                                        
                                        	Is route valid
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_targeted
                                        
                                        	Is session a targeted session
                                        	**type**\:  bool
                                        
                                        .. attribute:: last_session_down_info
                                        
                                        	Last session down information
                                        	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo>`
                                        
                                        .. attribute:: local_hold_time
                                        
                                        	Local hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: neighbor_hold_time
                                        
                                        	Neighbor hold time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: neighbor_ldp_identifier
                                        
                                        	Neighbor LDP Identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: neighbor_src_address
                                        
                                        	Neighbor source address
                                        	**type**\:   :py:class:`NeighborSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress>`
                                        
                                        .. attribute:: neighbor_transport_address
                                        
                                        	Neighbor transport address
                                        	**type**\:   :py:class:`NeighborTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress>`
                                        
                                        .. attribute:: session_bringup_failure_reason
                                        
                                        	session bringup failure reason
                                        	**type**\:  str
                                        
                                        .. attribute:: session_up
                                        
                                        	Is session up for this adj
                                        	**type**\:  bool
                                        
                                        .. attribute:: target
                                        
                                        	Target address
                                        	**type**\:   :py:class:`Target <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__init__()

                                            self.yang_name = "hello-information"
                                            self.yang_parent_name = "link-hello"

                                            self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                            self.established_age = YLeaf(YType.uint64, "established-age")

                                            self.established_time = YLeaf(YType.uint64, "established-time")

                                            self.hold_time = YLeaf(YType.uint32, "hold-time")

                                            self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                            self.is_targeted = YLeaf(YType.boolean, "is-targeted")

                                            self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                            self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                            self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                            self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                            self.session_up = YLeaf(YType.boolean, "session-up")

                                            self.neighbor_src_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                            self.neighbor_src_address.parent = self
                                            self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                            self._children_yang_names.add("neighbor-src-address")

                                            self.neighbor_transport_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                            self.neighbor_transport_address.parent = self
                                            self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                            self._children_yang_names.add("neighbor-transport-address")

                                            self.target = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                            self.target.parent = self
                                            self._children_name_map["target"] = "target"
                                            self._children_yang_names.add("target")

                                            self.last_session_down_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("disc_expiry",
                                                            "established_age",
                                                            "established_time",
                                                            "hold_time",
                                                            "is_no_route",
                                                            "is_targeted",
                                                            "local_hold_time",
                                                            "neighbor_hold_time",
                                                            "neighbor_ldp_identifier",
                                                            "session_bringup_failure_reason",
                                                            "session_up") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)


                                        class NeighborSrcAddress(Entity):
                                            """
                                            Neighbor source address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__init__()

                                                self.yang_name = "neighbor-src-address"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-src-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class NeighborTransportAddress(Entity):
                                            """
                                            Neighbor transport address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__init__()

                                                self.yang_name = "neighbor-transport-address"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "neighbor-transport-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class Target(Entity):
                                            """
                                            Target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__init__()

                                                self.yang_name = "target"
                                                self.yang_parent_name = "hello-information"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LastSessionDownInfo(Entity):
                                            """
                                            Last session down information
                                            
                                            .. attribute:: last_session_down_reason
                                            
                                            	The reason of last socket failure
                                            	**type**\:  str
                                            
                                            .. attribute:: last_session_down_time
                                            
                                            	Timestamp of when the last session went down
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: last_session_up_time
                                            
                                            	The time duration the last session was up
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__init__()

                                                self.yang_name = "last-session-down-info"
                                                self.yang_parent_name = "hello-information"

                                                self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("last_session_down_reason",
                                                                "last_session_down_time",
                                                                "last_session_up_time") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.last_session_down_reason.is_set or
                                                    self.last_session_down_time.is_set or
                                                    self.last_session_up_time.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.last_session_down_reason.yfilter != YFilter.not_set or
                                                    self.last_session_down_time.yfilter != YFilter.not_set or
                                                    self.last_session_up_time.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "last-session-down-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "last-session-down-reason"):
                                                    self.last_session_down_reason = value
                                                    self.last_session_down_reason.value_namespace = name_space
                                                    self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-down-time"):
                                                    self.last_session_down_time = value
                                                    self.last_session_down_time.value_namespace = name_space
                                                    self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-up-time"):
                                                    self.last_session_up_time = value
                                                    self.last_session_up_time.value_namespace = name_space
                                                    self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.disc_expiry.is_set or
                                                self.established_age.is_set or
                                                self.established_time.is_set or
                                                self.hold_time.is_set or
                                                self.is_no_route.is_set or
                                                self.is_targeted.is_set or
                                                self.local_hold_time.is_set or
                                                self.neighbor_hold_time.is_set or
                                                self.neighbor_ldp_identifier.is_set or
                                                self.session_bringup_failure_reason.is_set or
                                                self.session_up.is_set or
                                                (self.neighbor_src_address is not None and self.neighbor_src_address.has_data()) or
                                                (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_data()) or
                                                (self.target is not None and self.target.has_data()))

                                        def has_operation(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.disc_expiry.yfilter != YFilter.not_set or
                                                self.established_age.yfilter != YFilter.not_set or
                                                self.established_time.yfilter != YFilter.not_set or
                                                self.hold_time.yfilter != YFilter.not_set or
                                                self.is_no_route.yfilter != YFilter.not_set or
                                                self.is_targeted.yfilter != YFilter.not_set or
                                                self.local_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                self.session_up.yfilter != YFilter.not_set or
                                                (self.neighbor_src_address is not None and self.neighbor_src_address.has_operation()) or
                                                (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_operation()) or
                                                (self.target is not None and self.target.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "hello-information" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                            if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_age.get_name_leafdata())
                                            if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_time.get_name_leafdata())
                                            if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_time.get_name_leafdata())
                                            if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                            if (self.is_targeted.is_set or self.is_targeted.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_targeted.get_name_leafdata())
                                            if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                            if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                            if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                            if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                            if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_up.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "last-session-down-info"):
                                                for c in self.last_session_down_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.last_session_down_info.append(c)
                                                return c

                                            if (child_yang_name == "neighbor-src-address"):
                                                if (self.neighbor_src_address is None):
                                                    self.neighbor_src_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                    self.neighbor_src_address.parent = self
                                                    self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                return self.neighbor_src_address

                                            if (child_yang_name == "neighbor-transport-address"):
                                                if (self.neighbor_transport_address is None):
                                                    self.neighbor_transport_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                    self.neighbor_transport_address.parent = self
                                                    self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                return self.neighbor_transport_address

                                            if (child_yang_name == "target"):
                                                if (self.target is None):
                                                    self.target = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                    self.target.parent = self
                                                    self._children_name_map["target"] = "target"
                                                return self.target

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "last-session-down-info" or name == "neighbor-src-address" or name == "neighbor-transport-address" or name == "target" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "is-no-route" or name == "is-targeted" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "neighbor-ldp-identifier" or name == "session-bringup-failure-reason" or name == "session-up"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "disc-expiry"):
                                                self.disc_expiry = value
                                                self.disc_expiry.value_namespace = name_space
                                                self.disc_expiry.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-age"):
                                                self.established_age = value
                                                self.established_age.value_namespace = name_space
                                                self.established_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-time"):
                                                self.established_time = value
                                                self.established_time.value_namespace = name_space
                                                self.established_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-time"):
                                                self.hold_time = value
                                                self.hold_time.value_namespace = name_space
                                                self.hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-no-route"):
                                                self.is_no_route = value
                                                self.is_no_route.value_namespace = name_space
                                                self.is_no_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-targeted"):
                                                self.is_targeted = value
                                                self.is_targeted.value_namespace = name_space
                                                self.is_targeted.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-hold-time"):
                                                self.local_hold_time = value
                                                self.local_hold_time.value_namespace = name_space
                                                self.local_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-hold-time"):
                                                self.neighbor_hold_time = value
                                                self.neighbor_hold_time.value_namespace = name_space
                                                self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-ldp-identifier"):
                                                self.neighbor_ldp_identifier = value
                                                self.neighbor_ldp_identifier.value_namespace = name_space
                                                self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-bringup-failure-reason"):
                                                self.session_bringup_failure_reason = value
                                                self.session_bringup_failure_reason.value_namespace = name_space
                                                self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-up"):
                                                self.session_up = value
                                                self.session_up.value_namespace = name_space
                                                self.session_up.value_namespace_prefix = name_space_prefix


                                    class DiscoveryLinkAf(Entity):
                                        """
                                        LDP hello AF info
                                        
                                        .. attribute:: interval
                                        
                                        	Hello interval in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: local_src_address
                                        
                                        	Local source address
                                        	**type**\:   :py:class:`LocalSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress>`
                                        
                                        .. attribute:: local_transport_address
                                        
                                        	Local transport address
                                        	**type**\:   :py:class:`LocalTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__init__()

                                            self.yang_name = "discovery-link-af"
                                            self.yang_parent_name = "link-hello"

                                            self.interval = YLeaf(YType.uint32, "interval")

                                            self.local_src_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                            self.local_src_address.parent = self
                                            self._children_name_map["local_src_address"] = "local-src-address"
                                            self._children_yang_names.add("local-src-address")

                                            self.local_transport_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                            self.local_transport_address.parent = self
                                            self._children_name_map["local_transport_address"] = "local-transport-address"
                                            self._children_yang_names.add("local-transport-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interval") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)


                                        class LocalSrcAddress(Entity):
                                            """
                                            Local source address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__init__()

                                                self.yang_name = "local-src-address"
                                                self.yang_parent_name = "discovery-link-af"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-src-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LocalTransportAddress(Entity):
                                            """
                                            Local transport address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__init__()

                                                self.yang_name = "local-transport-address"
                                                self.yang_parent_name = "discovery-link-af"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-transport-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.interval.is_set or
                                                (self.local_src_address is not None and self.local_src_address.has_data()) or
                                                (self.local_transport_address is not None and self.local_transport_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interval.yfilter != YFilter.not_set or
                                                (self.local_src_address is not None and self.local_src_address.has_operation()) or
                                                (self.local_transport_address is not None and self.local_transport_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "discovery-link-af" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interval.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-src-address"):
                                                if (self.local_src_address is None):
                                                    self.local_src_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                    self.local_src_address.parent = self
                                                    self._children_name_map["local_src_address"] = "local-src-address"
                                                return self.local_src_address

                                            if (child_yang_name == "local-transport-address"):
                                                if (self.local_transport_address is None):
                                                    self.local_transport_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                    self.local_transport_address.parent = self
                                                    self._children_name_map["local_transport_address"] = "local-transport-address"
                                                return self.local_transport_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-src-address" or name == "local-transport-address" or name == "interval"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interval"):
                                                self.interval = value
                                                self.interval.value_namespace = name_space
                                                self.interval.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.discovery_link_af:
                                            if (c.has_data()):
                                                return True
                                        for c in self.hello_information:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.interface.is_set or
                                            self.interface_name_xr.is_set or
                                            self.next_hello.is_set or
                                            self.quick_start_disabled.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.discovery_link_af:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.hello_information:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.next_hello.yfilter != YFilter.not_set or
                                            self.quick_start_disabled.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hello.get_name_leafdata())
                                        if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "discovery-link-af"):
                                            for c in self.discovery_link_af:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.discovery_link_af.append(c)
                                            return c

                                        if (child_yang_name == "hello-information"):
                                            for c in self.hello_information:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.hello_information.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "discovery-link-af" or name == "hello-information" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "next-hello" or name == "quick-start-disabled"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hello"):
                                            self.next_hello = value
                                            self.next_hello.value_namespace = name_space
                                            self.next_hello.value_namespace_prefix = name_space_prefix
                                        if(value_path == "quick-start-disabled"):
                                            self.quick_start_disabled = value
                                            self.quick_start_disabled.value_namespace = name_space
                                            self.quick_start_disabled.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.link_hello:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.link_hello:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "link-hellos" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello"):
                                        for c in self.link_hello:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos.LinkHello()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.link_hello.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Summary(Entity):
                                """
                                Summarized information on LDP discovery
                                
                                .. attribute:: local_ldp_id
                                
                                	Local LDP identifier
                                	**type**\:  str
                                
                                .. attribute:: num_of_active_ldp_interfaces
                                
                                	Number of active LDP enabled interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_addr_recv
                                
                                	Number of hello discoveries received with bad source address
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_hello_pdu
                                
                                	Number of hello discoveries received with bad hello PDU
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_bad_xport_addr
                                
                                	Number of hello discoveries received with bad export address
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_same_router_id
                                
                                	Number of hello discoveries received with the same router id as this router
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_disc_with_wrong_router_id
                                
                                	Number of hello discoveries received with the router id that is not destined for this router
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_ldp_interfaces
                                
                                	Total Number of LDP configured interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_lnk_disc_recv
                                
                                	Number of link hello discoveries in recv state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_lnk_disc_xmit
                                
                                	Number of link hello discoveries in xmit state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_tgt_disc_recv
                                
                                	Number of targeted hello discoveries in recv state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_tgt_disc_xmit
                                
                                	Number of targeted hello discoveries in xmit state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary, self).__init__()

                                    self.yang_name = "summary"
                                    self.yang_parent_name = "discovery"

                                    self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                                    self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                                    self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                                    self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                                    self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                                    self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                                    self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                                    self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                                    self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                                    self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                                    self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                                    self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("local_ldp_id",
                                                    "num_of_active_ldp_interfaces",
                                                    "num_of_disc_with_bad_addr_recv",
                                                    "num_of_disc_with_bad_hello_pdu",
                                                    "num_of_disc_with_bad_xport_addr",
                                                    "num_of_disc_with_same_router_id",
                                                    "num_of_disc_with_wrong_router_id",
                                                    "num_of_ldp_interfaces",
                                                    "num_of_lnk_disc_recv",
                                                    "num_of_lnk_disc_xmit",
                                                    "num_of_tgt_disc_recv",
                                                    "num_of_tgt_disc_xmit") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.local_ldp_id.is_set or
                                        self.num_of_active_ldp_interfaces.is_set or
                                        self.num_of_disc_with_bad_addr_recv.is_set or
                                        self.num_of_disc_with_bad_hello_pdu.is_set or
                                        self.num_of_disc_with_bad_xport_addr.is_set or
                                        self.num_of_disc_with_same_router_id.is_set or
                                        self.num_of_disc_with_wrong_router_id.is_set or
                                        self.num_of_ldp_interfaces.is_set or
                                        self.num_of_lnk_disc_recv.is_set or
                                        self.num_of_lnk_disc_xmit.is_set or
                                        self.num_of_tgt_disc_recv.is_set or
                                        self.num_of_tgt_disc_xmit.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.local_ldp_id.yfilter != YFilter.not_set or
                                        self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                                        self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                                        self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                                        self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                                        self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                                        self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                                        self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                                    if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                                    if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                                    if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                                    if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                                    if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                                    if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                                    if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                                    if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                                    if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "local-ldp-id"):
                                        self.local_ldp_id = value
                                        self.local_ldp_id.value_namespace = name_space
                                        self.local_ldp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-active-ldp-interfaces"):
                                        self.num_of_active_ldp_interfaces = value
                                        self.num_of_active_ldp_interfaces.value_namespace = name_space
                                        self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-addr-recv"):
                                        self.num_of_disc_with_bad_addr_recv = value
                                        self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                                        self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-hello-pdu"):
                                        self.num_of_disc_with_bad_hello_pdu = value
                                        self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                                        self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-bad-xport-addr"):
                                        self.num_of_disc_with_bad_xport_addr = value
                                        self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                                        self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-same-router-id"):
                                        self.num_of_disc_with_same_router_id = value
                                        self.num_of_disc_with_same_router_id.value_namespace = name_space
                                        self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-disc-with-wrong-router-id"):
                                        self.num_of_disc_with_wrong_router_id = value
                                        self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                                        self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-ldp-interfaces"):
                                        self.num_of_ldp_interfaces = value
                                        self.num_of_ldp_interfaces.value_namespace = name_space
                                        self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-lnk-disc-recv"):
                                        self.num_of_lnk_disc_recv = value
                                        self.num_of_lnk_disc_recv.value_namespace = name_space
                                        self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-lnk-disc-xmit"):
                                        self.num_of_lnk_disc_xmit = value
                                        self.num_of_lnk_disc_xmit.value_namespace = name_space
                                        self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-tgt-disc-recv"):
                                        self.num_of_tgt_disc_recv = value
                                        self.num_of_tgt_disc_recv.value_namespace = name_space
                                        self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-tgt-disc-xmit"):
                                        self.num_of_tgt_disc_xmit = value
                                        self.num_of_tgt_disc_xmit.value_namespace = name_space
                                        self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix


                            class TargetedHellos(Entity):
                                """
                                The LDP Discovery Targeted
                                
                                .. attribute:: targeted_hello
                                
                                	Information on LDP targeted discovery
                                	**type**\: list of    :py:class:`TargetedHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__init__()

                                    self.yang_name = "targeted-hellos"
                                    self.yang_parent_name = "discovery"

                                    self.targeted_hello = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)


                                class TargetedHello(Entity):
                                    """
                                    Information on LDP targeted discovery
                                    
                                    .. attribute:: adjacency_ldp_identifier
                                    
                                    	Adjacency LDP Identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: dhcb_local_address
                                    
                                    	DHCB local address
                                    	**type**\:   :py:class:`DhcbLocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress>`
                                    
                                    .. attribute:: dhcb_target_address
                                    
                                    	DHCB target address
                                    	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress>`
                                    
                                    .. attribute:: disc_expiry
                                    
                                    	Discovery expiry time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: established_age
                                    
                                    	Hello adjacency estabished age in nanosec
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: established_time
                                    
                                    	Hello adjacency estabished time in nanosec
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    .. attribute:: hold_time
                                    
                                    	Targeted hello hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: interval
                                    
                                    	Hello interval in sec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_session_down_info
                                    
                                    	Last session down information
                                    	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo>`
                                    
                                    .. attribute:: local_address
                                    
                                    	Local IP Address
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: local_hold_time
                                    
                                    	Local hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: neighbor_hold_time
                                    
                                    	Neighbor hold time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_hello
                                    
                                    	Next hello due time in msec
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: quick_start_disabled
                                    
                                    	Quick\-start disabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: session_bringup_failure_reason
                                    
                                    	session bringup failure reason
                                    	**type**\:  str
                                    
                                    .. attribute:: session_up
                                    
                                    	Is session up for this adj
                                    	**type**\:  bool
                                    
                                    .. attribute:: state
                                    
                                    	Targeted hello state
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	The target IP Address
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__init__()

                                        self.yang_name = "targeted-hello"
                                        self.yang_parent_name = "targeted-hellos"

                                        self.adjacency_ldp_identifier = YLeaf(YType.str, "adjacency-ldp-identifier")

                                        self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                        self.established_age = YLeaf(YType.uint64, "established-age")

                                        self.established_time = YLeaf(YType.uint64, "established-time")

                                        self.hold_time = YLeaf(YType.uint32, "hold-time")

                                        self.interval = YLeaf(YType.uint32, "interval")

                                        self.local_address = YLeaf(YType.str, "local-address")

                                        self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                        self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                        self.next_hello = YLeaf(YType.uint32, "next-hello")

                                        self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                        self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                        self.session_up = YLeaf(YType.boolean, "session-up")

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.target_address = YLeaf(YType.str, "target-address")

                                        self.dhcb_local_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                        self.dhcb_local_address.parent = self
                                        self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                        self._children_yang_names.add("dhcb-local-address")

                                        self.dhcb_target_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                        self.dhcb_target_address.parent = self
                                        self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                        self._children_yang_names.add("dhcb-target-address")

                                        self.last_session_down_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("adjacency_ldp_identifier",
                                                        "disc_expiry",
                                                        "established_age",
                                                        "established_time",
                                                        "hold_time",
                                                        "interval",
                                                        "local_address",
                                                        "local_hold_time",
                                                        "neighbor_hold_time",
                                                        "next_hello",
                                                        "quick_start_disabled",
                                                        "session_bringup_failure_reason",
                                                        "session_up",
                                                        "state",
                                                        "target_address") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)


                                    class DhcbLocalAddress(Entity):
                                        """
                                        DHCB local address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__init__()

                                            self.yang_name = "dhcb-local-address"
                                            self.yang_parent_name = "targeted-hello"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "dhcb-local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class DhcbTargetAddress(Entity):
                                        """
                                        DHCB target address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__init__()

                                            self.yang_name = "dhcb-target-address"
                                            self.yang_parent_name = "targeted-hello"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "dhcb-target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class LastSessionDownInfo(Entity):
                                        """
                                        Last session down information
                                        
                                        .. attribute:: last_session_down_reason
                                        
                                        	The reason of last socket failure
                                        	**type**\:  str
                                        
                                        .. attribute:: last_session_down_time
                                        
                                        	Timestamp of when the last session went down
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: last_session_up_time
                                        
                                        	The time duration the last session was up
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__init__()

                                            self.yang_name = "last-session-down-info"
                                            self.yang_parent_name = "targeted-hello"

                                            self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                            self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                            self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("last_session_down_reason",
                                                            "last_session_down_time",
                                                            "last_session_up_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.last_session_down_reason.is_set or
                                                self.last_session_down_time.is_set or
                                                self.last_session_up_time.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.last_session_down_reason.yfilter != YFilter.not_set or
                                                self.last_session_down_time.yfilter != YFilter.not_set or
                                                self.last_session_up_time.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "last-session-down-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                            if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                            if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "last-session-down-reason"):
                                                self.last_session_down_reason = value
                                                self.last_session_down_reason.value_namespace = name_space
                                                self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-session-down-time"):
                                                self.last_session_down_time = value
                                                self.last_session_down_time.value_namespace = name_space
                                                self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "last-session-up-time"):
                                                self.last_session_up_time = value
                                                self.last_session_up_time.value_namespace = name_space
                                                self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.last_session_down_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.adjacency_ldp_identifier.is_set or
                                            self.disc_expiry.is_set or
                                            self.established_age.is_set or
                                            self.established_time.is_set or
                                            self.hold_time.is_set or
                                            self.interval.is_set or
                                            self.local_address.is_set or
                                            self.local_hold_time.is_set or
                                            self.neighbor_hold_time.is_set or
                                            self.next_hello.is_set or
                                            self.quick_start_disabled.is_set or
                                            self.session_bringup_failure_reason.is_set or
                                            self.session_up.is_set or
                                            self.state.is_set or
                                            self.target_address.is_set or
                                            (self.dhcb_local_address is not None and self.dhcb_local_address.has_data()) or
                                            (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()))

                                    def has_operation(self):
                                        for c in self.last_session_down_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.adjacency_ldp_identifier.yfilter != YFilter.not_set or
                                            self.disc_expiry.yfilter != YFilter.not_set or
                                            self.established_age.yfilter != YFilter.not_set or
                                            self.established_time.yfilter != YFilter.not_set or
                                            self.hold_time.yfilter != YFilter.not_set or
                                            self.interval.yfilter != YFilter.not_set or
                                            self.local_address.yfilter != YFilter.not_set or
                                            self.local_hold_time.yfilter != YFilter.not_set or
                                            self.neighbor_hold_time.yfilter != YFilter.not_set or
                                            self.next_hello.yfilter != YFilter.not_set or
                                            self.quick_start_disabled.yfilter != YFilter.not_set or
                                            self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                            self.session_up.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            self.target_address.yfilter != YFilter.not_set or
                                            (self.dhcb_local_address is not None and self.dhcb_local_address.has_operation()) or
                                            (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hello" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.adjacency_ldp_identifier.is_set or self.adjacency_ldp_identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.adjacency_ldp_identifier.get_name_leafdata())
                                        if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                        if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.established_age.get_name_leafdata())
                                        if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.established_time.get_name_leafdata())
                                        if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_time.get_name_leafdata())
                                        if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interval.get_name_leafdata())
                                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_address.get_name_leafdata())
                                        if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                        if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                        if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_hello.get_name_leafdata())
                                        if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())
                                        if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                        if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.session_up.get_name_leafdata())
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())
                                        if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.target_address.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "dhcb-local-address"):
                                            if (self.dhcb_local_address is None):
                                                self.dhcb_local_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                                self.dhcb_local_address.parent = self
                                                self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                            return self.dhcb_local_address

                                        if (child_yang_name == "dhcb-target-address"):
                                            if (self.dhcb_target_address is None):
                                                self.dhcb_target_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                                self.dhcb_target_address.parent = self
                                                self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            return self.dhcb_target_address

                                        if (child_yang_name == "last-session-down-info"):
                                            for c in self.last_session_down_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.last_session_down_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "dhcb-local-address" or name == "dhcb-target-address" or name == "last-session-down-info" or name == "adjacency-ldp-identifier" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "interval" or name == "local-address" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "next-hello" or name == "quick-start-disabled" or name == "session-bringup-failure-reason" or name == "session-up" or name == "state" or name == "target-address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "adjacency-ldp-identifier"):
                                            self.adjacency_ldp_identifier = value
                                            self.adjacency_ldp_identifier.value_namespace = name_space
                                            self.adjacency_ldp_identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "disc-expiry"):
                                            self.disc_expiry = value
                                            self.disc_expiry.value_namespace = name_space
                                            self.disc_expiry.value_namespace_prefix = name_space_prefix
                                        if(value_path == "established-age"):
                                            self.established_age = value
                                            self.established_age.value_namespace = name_space
                                            self.established_age.value_namespace_prefix = name_space_prefix
                                        if(value_path == "established-time"):
                                            self.established_time = value
                                            self.established_time.value_namespace = name_space
                                            self.established_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-time"):
                                            self.hold_time = value
                                            self.hold_time.value_namespace = name_space
                                            self.hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interval"):
                                            self.interval = value
                                            self.interval.value_namespace = name_space
                                            self.interval.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-address"):
                                            self.local_address = value
                                            self.local_address.value_namespace = name_space
                                            self.local_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-hold-time"):
                                            self.local_hold_time = value
                                            self.local_hold_time.value_namespace = name_space
                                            self.local_hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "neighbor-hold-time"):
                                            self.neighbor_hold_time = value
                                            self.neighbor_hold_time.value_namespace = name_space
                                            self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-hello"):
                                            self.next_hello = value
                                            self.next_hello.value_namespace = name_space
                                            self.next_hello.value_namespace_prefix = name_space_prefix
                                        if(value_path == "quick-start-disabled"):
                                            self.quick_start_disabled = value
                                            self.quick_start_disabled.value_namespace = name_space
                                            self.quick_start_disabled.value_namespace_prefix = name_space_prefix
                                        if(value_path == "session-bringup-failure-reason"):
                                            self.session_bringup_failure_reason = value
                                            self.session_bringup_failure_reason.value_namespace = name_space
                                            self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                        if(value_path == "session-up"):
                                            self.session_up = value
                                            self.session_up.value_namespace = name_space
                                            self.session_up.value_namespace_prefix = name_space_prefix
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "target-address"):
                                            self.target_address = value
                                            self.target_address.value_namespace = name_space
                                            self.target_address.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.targeted_hello:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.targeted_hello:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "targeted-hellos" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "targeted-hello"):
                                        for c in self.targeted_hello:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos.TargetedHello()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.targeted_hello.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "targeted-hello"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Brief(Entity):
                                """
                                Brief information on LDP discovery
                                
                                .. attribute:: link_hello_briefs
                                
                                	The LDP Discovery link brief information
                                	**type**\:   :py:class:`LinkHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs>`
                                
                                .. attribute:: targeted_hello_briefs
                                
                                	The LDP Discovery Targeted brief information
                                	**type**\:   :py:class:`TargetedHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief, self).__init__()

                                    self.yang_name = "brief"
                                    self.yang_parent_name = "discovery"

                                    self.link_hello_briefs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                    self.link_hello_briefs.parent = self
                                    self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                    self._children_yang_names.add("link-hello-briefs")

                                    self.targeted_hello_briefs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                    self.targeted_hello_briefs.parent = self
                                    self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                    self._children_yang_names.add("targeted-hello-briefs")


                                class LinkHelloBriefs(Entity):
                                    """
                                    The LDP Discovery link brief information
                                    
                                    .. attribute:: link_hello_brief
                                    
                                    	Brief information on LDP link discovery
                                    	**type**\: list of    :py:class:`LinkHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__init__()

                                        self.yang_name = "link-hello-briefs"
                                        self.yang_parent_name = "brief"

                                        self.link_hello_brief = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)


                                    class LinkHelloBrief(Entity):
                                        """
                                        Brief information on LDP link discovery
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: address_family
                                        
                                        	Discovery Brief Address Family
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: address_family_set
                                        
                                        	Discovery Brief Address Family Set
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation>`
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__init__()

                                            self.yang_name = "link-hello-brief"
                                            self.yang_parent_name = "link-hello-briefs"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.address_family = YLeaf(YType.enumeration, "address-family")

                                            self.address_family_set = YLeaf(YType.enumeration, "address-family-set")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "address_family",
                                                            "address_family_set",
                                                            "interface",
                                                            "interface_name_xr") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "link-hello-brief"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "link-hello-brief"

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_up.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.address_family.is_set or
                                                self.address_family_set.is_set or
                                                self.interface.is_set or
                                                self.interface_name_xr.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.address_family.yfilter != YFilter.not_set or
                                                self.address_family_set.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family.get_name_leafdata())
                                            if (self.address_family_set.is_set or self.address_family_set.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family_set.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "hello-information" or name == "vrf" or name == "interface-name" or name == "address-family" or name == "address-family-set" or name == "interface" or name == "interface-name-xr"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "address-family"):
                                                self.address_family = value
                                                self.address_family.value_namespace = name_space
                                                self.address_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "address-family-set"):
                                                self.address_family_set = value
                                                self.address_family_set.value_namespace = name_space
                                                self.address_family_set.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link_hello_brief:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.link_hello_brief:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-briefs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-brief"):
                                            for c in self.link_hello_brief:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link_hello_brief.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-brief"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class TargetedHelloBriefs(Entity):
                                    """
                                    The LDP Discovery Targeted brief information
                                    
                                    .. attribute:: targeted_hello_brief
                                    
                                    	Brief information on LDP targeted discovery
                                    	**type**\: list of    :py:class:`TargetedHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__init__()

                                        self.yang_name = "targeted-hello-briefs"
                                        self.yang_parent_name = "brief"

                                        self.targeted_hello_brief = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)


                                    class TargetedHelloBrief(Entity):
                                        """
                                        Brief information on LDP targeted discovery
                                        
                                        .. attribute:: address_family
                                        
                                        	Targeted Discovery Address Family
                                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                        
                                        .. attribute:: dhcb_target_address
                                        
                                        	DHCB target address
                                        	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation>`
                                        
                                        .. attribute:: local_address
                                        
                                        	Local IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: target_address
                                        
                                        	The target IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__init__()

                                            self.yang_name = "targeted-hello-brief"
                                            self.yang_parent_name = "targeted-hello-briefs"

                                            self.address_family = YLeaf(YType.enumeration, "address-family")

                                            self.local_address = YLeaf(YType.str, "local-address")

                                            self.target_address = YLeaf(YType.str, "target-address")

                                            self.dhcb_target_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                            self.dhcb_target_address.parent = self
                                            self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            self._children_yang_names.add("dhcb-target-address")

                                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address_family",
                                                            "local_address",
                                                            "target_address") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class DhcbTargetAddress(Entity):
                                            """
                                            DHCB target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__init__()

                                                self.yang_name = "dhcb-target-address"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "targeted-hello-brief"

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_up.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.address_family.is_set or
                                                self.local_address.is_set or
                                                self.target_address.is_set or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()) or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address_family.yfilter != YFilter.not_set or
                                                self.local_address.yfilter != YFilter.not_set or
                                                self.target_address.yfilter != YFilter.not_set or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()) or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello-brief" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address_family.get_name_leafdata())
                                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_address.get_name_leafdata())
                                            if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.target_address.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "dhcb-target-address"):
                                                if (self.dhcb_target_address is None):
                                                    self.dhcb_target_address = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                    self.dhcb_target_address.parent = self
                                                    self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                return self.dhcb_target_address

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "dhcb-target-address" or name == "hello-information" or name == "vrf" or name == "address-family" or name == "local-address" or name == "target-address"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address-family"):
                                                self.address_family = value
                                                self.address_family.value_namespace = name_space
                                                self.address_family.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-address"):
                                                self.local_address = value
                                                self.local_address.value_namespace = name_space
                                                self.local_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "target-address"):
                                                self.target_address = value
                                                self.target_address.value_namespace = name_space
                                                self.target_address.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.targeted_hello_brief:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.targeted_hello_brief:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hello-briefs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "targeted-hello-brief"):
                                            for c in self.targeted_hello_brief:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.targeted_hello_brief.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "targeted-hello-brief"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        (self.link_hello_briefs is not None and self.link_hello_briefs.has_data()) or
                                        (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.link_hello_briefs is not None and self.link_hello_briefs.has_operation()) or
                                        (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "brief" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-briefs"):
                                        if (self.link_hello_briefs is None):
                                            self.link_hello_briefs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                            self.link_hello_briefs.parent = self
                                            self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                        return self.link_hello_briefs

                                    if (child_yang_name == "targeted-hello-briefs"):
                                        if (self.targeted_hello_briefs is None):
                                            self.targeted_hello_briefs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                            self.targeted_hello_briefs.parent = self
                                            self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                        return self.targeted_hello_briefs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-briefs" or name == "targeted-hello-briefs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Stats(Entity):
                                """
                                The LDP Discovery Statistics
                                
                                .. attribute:: stat
                                
                                	Information on LDP discovery statistics
                                	**type**\: list of    :py:class:`Stat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats.Stat>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats, self).__init__()

                                    self.yang_name = "stats"
                                    self.yang_parent_name = "discovery"

                                    self.stat = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)


                                class Stat(Entity):
                                    """
                                    Information on LDP discovery statistics
                                    
                                    .. attribute:: adjacency_group_up_time
                                    
                                    	Adjacency group up time in seconds
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: second
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: tcp_arb_chg_count
                                    
                                    	Count of changes in TCP arbitration
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tcp_open_count
                                    
                                    	Count of attempted TCP opens
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tcp_role
                                    
                                    	TCP Role
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__init__()

                                        self.yang_name = "stat"
                                        self.yang_parent_name = "stats"

                                        self.adjacency_group_up_time = YLeaf(YType.uint32, "adjacency-group-up-time")

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.tcp_arb_chg_count = YLeaf(YType.uint32, "tcp-arb-chg-count")

                                        self.tcp_open_count = YLeaf(YType.uint32, "tcp-open-count")

                                        self.tcp_role = YLeaf(YType.uint32, "tcp-role")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("adjacency_group_up_time",
                                                        "label_space_id",
                                                        "lsr_id",
                                                        "tcp_arb_chg_count",
                                                        "tcp_open_count",
                                                        "tcp_role") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.adjacency_group_up_time.is_set or
                                            self.label_space_id.is_set or
                                            self.lsr_id.is_set or
                                            self.tcp_arb_chg_count.is_set or
                                            self.tcp_open_count.is_set or
                                            self.tcp_role.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.adjacency_group_up_time.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.tcp_arb_chg_count.yfilter != YFilter.not_set or
                                            self.tcp_open_count.yfilter != YFilter.not_set or
                                            self.tcp_role.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stat" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.adjacency_group_up_time.is_set or self.adjacency_group_up_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.adjacency_group_up_time.get_name_leafdata())
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.tcp_arb_chg_count.is_set or self.tcp_arb_chg_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_arb_chg_count.get_name_leafdata())
                                        if (self.tcp_open_count.is_set or self.tcp_open_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_open_count.get_name_leafdata())
                                        if (self.tcp_role.is_set or self.tcp_role.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcp_role.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "adjacency-group-up-time" or name == "label-space-id" or name == "lsr-id" or name == "tcp-arb-chg-count" or name == "tcp-open-count" or name == "tcp-role"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "adjacency-group-up-time"):
                                            self.adjacency_group_up_time = value
                                            self.adjacency_group_up_time.value_namespace = name_space
                                            self.adjacency_group_up_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-arb-chg-count"):
                                            self.tcp_arb_chg_count = value
                                            self.tcp_arb_chg_count.value_namespace = name_space
                                            self.tcp_arb_chg_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-open-count"):
                                            self.tcp_open_count = value
                                            self.tcp_open_count.value_namespace = name_space
                                            self.tcp_open_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcp-role"):
                                            self.tcp_role = value
                                            self.tcp_role.value_namespace = name_space
                                            self.tcp_role.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.stat:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.stat:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "stats" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "stat"):
                                        for c in self.stat:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats.Stat()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.stat.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "stat"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.brief is not None and self.brief.has_data()) or
                                    (self.link_hellos is not None and self.link_hellos.has_data()) or
                                    (self.stats is not None and self.stats.has_data()) or
                                    (self.summary is not None and self.summary.has_data()) or
                                    (self.targeted_hellos is not None and self.targeted_hellos.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.brief is not None and self.brief.has_operation()) or
                                    (self.link_hellos is not None and self.link_hellos.has_operation()) or
                                    (self.stats is not None and self.stats.has_operation()) or
                                    (self.summary is not None and self.summary.has_operation()) or
                                    (self.targeted_hellos is not None and self.targeted_hellos.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovery" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "brief"):
                                    if (self.brief is None):
                                        self.brief = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Brief()
                                        self.brief.parent = self
                                        self._children_name_map["brief"] = "brief"
                                    return self.brief

                                if (child_yang_name == "link-hellos"):
                                    if (self.link_hellos is None):
                                        self.link_hellos = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.LinkHellos()
                                        self.link_hellos.parent = self
                                        self._children_name_map["link_hellos"] = "link-hellos"
                                    return self.link_hellos

                                if (child_yang_name == "stats"):
                                    if (self.stats is None):
                                        self.stats = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Stats()
                                        self.stats.parent = self
                                        self._children_name_map["stats"] = "stats"
                                    return self.stats

                                if (child_yang_name == "summary"):
                                    if (self.summary is None):
                                        self.summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.Summary()
                                        self.summary.parent = self
                                        self._children_name_map["summary"] = "summary"
                                    return self.summary

                                if (child_yang_name == "targeted-hellos"):
                                    if (self.targeted_hellos is None):
                                        self.targeted_hellos = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery.TargetedHellos()
                                        self.targeted_hellos.parent = self
                                        self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                    return self.targeted_hellos

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "brief" or name == "link-hellos" or name == "stats" or name == "summary" or name == "targeted-hellos"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsSummaryAll(Entity):
                            """
                            Aggregate VRF counters for the LDP Label
                            Infomation Base (LIB)
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: bind_af
                            
                            	bind af
                            	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf>`
                            
                            .. attribute:: binding_local_explicit_null
                            
                            	Number of local explicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_implicit_null
                            
                            	Number of local implicit null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_no_route
                            
                            	Local bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_non_null
                            
                            	Number of local non\-null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_null
                            
                            	Number of local null bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_local_oor
                            
                            	Number of local bindings        needing label \- OOR
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: binding_no_route
                            
                            	Bindings with no route
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: highest_allocated_label
                            
                            	Highest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lowest_allocated_label
                            
                            	Lowest allocated label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__init__()

                                self.yang_name = "bindings-summary-all"
                                self.yang_parent_name = "af"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.bind_af = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "binding_local_explicit_null",
                                                "binding_local_implicit_null",
                                                "binding_local_no_route",
                                                "binding_local_non_null",
                                                "binding_local_null",
                                                "binding_local_oor",
                                                "binding_no_route",
                                                "highest_allocated_label",
                                                "lowest_allocated_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "bindings-summary-all"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class BindAf(Entity):
                                """
                                bind af
                                
                                .. attribute:: address_family
                                
                                	Binding Summary Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: binding_local
                                
                                	Number of local bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_remote
                                
                                	Number of remote bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_total
                                
                                	Total bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: last_lib_update
                                
                                	Last update to LIB local binding
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lib_minimum_revision_sent_all
                                
                                	Last update sent to all peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__init__()

                                    self.yang_name = "bind-af"
                                    self.yang_parent_name = "bindings-summary-all"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local = YLeaf(YType.uint32, "binding-local")

                                    self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                    self.binding_total = YLeaf(YType.uint32, "binding-total")

                                    self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                    self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local",
                                                    "binding_remote",
                                                    "binding_total",
                                                    "last_lib_update",
                                                    "lib_minimum_revision_sent_all") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local.is_set or
                                        self.binding_remote.is_set or
                                        self.binding_total.is_set or
                                        self.last_lib_update.is_set or
                                        self.lib_minimum_revision_sent_all.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local.yfilter != YFilter.not_set or
                                        self.binding_remote.yfilter != YFilter.not_set or
                                        self.binding_total.yfilter != YFilter.not_set or
                                        self.last_lib_update.yfilter != YFilter.not_set or
                                        self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bind-af" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local.get_name_leafdata())
                                    if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                    if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_total.get_name_leafdata())
                                    if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                    if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local"):
                                        self.binding_local = value
                                        self.binding_local.value_namespace = name_space
                                        self.binding_local.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-remote"):
                                        self.binding_remote = value
                                        self.binding_remote.value_namespace = name_space
                                        self.binding_remote.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-total"):
                                        self.binding_total = value
                                        self.binding_total.value_namespace = name_space
                                        self.binding_total.value_namespace_prefix = name_space_prefix
                                    if(value_path == "last-lib-update"):
                                        self.last_lib_update = value
                                        self.last_lib_update.value_namespace = name_space
                                        self.last_lib_update.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lib-minimum-revision-sent-all"):
                                        self.lib_minimum_revision_sent_all = value
                                        self.lib_minimum_revision_sent_all.value_namespace = name_space
                                        self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bind_af:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.address_family.is_set or
                                    self.binding_local_explicit_null.is_set or
                                    self.binding_local_implicit_null.is_set or
                                    self.binding_local_no_route.is_set or
                                    self.binding_local_non_null.is_set or
                                    self.binding_local_null.is_set or
                                    self.binding_local_oor.is_set or
                                    self.binding_no_route.is_set or
                                    self.highest_allocated_label.is_set or
                                    self.lowest_allocated_label.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.bind_af:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                    self.binding_local_no_route.yfilter != YFilter.not_set or
                                    self.binding_local_non_null.yfilter != YFilter.not_set or
                                    self.binding_local_null.yfilter != YFilter.not_set or
                                    self.binding_local_oor.yfilter != YFilter.not_set or
                                    self.binding_no_route.yfilter != YFilter.not_set or
                                    self.highest_allocated_label.yfilter != YFilter.not_set or
                                    self.lowest_allocated_label.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-summary-all" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bind-af"):
                                    for c in self.bind_af:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.BindAf()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bind_af.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-explicit-null"):
                                    self.binding_local_explicit_null = value
                                    self.binding_local_explicit_null.value_namespace = name_space
                                    self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-implicit-null"):
                                    self.binding_local_implicit_null = value
                                    self.binding_local_implicit_null.value_namespace = name_space
                                    self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-no-route"):
                                    self.binding_local_no_route = value
                                    self.binding_local_no_route.value_namespace = name_space
                                    self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-non-null"):
                                    self.binding_local_non_null = value
                                    self.binding_local_non_null.value_namespace = name_space
                                    self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-null"):
                                    self.binding_local_null = value
                                    self.binding_local_null.value_namespace = name_space
                                    self.binding_local_null.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-local-oor"):
                                    self.binding_local_oor = value
                                    self.binding_local_oor.value_namespace = name_space
                                    self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                if(value_path == "binding-no-route"):
                                    self.binding_no_route = value
                                    self.binding_no_route.value_namespace = name_space
                                    self.binding_no_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "highest-allocated-label"):
                                    self.highest_allocated_label = value
                                    self.highest_allocated_label.value_namespace = name_space
                                    self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lowest-allocated-label"):
                                    self.lowest_allocated_label = value
                                    self.lowest_allocated_label.value_namespace = name_space
                                    self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                        class Forwardings(Entity):
                            """
                            The LDP Forwarding rewrites
                            
                            .. attribute:: forwarding
                            
                            	Information on a particular LDP forwarding rewrite
                            	**type**\: list of    :py:class:`Forwarding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings, self).__init__()

                                self.yang_name = "forwardings"
                                self.yang_parent_name = "af"

                                self.forwarding = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings, self).__setattr__(name, value)


                            class Forwarding(Entity):
                                """
                                Information on a particular LDP forwarding
                                rewrite
                                
                                .. attribute:: prefix  <key>
                                
                                	The IP Prefix
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                
                                
                                ----
                                .. attribute:: paths
                                
                                	Paths
                                	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths>`
                                
                                .. attribute:: prefix_length
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: prefix_xr
                                
                                	IP Prefix
                                	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr>`
                                
                                .. attribute:: route
                                
                                	Route
                                	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route>`
                                
                                .. attribute:: table_id
                                
                                	Table ID associated with IP prefix
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__init__()

                                    self.yang_name = "forwarding"
                                    self.yang_parent_name = "forwardings"

                                    self.prefix = YLeaf(YType.str, "prefix")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                    self.table_id = YLeaf(YType.uint32, "table-id")

                                    self.prefix_xr = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                    self.prefix_xr.parent = self
                                    self._children_name_map["prefix_xr"] = "prefix-xr"
                                    self._children_yang_names.add("prefix-xr")

                                    self.route = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route()
                                    self.route.parent = self
                                    self._children_name_map["route"] = "route"
                                    self._children_yang_names.add("route")

                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.paths = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("prefix",
                                                    "prefix_length",
                                                    "table_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "forwarding"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class PrefixXr(Entity):
                                    """
                                    IP Prefix
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__init__()

                                        self.yang_name = "prefix-xr"
                                        self.yang_parent_name = "forwarding"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prefix-xr" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class Route(Entity):
                                    """
                                    Route
                                    
                                    .. attribute:: mpls
                                    
                                    	MPLS information
                                    	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls>`
                                    
                                    .. attribute:: routing
                                    
                                    	IP routing information
                                    	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route, self).__init__()

                                        self.yang_name = "route"
                                        self.yang_parent_name = "forwarding"

                                        self.mpls = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                        self.mpls.parent = self
                                        self._children_name_map["mpls"] = "mpls"
                                        self._children_yang_names.add("mpls")

                                        self.routing = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                        self.routing.parent = self
                                        self._children_name_map["routing"] = "routing"
                                        self._children_yang_names.add("routing")


                                    class Routing(Entity):
                                        """
                                        IP routing information
                                        
                                        .. attribute:: flags
                                        
                                        	Route RIB flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_local_vrf_leaked
                                        
                                        	Is route leaked across local VRFs?
                                        	**type**\:  bool
                                        
                                        .. attribute:: metric
                                        
                                        	Route metric
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: priority
                                        
                                        	Route priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: routing_update_age
                                        
                                        	Last Routing update nanosec age
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: routing_update_count
                                        
                                        	Number of routing updates
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: routing_update_timestamp
                                        
                                        	Last Routing update nanosec timestamp
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: source
                                        
                                        	Route source protol Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: sr_local_label
                                        
                                        	SR Local\-label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: type
                                        
                                        	Route type
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: version
                                        
                                        	Route RIB ersion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__init__()

                                            self.yang_name = "routing"
                                            self.yang_parent_name = "route"

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.is_local_vrf_leaked = YLeaf(YType.boolean, "is-local-vrf-leaked")

                                            self.metric = YLeaf(YType.uint32, "metric")

                                            self.priority = YLeaf(YType.uint8, "priority")

                                            self.routing_update_age = YLeaf(YType.uint64, "routing-update-age")

                                            self.routing_update_count = YLeaf(YType.uint32, "routing-update-count")

                                            self.routing_update_timestamp = YLeaf(YType.uint64, "routing-update-timestamp")

                                            self.source = YLeaf(YType.uint16, "source")

                                            self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                            self.type = YLeaf(YType.uint16, "type")

                                            self.version = YLeaf(YType.uint32, "version")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("flags",
                                                            "is_local_vrf_leaked",
                                                            "metric",
                                                            "priority",
                                                            "routing_update_age",
                                                            "routing_update_count",
                                                            "routing_update_timestamp",
                                                            "source",
                                                            "sr_local_label",
                                                            "type",
                                                            "version") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.flags.is_set or
                                                self.is_local_vrf_leaked.is_set or
                                                self.metric.is_set or
                                                self.priority.is_set or
                                                self.routing_update_age.is_set or
                                                self.routing_update_count.is_set or
                                                self.routing_update_timestamp.is_set or
                                                self.source.is_set or
                                                self.sr_local_label.is_set or
                                                self.type.is_set or
                                                self.version.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.flags.yfilter != YFilter.not_set or
                                                self.is_local_vrf_leaked.yfilter != YFilter.not_set or
                                                self.metric.yfilter != YFilter.not_set or
                                                self.priority.yfilter != YFilter.not_set or
                                                self.routing_update_age.yfilter != YFilter.not_set or
                                                self.routing_update_count.yfilter != YFilter.not_set or
                                                self.routing_update_timestamp.yfilter != YFilter.not_set or
                                                self.source.yfilter != YFilter.not_set or
                                                self.sr_local_label.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set or
                                                self.version.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "routing" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flags.get_name_leafdata())
                                            if (self.is_local_vrf_leaked.is_set or self.is_local_vrf_leaked.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_local_vrf_leaked.get_name_leafdata())
                                            if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.metric.get_name_leafdata())
                                            if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.priority.get_name_leafdata())
                                            if (self.routing_update_age.is_set or self.routing_update_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_age.get_name_leafdata())
                                            if (self.routing_update_count.is_set or self.routing_update_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_count.get_name_leafdata())
                                            if (self.routing_update_timestamp.is_set or self.routing_update_timestamp.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.routing_update_timestamp.get_name_leafdata())
                                            if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source.get_name_leafdata())
                                            if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())
                                            if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.version.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "flags" or name == "is-local-vrf-leaked" or name == "metric" or name == "priority" or name == "routing-update-age" or name == "routing-update-count" or name == "routing-update-timestamp" or name == "source" or name == "sr-local-label" or name == "type" or name == "version"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "flags"):
                                                self.flags = value
                                                self.flags.value_namespace = name_space
                                                self.flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-local-vrf-leaked"):
                                                self.is_local_vrf_leaked = value
                                                self.is_local_vrf_leaked.value_namespace = name_space
                                                self.is_local_vrf_leaked.value_namespace_prefix = name_space_prefix
                                            if(value_path == "metric"):
                                                self.metric = value
                                                self.metric.value_namespace = name_space
                                                self.metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "priority"):
                                                self.priority = value
                                                self.priority.value_namespace = name_space
                                                self.priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-age"):
                                                self.routing_update_age = value
                                                self.routing_update_age.value_namespace = name_space
                                                self.routing_update_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-count"):
                                                self.routing_update_count = value
                                                self.routing_update_count.value_namespace = name_space
                                                self.routing_update_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "routing-update-timestamp"):
                                                self.routing_update_timestamp = value
                                                self.routing_update_timestamp.value_namespace = name_space
                                                self.routing_update_timestamp.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source"):
                                                self.source = value
                                                self.source.value_namespace = name_space
                                                self.source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "sr-local-label"):
                                                self.sr_local_label = value
                                                self.sr_local_label.value_namespace = name_space
                                                self.sr_local_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "version"):
                                                self.version = value
                                                self.version.value_namespace = name_space
                                                self.version.value_namespace_prefix = name_space_prefix


                                    class Mpls(Entity):
                                        """
                                        MPLS information
                                        
                                        .. attribute:: forwarding_update_age
                                        
                                        	Last Forwarding update nanosec age
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: forwarding_update_count
                                        
                                        	Number of forwarding updates
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: forwarding_update_timestamp
                                        
                                        	Last Forwarding update nanosec timestamp
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: local_label
                                        
                                        	Local label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__init__()

                                            self.yang_name = "mpls"
                                            self.yang_parent_name = "route"

                                            self.forwarding_update_age = YLeaf(YType.uint64, "forwarding-update-age")

                                            self.forwarding_update_count = YLeaf(YType.uint32, "forwarding-update-count")

                                            self.forwarding_update_timestamp = YLeaf(YType.uint64, "forwarding-update-timestamp")

                                            self.local_label = YLeaf(YType.uint32, "local-label")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("forwarding_update_age",
                                                            "forwarding_update_count",
                                                            "forwarding_update_timestamp",
                                                            "local_label") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.forwarding_update_age.is_set or
                                                self.forwarding_update_count.is_set or
                                                self.forwarding_update_timestamp.is_set or
                                                self.local_label.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.forwarding_update_age.yfilter != YFilter.not_set or
                                                self.forwarding_update_count.yfilter != YFilter.not_set or
                                                self.forwarding_update_timestamp.yfilter != YFilter.not_set or
                                                self.local_label.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mpls" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.forwarding_update_age.is_set or self.forwarding_update_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_age.get_name_leafdata())
                                            if (self.forwarding_update_count.is_set or self.forwarding_update_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_count.get_name_leafdata())
                                            if (self.forwarding_update_timestamp.is_set or self.forwarding_update_timestamp.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forwarding_update_timestamp.get_name_leafdata())
                                            if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_label.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "forwarding-update-age" or name == "forwarding-update-count" or name == "forwarding-update-timestamp" or name == "local-label"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "forwarding-update-age"):
                                                self.forwarding_update_age = value
                                                self.forwarding_update_age.value_namespace = name_space
                                                self.forwarding_update_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-update-count"):
                                                self.forwarding_update_count = value
                                                self.forwarding_update_count.value_namespace = name_space
                                                self.forwarding_update_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forwarding-update-timestamp"):
                                                self.forwarding_update_timestamp = value
                                                self.forwarding_update_timestamp.value_namespace = name_space
                                                self.forwarding_update_timestamp.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-label"):
                                                self.local_label = value
                                                self.local_label.value_namespace = name_space
                                                self.local_label.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.mpls is not None and self.mpls.has_data()) or
                                            (self.routing is not None and self.routing.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.mpls is not None and self.mpls.has_operation()) or
                                            (self.routing is not None and self.routing.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "route" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mpls"):
                                            if (self.mpls is None):
                                                self.mpls = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                                self.mpls.parent = self
                                                self._children_name_map["mpls"] = "mpls"
                                            return self.mpls

                                        if (child_yang_name == "routing"):
                                            if (self.routing is None):
                                                self.routing = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                                self.routing.parent = self
                                                self._children_name_map["routing"] = "routing"
                                            return self.routing

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mpls" or name == "routing"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Paths(Entity):
                                    """
                                    Paths
                                    
                                    .. attribute:: mpls
                                    
                                    	MPLS information
                                    	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls>`
                                    
                                    .. attribute:: routing
                                    
                                    	IP routing information
                                    	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths, self).__init__()

                                        self.yang_name = "paths"
                                        self.yang_parent_name = "forwarding"

                                        self.mpls = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                        self.mpls.parent = self
                                        self._children_name_map["mpls"] = "mpls"
                                        self._children_yang_names.add("mpls")

                                        self.routing = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                        self.routing.parent = self
                                        self._children_name_map["routing"] = "routing"
                                        self._children_yang_names.add("routing")


                                    class Routing(Entity):
                                        """
                                        IP routing information
                                        
                                        .. attribute:: bkup_path_id
                                        
                                        	Backup path Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: flags
                                        
                                        	Route path flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface Name
                                        	**type**\:  str
                                        
                                        .. attribute:: load_metric
                                        
                                        	Path's load metric for load balancing
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hop
                                        
                                        	Next Hop
                                        	**type**\:   :py:class:`NextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop>`
                                        
                                        .. attribute:: next_hop_table_id
                                        
                                        	Table ID for nexthop address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: nexthop_id
                                        
                                        	Nexthop Identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: nh_is_overriden
                                        
                                        	Nexthop is overriden by LDP
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_flags
                                        
                                        	Routing path flags decoded
                                        	**type**\:   :py:class:`LdpRoutePathFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathFlags>`
                                        
                                        .. attribute:: path_id
                                        
                                        	path Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: remote_lfa
                                        
                                        	Remote LFA\-FRR backup info
                                        	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__init__()

                                            self.yang_name = "routing"
                                            self.yang_parent_name = "paths"

                                            self.bkup_path_id = YLeaf(YType.uint8, "bkup-path-id")

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.load_metric = YLeaf(YType.uint32, "load-metric")

                                            self.next_hop_table_id = YLeaf(YType.uint32, "next-hop-table-id")

                                            self.nexthop_id = YLeaf(YType.uint32, "nexthop-id")

                                            self.nh_is_overriden = YLeaf(YType.boolean, "nh-is-overriden")

                                            self.path_flags = YLeaf(YType.enumeration, "path-flags")

                                            self.path_id = YLeaf(YType.uint8, "path-id")

                                            self.next_hop = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                            self.next_hop.parent = self
                                            self._children_name_map["next_hop"] = "next-hop"
                                            self._children_yang_names.add("next-hop")

                                            self.remote_lfa = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                            self.remote_lfa.parent = self
                                            self._children_name_map["remote_lfa"] = "remote-lfa"
                                            self._children_yang_names.add("remote-lfa")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bkup_path_id",
                                                            "flags",
                                                            "interface",
                                                            "interface_name",
                                                            "load_metric",
                                                            "next_hop_table_id",
                                                            "nexthop_id",
                                                            "nh_is_overriden",
                                                            "path_flags",
                                                            "path_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)


                                        class NextHop(Entity):
                                            """
                                            Next Hop
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__init__()

                                                self.yang_name = "next-hop"
                                                self.yang_parent_name = "routing"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "next-hop" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class RemoteLfa(Entity):
                                            """
                                            Remote LFA\-FRR backup info
                                            
                                            .. attribute:: has_q_node
                                            
                                            	Whether remote LFA path has a Q node associated
                                            	**type**\:  bool
                                            
                                            .. attribute:: has_remote_lfa_bkup
                                            
                                            	Whether path has remote LFA backup
                                            	**type**\:  bool
                                            
                                            .. attribute:: needs_tldp
                                            
                                            	Whether TLDP is needed with remote PQ node
                                            	**type**\:  bool
                                            
                                            .. attribute:: remote_p_node_id
                                            
                                            	Remote/P node address
                                            	**type**\:   :py:class:`RemotePNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId>`
                                            
                                            .. attribute:: remote_q_node_id
                                            
                                            	Remote/Q node address
                                            	**type**\:   :py:class:`RemoteQNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__init__()

                                                self.yang_name = "remote-lfa"
                                                self.yang_parent_name = "routing"

                                                self.has_q_node = YLeaf(YType.boolean, "has-q-node")

                                                self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                self.needs_tldp = YLeaf(YType.boolean, "needs-tldp")

                                                self.remote_p_node_id = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                self.remote_p_node_id.parent = self
                                                self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                self._children_yang_names.add("remote-p-node-id")

                                                self.remote_q_node_id = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                self.remote_q_node_id.parent = self
                                                self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                self._children_yang_names.add("remote-q-node-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("has_q_node",
                                                                "has_remote_lfa_bkup",
                                                                "needs_tldp") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)


                                            class RemotePNodeId(Entity):
                                                """
                                                Remote/P node address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__init__()

                                                    self.yang_name = "remote-p-node-id"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-p-node-id" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class RemoteQNodeId(Entity):
                                                """
                                                Remote/Q node address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__init__()

                                                    self.yang_name = "remote-q-node-id"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-q-node-id" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.has_q_node.is_set or
                                                    self.has_remote_lfa_bkup.is_set or
                                                    self.needs_tldp.is_set or
                                                    (self.remote_p_node_id is not None and self.remote_p_node_id.has_data()) or
                                                    (self.remote_q_node_id is not None and self.remote_q_node_id.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.has_q_node.yfilter != YFilter.not_set or
                                                    self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                    self.needs_tldp.yfilter != YFilter.not_set or
                                                    (self.remote_p_node_id is not None and self.remote_p_node_id.has_operation()) or
                                                    (self.remote_q_node_id is not None and self.remote_q_node_id.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "remote-lfa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.has_q_node.is_set or self.has_q_node.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_q_node.get_name_leafdata())
                                                if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())
                                                if (self.needs_tldp.is_set or self.needs_tldp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.needs_tldp.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "remote-p-node-id"):
                                                    if (self.remote_p_node_id is None):
                                                        self.remote_p_node_id = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                        self.remote_p_node_id.parent = self
                                                        self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                    return self.remote_p_node_id

                                                if (child_yang_name == "remote-q-node-id"):
                                                    if (self.remote_q_node_id is None):
                                                        self.remote_q_node_id = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                        self.remote_q_node_id.parent = self
                                                        self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                    return self.remote_q_node_id

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "remote-p-node-id" or name == "remote-q-node-id" or name == "has-q-node" or name == "has-remote-lfa-bkup" or name == "needs-tldp"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "has-q-node"):
                                                    self.has_q_node = value
                                                    self.has_q_node.value_namespace = name_space
                                                    self.has_q_node.value_namespace_prefix = name_space_prefix
                                                if(value_path == "has-remote-lfa-bkup"):
                                                    self.has_remote_lfa_bkup = value
                                                    self.has_remote_lfa_bkup.value_namespace = name_space
                                                    self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix
                                                if(value_path == "needs-tldp"):
                                                    self.needs_tldp = value
                                                    self.needs_tldp.value_namespace = name_space
                                                    self.needs_tldp.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.bkup_path_id.is_set or
                                                self.flags.is_set or
                                                self.interface.is_set or
                                                self.interface_name.is_set or
                                                self.load_metric.is_set or
                                                self.next_hop_table_id.is_set or
                                                self.nexthop_id.is_set or
                                                self.nh_is_overriden.is_set or
                                                self.path_flags.is_set or
                                                self.path_id.is_set or
                                                (self.next_hop is not None and self.next_hop.has_data()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bkup_path_id.yfilter != YFilter.not_set or
                                                self.flags.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.load_metric.yfilter != YFilter.not_set or
                                                self.next_hop_table_id.yfilter != YFilter.not_set or
                                                self.nexthop_id.yfilter != YFilter.not_set or
                                                self.nh_is_overriden.yfilter != YFilter.not_set or
                                                self.path_flags.yfilter != YFilter.not_set or
                                                self.path_id.yfilter != YFilter.not_set or
                                                (self.next_hop is not None and self.next_hop.has_operation()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "routing" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bkup_path_id.is_set or self.bkup_path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bkup_path_id.get_name_leafdata())
                                            if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.flags.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_metric.get_name_leafdata())
                                            if (self.next_hop_table_id.is_set or self.next_hop_table_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hop_table_id.get_name_leafdata())
                                            if (self.nexthop_id.is_set or self.nexthop_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nexthop_id.get_name_leafdata())
                                            if (self.nh_is_overriden.is_set or self.nh_is_overriden.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.nh_is_overriden.get_name_leafdata())
                                            if (self.path_flags.is_set or self.path_flags.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_flags.get_name_leafdata())
                                            if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "next-hop"):
                                                if (self.next_hop is None):
                                                    self.next_hop = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                    self.next_hop.parent = self
                                                    self._children_name_map["next_hop"] = "next-hop"
                                                return self.next_hop

                                            if (child_yang_name == "remote-lfa"):
                                                if (self.remote_lfa is None):
                                                    self.remote_lfa = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                    self.remote_lfa.parent = self
                                                    self._children_name_map["remote_lfa"] = "remote-lfa"
                                                return self.remote_lfa

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "next-hop" or name == "remote-lfa" or name == "bkup-path-id" or name == "flags" or name == "interface" or name == "interface-name" or name == "load-metric" or name == "next-hop-table-id" or name == "nexthop-id" or name == "nh-is-overriden" or name == "path-flags" or name == "path-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bkup-path-id"):
                                                self.bkup_path_id = value
                                                self.bkup_path_id.value_namespace = name_space
                                                self.bkup_path_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "flags"):
                                                self.flags = value
                                                self.flags.value_namespace = name_space
                                                self.flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-metric"):
                                                self.load_metric = value
                                                self.load_metric.value_namespace = name_space
                                                self.load_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hop-table-id"):
                                                self.next_hop_table_id = value
                                                self.next_hop_table_id.value_namespace = name_space
                                                self.next_hop_table_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nexthop-id"):
                                                self.nexthop_id = value
                                                self.nexthop_id.value_namespace = name_space
                                                self.nexthop_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "nh-is-overriden"):
                                                self.nh_is_overriden = value
                                                self.nh_is_overriden.value_namespace = name_space
                                                self.nh_is_overriden.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-flags"):
                                                self.path_flags = value
                                                self.path_flags.value_namespace = name_space
                                                self.path_flags.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-id"):
                                                self.path_id = value
                                                self.path_id.value_namespace = name_space
                                                self.path_id.value_namespace_prefix = name_space_prefix


                                    class Mpls(Entity):
                                        """
                                        MPLS information
                                        
                                        .. attribute:: mpls_outgoing_info
                                        
                                        	MPLS nexthop info
                                        	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo>`
                                        
                                        .. attribute:: remote_lfa
                                        
                                        	Remote LFA\-FRR backup info
                                        	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls, self).__init__()

                                            self.yang_name = "mpls"
                                            self.yang_parent_name = "paths"

                                            self.mpls_outgoing_info = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                            self.mpls_outgoing_info.parent = self
                                            self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                            self._children_yang_names.add("mpls-outgoing-info")

                                            self.remote_lfa = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                            self.remote_lfa.parent = self
                                            self._children_name_map["remote_lfa"] = "remote-lfa"
                                            self._children_yang_names.add("remote-lfa")


                                        class MplsOutgoingInfo(Entity):
                                            """
                                            MPLS nexthop info
                                            
                                            .. attribute:: is_from_graceful_restartable_neighbor
                                            
                                            	Is from a GR neighbor
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_stale
                                            
                                            	Is the entry stale
                                            	**type**\:  bool
                                            
                                            .. attribute:: nexthop_peer_ldp_ident
                                            
                                            	Nexthop LDP peer
                                            	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent>`
                                            
                                            .. attribute:: out_label
                                            
                                            	Outgoing label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: out_label_owner
                                            
                                            	Outgoing label owner
                                            	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                            
                                            .. attribute:: out_label_rsn
                                            
                                            	Outgoing label reason
                                            	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                            
                                            .. attribute:: out_label_type
                                            
                                            	Outgoing Label Type
                                            	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__init__()

                                                self.yang_name = "mpls-outgoing-info"
                                                self.yang_parent_name = "mpls"

                                                self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                self.out_label = YLeaf(YType.uint32, "out-label")

                                                self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                self.nexthop_peer_ldp_ident.parent = self
                                                self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                self._children_yang_names.add("nexthop-peer-ldp-ident")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_from_graceful_restartable_neighbor",
                                                                "is_stale",
                                                                "out_label",
                                                                "out_label_owner",
                                                                "out_label_rsn",
                                                                "out_label_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)


                                            class NexthopPeerLdpIdent(Entity):
                                                """
                                                Nexthop LDP peer
                                                
                                                .. attribute:: label_space_id
                                                
                                                	Label space identifier
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: ldp_id
                                                
                                                	LDP identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: lsr_id
                                                
                                                	LSR identifier
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__init__()

                                                    self.yang_name = "nexthop-peer-ldp-ident"
                                                    self.yang_parent_name = "mpls-outgoing-info"

                                                    self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                    self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("label_space_id",
                                                                    "ldp_id",
                                                                    "lsr_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.label_space_id.is_set or
                                                        self.ldp_id.is_set or
                                                        self.lsr_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.label_space_id.yfilter != YFilter.not_set or
                                                        self.ldp_id.yfilter != YFilter.not_set or
                                                        self.lsr_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                    if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "label-space-id"):
                                                        self.label_space_id = value
                                                        self.label_space_id.value_namespace = name_space
                                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ldp-id"):
                                                        self.ldp_id = value
                                                        self.ldp_id.value_namespace = name_space
                                                        self.ldp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "lsr-id"):
                                                        self.lsr_id = value
                                                        self.lsr_id.value_namespace = name_space
                                                        self.lsr_id.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.is_from_graceful_restartable_neighbor.is_set or
                                                    self.is_stale.is_set or
                                                    self.out_label.is_set or
                                                    self.out_label_owner.is_set or
                                                    self.out_label_rsn.is_set or
                                                    self.out_label_type.is_set or
                                                    (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                    self.is_stale.yfilter != YFilter.not_set or
                                                    self.out_label.yfilter != YFilter.not_set or
                                                    self.out_label_owner.yfilter != YFilter.not_set or
                                                    self.out_label_rsn.yfilter != YFilter.not_set or
                                                    self.out_label_type.yfilter != YFilter.not_set or
                                                    (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls-outgoing-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                                if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                    if (self.nexthop_peer_ldp_ident is None):
                                                        self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                        self.nexthop_peer_ldp_ident.parent = self
                                                        self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                    return self.nexthop_peer_ldp_ident

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-from-graceful-restartable-neighbor"):
                                                    self.is_from_graceful_restartable_neighbor = value
                                                    self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                    self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-stale"):
                                                    self.is_stale = value
                                                    self.is_stale.value_namespace = name_space
                                                    self.is_stale.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label"):
                                                    self.out_label = value
                                                    self.out_label.value_namespace = name_space
                                                    self.out_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-owner"):
                                                    self.out_label_owner = value
                                                    self.out_label_owner.value_namespace = name_space
                                                    self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-rsn"):
                                                    self.out_label_rsn = value
                                                    self.out_label_rsn.value_namespace = name_space
                                                    self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                if(value_path == "out-label-type"):
                                                    self.out_label_type = value
                                                    self.out_label_type.value_namespace = name_space
                                                    self.out_label_type.value_namespace_prefix = name_space_prefix


                                        class RemoteLfa(Entity):
                                            """
                                            Remote LFA\-FRR backup info
                                            
                                            .. attribute:: has_remote_lfa_bkup
                                            
                                            	Whether path has remote LFA backup
                                            	**type**\:  bool
                                            
                                            .. attribute:: mpls_outgoing_info
                                            
                                            	Remote LFA MPLS nexthop(s\_ info
                                            	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__init__()

                                                self.yang_name = "remote-lfa"
                                                self.yang_parent_name = "mpls"

                                                self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                self.mpls_outgoing_info = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                self.mpls_outgoing_info.parent = self
                                                self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                self._children_yang_names.add("mpls-outgoing-info")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("has_remote_lfa_bkup") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)


                                            class MplsOutgoingInfo(Entity):
                                                """
                                                Remote LFA MPLS nexthop(s\_ info
                                                
                                                .. attribute:: stack
                                                
                                                	Inner label stack info
                                                	**type**\: list of    :py:class:`Stack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__init__()

                                                    self.yang_name = "mpls-outgoing-info"
                                                    self.yang_parent_name = "remote-lfa"

                                                    self.stack = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in () and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)


                                                class Stack(Entity):
                                                    """
                                                    Inner label stack info
                                                    
                                                    .. attribute:: is_from_graceful_restartable_neighbor
                                                    
                                                    	Is from a GR neighbor
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: is_stale
                                                    
                                                    	Is the entry stale
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: nexthop_peer_ldp_ident
                                                    
                                                    	Nexthop LDP peer
                                                    	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent>`
                                                    
                                                    .. attribute:: out_label
                                                    
                                                    	Outgoing label
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: out_label_owner
                                                    
                                                    	Outgoing label owner
                                                    	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                    
                                                    .. attribute:: out_label_rsn
                                                    
                                                    	Outgoing label reason
                                                    	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                    
                                                    .. attribute:: out_label_type
                                                    
                                                    	Outgoing Label Type
                                                    	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__init__()

                                                        self.yang_name = "stack"
                                                        self.yang_parent_name = "mpls-outgoing-info"

                                                        self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                        self.out_label = YLeaf(YType.uint32, "out-label")

                                                        self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                        self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                        self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                        self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                        self.nexthop_peer_ldp_ident.parent = self
                                                        self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                        self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("is_from_graceful_restartable_neighbor",
                                                                        "is_stale",
                                                                        "out_label",
                                                                        "out_label_owner",
                                                                        "out_label_rsn",
                                                                        "out_label_type") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)


                                                    class NexthopPeerLdpIdent(Entity):
                                                        """
                                                        Nexthop LDP peer
                                                        
                                                        .. attribute:: label_space_id
                                                        
                                                        	Label space identifier
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: ldp_id
                                                        
                                                        	LDP identifier
                                                        	**type**\:  str
                                                        
                                                        .. attribute:: lsr_id
                                                        
                                                        	LSR identifier
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-ldp-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__init__()

                                                            self.yang_name = "nexthop-peer-ldp-ident"
                                                            self.yang_parent_name = "stack"

                                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("label_space_id",
                                                                            "ldp_id",
                                                                            "lsr_id") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.label_space_id.is_set or
                                                                self.ldp_id.is_set or
                                                                self.lsr_id.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.label_space_id.yfilter != YFilter.not_set or
                                                                self.ldp_id.yfilter != YFilter.not_set or
                                                                self.lsr_id.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "label-space-id"):
                                                                self.label_space_id = value
                                                                self.label_space_id.value_namespace = name_space
                                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "ldp-id"):
                                                                self.ldp_id = value
                                                                self.ldp_id.value_namespace = name_space
                                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "lsr-id"):
                                                                self.lsr_id = value
                                                                self.lsr_id.value_namespace = name_space
                                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.is_from_graceful_restartable_neighbor.is_set or
                                                            self.is_stale.is_set or
                                                            self.out_label.is_set or
                                                            self.out_label_owner.is_set or
                                                            self.out_label_rsn.is_set or
                                                            self.out_label_type.is_set or
                                                            (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                            self.is_stale.yfilter != YFilter.not_set or
                                                            self.out_label.yfilter != YFilter.not_set or
                                                            self.out_label_owner.yfilter != YFilter.not_set or
                                                            self.out_label_rsn.yfilter != YFilter.not_set or
                                                            self.out_label_type.yfilter != YFilter.not_set or
                                                            (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "stack" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                        if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label.get_name_leafdata())
                                                        if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                        if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                        if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                            if (self.nexthop_peer_ldp_ident is None):
                                                                self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                                self.nexthop_peer_ldp_ident.parent = self
                                                                self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                            return self.nexthop_peer_ldp_ident

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "is-from-graceful-restartable-neighbor"):
                                                            self.is_from_graceful_restartable_neighbor = value
                                                            self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                            self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "is-stale"):
                                                            self.is_stale = value
                                                            self.is_stale.value_namespace = name_space
                                                            self.is_stale.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label"):
                                                            self.out_label = value
                                                            self.out_label.value_namespace = name_space
                                                            self.out_label.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-owner"):
                                                            self.out_label_owner = value
                                                            self.out_label_owner.value_namespace = name_space
                                                            self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-rsn"):
                                                            self.out_label_rsn = value
                                                            self.out_label_rsn.value_namespace = name_space
                                                            self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "out-label-type"):
                                                            self.out_label_type = value
                                                            self.out_label_type.value_namespace = name_space
                                                            self.out_label_type.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.stack:
                                                        if (c.has_data()):
                                                            return True
                                                    return False

                                                def has_operation(self):
                                                    for c in self.stack:
                                                        if (c.has_operation()):
                                                            return True
                                                    return self.yfilter != YFilter.not_set

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mpls-outgoing-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "stack"):
                                                        for c in self.stack:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.stack.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "stack"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    pass

                                            def has_data(self):
                                                return (
                                                    self.has_remote_lfa_bkup.is_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "remote-lfa" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mpls-outgoing-info"):
                                                    if (self.mpls_outgoing_info is None):
                                                        self.mpls_outgoing_info = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                        self.mpls_outgoing_info.parent = self
                                                        self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    return self.mpls_outgoing_info

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mpls-outgoing-info" or name == "has-remote-lfa-bkup"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "has-remote-lfa-bkup"):
                                                    self.has_remote_lfa_bkup = value
                                                    self.has_remote_lfa_bkup.value_namespace = name_space
                                                    self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()) or
                                                (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mpls" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls-outgoing-info"):
                                                if (self.mpls_outgoing_info is None):
                                                    self.mpls_outgoing_info = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                    self.mpls_outgoing_info.parent = self
                                                    self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                return self.mpls_outgoing_info

                                            if (child_yang_name == "remote-lfa"):
                                                if (self.remote_lfa is None):
                                                    self.remote_lfa = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                    self.remote_lfa.parent = self
                                                    self._children_name_map["remote_lfa"] = "remote-lfa"
                                                return self.remote_lfa

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls-outgoing-info" or name == "remote-lfa"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.mpls is not None and self.mpls.has_data()) or
                                            (self.routing is not None and self.routing.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.mpls is not None and self.mpls.has_operation()) or
                                            (self.routing is not None and self.routing.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "paths" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "mpls"):
                                            if (self.mpls is None):
                                                self.mpls = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                                self.mpls.parent = self
                                                self._children_name_map["mpls"] = "mpls"
                                            return self.mpls

                                        if (child_yang_name == "routing"):
                                            if (self.routing is None):
                                                self.routing = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                                self.routing.parent = self
                                                self._children_name_map["routing"] = "routing"
                                            return self.routing

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "mpls" or name == "routing"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    for c in self.paths:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.prefix.is_set or
                                        self.prefix_length.is_set or
                                        self.table_id.is_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                        (self.route is not None and self.route.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.paths:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.prefix.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set or
                                        self.table_id.yfilter != YFilter.not_set or
                                        (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                        (self.route is not None and self.route.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwarding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                    if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.table_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "paths"):
                                        for c in self.paths:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Paths()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.paths.append(c)
                                        return c

                                    if (child_yang_name == "prefix-xr"):
                                        if (self.prefix_xr is None):
                                            self.prefix_xr = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                            self.prefix_xr.parent = self
                                            self._children_name_map["prefix_xr"] = "prefix-xr"
                                        return self.prefix_xr

                                    if (child_yang_name == "route"):
                                        if (self.route is None):
                                            self.route = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Route()
                                            self.route.parent = self
                                            self._children_name_map["route"] = "route"
                                        return self.route

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "paths" or name == "prefix-xr" or name == "route" or name == "vrf" or name == "prefix" or name == "prefix-length" or name == "table-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "prefix"):
                                        self.prefix = value
                                        self.prefix.value_namespace = name_space
                                        self.prefix.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "table-id"):
                                        self.table_id = value
                                        self.table_id.value_namespace = name_space
                                        self.table_id.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.forwarding:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.forwarding:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "forwardings" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "forwarding"):
                                    for c in self.forwarding:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings.Forwarding()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.forwarding.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "forwarding"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class BindingsAdvertiseSpec(Entity):
                            """
                            Advertisement Spec (ACL) for LDP Label
                            Infomation Base (LIB)
                            
                            .. attribute:: advt_acl
                            
                            	Advertisement ACLs
                            	**type**\: list of    :py:class:`AdvtAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl>`
                            
                            .. attribute:: allocation_acl
                            
                            	Local label Allocation filter
                            	**type**\:   :py:class:`AllocationAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__init__()

                                self.yang_name = "bindings-advertise-spec"
                                self.yang_parent_name = "af"

                                self.allocation_acl = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                self.allocation_acl.parent = self
                                self._children_name_map["allocation_acl"] = "allocation-acl"
                                self._children_yang_names.add("allocation-acl")

                                self.advt_acl = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)


                            class AllocationAcl(Entity):
                                """
                                Local label Allocation filter
                                
                                .. attribute:: has_acl
                                
                                	Has ACL filter?
                                	**type**\:  bool
                                
                                .. attribute:: is_host_route_only
                                
                                	Host\-routes only?
                                	**type**\:  bool
                                
                                .. attribute:: prefix_acl
                                
                                	Prefix ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__init__()

                                    self.yang_name = "allocation-acl"
                                    self.yang_parent_name = "bindings-advertise-spec"

                                    self.has_acl = YLeaf(YType.boolean, "has-acl")

                                    self.is_host_route_only = YLeaf(YType.boolean, "is-host-route-only")

                                    self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("has_acl",
                                                    "is_host_route_only",
                                                    "prefix_acl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.has_acl.is_set or
                                        self.is_host_route_only.is_set or
                                        self.prefix_acl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.has_acl.yfilter != YFilter.not_set or
                                        self.is_host_route_only.yfilter != YFilter.not_set or
                                        self.prefix_acl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "allocation-acl" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.has_acl.is_set or self.has_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_acl.get_name_leafdata())
                                    if (self.is_host_route_only.is_set or self.is_host_route_only.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_host_route_only.get_name_leafdata())
                                    if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "has-acl" or name == "is-host-route-only" or name == "prefix-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "has-acl"):
                                        self.has_acl = value
                                        self.has_acl.value_namespace = name_space
                                        self.has_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-host-route-only"):
                                        self.is_host_route_only = value
                                        self.is_host_route_only.value_namespace = name_space
                                        self.is_host_route_only.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-acl"):
                                        self.prefix_acl = value
                                        self.prefix_acl.value_namespace = name_space
                                        self.prefix_acl.value_namespace_prefix = name_space_prefix


                            class AdvtAcl(Entity):
                                """
                                Advertisement ACLs
                                
                                .. attribute:: peer_acl
                                
                                	Peer ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                .. attribute:: prefix_acl
                                
                                	Prefix ACL
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__init__()

                                    self.yang_name = "advt-acl"
                                    self.yang_parent_name = "bindings-advertise-spec"

                                    self.peer_acl = YLeaf(YType.str, "peer-acl")

                                    self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("peer_acl",
                                                    "prefix_acl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.peer_acl.is_set or
                                        self.prefix_acl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.peer_acl.yfilter != YFilter.not_set or
                                        self.prefix_acl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "advt-acl" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.peer_acl.is_set or self.peer_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_acl.get_name_leafdata())
                                    if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "peer-acl" or name == "prefix-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "peer-acl"):
                                        self.peer_acl = value
                                        self.peer_acl.value_namespace = name_space
                                        self.peer_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-acl"):
                                        self.prefix_acl = value
                                        self.prefix_acl.value_namespace = name_space
                                        self.prefix_acl.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.advt_acl:
                                    if (c.has_data()):
                                        return True
                                return (self.allocation_acl is not None and self.allocation_acl.has_data())

                            def has_operation(self):
                                for c in self.advt_acl:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.allocation_acl is not None and self.allocation_acl.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bindings-advertise-spec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "advt-acl"):
                                    for c in self.advt_acl:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.advt_acl.append(c)
                                    return c

                                if (child_yang_name == "allocation-acl"):
                                    if (self.allocation_acl is None):
                                        self.allocation_acl = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                        self.allocation_acl.parent = self
                                        self._children_name_map["allocation_acl"] = "allocation-acl"
                                    return self.allocation_acl

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "advt-acl" or name == "allocation-acl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class ForwardingSummary(Entity):
                            """
                            Summary information regarding LDP forwarding
                            setup
                            
                            .. attribute:: fsht
                            
                            	Forwarding state hold time registered with LSD
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: intfs
                            
                            	MPLS forwarding enabled interface count
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: is_lsd_bound
                            
                            	LDP is connected to LSD server
                            	**type**\:  bool
                            
                            .. attribute:: lbls
                            
                            	Local label allocated count
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: rws
                            
                            	Forwarding rewrites summary
                            	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary, self).__init__()

                                self.yang_name = "forwarding-summary"
                                self.yang_parent_name = "af"

                                self.fsht = YLeaf(YType.uint16, "fsht")

                                self.intfs = YLeaf(YType.uint16, "intfs")

                                self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                                self.lbls = YLeaf(YType.uint16, "lbls")

                                self.rws = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws()
                                self.rws.parent = self
                                self._children_name_map["rws"] = "rws"
                                self._children_yang_names.add("rws")

                                self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fsht",
                                                "intfs",
                                                "is_lsd_bound",
                                                "lbls") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "forwarding-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Rws(Entity):
                                """
                                Forwarding rewrites summary
                                
                                .. attribute:: nhs
                                
                                	Forwarding rewrites nexthops (paths) summary
                                	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs>`
                                
                                .. attribute:: pfxs
                                
                                	Forwarding rewrites prefix summary
                                	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws, self).__init__()

                                    self.yang_name = "rws"
                                    self.yang_parent_name = "forwarding-summary"

                                    self.nhs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                    self.nhs.parent = self
                                    self._children_name_map["nhs"] = "nhs"
                                    self._children_yang_names.add("nhs")

                                    self.pfxs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                    self.pfxs.parent = self
                                    self._children_name_map["pfxs"] = "pfxs"
                                    self._children_yang_names.add("pfxs")


                                class Pfxs(Entity):
                                    """
                                    Forwarding rewrites prefix summary
                                    
                                    .. attribute:: ecmp_pfxs
                                    
                                    	Count of prefixes with ECMP
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: labeled_pfxs_aggr
                                    
                                    	Labeled prefix count for all paths
                                    	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr>`
                                    
                                    .. attribute:: labeled_pfxs_backup
                                    
                                    	Labeled prefix count related to backup paths only
                                    	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup>`
                                    
                                    .. attribute:: labeled_pfxs_primary
                                    
                                    	Labeled prefix count related to primary paths only
                                    	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary>`
                                    
                                    .. attribute:: protected_pfxs
                                    
                                    	Count of FRR protected prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: total_pfxs
                                    
                                    	Total Prefix count
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__init__()

                                        self.yang_name = "pfxs"
                                        self.yang_parent_name = "rws"

                                        self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                                        self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                                        self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                                        self.labeled_pfxs_aggr = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                        self.labeled_pfxs_aggr.parent = self
                                        self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                        self._children_yang_names.add("labeled-pfxs-aggr")

                                        self.labeled_pfxs_backup = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                        self.labeled_pfxs_backup.parent = self
                                        self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                        self._children_yang_names.add("labeled-pfxs-backup")

                                        self.labeled_pfxs_primary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                        self.labeled_pfxs_primary.parent = self
                                        self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                        self._children_yang_names.add("labeled-pfxs-primary")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ecmp_pfxs",
                                                        "protected_pfxs",
                                                        "total_pfxs") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)


                                    class LabeledPfxsAggr(Entity):
                                        """
                                        Labeled prefix count for all paths
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                            self.yang_name = "labeled-pfxs-aggr"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-aggr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                    class LabeledPfxsPrimary(Entity):
                                        """
                                        Labeled prefix count related to primary paths
                                        only
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                            self.yang_name = "labeled-pfxs-primary"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-primary" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                    class LabeledPfxsBackup(Entity):
                                        """
                                        Labeled prefix count related to backup paths
                                        only
                                        
                                        .. attribute:: labeled_pfxs
                                        
                                        	Count of labeled prefixes with 1 or more paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_partial
                                        
                                        	Count of labeled prefixes with some (but not ALL) paths labeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: unlabeled_pfxs
                                        
                                        	Count of labeled prefixes with ALL paths unlabeled
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                            self.yang_name = "labeled-pfxs-backup"
                                            self.yang_parent_name = "pfxs"

                                            self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                            self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                            self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("labeled_pfxs",
                                                            "labeled_pfxs_partial",
                                                            "unlabeled_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.labeled_pfxs.is_set or
                                                self.labeled_pfxs_partial.is_set or
                                                self.unlabeled_pfxs.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.labeled_pfxs.yfilter != YFilter.not_set or
                                                self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "labeled-pfxs-backup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                            if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                            if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "labeled-pfxs"):
                                                self.labeled_pfxs = value
                                                self.labeled_pfxs.value_namespace = name_space
                                                self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-pfxs-partial"):
                                                self.labeled_pfxs_partial = value
                                                self.labeled_pfxs_partial.value_namespace = name_space
                                                self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                            if(value_path == "unlabeled-pfxs"):
                                                self.unlabeled_pfxs = value
                                                self.unlabeled_pfxs.value_namespace = name_space
                                                self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.ecmp_pfxs.is_set or
                                            self.protected_pfxs.is_set or
                                            self.total_pfxs.is_set or
                                            (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                            (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                            (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ecmp_pfxs.yfilter != YFilter.not_set or
                                            self.protected_pfxs.yfilter != YFilter.not_set or
                                            self.total_pfxs.yfilter != YFilter.not_set or
                                            (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                            (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                            (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "pfxs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                                        if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                                        if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "labeled-pfxs-aggr"):
                                            if (self.labeled_pfxs_aggr is None):
                                                self.labeled_pfxs_aggr = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                                self.labeled_pfxs_aggr.parent = self
                                                self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                            return self.labeled_pfxs_aggr

                                        if (child_yang_name == "labeled-pfxs-backup"):
                                            if (self.labeled_pfxs_backup is None):
                                                self.labeled_pfxs_backup = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                                self.labeled_pfxs_backup.parent = self
                                                self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                            return self.labeled_pfxs_backup

                                        if (child_yang_name == "labeled-pfxs-primary"):
                                            if (self.labeled_pfxs_primary is None):
                                                self.labeled_pfxs_primary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                                self.labeled_pfxs_primary.parent = self
                                                self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                            return self.labeled_pfxs_primary

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ecmp-pfxs"):
                                            self.ecmp_pfxs = value
                                            self.ecmp_pfxs.value_namespace = name_space
                                            self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protected-pfxs"):
                                            self.protected_pfxs = value
                                            self.protected_pfxs.value_namespace = name_space
                                            self.protected_pfxs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-pfxs"):
                                            self.total_pfxs = value
                                            self.total_pfxs.value_namespace = name_space
                                            self.total_pfxs.value_namespace_prefix = name_space_prefix


                                class Nhs(Entity):
                                    """
                                    Forwarding rewrites nexthops (paths) summary
                                    
                                    .. attribute:: backup_paths
                                    
                                    	Count of non\-primary backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: labeled_backup_paths
                                    
                                    	Count of labeled backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: labeled_paths
                                    
                                    	Count of all labeled paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: protected_paths
                                    
                                    	Count of FRR protected paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: remote_backup_paths
                                    
                                    	Count of non\-primary remote backup paths
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_paths
                                    
                                    	Total path count
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__init__()

                                        self.yang_name = "nhs"
                                        self.yang_parent_name = "rws"

                                        self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                                        self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                                        self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                                        self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                                        self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                                        self.total_paths = YLeaf(YType.uint32, "total-paths")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("backup_paths",
                                                        "labeled_backup_paths",
                                                        "labeled_paths",
                                                        "protected_paths",
                                                        "remote_backup_paths",
                                                        "total_paths") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.backup_paths.is_set or
                                            self.labeled_backup_paths.is_set or
                                            self.labeled_paths.is_set or
                                            self.protected_paths.is_set or
                                            self.remote_backup_paths.is_set or
                                            self.total_paths.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.backup_paths.yfilter != YFilter.not_set or
                                            self.labeled_backup_paths.yfilter != YFilter.not_set or
                                            self.labeled_paths.yfilter != YFilter.not_set or
                                            self.protected_paths.yfilter != YFilter.not_set or
                                            self.remote_backup_paths.yfilter != YFilter.not_set or
                                            self.total_paths.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "nhs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.backup_paths.get_name_leafdata())
                                        if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                                        if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                                        if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protected_paths.get_name_leafdata())
                                        if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                                        if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_paths.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "backup-paths"):
                                            self.backup_paths = value
                                            self.backup_paths.value_namespace = name_space
                                            self.backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "labeled-backup-paths"):
                                            self.labeled_backup_paths = value
                                            self.labeled_backup_paths.value_namespace = name_space
                                            self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "labeled-paths"):
                                            self.labeled_paths = value
                                            self.labeled_paths.value_namespace = name_space
                                            self.labeled_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protected-paths"):
                                            self.protected_paths = value
                                            self.protected_paths.value_namespace = name_space
                                            self.protected_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remote-backup-paths"):
                                            self.remote_backup_paths = value
                                            self.remote_backup_paths.value_namespace = name_space
                                            self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-paths"):
                                            self.total_paths = value
                                            self.total_paths.value_namespace = name_space
                                            self.total_paths.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.nhs is not None and self.nhs.has_data()) or
                                        (self.pfxs is not None and self.pfxs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.nhs is not None and self.nhs.has_operation()) or
                                        (self.pfxs is not None and self.pfxs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "rws" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "nhs"):
                                        if (self.nhs is None):
                                            self.nhs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                            self.nhs.parent = self
                                            self._children_name_map["nhs"] = "nhs"
                                        return self.nhs

                                    if (child_yang_name == "pfxs"):
                                        if (self.pfxs is None):
                                            self.pfxs = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                            self.pfxs.parent = self
                                            self._children_name_map["pfxs"] = "pfxs"
                                        return self.pfxs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nhs" or name == "pfxs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.fsht.is_set or
                                    self.intfs.is_set or
                                    self.is_lsd_bound.is_set or
                                    self.lbls.is_set or
                                    (self.rws is not None and self.rws.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fsht.yfilter != YFilter.not_set or
                                    self.intfs.yfilter != YFilter.not_set or
                                    self.is_lsd_bound.yfilter != YFilter.not_set or
                                    self.lbls.yfilter != YFilter.not_set or
                                    (self.rws is not None and self.rws.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "forwarding-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fsht.get_name_leafdata())
                                if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.intfs.get_name_leafdata())
                                if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                                if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lbls.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "rws"):
                                    if (self.rws is None):
                                        self.rws = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Rws()
                                        self.rws.parent = self
                                        self._children_name_map["rws"] = "rws"
                                    return self.rws

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fsht"):
                                    self.fsht = value
                                    self.fsht.value_namespace = name_space
                                    self.fsht.value_namespace_prefix = name_space_prefix
                                if(value_path == "intfs"):
                                    self.intfs = value
                                    self.intfs.value_namespace = name_space
                                    self.intfs.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lsd-bound"):
                                    self.is_lsd_bound = value
                                    self.is_lsd_bound.value_namespace = name_space
                                    self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                                if(value_path == "lbls"):
                                    self.lbls = value
                                    self.lbls.value_namespace = name_space
                                    self.lbls.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.af_name.is_set or
                                (self.bindings is not None and self.bindings.has_data()) or
                                (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_data()) or
                                (self.bindings_summary is not None and self.bindings_summary.has_data()) or
                                (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                                (self.discovery is not None and self.discovery.has_data()) or
                                (self.forwarding_summary is not None and self.forwarding_summary.has_data()) or
                                (self.forwardings is not None and self.forwardings.has_data()) or
                                (self.igp is not None and self.igp.has_data()) or
                                (self.interface_summary is not None and self.interface_summary.has_data()) or
                                (self.interfaces is not None and self.interfaces.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.af_name.yfilter != YFilter.not_set or
                                (self.bindings is not None and self.bindings.has_operation()) or
                                (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_operation()) or
                                (self.bindings_summary is not None and self.bindings_summary.has_operation()) or
                                (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                                (self.discovery is not None and self.discovery.has_operation()) or
                                (self.forwarding_summary is not None and self.forwarding_summary.has_operation()) or
                                (self.forwardings is not None and self.forwardings.has_operation()) or
                                (self.igp is not None and self.igp.has_operation()) or
                                (self.interface_summary is not None and self.interface_summary.has_operation()) or
                                (self.interfaces is not None and self.interfaces.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "af" + "[af-name='" + self.af_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.af_name.is_set or self.af_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.af_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bindings"):
                                if (self.bindings is None):
                                    self.bindings = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Bindings()
                                    self.bindings.parent = self
                                    self._children_name_map["bindings"] = "bindings"
                                return self.bindings

                            if (child_yang_name == "bindings-advertise-spec"):
                                if (self.bindings_advertise_spec is None):
                                    self.bindings_advertise_spec = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsAdvertiseSpec()
                                    self.bindings_advertise_spec.parent = self
                                    self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                return self.bindings_advertise_spec

                            if (child_yang_name == "bindings-summary"):
                                if (self.bindings_summary is None):
                                    self.bindings_summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummary()
                                    self.bindings_summary.parent = self
                                    self._children_name_map["bindings_summary"] = "bindings-summary"
                                return self.bindings_summary

                            if (child_yang_name == "bindings-summary-all"):
                                if (self.bindings_summary_all is None):
                                    self.bindings_summary_all = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.BindingsSummaryAll()
                                    self.bindings_summary_all.parent = self
                                    self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                return self.bindings_summary_all

                            if (child_yang_name == "discovery"):
                                if (self.discovery is None):
                                    self.discovery = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Discovery()
                                    self.discovery.parent = self
                                    self._children_name_map["discovery"] = "discovery"
                                return self.discovery

                            if (child_yang_name == "forwarding-summary"):
                                if (self.forwarding_summary is None):
                                    self.forwarding_summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.ForwardingSummary()
                                    self.forwarding_summary.parent = self
                                    self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                return self.forwarding_summary

                            if (child_yang_name == "forwardings"):
                                if (self.forwardings is None):
                                    self.forwardings = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Forwardings()
                                    self.forwardings.parent = self
                                    self._children_name_map["forwardings"] = "forwardings"
                                return self.forwardings

                            if (child_yang_name == "igp"):
                                if (self.igp is None):
                                    self.igp = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Igp()
                                    self.igp.parent = self
                                    self._children_name_map["igp"] = "igp"
                                return self.igp

                            if (child_yang_name == "interface-summary"):
                                if (self.interface_summary is None):
                                    self.interface_summary = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.InterfaceSummary()
                                    self.interface_summary.parent = self
                                    self._children_name_map["interface_summary"] = "interface-summary"
                                return self.interface_summary

                            if (child_yang_name == "interfaces"):
                                if (self.interfaces is None):
                                    self.interfaces = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af.Interfaces()
                                    self.interfaces.parent = self
                                    self._children_name_map["interfaces"] = "interfaces"
                                return self.interfaces

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bindings" or name == "bindings-advertise-spec" or name == "bindings-summary" or name == "bindings-summary-all" or name == "discovery" or name == "forwarding-summary" or name == "forwardings" or name == "igp" or name == "interface-summary" or name == "interfaces" or name == "af-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "af-name"):
                                self.af_name = value
                                self.af_name.value_namespace = name_space
                                self.af_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.af:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.af:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "afs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "af"):
                            for c in self.af:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.Afs.Af()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.af.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "af"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborBriefs(Entity):
                    """
                    The LDP Neighbors (brief)
                    
                    .. attribute:: neighbor_brief
                    
                    	Brief information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`NeighborBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs, self).__init__()

                        self.yang_name = "neighbor-briefs"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor_brief = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs, self).__setattr__(name, value)


                    class NeighborBrief(Entity):
                        """
                        Brief information on a particular LDP neighbor
                        
                        .. attribute:: is_graceful_restartable
                        
                        	Is graceful restartable
                        	**type**\:  bool
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: nbr_br_af_info
                        
                        	Neighbor Brief AF Info
                        	**type**\: list of    :py:class:`NbrBrAfInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo>`
                        
                        .. attribute:: nsr_state
                        
                        	NSR readiness state
                        	**type**\:   :py:class:`ShowNsrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.ShowNsrState>`
                        
                        .. attribute:: up_time_seconds
                        
                        	Up time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief, self).__init__()

                            self.yang_name = "neighbor-brief"
                            self.yang_parent_name = "neighbor-briefs"

                            self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.nsr_state = YLeaf(YType.enumeration, "nsr-state")

                            self.up_time_seconds = YLeaf(YType.uint32, "up-time-seconds")

                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")

                            self.nbr_br_af_info = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_graceful_restartable",
                                            "label_space_id",
                                            "lsr_id",
                                            "nsr_state",
                                            "up_time_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "neighbor-brief"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class NbrBrAfInfo(Entity):
                            """
                            Neighbor Brief AF Info
                            
                            .. attribute:: address_family
                            
                            	Neighbor Brief Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: num_of_nbr_addresses
                            
                            	Number of neighbor addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: num_of_nbr_discovery
                            
                            	Number of neighbor discovery sources
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: num_of_nbr_lbl
                            
                            	Number of neighbor labels
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__init__()

                                self.yang_name = "nbr-br-af-info"
                                self.yang_parent_name = "neighbor-brief"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.num_of_nbr_addresses = YLeaf(YType.uint32, "num-of-nbr-addresses")

                                self.num_of_nbr_discovery = YLeaf(YType.uint32, "num-of-nbr-discovery")

                                self.num_of_nbr_lbl = YLeaf(YType.uint32, "num-of-nbr-lbl")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "num_of_nbr_addresses",
                                                "num_of_nbr_discovery",
                                                "num_of_nbr_lbl") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.num_of_nbr_addresses.is_set or
                                    self.num_of_nbr_discovery.is_set or
                                    self.num_of_nbr_lbl.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.num_of_nbr_addresses.yfilter != YFilter.not_set or
                                    self.num_of_nbr_discovery.yfilter != YFilter.not_set or
                                    self.num_of_nbr_lbl.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nbr-br-af-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.num_of_nbr_addresses.is_set or self.num_of_nbr_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_addresses.get_name_leafdata())
                                if (self.num_of_nbr_discovery.is_set or self.num_of_nbr_discovery.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_discovery.get_name_leafdata())
                                if (self.num_of_nbr_lbl.is_set or self.num_of_nbr_lbl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.num_of_nbr_lbl.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-family" or name == "num-of-nbr-addresses" or name == "num-of-nbr-discovery" or name == "num-of-nbr-lbl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-addresses"):
                                    self.num_of_nbr_addresses = value
                                    self.num_of_nbr_addresses.value_namespace = name_space
                                    self.num_of_nbr_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-discovery"):
                                    self.num_of_nbr_discovery = value
                                    self.num_of_nbr_discovery.value_namespace = name_space
                                    self.num_of_nbr_discovery.value_namespace_prefix = name_space_prefix
                                if(value_path == "num-of-nbr-lbl"):
                                    self.num_of_nbr_lbl = value
                                    self.num_of_nbr_lbl.value_namespace = name_space
                                    self.num_of_nbr_lbl.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.nbr_br_af_info:
                                if (c.has_data()):
                                    return True
                            return (
                                self.is_graceful_restartable.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                self.nsr_state.is_set or
                                self.up_time_seconds.is_set or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            for c in self.nbr_br_af_info:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_graceful_restartable.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                self.nsr_state.yfilter != YFilter.not_set or
                                self.up_time_seconds.yfilter != YFilter.not_set or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-brief" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                            if (self.nsr_state.is_set or self.nsr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_state.get_name_leafdata())
                            if (self.up_time_seconds.is_set or self.up_time_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_time_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "nbr-br-af-info"):
                                for c in self.nbr_br_af_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.nbr_br_af_info.append(c)
                                return c

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "nbr-br-af-info" or name == "vrf" or name == "is-graceful-restartable" or name == "label-space-id" or name == "lsr-id" or name == "nsr-state" or name == "up-time-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-graceful-restartable"):
                                self.is_graceful_restartable = value
                                self.is_graceful_restartable.value_namespace = name_space
                                self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-state"):
                                self.nsr_state = value
                                self.nsr_state.value_namespace = name_space
                                self.nsr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-time-seconds"):
                                self.up_time_seconds = value
                                self.up_time_seconds.value_namespace = name_space
                                self.up_time_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor_brief:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor_brief:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-briefs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor-brief"):
                            for c in self.neighbor_brief:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs.NeighborBrief()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor_brief.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor-brief"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class BackoffParameters(Entity):
                    """
                    The LDP Backoff Parameters
                    
                    .. attribute:: initial_seconds
                    
                    	Initial backoff value in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: maximum_seconds
                    
                    	Maximum backoff value in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.BackoffParameters, self).__init__()

                        self.yang_name = "backoff-parameters"
                        self.yang_parent_name = "default-vrf"

                        self.initial_seconds = YLeaf(YType.uint32, "initial-seconds")

                        self.maximum_seconds = YLeaf(YType.uint32, "maximum-seconds")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("initial_seconds",
                                        "maximum_seconds") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.BackoffParameters, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.BackoffParameters, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.initial_seconds.is_set or
                            self.maximum_seconds.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.initial_seconds.yfilter != YFilter.not_set or
                            self.maximum_seconds.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "backoff-parameters" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.initial_seconds.is_set or self.initial_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.initial_seconds.get_name_leafdata())
                        if (self.maximum_seconds.is_set or self.maximum_seconds.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_seconds.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "initial-seconds" or name == "maximum-seconds"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "initial-seconds"):
                            self.initial_seconds = value
                            self.initial_seconds.value_namespace = name_space
                            self.initial_seconds.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-seconds"):
                            self.maximum_seconds = value
                            self.maximum_seconds.value_namespace = name_space
                            self.maximum_seconds.value_namespace_prefix = name_space_prefix


                class Backoffs(Entity):
                    """
                    The LDP backoff
                    
                    .. attribute:: backoff
                    
                    	LDP Backoff Information
                    	**type**\: list of    :py:class:`Backoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Backoffs.Backoff>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Backoffs, self).__init__()

                        self.yang_name = "backoffs"
                        self.yang_parent_name = "default-vrf"

                        self.backoff = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Backoffs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.Backoffs, self).__setattr__(name, value)


                    class Backoff(Entity):
                        """
                        LDP Backoff Information
                        
                        .. attribute:: backoff_seconds
                        
                        	Backoff seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: waiting_seconds
                        
                        	Backoff waiting seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Backoffs.Backoff, self).__init__()

                            self.yang_name = "backoff"
                            self.yang_parent_name = "backoffs"

                            self.backoff_seconds = YLeaf(YType.uint32, "backoff-seconds")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.waiting_seconds = YLeaf(YType.uint32, "waiting-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backoff_seconds",
                                            "label_space_id",
                                            "lsr_id",
                                            "waiting_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Backoffs.Backoff, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Backoffs.Backoff, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backoff_seconds.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                self.waiting_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backoff_seconds.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                self.waiting_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoff" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backoff_seconds.is_set or self.backoff_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backoff_seconds.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                            if (self.waiting_seconds.is_set or self.waiting_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.waiting_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff-seconds" or name == "label-space-id" or name == "lsr-id" or name == "waiting-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backoff-seconds"):
                                self.backoff_seconds = value
                                self.backoff_seconds.value_namespace = name_space
                                self.backoff_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "waiting-seconds"):
                                self.waiting_seconds = value
                                self.waiting_seconds.value_namespace = name_space
                                self.waiting_seconds.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.backoff:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.backoff:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "backoffs" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "backoff"):
                            for c in self.backoff:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.Backoffs.Backoff()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.backoff.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "backoff"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Nsr(Entity):
                    """
                    LDP NSR related information
                    
                    .. attribute:: ha_statistics
                    
                    	LDP NSR Statistics related information
                    	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics>`
                    
                    .. attribute:: ha_summary
                    
                    	LDP HA Summary
                    	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary>`
                    
                    .. attribute:: nsr_pending
                    
                    	LDP NSR Pending related information
                    	**type**\:   :py:class:`NsrPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr, self).__init__()

                        self.yang_name = "nsr"
                        self.yang_parent_name = "default-vrf"

                        self.ha_statistics = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics()
                        self.ha_statistics.parent = self
                        self._children_name_map["ha_statistics"] = "ha-statistics"
                        self._children_yang_names.add("ha-statistics")

                        self.ha_summary = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary()
                        self.ha_summary.parent = self
                        self._children_name_map["ha_summary"] = "ha-summary"
                        self._children_yang_names.add("ha-summary")

                        self.nsr_pending = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending()
                        self.nsr_pending.parent = self
                        self._children_name_map["nsr_pending"] = "nsr-pending"
                        self._children_yang_names.add("nsr-pending")


                    class NsrPending(Entity):
                        """
                        LDP NSR Pending related information
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending, self).__init__()

                            self.yang_name = "nsr-pending"
                            self.yang_parent_name = "nsr"

                            self.ha_neighbors = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "nsr-pending"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (self.ha_neighbors is not None and self.ha_neighbors.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaSummary(Entity):
                        """
                        LDP HA Summary
                        
                        .. attribute:: sessions
                        
                        	Session summary
                        	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Sessions>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary, self).__init__()

                            self.yang_name = "ha-summary"
                            self.yang_parent_name = "nsr"

                            self.sessions = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                            self._children_yang_names.add("sessions")

                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "ha-summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Sessions(Entity):
                            """
                            Session summary
                            
                            .. attribute:: nsr_eligible
                            
                            	NSR eligible sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_app_wait
                            
                            	Number of sessions in NSR app\-wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_none
                            
                            	Number of sessions in NSR none state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_operational
                            
                            	Number of sessions in NSR operational state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_prepare
                            
                            	Number of sessions in NSR prepare state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_ready
                            
                            	Number of sessions in NSR ready state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase1
                            
                            	Number of sessions in NSR TCP phase 1 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase2
                            
                            	Number of sessions in NSR TCP phase 2 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_wait
                            
                            	Number of sessions in NSR wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total
                            
                            	Total sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Sessions, self).__init__()

                                self.yang_name = "sessions"
                                self.yang_parent_name = "ha-summary"

                                self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                self.total = YLeaf(YType.uint32, "total")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_eligible",
                                                "nsr_state_app_wait",
                                                "nsr_state_none",
                                                "nsr_state_operational",
                                                "nsr_state_prepare",
                                                "nsr_state_ready",
                                                "nsr_state_tcp_phase1",
                                                "nsr_state_tcp_phase2",
                                                "nsr_state_wait",
                                                "total") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_eligible.is_set or
                                    self.nsr_state_app_wait.is_set or
                                    self.nsr_state_none.is_set or
                                    self.nsr_state_operational.is_set or
                                    self.nsr_state_prepare.is_set or
                                    self.nsr_state_ready.is_set or
                                    self.nsr_state_tcp_phase1.is_set or
                                    self.nsr_state_tcp_phase2.is_set or
                                    self.nsr_state_wait.is_set or
                                    self.total.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_eligible.yfilter != YFilter.not_set or
                                    self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                    self.nsr_state_none.yfilter != YFilter.not_set or
                                    self.nsr_state_operational.yfilter != YFilter.not_set or
                                    self.nsr_state_prepare.yfilter != YFilter.not_set or
                                    self.nsr_state_ready.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                    self.nsr_state_wait.yfilter != YFilter.not_set or
                                    self.total.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sessions" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-eligible"):
                                    self.nsr_eligible = value
                                    self.nsr_eligible.value_namespace = name_space
                                    self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-app-wait"):
                                    self.nsr_state_app_wait = value
                                    self.nsr_state_app_wait.value_namespace = name_space
                                    self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-none"):
                                    self.nsr_state_none = value
                                    self.nsr_state_none.value_namespace = name_space
                                    self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-operational"):
                                    self.nsr_state_operational = value
                                    self.nsr_state_operational.value_namespace = name_space
                                    self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-prepare"):
                                    self.nsr_state_prepare = value
                                    self.nsr_state_prepare.value_namespace = name_space
                                    self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-ready"):
                                    self.nsr_state_ready = value
                                    self.nsr_state_ready.value_namespace = name_space
                                    self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase1"):
                                    self.nsr_state_tcp_phase1 = value
                                    self.nsr_state_tcp_phase1.value_namespace = name_space
                                    self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase2"):
                                    self.nsr_state_tcp_phase2 = value
                                    self.nsr_state_tcp_phase2.value_namespace = name_space
                                    self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-wait"):
                                    self.nsr_state_wait = value
                                    self.nsr_state_wait.value_namespace = name_space
                                    self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "total"):
                                    self.total = value
                                    self.total.value_namespace = name_space
                                    self.total.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.sessions is not None and self.sessions.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.sessions is not None and self.sessions.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sessions"):
                                if (self.sessions is None):
                                    self.sessions = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Sessions()
                                    self.sessions.parent = self
                                    self._children_name_map["sessions"] = "sessions"
                                return self.sessions

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sessions" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaStatistics(Entity):
                        """
                        LDP NSR Statistics related information
                        
                        .. attribute:: ha_global
                        
                        	LDP NSR Global Statistics information
                        	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal>`
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics, self).__init__()

                            self.yang_name = "ha-statistics"
                            self.yang_parent_name = "nsr"

                            self.ha_global = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal()
                            self.ha_global.parent = self
                            self._children_name_map["ha_global"] = "ha-global"
                            self._children_yang_names.add("ha-global")

                            self.ha_neighbors = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaGlobal(Entity):
                            """
                            LDP NSR Global Statistics information
                            
                            .. attribute:: init_sync
                            
                            	Init Sync
                            	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal, self).__init__()

                                self.yang_name = "ha-global"
                                self.yang_parent_name = "ha-statistics"

                                self.init_sync = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                self.init_sync.parent = self
                                self._children_name_map["init_sync"] = "init-sync"
                                self._children_yang_names.add("init-sync")


                            class InitSync(Entity):
                                """
                                Init Sync
                                
                                .. attribute:: init_sync_end
                                
                                	Init Sync End Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_sync_start
                                
                                	Init Sync Start Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_default_mtu
                                
                                	default IPC MTU bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_exceeded_mtu_msg_cnt
                                
                                	ipc exceeded mtu msg cnt
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_max_rx_batch_bytes
                                
                                	biggest IPC RX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_max_tx_batch_bytes
                                
                                	biggest IPC TX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_rx_bytes
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_rx_cnt
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_tx_bytes
                                
                                	total IPC bytes sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_tx_cnt
                                
                                	num IPC msgs sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_restart_cnt
                                
                                	number of times ipc has been restarted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_tx_fail_cnt
                                
                                	number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_cfged
                                
                                	TRUE if NSR configured
                                	**type**\:  bool
                                
                                .. attribute:: nsr_synced
                                
                                	TRUE if NSR synced
                                	**type**\:  bool
                                
                                .. attribute:: num_cap_rcvd
                                
                                	Number of Rcvd Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_cap_sent
                                
                                	Number of Sent Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl
                                
                                	Number of label bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl_adv
                                
                                	Num of lbl adv
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lcl_addr_wd
                                
                                	Num of lcl address withdraw
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_peers
                                
                                	Number of Peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_pfx
                                
                                	Number of binding prefixes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_ipc_tx_fail_cnt
                                
                                	total number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__init__()

                                    self.yang_name = "init-sync"
                                    self.yang_parent_name = "ha-global"

                                    self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                    self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                    self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                    self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                    self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                    self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                    self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                    self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                    self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                    self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                    self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                    self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                    self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                    self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                    self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                    self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                    self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                    self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                    self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                    self.num_peers = YLeaf(YType.uint32, "num-peers")

                                    self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                    self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("init_sync_end",
                                                    "init_sync_start",
                                                    "ipc_default_mtu",
                                                    "ipc_exceeded_mtu_msg_cnt",
                                                    "ipc_max_rx_batch_bytes",
                                                    "ipc_max_tx_batch_bytes",
                                                    "ipc_msg_rx_bytes",
                                                    "ipc_msg_rx_cnt",
                                                    "ipc_msg_tx_bytes",
                                                    "ipc_msg_tx_cnt",
                                                    "ipc_restart_cnt",
                                                    "ipc_tx_fail_cnt",
                                                    "nsr_cfged",
                                                    "nsr_synced",
                                                    "num_cap_rcvd",
                                                    "num_cap_sent",
                                                    "num_lbl",
                                                    "num_lbl_adv",
                                                    "num_lcl_addr_wd",
                                                    "num_peers",
                                                    "num_pfx",
                                                    "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.init_sync_end.is_set or
                                        self.init_sync_start.is_set or
                                        self.ipc_default_mtu.is_set or
                                        self.ipc_exceeded_mtu_msg_cnt.is_set or
                                        self.ipc_max_rx_batch_bytes.is_set or
                                        self.ipc_max_tx_batch_bytes.is_set or
                                        self.ipc_msg_rx_bytes.is_set or
                                        self.ipc_msg_rx_cnt.is_set or
                                        self.ipc_msg_tx_bytes.is_set or
                                        self.ipc_msg_tx_cnt.is_set or
                                        self.ipc_restart_cnt.is_set or
                                        self.ipc_tx_fail_cnt.is_set or
                                        self.nsr_cfged.is_set or
                                        self.nsr_synced.is_set or
                                        self.num_cap_rcvd.is_set or
                                        self.num_cap_sent.is_set or
                                        self.num_lbl.is_set or
                                        self.num_lbl_adv.is_set or
                                        self.num_lcl_addr_wd.is_set or
                                        self.num_peers.is_set or
                                        self.num_pfx.is_set or
                                        self.total_ipc_tx_fail_cnt.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.init_sync_end.yfilter != YFilter.not_set or
                                        self.init_sync_start.yfilter != YFilter.not_set or
                                        self.ipc_default_mtu.yfilter != YFilter.not_set or
                                        self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                        self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                        self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                        self.nsr_cfged.yfilter != YFilter.not_set or
                                        self.nsr_synced.yfilter != YFilter.not_set or
                                        self.num_cap_rcvd.yfilter != YFilter.not_set or
                                        self.num_cap_sent.yfilter != YFilter.not_set or
                                        self.num_lbl.yfilter != YFilter.not_set or
                                        self.num_lbl_adv.yfilter != YFilter.not_set or
                                        self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                        self.num_peers.yfilter != YFilter.not_set or
                                        self.num_pfx.yfilter != YFilter.not_set or
                                        self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "init-sync" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                    if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                    if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                    if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                    if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                    if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                    if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                    if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                    if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                    if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                    if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                    if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                    if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                    if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                    if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                    if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_peers.get_name_leafdata())
                                    if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                    if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "init-sync-end"):
                                        self.init_sync_end = value
                                        self.init_sync_end.value_namespace = name_space
                                        self.init_sync_end.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-sync-start"):
                                        self.init_sync_start = value
                                        self.init_sync_start.value_namespace = name_space
                                        self.init_sync_start.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-default-mtu"):
                                        self.ipc_default_mtu = value
                                        self.ipc_default_mtu.value_namespace = name_space
                                        self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                        self.ipc_exceeded_mtu_msg_cnt = value
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-rx-batch-bytes"):
                                        self.ipc_max_rx_batch_bytes = value
                                        self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-tx-batch-bytes"):
                                        self.ipc_max_tx_batch_bytes = value
                                        self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-bytes"):
                                        self.ipc_msg_rx_bytes = value
                                        self.ipc_msg_rx_bytes.value_namespace = name_space
                                        self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-cnt"):
                                        self.ipc_msg_rx_cnt = value
                                        self.ipc_msg_rx_cnt.value_namespace = name_space
                                        self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-bytes"):
                                        self.ipc_msg_tx_bytes = value
                                        self.ipc_msg_tx_bytes.value_namespace = name_space
                                        self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-cnt"):
                                        self.ipc_msg_tx_cnt = value
                                        self.ipc_msg_tx_cnt.value_namespace = name_space
                                        self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-restart-cnt"):
                                        self.ipc_restart_cnt = value
                                        self.ipc_restart_cnt.value_namespace = name_space
                                        self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-tx-fail-cnt"):
                                        self.ipc_tx_fail_cnt = value
                                        self.ipc_tx_fail_cnt.value_namespace = name_space
                                        self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-cfged"):
                                        self.nsr_cfged = value
                                        self.nsr_cfged.value_namespace = name_space
                                        self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-synced"):
                                        self.nsr_synced = value
                                        self.nsr_synced.value_namespace = name_space
                                        self.nsr_synced.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-rcvd"):
                                        self.num_cap_rcvd = value
                                        self.num_cap_rcvd.value_namespace = name_space
                                        self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-sent"):
                                        self.num_cap_sent = value
                                        self.num_cap_sent.value_namespace = name_space
                                        self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl"):
                                        self.num_lbl = value
                                        self.num_lbl.value_namespace = name_space
                                        self.num_lbl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl-adv"):
                                        self.num_lbl_adv = value
                                        self.num_lbl_adv.value_namespace = name_space
                                        self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lcl-addr-wd"):
                                        self.num_lcl_addr_wd = value
                                        self.num_lcl_addr_wd.value_namespace = name_space
                                        self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-peers"):
                                        self.num_peers = value
                                        self.num_peers.value_namespace = name_space
                                        self.num_peers.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-pfx"):
                                        self.num_pfx = value
                                        self.num_pfx.value_namespace = name_space
                                        self.num_pfx.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-ipc-tx-fail-cnt"):
                                        self.total_ipc_tx_fail_cnt = value
                                        self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                        self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.init_sync is not None and self.init_sync.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.init_sync is not None and self.init_sync.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-global" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "init-sync"):
                                    if (self.init_sync is None):
                                        self.init_sync = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                        self.init_sync.parent = self
                                        self._children_name_map["init_sync"] = "init-sync"
                                    return self.init_sync

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "init-sync"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "ha-statistics"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_global is not None and self.ha_global.has_data()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_global is not None and self.ha_global.has_operation()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-global"):
                                if (self.ha_global is None):
                                    self.ha_global = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaGlobal()
                                    self.ha_global.parent = self
                                    self._children_name_map["ha_global"] = "ha-global"
                                return self.ha_global

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-global" or name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                            (self.ha_summary is not None and self.ha_summary.has_data()) or
                            (self.nsr_pending is not None and self.nsr_pending.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                            (self.ha_summary is not None and self.ha_summary.has_operation()) or
                            (self.nsr_pending is not None and self.nsr_pending.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "nsr" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ha-statistics"):
                            if (self.ha_statistics is None):
                                self.ha_statistics = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaStatistics()
                                self.ha_statistics.parent = self
                                self._children_name_map["ha_statistics"] = "ha-statistics"
                            return self.ha_statistics

                        if (child_yang_name == "ha-summary"):
                            if (self.ha_summary is None):
                                self.ha_summary = MplsLdp.Nodes.Node.DefaultVrf.Nsr.HaSummary()
                                self.ha_summary.parent = self
                                self._children_name_map["ha_summary"] = "ha-summary"
                            return self.ha_summary

                        if (child_yang_name == "nsr-pending"):
                            if (self.nsr_pending is None):
                                self.nsr_pending = MplsLdp.Nodes.Node.DefaultVrf.Nsr.NsrPending()
                                self.nsr_pending.parent = self
                                self._children_name_map["nsr_pending"] = "nsr-pending"
                            return self.nsr_pending

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ha-statistics" or name == "ha-summary" or name == "nsr-pending"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Parameters(Entity):
                    """
                    LDP parameters
                    
                    .. attribute:: address_family_parameter
                    
                    	Per AF parameters
                    	**type**\: list of    :py:class:`AddressFamilyParameter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter>`
                    
                    .. attribute:: af_binding_withdraw_delay
                    
                    	Delay (sec) in Binding Withdrawal for an Address Family
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: discovery_quick_start_disabled_on_interfaces
                    
                    	Discovery quick\-start disabled on some LDP\-enabled interfaces
                    	**type**\:  bool
                    
                    .. attribute:: global_discovery_quick_start_disabled
                    
                    	Discovery quick\-start globally disabled
                    	**type**\:  bool
                    
                    .. attribute:: global_md5_password_enabled
                    
                    	Global MD5 password enabled
                    	**type**\:  bool
                    
                    .. attribute:: graceful_restart_information
                    
                    	Graceful restart information
                    	**type**\:   :py:class:`GracefulRestartInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Parameters.GracefulRestartInformation>`
                    
                    .. attribute:: hello_hold_time
                    
                    	Hello hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hello_interval
                    
                    	Hello interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: housekeeping_timer_interval
                    
                    	Housekeeping periodic timer interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp_sync_delay_time_for_interface
                    
                    	Interface IGP sync delay time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: igp_sync_delay_time_on_restart
                    
                    	IGP sync delay time on process restart in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: keepalive_interval
                    
                    	Keepalive interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ldp_out_of_mem_state
                    
                    	LDP Out of memory state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: ldp_recovery_timeout
                    
                    	LDP recovery timeout with LSD
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: le_no_route_timeout
                    
                    	LIB entry no route timeout
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_intf_attached
                    
                    	Maximum number of LDP enabled attached interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_intf_te
                    
                    	Maximum number of LDP enabled TE interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: max_peer
                    
                    	Maximum number of LDP peers
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_enabled
                    
                    	TRUE if NSR is enabled
                    	**type**\:  bool
                    
                    .. attribute:: nsr_synced
                    
                    	TRUE if LDP is standby and is NSR Sync\-ed with active
                    	**type**\:  bool
                    
                    .. attribute:: protocol_version
                    
                    	Protocol version
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: role_is_active
                    
                    	Is process role active or standby
                    	**type**\:  bool
                    
                    .. attribute:: router_id
                    
                    	Router ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: session_hold_time
                    
                    	Session hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: targeted_hello_hold_time
                    
                    	Targeted hello hold time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: targeted_hello_interval
                    
                    	Targeted hello interval
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Parameters, self).__init__()

                        self.yang_name = "parameters"
                        self.yang_parent_name = "default-vrf"

                        self.af_binding_withdraw_delay = YLeaf(YType.uint32, "af-binding-withdraw-delay")

                        self.discovery_quick_start_disabled_on_interfaces = YLeaf(YType.boolean, "discovery-quick-start-disabled-on-interfaces")

                        self.global_discovery_quick_start_disabled = YLeaf(YType.boolean, "global-discovery-quick-start-disabled")

                        self.global_md5_password_enabled = YLeaf(YType.boolean, "global-md5-password-enabled")

                        self.hello_hold_time = YLeaf(YType.uint32, "hello-hold-time")

                        self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                        self.housekeeping_timer_interval = YLeaf(YType.uint32, "housekeeping-timer-interval")

                        self.igp_sync_delay_time_for_interface = YLeaf(YType.uint32, "igp-sync-delay-time-for-interface")

                        self.igp_sync_delay_time_on_restart = YLeaf(YType.uint32, "igp-sync-delay-time-on-restart")

                        self.keepalive_interval = YLeaf(YType.uint32, "keepalive-interval")

                        self.ldp_out_of_mem_state = YLeaf(YType.uint32, "ldp-out-of-mem-state")

                        self.ldp_recovery_timeout = YLeaf(YType.uint32, "ldp-recovery-timeout")

                        self.le_no_route_timeout = YLeaf(YType.uint32, "le-no-route-timeout")

                        self.max_intf_attached = YLeaf(YType.uint32, "max-intf-attached")

                        self.max_intf_te = YLeaf(YType.uint32, "max-intf-te")

                        self.max_peer = YLeaf(YType.uint32, "max-peer")

                        self.nsr_enabled = YLeaf(YType.boolean, "nsr-enabled")

                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                        self.protocol_version = YLeaf(YType.uint32, "protocol-version")

                        self.role_is_active = YLeaf(YType.boolean, "role-is-active")

                        self.router_id = YLeaf(YType.str, "router-id")

                        self.session_hold_time = YLeaf(YType.uint32, "session-hold-time")

                        self.targeted_hello_hold_time = YLeaf(YType.uint32, "targeted-hello-hold-time")

                        self.targeted_hello_interval = YLeaf(YType.uint32, "targeted-hello-interval")

                        self.graceful_restart_information = MplsLdp.Nodes.Node.DefaultVrf.Parameters.GracefulRestartInformation()
                        self.graceful_restart_information.parent = self
                        self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                        self._children_yang_names.add("graceful-restart-information")

                        self.address_family_parameter = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("af_binding_withdraw_delay",
                                        "discovery_quick_start_disabled_on_interfaces",
                                        "global_discovery_quick_start_disabled",
                                        "global_md5_password_enabled",
                                        "hello_hold_time",
                                        "hello_interval",
                                        "housekeeping_timer_interval",
                                        "igp_sync_delay_time_for_interface",
                                        "igp_sync_delay_time_on_restart",
                                        "keepalive_interval",
                                        "ldp_out_of_mem_state",
                                        "ldp_recovery_timeout",
                                        "le_no_route_timeout",
                                        "max_intf_attached",
                                        "max_intf_te",
                                        "max_peer",
                                        "nsr_enabled",
                                        "nsr_synced",
                                        "protocol_version",
                                        "role_is_active",
                                        "router_id",
                                        "session_hold_time",
                                        "targeted_hello_hold_time",
                                        "targeted_hello_interval") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Parameters, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.Parameters, self).__setattr__(name, value)


                    class GracefulRestartInformation(Entity):
                        """
                        Graceful restart information
                        
                        .. attribute:: graceful_restart_forwarding_state_hold_time
                        
                        	Graceful restart forward state hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: graceful_restart_reconnect_timeout
                        
                        	Reconnect timeout value
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_graceful_restart_configured
                        
                        	Is graceful restart configured
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.GracefulRestartInformation, self).__init__()

                            self.yang_name = "graceful-restart-information"
                            self.yang_parent_name = "parameters"

                            self.graceful_restart_forwarding_state_hold_time = YLeaf(YType.uint32, "graceful-restart-forwarding-state-hold-time")

                            self.graceful_restart_reconnect_timeout = YLeaf(YType.uint32, "graceful-restart-reconnect-timeout")

                            self.is_graceful_restart_configured = YLeaf(YType.boolean, "is-graceful-restart-configured")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("graceful_restart_forwarding_state_hold_time",
                                            "graceful_restart_reconnect_timeout",
                                            "is_graceful_restart_configured") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.graceful_restart_forwarding_state_hold_time.is_set or
                                self.graceful_restart_reconnect_timeout.is_set or
                                self.is_graceful_restart_configured.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set or
                                self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set or
                                self.is_graceful_restart_configured.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restart-information" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.graceful_restart_forwarding_state_hold_time.is_set or self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.graceful_restart_forwarding_state_hold_time.get_name_leafdata())
                            if (self.graceful_restart_reconnect_timeout.is_set or self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.graceful_restart_reconnect_timeout.get_name_leafdata())
                            if (self.is_graceful_restart_configured.is_set or self.is_graceful_restart_configured.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_graceful_restart_configured.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "graceful-restart-forwarding-state-hold-time" or name == "graceful-restart-reconnect-timeout" or name == "is-graceful-restart-configured"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "graceful-restart-forwarding-state-hold-time"):
                                self.graceful_restart_forwarding_state_hold_time = value
                                self.graceful_restart_forwarding_state_hold_time.value_namespace = name_space
                                self.graceful_restart_forwarding_state_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "graceful-restart-reconnect-timeout"):
                                self.graceful_restart_reconnect_timeout = value
                                self.graceful_restart_reconnect_timeout.value_namespace = name_space
                                self.graceful_restart_reconnect_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-graceful-restart-configured"):
                                self.is_graceful_restart_configured = value
                                self.is_graceful_restart_configured.value_namespace = name_space
                                self.is_graceful_restart_configured.value_namespace_prefix = name_space_prefix


                    class AddressFamilyParameter(Entity):
                        """
                        Per AF parameters
                        
                        .. attribute:: address_family
                        
                        	Address Family
                        	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                        
                        .. attribute:: discovery_transport_address
                        
                        	Discovery transport address
                        	**type**\:   :py:class:`DiscoveryTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress>`
                        
                        .. attribute:: is_accepting_targeted_hellos
                        
                        	Accepting targeted Hellos
                        	**type**\:  bool
                        
                        .. attribute:: label_imp_null_override_acl
                        
                        	ACL to override local label to use implicit\-null
                        	**type**\:  str
                        
                        .. attribute:: null_label
                        
                        	Null label
                        	**type**\:  str
                        
                        .. attribute:: targeted_hello_acl
                        
                        	Targeted Hello ACL
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter, self).__init__()

                            self.yang_name = "address-family-parameter"
                            self.yang_parent_name = "parameters"

                            self.address_family = YLeaf(YType.enumeration, "address-family")

                            self.is_accepting_targeted_hellos = YLeaf(YType.boolean, "is-accepting-targeted-hellos")

                            self.label_imp_null_override_acl = YLeaf(YType.str, "label-imp-null-override-acl")

                            self.null_label = YLeaf(YType.str, "null-label")

                            self.targeted_hello_acl = YLeaf(YType.str, "targeted-hello-acl")

                            self.discovery_transport_address = MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                            self.discovery_transport_address.parent = self
                            self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                            self._children_yang_names.add("discovery-transport-address")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("address_family",
                                            "is_accepting_targeted_hellos",
                                            "label_imp_null_override_acl",
                                            "null_label",
                                            "targeted_hello_acl") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)


                        class DiscoveryTransportAddress(Entity):
                            """
                            Discovery transport address
                            
                            .. attribute:: afi
                            
                            	AFI
                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                            
                            .. attribute:: dummy
                            
                            	No Address
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: ipv4
                            
                            	IPv4 address type
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: ipv6
                            
                            	IPv6 address type
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__init__()

                                self.yang_name = "discovery-transport-address"
                                self.yang_parent_name = "address-family-parameter"

                                self.afi = YLeaf(YType.enumeration, "afi")

                                self.dummy = YLeaf(YType.uint8, "dummy")

                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                self.ipv6 = YLeaf(YType.str, "ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("afi",
                                                "dummy",
                                                "ipv4",
                                                "ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.afi.is_set or
                                    self.dummy.is_set or
                                    self.ipv4.is_set or
                                    self.ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.afi.yfilter != YFilter.not_set or
                                    self.dummy.yfilter != YFilter.not_set or
                                    self.ipv4.yfilter != YFilter.not_set or
                                    self.ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "discovery-transport-address" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "afi"):
                                    self.afi = value
                                    self.afi.value_namespace = name_space
                                    self.afi.value_namespace_prefix = name_space_prefix
                                if(value_path == "dummy"):
                                    self.dummy = value
                                    self.dummy.value_namespace = name_space
                                    self.dummy.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv4"):
                                    self.ipv4 = value
                                    self.ipv4.value_namespace = name_space
                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "ipv6"):
                                    self.ipv6 = value
                                    self.ipv6.value_namespace = name_space
                                    self.ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.address_family.is_set or
                                self.is_accepting_targeted_hellos.is_set or
                                self.label_imp_null_override_acl.is_set or
                                self.null_label.is_set or
                                self.targeted_hello_acl.is_set or
                                (self.discovery_transport_address is not None and self.discovery_transport_address.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.address_family.yfilter != YFilter.not_set or
                                self.is_accepting_targeted_hellos.yfilter != YFilter.not_set or
                                self.label_imp_null_override_acl.yfilter != YFilter.not_set or
                                self.null_label.yfilter != YFilter.not_set or
                                self.targeted_hello_acl.yfilter != YFilter.not_set or
                                (self.discovery_transport_address is not None and self.discovery_transport_address.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "address-family-parameter" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.address_family.get_name_leafdata())
                            if (self.is_accepting_targeted_hellos.is_set or self.is_accepting_targeted_hellos.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_accepting_targeted_hellos.get_name_leafdata())
                            if (self.label_imp_null_override_acl.is_set or self.label_imp_null_override_acl.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_imp_null_override_acl.get_name_leafdata())
                            if (self.null_label.is_set or self.null_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.null_label.get_name_leafdata())
                            if (self.targeted_hello_acl.is_set or self.targeted_hello_acl.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_acl.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "discovery-transport-address"):
                                if (self.discovery_transport_address is None):
                                    self.discovery_transport_address = MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                    self.discovery_transport_address.parent = self
                                    self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                return self.discovery_transport_address

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "discovery-transport-address" or name == "address-family" or name == "is-accepting-targeted-hellos" or name == "label-imp-null-override-acl" or name == "null-label" or name == "targeted-hello-acl"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "address-family"):
                                self.address_family = value
                                self.address_family.value_namespace = name_space
                                self.address_family.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-accepting-targeted-hellos"):
                                self.is_accepting_targeted_hellos = value
                                self.is_accepting_targeted_hellos.value_namespace = name_space
                                self.is_accepting_targeted_hellos.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-imp-null-override-acl"):
                                self.label_imp_null_override_acl = value
                                self.label_imp_null_override_acl.value_namespace = name_space
                                self.label_imp_null_override_acl.value_namespace_prefix = name_space_prefix
                            if(value_path == "null-label"):
                                self.null_label = value
                                self.null_label.value_namespace = name_space
                                self.null_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-acl"):
                                self.targeted_hello_acl = value
                                self.targeted_hello_acl.value_namespace = name_space
                                self.targeted_hello_acl.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.address_family_parameter:
                            if (c.has_data()):
                                return True
                        return (
                            self.af_binding_withdraw_delay.is_set or
                            self.discovery_quick_start_disabled_on_interfaces.is_set or
                            self.global_discovery_quick_start_disabled.is_set or
                            self.global_md5_password_enabled.is_set or
                            self.hello_hold_time.is_set or
                            self.hello_interval.is_set or
                            self.housekeeping_timer_interval.is_set or
                            self.igp_sync_delay_time_for_interface.is_set or
                            self.igp_sync_delay_time_on_restart.is_set or
                            self.keepalive_interval.is_set or
                            self.ldp_out_of_mem_state.is_set or
                            self.ldp_recovery_timeout.is_set or
                            self.le_no_route_timeout.is_set or
                            self.max_intf_attached.is_set or
                            self.max_intf_te.is_set or
                            self.max_peer.is_set or
                            self.nsr_enabled.is_set or
                            self.nsr_synced.is_set or
                            self.protocol_version.is_set or
                            self.role_is_active.is_set or
                            self.router_id.is_set or
                            self.session_hold_time.is_set or
                            self.targeted_hello_hold_time.is_set or
                            self.targeted_hello_interval.is_set or
                            (self.graceful_restart_information is not None and self.graceful_restart_information.has_data()))

                    def has_operation(self):
                        for c in self.address_family_parameter:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.af_binding_withdraw_delay.yfilter != YFilter.not_set or
                            self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set or
                            self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set or
                            self.global_md5_password_enabled.yfilter != YFilter.not_set or
                            self.hello_hold_time.yfilter != YFilter.not_set or
                            self.hello_interval.yfilter != YFilter.not_set or
                            self.housekeeping_timer_interval.yfilter != YFilter.not_set or
                            self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set or
                            self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set or
                            self.keepalive_interval.yfilter != YFilter.not_set or
                            self.ldp_out_of_mem_state.yfilter != YFilter.not_set or
                            self.ldp_recovery_timeout.yfilter != YFilter.not_set or
                            self.le_no_route_timeout.yfilter != YFilter.not_set or
                            self.max_intf_attached.yfilter != YFilter.not_set or
                            self.max_intf_te.yfilter != YFilter.not_set or
                            self.max_peer.yfilter != YFilter.not_set or
                            self.nsr_enabled.yfilter != YFilter.not_set or
                            self.nsr_synced.yfilter != YFilter.not_set or
                            self.protocol_version.yfilter != YFilter.not_set or
                            self.role_is_active.yfilter != YFilter.not_set or
                            self.router_id.yfilter != YFilter.not_set or
                            self.session_hold_time.yfilter != YFilter.not_set or
                            self.targeted_hello_hold_time.yfilter != YFilter.not_set or
                            self.targeted_hello_interval.yfilter != YFilter.not_set or
                            (self.graceful_restart_information is not None and self.graceful_restart_information.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "parameters" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.af_binding_withdraw_delay.is_set or self.af_binding_withdraw_delay.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.af_binding_withdraw_delay.get_name_leafdata())
                        if (self.discovery_quick_start_disabled_on_interfaces.is_set or self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.discovery_quick_start_disabled_on_interfaces.get_name_leafdata())
                        if (self.global_discovery_quick_start_disabled.is_set or self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_discovery_quick_start_disabled.get_name_leafdata())
                        if (self.global_md5_password_enabled.is_set or self.global_md5_password_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.global_md5_password_enabled.get_name_leafdata())
                        if (self.hello_hold_time.is_set or self.hello_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hello_hold_time.get_name_leafdata())
                        if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hello_interval.get_name_leafdata())
                        if (self.housekeeping_timer_interval.is_set or self.housekeeping_timer_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.housekeeping_timer_interval.get_name_leafdata())
                        if (self.igp_sync_delay_time_for_interface.is_set or self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_sync_delay_time_for_interface.get_name_leafdata())
                        if (self.igp_sync_delay_time_on_restart.is_set or self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_sync_delay_time_on_restart.get_name_leafdata())
                        if (self.keepalive_interval.is_set or self.keepalive_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.keepalive_interval.get_name_leafdata())
                        if (self.ldp_out_of_mem_state.is_set or self.ldp_out_of_mem_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_out_of_mem_state.get_name_leafdata())
                        if (self.ldp_recovery_timeout.is_set or self.ldp_recovery_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_recovery_timeout.get_name_leafdata())
                        if (self.le_no_route_timeout.is_set or self.le_no_route_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.le_no_route_timeout.get_name_leafdata())
                        if (self.max_intf_attached.is_set or self.max_intf_attached.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_intf_attached.get_name_leafdata())
                        if (self.max_intf_te.is_set or self.max_intf_te.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_intf_te.get_name_leafdata())
                        if (self.max_peer.is_set or self.max_peer.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.max_peer.get_name_leafdata())
                        if (self.nsr_enabled.is_set or self.nsr_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_enabled.get_name_leafdata())
                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                        if (self.protocol_version.is_set or self.protocol_version.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protocol_version.get_name_leafdata())
                        if (self.role_is_active.is_set or self.role_is_active.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.role_is_active.get_name_leafdata())
                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.router_id.get_name_leafdata())
                        if (self.session_hold_time.is_set or self.session_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.session_hold_time.get_name_leafdata())
                        if (self.targeted_hello_hold_time.is_set or self.targeted_hello_hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.targeted_hello_hold_time.get_name_leafdata())
                        if (self.targeted_hello_interval.is_set or self.targeted_hello_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.targeted_hello_interval.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "address-family-parameter"):
                            for c in self.address_family_parameter:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.Parameters.AddressFamilyParameter()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.address_family_parameter.append(c)
                            return c

                        if (child_yang_name == "graceful-restart-information"):
                            if (self.graceful_restart_information is None):
                                self.graceful_restart_information = MplsLdp.Nodes.Node.DefaultVrf.Parameters.GracefulRestartInformation()
                                self.graceful_restart_information.parent = self
                                self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                            return self.graceful_restart_information

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family-parameter" or name == "graceful-restart-information" or name == "af-binding-withdraw-delay" or name == "discovery-quick-start-disabled-on-interfaces" or name == "global-discovery-quick-start-disabled" or name == "global-md5-password-enabled" or name == "hello-hold-time" or name == "hello-interval" or name == "housekeeping-timer-interval" or name == "igp-sync-delay-time-for-interface" or name == "igp-sync-delay-time-on-restart" or name == "keepalive-interval" or name == "ldp-out-of-mem-state" or name == "ldp-recovery-timeout" or name == "le-no-route-timeout" or name == "max-intf-attached" or name == "max-intf-te" or name == "max-peer" or name == "nsr-enabled" or name == "nsr-synced" or name == "protocol-version" or name == "role-is-active" or name == "router-id" or name == "session-hold-time" or name == "targeted-hello-hold-time" or name == "targeted-hello-interval"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "af-binding-withdraw-delay"):
                            self.af_binding_withdraw_delay = value
                            self.af_binding_withdraw_delay.value_namespace = name_space
                            self.af_binding_withdraw_delay.value_namespace_prefix = name_space_prefix
                        if(value_path == "discovery-quick-start-disabled-on-interfaces"):
                            self.discovery_quick_start_disabled_on_interfaces = value
                            self.discovery_quick_start_disabled_on_interfaces.value_namespace = name_space
                            self.discovery_quick_start_disabled_on_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "global-discovery-quick-start-disabled"):
                            self.global_discovery_quick_start_disabled = value
                            self.global_discovery_quick_start_disabled.value_namespace = name_space
                            self.global_discovery_quick_start_disabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "global-md5-password-enabled"):
                            self.global_md5_password_enabled = value
                            self.global_md5_password_enabled.value_namespace = name_space
                            self.global_md5_password_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "hello-hold-time"):
                            self.hello_hold_time = value
                            self.hello_hold_time.value_namespace = name_space
                            self.hello_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "hello-interval"):
                            self.hello_interval = value
                            self.hello_interval.value_namespace = name_space
                            self.hello_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "housekeeping-timer-interval"):
                            self.housekeeping_timer_interval = value
                            self.housekeeping_timer_interval.value_namespace = name_space
                            self.housekeeping_timer_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-sync-delay-time-for-interface"):
                            self.igp_sync_delay_time_for_interface = value
                            self.igp_sync_delay_time_for_interface.value_namespace = name_space
                            self.igp_sync_delay_time_for_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-sync-delay-time-on-restart"):
                            self.igp_sync_delay_time_on_restart = value
                            self.igp_sync_delay_time_on_restart.value_namespace = name_space
                            self.igp_sync_delay_time_on_restart.value_namespace_prefix = name_space_prefix
                        if(value_path == "keepalive-interval"):
                            self.keepalive_interval = value
                            self.keepalive_interval.value_namespace = name_space
                            self.keepalive_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-out-of-mem-state"):
                            self.ldp_out_of_mem_state = value
                            self.ldp_out_of_mem_state.value_namespace = name_space
                            self.ldp_out_of_mem_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-recovery-timeout"):
                            self.ldp_recovery_timeout = value
                            self.ldp_recovery_timeout.value_namespace = name_space
                            self.ldp_recovery_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "le-no-route-timeout"):
                            self.le_no_route_timeout = value
                            self.le_no_route_timeout.value_namespace = name_space
                            self.le_no_route_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-intf-attached"):
                            self.max_intf_attached = value
                            self.max_intf_attached.value_namespace = name_space
                            self.max_intf_attached.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-intf-te"):
                            self.max_intf_te = value
                            self.max_intf_te.value_namespace = name_space
                            self.max_intf_te.value_namespace_prefix = name_space_prefix
                        if(value_path == "max-peer"):
                            self.max_peer = value
                            self.max_peer.value_namespace = name_space
                            self.max_peer.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-enabled"):
                            self.nsr_enabled = value
                            self.nsr_enabled.value_namespace = name_space
                            self.nsr_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-synced"):
                            self.nsr_synced = value
                            self.nsr_synced.value_namespace = name_space
                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                        if(value_path == "protocol-version"):
                            self.protocol_version = value
                            self.protocol_version.value_namespace = name_space
                            self.protocol_version.value_namespace_prefix = name_space_prefix
                        if(value_path == "role-is-active"):
                            self.role_is_active = value
                            self.role_is_active.value_namespace = name_space
                            self.role_is_active.value_namespace_prefix = name_space_prefix
                        if(value_path == "router-id"):
                            self.router_id = value
                            self.router_id.value_namespace = name_space
                            self.router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "session-hold-time"):
                            self.session_hold_time = value
                            self.session_hold_time.value_namespace = name_space
                            self.session_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "targeted-hello-hold-time"):
                            self.targeted_hello_hold_time = value
                            self.targeted_hello_hold_time.value_namespace = name_space
                            self.targeted_hello_hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "targeted-hello-interval"):
                            self.targeted_hello_interval = value
                            self.targeted_hello_interval.value_namespace = name_space
                            self.targeted_hello_interval.value_namespace_prefix = name_space_prefix


                class Issu(Entity):
                    """
                    LDP ISSU related information
                    
                    .. attribute:: ha_statistics
                    
                    	LDP NSR Statistics related information
                    	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics>`
                    
                    .. attribute:: ha_summary
                    
                    	LDP HA Summary
                    	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Issu, self).__init__()

                        self.yang_name = "issu"
                        self.yang_parent_name = "default-vrf"

                        self.ha_statistics = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics()
                        self.ha_statistics.parent = self
                        self._children_name_map["ha_statistics"] = "ha-statistics"
                        self._children_yang_names.add("ha-statistics")

                        self.ha_summary = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary()
                        self.ha_summary.parent = self
                        self._children_name_map["ha_summary"] = "ha-summary"
                        self._children_yang_names.add("ha-summary")


                    class HaSummary(Entity):
                        """
                        LDP HA Summary
                        
                        .. attribute:: sessions
                        
                        	Session summary
                        	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Sessions>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary, self).__init__()

                            self.yang_name = "ha-summary"
                            self.yang_parent_name = "issu"

                            self.sessions = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                            self._children_yang_names.add("sessions")

                            self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "ha-summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Sessions(Entity):
                            """
                            Session summary
                            
                            .. attribute:: nsr_eligible
                            
                            	NSR eligible sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_app_wait
                            
                            	Number of sessions in NSR app\-wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_none
                            
                            	Number of sessions in NSR none state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_operational
                            
                            	Number of sessions in NSR operational state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_prepare
                            
                            	Number of sessions in NSR prepare state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_ready
                            
                            	Number of sessions in NSR ready state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase1
                            
                            	Number of sessions in NSR TCP phase 1 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_tcp_phase2
                            
                            	Number of sessions in NSR TCP phase 2 state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: nsr_state_wait
                            
                            	Number of sessions in NSR wait state
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total
                            
                            	Total sessions
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Sessions, self).__init__()

                                self.yang_name = "sessions"
                                self.yang_parent_name = "ha-summary"

                                self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                self.total = YLeaf(YType.uint32, "total")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("nsr_eligible",
                                                "nsr_state_app_wait",
                                                "nsr_state_none",
                                                "nsr_state_operational",
                                                "nsr_state_prepare",
                                                "nsr_state_ready",
                                                "nsr_state_tcp_phase1",
                                                "nsr_state_tcp_phase2",
                                                "nsr_state_wait",
                                                "total") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.nsr_eligible.is_set or
                                    self.nsr_state_app_wait.is_set or
                                    self.nsr_state_none.is_set or
                                    self.nsr_state_operational.is_set or
                                    self.nsr_state_prepare.is_set or
                                    self.nsr_state_ready.is_set or
                                    self.nsr_state_tcp_phase1.is_set or
                                    self.nsr_state_tcp_phase2.is_set or
                                    self.nsr_state_wait.is_set or
                                    self.total.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.nsr_eligible.yfilter != YFilter.not_set or
                                    self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                    self.nsr_state_none.yfilter != YFilter.not_set or
                                    self.nsr_state_operational.yfilter != YFilter.not_set or
                                    self.nsr_state_prepare.yfilter != YFilter.not_set or
                                    self.nsr_state_ready.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                    self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                    self.nsr_state_wait.yfilter != YFilter.not_set or
                                    self.total.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sessions" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "nsr-eligible"):
                                    self.nsr_eligible = value
                                    self.nsr_eligible.value_namespace = name_space
                                    self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-app-wait"):
                                    self.nsr_state_app_wait = value
                                    self.nsr_state_app_wait.value_namespace = name_space
                                    self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-none"):
                                    self.nsr_state_none = value
                                    self.nsr_state_none.value_namespace = name_space
                                    self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-operational"):
                                    self.nsr_state_operational = value
                                    self.nsr_state_operational.value_namespace = name_space
                                    self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-prepare"):
                                    self.nsr_state_prepare = value
                                    self.nsr_state_prepare.value_namespace = name_space
                                    self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-ready"):
                                    self.nsr_state_ready = value
                                    self.nsr_state_ready.value_namespace = name_space
                                    self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase1"):
                                    self.nsr_state_tcp_phase1 = value
                                    self.nsr_state_tcp_phase1.value_namespace = name_space
                                    self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-tcp-phase2"):
                                    self.nsr_state_tcp_phase2 = value
                                    self.nsr_state_tcp_phase2.value_namespace = name_space
                                    self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state-wait"):
                                    self.nsr_state_wait = value
                                    self.nsr_state_wait.value_namespace = name_space
                                    self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                if(value_path == "total"):
                                    self.total = value
                                    self.total.value_namespace = name_space
                                    self.total.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.sessions is not None and self.sessions.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.sessions is not None and self.sessions.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "sessions"):
                                if (self.sessions is None):
                                    self.sessions = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Sessions()
                                    self.sessions.parent = self
                                    self._children_name_map["sessions"] = "sessions"
                                return self.sessions

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "sessions" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class HaStatistics(Entity):
                        """
                        LDP NSR Statistics related information
                        
                        .. attribute:: ha_global
                        
                        	LDP NSR Global Statistics information
                        	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal>`
                        
                        .. attribute:: ha_neighbors
                        
                        	The LDP HA Neighbors
                        	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics, self).__init__()

                            self.yang_name = "ha-statistics"
                            self.yang_parent_name = "issu"

                            self.ha_global = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal()
                            self.ha_global.parent = self
                            self._children_name_map["ha_global"] = "ha-global"
                            self._children_yang_names.add("ha-global")

                            self.ha_neighbors = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors()
                            self.ha_neighbors.parent = self
                            self._children_name_map["ha_neighbors"] = "ha-neighbors"
                            self._children_yang_names.add("ha-neighbors")


                        class HaGlobal(Entity):
                            """
                            LDP NSR Global Statistics information
                            
                            .. attribute:: init_sync
                            
                            	Init Sync
                            	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal, self).__init__()

                                self.yang_name = "ha-global"
                                self.yang_parent_name = "ha-statistics"

                                self.init_sync = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync()
                                self.init_sync.parent = self
                                self._children_name_map["init_sync"] = "init-sync"
                                self._children_yang_names.add("init-sync")


                            class InitSync(Entity):
                                """
                                Init Sync
                                
                                .. attribute:: init_sync_end
                                
                                	Init Sync End Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_sync_start
                                
                                	Init Sync Start Time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_default_mtu
                                
                                	default IPC MTU bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_exceeded_mtu_msg_cnt
                                
                                	ipc exceeded mtu msg cnt
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_max_rx_batch_bytes
                                
                                	biggest IPC RX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_max_tx_batch_bytes
                                
                                	biggest IPC TX bytes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_rx_bytes
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_rx_cnt
                                
                                	num IPC msgs rxed
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_msg_tx_bytes
                                
                                	total IPC bytes sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: byte
                                
                                .. attribute:: ipc_msg_tx_cnt
                                
                                	num IPC msgs sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_restart_cnt
                                
                                	number of times ipc has been restarted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ipc_tx_fail_cnt
                                
                                	number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_cfged
                                
                                	TRUE if NSR configured
                                	**type**\:  bool
                                
                                .. attribute:: nsr_synced
                                
                                	TRUE if NSR synced
                                	**type**\:  bool
                                
                                .. attribute:: num_cap_rcvd
                                
                                	Number of Rcvd Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_cap_sent
                                
                                	Number of Sent Capabilities objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl
                                
                                	Number of label bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lbl_adv
                                
                                	Num of lbl adv
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_lcl_addr_wd
                                
                                	Num of lcl address withdraw
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_peers
                                
                                	Number of Peers
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_pfx
                                
                                	Number of binding prefixes
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_ipc_tx_fail_cnt
                                
                                	total number of ipc send failures
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__init__()

                                    self.yang_name = "init-sync"
                                    self.yang_parent_name = "ha-global"

                                    self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                    self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                    self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                    self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                    self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                    self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                    self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                    self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                    self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                    self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                    self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                    self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                    self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                    self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                    self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                    self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                    self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                    self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                    self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                    self.num_peers = YLeaf(YType.uint32, "num-peers")

                                    self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                    self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("init_sync_end",
                                                    "init_sync_start",
                                                    "ipc_default_mtu",
                                                    "ipc_exceeded_mtu_msg_cnt",
                                                    "ipc_max_rx_batch_bytes",
                                                    "ipc_max_tx_batch_bytes",
                                                    "ipc_msg_rx_bytes",
                                                    "ipc_msg_rx_cnt",
                                                    "ipc_msg_tx_bytes",
                                                    "ipc_msg_tx_cnt",
                                                    "ipc_restart_cnt",
                                                    "ipc_tx_fail_cnt",
                                                    "nsr_cfged",
                                                    "nsr_synced",
                                                    "num_cap_rcvd",
                                                    "num_cap_sent",
                                                    "num_lbl",
                                                    "num_lbl_adv",
                                                    "num_lcl_addr_wd",
                                                    "num_peers",
                                                    "num_pfx",
                                                    "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.init_sync_end.is_set or
                                        self.init_sync_start.is_set or
                                        self.ipc_default_mtu.is_set or
                                        self.ipc_exceeded_mtu_msg_cnt.is_set or
                                        self.ipc_max_rx_batch_bytes.is_set or
                                        self.ipc_max_tx_batch_bytes.is_set or
                                        self.ipc_msg_rx_bytes.is_set or
                                        self.ipc_msg_rx_cnt.is_set or
                                        self.ipc_msg_tx_bytes.is_set or
                                        self.ipc_msg_tx_cnt.is_set or
                                        self.ipc_restart_cnt.is_set or
                                        self.ipc_tx_fail_cnt.is_set or
                                        self.nsr_cfged.is_set or
                                        self.nsr_synced.is_set or
                                        self.num_cap_rcvd.is_set or
                                        self.num_cap_sent.is_set or
                                        self.num_lbl.is_set or
                                        self.num_lbl_adv.is_set or
                                        self.num_lcl_addr_wd.is_set or
                                        self.num_peers.is_set or
                                        self.num_pfx.is_set or
                                        self.total_ipc_tx_fail_cnt.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.init_sync_end.yfilter != YFilter.not_set or
                                        self.init_sync_start.yfilter != YFilter.not_set or
                                        self.ipc_default_mtu.yfilter != YFilter.not_set or
                                        self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                        self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                        self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                        self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                        self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                        self.nsr_cfged.yfilter != YFilter.not_set or
                                        self.nsr_synced.yfilter != YFilter.not_set or
                                        self.num_cap_rcvd.yfilter != YFilter.not_set or
                                        self.num_cap_sent.yfilter != YFilter.not_set or
                                        self.num_lbl.yfilter != YFilter.not_set or
                                        self.num_lbl_adv.yfilter != YFilter.not_set or
                                        self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                        self.num_peers.yfilter != YFilter.not_set or
                                        self.num_pfx.yfilter != YFilter.not_set or
                                        self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "init-sync" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                    if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                    if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                    if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                    if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                    if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                    if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                    if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                    if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                    if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                    if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                    if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                    if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                    if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                    if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                    if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                    if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_peers.get_name_leafdata())
                                    if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                    if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "init-sync-end"):
                                        self.init_sync_end = value
                                        self.init_sync_end.value_namespace = name_space
                                        self.init_sync_end.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-sync-start"):
                                        self.init_sync_start = value
                                        self.init_sync_start.value_namespace = name_space
                                        self.init_sync_start.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-default-mtu"):
                                        self.ipc_default_mtu = value
                                        self.ipc_default_mtu.value_namespace = name_space
                                        self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                        self.ipc_exceeded_mtu_msg_cnt = value
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                        self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-rx-batch-bytes"):
                                        self.ipc_max_rx_batch_bytes = value
                                        self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-max-tx-batch-bytes"):
                                        self.ipc_max_tx_batch_bytes = value
                                        self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                        self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-bytes"):
                                        self.ipc_msg_rx_bytes = value
                                        self.ipc_msg_rx_bytes.value_namespace = name_space
                                        self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-rx-cnt"):
                                        self.ipc_msg_rx_cnt = value
                                        self.ipc_msg_rx_cnt.value_namespace = name_space
                                        self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-bytes"):
                                        self.ipc_msg_tx_bytes = value
                                        self.ipc_msg_tx_bytes.value_namespace = name_space
                                        self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-msg-tx-cnt"):
                                        self.ipc_msg_tx_cnt = value
                                        self.ipc_msg_tx_cnt.value_namespace = name_space
                                        self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-restart-cnt"):
                                        self.ipc_restart_cnt = value
                                        self.ipc_restart_cnt.value_namespace = name_space
                                        self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipc-tx-fail-cnt"):
                                        self.ipc_tx_fail_cnt = value
                                        self.ipc_tx_fail_cnt.value_namespace = name_space
                                        self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-cfged"):
                                        self.nsr_cfged = value
                                        self.nsr_cfged.value_namespace = name_space
                                        self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-synced"):
                                        self.nsr_synced = value
                                        self.nsr_synced.value_namespace = name_space
                                        self.nsr_synced.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-rcvd"):
                                        self.num_cap_rcvd = value
                                        self.num_cap_rcvd.value_namespace = name_space
                                        self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-cap-sent"):
                                        self.num_cap_sent = value
                                        self.num_cap_sent.value_namespace = name_space
                                        self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl"):
                                        self.num_lbl = value
                                        self.num_lbl.value_namespace = name_space
                                        self.num_lbl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lbl-adv"):
                                        self.num_lbl_adv = value
                                        self.num_lbl_adv.value_namespace = name_space
                                        self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-lcl-addr-wd"):
                                        self.num_lcl_addr_wd = value
                                        self.num_lcl_addr_wd.value_namespace = name_space
                                        self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-peers"):
                                        self.num_peers = value
                                        self.num_peers.value_namespace = name_space
                                        self.num_peers.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-pfx"):
                                        self.num_pfx = value
                                        self.num_pfx.value_namespace = name_space
                                        self.num_pfx.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-ipc-tx-fail-cnt"):
                                        self.total_ipc_tx_fail_cnt = value
                                        self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                        self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.init_sync is not None and self.init_sync.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.init_sync is not None and self.init_sync.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-global" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "init-sync"):
                                    if (self.init_sync is None):
                                        self.init_sync = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal.InitSync()
                                        self.init_sync.parent = self
                                        self._children_name_map["init_sync"] = "init-sync"
                                    return self.init_sync

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "init-sync"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaNeighbors(Entity):
                            """
                            The LDP HA Neighbors
                            
                            .. attribute:: ha_neighbor
                            
                            	Information on a particular LDP HA neighbor
                            	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__init__()

                                self.yang_name = "ha-neighbors"
                                self.yang_parent_name = "ha-statistics"

                                self.ha_neighbor = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                            class HaNeighbor(Entity):
                                """
                                Information on a particular LDP HA neighbor
                                
                                .. attribute:: init_sync_info
                                
                                	NSR Init Sync Info
                                	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                
                                .. attribute:: label_space_id
                                
                                	Label space ID of neighbor
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lbl_spc_id
                                
                                	lbl spc id
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: lsr_id
                                
                                	LSR ID of neighbor
                                	**type**\: one of the below types:
                                
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                
                                ----
                                .. attribute:: lsr_id_xr
                                
                                	lsr id xr
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_sync_state
                                
                                	nsr sync state
                                	**type**\:  int
                                
                                	**range:** \-2147483648..2147483647
                                
                                .. attribute:: num_msg
                                
                                	Number of sync messages
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: steady_state_sync_info
                                
                                	NSR Steady State Sync Info
                                	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                    self.yang_name = "ha-neighbor"
                                    self.yang_parent_name = "ha-neighbors"

                                    self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                    self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                    self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                    self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                    self.num_msg = YLeaf(YType.uint32, "num-msg")

                                    self.init_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                    self.init_sync_info.parent = self
                                    self._children_name_map["init_sync_info"] = "init-sync-info"
                                    self._children_yang_names.add("init-sync-info")

                                    self.steady_state_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                    self.steady_state_sync_info.parent = self
                                    self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                    self._children_yang_names.add("steady-state-sync-info")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "lbl_spc_id",
                                                    "lsr_id",
                                                    "lsr_id_xr",
                                                    "nsr_sync_state",
                                                    "num_msg") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                class InitSyncInfo(Entity):
                                    """
                                    NSR Init Sync Info
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_addr
                                    
                                    	Number of peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_app_bytes
                                    
                                    	Number of external App data bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_duplicate_addr
                                    
                                    	Number of duplicate peer addresses
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of peer bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_rx_bytes
                                    
                                    	Number of unprocessed Rx buffer bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                        self.yang_name = "init-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.num_addr = YLeaf(YType.uint32, "num-addr")

                                        self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "num_addr",
                                                        "num_app_bytes",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_duplicate_addr",
                                                        "num_lbl",
                                                        "num_rx_bytes") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.num_addr.is_set or
                                            self.num_app_bytes.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_duplicate_addr.is_set or
                                            self.num_lbl.is_set or
                                            self.num_rx_bytes.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.num_addr.yfilter != YFilter.not_set or
                                            self.num_app_bytes.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_duplicate_addr.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_rx_bytes.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_addr.get_name_leafdata())
                                        if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-addr"):
                                            self.num_addr = value
                                            self.num_addr.value_namespace = name_space
                                            self.num_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-app-bytes"):
                                            self.num_app_bytes = value
                                            self.num_app_bytes.value_namespace = name_space
                                            self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-duplicate-addr"):
                                            self.num_duplicate_addr = value
                                            self.num_duplicate_addr.value_namespace = name_space
                                            self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-rx-bytes"):
                                            self.num_rx_bytes = value
                                            self.num_rx_bytes.value_namespace = name_space
                                            self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                class SteadyStateSyncInfo(Entity):
                                    """
                                    NSR Steady State Sync Info
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Num of Rcvd Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Num of Sent Capabilities
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_join
                                    
                                    	Number of standby adj join
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_stdby_adj_leave
                                    
                                    	Number of standby adj leave
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_rq
                                    
                                    	Number of remote label request events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rem_lbl_wd
                                    
                                    	Number of remote label withdraw events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                        self.yang_name = "steady-state-sync-info"
                                        self.yang_parent_name = "ha-neighbor"

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                        self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                        self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                        self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_stdby_adj_join",
                                                        "num_stdby_adj_leave",
                                                        "rem_lbl_rq",
                                                        "rem_lbl_wd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_stdby_adj_join.is_set or
                                            self.num_stdby_adj_leave.is_set or
                                            self.rem_lbl_rq.is_set or
                                            self.rem_lbl_wd.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                            self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                            self.rem_lbl_rq.yfilter != YFilter.not_set or
                                            self.rem_lbl_wd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "steady-state-sync-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                        if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                        if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                        if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-join"):
                                            self.num_stdby_adj_join = value
                                            self.num_stdby_adj_join.value_namespace = name_space
                                            self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-stdby-adj-leave"):
                                            self.num_stdby_adj_leave = value
                                            self.num_stdby_adj_leave.value_namespace = name_space
                                            self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-rq"):
                                            self.rem_lbl_rq = value
                                            self.rem_lbl_rq.value_namespace = name_space
                                            self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rem-lbl-wd"):
                                            self.rem_lbl_wd = value
                                            self.rem_lbl_wd.value_namespace = name_space
                                            self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.lbl_spc_id.is_set or
                                        self.lsr_id.is_set or
                                        self.lsr_id_xr.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.num_msg.is_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.lbl_spc_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set or
                                        self.lsr_id_xr.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.num_msg.yfilter != YFilter.not_set or
                                        (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                        (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbor" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                    if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_msg.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync-info"):
                                        if (self.init_sync_info is None):
                                            self.init_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                            self.init_sync_info.parent = self
                                            self._children_name_map["init_sync_info"] = "init-sync-info"
                                        return self.init_sync_info

                                    if (child_yang_name == "steady-state-sync-info"):
                                        if (self.steady_state_sync_info is None):
                                            self.steady_state_sync_info = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                            self.steady_state_sync_info.parent = self
                                            self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        return self.steady_state_sync_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbl-spc-id"):
                                        self.lbl_spc_id = value
                                        self.lbl_spc_id.value_namespace = name_space
                                        self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id-xr"):
                                        self.lsr_id_xr = value
                                        self.lsr_id_xr.value_namespace = name_space
                                        self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-msg"):
                                        self.num_msg = value
                                        self.num_msg.value_namespace = name_space
                                        self.num_msg.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.ha_neighbor:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.ha_neighbor:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-neighbors" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbor"):
                                    for c in self.ha_neighbor:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors.HaNeighbor()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ha_neighbor.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbor"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_global is not None and self.ha_global.has_data()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_global is not None and self.ha_global.has_operation()) or
                                (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ha-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-global"):
                                if (self.ha_global is None):
                                    self.ha_global = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaGlobal()
                                    self.ha_global.parent = self
                                    self._children_name_map["ha_global"] = "ha-global"
                                return self.ha_global

                            if (child_yang_name == "ha-neighbors"):
                                if (self.ha_neighbors is None):
                                    self.ha_neighbors = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics.HaNeighbors()
                                    self.ha_neighbors.parent = self
                                    self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                return self.ha_neighbors

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-global" or name == "ha-neighbors"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                            (self.ha_summary is not None and self.ha_summary.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                            (self.ha_summary is not None and self.ha_summary.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "issu" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ha-statistics"):
                            if (self.ha_statistics is None):
                                self.ha_statistics = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaStatistics()
                                self.ha_statistics.parent = self
                                self._children_name_map["ha_statistics"] = "ha-statistics"
                            return self.ha_statistics

                        if (child_yang_name == "ha-summary"):
                            if (self.ha_summary is None):
                                self.ha_summary = MplsLdp.Nodes.Node.DefaultVrf.Issu.HaSummary()
                                self.ha_summary.parent = self
                                self._children_name_map["ha_summary"] = "ha-summary"
                            return self.ha_summary

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ha-statistics" or name == "ha-summary"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class NeighborCapabilities(Entity):
                    """
                    LDP Neighbors Capabilities
                    
                    .. attribute:: neighbor_capability
                    
                    	Information on capabilities of a particular LDP neighbor
                    	**type**\: list of    :py:class:`NeighborCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities, self).__init__()

                        self.yang_name = "neighbor-capabilities"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities, self).__setattr__(name, value)


                    class NeighborCapability(Entity):
                        """
                        Information on capabilities of a particular LDP
                        neighbor
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: received
                        
                        	List of received capabilities
                        	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Received>`
                        
                        .. attribute:: sent
                        
                        	List of sent capabilities
                        	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__init__()

                            self.yang_name = "neighbor-capability"
                            self.yang_parent_name = "neighbor-capabilities"

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.received = YList(self)
                            self.sent = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)


                        class Sent(Entity):
                            """
                            List of sent capabilities
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__init__()

                                self.yang_name = "sent"
                                self.yang_parent_name = "neighbor-capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "sent" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix


                        class Received(Entity):
                            """
                            List of received capabilities
                            
                            .. attribute:: capability_data
                            
                            	Capability data
                            	**type**\:  str
                            
                            .. attribute:: capability_data_length
                            
                            	Capability data length
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: description
                            
                            	Capability description
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: type
                            
                            	Capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__init__()

                                self.yang_name = "received"
                                self.yang_parent_name = "neighbor-capability"

                                self.capability_data = YLeaf(YType.str, "capability-data")

                                self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                self.description = YLeaf(YType.str, "description")

                                self.type = YLeaf(YType.uint16, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_data",
                                                "capability_data_length",
                                                "description",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.capability_data.is_set or
                                    self.capability_data_length.is_set or
                                    self.description.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_data.yfilter != YFilter.not_set or
                                    self.capability_data_length.yfilter != YFilter.not_set or
                                    self.description.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "received" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data.get_name_leafdata())
                                if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.description.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-data"):
                                    self.capability_data = value
                                    self.capability_data.value_namespace = name_space
                                    self.capability_data.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-data-length"):
                                    self.capability_data_length = value
                                    self.capability_data_length.value_namespace = name_space
                                    self.capability_data_length.value_namespace_prefix = name_space_prefix
                                if(value_path == "description"):
                                    self.description = value
                                    self.description.value_namespace = name_space
                                    self.description.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.received:
                                if (c.has_data()):
                                    return True
                            for c in self.sent:
                                if (c.has_data()):
                                    return True
                            return (
                                self.label_space_id.is_set or
                                self.lsr_id.is_set)

                        def has_operation(self):
                            for c in self.received:
                                if (c.has_operation()):
                                    return True
                            for c in self.sent:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "received"):
                                for c in self.received:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Received()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.received.append(c)
                                return c

                            if (child_yang_name == "sent"):
                                for c in self.sent:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability.Sent()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.sent.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "received" or name == "sent" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor-capability"):
                            for c in self.neighbor_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities.NeighborCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Neighbors(Entity):
                    """
                    The LDP Neighbors
                    
                    .. attribute:: neighbor
                    
                    	Information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors, self).__init__()

                        self.yang_name = "neighbors"
                        self.yang_parent_name = "default-vrf"

                        self.neighbor = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors, self).__setattr__(name, value)


                    class Neighbor(Entity):
                        """
                        Information on a particular LDP neighbor
                        
                        .. attribute:: detailed_information
                        
                        	Detailed information with regards to holdtime, KA, inbound filtering, and Session protection
                        	**type**\:   :py:class:`DetailedInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation>`
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: ldp_nbr_bound_ipv4_address_info
                        
                        	Neighbor IPv4 Address Info
                        	**type**\: list of    :py:class:`LdpNbrBoundIpv4AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo>`
                        
                        .. attribute:: ldp_nbr_bound_ipv6_address_info
                        
                        	Neighbor IPv6 Address Info
                        	**type**\: list of    :py:class:`LdpNbrBoundIpv6AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo>`
                        
                        .. attribute:: ldp_nbr_ipv4_adj_info
                        
                        	Neighbor's IPv4 Adjacency Information
                        	**type**\: list of    :py:class:`LdpNbrIpv4AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo>`
                        
                        .. attribute:: ldp_nbr_ipv6_adj_info
                        
                        	Neighbor's IPv6 Adjacency Information
                        	**type**\: list of    :py:class:`LdpNbrIpv6AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo>`
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: protocol_information
                        
                        	Protocol Information
                        	**type**\:   :py:class:`ProtocolInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation>`
                        
                        .. attribute:: tcp_information
                        
                        	TCP Information
                        	**type**\:   :py:class:`TcpInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor, self).__init__()

                            self.yang_name = "neighbor"
                            self.yang_parent_name = "neighbors"

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.detailed_information = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation()
                            self.detailed_information.parent = self
                            self._children_name_map["detailed_information"] = "detailed-information"
                            self._children_yang_names.add("detailed-information")

                            self.protocol_information = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation()
                            self.protocol_information.parent = self
                            self._children_name_map["protocol_information"] = "protocol-information"
                            self._children_yang_names.add("protocol-information")

                            self.tcp_information = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation()
                            self.tcp_information.parent = self
                            self._children_name_map["tcp_information"] = "tcp-information"
                            self._children_yang_names.add("tcp-information")

                            self.ldp_nbr_bound_ipv4_address_info = YList(self)
                            self.ldp_nbr_bound_ipv6_address_info = YList(self)
                            self.ldp_nbr_ipv4_adj_info = YList(self)
                            self.ldp_nbr_ipv6_adj_info = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor, self).__setattr__(name, value)


                        class ProtocolInformation(Entity):
                            """
                            Protocol Information
                            
                            .. attribute:: downstream_on_demand
                            
                            	Is Label advertisment mode in Downstream On Demand mode or Not
                            	**type**\:  bool
                            
                            .. attribute:: ta_graceful_restart_adjacency
                            
                            	Graceful restart information
                            	**type**\:   :py:class:`TaGracefulRestartAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency>`
                            
                            .. attribute:: ta_holdtime
                            
                            	Session holdtime in sec
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_pies_rcvd
                            
                            	Number of pies received
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_pies_sent
                            
                            	Number of pies sent
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ta_state
                            
                            	State
                            	**type**\:  str
                            
                            .. attribute:: ta_up_time_seconds
                            
                            	Up time in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__init__()

                                self.yang_name = "protocol-information"
                                self.yang_parent_name = "neighbor"

                                self.downstream_on_demand = YLeaf(YType.boolean, "downstream-on-demand")

                                self.ta_holdtime = YLeaf(YType.uint32, "ta-holdtime")

                                self.ta_pies_rcvd = YLeaf(YType.uint32, "ta-pies-rcvd")

                                self.ta_pies_sent = YLeaf(YType.uint32, "ta-pies-sent")

                                self.ta_state = YLeaf(YType.str, "ta-state")

                                self.ta_up_time_seconds = YLeaf(YType.uint32, "ta-up-time-seconds")

                                self.ta_graceful_restart_adjacency = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                self.ta_graceful_restart_adjacency.parent = self
                                self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                self._children_yang_names.add("ta-graceful-restart-adjacency")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("downstream_on_demand",
                                                "ta_holdtime",
                                                "ta_pies_rcvd",
                                                "ta_pies_sent",
                                                "ta_state",
                                                "ta_up_time_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)


                            class TaGracefulRestartAdjacency(Entity):
                                """
                                Graceful restart information
                                
                                .. attribute:: is_graceful_restartable
                                
                                	Is graceful restartable
                                	**type**\:  bool
                                
                                .. attribute:: reconnect_timeout
                                
                                	Reconnect timeout
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: recovery_time
                                
                                	Recovery time
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__init__()

                                    self.yang_name = "ta-graceful-restart-adjacency"
                                    self.yang_parent_name = "protocol-information"

                                    self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                    self.reconnect_timeout = YLeaf(YType.uint32, "reconnect-timeout")

                                    self.recovery_time = YLeaf(YType.uint32, "recovery-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_graceful_restartable",
                                                    "reconnect_timeout",
                                                    "recovery_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_graceful_restartable.is_set or
                                        self.reconnect_timeout.is_set or
                                        self.recovery_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_graceful_restartable.yfilter != YFilter.not_set or
                                        self.reconnect_timeout.yfilter != YFilter.not_set or
                                        self.recovery_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ta-graceful-restart-adjacency" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                    if (self.reconnect_timeout.is_set or self.reconnect_timeout.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reconnect_timeout.get_name_leafdata())
                                    if (self.recovery_time.is_set or self.recovery_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.recovery_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-graceful-restartable" or name == "reconnect-timeout" or name == "recovery-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-graceful-restartable"):
                                        self.is_graceful_restartable = value
                                        self.is_graceful_restartable.value_namespace = name_space
                                        self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reconnect-timeout"):
                                        self.reconnect_timeout = value
                                        self.reconnect_timeout.value_namespace = name_space
                                        self.reconnect_timeout.value_namespace_prefix = name_space_prefix
                                    if(value_path == "recovery-time"):
                                        self.recovery_time = value
                                        self.recovery_time.value_namespace = name_space
                                        self.recovery_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.downstream_on_demand.is_set or
                                    self.ta_holdtime.is_set or
                                    self.ta_pies_rcvd.is_set or
                                    self.ta_pies_sent.is_set or
                                    self.ta_state.is_set or
                                    self.ta_up_time_seconds.is_set or
                                    (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.downstream_on_demand.yfilter != YFilter.not_set or
                                    self.ta_holdtime.yfilter != YFilter.not_set or
                                    self.ta_pies_rcvd.yfilter != YFilter.not_set or
                                    self.ta_pies_sent.yfilter != YFilter.not_set or
                                    self.ta_state.yfilter != YFilter.not_set or
                                    self.ta_up_time_seconds.yfilter != YFilter.not_set or
                                    (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protocol-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.downstream_on_demand.is_set or self.downstream_on_demand.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.downstream_on_demand.get_name_leafdata())
                                if (self.ta_holdtime.is_set or self.ta_holdtime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_holdtime.get_name_leafdata())
                                if (self.ta_pies_rcvd.is_set or self.ta_pies_rcvd.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_pies_rcvd.get_name_leafdata())
                                if (self.ta_pies_sent.is_set or self.ta_pies_sent.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_pies_sent.get_name_leafdata())
                                if (self.ta_state.is_set or self.ta_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_state.get_name_leafdata())
                                if (self.ta_up_time_seconds.is_set or self.ta_up_time_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ta_up_time_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ta-graceful-restart-adjacency"):
                                    if (self.ta_graceful_restart_adjacency is None):
                                        self.ta_graceful_restart_adjacency = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                        self.ta_graceful_restart_adjacency.parent = self
                                        self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                    return self.ta_graceful_restart_adjacency

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ta-graceful-restart-adjacency" or name == "downstream-on-demand" or name == "ta-holdtime" or name == "ta-pies-rcvd" or name == "ta-pies-sent" or name == "ta-state" or name == "ta-up-time-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "downstream-on-demand"):
                                    self.downstream_on_demand = value
                                    self.downstream_on_demand.value_namespace = name_space
                                    self.downstream_on_demand.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-holdtime"):
                                    self.ta_holdtime = value
                                    self.ta_holdtime.value_namespace = name_space
                                    self.ta_holdtime.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-pies-rcvd"):
                                    self.ta_pies_rcvd = value
                                    self.ta_pies_rcvd.value_namespace = name_space
                                    self.ta_pies_rcvd.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-pies-sent"):
                                    self.ta_pies_sent = value
                                    self.ta_pies_sent.value_namespace = name_space
                                    self.ta_pies_sent.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-state"):
                                    self.ta_state = value
                                    self.ta_state.value_namespace = name_space
                                    self.ta_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "ta-up-time-seconds"):
                                    self.ta_up_time_seconds = value
                                    self.ta_up_time_seconds.value_namespace = name_space
                                    self.ta_up_time_seconds.value_namespace_prefix = name_space_prefix


                        class TcpInformation(Entity):
                            """
                            TCP Information
                            
                            .. attribute:: foreign_host
                            
                            	Foreign host address
                            	**type**\:   :py:class:`ForeignHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost>`
                            
                            .. attribute:: foreign_port
                            
                            	Foreign port number
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: is_md5_on
                            
                            	Is MD5 Digest on
                            	**type**\:  bool
                            
                            .. attribute:: local_host
                            
                            	Local host address
                            	**type**\:   :py:class:`LocalHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost>`
                            
                            .. attribute:: local_port
                            
                            	Local port number
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__init__()

                                self.yang_name = "tcp-information"
                                self.yang_parent_name = "neighbor"

                                self.foreign_port = YLeaf(YType.uint16, "foreign-port")

                                self.is_md5_on = YLeaf(YType.boolean, "is-md5-on")

                                self.local_port = YLeaf(YType.uint16, "local-port")

                                self.foreign_host = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                self.foreign_host.parent = self
                                self._children_name_map["foreign_host"] = "foreign-host"
                                self._children_yang_names.add("foreign-host")

                                self.local_host = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                self.local_host.parent = self
                                self._children_name_map["local_host"] = "local-host"
                                self._children_yang_names.add("local-host")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("foreign_port",
                                                "is_md5_on",
                                                "local_port") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)


                            class ForeignHost(Entity):
                                """
                                Foreign host address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__init__()

                                    self.yang_name = "foreign-host"
                                    self.yang_parent_name = "tcp-information"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "foreign-host" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix


                            class LocalHost(Entity):
                                """
                                Local host address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__init__()

                                    self.yang_name = "local-host"
                                    self.yang_parent_name = "tcp-information"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "local-host" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.foreign_port.is_set or
                                    self.is_md5_on.is_set or
                                    self.local_port.is_set or
                                    (self.foreign_host is not None and self.foreign_host.has_data()) or
                                    (self.local_host is not None and self.local_host.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.foreign_port.yfilter != YFilter.not_set or
                                    self.is_md5_on.yfilter != YFilter.not_set or
                                    self.local_port.yfilter != YFilter.not_set or
                                    (self.foreign_host is not None and self.foreign_host.has_operation()) or
                                    (self.local_host is not None and self.local_host.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tcp-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.foreign_port.is_set or self.foreign_port.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.foreign_port.get_name_leafdata())
                                if (self.is_md5_on.is_set or self.is_md5_on.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_md5_on.get_name_leafdata())
                                if (self.local_port.is_set or self.local_port.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_port.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "foreign-host"):
                                    if (self.foreign_host is None):
                                        self.foreign_host = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                        self.foreign_host.parent = self
                                        self._children_name_map["foreign_host"] = "foreign-host"
                                    return self.foreign_host

                                if (child_yang_name == "local-host"):
                                    if (self.local_host is None):
                                        self.local_host = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                        self.local_host.parent = self
                                        self._children_name_map["local_host"] = "local-host"
                                    return self.local_host

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "foreign-host" or name == "local-host" or name == "foreign-port" or name == "is-md5-on" or name == "local-port"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "foreign-port"):
                                    self.foreign_port = value
                                    self.foreign_port.value_namespace = name_space
                                    self.foreign_port.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-md5-on"):
                                    self.is_md5_on = value
                                    self.is_md5_on.value_namespace = name_space
                                    self.is_md5_on.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-port"):
                                    self.local_port = value
                                    self.local_port.value_namespace = name_space
                                    self.local_port.value_namespace_prefix = name_space_prefix


                        class DetailedInformation(Entity):
                            """
                            Detailed information with regards to holdtime,
                            KA, inbound filtering, and Session protection
                            
                            .. attribute:: advertise_bgp_prefixes
                            
                            	Is BGP labelled prefixes advertised to the neighbor
                            	**type**\:  bool
                            
                            .. attribute:: bgp_advertisement_state
                            
                            	BGP labelled prefixes advertisement state
                            	**type**\:   :py:class:`MgmtLdpNbrBgpAdvtState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNbrBgpAdvtState>`
                            
                            .. attribute:: capabilities
                            
                            	Capabilities sent to and received from neighbor
                            	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities>`
                            
                            .. attribute:: client
                            
                            	Targeted Session clients
                            	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client>`
                            
                            .. attribute:: has_ipv4_inbound
                            
                            	IPv4 Inbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv4_outbound
                            
                            	IPv4 Outbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv6_inbound
                            
                            	IPv6 Inbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_ipv6_outbound
                            
                            	IPv6 Outbound label filtering present
                            	**type**\:  bool
                            
                            .. attribute:: has_sp
                            
                            	Session Protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: inbound_ipv4acl
                            
                            	IPv4 Inbound accept ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: inbound_ipv6acl
                            
                            	IPv6 Inbound accept ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: ipv4_duplicate_address
                            
                            	Duplicate IPv4 address bound to this peer
                            	**type**\: list of    :py:class:`Ipv4DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress>`
                            
                            .. attribute:: ipv6_duplicate_address
                            
                            	Duplicate IPv6 address bound to this peer
                            	**type**\: list of    :py:class:`Ipv6DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress>`
                            
                            .. attribute:: keep_alive_interval
                            
                            	Session keepalive interval in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: nsr_last_sync_error
                            
                            	Last NSR sync error
                            	**type**\:   :py:class:`MgmtLdpNsrPeerSyncErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncErr>`
                            
                            .. attribute:: nsr_last_sync_nack_reason
                            
                            	Last NSR sync NACK reaston
                            	**type**\:   :py:class:`MgmtLdpNsrPeerLdpSyncNackRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerLdpSyncNackRsn>`
                            
                            .. attribute:: nsr_sync_state
                            
                            	NSR Sync State
                            	**type**\:   :py:class:`MgmtLdpNsrPeerSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncState>`
                            
                            .. attribute:: outbound_ipv4acl
                            
                            	IPv4 Outbound advertise ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: outbound_ipv6acl
                            
                            	IPv6 Outbound advertise ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: peer_holdtime
                            
                            	Session holdtime value in seconds from the peer
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: peer_state
                            
                            	Peer state
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: sp_duration
                            
                            	Session protection holdup time duration in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: sp_has_acl
                            
                            	Session protection ACL is present
                            	**type**\:  bool
                            
                            .. attribute:: sp_has_duration
                            
                            	Session Protection has non\-default duration
                            	**type**\:  bool
                            
                            .. attribute:: sp_state
                            
                            	Session Protection state
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: spacl
                            
                            	Session Protection ACL
                            	**type**\:  str
                            
                            	**length:** 0..80
                            
                            .. attribute:: spht_remaining
                            
                            	Session Protection holdup time remaining value in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: spht_running
                            
                            	Session Protection holdup timer is running
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__init__()

                                self.yang_name = "detailed-information"
                                self.yang_parent_name = "neighbor"

                                self.advertise_bgp_prefixes = YLeaf(YType.boolean, "advertise-bgp-prefixes")

                                self.bgp_advertisement_state = YLeaf(YType.enumeration, "bgp-advertisement-state")

                                self.has_ipv4_inbound = YLeaf(YType.boolean, "has-ipv4-inbound")

                                self.has_ipv4_outbound = YLeaf(YType.boolean, "has-ipv4-outbound")

                                self.has_ipv6_inbound = YLeaf(YType.boolean, "has-ipv6-inbound")

                                self.has_ipv6_outbound = YLeaf(YType.boolean, "has-ipv6-outbound")

                                self.has_sp = YLeaf(YType.boolean, "has-sp")

                                self.inbound_ipv4acl = YLeaf(YType.str, "inbound-ipv4acl")

                                self.inbound_ipv6acl = YLeaf(YType.str, "inbound-ipv6acl")

                                self.keep_alive_interval = YLeaf(YType.uint32, "keep-alive-interval")

                                self.nsr_last_sync_error = YLeaf(YType.enumeration, "nsr-last-sync-error")

                                self.nsr_last_sync_nack_reason = YLeaf(YType.enumeration, "nsr-last-sync-nack-reason")

                                self.nsr_sync_state = YLeaf(YType.enumeration, "nsr-sync-state")

                                self.outbound_ipv4acl = YLeaf(YType.str, "outbound-ipv4acl")

                                self.outbound_ipv6acl = YLeaf(YType.str, "outbound-ipv6acl")

                                self.peer_holdtime = YLeaf(YType.uint32, "peer-holdtime")

                                self.peer_state = YLeaf(YType.str, "peer-state")

                                self.sp_duration = YLeaf(YType.uint32, "sp-duration")

                                self.sp_has_acl = YLeaf(YType.boolean, "sp-has-acl")

                                self.sp_has_duration = YLeaf(YType.boolean, "sp-has-duration")

                                self.sp_state = YLeaf(YType.str, "sp-state")

                                self.spacl = YLeaf(YType.str, "spacl")

                                self.spht_remaining = YLeaf(YType.uint32, "spht-remaining")

                                self.spht_running = YLeaf(YType.boolean, "spht-running")

                                self.capabilities = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                self.capabilities.parent = self
                                self._children_name_map["capabilities"] = "capabilities"
                                self._children_yang_names.add("capabilities")

                                self.client = YList(self)
                                self.ipv4_duplicate_address = YList(self)
                                self.ipv6_duplicate_address = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("advertise_bgp_prefixes",
                                                "bgp_advertisement_state",
                                                "has_ipv4_inbound",
                                                "has_ipv4_outbound",
                                                "has_ipv6_inbound",
                                                "has_ipv6_outbound",
                                                "has_sp",
                                                "inbound_ipv4acl",
                                                "inbound_ipv6acl",
                                                "keep_alive_interval",
                                                "nsr_last_sync_error",
                                                "nsr_last_sync_nack_reason",
                                                "nsr_sync_state",
                                                "outbound_ipv4acl",
                                                "outbound_ipv6acl",
                                                "peer_holdtime",
                                                "peer_state",
                                                "sp_duration",
                                                "sp_has_acl",
                                                "sp_has_duration",
                                                "sp_state",
                                                "spacl",
                                                "spht_remaining",
                                                "spht_running") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)


                            class Capabilities(Entity):
                                """
                                Capabilities sent to and received from neighbor
                                
                                .. attribute:: received
                                
                                	List of received capabilities
                                	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received>`
                                
                                .. attribute:: sent
                                
                                	List of sent capabilities
                                	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__init__()

                                    self.yang_name = "capabilities"
                                    self.yang_parent_name = "detailed-information"

                                    self.received = YList(self)
                                    self.sent = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)


                                class Sent(Entity):
                                    """
                                    List of sent capabilities
                                    
                                    .. attribute:: capability_data
                                    
                                    	Capability data
                                    	**type**\:  str
                                    
                                    .. attribute:: capability_data_length
                                    
                                    	Capability data length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: description
                                    
                                    	Capability description
                                    	**type**\:  str
                                    
                                    	**length:** 0..80
                                    
                                    .. attribute:: type
                                    
                                    	Capability type (IANA assigned)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__init__()

                                        self.yang_name = "sent"
                                        self.yang_parent_name = "capabilities"

                                        self.capability_data = YLeaf(YType.str, "capability-data")

                                        self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                        self.description = YLeaf(YType.str, "description")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("capability_data",
                                                        "capability_data_length",
                                                        "description",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.capability_data.is_set or
                                            self.capability_data_length.is_set or
                                            self.description.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.capability_data.yfilter != YFilter.not_set or
                                            self.capability_data_length.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sent" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data.get_name_leafdata())
                                        if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "capability-data"):
                                            self.capability_data = value
                                            self.capability_data.value_namespace = name_space
                                            self.capability_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "capability-data-length"):
                                            self.capability_data_length = value
                                            self.capability_data_length.value_namespace = name_space
                                            self.capability_data_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix


                                class Received(Entity):
                                    """
                                    List of received capabilities
                                    
                                    .. attribute:: capability_data
                                    
                                    	Capability data
                                    	**type**\:  str
                                    
                                    .. attribute:: capability_data_length
                                    
                                    	Capability data length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: description
                                    
                                    	Capability description
                                    	**type**\:  str
                                    
                                    	**length:** 0..80
                                    
                                    .. attribute:: type
                                    
                                    	Capability type (IANA assigned)
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__init__()

                                        self.yang_name = "received"
                                        self.yang_parent_name = "capabilities"

                                        self.capability_data = YLeaf(YType.str, "capability-data")

                                        self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                        self.description = YLeaf(YType.str, "description")

                                        self.type = YLeaf(YType.uint16, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("capability_data",
                                                        "capability_data_length",
                                                        "description",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.capability_data.is_set or
                                            self.capability_data_length.is_set or
                                            self.description.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.capability_data.yfilter != YFilter.not_set or
                                            self.capability_data_length.yfilter != YFilter.not_set or
                                            self.description.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "received" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data.get_name_leafdata())
                                        if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                        if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.description.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "capability-data"):
                                            self.capability_data = value
                                            self.capability_data.value_namespace = name_space
                                            self.capability_data.value_namespace_prefix = name_space_prefix
                                        if(value_path == "capability-data-length"):
                                            self.capability_data_length = value
                                            self.capability_data_length.value_namespace = name_space
                                            self.capability_data_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "description"):
                                            self.description = value
                                            self.description.value_namespace = name_space
                                            self.description.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.received:
                                        if (c.has_data()):
                                            return True
                                    for c in self.sent:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.received:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.sent:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "capabilities" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "received"):
                                        for c in self.received:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.received.append(c)
                                        return c

                                    if (child_yang_name == "sent"):
                                        for c in self.sent:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sent.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "received" or name == "sent"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Client(Entity):
                                """
                                Targeted Session clients
                                
                                .. attribute:: name
                                
                                	Client's name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__init__()

                                    self.yang_name = "client"
                                    self.yang_parent_name = "detailed-information"

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.name.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "client" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Ipv4DuplicateAddress(Entity):
                                """
                                Duplicate IPv4 address bound to this peer
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress, self).__init__()

                                    self.yang_name = "ipv4-duplicate-address"
                                    self.yang_parent_name = "detailed-information"

                                    self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ipv4-duplicate-address"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-duplicate-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Ipv6DuplicateAddress(Entity):
                                """
                                Duplicate IPv6 address bound to this peer
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress, self).__init__()

                                    self.yang_name = "ipv6-duplicate-address"
                                    self.yang_parent_name = "detailed-information"

                                    self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ipv6-duplicate-address"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-duplicate-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                for c in self.client:
                                    if (c.has_data()):
                                        return True
                                for c in self.ipv4_duplicate_address:
                                    if (c.has_data()):
                                        return True
                                for c in self.ipv6_duplicate_address:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.advertise_bgp_prefixes.is_set or
                                    self.bgp_advertisement_state.is_set or
                                    self.has_ipv4_inbound.is_set or
                                    self.has_ipv4_outbound.is_set or
                                    self.has_ipv6_inbound.is_set or
                                    self.has_ipv6_outbound.is_set or
                                    self.has_sp.is_set or
                                    self.inbound_ipv4acl.is_set or
                                    self.inbound_ipv6acl.is_set or
                                    self.keep_alive_interval.is_set or
                                    self.nsr_last_sync_error.is_set or
                                    self.nsr_last_sync_nack_reason.is_set or
                                    self.nsr_sync_state.is_set or
                                    self.outbound_ipv4acl.is_set or
                                    self.outbound_ipv6acl.is_set or
                                    self.peer_holdtime.is_set or
                                    self.peer_state.is_set or
                                    self.sp_duration.is_set or
                                    self.sp_has_acl.is_set or
                                    self.sp_has_duration.is_set or
                                    self.sp_state.is_set or
                                    self.spacl.is_set or
                                    self.spht_remaining.is_set or
                                    self.spht_running.is_set or
                                    (self.capabilities is not None and self.capabilities.has_data()))

                            def has_operation(self):
                                for c in self.client:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ipv4_duplicate_address:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ipv6_duplicate_address:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.advertise_bgp_prefixes.yfilter != YFilter.not_set or
                                    self.bgp_advertisement_state.yfilter != YFilter.not_set or
                                    self.has_ipv4_inbound.yfilter != YFilter.not_set or
                                    self.has_ipv4_outbound.yfilter != YFilter.not_set or
                                    self.has_ipv6_inbound.yfilter != YFilter.not_set or
                                    self.has_ipv6_outbound.yfilter != YFilter.not_set or
                                    self.has_sp.yfilter != YFilter.not_set or
                                    self.inbound_ipv4acl.yfilter != YFilter.not_set or
                                    self.inbound_ipv6acl.yfilter != YFilter.not_set or
                                    self.keep_alive_interval.yfilter != YFilter.not_set or
                                    self.nsr_last_sync_error.yfilter != YFilter.not_set or
                                    self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set or
                                    self.nsr_sync_state.yfilter != YFilter.not_set or
                                    self.outbound_ipv4acl.yfilter != YFilter.not_set or
                                    self.outbound_ipv6acl.yfilter != YFilter.not_set or
                                    self.peer_holdtime.yfilter != YFilter.not_set or
                                    self.peer_state.yfilter != YFilter.not_set or
                                    self.sp_duration.yfilter != YFilter.not_set or
                                    self.sp_has_acl.yfilter != YFilter.not_set or
                                    self.sp_has_duration.yfilter != YFilter.not_set or
                                    self.sp_state.yfilter != YFilter.not_set or
                                    self.spacl.yfilter != YFilter.not_set or
                                    self.spht_remaining.yfilter != YFilter.not_set or
                                    self.spht_running.yfilter != YFilter.not_set or
                                    (self.capabilities is not None and self.capabilities.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "detailed-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.advertise_bgp_prefixes.is_set or self.advertise_bgp_prefixes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.advertise_bgp_prefixes.get_name_leafdata())
                                if (self.bgp_advertisement_state.is_set or self.bgp_advertisement_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bgp_advertisement_state.get_name_leafdata())
                                if (self.has_ipv4_inbound.is_set or self.has_ipv4_inbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv4_inbound.get_name_leafdata())
                                if (self.has_ipv4_outbound.is_set or self.has_ipv4_outbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv4_outbound.get_name_leafdata())
                                if (self.has_ipv6_inbound.is_set or self.has_ipv6_inbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv6_inbound.get_name_leafdata())
                                if (self.has_ipv6_outbound.is_set or self.has_ipv6_outbound.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ipv6_outbound.get_name_leafdata())
                                if (self.has_sp.is_set or self.has_sp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_sp.get_name_leafdata())
                                if (self.inbound_ipv4acl.is_set or self.inbound_ipv4acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inbound_ipv4acl.get_name_leafdata())
                                if (self.inbound_ipv6acl.is_set or self.inbound_ipv6acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.inbound_ipv6acl.get_name_leafdata())
                                if (self.keep_alive_interval.is_set or self.keep_alive_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_interval.get_name_leafdata())
                                if (self.nsr_last_sync_error.is_set or self.nsr_last_sync_error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_last_sync_error.get_name_leafdata())
                                if (self.nsr_last_sync_nack_reason.is_set or self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_last_sync_nack_reason.get_name_leafdata())
                                if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                if (self.outbound_ipv4acl.is_set or self.outbound_ipv4acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outbound_ipv4acl.get_name_leafdata())
                                if (self.outbound_ipv6acl.is_set or self.outbound_ipv6acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.outbound_ipv6acl.get_name_leafdata())
                                if (self.peer_holdtime.is_set or self.peer_holdtime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_holdtime.get_name_leafdata())
                                if (self.peer_state.is_set or self.peer_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peer_state.get_name_leafdata())
                                if (self.sp_duration.is_set or self.sp_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_duration.get_name_leafdata())
                                if (self.sp_has_acl.is_set or self.sp_has_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_has_acl.get_name_leafdata())
                                if (self.sp_has_duration.is_set or self.sp_has_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_has_duration.get_name_leafdata())
                                if (self.sp_state.is_set or self.sp_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sp_state.get_name_leafdata())
                                if (self.spacl.is_set or self.spacl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spacl.get_name_leafdata())
                                if (self.spht_remaining.is_set or self.spht_remaining.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spht_remaining.get_name_leafdata())
                                if (self.spht_running.is_set or self.spht_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.spht_running.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "capabilities"):
                                    if (self.capabilities is None):
                                        self.capabilities = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                        self.capabilities.parent = self
                                        self._children_name_map["capabilities"] = "capabilities"
                                    return self.capabilities

                                if (child_yang_name == "client"):
                                    for c in self.client:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Client()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.client.append(c)
                                    return c

                                if (child_yang_name == "ipv4-duplicate-address"):
                                    for c in self.ipv4_duplicate_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipv4_duplicate_address.append(c)
                                    return c

                                if (child_yang_name == "ipv6-duplicate-address"):
                                    for c in self.ipv6_duplicate_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ipv6_duplicate_address.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capabilities" or name == "client" or name == "ipv4-duplicate-address" or name == "ipv6-duplicate-address" or name == "advertise-bgp-prefixes" or name == "bgp-advertisement-state" or name == "has-ipv4-inbound" or name == "has-ipv4-outbound" or name == "has-ipv6-inbound" or name == "has-ipv6-outbound" or name == "has-sp" or name == "inbound-ipv4acl" or name == "inbound-ipv6acl" or name == "keep-alive-interval" or name == "nsr-last-sync-error" or name == "nsr-last-sync-nack-reason" or name == "nsr-sync-state" or name == "outbound-ipv4acl" or name == "outbound-ipv6acl" or name == "peer-holdtime" or name == "peer-state" or name == "sp-duration" or name == "sp-has-acl" or name == "sp-has-duration" or name == "sp-state" or name == "spacl" or name == "spht-remaining" or name == "spht-running"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "advertise-bgp-prefixes"):
                                    self.advertise_bgp_prefixes = value
                                    self.advertise_bgp_prefixes.value_namespace = name_space
                                    self.advertise_bgp_prefixes.value_namespace_prefix = name_space_prefix
                                if(value_path == "bgp-advertisement-state"):
                                    self.bgp_advertisement_state = value
                                    self.bgp_advertisement_state.value_namespace = name_space
                                    self.bgp_advertisement_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv4-inbound"):
                                    self.has_ipv4_inbound = value
                                    self.has_ipv4_inbound.value_namespace = name_space
                                    self.has_ipv4_inbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv4-outbound"):
                                    self.has_ipv4_outbound = value
                                    self.has_ipv4_outbound.value_namespace = name_space
                                    self.has_ipv4_outbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv6-inbound"):
                                    self.has_ipv6_inbound = value
                                    self.has_ipv6_inbound.value_namespace = name_space
                                    self.has_ipv6_inbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ipv6-outbound"):
                                    self.has_ipv6_outbound = value
                                    self.has_ipv6_outbound.value_namespace = name_space
                                    self.has_ipv6_outbound.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-sp"):
                                    self.has_sp = value
                                    self.has_sp.value_namespace = name_space
                                    self.has_sp.value_namespace_prefix = name_space_prefix
                                if(value_path == "inbound-ipv4acl"):
                                    self.inbound_ipv4acl = value
                                    self.inbound_ipv4acl.value_namespace = name_space
                                    self.inbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "inbound-ipv6acl"):
                                    self.inbound_ipv6acl = value
                                    self.inbound_ipv6acl.value_namespace = name_space
                                    self.inbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-interval"):
                                    self.keep_alive_interval = value
                                    self.keep_alive_interval.value_namespace = name_space
                                    self.keep_alive_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-last-sync-error"):
                                    self.nsr_last_sync_error = value
                                    self.nsr_last_sync_error.value_namespace = name_space
                                    self.nsr_last_sync_error.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-last-sync-nack-reason"):
                                    self.nsr_last_sync_nack_reason = value
                                    self.nsr_last_sync_nack_reason.value_namespace = name_space
                                    self.nsr_last_sync_nack_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-sync-state"):
                                    self.nsr_sync_state = value
                                    self.nsr_sync_state.value_namespace = name_space
                                    self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "outbound-ipv4acl"):
                                    self.outbound_ipv4acl = value
                                    self.outbound_ipv4acl.value_namespace = name_space
                                    self.outbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "outbound-ipv6acl"):
                                    self.outbound_ipv6acl = value
                                    self.outbound_ipv6acl.value_namespace = name_space
                                    self.outbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-holdtime"):
                                    self.peer_holdtime = value
                                    self.peer_holdtime.value_namespace = name_space
                                    self.peer_holdtime.value_namespace_prefix = name_space_prefix
                                if(value_path == "peer-state"):
                                    self.peer_state = value
                                    self.peer_state.value_namespace = name_space
                                    self.peer_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-duration"):
                                    self.sp_duration = value
                                    self.sp_duration.value_namespace = name_space
                                    self.sp_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-has-acl"):
                                    self.sp_has_acl = value
                                    self.sp_has_acl.value_namespace = name_space
                                    self.sp_has_acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-has-duration"):
                                    self.sp_has_duration = value
                                    self.sp_has_duration.value_namespace = name_space
                                    self.sp_has_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "sp-state"):
                                    self.sp_state = value
                                    self.sp_state.value_namespace = name_space
                                    self.sp_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "spacl"):
                                    self.spacl = value
                                    self.spacl.value_namespace = name_space
                                    self.spacl.value_namespace_prefix = name_space_prefix
                                if(value_path == "spht-remaining"):
                                    self.spht_remaining = value
                                    self.spht_remaining.value_namespace = name_space
                                    self.spht_remaining.value_namespace_prefix = name_space_prefix
                                if(value_path == "spht-running"):
                                    self.spht_running = value
                                    self.spht_running.value_namespace = name_space
                                    self.spht_running.value_namespace_prefix = name_space_prefix


                        class LdpNbrBoundIpv4AddressInfo(Entity):
                            """
                            Neighbor IPv4 Address Info
                            
                            .. attribute:: address
                            
                            	Neighbor Address
                            	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo, self).__init__()

                                self.yang_name = "ldp-nbr-bound-ipv4-address-info"
                                self.yang_parent_name = "neighbor"

                                self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                self.address.parent = self
                                self._children_name_map["address"] = "address"
                                self._children_yang_names.add("address")


                            class Address(Entity):
                                """
                                Neighbor Address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__init__()

                                    self.yang_name = "address"
                                    self.yang_parent_name = "ldp-nbr-bound-ipv4-address-info"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.address is not None and self.address.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.address is not None and self.address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-bound-ipv4-address-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "address"):
                                    if (self.address is None):
                                        self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                    return self.address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrBoundIpv6AddressInfo(Entity):
                            """
                            Neighbor IPv6 Address Info
                            
                            .. attribute:: address
                            
                            	Neighbor Address
                            	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo, self).__init__()

                                self.yang_name = "ldp-nbr-bound-ipv6-address-info"
                                self.yang_parent_name = "neighbor"

                                self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                self.address.parent = self
                                self._children_name_map["address"] = "address"
                                self._children_yang_names.add("address")


                            class Address(Entity):
                                """
                                Neighbor Address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__init__()

                                    self.yang_name = "address"
                                    self.yang_parent_name = "ldp-nbr-bound-ipv6-address-info"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.address is not None and self.address.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.address is not None and self.address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-bound-ipv6-address-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "address"):
                                    if (self.address is None):
                                        self.address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                    return self.address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrIpv4AdjInfo(Entity):
                            """
                            Neighbor's IPv4 Adjacency Information
                            
                            .. attribute:: adjacency_group
                            
                            	Adjacency group
                            	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo, self).__init__()

                                self.yang_name = "ldp-nbr-ipv4-adj-info"
                                self.yang_parent_name = "neighbor"

                                self.adjacency_group = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                self.adjacency_group.parent = self
                                self._children_name_map["adjacency_group"] = "adjacency-group"
                                self._children_yang_names.add("adjacency-group")


                            class AdjacencyGroup(Entity):
                                """
                                Adjacency group
                                
                                .. attribute:: hello_type
                                
                                	HelloType
                                	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                
                                .. attribute:: link_hello_data
                                
                                	Link hello
                                	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData>`
                                
                                .. attribute:: target_hello_data
                                
                                	Target Hello
                                	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__init__()

                                    self.yang_name = "adjacency-group"
                                    self.yang_parent_name = "ldp-nbr-ipv4-adj-info"

                                    self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                    self.link_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                    self.link_hello_data.parent = self
                                    self._children_name_map["link_hello_data"] = "link-hello-data"
                                    self._children_yang_names.add("link-hello-data")

                                    self.target_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                    self.target_hello_data.parent = self
                                    self._children_name_map["target_hello_data"] = "target-hello-data"
                                    self._children_yang_names.add("target-hello-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("hello_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                class LinkHelloData(Entity):
                                    """
                                    Link hello
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                        self.yang_name = "link-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface",
                                                        "interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface.is_set or
                                            self.interface_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix


                                class TargetHelloData(Entity):
                                    """
                                    Target Hello
                                    
                                    .. attribute:: local_address
                                    
                                    	Local Address
                                    	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	Target Address
                                    	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                        self.yang_name = "target-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.local_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                        self.local_address.parent = self
                                        self._children_name_map["local_address"] = "local-address"
                                        self._children_yang_names.add("local-address")

                                        self.target_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                        self.target_address.parent = self
                                        self._children_name_map["target_address"] = "target-address"
                                        self._children_yang_names.add("target-address")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                    class LocalAddress(Entity):
                                        """
                                        Local Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                            self.yang_name = "local-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class TargetAddress(Entity):
                                        """
                                        Target Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                            self.yang_name = "target-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.state.is_set or
                                            (self.local_address is not None and self.local_address.has_data()) or
                                            (self.target_address is not None and self.target_address.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            (self.local_address is not None and self.local_address.has_operation()) or
                                            (self.target_address is not None and self.target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "target-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "local-address"):
                                            if (self.local_address is None):
                                                self.local_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                self.local_address.parent = self
                                                self._children_name_map["local_address"] = "local-address"
                                            return self.local_address

                                        if (child_yang_name == "target-address"):
                                            if (self.target_address is None):
                                                self.target_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                self.target_address.parent = self
                                                self._children_name_map["target_address"] = "target-address"
                                            return self.target_address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-address" or name == "target-address" or name == "state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.hello_type.is_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.hello_type.yfilter != YFilter.not_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "adjacency-group" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-data"):
                                        if (self.link_hello_data is None):
                                            self.link_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                            self.link_hello_data.parent = self
                                            self._children_name_map["link_hello_data"] = "link-hello-data"
                                        return self.link_hello_data

                                    if (child_yang_name == "target-hello-data"):
                                        if (self.target_hello_data is None):
                                            self.target_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                            self.target_hello_data.parent = self
                                            self._children_name_map["target_hello_data"] = "target-hello-data"
                                        return self.target_hello_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "hello-type"):
                                        self.hello_type = value
                                        self.hello_type.value_namespace = name_space
                                        self.hello_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.adjacency_group is not None and self.adjacency_group.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-ipv4-adj-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "adjacency-group"):
                                    if (self.adjacency_group is None):
                                        self.adjacency_group = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                        self.adjacency_group.parent = self
                                        self._children_name_map["adjacency_group"] = "adjacency-group"
                                    return self.adjacency_group

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "adjacency-group"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class LdpNbrIpv6AdjInfo(Entity):
                            """
                            Neighbor's IPv6 Adjacency Information
                            
                            .. attribute:: adjacency_group
                            
                            	Adjacency group
                            	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo, self).__init__()

                                self.yang_name = "ldp-nbr-ipv6-adj-info"
                                self.yang_parent_name = "neighbor"

                                self.adjacency_group = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                self.adjacency_group.parent = self
                                self._children_name_map["adjacency_group"] = "adjacency-group"
                                self._children_yang_names.add("adjacency-group")


                            class AdjacencyGroup(Entity):
                                """
                                Adjacency group
                                
                                .. attribute:: hello_type
                                
                                	HelloType
                                	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                
                                .. attribute:: link_hello_data
                                
                                	Link hello
                                	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData>`
                                
                                .. attribute:: target_hello_data
                                
                                	Target Hello
                                	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__init__()

                                    self.yang_name = "adjacency-group"
                                    self.yang_parent_name = "ldp-nbr-ipv6-adj-info"

                                    self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                    self.link_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                    self.link_hello_data.parent = self
                                    self._children_name_map["link_hello_data"] = "link-hello-data"
                                    self._children_yang_names.add("link-hello-data")

                                    self.target_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                    self.target_hello_data.parent = self
                                    self._children_name_map["target_hello_data"] = "target-hello-data"
                                    self._children_yang_names.add("target-hello-data")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("hello_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                class LinkHelloData(Entity):
                                    """
                                    Link hello
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                        self.yang_name = "link-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface",
                                                        "interface_name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface.is_set or
                                            self.interface_name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface" or name == "interface-name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix


                                class TargetHelloData(Entity):
                                    """
                                    Target Hello
                                    
                                    .. attribute:: local_address
                                    
                                    	Local Address
                                    	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                    
                                    .. attribute:: state
                                    
                                    	State
                                    	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                    
                                    .. attribute:: target_address
                                    
                                    	Target Address
                                    	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                        self.yang_name = "target-hello-data"
                                        self.yang_parent_name = "adjacency-group"

                                        self.state = YLeaf(YType.enumeration, "state")

                                        self.local_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                        self.local_address.parent = self
                                        self._children_name_map["local_address"] = "local-address"
                                        self._children_yang_names.add("local-address")

                                        self.target_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                        self.target_address.parent = self
                                        self._children_name_map["target_address"] = "target-address"
                                        self._children_yang_names.add("target-address")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("state") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                    class LocalAddress(Entity):
                                        """
                                        Local Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                            self.yang_name = "local-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "local-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class TargetAddress(Entity):
                                        """
                                        Target Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                            self.yang_name = "target-address"
                                            self.yang_parent_name = "target-hello-data"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.state.is_set or
                                            (self.local_address is not None and self.local_address.has_data()) or
                                            (self.target_address is not None and self.target_address.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.state.yfilter != YFilter.not_set or
                                            (self.local_address is not None and self.local_address.has_operation()) or
                                            (self.target_address is not None and self.target_address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "target-hello-data" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.state.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "local-address"):
                                            if (self.local_address is None):
                                                self.local_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                self.local_address.parent = self
                                                self._children_name_map["local_address"] = "local-address"
                                            return self.local_address

                                        if (child_yang_name == "target-address"):
                                            if (self.target_address is None):
                                                self.target_address = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                self.target_address.parent = self
                                                self._children_name_map["target_address"] = "target-address"
                                            return self.target_address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-address" or name == "target-address" or name == "state"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "state"):
                                            self.state = value
                                            self.state.value_namespace = name_space
                                            self.state.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.hello_type.is_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.hello_type.yfilter != YFilter.not_set or
                                        (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                        (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "adjacency-group" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.hello_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "link-hello-data"):
                                        if (self.link_hello_data is None):
                                            self.link_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                            self.link_hello_data.parent = self
                                            self._children_name_map["link_hello_data"] = "link-hello-data"
                                        return self.link_hello_data

                                    if (child_yang_name == "target-hello-data"):
                                        if (self.target_hello_data is None):
                                            self.target_hello_data = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                            self.target_hello_data.parent = self
                                            self._children_name_map["target_hello_data"] = "target-hello-data"
                                        return self.target_hello_data

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "hello-type"):
                                        self.hello_type = value
                                        self.hello_type.value_namespace = name_space
                                        self.hello_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.adjacency_group is not None and self.adjacency_group.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ldp-nbr-ipv6-adj-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "adjacency-group"):
                                    if (self.adjacency_group is None):
                                        self.adjacency_group = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                        self.adjacency_group.parent = self
                                        self._children_name_map["adjacency_group"] = "adjacency-group"
                                    return self.adjacency_group

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "adjacency-group"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            for c in self.ldp_nbr_bound_ipv4_address_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_bound_ipv6_address_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_ipv4_adj_info:
                                if (c.has_data()):
                                    return True
                            for c in self.ldp_nbr_ipv6_adj_info:
                                if (c.has_data()):
                                    return True
                            return (
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                (self.detailed_information is not None and self.detailed_information.has_data()) or
                                (self.protocol_information is not None and self.protocol_information.has_data()) or
                                (self.tcp_information is not None and self.tcp_information.has_data()))

                        def has_operation(self):
                            for c in self.ldp_nbr_bound_ipv4_address_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_bound_ipv6_address_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_ipv4_adj_info:
                                if (c.has_operation()):
                                    return True
                            for c in self.ldp_nbr_ipv6_adj_info:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                (self.detailed_information is not None and self.detailed_information.has_operation()) or
                                (self.protocol_information is not None and self.protocol_information.has_operation()) or
                                (self.tcp_information is not None and self.tcp_information.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "detailed-information"):
                                if (self.detailed_information is None):
                                    self.detailed_information = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.DetailedInformation()
                                    self.detailed_information.parent = self
                                    self._children_name_map["detailed_information"] = "detailed-information"
                                return self.detailed_information

                            if (child_yang_name == "ldp-nbr-bound-ipv4-address-info"):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_bound_ipv4_address_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-bound-ipv6-address-info"):
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_bound_ipv6_address_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-ipv4-adj-info"):
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_ipv4_adj_info.append(c)
                                return c

                            if (child_yang_name == "ldp-nbr-ipv6-adj-info"):
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.ldp_nbr_ipv6_adj_info.append(c)
                                return c

                            if (child_yang_name == "protocol-information"):
                                if (self.protocol_information is None):
                                    self.protocol_information = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.ProtocolInformation()
                                    self.protocol_information.parent = self
                                    self._children_name_map["protocol_information"] = "protocol-information"
                                return self.protocol_information

                            if (child_yang_name == "tcp-information"):
                                if (self.tcp_information is None):
                                    self.tcp_information = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor.TcpInformation()
                                    self.tcp_information.parent = self
                                    self._children_name_map["tcp_information"] = "tcp-information"
                                return self.tcp_information

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "detailed-information" or name == "ldp-nbr-bound-ipv4-address-info" or name == "ldp-nbr-bound-ipv6-address-info" or name == "ldp-nbr-ipv4-adj-info" or name == "ldp-nbr-ipv6-adj-info" or name == "protocol-information" or name == "tcp-information" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.neighbor:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.neighbor:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbors" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "neighbor"):
                            for c in self.neighbor:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.Neighbors.Neighbor()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.neighbor.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "neighbor"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class LdpId(Entity):
                    """
                    Local LDP Id
                    
                    .. attribute:: label_space_id
                    
                    	Label space identifier
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: ldp_id
                    
                    	LDP identifier
                    	**type**\:  str
                    
                    .. attribute:: lsr_id
                    
                    	LSR identifier
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.LdpId, self).__init__()

                        self.yang_name = "ldp-id"
                        self.yang_parent_name = "default-vrf"

                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("label_space_id",
                                        "ldp_id",
                                        "lsr_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.LdpId, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.LdpId, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.label_space_id.is_set or
                            self.ldp_id.is_set or
                            self.lsr_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.label_space_id.yfilter != YFilter.not_set or
                            self.ldp_id.yfilter != YFilter.not_set or
                            self.lsr_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ldp-id" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "label-space-id"):
                            self.label_space_id = value
                            self.label_space_id.value_namespace = name_space
                            self.label_space_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "ldp-id"):
                            self.ldp_id = value
                            self.ldp_id.value_namespace = name_space
                            self.ldp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsr-id"):
                            self.lsr_id = value
                            self.lsr_id.value_namespace = name_space
                            self.lsr_id.value_namespace_prefix = name_space_prefix


                class Statistics(Entity):
                    """
                    The LDP Statistics
                    
                    .. attribute:: statistic
                    
                    	Statistical Information on a particular LDP neighbor
                    	**type**\: list of    :py:class:`Statistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DefaultVrf.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "default-vrf"

                        self.statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DefaultVrf.Statistics, self).__setattr__(name, value)


                    class Statistic(Entity):
                        """
                        Statistical Information on a particular LDP
                        neighbor
                        
                        .. attribute:: iccp_enabled
                        
                        	Is session ICCP enabled?
                        	**type**\:  bool
                        
                        .. attribute:: label_space_id
                        
                        	Label space ID of neighbor
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: lsr_id
                        
                        	LSR ID of neighbor
                        	**type**\: one of the below types:
                        
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        	**type**\:  str
                        
                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                        
                        
                        ----
                        .. attribute:: message_in
                        
                        	Message in count
                        	**type**\:   :py:class:`MessageIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageIn>`
                        
                        .. attribute:: message_out
                        
                        	Message out count
                        	**type**\:   :py:class:`MessageOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageOut>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic, self).__init__()

                            self.yang_name = "statistic"
                            self.yang_parent_name = "statistics"

                            self.iccp_enabled = YLeaf(YType.boolean, "iccp-enabled")

                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                            self.message_in = MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageIn()
                            self.message_in.parent = self
                            self._children_name_map["message_in"] = "message-in"
                            self._children_yang_names.add("message-in")

                            self.message_out = MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageOut()
                            self.message_out.parent = self
                            self._children_name_map["message_out"] = "message-out"
                            self._children_yang_names.add("message-out")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("iccp_enabled",
                                            "label_space_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic, self).__setattr__(name, value)


                        class MessageOut(Entity):
                            """
                            Message out count
                            
                            .. attribute:: address_count
                            
                            	Address message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: address_withdraw_count
                            
                            	Address withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_app_data_count
                            
                            	ICCP RG App Data count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_conn_count
                            
                            	ICCP RG Connect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_disconn_count
                            
                            	ICCP RG Disconnect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_notif_count
                            
                            	ICCP RG Notif count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: init_count
                            
                            	Init message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: keep_alive_count
                            
                            	Keepalive count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_abort_request_count
                            
                            	Label abort request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_map_count
                            
                            	Label map count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_release_count
                            
                            	Label release count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_request_count
                            
                            	Label request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_withdraw_count
                            
                            	Label withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: notification_count
                            
                            	Notification count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_count
                            
                            	Total message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageOut, self).__init__()

                                self.yang_name = "message-out"
                                self.yang_parent_name = "statistic"

                                self.address_count = YLeaf(YType.uint32, "address-count")

                                self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                self.init_count = YLeaf(YType.uint32, "init-count")

                                self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                self.notification_count = YLeaf(YType.uint32, "notification-count")

                                self.total_count = YLeaf(YType.uint32, "total-count")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_count",
                                                "address_withdraw_count",
                                                "iccp_rg_app_data_count",
                                                "iccp_rg_conn_count",
                                                "iccp_rg_disconn_count",
                                                "iccp_rg_notif_count",
                                                "init_count",
                                                "keep_alive_count",
                                                "label_abort_request_count",
                                                "label_map_count",
                                                "label_release_count",
                                                "label_request_count",
                                                "label_withdraw_count",
                                                "notification_count",
                                                "total_count") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_count.is_set or
                                    self.address_withdraw_count.is_set or
                                    self.iccp_rg_app_data_count.is_set or
                                    self.iccp_rg_conn_count.is_set or
                                    self.iccp_rg_disconn_count.is_set or
                                    self.iccp_rg_notif_count.is_set or
                                    self.init_count.is_set or
                                    self.keep_alive_count.is_set or
                                    self.label_abort_request_count.is_set or
                                    self.label_map_count.is_set or
                                    self.label_release_count.is_set or
                                    self.label_request_count.is_set or
                                    self.label_withdraw_count.is_set or
                                    self.notification_count.is_set or
                                    self.total_count.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_count.yfilter != YFilter.not_set or
                                    self.address_withdraw_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                    self.init_count.yfilter != YFilter.not_set or
                                    self.keep_alive_count.yfilter != YFilter.not_set or
                                    self.label_abort_request_count.yfilter != YFilter.not_set or
                                    self.label_map_count.yfilter != YFilter.not_set or
                                    self.label_release_count.yfilter != YFilter.not_set or
                                    self.label_request_count.yfilter != YFilter.not_set or
                                    self.label_withdraw_count.yfilter != YFilter.not_set or
                                    self.notification_count.yfilter != YFilter.not_set or
                                    self.total_count.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "message-out" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_count.get_name_leafdata())
                                if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.init_count.get_name_leafdata())
                                if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.notification_count.get_name_leafdata())
                                if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_count.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-count"):
                                    self.address_count = value
                                    self.address_count.value_namespace = name_space
                                    self.address_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "address-withdraw-count"):
                                    self.address_withdraw_count = value
                                    self.address_withdraw_count.value_namespace = name_space
                                    self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-app-data-count"):
                                    self.iccp_rg_app_data_count = value
                                    self.iccp_rg_app_data_count.value_namespace = name_space
                                    self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-conn-count"):
                                    self.iccp_rg_conn_count = value
                                    self.iccp_rg_conn_count.value_namespace = name_space
                                    self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-disconn-count"):
                                    self.iccp_rg_disconn_count = value
                                    self.iccp_rg_disconn_count.value_namespace = name_space
                                    self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-notif-count"):
                                    self.iccp_rg_notif_count = value
                                    self.iccp_rg_notif_count.value_namespace = name_space
                                    self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "init-count"):
                                    self.init_count = value
                                    self.init_count.value_namespace = name_space
                                    self.init_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-count"):
                                    self.keep_alive_count = value
                                    self.keep_alive_count.value_namespace = name_space
                                    self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-abort-request-count"):
                                    self.label_abort_request_count = value
                                    self.label_abort_request_count.value_namespace = name_space
                                    self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-map-count"):
                                    self.label_map_count = value
                                    self.label_map_count.value_namespace = name_space
                                    self.label_map_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-release-count"):
                                    self.label_release_count = value
                                    self.label_release_count.value_namespace = name_space
                                    self.label_release_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-request-count"):
                                    self.label_request_count = value
                                    self.label_request_count.value_namespace = name_space
                                    self.label_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-withdraw-count"):
                                    self.label_withdraw_count = value
                                    self.label_withdraw_count.value_namespace = name_space
                                    self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "notification-count"):
                                    self.notification_count = value
                                    self.notification_count.value_namespace = name_space
                                    self.notification_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-count"):
                                    self.total_count = value
                                    self.total_count.value_namespace = name_space
                                    self.total_count.value_namespace_prefix = name_space_prefix


                        class MessageIn(Entity):
                            """
                            Message in count
                            
                            .. attribute:: address_count
                            
                            	Address message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: address_withdraw_count
                            
                            	Address withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_app_data_count
                            
                            	ICCP RG App Data count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_conn_count
                            
                            	ICCP RG Connect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_disconn_count
                            
                            	ICCP RG Disconnect count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iccp_rg_notif_count
                            
                            	ICCP RG Notif count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: init_count
                            
                            	Init message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: keep_alive_count
                            
                            	Keepalive count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_abort_request_count
                            
                            	Label abort request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_map_count
                            
                            	Label map count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_release_count
                            
                            	Label release count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_request_count
                            
                            	Label request count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: label_withdraw_count
                            
                            	Label withdraw count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: notification_count
                            
                            	Notification count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_count
                            
                            	Total message count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageIn, self).__init__()

                                self.yang_name = "message-in"
                                self.yang_parent_name = "statistic"

                                self.address_count = YLeaf(YType.uint32, "address-count")

                                self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                self.init_count = YLeaf(YType.uint32, "init-count")

                                self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                self.notification_count = YLeaf(YType.uint32, "notification-count")

                                self.total_count = YLeaf(YType.uint32, "total-count")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_count",
                                                "address_withdraw_count",
                                                "iccp_rg_app_data_count",
                                                "iccp_rg_conn_count",
                                                "iccp_rg_disconn_count",
                                                "iccp_rg_notif_count",
                                                "init_count",
                                                "keep_alive_count",
                                                "label_abort_request_count",
                                                "label_map_count",
                                                "label_release_count",
                                                "label_request_count",
                                                "label_withdraw_count",
                                                "notification_count",
                                                "total_count") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_count.is_set or
                                    self.address_withdraw_count.is_set or
                                    self.iccp_rg_app_data_count.is_set or
                                    self.iccp_rg_conn_count.is_set or
                                    self.iccp_rg_disconn_count.is_set or
                                    self.iccp_rg_notif_count.is_set or
                                    self.init_count.is_set or
                                    self.keep_alive_count.is_set or
                                    self.label_abort_request_count.is_set or
                                    self.label_map_count.is_set or
                                    self.label_release_count.is_set or
                                    self.label_request_count.is_set or
                                    self.label_withdraw_count.is_set or
                                    self.notification_count.is_set or
                                    self.total_count.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_count.yfilter != YFilter.not_set or
                                    self.address_withdraw_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                    self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                    self.init_count.yfilter != YFilter.not_set or
                                    self.keep_alive_count.yfilter != YFilter.not_set or
                                    self.label_abort_request_count.yfilter != YFilter.not_set or
                                    self.label_map_count.yfilter != YFilter.not_set or
                                    self.label_release_count.yfilter != YFilter.not_set or
                                    self.label_request_count.yfilter != YFilter.not_set or
                                    self.label_withdraw_count.yfilter != YFilter.not_set or
                                    self.notification_count.yfilter != YFilter.not_set or
                                    self.total_count.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "message-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_count.get_name_leafdata())
                                if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.init_count.get_name_leafdata())
                                if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.notification_count.get_name_leafdata())
                                if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.total_count.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-count"):
                                    self.address_count = value
                                    self.address_count.value_namespace = name_space
                                    self.address_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "address-withdraw-count"):
                                    self.address_withdraw_count = value
                                    self.address_withdraw_count.value_namespace = name_space
                                    self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-app-data-count"):
                                    self.iccp_rg_app_data_count = value
                                    self.iccp_rg_app_data_count.value_namespace = name_space
                                    self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-conn-count"):
                                    self.iccp_rg_conn_count = value
                                    self.iccp_rg_conn_count.value_namespace = name_space
                                    self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-disconn-count"):
                                    self.iccp_rg_disconn_count = value
                                    self.iccp_rg_disconn_count.value_namespace = name_space
                                    self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "iccp-rg-notif-count"):
                                    self.iccp_rg_notif_count = value
                                    self.iccp_rg_notif_count.value_namespace = name_space
                                    self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "init-count"):
                                    self.init_count = value
                                    self.init_count.value_namespace = name_space
                                    self.init_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "keep-alive-count"):
                                    self.keep_alive_count = value
                                    self.keep_alive_count.value_namespace = name_space
                                    self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-abort-request-count"):
                                    self.label_abort_request_count = value
                                    self.label_abort_request_count.value_namespace = name_space
                                    self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-map-count"):
                                    self.label_map_count = value
                                    self.label_map_count.value_namespace = name_space
                                    self.label_map_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-release-count"):
                                    self.label_release_count = value
                                    self.label_release_count.value_namespace = name_space
                                    self.label_release_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-request-count"):
                                    self.label_request_count = value
                                    self.label_request_count.value_namespace = name_space
                                    self.label_request_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-withdraw-count"):
                                    self.label_withdraw_count = value
                                    self.label_withdraw_count.value_namespace = name_space
                                    self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "notification-count"):
                                    self.notification_count = value
                                    self.notification_count.value_namespace = name_space
                                    self.notification_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "total-count"):
                                    self.total_count = value
                                    self.total_count.value_namespace = name_space
                                    self.total_count.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.iccp_enabled.is_set or
                                self.label_space_id.is_set or
                                self.lsr_id.is_set or
                                (self.message_in is not None and self.message_in.has_data()) or
                                (self.message_out is not None and self.message_out.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.iccp_enabled.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set or
                                (self.message_in is not None and self.message_in.has_operation()) or
                                (self.message_out is not None and self.message_out.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.iccp_enabled.is_set or self.iccp_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.iccp_enabled.get_name_leafdata())
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "message-in"):
                                if (self.message_in is None):
                                    self.message_in = MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageIn()
                                    self.message_in.parent = self
                                    self._children_name_map["message_in"] = "message-in"
                                return self.message_in

                            if (child_yang_name == "message-out"):
                                if (self.message_out is None):
                                    self.message_out = MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic.MessageOut()
                                    self.message_out.parent = self
                                    self._children_name_map["message_out"] = "message-out"
                                return self.message_out

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "message-in" or name == "message-out" or name == "iccp-enabled" or name == "label-space-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "iccp-enabled"):
                                self.iccp_enabled = value
                                self.iccp_enabled.value_namespace = name_space
                                self.iccp_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.statistic:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.statistic:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistic"):
                            for c in self.statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsLdp.Nodes.Node.DefaultVrf.Statistics.Statistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.statistic.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistic"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        (self.afs is not None and self.afs.has_data()) or
                        (self.backoff_parameters is not None and self.backoff_parameters.has_data()) or
                        (self.backoffs is not None and self.backoffs.has_data()) or
                        (self.capabilities is not None and self.capabilities.has_data()) or
                        (self.graceful_restart is not None and self.graceful_restart.has_data()) or
                        (self.issu is not None and self.issu.has_data()) or
                        (self.ldp_id is not None and self.ldp_id.has_data()) or
                        (self.neighbor_briefs is not None and self.neighbor_briefs.has_data()) or
                        (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_data()) or
                        (self.neighbors is not None and self.neighbors.has_data()) or
                        (self.nsr is not None and self.nsr.has_data()) or
                        (self.parameters is not None and self.parameters.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()) or
                        (self.summary is not None and self.summary.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.afs is not None and self.afs.has_operation()) or
                        (self.backoff_parameters is not None and self.backoff_parameters.has_operation()) or
                        (self.backoffs is not None and self.backoffs.has_operation()) or
                        (self.capabilities is not None and self.capabilities.has_operation()) or
                        (self.graceful_restart is not None and self.graceful_restart.has_operation()) or
                        (self.issu is not None and self.issu.has_operation()) or
                        (self.ldp_id is not None and self.ldp_id.has_operation()) or
                        (self.neighbor_briefs is not None and self.neighbor_briefs.has_operation()) or
                        (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_operation()) or
                        (self.neighbors is not None and self.neighbors.has_operation()) or
                        (self.nsr is not None and self.nsr.has_operation()) or
                        (self.parameters is not None and self.parameters.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()) or
                        (self.summary is not None and self.summary.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "default-vrf" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "afs"):
                        if (self.afs is None):
                            self.afs = MplsLdp.Nodes.Node.DefaultVrf.Afs()
                            self.afs.parent = self
                            self._children_name_map["afs"] = "afs"
                        return self.afs

                    if (child_yang_name == "backoff-parameters"):
                        if (self.backoff_parameters is None):
                            self.backoff_parameters = MplsLdp.Nodes.Node.DefaultVrf.BackoffParameters()
                            self.backoff_parameters.parent = self
                            self._children_name_map["backoff_parameters"] = "backoff-parameters"
                        return self.backoff_parameters

                    if (child_yang_name == "backoffs"):
                        if (self.backoffs is None):
                            self.backoffs = MplsLdp.Nodes.Node.DefaultVrf.Backoffs()
                            self.backoffs.parent = self
                            self._children_name_map["backoffs"] = "backoffs"
                        return self.backoffs

                    if (child_yang_name == "capabilities"):
                        if (self.capabilities is None):
                            self.capabilities = MplsLdp.Nodes.Node.DefaultVrf.Capabilities()
                            self.capabilities.parent = self
                            self._children_name_map["capabilities"] = "capabilities"
                        return self.capabilities

                    if (child_yang_name == "graceful-restart"):
                        if (self.graceful_restart is None):
                            self.graceful_restart = MplsLdp.Nodes.Node.DefaultVrf.GracefulRestart()
                            self.graceful_restart.parent = self
                            self._children_name_map["graceful_restart"] = "graceful-restart"
                        return self.graceful_restart

                    if (child_yang_name == "issu"):
                        if (self.issu is None):
                            self.issu = MplsLdp.Nodes.Node.DefaultVrf.Issu()
                            self.issu.parent = self
                            self._children_name_map["issu"] = "issu"
                        return self.issu

                    if (child_yang_name == "ldp-id"):
                        if (self.ldp_id is None):
                            self.ldp_id = MplsLdp.Nodes.Node.DefaultVrf.LdpId()
                            self.ldp_id.parent = self
                            self._children_name_map["ldp_id"] = "ldp-id"
                        return self.ldp_id

                    if (child_yang_name == "neighbor-briefs"):
                        if (self.neighbor_briefs is None):
                            self.neighbor_briefs = MplsLdp.Nodes.Node.DefaultVrf.NeighborBriefs()
                            self.neighbor_briefs.parent = self
                            self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                        return self.neighbor_briefs

                    if (child_yang_name == "neighbor-capabilities"):
                        if (self.neighbor_capabilities is None):
                            self.neighbor_capabilities = MplsLdp.Nodes.Node.DefaultVrf.NeighborCapabilities()
                            self.neighbor_capabilities.parent = self
                            self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                        return self.neighbor_capabilities

                    if (child_yang_name == "neighbors"):
                        if (self.neighbors is None):
                            self.neighbors = MplsLdp.Nodes.Node.DefaultVrf.Neighbors()
                            self.neighbors.parent = self
                            self._children_name_map["neighbors"] = "neighbors"
                        return self.neighbors

                    if (child_yang_name == "nsr"):
                        if (self.nsr is None):
                            self.nsr = MplsLdp.Nodes.Node.DefaultVrf.Nsr()
                            self.nsr.parent = self
                            self._children_name_map["nsr"] = "nsr"
                        return self.nsr

                    if (child_yang_name == "parameters"):
                        if (self.parameters is None):
                            self.parameters = MplsLdp.Nodes.Node.DefaultVrf.Parameters()
                            self.parameters.parent = self
                            self._children_name_map["parameters"] = "parameters"
                        return self.parameters

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsLdp.Nodes.Node.DefaultVrf.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    if (child_yang_name == "summary"):
                        if (self.summary is None):
                            self.summary = MplsLdp.Nodes.Node.DefaultVrf.Summary()
                            self.summary.parent = self
                            self._children_name_map["summary"] = "summary"
                        return self.summary

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "afs" or name == "backoff-parameters" or name == "backoffs" or name == "capabilities" or name == "graceful-restart" or name == "issu" or name == "ldp-id" or name == "neighbor-briefs" or name == "neighbor-capabilities" or name == "neighbors" or name == "nsr" or name == "parameters" or name == "statistics" or name == "summary"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class ForwardingSummaryAll(Entity):
                """
                Summary information regarding LDP forwarding
                setup
                
                .. attribute:: fsht
                
                	Forwarding state hold time registered with LSD
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: intfs
                
                	MPLS forwarding enabled interface count
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: is_lsd_bound
                
                	LDP is connected to LSD server
                	**type**\:  bool
                
                .. attribute:: lbls
                
                	Local label allocated count
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: rws
                
                	Forwarding rewrites summary
                	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws>`
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.ForwardingSummaryAll, self).__init__()

                    self.yang_name = "forwarding-summary-all"
                    self.yang_parent_name = "node"

                    self.fsht = YLeaf(YType.uint16, "fsht")

                    self.intfs = YLeaf(YType.uint16, "intfs")

                    self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                    self.lbls = YLeaf(YType.uint16, "lbls")

                    self.rws = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws()
                    self.rws.parent = self
                    self._children_name_map["rws"] = "rws"
                    self._children_yang_names.add("rws")

                    self.vrf = MplsLdp.Nodes.Node.ForwardingSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("fsht",
                                    "intfs",
                                    "is_lsd_bound",
                                    "lbls") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Nodes.Node.ForwardingSummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Nodes.Node.ForwardingSummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "forwarding-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class Rws(Entity):
                    """
                    Forwarding rewrites summary
                    
                    .. attribute:: nhs
                    
                    	Forwarding rewrites nexthops (paths) summary
                    	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Nhs>`
                    
                    .. attribute:: pfxs
                    
                    	Forwarding rewrites prefix summary
                    	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws, self).__init__()

                        self.yang_name = "rws"
                        self.yang_parent_name = "forwarding-summary-all"

                        self.nhs = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Nhs()
                        self.nhs.parent = self
                        self._children_name_map["nhs"] = "nhs"
                        self._children_yang_names.add("nhs")

                        self.pfxs = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs()
                        self.pfxs.parent = self
                        self._children_name_map["pfxs"] = "pfxs"
                        self._children_yang_names.add("pfxs")


                    class Pfxs(Entity):
                        """
                        Forwarding rewrites prefix summary
                        
                        .. attribute:: ecmp_pfxs
                        
                        	Count of prefixes with ECMP
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: labeled_pfxs_aggr
                        
                        	Labeled prefix count for all paths
                        	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr>`
                        
                        .. attribute:: labeled_pfxs_backup
                        
                        	Labeled prefix count related to backup paths only
                        	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup>`
                        
                        .. attribute:: labeled_pfxs_primary
                        
                        	Labeled prefix count related to primary paths only
                        	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary>`
                        
                        .. attribute:: protected_pfxs
                        
                        	Count of FRR protected prefixes
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: total_pfxs
                        
                        	Total Prefix count
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs, self).__init__()

                            self.yang_name = "pfxs"
                            self.yang_parent_name = "rws"

                            self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                            self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                            self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                            self.labeled_pfxs_aggr = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr()
                            self.labeled_pfxs_aggr.parent = self
                            self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                            self._children_yang_names.add("labeled-pfxs-aggr")

                            self.labeled_pfxs_backup = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup()
                            self.labeled_pfxs_backup.parent = self
                            self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                            self._children_yang_names.add("labeled-pfxs-backup")

                            self.labeled_pfxs_primary = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary()
                            self.labeled_pfxs_primary.parent = self
                            self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                            self._children_yang_names.add("labeled-pfxs-primary")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ecmp_pfxs",
                                            "protected_pfxs",
                                            "total_pfxs") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs, self).__setattr__(name, value)


                        class LabeledPfxsAggr(Entity):
                            """
                            Labeled prefix count for all paths
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                self.yang_name = "labeled-pfxs-aggr"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-aggr" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                        class LabeledPfxsPrimary(Entity):
                            """
                            Labeled prefix count related to primary paths
                            only
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                self.yang_name = "labeled-pfxs-primary"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-primary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                        class LabeledPfxsBackup(Entity):
                            """
                            Labeled prefix count related to backup paths
                            only
                            
                            .. attribute:: labeled_pfxs
                            
                            	Count of labeled prefixes with 1 or more paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: labeled_pfxs_partial
                            
                            	Count of labeled prefixes with some (but not ALL) paths labeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: unlabeled_pfxs
                            
                            	Count of labeled prefixes with ALL paths unlabeled
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                self.yang_name = "labeled-pfxs-backup"
                                self.yang_parent_name = "pfxs"

                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("labeled_pfxs",
                                                "labeled_pfxs_partial",
                                                "unlabeled_pfxs") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.labeled_pfxs.is_set or
                                    self.labeled_pfxs_partial.is_set or
                                    self.unlabeled_pfxs.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "labeled-pfxs-backup" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "labeled-pfxs"):
                                    self.labeled_pfxs = value
                                    self.labeled_pfxs.value_namespace = name_space
                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                if(value_path == "labeled-pfxs-partial"):
                                    self.labeled_pfxs_partial = value
                                    self.labeled_pfxs_partial.value_namespace = name_space
                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                if(value_path == "unlabeled-pfxs"):
                                    self.unlabeled_pfxs = value
                                    self.unlabeled_pfxs.value_namespace = name_space
                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ecmp_pfxs.is_set or
                                self.protected_pfxs.is_set or
                                self.total_pfxs.is_set or
                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ecmp_pfxs.yfilter != YFilter.not_set or
                                self.protected_pfxs.yfilter != YFilter.not_set or
                                self.total_pfxs.yfilter != YFilter.not_set or
                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pfxs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                            if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                            if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "labeled-pfxs-aggr"):
                                if (self.labeled_pfxs_aggr is None):
                                    self.labeled_pfxs_aggr = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsAggr()
                                    self.labeled_pfxs_aggr.parent = self
                                    self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                return self.labeled_pfxs_aggr

                            if (child_yang_name == "labeled-pfxs-backup"):
                                if (self.labeled_pfxs_backup is None):
                                    self.labeled_pfxs_backup = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsBackup()
                                    self.labeled_pfxs_backup.parent = self
                                    self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                return self.labeled_pfxs_backup

                            if (child_yang_name == "labeled-pfxs-primary"):
                                if (self.labeled_pfxs_primary is None):
                                    self.labeled_pfxs_primary = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs.LabeledPfxsPrimary()
                                    self.labeled_pfxs_primary.parent = self
                                    self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                return self.labeled_pfxs_primary

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ecmp-pfxs"):
                                self.ecmp_pfxs = value
                                self.ecmp_pfxs.value_namespace = name_space
                                self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-pfxs"):
                                self.protected_pfxs = value
                                self.protected_pfxs.value_namespace = name_space
                                self.protected_pfxs.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-pfxs"):
                                self.total_pfxs = value
                                self.total_pfxs.value_namespace = name_space
                                self.total_pfxs.value_namespace_prefix = name_space_prefix


                    class Nhs(Entity):
                        """
                        Forwarding rewrites nexthops (paths) summary
                        
                        .. attribute:: backup_paths
                        
                        	Count of non\-primary backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: labeled_backup_paths
                        
                        	Count of labeled backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: labeled_paths
                        
                        	Count of all labeled paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: protected_paths
                        
                        	Count of FRR protected paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remote_backup_paths
                        
                        	Count of non\-primary remote backup paths
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_paths
                        
                        	Total path count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Nhs, self).__init__()

                            self.yang_name = "nhs"
                            self.yang_parent_name = "rws"

                            self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                            self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                            self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                            self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                            self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                            self.total_paths = YLeaf(YType.uint32, "total-paths")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_paths",
                                            "labeled_backup_paths",
                                            "labeled_paths",
                                            "protected_paths",
                                            "remote_backup_paths",
                                            "total_paths") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Nhs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Nhs, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backup_paths.is_set or
                                self.labeled_backup_paths.is_set or
                                self.labeled_paths.is_set or
                                self.protected_paths.is_set or
                                self.remote_backup_paths.is_set or
                                self.total_paths.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_paths.yfilter != YFilter.not_set or
                                self.labeled_backup_paths.yfilter != YFilter.not_set or
                                self.labeled_paths.yfilter != YFilter.not_set or
                                self.protected_paths.yfilter != YFilter.not_set or
                                self.remote_backup_paths.yfilter != YFilter.not_set or
                                self.total_paths.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nhs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_paths.get_name_leafdata())
                            if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                            if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                            if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_paths.get_name_leafdata())
                            if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                            if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.total_paths.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-paths"):
                                self.backup_paths = value
                                self.backup_paths.value_namespace = name_space
                                self.backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "labeled-backup-paths"):
                                self.labeled_backup_paths = value
                                self.labeled_backup_paths.value_namespace = name_space
                                self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "labeled-paths"):
                                self.labeled_paths = value
                                self.labeled_paths.value_namespace = name_space
                                self.labeled_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-paths"):
                                self.protected_paths = value
                                self.protected_paths.value_namespace = name_space
                                self.protected_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-backup-paths"):
                                self.remote_backup_paths = value
                                self.remote_backup_paths.value_namespace = name_space
                                self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                            if(value_path == "total-paths"):
                                self.total_paths = value
                                self.total_paths.value_namespace = name_space
                                self.total_paths.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.nhs is not None and self.nhs.has_data()) or
                            (self.pfxs is not None and self.pfxs.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.nhs is not None and self.nhs.has_operation()) or
                            (self.pfxs is not None and self.pfxs.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "rws" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "nhs"):
                            if (self.nhs is None):
                                self.nhs = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Nhs()
                                self.nhs.parent = self
                                self._children_name_map["nhs"] = "nhs"
                            return self.nhs

                        if (child_yang_name == "pfxs"):
                            if (self.pfxs is None):
                                self.pfxs = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws.Pfxs()
                                self.pfxs.parent = self
                                self._children_name_map["pfxs"] = "pfxs"
                            return self.pfxs

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nhs" or name == "pfxs"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.fsht.is_set or
                        self.intfs.is_set or
                        self.is_lsd_bound.is_set or
                        self.lbls.is_set or
                        (self.rws is not None and self.rws.has_data()) or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.fsht.yfilter != YFilter.not_set or
                        self.intfs.yfilter != YFilter.not_set or
                        self.is_lsd_bound.yfilter != YFilter.not_set or
                        self.lbls.yfilter != YFilter.not_set or
                        (self.rws is not None and self.rws.has_operation()) or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "forwarding-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.fsht.get_name_leafdata())
                    if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.intfs.get_name_leafdata())
                    if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                    if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lbls.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "rws"):
                        if (self.rws is None):
                            self.rws = MplsLdp.Nodes.Node.ForwardingSummaryAll.Rws()
                            self.rws.parent = self
                            self._children_name_map["rws"] = "rws"
                        return self.rws

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Nodes.Node.ForwardingSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "fsht"):
                        self.fsht = value
                        self.fsht.value_namespace = name_space
                        self.fsht.value_namespace_prefix = name_space_prefix
                    if(value_path == "intfs"):
                        self.intfs = value
                        self.intfs.value_namespace = name_space
                        self.intfs.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-lsd-bound"):
                        self.is_lsd_bound = value
                        self.is_lsd_bound.value_namespace = name_space
                        self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                    if(value_path == "lbls"):
                        self.lbls = value
                        self.lbls.value_namespace = name_space
                        self.lbls.value_namespace_prefix = name_space_prefix


            class BindingsSummaryAll(Entity):
                """
                Aggregate VRF counters for the LDP Label
                Infomation Base (LIB)
                
                .. attribute:: address_family
                
                	Address Family
                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                
                .. attribute:: bind_af
                
                	bind af
                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.BindingsSummaryAll.BindAf>`
                
                .. attribute:: binding_local_explicit_null
                
                	Number of local explicit null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_implicit_null
                
                	Number of local implicit null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_no_route
                
                	Local bindings with no route
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_non_null
                
                	Number of local non\-null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_null
                
                	Number of local null bindings
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_local_oor
                
                	Number of local bindings        needing label \- OOR
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_no_route
                
                	Bindings with no route
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: highest_allocated_label
                
                	Highest allocated label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lowest_allocated_label
                
                	Lowest allocated label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.BindingsSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.BindingsSummaryAll, self).__init__()

                    self.yang_name = "bindings-summary-all"
                    self.yang_parent_name = "node"

                    self.address_family = YLeaf(YType.enumeration, "address-family")

                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                    self.vrf = MplsLdp.Nodes.Node.BindingsSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                    self.bind_af = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("address_family",
                                    "binding_local_explicit_null",
                                    "binding_local_implicit_null",
                                    "binding_local_no_route",
                                    "binding_local_non_null",
                                    "binding_local_null",
                                    "binding_local_oor",
                                    "binding_no_route",
                                    "highest_allocated_label",
                                    "lowest_allocated_label") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Nodes.Node.BindingsSummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Nodes.Node.BindingsSummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.BindingsSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "bindings-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class BindAf(Entity):
                    """
                    bind af
                    
                    .. attribute:: address_family
                    
                    	Binding Summary Address Family
                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                    
                    .. attribute:: binding_local
                    
                    	Number of local bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: binding_remote
                    
                    	Number of remote bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: binding_total
                    
                    	Total bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: last_lib_update
                    
                    	Last update to LIB local binding
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lib_minimum_revision_sent_all
                    
                    	Last update sent to all peers
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.BindingsSummaryAll.BindAf, self).__init__()

                        self.yang_name = "bind-af"
                        self.yang_parent_name = "bindings-summary-all"

                        self.address_family = YLeaf(YType.enumeration, "address-family")

                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_family",
                                        "binding_local",
                                        "binding_remote",
                                        "binding_total",
                                        "last_lib_update",
                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_family.is_set or
                            self.binding_local.is_set or
                            self.binding_remote.is_set or
                            self.binding_total.is_set or
                            self.last_lib_update.is_set or
                            self.lib_minimum_revision_sent_all.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_family.yfilter != YFilter.not_set or
                            self.binding_local.yfilter != YFilter.not_set or
                            self.binding_remote.yfilter != YFilter.not_set or
                            self.binding_total.yfilter != YFilter.not_set or
                            self.last_lib_update.yfilter != YFilter.not_set or
                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bind-af" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_family.get_name_leafdata())
                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-family"):
                            self.address_family = value
                            self.address_family.value_namespace = name_space
                            self.address_family.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-local"):
                            self.binding_local = value
                            self.binding_local.value_namespace = name_space
                            self.binding_local.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-remote"):
                            self.binding_remote = value
                            self.binding_remote.value_namespace = name_space
                            self.binding_remote.value_namespace_prefix = name_space_prefix
                        if(value_path == "binding-total"):
                            self.binding_total = value
                            self.binding_total.value_namespace = name_space
                            self.binding_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-lib-update"):
                            self.last_lib_update = value
                            self.last_lib_update.value_namespace = name_space
                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                        if(value_path == "lib-minimum-revision-sent-all"):
                            self.lib_minimum_revision_sent_all = value
                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.bind_af:
                        if (c.has_data()):
                            return True
                    return (
                        self.address_family.is_set or
                        self.binding_local_explicit_null.is_set or
                        self.binding_local_implicit_null.is_set or
                        self.binding_local_no_route.is_set or
                        self.binding_local_non_null.is_set or
                        self.binding_local_null.is_set or
                        self.binding_local_oor.is_set or
                        self.binding_no_route.is_set or
                        self.highest_allocated_label.is_set or
                        self.lowest_allocated_label.is_set or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    for c in self.bind_af:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.address_family.yfilter != YFilter.not_set or
                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                        self.binding_local_no_route.yfilter != YFilter.not_set or
                        self.binding_local_non_null.yfilter != YFilter.not_set or
                        self.binding_local_null.yfilter != YFilter.not_set or
                        self.binding_local_oor.yfilter != YFilter.not_set or
                        self.binding_no_route.yfilter != YFilter.not_set or
                        self.highest_allocated_label.yfilter != YFilter.not_set or
                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bindings-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.address_family.get_name_leafdata())
                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "bind-af"):
                        for c in self.bind_af:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Nodes.Node.BindingsSummaryAll.BindAf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.bind_af.append(c)
                        return c

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Nodes.Node.BindingsSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "address-family"):
                        self.address_family = value
                        self.address_family.value_namespace = name_space
                        self.address_family.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-explicit-null"):
                        self.binding_local_explicit_null = value
                        self.binding_local_explicit_null.value_namespace = name_space
                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-implicit-null"):
                        self.binding_local_implicit_null = value
                        self.binding_local_implicit_null.value_namespace = name_space
                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-no-route"):
                        self.binding_local_no_route = value
                        self.binding_local_no_route.value_namespace = name_space
                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-non-null"):
                        self.binding_local_non_null = value
                        self.binding_local_non_null.value_namespace = name_space
                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-null"):
                        self.binding_local_null = value
                        self.binding_local_null.value_namespace = name_space
                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-local-oor"):
                        self.binding_local_oor = value
                        self.binding_local_oor.value_namespace = name_space
                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-no-route"):
                        self.binding_no_route = value
                        self.binding_no_route.value_namespace = name_space
                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "highest-allocated-label"):
                        self.highest_allocated_label = value
                        self.highest_allocated_label.value_namespace = name_space
                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lowest-allocated-label"):
                        self.lowest_allocated_label = value
                        self.lowest_allocated_label.value_namespace = name_space
                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


            class AtoMdbTableEntries(Entity):
                """
                AToM DB Table
                
                .. attribute:: ato_mdb_table_entry
                
                	Entries in AToM DB
                	**type**\: list of    :py:class:`AtoMdbTableEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries, self).__init__()

                    self.yang_name = "ato-mdb-table-entries"
                    self.yang_parent_name = "node"

                    self.ato_mdb_table_entry = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries, self).__setattr__(name, value)


                class AtoMdbTableEntry(Entity):
                    """
                    Entries in AToM DB
                    
                    .. attribute:: agi
                    
                    	AGI
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: agi_type
                    
                    	AGI Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: fe_ctype
                    
                    	FEC Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: fec_info
                    
                    	Pseudowire FEC information
                    	**type**\:   :py:class:`FecInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo>`
                    
                    .. attribute:: mapping_tlv_count
                    
                    	TLV Count from Label Mapping Message
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: notification_tlv_count
                    
                    	TLV Count from Notification Message
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: peer_id
                    
                    	Peer ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: peer_id_xr
                    
                    	Peer ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: pw_id
                    
                    	PW ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_ac_id
                    
                    	SAII AC ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_global_id
                    
                    	SAII Global ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: saii_local_id
                    
                    	SAII Local ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: saii_prefix
                    
                    	SAII Prefix
                    	**type**\:  str
                    
                    	**pattern:** [0\-9a\-fA\-F]{1,8}
                    
                    .. attribute:: saii_type
                    
                    	SAII Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_ac_id
                    
                    	TAII AC ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_global_id
                    
                    	TAII Global ID
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: taii_local_id
                    
                    	TAII Local ID
                    	**type**\: one of the below types:
                    
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    
                    ----
                    .. attribute:: taii_prefix
                    
                    	TAII Prefix
                    	**type**\:  str
                    
                    	**pattern:** [0\-9a\-fA\-F]{1,8}
                    
                    .. attribute:: taii_type
                    
                    	TAII Type
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry, self).__init__()

                        self.yang_name = "ato-mdb-table-entry"
                        self.yang_parent_name = "ato-mdb-table-entries"

                        self.agi = YLeaf(YType.int32, "agi")

                        self.agi_type = YLeaf(YType.int32, "agi-type")

                        self.fe_ctype = YLeaf(YType.int32, "fe-ctype")

                        self.mapping_tlv_count = YLeaf(YType.uint32, "mapping-tlv-count")

                        self.notification_tlv_count = YLeaf(YType.uint32, "notification-tlv-count")

                        self.peer_id = YLeaf(YType.str, "peer-id")

                        self.peer_id_xr = YLeaf(YType.str, "peer-id-xr")

                        self.pw_id = YLeaf(YType.int32, "pw-id")

                        self.saii_ac_id = YLeaf(YType.int32, "saii-ac-id")

                        self.saii_global_id = YLeaf(YType.int32, "saii-global-id")

                        self.saii_local_id = YLeaf(YType.str, "saii-local-id")

                        self.saii_prefix = YLeaf(YType.str, "saii-prefix")

                        self.saii_type = YLeaf(YType.int32, "saii-type")

                        self.taii_ac_id = YLeaf(YType.int32, "taii-ac-id")

                        self.taii_global_id = YLeaf(YType.int32, "taii-global-id")

                        self.taii_local_id = YLeaf(YType.str, "taii-local-id")

                        self.taii_prefix = YLeaf(YType.str, "taii-prefix")

                        self.taii_type = YLeaf(YType.int32, "taii-type")

                        self.fec_info = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo()
                        self.fec_info.parent = self
                        self._children_name_map["fec_info"] = "fec-info"
                        self._children_yang_names.add("fec-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("agi",
                                        "agi_type",
                                        "fe_ctype",
                                        "mapping_tlv_count",
                                        "notification_tlv_count",
                                        "peer_id",
                                        "peer_id_xr",
                                        "pw_id",
                                        "saii_ac_id",
                                        "saii_global_id",
                                        "saii_local_id",
                                        "saii_prefix",
                                        "saii_type",
                                        "taii_ac_id",
                                        "taii_global_id",
                                        "taii_local_id",
                                        "taii_prefix",
                                        "taii_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry, self).__setattr__(name, value)


                    class FecInfo(Entity):
                        """
                        Pseudowire FEC information
                        
                        .. attribute:: fe_ctype
                        
                        	FECType
                        	**type**\:   :py:class:`L2VpnLdpPwFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwFec>`
                        
                        .. attribute:: fec128
                        
                        	fec128
                        	**type**\:   :py:class:`Fec128 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128>`
                        
                        .. attribute:: fec129
                        
                        	fec129
                        	**type**\:   :py:class:`Fec129 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129>`
                        
                        .. attribute:: fec130
                        
                        	fec130
                        	**type**\:   :py:class:`Fec130 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__init__()

                            self.yang_name = "fec-info"
                            self.yang_parent_name = "ato-mdb-table-entry"

                            self.fe_ctype = YLeaf(YType.enumeration, "fe-ctype")

                            self.fec128 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128()
                            self.fec128.parent = self
                            self._children_name_map["fec128"] = "fec128"
                            self._children_yang_names.add("fec128")

                            self.fec129 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129()
                            self.fec129.parent = self
                            self._children_name_map["fec129"] = "fec129"
                            self._children_yang_names.add("fec129")

                            self.fec130 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130()
                            self.fec130.parent = self
                            self._children_name_map["fec130"] = "fec130"
                            self._children_yang_names.add("fec130")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fe_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo, self).__setattr__(name, value)


                        class Fec128(Entity):
                            """
                            fec128
                            
                            .. attribute:: pseudowire_id
                            
                            	Pseudowire ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__init__()

                                self.yang_name = "fec128"
                                self.yang_parent_name = "fec-info"

                                self.pseudowire_id = YLeaf(YType.uint32, "pseudowire-id")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("pseudowire_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128, self).__setattr__(name, value)

                            def has_data(self):
                                return self.pseudowire_id.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.pseudowire_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec128" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.pseudowire_id.is_set or self.pseudowire_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pseudowire_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "pseudowire-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "pseudowire-id"):
                                    self.pseudowire_id = value
                                    self.pseudowire_id.value_namespace = name_space
                                    self.pseudowire_id.value_namespace_prefix = name_space_prefix


                        class Fec129(Entity):
                            """
                            fec129
                            
                            .. attribute:: agi
                            
                            	AGI
                            	**type**\:   :py:class:`Agi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi>`
                            
                            .. attribute:: saii
                            
                            	Source Attachment Individual Identifier
                            	**type**\:   :py:class:`Saii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii>`
                            
                            .. attribute:: taii
                            
                            	Target Attachment Individual Identifier
                            	**type**\:   :py:class:`Taii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129, self).__init__()

                                self.yang_name = "fec129"
                                self.yang_parent_name = "fec-info"

                                self.agi = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi()
                                self.agi.parent = self
                                self._children_name_map["agi"] = "agi"
                                self._children_yang_names.add("agi")

                                self.saii = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii()
                                self.saii.parent = self
                                self._children_name_map["saii"] = "saii"
                                self._children_yang_names.add("saii")

                                self.taii = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii()
                                self.taii.parent = self
                                self._children_name_map["taii"] = "taii"
                                self._children_yang_names.add("taii")


                            class Agi(Entity):
                                """
                                AGI
                                
                                .. attribute:: agi1
                                
                                	agi1
                                	**type**\:   :py:class:`Agi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1>`
                                
                                .. attribute:: agi_type
                                
                                	AGIType
                                	**type**\:   :py:class:`L2VpnLdpPwAgi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAgi>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__init__()

                                    self.yang_name = "agi"
                                    self.yang_parent_name = "fec129"

                                    self.agi_type = YLeaf(YType.enumeration, "agi-type")

                                    self.agi1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1()
                                    self.agi1.parent = self
                                    self._children_name_map["agi1"] = "agi1"
                                    self._children_yang_names.add("agi1")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("agi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi, self).__setattr__(name, value)


                                class Agi1(Entity):
                                    """
                                    agi1
                                    
                                    .. attribute:: rd
                                    
                                    	Route Distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__init__()

                                        self.yang_name = "agi1"
                                        self.yang_parent_name = "agi"

                                        self.rd = YLeaf(YType.uint64, "rd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.rd.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "agi1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rd.is_set or self.rd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rd"):
                                            self.rd = value
                                            self.rd.value_namespace = name_space
                                            self.rd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.agi_type.is_set or
                                        (self.agi1 is not None and self.agi1.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.agi_type.yfilter != YFilter.not_set or
                                        (self.agi1 is not None and self.agi1.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "agi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.agi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "agi1"):
                                        if (self.agi1 is None):
                                            self.agi1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi.Agi1()
                                            self.agi1.parent = self
                                            self._children_name_map["agi1"] = "agi1"
                                        return self.agi1

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "agi1" or name == "agi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "agi-type"):
                                        self.agi_type = value
                                        self.agi_type.value_namespace = name_space
                                        self.agi_type.value_namespace_prefix = name_space_prefix


                            class Saii(Entity):
                                """
                                Source Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__init__()

                                    self.yang_name = "saii"
                                    self.yang_parent_name = "fec129"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "saii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "saii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "saii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix


                            class Taii(Entity):
                                """
                                Target Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__init__()

                                    self.yang_name = "taii"
                                    self.yang_parent_name = "fec129"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "taii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "taii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "taii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.agi is not None and self.agi.has_data()) or
                                    (self.saii is not None and self.saii.has_data()) or
                                    (self.taii is not None and self.taii.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.agi is not None and self.agi.has_operation()) or
                                    (self.saii is not None and self.saii.has_operation()) or
                                    (self.taii is not None and self.taii.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec129" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "agi"):
                                    if (self.agi is None):
                                        self.agi = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Agi()
                                        self.agi.parent = self
                                        self._children_name_map["agi"] = "agi"
                                    return self.agi

                                if (child_yang_name == "saii"):
                                    if (self.saii is None):
                                        self.saii = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Saii()
                                        self.saii.parent = self
                                        self._children_name_map["saii"] = "saii"
                                    return self.saii

                                if (child_yang_name == "taii"):
                                    if (self.taii is None):
                                        self.taii = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129.Taii()
                                        self.taii.parent = self
                                        self._children_name_map["taii"] = "taii"
                                    return self.taii

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "agi" or name == "saii" or name == "taii"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class Fec130(Entity):
                            """
                            fec130
                            
                            .. attribute:: agi
                            
                            	AGI
                            	**type**\:   :py:class:`Agi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi>`
                            
                            .. attribute:: saii
                            
                            	Source Attachment Individual Identifier
                            	**type**\:   :py:class:`Saii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130, self).__init__()

                                self.yang_name = "fec130"
                                self.yang_parent_name = "fec-info"

                                self.agi = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi()
                                self.agi.parent = self
                                self._children_name_map["agi"] = "agi"
                                self._children_yang_names.add("agi")

                                self.saii = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii()
                                self.saii.parent = self
                                self._children_name_map["saii"] = "saii"
                                self._children_yang_names.add("saii")


                            class Agi(Entity):
                                """
                                AGI
                                
                                .. attribute:: agi1
                                
                                	agi1
                                	**type**\:   :py:class:`Agi1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1>`
                                
                                .. attribute:: agi_type
                                
                                	AGIType
                                	**type**\:   :py:class:`L2VpnLdpPwAgi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAgi>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__init__()

                                    self.yang_name = "agi"
                                    self.yang_parent_name = "fec130"

                                    self.agi_type = YLeaf(YType.enumeration, "agi-type")

                                    self.agi1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1()
                                    self.agi1.parent = self
                                    self._children_name_map["agi1"] = "agi1"
                                    self._children_yang_names.add("agi1")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("agi_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi, self).__setattr__(name, value)


                                class Agi1(Entity):
                                    """
                                    agi1
                                    
                                    .. attribute:: rd
                                    
                                    	Route Distinguisher
                                    	**type**\:  int
                                    
                                    	**range:** 0..18446744073709551615
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__init__()

                                        self.yang_name = "agi1"
                                        self.yang_parent_name = "agi"

                                        self.rd = YLeaf(YType.uint64, "rd")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("rd") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.rd.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.rd.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "agi1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.rd.is_set or self.rd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rd.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "rd"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "rd"):
                                            self.rd = value
                                            self.rd.value_namespace = name_space
                                            self.rd.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.agi_type.is_set or
                                        (self.agi1 is not None and self.agi1.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.agi_type.yfilter != YFilter.not_set or
                                        (self.agi1 is not None and self.agi1.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "agi" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.agi_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "agi1"):
                                        if (self.agi1 is None):
                                            self.agi1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi.Agi1()
                                            self.agi1.parent = self
                                            self._children_name_map["agi1"] = "agi1"
                                        return self.agi1

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "agi1" or name == "agi-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "agi-type"):
                                        self.agi_type = value
                                        self.agi_type.value_namespace = name_space
                                        self.agi_type.value_namespace_prefix = name_space_prefix


                            class Saii(Entity):
                                """
                                Source Attachment Individual Identifier
                                
                                .. attribute:: aii1
                                
                                	aii1
                                	**type**\:   :py:class:`Aii1 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1>`
                                
                                .. attribute:: aii2
                                
                                	aii2
                                	**type**\:   :py:class:`Aii2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2>`
                                
                                .. attribute:: aii_type
                                
                                	AIIType
                                	**type**\:   :py:class:`L2VpnLdpPwAii <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.L2VpnLdpPwAii>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__init__()

                                    self.yang_name = "saii"
                                    self.yang_parent_name = "fec130"

                                    self.aii_type = YLeaf(YType.enumeration, "aii-type")

                                    self.aii1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1()
                                    self.aii1.parent = self
                                    self._children_name_map["aii1"] = "aii1"
                                    self._children_yang_names.add("aii1")

                                    self.aii2 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2()
                                    self.aii2.parent = self
                                    self._children_name_map["aii2"] = "aii2"
                                    self._children_yang_names.add("aii2")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("aii_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii, self).__setattr__(name, value)


                                class Aii1(Entity):
                                    """
                                    aii1
                                    
                                    .. attribute:: local_id
                                    
                                    	Local Identifier
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__init__()

                                        self.yang_name = "aii1"
                                        self.yang_parent_name = "saii"

                                        self.local_id = YLeaf(YType.str, "local-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.local_id.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii1" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "local-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-id"):
                                            self.local_id = value
                                            self.local_id.value_namespace = name_space
                                            self.local_id.value_namespace_prefix = name_space_prefix


                                class Aii2(Entity):
                                    """
                                    aii2
                                    
                                    .. attribute:: ac_id
                                    
                                    	AC ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: gobal_id
                                    
                                    	Global ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: prefix
                                    
                                    	Prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__init__()

                                        self.yang_name = "aii2"
                                        self.yang_parent_name = "saii"

                                        self.ac_id = YLeaf(YType.uint32, "ac-id")

                                        self.gobal_id = YLeaf(YType.uint32, "gobal-id")

                                        self.prefix = YLeaf(YType.uint32, "prefix")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ac_id",
                                                        "gobal_id",
                                                        "prefix") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ac_id.is_set or
                                            self.gobal_id.is_set or
                                            self.prefix.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ac_id.yfilter != YFilter.not_set or
                                            self.gobal_id.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "aii2" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ac_id.is_set or self.ac_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ac_id.get_name_leafdata())
                                        if (self.gobal_id.is_set or self.gobal_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.gobal_id.get_name_leafdata())
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ac-id" or name == "gobal-id" or name == "prefix"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ac-id"):
                                            self.ac_id = value
                                            self.ac_id.value_namespace = name_space
                                            self.ac_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "gobal-id"):
                                            self.gobal_id = value
                                            self.gobal_id.value_namespace = name_space
                                            self.gobal_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.aii_type.is_set or
                                        (self.aii1 is not None and self.aii1.has_data()) or
                                        (self.aii2 is not None and self.aii2.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.aii_type.yfilter != YFilter.not_set or
                                        (self.aii1 is not None and self.aii1.has_operation()) or
                                        (self.aii2 is not None and self.aii2.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "saii" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.aii_type.is_set or self.aii_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.aii_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "aii1"):
                                        if (self.aii1 is None):
                                            self.aii1 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii1()
                                            self.aii1.parent = self
                                            self._children_name_map["aii1"] = "aii1"
                                        return self.aii1

                                    if (child_yang_name == "aii2"):
                                        if (self.aii2 is None):
                                            self.aii2 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii.Aii2()
                                            self.aii2.parent = self
                                            self._children_name_map["aii2"] = "aii2"
                                        return self.aii2

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "aii1" or name == "aii2" or name == "aii-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "aii-type"):
                                        self.aii_type = value
                                        self.aii_type.value_namespace = name_space
                                        self.aii_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.agi is not None and self.agi.has_data()) or
                                    (self.saii is not None and self.saii.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.agi is not None and self.agi.has_operation()) or
                                    (self.saii is not None and self.saii.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec130" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "agi"):
                                    if (self.agi is None):
                                        self.agi = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Agi()
                                        self.agi.parent = self
                                        self._children_name_map["agi"] = "agi"
                                    return self.agi

                                if (child_yang_name == "saii"):
                                    if (self.saii is None):
                                        self.saii = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130.Saii()
                                        self.saii.parent = self
                                        self._children_name_map["saii"] = "saii"
                                    return self.saii

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "agi" or name == "saii"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.fe_ctype.is_set or
                                (self.fec128 is not None and self.fec128.has_data()) or
                                (self.fec129 is not None and self.fec129.has_data()) or
                                (self.fec130 is not None and self.fec130.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fe_ctype.yfilter != YFilter.not_set or
                                (self.fec128 is not None and self.fec128.has_operation()) or
                                (self.fec129 is not None and self.fec129.has_operation()) or
                                (self.fec130 is not None and self.fec130.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fe_ctype.is_set or self.fe_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fe_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec128"):
                                if (self.fec128 is None):
                                    self.fec128 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec128()
                                    self.fec128.parent = self
                                    self._children_name_map["fec128"] = "fec128"
                                return self.fec128

                            if (child_yang_name == "fec129"):
                                if (self.fec129 is None):
                                    self.fec129 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec129()
                                    self.fec129.parent = self
                                    self._children_name_map["fec129"] = "fec129"
                                return self.fec129

                            if (child_yang_name == "fec130"):
                                if (self.fec130 is None):
                                    self.fec130 = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo.Fec130()
                                    self.fec130.parent = self
                                    self._children_name_map["fec130"] = "fec130"
                                return self.fec130

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec128" or name == "fec129" or name == "fec130" or name == "fe-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fe-ctype"):
                                self.fe_ctype = value
                                self.fe_ctype.value_namespace = name_space
                                self.fe_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.agi.is_set or
                            self.agi_type.is_set or
                            self.fe_ctype.is_set or
                            self.mapping_tlv_count.is_set or
                            self.notification_tlv_count.is_set or
                            self.peer_id.is_set or
                            self.peer_id_xr.is_set or
                            self.pw_id.is_set or
                            self.saii_ac_id.is_set or
                            self.saii_global_id.is_set or
                            self.saii_local_id.is_set or
                            self.saii_prefix.is_set or
                            self.saii_type.is_set or
                            self.taii_ac_id.is_set or
                            self.taii_global_id.is_set or
                            self.taii_local_id.is_set or
                            self.taii_prefix.is_set or
                            self.taii_type.is_set or
                            (self.fec_info is not None and self.fec_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.agi.yfilter != YFilter.not_set or
                            self.agi_type.yfilter != YFilter.not_set or
                            self.fe_ctype.yfilter != YFilter.not_set or
                            self.mapping_tlv_count.yfilter != YFilter.not_set or
                            self.notification_tlv_count.yfilter != YFilter.not_set or
                            self.peer_id.yfilter != YFilter.not_set or
                            self.peer_id_xr.yfilter != YFilter.not_set or
                            self.pw_id.yfilter != YFilter.not_set or
                            self.saii_ac_id.yfilter != YFilter.not_set or
                            self.saii_global_id.yfilter != YFilter.not_set or
                            self.saii_local_id.yfilter != YFilter.not_set or
                            self.saii_prefix.yfilter != YFilter.not_set or
                            self.saii_type.yfilter != YFilter.not_set or
                            self.taii_ac_id.yfilter != YFilter.not_set or
                            self.taii_global_id.yfilter != YFilter.not_set or
                            self.taii_local_id.yfilter != YFilter.not_set or
                            self.taii_prefix.yfilter != YFilter.not_set or
                            self.taii_type.yfilter != YFilter.not_set or
                            (self.fec_info is not None and self.fec_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ato-mdb-table-entry" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.agi.is_set or self.agi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.agi.get_name_leafdata())
                        if (self.agi_type.is_set or self.agi_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.agi_type.get_name_leafdata())
                        if (self.fe_ctype.is_set or self.fe_ctype.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fe_ctype.get_name_leafdata())
                        if (self.mapping_tlv_count.is_set or self.mapping_tlv_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mapping_tlv_count.get_name_leafdata())
                        if (self.notification_tlv_count.is_set or self.notification_tlv_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.notification_tlv_count.get_name_leafdata())
                        if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.peer_id.get_name_leafdata())
                        if (self.peer_id_xr.is_set or self.peer_id_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.peer_id_xr.get_name_leafdata())
                        if (self.pw_id.is_set or self.pw_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pw_id.get_name_leafdata())
                        if (self.saii_ac_id.is_set or self.saii_ac_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_ac_id.get_name_leafdata())
                        if (self.saii_global_id.is_set or self.saii_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_global_id.get_name_leafdata())
                        if (self.saii_local_id.is_set or self.saii_local_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_local_id.get_name_leafdata())
                        if (self.saii_prefix.is_set or self.saii_prefix.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_prefix.get_name_leafdata())
                        if (self.saii_type.is_set or self.saii_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.saii_type.get_name_leafdata())
                        if (self.taii_ac_id.is_set or self.taii_ac_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_ac_id.get_name_leafdata())
                        if (self.taii_global_id.is_set or self.taii_global_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_global_id.get_name_leafdata())
                        if (self.taii_local_id.is_set or self.taii_local_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_local_id.get_name_leafdata())
                        if (self.taii_prefix.is_set or self.taii_prefix.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_prefix.get_name_leafdata())
                        if (self.taii_type.is_set or self.taii_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.taii_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-info"):
                            if (self.fec_info is None):
                                self.fec_info = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry.FecInfo()
                                self.fec_info.parent = self
                                self._children_name_map["fec_info"] = "fec-info"
                            return self.fec_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-info" or name == "agi" or name == "agi-type" or name == "fe-ctype" or name == "mapping-tlv-count" or name == "notification-tlv-count" or name == "peer-id" or name == "peer-id-xr" or name == "pw-id" or name == "saii-ac-id" or name == "saii-global-id" or name == "saii-local-id" or name == "saii-prefix" or name == "saii-type" or name == "taii-ac-id" or name == "taii-global-id" or name == "taii-local-id" or name == "taii-prefix" or name == "taii-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "agi"):
                            self.agi = value
                            self.agi.value_namespace = name_space
                            self.agi.value_namespace_prefix = name_space_prefix
                        if(value_path == "agi-type"):
                            self.agi_type = value
                            self.agi_type.value_namespace = name_space
                            self.agi_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "fe-ctype"):
                            self.fe_ctype = value
                            self.fe_ctype.value_namespace = name_space
                            self.fe_ctype.value_namespace_prefix = name_space_prefix
                        if(value_path == "mapping-tlv-count"):
                            self.mapping_tlv_count = value
                            self.mapping_tlv_count.value_namespace = name_space
                            self.mapping_tlv_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "notification-tlv-count"):
                            self.notification_tlv_count = value
                            self.notification_tlv_count.value_namespace = name_space
                            self.notification_tlv_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "peer-id"):
                            self.peer_id = value
                            self.peer_id.value_namespace = name_space
                            self.peer_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "peer-id-xr"):
                            self.peer_id_xr = value
                            self.peer_id_xr.value_namespace = name_space
                            self.peer_id_xr.value_namespace_prefix = name_space_prefix
                        if(value_path == "pw-id"):
                            self.pw_id = value
                            self.pw_id.value_namespace = name_space
                            self.pw_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-ac-id"):
                            self.saii_ac_id = value
                            self.saii_ac_id.value_namespace = name_space
                            self.saii_ac_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-global-id"):
                            self.saii_global_id = value
                            self.saii_global_id.value_namespace = name_space
                            self.saii_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-local-id"):
                            self.saii_local_id = value
                            self.saii_local_id.value_namespace = name_space
                            self.saii_local_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-prefix"):
                            self.saii_prefix = value
                            self.saii_prefix.value_namespace = name_space
                            self.saii_prefix.value_namespace_prefix = name_space_prefix
                        if(value_path == "saii-type"):
                            self.saii_type = value
                            self.saii_type.value_namespace = name_space
                            self.saii_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-ac-id"):
                            self.taii_ac_id = value
                            self.taii_ac_id.value_namespace = name_space
                            self.taii_ac_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-global-id"):
                            self.taii_global_id = value
                            self.taii_global_id.value_namespace = name_space
                            self.taii_global_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-local-id"):
                            self.taii_local_id = value
                            self.taii_local_id.value_namespace = name_space
                            self.taii_local_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-prefix"):
                            self.taii_prefix = value
                            self.taii_prefix.value_namespace = name_space
                            self.taii_prefix.value_namespace_prefix = name_space_prefix
                        if(value_path == "taii-type"):
                            self.taii_type = value
                            self.taii_type.value_namespace = name_space
                            self.taii_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.ato_mdb_table_entry:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.ato_mdb_table_entry:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "ato-mdb-table-entries" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ato-mdb-table-entry"):
                        for c in self.ato_mdb_table_entry:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Nodes.Node.AtoMdbTableEntries.AtoMdbTableEntry()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.ato_mdb_table_entry.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ato-mdb-table-entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class NsrSummaryAll(Entity):
                """
                Summary information regarding LDP NSR State
                
                .. attribute:: sessions
                
                	Session summary
                	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.NsrSummaryAll.Sessions>`
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.NsrSummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.NsrSummaryAll, self).__init__()

                    self.yang_name = "nsr-summary-all"
                    self.yang_parent_name = "node"

                    self.sessions = MplsLdp.Nodes.Node.NsrSummaryAll.Sessions()
                    self.sessions.parent = self
                    self._children_name_map["sessions"] = "sessions"
                    self._children_yang_names.add("sessions")

                    self.vrf = MplsLdp.Nodes.Node.NsrSummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.NsrSummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "nsr-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.NsrSummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.NsrSummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix


                class Sessions(Entity):
                    """
                    Session summary
                    
                    .. attribute:: nsr_eligible
                    
                    	NSR eligible sessions
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_app_wait
                    
                    	Number of sessions in NSR app\-wait state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_none
                    
                    	Number of sessions in NSR none state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_operational
                    
                    	Number of sessions in NSR operational state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_prepare
                    
                    	Number of sessions in NSR prepare state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_ready
                    
                    	Number of sessions in NSR ready state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_tcp_phase1
                    
                    	Number of sessions in NSR TCP phase 1 state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_tcp_phase2
                    
                    	Number of sessions in NSR TCP phase 2 state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: nsr_state_wait
                    
                    	Number of sessions in NSR wait state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total
                    
                    	Total sessions
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.NsrSummaryAll.Sessions, self).__init__()

                        self.yang_name = "sessions"
                        self.yang_parent_name = "nsr-summary-all"

                        self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                        self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                        self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                        self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                        self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                        self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                        self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                        self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                        self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                        self.total = YLeaf(YType.uint32, "total")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("nsr_eligible",
                                        "nsr_state_app_wait",
                                        "nsr_state_none",
                                        "nsr_state_operational",
                                        "nsr_state_prepare",
                                        "nsr_state_ready",
                                        "nsr_state_tcp_phase1",
                                        "nsr_state_tcp_phase2",
                                        "nsr_state_wait",
                                        "total") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.NsrSummaryAll.Sessions, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.NsrSummaryAll.Sessions, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.nsr_eligible.is_set or
                            self.nsr_state_app_wait.is_set or
                            self.nsr_state_none.is_set or
                            self.nsr_state_operational.is_set or
                            self.nsr_state_prepare.is_set or
                            self.nsr_state_ready.is_set or
                            self.nsr_state_tcp_phase1.is_set or
                            self.nsr_state_tcp_phase2.is_set or
                            self.nsr_state_wait.is_set or
                            self.total.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.nsr_eligible.yfilter != YFilter.not_set or
                            self.nsr_state_app_wait.yfilter != YFilter.not_set or
                            self.nsr_state_none.yfilter != YFilter.not_set or
                            self.nsr_state_operational.yfilter != YFilter.not_set or
                            self.nsr_state_prepare.yfilter != YFilter.not_set or
                            self.nsr_state_ready.yfilter != YFilter.not_set or
                            self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                            self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                            self.nsr_state_wait.yfilter != YFilter.not_set or
                            self.total.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sessions" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                        if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                        if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                        if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                        if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                        if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                        if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                        if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                        if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                        if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "nsr-eligible"):
                            self.nsr_eligible = value
                            self.nsr_eligible.value_namespace = name_space
                            self.nsr_eligible.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-app-wait"):
                            self.nsr_state_app_wait = value
                            self.nsr_state_app_wait.value_namespace = name_space
                            self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-none"):
                            self.nsr_state_none = value
                            self.nsr_state_none.value_namespace = name_space
                            self.nsr_state_none.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-operational"):
                            self.nsr_state_operational = value
                            self.nsr_state_operational.value_namespace = name_space
                            self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-prepare"):
                            self.nsr_state_prepare = value
                            self.nsr_state_prepare.value_namespace = name_space
                            self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-ready"):
                            self.nsr_state_ready = value
                            self.nsr_state_ready.value_namespace = name_space
                            self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-tcp-phase1"):
                            self.nsr_state_tcp_phase1 = value
                            self.nsr_state_tcp_phase1.value_namespace = name_space
                            self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-tcp-phase2"):
                            self.nsr_state_tcp_phase2 = value
                            self.nsr_state_tcp_phase2.value_namespace = name_space
                            self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                        if(value_path == "nsr-state-wait"):
                            self.nsr_state_wait = value
                            self.nsr_state_wait.value_namespace = name_space
                            self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                        if(value_path == "total"):
                            self.total = value
                            self.total.value_namespace = name_space
                            self.total.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.sessions is not None and self.sessions.has_data()) or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.sessions is not None and self.sessions.has_operation()) or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "nsr-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "sessions"):
                        if (self.sessions is None):
                            self.sessions = MplsLdp.Nodes.Node.NsrSummaryAll.Sessions()
                            self.sessions.parent = self
                            self._children_name_map["sessions"] = "sessions"
                        return self.sessions

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Nodes.Node.NsrSummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "sessions" or name == "vrf"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Summary(Entity):
                """
                LDP summary
                
                .. attribute:: common
                
                	Common Summary information
                	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Summary.Common>`
                
                .. attribute:: is_bound_with_atom
                
                	Bound status with L2VPN ATOM
                	**type**\:  bool
                
                .. attribute:: is_bound_with_interface_manager
                
                	Bound status with Interface Manager
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ip_arm
                
                	Bound status with IP Arm
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ipv4_rib
                
                	Bound status with IPv4 RIB
                	**type**\:  bool
                
                .. attribute:: is_bound_with_ipv6_rib
                
                	Bound status with IPv6 RIB
                	**type**\:  bool
                
                .. attribute:: is_bound_with_lsd
                
                	Bound status with LSD
                	**type**\:  bool
                
                .. attribute:: is_bound_with_nsr_mate
                
                	Bound status with NSR Mate
                	**type**\:  bool
                
                .. attribute:: is_bound_with_rsi
                
                	Bound status with rsi
                	**type**\:  bool
                
                .. attribute:: is_bound_with_sysdb
                
                	Bound status with sysdb
                	**type**\:  bool
                
                .. attribute:: is_mldp_registered
                
                	mLDP registration status
                	**type**\:  bool
                
                .. attribute:: is_nsr_configured
                
                	NSR configured
                	**type**\:  bool
                
                .. attribute:: is_registered_with_interface_manager
                
                	Registration status with Interface Manager
                	**type**\:  bool
                
                .. attribute:: is_registered_with_ipv4_rib
                
                	Registration status with IPv4 RIB
                	**type**\:  bool
                
                .. attribute:: is_registered_with_ipv6_rib
                
                	Registration status with IPv6 RIB
                	**type**\:  bool
                
                .. attribute:: is_registered_with_lsd
                
                	Registration status with LSD
                	**type**\:  bool
                
                .. attribute:: is_registered_with_sysdb
                
                	Registration status with Sysdb
                	**type**\:  bool
                
                .. attribute:: number_of_autocfg_interfaces
                
                	Number of auto\-configured interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_fwd_ref_interfaces
                
                	Number of Forward Referenc interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_interfaces
                
                	Number of known interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_ipv4rib_tables
                
                	Total number of ipv4 RIB tables
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_ipv6rib_tables
                
                	Total number of ipv6 RIB tables
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_registered_ipv4rib_tables
                
                	Number of ipv4 RIB tables registered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_registered_ipv6rib_tables
                
                	Number of ipv6 RIB tables registered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_vrf
                
                	Number of configured VRFs (including default)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: number_of_vrf_oper
                
                	Number of configured operational VRFs (including default)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "node"

                    self.is_bound_with_atom = YLeaf(YType.boolean, "is-bound-with-atom")

                    self.is_bound_with_interface_manager = YLeaf(YType.boolean, "is-bound-with-interface-manager")

                    self.is_bound_with_ip_arm = YLeaf(YType.boolean, "is-bound-with-ip-arm")

                    self.is_bound_with_ipv4_rib = YLeaf(YType.boolean, "is-bound-with-ipv4-rib")

                    self.is_bound_with_ipv6_rib = YLeaf(YType.boolean, "is-bound-with-ipv6-rib")

                    self.is_bound_with_lsd = YLeaf(YType.boolean, "is-bound-with-lsd")

                    self.is_bound_with_nsr_mate = YLeaf(YType.boolean, "is-bound-with-nsr-mate")

                    self.is_bound_with_rsi = YLeaf(YType.boolean, "is-bound-with-rsi")

                    self.is_bound_with_sysdb = YLeaf(YType.boolean, "is-bound-with-sysdb")

                    self.is_mldp_registered = YLeaf(YType.boolean, "is-mldp-registered")

                    self.is_nsr_configured = YLeaf(YType.boolean, "is-nsr-configured")

                    self.is_registered_with_interface_manager = YLeaf(YType.boolean, "is-registered-with-interface-manager")

                    self.is_registered_with_ipv4_rib = YLeaf(YType.boolean, "is-registered-with-ipv4-rib")

                    self.is_registered_with_ipv6_rib = YLeaf(YType.boolean, "is-registered-with-ipv6-rib")

                    self.is_registered_with_lsd = YLeaf(YType.boolean, "is-registered-with-lsd")

                    self.is_registered_with_sysdb = YLeaf(YType.boolean, "is-registered-with-sysdb")

                    self.number_of_autocfg_interfaces = YLeaf(YType.uint32, "number-of-autocfg-interfaces")

                    self.number_of_fwd_ref_interfaces = YLeaf(YType.uint32, "number-of-fwd-ref-interfaces")

                    self.number_of_interfaces = YLeaf(YType.uint32, "number-of-interfaces")

                    self.number_of_ipv4rib_tables = YLeaf(YType.uint32, "number-of-ipv4rib-tables")

                    self.number_of_ipv6rib_tables = YLeaf(YType.uint32, "number-of-ipv6rib-tables")

                    self.number_of_registered_ipv4rib_tables = YLeaf(YType.uint32, "number-of-registered-ipv4rib-tables")

                    self.number_of_registered_ipv6rib_tables = YLeaf(YType.uint32, "number-of-registered-ipv6rib-tables")

                    self.number_of_vrf = YLeaf(YType.uint32, "number-of-vrf")

                    self.number_of_vrf_oper = YLeaf(YType.uint32, "number-of-vrf-oper")

                    self.common = MplsLdp.Nodes.Node.Summary.Common()
                    self.common.parent = self
                    self._children_name_map["common"] = "common"
                    self._children_yang_names.add("common")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_bound_with_atom",
                                    "is_bound_with_interface_manager",
                                    "is_bound_with_ip_arm",
                                    "is_bound_with_ipv4_rib",
                                    "is_bound_with_ipv6_rib",
                                    "is_bound_with_lsd",
                                    "is_bound_with_nsr_mate",
                                    "is_bound_with_rsi",
                                    "is_bound_with_sysdb",
                                    "is_mldp_registered",
                                    "is_nsr_configured",
                                    "is_registered_with_interface_manager",
                                    "is_registered_with_ipv4_rib",
                                    "is_registered_with_ipv6_rib",
                                    "is_registered_with_lsd",
                                    "is_registered_with_sysdb",
                                    "number_of_autocfg_interfaces",
                                    "number_of_fwd_ref_interfaces",
                                    "number_of_interfaces",
                                    "number_of_ipv4rib_tables",
                                    "number_of_ipv6rib_tables",
                                    "number_of_registered_ipv4rib_tables",
                                    "number_of_registered_ipv6rib_tables",
                                    "number_of_vrf",
                                    "number_of_vrf_oper") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Nodes.Node.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Nodes.Node.Summary, self).__setattr__(name, value)


                class Common(Entity):
                    """
                    Common Summary information
                    
                    .. attribute:: address_families
                    
                    	Address Families enabled
                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                    
                    .. attribute:: number_of_bindings_ipv4
                    
                    	Total number of ipv4 bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_bindings_ipv6
                    
                    	Total number of ipv6 bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_downstream_on_demand_neighbors
                    
                    	Number of Downstream\-On\-Demand neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_graceful_restart_neighbors
                    
                    	Number of Graceful Restart neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_hello_adj
                    
                    	Number of LDP discovery IPv4 hello adjacencies
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_local_addresses
                    
                    	Number of IPv4 local addresses
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4_routes
                    
                    	Number of resolved IPv4 routes
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4af
                    
                    	Number of IPv4 address\-families enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv4ldp_interfaces
                    
                    	Number of LDP IPv4 configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_hello_adj
                    
                    	Number of LDP discovery IPv6 hello adjacencies
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_local_addresses
                    
                    	Number of IPv6 local addresses
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6_routes
                    
                    	Number of resolved IPv6 routes
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6af
                    
                    	Number of IPv6 address\-families enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ipv6ldp_interfaces
                    
                    	Number of LDP IPv6 configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_ldp_interfaces
                    
                    	Number of LDP configured interfaces
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_local_bindings_ipv4
                    
                    	Total number of ipv4 local label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_local_bindings_ipv6
                    
                    	Total number of ipv6 local label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_neighbors
                    
                    	Number of neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_nsr_synced_neighbors
                    
                    	Number of NSR\-synced/operational neighbors
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_remote_bindings_ipv4
                    
                    	Total number of ipv4 remote label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: number_of_remote_bindings_ipv6
                    
                    	Total number of ipv6 remote label bindings
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.Summary.Common, self).__init__()

                        self.yang_name = "common"
                        self.yang_parent_name = "summary"

                        self.address_families = YLeaf(YType.enumeration, "address-families")

                        self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                        self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                        self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                        self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                        self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                        self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                        self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                        self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                        self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                        self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                        self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                        self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                        self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                        self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                        self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                        self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                        self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                        self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                        self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                        self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                        self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_families",
                                        "number_of_bindings_ipv4",
                                        "number_of_bindings_ipv6",
                                        "number_of_downstream_on_demand_neighbors",
                                        "number_of_graceful_restart_neighbors",
                                        "number_of_ipv4_hello_adj",
                                        "number_of_ipv4_local_addresses",
                                        "number_of_ipv4_routes",
                                        "number_of_ipv4af",
                                        "number_of_ipv4ldp_interfaces",
                                        "number_of_ipv6_hello_adj",
                                        "number_of_ipv6_local_addresses",
                                        "number_of_ipv6_routes",
                                        "number_of_ipv6af",
                                        "number_of_ipv6ldp_interfaces",
                                        "number_of_ldp_interfaces",
                                        "number_of_local_bindings_ipv4",
                                        "number_of_local_bindings_ipv6",
                                        "number_of_neighbors",
                                        "number_of_nsr_synced_neighbors",
                                        "number_of_remote_bindings_ipv4",
                                        "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.Summary.Common, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.Summary.Common, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_families.is_set or
                            self.number_of_bindings_ipv4.is_set or
                            self.number_of_bindings_ipv6.is_set or
                            self.number_of_downstream_on_demand_neighbors.is_set or
                            self.number_of_graceful_restart_neighbors.is_set or
                            self.number_of_ipv4_hello_adj.is_set or
                            self.number_of_ipv4_local_addresses.is_set or
                            self.number_of_ipv4_routes.is_set or
                            self.number_of_ipv4af.is_set or
                            self.number_of_ipv4ldp_interfaces.is_set or
                            self.number_of_ipv6_hello_adj.is_set or
                            self.number_of_ipv6_local_addresses.is_set or
                            self.number_of_ipv6_routes.is_set or
                            self.number_of_ipv6af.is_set or
                            self.number_of_ipv6ldp_interfaces.is_set or
                            self.number_of_ldp_interfaces.is_set or
                            self.number_of_local_bindings_ipv4.is_set or
                            self.number_of_local_bindings_ipv6.is_set or
                            self.number_of_neighbors.is_set or
                            self.number_of_nsr_synced_neighbors.is_set or
                            self.number_of_remote_bindings_ipv4.is_set or
                            self.number_of_remote_bindings_ipv6.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_families.yfilter != YFilter.not_set or
                            self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                            self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                            self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                            self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                            self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                            self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                            self.number_of_ipv4af.yfilter != YFilter.not_set or
                            self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                            self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                            self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                            self.number_of_ipv6af.yfilter != YFilter.not_set or
                            self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                            self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                            self.number_of_neighbors.yfilter != YFilter.not_set or
                            self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                            self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                            self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "common" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_families.get_name_leafdata())
                        if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                        if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                        if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                        if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                        if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                        if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                        if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                        if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                        if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                        if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                        if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                        if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                        if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                        if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                        if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                        if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                        if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                        if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                        if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-families"):
                            self.address_families = value
                            self.address_families.value_namespace = name_space
                            self.address_families.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-bindings-ipv4"):
                            self.number_of_bindings_ipv4 = value
                            self.number_of_bindings_ipv4.value_namespace = name_space
                            self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-bindings-ipv6"):
                            self.number_of_bindings_ipv6 = value
                            self.number_of_bindings_ipv6.value_namespace = name_space
                            self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-downstream-on-demand-neighbors"):
                            self.number_of_downstream_on_demand_neighbors = value
                            self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                            self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-graceful-restart-neighbors"):
                            self.number_of_graceful_restart_neighbors = value
                            self.number_of_graceful_restart_neighbors.value_namespace = name_space
                            self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-hello-adj"):
                            self.number_of_ipv4_hello_adj = value
                            self.number_of_ipv4_hello_adj.value_namespace = name_space
                            self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-local-addresses"):
                            self.number_of_ipv4_local_addresses = value
                            self.number_of_ipv4_local_addresses.value_namespace = name_space
                            self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4-routes"):
                            self.number_of_ipv4_routes = value
                            self.number_of_ipv4_routes.value_namespace = name_space
                            self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4af"):
                            self.number_of_ipv4af = value
                            self.number_of_ipv4af.value_namespace = name_space
                            self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv4ldp-interfaces"):
                            self.number_of_ipv4ldp_interfaces = value
                            self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                            self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-hello-adj"):
                            self.number_of_ipv6_hello_adj = value
                            self.number_of_ipv6_hello_adj.value_namespace = name_space
                            self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-local-addresses"):
                            self.number_of_ipv6_local_addresses = value
                            self.number_of_ipv6_local_addresses.value_namespace = name_space
                            self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6-routes"):
                            self.number_of_ipv6_routes = value
                            self.number_of_ipv6_routes.value_namespace = name_space
                            self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6af"):
                            self.number_of_ipv6af = value
                            self.number_of_ipv6af.value_namespace = name_space
                            self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ipv6ldp-interfaces"):
                            self.number_of_ipv6ldp_interfaces = value
                            self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                            self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-ldp-interfaces"):
                            self.number_of_ldp_interfaces = value
                            self.number_of_ldp_interfaces.value_namespace = name_space
                            self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-local-bindings-ipv4"):
                            self.number_of_local_bindings_ipv4 = value
                            self.number_of_local_bindings_ipv4.value_namespace = name_space
                            self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-local-bindings-ipv6"):
                            self.number_of_local_bindings_ipv6 = value
                            self.number_of_local_bindings_ipv6.value_namespace = name_space
                            self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-neighbors"):
                            self.number_of_neighbors = value
                            self.number_of_neighbors.value_namespace = name_space
                            self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-nsr-synced-neighbors"):
                            self.number_of_nsr_synced_neighbors = value
                            self.number_of_nsr_synced_neighbors.value_namespace = name_space
                            self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-remote-bindings-ipv4"):
                            self.number_of_remote_bindings_ipv4 = value
                            self.number_of_remote_bindings_ipv4.value_namespace = name_space
                            self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                        if(value_path == "number-of-remote-bindings-ipv6"):
                            self.number_of_remote_bindings_ipv6 = value
                            self.number_of_remote_bindings_ipv6.value_namespace = name_space
                            self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.is_bound_with_atom.is_set or
                        self.is_bound_with_interface_manager.is_set or
                        self.is_bound_with_ip_arm.is_set or
                        self.is_bound_with_ipv4_rib.is_set or
                        self.is_bound_with_ipv6_rib.is_set or
                        self.is_bound_with_lsd.is_set or
                        self.is_bound_with_nsr_mate.is_set or
                        self.is_bound_with_rsi.is_set or
                        self.is_bound_with_sysdb.is_set or
                        self.is_mldp_registered.is_set or
                        self.is_nsr_configured.is_set or
                        self.is_registered_with_interface_manager.is_set or
                        self.is_registered_with_ipv4_rib.is_set or
                        self.is_registered_with_ipv6_rib.is_set or
                        self.is_registered_with_lsd.is_set or
                        self.is_registered_with_sysdb.is_set or
                        self.number_of_autocfg_interfaces.is_set or
                        self.number_of_fwd_ref_interfaces.is_set or
                        self.number_of_interfaces.is_set or
                        self.number_of_ipv4rib_tables.is_set or
                        self.number_of_ipv6rib_tables.is_set or
                        self.number_of_registered_ipv4rib_tables.is_set or
                        self.number_of_registered_ipv6rib_tables.is_set or
                        self.number_of_vrf.is_set or
                        self.number_of_vrf_oper.is_set or
                        (self.common is not None and self.common.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_bound_with_atom.yfilter != YFilter.not_set or
                        self.is_bound_with_interface_manager.yfilter != YFilter.not_set or
                        self.is_bound_with_ip_arm.yfilter != YFilter.not_set or
                        self.is_bound_with_ipv4_rib.yfilter != YFilter.not_set or
                        self.is_bound_with_ipv6_rib.yfilter != YFilter.not_set or
                        self.is_bound_with_lsd.yfilter != YFilter.not_set or
                        self.is_bound_with_nsr_mate.yfilter != YFilter.not_set or
                        self.is_bound_with_rsi.yfilter != YFilter.not_set or
                        self.is_bound_with_sysdb.yfilter != YFilter.not_set or
                        self.is_mldp_registered.yfilter != YFilter.not_set or
                        self.is_nsr_configured.yfilter != YFilter.not_set or
                        self.is_registered_with_interface_manager.yfilter != YFilter.not_set or
                        self.is_registered_with_ipv4_rib.yfilter != YFilter.not_set or
                        self.is_registered_with_ipv6_rib.yfilter != YFilter.not_set or
                        self.is_registered_with_lsd.yfilter != YFilter.not_set or
                        self.is_registered_with_sysdb.yfilter != YFilter.not_set or
                        self.number_of_autocfg_interfaces.yfilter != YFilter.not_set or
                        self.number_of_fwd_ref_interfaces.yfilter != YFilter.not_set or
                        self.number_of_interfaces.yfilter != YFilter.not_set or
                        self.number_of_ipv4rib_tables.yfilter != YFilter.not_set or
                        self.number_of_ipv6rib_tables.yfilter != YFilter.not_set or
                        self.number_of_registered_ipv4rib_tables.yfilter != YFilter.not_set or
                        self.number_of_registered_ipv6rib_tables.yfilter != YFilter.not_set or
                        self.number_of_vrf.yfilter != YFilter.not_set or
                        self.number_of_vrf_oper.yfilter != YFilter.not_set or
                        (self.common is not None and self.common.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_bound_with_atom.is_set or self.is_bound_with_atom.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_atom.get_name_leafdata())
                    if (self.is_bound_with_interface_manager.is_set or self.is_bound_with_interface_manager.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_interface_manager.get_name_leafdata())
                    if (self.is_bound_with_ip_arm.is_set or self.is_bound_with_ip_arm.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ip_arm.get_name_leafdata())
                    if (self.is_bound_with_ipv4_rib.is_set or self.is_bound_with_ipv4_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ipv4_rib.get_name_leafdata())
                    if (self.is_bound_with_ipv6_rib.is_set or self.is_bound_with_ipv6_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_ipv6_rib.get_name_leafdata())
                    if (self.is_bound_with_lsd.is_set or self.is_bound_with_lsd.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_lsd.get_name_leafdata())
                    if (self.is_bound_with_nsr_mate.is_set or self.is_bound_with_nsr_mate.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_nsr_mate.get_name_leafdata())
                    if (self.is_bound_with_rsi.is_set or self.is_bound_with_rsi.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_rsi.get_name_leafdata())
                    if (self.is_bound_with_sysdb.is_set or self.is_bound_with_sysdb.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bound_with_sysdb.get_name_leafdata())
                    if (self.is_mldp_registered.is_set or self.is_mldp_registered.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_mldp_registered.get_name_leafdata())
                    if (self.is_nsr_configured.is_set or self.is_nsr_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_nsr_configured.get_name_leafdata())
                    if (self.is_registered_with_interface_manager.is_set or self.is_registered_with_interface_manager.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_interface_manager.get_name_leafdata())
                    if (self.is_registered_with_ipv4_rib.is_set or self.is_registered_with_ipv4_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_ipv4_rib.get_name_leafdata())
                    if (self.is_registered_with_ipv6_rib.is_set or self.is_registered_with_ipv6_rib.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_ipv6_rib.get_name_leafdata())
                    if (self.is_registered_with_lsd.is_set or self.is_registered_with_lsd.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_lsd.get_name_leafdata())
                    if (self.is_registered_with_sysdb.is_set or self.is_registered_with_sysdb.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_registered_with_sysdb.get_name_leafdata())
                    if (self.number_of_autocfg_interfaces.is_set or self.number_of_autocfg_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_autocfg_interfaces.get_name_leafdata())
                    if (self.number_of_fwd_ref_interfaces.is_set or self.number_of_fwd_ref_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_fwd_ref_interfaces.get_name_leafdata())
                    if (self.number_of_interfaces.is_set or self.number_of_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_interfaces.get_name_leafdata())
                    if (self.number_of_ipv4rib_tables.is_set or self.number_of_ipv4rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_ipv4rib_tables.get_name_leafdata())
                    if (self.number_of_ipv6rib_tables.is_set or self.number_of_ipv6rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_ipv6rib_tables.get_name_leafdata())
                    if (self.number_of_registered_ipv4rib_tables.is_set or self.number_of_registered_ipv4rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_registered_ipv4rib_tables.get_name_leafdata())
                    if (self.number_of_registered_ipv6rib_tables.is_set or self.number_of_registered_ipv6rib_tables.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_registered_ipv6rib_tables.get_name_leafdata())
                    if (self.number_of_vrf.is_set or self.number_of_vrf.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_vrf.get_name_leafdata())
                    if (self.number_of_vrf_oper.is_set or self.number_of_vrf_oper.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.number_of_vrf_oper.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "common"):
                        if (self.common is None):
                            self.common = MplsLdp.Nodes.Node.Summary.Common()
                            self.common.parent = self
                            self._children_name_map["common"] = "common"
                        return self.common

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "common" or name == "is-bound-with-atom" or name == "is-bound-with-interface-manager" or name == "is-bound-with-ip-arm" or name == "is-bound-with-ipv4-rib" or name == "is-bound-with-ipv6-rib" or name == "is-bound-with-lsd" or name == "is-bound-with-nsr-mate" or name == "is-bound-with-rsi" or name == "is-bound-with-sysdb" or name == "is-mldp-registered" or name == "is-nsr-configured" or name == "is-registered-with-interface-manager" or name == "is-registered-with-ipv4-rib" or name == "is-registered-with-ipv6-rib" or name == "is-registered-with-lsd" or name == "is-registered-with-sysdb" or name == "number-of-autocfg-interfaces" or name == "number-of-fwd-ref-interfaces" or name == "number-of-interfaces" or name == "number-of-ipv4rib-tables" or name == "number-of-ipv6rib-tables" or name == "number-of-registered-ipv4rib-tables" or name == "number-of-registered-ipv6rib-tables" or name == "number-of-vrf" or name == "number-of-vrf-oper"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-bound-with-atom"):
                        self.is_bound_with_atom = value
                        self.is_bound_with_atom.value_namespace = name_space
                        self.is_bound_with_atom.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-interface-manager"):
                        self.is_bound_with_interface_manager = value
                        self.is_bound_with_interface_manager.value_namespace = name_space
                        self.is_bound_with_interface_manager.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ip-arm"):
                        self.is_bound_with_ip_arm = value
                        self.is_bound_with_ip_arm.value_namespace = name_space
                        self.is_bound_with_ip_arm.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ipv4-rib"):
                        self.is_bound_with_ipv4_rib = value
                        self.is_bound_with_ipv4_rib.value_namespace = name_space
                        self.is_bound_with_ipv4_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-ipv6-rib"):
                        self.is_bound_with_ipv6_rib = value
                        self.is_bound_with_ipv6_rib.value_namespace = name_space
                        self.is_bound_with_ipv6_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-lsd"):
                        self.is_bound_with_lsd = value
                        self.is_bound_with_lsd.value_namespace = name_space
                        self.is_bound_with_lsd.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-nsr-mate"):
                        self.is_bound_with_nsr_mate = value
                        self.is_bound_with_nsr_mate.value_namespace = name_space
                        self.is_bound_with_nsr_mate.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-rsi"):
                        self.is_bound_with_rsi = value
                        self.is_bound_with_rsi.value_namespace = name_space
                        self.is_bound_with_rsi.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bound-with-sysdb"):
                        self.is_bound_with_sysdb = value
                        self.is_bound_with_sysdb.value_namespace = name_space
                        self.is_bound_with_sysdb.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-mldp-registered"):
                        self.is_mldp_registered = value
                        self.is_mldp_registered.value_namespace = name_space
                        self.is_mldp_registered.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-nsr-configured"):
                        self.is_nsr_configured = value
                        self.is_nsr_configured.value_namespace = name_space
                        self.is_nsr_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-interface-manager"):
                        self.is_registered_with_interface_manager = value
                        self.is_registered_with_interface_manager.value_namespace = name_space
                        self.is_registered_with_interface_manager.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-ipv4-rib"):
                        self.is_registered_with_ipv4_rib = value
                        self.is_registered_with_ipv4_rib.value_namespace = name_space
                        self.is_registered_with_ipv4_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-ipv6-rib"):
                        self.is_registered_with_ipv6_rib = value
                        self.is_registered_with_ipv6_rib.value_namespace = name_space
                        self.is_registered_with_ipv6_rib.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-lsd"):
                        self.is_registered_with_lsd = value
                        self.is_registered_with_lsd.value_namespace = name_space
                        self.is_registered_with_lsd.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-registered-with-sysdb"):
                        self.is_registered_with_sysdb = value
                        self.is_registered_with_sysdb.value_namespace = name_space
                        self.is_registered_with_sysdb.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-autocfg-interfaces"):
                        self.number_of_autocfg_interfaces = value
                        self.number_of_autocfg_interfaces.value_namespace = name_space
                        self.number_of_autocfg_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-fwd-ref-interfaces"):
                        self.number_of_fwd_ref_interfaces = value
                        self.number_of_fwd_ref_interfaces.value_namespace = name_space
                        self.number_of_fwd_ref_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-interfaces"):
                        self.number_of_interfaces = value
                        self.number_of_interfaces.value_namespace = name_space
                        self.number_of_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-ipv4rib-tables"):
                        self.number_of_ipv4rib_tables = value
                        self.number_of_ipv4rib_tables.value_namespace = name_space
                        self.number_of_ipv4rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-ipv6rib-tables"):
                        self.number_of_ipv6rib_tables = value
                        self.number_of_ipv6rib_tables.value_namespace = name_space
                        self.number_of_ipv6rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-registered-ipv4rib-tables"):
                        self.number_of_registered_ipv4rib_tables = value
                        self.number_of_registered_ipv4rib_tables.value_namespace = name_space
                        self.number_of_registered_ipv4rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-registered-ipv6rib-tables"):
                        self.number_of_registered_ipv6rib_tables = value
                        self.number_of_registered_ipv6rib_tables.value_namespace = name_space
                        self.number_of_registered_ipv6rib_tables.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-vrf"):
                        self.number_of_vrf = value
                        self.number_of_vrf.value_namespace = name_space
                        self.number_of_vrf.value_namespace_prefix = name_space_prefix
                    if(value_path == "number-of-vrf-oper"):
                        self.number_of_vrf_oper = value
                        self.number_of_vrf_oper.value_namespace = name_space
                        self.number_of_vrf_oper.value_namespace_prefix = name_space_prefix


            class Vrfs(Entity):
                """
                VRF specific operational data
                
                .. attribute:: vrf
                
                	Operational data for given VRF
                	**type**\: list of    :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.Vrfs, self).__init__()

                    self.yang_name = "vrfs"
                    self.yang_parent_name = "node"

                    self.vrf = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Nodes.Node.Vrfs, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Nodes.Node.Vrfs, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    Operational data for given VRF
                    
                    .. attribute:: vrf_name  <key>
                    
                    	VRF Name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: afs
                    
                    	Address Family specific operational data
                    	**type**\:   :py:class:`Afs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs>`
                    
                    .. attribute:: backoff_parameters
                    
                    	The LDP Backoff Parameters
                    	**type**\:   :py:class:`BackoffParameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.BackoffParameters>`
                    
                    .. attribute:: backoffs
                    
                    	The LDP backoff
                    	**type**\:   :py:class:`Backoffs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs>`
                    
                    .. attribute:: capabilities
                    
                    	LDP capability database information
                    	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities>`
                    
                    .. attribute:: graceful_restart
                    
                    	LDP Graceful Restart info
                    	**type**\:   :py:class:`GracefulRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart>`
                    
                    .. attribute:: issu
                    
                    	LDP ISSU related information
                    	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu>`
                    
                    .. attribute:: ldp_id
                    
                    	Local LDP Id
                    	**type**\:   :py:class:`LdpId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.LdpId>`
                    
                    .. attribute:: neighbor_briefs
                    
                    	The LDP Neighbors (brief)
                    	**type**\:   :py:class:`NeighborBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs>`
                    
                    .. attribute:: neighbor_capabilities
                    
                    	LDP Neighbors Capabilities
                    	**type**\:   :py:class:`NeighborCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities>`
                    
                    .. attribute:: neighbors
                    
                    	The LDP Neighbors
                    	**type**\:   :py:class:`Neighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors>`
                    
                    .. attribute:: nsr
                    
                    	LDP NSR related information
                    	**type**\:   :py:class:`Nsr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr>`
                    
                    .. attribute:: parameters
                    
                    	LDP parameters
                    	**type**\:   :py:class:`Parameters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters>`
                    
                    .. attribute:: statistics
                    
                    	The LDP Statistics
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics>`
                    
                    .. attribute:: summary
                    
                    	LDP VRF summary
                    	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Summary>`
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.Vrfs.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "vrfs"

                        self.vrf_name = YLeaf(YType.str, "vrf-name")

                        self.afs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs()
                        self.afs.parent = self
                        self._children_name_map["afs"] = "afs"
                        self._children_yang_names.add("afs")

                        self.backoff_parameters = MplsLdp.Nodes.Node.Vrfs.Vrf.BackoffParameters()
                        self.backoff_parameters.parent = self
                        self._children_name_map["backoff_parameters"] = "backoff-parameters"
                        self._children_yang_names.add("backoff-parameters")

                        self.backoffs = MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs()
                        self.backoffs.parent = self
                        self._children_name_map["backoffs"] = "backoffs"
                        self._children_yang_names.add("backoffs")

                        self.capabilities = MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities()
                        self.capabilities.parent = self
                        self._children_name_map["capabilities"] = "capabilities"
                        self._children_yang_names.add("capabilities")

                        self.graceful_restart = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart()
                        self.graceful_restart.parent = self
                        self._children_name_map["graceful_restart"] = "graceful-restart"
                        self._children_yang_names.add("graceful-restart")

                        self.issu = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu()
                        self.issu.parent = self
                        self._children_name_map["issu"] = "issu"
                        self._children_yang_names.add("issu")

                        self.ldp_id = MplsLdp.Nodes.Node.Vrfs.Vrf.LdpId()
                        self.ldp_id.parent = self
                        self._children_name_map["ldp_id"] = "ldp-id"
                        self._children_yang_names.add("ldp-id")

                        self.neighbor_briefs = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs()
                        self.neighbor_briefs.parent = self
                        self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                        self._children_yang_names.add("neighbor-briefs")

                        self.neighbor_capabilities = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities()
                        self.neighbor_capabilities.parent = self
                        self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                        self._children_yang_names.add("neighbor-capabilities")

                        self.neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors()
                        self.neighbors.parent = self
                        self._children_name_map["neighbors"] = "neighbors"
                        self._children_yang_names.add("neighbors")

                        self.nsr = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr()
                        self.nsr.parent = self
                        self._children_name_map["nsr"] = "nsr"
                        self._children_yang_names.add("nsr")

                        self.parameters = MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters()
                        self.parameters.parent = self
                        self._children_name_map["parameters"] = "parameters"
                        self._children_yang_names.add("parameters")

                        self.statistics = MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                        self.summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                        self._children_yang_names.add("summary")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("vrf_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf, self).__setattr__(name, value)


                    class GracefulRestart(Entity):
                        """
                        LDP Graceful Restart info
                        
                        .. attribute:: forwarding_state_hold_timer_remaining_seconds
                        
                        	Forwarding state hold timer remaining time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: graceful_restartable_neighbor
                        
                        	Vector of graceful restart neighbor information
                        	**type**\: list of    :py:class:`GracefulRestartableNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor>`
                        
                        .. attribute:: is_forwarding_state_hold_timer_running
                        
                        	Is graceful restart forwarding state hold timer running
                        	**type**\:  bool
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart, self).__init__()

                            self.yang_name = "graceful-restart"
                            self.yang_parent_name = "vrf"

                            self.forwarding_state_hold_timer_remaining_seconds = YLeaf(YType.uint32, "forwarding-state-hold-timer-remaining-seconds")

                            self.is_forwarding_state_hold_timer_running = YLeaf(YType.boolean, "is-forwarding-state-hold-timer-running")

                            self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")

                            self.graceful_restartable_neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("forwarding_state_hold_timer_remaining_seconds",
                                            "is_forwarding_state_hold_timer_running") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart, self).__setattr__(name, value)


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "graceful-restart"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class GracefulRestartableNeighbor(Entity):
                            """
                            Vector of graceful restart neighbor information
                            
                            .. attribute:: connect_count
                            
                            	ConnectCount
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_address
                            
                            	Addresses bound to GR down Nbr
                            	**type**\: list of    :py:class:`DownNbrAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress>`
                            
                            .. attribute:: down_nbr_down_reason
                            
                            	Session down reason code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_flags
                            
                            	Flags
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: down_nbr_flap_count
                            
                            	Count of back2back flaps
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: down_nbr_interface
                            
                            	Interfaces bound to GR down Nbr
                            	**type**\: list of    :py:class:`DownNbrInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface>`
                            
                            .. attribute:: gr_peer
                            
                            	GR peer LDP Id
                            	**type**\:   :py:class:`GrPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer>`
                            
                            .. attribute:: is_liveness_timer_running
                            
                            	Is liveness timer running
                            	**type**\:  bool
                            
                            .. attribute:: is_neighbor_up
                            
                            	Is neighbor up
                            	**type**\:  bool
                            
                            .. attribute:: is_recovery_timer_running
                            
                            	Is recovery timer running
                            	**type**\:  bool
                            
                            .. attribute:: liveness_timer_remaining_seconds
                            
                            	Remaining time from liveness timer
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: recovery_timer_remaining_seconds
                            
                            	Recovery timer remining time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__init__()

                                self.yang_name = "graceful-restartable-neighbor"
                                self.yang_parent_name = "graceful-restart"

                                self.connect_count = YLeaf(YType.uint32, "connect-count")

                                self.down_nbr_down_reason = YLeaf(YType.uint32, "down-nbr-down-reason")

                                self.down_nbr_flags = YLeaf(YType.uint32, "down-nbr-flags")

                                self.down_nbr_flap_count = YLeaf(YType.uint8, "down-nbr-flap-count")

                                self.is_liveness_timer_running = YLeaf(YType.boolean, "is-liveness-timer-running")

                                self.is_neighbor_up = YLeaf(YType.boolean, "is-neighbor-up")

                                self.is_recovery_timer_running = YLeaf(YType.boolean, "is-recovery-timer-running")

                                self.liveness_timer_remaining_seconds = YLeaf(YType.uint32, "liveness-timer-remaining-seconds")

                                self.recovery_timer_remaining_seconds = YLeaf(YType.uint32, "recovery-timer-remaining-seconds")

                                self.gr_peer = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                self.gr_peer.parent = self
                                self._children_name_map["gr_peer"] = "gr-peer"
                                self._children_yang_names.add("gr-peer")

                                self.down_nbr_address = YList(self)
                                self.down_nbr_interface = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("connect_count",
                                                "down_nbr_down_reason",
                                                "down_nbr_flags",
                                                "down_nbr_flap_count",
                                                "is_liveness_timer_running",
                                                "is_neighbor_up",
                                                "is_recovery_timer_running",
                                                "liveness_timer_remaining_seconds",
                                                "recovery_timer_remaining_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor, self).__setattr__(name, value)


                            class GrPeer(Entity):
                                """
                                GR peer LDP Id
                                
                                .. attribute:: label_space_id
                                
                                	Label space identifier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: ldp_id
                                
                                	LDP identifier
                                	**type**\:  str
                                
                                .. attribute:: lsr_id
                                
                                	LSR identifier
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__init__()

                                    self.yang_name = "gr-peer"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                    self.ldp_id = YLeaf(YType.str, "ldp-id")

                                    self.lsr_id = YLeaf(YType.str, "lsr-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_space_id",
                                                    "ldp_id",
                                                    "lsr_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.label_space_id.is_set or
                                        self.ldp_id.is_set or
                                        self.lsr_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_space_id.yfilter != YFilter.not_set or
                                        self.ldp_id.yfilter != YFilter.not_set or
                                        self.lsr_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "gr-peer" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                    if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                    if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-space-id"):
                                        self.label_space_id = value
                                        self.label_space_id.value_namespace = name_space
                                        self.label_space_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-id"):
                                        self.ldp_id = value
                                        self.ldp_id.value_namespace = name_space
                                        self.ldp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsr-id"):
                                        self.lsr_id = value
                                        self.lsr_id.value_namespace = name_space
                                        self.lsr_id.value_namespace_prefix = name_space_prefix


                            class DownNbrInterface(Entity):
                                """
                                Interfaces bound to GR down Nbr
                                
                                .. attribute:: address_family
                                
                                	Interface adj Address Family
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: interface_handle
                                
                                	Interfaces handle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__init__()

                                    self.yang_name = "down-nbr-interface"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.interface_handle = YLeaf(YType.str, "interface-handle")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "interface_handle") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.interface_handle.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.interface_handle.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "down-nbr-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.interface_handle.is_set or self.interface_handle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_handle.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "interface-handle"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-handle"):
                                        self.interface_handle = value
                                        self.interface_handle.value_namespace = name_space
                                        self.interface_handle.value_namespace_prefix = name_space_prefix


                            class DownNbrAddress(Entity):
                                """
                                Addresses bound to GR down Nbr
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__init__()

                                    self.yang_name = "down-nbr-address"
                                    self.yang_parent_name = "graceful-restartable-neighbor"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "down-nbr-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.down_nbr_address:
                                    if (c.has_data()):
                                        return True
                                for c in self.down_nbr_interface:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.connect_count.is_set or
                                    self.down_nbr_down_reason.is_set or
                                    self.down_nbr_flags.is_set or
                                    self.down_nbr_flap_count.is_set or
                                    self.is_liveness_timer_running.is_set or
                                    self.is_neighbor_up.is_set or
                                    self.is_recovery_timer_running.is_set or
                                    self.liveness_timer_remaining_seconds.is_set or
                                    self.recovery_timer_remaining_seconds.is_set or
                                    (self.gr_peer is not None and self.gr_peer.has_data()))

                            def has_operation(self):
                                for c in self.down_nbr_address:
                                    if (c.has_operation()):
                                        return True
                                for c in self.down_nbr_interface:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.connect_count.yfilter != YFilter.not_set or
                                    self.down_nbr_down_reason.yfilter != YFilter.not_set or
                                    self.down_nbr_flags.yfilter != YFilter.not_set or
                                    self.down_nbr_flap_count.yfilter != YFilter.not_set or
                                    self.is_liveness_timer_running.yfilter != YFilter.not_set or
                                    self.is_neighbor_up.yfilter != YFilter.not_set or
                                    self.is_recovery_timer_running.yfilter != YFilter.not_set or
                                    self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set or
                                    self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set or
                                    (self.gr_peer is not None and self.gr_peer.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "graceful-restartable-neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.connect_count.is_set or self.connect_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.connect_count.get_name_leafdata())
                                if (self.down_nbr_down_reason.is_set or self.down_nbr_down_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_down_reason.get_name_leafdata())
                                if (self.down_nbr_flags.is_set or self.down_nbr_flags.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_flags.get_name_leafdata())
                                if (self.down_nbr_flap_count.is_set or self.down_nbr_flap_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.down_nbr_flap_count.get_name_leafdata())
                                if (self.is_liveness_timer_running.is_set or self.is_liveness_timer_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_liveness_timer_running.get_name_leafdata())
                                if (self.is_neighbor_up.is_set or self.is_neighbor_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_neighbor_up.get_name_leafdata())
                                if (self.is_recovery_timer_running.is_set or self.is_recovery_timer_running.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_recovery_timer_running.get_name_leafdata())
                                if (self.liveness_timer_remaining_seconds.is_set or self.liveness_timer_remaining_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.liveness_timer_remaining_seconds.get_name_leafdata())
                                if (self.recovery_timer_remaining_seconds.is_set or self.recovery_timer_remaining_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.recovery_timer_remaining_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "down-nbr-address"):
                                    for c in self.down_nbr_address:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrAddress()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.down_nbr_address.append(c)
                                    return c

                                if (child_yang_name == "down-nbr-interface"):
                                    for c in self.down_nbr_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.DownNbrInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.down_nbr_interface.append(c)
                                    return c

                                if (child_yang_name == "gr-peer"):
                                    if (self.gr_peer is None):
                                        self.gr_peer = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor.GrPeer()
                                        self.gr_peer.parent = self
                                        self._children_name_map["gr_peer"] = "gr-peer"
                                    return self.gr_peer

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "down-nbr-address" or name == "down-nbr-interface" or name == "gr-peer" or name == "connect-count" or name == "down-nbr-down-reason" or name == "down-nbr-flags" or name == "down-nbr-flap-count" or name == "is-liveness-timer-running" or name == "is-neighbor-up" or name == "is-recovery-timer-running" or name == "liveness-timer-remaining-seconds" or name == "recovery-timer-remaining-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "connect-count"):
                                    self.connect_count = value
                                    self.connect_count.value_namespace = name_space
                                    self.connect_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-down-reason"):
                                    self.down_nbr_down_reason = value
                                    self.down_nbr_down_reason.value_namespace = name_space
                                    self.down_nbr_down_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-flags"):
                                    self.down_nbr_flags = value
                                    self.down_nbr_flags.value_namespace = name_space
                                    self.down_nbr_flags.value_namespace_prefix = name_space_prefix
                                if(value_path == "down-nbr-flap-count"):
                                    self.down_nbr_flap_count = value
                                    self.down_nbr_flap_count.value_namespace = name_space
                                    self.down_nbr_flap_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-liveness-timer-running"):
                                    self.is_liveness_timer_running = value
                                    self.is_liveness_timer_running.value_namespace = name_space
                                    self.is_liveness_timer_running.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-neighbor-up"):
                                    self.is_neighbor_up = value
                                    self.is_neighbor_up.value_namespace = name_space
                                    self.is_neighbor_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-recovery-timer-running"):
                                    self.is_recovery_timer_running = value
                                    self.is_recovery_timer_running.value_namespace = name_space
                                    self.is_recovery_timer_running.value_namespace_prefix = name_space_prefix
                                if(value_path == "liveness-timer-remaining-seconds"):
                                    self.liveness_timer_remaining_seconds = value
                                    self.liveness_timer_remaining_seconds.value_namespace = name_space
                                    self.liveness_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                                if(value_path == "recovery-timer-remaining-seconds"):
                                    self.recovery_timer_remaining_seconds = value
                                    self.recovery_timer_remaining_seconds.value_namespace = name_space
                                    self.recovery_timer_remaining_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.graceful_restartable_neighbor:
                                if (c.has_data()):
                                    return True
                            return (
                                self.forwarding_state_hold_timer_remaining_seconds.is_set or
                                self.is_forwarding_state_hold_timer_running.is_set or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            for c in self.graceful_restartable_neighbor:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set or
                                self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "graceful-restart" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.forwarding_state_hold_timer_remaining_seconds.is_set or self.forwarding_state_hold_timer_remaining_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.forwarding_state_hold_timer_remaining_seconds.get_name_leafdata())
                            if (self.is_forwarding_state_hold_timer_running.is_set or self.is_forwarding_state_hold_timer_running.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_forwarding_state_hold_timer_running.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "graceful-restartable-neighbor"):
                                for c in self.graceful_restartable_neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.GracefulRestartableNeighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.graceful_restartable_neighbor.append(c)
                                return c

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "graceful-restartable-neighbor" or name == "vrf" or name == "forwarding-state-hold-timer-remaining-seconds" or name == "is-forwarding-state-hold-timer-running"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "forwarding-state-hold-timer-remaining-seconds"):
                                self.forwarding_state_hold_timer_remaining_seconds = value
                                self.forwarding_state_hold_timer_remaining_seconds.value_namespace = name_space
                                self.forwarding_state_hold_timer_remaining_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-forwarding-state-hold-timer-running"):
                                self.is_forwarding_state_hold_timer_running = value
                                self.is_forwarding_state_hold_timer_running.value_namespace = name_space
                                self.is_forwarding_state_hold_timer_running.value_namespace_prefix = name_space_prefix


                    class Capabilities(Entity):
                        """
                        LDP capability database information
                        
                        .. attribute:: capability
                        
                        	Information on LDP capability
                        	**type**\: list of    :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities, self).__init__()

                            self.yang_name = "capabilities"
                            self.yang_parent_name = "vrf"

                            self.capability = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities, self).__setattr__(name, value)


                        class Capability(Entity):
                            """
                            Information on LDP capability
                            
                            .. attribute:: capability_type  <key>
                            
                            	The capability type (IANA assigned)
                            	**type**\:  int
                            
                            	**range:** \-2147483648..2147483647
                            
                            .. attribute:: capability
                            
                            	Capability information
                            	**type**\:   :py:class:`Capability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability.Capability>`
                            
                            .. attribute:: capability_owner
                            
                            	Capability owner
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability, self).__init__()

                                self.yang_name = "capability"
                                self.yang_parent_name = "capabilities"

                                self.capability_type = YLeaf(YType.int32, "capability-type")

                                self.capability_owner = YLeaf(YType.str, "capability-owner")

                                self.capability = MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability.Capability()
                                self.capability.parent = self
                                self._children_name_map["capability"] = "capability"
                                self._children_yang_names.add("capability")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("capability_type",
                                                "capability_owner") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability, self).__setattr__(name, value)


                            class Capability(Entity):
                                """
                                Capability information
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability.Capability, self).__init__()

                                    self.yang_name = "capability"
                                    self.yang_parent_name = "capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability.Capability, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability.Capability, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "capability" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.capability_type.is_set or
                                    self.capability_owner.is_set or
                                    (self.capability is not None and self.capability.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.capability_type.yfilter != YFilter.not_set or
                                    self.capability_owner.yfilter != YFilter.not_set or
                                    (self.capability is not None and self.capability.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "capability" + "[capability-type='" + self.capability_type.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.capability_type.is_set or self.capability_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_type.get_name_leafdata())
                                if (self.capability_owner.is_set or self.capability_owner.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.capability_owner.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "capability"):
                                    if (self.capability is None):
                                        self.capability = MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability.Capability()
                                        self.capability.parent = self
                                        self._children_name_map["capability"] = "capability"
                                    return self.capability

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "capability" or name == "capability-type" or name == "capability-owner"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "capability-type"):
                                    self.capability_type = value
                                    self.capability_type.value_namespace = name_space
                                    self.capability_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "capability-owner"):
                                    self.capability_owner = value
                                    self.capability_owner.value_namespace = name_space
                                    self.capability_owner.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.capability:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.capability:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "capabilities" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "capability"):
                                for c in self.capability:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities.Capability()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.capability.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Summary(Entity):
                        """
                        LDP VRF summary
                        
                        .. attribute:: common
                        
                        	Common Summary information
                        	**type**\:   :py:class:`Common <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Common>`
                        
                        .. attribute:: vrf
                        
                        	VRF information
                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Vrf>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Summary, self).__init__()

                            self.yang_name = "summary"
                            self.yang_parent_name = "vrf"

                            self.common = MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Common()
                            self.common.parent = self
                            self._children_name_map["common"] = "common"
                            self._children_yang_names.add("common")

                            self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                            self._children_yang_names.add("vrf")


                        class Vrf(Entity):
                            """
                            VRF information
                            
                            .. attribute:: id
                            
                            	VRF Id
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: name
                            
                            	VRF Name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Vrf, self).__init__()

                                self.yang_name = "vrf"
                                self.yang_parent_name = "summary"

                                self.id = YLeaf(YType.uint32, "id")

                                self.name = YLeaf(YType.str, "name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("id",
                                                "name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Vrf, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Vrf, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.id.is_set or
                                    self.name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.id.yfilter != YFilter.not_set or
                                    self.name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "vrf" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.id.get_name_leafdata())
                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "id" or name == "name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "id"):
                                    self.id = value
                                    self.id.value_namespace = name_space
                                    self.id.value_namespace_prefix = name_space_prefix
                                if(value_path == "name"):
                                    self.name = value
                                    self.name.value_namespace = name_space
                                    self.name.value_namespace_prefix = name_space_prefix


                        class Common(Entity):
                            """
                            Common Summary information
                            
                            .. attribute:: address_families
                            
                            	Address Families enabled
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: number_of_bindings_ipv4
                            
                            	Total number of ipv4 bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_bindings_ipv6
                            
                            	Total number of ipv6 bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_downstream_on_demand_neighbors
                            
                            	Number of Downstream\-On\-Demand neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_graceful_restart_neighbors
                            
                            	Number of Graceful Restart neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_hello_adj
                            
                            	Number of LDP discovery IPv4 hello adjacencies
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_local_addresses
                            
                            	Number of IPv4 local addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4_routes
                            
                            	Number of resolved IPv4 routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4af
                            
                            	Number of IPv4 address\-families enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv4ldp_interfaces
                            
                            	Number of LDP IPv4 configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_hello_adj
                            
                            	Number of LDP discovery IPv6 hello adjacencies
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_local_addresses
                            
                            	Number of IPv6 local addresses
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6_routes
                            
                            	Number of resolved IPv6 routes
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6af
                            
                            	Number of IPv6 address\-families enabled
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ipv6ldp_interfaces
                            
                            	Number of LDP IPv6 configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_ldp_interfaces
                            
                            	Number of LDP configured interfaces
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_local_bindings_ipv4
                            
                            	Total number of ipv4 local label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_local_bindings_ipv6
                            
                            	Total number of ipv6 local label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_neighbors
                            
                            	Number of neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_nsr_synced_neighbors
                            
                            	Number of NSR\-synced/operational neighbors
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_remote_bindings_ipv4
                            
                            	Total number of ipv4 remote label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: number_of_remote_bindings_ipv6
                            
                            	Total number of ipv6 remote label bindings
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Common, self).__init__()

                                self.yang_name = "common"
                                self.yang_parent_name = "summary"

                                self.address_families = YLeaf(YType.enumeration, "address-families")

                                self.number_of_bindings_ipv4 = YLeaf(YType.uint32, "number-of-bindings-ipv4")

                                self.number_of_bindings_ipv6 = YLeaf(YType.uint32, "number-of-bindings-ipv6")

                                self.number_of_downstream_on_demand_neighbors = YLeaf(YType.uint32, "number-of-downstream-on-demand-neighbors")

                                self.number_of_graceful_restart_neighbors = YLeaf(YType.uint32, "number-of-graceful-restart-neighbors")

                                self.number_of_ipv4_hello_adj = YLeaf(YType.uint32, "number-of-ipv4-hello-adj")

                                self.number_of_ipv4_local_addresses = YLeaf(YType.uint32, "number-of-ipv4-local-addresses")

                                self.number_of_ipv4_routes = YLeaf(YType.uint32, "number-of-ipv4-routes")

                                self.number_of_ipv4af = YLeaf(YType.uint32, "number-of-ipv4af")

                                self.number_of_ipv4ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv4ldp-interfaces")

                                self.number_of_ipv6_hello_adj = YLeaf(YType.uint32, "number-of-ipv6-hello-adj")

                                self.number_of_ipv6_local_addresses = YLeaf(YType.uint32, "number-of-ipv6-local-addresses")

                                self.number_of_ipv6_routes = YLeaf(YType.uint32, "number-of-ipv6-routes")

                                self.number_of_ipv6af = YLeaf(YType.uint32, "number-of-ipv6af")

                                self.number_of_ipv6ldp_interfaces = YLeaf(YType.uint32, "number-of-ipv6ldp-interfaces")

                                self.number_of_ldp_interfaces = YLeaf(YType.uint32, "number-of-ldp-interfaces")

                                self.number_of_local_bindings_ipv4 = YLeaf(YType.uint32, "number-of-local-bindings-ipv4")

                                self.number_of_local_bindings_ipv6 = YLeaf(YType.uint32, "number-of-local-bindings-ipv6")

                                self.number_of_neighbors = YLeaf(YType.uint32, "number-of-neighbors")

                                self.number_of_nsr_synced_neighbors = YLeaf(YType.uint32, "number-of-nsr-synced-neighbors")

                                self.number_of_remote_bindings_ipv4 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv4")

                                self.number_of_remote_bindings_ipv6 = YLeaf(YType.uint32, "number-of-remote-bindings-ipv6")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_families",
                                                "number_of_bindings_ipv4",
                                                "number_of_bindings_ipv6",
                                                "number_of_downstream_on_demand_neighbors",
                                                "number_of_graceful_restart_neighbors",
                                                "number_of_ipv4_hello_adj",
                                                "number_of_ipv4_local_addresses",
                                                "number_of_ipv4_routes",
                                                "number_of_ipv4af",
                                                "number_of_ipv4ldp_interfaces",
                                                "number_of_ipv6_hello_adj",
                                                "number_of_ipv6_local_addresses",
                                                "number_of_ipv6_routes",
                                                "number_of_ipv6af",
                                                "number_of_ipv6ldp_interfaces",
                                                "number_of_ldp_interfaces",
                                                "number_of_local_bindings_ipv4",
                                                "number_of_local_bindings_ipv6",
                                                "number_of_neighbors",
                                                "number_of_nsr_synced_neighbors",
                                                "number_of_remote_bindings_ipv4",
                                                "number_of_remote_bindings_ipv6") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Common, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Common, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.address_families.is_set or
                                    self.number_of_bindings_ipv4.is_set or
                                    self.number_of_bindings_ipv6.is_set or
                                    self.number_of_downstream_on_demand_neighbors.is_set or
                                    self.number_of_graceful_restart_neighbors.is_set or
                                    self.number_of_ipv4_hello_adj.is_set or
                                    self.number_of_ipv4_local_addresses.is_set or
                                    self.number_of_ipv4_routes.is_set or
                                    self.number_of_ipv4af.is_set or
                                    self.number_of_ipv4ldp_interfaces.is_set or
                                    self.number_of_ipv6_hello_adj.is_set or
                                    self.number_of_ipv6_local_addresses.is_set or
                                    self.number_of_ipv6_routes.is_set or
                                    self.number_of_ipv6af.is_set or
                                    self.number_of_ipv6ldp_interfaces.is_set or
                                    self.number_of_ldp_interfaces.is_set or
                                    self.number_of_local_bindings_ipv4.is_set or
                                    self.number_of_local_bindings_ipv6.is_set or
                                    self.number_of_neighbors.is_set or
                                    self.number_of_nsr_synced_neighbors.is_set or
                                    self.number_of_remote_bindings_ipv4.is_set or
                                    self.number_of_remote_bindings_ipv6.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_families.yfilter != YFilter.not_set or
                                    self.number_of_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_bindings_ipv6.yfilter != YFilter.not_set or
                                    self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set or
                                    self.number_of_ipv4_routes.yfilter != YFilter.not_set or
                                    self.number_of_ipv4af.yfilter != YFilter.not_set or
                                    self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set or
                                    self.number_of_ipv6_routes.yfilter != YFilter.not_set or
                                    self.number_of_ipv6af.yfilter != YFilter.not_set or
                                    self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_ldp_interfaces.yfilter != YFilter.not_set or
                                    self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set or
                                    self.number_of_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set or
                                    self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set or
                                    self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "common" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_families.is_set or self.address_families.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_families.get_name_leafdata())
                                if (self.number_of_bindings_ipv4.is_set or self.number_of_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_bindings_ipv6.is_set or self.number_of_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_bindings_ipv6.get_name_leafdata())
                                if (self.number_of_downstream_on_demand_neighbors.is_set or self.number_of_downstream_on_demand_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_downstream_on_demand_neighbors.get_name_leafdata())
                                if (self.number_of_graceful_restart_neighbors.is_set or self.number_of_graceful_restart_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_graceful_restart_neighbors.get_name_leafdata())
                                if (self.number_of_ipv4_hello_adj.is_set or self.number_of_ipv4_hello_adj.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_hello_adj.get_name_leafdata())
                                if (self.number_of_ipv4_local_addresses.is_set or self.number_of_ipv4_local_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_local_addresses.get_name_leafdata())
                                if (self.number_of_ipv4_routes.is_set or self.number_of_ipv4_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4_routes.get_name_leafdata())
                                if (self.number_of_ipv4af.is_set or self.number_of_ipv4af.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4af.get_name_leafdata())
                                if (self.number_of_ipv4ldp_interfaces.is_set or self.number_of_ipv4ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv4ldp_interfaces.get_name_leafdata())
                                if (self.number_of_ipv6_hello_adj.is_set or self.number_of_ipv6_hello_adj.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_hello_adj.get_name_leafdata())
                                if (self.number_of_ipv6_local_addresses.is_set or self.number_of_ipv6_local_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_local_addresses.get_name_leafdata())
                                if (self.number_of_ipv6_routes.is_set or self.number_of_ipv6_routes.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6_routes.get_name_leafdata())
                                if (self.number_of_ipv6af.is_set or self.number_of_ipv6af.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6af.get_name_leafdata())
                                if (self.number_of_ipv6ldp_interfaces.is_set or self.number_of_ipv6ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ipv6ldp_interfaces.get_name_leafdata())
                                if (self.number_of_ldp_interfaces.is_set or self.number_of_ldp_interfaces.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_ldp_interfaces.get_name_leafdata())
                                if (self.number_of_local_bindings_ipv4.is_set or self.number_of_local_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_local_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_local_bindings_ipv6.is_set or self.number_of_local_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_local_bindings_ipv6.get_name_leafdata())
                                if (self.number_of_neighbors.is_set or self.number_of_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_neighbors.get_name_leafdata())
                                if (self.number_of_nsr_synced_neighbors.is_set or self.number_of_nsr_synced_neighbors.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_nsr_synced_neighbors.get_name_leafdata())
                                if (self.number_of_remote_bindings_ipv4.is_set or self.number_of_remote_bindings_ipv4.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_remote_bindings_ipv4.get_name_leafdata())
                                if (self.number_of_remote_bindings_ipv6.is_set or self.number_of_remote_bindings_ipv6.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.number_of_remote_bindings_ipv6.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "address-families" or name == "number-of-bindings-ipv4" or name == "number-of-bindings-ipv6" or name == "number-of-downstream-on-demand-neighbors" or name == "number-of-graceful-restart-neighbors" or name == "number-of-ipv4-hello-adj" or name == "number-of-ipv4-local-addresses" or name == "number-of-ipv4-routes" or name == "number-of-ipv4af" or name == "number-of-ipv4ldp-interfaces" or name == "number-of-ipv6-hello-adj" or name == "number-of-ipv6-local-addresses" or name == "number-of-ipv6-routes" or name == "number-of-ipv6af" or name == "number-of-ipv6ldp-interfaces" or name == "number-of-ldp-interfaces" or name == "number-of-local-bindings-ipv4" or name == "number-of-local-bindings-ipv6" or name == "number-of-neighbors" or name == "number-of-nsr-synced-neighbors" or name == "number-of-remote-bindings-ipv4" or name == "number-of-remote-bindings-ipv6"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-families"):
                                    self.address_families = value
                                    self.address_families.value_namespace = name_space
                                    self.address_families.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-bindings-ipv4"):
                                    self.number_of_bindings_ipv4 = value
                                    self.number_of_bindings_ipv4.value_namespace = name_space
                                    self.number_of_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-bindings-ipv6"):
                                    self.number_of_bindings_ipv6 = value
                                    self.number_of_bindings_ipv6.value_namespace = name_space
                                    self.number_of_bindings_ipv6.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-downstream-on-demand-neighbors"):
                                    self.number_of_downstream_on_demand_neighbors = value
                                    self.number_of_downstream_on_demand_neighbors.value_namespace = name_space
                                    self.number_of_downstream_on_demand_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-graceful-restart-neighbors"):
                                    self.number_of_graceful_restart_neighbors = value
                                    self.number_of_graceful_restart_neighbors.value_namespace = name_space
                                    self.number_of_graceful_restart_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-hello-adj"):
                                    self.number_of_ipv4_hello_adj = value
                                    self.number_of_ipv4_hello_adj.value_namespace = name_space
                                    self.number_of_ipv4_hello_adj.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-local-addresses"):
                                    self.number_of_ipv4_local_addresses = value
                                    self.number_of_ipv4_local_addresses.value_namespace = name_space
                                    self.number_of_ipv4_local_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4-routes"):
                                    self.number_of_ipv4_routes = value
                                    self.number_of_ipv4_routes.value_namespace = name_space
                                    self.number_of_ipv4_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4af"):
                                    self.number_of_ipv4af = value
                                    self.number_of_ipv4af.value_namespace = name_space
                                    self.number_of_ipv4af.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv4ldp-interfaces"):
                                    self.number_of_ipv4ldp_interfaces = value
                                    self.number_of_ipv4ldp_interfaces.value_namespace = name_space
                                    self.number_of_ipv4ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-hello-adj"):
                                    self.number_of_ipv6_hello_adj = value
                                    self.number_of_ipv6_hello_adj.value_namespace = name_space
                                    self.number_of_ipv6_hello_adj.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-local-addresses"):
                                    self.number_of_ipv6_local_addresses = value
                                    self.number_of_ipv6_local_addresses.value_namespace = name_space
                                    self.number_of_ipv6_local_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6-routes"):
                                    self.number_of_ipv6_routes = value
                                    self.number_of_ipv6_routes.value_namespace = name_space
                                    self.number_of_ipv6_routes.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6af"):
                                    self.number_of_ipv6af = value
                                    self.number_of_ipv6af.value_namespace = name_space
                                    self.number_of_ipv6af.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ipv6ldp-interfaces"):
                                    self.number_of_ipv6ldp_interfaces = value
                                    self.number_of_ipv6ldp_interfaces.value_namespace = name_space
                                    self.number_of_ipv6ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-ldp-interfaces"):
                                    self.number_of_ldp_interfaces = value
                                    self.number_of_ldp_interfaces.value_namespace = name_space
                                    self.number_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-local-bindings-ipv4"):
                                    self.number_of_local_bindings_ipv4 = value
                                    self.number_of_local_bindings_ipv4.value_namespace = name_space
                                    self.number_of_local_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-local-bindings-ipv6"):
                                    self.number_of_local_bindings_ipv6 = value
                                    self.number_of_local_bindings_ipv6.value_namespace = name_space
                                    self.number_of_local_bindings_ipv6.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-neighbors"):
                                    self.number_of_neighbors = value
                                    self.number_of_neighbors.value_namespace = name_space
                                    self.number_of_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-nsr-synced-neighbors"):
                                    self.number_of_nsr_synced_neighbors = value
                                    self.number_of_nsr_synced_neighbors.value_namespace = name_space
                                    self.number_of_nsr_synced_neighbors.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-remote-bindings-ipv4"):
                                    self.number_of_remote_bindings_ipv4 = value
                                    self.number_of_remote_bindings_ipv4.value_namespace = name_space
                                    self.number_of_remote_bindings_ipv4.value_namespace_prefix = name_space_prefix
                                if(value_path == "number-of-remote-bindings-ipv6"):
                                    self.number_of_remote_bindings_ipv6 = value
                                    self.number_of_remote_bindings_ipv6.value_namespace = name_space
                                    self.number_of_remote_bindings_ipv6.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.common is not None and self.common.has_data()) or
                                (self.vrf is not None and self.vrf.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.common is not None and self.common.has_operation()) or
                                (self.vrf is not None and self.vrf.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "summary" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "common"):
                                if (self.common is None):
                                    self.common = MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Common()
                                    self.common.parent = self
                                    self._children_name_map["common"] = "common"
                                return self.common

                            if (child_yang_name == "vrf"):
                                if (self.vrf is None):
                                    self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Summary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                return self.vrf

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "common" or name == "vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Afs(Entity):
                        """
                        Address Family specific operational data
                        
                        .. attribute:: af
                        
                        	Operational data for given Address Family
                        	**type**\: list of    :py:class:`Af <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs, self).__init__()

                            self.yang_name = "afs"
                            self.yang_parent_name = "vrf"

                            self.af = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs, self).__setattr__(name, value)


                        class Af(Entity):
                            """
                            Operational data for given Address Family
                            
                            .. attribute:: af_name  <key>
                            
                            	Address Family name
                            	**type**\:   :py:class:`MplsLdpOperAfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdpOperAfName>`
                            
                            .. attribute:: bindings
                            
                            	The LDP Bindings
                            	**type**\:   :py:class:`Bindings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings>`
                            
                            .. attribute:: bindings_advertise_spec
                            
                            	Advertisement Spec (ACL) for LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsAdvertiseSpec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec>`
                            
                            .. attribute:: bindings_summary
                            
                            	Counters for the LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary>`
                            
                            .. attribute:: bindings_summary_all
                            
                            	Aggregate VRF counters for the LDP Label Infomation Base (LIB)
                            	**type**\:   :py:class:`BindingsSummaryAll <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll>`
                            
                            .. attribute:: discovery
                            
                            	The LDP Discovery
                            	**type**\:   :py:class:`Discovery <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery>`
                            
                            .. attribute:: forwarding_summary
                            
                            	Summary information regarding LDP forwarding setup
                            	**type**\:   :py:class:`ForwardingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary>`
                            
                            .. attribute:: forwardings
                            
                            	The LDP Forwarding rewrites
                            	**type**\:   :py:class:`Forwardings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings>`
                            
                            .. attribute:: igp
                            
                            	LDP IGP related information
                            	**type**\:   :py:class:`Igp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp>`
                            
                            .. attribute:: interface_summary
                            
                            	IPv4 interface summary information
                            	**type**\:   :py:class:`InterfaceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.InterfaceSummary>`
                            
                            .. attribute:: interfaces
                            
                            	LDP Interface related information
                            	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af, self).__init__()

                                self.yang_name = "af"
                                self.yang_parent_name = "afs"

                                self.af_name = YLeaf(YType.enumeration, "af-name")

                                self.bindings = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings()
                                self.bindings.parent = self
                                self._children_name_map["bindings"] = "bindings"
                                self._children_yang_names.add("bindings")

                                self.bindings_advertise_spec = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec()
                                self.bindings_advertise_spec.parent = self
                                self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                self._children_yang_names.add("bindings-advertise-spec")

                                self.bindings_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary()
                                self.bindings_summary.parent = self
                                self._children_name_map["bindings_summary"] = "bindings-summary"
                                self._children_yang_names.add("bindings-summary")

                                self.bindings_summary_all = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll()
                                self.bindings_summary_all.parent = self
                                self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                self._children_yang_names.add("bindings-summary-all")

                                self.discovery = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery()
                                self.discovery.parent = self
                                self._children_name_map["discovery"] = "discovery"
                                self._children_yang_names.add("discovery")

                                self.forwarding_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary()
                                self.forwarding_summary.parent = self
                                self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                self._children_yang_names.add("forwarding-summary")

                                self.forwardings = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings()
                                self.forwardings.parent = self
                                self._children_name_map["forwardings"] = "forwardings"
                                self._children_yang_names.add("forwardings")

                                self.igp = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp()
                                self.igp.parent = self
                                self._children_name_map["igp"] = "igp"
                                self._children_yang_names.add("igp")

                                self.interface_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.InterfaceSummary()
                                self.interface_summary.parent = self
                                self._children_name_map["interface_summary"] = "interface-summary"
                                self._children_yang_names.add("interface-summary")

                                self.interfaces = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces()
                                self.interfaces.parent = self
                                self._children_name_map["interfaces"] = "interfaces"
                                self._children_yang_names.add("interfaces")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("af_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af, self).__setattr__(name, value)


                            class InterfaceSummary(Entity):
                                """
                                IPv4 interface summary information
                                
                                .. attribute:: auto_config
                                
                                	Auto\-configured interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: auto_config_disabled
                                
                                	Autoconfigure disabled
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: auto_config_forward_reference_interfaces
                                
                                	Auto\-configured forward references
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: forward_references
                                
                                	Number of forward referenced interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: known_ip_interface_count
                                
                                	Number of known IP Interfaces
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: known_ip_interface_ldp_enabled
                                
                                	Number of known IP Interfaces with LDP Enabled
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ldp_configured_attached_interface
                                
                                	Number of attached interfaces configured in LDP
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ldp_configured_te_interface
                                
                                	Number of TE tunnel interfaces configured in LDP
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__init__()

                                    self.yang_name = "interface-summary"
                                    self.yang_parent_name = "af"

                                    self.auto_config = YLeaf(YType.uint32, "auto-config")

                                    self.auto_config_disabled = YLeaf(YType.uint32, "auto-config-disabled")

                                    self.auto_config_forward_reference_interfaces = YLeaf(YType.uint32, "auto-config-forward-reference-interfaces")

                                    self.forward_references = YLeaf(YType.uint32, "forward-references")

                                    self.known_ip_interface_count = YLeaf(YType.uint32, "known-ip-interface-count")

                                    self.known_ip_interface_ldp_enabled = YLeaf(YType.uint32, "known-ip-interface-ldp-enabled")

                                    self.ldp_configured_attached_interface = YLeaf(YType.uint32, "ldp-configured-attached-interface")

                                    self.ldp_configured_te_interface = YLeaf(YType.uint32, "ldp-configured-te-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("auto_config",
                                                    "auto_config_disabled",
                                                    "auto_config_forward_reference_interfaces",
                                                    "forward_references",
                                                    "known_ip_interface_count",
                                                    "known_ip_interface_ldp_enabled",
                                                    "ldp_configured_attached_interface",
                                                    "ldp_configured_te_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.InterfaceSummary, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.auto_config.is_set or
                                        self.auto_config_disabled.is_set or
                                        self.auto_config_forward_reference_interfaces.is_set or
                                        self.forward_references.is_set or
                                        self.known_ip_interface_count.is_set or
                                        self.known_ip_interface_ldp_enabled.is_set or
                                        self.ldp_configured_attached_interface.is_set or
                                        self.ldp_configured_te_interface.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.auto_config.yfilter != YFilter.not_set or
                                        self.auto_config_disabled.yfilter != YFilter.not_set or
                                        self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set or
                                        self.forward_references.yfilter != YFilter.not_set or
                                        self.known_ip_interface_count.yfilter != YFilter.not_set or
                                        self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set or
                                        self.ldp_configured_attached_interface.yfilter != YFilter.not_set or
                                        self.ldp_configured_te_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interface-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.auto_config.is_set or self.auto_config.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config.get_name_leafdata())
                                    if (self.auto_config_disabled.is_set or self.auto_config_disabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config_disabled.get_name_leafdata())
                                    if (self.auto_config_forward_reference_interfaces.is_set or self.auto_config_forward_reference_interfaces.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.auto_config_forward_reference_interfaces.get_name_leafdata())
                                    if (self.forward_references.is_set or self.forward_references.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.forward_references.get_name_leafdata())
                                    if (self.known_ip_interface_count.is_set or self.known_ip_interface_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.known_ip_interface_count.get_name_leafdata())
                                    if (self.known_ip_interface_ldp_enabled.is_set or self.known_ip_interface_ldp_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.known_ip_interface_ldp_enabled.get_name_leafdata())
                                    if (self.ldp_configured_attached_interface.is_set or self.ldp_configured_attached_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_configured_attached_interface.get_name_leafdata())
                                    if (self.ldp_configured_te_interface.is_set or self.ldp_configured_te_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ldp_configured_te_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "auto-config" or name == "auto-config-disabled" or name == "auto-config-forward-reference-interfaces" or name == "forward-references" or name == "known-ip-interface-count" or name == "known-ip-interface-ldp-enabled" or name == "ldp-configured-attached-interface" or name == "ldp-configured-te-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "auto-config"):
                                        self.auto_config = value
                                        self.auto_config.value_namespace = name_space
                                        self.auto_config.value_namespace_prefix = name_space_prefix
                                    if(value_path == "auto-config-disabled"):
                                        self.auto_config_disabled = value
                                        self.auto_config_disabled.value_namespace = name_space
                                        self.auto_config_disabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "auto-config-forward-reference-interfaces"):
                                        self.auto_config_forward_reference_interfaces = value
                                        self.auto_config_forward_reference_interfaces.value_namespace = name_space
                                        self.auto_config_forward_reference_interfaces.value_namespace_prefix = name_space_prefix
                                    if(value_path == "forward-references"):
                                        self.forward_references = value
                                        self.forward_references.value_namespace = name_space
                                        self.forward_references.value_namespace_prefix = name_space_prefix
                                    if(value_path == "known-ip-interface-count"):
                                        self.known_ip_interface_count = value
                                        self.known_ip_interface_count.value_namespace = name_space
                                        self.known_ip_interface_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "known-ip-interface-ldp-enabled"):
                                        self.known_ip_interface_ldp_enabled = value
                                        self.known_ip_interface_ldp_enabled.value_namespace = name_space
                                        self.known_ip_interface_ldp_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-configured-attached-interface"):
                                        self.ldp_configured_attached_interface = value
                                        self.ldp_configured_attached_interface.value_namespace = name_space
                                        self.ldp_configured_attached_interface.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ldp-configured-te-interface"):
                                        self.ldp_configured_te_interface = value
                                        self.ldp_configured_te_interface.value_namespace = name_space
                                        self.ldp_configured_te_interface.value_namespace_prefix = name_space_prefix


                            class Bindings(Entity):
                                """
                                The LDP Bindings
                                
                                .. attribute:: binding
                                
                                	Binding Information
                                	**type**\: list of    :py:class:`Binding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings, self).__init__()

                                    self.yang_name = "bindings"
                                    self.yang_parent_name = "af"

                                    self.binding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings, self).__setattr__(name, value)


                                class Binding(Entity):
                                    """
                                    Binding Information
                                    
                                    .. attribute:: prefix  <key>
                                    
                                    	The IP Prefix
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                    
                                    
                                    ----
                                    .. attribute:: advertise_prefix_acl
                                    
                                    	Advertise Prerfix ACL
                                    	**type**\:  str
                                    
                                    .. attribute:: advertise_tsr_acl
                                    
                                    	Advertise TSR ACL
                                    	**type**\:  str
                                    
                                    .. attribute:: config_enforced_local_label_value
                                    
                                    	Config/User enforced local label value
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_elc
                                    
                                    	Is the entry entropy label capable
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_no_route
                                    
                                    	No route
                                    	**type**\:  bool
                                    
                                    .. attribute:: label_oor
                                    
                                    	Label space depletion OOR
                                    	**type**\:  bool
                                    
                                    .. attribute:: le_local_binding_revision
                                    
                                    	Local Binding revision
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: le_local_label_state
                                    
                                    	Local label state
                                    	**type**\:   :py:class:`LocalLabelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LocalLabelState>`
                                    
                                    .. attribute:: local_label
                                    
                                    	Local label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: peers_acked
                                    
                                    	Peers that have ACKed this entry
                                    	**type**\: list of    :py:class:`PeersAcked <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked>`
                                    
                                    .. attribute:: peers_advertised_to
                                    
                                    	Peers this entry is advertised to
                                    	**type**\: list of    :py:class:`PeersAdvertisedTo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo>`
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix Length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: prefix_xr
                                    
                                    	IP Prefix
                                    	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr>`
                                    
                                    .. attribute:: remote_binding
                                    
                                    	Remote binding
                                    	**type**\: list of    :py:class:`RemoteBinding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__init__()

                                        self.yang_name = "binding"
                                        self.yang_parent_name = "bindings"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.advertise_prefix_acl = YLeaf(YType.str, "advertise-prefix-acl")

                                        self.advertise_tsr_acl = YLeaf(YType.str, "advertise-tsr-acl")

                                        self.config_enforced_local_label_value = YLeaf(YType.boolean, "config-enforced-local-label-value")

                                        self.is_elc = YLeaf(YType.boolean, "is-elc")

                                        self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                        self.label_oor = YLeaf(YType.boolean, "label-oor")

                                        self.le_local_binding_revision = YLeaf(YType.uint32, "le-local-binding-revision")

                                        self.le_local_label_state = YLeaf(YType.enumeration, "le-local-label-state")

                                        self.local_label = YLeaf(YType.uint32, "local-label")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.prefix_xr = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr()
                                        self.prefix_xr.parent = self
                                        self._children_name_map["prefix_xr"] = "prefix-xr"
                                        self._children_yang_names.add("prefix-xr")

                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.peers_acked = YList(self)
                                        self.peers_advertised_to = YList(self)
                                        self.remote_binding = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "advertise_prefix_acl",
                                                        "advertise_tsr_acl",
                                                        "config_enforced_local_label_value",
                                                        "is_elc",
                                                        "is_no_route",
                                                        "label_oor",
                                                        "le_local_binding_revision",
                                                        "le_local_label_state",
                                                        "local_label",
                                                        "prefix_length") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "binding"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class PrefixXr(Entity):
                                        """
                                        IP Prefix
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__init__()

                                            self.yang_name = "prefix-xr"
                                            self.yang_parent_name = "binding"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix-xr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class RemoteBinding(Entity):
                                        """
                                        Remote binding
                                        
                                        .. attribute:: assigning_peer_ldp_ident
                                        
                                        	Assigning peer
                                        	**type**\:   :py:class:`AssigningPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent>`
                                        
                                        .. attribute:: is_elc
                                        
                                        	Is the entry entropy label capable
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_stale
                                        
                                        	Is the entry stale
                                        	**type**\:  bool
                                        
                                        .. attribute:: remote_label
                                        
                                        	Remote Label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__init__()

                                            self.yang_name = "remote-binding"
                                            self.yang_parent_name = "binding"

                                            self.is_elc = YLeaf(YType.boolean, "is-elc")

                                            self.is_stale = YLeaf(YType.boolean, "is-stale")

                                            self.remote_label = YLeaf(YType.uint32, "remote-label")

                                            self.assigning_peer_ldp_ident = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                            self.assigning_peer_ldp_ident.parent = self
                                            self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                            self._children_yang_names.add("assigning-peer-ldp-ident")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_elc",
                                                            "is_stale",
                                                            "remote_label") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding, self).__setattr__(name, value)


                                        class AssigningPeerLdpIdent(Entity):
                                            """
                                            Assigning peer
                                            
                                            .. attribute:: label_space_id
                                            
                                            	Label space identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: ldp_id
                                            
                                            	LDP identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: lsr_id
                                            
                                            	LSR identifier
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__init__()

                                                self.yang_name = "assigning-peer-ldp-ident"
                                                self.yang_parent_name = "remote-binding"

                                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("label_space_id",
                                                                "ldp_id",
                                                                "lsr_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.label_space_id.is_set or
                                                    self.ldp_id.is_set or
                                                    self.lsr_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.label_space_id.yfilter != YFilter.not_set or
                                                    self.ldp_id.yfilter != YFilter.not_set or
                                                    self.lsr_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "assigning-peer-ldp-ident" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "label-space-id"):
                                                    self.label_space_id = value
                                                    self.label_space_id.value_namespace = name_space
                                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ldp-id"):
                                                    self.ldp_id = value
                                                    self.ldp_id.value_namespace = name_space
                                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsr-id"):
                                                    self.lsr_id = value
                                                    self.lsr_id.value_namespace = name_space
                                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.is_elc.is_set or
                                                self.is_stale.is_set or
                                                self.remote_label.is_set or
                                                (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_elc.yfilter != YFilter.not_set or
                                                self.is_stale.yfilter != YFilter.not_set or
                                                self.remote_label.yfilter != YFilter.not_set or
                                                (self.assigning_peer_ldp_ident is not None and self.assigning_peer_ldp_ident.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "remote-binding" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_elc.get_name_leafdata())
                                            if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_stale.get_name_leafdata())
                                            if (self.remote_label.is_set or self.remote_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.remote_label.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "assigning-peer-ldp-ident"):
                                                if (self.assigning_peer_ldp_ident is None):
                                                    self.assigning_peer_ldp_ident = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding.AssigningPeerLdpIdent()
                                                    self.assigning_peer_ldp_ident.parent = self
                                                    self._children_name_map["assigning_peer_ldp_ident"] = "assigning-peer-ldp-ident"
                                                return self.assigning_peer_ldp_ident

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "assigning-peer-ldp-ident" or name == "is-elc" or name == "is-stale" or name == "remote-label"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-elc"):
                                                self.is_elc = value
                                                self.is_elc.value_namespace = name_space
                                                self.is_elc.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-stale"):
                                                self.is_stale = value
                                                self.is_stale.value_namespace = name_space
                                                self.is_stale.value_namespace_prefix = name_space_prefix
                                            if(value_path == "remote-label"):
                                                self.remote_label = value
                                                self.remote_label.value_namespace = name_space
                                                self.remote_label.value_namespace_prefix = name_space_prefix


                                    class PeersAdvertisedTo(Entity):
                                        """
                                        Peers this entry is advertised to
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__init__()

                                            self.yang_name = "peers-advertised-to"
                                            self.yang_parent_name = "binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers-advertised-to" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix


                                    class PeersAcked(Entity):
                                        """
                                        Peers that have ACKed this entry
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space identifier
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: ldp_id
                                        
                                        	LDP identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR identifier
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__init__()

                                            self.yang_name = "peers-acked"
                                            self.yang_parent_name = "binding"

                                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_space_id",
                                                            "ldp_id",
                                                            "lsr_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.label_space_id.is_set or
                                                self.ldp_id.is_set or
                                                self.lsr_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.ldp_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "peers-acked" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-id"):
                                                self.ldp_id = value
                                                self.ldp_id.value_namespace = name_space
                                                self.ldp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.peers_acked:
                                            if (c.has_data()):
                                                return True
                                        for c in self.peers_advertised_to:
                                            if (c.has_data()):
                                                return True
                                        for c in self.remote_binding:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.prefix.is_set or
                                            self.advertise_prefix_acl.is_set or
                                            self.advertise_tsr_acl.is_set or
                                            self.config_enforced_local_label_value.is_set or
                                            self.is_elc.is_set or
                                            self.is_no_route.is_set or
                                            self.label_oor.is_set or
                                            self.le_local_binding_revision.is_set or
                                            self.le_local_label_state.is_set or
                                            self.local_label.is_set or
                                            self.prefix_length.is_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.peers_acked:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.peers_advertised_to:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.remote_binding:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.advertise_prefix_acl.yfilter != YFilter.not_set or
                                            self.advertise_tsr_acl.yfilter != YFilter.not_set or
                                            self.config_enforced_local_label_value.yfilter != YFilter.not_set or
                                            self.is_elc.yfilter != YFilter.not_set or
                                            self.is_no_route.yfilter != YFilter.not_set or
                                            self.label_oor.yfilter != YFilter.not_set or
                                            self.le_local_binding_revision.yfilter != YFilter.not_set or
                                            self.le_local_label_state.yfilter != YFilter.not_set or
                                            self.local_label.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "binding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.advertise_prefix_acl.is_set or self.advertise_prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertise_prefix_acl.get_name_leafdata())
                                        if (self.advertise_tsr_acl.is_set or self.advertise_tsr_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.advertise_tsr_acl.get_name_leafdata())
                                        if (self.config_enforced_local_label_value.is_set or self.config_enforced_local_label_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.config_enforced_local_label_value.get_name_leafdata())
                                        if (self.is_elc.is_set or self.is_elc.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_elc.get_name_leafdata())
                                        if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                        if (self.label_oor.is_set or self.label_oor.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_oor.get_name_leafdata())
                                        if (self.le_local_binding_revision.is_set or self.le_local_binding_revision.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.le_local_binding_revision.get_name_leafdata())
                                        if (self.le_local_label_state.is_set or self.le_local_label_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.le_local_label_state.get_name_leafdata())
                                        if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_label.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "peers-acked"):
                                            for c in self.peers_acked:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAcked()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers_acked.append(c)
                                            return c

                                        if (child_yang_name == "peers-advertised-to"):
                                            for c in self.peers_advertised_to:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PeersAdvertisedTo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.peers_advertised_to.append(c)
                                            return c

                                        if (child_yang_name == "prefix-xr"):
                                            if (self.prefix_xr is None):
                                                self.prefix_xr = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.PrefixXr()
                                                self.prefix_xr.parent = self
                                                self._children_name_map["prefix_xr"] = "prefix-xr"
                                            return self.prefix_xr

                                        if (child_yang_name == "remote-binding"):
                                            for c in self.remote_binding:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.RemoteBinding()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.remote_binding.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "peers-acked" or name == "peers-advertised-to" or name == "prefix-xr" or name == "remote-binding" or name == "vrf" or name == "prefix" or name == "advertise-prefix-acl" or name == "advertise-tsr-acl" or name == "config-enforced-local-label-value" or name == "is-elc" or name == "is-no-route" or name == "label-oor" or name == "le-local-binding-revision" or name == "le-local-label-state" or name == "local-label" or name == "prefix-length"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "advertise-prefix-acl"):
                                            self.advertise_prefix_acl = value
                                            self.advertise_prefix_acl.value_namespace = name_space
                                            self.advertise_prefix_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "advertise-tsr-acl"):
                                            self.advertise_tsr_acl = value
                                            self.advertise_tsr_acl.value_namespace = name_space
                                            self.advertise_tsr_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "config-enforced-local-label-value"):
                                            self.config_enforced_local_label_value = value
                                            self.config_enforced_local_label_value.value_namespace = name_space
                                            self.config_enforced_local_label_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-elc"):
                                            self.is_elc = value
                                            self.is_elc.value_namespace = name_space
                                            self.is_elc.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-no-route"):
                                            self.is_no_route = value
                                            self.is_no_route.value_namespace = name_space
                                            self.is_no_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-oor"):
                                            self.label_oor = value
                                            self.label_oor.value_namespace = name_space
                                            self.label_oor.value_namespace_prefix = name_space_prefix
                                        if(value_path == "le-local-binding-revision"):
                                            self.le_local_binding_revision = value
                                            self.le_local_binding_revision.value_namespace = name_space
                                            self.le_local_binding_revision.value_namespace_prefix = name_space_prefix
                                        if(value_path == "le-local-label-state"):
                                            self.le_local_label_state = value
                                            self.le_local_label_state.value_namespace = name_space
                                            self.le_local_label_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "local-label"):
                                            self.local_label = value
                                            self.local_label.value_namespace = name_space
                                            self.local_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.binding:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.binding:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "binding"):
                                        for c in self.binding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings.Binding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.binding.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "binding"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Igp(Entity):
                                """
                                LDP IGP related information
                                
                                .. attribute:: sync_delay_restart
                                
                                	LDP\-IGP Synchronization Delay related information
                                	**type**\:   :py:class:`SyncDelayRestart <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart>`
                                
                                .. attribute:: syncs
                                
                                	LDP IGP Sync related information
                                	**type**\:   :py:class:`Syncs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp, self).__init__()

                                    self.yang_name = "igp"
                                    self.yang_parent_name = "af"

                                    self.sync_delay_restart = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart()
                                    self.sync_delay_restart.parent = self
                                    self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                    self._children_yang_names.add("sync-delay-restart")

                                    self.syncs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs()
                                    self.syncs.parent = self
                                    self._children_name_map["syncs"] = "syncs"
                                    self._children_yang_names.add("syncs")


                                class Syncs(Entity):
                                    """
                                    LDP IGP Sync related information
                                    
                                    .. attribute:: sync
                                    
                                    	LDP\-IGP Synchronization related information for an interface
                                    	**type**\: list of    :py:class:`Sync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__init__()

                                        self.yang_name = "syncs"
                                        self.yang_parent_name = "igp"

                                        self.sync = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs, self).__setattr__(name, value)


                                    class Sync(Entity):
                                        """
                                        LDP\-IGP Synchronization related information
                                        for an interface
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: delay_timer_remaining
                                        
                                        	Remaining timer (seconds) till expiry of sync delay timer
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: gr_only_peer
                                        
                                        	Interface GR\-only reachable peers
                                        	**type**\: list of    :py:class:`GrOnlyPeer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer>`
                                        
                                        .. attribute:: igp_sync_delay
                                        
                                        	IGP sync delay in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: igp_sync_down_reason
                                        
                                        	Reason IGP Sync Not Achieved
                                        	**type**\:   :py:class:`LdpIgpSyncDownReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncDownReason>`
                                        
                                        .. attribute:: igp_sync_state
                                        
                                        	IGP Sync state
                                        	**type**\:   :py:class:`LdpIgpSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpIgpSyncState>`
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: is_delay_timer_running
                                        
                                        	Is sync delay timer running
                                        	**type**\:  bool
                                        
                                        .. attribute:: peers
                                        
                                        	Interface Peers
                                        	**type**\: list of    :py:class:`Peers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers>`
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__init__()

                                            self.yang_name = "sync"
                                            self.yang_parent_name = "syncs"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.delay_timer_remaining = YLeaf(YType.uint32, "delay-timer-remaining")

                                            self.igp_sync_delay = YLeaf(YType.uint32, "igp-sync-delay")

                                            self.igp_sync_down_reason = YLeaf(YType.enumeration, "igp-sync-down-reason")

                                            self.igp_sync_state = YLeaf(YType.enumeration, "igp-sync-state")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.is_delay_timer_running = YLeaf(YType.boolean, "is-delay-timer-running")

                                            self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.gr_only_peer = YList(self)
                                            self.peers = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "delay_timer_remaining",
                                                            "igp_sync_delay",
                                                            "igp_sync_down_reason",
                                                            "igp_sync_state",
                                                            "interface_name_xr",
                                                            "is_delay_timer_running") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "sync"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class Peers(Entity):
                                            """
                                            Interface Peers
                                            
                                            .. attribute:: is_gr_enabled
                                            
                                            	Is GR enabled session
                                            	**type**\:  bool
                                            
                                            .. attribute:: peer_id
                                            
                                            	Peer Identifier
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__init__()

                                                self.yang_name = "peers"
                                                self.yang_parent_name = "sync"

                                                self.is_gr_enabled = YLeaf(YType.boolean, "is-gr-enabled")

                                                self.peer_id = YLeaf(YType.str, "peer-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_gr_enabled",
                                                                "peer_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_gr_enabled.is_set or
                                                    self.peer_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_gr_enabled.yfilter != YFilter.not_set or
                                                    self.peer_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "peers" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_gr_enabled.is_set or self.is_gr_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_gr_enabled.get_name_leafdata())
                                                if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.peer_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-gr-enabled" or name == "peer-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-gr-enabled"):
                                                    self.is_gr_enabled = value
                                                    self.is_gr_enabled.value_namespace = name_space
                                                    self.is_gr_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "peer-id"):
                                                    self.peer_id = value
                                                    self.peer_id.value_namespace = name_space
                                                    self.peer_id.value_namespace_prefix = name_space_prefix


                                        class GrOnlyPeer(Entity):
                                            """
                                            Interface GR\-only reachable peers
                                            
                                            .. attribute:: is_chkpt_created
                                            
                                            	Is created due to checkpointing
                                            	**type**\:  bool
                                            
                                            .. attribute:: peer_id
                                            
                                            	Peer Identifier
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__init__()

                                                self.yang_name = "gr-only-peer"
                                                self.yang_parent_name = "sync"

                                                self.is_chkpt_created = YLeaf(YType.boolean, "is-chkpt-created")

                                                self.peer_id = YLeaf(YType.str, "peer-id")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_chkpt_created",
                                                                "peer_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_chkpt_created.is_set or
                                                    self.peer_id.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_chkpt_created.yfilter != YFilter.not_set or
                                                    self.peer_id.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "gr-only-peer" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_chkpt_created.is_set or self.is_chkpt_created.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_chkpt_created.get_name_leafdata())
                                                if (self.peer_id.is_set or self.peer_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.peer_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-chkpt-created" or name == "peer-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-chkpt-created"):
                                                    self.is_chkpt_created = value
                                                    self.is_chkpt_created.value_namespace = name_space
                                                    self.is_chkpt_created.value_namespace_prefix = name_space_prefix
                                                if(value_path == "peer-id"):
                                                    self.peer_id = value
                                                    self.peer_id.value_namespace = name_space
                                                    self.peer_id.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.gr_only_peer:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.peers:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.delay_timer_remaining.is_set or
                                                self.igp_sync_delay.is_set or
                                                self.igp_sync_down_reason.is_set or
                                                self.igp_sync_state.is_set or
                                                self.interface_name_xr.is_set or
                                                self.is_delay_timer_running.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.gr_only_peer:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.peers:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.delay_timer_remaining.yfilter != YFilter.not_set or
                                                self.igp_sync_delay.yfilter != YFilter.not_set or
                                                self.igp_sync_down_reason.yfilter != YFilter.not_set or
                                                self.igp_sync_state.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                self.is_delay_timer_running.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "sync" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.delay_timer_remaining.is_set or self.delay_timer_remaining.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.delay_timer_remaining.get_name_leafdata())
                                            if (self.igp_sync_delay.is_set or self.igp_sync_delay.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_delay.get_name_leafdata())
                                            if (self.igp_sync_down_reason.is_set or self.igp_sync_down_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_down_reason.get_name_leafdata())
                                            if (self.igp_sync_state.is_set or self.igp_sync_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.igp_sync_state.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                            if (self.is_delay_timer_running.is_set or self.is_delay_timer_running.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_delay_timer_running.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "gr-only-peer"):
                                                for c in self.gr_only_peer:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.GrOnlyPeer()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.gr_only_peer.append(c)
                                                return c

                                            if (child_yang_name == "peers"):
                                                for c in self.peers:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Peers()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.peers.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "gr-only-peer" or name == "peers" or name == "vrf" or name == "interface-name" or name == "delay-timer-remaining" or name == "igp-sync-delay" or name == "igp-sync-down-reason" or name == "igp-sync-state" or name == "interface-name-xr" or name == "is-delay-timer-running"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "delay-timer-remaining"):
                                                self.delay_timer_remaining = value
                                                self.delay_timer_remaining.value_namespace = name_space
                                                self.delay_timer_remaining.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-delay"):
                                                self.igp_sync_delay = value
                                                self.igp_sync_delay.value_namespace = name_space
                                                self.igp_sync_delay.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-down-reason"):
                                                self.igp_sync_down_reason = value
                                                self.igp_sync_down_reason.value_namespace = name_space
                                                self.igp_sync_down_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "igp-sync-state"):
                                                self.igp_sync_state = value
                                                self.igp_sync_state.value_namespace = name_space
                                                self.igp_sync_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-delay-timer-running"):
                                                self.is_delay_timer_running = value
                                                self.is_delay_timer_running.value_namespace = name_space
                                                self.is_delay_timer_running.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.sync:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.sync:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "syncs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "sync"):
                                            for c in self.sync:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs.Sync()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.sync.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "sync"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class SyncDelayRestart(Entity):
                                    """
                                    LDP\-IGP Synchronization Delay related
                                    information
                                    
                                    .. attribute:: configured
                                    
                                    	Is restart delay configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: delay_secs
                                    
                                    	Delay time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: remaining_secs
                                    
                                    	Delay timer remaining time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: timer_running
                                    
                                    	Is restart delay timer running
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__init__()

                                        self.yang_name = "sync-delay-restart"
                                        self.yang_parent_name = "igp"

                                        self.configured = YLeaf(YType.boolean, "configured")

                                        self.delay_secs = YLeaf(YType.uint32, "delay-secs")

                                        self.remaining_secs = YLeaf(YType.uint32, "remaining-secs")

                                        self.timer_running = YLeaf(YType.boolean, "timer-running")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured",
                                                        "delay_secs",
                                                        "remaining_secs",
                                                        "timer_running") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.configured.is_set or
                                            self.delay_secs.is_set or
                                            self.remaining_secs.is_set or
                                            self.timer_running.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured.yfilter != YFilter.not_set or
                                            self.delay_secs.yfilter != YFilter.not_set or
                                            self.remaining_secs.yfilter != YFilter.not_set or
                                            self.timer_running.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sync-delay-restart" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured.is_set or self.configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured.get_name_leafdata())
                                        if (self.delay_secs.is_set or self.delay_secs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.delay_secs.get_name_leafdata())
                                        if (self.remaining_secs.is_set or self.remaining_secs.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.remaining_secs.get_name_leafdata())
                                        if (self.timer_running.is_set or self.timer_running.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.timer_running.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "configured" or name == "delay-secs" or name == "remaining-secs" or name == "timer-running"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured"):
                                            self.configured = value
                                            self.configured.value_namespace = name_space
                                            self.configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "delay-secs"):
                                            self.delay_secs = value
                                            self.delay_secs.value_namespace = name_space
                                            self.delay_secs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "remaining-secs"):
                                            self.remaining_secs = value
                                            self.remaining_secs.value_namespace = name_space
                                            self.remaining_secs.value_namespace_prefix = name_space_prefix
                                        if(value_path == "timer-running"):
                                            self.timer_running = value
                                            self.timer_running.value_namespace = name_space
                                            self.timer_running.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        (self.sync_delay_restart is not None and self.sync_delay_restart.has_data()) or
                                        (self.syncs is not None and self.syncs.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.sync_delay_restart is not None and self.sync_delay_restart.has_operation()) or
                                        (self.syncs is not None and self.syncs.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "igp" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sync-delay-restart"):
                                        if (self.sync_delay_restart is None):
                                            self.sync_delay_restart = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.SyncDelayRestart()
                                            self.sync_delay_restart.parent = self
                                            self._children_name_map["sync_delay_restart"] = "sync-delay-restart"
                                        return self.sync_delay_restart

                                    if (child_yang_name == "syncs"):
                                        if (self.syncs is None):
                                            self.syncs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp.Syncs()
                                            self.syncs.parent = self
                                            self._children_name_map["syncs"] = "syncs"
                                        return self.syncs

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sync-delay-restart" or name == "syncs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsSummary(Entity):
                                """
                                Counters for the LDP Label Infomation Base
                                (LIB)
                                
                                .. attribute:: address_family
                                
                                	Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: bind_af
                                
                                	bind af
                                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf>`
                                
                                .. attribute:: binding_local_explicit_null
                                
                                	Number of local explicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_implicit_null
                                
                                	Number of local implicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_no_route
                                
                                	Local bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_non_null
                                
                                	Number of local non\-null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_null
                                
                                	Number of local null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_oor
                                
                                	Number of local bindings        needing label \- OOR
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_no_route
                                
                                	Bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: highest_allocated_label
                                
                                	Highest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lowest_allocated_label
                                
                                	Lowest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__init__()

                                    self.yang_name = "bindings-summary"
                                    self.yang_parent_name = "af"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                    self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.bind_af = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local_explicit_null",
                                                    "binding_local_implicit_null",
                                                    "binding_local_no_route",
                                                    "binding_local_non_null",
                                                    "binding_local_null",
                                                    "binding_local_oor",
                                                    "binding_no_route",
                                                    "highest_allocated_label",
                                                    "lowest_allocated_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "bindings-summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class BindAf(Entity):
                                    """
                                    bind af
                                    
                                    .. attribute:: address_family
                                    
                                    	Binding Summary Address Family
                                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                    
                                    .. attribute:: binding_local
                                    
                                    	Number of local bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_remote
                                    
                                    	Number of remote bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_total
                                    
                                    	Total bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_lib_update
                                    
                                    	Last update to LIB local binding
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lib_minimum_revision_sent_all
                                    
                                    	Last update sent to all peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__init__()

                                        self.yang_name = "bind-af"
                                        self.yang_parent_name = "bindings-summary"

                                        self.address_family = YLeaf(YType.enumeration, "address-family")

                                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address_family",
                                                        "binding_local",
                                                        "binding_remote",
                                                        "binding_total",
                                                        "last_lib_update",
                                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address_family.is_set or
                                            self.binding_local.is_set or
                                            self.binding_remote.is_set or
                                            self.binding_total.is_set or
                                            self.last_lib_update.is_set or
                                            self.lib_minimum_revision_sent_all.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address_family.yfilter != YFilter.not_set or
                                            self.binding_local.yfilter != YFilter.not_set or
                                            self.binding_remote.yfilter != YFilter.not_set or
                                            self.binding_total.yfilter != YFilter.not_set or
                                            self.last_lib_update.yfilter != YFilter.not_set or
                                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bind-af" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address_family.get_name_leafdata())
                                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address-family"):
                                            self.address_family = value
                                            self.address_family.value_namespace = name_space
                                            self.address_family.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-local"):
                                            self.binding_local = value
                                            self.binding_local.value_namespace = name_space
                                            self.binding_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-remote"):
                                            self.binding_remote = value
                                            self.binding_remote.value_namespace = name_space
                                            self.binding_remote.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-total"):
                                            self.binding_total = value
                                            self.binding_total.value_namespace = name_space
                                            self.binding_total.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-lib-update"):
                                            self.last_lib_update = value
                                            self.last_lib_update.value_namespace = name_space
                                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lib-minimum-revision-sent-all"):
                                            self.lib_minimum_revision_sent_all = value
                                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bind_af:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local_explicit_null.is_set or
                                        self.binding_local_implicit_null.is_set or
                                        self.binding_local_no_route.is_set or
                                        self.binding_local_non_null.is_set or
                                        self.binding_local_null.is_set or
                                        self.binding_local_oor.is_set or
                                        self.binding_no_route.is_set or
                                        self.highest_allocated_label.is_set or
                                        self.lowest_allocated_label.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.bind_af:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_no_route.yfilter != YFilter.not_set or
                                        self.binding_local_non_null.yfilter != YFilter.not_set or
                                        self.binding_local_null.yfilter != YFilter.not_set or
                                        self.binding_local_oor.yfilter != YFilter.not_set or
                                        self.binding_no_route.yfilter != YFilter.not_set or
                                        self.highest_allocated_label.yfilter != YFilter.not_set or
                                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bind-af"):
                                        for c in self.bind_af:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.BindAf()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bind_af.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-explicit-null"):
                                        self.binding_local_explicit_null = value
                                        self.binding_local_explicit_null.value_namespace = name_space
                                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-implicit-null"):
                                        self.binding_local_implicit_null = value
                                        self.binding_local_implicit_null.value_namespace = name_space
                                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-no-route"):
                                        self.binding_local_no_route = value
                                        self.binding_local_no_route.value_namespace = name_space
                                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-non-null"):
                                        self.binding_local_non_null = value
                                        self.binding_local_non_null.value_namespace = name_space
                                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-null"):
                                        self.binding_local_null = value
                                        self.binding_local_null.value_namespace = name_space
                                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-oor"):
                                        self.binding_local_oor = value
                                        self.binding_local_oor.value_namespace = name_space
                                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-no-route"):
                                        self.binding_no_route = value
                                        self.binding_no_route.value_namespace = name_space
                                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "highest-allocated-label"):
                                        self.highest_allocated_label = value
                                        self.highest_allocated_label.value_namespace = name_space
                                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lowest-allocated-label"):
                                        self.lowest_allocated_label = value
                                        self.lowest_allocated_label.value_namespace = name_space
                                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                            class Interfaces(Entity):
                                """
                                LDP Interface related information
                                
                                .. attribute:: interface
                                
                                	IPv4 interface information
                                	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces, self).__init__()

                                    self.yang_name = "interfaces"
                                    self.yang_parent_name = "af"

                                    self.interface = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces, self).__setattr__(name, value)


                                class Interface(Entity):
                                    """
                                    IPv4 interface information
                                    
                                    .. attribute:: interface_name  <key>
                                    
                                    	The Interface Name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: auto_config
                                    
                                    	Auto config
                                    	**type**\: list of    :py:class:`AutoConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig>`
                                    
                                    .. attribute:: interface
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                    
                                    .. attribute:: interface_name_xr
                                    
                                    	Interface name
                                    	**type**\:  str
                                    
                                    .. attribute:: is_im_stale
                                    
                                    	Is IM information stale
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_autoconfig_disable
                                    
                                    	LDP autoconfig disable
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_config_mode
                                    
                                    	LDP config mode
                                    	**type**\:  bool
                                    
                                    .. attribute:: ldp_enabled
                                    
                                    	LDP enabled
                                    	**type**\:  bool
                                    
                                    .. attribute:: te_mesh_grp
                                    
                                    	TE tunnel mesh\-group
                                    	**type**\: list of    :py:class:`TeMeshGrp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp>`
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__init__()

                                        self.yang_name = "interface"
                                        self.yang_parent_name = "interfaces"

                                        self.interface_name = YLeaf(YType.str, "interface-name")

                                        self.interface = YLeaf(YType.str, "interface")

                                        self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                        self.is_im_stale = YLeaf(YType.boolean, "is-im-stale")

                                        self.ldp_autoconfig_disable = YLeaf(YType.boolean, "ldp-autoconfig-disable")

                                        self.ldp_config_mode = YLeaf(YType.boolean, "ldp-config-mode")

                                        self.ldp_enabled = YLeaf(YType.boolean, "ldp-enabled")

                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.auto_config = YList(self)
                                        self.te_mesh_grp = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_name",
                                                        "interface",
                                                        "interface_name_xr",
                                                        "is_im_stale",
                                                        "ldp_autoconfig_disable",
                                                        "ldp_config_mode",
                                                        "ldp_enabled") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "interface"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class TeMeshGrp(Entity):
                                        """
                                        TE tunnel mesh\-group
                                        
                                        .. attribute:: ldp_mesh_group_enabled
                                        
                                        	LDP has enabled this TE mesh\-group
                                        	**type**\:  bool
                                        
                                        .. attribute:: ldp_te_mesh_group_all_cfgd
                                        
                                        	LDP has enabled all TE mesh\-groups
                                        	**type**\:  bool
                                        
                                        .. attribute:: te_mesh_group_id
                                        
                                        	TE tunnel Mesh Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__init__()

                                            self.yang_name = "te-mesh-grp"
                                            self.yang_parent_name = "interface"

                                            self.ldp_mesh_group_enabled = YLeaf(YType.boolean, "ldp-mesh-group-enabled")

                                            self.ldp_te_mesh_group_all_cfgd = YLeaf(YType.boolean, "ldp-te-mesh-group-all-cfgd")

                                            self.te_mesh_group_id = YLeaf(YType.uint32, "te-mesh-group-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ldp_mesh_group_enabled",
                                                            "ldp_te_mesh_group_all_cfgd",
                                                            "te_mesh_group_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.ldp_mesh_group_enabled.is_set or
                                                self.ldp_te_mesh_group_all_cfgd.is_set or
                                                self.te_mesh_group_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ldp_mesh_group_enabled.yfilter != YFilter.not_set or
                                                self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set or
                                                self.te_mesh_group_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "te-mesh-grp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ldp_mesh_group_enabled.is_set or self.ldp_mesh_group_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_mesh_group_enabled.get_name_leafdata())
                                            if (self.ldp_te_mesh_group_all_cfgd.is_set or self.ldp_te_mesh_group_all_cfgd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ldp_te_mesh_group_all_cfgd.get_name_leafdata())
                                            if (self.te_mesh_group_id.is_set or self.te_mesh_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.te_mesh_group_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "ldp-mesh-group-enabled" or name == "ldp-te-mesh-group-all-cfgd" or name == "te-mesh-group-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ldp-mesh-group-enabled"):
                                                self.ldp_mesh_group_enabled = value
                                                self.ldp_mesh_group_enabled.value_namespace = name_space
                                                self.ldp_mesh_group_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ldp-te-mesh-group-all-cfgd"):
                                                self.ldp_te_mesh_group_all_cfgd = value
                                                self.ldp_te_mesh_group_all_cfgd.value_namespace = name_space
                                                self.ldp_te_mesh_group_all_cfgd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "te-mesh-group-id"):
                                                self.te_mesh_group_id = value
                                                self.te_mesh_group_id.value_namespace = name_space
                                                self.te_mesh_group_id.value_namespace_prefix = name_space_prefix


                                    class AutoConfig(Entity):
                                        """
                                        Auto config
                                        
                                        .. attribute:: tuple
                                        
                                        	Tuple
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__init__()

                                            self.yang_name = "auto-config"
                                            self.yang_parent_name = "interface"

                                            self.tuple = YLeaf(YType.str, "tuple")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("tuple") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.tuple.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.tuple.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "auto-config" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.tuple.is_set or self.tuple.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tuple.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "tuple"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "tuple"):
                                                self.tuple = value
                                                self.tuple.value_namespace = name_space
                                                self.tuple.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.auto_config:
                                            if (c.has_data()):
                                                return True
                                        for c in self.te_mesh_grp:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.interface_name.is_set or
                                            self.interface.is_set or
                                            self.interface_name_xr.is_set or
                                            self.is_im_stale.is_set or
                                            self.ldp_autoconfig_disable.is_set or
                                            self.ldp_config_mode.is_set or
                                            self.ldp_enabled.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.auto_config:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.te_mesh_grp:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_name.yfilter != YFilter.not_set or
                                            self.interface.yfilter != YFilter.not_set or
                                            self.interface_name_xr.yfilter != YFilter.not_set or
                                            self.is_im_stale.yfilter != YFilter.not_set or
                                            self.ldp_autoconfig_disable.yfilter != YFilter.not_set or
                                            self.ldp_config_mode.yfilter != YFilter.not_set or
                                            self.ldp_enabled.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name.get_name_leafdata())
                                        if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface.get_name_leafdata())
                                        if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                        if (self.is_im_stale.is_set or self.is_im_stale.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_im_stale.get_name_leafdata())
                                        if (self.ldp_autoconfig_disable.is_set or self.ldp_autoconfig_disable.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_autoconfig_disable.get_name_leafdata())
                                        if (self.ldp_config_mode.is_set or self.ldp_config_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_config_mode.get_name_leafdata())
                                        if (self.ldp_enabled.is_set or self.ldp_enabled.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ldp_enabled.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "auto-config"):
                                            for c in self.auto_config:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.AutoConfig()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.auto_config.append(c)
                                            return c

                                        if (child_yang_name == "te-mesh-grp"):
                                            for c in self.te_mesh_grp:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.TeMeshGrp()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.te_mesh_grp.append(c)
                                            return c

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "auto-config" or name == "te-mesh-grp" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "is-im-stale" or name == "ldp-autoconfig-disable" or name == "ldp-config-mode" or name == "ldp-enabled"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-name"):
                                            self.interface_name = value
                                            self.interface_name.value_namespace = name_space
                                            self.interface_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface"):
                                            self.interface = value
                                            self.interface.value_namespace = name_space
                                            self.interface.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-name-xr"):
                                            self.interface_name_xr = value
                                            self.interface_name_xr.value_namespace = name_space
                                            self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-im-stale"):
                                            self.is_im_stale = value
                                            self.is_im_stale.value_namespace = name_space
                                            self.is_im_stale.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-autoconfig-disable"):
                                            self.ldp_autoconfig_disable = value
                                            self.ldp_autoconfig_disable.value_namespace = name_space
                                            self.ldp_autoconfig_disable.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-config-mode"):
                                            self.ldp_config_mode = value
                                            self.ldp_config_mode.value_namespace = name_space
                                            self.ldp_config_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ldp-enabled"):
                                            self.ldp_enabled = value
                                            self.ldp_enabled.value_namespace = name_space
                                            self.ldp_enabled.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.interface:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.interface:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "interfaces" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "interface"):
                                        for c in self.interface:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces.Interface()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.interface.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class Discovery(Entity):
                                """
                                The LDP Discovery
                                
                                .. attribute:: brief
                                
                                	Brief information on LDP discovery
                                	**type**\:   :py:class:`Brief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief>`
                                
                                .. attribute:: link_hellos
                                
                                	The LDP Discovery link
                                	**type**\:   :py:class:`LinkHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos>`
                                
                                .. attribute:: stats
                                
                                	The LDP Discovery Statistics
                                	**type**\:   :py:class:`Stats <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats>`
                                
                                .. attribute:: summary
                                
                                	Summarized information on LDP discovery
                                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary>`
                                
                                .. attribute:: targeted_hellos
                                
                                	The LDP Discovery Targeted
                                	**type**\:   :py:class:`TargetedHellos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery, self).__init__()

                                    self.yang_name = "discovery"
                                    self.yang_parent_name = "af"

                                    self.brief = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief()
                                    self.brief.parent = self
                                    self._children_name_map["brief"] = "brief"
                                    self._children_yang_names.add("brief")

                                    self.link_hellos = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos()
                                    self.link_hellos.parent = self
                                    self._children_name_map["link_hellos"] = "link-hellos"
                                    self._children_yang_names.add("link-hellos")

                                    self.stats = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats()
                                    self.stats.parent = self
                                    self._children_name_map["stats"] = "stats"
                                    self._children_yang_names.add("stats")

                                    self.summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary()
                                    self.summary.parent = self
                                    self._children_name_map["summary"] = "summary"
                                    self._children_yang_names.add("summary")

                                    self.targeted_hellos = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos()
                                    self.targeted_hellos.parent = self
                                    self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                    self._children_yang_names.add("targeted-hellos")


                                class LinkHellos(Entity):
                                    """
                                    The LDP Discovery link
                                    
                                    .. attribute:: link_hello
                                    
                                    	Information on LDP link discovery
                                    	**type**\: list of    :py:class:`LinkHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__init__()

                                        self.yang_name = "link-hellos"
                                        self.yang_parent_name = "discovery"

                                        self.link_hello = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos, self).__setattr__(name, value)


                                    class LinkHello(Entity):
                                        """
                                        Information on LDP link discovery
                                        
                                        .. attribute:: interface_name  <key>
                                        
                                        	The Interface Name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: discovery_link_af
                                        
                                        	LDP hello AF info
                                        	**type**\: list of    :py:class:`DiscoveryLinkAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf>`
                                        
                                        .. attribute:: hello_information
                                        
                                        	LDP hello info
                                        	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation>`
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name_xr
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        .. attribute:: next_hello
                                        
                                        	Next hello due time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: quick_start_disabled
                                        
                                        	Quick\-start disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: vrf
                                        
                                        	VRF information
                                        	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__init__()

                                            self.yang_name = "link-hello"
                                            self.yang_parent_name = "link-hellos"

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                            self.next_hello = YLeaf(YType.uint32, "next-hello")

                                            self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                            self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                            self._children_yang_names.add("vrf")

                                            self.discovery_link_af = YList(self)
                                            self.hello_information = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface_name",
                                                            "interface",
                                                            "interface_name_xr",
                                                            "next_hello",
                                                            "quick_start_disabled") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello, self).__setattr__(name, value)


                                        class Vrf(Entity):
                                            """
                                            VRF information
                                            
                                            .. attribute:: id
                                            
                                            	VRF Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	VRF Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__init__()

                                                self.yang_name = "vrf"
                                                self.yang_parent_name = "link-hello"

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("id",
                                                                "name") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.id.is_set or
                                                    self.name.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.id.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "vrf" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.id.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "id" or name == "name"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "id"):
                                                    self.id = value
                                                    self.id.value_namespace = name_space
                                                    self.id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix


                                        class HelloInformation(Entity):
                                            """
                                            LDP hello info
                                            
                                            .. attribute:: disc_expiry
                                            
                                            	Discovery expiry time in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: established_age
                                            
                                            	Hello adjacency estabished age in nanosec
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: established_time
                                            
                                            	Hello adjacency estabished time in nanosec
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: hold_time
                                            
                                            	Session hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: is_no_route
                                            
                                            	Is route valid
                                            	**type**\:  bool
                                            
                                            .. attribute:: is_targeted
                                            
                                            	Is session a targeted session
                                            	**type**\:  bool
                                            
                                            .. attribute:: last_session_down_info
                                            
                                            	Last session down information
                                            	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo>`
                                            
                                            .. attribute:: local_hold_time
                                            
                                            	Local hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: neighbor_hold_time
                                            
                                            	Neighbor hold time in seconds
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            	**units**\: second
                                            
                                            .. attribute:: neighbor_ldp_identifier
                                            
                                            	Neighbor LDP Identifier
                                            	**type**\:  str
                                            
                                            .. attribute:: neighbor_src_address
                                            
                                            	Neighbor source address
                                            	**type**\:   :py:class:`NeighborSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress>`
                                            
                                            .. attribute:: neighbor_transport_address
                                            
                                            	Neighbor transport address
                                            	**type**\:   :py:class:`NeighborTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress>`
                                            
                                            .. attribute:: session_bringup_failure_reason
                                            
                                            	session bringup failure reason
                                            	**type**\:  str
                                            
                                            .. attribute:: session_up
                                            
                                            	Is session up for this adj
                                            	**type**\:  bool
                                            
                                            .. attribute:: target
                                            
                                            	Target address
                                            	**type**\:   :py:class:`Target <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__init__()

                                                self.yang_name = "hello-information"
                                                self.yang_parent_name = "link-hello"

                                                self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                                self.established_age = YLeaf(YType.uint64, "established-age")

                                                self.established_time = YLeaf(YType.uint64, "established-time")

                                                self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                self.is_no_route = YLeaf(YType.boolean, "is-no-route")

                                                self.is_targeted = YLeaf(YType.boolean, "is-targeted")

                                                self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                                self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                                self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                                self.session_up = YLeaf(YType.boolean, "session-up")

                                                self.neighbor_src_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                self.neighbor_src_address.parent = self
                                                self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                self._children_yang_names.add("neighbor-src-address")

                                                self.neighbor_transport_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                self.neighbor_transport_address.parent = self
                                                self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                self._children_yang_names.add("neighbor-transport-address")

                                                self.target = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                self.target.parent = self
                                                self._children_name_map["target"] = "target"
                                                self._children_yang_names.add("target")

                                                self.last_session_down_info = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("disc_expiry",
                                                                "established_age",
                                                                "established_time",
                                                                "hold_time",
                                                                "is_no_route",
                                                                "is_targeted",
                                                                "local_hold_time",
                                                                "neighbor_hold_time",
                                                                "neighbor_ldp_identifier",
                                                                "session_bringup_failure_reason",
                                                                "session_up") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation, self).__setattr__(name, value)


                                            class NeighborSrcAddress(Entity):
                                                """
                                                Neighbor source address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__init__()

                                                    self.yang_name = "neighbor-src-address"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "neighbor-src-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class NeighborTransportAddress(Entity):
                                                """
                                                Neighbor transport address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__init__()

                                                    self.yang_name = "neighbor-transport-address"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "neighbor-transport-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class Target(Entity):
                                                """
                                                Target address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__init__()

                                                    self.yang_name = "target"
                                                    self.yang_parent_name = "hello-information"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "target" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class LastSessionDownInfo(Entity):
                                                """
                                                Last session down information
                                                
                                                .. attribute:: last_session_down_reason
                                                
                                                	The reason of last socket failure
                                                	**type**\:  str
                                                
                                                .. attribute:: last_session_down_time
                                                
                                                	Timestamp of when the last session went down
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: last_session_up_time
                                                
                                                	The time duration the last session was up
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__init__()

                                                    self.yang_name = "last-session-down-info"
                                                    self.yang_parent_name = "hello-information"

                                                    self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                    self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                    self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("last_session_down_reason",
                                                                    "last_session_down_time",
                                                                    "last_session_up_time") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.last_session_down_reason.is_set or
                                                        self.last_session_down_time.is_set or
                                                        self.last_session_up_time.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.last_session_down_reason.yfilter != YFilter.not_set or
                                                        self.last_session_down_time.yfilter != YFilter.not_set or
                                                        self.last_session_up_time.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "last-session-down-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                    if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                    if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "last-session-down-reason"):
                                                        self.last_session_down_reason = value
                                                        self.last_session_down_reason.value_namespace = name_space
                                                        self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "last-session-down-time"):
                                                        self.last_session_down_time = value
                                                        self.last_session_down_time.value_namespace = name_space
                                                        self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "last-session-up-time"):
                                                        self.last_session_up_time = value
                                                        self.last_session_up_time.value_namespace = name_space
                                                        self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.last_session_down_info:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.disc_expiry.is_set or
                                                    self.established_age.is_set or
                                                    self.established_time.is_set or
                                                    self.hold_time.is_set or
                                                    self.is_no_route.is_set or
                                                    self.is_targeted.is_set or
                                                    self.local_hold_time.is_set or
                                                    self.neighbor_hold_time.is_set or
                                                    self.neighbor_ldp_identifier.is_set or
                                                    self.session_bringup_failure_reason.is_set or
                                                    self.session_up.is_set or
                                                    (self.neighbor_src_address is not None and self.neighbor_src_address.has_data()) or
                                                    (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_data()) or
                                                    (self.target is not None and self.target.has_data()))

                                            def has_operation(self):
                                                for c in self.last_session_down_info:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.disc_expiry.yfilter != YFilter.not_set or
                                                    self.established_age.yfilter != YFilter.not_set or
                                                    self.established_time.yfilter != YFilter.not_set or
                                                    self.hold_time.yfilter != YFilter.not_set or
                                                    self.is_no_route.yfilter != YFilter.not_set or
                                                    self.is_targeted.yfilter != YFilter.not_set or
                                                    self.local_hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                    self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                    self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                    self.session_up.yfilter != YFilter.not_set or
                                                    (self.neighbor_src_address is not None and self.neighbor_src_address.has_operation()) or
                                                    (self.neighbor_transport_address is not None and self.neighbor_transport_address.has_operation()) or
                                                    (self.target is not None and self.target.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "hello-information" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                                if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.established_age.get_name_leafdata())
                                                if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.established_time.get_name_leafdata())
                                                if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                if (self.is_no_route.is_set or self.is_no_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_no_route.get_name_leafdata())
                                                if (self.is_targeted.is_set or self.is_targeted.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_targeted.get_name_leafdata())
                                                if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                                if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                                if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                                if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.session_up.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "last-session-down-info"):
                                                    for c in self.last_session_down_info:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.LastSessionDownInfo()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.last_session_down_info.append(c)
                                                    return c

                                                if (child_yang_name == "neighbor-src-address"):
                                                    if (self.neighbor_src_address is None):
                                                        self.neighbor_src_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborSrcAddress()
                                                        self.neighbor_src_address.parent = self
                                                        self._children_name_map["neighbor_src_address"] = "neighbor-src-address"
                                                    return self.neighbor_src_address

                                                if (child_yang_name == "neighbor-transport-address"):
                                                    if (self.neighbor_transport_address is None):
                                                        self.neighbor_transport_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.NeighborTransportAddress()
                                                        self.neighbor_transport_address.parent = self
                                                        self._children_name_map["neighbor_transport_address"] = "neighbor-transport-address"
                                                    return self.neighbor_transport_address

                                                if (child_yang_name == "target"):
                                                    if (self.target is None):
                                                        self.target = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation.Target()
                                                        self.target.parent = self
                                                        self._children_name_map["target"] = "target"
                                                    return self.target

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-info" or name == "neighbor-src-address" or name == "neighbor-transport-address" or name == "target" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "is-no-route" or name == "is-targeted" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "neighbor-ldp-identifier" or name == "session-bringup-failure-reason" or name == "session-up"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "disc-expiry"):
                                                    self.disc_expiry = value
                                                    self.disc_expiry.value_namespace = name_space
                                                    self.disc_expiry.value_namespace_prefix = name_space_prefix
                                                if(value_path == "established-age"):
                                                    self.established_age = value
                                                    self.established_age.value_namespace = name_space
                                                    self.established_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "established-time"):
                                                    self.established_time = value
                                                    self.established_time.value_namespace = name_space
                                                    self.established_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "hold-time"):
                                                    self.hold_time = value
                                                    self.hold_time.value_namespace = name_space
                                                    self.hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-no-route"):
                                                    self.is_no_route = value
                                                    self.is_no_route.value_namespace = name_space
                                                    self.is_no_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-targeted"):
                                                    self.is_targeted = value
                                                    self.is_targeted.value_namespace = name_space
                                                    self.is_targeted.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-hold-time"):
                                                    self.local_hold_time = value
                                                    self.local_hold_time.value_namespace = name_space
                                                    self.local_hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-hold-time"):
                                                    self.neighbor_hold_time = value
                                                    self.neighbor_hold_time.value_namespace = name_space
                                                    self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "neighbor-ldp-identifier"):
                                                    self.neighbor_ldp_identifier = value
                                                    self.neighbor_ldp_identifier.value_namespace = name_space
                                                    self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-bringup-failure-reason"):
                                                    self.session_bringup_failure_reason = value
                                                    self.session_bringup_failure_reason.value_namespace = name_space
                                                    self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "session-up"):
                                                    self.session_up = value
                                                    self.session_up.value_namespace = name_space
                                                    self.session_up.value_namespace_prefix = name_space_prefix


                                        class DiscoveryLinkAf(Entity):
                                            """
                                            LDP hello AF info
                                            
                                            .. attribute:: interval
                                            
                                            	Hello interval in sec
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: local_src_address
                                            
                                            	Local source address
                                            	**type**\:   :py:class:`LocalSrcAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress>`
                                            
                                            .. attribute:: local_transport_address
                                            
                                            	Local transport address
                                            	**type**\:   :py:class:`LocalTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__init__()

                                                self.yang_name = "discovery-link-af"
                                                self.yang_parent_name = "link-hello"

                                                self.interval = YLeaf(YType.uint32, "interval")

                                                self.local_src_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                self.local_src_address.parent = self
                                                self._children_name_map["local_src_address"] = "local-src-address"
                                                self._children_yang_names.add("local-src-address")

                                                self.local_transport_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                self.local_transport_address.parent = self
                                                self._children_name_map["local_transport_address"] = "local-transport-address"
                                                self._children_yang_names.add("local-transport-address")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interval") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf, self).__setattr__(name, value)


                                            class LocalSrcAddress(Entity):
                                                """
                                                Local source address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__init__()

                                                    self.yang_name = "local-src-address"
                                                    self.yang_parent_name = "discovery-link-af"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "local-src-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class LocalTransportAddress(Entity):
                                                """
                                                Local transport address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__init__()

                                                    self.yang_name = "local-transport-address"
                                                    self.yang_parent_name = "discovery-link-af"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "local-transport-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.interval.is_set or
                                                    (self.local_src_address is not None and self.local_src_address.has_data()) or
                                                    (self.local_transport_address is not None and self.local_transport_address.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interval.yfilter != YFilter.not_set or
                                                    (self.local_src_address is not None and self.local_src_address.has_operation()) or
                                                    (self.local_transport_address is not None and self.local_transport_address.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "discovery-link-af" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interval.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "local-src-address"):
                                                    if (self.local_src_address is None):
                                                        self.local_src_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalSrcAddress()
                                                        self.local_src_address.parent = self
                                                        self._children_name_map["local_src_address"] = "local-src-address"
                                                    return self.local_src_address

                                                if (child_yang_name == "local-transport-address"):
                                                    if (self.local_transport_address is None):
                                                        self.local_transport_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf.LocalTransportAddress()
                                                        self.local_transport_address.parent = self
                                                        self._children_name_map["local_transport_address"] = "local-transport-address"
                                                    return self.local_transport_address

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "local-src-address" or name == "local-transport-address" or name == "interval"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interval"):
                                                    self.interval = value
                                                    self.interval.value_namespace = name_space
                                                    self.interval.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.discovery_link_af:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.hello_information:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.interface_name.is_set or
                                                self.interface.is_set or
                                                self.interface_name_xr.is_set or
                                                self.next_hello.is_set or
                                                self.quick_start_disabled.is_set or
                                                (self.vrf is not None and self.vrf.has_data()))

                                        def has_operation(self):
                                            for c in self.discovery_link_af:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.hello_information:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name_xr.yfilter != YFilter.not_set or
                                                self.next_hello.yfilter != YFilter.not_set or
                                                self.quick_start_disabled.yfilter != YFilter.not_set or
                                                (self.vrf is not None and self.vrf.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())
                                            if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hello.get_name_leafdata())
                                            if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "discovery-link-af"):
                                                for c in self.discovery_link_af:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.DiscoveryLinkAf()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.discovery_link_af.append(c)
                                                return c

                                            if (child_yang_name == "hello-information"):
                                                for c in self.hello_information:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.HelloInformation()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.hello_information.append(c)
                                                return c

                                            if (child_yang_name == "vrf"):
                                                if (self.vrf is None):
                                                    self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello.Vrf()
                                                    self.vrf.parent = self
                                                    self._children_name_map["vrf"] = "vrf"
                                                return self.vrf

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "discovery-link-af" or name == "hello-information" or name == "vrf" or name == "interface-name" or name == "interface" or name == "interface-name-xr" or name == "next-hello" or name == "quick-start-disabled"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name-xr"):
                                                self.interface_name_xr = value
                                                self.interface_name_xr.value_namespace = name_space
                                                self.interface_name_xr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hello"):
                                                self.next_hello = value
                                                self.next_hello.value_namespace = name_space
                                                self.next_hello.value_namespace_prefix = name_space_prefix
                                            if(value_path == "quick-start-disabled"):
                                                self.quick_start_disabled = value
                                                self.quick_start_disabled.value_namespace = name_space
                                                self.quick_start_disabled.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.link_hello:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.link_hello:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "link-hellos" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello"):
                                            for c in self.link_hello:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos.LinkHello()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.link_hello.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Summary(Entity):
                                    """
                                    Summarized information on LDP discovery
                                    
                                    .. attribute:: local_ldp_id
                                    
                                    	Local LDP identifier
                                    	**type**\:  str
                                    
                                    .. attribute:: num_of_active_ldp_interfaces
                                    
                                    	Number of active LDP enabled interfaces
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_addr_recv
                                    
                                    	Number of hello discoveries received with bad source address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_hello_pdu
                                    
                                    	Number of hello discoveries received with bad hello PDU
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_bad_xport_addr
                                    
                                    	Number of hello discoveries received with bad export address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_same_router_id
                                    
                                    	Number of hello discoveries received with the same router id as this router
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_disc_with_wrong_router_id
                                    
                                    	Number of hello discoveries received with the router id that is not destined for this router
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_ldp_interfaces
                                    
                                    	Total Number of LDP configured interfaces
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_lnk_disc_recv
                                    
                                    	Number of link hello discoveries in recv state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_lnk_disc_xmit
                                    
                                    	Number of link hello discoveries in xmit state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_tgt_disc_recv
                                    
                                    	Number of targeted hello discoveries in recv state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_of_tgt_disc_xmit
                                    
                                    	Number of targeted hello discoveries in xmit state
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__init__()

                                        self.yang_name = "summary"
                                        self.yang_parent_name = "discovery"

                                        self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                                        self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                                        self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                                        self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                                        self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                                        self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                                        self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                                        self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                                        self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                                        self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                                        self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                                        self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("local_ldp_id",
                                                        "num_of_active_ldp_interfaces",
                                                        "num_of_disc_with_bad_addr_recv",
                                                        "num_of_disc_with_bad_hello_pdu",
                                                        "num_of_disc_with_bad_xport_addr",
                                                        "num_of_disc_with_same_router_id",
                                                        "num_of_disc_with_wrong_router_id",
                                                        "num_of_ldp_interfaces",
                                                        "num_of_lnk_disc_recv",
                                                        "num_of_lnk_disc_xmit",
                                                        "num_of_tgt_disc_recv",
                                                        "num_of_tgt_disc_xmit") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "summary"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.local_ldp_id.is_set or
                                            self.num_of_active_ldp_interfaces.is_set or
                                            self.num_of_disc_with_bad_addr_recv.is_set or
                                            self.num_of_disc_with_bad_hello_pdu.is_set or
                                            self.num_of_disc_with_bad_xport_addr.is_set or
                                            self.num_of_disc_with_same_router_id.is_set or
                                            self.num_of_disc_with_wrong_router_id.is_set or
                                            self.num_of_ldp_interfaces.is_set or
                                            self.num_of_lnk_disc_recv.is_set or
                                            self.num_of_lnk_disc_xmit.is_set or
                                            self.num_of_tgt_disc_recv.is_set or
                                            self.num_of_tgt_disc_xmit.is_set or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.local_ldp_id.yfilter != YFilter.not_set or
                                            self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                                            self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                                            self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                                            self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                                            self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                                            self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                                            self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "summary" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                                        if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                                        if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                                        if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                                        if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                                        if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                                        if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                                        if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                                        if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                                        if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "local-ldp-id"):
                                            self.local_ldp_id = value
                                            self.local_ldp_id.value_namespace = name_space
                                            self.local_ldp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-active-ldp-interfaces"):
                                            self.num_of_active_ldp_interfaces = value
                                            self.num_of_active_ldp_interfaces.value_namespace = name_space
                                            self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-addr-recv"):
                                            self.num_of_disc_with_bad_addr_recv = value
                                            self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                                            self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-hello-pdu"):
                                            self.num_of_disc_with_bad_hello_pdu = value
                                            self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                                            self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-bad-xport-addr"):
                                            self.num_of_disc_with_bad_xport_addr = value
                                            self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                                            self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-same-router-id"):
                                            self.num_of_disc_with_same_router_id = value
                                            self.num_of_disc_with_same_router_id.value_namespace = name_space
                                            self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-disc-with-wrong-router-id"):
                                            self.num_of_disc_with_wrong_router_id = value
                                            self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                                            self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-ldp-interfaces"):
                                            self.num_of_ldp_interfaces = value
                                            self.num_of_ldp_interfaces.value_namespace = name_space
                                            self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-lnk-disc-recv"):
                                            self.num_of_lnk_disc_recv = value
                                            self.num_of_lnk_disc_recv.value_namespace = name_space
                                            self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-lnk-disc-xmit"):
                                            self.num_of_lnk_disc_xmit = value
                                            self.num_of_lnk_disc_xmit.value_namespace = name_space
                                            self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-tgt-disc-recv"):
                                            self.num_of_tgt_disc_recv = value
                                            self.num_of_tgt_disc_recv.value_namespace = name_space
                                            self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-of-tgt-disc-xmit"):
                                            self.num_of_tgt_disc_xmit = value
                                            self.num_of_tgt_disc_xmit.value_namespace = name_space
                                            self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix


                                class TargetedHellos(Entity):
                                    """
                                    The LDP Discovery Targeted
                                    
                                    .. attribute:: targeted_hello
                                    
                                    	Information on LDP targeted discovery
                                    	**type**\: list of    :py:class:`TargetedHello <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__init__()

                                        self.yang_name = "targeted-hellos"
                                        self.yang_parent_name = "discovery"

                                        self.targeted_hello = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos, self).__setattr__(name, value)


                                    class TargetedHello(Entity):
                                        """
                                        Information on LDP targeted discovery
                                        
                                        .. attribute:: adjacency_ldp_identifier
                                        
                                        	Adjacency LDP Identifier
                                        	**type**\:  str
                                        
                                        .. attribute:: dhcb_local_address
                                        
                                        	DHCB local address
                                        	**type**\:   :py:class:`DhcbLocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress>`
                                        
                                        .. attribute:: dhcb_target_address
                                        
                                        	DHCB target address
                                        	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress>`
                                        
                                        .. attribute:: disc_expiry
                                        
                                        	Discovery expiry time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: established_age
                                        
                                        	Hello adjacency estabished age in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: established_time
                                        
                                        	Hello adjacency estabished time in nanosec
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: hold_time
                                        
                                        	Targeted hello hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: interval
                                        
                                        	Hello interval in sec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: last_session_down_info
                                        
                                        	Last session down information
                                        	**type**\: list of    :py:class:`LastSessionDownInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo>`
                                        
                                        .. attribute:: local_address
                                        
                                        	Local IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: local_hold_time
                                        
                                        	Local hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: neighbor_hold_time
                                        
                                        	Neighbor hold time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: next_hello
                                        
                                        	Next hello due time in msec
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: quick_start_disabled
                                        
                                        	Quick\-start disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: session_bringup_failure_reason
                                        
                                        	session bringup failure reason
                                        	**type**\:  str
                                        
                                        .. attribute:: session_up
                                        
                                        	Is session up for this adj
                                        	**type**\:  bool
                                        
                                        .. attribute:: state
                                        
                                        	Targeted hello state
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	The target IP Address
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__init__()

                                            self.yang_name = "targeted-hello"
                                            self.yang_parent_name = "targeted-hellos"

                                            self.adjacency_ldp_identifier = YLeaf(YType.str, "adjacency-ldp-identifier")

                                            self.disc_expiry = YLeaf(YType.uint32, "disc-expiry")

                                            self.established_age = YLeaf(YType.uint64, "established-age")

                                            self.established_time = YLeaf(YType.uint64, "established-time")

                                            self.hold_time = YLeaf(YType.uint32, "hold-time")

                                            self.interval = YLeaf(YType.uint32, "interval")

                                            self.local_address = YLeaf(YType.str, "local-address")

                                            self.local_hold_time = YLeaf(YType.uint32, "local-hold-time")

                                            self.neighbor_hold_time = YLeaf(YType.uint32, "neighbor-hold-time")

                                            self.next_hello = YLeaf(YType.uint32, "next-hello")

                                            self.quick_start_disabled = YLeaf(YType.boolean, "quick-start-disabled")

                                            self.session_bringup_failure_reason = YLeaf(YType.str, "session-bringup-failure-reason")

                                            self.session_up = YLeaf(YType.boolean, "session-up")

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.target_address = YLeaf(YType.str, "target-address")

                                            self.dhcb_local_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                            self.dhcb_local_address.parent = self
                                            self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                            self._children_yang_names.add("dhcb-local-address")

                                            self.dhcb_target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                            self.dhcb_target_address.parent = self
                                            self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                            self._children_yang_names.add("dhcb-target-address")

                                            self.last_session_down_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("adjacency_ldp_identifier",
                                                            "disc_expiry",
                                                            "established_age",
                                                            "established_time",
                                                            "hold_time",
                                                            "interval",
                                                            "local_address",
                                                            "local_hold_time",
                                                            "neighbor_hold_time",
                                                            "next_hello",
                                                            "quick_start_disabled",
                                                            "session_bringup_failure_reason",
                                                            "session_up",
                                                            "state",
                                                            "target_address") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello, self).__setattr__(name, value)


                                        class DhcbLocalAddress(Entity):
                                            """
                                            DHCB local address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__init__()

                                                self.yang_name = "dhcb-local-address"
                                                self.yang_parent_name = "targeted-hello"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class DhcbTargetAddress(Entity):
                                            """
                                            DHCB target address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__init__()

                                                self.yang_name = "dhcb-target-address"
                                                self.yang_parent_name = "targeted-hello"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "dhcb-target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class LastSessionDownInfo(Entity):
                                            """
                                            Last session down information
                                            
                                            .. attribute:: last_session_down_reason
                                            
                                            	The reason of last socket failure
                                            	**type**\:  str
                                            
                                            .. attribute:: last_session_down_time
                                            
                                            	Timestamp of when the last session went down
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: last_session_up_time
                                            
                                            	The time duration the last session was up
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__init__()

                                                self.yang_name = "last-session-down-info"
                                                self.yang_parent_name = "targeted-hello"

                                                self.last_session_down_reason = YLeaf(YType.str, "last-session-down-reason")

                                                self.last_session_down_time = YLeaf(YType.uint64, "last-session-down-time")

                                                self.last_session_up_time = YLeaf(YType.uint32, "last-session-up-time")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("last_session_down_reason",
                                                                "last_session_down_time",
                                                                "last_session_up_time") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.last_session_down_reason.is_set or
                                                    self.last_session_down_time.is_set or
                                                    self.last_session_up_time.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.last_session_down_reason.yfilter != YFilter.not_set or
                                                    self.last_session_down_time.yfilter != YFilter.not_set or
                                                    self.last_session_up_time.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "last-session-down-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.last_session_down_reason.is_set or self.last_session_down_reason.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_reason.get_name_leafdata())
                                                if (self.last_session_down_time.is_set or self.last_session_down_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_down_time.get_name_leafdata())
                                                if (self.last_session_up_time.is_set or self.last_session_up_time.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.last_session_up_time.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "last-session-down-reason" or name == "last-session-down-time" or name == "last-session-up-time"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "last-session-down-reason"):
                                                    self.last_session_down_reason = value
                                                    self.last_session_down_reason.value_namespace = name_space
                                                    self.last_session_down_reason.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-down-time"):
                                                    self.last_session_down_time = value
                                                    self.last_session_down_time.value_namespace = name_space
                                                    self.last_session_down_time.value_namespace_prefix = name_space_prefix
                                                if(value_path == "last-session-up-time"):
                                                    self.last_session_up_time = value
                                                    self.last_session_up_time.value_namespace = name_space
                                                    self.last_session_up_time.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.adjacency_ldp_identifier.is_set or
                                                self.disc_expiry.is_set or
                                                self.established_age.is_set or
                                                self.established_time.is_set or
                                                self.hold_time.is_set or
                                                self.interval.is_set or
                                                self.local_address.is_set or
                                                self.local_hold_time.is_set or
                                                self.neighbor_hold_time.is_set or
                                                self.next_hello.is_set or
                                                self.quick_start_disabled.is_set or
                                                self.session_bringup_failure_reason.is_set or
                                                self.session_up.is_set or
                                                self.state.is_set or
                                                self.target_address.is_set or
                                                (self.dhcb_local_address is not None and self.dhcb_local_address.has_data()) or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()))

                                        def has_operation(self):
                                            for c in self.last_session_down_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.adjacency_ldp_identifier.yfilter != YFilter.not_set or
                                                self.disc_expiry.yfilter != YFilter.not_set or
                                                self.established_age.yfilter != YFilter.not_set or
                                                self.established_time.yfilter != YFilter.not_set or
                                                self.hold_time.yfilter != YFilter.not_set or
                                                self.interval.yfilter != YFilter.not_set or
                                                self.local_address.yfilter != YFilter.not_set or
                                                self.local_hold_time.yfilter != YFilter.not_set or
                                                self.neighbor_hold_time.yfilter != YFilter.not_set or
                                                self.next_hello.yfilter != YFilter.not_set or
                                                self.quick_start_disabled.yfilter != YFilter.not_set or
                                                self.session_bringup_failure_reason.yfilter != YFilter.not_set or
                                                self.session_up.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                self.target_address.yfilter != YFilter.not_set or
                                                (self.dhcb_local_address is not None and self.dhcb_local_address.has_operation()) or
                                                (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.adjacency_ldp_identifier.is_set or self.adjacency_ldp_identifier.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.adjacency_ldp_identifier.get_name_leafdata())
                                            if (self.disc_expiry.is_set or self.disc_expiry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.disc_expiry.get_name_leafdata())
                                            if (self.established_age.is_set or self.established_age.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_age.get_name_leafdata())
                                            if (self.established_time.is_set or self.established_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.established_time.get_name_leafdata())
                                            if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_time.get_name_leafdata())
                                            if (self.interval.is_set or self.interval.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interval.get_name_leafdata())
                                            if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_address.get_name_leafdata())
                                            if (self.local_hold_time.is_set or self.local_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.local_hold_time.get_name_leafdata())
                                            if (self.neighbor_hold_time.is_set or self.neighbor_hold_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.neighbor_hold_time.get_name_leafdata())
                                            if (self.next_hello.is_set or self.next_hello.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.next_hello.get_name_leafdata())
                                            if (self.quick_start_disabled.is_set or self.quick_start_disabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.quick_start_disabled.get_name_leafdata())
                                            if (self.session_bringup_failure_reason.is_set or self.session_bringup_failure_reason.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_bringup_failure_reason.get_name_leafdata())
                                            if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.session_up.get_name_leafdata())
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())
                                            if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.target_address.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "dhcb-local-address"):
                                                if (self.dhcb_local_address is None):
                                                    self.dhcb_local_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbLocalAddress()
                                                    self.dhcb_local_address.parent = self
                                                    self._children_name_map["dhcb_local_address"] = "dhcb-local-address"
                                                return self.dhcb_local_address

                                            if (child_yang_name == "dhcb-target-address"):
                                                if (self.dhcb_target_address is None):
                                                    self.dhcb_target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.DhcbTargetAddress()
                                                    self.dhcb_target_address.parent = self
                                                    self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                return self.dhcb_target_address

                                            if (child_yang_name == "last-session-down-info"):
                                                for c in self.last_session_down_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello.LastSessionDownInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.last_session_down_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "dhcb-local-address" or name == "dhcb-target-address" or name == "last-session-down-info" or name == "adjacency-ldp-identifier" or name == "disc-expiry" or name == "established-age" or name == "established-time" or name == "hold-time" or name == "interval" or name == "local-address" or name == "local-hold-time" or name == "neighbor-hold-time" or name == "next-hello" or name == "quick-start-disabled" or name == "session-bringup-failure-reason" or name == "session-up" or name == "state" or name == "target-address"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "adjacency-ldp-identifier"):
                                                self.adjacency_ldp_identifier = value
                                                self.adjacency_ldp_identifier.value_namespace = name_space
                                                self.adjacency_ldp_identifier.value_namespace_prefix = name_space_prefix
                                            if(value_path == "disc-expiry"):
                                                self.disc_expiry = value
                                                self.disc_expiry.value_namespace = name_space
                                                self.disc_expiry.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-age"):
                                                self.established_age = value
                                                self.established_age.value_namespace = name_space
                                                self.established_age.value_namespace_prefix = name_space_prefix
                                            if(value_path == "established-time"):
                                                self.established_time = value
                                                self.established_time.value_namespace = name_space
                                                self.established_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-time"):
                                                self.hold_time = value
                                                self.hold_time.value_namespace = name_space
                                                self.hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interval"):
                                                self.interval = value
                                                self.interval.value_namespace = name_space
                                                self.interval.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-address"):
                                                self.local_address = value
                                                self.local_address.value_namespace = name_space
                                                self.local_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "local-hold-time"):
                                                self.local_hold_time = value
                                                self.local_hold_time.value_namespace = name_space
                                                self.local_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "neighbor-hold-time"):
                                                self.neighbor_hold_time = value
                                                self.neighbor_hold_time.value_namespace = name_space
                                                self.neighbor_hold_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "next-hello"):
                                                self.next_hello = value
                                                self.next_hello.value_namespace = name_space
                                                self.next_hello.value_namespace_prefix = name_space_prefix
                                            if(value_path == "quick-start-disabled"):
                                                self.quick_start_disabled = value
                                                self.quick_start_disabled.value_namespace = name_space
                                                self.quick_start_disabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-bringup-failure-reason"):
                                                self.session_bringup_failure_reason = value
                                                self.session_bringup_failure_reason.value_namespace = name_space
                                                self.session_bringup_failure_reason.value_namespace_prefix = name_space_prefix
                                            if(value_path == "session-up"):
                                                self.session_up = value
                                                self.session_up.value_namespace = name_space
                                                self.session_up.value_namespace_prefix = name_space_prefix
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "target-address"):
                                                self.target_address = value
                                                self.target_address.value_namespace = name_space
                                                self.target_address.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.targeted_hello:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.targeted_hello:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "targeted-hellos" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "targeted-hello"):
                                            for c in self.targeted_hello:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos.TargetedHello()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.targeted_hello.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "targeted-hello"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Brief(Entity):
                                    """
                                    Brief information on LDP discovery
                                    
                                    .. attribute:: link_hello_briefs
                                    
                                    	The LDP Discovery link brief information
                                    	**type**\:   :py:class:`LinkHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs>`
                                    
                                    .. attribute:: targeted_hello_briefs
                                    
                                    	The LDP Discovery Targeted brief information
                                    	**type**\:   :py:class:`TargetedHelloBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief, self).__init__()

                                        self.yang_name = "brief"
                                        self.yang_parent_name = "discovery"

                                        self.link_hello_briefs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                        self.link_hello_briefs.parent = self
                                        self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                        self._children_yang_names.add("link-hello-briefs")

                                        self.targeted_hello_briefs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                        self.targeted_hello_briefs.parent = self
                                        self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                        self._children_yang_names.add("targeted-hello-briefs")


                                    class LinkHelloBriefs(Entity):
                                        """
                                        The LDP Discovery link brief information
                                        
                                        .. attribute:: link_hello_brief
                                        
                                        	Brief information on LDP link discovery
                                        	**type**\: list of    :py:class:`LinkHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__init__()

                                            self.yang_name = "link-hello-briefs"
                                            self.yang_parent_name = "brief"

                                            self.link_hello_brief = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs, self).__setattr__(name, value)


                                        class LinkHelloBrief(Entity):
                                            """
                                            Brief information on LDP link discovery
                                            
                                            .. attribute:: interface_name  <key>
                                            
                                            	The Interface Name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: address_family
                                            
                                            	Discovery Brief Address Family
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: address_family_set
                                            
                                            	Discovery Brief Address Family Set
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: hello_information
                                            
                                            	LDP hello info
                                            	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation>`
                                            
                                            .. attribute:: interface
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: interface_name_xr
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            .. attribute:: vrf
                                            
                                            	VRF information
                                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__init__()

                                                self.yang_name = "link-hello-brief"
                                                self.yang_parent_name = "link-hello-briefs"

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                                self.address_family_set = YLeaf(YType.enumeration, "address-family-set")

                                                self.interface = YLeaf(YType.str, "interface")

                                                self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                                self._children_yang_names.add("vrf")

                                                self.hello_information = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("interface_name",
                                                                "address_family",
                                                                "address_family_set",
                                                                "interface",
                                                                "interface_name_xr") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief, self).__setattr__(name, value)


                                            class Vrf(Entity):
                                                """
                                                VRF information
                                                
                                                .. attribute:: id
                                                
                                                	VRF Id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	VRF Name
                                                	**type**\:  str
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__init__()

                                                    self.yang_name = "vrf"
                                                    self.yang_parent_name = "link-hello-brief"

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("id",
                                                                    "name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.id.is_set or
                                                        self.name.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.id.yfilter != YFilter.not_set or
                                                        self.name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "vrf" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.id.get_name_leafdata())
                                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "id" or name == "name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "id"):
                                                        self.id = value
                                                        self.id.value_namespace = name_space
                                                        self.id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "name"):
                                                        self.name = value
                                                        self.name.value_namespace = name_space
                                                        self.name.value_namespace_prefix = name_space_prefix


                                            class HelloInformation(Entity):
                                                """
                                                LDP hello info
                                                
                                                .. attribute:: hold_time
                                                
                                                	Session hold time in sec
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: neighbor_ldp_identifier
                                                
                                                	Neighbor LDP Identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: session_up
                                                
                                                	Is session up for this adj
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__init__()

                                                    self.yang_name = "hello-information"
                                                    self.yang_parent_name = "link-hello-brief"

                                                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                    self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                    self.session_up = YLeaf(YType.boolean, "session-up")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("hold_time",
                                                                    "neighbor_ldp_identifier",
                                                                    "session_up") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.hold_time.is_set or
                                                        self.neighbor_ldp_identifier.is_set or
                                                        self.session_up.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.hold_time.yfilter != YFilter.not_set or
                                                        self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                        self.session_up.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "hello-information" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                    if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                    if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.session_up.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "hold-time"):
                                                        self.hold_time = value
                                                        self.hold_time.value_namespace = name_space
                                                        self.hold_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "neighbor-ldp-identifier"):
                                                        self.neighbor_ldp_identifier = value
                                                        self.neighbor_ldp_identifier.value_namespace = name_space
                                                        self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "session-up"):
                                                        self.session_up = value
                                                        self.session_up.value_namespace = name_space
                                                        self.session_up.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.hello_information:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.interface_name.is_set or
                                                    self.address_family.is_set or
                                                    self.address_family_set.is_set or
                                                    self.interface.is_set or
                                                    self.interface_name_xr.is_set or
                                                    (self.vrf is not None and self.vrf.has_data()))

                                            def has_operation(self):
                                                for c in self.hello_information:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.address_family.yfilter != YFilter.not_set or
                                                    self.address_family_set.yfilter != YFilter.not_set or
                                                    self.interface.yfilter != YFilter.not_set or
                                                    self.interface_name_xr.yfilter != YFilter.not_set or
                                                    (self.vrf is not None and self.vrf.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "link-hello-brief" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                                if (self.address_family_set.is_set or self.address_family_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family_set.get_name_leafdata())
                                                if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface.get_name_leafdata())
                                                if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "hello-information"):
                                                    for c in self.hello_information:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.HelloInformation()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.hello_information.append(c)
                                                    return c

                                                if (child_yang_name == "vrf"):
                                                    if (self.vrf is None):
                                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief.Vrf()
                                                        self.vrf.parent = self
                                                        self._children_name_map["vrf"] = "vrf"
                                                    return self.vrf

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "hello-information" or name == "vrf" or name == "interface-name" or name == "address-family" or name == "address-family-set" or name == "interface" or name == "interface-name-xr"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "address-family"):
                                                    self.address_family = value
                                                    self.address_family.value_namespace = name_space
                                                    self.address_family.value_namespace_prefix = name_space_prefix
                                                if(value_path == "address-family-set"):
                                                    self.address_family_set = value
                                                    self.address_family_set.value_namespace = name_space
                                                    self.address_family_set.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface"):
                                                    self.interface = value
                                                    self.interface.value_namespace = name_space
                                                    self.interface.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface-name-xr"):
                                                    self.interface_name_xr = value
                                                    self.interface_name_xr.value_namespace = name_space
                                                    self.interface_name_xr.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.link_hello_brief:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.link_hello_brief:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-briefs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "link-hello-brief"):
                                                for c in self.link_hello_brief:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs.LinkHelloBrief()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.link_hello_brief.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "link-hello-brief"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TargetedHelloBriefs(Entity):
                                        """
                                        The LDP Discovery Targeted brief information
                                        
                                        .. attribute:: targeted_hello_brief
                                        
                                        	Brief information on LDP targeted discovery
                                        	**type**\: list of    :py:class:`TargetedHelloBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__init__()

                                            self.yang_name = "targeted-hello-briefs"
                                            self.yang_parent_name = "brief"

                                            self.targeted_hello_brief = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs, self).__setattr__(name, value)


                                        class TargetedHelloBrief(Entity):
                                            """
                                            Brief information on LDP targeted discovery
                                            
                                            .. attribute:: address_family
                                            
                                            	Targeted Discovery Address Family
                                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                            
                                            .. attribute:: dhcb_target_address
                                            
                                            	DHCB target address
                                            	**type**\:   :py:class:`DhcbTargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress>`
                                            
                                            .. attribute:: hello_information
                                            
                                            	LDP hello info
                                            	**type**\: list of    :py:class:`HelloInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation>`
                                            
                                            .. attribute:: local_address
                                            
                                            	Local IP Address
                                            	**type**\: one of the below types:
                                            
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            .. attribute:: target_address
                                            
                                            	The target IP Address
                                            	**type**\: one of the below types:
                                            
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            
                                            ----
                                            .. attribute:: vrf
                                            
                                            	VRF information
                                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__init__()

                                                self.yang_name = "targeted-hello-brief"
                                                self.yang_parent_name = "targeted-hello-briefs"

                                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                                self.local_address = YLeaf(YType.str, "local-address")

                                                self.target_address = YLeaf(YType.str, "target-address")

                                                self.dhcb_target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                self.dhcb_target_address.parent = self
                                                self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                self._children_yang_names.add("dhcb-target-address")

                                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                                self._children_yang_names.add("vrf")

                                                self.hello_information = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("address_family",
                                                                "local_address",
                                                                "target_address") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief, self).__setattr__(name, value)


                                            class Vrf(Entity):
                                                """
                                                VRF information
                                                
                                                .. attribute:: id
                                                
                                                	VRF Id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	VRF Name
                                                	**type**\:  str
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__init__()

                                                    self.yang_name = "vrf"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("id",
                                                                    "name") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.id.is_set or
                                                        self.name.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.id.yfilter != YFilter.not_set or
                                                        self.name.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "vrf" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.id.get_name_leafdata())
                                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.name.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "id" or name == "name"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "id"):
                                                        self.id = value
                                                        self.id.value_namespace = name_space
                                                        self.id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "name"):
                                                        self.name = value
                                                        self.name.value_namespace = name_space
                                                        self.name.value_namespace_prefix = name_space_prefix


                                            class DhcbTargetAddress(Entity):
                                                """
                                                DHCB target address
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__init__()

                                                    self.yang_name = "dhcb-target-address"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "dhcb-target-address" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class HelloInformation(Entity):
                                                """
                                                LDP hello info
                                                
                                                .. attribute:: hold_time
                                                
                                                	Session hold time in sec
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: neighbor_ldp_identifier
                                                
                                                	Neighbor LDP Identifier
                                                	**type**\:  str
                                                
                                                .. attribute:: session_up
                                                
                                                	Is session up for this adj
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__init__()

                                                    self.yang_name = "hello-information"
                                                    self.yang_parent_name = "targeted-hello-brief"

                                                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                                                    self.neighbor_ldp_identifier = YLeaf(YType.str, "neighbor-ldp-identifier")

                                                    self.session_up = YLeaf(YType.boolean, "session-up")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("hold_time",
                                                                    "neighbor_ldp_identifier",
                                                                    "session_up") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.hold_time.is_set or
                                                        self.neighbor_ldp_identifier.is_set or
                                                        self.session_up.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.hold_time.yfilter != YFilter.not_set or
                                                        self.neighbor_ldp_identifier.yfilter != YFilter.not_set or
                                                        self.session_up.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "hello-information" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                                                    if (self.neighbor_ldp_identifier.is_set or self.neighbor_ldp_identifier.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.neighbor_ldp_identifier.get_name_leafdata())
                                                    if (self.session_up.is_set or self.session_up.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.session_up.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "hold-time" or name == "neighbor-ldp-identifier" or name == "session-up"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "hold-time"):
                                                        self.hold_time = value
                                                        self.hold_time.value_namespace = name_space
                                                        self.hold_time.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "neighbor-ldp-identifier"):
                                                        self.neighbor_ldp_identifier = value
                                                        self.neighbor_ldp_identifier.value_namespace = name_space
                                                        self.neighbor_ldp_identifier.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "session-up"):
                                                        self.session_up = value
                                                        self.session_up.value_namespace = name_space
                                                        self.session_up.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.hello_information:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.address_family.is_set or
                                                    self.local_address.is_set or
                                                    self.target_address.is_set or
                                                    (self.dhcb_target_address is not None and self.dhcb_target_address.has_data()) or
                                                    (self.vrf is not None and self.vrf.has_data()))

                                            def has_operation(self):
                                                for c in self.hello_information:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.address_family.yfilter != YFilter.not_set or
                                                    self.local_address.yfilter != YFilter.not_set or
                                                    self.target_address.yfilter != YFilter.not_set or
                                                    (self.dhcb_target_address is not None and self.dhcb_target_address.has_operation()) or
                                                    (self.vrf is not None and self.vrf.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "targeted-hello-brief" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                                if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_address.get_name_leafdata())
                                                if (self.target_address.is_set or self.target_address.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.target_address.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "dhcb-target-address"):
                                                    if (self.dhcb_target_address is None):
                                                        self.dhcb_target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.DhcbTargetAddress()
                                                        self.dhcb_target_address.parent = self
                                                        self._children_name_map["dhcb_target_address"] = "dhcb-target-address"
                                                    return self.dhcb_target_address

                                                if (child_yang_name == "hello-information"):
                                                    for c in self.hello_information:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.HelloInformation()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.hello_information.append(c)
                                                    return c

                                                if (child_yang_name == "vrf"):
                                                    if (self.vrf is None):
                                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief.Vrf()
                                                        self.vrf.parent = self
                                                        self._children_name_map["vrf"] = "vrf"
                                                    return self.vrf

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "dhcb-target-address" or name == "hello-information" or name == "vrf" or name == "address-family" or name == "local-address" or name == "target-address"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "address-family"):
                                                    self.address_family = value
                                                    self.address_family.value_namespace = name_space
                                                    self.address_family.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-address"):
                                                    self.local_address = value
                                                    self.local_address.value_namespace = name_space
                                                    self.local_address.value_namespace_prefix = name_space_prefix
                                                if(value_path == "target-address"):
                                                    self.target_address = value
                                                    self.target_address.value_namespace = name_space
                                                    self.target_address.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.targeted_hello_brief:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.targeted_hello_brief:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "targeted-hello-briefs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "targeted-hello-brief"):
                                                for c in self.targeted_hello_brief:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs.TargetedHelloBrief()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.targeted_hello_brief.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "targeted-hello-brief"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        return (
                                            (self.link_hello_briefs is not None and self.link_hello_briefs.has_data()) or
                                            (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.link_hello_briefs is not None and self.link_hello_briefs.has_operation()) or
                                            (self.targeted_hello_briefs is not None and self.targeted_hello_briefs.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "brief" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-briefs"):
                                            if (self.link_hello_briefs is None):
                                                self.link_hello_briefs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.LinkHelloBriefs()
                                                self.link_hello_briefs.parent = self
                                                self._children_name_map["link_hello_briefs"] = "link-hello-briefs"
                                            return self.link_hello_briefs

                                        if (child_yang_name == "targeted-hello-briefs"):
                                            if (self.targeted_hello_briefs is None):
                                                self.targeted_hello_briefs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief.TargetedHelloBriefs()
                                                self.targeted_hello_briefs.parent = self
                                                self._children_name_map["targeted_hello_briefs"] = "targeted-hello-briefs"
                                            return self.targeted_hello_briefs

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-briefs" or name == "targeted-hello-briefs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Stats(Entity):
                                    """
                                    The LDP Discovery Statistics
                                    
                                    .. attribute:: stat
                                    
                                    	Information on LDP discovery statistics
                                    	**type**\: list of    :py:class:`Stat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__init__()

                                        self.yang_name = "stats"
                                        self.yang_parent_name = "discovery"

                                        self.stat = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats, self).__setattr__(name, value)


                                    class Stat(Entity):
                                        """
                                        Information on LDP discovery statistics
                                        
                                        .. attribute:: adjacency_group_up_time
                                        
                                        	Adjacency group up time in seconds
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: second
                                        
                                        .. attribute:: label_space_id
                                        
                                        	Label space ID of neighbor
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: lsr_id
                                        
                                        	LSR ID of neighbor
                                        	**type**\: one of the below types:
                                        
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        
                                        ----
                                        .. attribute:: tcp_arb_chg_count
                                        
                                        	Count of changes in TCP arbitration
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tcp_open_count
                                        
                                        	Count of attempted TCP opens
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tcp_role
                                        
                                        	TCP Role
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__init__()

                                            self.yang_name = "stat"
                                            self.yang_parent_name = "stats"

                                            self.adjacency_group_up_time = YLeaf(YType.uint32, "adjacency-group-up-time")

                                            self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                                            self.tcp_arb_chg_count = YLeaf(YType.uint32, "tcp-arb-chg-count")

                                            self.tcp_open_count = YLeaf(YType.uint32, "tcp-open-count")

                                            self.tcp_role = YLeaf(YType.uint32, "tcp-role")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("adjacency_group_up_time",
                                                            "label_space_id",
                                                            "lsr_id",
                                                            "tcp_arb_chg_count",
                                                            "tcp_open_count",
                                                            "tcp_role") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.adjacency_group_up_time.is_set or
                                                self.label_space_id.is_set or
                                                self.lsr_id.is_set or
                                                self.tcp_arb_chg_count.is_set or
                                                self.tcp_open_count.is_set or
                                                self.tcp_role.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.adjacency_group_up_time.yfilter != YFilter.not_set or
                                                self.label_space_id.yfilter != YFilter.not_set or
                                                self.lsr_id.yfilter != YFilter.not_set or
                                                self.tcp_arb_chg_count.yfilter != YFilter.not_set or
                                                self.tcp_open_count.yfilter != YFilter.not_set or
                                                self.tcp_role.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "stat" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.adjacency_group_up_time.is_set or self.adjacency_group_up_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.adjacency_group_up_time.get_name_leafdata())
                                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                            if (self.tcp_arb_chg_count.is_set or self.tcp_arb_chg_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_arb_chg_count.get_name_leafdata())
                                            if (self.tcp_open_count.is_set or self.tcp_open_count.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_open_count.get_name_leafdata())
                                            if (self.tcp_role.is_set or self.tcp_role.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcp_role.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "adjacency-group-up-time" or name == "label-space-id" or name == "lsr-id" or name == "tcp-arb-chg-count" or name == "tcp-open-count" or name == "tcp-role"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "adjacency-group-up-time"):
                                                self.adjacency_group_up_time = value
                                                self.adjacency_group_up_time.value_namespace = name_space
                                                self.adjacency_group_up_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "label-space-id"):
                                                self.label_space_id = value
                                                self.label_space_id.value_namespace = name_space
                                                self.label_space_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsr-id"):
                                                self.lsr_id = value
                                                self.lsr_id.value_namespace = name_space
                                                self.lsr_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-arb-chg-count"):
                                                self.tcp_arb_chg_count = value
                                                self.tcp_arb_chg_count.value_namespace = name_space
                                                self.tcp_arb_chg_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-open-count"):
                                                self.tcp_open_count = value
                                                self.tcp_open_count.value_namespace = name_space
                                                self.tcp_open_count.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcp-role"):
                                                self.tcp_role = value
                                                self.tcp_role.value_namespace = name_space
                                                self.tcp_role.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.stat:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.stat:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "stats" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "stat"):
                                            for c in self.stat:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats.Stat()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.stat.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "stat"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        (self.brief is not None and self.brief.has_data()) or
                                        (self.link_hellos is not None and self.link_hellos.has_data()) or
                                        (self.stats is not None and self.stats.has_data()) or
                                        (self.summary is not None and self.summary.has_data()) or
                                        (self.targeted_hellos is not None and self.targeted_hellos.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.brief is not None and self.brief.has_operation()) or
                                        (self.link_hellos is not None and self.link_hellos.has_operation()) or
                                        (self.stats is not None and self.stats.has_operation()) or
                                        (self.summary is not None and self.summary.has_operation()) or
                                        (self.targeted_hellos is not None and self.targeted_hellos.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovery" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "brief"):
                                        if (self.brief is None):
                                            self.brief = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Brief()
                                            self.brief.parent = self
                                            self._children_name_map["brief"] = "brief"
                                        return self.brief

                                    if (child_yang_name == "link-hellos"):
                                        if (self.link_hellos is None):
                                            self.link_hellos = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.LinkHellos()
                                            self.link_hellos.parent = self
                                            self._children_name_map["link_hellos"] = "link-hellos"
                                        return self.link_hellos

                                    if (child_yang_name == "stats"):
                                        if (self.stats is None):
                                            self.stats = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Stats()
                                            self.stats.parent = self
                                            self._children_name_map["stats"] = "stats"
                                        return self.stats

                                    if (child_yang_name == "summary"):
                                        if (self.summary is None):
                                            self.summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.Summary()
                                            self.summary.parent = self
                                            self._children_name_map["summary"] = "summary"
                                        return self.summary

                                    if (child_yang_name == "targeted-hellos"):
                                        if (self.targeted_hellos is None):
                                            self.targeted_hellos = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery.TargetedHellos()
                                            self.targeted_hellos.parent = self
                                            self._children_name_map["targeted_hellos"] = "targeted-hellos"
                                        return self.targeted_hellos

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "brief" or name == "link-hellos" or name == "stats" or name == "summary" or name == "targeted-hellos"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsSummaryAll(Entity):
                                """
                                Aggregate VRF counters for the LDP Label
                                Infomation Base (LIB)
                                
                                .. attribute:: address_family
                                
                                	Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: bind_af
                                
                                	bind af
                                	**type**\: list of    :py:class:`BindAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf>`
                                
                                .. attribute:: binding_local_explicit_null
                                
                                	Number of local explicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_implicit_null
                                
                                	Number of local implicit null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_no_route
                                
                                	Local bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_non_null
                                
                                	Number of local non\-null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_null
                                
                                	Number of local null bindings
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_local_oor
                                
                                	Number of local bindings        needing label \- OOR
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: binding_no_route
                                
                                	Bindings with no route
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: highest_allocated_label
                                
                                	Highest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lowest_allocated_label
                                
                                	Lowest allocated label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__init__()

                                    self.yang_name = "bindings-summary-all"
                                    self.yang_parent_name = "af"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.binding_local_explicit_null = YLeaf(YType.uint32, "binding-local-explicit-null")

                                    self.binding_local_implicit_null = YLeaf(YType.uint32, "binding-local-implicit-null")

                                    self.binding_local_no_route = YLeaf(YType.uint32, "binding-local-no-route")

                                    self.binding_local_non_null = YLeaf(YType.uint32, "binding-local-non-null")

                                    self.binding_local_null = YLeaf(YType.uint32, "binding-local-null")

                                    self.binding_local_oor = YLeaf(YType.uint32, "binding-local-oor")

                                    self.binding_no_route = YLeaf(YType.uint32, "binding-no-route")

                                    self.highest_allocated_label = YLeaf(YType.uint32, "highest-allocated-label")

                                    self.lowest_allocated_label = YLeaf(YType.uint32, "lowest-allocated-label")

                                    self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                    self.bind_af = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "binding_local_explicit_null",
                                                    "binding_local_implicit_null",
                                                    "binding_local_no_route",
                                                    "binding_local_non_null",
                                                    "binding_local_null",
                                                    "binding_local_oor",
                                                    "binding_no_route",
                                                    "highest_allocated_label",
                                                    "lowest_allocated_label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "bindings-summary-all"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class BindAf(Entity):
                                    """
                                    bind af
                                    
                                    .. attribute:: address_family
                                    
                                    	Binding Summary Address Family
                                    	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                    
                                    .. attribute:: binding_local
                                    
                                    	Number of local bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_remote
                                    
                                    	Number of remote bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: binding_total
                                    
                                    	Total bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: last_lib_update
                                    
                                    	Last update to LIB local binding
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: lib_minimum_revision_sent_all
                                    
                                    	Last update sent to all peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__init__()

                                        self.yang_name = "bind-af"
                                        self.yang_parent_name = "bindings-summary-all"

                                        self.address_family = YLeaf(YType.enumeration, "address-family")

                                        self.binding_local = YLeaf(YType.uint32, "binding-local")

                                        self.binding_remote = YLeaf(YType.uint32, "binding-remote")

                                        self.binding_total = YLeaf(YType.uint32, "binding-total")

                                        self.last_lib_update = YLeaf(YType.uint32, "last-lib-update")

                                        self.lib_minimum_revision_sent_all = YLeaf(YType.uint32, "lib-minimum-revision-sent-all")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address_family",
                                                        "binding_local",
                                                        "binding_remote",
                                                        "binding_total",
                                                        "last_lib_update",
                                                        "lib_minimum_revision_sent_all") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address_family.is_set or
                                            self.binding_local.is_set or
                                            self.binding_remote.is_set or
                                            self.binding_total.is_set or
                                            self.last_lib_update.is_set or
                                            self.lib_minimum_revision_sent_all.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address_family.yfilter != YFilter.not_set or
                                            self.binding_local.yfilter != YFilter.not_set or
                                            self.binding_remote.yfilter != YFilter.not_set or
                                            self.binding_total.yfilter != YFilter.not_set or
                                            self.last_lib_update.yfilter != YFilter.not_set or
                                            self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bind-af" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address_family.get_name_leafdata())
                                        if (self.binding_local.is_set or self.binding_local.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_local.get_name_leafdata())
                                        if (self.binding_remote.is_set or self.binding_remote.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_remote.get_name_leafdata())
                                        if (self.binding_total.is_set or self.binding_total.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.binding_total.get_name_leafdata())
                                        if (self.last_lib_update.is_set or self.last_lib_update.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.last_lib_update.get_name_leafdata())
                                        if (self.lib_minimum_revision_sent_all.is_set or self.lib_minimum_revision_sent_all.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lib_minimum_revision_sent_all.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address-family" or name == "binding-local" or name == "binding-remote" or name == "binding-total" or name == "last-lib-update" or name == "lib-minimum-revision-sent-all"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address-family"):
                                            self.address_family = value
                                            self.address_family.value_namespace = name_space
                                            self.address_family.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-local"):
                                            self.binding_local = value
                                            self.binding_local.value_namespace = name_space
                                            self.binding_local.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-remote"):
                                            self.binding_remote = value
                                            self.binding_remote.value_namespace = name_space
                                            self.binding_remote.value_namespace_prefix = name_space_prefix
                                        if(value_path == "binding-total"):
                                            self.binding_total = value
                                            self.binding_total.value_namespace = name_space
                                            self.binding_total.value_namespace_prefix = name_space_prefix
                                        if(value_path == "last-lib-update"):
                                            self.last_lib_update = value
                                            self.last_lib_update.value_namespace = name_space
                                            self.last_lib_update.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lib-minimum-revision-sent-all"):
                                            self.lib_minimum_revision_sent_all = value
                                            self.lib_minimum_revision_sent_all.value_namespace = name_space
                                            self.lib_minimum_revision_sent_all.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.bind_af:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.address_family.is_set or
                                        self.binding_local_explicit_null.is_set or
                                        self.binding_local_implicit_null.is_set or
                                        self.binding_local_no_route.is_set or
                                        self.binding_local_non_null.is_set or
                                        self.binding_local_null.is_set or
                                        self.binding_local_oor.is_set or
                                        self.binding_no_route.is_set or
                                        self.highest_allocated_label.is_set or
                                        self.lowest_allocated_label.is_set or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    for c in self.bind_af:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.binding_local_explicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_implicit_null.yfilter != YFilter.not_set or
                                        self.binding_local_no_route.yfilter != YFilter.not_set or
                                        self.binding_local_non_null.yfilter != YFilter.not_set or
                                        self.binding_local_null.yfilter != YFilter.not_set or
                                        self.binding_local_oor.yfilter != YFilter.not_set or
                                        self.binding_no_route.yfilter != YFilter.not_set or
                                        self.highest_allocated_label.yfilter != YFilter.not_set or
                                        self.lowest_allocated_label.yfilter != YFilter.not_set or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-summary-all" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.binding_local_explicit_null.is_set or self.binding_local_explicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_explicit_null.get_name_leafdata())
                                    if (self.binding_local_implicit_null.is_set or self.binding_local_implicit_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_implicit_null.get_name_leafdata())
                                    if (self.binding_local_no_route.is_set or self.binding_local_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_no_route.get_name_leafdata())
                                    if (self.binding_local_non_null.is_set or self.binding_local_non_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_non_null.get_name_leafdata())
                                    if (self.binding_local_null.is_set or self.binding_local_null.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_null.get_name_leafdata())
                                    if (self.binding_local_oor.is_set or self.binding_local_oor.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_local_oor.get_name_leafdata())
                                    if (self.binding_no_route.is_set or self.binding_no_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_no_route.get_name_leafdata())
                                    if (self.highest_allocated_label.is_set or self.highest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.highest_allocated_label.get_name_leafdata())
                                    if (self.lowest_allocated_label.is_set or self.lowest_allocated_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lowest_allocated_label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bind-af"):
                                        for c in self.bind_af:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.BindAf()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.bind_af.append(c)
                                        return c

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bind-af" or name == "vrf" or name == "address-family" or name == "binding-local-explicit-null" or name == "binding-local-implicit-null" or name == "binding-local-no-route" or name == "binding-local-non-null" or name == "binding-local-null" or name == "binding-local-oor" or name == "binding-no-route" or name == "highest-allocated-label" or name == "lowest-allocated-label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-explicit-null"):
                                        self.binding_local_explicit_null = value
                                        self.binding_local_explicit_null.value_namespace = name_space
                                        self.binding_local_explicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-implicit-null"):
                                        self.binding_local_implicit_null = value
                                        self.binding_local_implicit_null.value_namespace = name_space
                                        self.binding_local_implicit_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-no-route"):
                                        self.binding_local_no_route = value
                                        self.binding_local_no_route.value_namespace = name_space
                                        self.binding_local_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-non-null"):
                                        self.binding_local_non_null = value
                                        self.binding_local_non_null.value_namespace = name_space
                                        self.binding_local_non_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-null"):
                                        self.binding_local_null = value
                                        self.binding_local_null.value_namespace = name_space
                                        self.binding_local_null.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-local-oor"):
                                        self.binding_local_oor = value
                                        self.binding_local_oor.value_namespace = name_space
                                        self.binding_local_oor.value_namespace_prefix = name_space_prefix
                                    if(value_path == "binding-no-route"):
                                        self.binding_no_route = value
                                        self.binding_no_route.value_namespace = name_space
                                        self.binding_no_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "highest-allocated-label"):
                                        self.highest_allocated_label = value
                                        self.highest_allocated_label.value_namespace = name_space
                                        self.highest_allocated_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lowest-allocated-label"):
                                        self.lowest_allocated_label = value
                                        self.lowest_allocated_label.value_namespace = name_space
                                        self.lowest_allocated_label.value_namespace_prefix = name_space_prefix


                            class Forwardings(Entity):
                                """
                                The LDP Forwarding rewrites
                                
                                .. attribute:: forwarding
                                
                                	Information on a particular LDP forwarding rewrite
                                	**type**\: list of    :py:class:`Forwarding <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings, self).__init__()

                                    self.yang_name = "forwardings"
                                    self.yang_parent_name = "af"

                                    self.forwarding = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings, self).__setattr__(name, value)


                                class Forwarding(Entity):
                                    """
                                    Information on a particular LDP forwarding
                                    rewrite
                                    
                                    .. attribute:: prefix  <key>
                                    
                                    	The IP Prefix
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])/(([0\-9])\|([1\-2][0\-9])\|(3[0\-2]))
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(/(([0\-9])\|([0\-9]{2})\|(1[0\-1][0\-9])\|(12[0\-8])))
                                    
                                    
                                    ----
                                    .. attribute:: paths
                                    
                                    	Paths
                                    	**type**\: list of    :py:class:`Paths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths>`
                                    
                                    .. attribute:: prefix_length
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: prefix_xr
                                    
                                    	IP Prefix
                                    	**type**\:   :py:class:`PrefixXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr>`
                                    
                                    .. attribute:: route
                                    
                                    	Route
                                    	**type**\:   :py:class:`Route <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route>`
                                    
                                    .. attribute:: table_id
                                    
                                    	Table ID associated with IP prefix
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: vrf
                                    
                                    	VRF information
                                    	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__init__()

                                        self.yang_name = "forwarding"
                                        self.yang_parent_name = "forwardings"

                                        self.prefix = YLeaf(YType.str, "prefix")

                                        self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                        self.table_id = YLeaf(YType.uint32, "table-id")

                                        self.prefix_xr = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                        self.prefix_xr.parent = self
                                        self._children_name_map["prefix_xr"] = "prefix-xr"
                                        self._children_yang_names.add("prefix-xr")

                                        self.route = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route()
                                        self.route.parent = self
                                        self._children_name_map["route"] = "route"
                                        self._children_yang_names.add("route")

                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                        self._children_yang_names.add("vrf")

                                        self.paths = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("prefix",
                                                        "prefix_length",
                                                        "table_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding, self).__setattr__(name, value)


                                    class Vrf(Entity):
                                        """
                                        VRF information
                                        
                                        .. attribute:: id
                                        
                                        	VRF Id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	VRF Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__init__()

                                            self.yang_name = "vrf"
                                            self.yang_parent_name = "forwarding"

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("id",
                                                            "name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.id.is_set or
                                                self.name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.id.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "vrf" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.id.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "id" or name == "name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "id"):
                                                self.id = value
                                                self.id.value_namespace = name_space
                                                self.id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix


                                    class PrefixXr(Entity):
                                        """
                                        IP Prefix
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__init__()

                                            self.yang_name = "prefix-xr"
                                            self.yang_parent_name = "forwarding"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prefix-xr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix


                                    class Route(Entity):
                                        """
                                        Route
                                        
                                        .. attribute:: mpls
                                        
                                        	MPLS information
                                        	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls>`
                                        
                                        .. attribute:: routing
                                        
                                        	IP routing information
                                        	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route, self).__init__()

                                            self.yang_name = "route"
                                            self.yang_parent_name = "forwarding"

                                            self.mpls = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                            self.mpls.parent = self
                                            self._children_name_map["mpls"] = "mpls"
                                            self._children_yang_names.add("mpls")

                                            self.routing = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                            self.routing.parent = self
                                            self._children_name_map["routing"] = "routing"
                                            self._children_yang_names.add("routing")


                                        class Routing(Entity):
                                            """
                                            IP routing information
                                            
                                            .. attribute:: flags
                                            
                                            	Route RIB flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_local_vrf_leaked
                                            
                                            	Is route leaked across local VRFs?
                                            	**type**\:  bool
                                            
                                            .. attribute:: metric
                                            
                                            	Route metric
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: priority
                                            
                                            	Route priority
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: routing_update_age
                                            
                                            	Last Routing update nanosec age
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: routing_update_count
                                            
                                            	Number of routing updates
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: routing_update_timestamp
                                            
                                            	Last Routing update nanosec timestamp
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: source
                                            
                                            	Route source protol Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: sr_local_label
                                            
                                            	SR Local\-label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Route type
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: version
                                            
                                            	Route RIB ersion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__init__()

                                                self.yang_name = "routing"
                                                self.yang_parent_name = "route"

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.is_local_vrf_leaked = YLeaf(YType.boolean, "is-local-vrf-leaked")

                                                self.metric = YLeaf(YType.uint32, "metric")

                                                self.priority = YLeaf(YType.uint8, "priority")

                                                self.routing_update_age = YLeaf(YType.uint64, "routing-update-age")

                                                self.routing_update_count = YLeaf(YType.uint32, "routing-update-count")

                                                self.routing_update_timestamp = YLeaf(YType.uint64, "routing-update-timestamp")

                                                self.source = YLeaf(YType.uint16, "source")

                                                self.sr_local_label = YLeaf(YType.uint32, "sr-local-label")

                                                self.type = YLeaf(YType.uint16, "type")

                                                self.version = YLeaf(YType.uint32, "version")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("flags",
                                                                "is_local_vrf_leaked",
                                                                "metric",
                                                                "priority",
                                                                "routing_update_age",
                                                                "routing_update_count",
                                                                "routing_update_timestamp",
                                                                "source",
                                                                "sr_local_label",
                                                                "type",
                                                                "version") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.flags.is_set or
                                                    self.is_local_vrf_leaked.is_set or
                                                    self.metric.is_set or
                                                    self.priority.is_set or
                                                    self.routing_update_age.is_set or
                                                    self.routing_update_count.is_set or
                                                    self.routing_update_timestamp.is_set or
                                                    self.source.is_set or
                                                    self.sr_local_label.is_set or
                                                    self.type.is_set or
                                                    self.version.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.flags.yfilter != YFilter.not_set or
                                                    self.is_local_vrf_leaked.yfilter != YFilter.not_set or
                                                    self.metric.yfilter != YFilter.not_set or
                                                    self.priority.yfilter != YFilter.not_set or
                                                    self.routing_update_age.yfilter != YFilter.not_set or
                                                    self.routing_update_count.yfilter != YFilter.not_set or
                                                    self.routing_update_timestamp.yfilter != YFilter.not_set or
                                                    self.source.yfilter != YFilter.not_set or
                                                    self.sr_local_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    self.version.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "routing" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.flags.get_name_leafdata())
                                                if (self.is_local_vrf_leaked.is_set or self.is_local_vrf_leaked.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_local_vrf_leaked.get_name_leafdata())
                                                if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.metric.get_name_leafdata())
                                                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.priority.get_name_leafdata())
                                                if (self.routing_update_age.is_set or self.routing_update_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_age.get_name_leafdata())
                                                if (self.routing_update_count.is_set or self.routing_update_count.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_count.get_name_leafdata())
                                                if (self.routing_update_timestamp.is_set or self.routing_update_timestamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.routing_update_timestamp.get_name_leafdata())
                                                if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source.get_name_leafdata())
                                                if (self.sr_local_label.is_set or self.sr_local_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.sr_local_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())
                                                if (self.version.is_set or self.version.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.version.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "flags" or name == "is-local-vrf-leaked" or name == "metric" or name == "priority" or name == "routing-update-age" or name == "routing-update-count" or name == "routing-update-timestamp" or name == "source" or name == "sr-local-label" or name == "type" or name == "version"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "flags"):
                                                    self.flags = value
                                                    self.flags.value_namespace = name_space
                                                    self.flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-local-vrf-leaked"):
                                                    self.is_local_vrf_leaked = value
                                                    self.is_local_vrf_leaked.value_namespace = name_space
                                                    self.is_local_vrf_leaked.value_namespace_prefix = name_space_prefix
                                                if(value_path == "metric"):
                                                    self.metric = value
                                                    self.metric.value_namespace = name_space
                                                    self.metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "priority"):
                                                    self.priority = value
                                                    self.priority.value_namespace = name_space
                                                    self.priority.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-age"):
                                                    self.routing_update_age = value
                                                    self.routing_update_age.value_namespace = name_space
                                                    self.routing_update_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-count"):
                                                    self.routing_update_count = value
                                                    self.routing_update_count.value_namespace = name_space
                                                    self.routing_update_count.value_namespace_prefix = name_space_prefix
                                                if(value_path == "routing-update-timestamp"):
                                                    self.routing_update_timestamp = value
                                                    self.routing_update_timestamp.value_namespace = name_space
                                                    self.routing_update_timestamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source"):
                                                    self.source = value
                                                    self.source.value_namespace = name_space
                                                    self.source.value_namespace_prefix = name_space_prefix
                                                if(value_path == "sr-local-label"):
                                                    self.sr_local_label = value
                                                    self.sr_local_label.value_namespace = name_space
                                                    self.sr_local_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "version"):
                                                    self.version = value
                                                    self.version.value_namespace = name_space
                                                    self.version.value_namespace_prefix = name_space_prefix


                                        class Mpls(Entity):
                                            """
                                            MPLS information
                                            
                                            .. attribute:: forwarding_update_age
                                            
                                            	Last Forwarding update nanosec age
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: forwarding_update_count
                                            
                                            	Number of forwarding updates
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: forwarding_update_timestamp
                                            
                                            	Last Forwarding update nanosec timestamp
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: local_label
                                            
                                            	Local label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__init__()

                                                self.yang_name = "mpls"
                                                self.yang_parent_name = "route"

                                                self.forwarding_update_age = YLeaf(YType.uint64, "forwarding-update-age")

                                                self.forwarding_update_count = YLeaf(YType.uint32, "forwarding-update-count")

                                                self.forwarding_update_timestamp = YLeaf(YType.uint64, "forwarding-update-timestamp")

                                                self.local_label = YLeaf(YType.uint32, "local-label")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("forwarding_update_age",
                                                                "forwarding_update_count",
                                                                "forwarding_update_timestamp",
                                                                "local_label") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.forwarding_update_age.is_set or
                                                    self.forwarding_update_count.is_set or
                                                    self.forwarding_update_timestamp.is_set or
                                                    self.local_label.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.forwarding_update_age.yfilter != YFilter.not_set or
                                                    self.forwarding_update_count.yfilter != YFilter.not_set or
                                                    self.forwarding_update_timestamp.yfilter != YFilter.not_set or
                                                    self.local_label.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.forwarding_update_age.is_set or self.forwarding_update_age.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_age.get_name_leafdata())
                                                if (self.forwarding_update_count.is_set or self.forwarding_update_count.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_count.get_name_leafdata())
                                                if (self.forwarding_update_timestamp.is_set or self.forwarding_update_timestamp.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forwarding_update_timestamp.get_name_leafdata())
                                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "forwarding-update-age" or name == "forwarding-update-count" or name == "forwarding-update-timestamp" or name == "local-label"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "forwarding-update-age"):
                                                    self.forwarding_update_age = value
                                                    self.forwarding_update_age.value_namespace = name_space
                                                    self.forwarding_update_age.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-update-count"):
                                                    self.forwarding_update_count = value
                                                    self.forwarding_update_count.value_namespace = name_space
                                                    self.forwarding_update_count.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forwarding-update-timestamp"):
                                                    self.forwarding_update_timestamp = value
                                                    self.forwarding_update_timestamp.value_namespace = name_space
                                                    self.forwarding_update_timestamp.value_namespace_prefix = name_space_prefix
                                                if(value_path == "local-label"):
                                                    self.local_label = value
                                                    self.local_label.value_namespace = name_space
                                                    self.local_label.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                (self.mpls is not None and self.mpls.has_data()) or
                                                (self.routing is not None and self.routing.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls is not None and self.mpls.has_operation()) or
                                                (self.routing is not None and self.routing.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "route" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls"):
                                                if (self.mpls is None):
                                                    self.mpls = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Mpls()
                                                    self.mpls.parent = self
                                                    self._children_name_map["mpls"] = "mpls"
                                                return self.mpls

                                            if (child_yang_name == "routing"):
                                                if (self.routing is None):
                                                    self.routing = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route.Routing()
                                                    self.routing.parent = self
                                                    self._children_name_map["routing"] = "routing"
                                                return self.routing

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls" or name == "routing"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class Paths(Entity):
                                        """
                                        Paths
                                        
                                        .. attribute:: mpls
                                        
                                        	MPLS information
                                        	**type**\:   :py:class:`Mpls <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls>`
                                        
                                        .. attribute:: routing
                                        
                                        	IP routing information
                                        	**type**\:   :py:class:`Routing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths, self).__init__()

                                            self.yang_name = "paths"
                                            self.yang_parent_name = "forwarding"

                                            self.mpls = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                            self.mpls.parent = self
                                            self._children_name_map["mpls"] = "mpls"
                                            self._children_yang_names.add("mpls")

                                            self.routing = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                            self.routing.parent = self
                                            self._children_name_map["routing"] = "routing"
                                            self._children_yang_names.add("routing")


                                        class Routing(Entity):
                                            """
                                            IP routing information
                                            
                                            .. attribute:: bkup_path_id
                                            
                                            	Backup path Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: flags
                                            
                                            	Route path flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: interface
                                            
                                            	Interface name
                                            	**type**\:  str
                                            
                                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                            
                                            .. attribute:: interface_name
                                            
                                            	Interface Name
                                            	**type**\:  str
                                            
                                            .. attribute:: load_metric
                                            
                                            	Path's load metric for load balancing
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_hop
                                            
                                            	Next Hop
                                            	**type**\:   :py:class:`NextHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop>`
                                            
                                            .. attribute:: next_hop_table_id
                                            
                                            	Table ID for nexthop address
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: nexthop_id
                                            
                                            	Nexthop Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: nh_is_overriden
                                            
                                            	Nexthop is overriden by LDP
                                            	**type**\:  bool
                                            
                                            .. attribute:: path_flags
                                            
                                            	Routing path flags decoded
                                            	**type**\:   :py:class:`LdpRoutePathFlags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathFlags>`
                                            
                                            .. attribute:: path_id
                                            
                                            	path Id
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: remote_lfa
                                            
                                            	Remote LFA\-FRR backup info
                                            	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__init__()

                                                self.yang_name = "routing"
                                                self.yang_parent_name = "paths"

                                                self.bkup_path_id = YLeaf(YType.uint8, "bkup-path-id")

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.interface = YLeaf(YType.str, "interface")

                                                self.interface_name = YLeaf(YType.str, "interface-name")

                                                self.load_metric = YLeaf(YType.uint32, "load-metric")

                                                self.next_hop_table_id = YLeaf(YType.uint32, "next-hop-table-id")

                                                self.nexthop_id = YLeaf(YType.uint32, "nexthop-id")

                                                self.nh_is_overriden = YLeaf(YType.boolean, "nh-is-overriden")

                                                self.path_flags = YLeaf(YType.enumeration, "path-flags")

                                                self.path_id = YLeaf(YType.uint8, "path-id")

                                                self.next_hop = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                self.next_hop.parent = self
                                                self._children_name_map["next_hop"] = "next-hop"
                                                self._children_yang_names.add("next-hop")

                                                self.remote_lfa = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                self.remote_lfa.parent = self
                                                self._children_name_map["remote_lfa"] = "remote-lfa"
                                                self._children_yang_names.add("remote-lfa")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bkup_path_id",
                                                                "flags",
                                                                "interface",
                                                                "interface_name",
                                                                "load_metric",
                                                                "next_hop_table_id",
                                                                "nexthop_id",
                                                                "nh_is_overriden",
                                                                "path_flags",
                                                                "path_id") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing, self).__setattr__(name, value)


                                            class NextHop(Entity):
                                                """
                                                Next Hop
                                                
                                                .. attribute:: afi
                                                
                                                	AFI
                                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                
                                                .. attribute:: dummy
                                                
                                                	No Address
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: ipv4
                                                
                                                	IPv4 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: ipv6
                                                
                                                	IPv6 address type
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__init__()

                                                    self.yang_name = "next-hop"
                                                    self.yang_parent_name = "routing"

                                                    self.afi = YLeaf(YType.enumeration, "afi")

                                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("afi",
                                                                    "dummy",
                                                                    "ipv4",
                                                                    "ipv6") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.afi.is_set or
                                                        self.dummy.is_set or
                                                        self.ipv4.is_set or
                                                        self.ipv6.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.afi.yfilter != YFilter.not_set or
                                                        self.dummy.yfilter != YFilter.not_set or
                                                        self.ipv4.yfilter != YFilter.not_set or
                                                        self.ipv6.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "next-hop" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "afi"):
                                                        self.afi = value
                                                        self.afi.value_namespace = name_space
                                                        self.afi.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "dummy"):
                                                        self.dummy = value
                                                        self.dummy.value_namespace = name_space
                                                        self.dummy.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv4"):
                                                        self.ipv4 = value
                                                        self.ipv4.value_namespace = name_space
                                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ipv6"):
                                                        self.ipv6 = value
                                                        self.ipv6.value_namespace = name_space
                                                        self.ipv6.value_namespace_prefix = name_space_prefix


                                            class RemoteLfa(Entity):
                                                """
                                                Remote LFA\-FRR backup info
                                                
                                                .. attribute:: has_q_node
                                                
                                                	Whether remote LFA path has a Q node associated
                                                	**type**\:  bool
                                                
                                                .. attribute:: has_remote_lfa_bkup
                                                
                                                	Whether path has remote LFA backup
                                                	**type**\:  bool
                                                
                                                .. attribute:: needs_tldp
                                                
                                                	Whether TLDP is needed with remote PQ node
                                                	**type**\:  bool
                                                
                                                .. attribute:: remote_p_node_id
                                                
                                                	Remote/P node address
                                                	**type**\:   :py:class:`RemotePNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId>`
                                                
                                                .. attribute:: remote_q_node_id
                                                
                                                	Remote/Q node address
                                                	**type**\:   :py:class:`RemoteQNodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__init__()

                                                    self.yang_name = "remote-lfa"
                                                    self.yang_parent_name = "routing"

                                                    self.has_q_node = YLeaf(YType.boolean, "has-q-node")

                                                    self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                    self.needs_tldp = YLeaf(YType.boolean, "needs-tldp")

                                                    self.remote_p_node_id = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                    self.remote_p_node_id.parent = self
                                                    self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                    self._children_yang_names.add("remote-p-node-id")

                                                    self.remote_q_node_id = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                    self.remote_q_node_id.parent = self
                                                    self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                    self._children_yang_names.add("remote-q-node-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("has_q_node",
                                                                    "has_remote_lfa_bkup",
                                                                    "needs_tldp") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa, self).__setattr__(name, value)


                                                class RemotePNodeId(Entity):
                                                    """
                                                    Remote/P node address
                                                    
                                                    .. attribute:: afi
                                                    
                                                    	AFI
                                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                    
                                                    .. attribute:: dummy
                                                    
                                                    	No Address
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ipv4
                                                    
                                                    	IPv4 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: ipv6
                                                    
                                                    	IPv6 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__init__()

                                                        self.yang_name = "remote-p-node-id"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.afi = YLeaf(YType.enumeration, "afi")

                                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("afi",
                                                                        "dummy",
                                                                        "ipv4",
                                                                        "ipv6") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.afi.is_set or
                                                            self.dummy.is_set or
                                                            self.ipv4.is_set or
                                                            self.ipv6.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.afi.yfilter != YFilter.not_set or
                                                            self.dummy.yfilter != YFilter.not_set or
                                                            self.ipv4.yfilter != YFilter.not_set or
                                                            self.ipv6.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "remote-p-node-id" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "afi"):
                                                            self.afi = value
                                                            self.afi.value_namespace = name_space
                                                            self.afi.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "dummy"):
                                                            self.dummy = value
                                                            self.dummy.value_namespace = name_space
                                                            self.dummy.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv4"):
                                                            self.ipv4 = value
                                                            self.ipv4.value_namespace = name_space
                                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv6"):
                                                            self.ipv6 = value
                                                            self.ipv6.value_namespace = name_space
                                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                                class RemoteQNodeId(Entity):
                                                    """
                                                    Remote/Q node address
                                                    
                                                    .. attribute:: afi
                                                    
                                                    	AFI
                                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                                    
                                                    .. attribute:: dummy
                                                    
                                                    	No Address
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: ipv4
                                                    
                                                    	IPv4 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: ipv6
                                                    
                                                    	IPv6 address type
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__init__()

                                                        self.yang_name = "remote-q-node-id"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.afi = YLeaf(YType.enumeration, "afi")

                                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("afi",
                                                                        "dummy",
                                                                        "ipv4",
                                                                        "ipv6") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.afi.is_set or
                                                            self.dummy.is_set or
                                                            self.ipv4.is_set or
                                                            self.ipv6.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.afi.yfilter != YFilter.not_set or
                                                            self.dummy.yfilter != YFilter.not_set or
                                                            self.ipv4.yfilter != YFilter.not_set or
                                                            self.ipv6.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "remote-q-node-id" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "afi"):
                                                            self.afi = value
                                                            self.afi.value_namespace = name_space
                                                            self.afi.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "dummy"):
                                                            self.dummy = value
                                                            self.dummy.value_namespace = name_space
                                                            self.dummy.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv4"):
                                                            self.ipv4 = value
                                                            self.ipv4.value_namespace = name_space
                                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ipv6"):
                                                            self.ipv6 = value
                                                            self.ipv6.value_namespace = name_space
                                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.has_q_node.is_set or
                                                        self.has_remote_lfa_bkup.is_set or
                                                        self.needs_tldp.is_set or
                                                        (self.remote_p_node_id is not None and self.remote_p_node_id.has_data()) or
                                                        (self.remote_q_node_id is not None and self.remote_q_node_id.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.has_q_node.yfilter != YFilter.not_set or
                                                        self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                        self.needs_tldp.yfilter != YFilter.not_set or
                                                        (self.remote_p_node_id is not None and self.remote_p_node_id.has_operation()) or
                                                        (self.remote_q_node_id is not None and self.remote_q_node_id.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-lfa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.has_q_node.is_set or self.has_q_node.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_q_node.get_name_leafdata())
                                                    if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())
                                                    if (self.needs_tldp.is_set or self.needs_tldp.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.needs_tldp.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "remote-p-node-id"):
                                                        if (self.remote_p_node_id is None):
                                                            self.remote_p_node_id = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemotePNodeId()
                                                            self.remote_p_node_id.parent = self
                                                            self._children_name_map["remote_p_node_id"] = "remote-p-node-id"
                                                        return self.remote_p_node_id

                                                    if (child_yang_name == "remote-q-node-id"):
                                                        if (self.remote_q_node_id is None):
                                                            self.remote_q_node_id = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa.RemoteQNodeId()
                                                            self.remote_q_node_id.parent = self
                                                            self._children_name_map["remote_q_node_id"] = "remote-q-node-id"
                                                        return self.remote_q_node_id

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "remote-p-node-id" or name == "remote-q-node-id" or name == "has-q-node" or name == "has-remote-lfa-bkup" or name == "needs-tldp"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "has-q-node"):
                                                        self.has_q_node = value
                                                        self.has_q_node.value_namespace = name_space
                                                        self.has_q_node.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "has-remote-lfa-bkup"):
                                                        self.has_remote_lfa_bkup = value
                                                        self.has_remote_lfa_bkup.value_namespace = name_space
                                                        self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "needs-tldp"):
                                                        self.needs_tldp = value
                                                        self.needs_tldp.value_namespace = name_space
                                                        self.needs_tldp.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.bkup_path_id.is_set or
                                                    self.flags.is_set or
                                                    self.interface.is_set or
                                                    self.interface_name.is_set or
                                                    self.load_metric.is_set or
                                                    self.next_hop_table_id.is_set or
                                                    self.nexthop_id.is_set or
                                                    self.nh_is_overriden.is_set or
                                                    self.path_flags.is_set or
                                                    self.path_id.is_set or
                                                    (self.next_hop is not None and self.next_hop.has_data()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bkup_path_id.yfilter != YFilter.not_set or
                                                    self.flags.yfilter != YFilter.not_set or
                                                    self.interface.yfilter != YFilter.not_set or
                                                    self.interface_name.yfilter != YFilter.not_set or
                                                    self.load_metric.yfilter != YFilter.not_set or
                                                    self.next_hop_table_id.yfilter != YFilter.not_set or
                                                    self.nexthop_id.yfilter != YFilter.not_set or
                                                    self.nh_is_overriden.yfilter != YFilter.not_set or
                                                    self.path_flags.yfilter != YFilter.not_set or
                                                    self.path_id.yfilter != YFilter.not_set or
                                                    (self.next_hop is not None and self.next_hop.has_operation()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "routing" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bkup_path_id.is_set or self.bkup_path_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bkup_path_id.get_name_leafdata())
                                                if (self.flags.is_set or self.flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.flags.get_name_leafdata())
                                                if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface.get_name_leafdata())
                                                if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.interface_name.get_name_leafdata())
                                                if (self.load_metric.is_set or self.load_metric.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.load_metric.get_name_leafdata())
                                                if (self.next_hop_table_id.is_set or self.next_hop_table_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_hop_table_id.get_name_leafdata())
                                                if (self.nexthop_id.is_set or self.nexthop_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nexthop_id.get_name_leafdata())
                                                if (self.nh_is_overriden.is_set or self.nh_is_overriden.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.nh_is_overriden.get_name_leafdata())
                                                if (self.path_flags.is_set or self.path_flags.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_flags.get_name_leafdata())
                                                if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_id.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "next-hop"):
                                                    if (self.next_hop is None):
                                                        self.next_hop = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.NextHop()
                                                        self.next_hop.parent = self
                                                        self._children_name_map["next_hop"] = "next-hop"
                                                    return self.next_hop

                                                if (child_yang_name == "remote-lfa"):
                                                    if (self.remote_lfa is None):
                                                        self.remote_lfa = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing.RemoteLfa()
                                                        self.remote_lfa.parent = self
                                                        self._children_name_map["remote_lfa"] = "remote-lfa"
                                                    return self.remote_lfa

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "next-hop" or name == "remote-lfa" or name == "bkup-path-id" or name == "flags" or name == "interface" or name == "interface-name" or name == "load-metric" or name == "next-hop-table-id" or name == "nexthop-id" or name == "nh-is-overriden" or name == "path-flags" or name == "path-id"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bkup-path-id"):
                                                    self.bkup_path_id = value
                                                    self.bkup_path_id.value_namespace = name_space
                                                    self.bkup_path_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "flags"):
                                                    self.flags = value
                                                    self.flags.value_namespace = name_space
                                                    self.flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface"):
                                                    self.interface = value
                                                    self.interface.value_namespace = name_space
                                                    self.interface.value_namespace_prefix = name_space_prefix
                                                if(value_path == "interface-name"):
                                                    self.interface_name = value
                                                    self.interface_name.value_namespace = name_space
                                                    self.interface_name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "load-metric"):
                                                    self.load_metric = value
                                                    self.load_metric.value_namespace = name_space
                                                    self.load_metric.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-hop-table-id"):
                                                    self.next_hop_table_id = value
                                                    self.next_hop_table_id.value_namespace = name_space
                                                    self.next_hop_table_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nexthop-id"):
                                                    self.nexthop_id = value
                                                    self.nexthop_id.value_namespace = name_space
                                                    self.nexthop_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "nh-is-overriden"):
                                                    self.nh_is_overriden = value
                                                    self.nh_is_overriden.value_namespace = name_space
                                                    self.nh_is_overriden.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-flags"):
                                                    self.path_flags = value
                                                    self.path_flags.value_namespace = name_space
                                                    self.path_flags.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-id"):
                                                    self.path_id = value
                                                    self.path_id.value_namespace = name_space
                                                    self.path_id.value_namespace_prefix = name_space_prefix


                                        class Mpls(Entity):
                                            """
                                            MPLS information
                                            
                                            .. attribute:: mpls_outgoing_info
                                            
                                            	MPLS nexthop info
                                            	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo>`
                                            
                                            .. attribute:: remote_lfa
                                            
                                            	Remote LFA\-FRR backup info
                                            	**type**\:   :py:class:`RemoteLfa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls, self).__init__()

                                                self.yang_name = "mpls"
                                                self.yang_parent_name = "paths"

                                                self.mpls_outgoing_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                self.mpls_outgoing_info.parent = self
                                                self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                self._children_yang_names.add("mpls-outgoing-info")

                                                self.remote_lfa = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                self.remote_lfa.parent = self
                                                self._children_name_map["remote_lfa"] = "remote-lfa"
                                                self._children_yang_names.add("remote-lfa")


                                            class MplsOutgoingInfo(Entity):
                                                """
                                                MPLS nexthop info
                                                
                                                .. attribute:: is_from_graceful_restartable_neighbor
                                                
                                                	Is from a GR neighbor
                                                	**type**\:  bool
                                                
                                                .. attribute:: is_stale
                                                
                                                	Is the entry stale
                                                	**type**\:  bool
                                                
                                                .. attribute:: nexthop_peer_ldp_ident
                                                
                                                	Nexthop LDP peer
                                                	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent>`
                                                
                                                .. attribute:: out_label
                                                
                                                	Outgoing label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: out_label_owner
                                                
                                                	Outgoing label owner
                                                	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                
                                                .. attribute:: out_label_rsn
                                                
                                                	Outgoing label reason
                                                	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                
                                                .. attribute:: out_label_type
                                                
                                                	Outgoing Label Type
                                                	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__init__()

                                                    self.yang_name = "mpls-outgoing-info"
                                                    self.yang_parent_name = "mpls"

                                                    self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                    self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                                    self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                    self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                    self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                    self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                    self.nexthop_peer_ldp_ident.parent = self
                                                    self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                    self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("is_from_graceful_restartable_neighbor",
                                                                    "is_stale",
                                                                    "out_label",
                                                                    "out_label_owner",
                                                                    "out_label_rsn",
                                                                    "out_label_type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo, self).__setattr__(name, value)


                                                class NexthopPeerLdpIdent(Entity):
                                                    """
                                                    Nexthop LDP peer
                                                    
                                                    .. attribute:: label_space_id
                                                    
                                                    	Label space identifier
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: ldp_id
                                                    
                                                    	LDP identifier
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: lsr_id
                                                    
                                                    	LSR identifier
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__init__()

                                                        self.yang_name = "nexthop-peer-ldp-ident"
                                                        self.yang_parent_name = "mpls-outgoing-info"

                                                        self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                        self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("label_space_id",
                                                                        "ldp_id",
                                                                        "lsr_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.label_space_id.is_set or
                                                            self.ldp_id.is_set or
                                                            self.lsr_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.label_space_id.yfilter != YFilter.not_set or
                                                            self.ldp_id.yfilter != YFilter.not_set or
                                                            self.lsr_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                        if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "label-space-id"):
                                                            self.label_space_id = value
                                                            self.label_space_id.value_namespace = name_space
                                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ldp-id"):
                                                            self.ldp_id = value
                                                            self.ldp_id.value_namespace = name_space
                                                            self.ldp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "lsr-id"):
                                                            self.lsr_id = value
                                                            self.lsr_id.value_namespace = name_space
                                                            self.lsr_id.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.is_from_graceful_restartable_neighbor.is_set or
                                                        self.is_stale.is_set or
                                                        self.out_label.is_set or
                                                        self.out_label_owner.is_set or
                                                        self.out_label_rsn.is_set or
                                                        self.out_label_type.is_set or
                                                        (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                        self.is_stale.yfilter != YFilter.not_set or
                                                        self.out_label.yfilter != YFilter.not_set or
                                                        self.out_label_owner.yfilter != YFilter.not_set or
                                                        self.out_label_rsn.yfilter != YFilter.not_set or
                                                        self.out_label_type.yfilter != YFilter.not_set or
                                                        (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "mpls-outgoing-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                    if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                                    if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                    if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                    if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                        if (self.nexthop_peer_ldp_ident is None):
                                                            self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo.NexthopPeerLdpIdent()
                                                            self.nexthop_peer_ldp_ident.parent = self
                                                            self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                        return self.nexthop_peer_ldp_ident

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "is-from-graceful-restartable-neighbor"):
                                                        self.is_from_graceful_restartable_neighbor = value
                                                        self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                        self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "is-stale"):
                                                        self.is_stale = value
                                                        self.is_stale.value_namespace = name_space
                                                        self.is_stale.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label"):
                                                        self.out_label = value
                                                        self.out_label.value_namespace = name_space
                                                        self.out_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-owner"):
                                                        self.out_label_owner = value
                                                        self.out_label_owner.value_namespace = name_space
                                                        self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-rsn"):
                                                        self.out_label_rsn = value
                                                        self.out_label_rsn.value_namespace = name_space
                                                        self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "out-label-type"):
                                                        self.out_label_type = value
                                                        self.out_label_type.value_namespace = name_space
                                                        self.out_label_type.value_namespace_prefix = name_space_prefix


                                            class RemoteLfa(Entity):
                                                """
                                                Remote LFA\-FRR backup info
                                                
                                                .. attribute:: has_remote_lfa_bkup
                                                
                                                	Whether path has remote LFA backup
                                                	**type**\:  bool
                                                
                                                .. attribute:: mpls_outgoing_info
                                                
                                                	Remote LFA MPLS nexthop(s\_ info
                                                	**type**\:   :py:class:`MplsOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-ldp-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__init__()

                                                    self.yang_name = "remote-lfa"
                                                    self.yang_parent_name = "mpls"

                                                    self.has_remote_lfa_bkup = YLeaf(YType.boolean, "has-remote-lfa-bkup")

                                                    self.mpls_outgoing_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                    self.mpls_outgoing_info.parent = self
                                                    self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    self._children_yang_names.add("mpls-outgoing-info")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("has_remote_lfa_bkup") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa, self).__setattr__(name, value)


                                                class MplsOutgoingInfo(Entity):
                                                    """
                                                    Remote LFA MPLS nexthop(s\_ info
                                                    
                                                    .. attribute:: stack
                                                    
                                                    	Inner label stack info
                                                    	**type**\: list of    :py:class:`Stack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-ldp-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__init__()

                                                        self.yang_name = "mpls-outgoing-info"
                                                        self.yang_parent_name = "remote-lfa"

                                                        self.stack = YList(self)

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in () and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo, self).__setattr__(name, value)


                                                    class Stack(Entity):
                                                        """
                                                        Inner label stack info
                                                        
                                                        .. attribute:: is_from_graceful_restartable_neighbor
                                                        
                                                        	Is from a GR neighbor
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: is_stale
                                                        
                                                        	Is the entry stale
                                                        	**type**\:  bool
                                                        
                                                        .. attribute:: nexthop_peer_ldp_ident
                                                        
                                                        	Nexthop LDP peer
                                                        	**type**\:   :py:class:`NexthopPeerLdpIdent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent>`
                                                        
                                                        .. attribute:: out_label
                                                        
                                                        	Outgoing label
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: out_label_owner
                                                        
                                                        	Outgoing label owner
                                                        	**type**\:   :py:class:`LdpRoutePathLblOwner <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpRoutePathLblOwner>`
                                                        
                                                        .. attribute:: out_label_rsn
                                                        
                                                        	Outgoing label reason
                                                        	**type**\:   :py:class:`LdpFwdUnlblRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpFwdUnlblRsn>`
                                                        
                                                        .. attribute:: out_label_type
                                                        
                                                        	Outgoing Label Type
                                                        	**type**\:   :py:class:`LabelValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LabelValue>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-ldp-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__init__()

                                                            self.yang_name = "stack"
                                                            self.yang_parent_name = "mpls-outgoing-info"

                                                            self.is_from_graceful_restartable_neighbor = YLeaf(YType.boolean, "is-from-graceful-restartable-neighbor")

                                                            self.is_stale = YLeaf(YType.boolean, "is-stale")

                                                            self.out_label = YLeaf(YType.uint32, "out-label")

                                                            self.out_label_owner = YLeaf(YType.enumeration, "out-label-owner")

                                                            self.out_label_rsn = YLeaf(YType.enumeration, "out-label-rsn")

                                                            self.out_label_type = YLeaf(YType.enumeration, "out-label-type")

                                                            self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                            self.nexthop_peer_ldp_ident.parent = self
                                                            self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                            self._children_yang_names.add("nexthop-peer-ldp-ident")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("is_from_graceful_restartable_neighbor",
                                                                            "is_stale",
                                                                            "out_label",
                                                                            "out_label_owner",
                                                                            "out_label_rsn",
                                                                            "out_label_type") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack, self).__setattr__(name, value)


                                                        class NexthopPeerLdpIdent(Entity):
                                                            """
                                                            Nexthop LDP peer
                                                            
                                                            .. attribute:: label_space_id
                                                            
                                                            	Label space identifier
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: ldp_id
                                                            
                                                            	LDP identifier
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: lsr_id
                                                            
                                                            	LSR identifier
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-ldp-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__init__()

                                                                self.yang_name = "nexthop-peer-ldp-ident"
                                                                self.yang_parent_name = "stack"

                                                                self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                                                                self.ldp_id = YLeaf(YType.str, "ldp-id")

                                                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("label_space_id",
                                                                                "ldp_id",
                                                                                "lsr_id") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.label_space_id.is_set or
                                                                    self.ldp_id.is_set or
                                                                    self.lsr_id.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.label_space_id.yfilter != YFilter.not_set or
                                                                    self.ldp_id.yfilter != YFilter.not_set or
                                                                    self.lsr_id.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "nexthop-peer-ldp-ident" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                                                if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.ldp_id.get_name_leafdata())
                                                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "label-space-id"):
                                                                    self.label_space_id = value
                                                                    self.label_space_id.value_namespace = name_space
                                                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "ldp-id"):
                                                                    self.ldp_id = value
                                                                    self.ldp_id.value_namespace = name_space
                                                                    self.ldp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "lsr-id"):
                                                                    self.lsr_id = value
                                                                    self.lsr_id.value_namespace = name_space
                                                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.is_from_graceful_restartable_neighbor.is_set or
                                                                self.is_stale.is_set or
                                                                self.out_label.is_set or
                                                                self.out_label_owner.is_set or
                                                                self.out_label_rsn.is_set or
                                                                self.out_label_type.is_set or
                                                                (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set or
                                                                self.is_stale.yfilter != YFilter.not_set or
                                                                self.out_label.yfilter != YFilter.not_set or
                                                                self.out_label_owner.yfilter != YFilter.not_set or
                                                                self.out_label_rsn.yfilter != YFilter.not_set or
                                                                self.out_label_type.yfilter != YFilter.not_set or
                                                                (self.nexthop_peer_ldp_ident is not None and self.nexthop_peer_ldp_ident.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "stack" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.is_from_graceful_restartable_neighbor.is_set or self.is_from_graceful_restartable_neighbor.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.is_from_graceful_restartable_neighbor.get_name_leafdata())
                                                            if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.is_stale.get_name_leafdata())
                                                            if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label.get_name_leafdata())
                                                            if (self.out_label_owner.is_set or self.out_label_owner.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_owner.get_name_leafdata())
                                                            if (self.out_label_rsn.is_set or self.out_label_rsn.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_rsn.get_name_leafdata())
                                                            if (self.out_label_type.is_set or self.out_label_type.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.out_label_type.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "nexthop-peer-ldp-ident"):
                                                                if (self.nexthop_peer_ldp_ident is None):
                                                                    self.nexthop_peer_ldp_ident = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack.NexthopPeerLdpIdent()
                                                                    self.nexthop_peer_ldp_ident.parent = self
                                                                    self._children_name_map["nexthop_peer_ldp_ident"] = "nexthop-peer-ldp-ident"
                                                                return self.nexthop_peer_ldp_ident

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "nexthop-peer-ldp-ident" or name == "is-from-graceful-restartable-neighbor" or name == "is-stale" or name == "out-label" or name == "out-label-owner" or name == "out-label-rsn" or name == "out-label-type"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "is-from-graceful-restartable-neighbor"):
                                                                self.is_from_graceful_restartable_neighbor = value
                                                                self.is_from_graceful_restartable_neighbor.value_namespace = name_space
                                                                self.is_from_graceful_restartable_neighbor.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "is-stale"):
                                                                self.is_stale = value
                                                                self.is_stale.value_namespace = name_space
                                                                self.is_stale.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label"):
                                                                self.out_label = value
                                                                self.out_label.value_namespace = name_space
                                                                self.out_label.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-owner"):
                                                                self.out_label_owner = value
                                                                self.out_label_owner.value_namespace = name_space
                                                                self.out_label_owner.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-rsn"):
                                                                self.out_label_rsn = value
                                                                self.out_label_rsn.value_namespace = name_space
                                                                self.out_label_rsn.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "out-label-type"):
                                                                self.out_label_type = value
                                                                self.out_label_type.value_namespace = name_space
                                                                self.out_label_type.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        for c in self.stack:
                                                            if (c.has_data()):
                                                                return True
                                                        return False

                                                    def has_operation(self):
                                                        for c in self.stack:
                                                            if (c.has_operation()):
                                                                return True
                                                        return self.yfilter != YFilter.not_set

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "mpls-outgoing-info" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "stack"):
                                                            for c in self.stack:
                                                                segment = c.get_segment_path()
                                                                if (segment_path == segment):
                                                                    return c
                                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo.Stack()
                                                            c.parent = self
                                                            local_reference_key = "ydk::seg::%s" % segment_path
                                                            self._local_refs[local_reference_key] = c
                                                            self.stack.append(c)
                                                            return c

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "stack"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        pass

                                                def has_data(self):
                                                    return (
                                                        self.has_remote_lfa_bkup.is_set or
                                                        (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.has_remote_lfa_bkup.yfilter != YFilter.not_set or
                                                        (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "remote-lfa" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.has_remote_lfa_bkup.is_set or self.has_remote_lfa_bkup.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.has_remote_lfa_bkup.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "mpls-outgoing-info"):
                                                        if (self.mpls_outgoing_info is None):
                                                            self.mpls_outgoing_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa.MplsOutgoingInfo()
                                                            self.mpls_outgoing_info.parent = self
                                                            self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                        return self.mpls_outgoing_info

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "mpls-outgoing-info" or name == "has-remote-lfa-bkup"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "has-remote-lfa-bkup"):
                                                        self.has_remote_lfa_bkup = value
                                                        self.has_remote_lfa_bkup.value_namespace = name_space
                                                        self.has_remote_lfa_bkup.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_data()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    (self.mpls_outgoing_info is not None and self.mpls_outgoing_info.has_operation()) or
                                                    (self.remote_lfa is not None and self.remote_lfa.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mpls" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "mpls-outgoing-info"):
                                                    if (self.mpls_outgoing_info is None):
                                                        self.mpls_outgoing_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.MplsOutgoingInfo()
                                                        self.mpls_outgoing_info.parent = self
                                                        self._children_name_map["mpls_outgoing_info"] = "mpls-outgoing-info"
                                                    return self.mpls_outgoing_info

                                                if (child_yang_name == "remote-lfa"):
                                                    if (self.remote_lfa is None):
                                                        self.remote_lfa = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls.RemoteLfa()
                                                        self.remote_lfa.parent = self
                                                        self._children_name_map["remote_lfa"] = "remote-lfa"
                                                    return self.remote_lfa

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "mpls-outgoing-info" or name == "remote-lfa"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass

                                        def has_data(self):
                                            return (
                                                (self.mpls is not None and self.mpls.has_data()) or
                                                (self.routing is not None and self.routing.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.mpls is not None and self.mpls.has_operation()) or
                                                (self.routing is not None and self.routing.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "paths" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "mpls"):
                                                if (self.mpls is None):
                                                    self.mpls = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Mpls()
                                                    self.mpls.parent = self
                                                    self._children_name_map["mpls"] = "mpls"
                                                return self.mpls

                                            if (child_yang_name == "routing"):
                                                if (self.routing is None):
                                                    self.routing = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths.Routing()
                                                    self.routing.parent = self
                                                    self._children_name_map["routing"] = "routing"
                                                return self.routing

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "mpls" or name == "routing"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass

                                    def has_data(self):
                                        for c in self.paths:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.prefix.is_set or
                                            self.prefix_length.is_set or
                                            self.table_id.is_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_data()) or
                                            (self.route is not None and self.route.has_data()) or
                                            (self.vrf is not None and self.vrf.has_data()))

                                    def has_operation(self):
                                        for c in self.paths:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.prefix.yfilter != YFilter.not_set or
                                            self.prefix_length.yfilter != YFilter.not_set or
                                            self.table_id.yfilter != YFilter.not_set or
                                            (self.prefix_xr is not None and self.prefix_xr.has_operation()) or
                                            (self.route is not None and self.route.has_operation()) or
                                            (self.vrf is not None and self.vrf.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "forwarding" + "[prefix='" + self.prefix.get() + "']" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.prefix.is_set or self.prefix.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix.get_name_leafdata())
                                        if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_length.get_name_leafdata())
                                        if (self.table_id.is_set or self.table_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.table_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "paths"):
                                            for c in self.paths:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Paths()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.paths.append(c)
                                            return c

                                        if (child_yang_name == "prefix-xr"):
                                            if (self.prefix_xr is None):
                                                self.prefix_xr = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.PrefixXr()
                                                self.prefix_xr.parent = self
                                                self._children_name_map["prefix_xr"] = "prefix-xr"
                                            return self.prefix_xr

                                        if (child_yang_name == "route"):
                                            if (self.route is None):
                                                self.route = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Route()
                                                self.route.parent = self
                                                self._children_name_map["route"] = "route"
                                            return self.route

                                        if (child_yang_name == "vrf"):
                                            if (self.vrf is None):
                                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding.Vrf()
                                                self.vrf.parent = self
                                                self._children_name_map["vrf"] = "vrf"
                                            return self.vrf

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "paths" or name == "prefix-xr" or name == "route" or name == "vrf" or name == "prefix" or name == "prefix-length" or name == "table-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "prefix"):
                                            self.prefix = value
                                            self.prefix.value_namespace = name_space
                                            self.prefix.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-length"):
                                            self.prefix_length = value
                                            self.prefix_length.value_namespace = name_space
                                            self.prefix_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "table-id"):
                                            self.table_id = value
                                            self.table_id.value_namespace = name_space
                                            self.table_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.forwarding:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.forwarding:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwardings" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "forwarding"):
                                        for c in self.forwarding:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings.Forwarding()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.forwarding.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "forwarding"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class BindingsAdvertiseSpec(Entity):
                                """
                                Advertisement Spec (ACL) for LDP Label
                                Infomation Base (LIB)
                                
                                .. attribute:: advt_acl
                                
                                	Advertisement ACLs
                                	**type**\: list of    :py:class:`AdvtAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl>`
                                
                                .. attribute:: allocation_acl
                                
                                	Local label Allocation filter
                                	**type**\:   :py:class:`AllocationAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__init__()

                                    self.yang_name = "bindings-advertise-spec"
                                    self.yang_parent_name = "af"

                                    self.allocation_acl = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                    self.allocation_acl.parent = self
                                    self._children_name_map["allocation_acl"] = "allocation-acl"
                                    self._children_yang_names.add("allocation-acl")

                                    self.advt_acl = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec, self).__setattr__(name, value)


                                class AllocationAcl(Entity):
                                    """
                                    Local label Allocation filter
                                    
                                    .. attribute:: has_acl
                                    
                                    	Has ACL filter?
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_host_route_only
                                    
                                    	Host\-routes only?
                                    	**type**\:  bool
                                    
                                    .. attribute:: prefix_acl
                                    
                                    	Prefix ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__init__()

                                        self.yang_name = "allocation-acl"
                                        self.yang_parent_name = "bindings-advertise-spec"

                                        self.has_acl = YLeaf(YType.boolean, "has-acl")

                                        self.is_host_route_only = YLeaf(YType.boolean, "is-host-route-only")

                                        self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("has_acl",
                                                        "is_host_route_only",
                                                        "prefix_acl") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.has_acl.is_set or
                                            self.is_host_route_only.is_set or
                                            self.prefix_acl.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.has_acl.yfilter != YFilter.not_set or
                                            self.is_host_route_only.yfilter != YFilter.not_set or
                                            self.prefix_acl.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "allocation-acl" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.has_acl.is_set or self.has_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.has_acl.get_name_leafdata())
                                        if (self.is_host_route_only.is_set or self.is_host_route_only.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_host_route_only.get_name_leafdata())
                                        if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "has-acl" or name == "is-host-route-only" or name == "prefix-acl"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "has-acl"):
                                            self.has_acl = value
                                            self.has_acl.value_namespace = name_space
                                            self.has_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-host-route-only"):
                                            self.is_host_route_only = value
                                            self.is_host_route_only.value_namespace = name_space
                                            self.is_host_route_only.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-acl"):
                                            self.prefix_acl = value
                                            self.prefix_acl.value_namespace = name_space
                                            self.prefix_acl.value_namespace_prefix = name_space_prefix


                                class AdvtAcl(Entity):
                                    """
                                    Advertisement ACLs
                                    
                                    .. attribute:: peer_acl
                                    
                                    	Peer ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    .. attribute:: prefix_acl
                                    
                                    	Prefix ACL
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__init__()

                                        self.yang_name = "advt-acl"
                                        self.yang_parent_name = "bindings-advertise-spec"

                                        self.peer_acl = YLeaf(YType.str, "peer-acl")

                                        self.prefix_acl = YLeaf(YType.str, "prefix-acl")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("peer_acl",
                                                        "prefix_acl") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.peer_acl.is_set or
                                            self.prefix_acl.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.peer_acl.yfilter != YFilter.not_set or
                                            self.prefix_acl.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "advt-acl" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.peer_acl.is_set or self.peer_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.peer_acl.get_name_leafdata())
                                        if (self.prefix_acl.is_set or self.prefix_acl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_acl.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "peer-acl" or name == "prefix-acl"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "peer-acl"):
                                            self.peer_acl = value
                                            self.peer_acl.value_namespace = name_space
                                            self.peer_acl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-acl"):
                                            self.prefix_acl = value
                                            self.prefix_acl.value_namespace = name_space
                                            self.prefix_acl.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.advt_acl:
                                        if (c.has_data()):
                                            return True
                                    return (self.allocation_acl is not None and self.allocation_acl.has_data())

                                def has_operation(self):
                                    for c in self.advt_acl:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.allocation_acl is not None and self.allocation_acl.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bindings-advertise-spec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "advt-acl"):
                                        for c in self.advt_acl:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AdvtAcl()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.advt_acl.append(c)
                                        return c

                                    if (child_yang_name == "allocation-acl"):
                                        if (self.allocation_acl is None):
                                            self.allocation_acl = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec.AllocationAcl()
                                            self.allocation_acl.parent = self
                                            self._children_name_map["allocation_acl"] = "allocation-acl"
                                        return self.allocation_acl

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "advt-acl" or name == "allocation-acl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class ForwardingSummary(Entity):
                                """
                                Summary information regarding LDP forwarding
                                setup
                                
                                .. attribute:: fsht
                                
                                	Forwarding state hold time registered with LSD
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: intfs
                                
                                	MPLS forwarding enabled interface count
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: is_lsd_bound
                                
                                	LDP is connected to LSD server
                                	**type**\:  bool
                                
                                .. attribute:: lbls
                                
                                	Local label allocated count
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: rws
                                
                                	Forwarding rewrites summary
                                	**type**\:   :py:class:`Rws <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws>`
                                
                                .. attribute:: vrf
                                
                                	VRF information
                                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__init__()

                                    self.yang_name = "forwarding-summary"
                                    self.yang_parent_name = "af"

                                    self.fsht = YLeaf(YType.uint16, "fsht")

                                    self.intfs = YLeaf(YType.uint16, "intfs")

                                    self.is_lsd_bound = YLeaf(YType.boolean, "is-lsd-bound")

                                    self.lbls = YLeaf(YType.uint16, "lbls")

                                    self.rws = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws()
                                    self.rws.parent = self
                                    self._children_name_map["rws"] = "rws"
                                    self._children_yang_names.add("rws")

                                    self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf()
                                    self.vrf.parent = self
                                    self._children_name_map["vrf"] = "vrf"
                                    self._children_yang_names.add("vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fsht",
                                                    "intfs",
                                                    "is_lsd_bound",
                                                    "lbls") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary, self).__setattr__(name, value)


                                class Vrf(Entity):
                                    """
                                    VRF information
                                    
                                    .. attribute:: id
                                    
                                    	VRF Id
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: name
                                    
                                    	VRF Name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__init__()

                                        self.yang_name = "vrf"
                                        self.yang_parent_name = "forwarding-summary"

                                        self.id = YLeaf(YType.uint32, "id")

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("id",
                                                        "name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.id.is_set or
                                            self.name.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.id.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "vrf" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.id.get_name_leafdata())
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "id" or name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "id"):
                                            self.id = value
                                            self.id.value_namespace = name_space
                                            self.id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class Rws(Entity):
                                    """
                                    Forwarding rewrites summary
                                    
                                    .. attribute:: nhs
                                    
                                    	Forwarding rewrites nexthops (paths) summary
                                    	**type**\:   :py:class:`Nhs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs>`
                                    
                                    .. attribute:: pfxs
                                    
                                    	Forwarding rewrites prefix summary
                                    	**type**\:   :py:class:`Pfxs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws, self).__init__()

                                        self.yang_name = "rws"
                                        self.yang_parent_name = "forwarding-summary"

                                        self.nhs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                        self.nhs.parent = self
                                        self._children_name_map["nhs"] = "nhs"
                                        self._children_yang_names.add("nhs")

                                        self.pfxs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                        self.pfxs.parent = self
                                        self._children_name_map["pfxs"] = "pfxs"
                                        self._children_yang_names.add("pfxs")


                                    class Pfxs(Entity):
                                        """
                                        Forwarding rewrites prefix summary
                                        
                                        .. attribute:: ecmp_pfxs
                                        
                                        	Count of prefixes with ECMP
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: labeled_pfxs_aggr
                                        
                                        	Labeled prefix count for all paths
                                        	**type**\:   :py:class:`LabeledPfxsAggr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr>`
                                        
                                        .. attribute:: labeled_pfxs_backup
                                        
                                        	Labeled prefix count related to backup paths only
                                        	**type**\:   :py:class:`LabeledPfxsBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup>`
                                        
                                        .. attribute:: labeled_pfxs_primary
                                        
                                        	Labeled prefix count related to primary paths only
                                        	**type**\:   :py:class:`LabeledPfxsPrimary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary>`
                                        
                                        .. attribute:: protected_pfxs
                                        
                                        	Count of FRR protected prefixes
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: total_pfxs
                                        
                                        	Total Prefix count
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__init__()

                                            self.yang_name = "pfxs"
                                            self.yang_parent_name = "rws"

                                            self.ecmp_pfxs = YLeaf(YType.uint16, "ecmp-pfxs")

                                            self.protected_pfxs = YLeaf(YType.uint16, "protected-pfxs")

                                            self.total_pfxs = YLeaf(YType.uint16, "total-pfxs")

                                            self.labeled_pfxs_aggr = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                            self.labeled_pfxs_aggr.parent = self
                                            self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                            self._children_yang_names.add("labeled-pfxs-aggr")

                                            self.labeled_pfxs_backup = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                            self.labeled_pfxs_backup.parent = self
                                            self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                            self._children_yang_names.add("labeled-pfxs-backup")

                                            self.labeled_pfxs_primary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                            self.labeled_pfxs_primary.parent = self
                                            self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                            self._children_yang_names.add("labeled-pfxs-primary")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("ecmp_pfxs",
                                                            "protected_pfxs",
                                                            "total_pfxs") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs, self).__setattr__(name, value)


                                        class LabeledPfxsAggr(Entity):
                                            """
                                            Labeled prefix count for all paths
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__init__()

                                                self.yang_name = "labeled-pfxs-aggr"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-aggr" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                        class LabeledPfxsPrimary(Entity):
                                            """
                                            Labeled prefix count related to primary paths
                                            only
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__init__()

                                                self.yang_name = "labeled-pfxs-primary"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-primary" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix


                                        class LabeledPfxsBackup(Entity):
                                            """
                                            Labeled prefix count related to backup paths
                                            only
                                            
                                            .. attribute:: labeled_pfxs
                                            
                                            	Count of labeled prefixes with 1 or more paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: labeled_pfxs_partial
                                            
                                            	Count of labeled prefixes with some (but not ALL) paths labeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: unlabeled_pfxs
                                            
                                            	Count of labeled prefixes with ALL paths unlabeled
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__init__()

                                                self.yang_name = "labeled-pfxs-backup"
                                                self.yang_parent_name = "pfxs"

                                                self.labeled_pfxs = YLeaf(YType.uint16, "labeled-pfxs")

                                                self.labeled_pfxs_partial = YLeaf(YType.uint16, "labeled-pfxs-partial")

                                                self.unlabeled_pfxs = YLeaf(YType.uint16, "unlabeled-pfxs")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("labeled_pfxs",
                                                                "labeled_pfxs_partial",
                                                                "unlabeled_pfxs") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.labeled_pfxs.is_set or
                                                    self.labeled_pfxs_partial.is_set or
                                                    self.unlabeled_pfxs.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs.yfilter != YFilter.not_set or
                                                    self.labeled_pfxs_partial.yfilter != YFilter.not_set or
                                                    self.unlabeled_pfxs.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "labeled-pfxs-backup" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.labeled_pfxs.is_set or self.labeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs.get_name_leafdata())
                                                if (self.labeled_pfxs_partial.is_set or self.labeled_pfxs_partial.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.labeled_pfxs_partial.get_name_leafdata())
                                                if (self.unlabeled_pfxs.is_set or self.unlabeled_pfxs.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.unlabeled_pfxs.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "labeled-pfxs" or name == "labeled-pfxs-partial" or name == "unlabeled-pfxs"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "labeled-pfxs"):
                                                    self.labeled_pfxs = value
                                                    self.labeled_pfxs.value_namespace = name_space
                                                    self.labeled_pfxs.value_namespace_prefix = name_space_prefix
                                                if(value_path == "labeled-pfxs-partial"):
                                                    self.labeled_pfxs_partial = value
                                                    self.labeled_pfxs_partial.value_namespace = name_space
                                                    self.labeled_pfxs_partial.value_namespace_prefix = name_space_prefix
                                                if(value_path == "unlabeled-pfxs"):
                                                    self.unlabeled_pfxs = value
                                                    self.unlabeled_pfxs.value_namespace = name_space
                                                    self.unlabeled_pfxs.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.ecmp_pfxs.is_set or
                                                self.protected_pfxs.is_set or
                                                self.total_pfxs.is_set or
                                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_data()) or
                                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_data()) or
                                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.ecmp_pfxs.yfilter != YFilter.not_set or
                                                self.protected_pfxs.yfilter != YFilter.not_set or
                                                self.total_pfxs.yfilter != YFilter.not_set or
                                                (self.labeled_pfxs_aggr is not None and self.labeled_pfxs_aggr.has_operation()) or
                                                (self.labeled_pfxs_backup is not None and self.labeled_pfxs_backup.has_operation()) or
                                                (self.labeled_pfxs_primary is not None and self.labeled_pfxs_primary.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "pfxs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.ecmp_pfxs.is_set or self.ecmp_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ecmp_pfxs.get_name_leafdata())
                                            if (self.protected_pfxs.is_set or self.protected_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_pfxs.get_name_leafdata())
                                            if (self.total_pfxs.is_set or self.total_pfxs.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_pfxs.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "labeled-pfxs-aggr"):
                                                if (self.labeled_pfxs_aggr is None):
                                                    self.labeled_pfxs_aggr = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsAggr()
                                                    self.labeled_pfxs_aggr.parent = self
                                                    self._children_name_map["labeled_pfxs_aggr"] = "labeled-pfxs-aggr"
                                                return self.labeled_pfxs_aggr

                                            if (child_yang_name == "labeled-pfxs-backup"):
                                                if (self.labeled_pfxs_backup is None):
                                                    self.labeled_pfxs_backup = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsBackup()
                                                    self.labeled_pfxs_backup.parent = self
                                                    self._children_name_map["labeled_pfxs_backup"] = "labeled-pfxs-backup"
                                                return self.labeled_pfxs_backup

                                            if (child_yang_name == "labeled-pfxs-primary"):
                                                if (self.labeled_pfxs_primary is None):
                                                    self.labeled_pfxs_primary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs.LabeledPfxsPrimary()
                                                    self.labeled_pfxs_primary.parent = self
                                                    self._children_name_map["labeled_pfxs_primary"] = "labeled-pfxs-primary"
                                                return self.labeled_pfxs_primary

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "labeled-pfxs-aggr" or name == "labeled-pfxs-backup" or name == "labeled-pfxs-primary" or name == "ecmp-pfxs" or name == "protected-pfxs" or name == "total-pfxs"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "ecmp-pfxs"):
                                                self.ecmp_pfxs = value
                                                self.ecmp_pfxs.value_namespace = name_space
                                                self.ecmp_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-pfxs"):
                                                self.protected_pfxs = value
                                                self.protected_pfxs.value_namespace = name_space
                                                self.protected_pfxs.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-pfxs"):
                                                self.total_pfxs = value
                                                self.total_pfxs.value_namespace = name_space
                                                self.total_pfxs.value_namespace_prefix = name_space_prefix


                                    class Nhs(Entity):
                                        """
                                        Forwarding rewrites nexthops (paths) summary
                                        
                                        .. attribute:: backup_paths
                                        
                                        	Count of non\-primary backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: labeled_backup_paths
                                        
                                        	Count of labeled backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: labeled_paths
                                        
                                        	Count of all labeled paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: protected_paths
                                        
                                        	Count of FRR protected paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: remote_backup_paths
                                        
                                        	Count of non\-primary remote backup paths
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: total_paths
                                        
                                        	Total path count
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__init__()

                                            self.yang_name = "nhs"
                                            self.yang_parent_name = "rws"

                                            self.backup_paths = YLeaf(YType.uint32, "backup-paths")

                                            self.labeled_backup_paths = YLeaf(YType.uint32, "labeled-backup-paths")

                                            self.labeled_paths = YLeaf(YType.uint32, "labeled-paths")

                                            self.protected_paths = YLeaf(YType.uint32, "protected-paths")

                                            self.remote_backup_paths = YLeaf(YType.uint32, "remote-backup-paths")

                                            self.total_paths = YLeaf(YType.uint32, "total-paths")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("backup_paths",
                                                            "labeled_backup_paths",
                                                            "labeled_paths",
                                                            "protected_paths",
                                                            "remote_backup_paths",
                                                            "total_paths") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.backup_paths.is_set or
                                                self.labeled_backup_paths.is_set or
                                                self.labeled_paths.is_set or
                                                self.protected_paths.is_set or
                                                self.remote_backup_paths.is_set or
                                                self.total_paths.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.backup_paths.yfilter != YFilter.not_set or
                                                self.labeled_backup_paths.yfilter != YFilter.not_set or
                                                self.labeled_paths.yfilter != YFilter.not_set or
                                                self.protected_paths.yfilter != YFilter.not_set or
                                                self.remote_backup_paths.yfilter != YFilter.not_set or
                                                self.total_paths.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "nhs" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.backup_paths.is_set or self.backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.backup_paths.get_name_leafdata())
                                            if (self.labeled_backup_paths.is_set or self.labeled_backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_backup_paths.get_name_leafdata())
                                            if (self.labeled_paths.is_set or self.labeled_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.labeled_paths.get_name_leafdata())
                                            if (self.protected_paths.is_set or self.protected_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_paths.get_name_leafdata())
                                            if (self.remote_backup_paths.is_set or self.remote_backup_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.remote_backup_paths.get_name_leafdata())
                                            if (self.total_paths.is_set or self.total_paths.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.total_paths.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "backup-paths" or name == "labeled-backup-paths" or name == "labeled-paths" or name == "protected-paths" or name == "remote-backup-paths" or name == "total-paths"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "backup-paths"):
                                                self.backup_paths = value
                                                self.backup_paths.value_namespace = name_space
                                                self.backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-backup-paths"):
                                                self.labeled_backup_paths = value
                                                self.labeled_backup_paths.value_namespace = name_space
                                                self.labeled_backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "labeled-paths"):
                                                self.labeled_paths = value
                                                self.labeled_paths.value_namespace = name_space
                                                self.labeled_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-paths"):
                                                self.protected_paths = value
                                                self.protected_paths.value_namespace = name_space
                                                self.protected_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "remote-backup-paths"):
                                                self.remote_backup_paths = value
                                                self.remote_backup_paths.value_namespace = name_space
                                                self.remote_backup_paths.value_namespace_prefix = name_space_prefix
                                            if(value_path == "total-paths"):
                                                self.total_paths = value
                                                self.total_paths.value_namespace = name_space
                                                self.total_paths.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.nhs is not None and self.nhs.has_data()) or
                                            (self.pfxs is not None and self.pfxs.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.nhs is not None and self.nhs.has_operation()) or
                                            (self.pfxs is not None and self.pfxs.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "rws" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "nhs"):
                                            if (self.nhs is None):
                                                self.nhs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Nhs()
                                                self.nhs.parent = self
                                                self._children_name_map["nhs"] = "nhs"
                                            return self.nhs

                                        if (child_yang_name == "pfxs"):
                                            if (self.pfxs is None):
                                                self.pfxs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws.Pfxs()
                                                self.pfxs.parent = self
                                                self._children_name_map["pfxs"] = "pfxs"
                                            return self.pfxs

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "nhs" or name == "pfxs"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.fsht.is_set or
                                        self.intfs.is_set or
                                        self.is_lsd_bound.is_set or
                                        self.lbls.is_set or
                                        (self.rws is not None and self.rws.has_data()) or
                                        (self.vrf is not None and self.vrf.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fsht.yfilter != YFilter.not_set or
                                        self.intfs.yfilter != YFilter.not_set or
                                        self.is_lsd_bound.yfilter != YFilter.not_set or
                                        self.lbls.yfilter != YFilter.not_set or
                                        (self.rws is not None and self.rws.has_operation()) or
                                        (self.vrf is not None and self.vrf.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "forwarding-summary" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fsht.is_set or self.fsht.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fsht.get_name_leafdata())
                                    if (self.intfs.is_set or self.intfs.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.intfs.get_name_leafdata())
                                    if (self.is_lsd_bound.is_set or self.is_lsd_bound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_lsd_bound.get_name_leafdata())
                                    if (self.lbls.is_set or self.lbls.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lbls.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "rws"):
                                        if (self.rws is None):
                                            self.rws = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Rws()
                                            self.rws.parent = self
                                            self._children_name_map["rws"] = "rws"
                                        return self.rws

                                    if (child_yang_name == "vrf"):
                                        if (self.vrf is None):
                                            self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary.Vrf()
                                            self.vrf.parent = self
                                            self._children_name_map["vrf"] = "vrf"
                                        return self.vrf

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "rws" or name == "vrf" or name == "fsht" or name == "intfs" or name == "is-lsd-bound" or name == "lbls"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fsht"):
                                        self.fsht = value
                                        self.fsht.value_namespace = name_space
                                        self.fsht.value_namespace_prefix = name_space_prefix
                                    if(value_path == "intfs"):
                                        self.intfs = value
                                        self.intfs.value_namespace = name_space
                                        self.intfs.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-lsd-bound"):
                                        self.is_lsd_bound = value
                                        self.is_lsd_bound.value_namespace = name_space
                                        self.is_lsd_bound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lbls"):
                                        self.lbls = value
                                        self.lbls.value_namespace = name_space
                                        self.lbls.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.af_name.is_set or
                                    (self.bindings is not None and self.bindings.has_data()) or
                                    (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_data()) or
                                    (self.bindings_summary is not None and self.bindings_summary.has_data()) or
                                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                                    (self.discovery is not None and self.discovery.has_data()) or
                                    (self.forwarding_summary is not None and self.forwarding_summary.has_data()) or
                                    (self.forwardings is not None and self.forwardings.has_data()) or
                                    (self.igp is not None and self.igp.has_data()) or
                                    (self.interface_summary is not None and self.interface_summary.has_data()) or
                                    (self.interfaces is not None and self.interfaces.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.af_name.yfilter != YFilter.not_set or
                                    (self.bindings is not None and self.bindings.has_operation()) or
                                    (self.bindings_advertise_spec is not None and self.bindings_advertise_spec.has_operation()) or
                                    (self.bindings_summary is not None and self.bindings_summary.has_operation()) or
                                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                                    (self.discovery is not None and self.discovery.has_operation()) or
                                    (self.forwarding_summary is not None and self.forwarding_summary.has_operation()) or
                                    (self.forwardings is not None and self.forwardings.has_operation()) or
                                    (self.igp is not None and self.igp.has_operation()) or
                                    (self.interface_summary is not None and self.interface_summary.has_operation()) or
                                    (self.interfaces is not None and self.interfaces.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "af" + "[af-name='" + self.af_name.get() + "']" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.af_name.is_set or self.af_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.af_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bindings"):
                                    if (self.bindings is None):
                                        self.bindings = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Bindings()
                                        self.bindings.parent = self
                                        self._children_name_map["bindings"] = "bindings"
                                    return self.bindings

                                if (child_yang_name == "bindings-advertise-spec"):
                                    if (self.bindings_advertise_spec is None):
                                        self.bindings_advertise_spec = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsAdvertiseSpec()
                                        self.bindings_advertise_spec.parent = self
                                        self._children_name_map["bindings_advertise_spec"] = "bindings-advertise-spec"
                                    return self.bindings_advertise_spec

                                if (child_yang_name == "bindings-summary"):
                                    if (self.bindings_summary is None):
                                        self.bindings_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummary()
                                        self.bindings_summary.parent = self
                                        self._children_name_map["bindings_summary"] = "bindings-summary"
                                    return self.bindings_summary

                                if (child_yang_name == "bindings-summary-all"):
                                    if (self.bindings_summary_all is None):
                                        self.bindings_summary_all = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.BindingsSummaryAll()
                                        self.bindings_summary_all.parent = self
                                        self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                                    return self.bindings_summary_all

                                if (child_yang_name == "discovery"):
                                    if (self.discovery is None):
                                        self.discovery = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Discovery()
                                        self.discovery.parent = self
                                        self._children_name_map["discovery"] = "discovery"
                                    return self.discovery

                                if (child_yang_name == "forwarding-summary"):
                                    if (self.forwarding_summary is None):
                                        self.forwarding_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.ForwardingSummary()
                                        self.forwarding_summary.parent = self
                                        self._children_name_map["forwarding_summary"] = "forwarding-summary"
                                    return self.forwarding_summary

                                if (child_yang_name == "forwardings"):
                                    if (self.forwardings is None):
                                        self.forwardings = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Forwardings()
                                        self.forwardings.parent = self
                                        self._children_name_map["forwardings"] = "forwardings"
                                    return self.forwardings

                                if (child_yang_name == "igp"):
                                    if (self.igp is None):
                                        self.igp = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Igp()
                                        self.igp.parent = self
                                        self._children_name_map["igp"] = "igp"
                                    return self.igp

                                if (child_yang_name == "interface-summary"):
                                    if (self.interface_summary is None):
                                        self.interface_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.InterfaceSummary()
                                        self.interface_summary.parent = self
                                        self._children_name_map["interface_summary"] = "interface-summary"
                                    return self.interface_summary

                                if (child_yang_name == "interfaces"):
                                    if (self.interfaces is None):
                                        self.interfaces = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af.Interfaces()
                                        self.interfaces.parent = self
                                        self._children_name_map["interfaces"] = "interfaces"
                                    return self.interfaces

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bindings" or name == "bindings-advertise-spec" or name == "bindings-summary" or name == "bindings-summary-all" or name == "discovery" or name == "forwarding-summary" or name == "forwardings" or name == "igp" or name == "interface-summary" or name == "interfaces" or name == "af-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "af-name"):
                                    self.af_name = value
                                    self.af_name.value_namespace = name_space
                                    self.af_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.af:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.af:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "afs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "af"):
                                for c in self.af:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs.Af()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.af.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "af"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborBriefs(Entity):
                        """
                        The LDP Neighbors (brief)
                        
                        .. attribute:: neighbor_brief
                        
                        	Brief information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`NeighborBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs, self).__init__()

                            self.yang_name = "neighbor-briefs"
                            self.yang_parent_name = "vrf"

                            self.neighbor_brief = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs, self).__setattr__(name, value)


                        class NeighborBrief(Entity):
                            """
                            Brief information on a particular LDP neighbor
                            
                            .. attribute:: is_graceful_restartable
                            
                            	Is graceful restartable
                            	**type**\:  bool
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: nbr_br_af_info
                            
                            	Neighbor Brief AF Info
                            	**type**\: list of    :py:class:`NbrBrAfInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo>`
                            
                            .. attribute:: nsr_state
                            
                            	NSR readiness state
                            	**type**\:   :py:class:`ShowNsrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.ShowNsrState>`
                            
                            .. attribute:: up_time_seconds
                            
                            	Up time in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__init__()

                                self.yang_name = "neighbor-brief"
                                self.yang_parent_name = "neighbor-briefs"

                                self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.nsr_state = YLeaf(YType.enumeration, "nsr-state")

                                self.up_time_seconds = YLeaf(YType.uint32, "up-time-seconds")

                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")

                                self.nbr_br_af_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_graceful_restartable",
                                                "label_space_id",
                                                "lsr_id",
                                                "nsr_state",
                                                "up_time_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief, self).__setattr__(name, value)


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "neighbor-brief"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class NbrBrAfInfo(Entity):
                                """
                                Neighbor Brief AF Info
                                
                                .. attribute:: address_family
                                
                                	Neighbor Brief Address Family
                                	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                                
                                .. attribute:: num_of_nbr_addresses
                                
                                	Number of neighbor addresses
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_nbr_discovery
                                
                                	Number of neighbor discovery sources
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: num_of_nbr_lbl
                                
                                	Number of neighbor labels
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__init__()

                                    self.yang_name = "nbr-br-af-info"
                                    self.yang_parent_name = "neighbor-brief"

                                    self.address_family = YLeaf(YType.enumeration, "address-family")

                                    self.num_of_nbr_addresses = YLeaf(YType.uint32, "num-of-nbr-addresses")

                                    self.num_of_nbr_discovery = YLeaf(YType.uint32, "num-of-nbr-discovery")

                                    self.num_of_nbr_lbl = YLeaf(YType.uint32, "num-of-nbr-lbl")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_family",
                                                    "num_of_nbr_addresses",
                                                    "num_of_nbr_discovery",
                                                    "num_of_nbr_lbl") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_family.is_set or
                                        self.num_of_nbr_addresses.is_set or
                                        self.num_of_nbr_discovery.is_set or
                                        self.num_of_nbr_lbl.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_family.yfilter != YFilter.not_set or
                                        self.num_of_nbr_addresses.yfilter != YFilter.not_set or
                                        self.num_of_nbr_discovery.yfilter != YFilter.not_set or
                                        self.num_of_nbr_lbl.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "nbr-br-af-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_family.get_name_leafdata())
                                    if (self.num_of_nbr_addresses.is_set or self.num_of_nbr_addresses.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_addresses.get_name_leafdata())
                                    if (self.num_of_nbr_discovery.is_set or self.num_of_nbr_discovery.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_discovery.get_name_leafdata())
                                    if (self.num_of_nbr_lbl.is_set or self.num_of_nbr_lbl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.num_of_nbr_lbl.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-family" or name == "num-of-nbr-addresses" or name == "num-of-nbr-discovery" or name == "num-of-nbr-lbl"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-family"):
                                        self.address_family = value
                                        self.address_family.value_namespace = name_space
                                        self.address_family.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-addresses"):
                                        self.num_of_nbr_addresses = value
                                        self.num_of_nbr_addresses.value_namespace = name_space
                                        self.num_of_nbr_addresses.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-discovery"):
                                        self.num_of_nbr_discovery = value
                                        self.num_of_nbr_discovery.value_namespace = name_space
                                        self.num_of_nbr_discovery.value_namespace_prefix = name_space_prefix
                                    if(value_path == "num-of-nbr-lbl"):
                                        self.num_of_nbr_lbl = value
                                        self.num_of_nbr_lbl.value_namespace = name_space
                                        self.num_of_nbr_lbl.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.nbr_br_af_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_graceful_restartable.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    self.nsr_state.is_set or
                                    self.up_time_seconds.is_set or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                for c in self.nbr_br_af_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_graceful_restartable.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    self.nsr_state.yfilter != YFilter.not_set or
                                    self.up_time_seconds.yfilter != YFilter.not_set or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-brief" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                if (self.nsr_state.is_set or self.nsr_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.nsr_state.get_name_leafdata())
                                if (self.up_time_seconds.is_set or self.up_time_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.up_time_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "nbr-br-af-info"):
                                    for c in self.nbr_br_af_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.NbrBrAfInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.nbr_br_af_info.append(c)
                                    return c

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "nbr-br-af-info" or name == "vrf" or name == "is-graceful-restartable" or name == "label-space-id" or name == "lsr-id" or name == "nsr-state" or name == "up-time-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-graceful-restartable"):
                                    self.is_graceful_restartable = value
                                    self.is_graceful_restartable.value_namespace = name_space
                                    self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "nsr-state"):
                                    self.nsr_state = value
                                    self.nsr_state.value_namespace = name_space
                                    self.nsr_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "up-time-seconds"):
                                    self.up_time_seconds = value
                                    self.up_time_seconds.value_namespace = name_space
                                    self.up_time_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor_brief:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor_brief:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-briefs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-brief"):
                                for c in self.neighbor_brief:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs.NeighborBrief()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor_brief.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-brief"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class BackoffParameters(Entity):
                        """
                        The LDP Backoff Parameters
                        
                        .. attribute:: initial_seconds
                        
                        	Initial backoff value in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: maximum_seconds
                        
                        	Maximum backoff value in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.BackoffParameters, self).__init__()

                            self.yang_name = "backoff-parameters"
                            self.yang_parent_name = "vrf"

                            self.initial_seconds = YLeaf(YType.uint32, "initial-seconds")

                            self.maximum_seconds = YLeaf(YType.uint32, "maximum-seconds")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("initial_seconds",
                                            "maximum_seconds") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.BackoffParameters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.BackoffParameters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.initial_seconds.is_set or
                                self.maximum_seconds.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.initial_seconds.yfilter != YFilter.not_set or
                                self.maximum_seconds.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoff-parameters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.initial_seconds.is_set or self.initial_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.initial_seconds.get_name_leafdata())
                            if (self.maximum_seconds.is_set or self.maximum_seconds.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_seconds.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "initial-seconds" or name == "maximum-seconds"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "initial-seconds"):
                                self.initial_seconds = value
                                self.initial_seconds.value_namespace = name_space
                                self.initial_seconds.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-seconds"):
                                self.maximum_seconds = value
                                self.maximum_seconds.value_namespace = name_space
                                self.maximum_seconds.value_namespace_prefix = name_space_prefix


                    class Backoffs(Entity):
                        """
                        The LDP backoff
                        
                        .. attribute:: backoff
                        
                        	LDP Backoff Information
                        	**type**\: list of    :py:class:`Backoff <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs.Backoff>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs, self).__init__()

                            self.yang_name = "backoffs"
                            self.yang_parent_name = "vrf"

                            self.backoff = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs, self).__setattr__(name, value)


                        class Backoff(Entity):
                            """
                            LDP Backoff Information
                            
                            .. attribute:: backoff_seconds
                            
                            	Backoff seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: waiting_seconds
                            
                            	Backoff waiting seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs.Backoff, self).__init__()

                                self.yang_name = "backoff"
                                self.yang_parent_name = "backoffs"

                                self.backoff_seconds = YLeaf(YType.uint32, "backoff-seconds")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.waiting_seconds = YLeaf(YType.uint32, "waiting-seconds")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backoff_seconds",
                                                "label_space_id",
                                                "lsr_id",
                                                "waiting_seconds") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs.Backoff, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs.Backoff, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.backoff_seconds.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    self.waiting_seconds.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backoff_seconds.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    self.waiting_seconds.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backoff" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backoff_seconds.is_set or self.backoff_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backoff_seconds.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                if (self.waiting_seconds.is_set or self.waiting_seconds.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.waiting_seconds.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backoff-seconds" or name == "label-space-id" or name == "lsr-id" or name == "waiting-seconds"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backoff-seconds"):
                                    self.backoff_seconds = value
                                    self.backoff_seconds.value_namespace = name_space
                                    self.backoff_seconds.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "waiting-seconds"):
                                    self.waiting_seconds = value
                                    self.waiting_seconds.value_namespace = name_space
                                    self.waiting_seconds.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.backoff:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.backoff:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "backoffs" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backoff"):
                                for c in self.backoff:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs.Backoff()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.backoff.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Nsr(Entity):
                        """
                        LDP NSR related information
                        
                        .. attribute:: ha_statistics
                        
                        	LDP NSR Statistics related information
                        	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics>`
                        
                        .. attribute:: ha_summary
                        
                        	LDP HA Summary
                        	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary>`
                        
                        .. attribute:: nsr_pending
                        
                        	LDP NSR Pending related information
                        	**type**\:   :py:class:`NsrPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr, self).__init__()

                            self.yang_name = "nsr"
                            self.yang_parent_name = "vrf"

                            self.ha_statistics = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics()
                            self.ha_statistics.parent = self
                            self._children_name_map["ha_statistics"] = "ha-statistics"
                            self._children_yang_names.add("ha-statistics")

                            self.ha_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary()
                            self.ha_summary.parent = self
                            self._children_name_map["ha_summary"] = "ha-summary"
                            self._children_yang_names.add("ha-summary")

                            self.nsr_pending = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending()
                            self.nsr_pending.parent = self
                            self._children_name_map["nsr_pending"] = "nsr-pending"
                            self._children_yang_names.add("nsr-pending")


                        class NsrPending(Entity):
                            """
                            LDP NSR Pending related information
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending, self).__init__()

                                self.yang_name = "nsr-pending"
                                self.yang_parent_name = "nsr"

                                self.ha_neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "nsr-pending"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (self.ha_neighbors is not None and self.ha_neighbors.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "nsr-pending" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaSummary(Entity):
                            """
                            LDP HA Summary
                            
                            .. attribute:: sessions
                            
                            	Session summary
                            	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Sessions>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary, self).__init__()

                                self.yang_name = "ha-summary"
                                self.yang_parent_name = "nsr"

                                self.sessions = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Sessions()
                                self.sessions.parent = self
                                self._children_name_map["sessions"] = "sessions"
                                self._children_yang_names.add("sessions")

                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "ha-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Sessions(Entity):
                                """
                                Session summary
                                
                                .. attribute:: nsr_eligible
                                
                                	NSR eligible sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_app_wait
                                
                                	Number of sessions in NSR app\-wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_none
                                
                                	Number of sessions in NSR none state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_operational
                                
                                	Number of sessions in NSR operational state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_prepare
                                
                                	Number of sessions in NSR prepare state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_ready
                                
                                	Number of sessions in NSR ready state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase1
                                
                                	Number of sessions in NSR TCP phase 1 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase2
                                
                                	Number of sessions in NSR TCP phase 2 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_wait
                                
                                	Number of sessions in NSR wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total
                                
                                	Total sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__init__()

                                    self.yang_name = "sessions"
                                    self.yang_parent_name = "ha-summary"

                                    self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                    self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                    self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                    self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                    self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                    self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                    self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                    self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                    self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                    self.total = YLeaf(YType.uint32, "total")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nsr_eligible",
                                                    "nsr_state_app_wait",
                                                    "nsr_state_none",
                                                    "nsr_state_operational",
                                                    "nsr_state_prepare",
                                                    "nsr_state_ready",
                                                    "nsr_state_tcp_phase1",
                                                    "nsr_state_tcp_phase2",
                                                    "nsr_state_wait",
                                                    "total") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Sessions, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nsr_eligible.is_set or
                                        self.nsr_state_app_wait.is_set or
                                        self.nsr_state_none.is_set or
                                        self.nsr_state_operational.is_set or
                                        self.nsr_state_prepare.is_set or
                                        self.nsr_state_ready.is_set or
                                        self.nsr_state_tcp_phase1.is_set or
                                        self.nsr_state_tcp_phase2.is_set or
                                        self.nsr_state_wait.is_set or
                                        self.total.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nsr_eligible.yfilter != YFilter.not_set or
                                        self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                        self.nsr_state_none.yfilter != YFilter.not_set or
                                        self.nsr_state_operational.yfilter != YFilter.not_set or
                                        self.nsr_state_prepare.yfilter != YFilter.not_set or
                                        self.nsr_state_ready.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                        self.nsr_state_wait.yfilter != YFilter.not_set or
                                        self.total.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sessions" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                    if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                    if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                    if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                    if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                    if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                    if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                    if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nsr-eligible"):
                                        self.nsr_eligible = value
                                        self.nsr_eligible.value_namespace = name_space
                                        self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-app-wait"):
                                        self.nsr_state_app_wait = value
                                        self.nsr_state_app_wait.value_namespace = name_space
                                        self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-none"):
                                        self.nsr_state_none = value
                                        self.nsr_state_none.value_namespace = name_space
                                        self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-operational"):
                                        self.nsr_state_operational = value
                                        self.nsr_state_operational.value_namespace = name_space
                                        self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-prepare"):
                                        self.nsr_state_prepare = value
                                        self.nsr_state_prepare.value_namespace = name_space
                                        self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-ready"):
                                        self.nsr_state_ready = value
                                        self.nsr_state_ready.value_namespace = name_space
                                        self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase1"):
                                        self.nsr_state_tcp_phase1 = value
                                        self.nsr_state_tcp_phase1.value_namespace = name_space
                                        self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase2"):
                                        self.nsr_state_tcp_phase2 = value
                                        self.nsr_state_tcp_phase2.value_namespace = name_space
                                        self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-wait"):
                                        self.nsr_state_wait = value
                                        self.nsr_state_wait.value_namespace = name_space
                                        self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total"):
                                        self.total = value
                                        self.total.value_namespace = name_space
                                        self.total.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sessions is not None and self.sessions.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sessions is not None and self.sessions.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sessions"):
                                    if (self.sessions is None):
                                        self.sessions = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Sessions()
                                        self.sessions.parent = self
                                        self._children_name_map["sessions"] = "sessions"
                                    return self.sessions

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sessions" or name == "vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaStatistics(Entity):
                            """
                            LDP NSR Statistics related information
                            
                            .. attribute:: ha_global
                            
                            	LDP NSR Global Statistics information
                            	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal>`
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics, self).__init__()

                                self.yang_name = "ha-statistics"
                                self.yang_parent_name = "nsr"

                                self.ha_global = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal()
                                self.ha_global.parent = self
                                self._children_name_map["ha_global"] = "ha-global"
                                self._children_yang_names.add("ha-global")

                                self.ha_neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaGlobal(Entity):
                                """
                                LDP NSR Global Statistics information
                                
                                .. attribute:: init_sync
                                
                                	Init Sync
                                	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal, self).__init__()

                                    self.yang_name = "ha-global"
                                    self.yang_parent_name = "ha-statistics"

                                    self.init_sync = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                    self.init_sync.parent = self
                                    self._children_name_map["init_sync"] = "init-sync"
                                    self._children_yang_names.add("init-sync")


                                class InitSync(Entity):
                                    """
                                    Init Sync
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_default_mtu
                                    
                                    	default IPC MTU bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_exceeded_mtu_msg_cnt
                                    
                                    	ipc exceeded mtu msg cnt
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_max_rx_batch_bytes
                                    
                                    	biggest IPC RX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_max_tx_batch_bytes
                                    
                                    	biggest IPC TX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_rx_bytes
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_rx_cnt
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_tx_bytes
                                    
                                    	total IPC bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_tx_cnt
                                    
                                    	num IPC msgs sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_restart_cnt
                                    
                                    	number of times ipc has been restarted
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_tx_fail_cnt
                                    
                                    	number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_cfged
                                    
                                    	TRUE if NSR configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: nsr_synced
                                    
                                    	TRUE if NSR synced
                                    	**type**\:  bool
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Number of Rcvd Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Number of Sent Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of label bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl_adv
                                    
                                    	Num of lbl adv
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lcl_addr_wd
                                    
                                    	Num of lcl address withdraw
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_peers
                                    
                                    	Number of Peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_pfx
                                    
                                    	Number of binding prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_ipc_tx_fail_cnt
                                    
                                    	total number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__init__()

                                        self.yang_name = "init-sync"
                                        self.yang_parent_name = "ha-global"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                        self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                        self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                        self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                        self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                        self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                        self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                        self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                        self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                        self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                        self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                        self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                        self.num_peers = YLeaf(YType.uint32, "num-peers")

                                        self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                        self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "ipc_default_mtu",
                                                        "ipc_exceeded_mtu_msg_cnt",
                                                        "ipc_max_rx_batch_bytes",
                                                        "ipc_max_tx_batch_bytes",
                                                        "ipc_msg_rx_bytes",
                                                        "ipc_msg_rx_cnt",
                                                        "ipc_msg_tx_bytes",
                                                        "ipc_msg_tx_cnt",
                                                        "ipc_restart_cnt",
                                                        "ipc_tx_fail_cnt",
                                                        "nsr_cfged",
                                                        "nsr_synced",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_lbl",
                                                        "num_lbl_adv",
                                                        "num_lcl_addr_wd",
                                                        "num_peers",
                                                        "num_pfx",
                                                        "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.ipc_default_mtu.is_set or
                                            self.ipc_exceeded_mtu_msg_cnt.is_set or
                                            self.ipc_max_rx_batch_bytes.is_set or
                                            self.ipc_max_tx_batch_bytes.is_set or
                                            self.ipc_msg_rx_bytes.is_set or
                                            self.ipc_msg_rx_cnt.is_set or
                                            self.ipc_msg_tx_bytes.is_set or
                                            self.ipc_msg_tx_cnt.is_set or
                                            self.ipc_restart_cnt.is_set or
                                            self.ipc_tx_fail_cnt.is_set or
                                            self.nsr_cfged.is_set or
                                            self.nsr_synced.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_lbl.is_set or
                                            self.num_lbl_adv.is_set or
                                            self.num_lcl_addr_wd.is_set or
                                            self.num_peers.is_set or
                                            self.num_pfx.is_set or
                                            self.total_ipc_tx_fail_cnt.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.ipc_default_mtu.yfilter != YFilter.not_set or
                                            self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                            self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                            self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                            self.nsr_cfged.yfilter != YFilter.not_set or
                                            self.nsr_synced.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_lbl_adv.yfilter != YFilter.not_set or
                                            self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                            self.num_peers.yfilter != YFilter.not_set or
                                            self.num_pfx.yfilter != YFilter.not_set or
                                            self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                        if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                        if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                        if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                        if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                        if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                        if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                        if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                        if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_peers.get_name_leafdata())
                                        if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                        if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-default-mtu"):
                                            self.ipc_default_mtu = value
                                            self.ipc_default_mtu.value_namespace = name_space
                                            self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                            self.ipc_exceeded_mtu_msg_cnt = value
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-rx-batch-bytes"):
                                            self.ipc_max_rx_batch_bytes = value
                                            self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-tx-batch-bytes"):
                                            self.ipc_max_tx_batch_bytes = value
                                            self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-bytes"):
                                            self.ipc_msg_rx_bytes = value
                                            self.ipc_msg_rx_bytes.value_namespace = name_space
                                            self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-cnt"):
                                            self.ipc_msg_rx_cnt = value
                                            self.ipc_msg_rx_cnt.value_namespace = name_space
                                            self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-bytes"):
                                            self.ipc_msg_tx_bytes = value
                                            self.ipc_msg_tx_bytes.value_namespace = name_space
                                            self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-cnt"):
                                            self.ipc_msg_tx_cnt = value
                                            self.ipc_msg_tx_cnt.value_namespace = name_space
                                            self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-restart-cnt"):
                                            self.ipc_restart_cnt = value
                                            self.ipc_restart_cnt.value_namespace = name_space
                                            self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-tx-fail-cnt"):
                                            self.ipc_tx_fail_cnt = value
                                            self.ipc_tx_fail_cnt.value_namespace = name_space
                                            self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-cfged"):
                                            self.nsr_cfged = value
                                            self.nsr_cfged.value_namespace = name_space
                                            self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-synced"):
                                            self.nsr_synced = value
                                            self.nsr_synced.value_namespace = name_space
                                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl-adv"):
                                            self.num_lbl_adv = value
                                            self.num_lbl_adv.value_namespace = name_space
                                            self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lcl-addr-wd"):
                                            self.num_lcl_addr_wd = value
                                            self.num_lcl_addr_wd.value_namespace = name_space
                                            self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-peers"):
                                            self.num_peers = value
                                            self.num_peers.value_namespace = name_space
                                            self.num_peers.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-pfx"):
                                            self.num_pfx = value
                                            self.num_pfx.value_namespace = name_space
                                            self.num_pfx.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-ipc-tx-fail-cnt"):
                                            self.total_ipc_tx_fail_cnt = value
                                            self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                            self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.init_sync is not None and self.init_sync.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.init_sync is not None and self.init_sync.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync"):
                                        if (self.init_sync is None):
                                            self.init_sync = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal.InitSync()
                                            self.init_sync.parent = self
                                            self._children_name_map["init_sync"] = "init-sync"
                                        return self.init_sync

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "ha-statistics"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.ha_global is not None and self.ha_global.has_data()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_global is not None and self.ha_global.has_operation()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-global"):
                                    if (self.ha_global is None):
                                        self.ha_global = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaGlobal()
                                        self.ha_global.parent = self
                                        self._children_name_map["ha_global"] = "ha-global"
                                    return self.ha_global

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-global" or name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                                (self.ha_summary is not None and self.ha_summary.has_data()) or
                                (self.nsr_pending is not None and self.nsr_pending.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                                (self.ha_summary is not None and self.ha_summary.has_operation()) or
                                (self.nsr_pending is not None and self.nsr_pending.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "nsr" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-statistics"):
                                if (self.ha_statistics is None):
                                    self.ha_statistics = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaStatistics()
                                    self.ha_statistics.parent = self
                                    self._children_name_map["ha_statistics"] = "ha-statistics"
                                return self.ha_statistics

                            if (child_yang_name == "ha-summary"):
                                if (self.ha_summary is None):
                                    self.ha_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.HaSummary()
                                    self.ha_summary.parent = self
                                    self._children_name_map["ha_summary"] = "ha-summary"
                                return self.ha_summary

                            if (child_yang_name == "nsr-pending"):
                                if (self.nsr_pending is None):
                                    self.nsr_pending = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr.NsrPending()
                                    self.nsr_pending.parent = self
                                    self._children_name_map["nsr_pending"] = "nsr-pending"
                                return self.nsr_pending

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-statistics" or name == "ha-summary" or name == "nsr-pending"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Parameters(Entity):
                        """
                        LDP parameters
                        
                        .. attribute:: address_family_parameter
                        
                        	Per AF parameters
                        	**type**\: list of    :py:class:`AddressFamilyParameter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter>`
                        
                        .. attribute:: af_binding_withdraw_delay
                        
                        	Delay (sec) in Binding Withdrawal for an Address Family
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: discovery_quick_start_disabled_on_interfaces
                        
                        	Discovery quick\-start disabled on some LDP\-enabled interfaces
                        	**type**\:  bool
                        
                        .. attribute:: global_discovery_quick_start_disabled
                        
                        	Discovery quick\-start globally disabled
                        	**type**\:  bool
                        
                        .. attribute:: global_md5_password_enabled
                        
                        	Global MD5 password enabled
                        	**type**\:  bool
                        
                        .. attribute:: graceful_restart_information
                        
                        	Graceful restart information
                        	**type**\:   :py:class:`GracefulRestartInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.GracefulRestartInformation>`
                        
                        .. attribute:: hello_hold_time
                        
                        	Hello hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hello_interval
                        
                        	Hello interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: housekeeping_timer_interval
                        
                        	Housekeeping periodic timer interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: igp_sync_delay_time_for_interface
                        
                        	Interface IGP sync delay time in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: igp_sync_delay_time_on_restart
                        
                        	IGP sync delay time on process restart in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: keepalive_interval
                        
                        	Keepalive interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ldp_out_of_mem_state
                        
                        	LDP Out of memory state
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: ldp_recovery_timeout
                        
                        	LDP recovery timeout with LSD
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: le_no_route_timeout
                        
                        	LIB entry no route timeout
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_intf_attached
                        
                        	Maximum number of LDP enabled attached interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_intf_te
                        
                        	Maximum number of LDP enabled TE interfaces
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_peer
                        
                        	Maximum number of LDP peers
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: nsr_enabled
                        
                        	TRUE if NSR is enabled
                        	**type**\:  bool
                        
                        .. attribute:: nsr_synced
                        
                        	TRUE if LDP is standby and is NSR Sync\-ed with active
                        	**type**\:  bool
                        
                        .. attribute:: protocol_version
                        
                        	Protocol version
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: role_is_active
                        
                        	Is process role active or standby
                        	**type**\:  bool
                        
                        .. attribute:: router_id
                        
                        	Router ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: session_hold_time
                        
                        	Session hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: targeted_hello_hold_time
                        
                        	Targeted hello hold time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: targeted_hello_interval
                        
                        	Targeted hello interval
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters, self).__init__()

                            self.yang_name = "parameters"
                            self.yang_parent_name = "vrf"

                            self.af_binding_withdraw_delay = YLeaf(YType.uint32, "af-binding-withdraw-delay")

                            self.discovery_quick_start_disabled_on_interfaces = YLeaf(YType.boolean, "discovery-quick-start-disabled-on-interfaces")

                            self.global_discovery_quick_start_disabled = YLeaf(YType.boolean, "global-discovery-quick-start-disabled")

                            self.global_md5_password_enabled = YLeaf(YType.boolean, "global-md5-password-enabled")

                            self.hello_hold_time = YLeaf(YType.uint32, "hello-hold-time")

                            self.hello_interval = YLeaf(YType.uint32, "hello-interval")

                            self.housekeeping_timer_interval = YLeaf(YType.uint32, "housekeeping-timer-interval")

                            self.igp_sync_delay_time_for_interface = YLeaf(YType.uint32, "igp-sync-delay-time-for-interface")

                            self.igp_sync_delay_time_on_restart = YLeaf(YType.uint32, "igp-sync-delay-time-on-restart")

                            self.keepalive_interval = YLeaf(YType.uint32, "keepalive-interval")

                            self.ldp_out_of_mem_state = YLeaf(YType.uint32, "ldp-out-of-mem-state")

                            self.ldp_recovery_timeout = YLeaf(YType.uint32, "ldp-recovery-timeout")

                            self.le_no_route_timeout = YLeaf(YType.uint32, "le-no-route-timeout")

                            self.max_intf_attached = YLeaf(YType.uint32, "max-intf-attached")

                            self.max_intf_te = YLeaf(YType.uint32, "max-intf-te")

                            self.max_peer = YLeaf(YType.uint32, "max-peer")

                            self.nsr_enabled = YLeaf(YType.boolean, "nsr-enabled")

                            self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                            self.protocol_version = YLeaf(YType.uint32, "protocol-version")

                            self.role_is_active = YLeaf(YType.boolean, "role-is-active")

                            self.router_id = YLeaf(YType.str, "router-id")

                            self.session_hold_time = YLeaf(YType.uint32, "session-hold-time")

                            self.targeted_hello_hold_time = YLeaf(YType.uint32, "targeted-hello-hold-time")

                            self.targeted_hello_interval = YLeaf(YType.uint32, "targeted-hello-interval")

                            self.graceful_restart_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.GracefulRestartInformation()
                            self.graceful_restart_information.parent = self
                            self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                            self._children_yang_names.add("graceful-restart-information")

                            self.address_family_parameter = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("af_binding_withdraw_delay",
                                            "discovery_quick_start_disabled_on_interfaces",
                                            "global_discovery_quick_start_disabled",
                                            "global_md5_password_enabled",
                                            "hello_hold_time",
                                            "hello_interval",
                                            "housekeeping_timer_interval",
                                            "igp_sync_delay_time_for_interface",
                                            "igp_sync_delay_time_on_restart",
                                            "keepalive_interval",
                                            "ldp_out_of_mem_state",
                                            "ldp_recovery_timeout",
                                            "le_no_route_timeout",
                                            "max_intf_attached",
                                            "max_intf_te",
                                            "max_peer",
                                            "nsr_enabled",
                                            "nsr_synced",
                                            "protocol_version",
                                            "role_is_active",
                                            "router_id",
                                            "session_hold_time",
                                            "targeted_hello_hold_time",
                                            "targeted_hello_interval") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters, self).__setattr__(name, value)


                        class GracefulRestartInformation(Entity):
                            """
                            Graceful restart information
                            
                            .. attribute:: graceful_restart_forwarding_state_hold_time
                            
                            	Graceful restart forward state hold time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: graceful_restart_reconnect_timeout
                            
                            	Reconnect timeout value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_graceful_restart_configured
                            
                            	Is graceful restart configured
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__init__()

                                self.yang_name = "graceful-restart-information"
                                self.yang_parent_name = "parameters"

                                self.graceful_restart_forwarding_state_hold_time = YLeaf(YType.uint32, "graceful-restart-forwarding-state-hold-time")

                                self.graceful_restart_reconnect_timeout = YLeaf(YType.uint32, "graceful-restart-reconnect-timeout")

                                self.is_graceful_restart_configured = YLeaf(YType.boolean, "is-graceful-restart-configured")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("graceful_restart_forwarding_state_hold_time",
                                                "graceful_restart_reconnect_timeout",
                                                "is_graceful_restart_configured") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.GracefulRestartInformation, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.graceful_restart_forwarding_state_hold_time.is_set or
                                    self.graceful_restart_reconnect_timeout.is_set or
                                    self.is_graceful_restart_configured.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set or
                                    self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set or
                                    self.is_graceful_restart_configured.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "graceful-restart-information" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.graceful_restart_forwarding_state_hold_time.is_set or self.graceful_restart_forwarding_state_hold_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.graceful_restart_forwarding_state_hold_time.get_name_leafdata())
                                if (self.graceful_restart_reconnect_timeout.is_set or self.graceful_restart_reconnect_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.graceful_restart_reconnect_timeout.get_name_leafdata())
                                if (self.is_graceful_restart_configured.is_set or self.is_graceful_restart_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_graceful_restart_configured.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "graceful-restart-forwarding-state-hold-time" or name == "graceful-restart-reconnect-timeout" or name == "is-graceful-restart-configured"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "graceful-restart-forwarding-state-hold-time"):
                                    self.graceful_restart_forwarding_state_hold_time = value
                                    self.graceful_restart_forwarding_state_hold_time.value_namespace = name_space
                                    self.graceful_restart_forwarding_state_hold_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "graceful-restart-reconnect-timeout"):
                                    self.graceful_restart_reconnect_timeout = value
                                    self.graceful_restart_reconnect_timeout.value_namespace = name_space
                                    self.graceful_restart_reconnect_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-graceful-restart-configured"):
                                    self.is_graceful_restart_configured = value
                                    self.is_graceful_restart_configured.value_namespace = name_space
                                    self.is_graceful_restart_configured.value_namespace_prefix = name_space_prefix


                        class AddressFamilyParameter(Entity):
                            """
                            Per AF parameters
                            
                            .. attribute:: address_family
                            
                            	Address Family
                            	**type**\:   :py:class:`LdpAf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAf>`
                            
                            .. attribute:: discovery_transport_address
                            
                            	Discovery transport address
                            	**type**\:   :py:class:`DiscoveryTransportAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress>`
                            
                            .. attribute:: is_accepting_targeted_hellos
                            
                            	Accepting targeted Hellos
                            	**type**\:  bool
                            
                            .. attribute:: label_imp_null_override_acl
                            
                            	ACL to override local label to use implicit\-null
                            	**type**\:  str
                            
                            .. attribute:: null_label
                            
                            	Null label
                            	**type**\:  str
                            
                            .. attribute:: targeted_hello_acl
                            
                            	Targeted Hello ACL
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__init__()

                                self.yang_name = "address-family-parameter"
                                self.yang_parent_name = "parameters"

                                self.address_family = YLeaf(YType.enumeration, "address-family")

                                self.is_accepting_targeted_hellos = YLeaf(YType.boolean, "is-accepting-targeted-hellos")

                                self.label_imp_null_override_acl = YLeaf(YType.str, "label-imp-null-override-acl")

                                self.null_label = YLeaf(YType.str, "null-label")

                                self.targeted_hello_acl = YLeaf(YType.str, "targeted-hello-acl")

                                self.discovery_transport_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                self.discovery_transport_address.parent = self
                                self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                self._children_yang_names.add("discovery-transport-address")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("address_family",
                                                "is_accepting_targeted_hellos",
                                                "label_imp_null_override_acl",
                                                "null_label",
                                                "targeted_hello_acl") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter, self).__setattr__(name, value)


                            class DiscoveryTransportAddress(Entity):
                                """
                                Discovery transport address
                                
                                .. attribute:: afi
                                
                                	AFI
                                	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                
                                .. attribute:: dummy
                                
                                	No Address
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: ipv4
                                
                                	IPv4 address type
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv6
                                
                                	IPv6 address type
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__init__()

                                    self.yang_name = "discovery-transport-address"
                                    self.yang_parent_name = "address-family-parameter"

                                    self.afi = YLeaf(YType.enumeration, "afi")

                                    self.dummy = YLeaf(YType.uint8, "dummy")

                                    self.ipv4 = YLeaf(YType.str, "ipv4")

                                    self.ipv6 = YLeaf(YType.str, "ipv6")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("afi",
                                                    "dummy",
                                                    "ipv4",
                                                    "ipv6") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.afi.is_set or
                                        self.dummy.is_set or
                                        self.ipv4.is_set or
                                        self.ipv6.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.afi.yfilter != YFilter.not_set or
                                        self.dummy.yfilter != YFilter.not_set or
                                        self.ipv4.yfilter != YFilter.not_set or
                                        self.ipv6.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovery-transport-address" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.afi.get_name_leafdata())
                                    if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.dummy.get_name_leafdata())
                                    if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4.get_name_leafdata())
                                    if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv6.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "afi"):
                                        self.afi = value
                                        self.afi.value_namespace = name_space
                                        self.afi.value_namespace_prefix = name_space_prefix
                                    if(value_path == "dummy"):
                                        self.dummy = value
                                        self.dummy.value_namespace = name_space
                                        self.dummy.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv4"):
                                        self.ipv4 = value
                                        self.ipv4.value_namespace = name_space
                                        self.ipv4.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ipv6"):
                                        self.ipv6 = value
                                        self.ipv6.value_namespace = name_space
                                        self.ipv6.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.address_family.is_set or
                                    self.is_accepting_targeted_hellos.is_set or
                                    self.label_imp_null_override_acl.is_set or
                                    self.null_label.is_set or
                                    self.targeted_hello_acl.is_set or
                                    (self.discovery_transport_address is not None and self.discovery_transport_address.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.address_family.yfilter != YFilter.not_set or
                                    self.is_accepting_targeted_hellos.yfilter != YFilter.not_set or
                                    self.label_imp_null_override_acl.yfilter != YFilter.not_set or
                                    self.null_label.yfilter != YFilter.not_set or
                                    self.targeted_hello_acl.yfilter != YFilter.not_set or
                                    (self.discovery_transport_address is not None and self.discovery_transport_address.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "address-family-parameter" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.address_family.is_set or self.address_family.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.address_family.get_name_leafdata())
                                if (self.is_accepting_targeted_hellos.is_set or self.is_accepting_targeted_hellos.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_accepting_targeted_hellos.get_name_leafdata())
                                if (self.label_imp_null_override_acl.is_set or self.label_imp_null_override_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_imp_null_override_acl.get_name_leafdata())
                                if (self.null_label.is_set or self.null_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.null_label.get_name_leafdata())
                                if (self.targeted_hello_acl.is_set or self.targeted_hello_acl.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.targeted_hello_acl.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovery-transport-address"):
                                    if (self.discovery_transport_address is None):
                                        self.discovery_transport_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter.DiscoveryTransportAddress()
                                        self.discovery_transport_address.parent = self
                                        self._children_name_map["discovery_transport_address"] = "discovery-transport-address"
                                    return self.discovery_transport_address

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovery-transport-address" or name == "address-family" or name == "is-accepting-targeted-hellos" or name == "label-imp-null-override-acl" or name == "null-label" or name == "targeted-hello-acl"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "address-family"):
                                    self.address_family = value
                                    self.address_family.value_namespace = name_space
                                    self.address_family.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-accepting-targeted-hellos"):
                                    self.is_accepting_targeted_hellos = value
                                    self.is_accepting_targeted_hellos.value_namespace = name_space
                                    self.is_accepting_targeted_hellos.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-imp-null-override-acl"):
                                    self.label_imp_null_override_acl = value
                                    self.label_imp_null_override_acl.value_namespace = name_space
                                    self.label_imp_null_override_acl.value_namespace_prefix = name_space_prefix
                                if(value_path == "null-label"):
                                    self.null_label = value
                                    self.null_label.value_namespace = name_space
                                    self.null_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "targeted-hello-acl"):
                                    self.targeted_hello_acl = value
                                    self.targeted_hello_acl.value_namespace = name_space
                                    self.targeted_hello_acl.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.address_family_parameter:
                                if (c.has_data()):
                                    return True
                            return (
                                self.af_binding_withdraw_delay.is_set or
                                self.discovery_quick_start_disabled_on_interfaces.is_set or
                                self.global_discovery_quick_start_disabled.is_set or
                                self.global_md5_password_enabled.is_set or
                                self.hello_hold_time.is_set or
                                self.hello_interval.is_set or
                                self.housekeeping_timer_interval.is_set or
                                self.igp_sync_delay_time_for_interface.is_set or
                                self.igp_sync_delay_time_on_restart.is_set or
                                self.keepalive_interval.is_set or
                                self.ldp_out_of_mem_state.is_set or
                                self.ldp_recovery_timeout.is_set or
                                self.le_no_route_timeout.is_set or
                                self.max_intf_attached.is_set or
                                self.max_intf_te.is_set or
                                self.max_peer.is_set or
                                self.nsr_enabled.is_set or
                                self.nsr_synced.is_set or
                                self.protocol_version.is_set or
                                self.role_is_active.is_set or
                                self.router_id.is_set or
                                self.session_hold_time.is_set or
                                self.targeted_hello_hold_time.is_set or
                                self.targeted_hello_interval.is_set or
                                (self.graceful_restart_information is not None and self.graceful_restart_information.has_data()))

                        def has_operation(self):
                            for c in self.address_family_parameter:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.af_binding_withdraw_delay.yfilter != YFilter.not_set or
                                self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set or
                                self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set or
                                self.global_md5_password_enabled.yfilter != YFilter.not_set or
                                self.hello_hold_time.yfilter != YFilter.not_set or
                                self.hello_interval.yfilter != YFilter.not_set or
                                self.housekeeping_timer_interval.yfilter != YFilter.not_set or
                                self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set or
                                self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set or
                                self.keepalive_interval.yfilter != YFilter.not_set or
                                self.ldp_out_of_mem_state.yfilter != YFilter.not_set or
                                self.ldp_recovery_timeout.yfilter != YFilter.not_set or
                                self.le_no_route_timeout.yfilter != YFilter.not_set or
                                self.max_intf_attached.yfilter != YFilter.not_set or
                                self.max_intf_te.yfilter != YFilter.not_set or
                                self.max_peer.yfilter != YFilter.not_set or
                                self.nsr_enabled.yfilter != YFilter.not_set or
                                self.nsr_synced.yfilter != YFilter.not_set or
                                self.protocol_version.yfilter != YFilter.not_set or
                                self.role_is_active.yfilter != YFilter.not_set or
                                self.router_id.yfilter != YFilter.not_set or
                                self.session_hold_time.yfilter != YFilter.not_set or
                                self.targeted_hello_hold_time.yfilter != YFilter.not_set or
                                self.targeted_hello_interval.yfilter != YFilter.not_set or
                                (self.graceful_restart_information is not None and self.graceful_restart_information.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "parameters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.af_binding_withdraw_delay.is_set or self.af_binding_withdraw_delay.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.af_binding_withdraw_delay.get_name_leafdata())
                            if (self.discovery_quick_start_disabled_on_interfaces.is_set or self.discovery_quick_start_disabled_on_interfaces.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.discovery_quick_start_disabled_on_interfaces.get_name_leafdata())
                            if (self.global_discovery_quick_start_disabled.is_set or self.global_discovery_quick_start_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_discovery_quick_start_disabled.get_name_leafdata())
                            if (self.global_md5_password_enabled.is_set or self.global_md5_password_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.global_md5_password_enabled.get_name_leafdata())
                            if (self.hello_hold_time.is_set or self.hello_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_hold_time.get_name_leafdata())
                            if (self.hello_interval.is_set or self.hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hello_interval.get_name_leafdata())
                            if (self.housekeeping_timer_interval.is_set or self.housekeeping_timer_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.housekeeping_timer_interval.get_name_leafdata())
                            if (self.igp_sync_delay_time_for_interface.is_set or self.igp_sync_delay_time_for_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_sync_delay_time_for_interface.get_name_leafdata())
                            if (self.igp_sync_delay_time_on_restart.is_set or self.igp_sync_delay_time_on_restart.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_sync_delay_time_on_restart.get_name_leafdata())
                            if (self.keepalive_interval.is_set or self.keepalive_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.keepalive_interval.get_name_leafdata())
                            if (self.ldp_out_of_mem_state.is_set or self.ldp_out_of_mem_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_out_of_mem_state.get_name_leafdata())
                            if (self.ldp_recovery_timeout.is_set or self.ldp_recovery_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_recovery_timeout.get_name_leafdata())
                            if (self.le_no_route_timeout.is_set or self.le_no_route_timeout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.le_no_route_timeout.get_name_leafdata())
                            if (self.max_intf_attached.is_set or self.max_intf_attached.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_intf_attached.get_name_leafdata())
                            if (self.max_intf_te.is_set or self.max_intf_te.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_intf_te.get_name_leafdata())
                            if (self.max_peer.is_set or self.max_peer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_peer.get_name_leafdata())
                            if (self.nsr_enabled.is_set or self.nsr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_enabled.get_name_leafdata())
                            if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                            if (self.protocol_version.is_set or self.protocol_version.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_version.get_name_leafdata())
                            if (self.role_is_active.is_set or self.role_is_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role_is_active.get_name_leafdata())
                            if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.router_id.get_name_leafdata())
                            if (self.session_hold_time.is_set or self.session_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_hold_time.get_name_leafdata())
                            if (self.targeted_hello_hold_time.is_set or self.targeted_hello_hold_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_hold_time.get_name_leafdata())
                            if (self.targeted_hello_interval.is_set or self.targeted_hello_interval.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.targeted_hello_interval.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "address-family-parameter"):
                                for c in self.address_family_parameter:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.AddressFamilyParameter()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.address_family_parameter.append(c)
                                return c

                            if (child_yang_name == "graceful-restart-information"):
                                if (self.graceful_restart_information is None):
                                    self.graceful_restart_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters.GracefulRestartInformation()
                                    self.graceful_restart_information.parent = self
                                    self._children_name_map["graceful_restart_information"] = "graceful-restart-information"
                                return self.graceful_restart_information

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "address-family-parameter" or name == "graceful-restart-information" or name == "af-binding-withdraw-delay" or name == "discovery-quick-start-disabled-on-interfaces" or name == "global-discovery-quick-start-disabled" or name == "global-md5-password-enabled" or name == "hello-hold-time" or name == "hello-interval" or name == "housekeeping-timer-interval" or name == "igp-sync-delay-time-for-interface" or name == "igp-sync-delay-time-on-restart" or name == "keepalive-interval" or name == "ldp-out-of-mem-state" or name == "ldp-recovery-timeout" or name == "le-no-route-timeout" or name == "max-intf-attached" or name == "max-intf-te" or name == "max-peer" or name == "nsr-enabled" or name == "nsr-synced" or name == "protocol-version" or name == "role-is-active" or name == "router-id" or name == "session-hold-time" or name == "targeted-hello-hold-time" or name == "targeted-hello-interval"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "af-binding-withdraw-delay"):
                                self.af_binding_withdraw_delay = value
                                self.af_binding_withdraw_delay.value_namespace = name_space
                                self.af_binding_withdraw_delay.value_namespace_prefix = name_space_prefix
                            if(value_path == "discovery-quick-start-disabled-on-interfaces"):
                                self.discovery_quick_start_disabled_on_interfaces = value
                                self.discovery_quick_start_disabled_on_interfaces.value_namespace = name_space
                                self.discovery_quick_start_disabled_on_interfaces.value_namespace_prefix = name_space_prefix
                            if(value_path == "global-discovery-quick-start-disabled"):
                                self.global_discovery_quick_start_disabled = value
                                self.global_discovery_quick_start_disabled.value_namespace = name_space
                                self.global_discovery_quick_start_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "global-md5-password-enabled"):
                                self.global_md5_password_enabled = value
                                self.global_md5_password_enabled.value_namespace = name_space
                                self.global_md5_password_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-hold-time"):
                                self.hello_hold_time = value
                                self.hello_hold_time.value_namespace = name_space
                                self.hello_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "hello-interval"):
                                self.hello_interval = value
                                self.hello_interval.value_namespace = name_space
                                self.hello_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "housekeeping-timer-interval"):
                                self.housekeeping_timer_interval = value
                                self.housekeeping_timer_interval.value_namespace = name_space
                                self.housekeeping_timer_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-sync-delay-time-for-interface"):
                                self.igp_sync_delay_time_for_interface = value
                                self.igp_sync_delay_time_for_interface.value_namespace = name_space
                                self.igp_sync_delay_time_for_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-sync-delay-time-on-restart"):
                                self.igp_sync_delay_time_on_restart = value
                                self.igp_sync_delay_time_on_restart.value_namespace = name_space
                                self.igp_sync_delay_time_on_restart.value_namespace_prefix = name_space_prefix
                            if(value_path == "keepalive-interval"):
                                self.keepalive_interval = value
                                self.keepalive_interval.value_namespace = name_space
                                self.keepalive_interval.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-out-of-mem-state"):
                                self.ldp_out_of_mem_state = value
                                self.ldp_out_of_mem_state.value_namespace = name_space
                                self.ldp_out_of_mem_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-recovery-timeout"):
                                self.ldp_recovery_timeout = value
                                self.ldp_recovery_timeout.value_namespace = name_space
                                self.ldp_recovery_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "le-no-route-timeout"):
                                self.le_no_route_timeout = value
                                self.le_no_route_timeout.value_namespace = name_space
                                self.le_no_route_timeout.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-intf-attached"):
                                self.max_intf_attached = value
                                self.max_intf_attached.value_namespace = name_space
                                self.max_intf_attached.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-intf-te"):
                                self.max_intf_te = value
                                self.max_intf_te.value_namespace = name_space
                                self.max_intf_te.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-peer"):
                                self.max_peer = value
                                self.max_peer.value_namespace = name_space
                                self.max_peer.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-enabled"):
                                self.nsr_enabled = value
                                self.nsr_enabled.value_namespace = name_space
                                self.nsr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "nsr-synced"):
                                self.nsr_synced = value
                                self.nsr_synced.value_namespace = name_space
                                self.nsr_synced.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-version"):
                                self.protocol_version = value
                                self.protocol_version.value_namespace = name_space
                                self.protocol_version.value_namespace_prefix = name_space_prefix
                            if(value_path == "role-is-active"):
                                self.role_is_active = value
                                self.role_is_active.value_namespace = name_space
                                self.role_is_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "router-id"):
                                self.router_id = value
                                self.router_id.value_namespace = name_space
                                self.router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-hold-time"):
                                self.session_hold_time = value
                                self.session_hold_time.value_namespace = name_space
                                self.session_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-hold-time"):
                                self.targeted_hello_hold_time = value
                                self.targeted_hello_hold_time.value_namespace = name_space
                                self.targeted_hello_hold_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "targeted-hello-interval"):
                                self.targeted_hello_interval = value
                                self.targeted_hello_interval.value_namespace = name_space
                                self.targeted_hello_interval.value_namespace_prefix = name_space_prefix


                    class Issu(Entity):
                        """
                        LDP ISSU related information
                        
                        .. attribute:: ha_statistics
                        
                        	LDP NSR Statistics related information
                        	**type**\:   :py:class:`HaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics>`
                        
                        .. attribute:: ha_summary
                        
                        	LDP HA Summary
                        	**type**\:   :py:class:`HaSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu, self).__init__()

                            self.yang_name = "issu"
                            self.yang_parent_name = "vrf"

                            self.ha_statistics = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics()
                            self.ha_statistics.parent = self
                            self._children_name_map["ha_statistics"] = "ha-statistics"
                            self._children_yang_names.add("ha-statistics")

                            self.ha_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary()
                            self.ha_summary.parent = self
                            self._children_name_map["ha_summary"] = "ha-summary"
                            self._children_yang_names.add("ha-summary")


                        class HaSummary(Entity):
                            """
                            LDP HA Summary
                            
                            .. attribute:: sessions
                            
                            	Session summary
                            	**type**\:   :py:class:`Sessions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Sessions>`
                            
                            .. attribute:: vrf
                            
                            	VRF information
                            	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Vrf>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary, self).__init__()

                                self.yang_name = "ha-summary"
                                self.yang_parent_name = "issu"

                                self.sessions = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Sessions()
                                self.sessions.parent = self
                                self._children_name_map["sessions"] = "sessions"
                                self._children_yang_names.add("sessions")

                                self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Vrf()
                                self.vrf.parent = self
                                self._children_name_map["vrf"] = "vrf"
                                self._children_yang_names.add("vrf")


                            class Vrf(Entity):
                                """
                                VRF information
                                
                                .. attribute:: id
                                
                                	VRF Id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: name
                                
                                	VRF Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__init__()

                                    self.yang_name = "vrf"
                                    self.yang_parent_name = "ha-summary"

                                    self.id = YLeaf(YType.uint32, "id")

                                    self.name = YLeaf(YType.str, "name")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("id",
                                                    "name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Vrf, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.id.is_set or
                                        self.name.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.id.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "vrf" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.id.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "id" or name == "name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "id"):
                                        self.id = value
                                        self.id.value_namespace = name_space
                                        self.id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix


                            class Sessions(Entity):
                                """
                                Session summary
                                
                                .. attribute:: nsr_eligible
                                
                                	NSR eligible sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_app_wait
                                
                                	Number of sessions in NSR app\-wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_none
                                
                                	Number of sessions in NSR none state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_operational
                                
                                	Number of sessions in NSR operational state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_prepare
                                
                                	Number of sessions in NSR prepare state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_ready
                                
                                	Number of sessions in NSR ready state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase1
                                
                                	Number of sessions in NSR TCP phase 1 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_tcp_phase2
                                
                                	Number of sessions in NSR TCP phase 2 state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: nsr_state_wait
                                
                                	Number of sessions in NSR wait state
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total
                                
                                	Total sessions
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__init__()

                                    self.yang_name = "sessions"
                                    self.yang_parent_name = "ha-summary"

                                    self.nsr_eligible = YLeaf(YType.uint32, "nsr-eligible")

                                    self.nsr_state_app_wait = YLeaf(YType.uint32, "nsr-state-app-wait")

                                    self.nsr_state_none = YLeaf(YType.uint32, "nsr-state-none")

                                    self.nsr_state_operational = YLeaf(YType.uint32, "nsr-state-operational")

                                    self.nsr_state_prepare = YLeaf(YType.uint32, "nsr-state-prepare")

                                    self.nsr_state_ready = YLeaf(YType.uint32, "nsr-state-ready")

                                    self.nsr_state_tcp_phase1 = YLeaf(YType.uint32, "nsr-state-tcp-phase1")

                                    self.nsr_state_tcp_phase2 = YLeaf(YType.uint32, "nsr-state-tcp-phase2")

                                    self.nsr_state_wait = YLeaf(YType.uint32, "nsr-state-wait")

                                    self.total = YLeaf(YType.uint32, "total")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("nsr_eligible",
                                                    "nsr_state_app_wait",
                                                    "nsr_state_none",
                                                    "nsr_state_operational",
                                                    "nsr_state_prepare",
                                                    "nsr_state_ready",
                                                    "nsr_state_tcp_phase1",
                                                    "nsr_state_tcp_phase2",
                                                    "nsr_state_wait",
                                                    "total") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Sessions, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.nsr_eligible.is_set or
                                        self.nsr_state_app_wait.is_set or
                                        self.nsr_state_none.is_set or
                                        self.nsr_state_operational.is_set or
                                        self.nsr_state_prepare.is_set or
                                        self.nsr_state_ready.is_set or
                                        self.nsr_state_tcp_phase1.is_set or
                                        self.nsr_state_tcp_phase2.is_set or
                                        self.nsr_state_wait.is_set or
                                        self.total.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.nsr_eligible.yfilter != YFilter.not_set or
                                        self.nsr_state_app_wait.yfilter != YFilter.not_set or
                                        self.nsr_state_none.yfilter != YFilter.not_set or
                                        self.nsr_state_operational.yfilter != YFilter.not_set or
                                        self.nsr_state_prepare.yfilter != YFilter.not_set or
                                        self.nsr_state_ready.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase1.yfilter != YFilter.not_set or
                                        self.nsr_state_tcp_phase2.yfilter != YFilter.not_set or
                                        self.nsr_state_wait.yfilter != YFilter.not_set or
                                        self.total.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sessions" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.nsr_eligible.is_set or self.nsr_eligible.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_eligible.get_name_leafdata())
                                    if (self.nsr_state_app_wait.is_set or self.nsr_state_app_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_app_wait.get_name_leafdata())
                                    if (self.nsr_state_none.is_set or self.nsr_state_none.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_none.get_name_leafdata())
                                    if (self.nsr_state_operational.is_set or self.nsr_state_operational.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_operational.get_name_leafdata())
                                    if (self.nsr_state_prepare.is_set or self.nsr_state_prepare.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_prepare.get_name_leafdata())
                                    if (self.nsr_state_ready.is_set or self.nsr_state_ready.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_ready.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase1.is_set or self.nsr_state_tcp_phase1.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase1.get_name_leafdata())
                                    if (self.nsr_state_tcp_phase2.is_set or self.nsr_state_tcp_phase2.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_tcp_phase2.get_name_leafdata())
                                    if (self.nsr_state_wait.is_set or self.nsr_state_wait.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_state_wait.get_name_leafdata())
                                    if (self.total.is_set or self.total.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "nsr-eligible" or name == "nsr-state-app-wait" or name == "nsr-state-none" or name == "nsr-state-operational" or name == "nsr-state-prepare" or name == "nsr-state-ready" or name == "nsr-state-tcp-phase1" or name == "nsr-state-tcp-phase2" or name == "nsr-state-wait" or name == "total"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "nsr-eligible"):
                                        self.nsr_eligible = value
                                        self.nsr_eligible.value_namespace = name_space
                                        self.nsr_eligible.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-app-wait"):
                                        self.nsr_state_app_wait = value
                                        self.nsr_state_app_wait.value_namespace = name_space
                                        self.nsr_state_app_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-none"):
                                        self.nsr_state_none = value
                                        self.nsr_state_none.value_namespace = name_space
                                        self.nsr_state_none.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-operational"):
                                        self.nsr_state_operational = value
                                        self.nsr_state_operational.value_namespace = name_space
                                        self.nsr_state_operational.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-prepare"):
                                        self.nsr_state_prepare = value
                                        self.nsr_state_prepare.value_namespace = name_space
                                        self.nsr_state_prepare.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-ready"):
                                        self.nsr_state_ready = value
                                        self.nsr_state_ready.value_namespace = name_space
                                        self.nsr_state_ready.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase1"):
                                        self.nsr_state_tcp_phase1 = value
                                        self.nsr_state_tcp_phase1.value_namespace = name_space
                                        self.nsr_state_tcp_phase1.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-tcp-phase2"):
                                        self.nsr_state_tcp_phase2 = value
                                        self.nsr_state_tcp_phase2.value_namespace = name_space
                                        self.nsr_state_tcp_phase2.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-state-wait"):
                                        self.nsr_state_wait = value
                                        self.nsr_state_wait.value_namespace = name_space
                                        self.nsr_state_wait.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total"):
                                        self.total = value
                                        self.total.value_namespace = name_space
                                        self.total.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.sessions is not None and self.sessions.has_data()) or
                                    (self.vrf is not None and self.vrf.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.sessions is not None and self.sessions.has_operation()) or
                                    (self.vrf is not None and self.vrf.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-summary" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sessions"):
                                    if (self.sessions is None):
                                        self.sessions = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Sessions()
                                        self.sessions.parent = self
                                        self._children_name_map["sessions"] = "sessions"
                                    return self.sessions

                                if (child_yang_name == "vrf"):
                                    if (self.vrf is None):
                                        self.vrf = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary.Vrf()
                                        self.vrf.parent = self
                                        self._children_name_map["vrf"] = "vrf"
                                    return self.vrf

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sessions" or name == "vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HaStatistics(Entity):
                            """
                            LDP NSR Statistics related information
                            
                            .. attribute:: ha_global
                            
                            	LDP NSR Global Statistics information
                            	**type**\:   :py:class:`HaGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal>`
                            
                            .. attribute:: ha_neighbors
                            
                            	The LDP HA Neighbors
                            	**type**\:   :py:class:`HaNeighbors <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics, self).__init__()

                                self.yang_name = "ha-statistics"
                                self.yang_parent_name = "issu"

                                self.ha_global = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal()
                                self.ha_global.parent = self
                                self._children_name_map["ha_global"] = "ha-global"
                                self._children_yang_names.add("ha-global")

                                self.ha_neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors()
                                self.ha_neighbors.parent = self
                                self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                self._children_yang_names.add("ha-neighbors")


                            class HaGlobal(Entity):
                                """
                                LDP NSR Global Statistics information
                                
                                .. attribute:: init_sync
                                
                                	Init Sync
                                	**type**\:   :py:class:`InitSync <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal, self).__init__()

                                    self.yang_name = "ha-global"
                                    self.yang_parent_name = "ha-statistics"

                                    self.init_sync = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync()
                                    self.init_sync.parent = self
                                    self._children_name_map["init_sync"] = "init-sync"
                                    self._children_yang_names.add("init-sync")


                                class InitSync(Entity):
                                    """
                                    Init Sync
                                    
                                    .. attribute:: init_sync_end
                                    
                                    	Init Sync End Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: init_sync_start
                                    
                                    	Init Sync Start Time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_default_mtu
                                    
                                    	default IPC MTU bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_exceeded_mtu_msg_cnt
                                    
                                    	ipc exceeded mtu msg cnt
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_max_rx_batch_bytes
                                    
                                    	biggest IPC RX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_max_tx_batch_bytes
                                    
                                    	biggest IPC TX bytes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_rx_bytes
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_rx_cnt
                                    
                                    	num IPC msgs rxed
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_msg_tx_bytes
                                    
                                    	total IPC bytes sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: byte
                                    
                                    .. attribute:: ipc_msg_tx_cnt
                                    
                                    	num IPC msgs sent
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_restart_cnt
                                    
                                    	number of times ipc has been restarted
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: ipc_tx_fail_cnt
                                    
                                    	number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_cfged
                                    
                                    	TRUE if NSR configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: nsr_synced
                                    
                                    	TRUE if NSR synced
                                    	**type**\:  bool
                                    
                                    .. attribute:: num_cap_rcvd
                                    
                                    	Number of Rcvd Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_cap_sent
                                    
                                    	Number of Sent Capabilities objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl
                                    
                                    	Number of label bindings
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lbl_adv
                                    
                                    	Num of lbl adv
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_lcl_addr_wd
                                    
                                    	Num of lcl address withdraw
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_peers
                                    
                                    	Number of Peers
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: num_pfx
                                    
                                    	Number of binding prefixes
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_ipc_tx_fail_cnt
                                    
                                    	total number of ipc send failures
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__init__()

                                        self.yang_name = "init-sync"
                                        self.yang_parent_name = "ha-global"

                                        self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                        self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                        self.ipc_default_mtu = YLeaf(YType.uint32, "ipc-default-mtu")

                                        self.ipc_exceeded_mtu_msg_cnt = YLeaf(YType.uint32, "ipc-exceeded-mtu-msg-cnt")

                                        self.ipc_max_rx_batch_bytes = YLeaf(YType.uint32, "ipc-max-rx-batch-bytes")

                                        self.ipc_max_tx_batch_bytes = YLeaf(YType.uint32, "ipc-max-tx-batch-bytes")

                                        self.ipc_msg_rx_bytes = YLeaf(YType.uint32, "ipc-msg-rx-bytes")

                                        self.ipc_msg_rx_cnt = YLeaf(YType.uint32, "ipc-msg-rx-cnt")

                                        self.ipc_msg_tx_bytes = YLeaf(YType.uint32, "ipc-msg-tx-bytes")

                                        self.ipc_msg_tx_cnt = YLeaf(YType.uint32, "ipc-msg-tx-cnt")

                                        self.ipc_restart_cnt = YLeaf(YType.uint32, "ipc-restart-cnt")

                                        self.ipc_tx_fail_cnt = YLeaf(YType.uint32, "ipc-tx-fail-cnt")

                                        self.nsr_cfged = YLeaf(YType.boolean, "nsr-cfged")

                                        self.nsr_synced = YLeaf(YType.boolean, "nsr-synced")

                                        self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                        self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                        self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                        self.num_lbl_adv = YLeaf(YType.uint32, "num-lbl-adv")

                                        self.num_lcl_addr_wd = YLeaf(YType.uint32, "num-lcl-addr-wd")

                                        self.num_peers = YLeaf(YType.uint32, "num-peers")

                                        self.num_pfx = YLeaf(YType.uint32, "num-pfx")

                                        self.total_ipc_tx_fail_cnt = YLeaf(YType.uint32, "total-ipc-tx-fail-cnt")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("init_sync_end",
                                                        "init_sync_start",
                                                        "ipc_default_mtu",
                                                        "ipc_exceeded_mtu_msg_cnt",
                                                        "ipc_max_rx_batch_bytes",
                                                        "ipc_max_tx_batch_bytes",
                                                        "ipc_msg_rx_bytes",
                                                        "ipc_msg_rx_cnt",
                                                        "ipc_msg_tx_bytes",
                                                        "ipc_msg_tx_cnt",
                                                        "ipc_restart_cnt",
                                                        "ipc_tx_fail_cnt",
                                                        "nsr_cfged",
                                                        "nsr_synced",
                                                        "num_cap_rcvd",
                                                        "num_cap_sent",
                                                        "num_lbl",
                                                        "num_lbl_adv",
                                                        "num_lcl_addr_wd",
                                                        "num_peers",
                                                        "num_pfx",
                                                        "total_ipc_tx_fail_cnt") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.init_sync_end.is_set or
                                            self.init_sync_start.is_set or
                                            self.ipc_default_mtu.is_set or
                                            self.ipc_exceeded_mtu_msg_cnt.is_set or
                                            self.ipc_max_rx_batch_bytes.is_set or
                                            self.ipc_max_tx_batch_bytes.is_set or
                                            self.ipc_msg_rx_bytes.is_set or
                                            self.ipc_msg_rx_cnt.is_set or
                                            self.ipc_msg_tx_bytes.is_set or
                                            self.ipc_msg_tx_cnt.is_set or
                                            self.ipc_restart_cnt.is_set or
                                            self.ipc_tx_fail_cnt.is_set or
                                            self.nsr_cfged.is_set or
                                            self.nsr_synced.is_set or
                                            self.num_cap_rcvd.is_set or
                                            self.num_cap_sent.is_set or
                                            self.num_lbl.is_set or
                                            self.num_lbl_adv.is_set or
                                            self.num_lcl_addr_wd.is_set or
                                            self.num_peers.is_set or
                                            self.num_pfx.is_set or
                                            self.total_ipc_tx_fail_cnt.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.init_sync_end.yfilter != YFilter.not_set or
                                            self.init_sync_start.yfilter != YFilter.not_set or
                                            self.ipc_default_mtu.yfilter != YFilter.not_set or
                                            self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set or
                                            self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_rx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_bytes.yfilter != YFilter.not_set or
                                            self.ipc_msg_tx_cnt.yfilter != YFilter.not_set or
                                            self.ipc_restart_cnt.yfilter != YFilter.not_set or
                                            self.ipc_tx_fail_cnt.yfilter != YFilter.not_set or
                                            self.nsr_cfged.yfilter != YFilter.not_set or
                                            self.nsr_synced.yfilter != YFilter.not_set or
                                            self.num_cap_rcvd.yfilter != YFilter.not_set or
                                            self.num_cap_sent.yfilter != YFilter.not_set or
                                            self.num_lbl.yfilter != YFilter.not_set or
                                            self.num_lbl_adv.yfilter != YFilter.not_set or
                                            self.num_lcl_addr_wd.yfilter != YFilter.not_set or
                                            self.num_peers.yfilter != YFilter.not_set or
                                            self.num_pfx.yfilter != YFilter.not_set or
                                            self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "init-sync" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                        if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                        if (self.ipc_default_mtu.is_set or self.ipc_default_mtu.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_default_mtu.get_name_leafdata())
                                        if (self.ipc_exceeded_mtu_msg_cnt.is_set or self.ipc_exceeded_mtu_msg_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_exceeded_mtu_msg_cnt.get_name_leafdata())
                                        if (self.ipc_max_rx_batch_bytes.is_set or self.ipc_max_rx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_rx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_max_tx_batch_bytes.is_set or self.ipc_max_tx_batch_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_max_tx_batch_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_bytes.is_set or self.ipc_msg_rx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_rx_cnt.is_set or self.ipc_msg_rx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_rx_cnt.get_name_leafdata())
                                        if (self.ipc_msg_tx_bytes.is_set or self.ipc_msg_tx_bytes.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_bytes.get_name_leafdata())
                                        if (self.ipc_msg_tx_cnt.is_set or self.ipc_msg_tx_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_msg_tx_cnt.get_name_leafdata())
                                        if (self.ipc_restart_cnt.is_set or self.ipc_restart_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_restart_cnt.get_name_leafdata())
                                        if (self.ipc_tx_fail_cnt.is_set or self.ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipc_tx_fail_cnt.get_name_leafdata())
                                        if (self.nsr_cfged.is_set or self.nsr_cfged.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_cfged.get_name_leafdata())
                                        if (self.nsr_synced.is_set or self.nsr_synced.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_synced.get_name_leafdata())
                                        if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                        if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                        if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                        if (self.num_lbl_adv.is_set or self.num_lbl_adv.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lbl_adv.get_name_leafdata())
                                        if (self.num_lcl_addr_wd.is_set or self.num_lcl_addr_wd.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_lcl_addr_wd.get_name_leafdata())
                                        if (self.num_peers.is_set or self.num_peers.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_peers.get_name_leafdata())
                                        if (self.num_pfx.is_set or self.num_pfx.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_pfx.get_name_leafdata())
                                        if (self.total_ipc_tx_fail_cnt.is_set or self.total_ipc_tx_fail_cnt.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.total_ipc_tx_fail_cnt.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-end" or name == "init-sync-start" or name == "ipc-default-mtu" or name == "ipc-exceeded-mtu-msg-cnt" or name == "ipc-max-rx-batch-bytes" or name == "ipc-max-tx-batch-bytes" or name == "ipc-msg-rx-bytes" or name == "ipc-msg-rx-cnt" or name == "ipc-msg-tx-bytes" or name == "ipc-msg-tx-cnt" or name == "ipc-restart-cnt" or name == "ipc-tx-fail-cnt" or name == "nsr-cfged" or name == "nsr-synced" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-lbl" or name == "num-lbl-adv" or name == "num-lcl-addr-wd" or name == "num-peers" or name == "num-pfx" or name == "total-ipc-tx-fail-cnt"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "init-sync-end"):
                                            self.init_sync_end = value
                                            self.init_sync_end.value_namespace = name_space
                                            self.init_sync_end.value_namespace_prefix = name_space_prefix
                                        if(value_path == "init-sync-start"):
                                            self.init_sync_start = value
                                            self.init_sync_start.value_namespace = name_space
                                            self.init_sync_start.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-default-mtu"):
                                            self.ipc_default_mtu = value
                                            self.ipc_default_mtu.value_namespace = name_space
                                            self.ipc_default_mtu.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-exceeded-mtu-msg-cnt"):
                                            self.ipc_exceeded_mtu_msg_cnt = value
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace = name_space
                                            self.ipc_exceeded_mtu_msg_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-rx-batch-bytes"):
                                            self.ipc_max_rx_batch_bytes = value
                                            self.ipc_max_rx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_rx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-max-tx-batch-bytes"):
                                            self.ipc_max_tx_batch_bytes = value
                                            self.ipc_max_tx_batch_bytes.value_namespace = name_space
                                            self.ipc_max_tx_batch_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-bytes"):
                                            self.ipc_msg_rx_bytes = value
                                            self.ipc_msg_rx_bytes.value_namespace = name_space
                                            self.ipc_msg_rx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-rx-cnt"):
                                            self.ipc_msg_rx_cnt = value
                                            self.ipc_msg_rx_cnt.value_namespace = name_space
                                            self.ipc_msg_rx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-bytes"):
                                            self.ipc_msg_tx_bytes = value
                                            self.ipc_msg_tx_bytes.value_namespace = name_space
                                            self.ipc_msg_tx_bytes.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-msg-tx-cnt"):
                                            self.ipc_msg_tx_cnt = value
                                            self.ipc_msg_tx_cnt.value_namespace = name_space
                                            self.ipc_msg_tx_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-restart-cnt"):
                                            self.ipc_restart_cnt = value
                                            self.ipc_restart_cnt.value_namespace = name_space
                                            self.ipc_restart_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipc-tx-fail-cnt"):
                                            self.ipc_tx_fail_cnt = value
                                            self.ipc_tx_fail_cnt.value_namespace = name_space
                                            self.ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-cfged"):
                                            self.nsr_cfged = value
                                            self.nsr_cfged.value_namespace = name_space
                                            self.nsr_cfged.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-synced"):
                                            self.nsr_synced = value
                                            self.nsr_synced.value_namespace = name_space
                                            self.nsr_synced.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-rcvd"):
                                            self.num_cap_rcvd = value
                                            self.num_cap_rcvd.value_namespace = name_space
                                            self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-cap-sent"):
                                            self.num_cap_sent = value
                                            self.num_cap_sent.value_namespace = name_space
                                            self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl"):
                                            self.num_lbl = value
                                            self.num_lbl.value_namespace = name_space
                                            self.num_lbl.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lbl-adv"):
                                            self.num_lbl_adv = value
                                            self.num_lbl_adv.value_namespace = name_space
                                            self.num_lbl_adv.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-lcl-addr-wd"):
                                            self.num_lcl_addr_wd = value
                                            self.num_lcl_addr_wd.value_namespace = name_space
                                            self.num_lcl_addr_wd.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-peers"):
                                            self.num_peers = value
                                            self.num_peers.value_namespace = name_space
                                            self.num_peers.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-pfx"):
                                            self.num_pfx = value
                                            self.num_pfx.value_namespace = name_space
                                            self.num_pfx.value_namespace_prefix = name_space_prefix
                                        if(value_path == "total-ipc-tx-fail-cnt"):
                                            self.total_ipc_tx_fail_cnt = value
                                            self.total_ipc_tx_fail_cnt.value_namespace = name_space
                                            self.total_ipc_tx_fail_cnt.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.init_sync is not None and self.init_sync.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.init_sync is not None and self.init_sync.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "init-sync"):
                                        if (self.init_sync is None):
                                            self.init_sync = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal.InitSync()
                                            self.init_sync.parent = self
                                            self._children_name_map["init_sync"] = "init-sync"
                                        return self.init_sync

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "init-sync"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class HaNeighbors(Entity):
                                """
                                The LDP HA Neighbors
                                
                                .. attribute:: ha_neighbor
                                
                                	Information on a particular LDP HA neighbor
                                	**type**\: list of    :py:class:`HaNeighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__init__()

                                    self.yang_name = "ha-neighbors"
                                    self.yang_parent_name = "ha-statistics"

                                    self.ha_neighbor = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors, self).__setattr__(name, value)


                                class HaNeighbor(Entity):
                                    """
                                    Information on a particular LDP HA neighbor
                                    
                                    .. attribute:: init_sync_info
                                    
                                    	NSR Init Sync Info
                                    	**type**\:   :py:class:`InitSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo>`
                                    
                                    .. attribute:: label_space_id
                                    
                                    	Label space ID of neighbor
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lbl_spc_id
                                    
                                    	lbl spc id
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: lsr_id
                                    
                                    	LSR ID of neighbor
                                    	**type**\: one of the below types:
                                    
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    
                                    ----
                                    .. attribute:: lsr_id_xr
                                    
                                    	lsr id xr
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: nsr_sync_state
                                    
                                    	nsr sync state
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: num_msg
                                    
                                    	Number of sync messages
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: steady_state_sync_info
                                    
                                    	NSR Steady State Sync Info
                                    	**type**\:   :py:class:`SteadyStateSyncInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__init__()

                                        self.yang_name = "ha-neighbor"
                                        self.yang_parent_name = "ha-neighbors"

                                        self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                        self.lbl_spc_id = YLeaf(YType.uint16, "lbl-spc-id")

                                        self.lsr_id = YLeaf(YType.str, "lsr-id")

                                        self.lsr_id_xr = YLeaf(YType.uint32, "lsr-id-xr")

                                        self.nsr_sync_state = YLeaf(YType.int32, "nsr-sync-state")

                                        self.num_msg = YLeaf(YType.uint32, "num-msg")

                                        self.init_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                        self.init_sync_info.parent = self
                                        self._children_name_map["init_sync_info"] = "init-sync-info"
                                        self._children_yang_names.add("init-sync-info")

                                        self.steady_state_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                        self.steady_state_sync_info.parent = self
                                        self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                        self._children_yang_names.add("steady-state-sync-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("label_space_id",
                                                        "lbl_spc_id",
                                                        "lsr_id",
                                                        "lsr_id_xr",
                                                        "nsr_sync_state",
                                                        "num_msg") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor, self).__setattr__(name, value)


                                    class InitSyncInfo(Entity):
                                        """
                                        NSR Init Sync Info
                                        
                                        .. attribute:: init_sync_end
                                        
                                        	Init Sync End Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: init_sync_start
                                        
                                        	Init Sync Start Time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_addr
                                        
                                        	Number of peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_app_bytes
                                        
                                        	Number of external App data bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_duplicate_addr
                                        
                                        	Number of duplicate peer addresses
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_lbl
                                        
                                        	Number of peer bindings
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_rx_bytes
                                        
                                        	Number of unprocessed Rx buffer bytes
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: byte
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__init__()

                                            self.yang_name = "init-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.init_sync_end = YLeaf(YType.uint32, "init-sync-end")

                                            self.init_sync_start = YLeaf(YType.uint32, "init-sync-start")

                                            self.num_addr = YLeaf(YType.uint32, "num-addr")

                                            self.num_app_bytes = YLeaf(YType.uint32, "num-app-bytes")

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_duplicate_addr = YLeaf(YType.uint32, "num-duplicate-addr")

                                            self.num_lbl = YLeaf(YType.uint32, "num-lbl")

                                            self.num_rx_bytes = YLeaf(YType.uint32, "num-rx-bytes")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("init_sync_end",
                                                            "init_sync_start",
                                                            "num_addr",
                                                            "num_app_bytes",
                                                            "num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_duplicate_addr",
                                                            "num_lbl",
                                                            "num_rx_bytes") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.init_sync_end.is_set or
                                                self.init_sync_start.is_set or
                                                self.num_addr.is_set or
                                                self.num_app_bytes.is_set or
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_duplicate_addr.is_set or
                                                self.num_lbl.is_set or
                                                self.num_rx_bytes.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.init_sync_end.yfilter != YFilter.not_set or
                                                self.init_sync_start.yfilter != YFilter.not_set or
                                                self.num_addr.yfilter != YFilter.not_set or
                                                self.num_app_bytes.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_duplicate_addr.yfilter != YFilter.not_set or
                                                self.num_lbl.yfilter != YFilter.not_set or
                                                self.num_rx_bytes.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "init-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.init_sync_end.is_set or self.init_sync_end.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_end.get_name_leafdata())
                                            if (self.init_sync_start.is_set or self.init_sync_start.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.init_sync_start.get_name_leafdata())
                                            if (self.num_addr.is_set or self.num_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_addr.get_name_leafdata())
                                            if (self.num_app_bytes.is_set or self.num_app_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_app_bytes.get_name_leafdata())
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_duplicate_addr.is_set or self.num_duplicate_addr.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_duplicate_addr.get_name_leafdata())
                                            if (self.num_lbl.is_set or self.num_lbl.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_lbl.get_name_leafdata())
                                            if (self.num_rx_bytes.is_set or self.num_rx_bytes.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_rx_bytes.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "init-sync-end" or name == "init-sync-start" or name == "num-addr" or name == "num-app-bytes" or name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-duplicate-addr" or name == "num-lbl" or name == "num-rx-bytes"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "init-sync-end"):
                                                self.init_sync_end = value
                                                self.init_sync_end.value_namespace = name_space
                                                self.init_sync_end.value_namespace_prefix = name_space_prefix
                                            if(value_path == "init-sync-start"):
                                                self.init_sync_start = value
                                                self.init_sync_start.value_namespace = name_space
                                                self.init_sync_start.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-addr"):
                                                self.num_addr = value
                                                self.num_addr.value_namespace = name_space
                                                self.num_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-app-bytes"):
                                                self.num_app_bytes = value
                                                self.num_app_bytes.value_namespace = name_space
                                                self.num_app_bytes.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-duplicate-addr"):
                                                self.num_duplicate_addr = value
                                                self.num_duplicate_addr.value_namespace = name_space
                                                self.num_duplicate_addr.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-lbl"):
                                                self.num_lbl = value
                                                self.num_lbl.value_namespace = name_space
                                                self.num_lbl.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-rx-bytes"):
                                                self.num_rx_bytes = value
                                                self.num_rx_bytes.value_namespace = name_space
                                                self.num_rx_bytes.value_namespace_prefix = name_space_prefix


                                    class SteadyStateSyncInfo(Entity):
                                        """
                                        NSR Steady State Sync Info
                                        
                                        .. attribute:: num_cap_rcvd
                                        
                                        	Num of Rcvd Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_cap_sent
                                        
                                        	Num of Sent Capabilities
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_join
                                        
                                        	Number of standby adj join
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: num_stdby_adj_leave
                                        
                                        	Number of standby adj leave
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_rq
                                        
                                        	Number of remote label request events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: rem_lbl_wd
                                        
                                        	Number of remote label withdraw events
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__init__()

                                            self.yang_name = "steady-state-sync-info"
                                            self.yang_parent_name = "ha-neighbor"

                                            self.num_cap_rcvd = YLeaf(YType.uint32, "num-cap-rcvd")

                                            self.num_cap_sent = YLeaf(YType.uint32, "num-cap-sent")

                                            self.num_stdby_adj_join = YLeaf(YType.uint32, "num-stdby-adj-join")

                                            self.num_stdby_adj_leave = YLeaf(YType.uint32, "num-stdby-adj-leave")

                                            self.rem_lbl_rq = YLeaf(YType.uint32, "rem-lbl-rq")

                                            self.rem_lbl_wd = YLeaf(YType.uint32, "rem-lbl-wd")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("num_cap_rcvd",
                                                            "num_cap_sent",
                                                            "num_stdby_adj_join",
                                                            "num_stdby_adj_leave",
                                                            "rem_lbl_rq",
                                                            "rem_lbl_wd") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.num_cap_rcvd.is_set or
                                                self.num_cap_sent.is_set or
                                                self.num_stdby_adj_join.is_set or
                                                self.num_stdby_adj_leave.is_set or
                                                self.rem_lbl_rq.is_set or
                                                self.rem_lbl_wd.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.num_cap_rcvd.yfilter != YFilter.not_set or
                                                self.num_cap_sent.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_join.yfilter != YFilter.not_set or
                                                self.num_stdby_adj_leave.yfilter != YFilter.not_set or
                                                self.rem_lbl_rq.yfilter != YFilter.not_set or
                                                self.rem_lbl_wd.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "steady-state-sync-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.num_cap_rcvd.is_set or self.num_cap_rcvd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_rcvd.get_name_leafdata())
                                            if (self.num_cap_sent.is_set or self.num_cap_sent.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_cap_sent.get_name_leafdata())
                                            if (self.num_stdby_adj_join.is_set or self.num_stdby_adj_join.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_join.get_name_leafdata())
                                            if (self.num_stdby_adj_leave.is_set or self.num_stdby_adj_leave.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.num_stdby_adj_leave.get_name_leafdata())
                                            if (self.rem_lbl_rq.is_set or self.rem_lbl_rq.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_rq.get_name_leafdata())
                                            if (self.rem_lbl_wd.is_set or self.rem_lbl_wd.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.rem_lbl_wd.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "num-cap-rcvd" or name == "num-cap-sent" or name == "num-stdby-adj-join" or name == "num-stdby-adj-leave" or name == "rem-lbl-rq" or name == "rem-lbl-wd"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "num-cap-rcvd"):
                                                self.num_cap_rcvd = value
                                                self.num_cap_rcvd.value_namespace = name_space
                                                self.num_cap_rcvd.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-cap-sent"):
                                                self.num_cap_sent = value
                                                self.num_cap_sent.value_namespace = name_space
                                                self.num_cap_sent.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-join"):
                                                self.num_stdby_adj_join = value
                                                self.num_stdby_adj_join.value_namespace = name_space
                                                self.num_stdby_adj_join.value_namespace_prefix = name_space_prefix
                                            if(value_path == "num-stdby-adj-leave"):
                                                self.num_stdby_adj_leave = value
                                                self.num_stdby_adj_leave.value_namespace = name_space
                                                self.num_stdby_adj_leave.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-rq"):
                                                self.rem_lbl_rq = value
                                                self.rem_lbl_rq.value_namespace = name_space
                                                self.rem_lbl_rq.value_namespace_prefix = name_space_prefix
                                            if(value_path == "rem-lbl-wd"):
                                                self.rem_lbl_wd = value
                                                self.rem_lbl_wd.value_namespace = name_space
                                                self.rem_lbl_wd.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.label_space_id.is_set or
                                            self.lbl_spc_id.is_set or
                                            self.lsr_id.is_set or
                                            self.lsr_id_xr.is_set or
                                            self.nsr_sync_state.is_set or
                                            self.num_msg.is_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_data()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.label_space_id.yfilter != YFilter.not_set or
                                            self.lbl_spc_id.yfilter != YFilter.not_set or
                                            self.lsr_id.yfilter != YFilter.not_set or
                                            self.lsr_id_xr.yfilter != YFilter.not_set or
                                            self.nsr_sync_state.yfilter != YFilter.not_set or
                                            self.num_msg.yfilter != YFilter.not_set or
                                            (self.init_sync_info is not None and self.init_sync_info.has_operation()) or
                                            (self.steady_state_sync_info is not None and self.steady_state_sync_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ha-neighbor" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                        if (self.lbl_spc_id.is_set or self.lbl_spc_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lbl_spc_id.get_name_leafdata())
                                        if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id.get_name_leafdata())
                                        if (self.lsr_id_xr.is_set or self.lsr_id_xr.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.lsr_id_xr.get_name_leafdata())
                                        if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                        if (self.num_msg.is_set or self.num_msg.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.num_msg.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "init-sync-info"):
                                            if (self.init_sync_info is None):
                                                self.init_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.InitSyncInfo()
                                                self.init_sync_info.parent = self
                                                self._children_name_map["init_sync_info"] = "init-sync-info"
                                            return self.init_sync_info

                                        if (child_yang_name == "steady-state-sync-info"):
                                            if (self.steady_state_sync_info is None):
                                                self.steady_state_sync_info = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor.SteadyStateSyncInfo()
                                                self.steady_state_sync_info.parent = self
                                                self._children_name_map["steady_state_sync_info"] = "steady-state-sync-info"
                                            return self.steady_state_sync_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "init-sync-info" or name == "steady-state-sync-info" or name == "label-space-id" or name == "lbl-spc-id" or name == "lsr-id" or name == "lsr-id-xr" or name == "nsr-sync-state" or name == "num-msg"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "label-space-id"):
                                            self.label_space_id = value
                                            self.label_space_id.value_namespace = name_space
                                            self.label_space_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lbl-spc-id"):
                                            self.lbl_spc_id = value
                                            self.lbl_spc_id.value_namespace = name_space
                                            self.lbl_spc_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id"):
                                            self.lsr_id = value
                                            self.lsr_id.value_namespace = name_space
                                            self.lsr_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "lsr-id-xr"):
                                            self.lsr_id_xr = value
                                            self.lsr_id_xr.value_namespace = name_space
                                            self.lsr_id_xr.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nsr-sync-state"):
                                            self.nsr_sync_state = value
                                            self.nsr_sync_state.value_namespace = name_space
                                            self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                        if(value_path == "num-msg"):
                                            self.num_msg = value
                                            self.num_msg.value_namespace = name_space
                                            self.num_msg.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.ha_neighbor:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ha-neighbors" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ha-neighbor"):
                                        for c in self.ha_neighbor:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors.HaNeighbor()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ha_neighbor.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ha-neighbor"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.ha_global is not None and self.ha_global.has_data()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.ha_global is not None and self.ha_global.has_operation()) or
                                    (self.ha_neighbors is not None and self.ha_neighbors.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ha-statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ha-global"):
                                    if (self.ha_global is None):
                                        self.ha_global = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaGlobal()
                                        self.ha_global.parent = self
                                        self._children_name_map["ha_global"] = "ha-global"
                                    return self.ha_global

                                if (child_yang_name == "ha-neighbors"):
                                    if (self.ha_neighbors is None):
                                        self.ha_neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics.HaNeighbors()
                                        self.ha_neighbors.parent = self
                                        self._children_name_map["ha_neighbors"] = "ha-neighbors"
                                    return self.ha_neighbors

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ha-global" or name == "ha-neighbors"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                (self.ha_statistics is not None and self.ha_statistics.has_data()) or
                                (self.ha_summary is not None and self.ha_summary.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.ha_statistics is not None and self.ha_statistics.has_operation()) or
                                (self.ha_summary is not None and self.ha_summary.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "issu" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ha-statistics"):
                                if (self.ha_statistics is None):
                                    self.ha_statistics = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaStatistics()
                                    self.ha_statistics.parent = self
                                    self._children_name_map["ha_statistics"] = "ha-statistics"
                                return self.ha_statistics

                            if (child_yang_name == "ha-summary"):
                                if (self.ha_summary is None):
                                    self.ha_summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu.HaSummary()
                                    self.ha_summary.parent = self
                                    self._children_name_map["ha_summary"] = "ha-summary"
                                return self.ha_summary

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ha-statistics" or name == "ha-summary"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class NeighborCapabilities(Entity):
                        """
                        LDP Neighbors Capabilities
                        
                        .. attribute:: neighbor_capability
                        
                        	Information on capabilities of a particular LDP neighbor
                        	**type**\: list of    :py:class:`NeighborCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities, self).__init__()

                            self.yang_name = "neighbor-capabilities"
                            self.yang_parent_name = "vrf"

                            self.neighbor_capability = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities, self).__setattr__(name, value)


                        class NeighborCapability(Entity):
                            """
                            Information on capabilities of a particular LDP
                            neighbor
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: received
                            
                            	List of received capabilities
                            	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received>`
                            
                            .. attribute:: sent
                            
                            	List of sent capabilities
                            	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__init__()

                                self.yang_name = "neighbor-capability"
                                self.yang_parent_name = "neighbor-capabilities"

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.received = YList(self)
                                self.sent = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability, self).__setattr__(name, value)


                            class Sent(Entity):
                                """
                                List of sent capabilities
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__init__()

                                    self.yang_name = "sent"
                                    self.yang_parent_name = "neighbor-capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sent" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix


                            class Received(Entity):
                                """
                                List of received capabilities
                                
                                .. attribute:: capability_data
                                
                                	Capability data
                                	**type**\:  str
                                
                                .. attribute:: capability_data_length
                                
                                	Capability data length
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: description
                                
                                	Capability description
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: type
                                
                                	Capability type (IANA assigned)
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__init__()

                                    self.yang_name = "received"
                                    self.yang_parent_name = "neighbor-capability"

                                    self.capability_data = YLeaf(YType.str, "capability-data")

                                    self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                    self.description = YLeaf(YType.str, "description")

                                    self.type = YLeaf(YType.uint16, "type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("capability_data",
                                                    "capability_data_length",
                                                    "description",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.capability_data.is_set or
                                        self.capability_data_length.is_set or
                                        self.description.is_set or
                                        self.type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.capability_data.yfilter != YFilter.not_set or
                                        self.capability_data_length.yfilter != YFilter.not_set or
                                        self.description.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "received" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data.get_name_leafdata())
                                    if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.description.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "capability-data"):
                                        self.capability_data = value
                                        self.capability_data.value_namespace = name_space
                                        self.capability_data.value_namespace_prefix = name_space_prefix
                                    if(value_path == "capability-data-length"):
                                        self.capability_data_length = value
                                        self.capability_data_length.value_namespace = name_space
                                        self.capability_data_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "description"):
                                        self.description = value
                                        self.description.value_namespace = name_space
                                        self.description.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.received:
                                    if (c.has_data()):
                                        return True
                                for c in self.sent:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set)

                            def has_operation(self):
                                for c in self.received:
                                    if (c.has_operation()):
                                        return True
                                for c in self.sent:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor-capability" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "received"):
                                    for c in self.received:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Received()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.received.append(c)
                                    return c

                                if (child_yang_name == "sent"):
                                    for c in self.sent:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability.Sent()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sent.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "received" or name == "sent" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor_capability:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor_capability:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbor-capabilities" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor-capability"):
                                for c in self.neighbor_capability:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities.NeighborCapability()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor_capability.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor-capability"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Neighbors(Entity):
                        """
                        The LDP Neighbors
                        
                        .. attribute:: neighbor
                        
                        	Information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors, self).__init__()

                            self.yang_name = "neighbors"
                            self.yang_parent_name = "vrf"

                            self.neighbor = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors, self).__setattr__(name, value)


                        class Neighbor(Entity):
                            """
                            Information on a particular LDP neighbor
                            
                            .. attribute:: detailed_information
                            
                            	Detailed information with regards to holdtime, KA, inbound filtering, and Session protection
                            	**type**\:   :py:class:`DetailedInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation>`
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: ldp_nbr_bound_ipv4_address_info
                            
                            	Neighbor IPv4 Address Info
                            	**type**\: list of    :py:class:`LdpNbrBoundIpv4AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo>`
                            
                            .. attribute:: ldp_nbr_bound_ipv6_address_info
                            
                            	Neighbor IPv6 Address Info
                            	**type**\: list of    :py:class:`LdpNbrBoundIpv6AddressInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo>`
                            
                            .. attribute:: ldp_nbr_ipv4_adj_info
                            
                            	Neighbor's IPv4 Adjacency Information
                            	**type**\: list of    :py:class:`LdpNbrIpv4AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo>`
                            
                            .. attribute:: ldp_nbr_ipv6_adj_info
                            
                            	Neighbor's IPv6 Adjacency Information
                            	**type**\: list of    :py:class:`LdpNbrIpv6AdjInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo>`
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: protocol_information
                            
                            	Protocol Information
                            	**type**\:   :py:class:`ProtocolInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation>`
                            
                            .. attribute:: tcp_information
                            
                            	TCP Information
                            	**type**\:   :py:class:`TcpInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor, self).__init__()

                                self.yang_name = "neighbor"
                                self.yang_parent_name = "neighbors"

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.detailed_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation()
                                self.detailed_information.parent = self
                                self._children_name_map["detailed_information"] = "detailed-information"
                                self._children_yang_names.add("detailed-information")

                                self.protocol_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation()
                                self.protocol_information.parent = self
                                self._children_name_map["protocol_information"] = "protocol-information"
                                self._children_yang_names.add("protocol-information")

                                self.tcp_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation()
                                self.tcp_information.parent = self
                                self._children_name_map["tcp_information"] = "tcp-information"
                                self._children_yang_names.add("tcp-information")

                                self.ldp_nbr_bound_ipv4_address_info = YList(self)
                                self.ldp_nbr_bound_ipv6_address_info = YList(self)
                                self.ldp_nbr_ipv4_adj_info = YList(self)
                                self.ldp_nbr_ipv6_adj_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor, self).__setattr__(name, value)


                            class ProtocolInformation(Entity):
                                """
                                Protocol Information
                                
                                .. attribute:: downstream_on_demand
                                
                                	Is Label advertisment mode in Downstream On Demand mode or Not
                                	**type**\:  bool
                                
                                .. attribute:: ta_graceful_restart_adjacency
                                
                                	Graceful restart information
                                	**type**\:   :py:class:`TaGracefulRestartAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency>`
                                
                                .. attribute:: ta_holdtime
                                
                                	Session holdtime in sec
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_pies_rcvd
                                
                                	Number of pies received
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_pies_sent
                                
                                	Number of pies sent
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ta_state
                                
                                	State
                                	**type**\:  str
                                
                                .. attribute:: ta_up_time_seconds
                                
                                	Up time in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__init__()

                                    self.yang_name = "protocol-information"
                                    self.yang_parent_name = "neighbor"

                                    self.downstream_on_demand = YLeaf(YType.boolean, "downstream-on-demand")

                                    self.ta_holdtime = YLeaf(YType.uint32, "ta-holdtime")

                                    self.ta_pies_rcvd = YLeaf(YType.uint32, "ta-pies-rcvd")

                                    self.ta_pies_sent = YLeaf(YType.uint32, "ta-pies-sent")

                                    self.ta_state = YLeaf(YType.str, "ta-state")

                                    self.ta_up_time_seconds = YLeaf(YType.uint32, "ta-up-time-seconds")

                                    self.ta_graceful_restart_adjacency = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                    self.ta_graceful_restart_adjacency.parent = self
                                    self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                    self._children_yang_names.add("ta-graceful-restart-adjacency")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("downstream_on_demand",
                                                    "ta_holdtime",
                                                    "ta_pies_rcvd",
                                                    "ta_pies_sent",
                                                    "ta_state",
                                                    "ta_up_time_seconds") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation, self).__setattr__(name, value)


                                class TaGracefulRestartAdjacency(Entity):
                                    """
                                    Graceful restart information
                                    
                                    .. attribute:: is_graceful_restartable
                                    
                                    	Is graceful restartable
                                    	**type**\:  bool
                                    
                                    .. attribute:: reconnect_timeout
                                    
                                    	Reconnect timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: recovery_time
                                    
                                    	Recovery time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__init__()

                                        self.yang_name = "ta-graceful-restart-adjacency"
                                        self.yang_parent_name = "protocol-information"

                                        self.is_graceful_restartable = YLeaf(YType.boolean, "is-graceful-restartable")

                                        self.reconnect_timeout = YLeaf(YType.uint32, "reconnect-timeout")

                                        self.recovery_time = YLeaf(YType.uint32, "recovery-time")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_graceful_restartable",
                                                        "reconnect_timeout",
                                                        "recovery_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_graceful_restartable.is_set or
                                            self.reconnect_timeout.is_set or
                                            self.recovery_time.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_graceful_restartable.yfilter != YFilter.not_set or
                                            self.reconnect_timeout.yfilter != YFilter.not_set or
                                            self.recovery_time.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ta-graceful-restart-adjacency" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_graceful_restartable.is_set or self.is_graceful_restartable.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_graceful_restartable.get_name_leafdata())
                                        if (self.reconnect_timeout.is_set or self.reconnect_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.reconnect_timeout.get_name_leafdata())
                                        if (self.recovery_time.is_set or self.recovery_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.recovery_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-graceful-restartable" or name == "reconnect-timeout" or name == "recovery-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-graceful-restartable"):
                                            self.is_graceful_restartable = value
                                            self.is_graceful_restartable.value_namespace = name_space
                                            self.is_graceful_restartable.value_namespace_prefix = name_space_prefix
                                        if(value_path == "reconnect-timeout"):
                                            self.reconnect_timeout = value
                                            self.reconnect_timeout.value_namespace = name_space
                                            self.reconnect_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "recovery-time"):
                                            self.recovery_time = value
                                            self.recovery_time.value_namespace = name_space
                                            self.recovery_time.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.downstream_on_demand.is_set or
                                        self.ta_holdtime.is_set or
                                        self.ta_pies_rcvd.is_set or
                                        self.ta_pies_sent.is_set or
                                        self.ta_state.is_set or
                                        self.ta_up_time_seconds.is_set or
                                        (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.downstream_on_demand.yfilter != YFilter.not_set or
                                        self.ta_holdtime.yfilter != YFilter.not_set or
                                        self.ta_pies_rcvd.yfilter != YFilter.not_set or
                                        self.ta_pies_sent.yfilter != YFilter.not_set or
                                        self.ta_state.yfilter != YFilter.not_set or
                                        self.ta_up_time_seconds.yfilter != YFilter.not_set or
                                        (self.ta_graceful_restart_adjacency is not None and self.ta_graceful_restart_adjacency.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protocol-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.downstream_on_demand.is_set or self.downstream_on_demand.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.downstream_on_demand.get_name_leafdata())
                                    if (self.ta_holdtime.is_set or self.ta_holdtime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_holdtime.get_name_leafdata())
                                    if (self.ta_pies_rcvd.is_set or self.ta_pies_rcvd.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_pies_rcvd.get_name_leafdata())
                                    if (self.ta_pies_sent.is_set or self.ta_pies_sent.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_pies_sent.get_name_leafdata())
                                    if (self.ta_state.is_set or self.ta_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_state.get_name_leafdata())
                                    if (self.ta_up_time_seconds.is_set or self.ta_up_time_seconds.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ta_up_time_seconds.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ta-graceful-restart-adjacency"):
                                        if (self.ta_graceful_restart_adjacency is None):
                                            self.ta_graceful_restart_adjacency = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation.TaGracefulRestartAdjacency()
                                            self.ta_graceful_restart_adjacency.parent = self
                                            self._children_name_map["ta_graceful_restart_adjacency"] = "ta-graceful-restart-adjacency"
                                        return self.ta_graceful_restart_adjacency

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ta-graceful-restart-adjacency" or name == "downstream-on-demand" or name == "ta-holdtime" or name == "ta-pies-rcvd" or name == "ta-pies-sent" or name == "ta-state" or name == "ta-up-time-seconds"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "downstream-on-demand"):
                                        self.downstream_on_demand = value
                                        self.downstream_on_demand.value_namespace = name_space
                                        self.downstream_on_demand.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-holdtime"):
                                        self.ta_holdtime = value
                                        self.ta_holdtime.value_namespace = name_space
                                        self.ta_holdtime.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-pies-rcvd"):
                                        self.ta_pies_rcvd = value
                                        self.ta_pies_rcvd.value_namespace = name_space
                                        self.ta_pies_rcvd.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-pies-sent"):
                                        self.ta_pies_sent = value
                                        self.ta_pies_sent.value_namespace = name_space
                                        self.ta_pies_sent.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-state"):
                                        self.ta_state = value
                                        self.ta_state.value_namespace = name_space
                                        self.ta_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ta-up-time-seconds"):
                                        self.ta_up_time_seconds = value
                                        self.ta_up_time_seconds.value_namespace = name_space
                                        self.ta_up_time_seconds.value_namespace_prefix = name_space_prefix


                            class TcpInformation(Entity):
                                """
                                TCP Information
                                
                                .. attribute:: foreign_host
                                
                                	Foreign host address
                                	**type**\:   :py:class:`ForeignHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost>`
                                
                                .. attribute:: foreign_port
                                
                                	Foreign port number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: is_md5_on
                                
                                	Is MD5 Digest on
                                	**type**\:  bool
                                
                                .. attribute:: local_host
                                
                                	Local host address
                                	**type**\:   :py:class:`LocalHost <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost>`
                                
                                .. attribute:: local_port
                                
                                	Local port number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__init__()

                                    self.yang_name = "tcp-information"
                                    self.yang_parent_name = "neighbor"

                                    self.foreign_port = YLeaf(YType.uint16, "foreign-port")

                                    self.is_md5_on = YLeaf(YType.boolean, "is-md5-on")

                                    self.local_port = YLeaf(YType.uint16, "local-port")

                                    self.foreign_host = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                    self.foreign_host.parent = self
                                    self._children_name_map["foreign_host"] = "foreign-host"
                                    self._children_yang_names.add("foreign-host")

                                    self.local_host = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                    self.local_host.parent = self
                                    self._children_name_map["local_host"] = "local-host"
                                    self._children_yang_names.add("local-host")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("foreign_port",
                                                    "is_md5_on",
                                                    "local_port") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation, self).__setattr__(name, value)


                                class ForeignHost(Entity):
                                    """
                                    Foreign host address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__init__()

                                        self.yang_name = "foreign-host"
                                        self.yang_parent_name = "tcp-information"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "foreign-host" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix


                                class LocalHost(Entity):
                                    """
                                    Local host address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__init__()

                                        self.yang_name = "local-host"
                                        self.yang_parent_name = "tcp-information"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "local-host" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.foreign_port.is_set or
                                        self.is_md5_on.is_set or
                                        self.local_port.is_set or
                                        (self.foreign_host is not None and self.foreign_host.has_data()) or
                                        (self.local_host is not None and self.local_host.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.foreign_port.yfilter != YFilter.not_set or
                                        self.is_md5_on.yfilter != YFilter.not_set or
                                        self.local_port.yfilter != YFilter.not_set or
                                        (self.foreign_host is not None and self.foreign_host.has_operation()) or
                                        (self.local_host is not None and self.local_host.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tcp-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.foreign_port.is_set or self.foreign_port.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.foreign_port.get_name_leafdata())
                                    if (self.is_md5_on.is_set or self.is_md5_on.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_md5_on.get_name_leafdata())
                                    if (self.local_port.is_set or self.local_port.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.local_port.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "foreign-host"):
                                        if (self.foreign_host is None):
                                            self.foreign_host = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.ForeignHost()
                                            self.foreign_host.parent = self
                                            self._children_name_map["foreign_host"] = "foreign-host"
                                        return self.foreign_host

                                    if (child_yang_name == "local-host"):
                                        if (self.local_host is None):
                                            self.local_host = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation.LocalHost()
                                            self.local_host.parent = self
                                            self._children_name_map["local_host"] = "local-host"
                                        return self.local_host

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "foreign-host" or name == "local-host" or name == "foreign-port" or name == "is-md5-on" or name == "local-port"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "foreign-port"):
                                        self.foreign_port = value
                                        self.foreign_port.value_namespace = name_space
                                        self.foreign_port.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-md5-on"):
                                        self.is_md5_on = value
                                        self.is_md5_on.value_namespace = name_space
                                        self.is_md5_on.value_namespace_prefix = name_space_prefix
                                    if(value_path == "local-port"):
                                        self.local_port = value
                                        self.local_port.value_namespace = name_space
                                        self.local_port.value_namespace_prefix = name_space_prefix


                            class DetailedInformation(Entity):
                                """
                                Detailed information with regards to holdtime,
                                KA, inbound filtering, and Session protection
                                
                                .. attribute:: advertise_bgp_prefixes
                                
                                	Is BGP labelled prefixes advertised to the neighbor
                                	**type**\:  bool
                                
                                .. attribute:: bgp_advertisement_state
                                
                                	BGP labelled prefixes advertisement state
                                	**type**\:   :py:class:`MgmtLdpNbrBgpAdvtState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNbrBgpAdvtState>`
                                
                                .. attribute:: capabilities
                                
                                	Capabilities sent to and received from neighbor
                                	**type**\:   :py:class:`Capabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities>`
                                
                                .. attribute:: client
                                
                                	Targeted Session clients
                                	**type**\: list of    :py:class:`Client <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client>`
                                
                                .. attribute:: has_ipv4_inbound
                                
                                	IPv4 Inbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv4_outbound
                                
                                	IPv4 Outbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv6_inbound
                                
                                	IPv6 Inbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_ipv6_outbound
                                
                                	IPv6 Outbound label filtering present
                                	**type**\:  bool
                                
                                .. attribute:: has_sp
                                
                                	Session Protection enabled
                                	**type**\:  bool
                                
                                .. attribute:: inbound_ipv4acl
                                
                                	IPv4 Inbound accept ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: inbound_ipv6acl
                                
                                	IPv6 Inbound accept ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: ipv4_duplicate_address
                                
                                	Duplicate IPv4 address bound to this peer
                                	**type**\: list of    :py:class:`Ipv4DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress>`
                                
                                .. attribute:: ipv6_duplicate_address
                                
                                	Duplicate IPv6 address bound to this peer
                                	**type**\: list of    :py:class:`Ipv6DuplicateAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress>`
                                
                                .. attribute:: keep_alive_interval
                                
                                	Session keepalive interval in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: nsr_last_sync_error
                                
                                	Last NSR sync error
                                	**type**\:   :py:class:`MgmtLdpNsrPeerSyncErr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncErr>`
                                
                                .. attribute:: nsr_last_sync_nack_reason
                                
                                	Last NSR sync NACK reaston
                                	**type**\:   :py:class:`MgmtLdpNsrPeerLdpSyncNackRsn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerLdpSyncNackRsn>`
                                
                                .. attribute:: nsr_sync_state
                                
                                	NSR Sync State
                                	**type**\:   :py:class:`MgmtLdpNsrPeerSyncState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MgmtLdpNsrPeerSyncState>`
                                
                                .. attribute:: outbound_ipv4acl
                                
                                	IPv4 Outbound advertise ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: outbound_ipv6acl
                                
                                	IPv6 Outbound advertise ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: peer_holdtime
                                
                                	Session holdtime value in seconds from the peer
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: peer_state
                                
                                	Peer state
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: sp_duration
                                
                                	Session protection holdup time duration in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: sp_has_acl
                                
                                	Session protection ACL is present
                                	**type**\:  bool
                                
                                .. attribute:: sp_has_duration
                                
                                	Session Protection has non\-default duration
                                	**type**\:  bool
                                
                                .. attribute:: sp_state
                                
                                	Session Protection state
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: spacl
                                
                                	Session Protection ACL
                                	**type**\:  str
                                
                                	**length:** 0..80
                                
                                .. attribute:: spht_remaining
                                
                                	Session Protection holdup time remaining value in seconds
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: spht_running
                                
                                	Session Protection holdup timer is running
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__init__()

                                    self.yang_name = "detailed-information"
                                    self.yang_parent_name = "neighbor"

                                    self.advertise_bgp_prefixes = YLeaf(YType.boolean, "advertise-bgp-prefixes")

                                    self.bgp_advertisement_state = YLeaf(YType.enumeration, "bgp-advertisement-state")

                                    self.has_ipv4_inbound = YLeaf(YType.boolean, "has-ipv4-inbound")

                                    self.has_ipv4_outbound = YLeaf(YType.boolean, "has-ipv4-outbound")

                                    self.has_ipv6_inbound = YLeaf(YType.boolean, "has-ipv6-inbound")

                                    self.has_ipv6_outbound = YLeaf(YType.boolean, "has-ipv6-outbound")

                                    self.has_sp = YLeaf(YType.boolean, "has-sp")

                                    self.inbound_ipv4acl = YLeaf(YType.str, "inbound-ipv4acl")

                                    self.inbound_ipv6acl = YLeaf(YType.str, "inbound-ipv6acl")

                                    self.keep_alive_interval = YLeaf(YType.uint32, "keep-alive-interval")

                                    self.nsr_last_sync_error = YLeaf(YType.enumeration, "nsr-last-sync-error")

                                    self.nsr_last_sync_nack_reason = YLeaf(YType.enumeration, "nsr-last-sync-nack-reason")

                                    self.nsr_sync_state = YLeaf(YType.enumeration, "nsr-sync-state")

                                    self.outbound_ipv4acl = YLeaf(YType.str, "outbound-ipv4acl")

                                    self.outbound_ipv6acl = YLeaf(YType.str, "outbound-ipv6acl")

                                    self.peer_holdtime = YLeaf(YType.uint32, "peer-holdtime")

                                    self.peer_state = YLeaf(YType.str, "peer-state")

                                    self.sp_duration = YLeaf(YType.uint32, "sp-duration")

                                    self.sp_has_acl = YLeaf(YType.boolean, "sp-has-acl")

                                    self.sp_has_duration = YLeaf(YType.boolean, "sp-has-duration")

                                    self.sp_state = YLeaf(YType.str, "sp-state")

                                    self.spacl = YLeaf(YType.str, "spacl")

                                    self.spht_remaining = YLeaf(YType.uint32, "spht-remaining")

                                    self.spht_running = YLeaf(YType.boolean, "spht-running")

                                    self.capabilities = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                    self.capabilities.parent = self
                                    self._children_name_map["capabilities"] = "capabilities"
                                    self._children_yang_names.add("capabilities")

                                    self.client = YList(self)
                                    self.ipv4_duplicate_address = YList(self)
                                    self.ipv6_duplicate_address = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("advertise_bgp_prefixes",
                                                    "bgp_advertisement_state",
                                                    "has_ipv4_inbound",
                                                    "has_ipv4_outbound",
                                                    "has_ipv6_inbound",
                                                    "has_ipv6_outbound",
                                                    "has_sp",
                                                    "inbound_ipv4acl",
                                                    "inbound_ipv6acl",
                                                    "keep_alive_interval",
                                                    "nsr_last_sync_error",
                                                    "nsr_last_sync_nack_reason",
                                                    "nsr_sync_state",
                                                    "outbound_ipv4acl",
                                                    "outbound_ipv6acl",
                                                    "peer_holdtime",
                                                    "peer_state",
                                                    "sp_duration",
                                                    "sp_has_acl",
                                                    "sp_has_duration",
                                                    "sp_state",
                                                    "spacl",
                                                    "spht_remaining",
                                                    "spht_running") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation, self).__setattr__(name, value)


                                class Capabilities(Entity):
                                    """
                                    Capabilities sent to and received from neighbor
                                    
                                    .. attribute:: received
                                    
                                    	List of received capabilities
                                    	**type**\: list of    :py:class:`Received <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received>`
                                    
                                    .. attribute:: sent
                                    
                                    	List of sent capabilities
                                    	**type**\: list of    :py:class:`Sent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__init__()

                                        self.yang_name = "capabilities"
                                        self.yang_parent_name = "detailed-information"

                                        self.received = YList(self)
                                        self.sent = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in () and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities, self).__setattr__(name, value)


                                    class Sent(Entity):
                                        """
                                        List of sent capabilities
                                        
                                        .. attribute:: capability_data
                                        
                                        	Capability data
                                        	**type**\:  str
                                        
                                        .. attribute:: capability_data_length
                                        
                                        	Capability data length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: description
                                        
                                        	Capability description
                                        	**type**\:  str
                                        
                                        	**length:** 0..80
                                        
                                        .. attribute:: type
                                        
                                        	Capability type (IANA assigned)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__init__()

                                            self.yang_name = "sent"
                                            self.yang_parent_name = "capabilities"

                                            self.capability_data = YLeaf(YType.str, "capability-data")

                                            self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                            self.description = YLeaf(YType.str, "description")

                                            self.type = YLeaf(YType.uint16, "type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("capability_data",
                                                            "capability_data_length",
                                                            "description",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.capability_data.is_set or
                                                self.capability_data_length.is_set or
                                                self.description.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.capability_data.yfilter != YFilter.not_set or
                                                self.capability_data_length.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "sent" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data.get_name_leafdata())
                                            if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "capability-data"):
                                                self.capability_data = value
                                                self.capability_data.value_namespace = name_space
                                                self.capability_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "capability-data-length"):
                                                self.capability_data_length = value
                                                self.capability_data_length.value_namespace = name_space
                                                self.capability_data_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix


                                    class Received(Entity):
                                        """
                                        List of received capabilities
                                        
                                        .. attribute:: capability_data
                                        
                                        	Capability data
                                        	**type**\:  str
                                        
                                        .. attribute:: capability_data_length
                                        
                                        	Capability data length
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: description
                                        
                                        	Capability description
                                        	**type**\:  str
                                        
                                        	**length:** 0..80
                                        
                                        .. attribute:: type
                                        
                                        	Capability type (IANA assigned)
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__init__()

                                            self.yang_name = "received"
                                            self.yang_parent_name = "capabilities"

                                            self.capability_data = YLeaf(YType.str, "capability-data")

                                            self.capability_data_length = YLeaf(YType.uint16, "capability-data-length")

                                            self.description = YLeaf(YType.str, "description")

                                            self.type = YLeaf(YType.uint16, "type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("capability_data",
                                                            "capability_data_length",
                                                            "description",
                                                            "type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.capability_data.is_set or
                                                self.capability_data_length.is_set or
                                                self.description.is_set or
                                                self.type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.capability_data.yfilter != YFilter.not_set or
                                                self.capability_data_length.yfilter != YFilter.not_set or
                                                self.description.yfilter != YFilter.not_set or
                                                self.type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "received" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.capability_data.is_set or self.capability_data.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data.get_name_leafdata())
                                            if (self.capability_data_length.is_set or self.capability_data_length.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.capability_data_length.get_name_leafdata())
                                            if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.description.get_name_leafdata())
                                            if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "capability-data" or name == "capability-data-length" or name == "description" or name == "type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "capability-data"):
                                                self.capability_data = value
                                                self.capability_data.value_namespace = name_space
                                                self.capability_data.value_namespace_prefix = name_space_prefix
                                            if(value_path == "capability-data-length"):
                                                self.capability_data_length = value
                                                self.capability_data_length.value_namespace = name_space
                                                self.capability_data_length.value_namespace_prefix = name_space_prefix
                                            if(value_path == "description"):
                                                self.description = value
                                                self.description.value_namespace = name_space
                                                self.description.value_namespace_prefix = name_space_prefix
                                            if(value_path == "type"):
                                                self.type = value
                                                self.type.value_namespace = name_space
                                                self.type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.received:
                                            if (c.has_data()):
                                                return True
                                        for c in self.sent:
                                            if (c.has_data()):
                                                return True
                                        return False

                                    def has_operation(self):
                                        for c in self.received:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.sent:
                                            if (c.has_operation()):
                                                return True
                                        return self.yfilter != YFilter.not_set

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "capabilities" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "received"):
                                            for c in self.received:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Received()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.received.append(c)
                                            return c

                                        if (child_yang_name == "sent"):
                                            for c in self.sent:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities.Sent()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.sent.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "received" or name == "sent"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Client(Entity):
                                    """
                                    Targeted Session clients
                                    
                                    .. attribute:: name
                                    
                                    	Client's name
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__init__()

                                        self.yang_name = "client"
                                        self.yang_parent_name = "detailed-information"

                                        self.name = YLeaf(YType.str, "name")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("name") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.name.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.name.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "client" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.name.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "name"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "name"):
                                            self.name = value
                                            self.name.value_namespace = name_space
                                            self.name.value_namespace_prefix = name_space_prefix


                                class Ipv4DuplicateAddress(Entity):
                                    """
                                    Duplicate IPv4 address bound to this peer
                                    
                                    .. attribute:: address
                                    
                                    	Neighbor Address
                                    	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress, self).__init__()

                                        self.yang_name = "ipv4-duplicate-address"
                                        self.yang_parent_name = "detailed-information"

                                        self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                        self._children_yang_names.add("address")


                                    class Address(Entity):
                                        """
                                        Neighbor Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__init__()

                                            self.yang_name = "address"
                                            self.yang_parent_name = "ipv4-duplicate-address"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.address is not None and self.address.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.address is not None and self.address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-duplicate-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "address"):
                                            if (self.address is None):
                                                self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress.Address()
                                                self.address.parent = self
                                                self._children_name_map["address"] = "address"
                                            return self.address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class Ipv6DuplicateAddress(Entity):
                                    """
                                    Duplicate IPv6 address bound to this peer
                                    
                                    .. attribute:: address
                                    
                                    	Neighbor Address
                                    	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress, self).__init__()

                                        self.yang_name = "ipv6-duplicate-address"
                                        self.yang_parent_name = "detailed-information"

                                        self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                        self.address.parent = self
                                        self._children_name_map["address"] = "address"
                                        self._children_yang_names.add("address")


                                    class Address(Entity):
                                        """
                                        Neighbor Address
                                        
                                        .. attribute:: afi
                                        
                                        	AFI
                                        	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                        
                                        .. attribute:: dummy
                                        
                                        	No Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: ipv4
                                        
                                        	IPv4 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: ipv6
                                        
                                        	IPv6 address type
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__init__()

                                            self.yang_name = "address"
                                            self.yang_parent_name = "ipv6-duplicate-address"

                                            self.afi = YLeaf(YType.enumeration, "afi")

                                            self.dummy = YLeaf(YType.uint8, "dummy")

                                            self.ipv4 = YLeaf(YType.str, "ipv4")

                                            self.ipv6 = YLeaf(YType.str, "ipv6")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("afi",
                                                            "dummy",
                                                            "ipv4",
                                                            "ipv6") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.afi.is_set or
                                                self.dummy.is_set or
                                                self.ipv4.is_set or
                                                self.ipv6.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.afi.yfilter != YFilter.not_set or
                                                self.dummy.yfilter != YFilter.not_set or
                                                self.ipv4.yfilter != YFilter.not_set or
                                                self.ipv6.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "address" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.afi.get_name_leafdata())
                                            if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dummy.get_name_leafdata())
                                            if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv4.get_name_leafdata())
                                            if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ipv6.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "afi"):
                                                self.afi = value
                                                self.afi.value_namespace = name_space
                                                self.afi.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dummy"):
                                                self.dummy = value
                                                self.dummy.value_namespace = name_space
                                                self.dummy.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv4"):
                                                self.ipv4 = value
                                                self.ipv4.value_namespace = name_space
                                                self.ipv4.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ipv6"):
                                                self.ipv6 = value
                                                self.ipv6.value_namespace = name_space
                                                self.ipv6.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.address is not None and self.address.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.address is not None and self.address.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-duplicate-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "address"):
                                            if (self.address is None):
                                                self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress.Address()
                                                self.address.parent = self
                                                self._children_name_map["address"] = "address"
                                            return self.address

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    for c in self.client:
                                        if (c.has_data()):
                                            return True
                                    for c in self.ipv4_duplicate_address:
                                        if (c.has_data()):
                                            return True
                                    for c in self.ipv6_duplicate_address:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.advertise_bgp_prefixes.is_set or
                                        self.bgp_advertisement_state.is_set or
                                        self.has_ipv4_inbound.is_set or
                                        self.has_ipv4_outbound.is_set or
                                        self.has_ipv6_inbound.is_set or
                                        self.has_ipv6_outbound.is_set or
                                        self.has_sp.is_set or
                                        self.inbound_ipv4acl.is_set or
                                        self.inbound_ipv6acl.is_set or
                                        self.keep_alive_interval.is_set or
                                        self.nsr_last_sync_error.is_set or
                                        self.nsr_last_sync_nack_reason.is_set or
                                        self.nsr_sync_state.is_set or
                                        self.outbound_ipv4acl.is_set or
                                        self.outbound_ipv6acl.is_set or
                                        self.peer_holdtime.is_set or
                                        self.peer_state.is_set or
                                        self.sp_duration.is_set or
                                        self.sp_has_acl.is_set or
                                        self.sp_has_duration.is_set or
                                        self.sp_state.is_set or
                                        self.spacl.is_set or
                                        self.spht_remaining.is_set or
                                        self.spht_running.is_set or
                                        (self.capabilities is not None and self.capabilities.has_data()))

                                def has_operation(self):
                                    for c in self.client:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.ipv4_duplicate_address:
                                        if (c.has_operation()):
                                            return True
                                    for c in self.ipv6_duplicate_address:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.advertise_bgp_prefixes.yfilter != YFilter.not_set or
                                        self.bgp_advertisement_state.yfilter != YFilter.not_set or
                                        self.has_ipv4_inbound.yfilter != YFilter.not_set or
                                        self.has_ipv4_outbound.yfilter != YFilter.not_set or
                                        self.has_ipv6_inbound.yfilter != YFilter.not_set or
                                        self.has_ipv6_outbound.yfilter != YFilter.not_set or
                                        self.has_sp.yfilter != YFilter.not_set or
                                        self.inbound_ipv4acl.yfilter != YFilter.not_set or
                                        self.inbound_ipv6acl.yfilter != YFilter.not_set or
                                        self.keep_alive_interval.yfilter != YFilter.not_set or
                                        self.nsr_last_sync_error.yfilter != YFilter.not_set or
                                        self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set or
                                        self.nsr_sync_state.yfilter != YFilter.not_set or
                                        self.outbound_ipv4acl.yfilter != YFilter.not_set or
                                        self.outbound_ipv6acl.yfilter != YFilter.not_set or
                                        self.peer_holdtime.yfilter != YFilter.not_set or
                                        self.peer_state.yfilter != YFilter.not_set or
                                        self.sp_duration.yfilter != YFilter.not_set or
                                        self.sp_has_acl.yfilter != YFilter.not_set or
                                        self.sp_has_duration.yfilter != YFilter.not_set or
                                        self.sp_state.yfilter != YFilter.not_set or
                                        self.spacl.yfilter != YFilter.not_set or
                                        self.spht_remaining.yfilter != YFilter.not_set or
                                        self.spht_running.yfilter != YFilter.not_set or
                                        (self.capabilities is not None and self.capabilities.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "detailed-information" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.advertise_bgp_prefixes.is_set or self.advertise_bgp_prefixes.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.advertise_bgp_prefixes.get_name_leafdata())
                                    if (self.bgp_advertisement_state.is_set or self.bgp_advertisement_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bgp_advertisement_state.get_name_leafdata())
                                    if (self.has_ipv4_inbound.is_set or self.has_ipv4_inbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv4_inbound.get_name_leafdata())
                                    if (self.has_ipv4_outbound.is_set or self.has_ipv4_outbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv4_outbound.get_name_leafdata())
                                    if (self.has_ipv6_inbound.is_set or self.has_ipv6_inbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv6_inbound.get_name_leafdata())
                                    if (self.has_ipv6_outbound.is_set or self.has_ipv6_outbound.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_ipv6_outbound.get_name_leafdata())
                                    if (self.has_sp.is_set or self.has_sp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.has_sp.get_name_leafdata())
                                    if (self.inbound_ipv4acl.is_set or self.inbound_ipv4acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inbound_ipv4acl.get_name_leafdata())
                                    if (self.inbound_ipv6acl.is_set or self.inbound_ipv6acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.inbound_ipv6acl.get_name_leafdata())
                                    if (self.keep_alive_interval.is_set or self.keep_alive_interval.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_interval.get_name_leafdata())
                                    if (self.nsr_last_sync_error.is_set or self.nsr_last_sync_error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_last_sync_error.get_name_leafdata())
                                    if (self.nsr_last_sync_nack_reason.is_set or self.nsr_last_sync_nack_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_last_sync_nack_reason.get_name_leafdata())
                                    if (self.nsr_sync_state.is_set or self.nsr_sync_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nsr_sync_state.get_name_leafdata())
                                    if (self.outbound_ipv4acl.is_set or self.outbound_ipv4acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outbound_ipv4acl.get_name_leafdata())
                                    if (self.outbound_ipv6acl.is_set or self.outbound_ipv6acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outbound_ipv6acl.get_name_leafdata())
                                    if (self.peer_holdtime.is_set or self.peer_holdtime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_holdtime.get_name_leafdata())
                                    if (self.peer_state.is_set or self.peer_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.peer_state.get_name_leafdata())
                                    if (self.sp_duration.is_set or self.sp_duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_duration.get_name_leafdata())
                                    if (self.sp_has_acl.is_set or self.sp_has_acl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_has_acl.get_name_leafdata())
                                    if (self.sp_has_duration.is_set or self.sp_has_duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_has_duration.get_name_leafdata())
                                    if (self.sp_state.is_set or self.sp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sp_state.get_name_leafdata())
                                    if (self.spacl.is_set or self.spacl.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spacl.get_name_leafdata())
                                    if (self.spht_remaining.is_set or self.spht_remaining.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spht_remaining.get_name_leafdata())
                                    if (self.spht_running.is_set or self.spht_running.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.spht_running.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "capabilities"):
                                        if (self.capabilities is None):
                                            self.capabilities = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Capabilities()
                                            self.capabilities.parent = self
                                            self._children_name_map["capabilities"] = "capabilities"
                                        return self.capabilities

                                    if (child_yang_name == "client"):
                                        for c in self.client:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Client()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.client.append(c)
                                        return c

                                    if (child_yang_name == "ipv4-duplicate-address"):
                                        for c in self.ipv4_duplicate_address:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv4DuplicateAddress()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ipv4_duplicate_address.append(c)
                                        return c

                                    if (child_yang_name == "ipv6-duplicate-address"):
                                        for c in self.ipv6_duplicate_address:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation.Ipv6DuplicateAddress()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.ipv6_duplicate_address.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "capabilities" or name == "client" or name == "ipv4-duplicate-address" or name == "ipv6-duplicate-address" or name == "advertise-bgp-prefixes" or name == "bgp-advertisement-state" or name == "has-ipv4-inbound" or name == "has-ipv4-outbound" or name == "has-ipv6-inbound" or name == "has-ipv6-outbound" or name == "has-sp" or name == "inbound-ipv4acl" or name == "inbound-ipv6acl" or name == "keep-alive-interval" or name == "nsr-last-sync-error" or name == "nsr-last-sync-nack-reason" or name == "nsr-sync-state" or name == "outbound-ipv4acl" or name == "outbound-ipv6acl" or name == "peer-holdtime" or name == "peer-state" or name == "sp-duration" or name == "sp-has-acl" or name == "sp-has-duration" or name == "sp-state" or name == "spacl" or name == "spht-remaining" or name == "spht-running"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "advertise-bgp-prefixes"):
                                        self.advertise_bgp_prefixes = value
                                        self.advertise_bgp_prefixes.value_namespace = name_space
                                        self.advertise_bgp_prefixes.value_namespace_prefix = name_space_prefix
                                    if(value_path == "bgp-advertisement-state"):
                                        self.bgp_advertisement_state = value
                                        self.bgp_advertisement_state.value_namespace = name_space
                                        self.bgp_advertisement_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv4-inbound"):
                                        self.has_ipv4_inbound = value
                                        self.has_ipv4_inbound.value_namespace = name_space
                                        self.has_ipv4_inbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv4-outbound"):
                                        self.has_ipv4_outbound = value
                                        self.has_ipv4_outbound.value_namespace = name_space
                                        self.has_ipv4_outbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv6-inbound"):
                                        self.has_ipv6_inbound = value
                                        self.has_ipv6_inbound.value_namespace = name_space
                                        self.has_ipv6_inbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-ipv6-outbound"):
                                        self.has_ipv6_outbound = value
                                        self.has_ipv6_outbound.value_namespace = name_space
                                        self.has_ipv6_outbound.value_namespace_prefix = name_space_prefix
                                    if(value_path == "has-sp"):
                                        self.has_sp = value
                                        self.has_sp.value_namespace = name_space
                                        self.has_sp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inbound-ipv4acl"):
                                        self.inbound_ipv4acl = value
                                        self.inbound_ipv4acl.value_namespace = name_space
                                        self.inbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "inbound-ipv6acl"):
                                        self.inbound_ipv6acl = value
                                        self.inbound_ipv6acl.value_namespace = name_space
                                        self.inbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-interval"):
                                        self.keep_alive_interval = value
                                        self.keep_alive_interval.value_namespace = name_space
                                        self.keep_alive_interval.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-last-sync-error"):
                                        self.nsr_last_sync_error = value
                                        self.nsr_last_sync_error.value_namespace = name_space
                                        self.nsr_last_sync_error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-last-sync-nack-reason"):
                                        self.nsr_last_sync_nack_reason = value
                                        self.nsr_last_sync_nack_reason.value_namespace = name_space
                                        self.nsr_last_sync_nack_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nsr-sync-state"):
                                        self.nsr_sync_state = value
                                        self.nsr_sync_state.value_namespace = name_space
                                        self.nsr_sync_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outbound-ipv4acl"):
                                        self.outbound_ipv4acl = value
                                        self.outbound_ipv4acl.value_namespace = name_space
                                        self.outbound_ipv4acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outbound-ipv6acl"):
                                        self.outbound_ipv6acl = value
                                        self.outbound_ipv6acl.value_namespace = name_space
                                        self.outbound_ipv6acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-holdtime"):
                                        self.peer_holdtime = value
                                        self.peer_holdtime.value_namespace = name_space
                                        self.peer_holdtime.value_namespace_prefix = name_space_prefix
                                    if(value_path == "peer-state"):
                                        self.peer_state = value
                                        self.peer_state.value_namespace = name_space
                                        self.peer_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-duration"):
                                        self.sp_duration = value
                                        self.sp_duration.value_namespace = name_space
                                        self.sp_duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-has-acl"):
                                        self.sp_has_acl = value
                                        self.sp_has_acl.value_namespace = name_space
                                        self.sp_has_acl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-has-duration"):
                                        self.sp_has_duration = value
                                        self.sp_has_duration.value_namespace = name_space
                                        self.sp_has_duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sp-state"):
                                        self.sp_state = value
                                        self.sp_state.value_namespace = name_space
                                        self.sp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spacl"):
                                        self.spacl = value
                                        self.spacl.value_namespace = name_space
                                        self.spacl.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spht-remaining"):
                                        self.spht_remaining = value
                                        self.spht_remaining.value_namespace = name_space
                                        self.spht_remaining.value_namespace_prefix = name_space_prefix
                                    if(value_path == "spht-running"):
                                        self.spht_running = value
                                        self.spht_running.value_namespace = name_space
                                        self.spht_running.value_namespace_prefix = name_space_prefix


                            class LdpNbrBoundIpv4AddressInfo(Entity):
                                """
                                Neighbor IPv4 Address Info
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-bound-ipv4-address-info"
                                    self.yang_parent_name = "neighbor"

                                    self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ldp-nbr-bound-ipv4-address-info"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-bound-ipv4-address-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrBoundIpv6AddressInfo(Entity):
                                """
                                Neighbor IPv6 Address Info
                                
                                .. attribute:: address
                                
                                	Neighbor Address
                                	**type**\:   :py:class:`Address <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-bound-ipv6-address-info"
                                    self.yang_parent_name = "neighbor"

                                    self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                    self.address.parent = self
                                    self._children_name_map["address"] = "address"
                                    self._children_yang_names.add("address")


                                class Address(Entity):
                                    """
                                    Neighbor Address
                                    
                                    .. attribute:: afi
                                    
                                    	AFI
                                    	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                    
                                    .. attribute:: dummy
                                    
                                    	No Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: ipv4
                                    
                                    	IPv4 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: ipv6
                                    
                                    	IPv6 address type
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__init__()

                                        self.yang_name = "address"
                                        self.yang_parent_name = "ldp-nbr-bound-ipv6-address-info"

                                        self.afi = YLeaf(YType.enumeration, "afi")

                                        self.dummy = YLeaf(YType.uint8, "dummy")

                                        self.ipv4 = YLeaf(YType.str, "ipv4")

                                        self.ipv6 = YLeaf(YType.str, "ipv6")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("afi",
                                                        "dummy",
                                                        "ipv4",
                                                        "ipv6") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.afi.is_set or
                                            self.dummy.is_set or
                                            self.ipv4.is_set or
                                            self.ipv6.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.afi.yfilter != YFilter.not_set or
                                            self.dummy.yfilter != YFilter.not_set or
                                            self.ipv4.yfilter != YFilter.not_set or
                                            self.ipv6.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.afi.get_name_leafdata())
                                        if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dummy.get_name_leafdata())
                                        if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv4.get_name_leafdata())
                                        if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ipv6.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "afi"):
                                            self.afi = value
                                            self.afi.value_namespace = name_space
                                            self.afi.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dummy"):
                                            self.dummy = value
                                            self.dummy.value_namespace = name_space
                                            self.dummy.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv4"):
                                            self.ipv4 = value
                                            self.ipv4.value_namespace = name_space
                                            self.ipv4.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ipv6"):
                                            self.ipv6 = value
                                            self.ipv6.value_namespace = name_space
                                            self.ipv6.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.address is not None and self.address.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.address is not None and self.address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-bound-ipv6-address-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "address"):
                                        if (self.address is None):
                                            self.address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo.Address()
                                            self.address.parent = self
                                            self._children_name_map["address"] = "address"
                                        return self.address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrIpv4AdjInfo(Entity):
                                """
                                Neighbor's IPv4 Adjacency Information
                                
                                .. attribute:: adjacency_group
                                
                                	Adjacency group
                                	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-ipv4-adj-info"
                                    self.yang_parent_name = "neighbor"

                                    self.adjacency_group = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                    self.adjacency_group.parent = self
                                    self._children_name_map["adjacency_group"] = "adjacency-group"
                                    self._children_yang_names.add("adjacency-group")


                                class AdjacencyGroup(Entity):
                                    """
                                    Adjacency group
                                    
                                    .. attribute:: hello_type
                                    
                                    	HelloType
                                    	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                    
                                    .. attribute:: link_hello_data
                                    
                                    	Link hello
                                    	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData>`
                                    
                                    .. attribute:: target_hello_data
                                    
                                    	Target Hello
                                    	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__init__()

                                        self.yang_name = "adjacency-group"
                                        self.yang_parent_name = "ldp-nbr-ipv4-adj-info"

                                        self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                        self.link_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                        self.link_hello_data.parent = self
                                        self._children_name_map["link_hello_data"] = "link-hello-data"
                                        self._children_yang_names.add("link-hello-data")

                                        self.target_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                        self.target_hello_data.parent = self
                                        self._children_name_map["target_hello_data"] = "target-hello-data"
                                        self._children_yang_names.add("target-hello-data")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hello_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                    class LinkHelloData(Entity):
                                        """
                                        Link hello
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                            self.yang_name = "link-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface",
                                                            "interface_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface.is_set or
                                                self.interface_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface" or name == "interface-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix


                                    class TargetHelloData(Entity):
                                        """
                                        Target Hello
                                        
                                        .. attribute:: local_address
                                        
                                        	Local Address
                                        	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	Target Address
                                        	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                            self.yang_name = "target-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.local_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                            self.local_address.parent = self
                                            self._children_name_map["local_address"] = "local-address"
                                            self._children_yang_names.add("local-address")

                                            self.target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                            self.target_address.parent = self
                                            self._children_name_map["target_address"] = "target-address"
                                            self._children_yang_names.add("target-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                        class LocalAddress(Entity):
                                            """
                                            Local Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                                self.yang_name = "local-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class TargetAddress(Entity):
                                            """
                                            Target Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                                self.yang_name = "target-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.state.is_set or
                                                (self.local_address is not None and self.local_address.has_data()) or
                                                (self.target_address is not None and self.target_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                (self.local_address is not None and self.local_address.has_operation()) or
                                                (self.target_address is not None and self.target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-address"):
                                                if (self.local_address is None):
                                                    self.local_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                    self.local_address.parent = self
                                                    self._children_name_map["local_address"] = "local-address"
                                                return self.local_address

                                            if (child_yang_name == "target-address"):
                                                if (self.target_address is None):
                                                    self.target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                    self.target_address.parent = self
                                                    self._children_name_map["target_address"] = "target-address"
                                                return self.target_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-address" or name == "target-address" or name == "state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hello_type.is_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hello_type.yfilter != YFilter.not_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "adjacency-group" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hello_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-data"):
                                            if (self.link_hello_data is None):
                                                self.link_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.LinkHelloData()
                                                self.link_hello_data.parent = self
                                                self._children_name_map["link_hello_data"] = "link-hello-data"
                                            return self.link_hello_data

                                        if (child_yang_name == "target-hello-data"):
                                            if (self.target_hello_data is None):
                                                self.target_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup.TargetHelloData()
                                                self.target_hello_data.parent = self
                                                self._children_name_map["target_hello_data"] = "target-hello-data"
                                            return self.target_hello_data

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hello-type"):
                                            self.hello_type = value
                                            self.hello_type.value_namespace = name_space
                                            self.hello_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.adjacency_group is not None and self.adjacency_group.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-ipv4-adj-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "adjacency-group"):
                                        if (self.adjacency_group is None):
                                            self.adjacency_group = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo.AdjacencyGroup()
                                            self.adjacency_group.parent = self
                                            self._children_name_map["adjacency_group"] = "adjacency-group"
                                        return self.adjacency_group

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "adjacency-group"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class LdpNbrIpv6AdjInfo(Entity):
                                """
                                Neighbor's IPv6 Adjacency Information
                                
                                .. attribute:: adjacency_group
                                
                                	Adjacency group
                                	**type**\:   :py:class:`AdjacencyGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup>`
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo, self).__init__()

                                    self.yang_name = "ldp-nbr-ipv6-adj-info"
                                    self.yang_parent_name = "neighbor"

                                    self.adjacency_group = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                    self.adjacency_group.parent = self
                                    self._children_name_map["adjacency_group"] = "adjacency-group"
                                    self._children_yang_names.add("adjacency-group")


                                class AdjacencyGroup(Entity):
                                    """
                                    Adjacency group
                                    
                                    .. attribute:: hello_type
                                    
                                    	HelloType
                                    	**type**\:   :py:class:`LdpAdjUnionDiscrim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAdjUnionDiscrim>`
                                    
                                    .. attribute:: link_hello_data
                                    
                                    	Link hello
                                    	**type**\:   :py:class:`LinkHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData>`
                                    
                                    .. attribute:: target_hello_data
                                    
                                    	Target Hello
                                    	**type**\:   :py:class:`TargetHelloData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-ldp-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__init__()

                                        self.yang_name = "adjacency-group"
                                        self.yang_parent_name = "ldp-nbr-ipv6-adj-info"

                                        self.hello_type = YLeaf(YType.enumeration, "hello-type")

                                        self.link_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                        self.link_hello_data.parent = self
                                        self._children_name_map["link_hello_data"] = "link-hello-data"
                                        self._children_yang_names.add("link-hello-data")

                                        self.target_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                        self.target_hello_data.parent = self
                                        self._children_name_map["target_hello_data"] = "target-hello-data"
                                        self._children_yang_names.add("target-hello-data")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hello_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup, self).__setattr__(name, value)


                                    class LinkHelloData(Entity):
                                        """
                                        Link hello
                                        
                                        .. attribute:: interface
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                        
                                        .. attribute:: interface_name
                                        
                                        	Interface name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__init__()

                                            self.yang_name = "link-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.interface = YLeaf(YType.str, "interface")

                                            self.interface_name = YLeaf(YType.str, "interface-name")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("interface",
                                                            "interface_name") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.interface.is_set or
                                                self.interface_name.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.interface.yfilter != YFilter.not_set or
                                                self.interface_name.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "link-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface.get_name_leafdata())
                                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_name.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "interface" or name == "interface-name"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "interface"):
                                                self.interface = value
                                                self.interface.value_namespace = name_space
                                                self.interface.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-name"):
                                                self.interface_name = value
                                                self.interface_name.value_namespace = name_space
                                                self.interface_name.value_namespace_prefix = name_space_prefix


                                    class TargetHelloData(Entity):
                                        """
                                        Target Hello
                                        
                                        .. attribute:: local_address
                                        
                                        	Local Address
                                        	**type**\:   :py:class:`LocalAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress>`
                                        
                                        .. attribute:: state
                                        
                                        	State
                                        	**type**\:   :py:class:`DhcbState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.DhcbState>`
                                        
                                        .. attribute:: target_address
                                        
                                        	Target Address
                                        	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-ldp-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__init__()

                                            self.yang_name = "target-hello-data"
                                            self.yang_parent_name = "adjacency-group"

                                            self.state = YLeaf(YType.enumeration, "state")

                                            self.local_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                            self.local_address.parent = self
                                            self._children_name_map["local_address"] = "local-address"
                                            self._children_yang_names.add("local-address")

                                            self.target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                            self.target_address.parent = self
                                            self._children_name_map["target_address"] = "target-address"
                                            self._children_yang_names.add("target-address")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData, self).__setattr__(name, value)


                                        class LocalAddress(Entity):
                                            """
                                            Local Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__init__()

                                                self.yang_name = "local-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "local-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix


                                        class TargetAddress(Entity):
                                            """
                                            Target Address
                                            
                                            .. attribute:: afi
                                            
                                            	AFI
                                            	**type**\:   :py:class:`LdpAfId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.LdpAfId>`
                                            
                                            .. attribute:: dummy
                                            
                                            	No Address
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: ipv4
                                            
                                            	IPv4 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: ipv6
                                            
                                            	IPv6 address type
                                            	**type**\:  str
                                            
                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-ldp-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__init__()

                                                self.yang_name = "target-address"
                                                self.yang_parent_name = "target-hello-data"

                                                self.afi = YLeaf(YType.enumeration, "afi")

                                                self.dummy = YLeaf(YType.uint8, "dummy")

                                                self.ipv4 = YLeaf(YType.str, "ipv4")

                                                self.ipv6 = YLeaf(YType.str, "ipv6")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("afi",
                                                                "dummy",
                                                                "ipv4",
                                                                "ipv6") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.afi.is_set or
                                                    self.dummy.is_set or
                                                    self.ipv4.is_set or
                                                    self.ipv6.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.afi.yfilter != YFilter.not_set or
                                                    self.dummy.yfilter != YFilter.not_set or
                                                    self.ipv4.yfilter != YFilter.not_set or
                                                    self.ipv6.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "target-address" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.afi.get_name_leafdata())
                                                if (self.dummy.is_set or self.dummy.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.dummy.get_name_leafdata())
                                                if (self.ipv4.is_set or self.ipv4.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv4.get_name_leafdata())
                                                if (self.ipv6.is_set or self.ipv6.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.ipv6.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "afi" or name == "dummy" or name == "ipv4" or name == "ipv6"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "afi"):
                                                    self.afi = value
                                                    self.afi.value_namespace = name_space
                                                    self.afi.value_namespace_prefix = name_space_prefix
                                                if(value_path == "dummy"):
                                                    self.dummy = value
                                                    self.dummy.value_namespace = name_space
                                                    self.dummy.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv4"):
                                                    self.ipv4 = value
                                                    self.ipv4.value_namespace = name_space
                                                    self.ipv4.value_namespace_prefix = name_space_prefix
                                                if(value_path == "ipv6"):
                                                    self.ipv6 = value
                                                    self.ipv6.value_namespace = name_space
                                                    self.ipv6.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.state.is_set or
                                                (self.local_address is not None and self.local_address.has_data()) or
                                                (self.target_address is not None and self.target_address.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.state.yfilter != YFilter.not_set or
                                                (self.local_address is not None and self.local_address.has_operation()) or
                                                (self.target_address is not None and self.target_address.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "target-hello-data" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "local-address"):
                                                if (self.local_address is None):
                                                    self.local_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.LocalAddress()
                                                    self.local_address.parent = self
                                                    self._children_name_map["local_address"] = "local-address"
                                                return self.local_address

                                            if (child_yang_name == "target-address"):
                                                if (self.target_address is None):
                                                    self.target_address = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData.TargetAddress()
                                                    self.target_address.parent = self
                                                    self._children_name_map["target_address"] = "target-address"
                                                return self.target_address

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "local-address" or name == "target-address" or name == "state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "state"):
                                                self.state = value
                                                self.state.value_namespace = name_space
                                                self.state.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hello_type.is_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_data()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hello_type.yfilter != YFilter.not_set or
                                            (self.link_hello_data is not None and self.link_hello_data.has_operation()) or
                                            (self.target_hello_data is not None and self.target_hello_data.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "adjacency-group" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hello_type.is_set or self.hello_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hello_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "link-hello-data"):
                                            if (self.link_hello_data is None):
                                                self.link_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.LinkHelloData()
                                                self.link_hello_data.parent = self
                                                self._children_name_map["link_hello_data"] = "link-hello-data"
                                            return self.link_hello_data

                                        if (child_yang_name == "target-hello-data"):
                                            if (self.target_hello_data is None):
                                                self.target_hello_data = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup.TargetHelloData()
                                                self.target_hello_data.parent = self
                                                self._children_name_map["target_hello_data"] = "target-hello-data"
                                            return self.target_hello_data

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "link-hello-data" or name == "target-hello-data" or name == "hello-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hello-type"):
                                            self.hello_type = value
                                            self.hello_type.value_namespace = name_space
                                            self.hello_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.adjacency_group is not None and self.adjacency_group.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.adjacency_group is not None and self.adjacency_group.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ldp-nbr-ipv6-adj-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "adjacency-group"):
                                        if (self.adjacency_group is None):
                                            self.adjacency_group = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo.AdjacencyGroup()
                                            self.adjacency_group.parent = self
                                            self._children_name_map["adjacency_group"] = "adjacency-group"
                                        return self.adjacency_group

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "adjacency-group"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    if (c.has_data()):
                                        return True
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    (self.detailed_information is not None and self.detailed_information.has_data()) or
                                    (self.protocol_information is not None and self.protocol_information.has_data()) or
                                    (self.tcp_information is not None and self.tcp_information.has_data()))

                            def has_operation(self):
                                for c in self.ldp_nbr_bound_ipv4_address_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_bound_ipv6_address_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_ipv4_adj_info:
                                    if (c.has_operation()):
                                        return True
                                for c in self.ldp_nbr_ipv6_adj_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    (self.detailed_information is not None and self.detailed_information.has_operation()) or
                                    (self.protocol_information is not None and self.protocol_information.has_operation()) or
                                    (self.tcp_information is not None and self.tcp_information.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "neighbor" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "detailed-information"):
                                    if (self.detailed_information is None):
                                        self.detailed_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.DetailedInformation()
                                        self.detailed_information.parent = self
                                        self._children_name_map["detailed_information"] = "detailed-information"
                                    return self.detailed_information

                                if (child_yang_name == "ldp-nbr-bound-ipv4-address-info"):
                                    for c in self.ldp_nbr_bound_ipv4_address_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv4AddressInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_bound_ipv4_address_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-bound-ipv6-address-info"):
                                    for c in self.ldp_nbr_bound_ipv6_address_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrBoundIpv6AddressInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_bound_ipv6_address_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-ipv4-adj-info"):
                                    for c in self.ldp_nbr_ipv4_adj_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv4AdjInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_ipv4_adj_info.append(c)
                                    return c

                                if (child_yang_name == "ldp-nbr-ipv6-adj-info"):
                                    for c in self.ldp_nbr_ipv6_adj_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.LdpNbrIpv6AdjInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.ldp_nbr_ipv6_adj_info.append(c)
                                    return c

                                if (child_yang_name == "protocol-information"):
                                    if (self.protocol_information is None):
                                        self.protocol_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.ProtocolInformation()
                                        self.protocol_information.parent = self
                                        self._children_name_map["protocol_information"] = "protocol-information"
                                    return self.protocol_information

                                if (child_yang_name == "tcp-information"):
                                    if (self.tcp_information is None):
                                        self.tcp_information = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor.TcpInformation()
                                        self.tcp_information.parent = self
                                        self._children_name_map["tcp_information"] = "tcp-information"
                                    return self.tcp_information

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "detailed-information" or name == "ldp-nbr-bound-ipv4-address-info" or name == "ldp-nbr-bound-ipv6-address-info" or name == "ldp-nbr-ipv4-adj-info" or name == "ldp-nbr-ipv6-adj-info" or name == "protocol-information" or name == "tcp-information" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.neighbor:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.neighbor:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "neighbors" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "neighbor"):
                                for c in self.neighbor:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors.Neighbor()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.neighbor.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "neighbor"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class LdpId(Entity):
                        """
                        Local LDP Id
                        
                        .. attribute:: label_space_id
                        
                        	Label space identifier
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: ldp_id
                        
                        	LDP identifier
                        	**type**\:  str
                        
                        .. attribute:: lsr_id
                        
                        	LSR identifier
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.LdpId, self).__init__()

                            self.yang_name = "ldp-id"
                            self.yang_parent_name = "vrf"

                            self.label_space_id = YLeaf(YType.uint16, "label-space-id")

                            self.ldp_id = YLeaf(YType.str, "ldp-id")

                            self.lsr_id = YLeaf(YType.str, "lsr-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("label_space_id",
                                            "ldp_id",
                                            "lsr_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.LdpId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.LdpId, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.label_space_id.is_set or
                                self.ldp_id.is_set or
                                self.lsr_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.label_space_id.yfilter != YFilter.not_set or
                                self.ldp_id.yfilter != YFilter.not_set or
                                self.lsr_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ldp-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_space_id.get_name_leafdata())
                            if (self.ldp_id.is_set or self.ldp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ldp_id.get_name_leafdata())
                            if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsr_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "label-space-id" or name == "ldp-id" or name == "lsr-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "label-space-id"):
                                self.label_space_id = value
                                self.label_space_id.value_namespace = name_space
                                self.label_space_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "ldp-id"):
                                self.ldp_id = value
                                self.ldp_id.value_namespace = name_space
                                self.ldp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsr-id"):
                                self.lsr_id = value
                                self.lsr_id.value_namespace = name_space
                                self.lsr_id.value_namespace_prefix = name_space_prefix


                    class Statistics(Entity):
                        """
                        The LDP Statistics
                        
                        .. attribute:: statistic
                        
                        	Statistical Information on a particular LDP neighbor
                        	**type**\: list of    :py:class:`Statistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic>`
                        
                        

                        """

                        _prefix = 'mpls-ldp-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "vrf"

                            self.statistic = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics, self).__setattr__(name, value)


                        class Statistic(Entity):
                            """
                            Statistical Information on a particular LDP
                            neighbor
                            
                            .. attribute:: iccp_enabled
                            
                            	Is session ICCP enabled?
                            	**type**\:  bool
                            
                            .. attribute:: label_space_id
                            
                            	Label space ID of neighbor
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: lsr_id
                            
                            	LSR ID of neighbor
                            	**type**\: one of the below types:
                            
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            	**type**\:  str
                            
                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                            
                            
                            ----
                            .. attribute:: message_in
                            
                            	Message in count
                            	**type**\:   :py:class:`MessageIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageIn>`
                            
                            .. attribute:: message_out
                            
                            	Message out count
                            	**type**\:   :py:class:`MessageOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageOut>`
                            
                            

                            """

                            _prefix = 'mpls-ldp-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic, self).__init__()

                                self.yang_name = "statistic"
                                self.yang_parent_name = "statistics"

                                self.iccp_enabled = YLeaf(YType.boolean, "iccp-enabled")

                                self.label_space_id = YLeaf(YType.uint32, "label-space-id")

                                self.lsr_id = YLeaf(YType.str, "lsr-id")

                                self.message_in = MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageIn()
                                self.message_in.parent = self
                                self._children_name_map["message_in"] = "message-in"
                                self._children_yang_names.add("message-in")

                                self.message_out = MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageOut()
                                self.message_out.parent = self
                                self._children_name_map["message_out"] = "message-out"
                                self._children_yang_names.add("message-out")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("iccp_enabled",
                                                "label_space_id",
                                                "lsr_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic, self).__setattr__(name, value)


                            class MessageOut(Entity):
                                """
                                Message out count
                                
                                .. attribute:: address_count
                                
                                	Address message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: address_withdraw_count
                                
                                	Address withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_app_data_count
                                
                                	ICCP RG App Data count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_conn_count
                                
                                	ICCP RG Connect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_disconn_count
                                
                                	ICCP RG Disconnect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_notif_count
                                
                                	ICCP RG Notif count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_count
                                
                                	Init message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: keep_alive_count
                                
                                	Keepalive count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_abort_request_count
                                
                                	Label abort request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_map_count
                                
                                	Label map count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_release_count
                                
                                	Label release count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_request_count
                                
                                	Label request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_withdraw_count
                                
                                	Label withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: notification_count
                                
                                	Notification count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_count
                                
                                	Total message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__init__()

                                    self.yang_name = "message-out"
                                    self.yang_parent_name = "statistic"

                                    self.address_count = YLeaf(YType.uint32, "address-count")

                                    self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                    self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                    self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                    self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                    self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                    self.init_count = YLeaf(YType.uint32, "init-count")

                                    self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                    self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                    self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                    self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                    self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                    self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                    self.notification_count = YLeaf(YType.uint32, "notification-count")

                                    self.total_count = YLeaf(YType.uint32, "total-count")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_count",
                                                    "address_withdraw_count",
                                                    "iccp_rg_app_data_count",
                                                    "iccp_rg_conn_count",
                                                    "iccp_rg_disconn_count",
                                                    "iccp_rg_notif_count",
                                                    "init_count",
                                                    "keep_alive_count",
                                                    "label_abort_request_count",
                                                    "label_map_count",
                                                    "label_release_count",
                                                    "label_request_count",
                                                    "label_withdraw_count",
                                                    "notification_count",
                                                    "total_count") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageOut, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_count.is_set or
                                        self.address_withdraw_count.is_set or
                                        self.iccp_rg_app_data_count.is_set or
                                        self.iccp_rg_conn_count.is_set or
                                        self.iccp_rg_disconn_count.is_set or
                                        self.iccp_rg_notif_count.is_set or
                                        self.init_count.is_set or
                                        self.keep_alive_count.is_set or
                                        self.label_abort_request_count.is_set or
                                        self.label_map_count.is_set or
                                        self.label_release_count.is_set or
                                        self.label_request_count.is_set or
                                        self.label_withdraw_count.is_set or
                                        self.notification_count.is_set or
                                        self.total_count.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_count.yfilter != YFilter.not_set or
                                        self.address_withdraw_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                        self.init_count.yfilter != YFilter.not_set or
                                        self.keep_alive_count.yfilter != YFilter.not_set or
                                        self.label_abort_request_count.yfilter != YFilter.not_set or
                                        self.label_map_count.yfilter != YFilter.not_set or
                                        self.label_release_count.yfilter != YFilter.not_set or
                                        self.label_request_count.yfilter != YFilter.not_set or
                                        self.label_withdraw_count.yfilter != YFilter.not_set or
                                        self.notification_count.yfilter != YFilter.not_set or
                                        self.total_count.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "message-out" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_count.get_name_leafdata())
                                    if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                    if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                    if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                    if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                    if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                    if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_count.get_name_leafdata())
                                    if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                    if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                    if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                    if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                    if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                    if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                    if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.notification_count.get_name_leafdata())
                                    if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_count.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-count"):
                                        self.address_count = value
                                        self.address_count.value_namespace = name_space
                                        self.address_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "address-withdraw-count"):
                                        self.address_withdraw_count = value
                                        self.address_withdraw_count.value_namespace = name_space
                                        self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-app-data-count"):
                                        self.iccp_rg_app_data_count = value
                                        self.iccp_rg_app_data_count.value_namespace = name_space
                                        self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-conn-count"):
                                        self.iccp_rg_conn_count = value
                                        self.iccp_rg_conn_count.value_namespace = name_space
                                        self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-disconn-count"):
                                        self.iccp_rg_disconn_count = value
                                        self.iccp_rg_disconn_count.value_namespace = name_space
                                        self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-notif-count"):
                                        self.iccp_rg_notif_count = value
                                        self.iccp_rg_notif_count.value_namespace = name_space
                                        self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-count"):
                                        self.init_count = value
                                        self.init_count.value_namespace = name_space
                                        self.init_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-count"):
                                        self.keep_alive_count = value
                                        self.keep_alive_count.value_namespace = name_space
                                        self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-abort-request-count"):
                                        self.label_abort_request_count = value
                                        self.label_abort_request_count.value_namespace = name_space
                                        self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-map-count"):
                                        self.label_map_count = value
                                        self.label_map_count.value_namespace = name_space
                                        self.label_map_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-release-count"):
                                        self.label_release_count = value
                                        self.label_release_count.value_namespace = name_space
                                        self.label_release_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-request-count"):
                                        self.label_request_count = value
                                        self.label_request_count.value_namespace = name_space
                                        self.label_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-withdraw-count"):
                                        self.label_withdraw_count = value
                                        self.label_withdraw_count.value_namespace = name_space
                                        self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "notification-count"):
                                        self.notification_count = value
                                        self.notification_count.value_namespace = name_space
                                        self.notification_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-count"):
                                        self.total_count = value
                                        self.total_count.value_namespace = name_space
                                        self.total_count.value_namespace_prefix = name_space_prefix


                            class MessageIn(Entity):
                                """
                                Message in count
                                
                                .. attribute:: address_count
                                
                                	Address message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: address_withdraw_count
                                
                                	Address withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_app_data_count
                                
                                	ICCP RG App Data count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_conn_count
                                
                                	ICCP RG Connect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_disconn_count
                                
                                	ICCP RG Disconnect count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: iccp_rg_notif_count
                                
                                	ICCP RG Notif count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: init_count
                                
                                	Init message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: keep_alive_count
                                
                                	Keepalive count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_abort_request_count
                                
                                	Label abort request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_map_count
                                
                                	Label map count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_release_count
                                
                                	Label release count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_request_count
                                
                                	Label request count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: label_withdraw_count
                                
                                	Label withdraw count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: notification_count
                                
                                	Notification count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_count
                                
                                	Total message count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-ldp-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__init__()

                                    self.yang_name = "message-in"
                                    self.yang_parent_name = "statistic"

                                    self.address_count = YLeaf(YType.uint32, "address-count")

                                    self.address_withdraw_count = YLeaf(YType.uint32, "address-withdraw-count")

                                    self.iccp_rg_app_data_count = YLeaf(YType.uint32, "iccp-rg-app-data-count")

                                    self.iccp_rg_conn_count = YLeaf(YType.uint32, "iccp-rg-conn-count")

                                    self.iccp_rg_disconn_count = YLeaf(YType.uint32, "iccp-rg-disconn-count")

                                    self.iccp_rg_notif_count = YLeaf(YType.uint32, "iccp-rg-notif-count")

                                    self.init_count = YLeaf(YType.uint32, "init-count")

                                    self.keep_alive_count = YLeaf(YType.uint32, "keep-alive-count")

                                    self.label_abort_request_count = YLeaf(YType.uint32, "label-abort-request-count")

                                    self.label_map_count = YLeaf(YType.uint32, "label-map-count")

                                    self.label_release_count = YLeaf(YType.uint32, "label-release-count")

                                    self.label_request_count = YLeaf(YType.uint32, "label-request-count")

                                    self.label_withdraw_count = YLeaf(YType.uint32, "label-withdraw-count")

                                    self.notification_count = YLeaf(YType.uint32, "notification-count")

                                    self.total_count = YLeaf(YType.uint32, "total-count")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address_count",
                                                    "address_withdraw_count",
                                                    "iccp_rg_app_data_count",
                                                    "iccp_rg_conn_count",
                                                    "iccp_rg_disconn_count",
                                                    "iccp_rg_notif_count",
                                                    "init_count",
                                                    "keep_alive_count",
                                                    "label_abort_request_count",
                                                    "label_map_count",
                                                    "label_release_count",
                                                    "label_request_count",
                                                    "label_withdraw_count",
                                                    "notification_count",
                                                    "total_count") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageIn, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address_count.is_set or
                                        self.address_withdraw_count.is_set or
                                        self.iccp_rg_app_data_count.is_set or
                                        self.iccp_rg_conn_count.is_set or
                                        self.iccp_rg_disconn_count.is_set or
                                        self.iccp_rg_notif_count.is_set or
                                        self.init_count.is_set or
                                        self.keep_alive_count.is_set or
                                        self.label_abort_request_count.is_set or
                                        self.label_map_count.is_set or
                                        self.label_release_count.is_set or
                                        self.label_request_count.is_set or
                                        self.label_withdraw_count.is_set or
                                        self.notification_count.is_set or
                                        self.total_count.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address_count.yfilter != YFilter.not_set or
                                        self.address_withdraw_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_app_data_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_conn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_disconn_count.yfilter != YFilter.not_set or
                                        self.iccp_rg_notif_count.yfilter != YFilter.not_set or
                                        self.init_count.yfilter != YFilter.not_set or
                                        self.keep_alive_count.yfilter != YFilter.not_set or
                                        self.label_abort_request_count.yfilter != YFilter.not_set or
                                        self.label_map_count.yfilter != YFilter.not_set or
                                        self.label_release_count.yfilter != YFilter.not_set or
                                        self.label_request_count.yfilter != YFilter.not_set or
                                        self.label_withdraw_count.yfilter != YFilter.not_set or
                                        self.notification_count.yfilter != YFilter.not_set or
                                        self.total_count.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "message-in" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address_count.is_set or self.address_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_count.get_name_leafdata())
                                    if (self.address_withdraw_count.is_set or self.address_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address_withdraw_count.get_name_leafdata())
                                    if (self.iccp_rg_app_data_count.is_set or self.iccp_rg_app_data_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_app_data_count.get_name_leafdata())
                                    if (self.iccp_rg_conn_count.is_set or self.iccp_rg_conn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_conn_count.get_name_leafdata())
                                    if (self.iccp_rg_disconn_count.is_set or self.iccp_rg_disconn_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_disconn_count.get_name_leafdata())
                                    if (self.iccp_rg_notif_count.is_set or self.iccp_rg_notif_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.iccp_rg_notif_count.get_name_leafdata())
                                    if (self.init_count.is_set or self.init_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.init_count.get_name_leafdata())
                                    if (self.keep_alive_count.is_set or self.keep_alive_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.keep_alive_count.get_name_leafdata())
                                    if (self.label_abort_request_count.is_set or self.label_abort_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_abort_request_count.get_name_leafdata())
                                    if (self.label_map_count.is_set or self.label_map_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_map_count.get_name_leafdata())
                                    if (self.label_release_count.is_set or self.label_release_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_release_count.get_name_leafdata())
                                    if (self.label_request_count.is_set or self.label_request_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_request_count.get_name_leafdata())
                                    if (self.label_withdraw_count.is_set or self.label_withdraw_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_withdraw_count.get_name_leafdata())
                                    if (self.notification_count.is_set or self.notification_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.notification_count.get_name_leafdata())
                                    if (self.total_count.is_set or self.total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.total_count.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address-count" or name == "address-withdraw-count" or name == "iccp-rg-app-data-count" or name == "iccp-rg-conn-count" or name == "iccp-rg-disconn-count" or name == "iccp-rg-notif-count" or name == "init-count" or name == "keep-alive-count" or name == "label-abort-request-count" or name == "label-map-count" or name == "label-release-count" or name == "label-request-count" or name == "label-withdraw-count" or name == "notification-count" or name == "total-count"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address-count"):
                                        self.address_count = value
                                        self.address_count.value_namespace = name_space
                                        self.address_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "address-withdraw-count"):
                                        self.address_withdraw_count = value
                                        self.address_withdraw_count.value_namespace = name_space
                                        self.address_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-app-data-count"):
                                        self.iccp_rg_app_data_count = value
                                        self.iccp_rg_app_data_count.value_namespace = name_space
                                        self.iccp_rg_app_data_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-conn-count"):
                                        self.iccp_rg_conn_count = value
                                        self.iccp_rg_conn_count.value_namespace = name_space
                                        self.iccp_rg_conn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-disconn-count"):
                                        self.iccp_rg_disconn_count = value
                                        self.iccp_rg_disconn_count.value_namespace = name_space
                                        self.iccp_rg_disconn_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "iccp-rg-notif-count"):
                                        self.iccp_rg_notif_count = value
                                        self.iccp_rg_notif_count.value_namespace = name_space
                                        self.iccp_rg_notif_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "init-count"):
                                        self.init_count = value
                                        self.init_count.value_namespace = name_space
                                        self.init_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "keep-alive-count"):
                                        self.keep_alive_count = value
                                        self.keep_alive_count.value_namespace = name_space
                                        self.keep_alive_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-abort-request-count"):
                                        self.label_abort_request_count = value
                                        self.label_abort_request_count.value_namespace = name_space
                                        self.label_abort_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-map-count"):
                                        self.label_map_count = value
                                        self.label_map_count.value_namespace = name_space
                                        self.label_map_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-release-count"):
                                        self.label_release_count = value
                                        self.label_release_count.value_namespace = name_space
                                        self.label_release_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-request-count"):
                                        self.label_request_count = value
                                        self.label_request_count.value_namespace = name_space
                                        self.label_request_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label-withdraw-count"):
                                        self.label_withdraw_count = value
                                        self.label_withdraw_count.value_namespace = name_space
                                        self.label_withdraw_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "notification-count"):
                                        self.notification_count = value
                                        self.notification_count.value_namespace = name_space
                                        self.notification_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "total-count"):
                                        self.total_count = value
                                        self.total_count.value_namespace = name_space
                                        self.total_count.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.iccp_enabled.is_set or
                                    self.label_space_id.is_set or
                                    self.lsr_id.is_set or
                                    (self.message_in is not None and self.message_in.has_data()) or
                                    (self.message_out is not None and self.message_out.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.iccp_enabled.yfilter != YFilter.not_set or
                                    self.label_space_id.yfilter != YFilter.not_set or
                                    self.lsr_id.yfilter != YFilter.not_set or
                                    (self.message_in is not None and self.message_in.has_operation()) or
                                    (self.message_out is not None and self.message_out.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.iccp_enabled.is_set or self.iccp_enabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iccp_enabled.get_name_leafdata())
                                if (self.label_space_id.is_set or self.label_space_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_space_id.get_name_leafdata())
                                if (self.lsr_id.is_set or self.lsr_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsr_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "message-in"):
                                    if (self.message_in is None):
                                        self.message_in = MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageIn()
                                        self.message_in.parent = self
                                        self._children_name_map["message_in"] = "message-in"
                                    return self.message_in

                                if (child_yang_name == "message-out"):
                                    if (self.message_out is None):
                                        self.message_out = MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic.MessageOut()
                                        self.message_out.parent = self
                                        self._children_name_map["message_out"] = "message-out"
                                    return self.message_out

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "message-in" or name == "message-out" or name == "iccp-enabled" or name == "label-space-id" or name == "lsr-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "iccp-enabled"):
                                    self.iccp_enabled = value
                                    self.iccp_enabled.value_namespace = name_space
                                    self.iccp_enabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-space-id"):
                                    self.label_space_id = value
                                    self.label_space_id.value_namespace = name_space
                                    self.label_space_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsr-id"):
                                    self.lsr_id = value
                                    self.lsr_id.value_namespace = name_space
                                    self.lsr_id.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.statistic:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.statistic:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "statistic"):
                                for c in self.statistic:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics.Statistic()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.statistic.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "statistic"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (
                            self.vrf_name.is_set or
                            (self.afs is not None and self.afs.has_data()) or
                            (self.backoff_parameters is not None and self.backoff_parameters.has_data()) or
                            (self.backoffs is not None and self.backoffs.has_data()) or
                            (self.capabilities is not None and self.capabilities.has_data()) or
                            (self.graceful_restart is not None and self.graceful_restart.has_data()) or
                            (self.issu is not None and self.issu.has_data()) or
                            (self.ldp_id is not None and self.ldp_id.has_data()) or
                            (self.neighbor_briefs is not None and self.neighbor_briefs.has_data()) or
                            (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_data()) or
                            (self.neighbors is not None and self.neighbors.has_data()) or
                            (self.nsr is not None and self.nsr.has_data()) or
                            (self.parameters is not None and self.parameters.has_data()) or
                            (self.statistics is not None and self.statistics.has_data()) or
                            (self.summary is not None and self.summary.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.vrf_name.yfilter != YFilter.not_set or
                            (self.afs is not None and self.afs.has_operation()) or
                            (self.backoff_parameters is not None and self.backoff_parameters.has_operation()) or
                            (self.backoffs is not None and self.backoffs.has_operation()) or
                            (self.capabilities is not None and self.capabilities.has_operation()) or
                            (self.graceful_restart is not None and self.graceful_restart.has_operation()) or
                            (self.issu is not None and self.issu.has_operation()) or
                            (self.ldp_id is not None and self.ldp_id.has_operation()) or
                            (self.neighbor_briefs is not None and self.neighbor_briefs.has_operation()) or
                            (self.neighbor_capabilities is not None and self.neighbor_capabilities.has_operation()) or
                            (self.neighbors is not None and self.neighbors.has_operation()) or
                            (self.nsr is not None and self.nsr.has_operation()) or
                            (self.parameters is not None and self.parameters.has_operation()) or
                            (self.statistics is not None and self.statistics.has_operation()) or
                            (self.summary is not None and self.summary.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + "[vrf-name='" + self.vrf_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.vrf_name.is_set or self.vrf_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vrf_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "afs"):
                            if (self.afs is None):
                                self.afs = MplsLdp.Nodes.Node.Vrfs.Vrf.Afs()
                                self.afs.parent = self
                                self._children_name_map["afs"] = "afs"
                            return self.afs

                        if (child_yang_name == "backoff-parameters"):
                            if (self.backoff_parameters is None):
                                self.backoff_parameters = MplsLdp.Nodes.Node.Vrfs.Vrf.BackoffParameters()
                                self.backoff_parameters.parent = self
                                self._children_name_map["backoff_parameters"] = "backoff-parameters"
                            return self.backoff_parameters

                        if (child_yang_name == "backoffs"):
                            if (self.backoffs is None):
                                self.backoffs = MplsLdp.Nodes.Node.Vrfs.Vrf.Backoffs()
                                self.backoffs.parent = self
                                self._children_name_map["backoffs"] = "backoffs"
                            return self.backoffs

                        if (child_yang_name == "capabilities"):
                            if (self.capabilities is None):
                                self.capabilities = MplsLdp.Nodes.Node.Vrfs.Vrf.Capabilities()
                                self.capabilities.parent = self
                                self._children_name_map["capabilities"] = "capabilities"
                            return self.capabilities

                        if (child_yang_name == "graceful-restart"):
                            if (self.graceful_restart is None):
                                self.graceful_restart = MplsLdp.Nodes.Node.Vrfs.Vrf.GracefulRestart()
                                self.graceful_restart.parent = self
                                self._children_name_map["graceful_restart"] = "graceful-restart"
                            return self.graceful_restart

                        if (child_yang_name == "issu"):
                            if (self.issu is None):
                                self.issu = MplsLdp.Nodes.Node.Vrfs.Vrf.Issu()
                                self.issu.parent = self
                                self._children_name_map["issu"] = "issu"
                            return self.issu

                        if (child_yang_name == "ldp-id"):
                            if (self.ldp_id is None):
                                self.ldp_id = MplsLdp.Nodes.Node.Vrfs.Vrf.LdpId()
                                self.ldp_id.parent = self
                                self._children_name_map["ldp_id"] = "ldp-id"
                            return self.ldp_id

                        if (child_yang_name == "neighbor-briefs"):
                            if (self.neighbor_briefs is None):
                                self.neighbor_briefs = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborBriefs()
                                self.neighbor_briefs.parent = self
                                self._children_name_map["neighbor_briefs"] = "neighbor-briefs"
                            return self.neighbor_briefs

                        if (child_yang_name == "neighbor-capabilities"):
                            if (self.neighbor_capabilities is None):
                                self.neighbor_capabilities = MplsLdp.Nodes.Node.Vrfs.Vrf.NeighborCapabilities()
                                self.neighbor_capabilities.parent = self
                                self._children_name_map["neighbor_capabilities"] = "neighbor-capabilities"
                            return self.neighbor_capabilities

                        if (child_yang_name == "neighbors"):
                            if (self.neighbors is None):
                                self.neighbors = MplsLdp.Nodes.Node.Vrfs.Vrf.Neighbors()
                                self.neighbors.parent = self
                                self._children_name_map["neighbors"] = "neighbors"
                            return self.neighbors

                        if (child_yang_name == "nsr"):
                            if (self.nsr is None):
                                self.nsr = MplsLdp.Nodes.Node.Vrfs.Vrf.Nsr()
                                self.nsr.parent = self
                                self._children_name_map["nsr"] = "nsr"
                            return self.nsr

                        if (child_yang_name == "parameters"):
                            if (self.parameters is None):
                                self.parameters = MplsLdp.Nodes.Node.Vrfs.Vrf.Parameters()
                                self.parameters.parent = self
                                self._children_name_map["parameters"] = "parameters"
                            return self.parameters

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsLdp.Nodes.Node.Vrfs.Vrf.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        if (child_yang_name == "summary"):
                            if (self.summary is None):
                                self.summary = MplsLdp.Nodes.Node.Vrfs.Vrf.Summary()
                                self.summary.parent = self
                                self._children_name_map["summary"] = "summary"
                            return self.summary

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "afs" or name == "backoff-parameters" or name == "backoffs" or name == "capabilities" or name == "graceful-restart" or name == "issu" or name == "ldp-id" or name == "neighbor-briefs" or name == "neighbor-capabilities" or name == "neighbors" or name == "nsr" or name == "parameters" or name == "statistics" or name == "summary" or name == "vrf-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "vrf-name"):
                            self.vrf_name = value
                            self.vrf_name.value_namespace = name_space
                            self.vrf_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.vrf:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.vrf:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "vrfs" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vrf"):
                        for c in self.vrf:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsLdp.Nodes.Node.Vrfs.Vrf()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.vrf.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vrf"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class DiscoverySummaryAll(Entity):
                """
                Summary information regarding LDP discovery
                
                .. attribute:: local_ldp_id
                
                	Local LDP identifier
                	**type**\:  str
                
                .. attribute:: num_of_active_ldp_interfaces
                
                	Number of active LDP enabled interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_addr_recv
                
                	Number of hello discoveries received with bad source address
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_hello_pdu
                
                	Number of hello discoveries received with bad hello PDU
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_bad_xport_addr
                
                	Number of hello discoveries received with bad export address
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_same_router_id
                
                	Number of hello discoveries received with the same router id as this router
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_disc_with_wrong_router_id
                
                	Number of hello discoveries received with the router id that is not destined for this router
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_ldp_interfaces
                
                	Total Number of LDP configured interfaces
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_lnk_disc_recv
                
                	Number of link hello discoveries in recv state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_lnk_disc_xmit
                
                	Number of link hello discoveries in xmit state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_tgt_disc_recv
                
                	Number of targeted hello discoveries in recv state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: num_of_tgt_disc_xmit
                
                	Number of targeted hello discoveries in xmit state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: vrf
                
                	VRF information
                	**type**\:   :py:class:`Vrf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_ldp_oper.MplsLdp.Nodes.Node.DiscoverySummaryAll.Vrf>`
                
                

                """

                _prefix = 'mpls-ldp-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsLdp.Nodes.Node.DiscoverySummaryAll, self).__init__()

                    self.yang_name = "discovery-summary-all"
                    self.yang_parent_name = "node"

                    self.local_ldp_id = YLeaf(YType.str, "local-ldp-id")

                    self.num_of_active_ldp_interfaces = YLeaf(YType.uint32, "num-of-active-ldp-interfaces")

                    self.num_of_disc_with_bad_addr_recv = YLeaf(YType.uint32, "num-of-disc-with-bad-addr-recv")

                    self.num_of_disc_with_bad_hello_pdu = YLeaf(YType.uint32, "num-of-disc-with-bad-hello-pdu")

                    self.num_of_disc_with_bad_xport_addr = YLeaf(YType.uint32, "num-of-disc-with-bad-xport-addr")

                    self.num_of_disc_with_same_router_id = YLeaf(YType.uint32, "num-of-disc-with-same-router-id")

                    self.num_of_disc_with_wrong_router_id = YLeaf(YType.uint32, "num-of-disc-with-wrong-router-id")

                    self.num_of_ldp_interfaces = YLeaf(YType.uint32, "num-of-ldp-interfaces")

                    self.num_of_lnk_disc_recv = YLeaf(YType.uint32, "num-of-lnk-disc-recv")

                    self.num_of_lnk_disc_xmit = YLeaf(YType.uint32, "num-of-lnk-disc-xmit")

                    self.num_of_tgt_disc_recv = YLeaf(YType.uint32, "num-of-tgt-disc-recv")

                    self.num_of_tgt_disc_xmit = YLeaf(YType.uint32, "num-of-tgt-disc-xmit")

                    self.vrf = MplsLdp.Nodes.Node.DiscoverySummaryAll.Vrf()
                    self.vrf.parent = self
                    self._children_name_map["vrf"] = "vrf"
                    self._children_yang_names.add("vrf")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("local_ldp_id",
                                    "num_of_active_ldp_interfaces",
                                    "num_of_disc_with_bad_addr_recv",
                                    "num_of_disc_with_bad_hello_pdu",
                                    "num_of_disc_with_bad_xport_addr",
                                    "num_of_disc_with_same_router_id",
                                    "num_of_disc_with_wrong_router_id",
                                    "num_of_ldp_interfaces",
                                    "num_of_lnk_disc_recv",
                                    "num_of_lnk_disc_xmit",
                                    "num_of_tgt_disc_recv",
                                    "num_of_tgt_disc_xmit") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsLdp.Nodes.Node.DiscoverySummaryAll, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsLdp.Nodes.Node.DiscoverySummaryAll, self).__setattr__(name, value)


                class Vrf(Entity):
                    """
                    VRF information
                    
                    .. attribute:: id
                    
                    	VRF Id
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: name
                    
                    	VRF Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-ldp-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsLdp.Nodes.Node.DiscoverySummaryAll.Vrf, self).__init__()

                        self.yang_name = "vrf"
                        self.yang_parent_name = "discovery-summary-all"

                        self.id = YLeaf(YType.uint32, "id")

                        self.name = YLeaf(YType.str, "name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("id",
                                        "name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsLdp.Nodes.Node.DiscoverySummaryAll.Vrf, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsLdp.Nodes.Node.DiscoverySummaryAll.Vrf, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.id.is_set or
                            self.name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.id.yfilter != YFilter.not_set or
                            self.name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "vrf" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.id.is_set or self.id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.id.get_name_leafdata())
                        if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "id" or name == "name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "id"):
                            self.id = value
                            self.id.value_namespace = name_space
                            self.id.value_namespace_prefix = name_space_prefix
                        if(value_path == "name"):
                            self.name = value
                            self.name.value_namespace = name_space
                            self.name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.local_ldp_id.is_set or
                        self.num_of_active_ldp_interfaces.is_set or
                        self.num_of_disc_with_bad_addr_recv.is_set or
                        self.num_of_disc_with_bad_hello_pdu.is_set or
                        self.num_of_disc_with_bad_xport_addr.is_set or
                        self.num_of_disc_with_same_router_id.is_set or
                        self.num_of_disc_with_wrong_router_id.is_set or
                        self.num_of_ldp_interfaces.is_set or
                        self.num_of_lnk_disc_recv.is_set or
                        self.num_of_lnk_disc_xmit.is_set or
                        self.num_of_tgt_disc_recv.is_set or
                        self.num_of_tgt_disc_xmit.is_set or
                        (self.vrf is not None and self.vrf.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.local_ldp_id.yfilter != YFilter.not_set or
                        self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set or
                        self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set or
                        self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set or
                        self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set or
                        self.num_of_ldp_interfaces.yfilter != YFilter.not_set or
                        self.num_of_lnk_disc_recv.yfilter != YFilter.not_set or
                        self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set or
                        self.num_of_tgt_disc_recv.yfilter != YFilter.not_set or
                        self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set or
                        (self.vrf is not None and self.vrf.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "discovery-summary-all" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.local_ldp_id.is_set or self.local_ldp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_ldp_id.get_name_leafdata())
                    if (self.num_of_active_ldp_interfaces.is_set or self.num_of_active_ldp_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_active_ldp_interfaces.get_name_leafdata())
                    if (self.num_of_disc_with_bad_addr_recv.is_set or self.num_of_disc_with_bad_addr_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_addr_recv.get_name_leafdata())
                    if (self.num_of_disc_with_bad_hello_pdu.is_set or self.num_of_disc_with_bad_hello_pdu.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_hello_pdu.get_name_leafdata())
                    if (self.num_of_disc_with_bad_xport_addr.is_set or self.num_of_disc_with_bad_xport_addr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_bad_xport_addr.get_name_leafdata())
                    if (self.num_of_disc_with_same_router_id.is_set or self.num_of_disc_with_same_router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_same_router_id.get_name_leafdata())
                    if (self.num_of_disc_with_wrong_router_id.is_set or self.num_of_disc_with_wrong_router_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_disc_with_wrong_router_id.get_name_leafdata())
                    if (self.num_of_ldp_interfaces.is_set or self.num_of_ldp_interfaces.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_ldp_interfaces.get_name_leafdata())
                    if (self.num_of_lnk_disc_recv.is_set or self.num_of_lnk_disc_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_lnk_disc_recv.get_name_leafdata())
                    if (self.num_of_lnk_disc_xmit.is_set or self.num_of_lnk_disc_xmit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_lnk_disc_xmit.get_name_leafdata())
                    if (self.num_of_tgt_disc_recv.is_set or self.num_of_tgt_disc_recv.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_tgt_disc_recv.get_name_leafdata())
                    if (self.num_of_tgt_disc_xmit.is_set or self.num_of_tgt_disc_xmit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.num_of_tgt_disc_xmit.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "vrf"):
                        if (self.vrf is None):
                            self.vrf = MplsLdp.Nodes.Node.DiscoverySummaryAll.Vrf()
                            self.vrf.parent = self
                            self._children_name_map["vrf"] = "vrf"
                        return self.vrf

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "vrf" or name == "local-ldp-id" or name == "num-of-active-ldp-interfaces" or name == "num-of-disc-with-bad-addr-recv" or name == "num-of-disc-with-bad-hello-pdu" or name == "num-of-disc-with-bad-xport-addr" or name == "num-of-disc-with-same-router-id" or name == "num-of-disc-with-wrong-router-id" or name == "num-of-ldp-interfaces" or name == "num-of-lnk-disc-recv" or name == "num-of-lnk-disc-xmit" or name == "num-of-tgt-disc-recv" or name == "num-of-tgt-disc-xmit"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "local-ldp-id"):
                        self.local_ldp_id = value
                        self.local_ldp_id.value_namespace = name_space
                        self.local_ldp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-active-ldp-interfaces"):
                        self.num_of_active_ldp_interfaces = value
                        self.num_of_active_ldp_interfaces.value_namespace = name_space
                        self.num_of_active_ldp_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-addr-recv"):
                        self.num_of_disc_with_bad_addr_recv = value
                        self.num_of_disc_with_bad_addr_recv.value_namespace = name_space
                        self.num_of_disc_with_bad_addr_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-hello-pdu"):
                        self.num_of_disc_with_bad_hello_pdu = value
                        self.num_of_disc_with_bad_hello_pdu.value_namespace = name_space
                        self.num_of_disc_with_bad_hello_pdu.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-bad-xport-addr"):
                        self.num_of_disc_with_bad_xport_addr = value
                        self.num_of_disc_with_bad_xport_addr.value_namespace = name_space
                        self.num_of_disc_with_bad_xport_addr.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-same-router-id"):
                        self.num_of_disc_with_same_router_id = value
                        self.num_of_disc_with_same_router_id.value_namespace = name_space
                        self.num_of_disc_with_same_router_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-disc-with-wrong-router-id"):
                        self.num_of_disc_with_wrong_router_id = value
                        self.num_of_disc_with_wrong_router_id.value_namespace = name_space
                        self.num_of_disc_with_wrong_router_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-ldp-interfaces"):
                        self.num_of_ldp_interfaces = value
                        self.num_of_ldp_interfaces.value_namespace = name_space
                        self.num_of_ldp_interfaces.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-lnk-disc-recv"):
                        self.num_of_lnk_disc_recv = value
                        self.num_of_lnk_disc_recv.value_namespace = name_space
                        self.num_of_lnk_disc_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-lnk-disc-xmit"):
                        self.num_of_lnk_disc_xmit = value
                        self.num_of_lnk_disc_xmit.value_namespace = name_space
                        self.num_of_lnk_disc_xmit.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-tgt-disc-recv"):
                        self.num_of_tgt_disc_recv = value
                        self.num_of_tgt_disc_recv.value_namespace = name_space
                        self.num_of_tgt_disc_recv.value_namespace_prefix = name_space_prefix
                    if(value_path == "num-of-tgt-disc-xmit"):
                        self.num_of_tgt_disc_xmit = value
                        self.num_of_tgt_disc_xmit.value_namespace = name_space
                        self.num_of_tgt_disc_xmit.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.node_name.is_set or
                    (self.ato_mdb_table_entries is not None and self.ato_mdb_table_entries.has_data()) or
                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_data()) or
                    (self.default_vrf is not None and self.default_vrf.has_data()) or
                    (self.discovery_summary_all is not None and self.discovery_summary_all.has_data()) or
                    (self.forwarding_summary_all is not None and self.forwarding_summary_all.has_data()) or
                    (self.nsr_summary_all is not None and self.nsr_summary_all.has_data()) or
                    (self.summary is not None and self.summary.has_data()) or
                    (self.vrfs is not None and self.vrfs.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.node_name.yfilter != YFilter.not_set or
                    (self.ato_mdb_table_entries is not None and self.ato_mdb_table_entries.has_operation()) or
                    (self.bindings_summary_all is not None and self.bindings_summary_all.has_operation()) or
                    (self.default_vrf is not None and self.default_vrf.has_operation()) or
                    (self.discovery_summary_all is not None and self.discovery_summary_all.has_operation()) or
                    (self.forwarding_summary_all is not None and self.forwarding_summary_all.has_operation()) or
                    (self.nsr_summary_all is not None and self.nsr_summary_all.has_operation()) or
                    (self.summary is not None and self.summary.has_operation()) or
                    (self.vrfs is not None and self.vrfs.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "node" + "[node-name='" + self.node_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/nodes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.node_name.is_set or self.node_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_name.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "ato-mdb-table-entries"):
                    if (self.ato_mdb_table_entries is None):
                        self.ato_mdb_table_entries = MplsLdp.Nodes.Node.AtoMdbTableEntries()
                        self.ato_mdb_table_entries.parent = self
                        self._children_name_map["ato_mdb_table_entries"] = "ato-mdb-table-entries"
                    return self.ato_mdb_table_entries

                if (child_yang_name == "bindings-summary-all"):
                    if (self.bindings_summary_all is None):
                        self.bindings_summary_all = MplsLdp.Nodes.Node.BindingsSummaryAll()
                        self.bindings_summary_all.parent = self
                        self._children_name_map["bindings_summary_all"] = "bindings-summary-all"
                    return self.bindings_summary_all

                if (child_yang_name == "default-vrf"):
                    if (self.default_vrf is None):
                        self.default_vrf = MplsLdp.Nodes.Node.DefaultVrf()
                        self.default_vrf.parent = self
                        self._children_name_map["default_vrf"] = "default-vrf"
                    return self.default_vrf

                if (child_yang_name == "discovery-summary-all"):
                    if (self.discovery_summary_all is None):
                        self.discovery_summary_all = MplsLdp.Nodes.Node.DiscoverySummaryAll()
                        self.discovery_summary_all.parent = self
                        self._children_name_map["discovery_summary_all"] = "discovery-summary-all"
                    return self.discovery_summary_all

                if (child_yang_name == "forwarding-summary-all"):
                    if (self.forwarding_summary_all is None):
                        self.forwarding_summary_all = MplsLdp.Nodes.Node.ForwardingSummaryAll()
                        self.forwarding_summary_all.parent = self
                        self._children_name_map["forwarding_summary_all"] = "forwarding-summary-all"
                    return self.forwarding_summary_all

                if (child_yang_name == "nsr-summary-all"):
                    if (self.nsr_summary_all is None):
                        self.nsr_summary_all = MplsLdp.Nodes.Node.NsrSummaryAll()
                        self.nsr_summary_all.parent = self
                        self._children_name_map["nsr_summary_all"] = "nsr-summary-all"
                    return self.nsr_summary_all

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsLdp.Nodes.Node.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                if (child_yang_name == "vrfs"):
                    if (self.vrfs is None):
                        self.vrfs = MplsLdp.Nodes.Node.Vrfs()
                        self.vrfs.parent = self
                        self._children_name_map["vrfs"] = "vrfs"
                    return self.vrfs

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "ato-mdb-table-entries" or name == "bindings-summary-all" or name == "default-vrf" or name == "discovery-summary-all" or name == "forwarding-summary-all" or name == "nsr-summary-all" or name == "summary" or name == "vrfs" or name == "node-name"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "node-name"):
                    self.node_name = value
                    self.node_name.value_namespace = name_space
                    self.node_name.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.node:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.node:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "nodes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "node"):
                for c in self.node:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsLdp.Nodes.Node()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.node.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "node"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.global_ is not None and self.global_.has_data()) or
            (self.nodes is not None and self.nodes.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.global_ is not None and self.global_.has_operation()) or
            (self.nodes is not None and self.nodes.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-ldp-oper:mpls-ldp" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "global"):
            if (self.global_ is None):
                self.global_ = MplsLdp.Global_()
                self.global_.parent = self
                self._children_name_map["global_"] = "global"
            return self.global_

        if (child_yang_name == "nodes"):
            if (self.nodes is None):
                self.nodes = MplsLdp.Nodes()
                self.nodes.parent = self
                self._children_name_map["nodes"] = "nodes"
            return self.nodes

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "global" or name == "nodes"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsLdp()
        return self._top_entity

